<?php
/*
	This file is part of Astairs.

    Astairs is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    Astairs is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Astairs.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2006, 2007, 2008, 2009 AFIDE
    
	Auteurs:

	Said Ladjani <sladjani@yahoo.fr>
	Remi Cocquet <remi.cocquet@gmail.com>

*/

/**
    Dresse le bilan gnral  un test de positionnement

    Bilan pour un utilisateur

    @param integer : $formation numero de la formation
    @param integer : $liste numero de la liste de test de positionnement
    @param integer : $user numero du user
    @param integer : $parcours numero du parcours de la formation

*/
require('../dbpostgres.php3');
$db=pg_connect($server,"","","","$nombase");
require("$chemin_bo/lib/obj_liste_test.php");
require("$chemin_bo/lib/obj_individu.php");
require("$chemin_bo/lib/lib_parcours.php");
require('./analyse_fonctions.php');

/*---------------------------------------------------------------------*/
//          FONCTIONS PHP
/*---------------------------------------------------------------------*/

/*---------------------------------------------------------------------*/
//                  INITIALISATION
/*---------------------------------------------------------------------*/
$obj_liste=new Liste_test($liste);
// nombre de test pour la liste (si dynamique)

$nb_test=$obj_liste->getNbTests();


$obj_user=new Individu($user);

// tableau pour les couleurs de tests
$tab_couleur_test=array("#ffcc00"=>array("#ffe374","#ffed4a","#ffffc6"),
                                        "#0054ff"=>array("#4c94ff","#95c0ff","#b7e3ff"),
                                        "#009900"=>array("#02bf02","#5aed5a","#7bff7b"),
                                        "#990099"=>array("#d040d0","#e48ee4","#ffb0ff"));

/*---------------------------------------------------------------------*/
//                  AFFICHAGE ENTETE
/*---------------------------------------------------------------------*/
$nompage="bilgen_nondynamic.php";
$titre="";
$path='..';
$styleCSS="./style_analyse.css";
include('../entete.php3');

// affichage du titre de la page
print("
<div class=\"adv\">1 - BILAN GENERAL<BR>DES TESTS D'AUTO-POSITIONNEMENT (QCM)
</div>
");
print("
<br>
<div align=left><font face=\"Arial,Helvetica\" size=2>
Test : ".$obj_liste->toString()."<br>
Identifiant : ".$obj_user->toString()."<br>
Date des rsultats :  suivre ....<br>
");
// a suivre ....
//$tab=dates_test_auto_positionnement($liste);
/*
print("
- Test : ".gmdate("d-m-Y  G:i:s",$tab[0])."<br>
");
for($i=0;$i<$nb_test;$i++){
    $ind=$i+1;
    print("- Srie n$ind : ");
    if($tab[$ind]=="X")
        print("Pas fait");
    else
        print gmdate("d-m-Y  G:i:s",$tab[$ind]);
    print("<br>");
}

print("
</font>
<br><br>
");
*/
/*---------------------------------------------------------------------*/
//  TABLEAU BILAN DU TEST D'AUTO-POSITIONNEMENT
/*---------------------------------------------------------------------*/
print("
<br><b><u>Bilan des tests</u><br><br>
</font>

");
// le tableau
print("
<table border=0 width=80%>
");
// BOUCLE SUR LES TEST
for($i=0;$i<$nb_test;$i++){
    $obj_test=&$obj_liste->getTest($i);
    // le thme du test
    $num_theme=$obj_test->getNumTheme();
    // nb de reponses pour ce test
    $nb_reponse=$obj_test->getNbReponses();
    // couleur pout le titre du test
     if($i%4==0)
            reset($tab_couleur_test);
    list($couleur_titre)=each($tab_couleur_test);
    print("
    <tr>
    <td>

    <table border=1>
    <tr>
    <td height=60 width=200 bgcolor=$couleur_titre>
    <b><font face=\"Arial,Helvetica\" size=2>".$obj_test->toString()."</font></b>
    </td>
    </tr>
    
    </table>


    </td>
    <!--<td>&nbsp;</td>-->
    <td>
    <table border=1>
    <tr>
    <td colspan=$nb_reponse bgcolor=$couleur_titre align=center width=600>
    <b><font face=\"Arial,Helvetica\" size=2>Nombre de CASES COCHEES pour le test d'auto-positionnement</font></b>
    </td>
    </tr>
    <tr>
    ");
    // BOUCLE SUR LES REPONSES DU TEST
    reset($tab_couleur_test["$couleur_titre"]);
    for($j=0;$j<$nb_reponse;$j++){
        $obj_reponse=&$obj_test->getReponse($j);
        // couleur pour les rponses

        list($cle,$couleur_reponse)=each($tab_couleur_test["$couleur_titre"]);
        print("
        <td bgcolor=$couleur_reponse align=center>
        <b><font face=\"Arial,Helvetica\" size=2>".$obj_reponse->toString()."</font></b>
        </td>
        ");
    }
    print("
    </tr>
    <tr>
    ");
    for($j=0;$j<$nb_reponse;$j++){
        $obj_reponse=&$obj_test->getReponse($j);
        // numero de la reponse
        $num_reponse=$obj_reponse->getId();
        // recup du nb de cette reponse
        // NOTE : Prevoir des methodes ....
        $sql="select count(1) from res_liste_test where id_formation=$formation and id_stag=$user and ordre_etape=$i+1 and reponse=$num_reponse";
        $res=pg_query($sql);
        $row=pg_fetch_row($res,0);
        print("
        <td align=center><b><b><font face=\"Arial,Helvetica\" size=2>$row[0]</font></b></td>
        ");
    }
    print("
    </tr>
    </table>
    </td>
    </tr>
    ");
}
print("
</table>
");
/*---------------------------------------------------------------------*/
//  TABLEAU BILAN DES EVALUATIONS
/*---------------------------------------------------------------------*/
print("
<br>
<font face=\"Arial,Helvetica\" size=2>
<b><u>Bilan des valuations (QCM)</u><br><br>
</font>
");
// le tableau
reset($tab_couleur_test);
print("
<table border=1 cellspacing=0 cellpadding=0 width=80%>
");
/*-------------------------------- Premiere ligne ------------------*/
print("
<tr bgcolor=\"#cccccc\">
<td align=center height=30><font face=\"Arial,Helvetica\" size=2><b>TEST</b></font></td>
<td align=center><font face=\"Arial,Helvetica\" size=2><b>RESULTAT</b></font></td>
<td align=center><font face=\"Arial,Helvetica\" size=2><b>ECART</b></font></td>
<td align=center><font face=\"Arial,Helvetica\" size=2><b>MOYENNE (/20)</b></font></td>
<td align=center bgcolor=\"#ff0000\"><font face=\"Arial,Helvetica\" size=2 color=\"#ffffff\"><b>ACTION</b></font></td>
</tr>

");
$score_total=0;
$ecart_total=0;
$nb_exo_total=0;
for($i=0;$i<$nb_test;$i++){
    $ordre_test=$i+1;
    $obj_test=&$obj_liste->getTest($i);

    //numero du test en cours
    $num_test=$obj_test->getId();
    // nb d'exo pour le test courant
    $nb_exo_test=$obj_test->getNbExercices();
    if($obj_test->getType()!='s'){
    $nb_exo_total +=$nb_exo_test;
    // le score pour ce test
    $sql="select sum(score) from res_liste_test where id_stag=$user and id_formation=$formation and id_liste=$liste and ordre_etape=($i+1) and type_exo='q'";
    $resscore=pg_query($sql);
    $rowscore=pg_fetch_row($resscore,0);
    $score_test=$rowscore[0];
    $score_total +=$score_test;
    $ecart_test=$nb_exo_test - $score_test;
    $ecart_total +=$ecart_test;
    $moyenne_test=$score_test * (20/$nb_exo_test);
    $moyenne_test *=100;
    $moyenne_test = round($moyenne_test);
    $moyenne_test /=100;
        //debug
        //echo "score_test=$score_test<br>";
    // nb de reponses pour ce test (sauf la derniere)
    $nb_reponse=$obj_test->getNbReponses() -1;
    }
    else {
        $score_test='X';
        $ecart_test='X';
        $moyenne_test='X';

    }
    // couleur pout le titre du test
    if($i%4==0)
            reset($tab_couleur_test);
    list($couleur_titre)=each($tab_couleur_test);
    print("
    <tr>
    <td bgcolor=$couleur_titre align=center height=30>
    <b><font face=\"Arial,Helvetica\" size=2>".$obj_test->toString()."</font></b>
    </td>
    ");
    print("
    <td align=center>
    <b><font face=\"Arial,Helvetica\" size=2>$score_test / $nb_exo_test</font></b>
    </td>
    ");
    print("
    <td align=center>
    <b><font face=\"Arial,Helvetica\" size=2>$ecart_test</font></b>
    </td>
    ");
    print("
    <td align=center>
    <b><font face=\"Arial,Helvetica\" size=2>$moyenne_test</font></b>
    </td>
    ");
    print("
    <td align=center>
    <b><font face=\"Arial,Helvetica\" size=2>
    ");

        $lien="detailtest.php?theme=$num_theme&ordre_test=$ordre_test&formation=$formation&user=$user&liste=$liste";
        //debug
        //echo "lien=$lien<br>";
        print("
        <a href=\"#\" OnClick=\"window.open('$lien','detail','status=yes,scrollbars=yes,resizable=yes,width=600,height=400');
         return (false);\"><font color=\"#ff0000\">detail</font></a>
        ");






    print("
    </font></b>
    </td>
    </tr>
    ");


}
// total
// la moyenne
$moyenne_total=$score_total * (20/$nb_exo_total);
    $moyenne_total *=100;
    $moyenne_total = round($moyenne_total);
    $moyenne_total /=100;
print("
<tr>
<td align=center bgcolor=\"#cccccc\" height=30><font face=\"Arial,Helvetica\" size=2><b>TOTAL</b></font></td>
<td align=center>
<b><font face=\"Arial,Helvetica\" size=2>$score_total / $nb_exo_total</font></b>
</td>
<td align=center>
<b><font face=\"Arial,Helvetica\" size=2>$ecart_total</font></b>
</td>
<td align=center>
<b><font face=\"Arial,Helvetica\" size=2>$moyenne_total</font></b>
</td>
<td>&nbsp;</td>
</tr>
");
print("
</table>
");








?>