<?php
/*
	This file is part of Astairs.

    Astairs is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    Astairs is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Astairs.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2006, 2007, 2008, 2009 AFIDE
    
	Auteurs:

	Said Ladjani <sladjani@yahoo.fr>
	Remi Cocquet <remi.cocquet@gmail.com>

*/

class guiEvaluationCorrectionFactory{
	
	function guiEvaluationCorrectionFactory(){
		
	}
	
	function &createGuiEvaluation($obj_EvaluationCorrection){
		
		switch($obj_EvaluationCorrection->getType()){
			case TYPE_EVALUATION_QCM;
				return new guiQcmCorrection($obj_EvaluationCorrection);
				break;
			case TYPE_EVALUATION_SONDAGE;
				return new guiSondageCorrection($obj_EvaluationCorrection);
			case TYPE_EVALUATION_FTB;
				return new guiFtbCorrection($obj_EvaluationCorrection);
				break;
			case TYPE_EVALUATION_QRC;
				return new guiQrcCorrection($obj_EvaluationCorrection);
				break;
			case TYPE_EVALUATION_SRC;
				return new guiSrcCorrection($obj_EvaluationCorrection);
				break;
			case TYPE_EVALUATION_QUESTION_POSITIONNEMENT;
				return new guiQuestionPositionnementCorrection($obj_EvaluationCorrection);
				break;
			default:
				die("guiEvaluationCorrectionFactory::createGuiEvaluation($obj_EvaluationCorrection): Le type '".$obj_EvaluationCorrection->getType()."' est inconnu.<br>");																				
		}
	}
}
?>