<?php
/*
	This file is part of Astairs.

    Astairs is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    Astairs is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Astairs.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2006, 2007, 2008, 2009 AFIDE
    
	Auteurs:

	Said Ladjani <sladjani@yahoo.fr>
	Remi Cocquet <remi.cocquet@gmail.com>

*/

/**
	Fichier de fonctions PHP pour les groupes
	
	Ce fichier contient les fonctions php utiles au groupe.
	
	@package classe
	@modulegroup fonctions
*/

/**
*   Vrification nombre de personne dans un groupe
*
*  Vrifier si un groupe a bien un nombre de places compris
*   entre min et max .
*
*   @param integer : borne infrieure
*   @param integer : borne suprieure
*   @param integer : nombre de stagiaires du groupe
*/
function testminmax($mini, $maxi, $taillegroupe) {
//	echo "testminmax($mini, $maxi, $taillegroupe)";

	if ($mini > $maxi && $maxi != "") {
		return false;
	} else {
		//recup du nb d'utilisateurs pour ce groupe
		if ($maxi < $taillegroupe && $maxi != "") {
			return false;
		} else {
			return true;
		}
	}
}

/**
	Teste la cohrence entre min,max et nb individu pour une classe
	@param integer : min
	@param integer : max
	@param integer : numero classe
	@return integer : 0 si ok, 1 si min>max ,2 si nb individu>max
*/
function get_classe_place_ok($min,$max,$classe){
	if($min>$max)
		return 1;
	// recup individus
	$res=get_classe_individus($classe,0,'desc','false');
	$nb_individu=pg_num_rows($res);
	if($nb_individu>$max)
		return 2;
	return 0;
}


?>