<?php
/*
	This file is part of Astairs.

    Astairs is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    Astairs is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Astairs.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2006, 2007, 2008, 2009 AFIDE
    
	Auteurs:

	Said Ladjani <sladjani@yahoo.fr>
	Remi Cocquet <remi.cocquet@gmail.com>

*/

/**
 *	Fichier de dfinition de la classe EtapeTitre.
 *	Une EtapeTitre est un objet driv d'Etape.
 *
 *	@package etape_titre
 */
class EtapeTitre extends Etape{

	/**
	 * Construit une EtapeTitre.
	 * L'EtapeTitre peut tre construit  partir d'un identifiant (1 seul parametre), auquel cas les donnes sont rcupres en base de donnes,
	 * ou  partir de l'ensemble des donnes (tous les parametres), pour ensuite tre enregistr en base.
	 *  
	 * @param integer $id identifiant du ParcoursOriente
	 * @param string $libelle Libell
	 * @param string $date_creation date de cration (format SQL)
	 */
	function EtapeTitre($id, $libelle="Etape Titre", $date_creation="27.11.2006"){
		if(func_num_args()==1){
			$res_etape=get_etape($id);
			$row_etape=pg_fetch_row($res_etape);
			$libelle=$row_etape[1];
			$date_creation=$row_etape[3];
		}else{
			
		}
		parent::Etape($id, $libelle,$date_creation, TYPE_ETAPE_TITRE);
		$this->initEtapeTitre();
	}
	
	/**
	 * Initialise les attributs propres au ParcoursOriente.
	 * Ne fait rien.
	 */		
	function initEtapeTitre(){
		parent::initEtape();
	}
	
	/**
	 * Obtenir l'icone associe  l'Etape.
	 * @return string Le nom du fichier icone
	 */
	function getIcone(){
		return "ico_titre.gif";
	}	
}
?>