<?php
/*
	This file is part of Astairs.

    Astairs is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    Astairs is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Astairs.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2006, 2007, 2008, 2009 AFIDE
    
	Auteurs:

	Said Ladjani <sladjani@yahoo.fr>
	Remi Cocquet <remi.cocquet@gmail.com>

*/

/**
 * Contient les fonctions propres aux grilles,titrecapacite et capacites
 * 
 * @package grille
 * @modulegroup fonctions
 */

/**
 * fonction qui retourne vrai ou faux selon qu'une grille ou titrecapacite ou capacite est supprimable (cas des libelles)
 * 
 */
function supprimable_libelle($nom,$num){
    switch($nom){
        case "grille" : // test si la grille est ds la table notation
            $req="select * from notation where num_grille='$num'";
            if(check_grille_supprimable($num))
				$retour=true;
			else
				$retour=false;
		break;
        case "titrecapacite" : // test si le titrecapacite est ds la table grilletitrecapa
            //$req="select * from grilletitrecapa where gt_num_titrecapacite='$num'";
			if(check_titrecapacite_supprimable($num))
				$retour=true;
			else
				$retour=false;
        break;
        case "capacite" : // test si la capacite est ds la table titrecapa
            //$req="select * from titrecapa where tr_num_capacite='$num'";
			//if(check_capacite_utilisee($num))
			if(check_capacite_supprimable($num))
				$retour=true;
			else
				$retour=false;
        break;
        default :
    }
	/*
    $res=pg_query($req);
    if(pg_numrows($res)==0)
        return true;
    return false;
	*/
	return $retour;
}                                                 

/**
 * fonction qui retourne vrai ou faux selon qu'une grille ou titrecapacite ou capacite est supprimable (cas des numeros)
 */
function supprime_possible($nom,$num,$numpere){
    switch($nom){
        case "grille" : // test si la grille est ds la table notation
            //$req="select * from notation where num_grille='$num'";
			//if(check_grille_notee($num))
			if(check_grille_supprimable($num))
				$retour=true;
			else
				$retour=false;
        break;
        case "titrecapacite" : // test si le titrecapacite est ds la table notation
            if($numpere!=0){
                //$req="select * from notation where num_titrecapacite='$num' and num_grille='$numpere'";
				if(check_grille_titrecapacite_supprimable($numpere,$num))
					$retour=true;
				else
					$retour=false;
			}
            else{
                //$req="select * from notation where num_titrecapacite='$num'";
				//if(check_titrecapacite_note($num))
				if(check_titrecapacite_supprimable($num))
					$retour=true;
				else
					$retour=false;
			}
        break ;
        case "capacite" :  // test si la capacite est ds la table notation
            //$req="select * from notation where num_capacite='$num' and num_titrecapacite='$numpere'";
			//if(check_titrecapacite_capacite_notee($numpere,$num))
			if(check_titrecapacite_capacite_supprimable($numpere,$num))
				$retour=true;
			else
				$retour=false;
        break;

    }
	/*
    $res=pg_query($req);
    if(pg_numrows($res)==0)
        return true;
    return false;
	*/
	return $retour;
}