<?php
/*
	This file is part of Astairs.

    Astairs is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    Astairs is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Astairs.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2006, 2007, 2008, 2009 AFIDE
    
	Auteurs:

	Said Ladjani <sladjani@yahoo.fr>
	Remi Cocquet <remi.cocquet@gmail.com>

*/

/**
 * Fabrique ExportAstairsFactory
 * Permet la cration d'objet d'Export pour le format de fichier Astairs (BDD).
 * Chacuns de ces objets hrite de la classe ExportAstairs et est propre  un type de donnes (Qcm, Sondage, etc.)
 * 
 * @package import_export
 */
class ExportAstairsFactory extends ExportFileFactory{

	/**
	 * Constructeur de la fabrique.
	 */
	function ExportAstairsFactory(){
	 
	}

	/**
	 * Creation d'objet ExportAstairs.
	 * @param integer $type Type de donnes parmis  TYPE_EVALUATION_QCM, TYPE_EVALUATION_SONDAGE,TYPE_EVALUATION_FTB,TYPE_EVALUATION_QRC,TYPE_EVALUATION_SRC
	 * @return object ExportAstairs Objet hritant de la classe ExportAstairs spcifique au type fourni en parametre.
	 */
	function create($type){
		switch($type){
			case TYPE_EVALUATION_QCM :
				return new ExportAstairsQcm();
			case TYPE_EVALUATION_SONDAGE : 
				 return new ExportAstairsSondage($datafile);
			case TYPE_EVALUATION_FTB :
				return new ExportAstairsFtb($datafile);
			case TYPE_EVALUATION_QRC :
				 return new ExportAstairsQrc($datafile);
			case TYPE_EVALUATION_SRC :
				 return new ExportAstairsSrc($datafile);
			//TODO a dplacer dans la bonne factory
			case TYPE_CATEGORIE_RESSOURCE_GLOSSAIRE :
				return new ExportAstairsGlossaire($datafile);	 
			default:
				die("ExportAstairsFactory::create($type,$datafile): le type($type) est inconnu.");
		}
	 }
}


?>