<?php
/*
	This file is part of Astairs.

    Astairs is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    Astairs is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Astairs.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2006, 2007, 2008, 2009 AFIDE
    
	Auteurs:

	Said Ladjani <sladjani@yahoo.fr>
	Remi Cocquet <remi.cocquet@gmail.com>

*/

/**
 * Dfinition de la classe ResultatSondage.
 * Cet objet est requis par la mthode endCurrentEtape() de la
 * classe DoSondage
 * Dfini les valeurs ncessaires  la fin de l'Evaluation et fourni des mthodes
 * de d'initialisation et de vrification de ces valeurs.
 * 
 * @package sondage
 */
class ResultatSondage extends ResultatQuestionReponse{
	
	/**
	 * Affecter les valeurs des attributs de l'objet.
	 * @param $question integer Identifiant de la Question
	 * @param $reponse integer Identifiant de la Reponse
	 * @param $valeur integer Valeur de la rponse
	 */		
	function init($question, $reponse, $valeur){
		if(!in_array($question,$this->questions))$this->questions[]=$question;
		$this->reponses[]=$reponse;
		$this->valeurs[]=$valeur;
	}

	/**
	 * Vrifie les valeurs des attributs.
	 * @param object Sondage $sondage Evaluation associe au Resultat.
	 * @return boolean true si les valeurs sont correctes, false sinon.
	 */	
	function verify($sondage){
		if( ($sondage->getNbQuestions()==count($this->questions) ) && ($sondage->getNbReponses()==count($this->reponses)) && ($sondage->getNbReponses()==count($this->valeurs)) ){
			return ( count($this->questions)==1 ) && ( count($this->reponses)== count($this->valeurs) ) && ( count($this->reponses)>=0 );
		}else{
			return false;
		}
	}
}
?>
