<?php
/*
	This file is part of Astairs.

    Astairs is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    Astairs is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Astairs.  If not, see <http://www.gnu.org/licenses/>.

	Copyright (C) 2006, 2007, 2008, 2009 AFIDE
    
	Auteurs:

	Said Ladjani <sladjani@yahoo.fr>
	Remi Cocquet <remi.cocquet@gmail.com>

*/

/**
 * Dfinition d'un DoSrc.
 * Un DoSrc est l'objet servant  gerer l'avancement des
 * Src.
 * 
 * @package src
 */
class DoSrc extends DoQsrc{

	/**
	 * Constucteur.
	 * Affecte les attributs de la classe  
	 * partir des paramtres.
	 * 
	 * @param integer $resultat Identifiant du rsultat d'avancement.
	 * @param integer $evaluation Identifiant de l'Evaluation concerne par l'avancement.
	 * @param integer $indice Indice de l'valuation.
	 * @param object EvaluationFactory &$obj_EvaluationFactory La fabrique d'objet Evaluation.
	 */			
	function DoSrc($resultat,$evaluation,$indice,&$obj_EvaluationFactory){
		parent::DoQsrc($resultat,$evaluation,TYPE_EVALUATION_SRC,$indice,$obj_EvaluationFactory);
	}
	
//-----------------------------------------------------
//			METHODES
//-----------------------------------------------------
	
//-----------------------------------------------------
//			ACCESSEURS
//-----------------------------------------------------

	/**
	 * Obtenir le Src associ  l'objet d'avancement
	 * @return object Src  Le Src
	 */	
	function &getSrc(){
		return parent::getObjEvaluation();
	}
}
?>
