--
-- PostgreSQL database dump
--

-- Started on 2009-02-08 16:28:55 CET

SET client_encoding = 'UTF8';
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- TOC entry 5 (class 2615 OID 2595582)
-- Name: contraintes; Type: SCHEMA; Schema: -; Owner: pgsql
--

CREATE SCHEMA contraintes;


ALTER SCHEMA contraintes OWNER TO pgsql;

--
-- TOC entry 7195 (class 0 OID 0)
-- Dependencies: 6
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: postgres
--

COMMENT ON SCHEMA public IS 'Standard public schema';


--
-- TOC entry 7 (class 2615 OID 2595583)
-- Name: v2; Type: SCHEMA; Schema: -; Owner: pgsql
--

CREATE SCHEMA v2;


ALTER SCHEMA v2 OWNER TO pgsql;

--
-- TOC entry 2983 (class 2612 OID 2595584)
-- Name: plpgsql; Type: PROCEDURAL LANGUAGE; Schema: -; Owner: 
--

CREATE PROCEDURAL LANGUAGE plpgsql;


SET search_path = contraintes, pg_catalog;

--
-- TOC entry 2150 (class 1247 OID 2595586)
-- Dependencies: 3917
-- Name: evolution; Type: TYPE; Schema: contraintes; Owner: pgsql
--

CREATE TYPE evolution AS (
	fait integer,
	total integer
);


ALTER TYPE contraintes.evolution OWNER TO pgsql;

--
-- TOC entry 2151 (class 1247 OID 2595588)
-- Dependencies: 3918
-- Name: fw_organisme_type_individu; Type: TYPE; Schema: contraintes; Owner: pgsql
--

CREATE TYPE fw_organisme_type_individu AS (
	id integer,
	nom character varying,
	prenom character varying,
	organisme integer,
	types integer[]
);


ALTER TYPE contraintes.fw_organisme_type_individu OWNER TO pgsql;

--
-- TOC entry 2152 (class 1247 OID 2595590)
-- Dependencies: 3919
-- Name: intkey_boolvalue; Type: TYPE; Schema: contraintes; Owner: pgsql
--

CREATE TYPE intkey_boolvalue AS (
	"key" integer,
	bool boolean
);


ALTER TYPE contraintes.intkey_boolvalue OWNER TO pgsql;

--
-- TOC entry 2153 (class 1247 OID 2595592)
-- Dependencies: 3920
-- Name: organisme_type_individu; Type: TYPE; Schema: contraintes; Owner: pgsql
--

CREATE TYPE organisme_type_individu AS (
	id integer,
	nom character varying,
	prenom character varying,
	organisme integer,
	types integer[]
);


ALTER TYPE contraintes.organisme_type_individu OWNER TO pgsql;

--
-- TOC entry 2154 (class 1247 OID 2595594)
-- Dependencies: 3921
-- Name: parents; Type: TYPE; Schema: contraintes; Owner: postgres
--

CREATE TYPE parents AS (
	id integer,
	pere integer,
	ind integer
);


ALTER TYPE contraintes.parents OWNER TO postgres;

--
-- TOC entry 2155 (class 1247 OID 2595596)
-- Dependencies: 3922
-- Name: type_element; Type: TYPE; Schema: contraintes; Owner: pgsql
--

CREATE TYPE type_element AS (
	id character varying,
	libelle character varying
);


ALTER TYPE contraintes.type_element OWNER TO pgsql;

SET search_path = v2, pg_catalog;

--
-- TOC entry 2156 (class 1247 OID 2595598)
-- Dependencies: 3923
-- Name: intkey_boolvalue; Type: TYPE; Schema: v2; Owner: pgsql
--

CREATE TYPE intkey_boolvalue AS (
	"key" integer,
	bool boolean
);


ALTER TYPE v2.intkey_boolvalue OWNER TO pgsql;

--
-- TOC entry 2157 (class 1247 OID 2595600)
-- Dependencies: 3924
-- Name: organisme_type_individu; Type: TYPE; Schema: v2; Owner: pgsql
--

CREATE TYPE organisme_type_individu AS (
	id integer,
	nom character varying,
	prenom character varying,
	organisme integer,
	types integer[]
);


ALTER TYPE v2.organisme_type_individu OWNER TO pgsql;

--
-- TOC entry 2158 (class 1247 OID 2595602)
-- Dependencies: 3925
-- Name: parents; Type: TYPE; Schema: v2; Owner: postgres
--

CREATE TYPE parents AS (
	id integer,
	pere integer,
	ind integer
);


ALTER TYPE v2.parents OWNER TO postgres;

--
-- TOC entry 2159 (class 1247 OID 2595604)
-- Dependencies: 3926
-- Name: type_element; Type: TYPE; Schema: v2; Owner: pgsql
--

CREATE TYPE type_element AS (
	id character varying,
	libelle character varying
);


ALTER TYPE v2.type_element OWNER TO pgsql;

SET search_path = contraintes, pg_catalog;

--
-- TOC entry 828 (class 1255 OID 2595605)
-- Dependencies: 2983 5
-- Name: af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) RETURNS integer[]
    AS $_$-- $1 : numero formation
-- $2 : date
-- $3 : debut
-- $4 : fin
-- $5 : ancien debut
-- $6 : mode ('add' ou 'edit')
-- $7 : copie
declare
rec record;
classe int4;
tab_conflit _int4;
i int4:=0;
begin
    -- Teste sur les heures debut et fin
    if $6='edit' and $7 is null then
	perform * from contraintes.af_get_evenements_dates($2,$3,$4) 
	as (formation int4,libelle varchar,date timestamp,duree interval,modalite int4,intervention int4,intervenant int4,salle int4)
	where formation=$1 
	and cast(date as time)!=$5;
    else
	perform * from contraintes.af_get_evenements_dates($2,$3,$4) 
	as (formation int4,libelle varchar,date timestamp,duree interval,modalite int4,intervention int4,intervenant int4,salle int4)
	where formation=$1; 
    end if;
    if found then
	tab_conflit[i]:=1;
	i:=i+1;
    end if;
	
    -- teste si le groupe n'est pas pris à ces heures dans d'autres formations
    -- recup du numero de classe
    select into rec * from contraintes.af_get_formation_classes($1) as(id int4,libelle varchar, pere int4,min int4,max int4);
    classe=rec.id;
    perform * from contraintes.af_get_evenements_dates($2,$3,$4) 
    as (ed_formation int4,ed_libelle varchar,ed_date timestamp,ed_duree interval,ed_modalite int4,ed_intervention int4,ed_intervenant int4,ed_salle int4) ,
    contraintes.formation_participants fp
    where (ed_formation=fp.formation and classe=fp.classe)

    and ed_formation!=$1
    and cast(ed_date as time)!=$5;
	
    if found then
	tab_conflit[i]:=2;
	i:=i+1;
    end if;

    -- teste si la salle est libre

    perform * from contraintes.af_get_evenements_dates($2,$3,$4) 
    as (ed_formation int4,ed_libelle varchar,ed_date timestamp,ed_duree interval,ed_modalite int4,ed_intervention int4,ed_intervenant int4,ed_salle int4) ,
    contraintes.af_get_evenements() 
    as (ef_formation int4,ef_libelle varchar,ef_date timestamp,ef_duree interval,ef_modalite int4,ef_intervention int4,ef_intervenant int4,ef_salle int4)
    where ed_salle=ef_salle
    and not (cast(ed_date as time)=$5 and ed_formation=$1); 
    if found then
	tab_conflit[i]:=3;
	i:=i+1;
    end if;

    -- teste si l'intervenant est libre
    perform * from contraintes.af_get_evenements_dates($2,$3,$4) 
    as (ed_formation int4,ed_libelle varchar,ed_date timestamp,ed_duree interval,ed_modalite int4,ed_intervention int4,ed_intervenant int4,ed_salle int4) ,
    contraintes.af_get_evenements() 
    as (ef_formation int4,ef_libelle varchar,ef_date timestamp,ef_duree interval,ef_modalite int4,ef_intervention int4,ef_intervenant int4,ef_salle int4)
    where ed_intervenant=ef_intervenant
    and not (cast(ed_date as time)=$5 and ed_formation=$1); 
    if found then
	tab_conflit[i]:=4;
	i:=i+1;
    end if;
    --raise notice '%,%',tab_conflit[0],tab_conflit[1];
    return tab_conflit;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 7198 (class 0 OID 0)
-- Dependencies: 828
-- Name: FUNCTION af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) IS 'retourne un tableau de conflits pour un evenement de formation';


--
-- TOC entry 829 (class 1255 OID 2595606)
-- Dependencies: 2983 5
-- Name: af_del_alerte(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_alerte(integer) RETURNS boolean
    AS $_$-- $1 : numero alerte
begin
    delete from contraintes.alerte where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_alerte(integer) OWNER TO pgsql;

--
-- TOC entry 7200 (class 0 OID 0)
-- Dependencies: 829
-- Name: FUNCTION af_del_alerte(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_alerte(integer) IS 'supprime une alerte';


--
-- TOC entry 830 (class 1255 OID 2595607)
-- Dependencies: 2983 5
-- Name: af_del_bareme(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_bareme(integer) RETURNS boolean
    AS $_$-- $1 : numero bareme
begin
    delete from contraintes.bareme where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_bareme(integer) OWNER TO pgsql;

--
-- TOC entry 7202 (class 0 OID 0)
-- Dependencies: 830
-- Name: FUNCTION af_del_bareme(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_bareme(integer) IS 'supprime un bareme';


--
-- TOC entry 831 (class 1255 OID 2595608)
-- Dependencies: 2983 5
-- Name: af_del_capacite(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_capacite(integer) RETURNS boolean
    AS $_$-- $1 : numero capacite
begin
    delete from contraintes.capacite where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_capacite(integer) OWNER TO pgsql;

--
-- TOC entry 7204 (class 0 OID 0)
-- Dependencies: 831
-- Name: FUNCTION af_del_capacite(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_capacite(integer) IS 'supprime une capacite';


--
-- TOC entry 832 (class 1255 OID 2595609)
-- Dependencies: 2983 5
-- Name: af_del_capacite_titre(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_capacite_titre(integer) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
begin
    delete from contraintes.capacite_titre where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_capacite_titre(integer) OWNER TO pgsql;

--
-- TOC entry 7206 (class 0 OID 0)
-- Dependencies: 832
-- Name: FUNCTION af_del_capacite_titre(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_capacite_titre(integer) IS 'supprime un titre de capacite';


--
-- TOC entry 833 (class 1255 OID 2595610)
-- Dependencies: 2983 5
-- Name: af_del_capacite_titre_capacite(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_capacite_titre_capacite(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
-- $2 : numero capacite
begin
    delete from contraintes.capacite_titre_capacites where capacite_titre=$1 and capacite=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_capacite_titre_capacite(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7208 (class 0 OID 0)
-- Dependencies: 833
-- Name: FUNCTION af_del_capacite_titre_capacite(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_capacite_titre_capacite(integer, integer) IS 'supprime le couple capacite_titre / capacite';


--
-- TOC entry 834 (class 1255 OID 2595611)
-- Dependencies: 2983 5
-- Name: af_del_categorie(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_del_categorie(integer) RETURNS boolean
    AS $_$
DECLARE
nom_table varchar;
req_del text;
BEGIN
	--SELECTIONE LE NOM DE LA TABLE ASSOCIEE
	SELECT  INTO nom_table table_cible FROM contraintes.categorie WHERE id=$1;
	
	--SUPPRIME LA TABLE PERMETTANT DE GERER LES CONTRAINTES SUR LE CHAMP ID DE LA TABLE THEME_CATEGORIES
	IF (nom_table IS NOT NULL) THEN	
		req_del:='DELETE TABLE contraintes.categorie_'|| nom_table  ||'';
		EXECUTE req_del;
	END IF;
	
	--SUPPRIME LES ENREGISTREMENTS DE LA TABLE THEME_CATEGORIES
	--INUTILE CAR DELETE CASCADE DELETE FROM contraintes.theme_categories where categorie=$1;
	
	--SUPPRIME L'ENREGISTREMENT DANS LA TABLE CATEGORIE
	DELETE FROM contraintes.categorie WHERE id=$1;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_categorie(integer) OWNER TO postgres;

--
-- TOC entry 7210 (class 0 OID 0)
-- Dependencies: 834
-- Name: FUNCTION af_del_categorie(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_del_categorie(integer) IS 'Fonction qui supprime  une  catÃ©gorie ainsi que les tables associÃ©es';


--
-- TOC entry 835 (class 1255 OID 2595612)
-- Dependencies: 2983 5
-- Name: af_del_categorie_element(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_categorie_element(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 categorie
--$2 id de l'element a supprimer
req varchar;
table_ci varchar;
BEGIN

	--recupere la table cible du fichier
	SELECT INTO table_ci table_cible FROM contraintes.categorie C 
	WHERE C.id=$1;

	IF table_ci IS NULL THEN
		RAISE EXCEPTION 'Erreur lors de la recupÃ©ration des informations pour la suppression de l''Ã©lÃ©ment %',$1;
	END IF;
	req:='DELETE FROM contraintes.categorie_'||table_ci||' WHERE id='||$2;
	RAISE NOTICE 'req=%',req;
	EXECUTE req;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_categorie_element(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7212 (class 0 OID 0)
-- Dependencies: 835
-- Name: FUNCTION af_del_categorie_element(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_categorie_element(integer, integer) IS 'Supprime un élément d''une catégorie';


--
-- TOC entry 836 (class 1255 OID 2595613)
-- Dependencies: 2983 5
-- Name: af_del_classe(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_classe(integer) RETURNS boolean
    AS $_$declare
rec record;
num int4;
begin
    num:=$1;
    delete from contraintes.classe where id=num;
    -- recup des classes filles
    for rec in
	select * from contraintes.classe where pere=num
    loop
	num:=rec.id;
	perform contraintes.af_del_classe(num);
    end loop;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_classe(integer) OWNER TO pgsql;

--
-- TOC entry 7214 (class 0 OID 0)
-- Dependencies: 836
-- Name: FUNCTION af_del_classe(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_classe(integer) IS 'Supprime une classe (et ses classes filles si necessaire)';


--
-- TOC entry 837 (class 1255 OID 2595614)
-- Dependencies: 2983 5
-- Name: af_del_classe_droit(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_classe_droit(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero classe
-- $2 : numero droit
begin
    delete from contraintes.individu_droits where classe=$1 and droit=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_classe_droit(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7216 (class 0 OID 0)
-- Dependencies: 837
-- Name: FUNCTION af_del_classe_droit(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_classe_droit(integer, integer) IS 'Supprime un droit à une classe';


--
-- TOC entry 838 (class 1255 OID 2595615)
-- Dependencies: 2983 5
-- Name: af_del_classe_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_classe_individu(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero classe
-- $2 : numero individu
-- $3 : numero formation
declare

begin
    -- supprime l'individu de la classe
    delete from contraintes.classe_individus where classe=$1 and individu=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_classe_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7218 (class 0 OID 0)
-- Dependencies: 838
-- Name: FUNCTION af_del_classe_individu(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_classe_individu(integer, integer) IS 'supprime un individu d''une classe';


--
-- TOC entry 839 (class 1255 OID 2595616)
-- Dependencies: 2983 5
-- Name: af_del_commentaire(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_commentaire(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero etape
-- $2 : min
-- $3 : max
begin
    delete from contraintes.commentaire_etape 
    where etape=$1 and min=$2 and max=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_commentaire(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7220 (class 0 OID 0)
-- Dependencies: 839
-- Name: FUNCTION af_del_commentaire(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_commentaire(integer, integer, integer) IS 'supprime un commentaire';


--
-- TOC entry 840 (class 1255 OID 2595617)
-- Dependencies: 2983 5
-- Name: af_del_critere(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_critere(integer) RETURNS boolean
    AS $_$-- $1 : numero critere
begin
    delete from contraintes.critere where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_critere(integer) OWNER TO pgsql;

--
-- TOC entry 7222 (class 0 OID 0)
-- Dependencies: 840
-- Name: FUNCTION af_del_critere(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_critere(integer) IS 'supprime un critere';


--
-- TOC entry 841 (class 1255 OID 2595618)
-- Dependencies: 2983 5
-- Name: af_del_espace(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_espace(integer) RETURNS boolean
    AS $_$-- $1 : numero espace
begin
    delete from contraintes.espace 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_espace(integer) OWNER TO pgsql;

--
-- TOC entry 7224 (class 0 OID 0)
-- Dependencies: 841
-- Name: FUNCTION af_del_espace(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_espace(integer) IS 'supprime un espace';


--
-- TOC entry 842 (class 1255 OID 2595619)
-- Dependencies: 2983 5
-- Name: af_del_etape(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_etape(integer) RETURNS boolean
    AS $_$begin
    delete from contraintes.etape where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_etape(integer) OWNER TO pgsql;

--
-- TOC entry 7226 (class 0 OID 0)
-- Dependencies: 842
-- Name: FUNCTION af_del_etape(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_etape(integer) IS 'supprime une etape';


--
-- TOC entry 843 (class 1255 OID 2595620)
-- Dependencies: 2983 5
-- Name: af_del_etape_resultat_individu(integer, integer, integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_etape_resultat_individu(integer, integer, integer[], integer[]) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : tableau d'etapes
-- $4 : tableau de parcours
declare
i integer;
begin
    for i in array_lower($3,1)..array_upper($3,1)
    loop
	delete from contraintes.resultat where formation=$1 and stagiaire=$2 and etape=$3[i] and parcours=$4[i];
	-- si etape serie aleatoire (# mode 1) alors supprimer dans serie_aleatoire_evaluations A Suivre ....
	--Voir avec Rémi si utilité trigger
	delete from contraintes.resultat_tentative 
	where formation=$1 and stagiaire=$2 and parcours=$4[i] and etape=$3[i];
   
    end loop;
    return true;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_etape_resultat_individu(integer, integer, integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 7228 (class 0 OID 0)
-- Dependencies: 843
-- Name: FUNCTION af_del_etape_resultat_individu(integer, integer, integer[], integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_etape_resultat_individu(integer, integer, integer[], integer[]) IS 'raz des resultat des etapes pour un individu (une formation)';


--
-- TOC entry 844 (class 1255 OID 2595621)
-- Dependencies: 2983 5
-- Name: af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : tableau d'etapes
-- $4 : parcours
declare
i integer;
begin
    for i in array_lower($3,1)..array_upper($3,1)
    loop
	delete from contraintes.resultat_tentative where formation=$1 and stagiaire=$2 and etape=$3[i] and parcours=$4;
    end loop;
    return true;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) OWNER TO pgsql;

--
-- TOC entry 7230 (class 0 OID 0)
-- Dependencies: 844
-- Name: FUNCTION af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) IS 'raz des resultats (tentative) des etapes pour un individu (une formation)';


--
-- TOC entry 845 (class 1255 OID 2595622)
-- Dependencies: 2983 5
-- Name: af_del_evaluation(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_evaluation(integer) RETURNS boolean
    AS $_$BEGIN

	DELETE FROM contraintes.evaluation WHERE  id=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_evaluation(integer) OWNER TO pgsql;

--
-- TOC entry 7232 (class 0 OID 0)
-- Dependencies: 845
-- Name: FUNCTION af_del_evaluation(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_evaluation(integer) IS 'Supprime une évaluation.';


--
-- TOC entry 1825 (class 1255 OID 2595623)
-- Dependencies: 2983 5
-- Name: af_del_evaluation_resultat_individu(bigint, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_evaluation_resultat_individu(bigint, integer[]) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : tableau d'evaluations
declare
i integer;
begin
    -- supprime la durée dans la table resultat
    update contraintes.resultat set duree=null where id=$1;
    for i in array_lower($2,1)..array_upper($2,1)
    loop
	delete from contraintes.resultat_serie where id=$1 and evaluation=$2[i] ;
    end loop;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_evaluation_resultat_individu(bigint, integer[]) OWNER TO pgsql;

--
-- TOC entry 7234 (class 0 OID 0)
-- Dependencies: 1825
-- Name: FUNCTION af_del_evaluation_resultat_individu(bigint, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_evaluation_resultat_individu(bigint, integer[]) IS 'Supprime des resultats d''evaluation pour un individu';


--
-- TOC entry 846 (class 1255 OID 2595624)
-- Dependencies: 2983 5
-- Name: af_del_evaluation_resultat_tentative_individu(bigint, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_evaluation_resultat_tentative_individu(bigint, integer[]) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : tableau d'evaluations
declare
i integer;
begin
    for i in array_lower($2,1)..array_upper($2,1)
    loop
	delete from contraintes.resultat_serie_tentative where id=$1 and evaluation=$2[i] ;
    end loop;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_evaluation_resultat_tentative_individu(bigint, integer[]) OWNER TO pgsql;

--
-- TOC entry 7236 (class 0 OID 0)
-- Dependencies: 846
-- Name: FUNCTION af_del_evaluation_resultat_tentative_individu(bigint, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_evaluation_resultat_tentative_individu(bigint, integer[]) IS 'Supprime des resultats tentative d''evaluation pour un individu';


--
-- TOC entry 847 (class 1255 OID 2595625)
-- Dependencies: 2983 5
-- Name: af_del_evaluations(integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_evaluations(integer[]) RETURNS boolean
    AS $_$
DECLARE 
i int4;
ok int4:=0;
BEGIN

	FOR i IN array_lower($1,1)..array_upper($1,1)
	LOOP
		DELETE FROM contraintes.evaluation WHERE  id=$1[i];
		IF FOUND THEN 
			ok:=ok+1;
		END IF;
	END LOOP;
	RETURN ok=i;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_evaluations(integer[]) OWNER TO pgsql;

--
-- TOC entry 7238 (class 0 OID 0)
-- Dependencies: 847
-- Name: FUNCTION af_del_evaluations(integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_evaluations(integer[]) IS 'Supprime des évaluations.';


--
-- TOC entry 848 (class 1255 OID 2595626)
-- Dependencies: 2983 5
-- Name: af_del_exotlc_fichiers(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_exotlc_fichiers(integer) RETURNS boolean
    AS $_$-- $1 : numero exotlc
declare
ok bool;
begin
    -- suppression des fichiers
    delete from contraintes.exotlc_fichiers where exotlc=$1;
    ok:=found;
    -- suppression fichiers correction
    delete from contraintes.exotlc_corrections where exotlc=$1;
    return (ok and found);
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_exotlc_fichiers(integer) OWNER TO pgsql;

--
-- TOC entry 7240 (class 0 OID 0)
-- Dependencies: 848
-- Name: FUNCTION af_del_exotlc_fichiers(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_exotlc_fichiers(integer) IS 'supprime les fichiers et fichiers correction d''un exotlc';


--
-- TOC entry 849 (class 1255 OID 2595627)
-- Dependencies: 2983 5
-- Name: af_del_fichier(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_fichier(integer) RETURNS boolean
    AS $_$DECLARE
table_cible_fic VARCHAR;
req VARCHAR;
BEGIN
	

	DELETE FROM contraintes.fichier WHERE id=$1;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 7242 (class 0 OID 0)
-- Dependencies: 849
-- Name: FUNCTION af_del_fichier(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_fichier(integer) IS 'Supprime un fichier.';


--
-- TOC entry 850 (class 1255 OID 2595628)
-- Dependencies: 2983 5
-- Name: af_del_fichier_scenario_dynamique_bloc(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_fichier_scenario_dynamique_bloc(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 fichier scenario dynamique
--$2 bloc ordre
rec RECORD;
BEGIN
	DELETE FROM contraintes.fichier_scenario_dynamique_blocs
	WHERE id=$1
	AND ordre=$2;
	

	FOR rec IN
		SELECT id, ordre
		FROM contraintes.fichier_scenario_dynamique_blocs
		WHERE id=$1
		AND ordre > $2 
		ORDER BY ordre ASC
	LOOP		
		
		--on décale tous les successeurs
		UPDATE contraintes.fichier_scenario_dynamique_blocs
		SET ordre=ordre-1
		WHERE id=rec.id
		AND ordre=rec.ordre;
		--RAISE NOTICE 'decale successeurs';
		
	END LOOP;
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_fichier_scenario_dynamique_bloc(integer, integer) OWNER TO pgsql;

--
-- TOC entry 851 (class 1255 OID 2595629)
-- Dependencies: 2983 5
-- Name: af_del_fichier_texte(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_fichier_texte(integer) RETURNS boolean
    AS $_$DECLARE
req VARCHAR;
BEGIN
	--SUPPRESSION
	DELETE FROM contraintes.fichier_texte WHERE id=$1;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_fichier_texte(integer) OWNER TO pgsql;

--
-- TOC entry 7245 (class 0 OID 0)
-- Dependencies: 851
-- Name: FUNCTION af_del_fichier_texte(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_fichier_texte(integer) IS 'Supprime un fichier_texte.';


--
-- TOC entry 852 (class 1255 OID 2595630)
-- Dependencies: 2983 5
-- Name: af_del_fichiers_scenarios_dynamiques(integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_fichiers_scenarios_dynamiques(integer[]) RETURNS boolean
    AS $_$-- $1 : tableau de numero de fichiers scenarios
declare
i integer;
begin
    for i in array_lower($1,1)..array_upper($1,1)
    loop
	PERFORM * from contraintes.af_del_fichier($1[i]);
    end loop;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_fichiers_scenarios_dynamiques(integer[]) OWNER TO pgsql;

--
-- TOC entry 853 (class 1255 OID 2595631)
-- Dependencies: 2983 5
-- Name: af_del_filiere(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_filiere(integer) RETURNS boolean
    AS $_$DECLARE
--$1 filiere
BEGIN
	DELETE FROM contraintes.filiere WHERE id=$1;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_filiere(integer) OWNER TO pgsql;

--
-- TOC entry 1826 (class 1255 OID 2960161)
-- Dependencies: 2983 5
-- Name: af_del_formation(integer); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION af_del_formation(integer) RETURNS boolean
    AS $_$BEGIN
	DELETE FROM contraintes.formation
	WHERE id=$1;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation(integer) OWNER TO www;

--
-- TOC entry 854 (class 1255 OID 2595632)
-- Dependencies: 2983 5
-- Name: af_del_formation_droit(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_droit(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero formation
-- $2 : numero droit
begin
    delete from contraintes.formateur_droits where formation=$1 and droit=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_droit(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7250 (class 0 OID 0)
-- Dependencies: 854
-- Name: FUNCTION af_del_formation_droit(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_droit(integer, integer) IS 'supprime un droit à une formation';


--
-- TOC entry 855 (class 1255 OID 2595633)
-- Dependencies: 2983 5
-- Name: af_del_formation_espace(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_espace(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : espace
begin
    delete from contraintes.formation_ressources 
    where formation=$1 and espace=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_espace(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7252 (class 0 OID 0)
-- Dependencies: 855
-- Name: FUNCTION af_del_formation_espace(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_espace(integer, integer) IS 'supprime un espace (ressource) de la formation';


--
-- TOC entry 856 (class 1255 OID 2595634)
-- Dependencies: 2983 5
-- Name: af_del_formation_espace_section(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_espace_section(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : espace
-- $3 : section
begin
    delete from contraintes.formation_ressources 
    where formation=$1 and espace=$2 and section=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_espace_section(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7254 (class 0 OID 0)
-- Dependencies: 856
-- Name: FUNCTION af_del_formation_espace_section(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_espace_section(integer, integer, integer) IS 'supprime une section d''un espace (ressource) d''une formation';


--
-- TOC entry 857 (class 1255 OID 2595635)
-- Dependencies: 2983 5
-- Name: af_del_formation_evenement(integer, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_evenement(integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date
-- $3 : debut
begin
    delete from contraintes.evenement 
    where formation=$1 and date=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_evenement(integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 7256 (class 0 OID 0)
-- Dependencies: 857
-- Name: FUNCTION af_del_formation_evenement(integer, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_evenement(integer, timestamp without time zone) IS 'Supprime un evenement d''une journee de formation';


--
-- TOC entry 858 (class 1255 OID 2595636)
-- Dependencies: 2983 5
-- Name: af_del_formation_evenements(integer, date); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_evenements(integer, date) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date
begin
    delete from contraintes.evenement 
    where formation=$1 and cast(date as date)=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_evenements(integer, date) OWNER TO pgsql;

--
-- TOC entry 7258 (class 0 OID 0)
-- Dependencies: 858
-- Name: FUNCTION af_del_formation_evenements(integer, date); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_evenements(integer, date) IS 'Supprime les evenements d''une journee de formation';


--
-- TOC entry 859 (class 1255 OID 2595637)
-- Dependencies: 2983 5
-- Name: af_del_formation_forum(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_forum(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : forum
begin
    delete from contraintes.formation_forums where formation=$1 and forum=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_forum(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7260 (class 0 OID 0)
-- Dependencies: 859
-- Name: FUNCTION af_del_formation_forum(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_forum(integer, integer) IS 'Supprime une association formation / forum';


--
-- TOC entry 860 (class 1255 OID 2595638)
-- Dependencies: 2983 5
-- Name: af_del_formation_langue(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_langue(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : n° langue
begin
    delete from contraintes.formation_langues where formation=$1 and langue=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_langue(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7262 (class 0 OID 0)
-- Dependencies: 860
-- Name: FUNCTION af_del_formation_langue(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_langue(integer, integer) IS 'Supprime une langue dispo d''une formation';


--
-- TOC entry 861 (class 1255 OID 2595639)
-- Dependencies: 2983 5
-- Name: af_del_formation_ressource(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_ressource(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : ressource
-- $3 : espace
-- $4 : section
begin
    delete from contraintes.formation_ressources 
    where formation=$1 and fichier_ressource=$2 and espace=$3 and (section=$4 or section is null);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_ressource(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7264 (class 0 OID 0)
-- Dependencies: 861
-- Name: FUNCTION af_del_formation_ressource(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_ressource(integer, integer, integer, integer) IS 'supprime une ressource d''une formation';


--
-- TOC entry 862 (class 1255 OID 2595640)
-- Dependencies: 2983 5
-- Name: af_del_formation_resultat_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_resultat_individu(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : individu

begin
    delete from contraintes.resultat where formation=$1 and stagiaire=$2;
    delete from contraintes.resultat_tentative where formation=$1 and stagiaire=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_resultat_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7266 (class 0 OID 0)
-- Dependencies: 862
-- Name: FUNCTION af_del_formation_resultat_individu(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_resultat_individu(integer, integer) IS 'raz parcours d''un individu (pour une formation)';


--
-- TOC entry 863 (class 1255 OID 2595641)
-- Dependencies: 2983 5
-- Name: af_del_formation_session(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_formation_session(integer) RETURNS boolean
    AS $_$-- $1 : formation
begin
    delete from contraintes.formation_session where formation=$1;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_formation_session(integer) OWNER TO pgsql;

--
-- TOC entry 7268 (class 0 OID 0)
-- Dependencies: 863
-- Name: FUNCTION af_del_formation_session(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_formation_session(integer) IS 'supprime les temps de session pour une formation';


--
-- TOC entry 864 (class 1255 OID 2595642)
-- Dependencies: 2983 5
-- Name: af_del_forum(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_forum(integer) RETURNS boolean
    AS $_$-- $1 : forum
declare

begin
    --supprime dans forum_environnements
    delete from contraintes.forum_environnements where forum=$1;
    delete from contraintes.forum where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_forum(integer) OWNER TO pgsql;

--
-- TOC entry 7270 (class 0 OID 0)
-- Dependencies: 864
-- Name: FUNCTION af_del_forum(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_forum(integer) IS 'supprime un forum';


--
-- TOC entry 865 (class 1255 OID 2595643)
-- Dependencies: 2983 5
-- Name: af_del_grille(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_grille(integer) RETURNS boolean
    AS $_$-- $1 : numero grille
begin  
    delete from contraintes.grille where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_grille(integer) OWNER TO pgsql;

--
-- TOC entry 7272 (class 0 OID 0)
-- Dependencies: 865
-- Name: FUNCTION af_del_grille(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_grille(integer) IS 'supprime une grille';


--
-- TOC entry 866 (class 1255 OID 2595644)
-- Dependencies: 2983 5
-- Name: af_del_grille_capacite_titre(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_grille_capacite_titre(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero grille
-- $2 : numero capacite_titre
begin
    delete from contraintes.grille_capacites_titres where grille=$1 and capacite_titre=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_grille_capacite_titre(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7274 (class 0 OID 0)
-- Dependencies: 866
-- Name: FUNCTION af_del_grille_capacite_titre(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_grille_capacite_titre(integer, integer) IS 'supprime le couple grille / capacite_titre';


--
-- TOC entry 867 (class 1255 OID 2595645)
-- Dependencies: 2983 5
-- Name: af_del_individu(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_individu(integer) RETURNS boolean
    AS $_$begin
    delete from contraintes.fw_individu where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_individu(integer) OWNER TO pgsql;

--
-- TOC entry 7276 (class 0 OID 0)
-- Dependencies: 867
-- Name: FUNCTION af_del_individu(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_individu(integer) IS 'supprime un individu';


--
-- TOC entry 868 (class 1255 OID 2595646)
-- Dependencies: 2983 5
-- Name: af_del_individu_droit_classe(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_individu_droit_classe(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero individu
-- $2 : numero classe
-- $3 : numero droit
begin
    delete from contraintes.individu_droits where individu=$1 and classe=$2 and droit=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_individu_droit_classe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7278 (class 0 OID 0)
-- Dependencies: 868
-- Name: FUNCTION af_del_individu_droit_classe(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_individu_droit_classe(integer, integer, integer) IS 'Supprime un droit pour un individu et une classe';


--
-- TOC entry 869 (class 1255 OID 2595647)
-- Dependencies: 2983 5
-- Name: af_del_individu_session(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_individu_session(integer) RETURNS boolean
    AS $_$-- $1 : individu
begin
    delete from contraintes.session where individu=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_individu_session(integer) OWNER TO pgsql;

--
-- TOC entry 7280 (class 0 OID 0)
-- Dependencies: 869
-- Name: FUNCTION af_del_individu_session(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_individu_session(integer) IS 'supprime la session d''un individu';


--
-- TOC entry 870 (class 1255 OID 2595648)
-- Dependencies: 2983 5
-- Name: af_del_individu_type(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_individu_type(integer, integer) RETURNS boolean
    AS $_$begin
    delete from contraintes.fw_individu_types 
    where individu=$1 and type=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_individu_type(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7282 (class 0 OID 0)
-- Dependencies: 870
-- Name: FUNCTION af_del_individu_type(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_individu_type(integer, integer) IS 'supprime un type à un individu';


--
-- TOC entry 871 (class 1255 OID 2595649)
-- Dependencies: 2983 5
-- Name: af_del_inscription(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_inscription(integer) RETURNS boolean
    AS $_$begin
    delete from contraintes.inscription where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_inscription(integer) OWNER TO pgsql;

--
-- TOC entry 7284 (class 0 OID 0)
-- Dependencies: 871
-- Name: FUNCTION af_del_inscription(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_inscription(integer) IS 'supprime un individu inscrit';


--
-- TOC entry 872 (class 1255 OID 2595650)
-- Dependencies: 2983 5
-- Name: af_del_intervention(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_intervention(integer) RETURNS boolean
    AS $_$-- $1 : numero intervention
begin
    delete from contraintes.intervention where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_intervention(integer) OWNER TO pgsql;

--
-- TOC entry 7286 (class 0 OID 0)
-- Dependencies: 872
-- Name: FUNCTION af_del_intervention(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_intervention(integer) IS 'supprime une intervention';


--
-- TOC entry 873 (class 1255 OID 2595651)
-- Dependencies: 2983 5
-- Name: af_del_langue_message(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_langue_message(integer, integer) RETURNS boolean
    AS $_$-- $1 : type de message
-- $2 : numero de message
-- Attention : supprime dans toutes les langues
begin
    delete from contraintes.langue_message where type=$1 and id=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_langue_message(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7288 (class 0 OID 0)
-- Dependencies: 873
-- Name: FUNCTION af_del_langue_message(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_langue_message(integer, integer) IS 'Supprime un message de langue';


--
-- TOC entry 874 (class 1255 OID 2595652)
-- Dependencies: 2983 5
-- Name: af_del_langue_messages(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_langue_messages(integer, integer[]) RETURNS boolean
    AS $_$-- $1 : type de message
-- $2 : tableau de numero de message
declare
i integer;
begin
    for i in array_lower($2,1)..array_upper($2,1)
    loop
	delete from contraintes.langue_message where type=$1 and id=$2[i];
    end loop;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_langue_messages(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 7290 (class 0 OID 0)
-- Dependencies: 874
-- Name: FUNCTION af_del_langue_messages(integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_langue_messages(integer, integer[]) IS 'Supprime des messages de langue';


--
-- TOC entry 875 (class 1255 OID 2595653)
-- Dependencies: 2983 5
-- Name: af_del_organisme(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_organisme(integer) RETURNS boolean
    AS $_$begin
    delete from contraintes.organisme
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_organisme(integer) OWNER TO pgsql;

--
-- TOC entry 7292 (class 0 OID 0)
-- Dependencies: 875
-- Name: FUNCTION af_del_organisme(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_organisme(integer) IS 'supprime un organisme';


--
-- TOC entry 876 (class 1255 OID 2595654)
-- Dependencies: 2983 5
-- Name: af_del_page_annuaire_configuration(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_page_annuaire_configuration(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : type individu
begin
    delete from contraintes.page_annuaire_configuration 
    where formation=$1 and page=$2 and individu_type=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_page_annuaire_configuration(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7294 (class 0 OID 0)
-- Dependencies: 876
-- Name: FUNCTION af_del_page_annuaire_configuration(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_page_annuaire_configuration(integer, integer, integer) IS 'Supprime la configuration de la page d''annuaire';


--
-- TOC entry 877 (class 1255 OID 2595655)
-- Dependencies: 2983 5
-- Name: af_del_page_liste_configuration(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_page_liste_configuration(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : liste
-- $4 : page
begin
    delete from contraintes.page_liste_configuration 
    where formation=$1 and parcours=$2 and liste=$3 and page=$4;
    delete from contraintes.page_liste 
    where formation=$1 and parcours=$2 and liste=$3 and page=$4;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_page_liste_configuration(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7296 (class 0 OID 0)
-- Dependencies: 877
-- Name: FUNCTION af_del_page_liste_configuration(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_page_liste_configuration(integer, integer, integer, integer) IS 'Supprile la configuration d''une page de liste';


--
-- TOC entry 878 (class 1255 OID 2595656)
-- Dependencies: 2983 5
-- Name: af_del_parcours_etape(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_parcours_etape(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
res int4;
type_etape int4;
BEGIN
	SELECT INTO res * FROM contraintes.af_gen_del_element('contraintes.parcours_etapes','etape',$2,'AND parcours='||$1);
	
	--traitement particulier pour les etapes titres: on les supprimme systematiquement
	SELECT INTO type_etape type FROM contraintes.af_get_etape($2) AS (id int4, libelle varchar, type int4,date_creation timestamp);
	IF type_etape=9 THEN
		PERFORM contraintes.af_del_etape($2);
	END IF;

	RETURN res>0;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_parcours_etape(integer, integer) OWNER TO pgsql;

--
-- TOC entry 879 (class 1255 OID 2595657)
-- Dependencies: 2983 5
-- Name: af_del_positionnement(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_positionnement(integer) RETURNS boolean
    AS $_$BEGIN
	DELETE FROM contraintes.positionnement
	WHERE id=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_positionnement(integer) OWNER TO pgsql;

--
-- TOC entry 880 (class 1255 OID 2595658)
-- Dependencies: 2983 5
-- Name: af_del_positionnement_choix(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_positionnement_choix(integer, integer) RETURNS boolean
    AS $_$DECLARE
qr int4;
nb_del int4:=0;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	--SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	SELECT INTO nb_del * FROM contraintes.af_gen_del_element('contraintes.choix', 'id', $2, ' AND positionnement='||$1);

	RETURN nb_del>0;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_positionnement_choix(integer, integer) OWNER TO pgsql;

--
-- TOC entry 881 (class 1255 OID 2595659)
-- Dependencies: 2983 5
-- Name: af_del_positionnement_evaluations_a_generer(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_positionnement_evaluations_a_generer(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question de positionnement
--$3 choix
--$4 evaluation
qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	DELETE FROM contraintes.positionnement_evaluations
	WHERE question_reponse=qr
	AND question=$2
	AND choix=$3;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_positionnement_evaluations_a_generer(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 882 (class 1255 OID 2595660)
-- Dependencies: 2983 5
-- Name: af_del_positionnement_question(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_positionnement_question(integer, integer) RETURNS boolean
    AS $_$DECLARE
qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	PERFORM * FROM contraintes.af_gen_del_element('contraintes.question_reponse_elements', 'question', $2, ' AND question_reponse='||qr);

	RETURN TRUE;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_positionnement_question(integer, integer) OWNER TO pgsql;

--
-- TOC entry 883 (class 1255 OID 2595661)
-- Dependencies: 2983 5
-- Name: af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
begin
    delete from contraintes.grille_resultats 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 7303 (class 0 OID 0)
-- Dependencies: 883
-- Name: FUNCTION af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) IS 'Supprime un carton pour une capacite à une date';


--
-- TOC entry 884 (class 1255 OID 2595662)
-- Dependencies: 2983 5
-- Name: af_del_qsrc_question(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_qsrc_question(integer, integer) RETURNS boolean
    AS $_$DECLARE
BEGIN
	PERFORM * FROM contraintes.af_gen_del_element('contraintes.question_reponse_elements', 'question', $2, ' AND question_reponse='||$1);

	RETURN TRUE;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_qsrc_question(integer, integer) OWNER TO pgsql;

--
-- TOC entry 885 (class 1255 OID 2595663)
-- Dependencies: 2983 5
-- Name: af_del_question_reponse_association_element(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_question_reponse_association_element(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 numero de question_reponse
--$2 numero de question_reponse_element
val_reponse varchar;
cond varchar;
res integer;
BEGIN
    --les questions
    /*
    DELETE FROM contraintes.question_reponse_elements 
    WHERE question_reponse=$1
    AND question=$2;
    IF $1 IS NULL THEN
        cond:=' AND question_reponse IS NULL';
    ELSE
	cond:=' AND question_reponse='||$1;
    END IF;
    */

    -- question ou reponse ?
    perform * from contraintes.af_get_question_reponse_element($2) 
    as (id integer,libelle varchar,interpretation_html boolean, "type" integer, reponse boolean ) 
    where reponse is false;
    if found then 
	--raise notice 'question';
	val_reponse:=' is false ';
     else
	--raise notice 'reponse';
	val_reponse:=' is true ';
    end if;
    cond:=' AND question_reponse='||$1||' and question_reponse_element in (select id from contraintes.question_reponse_element where reponse '||val_reponse||') ';
   
	--le question_reponse_element
	SELECT INTO res * FROM contraintes.af_gen_del_element(varchar 'contraintes.question_reponse_elements',varchar 'question_reponse_element', $2, cond);

	RETURN res>1;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_question_reponse_association_element(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7306 (class 0 OID 0)
-- Dependencies: 885
-- Name: FUNCTION af_del_question_reponse_association_element(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_question_reponse_association_element(integer, integer) IS 'Supprime un élément d''un question réponse.';


--
-- TOC entry 886 (class 1255 OID 2595664)
-- Dependencies: 2983 5
-- Name: af_del_question_reponse_choix(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_question_reponse_choix(integer, integer) RETURNS boolean
    AS $_$DECLARE
nb_del int4:=0;
BEGIN


	SELECT INTO nb_del * FROM contraintes.af_gen_del_element('contraintes.choix', 'id', $2, ' AND question_reponse='||$1);

	RETURN nb_del>0;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_question_reponse_choix(integer, integer) OWNER TO pgsql;

--
-- TOC entry 887 (class 1255 OID 2595665)
-- Dependencies: 2983 5
-- Name: af_del_question_reponse_element(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_question_reponse_element(integer) RETURNS boolean
    AS $_$BEGIN
	DELETE FROM contraintes.question_reponse_element
	WHERE id=$1;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_question_reponse_element(integer) OWNER TO pgsql;

--
-- TOC entry 7309 (class 0 OID 0)
-- Dependencies: 887
-- Name: FUNCTION af_del_question_reponse_element(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_question_reponse_element(integer) IS 'Supprime un question_reponse_element.';


--
-- TOC entry 888 (class 1255 OID 2595666)
-- Dependencies: 2983 5
-- Name: af_del_question_reponse_element_media(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_question_reponse_element_media(integer, integer) RETURNS boolean
    AS $_$BEGIN
	DELETE FROM contraintes.media_question_reponse_element
	WHERE question_reponse=$1
	AND question_reponse_element=$2;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_question_reponse_element_media(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7311 (class 0 OID 0)
-- Dependencies: 888
-- Name: FUNCTION af_del_question_reponse_element_media(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_question_reponse_element_media(integer, integer) IS 'Supprime un média d''un question_reponse_element.';


--
-- TOC entry 889 (class 1255 OID 2595667)
-- Dependencies: 2983 5
-- Name: af_del_question_reponse_media(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_question_reponse_media(integer) RETURNS boolean
    AS $_$BEGIN
	DELETE FROM contraintes.media_question_reponse
	WHERE question_reponse=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_question_reponse_media(integer) OWNER TO pgsql;

--
-- TOC entry 7313 (class 0 OID 0)
-- Dependencies: 889
-- Name: FUNCTION af_del_question_reponse_media(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_question_reponse_media(integer) IS 'Supprime un média d''un question_reponse.';


--
-- TOC entry 890 (class 1255 OID 2595668)
-- Dependencies: 2983 5
-- Name: af_del_resultat_exotlc(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_resultat_exotlc(integer) RETURNS boolean
    AS $_$-- $1 : id resultat
begin
    delete from contraintes.resultat_exotlc where id=$1;
    -- mise à jour de la table resultat
    --update contraintes.resultat set duree=null where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_resultat_exotlc(integer) OWNER TO pgsql;

--
-- TOC entry 7315 (class 0 OID 0)
-- Dependencies: 890
-- Name: FUNCTION af_del_resultat_exotlc(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_resultat_exotlc(integer) IS 'Supprime les resultats pour un identifiant de resultat';


--
-- TOC entry 891 (class 1255 OID 2595669)
-- Dependencies: 2983 5
-- Name: af_del_resultat_exotlc_fichier_rendu(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_resultat_exotlc_fichier_rendu(integer) RETURNS boolean
    AS $_$DECLARE
--$1 id resultat
BEGIN
	UPDATE contraintes.resultat_exotlc
	SET fichier_rendu = NULL
	WHERE id=$1;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_resultat_exotlc_fichier_rendu(integer) OWNER TO pgsql;

--
-- TOC entry 892 (class 1255 OID 2595670)
-- Dependencies: 2983 5
-- Name: af_del_resultat_fin(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_resultat_fin(integer) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
duree_init interval;
BEGIN
	
	UPDATE contraintes.resultat
	SET duree=NULL
	WHERE id=$1;

	RETURN FOUND;
		

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_resultat_fin(integer) OWNER TO pgsql;

--
-- TOC entry 893 (class 1255 OID 2595671)
-- Dependencies: 2983 5
-- Name: af_del_salle(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_salle(integer) RETURNS boolean
    AS $_$-- $1 : numero salle
begin
    delete from contraintes.salle where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_salle(integer) OWNER TO pgsql;

--
-- TOC entry 7319 (class 0 OID 0)
-- Dependencies: 893
-- Name: FUNCTION af_del_salle(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_salle(integer) IS 'supprime une salle';


--
-- TOC entry 894 (class 1255 OID 2595672)
-- Dependencies: 2983 5
-- Name: af_del_section(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_section(integer) RETURNS boolean
    AS $_$-- $1 : numero section
begin
    delete from contraintes.section 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_section(integer) OWNER TO pgsql;

--
-- TOC entry 7321 (class 0 OID 0)
-- Dependencies: 894
-- Name: FUNCTION af_del_section(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_section(integer) IS 'supprime une section';


--
-- TOC entry 895 (class 1255 OID 2595673)
-- Dependencies: 2983 5
-- Name: af_del_serie_aleatoire_configuration(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_serie_aleatoire_configuration(integer, integer) RETURNS boolean
    AS $_$declare

begin
    if $2=2 then
	delete from contraintes.serie_aleatoire_multiserie where serie=$1;
    else
	if $2=3 then
	    delete from contraintes.serie_aleatoire_multitheme where serie=$1;
	else
	    raise exception 'Mode invalide';
	end if;
     end if;
     return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_serie_aleatoire_configuration(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7323 (class 0 OID 0)
-- Dependencies: 895
-- Name: FUNCTION af_del_serie_aleatoire_configuration(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_serie_aleatoire_configuration(integer, integer) IS 'Supprime la configuration d''une serie aleatoire multiserie ou multitheme';


--
-- TOC entry 896 (class 1255 OID 2595674)
-- Dependencies: 2983 5
-- Name: af_del_serie_aleatoire_melangee(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_serie_aleatoire_melangee(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
begin
    -- suppression dans serie aleatoire
    
    delete from contraintes.serie_aleatoire_melangee 
    where serie=$1 and formation=$2 and parcours=$3;

    -- suppression dans serie aleatoire (si 
    delete from contraintes.serie_aleatoire where id=$1 and type=1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_serie_aleatoire_melangee(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7325 (class 0 OID 0)
-- Dependencies: 896
-- Name: FUNCTION af_del_serie_aleatoire_melangee(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_serie_aleatoire_melangee(integer, integer, integer) IS 'Supprime le mode aleatoire pour une serie existante';


--
-- TOC entry 897 (class 1255 OID 2595675)
-- Dependencies: 2983 5
-- Name: af_del_serie_bloquante_configuration(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_serie_bloquante_configuration(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
begin
    delete from contraintes.serie_bloquante 
    where serie=$1 and formation=$2 and parcours=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_serie_bloquante_configuration(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7327 (class 0 OID 0)
-- Dependencies: 897
-- Name: FUNCTION af_del_serie_bloquante_configuration(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_serie_bloquante_configuration(integer, integer, integer) IS 'Supprime la configuration d''une serie bloquante';


--
-- TOC entry 898 (class 1255 OID 2595676)
-- Dependencies: 2983 5
-- Name: af_del_serie_evaluation(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_serie_evaluation(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 la serie
--$2 l'evaluation a supprimer de l'assoc
ok bool;
BEGIN

	SELECT INTO ok contraintes.af_gen_del_element('contraintes.serie_evaluations', 'evaluation', $2, ' AND serie='||$1); 
	RETURN ok;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_serie_evaluation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 899 (class 1255 OID 2595677)
-- Dependencies: 2983 5
-- Name: af_del_serie_evaluation_ordre(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_serie_evaluation_ordre(integer, integer) RETURNS boolean
    AS $_$DECLARE
req varchar;
cond varchar;
BEGIN

	IF $2 IS NULL THEN
		cond:=' IS NULL';
	ELSE
		cond:=' ='||$3;

	END IF;

	req:='DELETE FROM contraintes.serie_evaluations 
	WHERE id=$1 AND pere '||cond;

	EXECUTE req;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_serie_evaluation_ordre(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7330 (class 0 OID 0)
-- Dependencies: 899
-- Name: FUNCTION af_del_serie_evaluation_ordre(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_serie_evaluation_ordre(integer, integer) IS 'Supprime une évaluation d''une série en fonction du numero du père.';


--
-- TOC entry 900 (class 1255 OID 2595678)
-- Dependencies: 2983 5
-- Name: af_del_template(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_template(integer) RETURNS boolean
    AS $_$-- $1 : numero modele
begin
    delete from contraintes.modele_correction where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_template(integer) OWNER TO pgsql;

--
-- TOC entry 7332 (class 0 OID 0)
-- Dependencies: 900
-- Name: FUNCTION af_del_template(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_del_template(integer) IS 'supprime un modele de correction';


--
-- TOC entry 901 (class 1255 OID 2595679)
-- Dependencies: 2983 5
-- Name: af_del_test_positionnement(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_test_positionnement(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 test
--$2 positionnement
BEGIN
	PERFORM * FROM contraintes.af_gen_del_element('contraintes.test_positionnements', 'positionnement', $2, ' AND test='||$1);
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_test_positionnement(integer, integer) OWNER TO pgsql;

--
-- TOC entry 902 (class 1255 OID 2595680)
-- Dependencies: 2983 5
-- Name: af_del_tests(integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_del_tests(tests integer[]) RETURNS integer
    AS $_$DECLARE
---$1 tests
i int4;
nb int4:=0;
BEGIN

	FOR i IN array_lower($1, 1) .. array_upper($1, 1) 
	LOOP
		nb:=nb+1;
		DELETE FROM contraintes.test WHERE id=$1[i];
	END LOOP; 

	raise notice 'nb supprime= %',nb;
	RETURN nb;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_tests(tests integer[]) OWNER TO pgsql;

--
-- TOC entry 903 (class 1255 OID 2595681)
-- Dependencies: 2983 5
-- Name: af_del_theme(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_del_theme(integer) RETURNS boolean
    AS $_$
BEGIN

	DELETE  FROM contraintes.theme WHERE id=$1;
	
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_del_theme(integer) OWNER TO postgres;

--
-- TOC entry 7336 (class 0 OID 0)
-- Dependencies: 903
-- Name: FUNCTION af_del_theme(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_del_theme(integer) IS 'Supprimer le theme dont l''identifiant est passÃ© en paramettre';


--
-- TOC entry 1827 (class 1255 OID 2595682)
-- Dependencies: 2983 5
-- Name: af_fk_finder(character varying, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_fk_finder(character varying, character varying, integer) RETURNS boolean
    AS $_$DECLARE
--$1 nom de la table
--$2 nom de la colonne
--$3 valeur de la colonne
start_oid_values _int4;
rec RECORD;
i int4:=0;
req varchar;
nb_referenced_records int4;
BEGIN 

	--(A) on selection les oid du shema, de la table et le numero de la colonne
	SELECT INTO start_oid_values * FROM contraintes.af_fk_finder_oid($1,$2);
	--RAISE NOTICE '% % %',start_oid_values[1], start_oid_values[2],start_oid_values[3]; 
	
	--(B)on selectionne les noms du shema, des tables et des colonnes des tables ayant une rÃ©fÃ©rence vers (B)
	FOR rec IN 
		SELECT * FROM contraintes.af_fk_finder_tree(start_oid_values[1], start_oid_values[2], start_oid_values[3]) AS fkeys_infos
	LOOP
		--RAISE NOTICE '%: % %',i, rec.fkeys_infos[1],rec.fkeys_infos[2];
		i:=i+1;
		--(C) pour chacunes de ces tables on execute une requete pour avoir le nombre d'enregistrements refÃ©renÃ§ant la colonne de (A) avec l'identifiant voulu
		--cela en ignorant les tables de categories (car tout y est forcement!)
		IF rec.fkeys_infos[2]NOT LIKE '%categorie_%' THEN
	
			req:='SELECT '||rec.fkeys_infos[1]||' FROM contraintes.'||rec.fkeys_infos[2]||' WHERE '||rec.fkeys_infos[1]||'= '||$3;
			--RAISE NOTICE 'req=%',req;
			EXECUTE req; 

			GET DIAGNOSTICS nb_referenced_records = ROW_COUNT;

			IF nb_referenced_records>0 THEN
				--RAISE NOTICE 'nombre de liens trouvÃ©:%',nb_referenced_records;
				RETURN TRUE;
			ELSE
				CONTINUE;
			END IF;
		END IF;
	END LOOP;

	RETURN FALSE;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_fk_finder(character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 7338 (class 0 OID 0)
-- Dependencies: 1827
-- Name: FUNCTION af_fk_finder(character varying, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_fk_finder(character varying, character varying, integer) IS 'Savoir si un Ã©lÃ©ment est vÃ©rouillÃ©.
Retourne TRUE si l''element $3 de la table $2 et du shema $1 est prÃ©sent dans une table avec laquelle il serait liÃ© par une clÃ© Ã©trangÃ¨re.';


--
-- TOC entry 1828 (class 1255 OID 2595683)
-- Dependencies: 2983 5
-- Name: af_fk_finder_oid(character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_fk_finder_oid(character varying, character varying) RETURNS oid[]
    AS $_$DECLARE
--$1 nom de la table
--$2 nom de la colonne
nom_shema varchar:='contraintes';
tmp1 oid;
tmp2 oid;
tmp3 int4; --attention, ce n'est pas un oid, mais le numÃ©ro de la colonne! (nb: de 1 Ã  n)
BEGIN

	--recupere l'oid du schema
	SELECT INTO tmp1 oid FROM pg_catalog.pg_namespace WHERE nspname LIKE nom_shema;
	--raise notice 'oid schema=%',tmp1;
	
	--recupere l'oid de la table
	SELECT INTO tmp2 oid FROM pg_catalog.pg_class WHERE relname LIKE $1
	AND relnamespace=tmp1;
	
	--recupere l'oid de la colonne
	SELECT INTO tmp3 attnum FROM pg_catalog.pg_attribute WHERE attname LIKE $2 AND attrelid=tmp2;
	
	RETURN ARRAY[tmp1,tmp2,tmp3];
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_fk_finder_oid(character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 7340 (class 0 OID 0)
-- Dependencies: 1828
-- Name: FUNCTION af_fk_finder_oid(character varying, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_fk_finder_oid(character varying, character varying) IS 'FONCTION PRIVEE
Composante de la fonction af_fk_finder.

Retourne un tableau de 2 Ã©lÃ©ments contenant, dans l''ordre:
-l''oid du shema contraintes
-l''oid de la table passÃ© en 1er paramatre
-le numero de la colonne passÃ© en 2Ã¨me parametre';


--
-- TOC entry 904 (class 1255 OID 2595684)
-- Dependencies: 2983 5
-- Name: af_fk_finder_tree(oid, oid, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_fk_finder_tree(oid, oid, integer) RETURNS SETOF character varying[]
    AS $_$DECLARE
--$1 oid du schema
--$2 oid de la table
--$3 numero de la colonne
nb int4:=0;
rec RECORD;
BEGIN

FOR rec IN
	SELECT DISTINCT
	--fka.attrelid AS FKTABLE_OID,
	--fka.attnum AS FKCOL_OID
	fka.attname AS FKTABLE_NAME,
	fkc.relname AS FKCOL_NAME
	FROM
		pg_constraint AS fkcon
	JOIN
		pg_constraint AS pkcon ON fkcon.confrelid=pkcon.conrelid
			AND fkcon.confkey=pkcon.conkey
	JOIN
		pg_class fkc ON fkc.oid=fkcon.conrelid
	JOIN
		pg_class pkc ON pkc.oid=fkcon.confrelid
	JOIN
		pg_attribute fka ON  fka.attrelid=fkc.oid  AND fka.attnum=fkcon.conkey[1]
	JOIN
		pg_attribute pka ON pka.attrelid=pkc.oid  AND pka.attnum=pkcon.conkey[1]
	WHERE pkcon.connamespace=$1
	AND pkc.oid=$2
	AND pka.attnum=$3
LOOP
	RETURN NEXT ARRAY[rec.FKTABLE_NAME, rec.FKCOL_NAME];
	RAISE NOTICE '% % %',$1, rec.FKTABLE_NAME,rec.FKCOL_NAME; 
	nb:=nb+1;
END LOOP;
	RAISE NOTICE 'Nombre de table liÃ©es trouvÃ©es:%',nb;
RETURN;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_fk_finder_tree(oid, oid, integer) OWNER TO pgsql;

--
-- TOC entry 7342 (class 0 OID 0)
-- Dependencies: 904
-- Name: FUNCTION af_fk_finder_tree(oid, oid, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_fk_finder_tree(oid, oid, integer) IS 'FONCTION PRIVEE
Composante de la fonction af_fk_finder.

Retourne le nom des tables et de leurs colonnes liées aux parametres de la fonction.';


--
-- TOC entry 905 (class 1255 OID 2595685)
-- Dependencies: 2983 5
-- Name: af_gen_del_element(character varying, character varying, integer, text); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_gen_del_element(character varying, character varying, integer, text) RETURNS integer
    AS $_$DECLARE
	-- nom de la table sur laquelle executer la requete
	nom_table ALIAS FOR $1;
	-- nom du champ lie au champ pere ( le champ id )
	nom_id ALIAS FOR $2;
	-- numero de l'element (id) que l'on veut supprimer
	indice ALIAS FOR $3;
	-- condition de selection d'une ligne
	cond ALIAS FOR  $4;
	-- variable ou l'on stock une ligne du resultat de la 1ere requete
	rec1 record;
	-- variable ou l'on stock une ligne du resultat de la 2eme requete
	rec2 record;
	-- variable dans laquelle on stock la chaine de la 1ere requete pour sa contruction
	req1 text;
	-- variable dans laquelle on stock la chaine de la 2eme  requete pour sa contruction
	req2 text;
	-- variable dans laquelle on stock la chaine de la 3eme  requete pour sa contruction
	req3 text;
	-- variable dans laquelle on stock la chaine de la 4eme requete pour sa contruction
	req4 text;
	--permet de stocker le nombre de lignes supprimees
	nb_del int4;
	--variable tmp
	rec1_pere varchar;
	--variable temporaire
	tmp_id RECORD;
	fait bool:=FALSE;
BEGIN
	--RAISE NOTICE 'p1:% p2:% p3:% p4:%',$1,$2,$3,$4;
	
	--SELECTION DES LIGNES QUI SONT PERES DES ENREGISTREMENTS A SUPPRIMER
	--on construit la requete
	req1:='SELECT  pere  FROM '|| nom_table;
	req1:=req1   ||' WHERE '||nom_id||'='|| indice ||' '|| cond ||' ;';

	--chaque ligne du resultat est stockee temporairement dans rec1
	FOR rec1 IN 
		EXECUTE req1
			LOOP
				--SELECTION DES LIGNES QUI SONT FILLES DES ENREGISTREMENTS A SUPPRIMER
				--on construit la requete
				req2:='SELECT  '||nom_id||' AS id  FROM '|| nom_table;
				req2:=req2   ||' WHERE pere ='|| indice ||' '|| cond ||' ;';
			
				--chaque ligne du resultat est stockee temporairement dans rec2
				FOR rec2 IN 
					EXECUTE req2
						LOOP
							IF rec1.pere IS NULL THEN
								rec1_pere:='=NULL ';
							ELSE
								rec1_pere:='= '||rec1.pere;
							END IF;

							--ASTUCE: ON RECUPERE L'id DU DERNIER POUR LE METTRE TEMPORAIREMENT COMME PERE, AU LIEU DE rec1_pere
							--(pour respecter les contraintes)
							FOR tmp_id IN
								SELECT * FROM contraintes.af_gen_get_last_element(nom_table, nom_id, cond)
							LOOP
							END LOOP;

							--RAISE NOTICE 'rec1.pere:% rec2.id % ',rec1.pere,rec2.id;
							--EFFECTUE L'UPDATE DES FILS AVEC LA VALEUR TEMPORAIRE
							req3='UPDATE  '||nom_table ||' SET pere ='|| tmp_id.id ||' WHERE '||nom_id||'='|| rec2.id ||' '|| cond ||' ;';
							--RAISE NOTICE 'req3=%',req3;
							EXECUTE req3;

							--SUPPRIME LES ENREGISTREMENTS VOULUS
							req4='DELETE FROM  '||nom_table ||'  WHERE '||nom_id||'='|| indice ||' '|| cond ||' ;';
							EXECUTE req4;
							--recupere le nombre de lignes modifiees par la derniere requete (ici le delete)
							GET DIAGNOSTICS nb_del = ROW_COUNT;

							--EFFECTUE L'UPDATE DES FILS AVEC LE NOUVEAU PERE 
							req3='UPDATE  '||nom_table ||' SET pere '|| rec1_pere ||' WHERE '||nom_id||'='|| rec2.id ||' '|| cond ||' ;';
							EXECUTE req3;
						
							fait:=TRUE;
						END LOOP;	
			END LOOP;
	--CAS OU L'ELEMENT A SUPPRIMER EST LE DERNIER
	IF fait IS FALSE THEN
		--SUPPRIME LES ENREGISTREMENTS VOULUS
		req4='DELETE FROM  '||nom_table ||'  WHERE '||nom_id||'='|| indice ||' '|| cond ||' ;';
		EXECUTE req4;
		--recupere le nombre de lignes modifiees par la derniere requete (ici le delete)
		GET DIAGNOSTICS nb_del = ROW_COUNT;
	END IF;
	RETURN  nb_del;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_del_element(character varying, character varying, integer, text) OWNER TO postgres;

--
-- TOC entry 7344 (class 0 OID 0)
-- Dependencies: 905
-- Name: FUNCTION af_gen_del_element(character varying, character varying, integer, text); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_gen_del_element(character varying, character varying, integer, text) IS 'Supprimer un element dans une table avec une notion de parentalitÃ©.

param1:
Le nom de la table

param2:
Le nom du champ liÃ© au champ pere (id)

param3:
Le numero du champ param2 (id) Ã  supprimer

param4:
La condition de selection de l''element Ã  supprimer.

retourne le nombre d''Ã©lÃ©ments supprimÃ©s dans la table.';


--
-- TOC entry 906 (class 1255 OID 2595686)
-- Dependencies: 2983 5
-- Name: af_gen_get_element_niveau(character varying, character varying, integer, text, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_gen_get_element_niveau(character varying, character varying, integer, text, integer) RETURNS integer
    AS $_$declare
	--stock le resultat de la requete
	rec record;
	-- variable dans laquelle on stock la chaine de la requete pour sa contruction
	req text;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃÂ© au champ pÃÅ¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--3eme parametre : numero de l'element dont on cherche le niveau
	id ALIAS FOR  $3;
	--5eme parametre :condition de selection d'une ligne 
	cond ALIAS FOR  $4;
	-- l'indice 
	ind ALIAS FOR $5;
	--variable  permettant l'incrÃÂ©mentation de l'indice 
	indice int4;
	--nombre de lignes trouvÃÂ©es par la requete
	trouve int4;
begin

	--si l'id est null on retourne l'indice
	if(id is null) then
		--raise notice 'detection de la fin, ind=%', ind;
		return ind;
		exit;
	end if;

	--on incrÃÂ©mente l'indice 
	indice:=ind+1;

	--on construit la requete
	req:='SELECT  '||nom_id||' AS id, pere, '||indice ||' AS ind  FROM ';
	req:=req || nom_table|| ' where id= ' || id;
	--fin de la construction de la requete
	req:=req ||' ' || cond ||' ;';

	for rec in
		execute req
	loop
		if( rec.id is not null) then
			--raise notice 'appel recursif, indice=%',indice;
			select into indice contraintes.af_gen_get_element_niveau(nom_table,nom_id,  rec.pere, cond, indice);
		end if;
	end loop;
	--on recupere le nombre de lignes trouvÃÂ©es par le execute 
	GET DIAGNOSTICS trouve = ROW_COUNT;
	if(trouve =0 )then 
		--met l'indice a 0 pour faire la distinction entre le niveau 1 et pas de niveau
		indice := null;
	end if;
	--retourne le niveau
	return indice ;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_get_element_niveau(character varying, character varying, integer, text, integer) OWNER TO postgres;

--
-- TOC entry 7346 (class 0 OID 0)
-- Dependencies: 906
-- Name: FUNCTION af_gen_get_element_niveau(character varying, character varying, integer, text, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_gen_get_element_niveau(character varying, character varying, integer, text, integer) IS 'fonction gÃ©nÃ©rique permettant d''obtenir le niveau d''un element dans une table ayant une notion de parentalitÃ© (commence Ã  1)';


--
-- TOC entry 907 (class 1255 OID 2595687)
-- Dependencies: 2154 2983 5
-- Name: af_gen_get_elements(character varying, character varying, integer, text, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer) RETURNS SETOF parents
    AS $_$DECLARE
	--permet de stocker le resultat de la requete
	rec contraintes.parents;
	--permet de stocker le resultat de la fonction appelÃÂ©e recursivement
	rec_tmp contraintes.parents;
	-- variable dans laquelle on stock la chaine de la requete pour sa contruction
	req text;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃÂ© au champ pÃÅ¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--3eme parametre : numero de l'element (id) ÃÂ  partir duquel ont veut les elements (valeur du champ pere)
	id_pere ALIAS FOR  $3;
	--4eme parametre :condition de selection d'une ligne 
	cond ALIAS FOR  $4;
	--variable locale permettant l'incrÃÂ©mentation de l'indice pour le tris 
	ind int4;
BEGIN
	--on incrÃÂ©mente l'indice (5eme paramettre)
	ind:=$5 +1;
	--on construit la requete
	req:='SELECT  DISTINCT '||nom_id||' AS id, pere, '||ind ||' AS ind  FROM ';
	req:=req || nom_table ;	
	
	--on test la variable id_pere qui peut etre NULL et construit la requete en fonction
	IF id_pere IS NOT NULL THEN
		req:=req || ' where pere= ' || id_pere;
	ELSE 
		req:= req || ' where pere IS NULL ';
	END IF;

	--fin de la construction de la requete
	req:=req ||' ' || cond ||' ;';

	--chaque ligne du resultat est stockÃÂ©e temporairement dans rec
	FOR rec IN 
		--execution de la requete construite
		EXECUTE req
			--pour chaque ligne de resultat (rec)
			LOOP
				--on retourne le resultat (setof contraintes.parents) de la fonction si fin de la recursivite
				IF rec.id IS NULL THEN
					RETURN ;
				ELSE 
					--sinon :
					--chaque ligne du resultat de la requete recursive est stockÃÂ©e temporairement dans rec_tmp
					FOR rec_tmp IN
						---on rappelle la fonction recursivement avec un nouveau id_pere
						SELECT * FROM contraintes.af_gen_get_elements( nom_table, nom_id, rec.id, cond, ind) 
					LOOP
						--on ajoute les elements voulus de la ligne de resultat temporaire (rec_tmp) au retour de la fonction ( setof parents )
						RETURN NEXT rec_tmp ;
					END LOOP;
						--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof parents )
					RETURN NEXT rec;
				END IF;
			END LOOP;
	-- retourne le resultat de la fonction (setof parents)
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_get_elements(character varying, character varying, integer, text, integer) OWNER TO postgres;

--
-- TOC entry 7348 (class 0 OID 0)
-- Dependencies: 907
-- Name: FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer) IS 'FONCTION PRIVEE:
est appellee par la fonction contraintes.af_gen_get_elements(varchar, varchar, int4, text)

Fonction gÃ©nÃ©rique permettant d''obtenir les elements d''une table ayant une notion de parentalitÃ© .

Le 1er parametre indique le nom de la table, le 2eme indique le nom du champ liÃ© au champ pÃ¨re (celui que l''on veut recuperer), le 3eme le numero du champ 2 Ã  partir duquel on veut les enregistrements,  le 4eme une chaine permetant de preciser la condition d''une ligne ( ex: ''AND toto= 8'') et le 5 eme l''indice du prÃ©cÃ©dent appel de fonction.
';


--
-- TOC entry 908 (class 1255 OID 2595688)
-- Dependencies: 2983 5
-- Name: af_gen_get_elements(character varying, character varying, integer, text); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_gen_get_elements(character varying, character varying, integer, text) RETURNS SETOF integer
    AS $_$DECLARE
	-- nom de la table sur laquelle executer la requete
	nom_table ALIAS FOR $1;
	-- nom du champ liÃÂ© au champ pÃÅ¡re ( le champ id )
	nom_id ALIAS FOR $2;
	-- numero de l'element (id) ÃÂ  partir duquel ont veut les elements
	debut ALIAS FOR $3;
	-- condition de selection d'une ligne
	cond ALIAS FOR  $4;
	-- variable ou l'on stock une ligne du resultat de la requete
	rec record;
	--variable locale permettant l'initialisation de l'indice pour le tris dans l'odre ÃÂ  partir du 1er element (sans pere)
	ind_init int4;
BEGIN
	--initialisation de l'indice
	ind_init:=0;

	--chaque ligne du resultat est stockÃÂ©e temporairement dans rec
	FOR rec IN 
		-- la requete ordonnÃÂ© par l'indice
		SELECT id, ind FROM contraintes.af_gen_get_elements(nom_table, nom_id, debut,cond, ind_init) 
		ORDER BY ind 
			
			LOOP
				--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof int4 )
				RETURN NEXT rec.id;
			END LOOP;
	-- retourne le resultat de la fonction (setof int4)
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_get_elements(character varying, character varying, integer, text) OWNER TO postgres;

--
-- TOC entry 7350 (class 0 OID 0)
-- Dependencies: 908
-- Name: FUNCTION af_gen_get_elements(character varying, character varying, integer, text); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text) IS 'Fonction gÃ©nÃ©rique permettant d''obtenir les elements d''une table ayant une notion de parentalitÃ© dans l''ordre.

Le 1er parametre indique le nom de la table, le 2eme indique le nom du champ liÃ© au champ pÃ¨re (celui que l''on veut recuperer), le 3eme le numero du champ 2 Ã  partir duquel on veut les enregistrements et le 4eme une chaine permetant de preciser la condition d''une ligne ( ex: ''AND toto= 8'')

exemple d''appel: 
select * from contraintes.af_gen_get_elements(varchar ''contraintes.parcours_etapes'', varchar ''etape'' , NULL ,text ''AND parcours=1'');';


--
-- TOC entry 909 (class 1255 OID 2595689)
-- Dependencies: 2154 2983 5
-- Name: af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) RETURNS SETOF parents
    AS $_$DECLARE
	--permet de stocker le resultat de la requete
	rec contraintes.parents;
	--permet de stocker le resultat de la fonction appelÃÂ©e recursivement
	rec_tmp contraintes.parents;
	-- variable dans laquelle on stock la chaine de la requete pour sa contruction
	req text;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃÂ© au champ pÃÅ¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--3eme parametre : numero de l'element (id) ÃÂ  partir duquel ont veut les elements (valeur du champ pere)
	id_pere ALIAS FOR  $3;
	--4eme parametre :condition de selection d'une ligne 
	cond ALIAS FOR  $4;
	--variable locale permettant l'incrÃÂ©mentation de l'indice pour le tris 
	ind int4;
BEGIN
	--on incrÃÂ©mente l'indice (5eme paramettre)
	ind:=$5 +1;
	--on construit la requete
	req:='SELECT  DISTINCT '||nom_id||' AS id, pere, '||ind ||' AS ind  FROM ';
	req:=req || nom_table ;	
	
	--on test la variable id_pere qui peut etre NULL et construit la requete en fonction
	IF id_pere IS NOT NULL THEN
		req:=req || ' where pere= ' || id_pere;
	ELSE 
		req:= req || ' where pere IS NULL ';
	END IF;

	--fin de la construction de la requete
	req:=req ||' ' || cond ||' and '||nom_id||' in ('||array_to_string($6,',')||');';

	--chaque ligne du resultat est stockÃÂ©e temporairement dans rec
	FOR rec IN 
		--execution de la requete construite
		EXECUTE req
			--pour chaque ligne de resultat (rec)
			LOOP
				--on retourne le resultat (setof contraintes.parents) de la fonction si fin de la recursivite
				IF rec.id IS NULL THEN
					RETURN ;
				ELSE 
					--sinon :
					--chaque ligne du resultat de la requete recursive est stockÃÂ©e temporairement dans rec_tmp
					FOR rec_tmp IN
						---on rappelle la fonction recursivement avec un nouveau id_pere
						SELECT * FROM contraintes.af_gen_get_elements( nom_table, nom_id, rec.id, cond, ind) 
					LOOP
						--on ajoute les elements voulus de la ligne de resultat temporaire (rec_tmp) au retour de la fonction ( setof parents )
						RETURN NEXT rec_tmp ;
					END LOOP;
						--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof parents )
					RETURN NEXT rec;
				END IF;
			END LOOP;
	-- retourne le resultat de la fonction (setof parents)
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) OWNER TO postgres;

--
-- TOC entry 7352 (class 0 OID 0)
-- Dependencies: 909
-- Name: FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) IS 'FONCTION PRIVEE:
est appellee par la fonction contraintes.af_gen_get_elements(varchar, varchar, int4, text)

Fonction gÃ©nÃ©rique permettant d''obtenir les elements d''une table ayant une notion de parentalitÃ© .

Le 1er parametre indique le nom de la table, le 2eme indique le nom du champ liÃ© au champ pÃ¨re (celui que l''on veut recuperer), le 3eme le numero du champ 2 Ã  partir duquel on veut les enregistrements,  le 4eme une chaine permetant de preciser la condition d''une ligne ( ex: ''AND toto= 8'') et le 5 eme l''indice du prÃ©cÃ©dent appel de fonction.
';


--
-- TOC entry 1829 (class 1255 OID 2595690)
-- Dependencies: 2983 5
-- Name: af_gen_get_int_values(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_gen_get_int_values(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : pas
-- $2 : max
declare
rec record;
pas integer;
max integer;
val integer;
i integer;
begin
    -- Init
    if $1 is null then
	pas:=10;
    else
	pas:=$1;
    end if;
    if $2 is null then
	max:=100;
    else
	max:=$2;
    end if;
    val:=pas;
    i:=1;
    loop
	if val<=max then
	    for rec in
		--select i,val
		select val,val
	    loop
		return next rec;
	    end loop;
	    val:=val+pas;
	    i:=i+1;
	else
	    exit;
	end if;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_get_int_values(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7354 (class 0 OID 0)
-- Dependencies: 1829
-- Name: FUNCTION af_gen_get_int_values(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_gen_get_int_values(integer, integer) IS 'genere des entiers avec un pas et un max';


--
-- TOC entry 910 (class 1255 OID 2595691)
-- Dependencies: 2154 2983 5
-- Name: af_gen_get_last_element(character varying, character varying, text); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_gen_get_last_element(character varying, character varying, text) RETURNS SETOF parents
    AS $_$DECLARE
	-- nom de la table sur laquelle executer la requete
	nom_table ALIAS FOR $1;
	-- nom du champ liÃÂ© au champ pÃÅ¡re ( le champ id )
	nom_id ALIAS FOR $2;
	-- condition de selection d'une ligne
	cond ALIAS FOR  $3;
	-- variable ou l'on stock une ligne du resultat de la requete
	rec record;
	--variable locale permettant l'initialisation de l'indice pour le tris dans l'odre ÃÂ  partir du 1er element (sans pere)
	ind_init int4;
	--variable pour stocker l'indice maximal
	ind_max int4;
	--varable pour afficher le nombre de ligne retournÃÂ©es
	nb_lignes int4;
BEGIN
	--initialisations 
	ind_init:=0;
	nb_lignes:=0;
	-- On recupere l'indice maximal
	SELECT  MAX (ind) INTO ind_max FROM contraintes.af_gen_get_elements(nom_table, nom_id, NULL,cond, ind_init) ;
	
	--chaque ligne du resultat est stockÃÂ©e temporairement dans rec
	FOR rec IN 
		-- la requete ordonnÃÂ© par l'indice
		SELECT  id, pere, ind  FROM contraintes.af_gen_get_elements(nom_table, nom_id, NULL,cond, ind_init) 
		WHERE ind = ind_max
			LOOP
				--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof int4 )
				RETURN NEXT rec;
			END LOOP;
	GET DIAGNOSTICS nb_lignes = ROW_COUNT;
	--RAISE NOTICE 'nombre de lignes: %', nb_lignes;
	-- retourne le resultat de la fonction (setof contraintes.parents)
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_get_last_element(character varying, character varying, text) OWNER TO postgres;

--
-- TOC entry 7356 (class 0 OID 0)
-- Dependencies: 910
-- Name: FUNCTION af_gen_get_last_element(character varying, character varying, text); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_gen_get_last_element(character varying, character varying, text) IS 'Retourne le dernier element d''une table ayant une notion de parentalitÃ© 

param1:
Nom de la table

param 2:
Nom du champ liÃ© au champ pere (id)

param3:
condition supplÃ©mÃ©ntaire la selection des enregistrements

exemple d''appel:
select * from contraintes.af_gen_get_last_element(varchar ''contraintes.parcours_etapes'', varchar ''etape'' ,text ''AND parcours=1'');
 ';


--
-- TOC entry 911 (class 1255 OID 2595692)
-- Dependencies: 2154 2983 5
-- Name: af_gen_get_last_element(character varying, character varying, integer[], text); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_gen_get_last_element(character varying, character varying, integer[], text) RETURNS SETOF parents
    AS $_$DECLARE
	-- nom de la table sur laquelle executer la requete
	nom_table ALIAS FOR $1;
	-- nom du champ liÃÂ© au champ pÃÅ¡re ( le champ id )
	nom_id ALIAS FOR $2;
	-- tableau des valeurs pour le champ nom_id
	val_id alias for $3;
	-- condition de selection d'une ligne
	cond ALIAS FOR  $4;
	-- variable ou l'on stock une ligne du resultat de la requete
	rec record;
	--variable locale permettant l'initialisation de l'indice pour le tris dans l'odre ÃÂ  partir du 1er element (sans pere)
	ind_init int4;
	--variable pour stocker l'indice maximal
	ind_max int4;
	--varable pour afficher le nombre de ligne retournÃÂ©es
	nb_lignes int4;
BEGIN
	--initialisations 
	ind_init:=0;
	nb_lignes:=0;
	-- On recupere l'indice maximal
	SELECT  MAX (ind) INTO ind_max FROM contraintes.af_gen_get_elements(nom_table, nom_id, NULL,cond, ind_init,val_id) ;
	
	--chaque ligne du resultat est stockÃÂ©e temporairement dans rec
	FOR rec IN 
		-- la requete ordonnÃÂ© par l'indice
		SELECT  id, pere, ind  FROM contraintes.af_gen_get_elements(nom_table, nom_id, NULL,cond, ind_init,val_id) 
		WHERE ind = ind_max
			LOOP
				--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof int4 )
				RETURN NEXT rec;
			END LOOP;
	GET DIAGNOSTICS nb_lignes = ROW_COUNT;
	RAISE NOTICE 'nombre de lignes: %', nb_lignes;
	-- retourne le resultat de la fonction (setof contraintes.parents)
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_get_last_element(character varying, character varying, integer[], text) OWNER TO postgres;

--
-- TOC entry 7358 (class 0 OID 0)
-- Dependencies: 911
-- Name: FUNCTION af_gen_get_last_element(character varying, character varying, integer[], text); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_gen_get_last_element(character varying, character varying, integer[], text) IS 'Retourne le dernier element d''une table ayant une notion de parentalitÃ© 

param1:
Nom de la table

param 2:
Nom du champ liÃ© au champ pere (id)

param3:
condition supplÃ©mÃ©ntaire la selection des enregistrements

exemple d''appel:
select * from contraintes.af_gen_get_last_element(varchar ''contraintes.parcours_etapes'', varchar ''etape'' ,text ''AND parcours=1'');
 ';


--
-- TOC entry 912 (class 1255 OID 2595693)
-- Dependencies: 2983 5
-- Name: af_gen_invert_elements(character varying, character varying, integer, integer, text); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_gen_invert_elements(character varying, character varying, integer, integer, text) RETURNS boolean
    AS $_$DECLARE
	-- variable dans laquelle on stock la chaine de la 1ere requete pour sa contruction (1ere select)
	req1 text;
	-- variable dans laquelle on stock la chaine de la 2eme requete pour sa contruction (2eme select)
	req2 text;
	req3 text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction(1er update)
	req1U text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction(2eme update)
	req2U text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction(3eme update)
	req3U text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction(4eme update)
	req4U text;
	--resultat du premier select
	rec1 record; 
	--resultat du second select
	rec2 record;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃÂ© au champ pÃÅ¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--numero d'un des 2 enregistrements que l'on veut inverser
	numero1 ALIAS FOR $3;
	--numero de l'autre enregistrement que l'on veut inverser
	numero2 ALIAS FOR $4;
	--condition de selection d'une ligne pour SELECT et UPDATE
	cond ALIAS FOR  $5;
	--boolÃÂ©en pour savoir si une l'inversion ÃÂ  eut lieu
	inverse boolean;
	--variable pour socker le nombre de ligne modifiÃÂ©es pour le premier update
	nb1 int4;
	--variable pour socker le nombre de ligne modifiÃÂ©es pour le deuxieme update
	nb2 int4;
	p1 varchar;
	p2 varchar;
	id int4;
BEGIN
	--initialisations
	inverse:=FALSE;
	nb1:=0;
	nb2:=0;

	--ON VERIFIE QUE LES 2 ELEMENTS A INVERSER NE SONT PAS NULL
	IF((numero1 IS NOT NULL  ) AND (numero2 IS NOT NULL)) THEN
	
		--ON RECUPERE LE PERE DU PREMIER ENREGISTREMENT
		req1:='SELECT   pere FROM '|| nom_table ||' WHERE '|| nom_id ||'='||numero1||' '||cond ||';';
		RAISE NOTICE 'req1=%',req1;
		--ON RECUPERE LE PERE DU SECOND ENREGISTREMENT
		req2:='SELECT   pere FROM '|| nom_table ||' WHERE '|| nom_id ||'='||numero2||' '||cond ||';';
		RAISE NOTICE 'req2=%',req2;
		--ON RECUPERE L'ID DU PERE DU PREMIER ENREGISTREMENT
		req3:='SELECT '|| nom_id ||' FROM '|| nom_table ||' WHERE  pere ='||numero1||' '||cond ||';';
		RAISE NOTICE 'req3=%',req3;
	
		EXECUTE req3 INTO id;
		
		FOR rec1 IN		
			EXECUTE req1
		LOOP
			IF rec1.pere IS NULL THEN
				p1:=' NULL';
			ELSE
				p1:=rec1.pere;
			END IF;

			FOR rec2 IN
				EXECUTE req2
			LOOP
				IF rec2.pere IS NULL THEN
					p2:=' NULL';
				ELSE
					p2:=rec2.pere;
				END IF;	


				--celui qui a B pour pere reçoit A
				req1U:= 'UPDATE '||nom_table ||' SET pere='||numero1||' WHERE  pere  =' || numero2 ||' '|| cond ||';';
				RAISE NOTICE 'req1U=%',req1U;
				EXECUTE req1U;

				--celui qui a A pour pere reçoit B (cad id reçoit B )
				IF numero2!=id THEN
					req2U:= 'UPDATE '||nom_table ||' SET pere='||numero2||' WHERE '|| nom_id|| ' =' ||id ||' '|| cond ||';';
					RAISE NOTICE 'req2U=%',req2U;
					EXECUTE req2U;
				END IF;

				--A reçoit le pere de B (ou B)
				IF numero1!=p2 THEN 
					req3U:= 'UPDATE '||nom_table ||' SET pere='||p2 ||' WHERE '|| nom_id|| ' =' || numero1 ||' '|| cond ||';';
					RAISE NOTICE '1req3U=%',req3U;
					EXECUTE req3U;
				ELSE
					req3U:= 'UPDATE '||nom_table ||' SET pere='||numero2||' WHERE '|| nom_id|| ' =' || numero1 ||' '|| cond ||';';
					RAISE NOTICE '2req3U=%',req3U;
					EXECUTE req3U;
				END IF;
		
				--B reçoit le pere de A (ou A)
				IF numero2!=p1 THEN 
					req4U:= 'UPDATE '||nom_table ||' SET pere='||p1||' WHERE '|| nom_id|| ' =' || numero2 ||' '|| cond ||';';
					RAISE NOTICE '1req4U=%',req4U;
					EXECUTE req4U;
				ELSE
					req4U:= 'UPDATE '||nom_table ||' SET pere='||numero1||' WHERE '|| nom_id|| ' =' || numero2 ||' '|| cond ||';';
					RAISE NOTICE '2req4U=%',req4U;
					EXECUTE req4U;
				END IF;


				-- OBTIENT LE NOMBRE DE LIGNES UPDATEE POUR LE PREMIER NUMERO
				--GET DIAGNOSTICS nb1 = ROW_COUNT;
		
				-- OBTIENT LE NOMBRE DE LIGNES UPDATEE  POUR LE DEUXIEME NUMERO
				--GET DIAGNOSTICS nb2= ROW_COUNT;
				--IF ( (nb1>0)AND( nb2>0) )THEN
					inverse:=TRUE;
				--END IF;
			END LOOP;
		END LOOP;
	
	ELSE
			RAISE EXCEPTION 'Les numeros des elements ÃÂ  inverser ne peuvent etre NULL';
	END IF;
	

	--RETOURNE TRUE SI AU MOINS 2*1 LIGNE A ETE UPDATEE
	RETURN inverse;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_invert_elements(character varying, character varying, integer, integer, text) OWNER TO postgres;

--
-- TOC entry 7360 (class 0 OID 0)
-- Dependencies: 912
-- Name: FUNCTION af_gen_invert_elements(character varying, character varying, integer, integer, text); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_gen_invert_elements(character varying, character varying, integer, integer, text) IS 'Fonction gÃ©nÃ©rÃ©ique pour inverser deux elements dans une table avec une notion de parentalitÃ©.

Param1:
nom de la table

Param2:
Nom du champ liÃ© au pere (id)

Param3:
Numero du premier element Ã  inverser

Param4:
Numero du second element Ã  inverser

Param5:
Condition de selection d''une ligne

Exemple d''execution:
select contraintes.af_gen_invert_elements(varchar ''contraintes.parcours_etapes'', varchar ''etape'' ,2, 9 ,text ''AND parcours=1'');

Retourne TRUE si l''invertion s''est bien passÃ©e.';


--
-- TOC entry 1831 (class 1255 OID 2595694)
-- Dependencies: 2983 5
-- Name: af_gen_set_element(character varying, character varying, integer, integer, text, text, text); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_gen_set_element(character varying, character varying, integer, integer, text, text, text) RETURNS boolean
    AS $_$DECLARE
	--permet de stocker le resultat de la requete
	rec1 contraintes.parents;
	rec1_pere varchar;
	--permet de stocker le resultat de la fonction appelÃÂ©e recursivement
	rec_tmp contraintes.parents;
	-- variable dans laquelle on stock la chaine de la 1ere requete pour sa contruction
	req1 text;
	-- variable dans laquelle on stock la chaine de la 2eme requete pour sa contruction
	req2 text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction
	req3 text;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃÂ© au champ pÃÅ¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--numero de l'enregistrement pour lequel on veut inserer avant
	indice ALIAS FOR $3;
	--numero de l'enregistrement ÃÂ  inserer
	nouveau ALIAS FOR $4;
	--chaine des champs supplÃÂ©mÃÂ©ntaires pour l'insertion
	champs ALIAS FOR  $5;
	--chaine des valeurs des champs pour l'insertion
	champs_values ALIAS FOR  $6;
	--condition de selection d'une ligne pour SELECT et UPDATE
	cond ALIAS FOR  $7;
	--boolÃÂ©en pour savoir si une insertion ÃÂ  eut lieu
	insere boolean;
	--nombre de lignes inserees
	nb int4 :=0;
BEGIN
	--initialisation
	insere:=FALSE;

	--SI ON INSERE AU DEBUT OU AU MILIEU
	--raise notice 'on insere avant %=%',nom_id, indice;
	IF (indice IS NOT NULL) THEN
		--ON RECUPERE LE PERE DE LA LIGNE OU L'ON INSERE AVANT
		req1:='SELECT '|| nom_id ||' AS id, pere, NULL FROM '|| nom_table ||' WHERE '|| nom_id ;
		IF (indice IS NULL) THEN
			req1:=req1 ||' IS NULL' ;
		ELSE
			req1:=req1 ||' =' || indice ;
		END IF;
		req1:=req1 ||' '|| cond ||';';
	--SI ON INSERE A LA FIN
	ELSE
		req1:='select pere, id, ind from contraintes.af_gen_get_last_element(varchar '''|| nom_table ||''', varchar '''|| nom_id ||'''  ,text '''||cond||''');';
	END IF; 
	--chaque ligne du resultat est stockÃÂ©e temporairement dans rec
	raise notice 'req1=%',req1;
	FOR rec1 IN 
		--execution de la requete construite
		EXECUTE req1
	--pour chaque ligne de resultat (rec)
	LOOP
		nb:= nb+1;
		IF rec1.pere IS NULL THEN
			rec1_pere := 'NULL';
		ELSE
			rec1_pere :=rec1.pere ;
		END IF;
		--ON INSERE LE NOUVEL ELEMENT
		req2:='INSERT INTO  '||nom_table||' ( ' || nom_id || ', pere '|| champs ||')  VALUES ( '|| nouveau  ||', '|| rec1_pere  || champs_values  ||') ;';		
		raise notice 'req2a=% ', req2;
		EXECUTE req2;
		-- OBTIENT LE NOMBRE DE LIGNES INSEREES
		--GET DIAGNOSTICS nb := ROW_COUNT;
		IF  nb>0 THEN
			--raise notice 'insere';
			insere:=TRUE;
		END IF;
	END LOOP;
	
	IF (nb = 0) AND (insere IS FALSE) THEN
		req2:='INSERT INTO  '||nom_table||' ( ' || nom_id || ', pere '|| champs ||')  VALUES ( '|| nouveau  ||', NULL '|| champs_values  ||') ;';		
		raise notice 'req2b=% ', req2;
		EXECUTE req2;
		RETURN FOUND;
	END IF;
	--UPDATE DES LIGNES POUR LEQUELLES IL FAUT CHANGER LE PERE
	req3:= 'UPDATE '||nom_table ||' SET pere='||nouveau ||' WHERE '|| nom_id ;
	IF indice IS NULL THEN
		req3:=req3 ||' IS NULL' ;
	ELSE
		req3:=req3 ||' =' || indice ;
	END IF;
	req3:=req3 ||' '|| cond ||';';
	raise notice 'req3=%',req3;
	EXECUTE req3;

	--RETOURNE TRUE SI AU MOINS UNE LIGNE INSEREE
	RETURN insere;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_gen_set_element(character varying, character varying, integer, integer, text, text, text) OWNER TO postgres;

--
-- TOC entry 7362 (class 0 OID 0)
-- Dependencies: 1831
-- Name: FUNCTION af_gen_set_element(character varying, character varying, integer, integer, text, text, text); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_gen_set_element(character varying, character varying, integer, integer, text, text, text) IS 'Fonction gÃ©nÃ©rÃ©ique pour inserer un nouvel element dans une table avec une notion de parentalitÃ© AVANT un champ spÃ©cifiÃ©.

Param1:
nom de la table

Param2:
Nom du champ liÃ© au pere (id)

Param3:
Numero de l''Ã©lÃ©ment(id) avant lequel on insere. NULL pour inserer Ã  la fin.

Param4:
Numero du nouvel Ã©lÃ©ment

Param5:
champs suplÃ©mentaires pour l''insertion.

Param6:
valeurs des champs supplÃ©mentaires pour l''insertion 

Param7:
Condition de selection d''une ligne pour l''update

Exemple d''execution:
select contraintes.af_gen_insert_element(varchar ''contraintes.parcours_etapes'', varchar ''etape'' , 5, 9 , varchar '', parcours'',varchar '',1'',text ''AND parcours=1'');

Retourne TRUE si l''insertion c''est bien passÃ©e.';


--
-- TOC entry 1832 (class 1255 OID 2595695)
-- Dependencies: 2983 5
-- Name: af_get_alerte(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_alerte(integer) RETURNS record
    AS $_$-- $1 : numero alerte
declare
rec record;
begin
    select into rec id,libelle,formation,date,jours,texte from contraintes.alerte where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_alerte(integer) OWNER TO pgsql;

--
-- TOC entry 7364 (class 0 OID 0)
-- Dependencies: 1832
-- Name: FUNCTION af_get_alerte(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_alerte(integer) IS 'retourne les infos d''une alerte';


--
-- TOC entry 1833 (class 1255 OID 2595696)
-- Dependencies: 2983 5
-- Name: af_get_alerte_periode_max(integer, date); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_alerte_periode_max(integer, date) RETURNS integer
    AS $_$-- $1 : numero formation
-- $2 : date
declare
my_date date;
periode int4;

begin
    -- recup la date suivante
    select into my_date min(date) from contraintes.alerte 
    where date>$2 and formation=$1;
    if my_date is not null then
	periode:=my_date - $2;
    else
	periode:=15;
    end if;
    return periode;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_alerte_periode_max(integer, date) OWNER TO pgsql;

--
-- TOC entry 7366 (class 0 OID 0)
-- Dependencies: 1833
-- Name: FUNCTION af_get_alerte_periode_max(integer, date); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_alerte_periode_max(integer, date) IS 'retourne la periode maxi pour une alerte de formation';


--
-- TOC entry 913 (class 1255 OID 2595697)
-- Dependencies: 2983 5
-- Name: af_get_alertes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_alertes() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,formation,date,jours,texte from contraintes.alerte
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_alertes() OWNER TO pgsql;

--
-- TOC entry 7368 (class 0 OID 0)
-- Dependencies: 913
-- Name: FUNCTION af_get_alertes(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_alertes() IS 'retourne les alertes de la plateforme';


--
-- TOC entry 914 (class 1255 OID 2595698)
-- Dependencies: 2983 5
-- Name: af_get_alertes_liees(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_alertes_liees(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;
begin
    if contraintes.fw_is_root($1) then
    for rec in 
	select id,libelle,formation,date,jours,texte from contraintes.alerte where formation is not null
    loop
	return next rec;
    end loop;
    else
    for rec in 
	select id,libelle,a.formation,date,jours,texte from contraintes.alerte a,contraintes.formation_participants fp 
	where a.formation is not null and a.formation=fp.formation and fp.formateur=$1 
    loop
	return next rec;
    end loop;
    end if;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_alertes_liees(integer) OWNER TO pgsql;

--
-- TOC entry 7370 (class 0 OID 0)
-- Dependencies: 914
-- Name: FUNCTION af_get_alertes_liees(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_alertes_liees(integer) IS 'retourne les alertes de la plateforme qui sont liees à une formation pour le root ou le formateur';


--
-- TOC entry 915 (class 1255 OID 2595699)
-- Dependencies: 2983 5
-- Name: af_get_alertes_non_liees(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_alertes_non_liees() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,formation,date,jours,texte from contraintes.alerte where formation is null
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_alertes_non_liees() OWNER TO pgsql;

--
-- TOC entry 7372 (class 0 OID 0)
-- Dependencies: 915
-- Name: FUNCTION af_get_alertes_non_liees(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_alertes_non_liees() IS 'retourne les alertes non liees à une formation';


--
-- TOC entry 916 (class 1255 OID 2595700)
-- Dependencies: 2983 5
-- Name: af_get_all_themes(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_all_themes() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
   
	FOR rec IN
	--pour la conversion du int4 en varchar, on utilise un masque de 9999999999 car les valeurs d'un int4
	--vont de -2147483648 Ã  +2147483647, il faut ensuite supprimer les blancs du dÃ©but de la chaine du aux '9' inutiles par rapport aux
	--nombres de chiffres rÃ©els du nombre 

		SELECT id, libelle, trim(leading ' ' from (CAST(to_char(id, '9999999999') AS varchar))) FROM contraintes.theme ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;
    
	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_all_themes() OWNER TO postgres;

--
-- TOC entry 917 (class 1255 OID 2595701)
-- Dependencies: 2983 5
-- Name: af_get_bareme(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_bareme(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN

	SELECT into rec * FROM contraintes.af_get_baremes() as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4) 
	WHERE id=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_bareme(integer) OWNER TO pgsql;

--
-- TOC entry 7375 (class 0 OID 0)
-- Dependencies: 917
-- Name: FUNCTION af_get_bareme(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_bareme(integer) IS 'Obtenir les informations d''un bareme.';


--
-- TOC entry 918 (class 1255 OID 2595702)
-- Dependencies: 2983 5
-- Name: af_get_baremes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_baremes() RETURNS SETOF record
    AS $$DECLARE
rec record;
BEGIN
	FOR  rec IN
		SELECT * FROM contraintes.bareme
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_baremes() OWNER TO pgsql;

--
-- TOC entry 919 (class 1255 OID 2595703)
-- Dependencies: 2983 5
-- Name: af_get_capacite(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_capacite(integer) RETURNS record
    AS $_$-- $1 : numero capacite
declare
rec record;
begin
    select into rec id,libelle from contraintes.capacite where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_capacite(integer) OWNER TO pgsql;

--
-- TOC entry 7378 (class 0 OID 0)
-- Dependencies: 919
-- Name: FUNCTION af_get_capacite(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_capacite(integer) IS 'retourne les infos d''une capacite';


--
-- TOC entry 920 (class 1255 OID 2595704)
-- Dependencies: 2983 5
-- Name: af_get_capacite_titre(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_capacite_titre(integer) RETURNS record
    AS $_$-- $1 : numro capacite_titre
declare
rec record;
begin
    select into rec id,libelle from contraintes.capacite_titre where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_capacite_titre(integer) OWNER TO pgsql;

--
-- TOC entry 7380 (class 0 OID 0)
-- Dependencies: 920
-- Name: FUNCTION af_get_capacite_titre(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_capacite_titre(integer) IS 'retourne les infos d''un titre de capacite';


--
-- TOC entry 921 (class 1255 OID 2595705)
-- Dependencies: 2983 5
-- Name: af_get_capacite_titre_capacite_themes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_capacite_titre_capacite_themes(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;
begin
    if contraintes.fw_is_root($1) then
    for rec in 
	select distinct t.id,t.libelle from
	(contraintes.theme t
	left outer join
	--(contraintes.af_get_categorie_themes(11) as (ct_id int4,ct_libelle varchar)
	contraintes.categorie_capacite_titre cct
	on t.id=cct.theme
	left outer join 
	contraintes.capacite_titre_capacites ctc
	on ctc.capacite_titre=cct.id)
	where cct.theme is not null and ctc.capacite_titre is not null 
	
	
	
     loop
	return next rec;
     end loop;
    else
    for rec in 
	select distinct t.id,t.libelle from
	(contraintes.theme t
	left outer join
	--(contraintes.af_get_categorie_themes(11) as (ct_id int4,ct_libelle varchar)
	contraintes.categorie_capacite_titre cct
	on( t.id=cct.theme and ( t.individu=$1 OR t.individu IS NULL) )
 
	left outer join 
	contraintes.capacite_titre_capacites ctc
	on ctc.capacite_titre=cct.id)
	where cct.theme is not null and ctc.capacite_titre is not null 
	
	
	
     loop
	return next rec;
     end loop;
    end if;
     return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_capacite_titre_capacite_themes(integer) OWNER TO pgsql;

--
-- TOC entry 7382 (class 0 OID 0)
-- Dependencies: 921
-- Name: FUNCTION af_get_capacite_titre_capacite_themes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_capacite_titre_capacite_themes(integer) IS 'retourne les themes des couples capacite_titre / capacite pour un un individu';


--
-- TOC entry 922 (class 1255 OID 2595706)
-- Dependencies: 2983 5
-- Name: af_get_capacite_titre_capacites(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_capacite_titre_capacites(integer) RETURNS SETOF record
    AS $_$-- $1 : numero capacite_titre
declare
rec record;
begin
    for rec in 
	select c.id,c.libelle,ctc.capacite_titre from contraintes.capacite c,contraintes.capacite_titre_capacites ctc
	where ctc.capacite_titre=$1 and c.id=ctc.capacite
    loop
	return next rec;
    end loop;
    return;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_capacite_titre_capacites(integer) OWNER TO pgsql;

--
-- TOC entry 7384 (class 0 OID 0)
-- Dependencies: 922
-- Name: FUNCTION af_get_capacite_titre_capacites(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_capacite_titre_capacites(integer) IS 'retourne les capacites pour un titre de capacite';


--
-- TOC entry 923 (class 1255 OID 2595707)
-- Dependencies: 2983 5
-- Name: af_get_capacite_titre_capacites_disponibles(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_capacite_titre_capacites_disponibles(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero capacite_titre
-- $2 : numero theme
declare
rec record;
begin
    for rec in 
	
	select distinct c.id,c.libelle,$1 as capacite_titre from
	(contraintes.capacite c
	left outer join
	contraintes.capacite_titre_capacites ctc
	on c.id=ctc.capacite and ctc.capacite_titre=$1),

	contraintes.af_get_categorie_elements_theme(10,$2) et 
	
	
	where 
	ctc.capacite is null and 
	c.id=et
	
	
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_capacite_titre_capacites_disponibles(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7386 (class 0 OID 0)
-- Dependencies: 923
-- Name: FUNCTION af_get_capacite_titre_capacites_disponibles(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_capacite_titre_capacites_disponibles(integer, integer) IS 'retourne les capacites disponible pour un titre de capacite et un theme';


--
-- TOC entry 924 (class 1255 OID 2595708)
-- Dependencies: 2983 5
-- Name: af_get_categorie(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_categorie(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;

BEGIN
	SELECT INTO rec * FROM contraintes.af_get_categories() AS ( id int4 ,  libelle varchar, table_cible varchar,  gestionnaire_contenu bool , code varchar)
	WHERE id=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie(integer) OWNER TO postgres;

--
-- TOC entry 7388 (class 0 OID 0)
-- Dependencies: 924
-- Name: FUNCTION af_get_categorie(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_categorie(integer) IS 'Obtenir les informations d''une categorie.';


--
-- TOC entry 925 (class 1255 OID 2595709)
-- Dependencies: 2983 5
-- Name: af_get_categorie_elements(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_categorie_elements(integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
	for rec in
	select id,theme,categorie from contraintes.theme_categories
	where categorie=$1
	loop
	return next rec;
	end loop;
	return;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_elements(integer) OWNER TO pgsql;

--
-- TOC entry 7390 (class 0 OID 0)
-- Dependencies: 925
-- Name: FUNCTION af_get_categorie_elements(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_categorie_elements(integer) IS 'retourne les elements d''une categorie';


--
-- TOC entry 926 (class 1255 OID 2595710)
-- Dependencies: 2983 5
-- Name: af_get_categorie_elements_all_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_categorie_elements_all_theme(integer, integer) RETURNS SETOF integer
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
table_cible varchar;
BEGIN

	--recupere la table correspondant Ã  la categorie
	SELECT INTO table_cible  C_table_cible FROM contraintes.af_get_categorie($1)AS ( C_id int4 ,  C_libelle varchar, C_table_cible varchar,  C_gestionnaire_contenu bool, code varchar);

	req:='SELECT TC.id FROM contraintes.theme_categories TC, contraintes.categorie_'||table_cible||' CI
		WHERE TC.categorie='||$1||'
		AND TC.theme='||$2||'
		AND CI.id=TC.id';
	--RAISE NOTICE 'req: %',req;
	
	FOR rec IN
		EXECUTE req
	LOOP
		RETURN NEXT rec.id; 
	END LOOP;

	RETURN;
		 
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_elements_all_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 7392 (class 0 OID 0)
-- Dependencies: 926
-- Name: FUNCTION af_get_categorie_elements_all_theme(integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_categorie_elements_all_theme(integer, integer) IS 'Obtenir tous les éléments d''un theme pour une categorie, y compris les fichiers non connectés.

Il faur donc utiliser:
af_get_categorie_elements_theme
dans la plate-forme';


--
-- TOC entry 927 (class 1255 OID 2595711)
-- Dependencies: 2983 5
-- Name: af_get_categorie_elements_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_categorie_elements_theme(integer, integer) RETURNS SETOF integer
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
table_cible varchar;
BEGIN

	--recupere la table correspondant Ã  la categorie
	SELECT INTO table_cible  C_table_cible FROM contraintes.af_get_categorie($1)AS ( C_id int4 ,  C_libelle varchar, C_table_cible varchar,  C_gestionnaire_contenu bool, code varchar);

	req:='SELECT distinct TC.id FROM contraintes.theme_categories TC, contraintes.af_get_theme_elements('||$2||') AS (T_id int4,T_categorie int4), contraintes.categorie_'||table_cible||' CI
		WHERE TC.categorie='||$1||'
		AND TC.theme='||$2||'
		AND CI.id=TC.id
		AND T_id=TC.id';
	--RAISE NOTICE 'req: %',req;
	
	FOR rec IN
		EXECUTE req
	LOOP
		RETURN NEXT rec.id; 
	END LOOP;

	RETURN;
		 
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_elements_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 7394 (class 0 OID 0)
-- Dependencies: 927
-- Name: FUNCTION af_get_categorie_elements_theme(integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_categorie_elements_theme(integer, integer) IS 'Obtenir tous les éléments d''un theme pour une categorie qui sont utilisables dans la plate-forme. (les fichiers non-connectés n''aparaissent pas).';


--
-- TOC entry 928 (class 1255 OID 2595712)
-- Dependencies: 2983 5
-- Name: af_get_categorie_fichiers_all_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_categorie_fichiers_all_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
type_categorie int4;
BEGIN

	--recupere le type de fichier correspondant Ã  la categorie
	SELECT INTO type_categorie id FROM contraintes.fichier_type
	WHERE categorie = $1;

	IF type_categorie IS NULL THEN
		RAISE EXCEPTION 'La categorie % n''a pas de type de fichier associÃ©',$1;
	END IF;


		--req:='SELECT id, libelle,"type",connecte FROM contraintes.af_get_fichiers_type('||type_categorie||') AS (id int4, libelle varchar, "type" int4, connecte bool),
		--	contraintes.af_get_categorie_elements_all_theme('||$1||','||$2||') E_id
		--	WHERE id=E_id ORDER BY libelle';
	
	FOR rec IN
		SELECT id, libelle,"type",connecte FROM contraintes.af_get_fichiers_type(type_categorie) AS (id int4, libelle varchar, "type" int4, connecte bool),
		contraintes.af_get_categorie_elements_all_theme($1,$2) E_id
		WHERE id=E_id ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_fichiers_all_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 7396 (class 0 OID 0)
-- Dependencies: 928
-- Name: FUNCTION af_get_categorie_fichiers_all_theme(integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_categorie_fichiers_all_theme(integer, integer) IS 'Obtenir tous les fichiers d''un theme pour une categorie.';


--
-- TOC entry 1834 (class 1255 OID 2595713)
-- Dependencies: 2983 5
-- Name: af_get_categorie_fichiers_scenario_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_categorie_fichiers_scenario_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
type_categorie int4;
BEGIN

	--recupere le type de fichier correspondant Ã  la categorie
	SELECT INTO type_categorie id FROM contraintes.fichier_type
	WHERE categorie = $1;

	IF type_categorie IS NULL THEN
		RAISE EXCEPTION 'La categorie % n''a pas de type de fichier associÃ©',$1;
	END IF;


		--req:='SELECT id, libelle,"type",connecte FROM contraintes.af_get_fichiers_type('||type_categorie||') AS (id int4, libelle varchar, "type" int4, connecte bool),
		--	contraintes.af_get_categorie_elements_all_theme('||$1||','||$2||') E_id
		--	WHERE id=E_id ORDER BY libelle';
	
	FOR rec IN
		SELECT id, libelle,"type",connecte FROM contraintes.af_get_fichiers_type(type_categorie) AS (id int4, libelle varchar, "type" int4, connecte bool),
		contraintes.af_get_categorie_elements_theme($1,$2) E_id
		WHERE id=E_id ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_fichiers_scenario_theme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7398 (class 0 OID 0)
-- Dependencies: 1834
-- Name: FUNCTION af_get_categorie_fichiers_scenario_theme(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_categorie_fichiers_scenario_theme(integer, integer) IS 'Obtenir les fichiers connectés d''un theme pour un scenario.';


--
-- TOC entry 929 (class 1255 OID 2595714)
-- Dependencies: 2983 5
-- Name: af_get_categorie_fichiers_textes_all_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_categorie_fichiers_textes_all_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
type_categorie int4;
BEGIN

	--recupere le type de fichier correspondant Ã  la categorie
	SELECT INTO type_categorie id FROM contraintes.fichier_type
	WHERE categorie = $1;

	IF type_categorie IS NULL THEN
		RAISE EXCEPTION 'La categorie % n''a pas de type de fichier associÃ©',$1;
	END IF;

	--req:='SELECT T_id, T_libelle,"type",connecte, T.libelle, T.adresse, T.description, T.mise_en_forme, TO_CHAR(T.date_modification,''DD/MM/YYYY'') FROM contraintes.af_get_fichiers_type('||type_categorie||') AS (T_id int4, T_libelle varchar, "type" int4, connecte bool),
	--		contraintes.af_get_categorie_elements_all_theme('||$1||','||$2||') E_id, contraintes.fichier_texte T
	--		WHERE T_id=E_id
	--		AND T_id=T.id  ORDER BY T_libelle';
	

	RAISE NOTICE 'req: %',req;

	FOR rec IN
		SELECT T_id, T_libelle,"type",connecte, T.libelle, T.adresse, T.description, T.mise_en_forme, TO_CHAR(T.date_modification,'DD/MM/YYYY') FROM contraintes.af_get_fichiers_type(type_categorie) AS (T_id int4, T_libelle varchar, "type" int4, connecte bool),
		contraintes.af_get_categorie_elements_all_theme($1,$2) E_id, contraintes.fichier_ressource_texte T
		WHERE T_id=E_id
		AND T_id=T.id  ORDER BY T_libelle
	
	LOOP
		RETURN NEXT rec;
	END LOOP;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_fichiers_textes_all_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 7400 (class 0 OID 0)
-- Dependencies: 929
-- Name: FUNCTION af_get_categorie_fichiers_textes_all_theme(integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_categorie_fichiers_textes_all_theme(integer, integer) IS 'Obtenir tous les fichiers textes d''un theme pour une categorie.';


--
-- TOC entry 930 (class 1255 OID 2595715)
-- Dependencies: 2983 5
-- Name: af_get_categorie_fichiers_textes_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_categorie_fichiers_textes_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
type_categorie int4;
BEGIN

	--recupere le type de fichier correspondant Ã  la categorie
	SELECT INTO type_categorie id FROM contraintes.fichier_type
	WHERE categorie = $1;

	IF type_categorie IS NULL THEN
		RAISE EXCEPTION 'La categorie % n''a pas de type de fichier associÃ©',$1;
	END IF;

	--req:='SELECT T_id, T_libelle,"type",connecte, T.libelle, T.adresse, T.description, T.mise_en_forme, TO_CHAR(T.date_modification,''DD/MM/YYYY'') FROM contraintes.af_get_fichiers_type('||type_categorie||') AS (T_id int4, T_libelle varchar, "type" int4, connecte bool),
	--		contraintes.af_get_categorie_elements_all_theme('||$1||','||$2||') E_id, contraintes.fichier_texte T
	--		WHERE T_id=E_id
	--		AND T_id=T.id  ORDER BY T_libelle';
	

	RAISE NOTICE 'req: %',req;

	FOR rec IN
		SELECT T_id, T_libelle,"type",connecte, T.libelle, T.adresse, T.description, T.mise_en_forme, TO_CHAR(T.date_modification,'DD/MM/YYYY') FROM contraintes.af_get_fichiers_type(type_categorie) AS (T_id int4, T_libelle varchar, "type" int4, connecte bool),
		contraintes.af_get_categorie_elements_theme($1,$2) E_id, contraintes.fichier_ressource_texte T
		WHERE T_id=E_id
		AND T_id=T.id  ORDER BY T_libelle
	
	LOOP
		RETURN NEXT rec;
	END LOOP;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_fichiers_textes_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 7402 (class 0 OID 0)
-- Dependencies: 930
-- Name: FUNCTION af_get_categorie_fichiers_textes_theme(integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_categorie_fichiers_textes_theme(integer, integer) IS 'Obtenir les fichiers textes connectés d''un theme pour une categorie.';


--
-- TOC entry 931 (class 1255 OID 2595716)
-- Dependencies: 2983 5
-- Name: af_get_categorie_fichiers_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_categorie_fichiers_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
type_categorie int4;
BEGIN

	--recupere le type de fichier correspondant Ã  la categorie
	SELECT INTO type_categorie id FROM contraintes.fichier_type
	WHERE categorie = $1;

	IF type_categorie IS NULL THEN
		RAISE EXCEPTION 'La categorie % n''a pas de type de fichier associÃ©',$1;
	END IF;


		--req:='SELECT id, libelle,"type",connecte FROM contraintes.af_get_fichiers_type('||type_categorie||') AS (id int4, libelle varchar, "type" int4, connecte bool),
		--	contraintes.af_get_categorie_elements_all_theme('||$1||','||$2||') E_id
		--	WHERE id=E_id ORDER BY libelle';
	
	FOR rec IN
		SELECT id, libelle,"type",connecte FROM contraintes.af_get_fichiers_type(type_categorie) AS (id int4, libelle varchar, "type" int4, connecte bool),
		contraintes.af_get_categorie_elements_theme($1,$2) E_id
		WHERE id=E_id ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_fichiers_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 7404 (class 0 OID 0)
-- Dependencies: 931
-- Name: FUNCTION af_get_categorie_fichiers_theme(integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_categorie_fichiers_theme(integer, integer) IS 'Obtenir les fichiers connectés d''un theme pour une categorie.';


--
-- TOC entry 932 (class 1255 OID 2595717)
-- Dependencies: 2983 5
-- Name: af_get_categorie_fichiers_themes(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_categorie_fichiers_themes(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero categorie
-- $2 : theme
-- $3 : theme modele
declare
rec record;
type_categorie int4;
begin
    for rec in
	select distinct * from
	(select * from contraintes.af_get_categorie_fichiers_theme($1,$2) as (id int4,libelle varchar,type int4,connecte bool) 
	union
	select * from contraintes.af_get_categorie_fichiers_theme($1,$3) as (id int4,libelle varchar,type int4,connecte bool)) CF
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_fichiers_themes(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7406 (class 0 OID 0)
-- Dependencies: 932
-- Name: FUNCTION af_get_categorie_fichiers_themes(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_categorie_fichiers_themes(integer, integer, integer) IS 'retourne les fichiers pour une categorie et deux themes';


--
-- TOC entry 933 (class 1255 OID 2595718)
-- Dependencies: 2983 5
-- Name: af_get_categorie_themes(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_categorie_themes(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : categorie
-- $2 : individu
declare
rec record;
begin
    if contraintes.fw_is_root($2) then
    for rec in
	select DISTINCT t.id,t.libelle from contraintes.theme_categories c,contraintes.theme t 
	where c.categorie=$1
	and c.theme=t.id

    loop
	return next rec;
    end loop;
    else
    for rec in
	select DISTINCT t.id,t.libelle from contraintes.theme_categories c,contraintes.theme t 
	where c.categorie=$1
	and c.theme=t.id and (t.individu=$2 OR t.individu IS NULL)

    loop
	return next rec;
    end loop;
    end if;
    return;

end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_themes(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7408 (class 0 OID 0)
-- Dependencies: 933
-- Name: FUNCTION af_get_categorie_themes(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_categorie_themes(integer, integer) IS 'retourne les themes d''une categorie
pour un individu';


--
-- TOC entry 934 (class 1255 OID 2595719)
-- Dependencies: 2983 5
-- Name: af_get_categorie_themes_element_infos(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_categorie_themes_element_infos(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 element
rec RECORD;
BEGIN
	FOR rec IN
		SELECT T.id, T.libelle FROM contraintes.theme T, contraintes.theme_categories TC
		WHERE TC.id=$2
		AND TC.categorie=$1
		AND TC.theme=T.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
	
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_themes_element_infos(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7410 (class 0 OID 0)
-- Dependencies: 934
-- Name: FUNCTION af_get_categorie_themes_element_infos(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_categorie_themes_element_infos(integer, integer) IS 'Obtenir les informations sur les themes d''un element pour une categorie.';


--
-- TOC entry 935 (class 1255 OID 2595720)
-- Dependencies: 2983 5
-- Name: af_get_categorie_themes_type_evaluation(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_categorie_themes_type_evaluation(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : categorie
-- $2 : type
-- $3 : individu
declare
rec record;
begin
    
    for rec in
        select distinct ct_id,ct_libelle from contraintes.af_get_categorie_themes($1,$3) as (ct_id int4,ct_libelle varchar),
	contraintes.af_get_categorie_elements($1) as (c_id int4,c_theme int4,c_categorie int4),
	contraintes.evaluation e 
	where e.type=$2 and c_theme=ct_id 
	and e.id=c_id
    loop
	return next rec;
    end loop;
    

    return;
	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categorie_themes_type_evaluation(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7412 (class 0 OID 0)
-- Dependencies: 935
-- Name: FUNCTION af_get_categorie_themes_type_evaluation(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_categorie_themes_type_evaluation(integer, integer, integer) IS 'retourne les themes pour une categorie et un type d''evaluation et un individu';


--
-- TOC entry 936 (class 1255 OID 2595721)
-- Dependencies: 2983 5
-- Name: af_get_categories(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_categories() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM contraintes.categorie ORDER BY gestionnaire_contenu, libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categories() OWNER TO postgres;

--
-- TOC entry 7414 (class 0 OID 0)
-- Dependencies: 936
-- Name: FUNCTION af_get_categories(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_categories() IS 'Obtenir toutes les categories de la plate-forme';


--
-- TOC entry 937 (class 1255 OID 2595722)
-- Dependencies: 2983 5
-- Name: af_get_categories(boolean); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_categories(boolean) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM contraintes.af_get_categories()AS (id integer, libelle varchar, table_cible varchar, gestionnaire_contenus boolean, code varchar)
		WHERE gestionnaire_contenus = $1
		ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_categories(boolean) OWNER TO postgres;

--
-- TOC entry 7416 (class 0 OID 0)
-- Dependencies: 937
-- Name: FUNCTION af_get_categories(boolean); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_categories(boolean) IS 'Obtenir les categories de la plate-formeen fonction de gestionnaire_contenu';


--
-- TOC entry 938 (class 1255 OID 2595723)
-- Dependencies: 2983 5
-- Name: af_get_classe(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec * from 
    contraintes.af_get_classes() as(id int4,libelle varchar,pere int4,min int4,max int4) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe(integer) OWNER TO pgsql;

--
-- TOC entry 7418 (class 0 OID 0)
-- Dependencies: 938
-- Name: FUNCTION af_get_classe(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe(integer) IS 'retourne les infos d''une classe';


--
-- TOC entry 939 (class 1255 OID 2595724)
-- Dependencies: 2983 5
-- Name: af_get_classe_droits_communs(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_droits_communs(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero classe
-- $2 : nombre d'individu ds la classe
declare
rec record;
begin
    for rec in
	select droit from contraintes.individu_droits where classe=$1 
	group by droit having count(*)=$2
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_droits_communs(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7420 (class 0 OID 0)
-- Dependencies: 939
-- Name: FUNCTION af_get_classe_droits_communs(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_droits_communs(integer, integer) IS 'retourne les droits communs pour les individus d''une classe';


--
-- TOC entry 940 (class 1255 OID 2595725)
-- Dependencies: 2983 5
-- Name: af_get_classe_droits_non_affilies(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_droits_non_affilies(integer) RETURNS SETOF record
    AS $_$-- $1 : numero classe
declare
rec record;
begin
    for rec in 
	select distinct d.id from contraintes.droit d
	left outer join
	contraintes.individu_droits id  
	on d.id=id.droit and id.classe=$1 and d.type=2
	where  id.droit is null  
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_droits_non_affilies(integer) OWNER TO pgsql;

--
-- TOC entry 7422 (class 0 OID 0)
-- Dependencies: 940
-- Name: FUNCTION af_get_classe_droits_non_affilies(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_droits_non_affilies(integer) IS 'retourne les droits non affilies pour une classe (droit que personne ne possede)';


--
-- TOC entry 941 (class 1255 OID 2595726)
-- Dependencies: 2983 5
-- Name: af_get_classe_evenements(integer, date); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_evenements(integer, date) RETURNS SETOF record
    AS $_$-- $1 : classe
-- $2 : date
declare
rec record;
begin
    for rec in
	select e.formation,e.libelle,e.date,e.duree,e.modalite,e.intervention,e.intervenant,e.salle 
	from contraintes.evenement e,contraintes.formation_participants fp 
	where e.formation=fp.formation and fp.classe=$1 and cast(e.date as date)=$2
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_evenements(integer, date) OWNER TO pgsql;

--
-- TOC entry 7424 (class 0 OID 0)
-- Dependencies: 941
-- Name: FUNCTION af_get_classe_evenements(integer, date); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_evenements(integer, date) IS 'retourne les evenements d''une classe pour un jour de formation';


--
-- TOC entry 942 (class 1255 OID 2595727)
-- Dependencies: 2983 5
-- Name: af_get_classe_fils(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_fils(integer) RETURNS SETOF record
    AS $_$-- $1 : classe
declare
rec record;
begin
    for rec in
	select * from contraintes.af_gen_get_elements('contraintes.classe','id',$1,'')
    loop
	return next rec;
    end loop;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_fils(integer) OWNER TO pgsql;

--
-- TOC entry 7426 (class 0 OID 0)
-- Dependencies: 942
-- Name: FUNCTION af_get_classe_fils(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_fils(integer) IS 'retourne tous les fils d''une classe';


--
-- TOC entry 943 (class 1255 OID 2595728)
-- Dependencies: 2983 5
-- Name: af_get_classe_formations(integer, character varying, character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_formations(integer, character varying, character varying, integer, integer) RETURNS SETOF record
    AS $_$-- $1 numero de la classe
-- $2 ordre pour classement ('asc' ou 'desc')
-- $3 'date_debut' ou 'libelle' (orderby)
-- $4 periode (1 : passées, 2 : présentes, 3 : futures, 0 : toutes)
-- $5 individu
declare
rec record;
begin
    if contraintes.fw_is_root($5) then    
    for rec in 
	select id,libelle,parcours,date_debut,date_fin,langue,fp.classe
	from contraintes.af_get_formations($2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4,ressources_fusionnees boolean),
	contraintes.formation_participants fp 
	where fp.classe=$1 and fp.formation=id
    loop
	return next rec;
    end loop;
    else
    for rec in 
	select id,libelle,parcours,date_debut,date_fin,langue,fp.classe
	from contraintes.af_get_formations($2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4,ressources_fusionnees boolean),
	contraintes.formation_participants fp 
	where fp.classe=$1 and fp.formation=id 
	--and fp.formateur=$5
    loop
	return next rec;
    end loop;	
    end if;
    
    return;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_formations(integer, character varying, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7428 (class 0 OID 0)
-- Dependencies: 943
-- Name: FUNCTION af_get_classe_formations(integer, character varying, character varying, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_formations(integer, character varying, character varying, integer, integer) IS 'retourne les formations d''une classe pour le root ou formateur
';


--
-- TOC entry 1835 (class 1255 OID 2595729)
-- Dependencies: 2153 2983 5
-- Name: af_get_classe_individus(integer, integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_individus(integer, integer, character varying, boolean) RETURNS SETOF organisme_type_individu
    AS $_$-- Parametres :
-- 1. Identifiant de la classe
-- 2. Type : 0=tous, 1=formateurs & 2=stagiaires
-- 3. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 4. exclusif : si VRAI alors que les 'u' ou les 'f'
declare
rec record;
rec2 contraintes.organisme_type_individu;
req varchar;
begin
    
    for rec in 
	select id,nom,prenom,organisme 
	from contraintes.fw_get_individus($2,$3,$4) as (id int4,nom varchar,prenom varchar,organisme int4),contraintes.classe_individus CI 
	where CI.classe=$1 and CI.individu=id
	order by nom, prenom
    loop
	rec2.id:=rec.id;
	rec2.nom:=rec.nom;
	rec2.prenom:=rec.prenom;
	rec2.organisme:=rec.organisme;
	rec2.types:=NULL;
	return next rec2;
	--return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_individus(integer, integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 7430 (class 0 OID 0)
-- Dependencies: 1835
-- Name: FUNCTION af_get_classe_individus(integer, integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_individus(integer, integer, character varying, boolean) IS 'retourne les n°,nom prenom et tabtype des individu d''une classe';


--
-- TOC entry 944 (class 1255 OID 2595730)
-- Dependencies: 2983 5
-- Name: af_get_classe_individus_affiliables(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_individus_affiliables(integer) RETURNS SETOF record
    AS $_$declare
nb_individu int4;
org int4;
rec record;
req varchar;
begin
    -- test si la classe est vide
    perform * from contraintes.af_get_classe_individus($1,0,'asc',false) ;
    if not found then
	-- on renvoie tous les individus
	for rec in
	    select * from contraintes.fw_get_individus(0,'asc',false) as (id int4,nom varchar,prenom varchar,organisme int4)
		ORDER BY organisme, nom,prenom
	loop
	    return next rec;
	end loop;

    else
	-- on renvoie les individus qui ne sont pas affiliés à la classe
	-- et ayant un organisme communs aux individus de la classe ou (multi organisme)
	-- recup de l'organisme des individus de la classe
	--select into org * from contraintes.af_get_classe_organisme($1);
	--raise notice 'org =%',org;
	--if org is null then
	-- Modif du 06/01/08 (mutlti org correspond à null au lieu de 0)
	--if org is not null then	
	--raise notice 'org =%',org;
	    for rec in 
	    /*
	    select distinct I_id,I_nom,I_prenom,I_organisme 
	    from contraintes.fw_get_individus(0,'asc',false)  as (I_id int4,I_nom varchar,I_prenom varchar,I_organisme int4) ,
	    contraintes.af_get_classe_individus($1,0,'asc',false) CI 
	    --where I_id!=CI.id and I_organisme=org 
	    where I_organisme=org and I_id!=CI.id 
	    */

	    select distinct I_id,I_nom,I_prenom,I_organisme 
	    from contraintes.fw_get_individus(0,'asc',false)  as (I_id int4,I_nom varchar,I_prenom varchar,I_organisme int4) 
	    
	    where I_id not in (select CI.id from contraintes.af_get_classe_individus($1,0,'asc',false) CI) 
	   -- and I_organisme=org  
		ORDER BY I_organisme, I_nom,I_prenom
	    
	    

	    
	    loop
		--raise notice 'I_id=% ',rec.I_id;	
		return next rec;
	    end loop;
	/*else
	    --raise notice 'org is null';
	    for rec in 
	    
	    select distinct I_id,I_nom,I_prenom,I_organisme 
	    from contraintes.fw_get_individus(0,'asc',false) as (I_id int4,I_nom varchar,I_prenom varchar,I_organisme int4)
	    where I_id not in (select CI.id from contraintes.af_get_classe_individus($1,0,'asc',false) CI)
	   -and (I_organisme =org or I_organisme is null)
	    --and (I_organisme =org)	
	    
	    loop
		return next rec;
	    end loop;
	end if;*/
	
	
	

    end if;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_individus_affiliables(integer) OWNER TO pgsql;

--
-- TOC entry 7432 (class 0 OID 0)
-- Dependencies: 944
-- Name: FUNCTION af_get_classe_individus_affiliables(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_individus_affiliables(integer) IS 'retourne les individus affiliables à une classe';


--
-- TOC entry 945 (class 1255 OID 2595731)
-- Dependencies: 2153 2983 5
-- Name: af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean) RETURNS SETOF organisme_type_individu
    AS $_$-- Parametres :
-- 1. Identifiant de la classe
-- 2. Type : 0=tous, 1=formateurs & 2=stagiaires
-- 3. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 4. exclusif : si VRAI alors que les 'u' ou les 'f'
declare
rec record;
rec2 contraintes.organisme_type_individu;
req varchar;
begin
    
    for rec in 
	select id,nom,prenom,organisme 
	from contraintes.fw_get_individus_except_individus_types($2,$3,$4) as (id int4,nom varchar,prenom varchar,organisme int4),contraintes.classe_individus CI 
	
	where CI.classe=$1 and CI.individu=id
	order by nom, prenom
    loop
	rec2.id:=rec.id;
	rec2.nom:=rec.nom;
	rec2.prenom:=rec.prenom;
	rec2.organisme:=rec.organisme;
	rec2.types:=NULL;
	return next rec2;
	--return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 7434 (class 0 OID 0)
-- Dependencies: 945
-- Name: FUNCTION af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean) IS 'retourne les n°,nom prenom et organisme des individus d''une classe qui ne sont pas de certains types';


--
-- TOC entry 1836 (class 1255 OID 2595732)
-- Dependencies: 2983 5
-- Name: af_get_classe_individus_infos(integer, integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_individus_infos(integer, integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 : classe
-- $2 : type d'individu (0=tous, 1=formateurs & 2=stagiaires)
-- 3. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 4. exclusif : si VRAI alors que les 'u' ou les 'f'
declare
rec record;
begin
    for rec in
	select id ,identifiant_md5 ,login,password,nom ,prenom ,adresse ,code ,ville ,email ,tel_fixe ,tel_port ,langue ,organisme ,photo  
	from contraintes.fw_get_individus_infos($2,$3,$4)as (id int4,identifiant_md5 varchar,login varchar,password varchar,nom varchar,prenom varchar,adresse varchar,code varchar,ville varchar,email varchar,tel_fixe varchar,tel_port varchar,langue int4,organisme int4,photo int4),
	--from contraintes.af_get_individus_infos($2,$3,$4)as (id int4,identifiant_md5 varchar,login varchar,password varchar,nom varchar,prenom varchar,adresse varchar,code varchar,ville varchar,email varchar,tel_fixe varchar,tel_port varchar,langue int4,organisme int4,photo int4),
	
	contraintes.classe_individus CI 
	where CI.classe=$1 and CI.individu=id
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_individus_infos(integer, integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 7436 (class 0 OID 0)
-- Dependencies: 1836
-- Name: FUNCTION af_get_classe_individus_infos(integer, integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_individus_infos(integer, integer, character varying, boolean) IS 'Retourne les infos individu d''une classe';


--
-- TOC entry 946 (class 1255 OID 2595733)
-- Dependencies: 2983 5
-- Name: af_get_classe_nom_entier(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_nom_entier(integer) RETURNS character varying
    AS $_$declare
parent int4;
nom_classe varchar;
rec record;
begin
    parent=$1;
    while(parent is not null)
    loop
    select * into rec from contraintes.classe where id=parent;
    if nom_classe is null then
	nom_classe:=rec.libelle;
    else
	nom_classe:=rec.libelle || '/' || nom_classe;
    end if;
    parent:=rec.pere;
    end loop;
    return nom_classe;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_nom_entier(integer) OWNER TO pgsql;

--
-- TOC entry 7438 (class 0 OID 0)
-- Dependencies: 946
-- Name: FUNCTION af_get_classe_nom_entier(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_nom_entier(integer) IS 'retourne le nom entier de la classe';


--
-- TOC entry 947 (class 1255 OID 2595734)
-- Dependencies: 2983 5
-- Name: af_get_classe_organisme(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_organisme(integer) RETURNS integer
    AS $_$-- $1 : numero organisme
declare
res int4;
nb_res int4;
begin
    -- recup organisme nom null des individus de la classe
    select into res distinct organisme 
    from contraintes.af_get_classe_individus($1,0,'asc',false); 
    --where organisme is not null;
    if found then
	
	GET DIAGNOSTICS nb_res:=ROW_COUNT;
	if nb_res=1 then
		
	    return res;
	end if;
    else
	return NULL;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_organisme(integer) OWNER TO pgsql;

--
-- TOC entry 7440 (class 0 OID 0)
-- Dependencies: 947
-- Name: FUNCTION af_get_classe_organisme(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_organisme(integer) IS 'retourn l''organisme d''une classe';


--
-- TOC entry 948 (class 1255 OID 2595735)
-- Dependencies: 2983 5
-- Name: af_get_classe_pere(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_classe_pere(integer) RETURNS SETOF record
    AS $_$declare
	id_pere alias for $1;
	req text;
	rec record;

begin
	
	if (id_pere is null) then
		for rec in
		select * from contraintes.classe where pere is null
		loop
			return next rec;
		end loop;
	else
		for rec in
		select * from contraintes.classe where pere = id_pere
		loop
			return next rec;
		end loop;
		
	end if;
	
	return;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_pere(integer) OWNER TO postgres;

--
-- TOC entry 7442 (class 0 OID 0)
-- Dependencies: 948
-- Name: FUNCTION af_get_classe_pere(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_classe_pere(integer) IS 'Renvoie les classes associÃ©es Ã  un pere.';


--
-- TOC entry 949 (class 1255 OID 2595736)
-- Dependencies: 2983 5
-- Name: af_get_classe_peres_fils(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classe_peres_fils() RETURNS SETOF record
    AS $$declare
rec record;
rec2 record;
begin
    for rec in 
	select * from contraintes.af_get_classes() as (gc_id int4,gc_nom varchar,gc_id_pere int4,gc_min int4,gc_max int4)
    loop
	/*
	for rec2 in
	    select * from contraintes.af_get_classe_pere(rec.gc_id) as (id int4,nom varchar,id_pere int4,min int4,max int4)
	loop
		
		return next rec2;
	end loop;
	*/
		return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classe_peres_fils() OWNER TO pgsql;

--
-- TOC entry 7444 (class 0 OID 0)
-- Dependencies: 949
-- Name: FUNCTION af_get_classe_peres_fils(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classe_peres_fils() IS 'retourne toutes les clases (pere fils)';


--
-- TOC entry 950 (class 1255 OID 2595737)
-- Dependencies: 2983 5
-- Name: af_get_classes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classes() RETURNS SETOF record
    AS $$declare
rec record;

begin
    for rec in 
	select id,libelle,pere,min,max from contraintes.classe
    loop
    return next rec;
    end loop;
    return; 
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classes() OWNER TO pgsql;

--
-- TOC entry 7446 (class 0 OID 0)
-- Dependencies: 950
-- Name: FUNCTION af_get_classes(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classes() IS 'retourne les classes de la plateforme';


--
-- TOC entry 951 (class 1255 OID 2595738)
-- Dependencies: 2983 5
-- Name: af_get_classes_exotlcs_corriges(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classes_exotlcs_corriges() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select distinct c_id,libelle from contraintes.af_get_classes() as (c_id int4,libelle varchar,pere int4,min int4,max int4),
	contraintes.classe_individus CI,
	contraintes.af_get_individus_exotlcs_corriges() as (id int4,nom varchar,prenom varchar) 
	where c_id=CI.classe and CI.individu=id 
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classes_exotlcs_corriges() OWNER TO pgsql;

--
-- TOC entry 7448 (class 0 OID 0)
-- Dependencies: 951
-- Name: FUNCTION af_get_classes_exotlcs_corriges(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classes_exotlcs_corriges() IS 'retourne les classes qui ont des exotlcs corriges';


--
-- TOC entry 952 (class 1255 OID 2595739)
-- Dependencies: 2983 5
-- Name: af_get_classes_formation(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classes_formation() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct c.id,c.libelle,c.pere 
	from contraintes.classe c,contraintes.formation_participants fp
	where c.id=fp.classe
    loop
	return next rec;
    end loop;
	
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classes_formation() OWNER TO pgsql;

--
-- TOC entry 7450 (class 0 OID 0)
-- Dependencies: 952
-- Name: FUNCTION af_get_classes_formation(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classes_formation() IS 'retourne les classes des fromations de la plateforme';


--
-- TOC entry 953 (class 1255 OID 2595740)
-- Dependencies: 2983 5
-- Name: af_get_classes_individu(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_classes_individu() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct id,libelle,pere,max,min from contraintes.af_get_classes() as (id int4,libelle varchar,pere int4,max int4,min int4),
	contraintes.classe_individus CI where id=CI.classe
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_classes_individu() OWNER TO pgsql;

--
-- TOC entry 7452 (class 0 OID 0)
-- Dependencies: 953
-- Name: FUNCTION af_get_classes_individu(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_classes_individu() IS 'retourne les classes avec individu de la plateforme';


--
-- TOC entry 954 (class 1255 OID 2595741)
-- Dependencies: 2983 5
-- Name: af_get_commentaire(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_commentaire(integer, integer, integer) RETURNS record
    AS $_$-- $1 : numero etape
-- $2 : min
-- $3 : max
declare
rec record;
begin
    select into rec etape,min,max,commentaire 
    from contraintes.commentaire_etape 
    where etape=$1 and min=$2 and max=$3;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_commentaire(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7454 (class 0 OID 0)
-- Dependencies: 954
-- Name: FUNCTION af_get_commentaire(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_commentaire(integer, integer, integer) IS 'retourne un commentaire';


--
-- TOC entry 955 (class 1255 OID 2595742)
-- Dependencies: 2983 5
-- Name: af_get_connexion_dates_max(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_connexion_dates_max(integer) RETURNS record
    AS $_$-- $1 : individu
declare
rec record;
begin
    select into rec max(c1.connexion),max(c2.deconnexion) 
    from contraintes.connexion c1,contraintes.connexion c2 where c1.individu=$1 and c2.individu=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_connexion_dates_max(integer) OWNER TO pgsql;

--
-- TOC entry 7456 (class 0 OID 0)
-- Dependencies: 955
-- Name: FUNCTION af_get_connexion_dates_max(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_connexion_dates_max(integer) IS 'retourne les dates max de connexion et deconnexion pour un individu';


--
-- TOC entry 956 (class 1255 OID 2595743)
-- Dependencies: 2983 5
-- Name: af_get_connexion_individus(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_connexion_individus() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select distinct(individu),max(connexion) as maxdate,ip 
	from contraintes.connexion 
	group by individu,ip order by maxdate
    loop
	return next rec;
    end loop;

end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_connexion_individus() OWNER TO pgsql;

--
-- TOC entry 7458 (class 0 OID 0)
-- Dependencies: 956
-- Name: FUNCTION af_get_connexion_individus(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_connexion_individus() IS 'retourne les dates de connexions des individus';


--
-- TOC entry 957 (class 1255 OID 2595744)
-- Dependencies: 2983 5
-- Name: af_get_critere(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_critere(integer) RETURNS record
    AS $_$-- $1 : numero critere
declare
rec record;
begin
    select into rec c_id,c_libelle,cc.theme,c_pere 
    from contraintes.af_get_criteres() as (c_id int4,c_libelle varchar,c_pere int4),contraintes.categorie_critere cc 
    where c_id=$1 and cc.id=c_id;
    return rec; 	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_critere(integer) OWNER TO pgsql;

--
-- TOC entry 7460 (class 0 OID 0)
-- Dependencies: 957
-- Name: FUNCTION af_get_critere(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_critere(integer) IS 'retourne l''id,le libelle et le theme d''un critere';


--
-- TOC entry 958 (class 1255 OID 2595745)
-- Dependencies: 2983 5
-- Name: af_get_critere_sous_criteres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_critere_sous_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero critere
declare
rec record;
begin
    for rec in 
	select c_id,c_libelle,cc.theme,c_pere from contraintes.af_get_criteres() as (c_id int4,c_libelle varchar,c_pere int4),
	contraintes.categorie_critere cc
	where c_pere=$1 and c_id=cc.id
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_critere_sous_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 7462 (class 0 OID 0)
-- Dependencies: 958
-- Name: FUNCTION af_get_critere_sous_criteres(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_critere_sous_criteres(integer) IS 'retourne les sous criteres d''un critere';


--
-- TOC entry 959 (class 1255 OID 2595746)
-- Dependencies: 2983 5
-- Name: af_get_criteres(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_criteres() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,pere from contraintes.critere 
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_criteres() OWNER TO pgsql;

--
-- TOC entry 7464 (class 0 OID 0)
-- Dependencies: 959
-- Name: FUNCTION af_get_criteres(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_criteres() IS 'retourne tous les criteres de la plateforme';


--
-- TOC entry 960 (class 1255 OID 2595747)
-- Dependencies: 2983 5
-- Name: af_get_droit(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_droit(integer) RETURNS record
    AS $_$-- $1 : numero droit
declare
rec record;
begin
    select into rec id,libelle,type,defaut from contraintes.droit where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_droit(integer) OWNER TO pgsql;

--
-- TOC entry 7466 (class 0 OID 0)
-- Dependencies: 960
-- Name: FUNCTION af_get_droit(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_droit(integer) IS 'retourne les info d''un droit';


--
-- TOC entry 961 (class 1255 OID 2595748)
-- Dependencies: 2983 5
-- Name: af_get_droits(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_droits(integer) RETURNS SETOF record
    AS $_$-- $1 : type individu (0=tous,1=formateur,2=utilisateur,3=intervenant
declare
rec record;
req varchar;
begin
    if $1=0 then
	req:='select id,libelle,type,defaut from contraintes.droit';
    else
	req:='select id,libelle,type,defaut from contraintes.droit where type='||$1;
    end if;
    for rec in
	execute req
    loop
	return next rec;
    end loop;
    return;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_droits(integer) OWNER TO pgsql;

--
-- TOC entry 7468 (class 0 OID 0)
-- Dependencies: 961
-- Name: FUNCTION af_get_droits(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_droits(integer) IS 'retourne tous les droits de la plateforme
pour un type d''individu';


--
-- TOC entry 962 (class 1255 OID 2595749)
-- Dependencies: 2983 5
-- Name: af_get_droits_defaut(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_droits_defaut(integer) RETURNS SETOF record
    AS $_$-- $1 type d'individu (1 : formateur, 2 : utilisateur, 3 : intervenant)
declare
rec record;
begin
    for rec in 
	select id,libelle,type from contraintes.droit where defaut is true and type=$1
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_droits_defaut(integer) OWNER TO pgsql;

--
-- TOC entry 7470 (class 0 OID 0)
-- Dependencies: 962
-- Name: FUNCTION af_get_droits_defaut(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_droits_defaut(integer) IS 'retourne les droits par defaut';


--
-- TOC entry 963 (class 1255 OID 2595750)
-- Dependencies: 2983 5
-- Name: af_get_element_themes_categorie(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_element_themes_categorie(integer, integer) RETURNS SETOF record
    AS $_$
--$1 l element dont on veut le theme
--$2 la categorie

DECLARE
	rec RECORD;
BEGIN

	FOR rec IN
		SELECT T.id, T.libelle FROM contraintes.theme_categories TC, contraintes.theme T 
		WHERE TC.categorie=$2 
		AND TC.id=$1
		AND TC.theme=T.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_element_themes_categorie(integer, integer) OWNER TO postgres;

--
-- TOC entry 7472 (class 0 OID 0)
-- Dependencies: 963
-- Name: FUNCTION af_get_element_themes_categorie(integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_element_themes_categorie(integer, integer) IS 'Obtenir les themes d''un element de la base

Param1:
NumÃ©ro de la catÃ©gorie

Param2
NumÃ©ro de l''Ã©lÃ©ment

Retourne;
Les numÃ©ros de thÃ¨mes (setof int4)';


--
-- TOC entry 964 (class 1255 OID 2595751)
-- Dependencies: 2983 5
-- Name: af_get_espace(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_espace(integer) RETURNS record
    AS $_$-- $1 : numero espace
declare
rec record;
begin
    select into rec * from contraintes.af_get_espaces() as (id int4,libelle varchar) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_espace(integer) OWNER TO pgsql;

--
-- TOC entry 7474 (class 0 OID 0)
-- Dependencies: 964
-- Name: FUNCTION af_get_espace(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_espace(integer) IS 'retourne un espace';


--
-- TOC entry 965 (class 1255 OID 2595752)
-- Dependencies: 2983 5
-- Name: af_get_espaces(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_espaces() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select * from contraintes.espace 
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_espaces() OWNER TO pgsql;

--
-- TOC entry 7476 (class 0 OID 0)
-- Dependencies: 965
-- Name: FUNCTION af_get_espaces(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_espaces() IS 'retourne les espaces de la plateforme';


--
-- TOC entry 966 (class 1255 OID 2595753)
-- Dependencies: 2983 5
-- Name: af_get_etape(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec id, libelle, "type", date_creation FROM contraintes.etape
	WHERE id=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape(integer) OWNER TO pgsql;

--
-- TOC entry 7478 (class 0 OID 0)
-- Dependencies: 966
-- Name: FUNCTION af_get_etape(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_etape(integer) IS 'Obtenir les informations d''une etape.';


--
-- TOC entry 967 (class 1255 OID 2595754)
-- Dependencies: 2983 5
-- Name: af_get_etape_classes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_classes(integer) RETURNS SETOF record
    AS $_$DECLARE
rec1 RECORD;
rec2 RECORD;
BEGIN
	FOR rec1 IN
		--on selectionne les parcours de l'étape
		SELECT id
		FROM contraintes.af_get_etape_parcourss($1) AS (id int4, libelle varchar, filiere int4, duree bool, etape int, date_creation timestamp) 

	LOOP
		raise notice 'etape % parcours % trouvé', $1, rec1.id;
		--pour chacun des parcours, on recupere ses formations et leurs classes
		FOR rec2 IN
			SELECT DISTINCT id ,libelle ,pere ,min ,max ,  rec1.id AS parcours
			FROM contraintes.af_get_parcours_formations(rec1.id)  AS (P_id int4, P_libelle varchar, P_parcours int4, P_date_debut date, P_date_fin date, P_langue_defaut int4,ressources_fusionnees boolean),
			contraintes.af_get_formations_classes() AS (id int4,libelle varchar,pere int4,min int4,max int4, formation int4)
			WHERE formation=P_id
		LOOP
			raise notice 'la';
			RETURN NEXT rec2;
		END LOOP;
	END LOOP;
	
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_classes(integer) OWNER TO pgsql;

--
-- TOC entry 968 (class 1255 OID 2595755)
-- Dependencies: 2983 5
-- Name: af_get_etape_filieres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_filieres(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT F_id, F_libelle, F_pere, id
		FROM contraintes.af_get_etape_parcourss($1) AS (id int4,libelle varchar, filiere int4, duree bool, etape int4, date_creation timestamp)
		LEFT OUTER JOIN 
		contraintes.af_get_filieres() AS (F_id int4, F_libelle varchar, F_pere int4, niveau int4)
		ON (filiere=F_id)
		ORDER BY F_libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_filieres(integer) OWNER TO pgsql;

--
-- TOC entry 969 (class 1255 OID 2595756)
-- Dependencies: 2983 5
-- Name: af_get_etape_formations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_formations(integer) RETURNS SETOF record
    AS $_$DECLARE
rec1 RECORD;
rec2 RECORD;
BEGIN
	FOR rec1 IN
		--on selectionne les parcours de l'étape
		SELECT id
		FROM contraintes.af_get_etape_parcourss($1) AS (id int4, libelle varchar, filiere int4, duree bool, etape int, date_creation timestamp) 

	LOOP
		--pour chacun des parcours, on recupere ses formations
		FOR rec2 IN
			SELECT  *
			FROM contraintes.af_get_parcours_formations(rec1.id)  AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4,ressources_fusionnees bool)
			ORDER BY libelle
		LOOP
			RETURN NEXT rec2;
		END LOOP;
	END LOOP;
	
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_formations(integer) OWNER TO pgsql;

--
-- TOC entry 970 (class 1255 OID 2595757)
-- Dependencies: 2983 5
-- Name: af_get_etape_formations_classe(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_formations_classe(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec1 RECORD;
rec2 RECORD;
BEGIN
	FOR rec1 IN
		--on selectionne les parcours de l'étape
		SELECT id
		FROM contraintes.af_get_etape_parcourss($1) AS (id int4, libelle varchar, filiere int4, duree bool, etape int, date_creation timestamp) 

	LOOP
		--pour chacun des parcours, on recupere ses formations
		FOR rec2 IN
			SELECT  id , libelle , parcours , date_debut , date_fin , langue_defaut , classe
			FROM contraintes.af_get_parcours_formations(rec1.id)  AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4,ressources_fusionnees boolean),
			contraintes.formation_participants
			WHERE classe=$2 
			AND id=formation
		LOOP
			RETURN NEXT rec2;
		END LOOP;
	END LOOP;
	
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_formations_classe(integer, integer) OWNER TO pgsql;

--
-- TOC entry 971 (class 1255 OID 2595758)
-- Dependencies: 2983 5
-- Name: af_get_etape_forum(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_forum(integer) RETURNS record
    AS $_$-- $1 : etape
declare
rec record;
begin
    select into rec * from contraintes.af_get_etapes_forum() 
    as (id int4,libelle_etape varchar,forum int4,libelle varchar,description varchar,moderation bool,moderateur_pwd varchar,fils int4,messages int4,upload bool,theme varchar,configuration int4,date_creation timestamp)
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_forum(integer) OWNER TO pgsql;

--
-- TOC entry 7484 (class 0 OID 0)
-- Dependencies: 971
-- Name: FUNCTION af_get_etape_forum(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_etape_forum(integer) IS 'retourne les données d''une etape forum';


--
-- TOC entry 972 (class 1255 OID 2595759)
-- Dependencies: 2983 5
-- Name: af_get_etape_parcours_oriente_configuration(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_parcours_oriente_configuration(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 etape
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, type, seuil, sous_parcours
		FROM contraintes.parcours_oriente PO
		WHERE PO.id=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_parcours_oriente_configuration(integer) OWNER TO pgsql;

--
-- TOC entry 973 (class 1255 OID 2595760)
-- Dependencies: 2983 5
-- Name: af_get_etape_parcourss(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_parcourss(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT parcours ,libelle , filiere , duree, etape , date_creation 
		FROM contraintes.parcours_etapes LEFT OUTER JOIN 
		contraintes.af_get_parcours() AS (id int4, libelle varchar, filiere int4, duree bool, date_creation timestamp) 
		ON (parcours=id)
		WHERE etape=$1
		ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_parcourss(integer) OWNER TO pgsql;

--
-- TOC entry 7487 (class 0 OID 0)
-- Dependencies: 973
-- Name: FUNCTION af_get_etape_parcourss(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_etape_parcourss(integer) IS 'Obtenir les numero des parcours qui contiennent une Ã©tape donnÃ©e';


--
-- TOC entry 974 (class 1255 OID 2595761)
-- Dependencies: 2983 5
-- Name: af_get_etape_ressource(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_ressource(integer) RETURNS record
    AS $_$DECLARE
-- $1 : id de l'étape
rec record;
BEGIN
	SELECT INTO rec er.id,e.libelle,er.espace,er.section,F.id,F.type,fm.mots_cles, e.date_creation 
	FROM contraintes.etape e,  contraintes.etape_ressource er LEFT OUTER JOIN (
		contraintes.fichier F LEFT OUTER JOIN contraintes.fichier_metadata fm ON (F.id=fm.id)
		)ON (er.fichier=F.id)
	WHERE e.id=er.id
	AND er.id=$1;
	
	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_ressource(integer) OWNER TO pgsql;

--
-- TOC entry 975 (class 1255 OID 2595762)
-- Dependencies: 2983 5
-- Name: af_get_etape_ressource_infos(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_etape_ressource_infos(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : espace
-- $2 : section
-- $3 : ressource
declare
rec record;
begin
    select into rec
    
	FR.ressource,R.fichier,FR.espace,E.libelle, FR.section,S.libelle,ET.libelle,FR.formation,FI.type,R.mots_cles, 
	cast(FR.debut_disponibilite as timestamp), cast(FR.fin_disponibilite as timestamp), FR.duree_nouveaute, S.icone
	FROM 
	contraintes.formation_ressources FR,
	contraintes.fichier_ressource FR,
	contraintes.etape ET,
	contraintes.etape_ressource ER,
	contraintes.fichier FI,
	contraintes.espace E,
	contraintes.section S
	WHERE 
	ER.espace=$1 and ER.section=$2 and ER.ressource=$3  
	and ER.ressource=R.id 
	and ER.espace=E.id 
	and ER.section=S.id 
	and R.fichier=FI.id 
	and ER.id=ET.id and ER.ressource=FR.ressource;
    
	return next rec;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_ressource_infos(integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 7490 (class 0 OID 0)
-- Dependencies: 975
-- Name: FUNCTION af_get_etape_ressource_infos(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_etape_ressource_infos(integer, integer, integer) IS 'Retourne les infos d''une ressource';


--
-- TOC entry 976 (class 1255 OID 2595763)
-- Dependencies: 2983 5
-- Name: af_get_etape_resultats(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_resultats(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, formation, stagiaire, parcours,  etape, date_debut, duree
		FROM contraintes.resultat
		WHERE etape=$1
	LOOP 
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 977 (class 1255 OID 2595764)
-- Dependencies: 2983 5
-- Name: af_get_etape_scorm_fichier(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_scorm_fichier(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du fichier
etape_scorm_id int4;
BEGIN

	SELECT INTO etape_scorm_id id FROM contraintes.etape_scorm
	WHERE fichier=$1;

	RETURN etape_scorm_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_scorm_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 7493 (class 0 OID 0)
-- Dependencies: 977
-- Name: FUNCTION af_get_etape_scorm_fichier(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_etape_scorm_fichier(integer) IS 'Obtenir l''identifiant d''une etape scorm a partir de son numero de fichier.';


--
-- TOC entry 1837 (class 1255 OID 2595765)
-- Dependencies: 2155 2983 5
-- Name: af_get_etape_type_sous_type(integer, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etape_type_sous_type(integer, integer, character varying) RETURNS type_element
    AS $_$DECLARE
--$1 identifiant d'etape
--$2 type d'etape
--$3 libelle du type d'etape
rec_spe_1 RECORD;
serie_aleatoire bool;
retour contraintes.type_element;
retour_serie contraintes.type_element;
BEGIN

--AFFECTE LE TYPE ETAPE (ORIGINAL)
retour.id:=$2;
retour.libelle:=$3;

--type liste
IF $2=4 THEN
	SELECT INTO rec_spe_1 libelle, L_type AS type
	FROM contraintes.af_get_liste($1) AS  (L_id int4,L_libelle varchar, L_type int4, date_creation timestamp),
	contraintes.liste_type T
	WHERE L_type=T.id;
	
	--AFFECTE LE TYPE LISTE
	retour.id:=retour.id||'_'||rec_spe_1.type;
	retour.libelle:=rec_spe_1.libelle;

	--type serie
	IF rec_spe_1.type=1 THEN

		--serie aléatoire ?
		SELECT INTO serie_aleatoire * FROM contraintes.af_is_serie_aleatoire($1);		
		IF serie_aleatoire THEN
			SELECT INTO retour_serie * FROM contraintes.af_get_serie_aleatoire_type($1);
			--si la serie est mono evaluation on l'indique, sinon on laisse le sous type tel quel
			IF retour_serie.id IS NOT NULL THEN
				--AFFECTE LE TYPE (D'EVALUATION)DE SERIE
				retour.libelle:='''   - ''.'||retour_serie.libelle;
				retour.id:=retour.id||'_'||retour_serie.id;
			END IF;
		ELSE
			SELECT INTO retour_serie * FROM contraintes.af_get_serie_simple_type($1);
			--si la serie est mono evaluation on l'indique, sinon on laisse le sous type tel quel
			IF retour_serie.id IS NOT NULL THEN
				--AFFECTE LE TYPE (D'EVALUATION)DE SERIE
				retour.libelle:='''   - ''.'||retour.libelle||'.'' (''.'||retour_serie.libelle||'.'')''';
				retour.id:=retour.id||'_0_'||retour_serie.id;
			END IF;
		END IF;
	--type test
	ELSE
		retour.libelle:=rec_spe_1.libelle;
	END IF;
END IF;

RETURN retour;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etape_type_sous_type(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 978 (class 1255 OID 2595766)
-- Dependencies: 2983 5
-- Name: af_get_etapes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etapes() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, libelle, "type",date_creation  FROM contraintes.etape
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etapes() OWNER TO pgsql;

--
-- TOC entry 1838 (class 1255 OID 2595767)
-- Dependencies: 2983 5
-- Name: af_get_etapes_chats(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etapes_chats() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select ec.id,e.libelle,e.type,e.date_creation 
	from contraintes.etape e , contraintes.etape_chat ec  
	where e.id=ec.id
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etapes_chats() OWNER TO pgsql;

--
-- TOC entry 7497 (class 0 OID 0)
-- Dependencies: 1838
-- Name: FUNCTION af_get_etapes_chats(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_etapes_chats() IS 'retourne les etapes chat de la plateforme';


--
-- TOC entry 979 (class 1255 OID 2595768)
-- Dependencies: 2983 5
-- Name: af_get_etapes_fichiers(integer[], character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etapes_fichiers(integer[], character varying) RETURNS SETOF record
    AS $_$DECLARE
--$1 les numeros de fichier
--$2 la table de correspondance fichier/etape
rec RECORD;
req varchar;
BEGIN

	req:='SELECT DISTINCT E.id, E.libelle, E.type, T.fichier, E.date_creation  FROM contraintes.'||$2||' T, contraintes.etape E
	WHERE T.fichier IN ('||array_to_string ($1, ',')||')
	AND E.id=T.id;';
	--RAISE NOTICE 'req=%', req;

	FOR rec IN 
		EXECUTE req
	LOOP
		RETURN NEXT rec;
	END LOOP; 

	RETURN;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etapes_fichiers(integer[], character varying) OWNER TO pgsql;

--
-- TOC entry 7499 (class 0 OID 0)
-- Dependencies: 979
-- Name: FUNCTION af_get_etapes_fichiers(integer[], character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_etapes_fichiers(integer[], character varying) IS 'Obtenir les informations sur les etapes d''un ensemble de fichiers d''apres leurs numeros.';


--
-- TOC entry 980 (class 1255 OID 2595769)
-- Dependencies: 2983 5
-- Name: af_get_etapes_forum(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_etapes_forum() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select ef.id,e.libelle,f.id,f.libelle,f.description,f.moderation,f.moderateur_pwd,f.fils,f.messages,f.upload,f.theme,fe.environnement,date_creation 
	from contraintes.etape e , contraintes.etape_forum ef  left outer join contraintes.forum f on (f.id=ef.forum)
	left outer join contraintes.forum_environnements fe ON (fe.forum=f.id) 
	where e.id=ef.id
	
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_etapes_forum() OWNER TO pgsql;

--
-- TOC entry 7501 (class 0 OID 0)
-- Dependencies: 980
-- Name: FUNCTION af_get_etapes_forum(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_etapes_forum() IS 'retourne les etapes forum de la plateforme';


--
-- TOC entry 981 (class 1255 OID 2595770)
-- Dependencies: 2983 5
-- Name: af_get_evaluation(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_evaluation(integer) RETURNS record
    AS $_$DECLARE
--$1 identifiant de l'evaluation
rec RECORD;
BEGIN
	SELECT INTO rec id, libelle, type, date_creation
	FROM contraintes.evaluation
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evaluation(integer) OWNER TO pgsql;

--
-- TOC entry 1839 (class 1255 OID 2595771)
-- Dependencies: 2983 5
-- Name: af_get_evaluation_bareme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_evaluation_bareme(integer, integer) RETURNS integer
    AS $_$-- $1 : serie
-- $2 : evaluation
declare
rec record;
rec_serie record;
aleatoire boolean;
begin
    -- si serie aleatoire monotheme ou multitheme
/*
    select into aleatoire * from contraintes.af_is_serie_aleatoire($1);
    if aleatoire is true then
	select into rec * from contraintes.af_get_serie_aleatoire($1) 
	as (id int4,libelle varchar,bareme int4,chrono int4,type int4,date_creation timestamp);
	
    else
	-- recup bareme de l'evaluation
	select into rec * from contraintes.af_get_serie_evaluation($1,$2) as (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );    
	if rec.bareme is null then
	    select into rec * from contraintes.af_get_serie($1) as (id int4, libelle varchar, bareme int4, chrono int4, date_creation timestamp);
	
        end if;
    end if;
*/

    -- recup bareme evaluation

    select into rec * from contraintes.af_get_serie_evaluation($1,$2) as (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );    
    if rec.bareme is null then
	-- recup bareme serie
	select into rec * from contraintes.af_get_serie($1) as (id int4, libelle varchar, bareme int4, chrono int4, date_creation timestamp);
	if rec.bareme is null then
	    -- si serie aleatoire monotheme ou multitheme
	    select into aleatoire * from contraintes.af_is_serie_aleatoire($1);
	    if aleatoire is true then
		select into rec * from contraintes.af_get_serie_aleatoire($1) 
		as (id int4,libelle varchar,bareme int4,chrono int4,type int4,date_creation timestamp);
	    end if;
	end if;
    end if;

    --raise notice 'bareme=%',rec.bareme;
    return rec.bareme;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evaluation_bareme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7504 (class 0 OID 0)
-- Dependencies: 1839
-- Name: FUNCTION af_get_evaluation_bareme(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_evaluation_bareme(integer, integer) IS 'retourne le n° de bareme d''une evaluation de serie';


--
-- TOC entry 1840 (class 1255 OID 2595772)
-- Dependencies: 2983 5
-- Name: af_get_evaluation_point(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_evaluation_point(integer, integer) RETURNS integer
    AS $_$-- $1 : serie
-- $2 : evaluation
declare
rec record;
aleatoire boolean;
rec_aleatoire record;
val_type integer;
begin
    val_type:=0;
    -- si serie aleatoire on retourne 1
    select into aleatoire * from contraintes.af_is_serie_aleatoire($1);
    if aleatoire is true then
	-- recup type aleatoire
	select into rec_aleatoire * from contraintes.af_get_serie_aleatoire($1)
	as (id int4,libelle varchar,bareme int4,chrono int4,type int4,date_creation timestamp);
	val_type:=rec_aleatoire.type;
    end if;
    if aleatoire is true and (val_type=2 or val_type=3) then
	return 1;
    end if;
    select into rec * from contraintes.af_get_serie_evaluation($1,$2) as (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );  
    return rec.points;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evaluation_point(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7506 (class 0 OID 0)
-- Dependencies: 1840
-- Name: FUNCTION af_get_evaluation_point(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_evaluation_point(integer, integer) IS 'retourne la valeur du point pour une evaluation de serie';


--
-- TOC entry 982 (class 1255 OID 2595773)
-- Dependencies: 2983 5
-- Name: af_get_evaluation_resultats(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_evaluation_resultats(integer) RETURNS SETOF record
    AS $_$-- $1 : evaluation
declare
rec record;
begin
    for rec in
	select * from contraintes.resultat_serie where evaluation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evaluation_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 7508 (class 0 OID 0)
-- Dependencies: 982
-- Name: FUNCTION af_get_evaluation_resultats(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_evaluation_resultats(integer) IS 'retourne les identifiants de resultat pour une evaluation';


--
-- TOC entry 983 (class 1255 OID 2595774)
-- Dependencies: 2983 5
-- Name: af_get_evaluation_series(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_evaluation_series(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
	
	for rec in
		select serie, E.libelle, evaluation from contraintes.serie_evaluations, contraintes.etape E where evaluation=$1
		AND serie= E.id order by E.libelle
	loop
		return next rec;
	end loop;
	return;
	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evaluation_series(integer) OWNER TO postgres;

--
-- TOC entry 7510 (class 0 OID 0)
-- Dependencies: 983
-- Name: FUNCTION af_get_evaluation_series(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_evaluation_series(integer) IS 'Obtenir les sÃ©ries pour une evaluation donnÃ©e (auteur : Said)';


--
-- TOC entry 984 (class 1255 OID 2595775)
-- Dependencies: 2983 5
-- Name: af_get_evaluation_type(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_evaluation_type(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN

	
	SELECT INTO rec id, libelle, code, couleur FROM contraintes.evaluation_type
	WHERE id=$1;

	RETURN rec ;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evaluation_type(integer) OWNER TO pgsql;

--
-- TOC entry 985 (class 1255 OID 2595776)
-- Dependencies: 2983 5
-- Name: af_get_evaluation_types(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_evaluation_types() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT * FROM contraintes.evaluation_type
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evaluation_types() OWNER TO pgsql;

--
-- TOC entry 986 (class 1255 OID 2595777)
-- Dependencies: 2983 5
-- Name: af_get_evenement_intervenants(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_evenement_intervenants(integer) RETURNS SETOF record
    AS $_$-- $1 : modalite (si <> 0)
declare
rec record;
req varchar;
begin
    if $1!=0 then
	req :='select distinct id,nom,prenom from contraintes.fw_individu,contraintes.evenement where id=intervenant and modalite='||$1;	
    else
	req :='select distinct id,nom,prenom from contraintes.fw_individu,contraintes.evenement where id=intervenant';
    end if;
    for rec in
	execute req
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evenement_intervenants(integer) OWNER TO pgsql;

--
-- TOC entry 7514 (class 0 OID 0)
-- Dependencies: 986
-- Name: FUNCTION af_get_evenement_intervenants(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_evenement_intervenants(integer) IS 'retourne les intervenants d''evenement';


--
-- TOC entry 987 (class 1255 OID 2595778)
-- Dependencies: 2983 5
-- Name: af_get_evenements(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_evenements() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
	from contraintes.evenement 
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evenements() OWNER TO pgsql;

--
-- TOC entry 7516 (class 0 OID 0)
-- Dependencies: 987
-- Name: FUNCTION af_get_evenements(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_evenements() IS 'retourne les evenements de la plateforme';


--
-- TOC entry 988 (class 1255 OID 2595779)
-- Dependencies: 2983 5
-- Name: af_get_evenements_dates(date, time without time zone, time without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_evenements_dates(date, time without time zone, time without time zone) RETURNS SETOF record
    AS $_$-- $1 : date de l'evenement
-- $2 : heure debut
-- $3 : heure fin
declare
rec record;
begin
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
	from contraintes.evenement 
	where cast(date as date) =$1
	and ((
	    cast(date as time)>=$2 and cast(date as time)<=$3
	)
	or (
	    cast(date as time)<=$2 and 	cast(date as time) +  duree >=$2)
	)
    loop
	return next rec;
    end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_evenements_dates(date, time without time zone, time without time zone) OWNER TO pgsql;

--
-- TOC entry 7518 (class 0 OID 0)
-- Dependencies: 988
-- Name: FUNCTION af_get_evenements_dates(date, time without time zone, time without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_evenements_dates(date, time without time zone, time without time zone) IS 'retourne les evenements en fonction des dates,debut et fin';


--
-- TOC entry 989 (class 1255 OID 2595780)
-- Dependencies: 2983 5
-- Name: af_get_exotlc(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc(integer, integer) RETURNS record
    AS $_$-- $1 : numero exotlc
-- $2 : type exo (1=plateforme,2=mail)
declare
rec record;
begin
    if $2=1 then
	select into rec 
	E.id,ET.libelle,EP.fichier_rendu,E.commentaire,E.texte,E.enonce,E.remarque,E.type, ET.date_creation ,autocorrection
	from contraintes.etape ET,contraintes.exotlc E,contraintes.exotlc_plate_forme EP 
	where E.id=$1 and ET.id=$1 and EP.id=$1;
    elseif $2=2 then
	select into rec 
	E.id,ET.libelle, EM.formateur,E.commentaire,E.texte,E.enonce,E.remarque,E.type , ET.date_creation 
	from contraintes.etape ET,contraintes.exotlc E,contraintes.exotlc_mail EM
	where E.id=$1 and ET.id=$1 and EM.id=$1;
    ELSE
	RAISE EXCEPTION 'Le type d''exotlc % n''est pas connu.', $2;
    end if;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7520 (class 0 OID 0)
-- Dependencies: 989
-- Name: FUNCTION af_get_exotlc(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlc(integer, integer) IS 'retourne les infos d''un exotlc';


--
-- TOC entry 990 (class 1255 OID 2595781)
-- Dependencies: 2983 5
-- Name: af_get_exotlc_fichier(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc_fichier(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du fichier
exotlc_id int4;
BEGIN

	SELECT INTO exotlc_id id FROM contraintes.exotlc_fichiers
	WHERE fichier=$1;

	RETURN exotlc_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 7522 (class 0 OID 0)
-- Dependencies: 990
-- Name: FUNCTION af_get_exotlc_fichier(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlc_fichier(integer) IS 'Obtenir l''identifiant d''un exotcl a partir de son numero de fichier.';


--
-- TOC entry 991 (class 1255 OID 2595782)
-- Dependencies: 2983 5
-- Name: af_get_exotlc_fichiers(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc_fichiers(integer) RETURNS SETOF record
    AS $_$-- $1 numero exotlc
declare
rec record;
begin
    for rec in
	select F.id,F.libelle from contraintes.fichier F,contraintes.exotlc_fichiers EF 
	where EF.exotlc=$1 and F.id=EF.fichier
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc_fichiers(integer) OWNER TO pgsql;

--
-- TOC entry 7524 (class 0 OID 0)
-- Dependencies: 991
-- Name: FUNCTION af_get_exotlc_fichiers(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlc_fichiers(integer) IS 'retourne les fichiers d''un exotlc';


--
-- TOC entry 992 (class 1255 OID 2595783)
-- Dependencies: 2983 5
-- Name: af_get_exotlc_fichiers_correction(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc_fichiers_correction(integer) RETURNS SETOF record
    AS $_$-- $1 : numero exotlc
declare
rec record;
begin
    for rec in 
	select F.id,F.libelle from contraintes.fichier F,contraintes.exotlc_corrections EC 
	where EC.exotlc=$1 and F.id=EC.correction
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc_fichiers_correction(integer) OWNER TO pgsql;

--
-- TOC entry 7526 (class 0 OID 0)
-- Dependencies: 992
-- Name: FUNCTION af_get_exotlc_fichiers_correction(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlc_fichiers_correction(integer) IS 'Obtenir les fichiers de correction d''un exotlc';


--
-- TOC entry 993 (class 1255 OID 2595784)
-- Dependencies: 2983 5
-- Name: af_get_exotlc_mail(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc_mail(integer) RETURNS record
    AS $_$-- $1 : numero exotlc
declare
rec record;
begin
    select into rec 
	id,libelle, formateur ,commentaire,texte,enonce,remarque,type, date_creation 
	from contraintes.af_get_exotlc($1,2) AS (id integer,libelle character varying,formateur integer,commentaire text,texte text,enonce text,remarque text,type integer,date_creation timestamp);
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc_mail(integer) OWNER TO pgsql;

--
-- TOC entry 7528 (class 0 OID 0)
-- Dependencies: 993
-- Name: FUNCTION af_get_exotlc_mail(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlc_mail(integer) IS 'retourne les infos d''un exotlc mail';


--
-- TOC entry 994 (class 1255 OID 2595785)
-- Dependencies: 2983 5
-- Name: af_get_exotlc_modele_correction(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc_modele_correction(integer) RETURNS record
    AS $_$DECLARE
--$1 exotlc
id_modele integer;
rec RECORD;
BEGIN
	SELECT INTO id_modele modele_correction FROM contraintes.exotlc_modele_correction
	WHERE id=$1;

	IF id_modele IS NOT NULL THEN
		SELECT INTO rec * from contraintes.af_get_template(id_modele) as (id int4,libelle varchar);
		RETURN rec;
	ELSE
		RETURN NULL;
	END IF;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc_modele_correction(integer) OWNER TO pgsql;

--
-- TOC entry 995 (class 1255 OID 2595786)
-- Dependencies: 2983 5
-- Name: af_get_exotlc_plate_forme(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc_plate_forme(integer) RETURNS record
    AS $_$-- $1 : numero exotlc
declare
rec record;
begin
    select into rec 
	id,libelle, fichier_rendu ,commentaire,texte,enonce,remarque,type, date_creation , autocorrection
	from contraintes.af_get_exotlc($1,1) AS (id integer,libelle character varying,fichier_rendu character varying,commentaire text,texte text,enonce text,remarque text,type integer,date_creation timestamp,autocorrection boolean);
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc_plate_forme(integer) OWNER TO pgsql;

--
-- TOC entry 7531 (class 0 OID 0)
-- Dependencies: 995
-- Name: FUNCTION af_get_exotlc_plate_forme(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlc_plate_forme(integer) IS 'retourne les infos d''un exotlc plateforme';


--
-- TOC entry 996 (class 1255 OID 2595787)
-- Dependencies: 2983 5
-- Name: af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) RETURNS SETOF record
    AS $_$-- $1 : exotlc (etape)
-- $2 : parcours
-- $3 : formation
-- $4 : bool (true -> corrige, false -> non corrige)
declare
rec record;
begin
    for rec in 
	select I.id,I.nom,I.prenom
	
	from contraintes.fw_individu I,
	contraintes.af_get_etape_resultats($1) as (ger_id int8, formation int4,   stagiaire int4, parcours int4,  etape int4, date_debut timestamp, duree interval)
	left outer join 
	contraintes.resultat_exotlc re on (ger_id=re.id)
	where I.id=stagiaire and formation=$3 and parcours=$2 
	group by I.id,I.nom,I.prenom ,re.date_correction
	having (CAST(case when re.date_correction is null then false else true end AS boolean)=cast($4 as boolean ))

	
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 7533 (class 0 OID 0)
-- Dependencies: 996
-- Name: FUNCTION af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) IS 'retourne les stagiaires corriges ou non corriges pour un exotlc et une formation';


--
-- TOC entry 997 (class 1255 OID 2595788)
-- Dependencies: 2983 5
-- Name: af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : exotlc
declare
rec record;
begin
    for rec in 
	select i.id,nom,prenom,re.fichier_rendu from contraintes.fw_individu i,contraintes.resultat r,contraintes.resultat_exotlc re  
	where i.id=r.stagiaire and r.formation=$1 and r.parcours=$2 and r.etape=$3 and r.id=re.id 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7535 (class 0 OID 0)
-- Dependencies: 997
-- Name: FUNCTION af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) IS 'retourne les stagiaires qui ont rendu leur fichier pour un exotlc';


--
-- TOC entry 998 (class 1255 OID 2595789)
-- Dependencies: 2983 5
-- Name: af_get_exotlc_type(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlc_type(integer) RETURNS integer
    AS $_$-- $1 : numero exotlc
declare
res int4;
begin
    select into res type from contraintes.exotlc where id=$1;
    return res;
end;  $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlc_type(integer) OWNER TO pgsql;

--
-- TOC entry 7537 (class 0 OID 0)
-- Dependencies: 998
-- Name: FUNCTION af_get_exotlc_type(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlc_type(integer) IS 'retourne le type d''un exotlc';


--
-- TOC entry 999 (class 1255 OID 2595790)
-- Dependencies: 2983 5
-- Name: af_get_exotlcs(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_exotlcs() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,commentaire,texte,enonce,remarque,type
	from contraintes.exotlc
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_exotlcs() OWNER TO pgsql;

--
-- TOC entry 7539 (class 0 OID 0)
-- Dependencies: 999
-- Name: FUNCTION af_get_exotlcs(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_exotlcs() IS 'retourne les exo tlc de la plateforme';


--
-- TOC entry 1000 (class 1255 OID 2595791)
-- Dependencies: 2983 5
-- Name: af_get_fichier(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_fichier(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN

	SELECT into rec * FROM contraintes.af_get_fichiers() AS ( id int4, libelle varchar, "type" int4, connecte bool)
	WHERE id=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichier(integer) OWNER TO postgres;

--
-- TOC entry 7541 (class 0 OID 0)
-- Dependencies: 1000
-- Name: FUNCTION af_get_fichier(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_fichier(integer) IS 'Obtenir les informations d''un fichier.';


--
-- TOC entry 1001 (class 1255 OID 2595792)
-- Dependencies: 2983 5
-- Name: af_get_fichier_glossaire(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_fichier_glossaire(integer) RETURNS record
    AS $_$DECLARE
--$1 identifiant du fichier
rec RECORD;
BEGIN
	SELECT into rec F_id, F_libelle, F_type , F_connecte,  FG.date_modification, G.libelle, G.id
	FROM contraintes.af_get_fichier($1) AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool),
	contraintes.fichier_glossaire FG,
	contraintes.glossaire G
	WHERE FG.id=$1
	AND FG.id=F_id
	AND G.fichier=F_id;
	
	
	RETURN rec;
END$_$
    LANGUAGE plpgsql STRICT;


ALTER FUNCTION contraintes.af_get_fichier_glossaire(integer) OWNER TO pgsql;

--
-- TOC entry 7543 (class 0 OID 0)
-- Dependencies: 1001
-- Name: FUNCTION af_get_fichier_glossaire(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_fichier_glossaire(integer) IS 'obtenir les informations d''un fichier de glossaire.';


--
-- TOC entry 1830 (class 1255 OID 2962559)
-- Dependencies: 2983 5
-- Name: af_get_fichier_metadata(integer); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION af_get_fichier_metadata(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT into rec  F_id , libelle ,  type, mots_cles, individu, connecte
	FROM contraintes.af_get_fichiers() AS ( F_id int4, libelle varchar, "type" int4, connecte bool),
	contraintes.fichier_metadata FM
	WHERE F_id=$1
	AND F_id=FM.id;

	RETURN rec;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichier_metadata(integer) OWNER TO www;

--
-- TOC entry 1002 (class 1255 OID 2595793)
-- Dependencies: 2983 5
-- Name: af_get_fichier_scenario_dynamique(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_fichier_scenario_dynamique(integer) RETURNS record
    AS $_$DECLARE
--$1 identifiant du fichier
rec RECORD;
BEGIN
	SELECT into rec F_id, F_libelle, F_type , F_connecte, SD.style, SD.date_modification
	FROM contraintes.af_get_fichier($1) AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool),
	contraintes.fichier_scenario_dynamique SD
	WHERE SD.id=$1
	AND SD.id=F_id;
	
	RETURN rec;
END$_$
    LANGUAGE plpgsql STRICT;


ALTER FUNCTION contraintes.af_get_fichier_scenario_dynamique(integer) OWNER TO pgsql;

--
-- TOC entry 7546 (class 0 OID 0)
-- Dependencies: 1002
-- Name: FUNCTION af_get_fichier_scenario_dynamique(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_fichier_scenario_dynamique(integer) IS 'obtenir les informations d''un fichier de scenario dynamique.';


--
-- TOC entry 1003 (class 1255 OID 2595794)
-- Dependencies: 2983 5
-- Name: af_get_fichier_scenario_dynamique_bloc(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_fichier_scenario_dynamique_bloc(integer, integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec * FROM contraintes.af_get_fichier_scenario_dynamique_blocs($1) 
	AS (id integer,libelle varchar, ordre integer, var_keys text[], var_values text, scenario integer)
	WHERE ordre=$2;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichier_scenario_dynamique_bloc(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1004 (class 1255 OID 2595795)
-- Dependencies: 2983 5
-- Name: af_get_fichier_scenario_dynamique_blocs(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_fichier_scenario_dynamique_blocs(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT FBS.id,F.libelle, FSDB.ordre, FSDB.bloc_vars_keys,FSDB.bloc_vars_values, FSDB.id
		FROM contraintes.fichier_scenario_dynamique_blocs FSDB,
		contraintes.fichier_bloc_scenario FBS,
		contraintes.fichier F
		WHERE FSDB.id=$1
		AND FSDB.fichier_bloc_scenario=FBS.id
		AND FBS.id=F.id
		ORDER BY FSDB.ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichier_scenario_dynamique_blocs(integer) OWNER TO pgsql;

--
-- TOC entry 1005 (class 1255 OID 2595796)
-- Dependencies: 2983 5
-- Name: af_get_fichier_scenario_dynamique_blocs_type(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_fichier_scenario_dynamique_blocs_type(integer) RETURNS integer
    AS $_$DECLARE
rec RECORD;
BEGIN

	FOR rec IN 
		SELECT COUNT(DISTINCT F.type) AS nb, F.type AS typ
		FROM contraintes.fichier_scenario_dynamique_blocs FSDB,
		contraintes.fichier F
		WHERE FSDB.id=$1
		AND FSDB.fichier_bloc_scenario=F.id
		GROUP BY F.type
	LOOP
		RAISE NOTICE '% > %',rec.nb,rec.typ;
		IF rec.nb>1 THEN
			RAISE EXCEPTION 'Le fichier scenario dynamique est corrompu: type de bloc differents';
		ELSEIF rec.nb = 0 THEN
			RETURN NULL;
		ELSE 
			RETURN rec.typ;
		END IF;

		RETURN NULL;
	END LOOP;
	RETURN NULL;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichier_scenario_dynamique_blocs_type(integer) OWNER TO pgsql;

--
-- TOC entry 1006 (class 1255 OID 2595797)
-- Dependencies: 2983 5
-- Name: af_get_fichier_scenario_dynamique_slide(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_fichier_scenario_dynamique_slide(integer, integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec * FROM contraintes.af_get_fichier_scenario_dynamique_slides($1) 
	AS (id integer,libelle varchar, ordre integer, var_keys text[], var_values text, scenario integer)
	WHERE ordre=$2;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichier_scenario_dynamique_slide(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1007 (class 1255 OID 2595798)
-- Dependencies: 2983 5
-- Name: af_get_fichier_scenario_dynamique_slides(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_fichier_scenario_dynamique_slides(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT FBS.id,F.libelle, FSDB.ordre, FSDB.bloc_vars_keys,FSDB.bloc_vars_values, FSDB.id
		FROM contraintes.fichier_scenario_dynamique_blocs FSDB,
		contraintes.fichier_slide_scenario FBS,
		contraintes.fichier F
		WHERE FSDB.id=$1
		AND FSDB.fichier_bloc_scenario=FBS.id
		AND FBS.id=F.id
		ORDER BY FSDB.ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichier_scenario_dynamique_slides(integer) OWNER TO pgsql;

--
-- TOC entry 1008 (class 1255 OID 2595799)
-- Dependencies: 2983 5
-- Name: af_get_fichier_texte(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_fichier_texte(integer) RETURNS record
    AS $_$DECLARE
--$1 identifiant du fichier
rec RECORD;
BEGIN
	SELECT into rec F_id, F_libelle, F_type , F_connecte, libelle, adresse, description, mise_en_forme, TO_CHAR(date_modification,'DD/MM/YYYY') FROM contraintes.af_get_fichiers() AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool),
	contraintes.fichier_ressource_texte
	WHERE F_id=$1
	AND F_id=id;
	
	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichier_texte(integer) OWNER TO pgsql;

--
-- TOC entry 7553 (class 0 OID 0)
-- Dependencies: 1008
-- Name: FUNCTION af_get_fichier_texte(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_fichier_texte(integer) IS 'obtenir les informations d''un fichier texte.';


--
-- TOC entry 19 (class 1255 OID 2595800)
-- Dependencies: 2983 5
-- Name: af_get_fichier_type(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_fichier_type(integer) RETURNS record
    AS $_$-- $1 : type
declare
rec record;
begin
    select into rec id,libelle,code,categorie from contraintes.fichier_type where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichier_type(integer) OWNER TO postgres;

--
-- TOC entry 7555 (class 0 OID 0)
-- Dependencies: 19
-- Name: FUNCTION af_get_fichier_type(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_fichier_type(integer) IS 'retourne les infos d''un type de fichier';


--
-- TOC entry 1009 (class 1255 OID 2595801)
-- Dependencies: 2983 5
-- Name: af_get_fichiers(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_fichiers() RETURNS SETOF record
    AS $$DECLARE
rec record;
BEGIN

	for rec in
		select * from contraintes.fichier
	loop
		return next rec;
	end loop;

	return;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichiers() OWNER TO postgres;

--
-- TOC entry 7557 (class 0 OID 0)
-- Dependencies: 1009
-- Name: FUNCTION af_get_fichiers(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_fichiers() IS 'Obtenirs tous les fichiers de la plate-forme.';


--
-- TOC entry 1010 (class 1255 OID 2595802)
-- Dependencies: 2983 5
-- Name: af_get_fichiers_type(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_fichiers_type(integer) RETURNS SETOF record
    AS $_$--$1 le typo de fichier voulu
DECLARE
rec record;
BEGIN
	
	FOR rec IN
		select * from contraintes.af_get_fichiers()AS ( id int4, libelle varchar, "type" int4, connecte bool) where "type" = $1
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_fichiers_type(integer) OWNER TO postgres;

--
-- TOC entry 7559 (class 0 OID 0)
-- Dependencies: 1010
-- Name: FUNCTION af_get_fichiers_type(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_fichiers_type(integer) IS 'Obtenir tous les fichiers d''un type particulier.
';


--
-- TOC entry 1011 (class 1255 OID 2595803)
-- Dependencies: 2983 5
-- Name: af_get_filiere(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filiere(integer) RETURNS record
    AS $_$DECLARE
--$1 filiere
rec RECORD;
BEGIN
	SELECT INTO rec id, libelle, pere FROM contraintes.filiere
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filiere(integer) OWNER TO pgsql;

--
-- TOC entry 1012 (class 1255 OID 2595804)
-- Dependencies: 2983 5
-- Name: af_get_filiere_etapes_disponibles_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filiere_etapes_disponibles_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
--$2 theme
rec RECORD;
sous_type contraintes.type_element;
rec_spe RECORD;
rec_ss_parcours RECORD;
BEGIN
	FOR rec IN 
		SELECT I_D AS id,  E.libelle AS libelle,CAST(E.type AS varchar) AS type, T.libelle  AS libelle_type
		FROM contraintes.etape E 
		LEFT OUTER JOIN contraintes.af_get_categorie_elements_theme(29 ,$2) I_D
		ON E.id=I_D,contraintes.etape_type T
		WHERE I_D IS NOT NULL
		AND E.type=T.id
		ORDER BY E.type

	LOOP
		--Cas speciaux: les types ayant des sous types
		SELECT INTO sous_type * FROM contraintes.af_get_etape_type_sous_type(rec.id, CAST(rec.type AS int4), rec.libelle_type)
		ORDER BY sous_type.id;
		rec.type:=sous_type.id;
		rec.libelle_type:=sous_type.libelle;
		RETURN NEXT rec;
	END LOOP;

	----------------------------------
	--      ETAPES SANS THEMES      --
	----------------------------------

	--les types d'étapes spéciales: forum (2), chat(8) et etape titre(9)
	FOR rec_spe IN 
		SELECT CAST(NULL AS int4) AS id,  CAST(NULL AS varchar) AS  libelle, CAST(id AS varchar) AS type, libelle  AS libelle_type
		FROM contraintes.etape_type T
		WHERE id IN (8,9)
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	--les types d'étapes forum (2)
	
	FOR rec_spe IN 
		SELECT P_id,  P_libelle_etape, cast('2' as varchar), T.libelle  AS libelle_type
		FROM contraintes.etape_type T,contraintes.af_get_etapes_forum() as
		(P_id int4,P_libelle_etape varchar,forum int4,libelle varchar,description varchar,moderation bool,moderateur_pwd varchar,fils int4,messages int4,upload bool,theme varchar,configuration int4,date_creation timestamp)
 
		WHERE T.id=2 
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	-- type chat(8)

	FOR rec_spe IN 
		SELECT P_id,  P_libelle_etape, cast('8' as varchar), T.libelle  AS libelle_type
		FROM contraintes.etape_type T,contraintes.af_get_etapes_chats() as
		(P_id int4,P_libelle_etape varchar,chat int4,date_creation timestamp)
 
		WHERE T.id=8 
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;
	

	FOR rec_ss_parcours IN 
		SELECT P_id,  P_libelle, CAST('1'AS varchar) AS type, libelle  AS libelle_type
		FROM contraintes.af_get_filiere_sous_parcourss_disponibles($1) AS (P_id int4, P_libelle varchar, filiere int4, duree bool),
		contraintes.etape_type T
		WHERE 1=T.id
	LOOP
		RETURN NEXT rec_ss_parcours;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filiere_etapes_disponibles_theme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1013 (class 1255 OID 2595805)
-- Dependencies: 2983 5
-- Name: af_get_filiere_formations(integer, character varying, boolean, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filiere_formations(integer, character varying, boolean, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
--$2 ASC(ou n'importe quoi) ou DESC pour le classement du resultat
--$3 TRUE, classement par date de début, ou FALSE classement par libelle
req varchar;
rec record;
BEGIN
	if contraintes.fw_is_root($4) then
	req:='SELECT F.id, F.libelle, F.parcours, F.date_debut, F.date_fin, F.langue, P.filiere FROM contraintes.formation F , contraintes.parcours P
		WHERE P.filiere='||$1||' AND F.parcours=P.id ';
	else
	req:='SELECT F.id, F.libelle, F.parcours, F.date_debut, F.date_fin, F.langue, P.filiere FROM contraintes.formation F , contraintes.parcours P,contraintes.formation_participants fp
		WHERE P.filiere='||$1||' AND F.parcours=P.id and F.id=fp.formation and fp.formateur='||$4;
	end if;

	IF $3 IS TRUE THEN
		req:=req||' ORDER BY F.date_debut';
	ELSE 
		req:=req||' ORDER BY F.libelle';
	END IF;

	IF $2 LIKE 'DESC' THEN
		req:=req||' DESC';
	END IF;
	FOR rec IN
	    EXECUTE req
	LOOP
	    RETURN next rec;
	END LOOP;

		
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filiere_formations(integer, character varying, boolean, integer) OWNER TO pgsql;

--
-- TOC entry 7563 (class 0 OID 0)
-- Dependencies: 1013
-- Name: FUNCTION af_get_filiere_formations(integer, character varying, boolean, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_filiere_formations(integer, character varying, boolean, integer) IS 'retourne les formations d''une filiere pour le root ou formateur';


--
-- TOC entry 1841 (class 1255 OID 2595806)
-- Dependencies: 2983 5
-- Name: af_get_filiere_libelle_complet(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filiere_libelle_complet(integer) RETURNS character varying
    AS $_$DECLARE
--$1 filiere
rec_pere RECORD;
libelle_complet varchar;
libelle_part varchar;
BEGIN
	IF $1 IS NULL THEN
		RETURN NULL;
	ELSE
		--selectionne le libelle et le pere de la filiere
		SELECT INTO rec_pere libelle, pere FROM contraintes.filiere
		WHERE id=$1;
		
		--recupere le libelle complet du pere
		SELECT INTO libelle_part * FROM contraintes.af_get_filiere_libelle_complet(rec_pere.pere);
	
		--ajoute le libellé complet du pêre à la filiere pour former le libellé complet de la filiere
		IF libelle_part IS NOT NULL THEN			
			libelle_complet:=libelle_part||'/'||rec_pere.libelle;
		ELSE
			libelle_complet:=rec_pere.libelle;
		END IF;

		RETURN libelle_complet;
	END IF;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filiere_libelle_complet(integer) OWNER TO pgsql;

--
-- TOC entry 1014 (class 1255 OID 2595807)
-- Dependencies: 2983 5
-- Name: af_get_filiere_parcourss(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filiere_parcourss(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT E.id, E.libelle, P.filiere, P.duree FROM contraintes.parcours P, contraintes.etape E 
		WHERE P.id=E.id
		AND P.filiere=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;
		
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filiere_parcourss(integer) OWNER TO pgsql;

--
-- TOC entry 1015 (class 1255 OID 2595808)
-- Dependencies: 2983 5
-- Name: af_get_filiere_pere(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_filiere_pere(integer) RETURNS SETOF record
    AS $_$declare
	id_pere alias for $1;
	req text;
	rec record;
begin
	req:='select * from contraintes.filiere where pere ';
	if (id_pere is null) then
		req:=req||' is null';
	else
		req:=req||'='||id_pere;
	end if;
	for rec in
		execute req
		loop
			return next rec;
		end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filiere_pere(integer) OWNER TO postgres;

--
-- TOC entry 7567 (class 0 OID 0)
-- Dependencies: 1015
-- Name: FUNCTION af_get_filiere_pere(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_filiere_pere(integer) IS 'Renvoie les filiÃ¨res associÃ©es Ã  un pÃ¨re.';


--
-- TOC entry 1016 (class 1255 OID 2595809)
-- Dependencies: 2983 5
-- Name: af_get_filiere_sous_filieres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filiere_sous_filieres(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
rec RECORD;
BEGIN

	IF $1 IS NOT NULL THEN
		FOR rec IN
			SELECT id, libelle, pere FROM contraintes.filiere
			WHERE pere=$1 ORDER BY libelle
		LOOP
			RETURN NEXT rec;
		END LOOP;
	ELSE
		FOR rec IN
			SELECT id, libelle, pere FROM contraintes.filiere
			WHERE pere IS NULL ORDER BY libelle
		LOOP
			RETURN NEXT rec;
		END LOOP;
	END IF;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filiere_sous_filieres(integer) OWNER TO pgsql;

--
-- TOC entry 1017 (class 1255 OID 2595810)
-- Dependencies: 2983 5
-- Name: af_get_filiere_sous_parcourss_disponibles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filiere_sous_parcourss_disponibles(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
ss_filieres RECORD;
parcourss RECORD;
BEGIN
	--selection des sous filieres de la filiere
	FOR ss_filieres IN
		SELECT id FROM contraintes.af_get_filiere_sous_filieres($1) AS (id int4, libelle varchar, pere int4)
	LOOP
		--selection des parcours de chacunes des filieres
		FOR parcourss IN
			SELECT * FROM contraintes.af_get_filiere_parcourss(ss_filieres.id) AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool)
		LOOP
			RETURN NEXT parcourss;
			
		END LOOP;
		
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filiere_sous_parcourss_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 1018 (class 1255 OID 2595811)
-- Dependencies: 2983 5
-- Name: af_get_filieres(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filieres() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT F.id, F.libelle, F.pere, F_ID.ind FROM contraintes.filiere F,
		contraintes.af_gen_get_elements('contraintes.filiere', 'id', NULL, ' ', 0) F_ID
		WHERE F.id=F_ID.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filieres() OWNER TO pgsql;

--
-- TOC entry 1019 (class 1255 OID 2595812)
-- Dependencies: 2983 5
-- Name: af_get_filieres_formation(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filieres_formation() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct fi.id,fi.libelle,fi.pere 
	from contraintes.filiere fi,contraintes.formation fo,contraintes.parcours p
	where fi.id=p.filiere and p.id=fo.parcours

    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filieres_formation() OWNER TO pgsql;

--
-- TOC entry 7572 (class 0 OID 0)
-- Dependencies: 1019
-- Name: FUNCTION af_get_filieres_formation(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_filieres_formation() IS 'retourne les filieres des formation de la plateforme';


--
-- TOC entry 1020 (class 1255 OID 2595813)
-- Dependencies: 2983 5
-- Name: af_get_filieres_parcours(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filieres_parcours() RETURNS SETOF record
    AS $_$DECLARE
--$1 idendifiant de la filiere de depart 

--Il doit etre à NULL pour obtenir toutes les filieres et sous filieres ayant des parcours,
--dans l'ordre (une filiere et ses sous filieres, puis une autre filiere et ses sous filieres, etc...
rec RECORD;
BEGIN
	FOR rec IN
		--on recupere toutes les filieres principales
		SELECT id, libelle, pere 
		FROM contraintes.af_get_filieres_sous_filieres(NULL) AS (id int4, libelle varchar, pere int4)
		
	LOOP
		--si la filiere principale a des parcours, on la retourne
		PERFORM P_filiere
		FROM contraintes.af_get_parcours() AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool)
		WHERE P_filiere=rec.id;
		
		IF FOUND THEN
			RETURN NEXT rec;
		END IF;

		--FOR rec1 IN
		--	SELECT contraintes.af_get_filieres_parcours()
		--on recupere les sous filieres de la filiere principale en cours
		SELECT DISTINCT id, libelle, pere 
		FROM contraintes.af_get_filieres_sous_filieres(rec.id) AS (id int4, libelle varchar, pere int4)
		LEFT OUTER JOIN
		contraintes.af_get_parcours() AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool)
		ON (id=P_filiere)
		WHERE P_id IS NOT NULL;
	
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filieres_parcours() OWNER TO pgsql;

--
-- TOC entry 7574 (class 0 OID 0)
-- Dependencies: 1020
-- Name: FUNCTION af_get_filieres_parcours(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_filieres_parcours() IS 'Obtenir les filieres ayant des parcours.
$1 doit etre à NULL pour obtenir toutes les filieres et sous filieres ayant des parcours, dans l''ordre (une filiere et ses sous filieres, puis une autre filiere et ses sous filieres, etc...';


--
-- TOC entry 1021 (class 1255 OID 2595814)
-- Dependencies: 2983 5
-- Name: af_get_filieres_parcours(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_filieres_parcours(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 idendifiant de la filiere de depart 

--Il doit etre à NULL pour obtenir toutes les filieres et sous filieres ayant des parcours,
--dans l'ordre (une filiere et ses sous filieres, puis une autre filiere et ses sous filieres, etc...
rec RECORD;
rec1 RECORD;
BEGIN
	FOR rec IN
		--on recupere toutes les filieres principales
		SELECT id, libelle, pere 
		FROM contraintes.af_get_filiere_sous_filieres($1) AS (id int4, libelle varchar, pere int4)
		ORDER BY libelle
		
	LOOP
		--si la filiere principale a des parcours, on la retourne
		PERFORM P_filiere
		FROM contraintes.af_get_parcours() AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool,date_creation timestamp)
		WHERE P_filiere=rec.id ;
		
		IF TRUE THEN
			RETURN NEXT rec;
		END IF;

		FOR rec1 IN
			SELECT * FROM contraintes.af_get_filieres_parcours(rec.id) AS (id int4, libelle varchar, pere int4)
		LOOP
			RETURN NEXT rec1;
		END LOOP;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_filieres_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 7576 (class 0 OID 0)
-- Dependencies: 1021
-- Name: FUNCTION af_get_filieres_parcours(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_filieres_parcours(integer) IS 'Obtenir les filieres ayant des parcours.
$1 doit etre à NULL pour obtenir toutes les filieres et sous filieres ayant des parcours, dans l''ordre (une filiere et ses sous filieres, puis une autre filiere et ses sous filieres, etc...';


--
-- TOC entry 1022 (class 1255 OID 2595815)
-- Dependencies: 2983 5
-- Name: af_get_formateur_classes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formateur_classes(integer) RETURNS SETOF record
    AS $_$-- $1 : numero formateur
declare
rec record;

begin
    for rec in 
	select distinct c.id,c.libelle,c.pere,c.min,c.max from contraintes.classe c ,
	contraintes.formation_participants pf
	where c.id=pf.classe and pf.formateur=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formateur_classes(integer) OWNER TO pgsql;

--
-- TOC entry 7578 (class 0 OID 0)
-- Dependencies: 1022
-- Name: FUNCTION af_get_formateur_classes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formateur_classes(integer) IS 'retourne les classes d''un formateur';


--
-- TOC entry 1023 (class 1255 OID 2595816)
-- Dependencies: 2983 5
-- Name: af_get_formateur_droits(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formateur_droits(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formateur
-- $2 : classe
declare
rec record;
begin
    for rec in 
	(select * from contraintes.af_get_formation_droits($1) as (id int4,libelle varchar))
	union
	(select id,libelle from contraintes.droit,contraintes.individu_droits where 
	id=droit and classe=$2)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formateur_droits(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7580 (class 0 OID 0)
-- Dependencies: 1023
-- Name: FUNCTION af_get_formateur_droits(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formateur_droits(integer, integer) IS 'retourne les droits du formateur';


--
-- TOC entry 1024 (class 1255 OID 2595817)
-- Dependencies: 2983 5
-- Name: af_get_formateur_formations(integer, character varying, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formateur_formations(integer, character varying, character varying, integer) RETURNS SETOF record
    AS $_$-- $1 : numero formateur
-- $2 : classement (asc ou desc)
-- $3 : order by (libelle ou date debut)
-- $4 : periode (1 : passées, 2 : présentes, 3 : futures, 0 toutes)
declare
rec record;
req varchar;
begin

IF contraintes.fw_is_root($1) THEN
    for rec in
	select f_id,f_libelle,f_parcours,f_date_debut,f_date_fin,f_langue,fp.formateur
	from contraintes.af_get_formations($2,$3,$4) as (f_id int4,f_libelle varchar,f_parcours int4,f_date_debut date,f_date_fin date,f_langue int4,ressources_fusionnees boolean),
	contraintes.formation_participants fp
	where f_id=fp.formation 
    loop
	return next rec;
    end loop;
ELSE
    for rec in
	select f_id,f_libelle,f_parcours,f_date_debut,f_date_fin,f_langue,fp.formateur
	from contraintes.af_get_formations($2,$3,$4) as (f_id int4,f_libelle varchar,f_parcours int4,f_date_debut date,f_date_fin date,f_langue int4,ressources_fusionnees boolean),
	contraintes.formation_participants fp
	where f_id=fp.formation and fp.formateur=$1
    loop
	return next rec;
    end loop;

END IF;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formateur_formations(integer, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 7582 (class 0 OID 0)
-- Dependencies: 1024
-- Name: FUNCTION af_get_formateur_formations(integer, character varying, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formateur_formations(integer, character varying, character varying, integer) IS 'retourne les formation d''un formateur';


--
-- TOC entry 1025 (class 1255 OID 2595818)
-- Dependencies: 2983 5
-- Name: af_get_formateur_individu_formations(integer, character varying, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formateur_individu_formations(integer, character varying, character varying, integer) RETURNS SETOF record
    AS $_$-- $1 : numero formateur
-- $2 : classement (asc ou desc)
-- $3 : order by (libelle ou date debut)
-- $4 : periode (1 : passées, 2 : présentes, 3 : futures, 0 toutes)
declare
rec record;
begin
    for rec in
	(select distinct id ,libelle ,parcours ,date_debut ,date_fin ,langue ,formateur, 1
	from contraintes.af_get_formateur_formations($1,$2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4,formateur int4))
	union
	(select distinct id ,libelle ,parcours ,date_debut ,date_fin ,langue ,formateur, 2
	from contraintes.af_get_individu_formations($1,$2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4,formateur int4))
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formateur_individu_formations(integer, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 7584 (class 0 OID 0)
-- Dependencies: 1025
-- Name: FUNCTION af_get_formateur_individu_formations(integer, character varying, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formateur_individu_formations(integer, character varying, character varying, integer) IS 'retourne les formations pour un formateur en tant que formateur et individu';


--
-- TOC entry 1026 (class 1255 OID 2595819)
-- Dependencies: 2983 5
-- Name: af_get_formateurs(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formateurs(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;
begin
    if contraintes.fw_is_root($1) then
    for rec in
	select DISTINCT I.id,textcat(textcat(I.nom,text ' '),I.prenom)
	from contraintes.fw_individu I,  contraintes.fw_individu_types T
	WHERE I.id=T.individu
	AND T.type=2
    loop
	return next rec;
    end loop;
    else
    for rec in
	select DISTINCT I.id,textcat(textcat(I.nom,text ' '),I.prenom)
	from contraintes.fw_individu I,  contraintes.fw_individu_types T
	WHERE I.id=T.individu
	AND T.type=2
	--AND I.id=$1
    loop
	return next rec;
    end loop;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formateurs(integer) OWNER TO pgsql;

--
-- TOC entry 7586 (class 0 OID 0)
-- Dependencies: 1026
-- Name: FUNCTION af_get_formateurs(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formateurs(integer) IS 'retourne les formateurs de la plateforme
si root';


--
-- TOC entry 1027 (class 1255 OID 2595820)
-- Dependencies: 2983 5
-- Name: af_get_formation(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation(integer) RETURNS record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN 
	SELECT INTO rec id, libelle, parcours, date_debut, date_fin, langue,ressources_fusionnees 
	FROM contraintes.formation
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation(integer) OWNER TO pgsql;

--
-- TOC entry 1028 (class 1255 OID 2595821)
-- Dependencies: 2983 5
-- Name: af_get_formation_alerte(integer, date); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_alerte(integer, date) RETURNS record
    AS $_$-- $1 : numero formation
-- $2 : date (timestamp)
declare
rec record;
begin
    select into rec id,libelle,formation,date,jours,texte 
    from contraintes.alerte 
    where formation=$1 and date=$2;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_alerte(integer, date) OWNER TO pgsql;

--
-- TOC entry 7589 (class 0 OID 0)
-- Dependencies: 1028
-- Name: FUNCTION af_get_formation_alerte(integer, date); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_alerte(integer, date) IS 'retourne l''alerte d''une date de formation';


--
-- TOC entry 1842 (class 1255 OID 2595822)
-- Dependencies: 2983 5
-- Name: af_get_formation_alertes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_alertes(integer) RETURNS SETOF record
    AS $_$-- $1 : numero formation
declare
rec record;
begin
    for rec in 
	select id,libelle,formation,date,jours,texte 
        from contraintes.alerte where formation=$1
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_alertes(integer) OWNER TO pgsql;

--
-- TOC entry 7591 (class 0 OID 0)
-- Dependencies: 1842
-- Name: FUNCTION af_get_formation_alertes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_alertes(integer) IS 'retourne les alertes d''une formation';


--
-- TOC entry 1029 (class 1255 OID 2595823)
-- Dependencies: 2983 5
-- Name: af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) RETURNS SETOF record
    AS $_$-- $1 : numero formation
-- $2 : debut periode
-- $3 : fin periode
declare
rec record;
begin
    for rec in
	select id,libelle,formation,date,jours,texte
	from contraintes.alerte
	where formation=$1
	and date between $2 and $3
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 7593 (class 0 OID 0)
-- Dependencies: 1029
-- Name: FUNCTION af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) IS 'retourne les alertes d''une formation pour une periode (debut,fin)';


--
-- TOC entry 1030 (class 1255 OID 2595824)
-- Dependencies: 2983 5
-- Name: af_get_formation_all_ressources_individu(integer, boolean, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_all_ressources_individu(integer, boolean, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : booleen (pour affichage ancienne ressource)
-- $3 : individu
declare
rec record;
begin
    for rec in
	(select * from contraintes.af_get_formation_ressources($1,$2) 
	as(ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut timestamp,fin timestamp,nouveau interval,icone int4) )
	union
	--(select * from contraintes.af_get_formation_parcourss_ressources($1)
	(select * from contraintes.af_get_formation_etapes_ressources_avancement_individu($1,$3)
	as(ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut timestamp,fin timestamp,nouveau interval,icone int4) )
	order by libelle_espace,libelle_section
	
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_all_ressources_individu(integer, boolean, integer) OWNER TO pgsql;

--
-- TOC entry 7595 (class 0 OID 0)
-- Dependencies: 1030
-- Name: FUNCTION af_get_formation_all_ressources_individu(integer, boolean, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_all_ressources_individu(integer, boolean, integer) IS 'retourne toutes les ressources pour une formation et un individu(parcours compris)';


--
-- TOC entry 1031 (class 1255 OID 2595825)
-- Dependencies: 2983 5
-- Name: af_get_formation_avancement(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_avancement(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
id_parcours int4;
rec RECORD;
rec_p RECORD;
BEGIN
	--on récupère le parcours de la formation
	SELECT INTO id_parcours parcours FROM contraintes.af_get_formation($1) 
	AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4,ressources_fusionnees boolean);
	if id_parcours is null then
		raise exception 'Pas de parcours principal pour la formation';
	end if;
	raise notice 'p=%',id_parcours;
	FOR rec IN
		SELECT F_parcours, F_etape, F_formation, F_stagiaire, F_type FROM contraintes.af_get_formation_avancement_parcours($1, id_parcours) AS (F_parcours int4, F_etape int4, F_formation int4, F_stagiaire int4, F_type varchar)
	LOOP
		IF rec.F_type=1 THEN
		
			FOR rec_p IN
				SELECT * FROM contraintes.af_get_formation_avancement_parcours($1,rec.F_etape) AS (parcours int4, etape int4, formation int4,  stagiaire int4, type varchar)
			LOOP
				RETURN NEXT rec_p;
			END LOOP;
		ELSE
			RETURN NEXT rec;
		END IF;
		
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_avancement(integer) OWNER TO pgsql;

--
-- TOC entry 1032 (class 1255 OID 2595826)
-- Dependencies: 2983 5
-- Name: af_get_formation_avancement_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_avancement_individu(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu

declare
rec record;
begin
    for rec in
	select * from contraintes.af_get_formation_avancement($1) 
	as (parcours int4, etape int4, formation int4, stagiaire int4, type varchar)
	where stagiaire=$2 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_avancement_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7598 (class 0 OID 0)
-- Dependencies: 1032
-- Name: FUNCTION af_get_formation_avancement_individu(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_avancement_individu(integer, integer) IS 'retourne les etapes réalisées pour une formation et un individu';


--
-- TOC entry 1033 (class 1255 OID 2595827)
-- Dependencies: 2983 5
-- Name: af_get_formation_avancement_max(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_avancement_max(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 formation
--$2 individu
id_parcours int4;
rec RECORD;
rec_p RECORD;
BEGIN
	--on récupère le parcours de la formation
	SELECT INTO id_parcours parcours FROM contraintes.af_get_formation($1) 
	AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4,ressources_fusionnees boolean);
	
	RAISE NOTICE 'Parcours principal pour la formation: %', id_parcours;
	IF id_parcours IS NULL THEN
		RAISE EXCEPTION 'Pas de parcours principal pour la formation';
	END IF;

	
	SELECT INTO rec * FROM contraintes.af_get_formation_avancement_max_parcours($1, id_parcours, $2) AS (parcours int4, etape int4, type int4,formation int4, individu int4, date_debut timestamp);
	
	IF rec.type=1 THEN
	
		SELECT INTO rec_p * FROM contraintes.af_get_formation_avancement_max_parcours($1,rec.etape, $2) AS (parcours int4, etape int4,type int4, formation int4, individu int4, date_debut timestamp);
		RETURN rec_p;
		
	ELSE
		RETURN rec;
	END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_avancement_max(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1034 (class 1255 OID 2595828)
-- Dependencies: 2983 5
-- Name: af_get_formation_avancement_max_parcours(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_avancement_max_parcours(integer, integer, integer) RETURNS record
    AS $_$
DECLARE
--$1 formation
--$2 parcours
--$3 individu 
mini integer;
rec RECORD; 
BEGIN
	SELECT INTO mini MIN(elt2.ind) FROM ( contraintes.af_gen_get_elements('contraintes.parcours_etapes', 'etape', NULL, 'AND parcours='||$2,0) elt2 
	INNER JOIN contraintes.parcours_etapes PE ON (PE.parcours = $2 AND elt2.id=PE.etape AND obligatoire IS TRUE)
	)LEFT OUTER JOIN contraintes.resultat R2 ON (R2.parcours = $2 AND elt2.id=R2.etape AND R2.formation=$1 AND R2.stagiaire=$3)
	WHERE R2.duree IS NULL;


	RAISE NOTICE 'min=%',mini;
	SELECT INTO rec $2, E.id, E.type , $1, $3, R1.date_debut, R1.duree
	FROM contraintes.etape E,contraintes.af_gen_get_elements('contraintes.parcours_etapes', 'etape', NULL, 'AND parcours='||$2,0) elt
	LEFT OUTER JOIN contraintes.resultat R1 ON (R1.parcours = $2 AND elt.id=R1.etape AND R1.formation=$1 AND R1.stagiaire=$3)
	WHERE E.id=elt.id
	AND elt.ind = mini;

	RETURN rec;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_avancement_max_parcours(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1035 (class 1255 OID 2595829)
-- Dependencies: 2983 5
-- Name: af_get_formation_avancement_parcours(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_avancement_parcours(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
--$2 parcours
rec RECORD;
BEGIN
	

	--on recupere les etapes du parcours
	FOR rec IN
		SELECT * FROM contraintes.af_get_parcours_avancement($2) 
		AS (parcours int4,etape int4, formation int4, stagiaire int4, type varchar)
		WHERE formation=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_avancement_parcours(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1036 (class 1255 OID 2595830)
-- Dependencies: 2983 5
-- Name: af_get_formation_avancement_parcours_individu(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_avancement_parcours_individu(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : parcours
declare
rec record;
begin
    for rec in
	select * from contraintes.af_get_formation_avancement($1) 
	as (parcours int4, etape int4, formation int4, stagiaire int4, type varchar)
	where stagiaire=$2 and parcours=$3 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_avancement_parcours_individu(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7603 (class 0 OID 0)
-- Dependencies: 1036
-- Name: FUNCTION af_get_formation_avancement_parcours_individu(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_avancement_parcours_individu(integer, integer, integer) IS 'retourne les etapes réalisées pour une formation,un parcours et un individu';


--
-- TOC entry 1037 (class 1255 OID 2595831)
-- Dependencies: 2983 5
-- Name: af_get_formation_avancement_reel_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_avancement_reel_individu(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu

declare
rec record;
etape_courante integer:=0 ;
begin
    for rec in
	select * from contraintes.af_get_formation_avancement_individu($1,$2)
	as (parcours int4, etape int4, formation int4, stagiaire int4, type varchar)
	where type not in ('9','10')
	
    loop
	
	if rec.etape != etape_courante then 
	    return next rec;
	    etape_courante:=rec.etape;
	end if;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_avancement_reel_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7605 (class 0 OID 0)
-- Dependencies: 1037
-- Name: FUNCTION af_get_formation_avancement_reel_individu(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_avancement_reel_individu(integer, integer) IS 'retourn l''avacement réel d''un individu pour une formation (cad : les etapes réellement faites (ex : pas les etapes titre))';


--
-- TOC entry 1038 (class 1255 OID 2595832)
-- Dependencies: 2983 5
-- Name: af_get_formation_classes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_classes(integer) RETURNS record
    AS $_$declare
rec record;
begin
    select into rec id,libelle,pere,min,max 
    from contraintes.af_get_classes() as(id int4,libelle varchar, pere int4,min int4,max int4) ,
    contraintes.formation_participants ft 
    where ft.formation=$1 and ft.classe=id;
    return rec; 
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_classes(integer) OWNER TO pgsql;

--
-- TOC entry 7607 (class 0 OID 0)
-- Dependencies: 1038
-- Name: FUNCTION af_get_formation_classes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_classes(integer) IS 'retourne la classe d''une formation';


--
-- TOC entry 1039 (class 1255 OID 2595833)
-- Dependencies: 2983 5
-- Name: af_get_formation_droits(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_droits(integer) RETURNS SETOF record
    AS $_$-- $1 : numero formation
declare
rec record;
begin
    for rec in
	select d.id,d.libelle from contraintes.droit d,contraintes.formateur_droits fd
	where d.id=fd.droit and fd.formation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_droits(integer) OWNER TO pgsql;

--
-- TOC entry 7609 (class 0 OID 0)
-- Dependencies: 1039
-- Name: FUNCTION af_get_formation_droits(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_droits(integer) IS 'retourne les droits (du formateur) d''une formation';


--
-- TOC entry 1040 (class 1255 OID 2595834)
-- Dependencies: 2983 5
-- Name: af_get_formation_espace_ressources(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_espace_ressources(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : espace
declare
rec record;
begin
    for rec in 
	select 
	FR.ressource,R.fichier,FR.espace,E.libelle, FR.section,S.libelle,ET.libelle,FR.formation,FI.type,R.mots_cles, 
	cast(FR.debut_disponibilite as date), cast(FR.fin_disponibilite as date), FR.duree_nouveaute,S.icone
	FROM 
	contraintes.formation_ressources FR,
	contraintes.ressource R,
	contraintes.etape ET,
	contraintes.etape_ressource ER,
	contraintes.fichier FI,
	contraintes.espace E,
	contraintes.section S
	WHERE 
	FR.formation=$1 and FR.espace=$2 
	and FR.ressource=R.id 
	and FR.espace=E.id 
	and FR.section=S.id 
	and R.fichier=FI.id 
	and ET.id=ER.id and ER.ressource=FR.ressource
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_espace_ressources(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7611 (class 0 OID 0)
-- Dependencies: 1040
-- Name: FUNCTION af_get_formation_espace_ressources(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_espace_ressources(integer, integer) IS 'retourne les ressources d''une formation pour un espace';


--
-- TOC entry 1041 (class 1255 OID 2595835)
-- Dependencies: 2983 5
-- Name: af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : espace
-- $3 : section
-- $4 : individu
declare
rec record;
begin
    for rec in
	(select * from contraintes.af_get_formation_espace_section_ressources($1,$2,$3)
	as (ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut date,fin date,nouveau interval,icone int4))
	union
	(select * from contraintes.af_get_formation_espace_section_etapes_ressources_avancement_individu($1,$2,$3,$4)
	as (ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut date,fin date,nouveau interval,icone int4))
	order by libelle_espace,libelle_section

    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7613 (class 0 OID 0)
-- Dependencies: 1041
-- Name: FUNCTION af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer) IS 'retourne les ressources pour un espace,une section d''une formation fusionnées aves celles des etapes faites par l''individu';


--
-- TOC entry 1042 (class 1255 OID 2595836)
-- Dependencies: 2983 5
-- Name: af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : espace
-- $3 : section
-- $4 : individu
declare
rec record;
begin
    for rec in
	
	select ET.fichier,ET.fichier,ET.espace,E.libelle,ET.section,S.libelle,FI.libelle,
	$1,FI.type,FM.mots_cles,CAST(NULL AS date),cast(NULL as date),cast(NULL as interval),S.icone
	from (contraintes.fichier FI left outer join contraintes.fichier_metadata FM on (FI.id=FM.id)),
	contraintes.etape_ressource ET,
	contraintes.espace E,
	contraintes.section S 
	where ET.fichier=FI.id
	and ET.espace=$2
	and ET.section=$3
	and ET.espace=E.id  
	and ET.section=S.id
	and ET.id in 
	--and ET.id in 
	(select etape from contraintes.af_get_formation_avancement_individu($1,$4) as 
	(parcours int4, etape int4, formation int4, stagiaire int4, type varchar) where type=7)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7615 (class 0 OID 0)
-- Dependencies: 1042
-- Name: FUNCTION af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer) IS 'retourne les ressources (pour un espace et une section) issues des etapes ressources faites par l''individu';


--
-- TOC entry 1843 (class 1255 OID 2595837)
-- Dependencies: 2983 5
-- Name: af_get_formation_espace_section_ressources(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_espace_section_ressources(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : espace
-- $3 : section
declare
rec record;
begin
    for rec in
    select 
	FR.fichier_ressource,FR.fichier_ressource,FR.espace,E.libelle, FR.section,S.libelle,FI.libelle,FR.formation,FI.type,FM.mots_cles, 
	cast(FR.debut_disponibilite as date), cast(FR.fin_disponibilite as date), FR.duree_nouveaute,S.icone
	FROM 
	(contraintes.fichier FI LEFT OUTER JOIN
	contraintes.fichier_metadata FM ON (FI.id=FM.id )),
	contraintes.formation_ressources FR,
	contraintes.espace E,
	contraintes.section S
	WHERE 
	FR.formation=$1 and FR.espace=$2 and FR.section=$3 
	and FR.fichier_ressource=FI.id 
	and FR.section=S.id 
	and FR.espace=E.id
	AND now() BETWEEN debut_disponibilite AND (fin_disponibilite + '1 day')
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_espace_section_ressources(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7617 (class 0 OID 0)
-- Dependencies: 1843
-- Name: FUNCTION af_get_formation_espace_section_ressources(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_espace_section_ressources(integer, integer, integer) IS 'retourne les ressources pour une formation,un espace et une section';


--
-- TOC entry 1043 (class 1255 OID 2595838)
-- Dependencies: 2983 5
-- Name: af_get_formation_espace_section_ressources_no_date(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_espace_section_ressources_no_date(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : espace
-- $3 : section
declare
rec record;
begin
    for rec in
    select 
	FR.fichier_ressource,FR.fichier_ressource,FR.espace,E.libelle, FR.section,S.libelle,FI.libelle,FR.formation,FI.type,FM.mots_cles, 
	cast(NULL as date), cast(NULL as date), cast(NULL as interval),S.icone
	FROM 
	(contraintes.fichier FI LEFT OUTER JOIN
	contraintes.fichier_metadata FM ON (FI.id=FM.id )),
	contraintes.formation_ressources FR,
	contraintes.espace E,
	contraintes.section S
	WHERE 
	FR.formation=$1 and FR.espace=$2 and FR.section=$3 
	and FR.fichier_ressource=FI.id 
	and FR.section=S.id 
	and FR.espace=E.id
	--AND (now() BETWEEN debut_disponibilite AND (fin_disponibilite + '1 day') or FR.debut_disponibilite is null)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_espace_section_ressources_no_date(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7619 (class 0 OID 0)
-- Dependencies: 1043
-- Name: FUNCTION af_get_formation_espace_section_ressources_no_date(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_espace_section_ressources_no_date(integer, integer, integer) IS 'retourne les ressources pour une formation,un espace et une section';


--
-- TOC entry 1044 (class 1255 OID 2595839)
-- Dependencies: 2983 5
-- Name: af_get_formation_espace_sections(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_formation_espace_sections(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
--$2 espace
rec RECORD;
BEGIN
    FOR rec IN
	/*SELECT FR.espace,E.libelle, FR.section,S.libelle,S.icone,FR.formation,FR.ressource
	FROM 
	contraintes.formation_ressources FR,
	contraintes.espace E,
	contraintes.section S
	WHERE 
	FR.formation=$1 and FR.espace=$2
	and FR.espace=E.id 
	and FR.section=S.id*/
--espace, libelle_espace, section ,libelle_section ,icone ,formation ,ressource
		select *  from contraintes.af_get_formation_ressources($1, FALSE) 
		as(ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut timestamp,fin timestamp,nouveau interval,icone int4) 
		WHERE espace=$2
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_espace_sections(integer, integer) OWNER TO postgres;

--
-- TOC entry 7621 (class 0 OID 0)
-- Dependencies: 1044
-- Name: FUNCTION af_get_formation_espace_sections(integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_formation_espace_sections(integer, integer) IS 'Retourne toutes les sections d''un espace';


--
-- TOC entry 1045 (class 1255 OID 2595840)
-- Dependencies: 2983 5
-- Name: af_get_formation_etape_individu_encadrants(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_etape_individu_encadrants(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE 
--$1 formation
--$2 Individu
--$3 Parcours
--$4 Etape
ligne_vide RECORD;
rec RECORD;
indice integer;
nb_ligne integer;
ligne_suivant boolean:= false ;
ligne_precedent boolean:= false;

v_ligne_suivant RECORD;
v_ligne_precedent RECORD;


BEGIN
	--selection l'indice
	select INTO indice B_indice 
	from contraintes.af_get_formation_etapes_individu($1,$2)
	as(id int4, libelle_pour_parcours varchar, libelle_etape  varchar,libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool,libelle_type_original varchar, modifiable bool, B_indice int4)
	WHERE parcours=$3
	AND id=$4;

	
	FOR rec IN

		select id , libelle_pour_parcours , libelle_etape  ,libelle_type_etape  , type ,  pere , parcours , obligatoire , chrono , fin ,libelle_type_original , modifiable , I_indice 
		from contraintes.af_get_formation_etapes_individu($1,$2) 
		as(id int4, libelle_pour_parcours varchar, libelle_etape  varchar,libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool,libelle_type_original varchar, modifiable bool, I_indice int4)
		WHERE (I_indice = indice+1
		OR I_indice=indice-1) ORDER BY indice
		
		
	LOOP 
		RAISE NOTICE '---------------------------indice=%   < rec.I_indice=%',indice,rec.I_indice;
		
		IF indice<rec.I_indice THEN
			ligne_suivant:=true;
			v_ligne_suivant:=rec;
		ELSE
			ligne_precedent:=true;
			v_ligne_precedent:=rec;
		END IF;

		
	END LOOP;

	IF  ligne_precedent=true AND ligne_suivant=true THEN
		RETURN NEXT v_ligne_precedent;
		RETURN NEXT v_ligne_suivant;
	ELSE
		ligne_vide:= rec;
		ligne_vide.id:=NULL;
		ligne_vide.libelle_pour_parcours:=NULL;
		ligne_vide.libelle_etape:=NULL;
		ligne_vide.libelle_type_etape:=NULL;
		ligne_vide.type:=NULL;
		ligne_vide.pere:=NULL;
		ligne_vide.parcours:=NULL;
		ligne_vide.obligatoire:=NULL;
		ligne_vide.chrono:=NULL;
		ligne_vide.fin:=NULL;
		ligne_vide.libelle_type_original:=NULL;
		ligne_vide.modifiable:=NULL;	
		ligne_vide.I_indice:= NULL;

		IF ligne_precedent=false THEN
		
				RETURN NEXT ligne_vide;
				RETURN NEXT rec;
		END IF;

		IF ligne_suivant=false THEN
				RETURN NEXT rec;
				RETURN NEXT ligne_vide;	
		END IF;	
	END IF;

	IF  ligne_precedent=false AND ligne_suivant=false THEN
		RETURN NEXT ligne_vide;
		RETURN NEXT ligne_vide;
	END IF;	
	
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_etape_individu_encadrants(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1046 (class 1255 OID 2595841)
-- Dependencies: 2983 5
-- Name: af_get_formation_etapes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_etapes(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
id_parcours int4;
rec RECORD;
rec_p RECORD;
indice integer:=0;
BEGIN
	--on récupère le parcours de la formation
	SELECT INTO id_parcours parcours FROM contraintes.af_get_formation($1) 
	AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4,ressources_fusionnees boolean);
	--raise notice 'parc=%',id_parcours;
	--on recupere les etapes du parcours
	FOR rec IN
		--SELECT * FROM contraintes.af_get_parcours_etapes_deroulees(id_parcours) AS (id int4, libelle_pour_parcours varchar, libelle_etape  varchar, type int4,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool)
		-- Modif said 17/11/06
		SELECT *,indice AS indic FROM contraintes.af_get_parcours_etapes_deroulees(id_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
	
	LOOP
		IF rec.type=1 THEN
			FOR rec_p IN
				--SELECT * FROM contraintes.af_get_parcours_etapes_deroulees(rec.id) AS (id int4, libelle_pour_parcours varchar, libelle_etape  varchar, type int4,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool)
				-- Modif said 17/11/06
				SELECT *,indice AS indic FROM contraintes.af_get_parcours_etapes_deroulees(rec.id) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
			
			LOOP
				rec_p.indic:=indice;
				RETURN NEXT rec_p;
				indice:=indice+1;
			END LOOP;
		ELSE 
			rec.indic:=indice;
			RETURN NEXT rec;
			indice:=indice+1;
		END IF;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_etapes(integer) OWNER TO pgsql;

--
-- TOC entry 1047 (class 1255 OID 2595842)
-- Dependencies: 2983 5
-- Name: af_get_formation_etapes_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_etapes_individu(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
--$2 individu
id_parcours int4;
sous_parcours integer;
rec_resultat record;
rec RECORD;
rec_p RECORD;
indice integer:=0;
BEGIN
    --on récupère le parcours de la formation
    SELECT INTO id_parcours parcours FROM contraintes.af_get_formation($1) 
    AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4,ressources_fusionnees boolean);
    raise notice 'parc=%',id_parcours;
    --on recupere les etapes du parcours
    FOR rec IN
	--SELECT * FROM contraintes.af_get_parcours_etapes_deroulees(id_parcours) AS (id int4, libelle_pour_parcours varchar, libelle_etape  varchar, type int4,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool)
	-- Modif said 17/11/06
	SELECT *,indice AS indic FROM contraintes.af_get_parcours_etapes_deroulees(id_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
	
	LOOP
	    IF rec.type=1 THEN
		FOR rec_p IN
		    --SELECT * FROM contraintes.af_get_parcours_etapes_deroulees(rec.id) AS (id int4, libelle_pour_parcours varchar, libelle_etape  varchar, type int4,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool)
		    -- Modif said 17/11/06
		    SELECT *,indice AS indic FROM contraintes.af_get_parcours_etapes_deroulees_formation_individu($1,$2,rec.id) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
			
		    LOOP
			rec_p.indic:=indice;
			RETURN NEXT rec_p;
			indice:=indice+1;
		    END LOOP;
	    ELSE 
		rec.indic:=indice;
		RETURN NEXT rec;
		indice:=indice+1;
		-- traitement spécial (sous parcours issu d'etape "parcours orienté")
		raise notice 'type=%',rec.type;
		if rec.type=10 then
		    -- test si l'etape a été faite
		    select into rec_resultat * from contraintes.af_get_resultat($1,$2,rec.parcours,rec.id) 
		    as (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
		    if rec_resultat.id is not null then
			raise notice 'rec_resultat.id=%',rec_resultat.id;
		        -- recup sous-parcours 
		        select into sous_parcours * from contraintes.af_get_resultat_parcours_parcours_oriente(rec_resultat.id);
		        
		        for rec_p in 
			    SELECT *,indice AS indic FROM contraintes.af_get_parcours_etapes_deroulees_formation_individu($1,$2,sous_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		        loop
			    rec_p.indic:=indice;
			    RETURN NEXT rec_p;
			    indice:=indice+1;
		        end loop;
		    end if;
		end if;--else
		    
		
	    END IF;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_etapes_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7625 (class 0 OID 0)
-- Dependencies: 1047
-- Name: FUNCTION af_get_formation_etapes_individu(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_etapes_individu(integer, integer) IS 'deroule les etapes d''une formation pour un individu y compris les etapes de sous-parcours issus d''etape parcours oriente
(suivant les resultats de l''individu)';


--
-- TOC entry 1048 (class 1255 OID 2595843)
-- Dependencies: 2983 5
-- Name: af_get_formation_etapes_reelles_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_etapes_reelles_individu(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu
declare
rec record;
begin
    for rec in
	select * from contraintes.af_get_formation_etapes_individu($1,$2)
	as (id int4, libelle_pour_parcours varchar, libelle_etape  varchar,libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool,libelle_type_original varchar, modifiable bool, indice int4)
	where type not in ('9','10') 
	--and obligatoire is true

    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_etapes_reelles_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7627 (class 0 OID 0)
-- Dependencies: 1048
-- Name: FUNCTION af_get_formation_etapes_reelles_individu(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_etapes_reelles_individu(integer, integer) IS 'retour les etapes d''une formation à faire réellement pour un individu';


--
-- TOC entry 1049 (class 1255 OID 2595844)
-- Dependencies: 2983 5
-- Name: af_get_formation_etapes_ressources_avancement_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_etapes_ressources_avancement_individu(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu
declare
rec record;
begin
    for rec in
	select ET.fichier,ET.fichier,ET.espace,E.libelle,ET.section,S.libelle,FI.libelle,
	--select ET.id,ET.fichier_ressource,ET.espace,E.libelle,ET.section,S.libelle,FI.libelle,
	--as(ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,
	--formation int4,type int4,mots_cles text,debut timestamp,fin timestamp,nouveau interval,icone int4) )
	
	$1,FI.type,FM.mots_cles,CAST(NULL AS timestamp),cast(NULL as timestamp),cast(NULL as interval),S.icone
	from (contraintes.fichier FI left outer join contraintes.fichier_metadata FM on (FI.id=FM.id)),
	contraintes.etape_ressource ET,
	contraintes.espace E,
	contraintes.section S 
	where ET.fichier=FI.id
	and ET.espace=E.id 
	and ET.section=S.id
	and ET.id in 
	--and ET.id in 
	(select etape from contraintes.af_get_formation_avancement_individu($1,$2) as 
	(parcours int4, etape int4, formation int4, stagiaire int4, type varchar) where type=7)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_etapes_ressources_avancement_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7629 (class 0 OID 0)
-- Dependencies: 1049
-- Name: FUNCTION af_get_formation_etapes_ressources_avancement_individu(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_etapes_ressources_avancement_individu(integer, integer) IS 'Retourne les ressouces des etapes des parcours faites par l''individu';


--
-- TOC entry 1050 (class 1255 OID 2595845)
-- Dependencies: 2983 5
-- Name: af_get_formation_etapes_series(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_etapes_series(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select fe_id , libelle_alias , libelle, libelle_type_etape,fe_type,  pere , parcours, obligatoire, chrono , fin,libelle_type_original,modifiable
	from 
	contraintes.af_get_formation_etapes_type($1,'4_1%') AS (fe_id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, fe_type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool,indice int4)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_etapes_series(integer) OWNER TO pgsql;

--
-- TOC entry 7631 (class 0 OID 0)
-- Dependencies: 1050
-- Name: FUNCTION af_get_formation_etapes_series(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_etapes_series(integer) IS 'retourne les series d''une formation';


--
-- TOC entry 1051 (class 1255 OID 2595846)
-- Dependencies: 2983 5
-- Name: af_get_formation_etapes_type(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_etapes_type(integer, character varying) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : type
declare
rec record;
begin
    for rec in 
	select * from contraintes.af_get_formation_etapes($1) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool,indice int4)
	where type LIKE $2
    loop 
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_etapes_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 7633 (class 0 OID 0)
-- Dependencies: 1051
-- Name: FUNCTION af_get_formation_etapes_type(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_etapes_type(integer, character varying) IS 'Retourne les etapes d''un type pour une formation';


--
-- TOC entry 1052 (class 1255 OID 2595847)
-- Dependencies: 2983 5
-- Name: af_get_formation_evenement(integer, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_evenement(integer, timestamp without time zone) RETURNS record
    AS $_$-- $1 numero formation
-- $2 date (timestamp)
declare
rec record;
begin
    select into rec formation,libelle,date,duree,modalite,intervention,intervenant,salle 
    from contraintes.evenement where formation=$1 and date=$2;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_evenement(integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 7635 (class 0 OID 0)
-- Dependencies: 1052
-- Name: FUNCTION af_get_formation_evenement(integer, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_evenement(integer, timestamp without time zone) IS 'retourne un evenement d''une formation';


--
-- TOC entry 1053 (class 1255 OID 2595848)
-- Dependencies: 2983 5
-- Name: af_get_formation_evenements(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_evenements(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select * from contraintes.evenement 
	where formation=$1 order by date
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_evenements(integer) OWNER TO pgsql;

--
-- TOC entry 7637 (class 0 OID 0)
-- Dependencies: 1053
-- Name: FUNCTION af_get_formation_evenements(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_evenements(integer) IS 'retourne tous les evenements d''une formation';


--
-- TOC entry 1054 (class 1255 OID 2595849)
-- Dependencies: 2983 5
-- Name: af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) RETURNS SETOF record
    AS $_$-- $1 : numero formation
-- $2 : debut
-- $3 : fin
declare
rec record;
req varchar;
begin
    /*	
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle
	from contraintes.evenement
	where formation=$1
	and date between $2 and $3
    loop
	return next rec;
    end loop;
   */ 

    req:='select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
		from contraintes.evenement where formation='||$1;
    if $2!=$3 then
	req:=req||' and date between '''||$2||''' and '''||$3||'''';
    else
	req:=req||' and date='''||$2||'''';
    end if;

    -- order by
    req:=req||'order by (date + duree)';  
    
    --RAISE NOTICE 'req: %',req;
    for rec in
	execute req
    loop
	return next rec;
    end loop;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 7639 (class 0 OID 0)
-- Dependencies: 1054
-- Name: FUNCTION af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) IS 'retourne les evenements d''une formation pour une periode donnée';


--
-- TOC entry 1055 (class 1255 OID 2595850)
-- Dependencies: 2983 5
-- Name: af_get_formation_evenements_presentiels(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_evenements_presentiels(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
	from contraintes.evenement 
	where formation=$1 and modalite=3
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_evenements_presentiels(integer) OWNER TO pgsql;

--
-- TOC entry 7641 (class 0 OID 0)
-- Dependencies: 1055
-- Name: FUNCTION af_get_formation_evenements_presentiels(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_evenements_presentiels(integer) IS 'retourne les evenements presentiels d''une formation';


--
-- TOC entry 20 (class 1255 OID 2595851)
-- Dependencies: 2150 2983 5
-- Name: af_get_formation_evolution_reelle_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_evolution_reelle_individu(integer, integer) RETURNS evolution
    AS $_$-- $1 : formation
-- $2 : individu
declare 
nb_etapes_reelles_faites integer;
nb_etapes_total integer;
evolution contraintes.evolution;
begin
    -- total
    select count(*) into nb_etapes_total 
    from contraintes.af_get_formation_etapes_reelles_individu($1,$2)
    as(id int4, libelle_pour_parcours varchar, libelle_etape  varchar,libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool,libelle_type_original varchar, modifiable bool, indice int4);
    -- nb etaptes reelles faites
    select count(*) into nb_etapes_reelles_faites 
    from contraintes.resultat
    where formation=$1 and stagiaire=$2 and duree is not null and etape 
    in (select id from contraintes.etape where type not in ('1','9','10'));
    evolution.fait=nb_etapes_reelles_faites;
    evolution.total=nb_etapes_total;
    return evolution; 
    	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_evolution_reelle_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7643 (class 0 OID 0)
-- Dependencies: 20
-- Name: FUNCTION af_get_formation_evolution_reelle_individu(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_evolution_reelle_individu(integer, integer) IS 'retourne le nb d''etapes reelles effectuées et le nombres d''etapes total pour un individu et une formation';


--
-- TOC entry 1844 (class 1255 OID 2595852)
-- Dependencies: 2983 5
-- Name: af_get_formation_exostlc_fichier_rendu(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_exostlc_fichier_rendu(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in 
	select distinct g_id,e.libelle,r.formation,r.parcours from contraintes.af_get_exotlcs() 
	as (g_id int4,g_commentaire varchar,texte varchar,enonce varchar,remarque varchar,type int4),
	contraintes.etape e,
	contraintes.resultat r,contraintes.resultat_exotlc re 
	where g_id=r.etape and g_id=e.id and r.formation=$1 and r.id=re.id and fichier_rendu is not null
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_exostlc_fichier_rendu(integer) OWNER TO pgsql;

--
-- TOC entry 7645 (class 0 OID 0)
-- Dependencies: 1844
-- Name: FUNCTION af_get_formation_exostlc_fichier_rendu(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_exostlc_fichier_rendu(integer) IS 'retourne les exotlc dont le fichier est rendu pour une formation donnee';


--
-- TOC entry 1056 (class 1255 OID 2595853)
-- Dependencies: 2983 5
-- Name: af_get_formation_formateur(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_formateur(integer) RETURNS record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
	
	SELECT INTO rec I.id,  I.nom ||' '|| I.prenom, PF.formation
	FROM contraintes.formation_participants PF, contraintes.fw_individu I
	WHERE formation=$1
	AND PF.formateur=I.id;

	RETURN rec;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_formateur(integer) OWNER TO pgsql;

--
-- TOC entry 1057 (class 1255 OID 2595854)
-- Dependencies: 2983 5
-- Name: af_get_formation_forums(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_forums(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in 
	select id,libelle,description,moderation,moderateur_pwd,fils,messages,upload,theme from contraintes.forum,contraintes.formation_forums 
	where id=forum and formation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_forums(integer) OWNER TO pgsql;

--
-- TOC entry 7648 (class 0 OID 0)
-- Dependencies: 1057
-- Name: FUNCTION af_get_formation_forums(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_forums(integer) IS 'retourne les forums d''une formation';


--
-- TOC entry 1058 (class 1255 OID 2595855)
-- Dependencies: 2983 5
-- Name: af_get_formation_forums_disponibles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_forums_disponibles(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in 
	select id,libelle from contraintes.forum 
	where id not in (select forum from contraintes.formation_forums where formation=$1)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_forums_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 7650 (class 0 OID 0)
-- Dependencies: 1058
-- Name: FUNCTION af_get_formation_forums_disponibles(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_forums_disponibles(integer) IS 'retourne les forums dispo pour une formation';


--
-- TOC entry 1059 (class 1255 OID 2595856)
-- Dependencies: 2983 5
-- Name: af_get_formation_grilles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_grilles(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select distinct id,libelle from 
	contraintes.grille,
	contraintes.grille_resultats gr 
	where gr.formation=$1 and id=gr.grille
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_grilles(integer) OWNER TO pgsql;

--
-- TOC entry 7652 (class 0 OID 0)
-- Dependencies: 1059
-- Name: FUNCTION af_get_formation_grilles(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_grilles(integer) IS 'retourne les grilles presentielles pour une formation';


--
-- TOC entry 1060 (class 1255 OID 2595857)
-- Dependencies: 2983 5
-- Name: af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) RETURNS real
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : parcours
declare
rec record;
rec_resultat record;
id_resultat bigint;
total real;
res real;
nb integer;
begin
    -- boucle sur les series du parcours
    nb:=0;
    total:=0;
    for rec in
	select * from contraintes.af_get_parcours_etapes_type($3,'5') 
	AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool, indice int4)
    loop
	if rec.obligatoire is true then
	    -- recup id resultat
	    select into rec_resultat * from contraintes.af_get_resultat($1,$2,$3,rec.id) 
	    AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	    raise notice 'rec=%',rec_resultat.id;
	    select into res * from contraintes.af_get_resultat_exotlc_moyenne(rec_resultat.id);
	    raise notice 'res=%',res;
	    total:=total+res;
	    nb:=nb+1;
	end if;
    end loop;
    if nb=0 then
	return null;
    else
	return total/nb;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7654 (class 0 OID 0)
-- Dependencies: 1060
-- Name: FUNCTION af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) IS 'retoune la note sur 20 pour les exotlcs d''un parcours (pour un individu,une formation)';


--
-- TOC entry 1061 (class 1255 OID 2595858)
-- Dependencies: 2983 5
-- Name: af_get_formation_individu_parcours_score(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_individu_parcours_score(integer, integer, integer) RETURNS real
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : parcours
declare
score_series real;
score_exotlcs real;
total real;
nb integer;
begin
    nb:=0;
    total:=0;
    select into score_series * from contraintes.af_get_formation_individu_parcours_series_score($1,$2,$3);
    if score_series is not null then
	total:=total+score_series;
	nb:=nb+1;
    end if;
    select into score_exotlcs * from contraintes.af_get_formation_individu_parcours_exotlcs_score($1,$2,$3);
    if score_exotlcs is not null then
	total:=total+score_exotlcs;
	nb:=nb+1;
    end if;
    if nb=0 then
	return false;
    else
	return total/nb;
    end if;
    

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_individu_parcours_score(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7656 (class 0 OID 0)
-- Dependencies: 1061
-- Name: FUNCTION af_get_formation_individu_parcours_score(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_individu_parcours_score(integer, integer, integer) IS 'retourne le score pour un parcours,un individu et une formation';


--
-- TOC entry 1062 (class 1255 OID 2595859)
-- Dependencies: 2983 5
-- Name: af_get_formation_individu_parcours_series_score(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_individu_parcours_series_score(integer, integer, integer) RETURNS real
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : parcours
declare
rec record;
rec_resultat record;
id_resultat bigint;
total real;
res real;
nb integer;
begin
    -- boucle sur les series du parcours
    nb:=0;
    total:=0;
    for rec in
	select * from contraintes.af_get_parcours_etapes_type($3,'4') 
	AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool, indice int4)
    loop
	if rec.type<>'4_1_0_2' and rec.obligatoire is true then
	    -- recup id resultat
	    select into rec_resultat * from contraintes.af_get_resultat($1,$2,$3,rec.id) 
	    AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	    raise notice 'rec=%',rec_resultat.id;
	    select into res * from contraintes.af_get_resultat_serie_score(rec_resultat.id);
	    raise notice 'res=%',res;
	    total:=total+res;
	    nb:=nb+1;
	end if;
    end loop;
    if nb=0 then
	return null;
    else
        return total/nb;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_individu_parcours_series_score(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7658 (class 0 OID 0)
-- Dependencies: 1062
-- Name: FUNCTION af_get_formation_individu_parcours_series_score(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_individu_parcours_series_score(integer, integer, integer) IS 'retoune la note sur 20 pour les series d''un parcours (pour un individu,une formation)';


--
-- TOC entry 1063 (class 1255 OID 2595860)
-- Dependencies: 2983 5
-- Name: af_get_formation_individus(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_individus(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
rec2 record;
begin
    -- Boucle sur les classes de la formation
    for rec in
	select id,libelle,pere,min,max from contraintes.af_get_formation_classes($1)  as (id int4,libelle varchar, pere int4,min int4,max int4)
    loop
	for rec2 in
	    select distinct id,nom,prenom,organisme 
	    from contraintes.af_get_classe_individus(rec.id,0,'asc',false)  
        loop
	    return next rec2;
        end loop;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_individus(integer) OWNER TO pgsql;

--
-- TOC entry 7660 (class 0 OID 0)
-- Dependencies: 1063
-- Name: FUNCTION af_get_formation_individus(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_individus(integer) IS 'retourne les individus d''une formation 
(ceux qui sont dans la classe)';


--
-- TOC entry 1064 (class 1255 OID 2595861)
-- Dependencies: 2983 5
-- Name: af_get_formation_individus(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_individus(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : classe
declare
rec record;
rec2 record;
begin
    -- Boucle sur les classes de la formation
    for rec in
	select id,libelle,pere,min,max from contraintes.af_get_formation_classes($1)
    loop
	for rec2 in
	    select distinct id,nom,prenom,organisme 
	    from contraintes.af_get_classe_individus(rec.id,0,'asc',false) 
        loop
	    return next rec2;
        end loop;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_individus(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1065 (class 1255 OID 2595862)
-- Dependencies: 2983 5
-- Name: af_get_formation_individus_except_individus_types(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_individus_except_individus_types(integer, integer[]) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : types d'individus à exclure
declare
rec record;
rec2 record;
begin
    -- Boucle sur les classes de la formation
    for rec in
	select id,libelle,pere,min,max from contraintes.af_get_formation_classes($1)  as (id int4,libelle varchar, pere int4,min int4,max int4)
    loop
	for rec2 in
	    select distinct id,nom,prenom,organisme 
	    from contraintes.af_get_classe_individus_except_individus_types(rec.id,$2,'asc',false)
	    --from contraintes.af_get_classe_individus_except_individus_types(rec.id,$2,'asc',true) 
	    	
        loop
	    return next rec2;
        end loop;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_individus_except_individus_types(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 7663 (class 0 OID 0)
-- Dependencies: 1065
-- Name: FUNCTION af_get_formation_individus_except_individus_types(integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_individus_except_individus_types(integer, integer[]) IS 'retourne les individus d''une formation 
(ceux qui sont dans les classes) et qui ne sont pas de certains types';


--
-- TOC entry 1066 (class 1255 OID 2595863)
-- Dependencies: 2983 5
-- Name: af_get_formation_intervenants(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_intervenants(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select distinct id,nom,prenom from contraintes.fw_individu i ,contraintes.evenement 
	where id=intervenant and formation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_intervenants(integer) OWNER TO pgsql;

--
-- TOC entry 7665 (class 0 OID 0)
-- Dependencies: 1066
-- Name: FUNCTION af_get_formation_intervenants(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_intervenants(integer) IS 'retourne les intervenants de la formation';


--
-- TOC entry 1067 (class 1255 OID 2595864)
-- Dependencies: 2983 5
-- Name: af_get_formation_langues(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_langues(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, libelle , code , locale , formation 
		FROM contraintes.formation_langues, contraintes.af_get_langues() AS (id int4,libelle varchar, code varchar, locale varchar) 
		WHERE formation=$1
		AND langue=id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_langues(integer) OWNER TO pgsql;

--
-- TOC entry 1068 (class 1255 OID 2595865)
-- Dependencies: 2983 5
-- Name: af_get_formation_parcourss_ressources(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_parcourss_ressources(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
rec_etape record;
rec_ress record;
begin
    -- Boucle sur les etapes ressources de la formation
    for rec in
	select * from contraintes.af_get_formation_etapes_type($1,'7') 
	as (id int4, libelle_pour_parcours varchar, libelle_etape  varchar,libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool,libelle_type_original varchar, modifiable bool,indice int4)
    loop
	-- Filtre sur espace,section et ressource
	select into rec_etape * from contraintes.af_get_etape_ressource(rec.id) 
	as (id int4,libelle varchar,espace int4, section int4, ressource int4, fichier int4,mots_cles text,date_creation timestamp);
	raise notice 'esp=% section=% ress=%',rec_etape.espace,rec_etape.section,rec_etape.ressource;
	if rec_etape.espace is not null and rec_etape.section is not null and rec_etape.ressource is not null then
	    for rec_ress in 
	        select * from contraintes.af_get_etape_ressource_infos(rec_etape.espace,rec_etape.section,rec_etape.ressource) 
		as(r_ressource int4,r_fichier int4,r_espace int4,r_libelle_espace varchar,r_section int4,r_libelle_section varchar,r_titre varchar,r_formation int4,r_type int4,r_mots_cles text,r_debut timestamp,r_fin timestamp,r_nouveau interval,r_icone int4)
	    loop
		--raise notice 'ress=% fic=%'rec_ress.r_ressource,rec_ress.r_fichier;
		return next rec_ress;
	    end loop;
	end if;

    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_parcourss_ressources(integer) OWNER TO pgsql;

--
-- TOC entry 7668 (class 0 OID 0)
-- Dependencies: 1068
-- Name: FUNCTION af_get_formation_parcourss_ressources(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_parcourss_ressources(integer) IS 'retourne les ressources (affichables) des parcours d''ine formation';


--
-- TOC entry 1845 (class 1255 OID 2595866)
-- Dependencies: 2983 5
-- Name: af_get_formation_participants(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_participants(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
	FOR rec IN
		SELECT formation, formateur, classe
		FROM contraintes.formation_participants
		WHERE formation=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_participants(integer) OWNER TO pgsql;

--
-- TOC entry 1069 (class 1255 OID 2595867)
-- Dependencies: 2983 5
-- Name: af_get_formation_ressource(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_ressource(integer, integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : espace
-- $3 : section
-- $4 : fichier_ressource
declare
rec record;
begin
    select into rec * FROM
	contraintes.af_get_formation_ressources($1,TRUE) 
	as(fichier_ressource int4,fichier_ressource_bis int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut timestamp,fin timestamp,nouveau interval,icone int4)
	WHERE 
	formation=$1 and espace=$2 and (section=$3 or section is null) and fichier_ressource=$4;  

	return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_ressource(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7671 (class 0 OID 0)
-- Dependencies: 1069
-- Name: FUNCTION af_get_formation_ressource(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_ressource(integer, integer, integer, integer) IS 'retourne les info d''une ressource de formation';


--
-- TOC entry 1070 (class 1255 OID 2595868)
-- Dependencies: 2983 5
-- Name: af_get_formation_ressource_nouveaute(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_ressource_nouveaute(integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 = numero de formation
--$2 = numero d'espace
--$3 = numero de section
--$4 = numero de ressource
rec record;
date_total TIMESTAMP;
BEGIN
	FOR rec IN
	select *  
	from contraintes.af_get_formation_ressource($1,$2,$3,$4) 
	as(ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut timestamp,fin timestamp,nouveau interval,icone int4) 
	LOOP
		date_total:= rec.debut + rec.nouveau;
		IF date_total >= now() THEN
			return true;
		END IF;
	END LOOP;
	return false;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_ressource_nouveaute(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7673 (class 0 OID 0)
-- Dependencies: 1070
-- Name: FUNCTION af_get_formation_ressource_nouveaute(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_ressource_nouveaute(integer, integer, integer, integer) IS 'Fonction qui retourne un boolean pour une ressource, cela confirm si elle est nouvelle ou non.';


--
-- TOC entry 1071 (class 1255 OID 2595869)
-- Dependencies: 2983 5
-- Name: af_get_formation_ressources(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_ressources(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
    FOR rec IN
	SELECT FR.fichier_ressource,FR.fichier_ressource,FR.espace,E.libelle, FR.section,S.libelle,FI.libelle,FR.formation,FI.type,FM.mots_cles, FR.debut_disponibilite, FR.fin_disponibilite, FR.duree_nouveaute,S.icone
	FROM 
	((contraintes.fichier FI LEFT OUTER JOIN contraintes.fichier_metadata FM 
	ON (FI.id=FM.id))inner join 
	contraintes.formation_ressources FR on (FR.fichier_ressource=FI.id )inner join  
	contraintes.espace E on (FR.espace=E.id )) 
	left outer join contraintes.section S on (FR.section=S.id )  
	WHERE 
	FR.formation=$1 
	
	
		
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_ressources(integer) OWNER TO pgsql;

--
-- TOC entry 1846 (class 1255 OID 2595870)
-- Dependencies: 2983 5
-- Name: af_get_formation_ressources(integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_ressources(integer, boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 formations
--$2 booléen, si true retourne toutes les ressources indépendament de leurs dates, si false, retourne uniquement les ressources dont les dates sont ok
rec RECORD;
BEGIN

	IF $2 IS TRUE THEN 
		FOR rec IN
			select * from contraintes.af_get_formation_ressources($1) 
			as(ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut_disponibilite timestamp,fin_disponibilite timestamp,nouveau interval,icone int4)
		LOOP
			RETURN NEXT rec;
		END LOOP;
	ELSE
		FOR rec IN
			select * from contraintes.af_get_formation_ressources($1) 
			as(ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut_disponibilite timestamp,fin_disponibilite timestamp,nouveau interval,icone int4)
			WHERE now() BETWEEN debut_disponibilite AND (fin_disponibilite + '1 day')
		LOOP
			RETURN NEXT rec;
		END LOOP;
	END IF;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_ressources(integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1072 (class 1255 OID 2595871)
-- Dependencies: 2983 5
-- Name: af_get_formation_ressources_nouveaute(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_ressources_nouveaute(integer) RETURNS boolean
    AS $_$DECLARE
--$1 = numero de formation
rec record;
date_total TIMESTAMP;
BEGIN
	FOR rec IN
	select *  
	from contraintes.af_get_formation_ressources($1,FALSE) 
	as(ressource int4,fichier int4,espace int4,libelle_espace varchar,section int4,libelle_section varchar,titre varchar,formation int4,type int4,mots_cles text,debut timestamp,fin timestamp,nouveau interval,icone int4) 
	LOOP
		date_total:= rec.debut + rec.nouveau;
		IF date_total >= now() THEN
			return true;
		END IF;
	END LOOP;
	return false;

END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_ressources_nouveaute(integer) OWNER TO pgsql;

--
-- TOC entry 7677 (class 0 OID 0)
-- Dependencies: 1072
-- Name: FUNCTION af_get_formation_ressources_nouveaute(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_ressources_nouveaute(integer) IS 'Fonction qui retourne true ou false si une des ressources est nouvelle.';


--
-- TOC entry 1073 (class 1255 OID 2595872)
-- Dependencies: 2983 5
-- Name: af_get_formation_salles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_salles(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare 
rec record;
begin
    for rec in
	select distinct s_id,s_libelle from contraintes.af_get_salles() as (s_id int4,s_libelle varchar),contraintes.evenement 
	where s_id=salle and formation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_salles(integer) OWNER TO pgsql;

--
-- TOC entry 7679 (class 0 OID 0)
-- Dependencies: 1073
-- Name: FUNCTION af_get_formation_salles(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_salles(integer) IS 'retourne les salles de la formation';


--
-- TOC entry 1074 (class 1255 OID 2595873)
-- Dependencies: 2983 5
-- Name: af_get_formation_sections(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_sections(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
    FOR rec IN
	SELECT FR.espace,E.libelle, FR.section,S.libelle,S.icone,FR.formation
	FROM 
	contraintes.formation_ressources FR,
	contraintes.espace E,
	contraintes.section S
	WHERE 
	FR.formation=$1 
	and FR.espace=E.id 
	and FR.section=S.id 
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_sections(integer) OWNER TO pgsql;

--
-- TOC entry 1075 (class 1255 OID 2595874)
-- Dependencies: 2983 5
-- Name: af_get_formation_session(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_session(integer) RETURNS record
    AS $_$-- $1 : formation
declare
rec record;
begin
    select into rec * from contraintes.formation_session where formation=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_session(integer) OWNER TO pgsql;

--
-- TOC entry 7682 (class 0 OID 0)
-- Dependencies: 1075
-- Name: FUNCTION af_get_formation_session(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_session(integer) IS 'retourne les temps d''inactivité et de session pour une formation';


--
-- TOC entry 1076 (class 1255 OID 2595875)
-- Dependencies: 2983 5
-- Name: af_get_formation_stagiaires_correction(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formation_stagiaires_correction(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : exotlc
-- $3 : classe
declare
rec record;
begin
    for rec in 
	select id,stagiaires_non_corriges.nom,stagiaires_non_corriges.prenom,date_correction
	from
	--(
	    --(
		(
		select ci1.id,nom,prenom 
		from contraintes.af_get_classe_individus($3,0,'asc',false) ci1 
		) as stagiaires_non_corriges 
		
		left outer join
		(
		select ci2.id,nom,prenom,date_correction 
		from contraintes.af_get_classe_individus($3,0,'asc',false) ci2,
		contraintes.resultat r,contraintes.resultat_exotlc re 
		where r.formation=$1 and r.etape=$2 and r.id=re.id and ci2.id=r.stagiaire
		) as stagiaires_corriges 
		using (id)
		
	    --)
	--)
	
		
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formation_stagiaires_correction(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7684 (class 0 OID 0)
-- Dependencies: 1076
-- Name: FUNCTION af_get_formation_stagiaires_correction(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formation_stagiaires_correction(integer, integer, integer) IS 'retourne les stagiaires de la formation et leur etat de correction';


--
-- TOC entry 1077 (class 1255 OID 2595876)
-- Dependencies: 2983 5
-- Name: af_get_formations(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formations() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,parcours,date_debut,date_fin,langue,ressources_fusionnees from contraintes.formation
    loop
    return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formations() OWNER TO pgsql;

--
-- TOC entry 7686 (class 0 OID 0)
-- Dependencies: 1077
-- Name: FUNCTION af_get_formations(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formations() IS 'retourne toutes les formations de la plateforme';


--
-- TOC entry 1078 (class 1255 OID 2595877)
-- Dependencies: 2983 5
-- Name: af_get_formations(character varying, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formations(character varying, character varying, integer) RETURNS SETOF record
    AS $_$-- $1 ordre de classement ('asc' ou 'desc')
-- $2 'libelle' ou 'date_debut' (order by)
-- $3 période (1 : passées, 2 : présentes, 3 : futures, 0 toutes)
declare
rec record;
req varchar;
condition_periode varchar;
begin
    -- traitement periode
    if $3=1 then
	condition_periode:='  date_fin<current_date ';
    else
	if $3=2 then
	    condition_periode:='  not(date_debut>current_date or date_fin<current_date) ';
	else
	    if $3=3 then
		condition_periode:='  date_debut>current_date ';
	    end if;
	end if;
    end if;
    req:='select id,libelle,parcours,date_debut,date_fin,langue,ressources_fusionnees from contraintes.af_get_formations() as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4,ressources_fusionnees bool)';
    if $3 !=0 then
	req:=req || 'where '||condition_periode;
    end if;
    req:=req || 'order by '||$2||' '||$1;
    raise notice 'req=%',req;
    for rec in 
	execute req
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formations(character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 7688 (class 0 OID 0)
-- Dependencies: 1078
-- Name: FUNCTION af_get_formations(character varying, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formations(character varying, character varying, integer) IS 'retourne les formations (avec critères de classement)';


--
-- TOC entry 1079 (class 1255 OID 2595878)
-- Dependencies: 2983 5
-- Name: af_get_formations_classes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formations_classes() RETURNS SETOF record
    AS $$declare
rec record;
begin
	FOR rec IN 
	    select id,libelle,pere,min,max, ft.formation 
	    from contraintes.af_get_classes() as(id int4,libelle varchar, pere int4,min int4,max int4) ,
	    contraintes.formation_participants ft 
	    where  ft.classe=id
	    ORDER BY formation
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
end$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formations_classes() OWNER TO pgsql;

--
-- TOC entry 7690 (class 0 OID 0)
-- Dependencies: 1079
-- Name: FUNCTION af_get_formations_classes(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formations_classes() IS 'retourne les classes des formations';


--
-- TOC entry 1080 (class 1255 OID 2595879)
-- Dependencies: 2983 5
-- Name: af_get_formations_dates(date, date, boolean, boolean, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formations_dates(date, date, boolean, boolean, boolean) RETURNS SETOF record
    AS $_$-- $1 : date debut
-- $2 : date fin
-- $3 : -> les formations commençant et finissant dans l'intervalle [debut - fin]
-- $4 : -> les formations commençant dans l'intervalle [debut - fin]
-- $5 : -> les formations finissant dans l'intervalle [debut - fin]
declare
rec record;
req varchar;

begin
    req:='select * from contraintes.af_get_formations() as (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4,ressources_fusionnees bool )';
    if $3 or $4 or $5 then
	req:=req ||' where ';
	if $3 then
	    req:=req || ' (date_debut >='''||$1||''' and date_fin <='''||$2||''')'; 
	end if;
	if $4 then
	    if $3 then
		req:=req ||' or (date_debut>='''||$1||''' and date_debut<='''||$2||''')';
	    else
		req:=req ||' (date_debut>='''||$1||''' and date_debut<='''||$2||''')';
	    end if;
	end if;
	if $5 then
	    if $3 or $4 then
		req:=req ||' or (date_fin>='''||$1||''' and date_fin<='''||$2||''')';
	    else
		req:=req ||'  (date_fin>='''||$1||''' and date_fin<='''||$2||''')';
	    end if;
	end if;
    end if;
    
    raise notice 'req=%',req;
    for rec in 
	execute req
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formations_dates(date, date, boolean, boolean, boolean) OWNER TO pgsql;

--
-- TOC entry 7692 (class 0 OID 0)
-- Dependencies: 1080
-- Name: FUNCTION af_get_formations_dates(date, date, boolean, boolean, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formations_dates(date, date, boolean, boolean, boolean) IS 'retourne les formations en fonction des dates de debut et fin';


--
-- TOC entry 1847 (class 1255 OID 2595880)
-- Dependencies: 2983 5
-- Name: af_get_formations_dates_bornes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formations_dates_bornes() RETURNS record
    AS $$DECLARE
rec RECORD;

BEGIN
	SELECT INTO rec MIN(F1.date_debut) AS premier, MAX(F2.date_fin) AS dernier
	FROM contraintes.formation F1, contraintes.formation F2;

	RETURN rec;
 
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formations_dates_bornes() OWNER TO pgsql;

--
-- TOC entry 1848 (class 1255 OID 2595881)
-- Dependencies: 2983 5
-- Name: af_get_formations_exotlcs_corriges(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formations_exotlcs_corriges() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select id,libelle from contraintes.af_get_formations() 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4),
	contraintes.formation_participants fp,
	contraintes.af_get_classes_exotlcs_corriges() as (c_id int4,c_libelle varchar) 
	where id=fp.formation and fp.classe=c_id
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formations_exotlcs_corriges() OWNER TO pgsql;

--
-- TOC entry 7695 (class 0 OID 0)
-- Dependencies: 1848
-- Name: FUNCTION af_get_formations_exotlcs_corriges(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formations_exotlcs_corriges() IS 'retourne les formations qui ont des exotlcs corriges';


--
-- TOC entry 1081 (class 1255 OID 2595882)
-- Dependencies: 2983 5
-- Name: af_get_formations_fichier_rendu(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formations_fichier_rendu() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct f_id,libelle from contraintes.af_get_formations() 
	as (f_id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4),
	contraintes.resultat r,contraintes.resultat_exotlc re 
	where f_id=r.formation and re.id=r.id and fichier_rendu is not null
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formations_fichier_rendu() OWNER TO pgsql;

--
-- TOC entry 7697 (class 0 OID 0)
-- Dependencies: 1081
-- Name: FUNCTION af_get_formations_fichier_rendu(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formations_fichier_rendu() IS 'retourne les formations qui ont des fichier rendu';


--
-- TOC entry 1082 (class 1255 OID 2595883)
-- Dependencies: 2983 5
-- Name: af_get_formations_forums(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formations_forums(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;
begin
    if contraintes.fw_is_root($1) then
    for rec in 
	select fi.id,fi.libelle,fu.id,fu.libelle 
	from contraintes.formation fi,contraintes.forum fu,contraintes.formation_forums 
	where fi.id=formation and fu.id=forum
    loop
	return next rec;
    end loop;
    else
    for rec in 
	select fi.id,fi.libelle,fu.id,fu.libelle 
	from contraintes.formation fi,contraintes.forum fu,contraintes.formation_forums ff,contraintes.formation_participants fp 
	where fi.id=ff.formation and fu.id=forum and fi.id=fp.formation and fp.formateur=$1
    loop
	return next rec;
    end loop;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formations_forums(integer) OWNER TO pgsql;

--
-- TOC entry 7699 (class 0 OID 0)
-- Dependencies: 1082
-- Name: FUNCTION af_get_formations_forums(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formations_forums(integer) IS 'retourne les associations formations/forums de la plateforme pour le root ou formateur';


--
-- TOC entry 1083 (class 1255 OID 2595884)
-- Dependencies: 2983 5
-- Name: af_get_formations_presentielles(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_formations_presentielles() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select distinct id, f.libelle, parcours, date_debut, date_fin, langue 
	from contraintes.formation f,contraintes.evenement 
	where id=formation and modalite=3
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_formations_presentielles() OWNER TO pgsql;

--
-- TOC entry 7701 (class 0 OID 0)
-- Dependencies: 1083
-- Name: FUNCTION af_get_formations_presentielles(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_formations_presentielles() IS 'retourne les formations ayants du presentiel';


--
-- TOC entry 1084 (class 1255 OID 2595885)
-- Dependencies: 2983 5
-- Name: af_get_forum(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_forum(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec * from contraintes.forum where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_forum(integer) OWNER TO pgsql;

--
-- TOC entry 7703 (class 0 OID 0)
-- Dependencies: 1084
-- Name: FUNCTION af_get_forum(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_forum(integer) IS 'retourne les donnees d''un forum';


--
-- TOC entry 21 (class 1255 OID 2595886)
-- Dependencies: 2983 5
-- Name: af_get_forum_environnement(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_forum_environnement(integer) RETURNS record
    AS $_$-- $1 : forum
declare
rec record;
begin
    select into rec * from contraintes.af_get_forum_environnements() 
    as (id int4,libelle varchar,chemin varchar,db_type varchar,db_serveur varchar,db_name varchar,db_user varchar,db_pwd varchar,
		admin varchar,admin_pwd varchar,email_valide bool,email_verification bool,interpretation_html bool,citation bool,noms_longs bool,
		taille_pj int4,lignes int4,block_ip bool,compte_vus bool,fils_fermes bool,affiche_fils bool,encodage varchar)
    where id =$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_forum_environnement(integer) OWNER TO pgsql;

--
-- TOC entry 1085 (class 1255 OID 2595887)
-- Dependencies: 2983 5
-- Name: af_get_forum_environnements(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_forum_environnements() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select * from contraintes.forum_environnement
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_forum_environnements() OWNER TO pgsql;

--
-- TOC entry 7706 (class 0 OID 0)
-- Dependencies: 1085
-- Name: FUNCTION af_get_forum_environnements(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_forum_environnements() IS 'retourne les configurations pour les forums';


--
-- TOC entry 1086 (class 1255 OID 2595888)
-- Dependencies: 2983 5
-- Name: af_get_forum_forum_environnement(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_forum_forum_environnement(integer) RETURNS record
    AS $_$-- $1 : forum
declare
rec record;
begin
    select into rec * from contraintes.af_get_forum_environnements() 
    as (id int4,libelle varchar,chemin varchar,db_type varchar,db_serveur varchar,db_name varchar,db_user varchar,db_pwd varchar,
		admin varchar,admin_pwd varchar,email_valide bool,email_verification bool,interpretation_html bool,citation bool,noms_longs bool,
		taille_pj int4,lignes int4,block_ip bool,compte_vus bool,fils_fermes bool,affiche_fils bool,encodage varchar)
    where id in (select environnement from contraintes.forum_environnements where forum=$1);
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_forum_forum_environnement(integer) OWNER TO pgsql;

--
-- TOC entry 7708 (class 0 OID 0)
-- Dependencies: 1086
-- Name: FUNCTION af_get_forum_forum_environnement(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_forum_forum_environnement(integer) IS 'retourne les données d''un environnement de forum';


--
-- TOC entry 1087 (class 1255 OID 2595889)
-- Dependencies: 2983 5
-- Name: af_get_forums(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_forums() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select * from contraintes.forum
    loop
	return next rec;
    end loop;
	
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_forums() OWNER TO pgsql;

--
-- TOC entry 7710 (class 0 OID 0)
-- Dependencies: 1087
-- Name: FUNCTION af_get_forums(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_forums() IS 'retourne les forrum de la plateforme';


--
-- TOC entry 1088 (class 1255 OID 2595890)
-- Dependencies: 2983 5
-- Name: af_get_ftb(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_ftb(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec E.id,E.libelle,text,voir_mots,interpretation_html, date_creation
    from contraintes.ftb F, contraintes.evaluation E
    where E.id=$1
    and F.id=E.id;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_ftb(integer) OWNER TO pgsql;

--
-- TOC entry 7712 (class 0 OID 0)
-- Dependencies: 1088
-- Name: FUNCTION af_get_ftb(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_ftb(integer) IS 'retourne les infos d''un ftb(remplir les blancs)';


--
-- TOC entry 1849 (class 1255 OID 2595891)
-- Dependencies: 2983 5
-- Name: af_get_ftb_liste_mot(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_ftb_liste_mot(integer, integer) RETURNS text[]
    AS $_$-- $1 : le ftb
-- $2 : la langue
declare
rec text[];
rec_ftb record;
mot_courant text;
texte text;
texte_ams text;
lettre char;
lettre_suivante char;
longueur_texte integer;
i integer;
j integer;
k integer;
begin
    -- recupere le texte du blanc
    select into rec_ftb * from contraintes.af_get_ftb($1) as (id int4, libelle varchar,text text,voir_mots bool,interpretation_html bool, date_creation timestamp);
    texte_ams:=rec_ftb.text;
    raise notice '$2=%',$2;
    if $2 is not null then
        texte:=substring(texte_ams from '##AMS'||$2||'##{"(.*?)"}');
    end if;
    if texte is null then
	texte:=texte_ams;
    end if;	
    raise notice 't=%',texte;
    longueur_texte:=char_length(texte);
	
    -- boucle sur le texte
    i:=1;
    k:=1;
    mot_courant:='';
    while i < longueur_texte
    loop
	if (substring(texte from i for 1))='[' then
	    i:=i+1;
	    if (substring(texte from i for 1))=':' then
		-- debut d'un mot
		
		i:=i+1;
		lettre:=substring(texte from i for 1);
		--raise notice 'lettre=%',lettre;
		mot_courant:=mot_courant || lettre;
		-- boucle jusqu'à ':]'
		i:=i+1;
		lettre:=substring(texte from i for 1);
		j:=i+1;
		lettre_suivante:=substring(texte from j for 1);
		while (lettre!=':' and lettre_suivante!=']')
		loop
		    mot_courant:=mot_courant || lettre;
		    i:=i+1;
		lettre:=substring(texte from i for 1);
		j:=i+1;
		lettre_suivante:=substring(texte from j for 1);
		end loop;
		-- stocke le mot
		rec[k]:=mot_courant;
		--raise notice 'mot_courant=%',mot_courant;
		--rec[k]:='toto';
		k:=k+1;
		mot_courant:='';
	    else
		i:=i+1;
	    end if;
	else
	    i:=i+1;
	end if;
	
    end loop;
	
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_ftb_liste_mot(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7714 (class 0 OID 0)
-- Dependencies: 1849
-- Name: FUNCTION af_get_ftb_liste_mot(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_ftb_liste_mot(integer, integer) IS 'retourne la liste des mots d''un ftb';


--
-- TOC entry 22 (class 1255 OID 2595892)
-- Dependencies: 2983 5
-- Name: af_get_glossaire(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_glossaire(integer) RETURNS record
    AS $_$-- $1 : glossaire
declare
rec record;
begin
    select into rec id,libelle from contraintes.glossaire where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_glossaire(integer) OWNER TO postgres;

--
-- TOC entry 7716 (class 0 OID 0)
-- Dependencies: 22
-- Name: FUNCTION af_get_glossaire(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_glossaire(integer) IS 'retourne info d''un glossaire';


--
-- TOC entry 1089 (class 1255 OID 2595893)
-- Dependencies: 2983 5
-- Name: af_get_glossaire_fichier(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_glossaire_fichier(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du fichier
glossaire_id int4;
BEGIN

	SELECT INTO glossaire_id id FROM contraintes.glossaire
	WHERE fichier=$1;

	RETURN glossaire_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_glossaire_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 7718 (class 0 OID 0)
-- Dependencies: 1089
-- Name: FUNCTION af_get_glossaire_fichier(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_glossaire_fichier(integer) IS 'Obtenir un glossaire à partir de son numero de fichier.
';


--
-- TOC entry 23 (class 1255 OID 2595894)
-- Dependencies: 2983 5
-- Name: af_get_glossaire_fichiers(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_glossaire_fichiers(integer) RETURNS SETOF record
    AS $_$-- $1 : glossaire
declare
rec record;
begin
    for rec in 
	select f.id,f.libelle,f.type,f.connecte from contraintes.fichier f where id in
	(select fichier from contraintes.glossaire_fichiers where id=$1)
    loop
	return next rec;
    end loop;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_glossaire_fichiers(integer) OWNER TO pgsql;

--
-- TOC entry 7720 (class 0 OID 0)
-- Dependencies: 23
-- Name: FUNCTION af_get_glossaire_fichiers(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_glossaire_fichiers(integer) IS 'retourne les fichier mots cles d''un glossaire';


--
-- TOC entry 1850 (class 1255 OID 2595895)
-- Dependencies: 2983 5
-- Name: af_get_grille(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_grille(integer) RETURNS record
    AS $_$-- $1 : numero grille
declare
rec record;
begin
    select into rec id,libelle from contraintes.grille where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_grille(integer) OWNER TO pgsql;

--
-- TOC entry 7722 (class 0 OID 0)
-- Dependencies: 1850
-- Name: FUNCTION af_get_grille(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_grille(integer) IS 'retourne les infos d''une grille';


--
-- TOC entry 1090 (class 1255 OID 2595896)
-- Dependencies: 2983 5
-- Name: af_get_grille_capacite_titre_themes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_grille_capacite_titre_themes(integer) RETURNS SETOF record
    AS $_$declare 
rec record;
begin
    if contraintes.fw_is_root($1) then
    for rec in 
	select distinct t.id,t.libelle from
	(contraintes.theme t
	left outer join
	--(contraintes.af_get_categorie_themes(11) as (ct_id int4,ct_libelle varchar)
	contraintes.categorie_grille cg
	on t.id=cg.theme
	left outer join 
	contraintes.grille_capacites_titres gtc
	on gtc.grille=cg.id)
	where cg.theme is not null and gtc.grille is not null 
	
	
	
     loop
	return next rec;
     end loop;
    else
    for rec in 
	select distinct t.id,t.libelle from
	(contraintes.theme t
	left outer join
	--(contraintes.af_get_categorie_themes(11) as (ct_id int4,ct_libelle varchar)
	contraintes.categorie_grille cg
	on (t.id=cg.theme  and ( t.individu=$1 OR t.individu IS NULL) ) 
	left outer join 
	contraintes.grille_capacites_titres gtc
	on gtc.grille=cg.id)
	where cg.theme is not null and gtc.grille is not null 
	
	
	
     loop
	return next rec;
     end loop;
    end if;
     return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_grille_capacite_titre_themes(integer) OWNER TO pgsql;

--
-- TOC entry 7724 (class 0 OID 0)
-- Dependencies: 1090
-- Name: FUNCTION af_get_grille_capacite_titre_themes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_grille_capacite_titre_themes(integer) IS 'retourne les themes des couples grille / capacite_titre pour un individu';


--
-- TOC entry 1091 (class 1255 OID 2595897)
-- Dependencies: 2983 5
-- Name: af_get_grille_capacites_titres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_grille_capacites_titres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero grille
declare
rec record;
begin
    for rec in 
	select ct.id,ct.libelle,gct.grille from contraintes.capacite_titre ct,contraintes.grille_capacites_titres gct 
	where gct.grille=$1 and ct.id=gct.capacite_titre
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_grille_capacites_titres(integer) OWNER TO pgsql;

--
-- TOC entry 7726 (class 0 OID 0)
-- Dependencies: 1091
-- Name: FUNCTION af_get_grille_capacites_titres(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_grille_capacites_titres(integer) IS 'retourne les titres de capacite pour une grille';


--
-- TOC entry 1092 (class 1255 OID 2595898)
-- Dependencies: 2983 5
-- Name: af_get_grille_capacites_titres_disponibles(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_grille_capacites_titres_disponibles(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero grille
-- $2 : numero theme
declare 
rec record;
begin
    for rec in 
	select distinct ct.id,ct.libelle,$1 as grille from 
	
	(contraintes.capacite_titre ct
	left outer join
	contraintes.capacite_titre_capacites ctc
	on ct.id=ctc.capacite_titre) ,
	
	
	
	(contraintes.capacite_titre c
	left outer join
	contraintes.grille_capacites_titres gct
	on c.id=gct.capacite_titre and gct.grille=$1) ,
	contraintes.af_get_categorie_elements_theme(11,$2) et
	where gct.capacite_titre is null and ctc.capacite_titre is not null and ct.id=et
	and ct.id=c.id

    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_grille_capacites_titres_disponibles(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7728 (class 0 OID 0)
-- Dependencies: 1092
-- Name: FUNCTION af_get_grille_capacites_titres_disponibles(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_grille_capacites_titres_disponibles(integer, integer) IS 'retourne tous les capacites_titres disponibles pour une grille et un theme
(les titres d''un meme themes non associés à la grille)';


--
-- TOC entry 1093 (class 1255 OID 2595899)
-- Dependencies: 2983 5
-- Name: af_get_grille_stagiaires_formation(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_grille_stagiaires_formation(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : grille
-- $2 : formation
declare
rec record;
begin
    for rec in 
	select distinct id,nom,prenom from 
	contraintes.fw_individu,
	contraintes.stagiaire_grille sg 
	where id=sg.stagiaire and sg.formation=$2 and sg.grille=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_grille_stagiaires_formation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7730 (class 0 OID 0)
-- Dependencies: 1093
-- Name: FUNCTION af_get_grille_stagiaires_formation(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_grille_stagiaires_formation(integer, integer) IS 'retourne les stagiaires de la table stagiaire_grille pour une grille et une formation';


--
-- TOC entry 1094 (class 1255 OID 2595900)
-- Dependencies: 2983 5
-- Name: af_get_icones(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_icones() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select f.id,f.libelle from contraintes.fichier f,contraintes.fichier_icone fi
	where f.id=fi.id
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_icones() OWNER TO pgsql;

--
-- TOC entry 7732 (class 0 OID 0)
-- Dependencies: 1094
-- Name: FUNCTION af_get_icones(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_icones() IS 'retourne les icones de la plateforme';


--
-- TOC entry 1095 (class 1255 OID 2595901)
-- Dependencies: 2983 5
-- Name: af_get_individu(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec id, identifiant_md5 ,login ,password ,nom ,prenom ,adresse ,code ,ville ,
		email ,tel_fixe ,tel_port ,langue,organisme ,photo  from contraintes.fw_individu where id=$1;
    return rec;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu(integer) OWNER TO pgsql;

--
-- TOC entry 7734 (class 0 OID 0)
-- Dependencies: 1095
-- Name: FUNCTION af_get_individu(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu(integer) IS 'retourne les in infos d''un individu';


--
-- TOC entry 1096 (class 1255 OID 2595902)
-- Dependencies: 2983 5
-- Name: af_get_individu(character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu(character varying, character varying) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec id , identifiant_md5 ,login , password, nom , prenom , adresse , code , ville ,email , tel_fixe , tel_port , langue , organisme, photo FROM contraintes.fw_individu
	WHERE login LIKE $1
	AND password LIKE $2;
	
	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu(character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 1097 (class 1255 OID 2595903)
-- Dependencies: 2983 5
-- Name: af_get_individu_classes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_classes(integer) RETURNS SETOF record
    AS $_$-- $1 : numero individu
declare
rec record;
begin
    for rec in 
	select id,libelle,pere,min,max from contraintes.af_get_classes() as (id int4,libelle varchar,pere int4,min int4,max int4),
	contraintes.classe_individus CI 
	where id=CI.classe and CI.individu=$1 
	ORDER BY libelle
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_classes(integer) OWNER TO pgsql;

--
-- TOC entry 7737 (class 0 OID 0)
-- Dependencies: 1097
-- Name: FUNCTION af_get_individu_classes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_classes(integer) IS 'retourne les classes d''un individu';


--
-- TOC entry 1098 (class 1255 OID 2595904)
-- Dependencies: 2983 5
-- Name: af_get_individu_date_connexion_max(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_date_connexion_max(integer) RETURNS record
    AS $_$-- $1 : individu
declare
rec record;
begin
    select into rec max(connexion) from contraintes.connexion where individu=$1;
    return rec;    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_date_connexion_max(integer) OWNER TO pgsql;

--
-- TOC entry 7739 (class 0 OID 0)
-- Dependencies: 1098
-- Name: FUNCTION af_get_individu_date_connexion_max(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_date_connexion_max(integer) IS 'retourne la date de connexion max pour un individu';


--
-- TOC entry 1099 (class 1255 OID 2595905)
-- Dependencies: 2983 5
-- Name: af_get_individu_date_deconnexion_max(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_date_deconnexion_max(integer) RETURNS record
    AS $_$-- $1 : individu
declare
rec record;
begin
    select into rec max(deconnexion) from contraintes.connexion where individu=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_date_deconnexion_max(integer) OWNER TO pgsql;

--
-- TOC entry 7741 (class 0 OID 0)
-- Dependencies: 1099
-- Name: FUNCTION af_get_individu_date_deconnexion_max(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_date_deconnexion_max(integer) IS 'retourne la date de deconnexion max pour un individu';


--
-- TOC entry 1100 (class 1255 OID 2595906)
-- Dependencies: 2983 5
-- Name: af_get_individu_droits_classe(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_droits_classe(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero individu
-- $2 : numero classe
declare 
rec record;
begin
    for rec in 
	select id,libelle,type,defaut from contraintes.af_get_droits(2) as (id int4,libelle varchar,type int4,defaut bool),contraintes.individu_droits ID 
	where id=ID.droit and ID.individu=$1 and ID.classe=$2
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_droits_classe(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7743 (class 0 OID 0)
-- Dependencies: 1100
-- Name: FUNCTION af_get_individu_droits_classe(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_droits_classe(integer, integer) IS 'retourne les droitts d''un individu pour une classe';


--
-- TOC entry 1101 (class 1255 OID 2595907)
-- Dependencies: 2983 5
-- Name: af_get_individu_filieres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_filieres(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;
begin
    for rec in
	--voir avec remi pour l'optimisation
	/*
	select fil.id,fil.libelle from 
	contraintes.filiere fil,
	contraintes.parcours par,
	contraintes.formation for,
	contraintes.formation_participants fp,
	contraintes.classe_individus ci 
	where ...
	*/
	select fil.id,fil.libelle from contraintes.filiere fil where fil.id in 
	(select par.filiere from contraintes.parcours par where par.id in 
	(select form.parcours from contraintes.formation form where form.id in 
	(select fp.formation from contraintes.formation_participants fp where fp.classe in 
	(select ci.classe from contraintes.classe_individus ci where ci.individu=$1))))
	
    loop
	return next rec;
    end loop;
	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_filieres(integer) OWNER TO pgsql;

--
-- TOC entry 7745 (class 0 OID 0)
-- Dependencies: 1101
-- Name: FUNCTION af_get_individu_filieres(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_filieres(integer) IS 'retourne les filieres de formation d''un individu';


--
-- TOC entry 1102 (class 1255 OID 2595908)
-- Dependencies: 2983 5
-- Name: af_get_individu_formations(integer, integer, character varying, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_formations(integer, integer, character varying, character varying, integer) RETURNS SETOF record
    AS $_$-- $1 : numero user
-- $2 filiere
-- $3 ordre pour classement ('asc' ou 'desc')
-- $4 'date_debut' ou 'libelle' (orderby)
-- $5 periode (1 : passées, 2 : présentes, 3 : futures, 0 : toutes)
declare
rec record;
begin
    for rec in 
	select f_id,libelle,f_parcours,date_debut,date_fin,langue,ci.individu,$2
	from contraintes.af_get_formations($3,$4,$5) 
	as (f_id int4,libelle varchar,f_parcours int4,date_debut date,date_fin date,langue int4,ressources_fusionnees boolean),
	contraintes.formation_participants fp,
	contraintes.classe_individus ci,
	contraintes.parcours p
	where fp.classe=ci.classe 
	and fp.formation=f_id 
	and ci.individu=$1 
	AND f_parcours=p.id
	AND p.filiere=$2
    loop
	return next rec;
    end loop;
    return;   
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_formations(integer, integer, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 7747 (class 0 OID 0)
-- Dependencies: 1102
-- Name: FUNCTION af_get_individu_formations(integer, integer, character varying, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_formations(integer, integer, character varying, character varying, integer) IS 'retourne les formations d''un individu pour une filiere';


--
-- TOC entry 1103 (class 1255 OID 2595909)
-- Dependencies: 2983 5
-- Name: af_get_individu_formations(integer, character varying, character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_formations(integer, character varying, character varying, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero user
-- $2 : ordre pour classement ('asc' ou 'desc')
-- $3 'date_debut' ou 'libelle' (orderby)
-- $4 periode (1 : passées, 2 : présentes, 3 : futures, 0 : toutes)
-- $5 individu
declare
rec record;
begin
    if contraintes.fw_is_root($5) then
    for rec in 
	select id,libelle,parcours,date_debut,date_fin,langue,ressources_fusionnees 
	from contraintes.af_get_formations($2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4,ressources_fusionnees boolean),
	contraintes.formation_participants fp,contraintes.classe_individus ci 
	where fp.classe=ci.classe and fp.formation=id and ci.individu=$1 
    loop
	return next rec;
    end loop;
    else
    for rec in 
	select id,libelle,parcours,date_debut,date_fin,langue,ressources_fusionnees 
	from contraintes.af_get_formations($2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4,ressources_fusionnees boolean),
	contraintes.formation_participants fp,contraintes.classe_individus ci 
	where fp.classe=ci.classe and fp.formation=id and ci.individu=$1 and fp.formateur=$5 
    loop
	return next rec;
    end loop;
    end if;
    return;   
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_formations(integer, character varying, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7749 (class 0 OID 0)
-- Dependencies: 1103
-- Name: FUNCTION af_get_individu_formations(integer, character varying, character varying, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_formations(integer, character varying, character varying, integer, integer) IS 'retourne les formations d''un individu pour le root ou formateur';


--
-- TOC entry 1104 (class 1255 OID 2595910)
-- Dependencies: 2983 5
-- Name: af_get_individu_grille(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_grille(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec record;
BEGIN
	SELECT INTO rec*
	FROM contraintes.stagiaire_grille
	WHERE formation=$1 and stagiaire=$2 and grille=$3;
	RETURN NEXT rec;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_grille(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7751 (class 0 OID 0)
-- Dependencies: 1104
-- Name: FUNCTION af_get_individu_grille(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_grille(integer, integer, integer) IS 'retourne les infos de la table stagiaire_grille pour un individu';


--
-- TOC entry 1105 (class 1255 OID 2595911)
-- Dependencies: 2983 5
-- Name: af_get_individu_last_deconnexion(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_last_deconnexion(integer) RETURNS record
    AS $_$-- $1 : individu
declare
rec record;
begin
    select into rec max(deconnexion) from contraintes.connexion 
    where individu=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_last_deconnexion(integer) OWNER TO pgsql;

--
-- TOC entry 7753 (class 0 OID 0)
-- Dependencies: 1105
-- Name: FUNCTION af_get_individu_last_deconnexion(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_last_deconnexion(integer) IS 'retourne la derniere deconnexion pour un individu';


--
-- TOC entry 1106 (class 1255 OID 2595912)
-- Dependencies: 2983 5
-- Name: af_get_individu_nom_prenom(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_nom_prenom(integer) RETURNS record
    AS $_$-- $1 : numero individu
declare
rec record;
begin
    select into rec 
    id,nom,prenom from contraintes.fw_individu where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_nom_prenom(integer) OWNER TO pgsql;

--
-- TOC entry 7755 (class 0 OID 0)
-- Dependencies: 1106
-- Name: FUNCTION af_get_individu_nom_prenom(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_nom_prenom(integer) IS 'retourne nom et prenom d''un individu';


--
-- TOC entry 1107 (class 1255 OID 2595913)
-- Dependencies: 2983 5
-- Name: af_get_individu_themes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_themes(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;

begin
    for rec in
	--select * from contraintes.themes 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_themes(integer) OWNER TO pgsql;

--
-- TOC entry 7757 (class 0 OID 0)
-- Dependencies: 1107
-- Name: FUNCTION af_get_individu_themes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_themes(integer) IS 'retourne les themes pour un individu';


--
-- TOC entry 1108 (class 1255 OID 2595914)
-- Dependencies: 2983 5
-- Name: af_get_individu_types(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_types(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
    for rec in 
	select id,libelle from contraintes.fw_individu_type,contraintes.fw_individu_types 
	where id=type and individu=$1 order by id
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_types(integer) OWNER TO pgsql;

--
-- TOC entry 7759 (class 0 OID 0)
-- Dependencies: 1108
-- Name: FUNCTION af_get_individu_types(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_types(integer) IS 'retourne les types d''un individu';


--
-- TOC entry 1109 (class 1255 OID 2595915)
-- Dependencies: 2983 5
-- Name: af_get_individu_types(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individu_types() RETURNS SETOF record
    AS $$DECLARE

rec record;

BEGIN
	FOR rec IN
	  SELECT id,libelle,code 
	  FROM contraintes.fw_individu_type
	  ORDER BY libelle

	LOOP
	  return next rec;
	END LOOP;
return;

END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individu_types() OWNER TO pgsql;

--
-- TOC entry 7761 (class 0 OID 0)
-- Dependencies: 1109
-- Name: FUNCTION af_get_individu_types(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individu_types() IS 'retourne tout les types';


--
-- TOC entry 1110 (class 1255 OID 2595916)
-- Dependencies: 2983 5
-- Name: af_get_individus(integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individus(integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 (0=>tous, 1=>formateurs, 2=>utilisateurs)
-- $2 (asc ou desc)
-- $3 (vrai => que les utilisateurs ou que les formateurs)
declare
rec record;
req varchar;
begin
    req:='select distinct id,nom,prenom,organisme from contraintes.fw_individu,contraintes.fw_individu_types IT1 ';
    if $3 is true then
	req:= req || ',contraintes.fw_individu_types IT2 ' ;
    end if;
    if $1 !=0 then
	req:= req || ' where ';
    end if;
    -- suite req
    if $1=1 then -- LES FORMATEURS
	if $3 is true then -- LES FORMATEURS STRICT
	    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1   ';
	    req:=req || ' and id =IT1.individu AND IT1.type=2';
	else
	    req:=req || ' id =IT1.individu AND IT1.type=2';
	end if;
	
    else
	if $1=2 then -- LES STAGIAIRES
	    if $3 is true then -- LES STAGIAIRES STRICT
	        req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		req:=req || ' and id =IT1.individu AND IT1.type=1';
	    else
		req:=req || ' id =IT1.individu AND IT1.type=1';
	    end if;
	    
	--/*
	else
	    if $1=3 then --LES INTERVENANTS
		if $3 is true then -- LES INTERVENANTS STRICT 
		    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		    req:=req || ' and id =IT1.individu AND IT1.type=3';
	        else
		    req:=req || ' id =IT1.individu AND IT1.type=3';     
	        end if;
	    --else
		--raise exception 'la valeur pour le paramètre 3 (type) doit être 1,2 ou 0';
	    end if;
	--*/
	end if;
	
    end if;

    -- classement
    if $2 like 'DESC' then
	req:=req || ' order by nom desc ';
    else
	req:=req || ' order by nom ';
    end if;

	 raise notice 'req=%',req;
for rec in
	execute req
loop
return next rec;
end loop;
return ;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individus(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 7763 (class 0 OID 0)
-- Dependencies: 1110
-- Name: FUNCTION af_get_individus(integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individus(integer, character varying, boolean) IS 'retourne les individus de la plateforme';


--
-- TOC entry 1111 (class 1255 OID 2595917)
-- Dependencies: 2983 5
-- Name: af_get_individus_exotlcs_corriges(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individus_exotlcs_corriges() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select distinct I.id,I.nom,I.prenom
	
	from contraintes.fw_individu I where I.id in 
	(select R.stagiaire from contraintes.resultat R where R.id in
	(select RE.id from contraintes.resultat_exotlc RE where RE.date_correction is not null))
	
	
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individus_exotlcs_corriges() OWNER TO pgsql;

--
-- TOC entry 7765 (class 0 OID 0)
-- Dependencies: 1111
-- Name: FUNCTION af_get_individus_exotlcs_corriges(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individus_exotlcs_corriges() IS 'retourne les individus qui ont des exotlc corriges';


--
-- TOC entry 1112 (class 1255 OID 2595918)
-- Dependencies: 2983 5
-- Name: af_get_individus_infos(integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individus_infos(integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 : type d'individu (0=tous, 1=formateurs & 2=stagiaires)
-- $2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- $3. exclusif : si VRAI alors que les 'u' ou les
declare
rec record;
req varchar;
begin
    req:='select distinct id,identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo from contraintes.fw_individu,contraintes.fw_individu_types IT1 ';
    if $3 is true then
	req:= req || ',contraintes.fw_individu_types IT2 ' ;
    end if;
    if $1 !=0 then
	req:= req || ' where ';
    end if;
    -- suite req
    if $1=1 then -- LES FORMATEURS
	if $3 is true then -- LES FORMATEURS STRICT
	    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type,identifiant_md5,login,password, nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  having count(IT2.type)=1   ';
	    req:=req || ' and id =IT1.individu AND IT1.type=2';
	else
	    req:=req || ' id =IT1.individu AND IT1.type=2';
	end if;
	
    else
	if $1=2 then -- LES STAGIAIRES
	    if $3 is true then -- LES STAGIAIRES STRICT
	        req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type,identifiant_md5,login,password, nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  having count(IT2.type)=1 '; 
		req:=req || ' and id =IT1.individu AND IT1.type=1';
	    else
		req:=req || ' id =IT1.individu AND IT1.type=1';
	    end if;
	    
	--/*
	else
	    if $1=3 then --LES INTERVENANTS
		if $3 is true then -- LES INTERVENANTS STRICT 
		    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		    req:=req || ' and id =IT1.individu AND IT1.type=3';
	        else
		    req:=req || ' id =IT1.individu AND IT1.type=3';     
	        end if;
	    --else
		--raise exception 'la valeur pour le paramètre 3 (type) doit être 1,2 ou 0';
	    end if;
	--*/
	end if;
	
    end if;

    -- classement
    if $2 like 'DESC' then
	req:=req || ' order by nom desc ';
    else
	req:=req || ' order by nom ';
    end if;

	 raise notice 'req=%',req; 
    for rec in
	execute req
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individus_infos(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 7767 (class 0 OID 0)
-- Dependencies: 1112
-- Name: FUNCTION af_get_individus_infos(integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individus_infos(integer, character varying, boolean) IS 'Retourne les infos individus de la plateforme';


--
-- TOC entry 1851 (class 1255 OID 2595919)
-- Dependencies: 2983 5
-- Name: af_get_individus_initiale(character varying, integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individus_initiale(character varying, integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 : initiale
-- $2 : type d'individu
-- $3 : classement (asc ou desc)
-- $4 : bool (excusif)
declare
rec record;
begin
    for rec in 
	select distinct id,nom,prenom from contraintes.af_get_individus($2,$3,$4) 
	--select * from contraintes.af_get_individus($2,$3,$4) 
	AS (id integer, nom varchar, prenom varchar,organisme int4) 
	where nom like $1 || '%' 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individus_initiale(character varying, integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 7769 (class 0 OID 0)
-- Dependencies: 1851
-- Name: FUNCTION af_get_individus_initiale(character varying, integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individus_initiale(character varying, integer, character varying, boolean) IS 'retourne les individus dont le nom commence par l''initiale';


--
-- TOC entry 1852 (class 1255 OID 2595920)
-- Dependencies: 2983 5
-- Name: af_get_individus_types(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_individus_types() RETURNS SETOF record
    AS $$DECLARE

rec record;

BEGIN
	FOR rec IN
	  SELECT id,libelle,code 
	  FROM contraintes.fw_individu_type
	  ORDER BY libelle

	LOOP
	  return next rec;
	END LOOP;
return;

END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_individus_types() OWNER TO pgsql;

--
-- TOC entry 7771 (class 0 OID 0)
-- Dependencies: 1852
-- Name: FUNCTION af_get_individus_types(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_individus_types() IS 'retourne tous les individus_types';


--
-- TOC entry 1113 (class 1255 OID 2595921)
-- Dependencies: 2983 5
-- Name: af_get_inscription(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_inscription(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec id, identifiant_md5 ,login ,password ,nom ,prenom ,adresse ,code ,ville ,
		email ,tel_fixe ,tel_port ,langue,organisme ,photo  from contraintes.inscription where id=$1;
    return rec;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_inscription(integer) OWNER TO pgsql;

--
-- TOC entry 7773 (class 0 OID 0)
-- Dependencies: 1113
-- Name: FUNCTION af_get_inscription(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_inscription(integer) IS 'retourne les in infos d''une inscription';


--
-- TOC entry 1114 (class 1255 OID 2595922)
-- Dependencies: 2983 5
-- Name: af_get_inscriptions(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_inscriptions() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select * from contraintes.inscription order by nom
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_inscriptions() OWNER TO pgsql;

--
-- TOC entry 7775 (class 0 OID 0)
-- Dependencies: 1114
-- Name: FUNCTION af_get_inscriptions(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_inscriptions() IS 'retourne les inscrits en attente de validation';


--
-- TOC entry 1115 (class 1255 OID 2595923)
-- Dependencies: 2983 5
-- Name: af_get_intervenant_evenements(integer, date); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_intervenant_evenements(integer, date) RETURNS SETOF record
    AS $_$-- $1 : intervenant
-- $2 : date
declare
rec record;
begin
    for rec in 
	select * from contraintes.evenement 
	where intervenant=$1 and cast(date as date)=$2
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_intervenant_evenements(integer, date) OWNER TO pgsql;

--
-- TOC entry 7777 (class 0 OID 0)
-- Dependencies: 1115
-- Name: FUNCTION af_get_intervenant_evenements(integer, date); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_intervenant_evenements(integer, date) IS 'retourne les evenements d''un intervenant pour un jour de formation';


--
-- TOC entry 1116 (class 1255 OID 2595924)
-- Dependencies: 2983 5
-- Name: af_get_intervenant_evenements_presentiels(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_intervenant_evenements_presentiels(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : intervenant
-- $2 : formation
declare
rec record;
begin
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
	from contraintes.af_get_formation_evenements_presentiels($2) 
	as (formation int4,libelle varchar,date timestamp,duree interval,modalite int4,intervention int4,intervenant int4,salle int4) 
	where intervenant=$1 order by date
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_intervenant_evenements_presentiels(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7779 (class 0 OID 0)
-- Dependencies: 1116
-- Name: FUNCTION af_get_intervenant_evenements_presentiels(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_intervenant_evenements_presentiels(integer, integer) IS 'retourne les evenements presentiels d''une formation pour un intervenant';


--
-- TOC entry 1117 (class 1255 OID 2595925)
-- Dependencies: 2983 5
-- Name: af_get_intervenant_formations_grille(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_intervenant_formations_grille(integer) RETURNS SETOF record
    AS $_$-- $1 : intervenant
declare
rec record;
begin
    for rec in 
	select distinct id,f.libelle from 
	contraintes.formation f,
	contraintes.evenement e,
	contraintes.grille_resultats gr 
	where id=e.formation and e.intervenant=$1 and e.modalite=3 and id=gr.formation
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_intervenant_formations_grille(integer) OWNER TO pgsql;

--
-- TOC entry 7781 (class 0 OID 0)
-- Dependencies: 1117
-- Name: FUNCTION af_get_intervenant_formations_grille(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_intervenant_formations_grille(integer) IS 'retourne les formations avec grille pour un intervenant';


--
-- TOC entry 1118 (class 1255 OID 2595926)
-- Dependencies: 2983 5
-- Name: af_get_intervenant_formations_presentielles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_intervenant_formations_presentielles(integer) RETURNS SETOF record
    AS $_$-- $1 : intervenant
declare
rec record;
begin
    for rec in
	select distinct f.id,f.libelle from contraintes.formation f,contraintes.evenement 
	where f.id=formation and intervenant=$1 and modalite=3
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_intervenant_formations_presentielles(integer) OWNER TO pgsql;

--
-- TOC entry 7783 (class 0 OID 0)
-- Dependencies: 1118
-- Name: FUNCTION af_get_intervenant_formations_presentielles(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_intervenant_formations_presentielles(integer) IS 'retourne les formations presentielles d''un intervenant';


--
-- TOC entry 1119 (class 1255 OID 2595927)
-- Dependencies: 2983 5
-- Name: af_get_intervenants(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_intervenants(integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
    if contraintes.fw_is_root($1) or contraintes.fw_is_formateur($1) then
    for rec in
	select id,nom,prenom from contraintes.fw_individu i,contraintes.fw_individu_types it 
	where i.id=it.individu and it.type=3
    loop
	return next rec;
    end loop;
    else
    for rec in
	select id,nom,prenom from contraintes.fw_individu i,contraintes.fw_individu_types it 
	where i.id=it.individu and it.type=3 and i.id=$1
    loop
	return next rec;
    end loop;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_intervenants(integer) OWNER TO pgsql;

--
-- TOC entry 7785 (class 0 OID 0)
-- Dependencies: 1119
-- Name: FUNCTION af_get_intervenants(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_intervenants(integer) IS 'retourne les intervenants de formation
si root ou formateur';


--
-- TOC entry 1120 (class 1255 OID 2595928)
-- Dependencies: 2983 5
-- Name: af_get_intervenants_presentiel_grille(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_intervenants_presentiel_grille(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;
begin
    for rec in 
	select distinct id,nom,prenom from 
	contraintes.af_get_intervenants($1) as (id int4,nom varchar,prenom varchar),
	contraintes.evenement e,
	contraintes.grille_resultats gr 
	where id=e.intervenant and e.modalite=3 and e.formation=gr.formation
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_intervenants_presentiel_grille(integer) OWNER TO pgsql;

--
-- TOC entry 7787 (class 0 OID 0)
-- Dependencies: 1120
-- Name: FUNCTION af_get_intervenants_presentiel_grille(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_intervenants_presentiel_grille(integer) IS 'retourne les intervenants presentiel avec grille si root';


--
-- TOC entry 1121 (class 1255 OID 2595929)
-- Dependencies: 2983 5
-- Name: af_get_intervention(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_intervention(integer) RETURNS record
    AS $_$-- $1 : numero intervention
declare
rec record;
begin
    select into rec * from contraintes.af_get_interventions() as (id int4,libelle varchar,couleur varchar) where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_intervention(integer) OWNER TO pgsql;

--
-- TOC entry 7789 (class 0 OID 0)
-- Dependencies: 1121
-- Name: FUNCTION af_get_intervention(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_intervention(integer) IS 'retourne une intervention';


--
-- TOC entry 1122 (class 1255 OID 2595930)
-- Dependencies: 2983 5
-- Name: af_get_interventions(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_interventions() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,couleur from contraintes.intervention order by libelle
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_interventions() OWNER TO pgsql;

--
-- TOC entry 7791 (class 0 OID 0)
-- Dependencies: 1122
-- Name: FUNCTION af_get_interventions(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_interventions() IS 'retourne les intervention de la plateforme';


--
-- TOC entry 1123 (class 1255 OID 2595931)
-- Dependencies: 2983 5
-- Name: af_get_langue(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langue(integer) RETURNS record
    AS $_$declare
rec record;
begin
    select into rec * from contraintes.af_get_langues() as (id int4,libelle varchar, code varchar, locale varchar) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langue(integer) OWNER TO pgsql;

--
-- TOC entry 7793 (class 0 OID 0)
-- Dependencies: 1123
-- Name: FUNCTION af_get_langue(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langue(integer) IS 'retourne les info langue';


--
-- TOC entry 1124 (class 1255 OID 2595932)
-- Dependencies: 2983 5
-- Name: af_get_langue(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langue(character varying) RETURNS record
    AS $_$declare
rec record;
begin
    select into rec * from contraintes.af_get_langues() as (id int4,libelle varchar, code varchar, locale varchar) 
    where code=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langue(character varying) OWNER TO pgsql;

--
-- TOC entry 7795 (class 0 OID 0)
-- Dependencies: 1124
-- Name: FUNCTION af_get_langue(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langue(character varying) IS 'retourne les info langue à partir du code';


--
-- TOC entry 1125 (class 1255 OID 2595933)
-- Dependencies: 2983 5
-- Name: af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying) RETURNS SETOF record
    AS $_$-- $1 : tableau de langue
-- $2 : type
-- $3 : numero du champ pour l'order by
-- $4 : classement (asc ou desc)
-- $5 : limit
-- $6 : offset
declare
rec record;
rec_langue record;
req varchar;
req_select varchar;
req_from varchar;
req_where varchar;
req_and varchar;
nb_langue integer;
i integer;
indice integer;
ind_select integer;
ind_from integer;
ind_where integer;
orderby varchar;
last_ref varchar;
msg alias for $7;
begin
    -- Exemple de requete à construire ( ici 4 langues : francais,anglais,chinois,japonnais)
    /*
    select a.id,a.libelle as francais,b.libelle as anglais,c.libelle as chinois,d.libelle as japonnais 
    from ((contraintes.langue_message as a join contraintes.langue_message as b
    on (a.id=b.id)) 
    join  contraintes.langue_message as c
    on (a.id=c.id)) 
    join contraintes.langue_message as d
    on (a.id=d.id)
    where (a.type=11 and b.type=11 and c.type=11 and d.type=11) 
    and (a.langue=1 and b.langue=2 and c.langue=3 and d.langue=4)
    order by a.id
    limit 7
    offset 0
    */


    -- INITIALISATION
    -- nombre de langues
    nb_langue:=0;
    nb_langue:=array_upper($1,1);
    -- premiere langue du tableau
    indice:=$1[1];
    --raise notice 'lg1=%',indice;
    --raise notice 'nb=%',nb_langue;	
    -- ordder by
    if $3 =0 then
	orderby:='lm'||indice||'.id';
    else
	orderby:='lm'||$3||'.libelle';
    end if;

    -- CONSTRUCTION REQUETE
    
    -- DEBUT REQUETE
    req:='';
    req_select:='select lm'||indice||'.id,';
    req_from:=' from ';
    req_where:=' where ';
    req_and:=' ';
    -- boucle sur le nb de langue
    ind_select:=0;
    ind_from:=0;
    ind_where:=0;
    FOR i IN array_lower($1,1)..array_upper($1,1)
    loop
	-- recup libelle langue pour construction select
	select into rec_langue * from contraintes.af_get_langue($1[i]) as (id int4,libelle varchar, code varchar, locale varchar);
	req_select:=req_select || 'lm'||$1[i] || '.'||'libelle as '||rec_langue.code ;
	ind_select:=ind_select + 1;
	if ind_select < nb_langue then
	    req_select:=req_select ||',';
	end if;

    -- contruction du from

    if ind_from=0 then
	ind_from:=ind_from + 1;
	req_from:=req_from || 'contraintes.langue_message as lm'||$1[i]; 
	    last_ref:='lm'||$1[i];
    else
	req_from:=req_from || ' join contraintes.langue_message as lm'||$1[i];
	req_from:=req_from || ' on '|| last_ref||'.id = lm'||$1[i]||'.id ';
	last_ref:='lm'||$1[i];
    end if;

    -- contruction du where
    ind_where:=ind_where+1;
	req_where:=req_where || 'lm'||$1[i]||'.type='||$2;
	if ind_where < nb_langue then
	    req_where:=req_where||' and ';
	end if;
    -- construction and
    req_and:=req_and || ' and lm'||$1[i]||'.langue='||$1[i];
    	
    end loop;
    
    -- assemblage
    req:=req || req_select||req_from||req_where||req_and;
    --raise notice 'req_select=% et req_from=% et req_where=% et req_and=%' ,req_select,req_from,req_where,req_and;
--raise notice 'msg=%',msg;
    -- test recherche libelle OK (A suivre ...)
    if $7 is not null then
	req:=req || ' and lm'||$1[1]||'.libelle ilike '''||msg||''''; 
    end if;
    --raise notice 'req=%',req; 
    -- fin requete
    req:=req ||' order by '||orderby ||' '|| $4 ;
    req:=req ||' limit ' ||$5;
    req:=req ||' offset '||$6;

    for rec in
	execute req
    loop
	return next rec;
    end loop;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 7797 (class 0 OID 0)
-- Dependencies: 1125
-- Name: FUNCTION af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying) IS 'retourne les libelles des langues pour un type donné';


--
-- TOC entry 1853 (class 1255 OID 2595934)
-- Dependencies: 2983 5
-- Name: af_get_langue_message_libelle(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langue_message_libelle(integer, integer, integer) RETURNS record
    AS $_$-- $1 : numero id
-- $2 : langue
-- $3 : type
declare
rec record;
begin
    select into rec id,libelle,type,langue from contraintes.langue_message 
    where id=$1 and langue=$2 and type=$3;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langue_message_libelle(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7799 (class 0 OID 0)
-- Dependencies: 1853
-- Name: FUNCTION af_get_langue_message_libelle(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langue_message_libelle(integer, integer, integer) IS 'retourne le libelle pour un id,un type et une langue';


--
-- TOC entry 1126 (class 1255 OID 2595935)
-- Dependencies: 2983 5
-- Name: af_get_langue_messages(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langue_messages(integer) RETURNS SETOF record
    AS $_$-- $1 : langue
declare
rec record;
begin
    for rec in
	select lm.id,lm.libelle,lm.type,lm.langue,lt.code||'_'||lm.id as message from contraintes.langue_message lm,contraintes.langue_type lt
	where lm.langue=$1 and lm.type=lt.id order by lm.type,lm.id
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langue_messages(integer) OWNER TO pgsql;

--
-- TOC entry 7801 (class 0 OID 0)
-- Dependencies: 1126
-- Name: FUNCTION af_get_langue_messages(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langue_messages(integer) IS 'retourne les messages de langue pour une langue donnée';


--
-- TOC entry 1127 (class 1255 OID 2595936)
-- Dependencies: 2983 5
-- Name: af_get_langue_messages_type(integer, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langue_messages_type(integer, integer, character varying) RETURNS SETOF record
    AS $_$-- $1 : langue
-- $2 : type
-- $3 : message
declare
rec record;
req varchar;
msg alias for $3;
begin
    req:='select lm_id,lm_libelle,lm_type,lm_langue,lm_message from contraintes.af_get_langue_messages('||$1||')';
    req:=req ||'as (lm_id integer,lm_libelle text,lm_type integer,lm_langue integer,lm_message text)'; 
    req:=req ||'where lm_type='||$2;
    if $3 is not null then
	req:=req || 'and lm_libelle like '''||msg||''''; 
    end if;
raise notice 'req=%',req; 
	
    for rec in
	/*
	select lm_id,lm_libelle,lm_type,lm_langue,lm_message from contraintes.af_get_langue_messages($1) 
	as (lm_id integer,lm_libelle text,lm_type integer,lm_langue integer,lm_message text) 
	where lm_type=$2
	*/
	execute req
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langue_messages_type(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 7803 (class 0 OID 0)
-- Dependencies: 1127
-- Name: FUNCTION af_get_langue_messages_type(integer, integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langue_messages_type(integer, integer, character varying) IS 'retourne les messages langue pour une langue et un type';


--
-- TOC entry 24 (class 1255 OID 2595937)
-- Dependencies: 2983 5
-- Name: af_get_langue_type(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langue_type(integer) RETURNS record
    AS $_$-- $1 : type
declare
rec record;
begin
    select into rec * from contraintes.af_get_langue_types() as (id integer,libelle varchar,code varchar) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langue_type(integer) OWNER TO pgsql;

--
-- TOC entry 7805 (class 0 OID 0)
-- Dependencies: 24
-- Name: FUNCTION af_get_langue_type(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langue_type(integer) IS 'retourne les infos d''un type de message de langue';


--
-- TOC entry 1128 (class 1255 OID 2595938)
-- Dependencies: 2983 5
-- Name: af_get_langue_types(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langue_types() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	-- order by provisoire (modif said 08/01/08)
	select * from contraintes.langue_type order by id
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langue_types() OWNER TO pgsql;

--
-- TOC entry 7807 (class 0 OID 0)
-- Dependencies: 1128
-- Name: FUNCTION af_get_langue_types(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langue_types() IS 'retourne les types de message langue';


--
-- TOC entry 1129 (class 1255 OID 2595939)
-- Dependencies: 2983 5
-- Name: af_get_langues(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langues() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle, code, locale from contraintes.langue
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langues() OWNER TO pgsql;

--
-- TOC entry 7809 (class 0 OID 0)
-- Dependencies: 1129
-- Name: FUNCTION af_get_langues(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langues() IS 'retourne les langues de la plateforme';


--
-- TOC entry 1130 (class 1255 OID 2595940)
-- Dependencies: 2983 5
-- Name: af_get_langues_messages_type(integer[], integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_langues_messages_type(integer[], integer) RETURNS SETOF record
    AS $_$-- $1 : tableau de langues
-- $2 : type
declare
rec record;
i integer;
begin
    for i in array_lower($1,1) .. array_upper($1,1)
    loop
	for rec in
	    select * from contraintes.af_get_langue_messages_type(i,$2) as (id int4,libelle text,type int4,langue int4,variable text)
	loop
	    return next rec;
	end loop;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_langues_messages_type(integer[], integer) OWNER TO pgsql;

--
-- TOC entry 7811 (class 0 OID 0)
-- Dependencies: 1130
-- Name: FUNCTION af_get_langues_messages_type(integer[], integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_langues_messages_type(integer[], integer) IS 'retourne les messages de langues pour un type';


--
-- TOC entry 1131 (class 1255 OID 2595941)
-- Dependencies: 2983 5
-- Name: af_get_liste(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_liste(integer) RETURNS record
    AS $_$DECLARE
--$1 liste
rec RECORD;
BEGIN
	SELECT INTO rec id, E_libelle, type, date_creation FROM contraintes.liste, contraintes.af_get_etape($1) AS (E_id int4, E_libelle varchar, E_type int4,date_creation timestamp)
	WHERE id=$1 
	AND id=E_id;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_liste(integer) OWNER TO pgsql;

--
-- TOC entry 1132 (class 1255 OID 2595942)
-- Dependencies: 2983 5
-- Name: af_get_liste_themes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_liste_themes(integer) RETURNS SETOF record
    AS $_$declare
rec record;
rec_tmp record;
--$1 liste
categorie int4;
BEGIN
	--recup le type de la liste
	SELECT INTO rec_tmp id, type FROM contraintes.af_get_liste($1) AS (id int4, libelle varchar, type int4);
	
	IF rec_tmp.id IS NULL THEN
		RAISE EXCEPTION 'La liste d''identifiant % n''existe pas', $1;
	END IF;

	--categorie
	IF rec_tmp.type=1 THEN
		categorie:=19;
	ELSEIF rec_tmp.type=3 THEN
		categorie:=44;
	ELSE 
		RAISE EXCEPTION 'Le type % n''est pas un liste_type valide',rec_tmp.type;
	END IF;

	--requete
	FOR rec IN 
		SELECT * FROM contraintes.af_get_element_themes_categorie($1,categorie) AS (id int4, libelle varchar)
	LOOP
		return next rec;
	end loop;

	RETURN;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_liste_themes(integer) OWNER TO pgsql;

--
-- TOC entry 7814 (class 0 OID 0)
-- Dependencies: 1132
-- Name: FUNCTION af_get_liste_themes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_liste_themes(integer) IS 'retourne les themes d''une liste ';


--
-- TOC entry 1133 (class 1255 OID 2595943)
-- Dependencies: 2983 5
-- Name: af_get_medias(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_medias() RETURNS SETOF record
    AS $$DECLARE
rec record;
BEGIN
	
	FOR  rec IN
		select  id from contraintes.media
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_medias() OWNER TO postgres;

--
-- TOC entry 7816 (class 0 OID 0)
-- Dependencies: 1133
-- Name: FUNCTION af_get_medias(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_medias() IS 'retourne le contenu de la table media';


--
-- TOC entry 1134 (class 1255 OID 2595944)
-- Dependencies: 2983 5
-- Name: af_get_medias_scenarios_theme(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_medias_scenarios_theme(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id,libelle,type,theme_id,theme_libelle
		FROM 
		contraintes.af_get_medias_scenarios_themes()  AS (id integer, libelle varchar, type integer, theme_id integer, theme_libelle varchar)
		WHERE theme_id=$1
		ORDER BY id,libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_medias_scenarios_theme(integer) OWNER TO pgsql;

--
-- TOC entry 7818 (class 0 OID 0)
-- Dependencies: 1134
-- Name: FUNCTION af_get_medias_scenarios_theme(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_medias_scenarios_theme(integer) IS 'obtenir tous les médias d''un theme';


--
-- TOC entry 1135 (class 1255 OID 2595945)
-- Dependencies: 2983 5
-- Name: af_get_medias_scenarios_themes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_medias_scenarios_themes(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	if contraintes.fw_is_root($1) then
	FOR rec IN
		SELECT F_id,F_libelle,F_type,T_id,T_libelle
		FROM 
		contraintes.af_get_categorie_elements(2) AS (C_id integer, C_theme integer,C_categorie integer) ,
		contraintes.af_get_categorie_themes(2,$1) AS (T_id integer, T_libelle varchar),
		contraintes.af_get_fichiers() AS (F_id integer, F_libelle varchar, F_type integer, F_connecte boolean)
		WHERE C_theme=T_id
		AND C_id=F_id
		AND F_connecte IS TRUE
		ORDER BY T_id,T_libelle,F_type
	LOOP
		RETURN NEXT rec;
	END LOOP;
	else
	FOR rec IN
		SELECT F_id,F_libelle,F_type,T_id,T_libelle
		FROM 
		contraintes.af_get_categorie_elements(2) AS (C_id integer, C_theme integer,C_categorie integer) ,
		contraintes.af_get_categorie_themes(2,$1) AS (T_id integer, T_libelle varchar),
		contraintes.af_get_fichiers() AS (F_id integer, F_libelle varchar, F_type integer, F_connecte boolean)
		WHERE C_theme=T_id
		AND C_id=F_id
		AND F_connecte IS TRUE
		ORDER BY T_id,T_libelle,F_type
	LOOP
		RETURN NEXT rec;
	END LOOP;
	end if;

	RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_medias_scenarios_themes(integer) OWNER TO pgsql;

--
-- TOC entry 7820 (class 0 OID 0)
-- Dependencies: 1135
-- Name: FUNCTION af_get_medias_scenarios_themes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_medias_scenarios_themes(integer) IS 'obtenir tous les médias et leurs themes';


--
-- TOC entry 1136 (class 1255 OID 2595946)
-- Dependencies: 2983 5
-- Name: af_get_medias_scenarios_themes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_medias_scenarios_themes() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT F_id,F_libelle,F_type,t.id,t.libelle
		FROM 
		contraintes.af_get_categorie_elements(2) AS (C_id integer, C_theme integer,C_categorie integer) ,
		contraintes.theme t ,
		contraintes.af_get_fichiers() AS (F_id integer, F_libelle varchar, F_type integer, F_connecte boolean)
		WHERE C_theme=t.id
		AND C_id=F_id
		
		AND F_connecte IS TRUE
		ORDER BY t.id,t.libelle,F_type
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_medias_scenarios_themes() OWNER TO pgsql;

--
-- TOC entry 7822 (class 0 OID 0)
-- Dependencies: 1136
-- Name: FUNCTION af_get_medias_scenarios_themes(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_medias_scenarios_themes() IS 'obtenir tous les médias et leurs themes';


--
-- TOC entry 1137 (class 1255 OID 2595947)
-- Dependencies: 2983 5
-- Name: af_get_modalite(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_modalite(integer) RETURNS record
    AS $_$-- $1 : numero modalite
declare
rec record;
begin
    SELECT into rec * FROM contraintes.af_get_modalites() as (id int4, libelle varchar, code varchar) 
	WHERE id=$1;

	RETURN rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_modalite(integer) OWNER TO pgsql;

--
-- TOC entry 7824 (class 0 OID 0)
-- Dependencies: 1137
-- Name: FUNCTION af_get_modalite(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_modalite(integer) IS 'retourne une modalite';


--
-- TOC entry 1138 (class 1255 OID 2595948)
-- Dependencies: 2983 5
-- Name: af_get_modalites(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_modalites() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	SELECT * FROM contraintes.modalite
    LOOP
	RETURN NEXT rec;
    END LOOP;

	RETURN;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_modalites() OWNER TO pgsql;

--
-- TOC entry 7826 (class 0 OID 0)
-- Dependencies: 1138
-- Name: FUNCTION af_get_modalites(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_modalites() IS 'retourne les modalites de la plateforme';


--
-- TOC entry 1854 (class 1255 OID 2595949)
-- Dependencies: 2983 5
-- Name: af_get_modele_correction_criteres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_modele_correction_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero modele correction
declare
rec record;
begin
    for rec in 
	select M1.modele_correction, M1.critere, fils.id,M1.note_max
	from contraintes.modele_correction M1 
	     left outer join(	contraintes.critere pere 
						left outer join contraintes.critere fils 
						on (fils.pere=pere.id)
					)
			on (M1.critere=pere.id)
	where M1.modele_correction=$1
	
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_modele_correction_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 7828 (class 0 OID 0)
-- Dependencies: 1854
-- Name: FUNCTION af_get_modele_correction_criteres(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_modele_correction_criteres(integer) IS 'retourne les criteres et sous criteres d''un medele de correction';


--
-- TOC entry 1139 (class 1255 OID 2595950)
-- Dependencies: 2983 5
-- Name: af_get_modeles_correction(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_modeles_correction() RETURNS SETOF record
    AS $$
declare
rec record;
begin
    for rec in 
	select id,libelle from contraintes.modele_correction 
	
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_modeles_correction() OWNER TO pgsql;

--
-- TOC entry 7830 (class 0 OID 0)
-- Dependencies: 1139
-- Name: FUNCTION af_get_modeles_correction(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_modeles_correction() IS 'retourne les modeles de correction de la plateforme';


--
-- TOC entry 1140 (class 1255 OID 2595951)
-- Dependencies: 2983 5
-- Name: af_get_organisme(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_organisme(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec id,libelle 
    from contraintes.organisme where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_organisme(integer) OWNER TO pgsql;

--
-- TOC entry 7832 (class 0 OID 0)
-- Dependencies: 1140
-- Name: FUNCTION af_get_organisme(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_organisme(integer) IS 'retourne lid et le libelle d''un organisme';


--
-- TOC entry 1141 (class 1255 OID 2595952)
-- Dependencies: 2983 5
-- Name: af_get_organisme_individus(integer, character varying, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_organisme_individus(integer, character varying, integer, boolean) RETURNS SETOF record
    AS $_$-- Retourne les informations des infividus appartenant ÃÂ  l'organisme

-- Parametres :
-- 1. Identifiant de l'organisme
-- 2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 3. Type : 0=tous, 1=formateurs & 2=stagiaires
-- 4. exclusif : si VRAI alors que les 'u' ou les 'f'
declare
rec record;
req varchar;
org varchar;
begin
/*
    req:='select distinct id,nom,prenom,login,password,'||$3||' from contraintes.fw_individu, contraintes.fw_individu_types IT1 ' ;
    if $4 is true then
	req:= req || ',contraintes.fw_individu_types IT2 ' ;
    end if;
    req:= req || 'where IT1.individu=id and ';
    -- multi org ?
    if $1 is null then
	req:=req || 'organisme is null ';
    else
	req:=req || 'organisme ='||$1;
    end if;
    -- suite req
    if $3=1 then -- LES FORMATEURS
	if $4 is true then -- LES FORMATEURS STRICT
	    req:=req || ' and id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom , login, password having count(IT2.type)=1   ';
	end if;
	req:=req || 'and id =IT1.individu AND IT1.type=2';
    else
	if $3=2 then -- LES STAGIAIRES
	    if $4 is true then -- LES STAGIAIRES STRICT
	        req:=req || ' and id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, login, nom,prenom , login, password having count(IT2.type)=1 '; 
	    end if;
	    req:=req || 'and id =IT1.individu AND IT1.type=1';
	else
	    if $3=0 then --LES FORMATEURS ET STAGIAIRES
		if $1 IS NULL THEN
			org:='IS NULL';
		ELSE
			org:='='||$1;
		END IF;
		if $4 is true then -- LES FORMATEURS STRICT ET STAGIAIRES STRICT
		    req:='select id,nom,prenom,login,password,'||$3||' from contraintes.fw_individu where organisme '||org||' group by fw_individu.id,nom,prenom , login, password '; 
		    raise notice 'r1=%',req ;
	    
			--req:='select individu,nom,prenom,login,password,'||$3||' from contraintes.fw_individu where organisme ='||org||' group by nom,prenom , login, password '; 
		else    
	       	    req:='select id,nom,prenom,login,password,'||$3||' from contraintes.fw_individu where organisme '||org||' group by fw_individu.id,nom,prenom , login, password '; 
		    --req:='select individu,nom,prenom,login,password,'||$3||' from contraintes.fw_individu,contraintes.fw_individu_types where individu=id and organisme '||org||' group by individu,nom,prenom , login, password having count(individu)=1'; 
			raise notice 'r2=%',req;
	        end if;
	    else
		raise exception 'la valeur pour le paramètre 3 (type) doit être 1,2 ou 0';
	    end if;
	end if;

    end if;

    -- classement
    if $2 like 'DESC' then
	req:=req || 'order by nom desc ';
    else
	req:=req || 'order by nom ';
    end if;

	raise notice 'req=%',req;
for rec in
	execute req
loop
return next rec;
end loop;
*/
-- nouvelle méthode	
    if $3 =0 then 
        if $2 like 'desc' then
	    if $1 is null then
	        for rec in 
		    select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu 
		    where organisme is null order by nom desc
	        loop
		    return next rec;
	        end loop;
	    else
		for rec in 
		    select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu 
		    where organisme =$1 order by nom desc
	        loop
		    return next rec;
	        end loop;
	    end if;	
        else
	    if $1 is null then 
	        for rec in 
		    select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu 
		    where organisme is null order by nom 
	        loop
		    return next rec;
	        end loop; 
	    else
		for rec in 
		    select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu 
		    where organisme = $1 order by nom 
	        loop
		    return next rec;
	        end loop; 
	    end if;
        end if;


    else
        if $4 is true then
	    if $2 like 'desc' then
		if $1 is null then 
		    for rec in 
		    select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1,contraintes.fw_individu_types IT2 
		    where IT1.individu=id and organisme is null 
		    and id=IT2.individu group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,login,password 
		    having count(IT2.type)=1 
		    and IT1.type=$3 order by nom desc
		    loop
			return next rec;
		    end loop;
		else
		    for rec in 	
		    select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1,contraintes.fw_individu_types IT2 
		    where IT1.individu=id and organisme =$1 
		    and id=IT2.individu group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,login,password 
		    having count(IT2.type)=1 
		    and IT1.type=$3 order by nom desc
		    loop
			return next rec;
		    end loop;
		end if;

	    else
		if $1 is null then 
		    for rec in 
		    select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1,contraintes.fw_individu_types IT2 
		    where IT1.individu=id and organisme is null 
		    and id=IT2.individu group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,login,password 
		    having count(IT2.type)=1 
		    and IT1.type=$3 order by nom 
		    loop
			return next rec;
		    end loop;
		else
		    for rec in 	
		    select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1,contraintes.fw_individu_types IT2 
		    where IT1.individu=id and organisme =$1 
		    and id=IT2.individu group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,login,password 
		    having count(IT2.type)=1 
		    and IT1.type=$3 order by nom 
		    loop
			return next rec;
		    end loop;
		end if;
	    end if;
	
        else
	    if $2 like 'desc' then
		if $1 is null then
		    for rec in 
			select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu,
			contraintes.fw_individu_types IT1 
			where IT1.individu=id  and organisme is null and IT1.type=$3 order by nom desc
		    loop
			return next rec;
		    end loop;
		else
		    for rec in 
			select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu,
			contraintes.fw_individu_types IT1 
			where IT1.individu=id and IT1.type=$3 and organisme =$1 order by nom desc
		    loop
			return next rec;
		    end loop;	
		end if;

	    else
		if $1 is null then
		    for rec in 
			select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu,
			contraintes.fw_individu_types IT1 
			where IT1.individu=id and IT1.type=$3 and organisme is null order by nom 
		    loop
			return next rec;
		    end loop;
		else
		    for rec in 
			select distinct id,nom,prenom,login,password,$3 from contraintes.fw_individu,
			contraintes.fw_individu_types IT1 
			where IT1.individu=id and IT1.type=$3 and organisme =$1 order by nom 
		    loop
			return next rec;
		    end loop;
		end if;

	    end if;

	end if;

    end if;


return ;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_organisme_individus(integer, character varying, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 7834 (class 0 OID 0)
-- Dependencies: 1141
-- Name: FUNCTION af_get_organisme_individus(integer, character varying, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_organisme_individus(integer, character varying, integer, boolean) IS 'retourne les individus d''un organisme';


--
-- TOC entry 1855 (class 1255 OID 2595953)
-- Dependencies: 2983 5
-- Name: af_get_organismes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_organismes() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle from contraintes.organisme order by libelle
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_organismes() OWNER TO pgsql;

--
-- TOC entry 7836 (class 0 OID 0)
-- Dependencies: 1855
-- Name: FUNCTION af_get_organismes(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_organismes() IS 'retourne les organismes de la plateforme';


--
-- TOC entry 1142 (class 1255 OID 2595954)
-- Dependencies: 2983 5
-- Name: af_get_organismes_non_vide(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_organismes_non_vide() RETURNS SETOF record
    AS $$declare
rec record;

begin
    for rec in 
	select distinct O_id,O_libelle from contraintes.af_get_organismes() as (O_id int4,O_libelle "varchar"),contraintes.fw_individu I 
	where O_id=I.organisme
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_organismes_non_vide() OWNER TO pgsql;

--
-- TOC entry 7838 (class 0 OID 0)
-- Dependencies: 1142
-- Name: FUNCTION af_get_organismes_non_vide(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_organismes_non_vide() IS 'retourne les organismes pour lesquels il y a des individus';


--
-- TOC entry 1143 (class 1255 OID 2595955)
-- Dependencies: 2983 5
-- Name: af_get_page_annuaire_configuration(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_page_annuaire_configuration(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : type individu
declare
rec record;
begin
    for rec in 
	select page_element,formation,page,individu_type
	from contraintes.page_annuaire_configuration 
	where formation=$1 and individu_type=$3
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_page_annuaire_configuration(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7840 (class 0 OID 0)
-- Dependencies: 1143
-- Name: FUNCTION af_get_page_annuaire_configuration(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_page_annuaire_configuration(integer, integer, integer) IS 'retourne la configuration d''une page d''annuaire';


--
-- TOC entry 1144 (class 1255 OID 2595956)
-- Dependencies: 2983 5
-- Name: af_get_page_commentaire(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_page_commentaire(integer, integer, integer) RETURNS record
    AS $_$-- $1 : page
-- $2 : formation
-- $3 : stagiaire
declare
rec record;
begin
    select into rec * from contraintes.page_commentaire 
    where page=$1 and formation=$2 and stagiaire=$3;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_page_commentaire(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7842 (class 0 OID 0)
-- Dependencies: 1144
-- Name: FUNCTION af_get_page_commentaire(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_page_commentaire(integer, integer, integer) IS 'retourne le commentaire pour une page';


--
-- TOC entry 1145 (class 1255 OID 2595957)
-- Dependencies: 2983 5
-- Name: af_get_page_elements(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_page_elements() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select id,libelle from contraintes.page_element
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_page_elements() OWNER TO pgsql;

--
-- TOC entry 7844 (class 0 OID 0)
-- Dependencies: 1145
-- Name: FUNCTION af_get_page_elements(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_page_elements() IS 'retourne les elements (des pages) de la plateforme';


--
-- TOC entry 1146 (class 1255 OID 2595958)
-- Dependencies: 2983 5
-- Name: af_get_page_elements(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_page_elements(integer) RETURNS SETOF record
    AS $_$-- $1 : page
declare
rec record;
begin
    for rec in
	select id,libelle,page from contraintes.af_get_page_elements() as (id int4,libelle varchar),contraintes.page_elements 
	where id=page_element and page=$1 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_page_elements(integer) OWNER TO pgsql;

--
-- TOC entry 7846 (class 0 OID 0)
-- Dependencies: 1146
-- Name: FUNCTION af_get_page_elements(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_page_elements(integer) IS 'retourne les elements pour une page';


--
-- TOC entry 1147 (class 1255 OID 2595959)
-- Dependencies: 2983 5
-- Name: af_get_page_liste(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_page_liste(integer, integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : liste
-- $4 : page
declare
rec record;
begin
    select into rec titre,commentaire,formation,parcours,liste,page 
    from contraintes.page_liste 
    where formation=$1 and parcours=$2 and liste=$3 and page=$4;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_page_liste(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7848 (class 0 OID 0)
-- Dependencies: 1147
-- Name: FUNCTION af_get_page_liste(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_page_liste(integer, integer, integer, integer) IS 'retourne titre et commentaire d''une page de liste';


--
-- TOC entry 1148 (class 1255 OID 2595960)
-- Dependencies: 2983 5
-- Name: af_get_page_liste_configuration(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_page_liste_configuration(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : liste
-- $4 : page
declare
rec record;
begin
    for rec in
	select page_element,formation,parcours,liste,page
	from contraintes.page_liste_configuration 
	where formation=$1 and parcours=$2 and liste=$3 and page=$4
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_page_liste_configuration(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7850 (class 0 OID 0)
-- Dependencies: 1148
-- Name: FUNCTION af_get_page_liste_configuration(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_page_liste_configuration(integer, integer, integer, integer) IS 'retourne la configuration d''une page de liste';


--
-- TOC entry 1149 (class 1255 OID 2595961)
-- Dependencies: 2983 5
-- Name: af_get_page_ressource_configuration(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_page_ressource_configuration(integer, integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : parcours
-- $4 : etape_ressource
declare
rec record;
begin
    select into rec formation,page,parcours,etape_ressource,commentaire  
    from contraintes.page_ressource_configuration
    where formation=$1 and page=$2 and parcours=$3 and etape_ressource=$4;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_page_ressource_configuration(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7852 (class 0 OID 0)
-- Dependencies: 1149
-- Name: FUNCTION af_get_page_ressource_configuration(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_page_ressource_configuration(integer, integer, integer, integer) IS 'retourne la configuration d''une page de ressource';


--
-- TOC entry 1150 (class 1255 OID 2595962)
-- Dependencies: 2983 5
-- Name: af_get_page_type_pages(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_page_type_pages(integer) RETURNS SETOF record
    AS $_$-- $1 : type de page
declare
rec record;
begin
    for rec in
	select * from contraintes.page where type=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_page_type_pages(integer) OWNER TO pgsql;

--
-- TOC entry 7854 (class 0 OID 0)
-- Dependencies: 1150
-- Name: FUNCTION af_get_page_type_pages(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_page_type_pages(integer) IS 'retourne les page d''un type de page';


--
-- TOC entry 1151 (class 1255 OID 2595963)
-- Dependencies: 2983 5
-- Name: af_get_pages_types(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_pages_types() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,code from contraintes.page_type
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_pages_types() OWNER TO pgsql;

--
-- TOC entry 7856 (class 0 OID 0)
-- Dependencies: 1151
-- Name: FUNCTION af_get_pages_types(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_pages_types() IS 'retourne les types de page de la plateforme';


--
-- TOC entry 1152 (class 1255 OID 2595964)
-- Dependencies: 2983 5
-- Name: af_get_parcours(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT E.id, E.libelle, P.filiere, P.duree, E.date_creation  FROM contraintes.etape E 
		, contraintes.parcours P  
		WHERE P.id = E.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours() OWNER TO pgsql;

--
-- TOC entry 1153 (class 1255 OID 2595965)
-- Dependencies: 2983 5
-- Name: af_get_parcours(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours(integer) RETURNS record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	IF $1 IS NULL THEN
		RETURN NULL;
	END IF;

	SELECT INTO rec  E.id, E.libelle, P.filiere, P.duree, E.date_creation  FROM contraintes.etape E 
	LEFT OUTER JOIN contraintes.parcours P  
	ON (P.id=E.id)
	WHERE E.id=$1;
	
	/*SELECT INTO rec * FROM contraintes.af_get_parcours() AS (id int4, libelle varchar, filiere int4, duree bool, date_creation timestamp) 
	WHERE id=$1;*/

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 1856 (class 1255 OID 2595966)
-- Dependencies: 2983 5
-- Name: af_get_parcours_all_formations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_all_formations(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
rec record;
rec1 RECORD;
rec2 RECORD;
rec3 RECORD;
rec4 RECORD;
id_pere int4;
parcours_pere integer;
nb_formations int4;
BEGIN
	--raise notice 'parc=%',$1;
    FOR rec1 IN
	--selectionne la formation
	SELECT * FROM contraintes.af_get_formations() AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4,ressources_fusionnees boolean)
	WHERE parcours=$1
    LOOP
	RETURN NEXT rec1;
	
    END LOOP;

    -- boucle sur les peres du parcours
    for rec in
	select pere from contraintes.af_get_parcours_parcours_pere($1) pere
    loop
	--raise notice 'pere=%',rec.pere;
	for rec2 in
	    SELECT * FROM contraintes.af_get_parcours_all_formations(rec.pere) AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4,ressources_fusionnees boolean)
	loop
	    return next rec2;
	end loop;
    end loop;

    -- boucle sur les parcours orientes ayant le parcours comme sous_parcours

    for rec4 in 
	select distinct parcours from contraintes.af_get_parcourss_orientes() 
	as(parcours integer,sous_parcours integer) 
	where sous_parcours=$1
    loop
	raise notice 'parcours=%',rec4.parcours;
	for rec3 in
	    SELECT * FROM contraintes.af_get_parcours_all_formations(rec4.parcours) AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4,ressources_fusionnees boolean)
	loop
	    return next rec3;
	end loop;

    end loop;

    
		

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_all_formations(integer) OWNER TO pgsql;

--
-- TOC entry 7860 (class 0 OID 0)
-- Dependencies: 1856
-- Name: FUNCTION af_get_parcours_all_formations(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_parcours_all_formations(integer) IS 'Obtenir les formations qui utilisent un parcours';


--
-- TOC entry 1154 (class 1255 OID 2595967)
-- Dependencies: 2983 5
-- Name: af_get_parcours_avancement(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_avancement(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN

	FOR rec IN
		SELECT e_parcours, e_id, A.formation, A.stagiaire, type
		FROM contraintes.af_get_parcours_etapes($1) 
		AS (e_id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, e_parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar,modifiable bool)
		LEFT OUTER JOIN contraintes.resultat  A
		ON(etape=e_id AND e_parcours=A.parcours)
		WHERE e_parcours=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_avancement(integer) OWNER TO pgsql;

--
-- TOC entry 1155 (class 1255 OID 2595968)
-- Dependencies: 2983 5
-- Name: af_get_parcours_avancement_max(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_avancement_max(integer) RETURNS record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
rec_etape RECORD;
etape_prec int4:=NULL;
BEGIN
	FOR rec IN 
		--on recupere l'avancement du parcours
		SELECT * FROM contraintes.af_get_parcours_avancement($1) AS (parcours int4, etape int4, formation int4, stagiaire int4 , type varchar)
	LOOP
		--cas pour la premiere etape
		IF etape_prec IS NULL THEN
			etape_prec:=rec.etape;
		ELSE
		
			--on suppose que si l'etape n'a pas encore été faite, etape_prec contient la derniere etape faite
			IF rec.formation IS NULL THEN
				--on recupere donc les informations de etape_prec
				SELECT INTO rec_etape * FROM contraintes.af_get_parcours_etape($1, etape_prec)  AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar);
				
				--si etape_prec est une etape obligatoire, il s'agit bien de la derniere etape faite
				IF rec_etape.obligatoire IS TRUE THEN
					--on la renvoie donc, sinon on continu a chercher	
					RETURN rec_etape;
				END IF;
			END IF;
			etape_prec:=rec.etape;
		END IF;

	END LOOP;

	RETURN NULL;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_avancement_max(integer) OWNER TO pgsql;

--
-- TOC entry 1156 (class 1255 OID 2595969)
-- Dependencies: 2983 5
-- Name: af_get_parcours_chats_disponibles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_chats_disponibles(integer) RETURNS SETOF record
    AS $_$-- $1 : parcours
declare
rec record;
begin
    for rec in
	select ef_id,ef_libelle_etape from contraintes.af_get_etapes_chats() 
	as 
	(ef_id int4,ef_libelle_etape varchar,type int4,date_creation timestamp)
	left outer join contraintes.af_gen_get_elements('contraintes.parcours_etapes', 'etape', NULL, 'AND parcours='||$1,1) elt 
	on (elt.id=ef_id) 
	where elt.id is null
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_chats_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 7864 (class 0 OID 0)
-- Dependencies: 1156
-- Name: FUNCTION af_get_parcours_chats_disponibles(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_parcours_chats_disponibles(integer) IS 'retourne les chats disponible pour un parcours';


--
-- TOC entry 1157 (class 1255 OID 2595970)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etape(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etape(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 parcours
--$2 etape
rec RECORD;
BEGIN
	SELECT INTO rec PE.etape, E.libelle, E.libelle, PE.libelle_type_etape, CAST(E.type AS varchar),  PE.pere, PE.parcours, PE.obligatoire, PE.chrono, PE.fin, T.libelle 
	FROM contraintes.parcours_etapes PE, contraintes.etape E, contraintes.etape_type T
	WHERE PE.etape=$2 AND PE.etape=E.id
	AND E.type=T.id
	AND PE.parcours=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etape(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1158 (class 1255 OID 2595971)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etape_fille(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etape_fille(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 parcours
--$2 identifiant de l'etape père
rec RECORD;
BEGIN
	IF $2 IS NOT NULL THEN
		SELECT INTO rec * FROM contraintes.af_get_parcours_etapes($1)
		AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape varchar, type varchar, pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		WHERE pere=$2;
	ELSE
		SELECT INTO rec * FROM contraintes.af_get_parcours_etapes($1)
		AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape varchar, type varchar, pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		WHERE pere IS NULL;
	END IF;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etape_fille(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1159 (class 1255 OID 2595972)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 numéro du parcours
/*filiere_id int4;
niveau int4;*/
ss_parcours RECORD;
BEGIN
	FOR ss_parcours IN
		SELECT * FROM contraintes.af_get_parcours_sous_parcourss_disponibles($1) 
		AS  (id int4, libelle varchar, filiere int4, duree bool, date_creation timestamp, indice integer)
	LOOP
		RETURN NEXT ss_parcours;
	END LOOP;

	RETURN;
	/*--selection de la filiere du parcours
	SELECT INTO filiere_id filiere FROM contraintes.parcours
	WHERE id =$1;

	--selection du niveau de la filiere
	SELECT INTO niveau * FROM contraintes.af_gen_get_element_niveau('contraintes.filiere','id', filiere_id, '',0);
	RAISE NOTICE 'filiere parcours: % niveau parcours=%',filiere_id,niveau;
	
	--selection des sous parcours disponibles pour le parcours
	FOR ss_parcours IN
		SELECT P_id, P_libelle, P_filiere, P_duree, P_date_creation,F_indice FROM contraintes.af_get_filieres()AS (F_id int4, F_libelle varchar, F_pere int4, F_indice int4),
		contraintes.af_get_parcours()AS (P_id integer, P_libelle varchar, P_filiere int4 , P_duree bool, P_date_creation timestamp)
		WHERE F_indice=(niveau+1)
		AND P_filiere=F_id
	LOOP
		RETURN NEXT ss_parcours;
	END LOOP;

	RETURN;*/
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 1160 (class 1255 OID 2595973)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etape_resultats(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etape_resultats(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, formation, stagiaire, parcours,  etape, date_debut, duree
		FROM contraintes.resultat
		WHERE parcours=$1 and etape=$2
	LOOP 
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etape_resultats(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1161 (class 1255 OID 2595974)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etapes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etapes(integer) RETURNS SETOF record
    AS $_$DECLARE 
--$1 parcours
rec RECORD;
modif bool;
sous_type contraintes.type_element;
BEGIN
	FOR rec IN
		SELECT PE.etape, E.libelle, E.libelle, PE.libelle_type_etape, CAST(E.type AS varchar) AS type,  PE.pere, PE.parcours, PE.obligatoire, PE.chrono, PE.fin, T.libelle AS libelle_type_original, CAST(NULL AS bool) AS modifiable
		FROM contraintes.af_gen_get_elements('contraintes.parcours_etapes', 'etape', NULL, 'AND parcours='||$1,1) elt, contraintes.parcours_etapes PE, contraintes.etape E, contraintes.etape_type T
		WHERE elt.id=PE.etape AND PE.etape=E.id
		AND E.type=T.id
		AND PE.parcours=$1
		ORDER BY elt.ind
	LOOP
		--Cas speciaux: les types ayant des sous types
		SELECT INTO sous_type * FROM contraintes.af_get_etape_type_sous_type(rec.etape, CAST(rec.type AS int4), rec.libelle_type_original);
		rec.type:=sous_type.id;
		rec.libelle_type_original:=sous_type.libelle;

		--l'etape est elle modifiable?
		SELECT INTO modif * FROM contraintes.af_is_parcours_etape_modifiable($1, rec.etape, rec.type);
		rec.modifiable:=modif;

		--les series générées par les test
		IF rec.type='4_1_4' THEN

		END IF;

		RETURN NEXT rec;
	END LOOP;

	/*----------------------------------
	--      ETAPES SANS THEMES      --
	----------------------------------

	--les types d'étapes spéciales: forum (2), chat(8) et etape titre(9)
	FOR rec_spe IN 
		SELECT CAST(NULL AS int4) AS id,  CAST(NULL AS varchar) AS  libelle,CAST(NULL AS varchar) AS  libelle2,CAST(id AS varchar) AS type, libelle  AS libelle_type
		FROM contraintes.etape_type T
		WHERE id IN (2,8,9)
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	FOR rec_ss_parcours IN 
		SELECT P_id,  P_libelle, P_libelle, CAST('1' AS varchar) AS type, libelle  AS libelle_type
		FROM contraintes.af_get_parcours_sous_parcourss_disponibles(num_parcours) AS (P_id int4, P_libelle varchar, filiere int4, duree bool),
		contraintes.etape_type T
		WHERE 1=T.id
	LOOP
		RETURN NEXT rec_ss_parcours;
	END LOOP;*/

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etapes(integer) OWNER TO pgsql;

--
-- TOC entry 1162 (class 1255 OID 2595975)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etapes_deroulees(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etapes_deroulees(integer) RETURNS SETOF record
    AS $_$DECLARE 
--$1 parcours
rec RECORD;
rec_p RECORD;
BEGIN
	--recup des etapes du parcours
	FOR rec IN
		SELECT * FROM contraintes.af_get_parcours_etapes($1) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		--SELECT PE.etape AS id_etape, E.libelle, E.libelle, E.type,  PE.pere, PE.parcours, PE.obligatoire, PE.chrono, PE.fin 
		--FROM contraintes.af_gen_get_elements('contraintes.parcours_etapes', 'etape', NULL, 'AND parcours='||$1) P_ID, contraintes.parcours_etapes PE, contraintes.etape E
		--WHERE P_ID=PE.etape AND PE.etape=E.id and PE.parcours=$1
	LOOP
		--Si etape de type parcours attaché, on recuperes ses etapes par recursivite
		IF rec.type='1' THEN
			FOR rec_p IN
				SELECT * FROM contraintes.af_get_parcours_etapes_deroulees(rec.id) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
			LOOP
				RETURN NEXT rec_p;
			END LOOP;
		ELSE
			RETURN NEXT rec;
		END IF;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etapes_deroulees(integer) OWNER TO pgsql;

--
-- TOC entry 1857 (class 1255 OID 2595976)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE 
--$1 formation
--$2 individu
--$3 parcours
rec RECORD;
rec_resultat record;
rec_p RECORD;
sous_parcours integer;
indice integer;
BEGIN
    --recup des etapes du parcours
    FOR rec IN
	SELECT * FROM contraintes.af_get_parcours_etapes($3) 
	AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    LOOP
	--Si etape de type parcours attaché, on recuperes ses etapes par recursivite
	IF rec.type='1' THEN
	    FOR rec_p IN
		SELECT * FROM contraintes.af_get_parcours_etapes_deroulees_formation_individu($1,$2,rec.id) 
		AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
	    LOOP
		RETURN NEXT rec_p;
	    END LOOP;
	ELSE
	    RETURN NEXT rec;
	    -- si etape parcours oriente
	    if rec.type='10' then
		-- test si l'etape a été faite
		select into rec_resultat * from contraintes.af_get_resultat($1,$2,$3,rec.id) 
		as (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
		if rec_resultat.id is not null then
		    -- recup sous-parcours 
		    select into sous_parcours * from contraintes.af_get_resultat_parcours_parcours_oriente(rec_resultat.id);
		    for rec_p in 
			--SELECT *,indice AS indic FROM contraintes.af_get_parcours_etapes_deroulees_formation_individu($1,$2,sous_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
			SELECT * FROM contraintes.af_get_parcours_etapes_deroulees_formation_individu($1,$2,sous_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		
		    loop
			    --rec_p.indic:=indice;
			RETURN NEXT rec_p;
			    --indice:=indice+1;
		    end loop;
		end if;
	    --end if;--else
	    end if;
	END IF;
    END LOOP;
    RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7872 (class 0 OID 0)
-- Dependencies: 1857
-- Name: FUNCTION af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) IS 'deroule les etapes d''un parcours pour un individu y compris les etapes de sous-parcours issus d''etape parcours oriente
(suivant les resultats de l''individu)';


--
-- TOC entry 1163 (class 1255 OID 2595977)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etapes_disponibles_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etapes_disponibles_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
--$2 theme
rec RECORD;
rec_spe RECORD;
rec_ss_parcours RECORD;
num_parcours int4;
nb_serie_generee int4;
sous_type contraintes.type_element;
BEGIN
	num_parcours:=$1;
	--IF num_parcours IS NULL THEN
	--	num_parcours:=0;
	--END IF;

	--on recupere tous les elements de la categorie etape, avec les type_d'etapes
	FOR rec IN 
		SELECT I_D AS id,  E.libelle AS libelle, CAST(E.type AS varchar) AS type, T.libelle  AS libelle_type
		FROM (contraintes.etape E 
		LEFT OUTER JOIN contraintes.parcours_etapes P
		ON E.id=P.etape AND P.parcours=num_parcours) 
		LEFT OUTER JOIN contraintes.af_get_categorie_elements_theme(29 ,$2) I_D
		ON E.id=I_D,contraintes.etape_type T
		WHERE P.etape IS NULL
		AND I_D IS NOT NULL
		AND E.type=T.id
		AND E.type!=10
		ORDER BY T.ordre

	LOOP
		--Cas speciaux: les types ayant des sous types
		SELECT INTO sous_type * FROM contraintes.af_get_etape_type_sous_type(rec.id, CAST(rec.type AS int4), rec.libelle_type)
		ORDER BY sous_type.id;
		rec.type:=sous_type.id;
		rec.libelle_type:=sous_type.libelle;

		--cas des séries générées par les test de positionnement
		IF FALSE AND rec.type='4_1_4' THEN
			SELECT INTO nb_serie_generee COUNT(*) FROM (
				--recup de toutes les séries générées par les test dynamiques du parcours
				SELECT P.serie_aleatoire FROM contraintes.af_get_parcours_etapes_type($1, '4_3') AS (PE_id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool, indice int4),
				contraintes.test T, contraintes.test_positionnements TP, contraintes.positionnement P
				WHERE PE_id=T.id
				AND T.dynamique IS TRUE
				AND T.id=TP.test
				AND P.id=TP.positionnement
			) as series_aleatoires
			--recup des séries générées déjà dans le parcours
			LEFT OUTER JOIN contraintes.af_get_parcours_etapes_type($1, '4_1_4') AS (series_aleatoire_id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool, indice int4)
			ON (series_aleatoire_id=series_aleatoires.serie_aleatoire)
			WHERE series_aleatoire_id IS NULL
			AND series_aleatoires.serie_aleatoire=rec.id;
			
			IF nb_serie_generee>0 THEN
				RETURN NEXT rec;
			END IF;
		ELSE
			RETURN NEXT rec;
		END IF;
	END LOOP;
	
	----------------------------------
	--      ETAPES SANS THEMES      --
	----------------------------------

	--les types d'étapes spéciales: forum (2), chat(8) et etape titre(9)
	FOR rec_spe IN 
		SELECT CAST(NULL AS int4) AS id,  CAST(NULL AS varchar) AS  libelle, CAST(9 AS varchar) AS type, libelle  AS libelle_type
		FROM contraintes.etape_type T
		WHERE T.id=9
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	--les types d'étapes forum (2)
	
	FOR rec_spe IN 
		SELECT P_id,  P_libelle, cast('2' as varchar), T.libelle  AS libelle_type
		FROM contraintes.etape_type T,contraintes.af_get_parcours_forums_disponibles(num_parcours) AS (P_id int4, P_libelle varchar)
		WHERE T.id=2 
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	-- type chat
	FOR rec_spe IN 
		SELECT P_id,  P_libelle, cast('8' as varchar), T.libelle  AS libelle_type
		FROM contraintes.etape_type T,contraintes.af_get_parcours_chats_disponibles(num_parcours) AS (P_id int4, P_libelle varchar)
		WHERE T.id=8 
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	

	--les sous parcours
	FOR rec_ss_parcours IN 
		SELECT P_id,  P_libelle, CAST('1' AS varchar) AS type, libelle  AS libelle_type
		FROM contraintes.af_get_parcours_sous_parcourss_disponibles(num_parcours) AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool, P_date_creation timestamp, P_indice integer),
		contraintes.etape_type T
		WHERE 1=T.id
	LOOP
		RETURN NEXT rec_ss_parcours;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etapes_disponibles_theme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1858 (class 1255 OID 2595978)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etapes_duree_type(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etapes_duree_type(integer, character varying) RETURNS integer
    AS $_$DECLARE
--$1 parcours
--$2 type
rec RECORD;
somme int4;
BEGIN
	SELECT INTO somme SUM(chrono)
	FROM contraintes.af_get_parcours_etapes($1)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
	WHERE type NOT LIKE '4_1_4%'
	AND type LIKE $2||'%';
	
	RETURN somme;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etapes_duree_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1164 (class 1255 OID 2595979)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etapes_durees_type(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etapes_durees_type(integer, character varying) RETURNS SETOF integer
    AS $_$DECLARE
--$1 parcours
--$2 type
rec RECORD;
somme int4;
BEGIN
	FOR rec IN
		SELECT DISTINCT chrono
		FROM contraintes.af_get_parcours_etapes($1)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		WHERE type NOT LIKE '4_1_4%'
		AND chrono IS NOT NULL
		AND type LIKE $2||'%'
	LOOP
		RETURN NEXT rec.chrono;
	END LOOP;
	
	RETURN;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etapes_durees_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1165 (class 1255 OID 2595980)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etapes_durees_type_distincts(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etapes_durees_type_distincts(integer, character varying) RETURNS SETOF integer
    AS $_$DECLARE
--$1 parcours
--$2 type
rec RECORD;
somme int4;
BEGIN
	FOR rec IN
		SELECT DISTINCT chrono
		FROM contraintes.af_get_parcours_etapes($1)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		WHERE type NOT LIKE '4_1_4%'
		AND type LIKE $2||'%'
	LOOP
		RETURN NEXT rec.chrono;
	END LOOP;
	
	RETURN;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etapes_durees_type_distincts(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1166 (class 1255 OID 2595981)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etapes_durees_valuees(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etapes_durees_valuees(integer) RETURNS SETOF integer
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	FOR rec IN
		SELECT chrono 
		FROM contraintes.parcours_etapes P--, contraintes.etape E
		WHERE chrono IS NOT NULL
		AND parcours=$1
		/*WHERE P.etape=E.id 
		AND P.parcours=$1
		AND E.type !=6
		AND E.type !=2
		AND E.type !=8
		AND E.type !=7
		AND E.type !=5*/
	LOOP
		RETURN NEXT rec.chrono;
	END LOOP;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etapes_durees_valuees(integer) OWNER TO pgsql;

--
-- TOC entry 1167 (class 1255 OID 2595982)
-- Dependencies: 2983 5
-- Name: af_get_parcours_etapes_type(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_etapes_type(integer, character varying) RETURNS SETOF record
    AS $_$declare
--$1 parcours
--$2 type d'étape
rec record;
indice int4;

begin
    indice:=0;
    for rec in
	SELECT id , libelle_alias, libelle , libelle_type_etape  , type ,  pere , parcours , obligatoire , chrono , fin , libelle_type_original , modifiable , CAST(NULL AS int4) AS ind
	FROM contraintes.af_get_parcours_etapes($1) 
	AS  (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    loop
	indice :=indice + 1;
	if(rec.type like $2||'%') then
	     rec.ind:=indice;	
	    return next rec;
	end if;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_etapes_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1168 (class 1255 OID 2595983)
-- Dependencies: 2983 5
-- Name: af_get_parcours_formations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_formations(integer) RETURNS SETOF record
    AS $_$-- $1 : parcours
declare
rec record;
begin
    for rec in
	SELECT * FROM contraintes.af_get_formations() AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4,ressources_fusionnees boolean)
	WHERE parcours=$1
    loop
	return next rec;
    end loop;

end;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_formations(integer) OWNER TO pgsql;

--
-- TOC entry 7880 (class 0 OID 0)
-- Dependencies: 1168
-- Name: FUNCTION af_get_parcours_formations(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_parcours_formations(integer) IS 'retourne les formations dont le parcours est principal';


--
-- TOC entry 1169 (class 1255 OID 2595984)
-- Dependencies: 2983 5
-- Name: af_get_parcours_forums_disponibles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_forums_disponibles(integer) RETURNS SETOF record
    AS $_$-- $1 : parcours
declare
rec record;
begin
    for rec in
	select ef_id,ef_libelle_etape from contraintes.af_get_etapes_forum() 
	as 
	(ef_id int4,ef_libelle_etape varchar,forum int4,libelle varchar,description varchar,moderation bool,moderateur_pwd varchar,fils int4,messages int4,upload bool,theme varchar,configuration int4,date_creation timestamp)
	left outer join contraintes.af_gen_get_elements('contraintes.parcours_etapes', 'etape', NULL, 'AND parcours='||$1,1) elt 
	on (elt.id=ef_id) 
	where elt.id is null
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_forums_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 7882 (class 0 OID 0)
-- Dependencies: 1169
-- Name: FUNCTION af_get_parcours_forums_disponibles(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_parcours_forums_disponibles(integer) IS 'retourne les etapes forums disponibles pour un parcours';


--
-- TOC entry 1170 (class 1255 OID 2595985)
-- Dependencies: 2983 5
-- Name: af_get_parcours_mode_affichage(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_mode_affichage(integer) RETURNS integer
    AS $_$DECLARE
--$1 parcours
BEGIN

    SELECT count(*) INTO mode_affich
    FROM gestparcours
    WHERE g_num_parcours = $1
    AND num_etape_suivante = 1 ;

    IF (mode_affich>0) THEN
        RETURN(2) ;
    END IF ;

    SELECT count(*) INTO mode_affich
    FROM gestparcours
    WHERE g_num_parcours = $1
    AND type_etape = 'I' ;

    IF (mode_affich>0) THEN
        RETURN(1) ;
    ELSE
        RETURN(0) ;
    END IF ;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_mode_affichage(integer) OWNER TO pgsql;

--
-- TOC entry 1171 (class 1255 OID 2595986)
-- Dependencies: 2983 5
-- Name: af_get_parcours_oriente_configuration(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_oriente_configuration(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 etape parcours oriente
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id,sous_parcours, type, seuil
		FROM contraintes.parcours_oriente
		WHERE id=$1
		ORDER BY ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_oriente_configuration(integer) OWNER TO pgsql;

--
-- TOC entry 1172 (class 1255 OID 2595987)
-- Dependencies: 2983 5
-- Name: af_get_parcours_oriente_sous_parcours(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_oriente_sous_parcours(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT P_id, libelle, filiere, ordre 
		FROM contraintes.parcours_oriente PO, contraintes.af_get_parcours() AS (P_id int4, libelle varchar, filiere int4, duree bool,date_creation timestamp)
		WHERE sous_parcours=P_id
		AND PO.id=$1
		ORDER BY ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_oriente_sous_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 1173 (class 1255 OID 2595988)
-- Dependencies: 2983 5
-- Name: af_get_parcours_orientes_sous_parcours(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_orientes_sous_parcours() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT P_id, libelle, filiere 
		FROM contraintes.parcours_oriente PO, contraintes.af_get_parcours() AS (P_id int4, libelle varchar, filiere int4, duree bool,date_creation timestamp)
		WHERE sous_parcours=P_id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_orientes_sous_parcours() OWNER TO pgsql;

--
-- TOC entry 1174 (class 1255 OID 2595989)
-- Dependencies: 2983 5
-- Name: af_get_parcours_parcours_pere(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_parcours_pere(integer) RETURNS SETOF integer
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
	    /*
		SELECT E.pere AS id FROM contraintes.parcours_etapes E, contraintes.parcours P
		WHERE E.etape=$1
		AND E.pere IS NOT NULL
		AND E.pere=P.id
	    */
	    select E.parcours as id from contraintes.parcours_etapes E,contraintes.parcours P
	    where E.etape=$1
	    and p.id=E.parcours
	LOOP
		RETURN NEXT rec.id;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_parcours_pere(integer) OWNER TO pgsql;

--
-- TOC entry 1175 (class 1255 OID 2595990)
-- Dependencies: 2983 5
-- Name: af_get_parcours_ressources(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_ressources(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT R.id, R.fichier , ER.espace , ER.section , PE_id , PE_parcours 
		FROM contraintes.af_get_parcours_etapes($1) AS (PE_id int4, PE_libelle varchar, PE_libelle_type_etape  varchar, PE_type int4,  PE_pere int4, PE_parcours int4, PE_obligatoire bool, PE_chrono int4, PE_fin bool),
		contraintes.ressource R, contraintes.etape_ressource ER
		WHERE PE_parcours=$1 
		AND PE_type=7
		AND ER.id=PE_id
		AND ER.ressource=R.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_ressources(integer) OWNER TO pgsql;

--
-- TOC entry 1176 (class 1255 OID 2595991)
-- Dependencies: 2983 5
-- Name: af_get_parcours_sous_parcourss_disponibles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_sous_parcourss_disponibles(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 numéro du parcours
filiere_id int4;
niveau int4;
ss_parcours RECORD;
BEGIN
	--selection de la filiere du parcours
	SELECT INTO filiere_id filiere FROM contraintes.parcours
	WHERE id =$1;

	--selection du niveau de la filiere
	SELECT INTO niveau * FROM contraintes.af_gen_get_element_niveau('contraintes.filiere','id', filiere_id, '',0);
	--RAISE NOTICE 'filiere parcours: % niveau parcours=%',filiere_id,niveau;
	
	--selection des sous parcours disponibles pour le parcours
	FOR ss_parcours IN
		SELECT P_id, P_libelle, P_filiere, P_duree, P_date_creation,F_indice FROM contraintes.af_get_filieres()AS (F_id int4, F_libelle varchar, F_pere int4, F_indice int4),
		contraintes.af_get_parcours()AS (P_id integer, P_libelle varchar, P_filiere int4 , P_duree bool, P_date_creation timestamp) 
		LEFT OUTER JOIN contraintes.af_get_parcours_etapes(727) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		ON (P_id=id AND type LIKE '1')
		WHERE F_indice=(niveau+1)
		AND P_filiere=F_id
		AND id IS NULL
	LOOP
		RETURN NEXT ss_parcours;
	END LOOP;

	RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_sous_parcourss_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 1177 (class 1255 OID 2595992)
-- Dependencies: 2983 5
-- Name: af_get_parcours_type_etape_personnalise(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_type_etape_personnalise(integer, character varying) RETURNS SETOF character varying
    AS $_$DECLARE
--$1 parcours
--$2 type d'etape
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT P.libelle_type_etape AS libelle
		FROM contraintes.parcours_etapes P, contraintes.etape E
		WHERE P.parcours=$1
		--AND E.type LIKE $2||'%'
		AND E.type LIKE $2
		AND E.id=P.etape
	LOOP
		RETURN NEXT rec.libelle;
	END LOOP;
	
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_type_etape_personnalise(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1178 (class 1255 OID 2595993)
-- Dependencies: 2983 5
-- Name: af_get_parcours_types_etapes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_types_etapes(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	FOR rec IN
		SELECT  type, libelle_type_original, CAST(COUNT (type)AS int4) FROM contraintes.af_get_parcours_etapes($1) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		GROUP BY type,libelle_type_original
		ORDER BY type
		/*SELECT DISTINCT T.id, T.libelle 
		FROM contraintes.parcours_etapes P, contraintes.etape_type T, contraintes.etape E
		WHERE P.parcours=$1 
		AND P.etape=E.id
		AND E.type=T.id*/
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_types_etapes(integer) OWNER TO pgsql;

--
-- TOC entry 1179 (class 1255 OID 2595994)
-- Dependencies: 2983 5
-- Name: af_get_parcours_types_etapes_personnalises(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcours_types_etapes_personnalises(integer) RETURNS SETOF character varying
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT libelle_type_etape FROM contraintes.parcours_etapes
		WHERE parcours=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcours_types_etapes_personnalises(integer) OWNER TO pgsql;

--
-- TOC entry 1180 (class 1255 OID 2595995)
-- Dependencies: 2983 5
-- Name: af_get_parcourss_orientes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_parcourss_orientes() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,sous_parcours from contraintes.parcours_oriente
    loop
	return next rec;
    end loop;
    return;

end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_parcourss_orientes() OWNER TO pgsql;

--
-- TOC entry 7894 (class 0 OID 0)
-- Dependencies: 1180
-- Name: FUNCTION af_get_parcourss_orientes(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_parcourss_orientes() IS 'retourne les parcours oriente de la plateforme';


--
-- TOC entry 1181 (class 1255 OID 2595996)
-- Dependencies: 2983 5
-- Name: af_get_positionnement(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN

	
	SELECT INTO rec P.id, P.libelle, QR.type, P.chrono, P.serie_generee, P.bareme, S.chrono AS chrono_genere, QR.radio, P.qsrc, E.date_creation
	FROM contraintes.positionnement P, contraintes.serie S, contraintes.qsrc Q, contraintes.question_reponse QR, contraintes.evaluation E
	WHERE P.id=$1
	AND P.serie_generee=S.id
	AND P.qsrc=Q.id
	AND Q.id=QR.id
	AND P.qsrc=E.id;

	RETURN rec;
	
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement(integer) OWNER TO pgsql;

--
-- TOC entry 1182 (class 1255 OID 2595997)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_choix(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_choix(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;
	raise notice 'question_reponse=%',qr;
	FOR rec IN
		SELECT DISTINCT O_id,R.libelle,R.interpretation_html,R.reponse
		FROM contraintes.af_gen_get_elements('contraintes.choix', 'id', NULL, 'AND positionnement='||$1 ) O_id
		LEFT OUTER JOIN
		contraintes.question_reponse_element R
		ON O_id=R.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_choix(integer) OWNER TO pgsql;

--
-- TOC entry 1183 (class 1255 OID 2595998)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_choix_infos(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_choix_infos(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;

qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;
	
	FOR rec IN
		SELECT C_id  , A_libelle, A_interpretationHTML ,C.positionnement, C.bareme, C.pere ,M.media, M.hauteur, M.largeur 
		FROM (contraintes.choix C INNER JOIN 
		contraintes.af_gen_get_elements('contraintes.choix', 'id', NULL, 'AND positionnement='||$1 ) C_id 
		ON C_id= C.id)
		LEFT OUTER JOIN contraintes.media_question_reponse_element M 
		ON C_id=M.question_reponse_element AND M.question_reponse=qr
		LEFT OUTER JOIN contraintes.af_get_positionnement_choix($1) AS (A_id int4, A_libelle varchar, A_interpretationHTML bool, A_question bool)
		ON C_id=A_id
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_choix_infos(integer) OWNER TO pgsql;

--
-- TOC entry 1184 (class 1255 OID 2595999)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_choix_infos(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_choix_infos(integer, integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	
	
	SELECT INTO rec * FROM contraintes.af_get_positionnement_choix_infos($1)AS (id int4, libelle varchar, interpretationHTML bool, positionnement int4, bareme int4, pere int4, media int4, longueur int4, largeur int4)
	WHERE id=$2;
	

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_choix_infos(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1859 (class 1255 OID 2596000)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_count_evaluations_a_associer(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_count_evaluations_a_associer(integer) RETURNS integer
    AS $_$DECLARE
nb int4:=0;
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM contraintes.af_get_positionnement_nb_evaluations_a_generer($1) 
		AS (id int4, reponse int4, type int4, nb_a_generer int4, taille_chapeau int4)
	LOOP
		IF rec.taille_chapeau IS NULL THEN
			nb:=nb+rec.nb_a_generer;
		ELSE
			nb:=nb+rec.taille_chapeau;
		END IF;
	END LOOP;
	RETURN nb; 
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_count_evaluations_a_associer(integer) OWNER TO pgsql;

--
-- TOC entry 1185 (class 1255 OID 2596001)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_elements(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_elements(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;
	
	FOR rec IN
		SELECT DISTINCT E.question , E.choix
		FROM contraintes.positionnement_elements E, 
		contraintes.af_gen_get_elements('contraintes.question_reponse_elements', 'question', NULL, 'AND question_reponse='||qr ) O_id
		WHERE E.question=O_id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_elements(integer) OWNER TO pgsql;

--
-- TOC entry 1186 (class 1255 OID 2596002)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_evaluation_a_generer(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_evaluation_a_generer(integer, integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3 reponse
--$4 ordre
rec RECORD;
qr int4;
v_i int4:=0;
BEGIN

	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	FOR rec IN
		
		SELECT E.id, E.libelle, E.type, P.pere 
		FROM 
		
		contraintes.af_gen_get_elements('contraintes.positionnement_evaluations', 'evaluation', NULL, ' AND question_reponse='||qr ||' AND question='||$2||' AND choix='||$3) AS O_id,
		contraintes.evaluation E ,
		contraintes.positionnement_evaluations P 
			
		     
		WHERE P.evaluation=O_id
		AND E.id=O_id
		AND P.question_reponse=qr 
		AND P.question=$2
		AND P.choix=$3
	LOOP
		RAISE NOTICE '% % %',qr,$2,$3;
		v_i:=v_i+1;
		IF v_i=$4 THEN
			RETURN rec;
		END IF;
	END LOOP; 

	RETURN NULL;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_evaluation_a_generer(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1187 (class 1255 OID 2596003)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_evaluations_a_generer(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	SELECT INTO qr question_reponse FROM contraintes.positionnement
	WHERE positionnement=$1;
 
	FOR rec IN
		SELECT  T.id, T.libelle, T.type, E.question, E.reponse
		FROM contraintes.positionnement_elements E,
		contraintes.positionnement_evaluations V,
		--contraintes.af_gen_get_elements('contraintes.q', 'evaluation', NULL, 'AND question_reponse='||qr ) O_id,
		contraintes.evaluation T
		--WHERE O_id=V.question_reponse
		WHERE V.question_reponse=E.question_reponse
		AND E.question=$2
		AND E.choix=$3
		AND V.evaluation=T.id
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_evaluations_a_generer(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1188 (class 1255 OID 2596004)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_evaluations_a_generer(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	SELECT INTO qr question_reponse FROM contraintes.positionnement
	WHERE id=$1;
 
	FOR rec IN
		SELECT  E.id, E.libelle, E.type, EV.pere
		FROM contraintes.af_gen_get_elements('contraintes.positionnement_evaluations', 'evaluation', NULL, 'AND question_reponse='||qr||' AND question='||$2||' AND choix='||$3 ) O_id,
		contraintes.evaluation E,
		contraintes.positionnement_evaluations EV
		WHERE E.id=O_id
		AND E.type=$4
		AND EV.question_reponse=qr
		AND EV.question=$2
		AND EV.choix=$3 
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_evaluations_a_generer(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1189 (class 1255 OID 2596005)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_evaluations_a_generer(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_evaluations_a_generer(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	SELECT INTO qr qsrc FROM contraintes.positionnement
	WHERE id=$1;
 
	FOR rec IN
		SELECT  T.id, T.libelle, T.type, V.question, V.choix, CAST(NULL AS int4) AS pere
		FROM 
		--contraintes.positionnement_elements E,
		contraintes.positionnement_evaluations V,
		contraintes.evaluation T
		WHERE V.question_reponse=qr
		--AND V.question_reponse=E.question_reponse
		AND V.evaluation=T.id
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_evaluations_a_generer(integer) OWNER TO pgsql;

--
-- TOC entry 1190 (class 1255 OID 2596006)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_evaluations_affiliables_type(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_evaluations_affiliables_type(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 positionnement
--$2 theme
--$3 type
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;
	
	FOR rec IN
		SELECT DISTINCT E.id, E.libelle, E.type
		FROM ((contraintes.evaluation E INNER JOIN 
		contraintes.af_get_theme_evaluations($2) AS (T_id int4, T_type int4) ON T_id=E.id)
		LEFT OUTER JOIN	contraintes.positionnement_evaluations PE 
		ON T_id=PE.evaluation AND PE.question_reponse=qr)
		WHERE E.type=$3
		AND T_type=$3 
		AND PE.evaluation IS NULL 
		 
		--GROUP BY E.id,PE.evaluation, PE.question_reponse, E.libelle, E.type
		--HAVING E.id!=PE.evaluation 
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_evaluations_affiliables_type(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1191 (class 1255 OID 2596007)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_last_question(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_last_question(integer) RETURNS integer
    AS $_$DECLARE 
last_id int4;
question_reponse_id int4;

BEGIN
	--on recupere le question_reponse correscpondant au positionnement
	SELECT INTO question_reponse_id  question_reponse FROM contraintes.positionnement WHERE id=$1;
	
	IF question_reponse_id IS NOT NULL THEN
		SELECT INTO last_id ID FROM contraintes.af_gen_get_last_element('contraintes.question_reponse_elements', 'question',' AND question_reponse='||question_reponse_id);
		RETURN last_id;
	ELSE
		RETURN NULL;
	END IF;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_last_question(integer) OWNER TO pgsql;

--
-- TOC entry 1192 (class 1255 OID 2596008)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_media(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_media(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	SELECT INTO rec media, hauteur, largeur, question_reponse 
	FROM contraintes.af_get_question_reponse_media(qr) AS (  question_reponse int4, media int4, flash int4, hauteur int4, largeur int4 );

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_media(integer) OWNER TO pgsql;

--
-- TOC entry 1193 (class 1255 OID 2596009)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_nb_evaluations_a_generer(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_nb_evaluations_a_generer(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;

BEGIN
 
	FOR rec IN
		SELECT E.positionnement , E.choix , E.type , E.nombre , E.nombre_max 
		FROM contraintes.positionnement_choix_evaluations E,
		contraintes.af_gen_get_elements('contraintes.choix', 'id', NULL, 'AND positionnement='||$1 ) O_id
		WHERE O_id=E.choix
		AND E.positionnement=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_nb_evaluations_a_generer(integer) OWNER TO pgsql;

--
-- TOC entry 1194 (class 1255 OID 2596010)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_question_positionnement_solution(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_question_positionnement_solution(integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3 reponse
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	SELECT INTO rec * FROM contraintes.qcm_elements
	WHERE question_reponse=qr
	AND question=$2
	AND reponse=$3;
	raise notice 'qr=% q=% r=%', qr, $2,$3;
	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_question_positionnement_solution(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1195 (class 1255 OID 2596011)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_questions(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_questions(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;
	
	FOR rec IN
		SELECT DISTINCT Q.id,Q.libelle,Q.interpretation_html,Q.reponse, O_id.ind
		FROM contraintes.af_gen_get_elements('contraintes.question_reponse_elements', 'question', NULL, 'AND question_reponse='||qr , 0) O_id,
		contraintes.question_reponse_element Q
		WHERE O_id.id=Q.id
		ORDER BY O_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_questions(integer) OWNER TO pgsql;

--
-- TOC entry 1196 (class 1255 OID 2596012)
-- Dependencies: 2983 5
-- Name: af_get_positionnement_tests(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnement_tests(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 positionnement
rec RECORD;
BEGIN
	FOR rec IN

		SELECT DISTINCT E_id, E_libelle,  E_dynamique, E_continu, media , hauteur_media , largeur_media, date_creation   FROM contraintes.test_positionnements P,
		contraintes.af_get_tests() AS (E_id int4, E_libelle varchar,  E_dynamique bool, E_continu bool, media int4, hauteur_media int4, largeur_media int4, date_creation timestamp)
		WHERE E_id=P.test
		AND P.positionnement=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnement_tests(integer) OWNER TO pgsql;

--
-- TOC entry 1197 (class 1255 OID 2596013)
-- Dependencies: 2983 5
-- Name: af_get_positionnements(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_positionnements() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT P.id, P.libelle, P.type_question, P.chrono, P.serie_aleatoire, S.bareme, S.chrono
		FROM contraintes.positionnement P, contraintes.serie S
		WHERE P.serie_aleatoire=S.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_positionnements() OWNER TO pgsql;

--
-- TOC entry 1198 (class 1255 OID 2596014)
-- Dependencies: 2983 5
-- Name: af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
declare
rec record;
begin
    select into rec carton from contraintes.grille_resultats 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return rec;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 7914 (class 0 OID 0)
-- Dependencies: 1198
-- Name: FUNCTION af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) IS 'retourne le carton pour une capacite à une date';


--
-- TOC entry 1199 (class 1255 OID 2596015)
-- Dependencies: 2983 5
-- Name: af_get_presentiel_carton_individu(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_presentiel_carton_individu(integer, integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
declare
rec record;
begin
    for rec in
	select * from contraintes.grille_resultats 
	where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_presentiel_carton_individu(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7916 (class 0 OID 0)
-- Dependencies: 1199
-- Name: FUNCTION af_get_presentiel_carton_individu(integer, integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_presentiel_carton_individu(integer, integer, integer, integer, integer) IS 'retourne les notations presentielles pour un individu';


--
-- TOC entry 1200 (class 1255 OID 2596016)
-- Dependencies: 2983 5
-- Name: af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
declare
rec record;
begin
    select into rec commentaire,note,note_max from contraintes.grille_resultats 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 7918 (class 0 OID 0)
-- Dependencies: 1200
-- Name: FUNCTION af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) IS 'retourne la note pour une capacite à une date';


--
-- TOC entry 1201 (class 1255 OID 2596017)
-- Dependencies: 2983 5
-- Name: af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
declare
rec record;
begin
    select into rec * from contraintes.grille_resultats 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 7920 (class 0 OID 0)
-- Dependencies: 1201
-- Name: FUNCTION af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) IS 'retourne le resultat pour un individu à une date';


--
-- TOC entry 1202 (class 1255 OID 2596018)
-- Dependencies: 2983 5
-- Name: af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
declare
rec record;
begin
    for rec in
	select * from contraintes.grille_resultats 
	where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7922 (class 0 OID 0)
-- Dependencies: 1202
-- Name: FUNCTION af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) IS 'retourne les resultat presentiel d''un individu pour une capacite';


--
-- TOC entry 1203 (class 1255 OID 2596019)
-- Dependencies: 2983 5
-- Name: af_get_presentiel_resultats_individu_grille(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_presentiel_resultats_individu_grille(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
declare
rec record;
begin
    for rec in 
	select formation,stagiaire,grille,g.libelle,capacite_titre,ct.libelle,capacite,c.libelle,commentaire,note,note_max,carton,date 
	from contraintes.grille_resultats,
	contraintes.grille g,
	contraintes.capacite_titre ct,
	contraintes.capacite c 
	where formation=$1 and stagiaire=$2 and grille=$3 
	and grille=g.id and capacite_titre=ct.id and capacite=c.id
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_presentiel_resultats_individu_grille(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7924 (class 0 OID 0)
-- Dependencies: 1203
-- Name: FUNCTION af_get_presentiel_resultats_individu_grille(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_presentiel_resultats_individu_grille(integer, integer, integer) IS 'Obtenir les resultats presentiels pour un individu et une grille';


--
-- TOC entry 1204 (class 1255 OID 2596020)
-- Dependencies: 2983 5
-- Name: af_get_presentiel_stagiaire_grille(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_presentiel_stagiaire_grille(integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
declare
rec record;
begin
    select into rec * from contraintes.stagiaire_grille 
    where formation=$1 and stagiaire=$2 and grille=$3;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_presentiel_stagiaire_grille(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 7926 (class 0 OID 0)
-- Dependencies: 1204
-- Name: FUNCTION af_get_presentiel_stagiaire_grille(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_presentiel_stagiaire_grille(integer, integer, integer) IS 'retourne les infos de la table stagiaire_grille pour un stagiaire';


--
-- TOC entry 1205 (class 1255 OID 2596021)
-- Dependencies: 2983 5
-- Name: af_get_qrc_question_solution(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_qrc_question_solution(integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 qrc
--$2 question
--$3 reponse
rec RECORD;
qr int4;
BEGIN

	SELECT INTO rec * FROM contraintes.qcm_elements
	WHERE question_reponse=$1
	AND question=$2
	AND reponse=$3;
	--raise notice 'qr=% q=% r=%', qr, $2,$3;
	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_qrc_question_solution(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1206 (class 1255 OID 2596022)
-- Dependencies: 2983 5
-- Name: af_get_qsrc(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_qsrc(integer) RETURNS record
    AS $_$DECLARE
--$1 identifiant du qsrc
rec RECORD;
BEGIN
	SELECT INTO rec Q.id, E_libelle, Q.question, E_type,E_date_modification, radio
	FROM contraintes.qsrc Q, contraintes.af_get_evaluation($1) AS (E_id int4, E_libelle varchar, E_type int4,  E_date_modification timestamp),
	contraintes.question_reponse QR
	WHERE Q.id=E_id
	AND Q.id=$1
	AND QR.id=Q.id;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_qsrc(integer) OWNER TO pgsql;

--
-- TOC entry 1207 (class 1255 OID 2596023)
-- Dependencies: 2983 5
-- Name: af_get_qsrc_question_reponse(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_qsrc_question_reponse(integer) RETURNS integer
    AS $_$DECLARE
v_question_reponse integer;
BEGIN
	SELECT INTO v_question_reponse question_reponse 
	FROM contraintes.qsrc Q, contraintes.positionnement P
	WHERE Q.id=$1 
	AND Q.positionnement=P.id;

	RETURN v_question_reponse;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_qsrc_question_reponse(integer) OWNER TO pgsql;

--
-- TOC entry 1208 (class 1255 OID 2596024)
-- Dependencies: 2983 5
-- Name: af_get_qsrc_questions(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_qsrc_questions(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
    FOR rec IN
        /*
	SELECT DISTINCT Q.id,Q.libelle,Q.interpretation_html,Q.reponse, O_id.ind
	FROM contraintes.af_gen_get_elements('contraintes.question_reponse_elements', 'question', NULL, 'AND question_reponse='||$1 , 0) O_id,
	contraintes.question_reponse_element Q
	WHERE O_id.id=Q.id
	ORDER BY O_id.ind
	*/
	SELECT DISTINCT Q.id,Q.libelle,Q.interpretation_html,Q.reponse, O_id.ind
	FROM contraintes.af_gen_get_elements('contraintes.question_reponse_elements', 'question_reponse_element', NULL, 'AND question_reponse='||$1||'and question_reponse_element in (select id from contraintes.question_reponse_element where reponse is false)' , 0) O_id,
	contraintes.question_reponse_element Q
	WHERE O_id.id=Q.id
	ORDER BY O_id.ind
    LOOP
	RETURN NEXT rec;
    END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_qsrc_questions(integer) OWNER TO pgsql;

--
-- TOC entry 1209 (class 1255 OID 2596025)
-- Dependencies: 2983 5
-- Name: af_get_question(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_question(integer) RETURNS record
    AS $_$DECLARE
rec record;
BEGIN
	
	--select into rec from contraintes.af_get_question_reponse_element E, contraintes.question Q
	select  into rec E.id,E.libelle,E.interpretation_html from contraintes.question_reponse_element E, contraintes.question Q
	WHERE E.id=$1 AND E.id=Q.id;
	return rec;
	
	

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question(integer) OWNER TO postgres;

--
-- TOC entry 7932 (class 0 OID 0)
-- Dependencies: 1209
-- Name: FUNCTION af_get_question(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_question(integer) IS 'Obtenir une question.
';


--
-- TOC entry 1860 (class 1255 OID 2596026)
-- Dependencies: 2983 5
-- Name: af_get_question_positionnement_media(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_positionnement_media(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 idenfifiant de la question de positionnement
--$2 idenfifiant du positionnement
rec RECORD;
qr int4;
BEGIN
	SELECT INTO qr question_reponse FROM contraintes.positionnement
	WHERE id=$2;

	SELECT INTO rec question_reponse, question_reponse_element, media, media, hauteur, largeur 
	FROM contraintes.af_get_question_reponse_element_media(qr,$1) AS (question_reponse int4, question_reponse_element int4, media int4, flash int4, hauteur int4, largeur int4);
	

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_positionnement_media(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7934 (class 0 OID 0)
-- Dependencies: 1860
-- Name: FUNCTION af_get_question_positionnement_media(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_positionnement_media(integer, integer) IS 'Obtenir le media d''une question de positionnement pour un positionnement.';


--
-- TOC entry 1210 (class 1255 OID 2596027)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse(integer) RETURNS record
    AS $_$DECLARE
--$1 question_reponse
rec RECORD;
BEGIN
	SELECT INTO rec E.id, E.libelle, E.type, E.date_creation, QR.radio
	FROM contraintes.question_reponse QR, contraintes.evaluation E
	WHERE QR.id = $1
	AND QR.id=E.id;

	return rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse(integer) OWNER TO pgsql;

--
-- TOC entry 7936 (class 0 OID 0)
-- Dependencies: 1210
-- Name: FUNCTION af_get_question_reponse(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse(integer) IS 'Obtenir un question_reponse.';


--
-- TOC entry 1211 (class 1255 OID 2596028)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_association_elements(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_association_elements(integer) RETURNS SETOF record
    AS $_$

DECLARE
rec RECORD;
BEGIN

	FOR rec IN

		SELECT * FROM contraintes.question_reponse_elements
		WHERE question_reponse=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

		RETURN;

END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_association_elements(integer) OWNER TO pgsql;

--
-- TOC entry 7938 (class 0 OID 0)
-- Dependencies: 1211
-- Name: FUNCTION af_get_question_reponse_association_elements(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_association_elements(integer) IS 'Obtenir les éléments associés à un question_reponse.';


--
-- TOC entry 1212 (class 1255 OID 2596029)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_choix(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_choix(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 question_reponse
rec RECORD;
BEGIN
	FOR rec IN
		SELECT C_id.id  , R.libelle, R.interpretation_html ,C.question_reponse, C.bareme, C.pere ,M.media, M.hauteur, M.largeur 
		FROM (contraintes.choix C INNER JOIN 
		contraintes.af_gen_get_elements('contraintes.choix', 'id', NULL, 'AND question_reponse='||$1,0 ) C_id 
		ON C_id.id= C.id)
		LEFT OUTER JOIN contraintes.media_question_reponse_element M 
		ON C_id.id=M.question_reponse_element AND M.question_reponse=$1
		LEFT OUTER JOIN contraintes.question_reponse_element R
		ON R.id=C_id.id
		ORDER BY C_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_choix(integer) OWNER TO pgsql;

--
-- TOC entry 1213 (class 1255 OID 2596030)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_element(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_question_reponse_element(integer) RETURNS record
    AS $_$declare 
rec record;
begin
	
	select INTO rec id,libelle,interpretation_html, "type", reponse from contraintes.question_reponse_element 
	where id=$1;
	
	return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_element(integer) OWNER TO postgres;

--
-- TOC entry 7941 (class 0 OID 0)
-- Dependencies: 1213
-- Name: FUNCTION af_get_question_reponse_element(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_question_reponse_element(integer) IS 'FONCTION PRIVEE: Obtenir las enregistrements de la table question_reponse_element pour un type donnÃ©';


--
-- TOC entry 1214 (class 1255 OID 2596031)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_element_evaluations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_element_evaluations(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT E.id, E.libelle, E.type FROM contraintes.question_reponse_elements QR,
		contraintes.evaluation E
		--WHERE (QR.question=$1 OR QR.reponse=$1)
		WHERE (QR.question_reponse_element=$1)
		AND E.id=QR.question_reponse
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_element_evaluations(integer) OWNER TO pgsql;

--
-- TOC entry 7943 (class 0 OID 0)
-- Dependencies: 1214
-- Name: FUNCTION af_get_question_reponse_element_evaluations(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_element_evaluations(integer) IS 'obtenir les evaluations utilisées par un question_reponse_element.';


--
-- TOC entry 1215 (class 1255 OID 2596032)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_element_media(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_element_media(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 idenfifiant du question reponse
--$2 idenfifiant du question reponse element
rec RECORD;
libelle_media character varying;
BEGIN
	SELECT INTO rec question_reponse, question_reponse_element, media, CAST( NULL AS varchar) AS libelle, hauteur, largeur 
	FROM contraintes.af_get_question_reponse_elements_media($1) AS (question_reponse int4, question_reponse_element int4, media int4, flash int4, hauteur int4, largeur int4)
	WHERE question_reponse_element=$2;

	SELECT INTO libelle_media libelle FROM contraintes.af_get_fichier(rec.media) AS ( id int4, libelle varchar, "type" int4, connecte bool);

	rec.libelle:= libelle_media;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_element_media(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7945 (class 0 OID 0)
-- Dependencies: 1215
-- Name: FUNCTION af_get_question_reponse_element_media(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_element_media(integer, integer) IS 'Obtenir le media d''un question_reponse_element pour un question_reponse.';


--
-- TOC entry 1216 (class 1255 OID 2596033)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_element_media(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_element_media(integer) RETURNS record
    AS $_$DECLARE
--$1 idenfifiant du question reponse element
rec RECORD;
BEGIN
	SELECT INTO rec  question_reponse, question_reponse_element, media, media, hauteur, largeur 
	FROM contraintes.media_question_reponse_element, contraintes.question Q
	WHERE question_reponse_element=$1
	AND question_reponse_element=Q.id;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_element_media(integer) OWNER TO pgsql;

--
-- TOC entry 7947 (class 0 OID 0)
-- Dependencies: 1216
-- Name: FUNCTION af_get_question_reponse_element_media(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_element_media(integer) IS 'Obtenir le media d''un question_reponse_element.
Le question_reponse_element doit etre une question.';


--
-- TOC entry 1217 (class 1255 OID 2596034)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_elements(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_question_reponse_elements() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM contraintes.question_reponse_element
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_elements() OWNER TO postgres;

--
-- TOC entry 7949 (class 0 OID 0)
-- Dependencies: 1217
-- Name: FUNCTION af_get_question_reponse_elements(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_question_reponse_elements() IS 'FONCTION PRIVEE: Obtenir les enregistrements de la table question_reponse_element';


--
-- TOC entry 1218 (class 1255 OID 2596035)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_elements(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_question_reponse_elements(integer) RETURNS SETOF record
    AS $_$declare 
rec record;
begin
	for rec in
		select id,libelle,interpretation_html,type,reponse from contraintes.question_reponse_element 
		--select * from contraintes.question_reponse_element 
		where type=$1
	loop
		return next rec;
	end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_elements(integer) OWNER TO postgres;

--
-- TOC entry 7951 (class 0 OID 0)
-- Dependencies: 1218
-- Name: FUNCTION af_get_question_reponse_elements(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_question_reponse_elements(integer) IS 'FONCTION PRIVEE: Obtenir las enregistrements de la table question_reponse_element pour un type donnÃ©';


--
-- TOC entry 1219 (class 1255 OID 2596036)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_elements(integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_elements(integer, boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 le numero de question_réponse
--$2 question ou réponse?
rec RECORD;
cond varchar;
BEGIN
   if $2 is true then
	cond:=' is true ';
   else
	cond:=' is false ';
   end if; 
   FOR rec IN
    /*
 
	SELECT DISTINCT Q.id,Q.libelle,Q.interpretation_html,Q.type, Q.reponse, CASE WHEN Q.reponse IS FALSE THEN O_id.ind ELSE NULL END AS ind 
	FROM contraintes.question_reponse_elements E 
	LEFT OUTER JOIN contraintes.question_reponse_element Q ON (E.question=Q.id OR E.Reponse=Q.id)
	LEFT OUTER JOIN contraintes.af_gen_get_elements('contraintes.question_reponse_elements', 'question', NULL, 'AND question_reponse='||$1 , 0) O_id
	ON (O_id.id=E.question)
	WHERE E.question_reponse=$1
	AND Q.reponse=$2
	ORDER BY ind
    */

    SELECT DISTINCT Q.id,Q.libelle,Q.interpretation_html,Q.type, Q.reponse, 
    --CASE WHEN Q.reponse IS FALSE THEN O_id.ind ELSE O_id.ind END AS ind 
    O_id.ind as ind
    FROM contraintes.question_reponse_elements E 
    LEFT OUTER JOIN contraintes.question_reponse_element Q ON (E.question_reponse_element=Q.id)
    LEFT OUTER JOIN contraintes.af_gen_get_elements('contraintes.question_reponse_elements', 'question_reponse_element', NULL, 'AND question_reponse='||$1||'and question_reponse_element in (select id from contraintes.question_reponse_element where reponse'||cond||')' , 0) O_id
    ON (O_id.id=E.question_reponse_element)
    WHERE E.question_reponse=$1
    AND Q.reponse=$2
    ORDER BY ind
	LOOP
		RETURN NEXT rec;
	END LOOP; 
	
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_elements(integer, boolean) OWNER TO pgsql;

--
-- TOC entry 7953 (class 0 OID 0)
-- Dependencies: 1219
-- Name: FUNCTION af_get_question_reponse_elements(integer, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_elements(integer, boolean) IS 'Obtenir les informations des question_reponse_elements pour un question réponse.';


--
-- TOC entry 1220 (class 1255 OID 2596037)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_elements_infos(integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_elements_infos(integer, integer, boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 le numero de question_réponse
--$2 le type de question réponse
--$3 question ou réponse?
rec RECORD;

BEGIN
	
	/*
	FOR rec IN
		SELECT DISTINCT id , libelle , interpretation_html , $2, reponse 
		FROM contraintes.af_get_question_reponse_association_elements($1) AS (E_question_reponse int4, E_question int4, E_reponse int4, E_pere int4),
		contraintes.af_get_question_reponse_elements($2) AS (id int4, libelle varchar, interpretation_html boolean,type integer, reponse boolean)
		WHERE (id=E_question
		OR id=E_reponse)
		AND reponse=$3
	*/
	
	
	FOR rec IN
		SELECT DISTINCT id , libelle , interpretation_html , $2, reponse 
		FROM contraintes.af_get_question_reponse_association_elements($1) AS (E_question_reponse int4, E_question_reponse_element int4, E_pere int4),
		contraintes.af_get_question_reponse_elements($2) AS (id int4, libelle varchar, interpretation_html boolean,type integer, reponse boolean)
		WHERE id=E_question_reponse_element 
		--OR id=E_question_reponse_element)
		AND reponse=$3

	LOOP
		RETURN NEXT rec;
	END LOOP;
	
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_elements_infos(integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 7955 (class 0 OID 0)
-- Dependencies: 1220
-- Name: FUNCTION af_get_question_reponse_elements_infos(integer, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_elements_infos(integer, integer, boolean) IS 'Obtenir les informations des question_reponse_elements.';


--
-- TOC entry 1221 (class 1255 OID 2596038)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_elements_media(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_elements_media(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 idenfifiant du question reponse element
rec RECORD;
BEGIN
	FOR rec IN
		SELECT  question_reponse, question_reponse_element, media, media, hauteur, largeur FROM contraintes.media_question_reponse_element
		WHERE question_reponse=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_elements_media(integer) OWNER TO pgsql;

--
-- TOC entry 7957 (class 0 OID 0)
-- Dependencies: 1221
-- Name: FUNCTION af_get_question_reponse_elements_media(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_elements_media(integer) IS 'Obtenir les medias de tous les question_reponse_elements.';


--
-- TOC entry 25 (class 1255 OID 2596039)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_last_reponse(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_last_reponse(integer) RETURNS record
    AS $_$-- $1 : question_reponse
declare
rec record;
begin
    select into rec * from 
    contraintes.af_gen_get_last_element('contraintes.question_reponse_elements', 'question_reponse_element',' AND question_reponse='||$1||' and question_reponse_element in (select id from contraintes.question_reponse_element where reponse is true)');
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_last_reponse(integer) OWNER TO pgsql;

--
-- TOC entry 7959 (class 0 OID 0)
-- Dependencies: 25
-- Name: FUNCTION af_get_question_reponse_last_reponse(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_last_reponse(integer) IS 'retourne la dernière reponse d''un question_reponse';


--
-- TOC entry 1222 (class 1255 OID 2596040)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_media(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_media(integer) RETURNS record
    AS $_$DECLARE
--$1 idenfifiant du question reponse
rec RECORD;
BEGIN
	SELECT INTO rec  question_reponse, media, media, hauteur, largeur FROM contraintes.media_question_reponse
	WHERE question_reponse=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_media(integer) OWNER TO pgsql;

--
-- TOC entry 7961 (class 0 OID 0)
-- Dependencies: 1222
-- Name: FUNCTION af_get_question_reponse_media(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_media(integer) IS 'Obtenir le media d''un question_reponse.';


--
-- TOC entry 1223 (class 1255 OID 2596041)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_questions(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_questions(integer) RETURNS SETOF integer
    AS $_$DECLARE
--$1 numero de question_reponse
rec RECORD;
BEGIN
	FOR rec IN
		/*
		SELECT DISTINCT question FROM contraintes.question_reponse_elements
		WHERE question_reponse=$1
		*/
		SELECT DISTINCT question_reponse_element FROM contraintes.question_reponse_elements
		WHERE question_reponse=$1 
		and question_reponse_element in (select id from contraintes.question_reponse_element where reponse is false)
	LOOP
		RETURN NEXT rec.question_reponse_element;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_questions(integer) OWNER TO pgsql;

--
-- TOC entry 7963 (class 0 OID 0)
-- Dependencies: 1223
-- Name: FUNCTION af_get_question_reponse_questions(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_questions(integer) IS 'Obtenir les questions d''un question_reponse.';


--
-- TOC entry 1224 (class 1255 OID 2596042)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_solution(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_question_reponse_solution(integer, integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec question_reponse, question,reponse,juste 
	FROM contraintes.qcm_elements
	WHERE question_reponse=$1
	AND reponse=$2;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_solution(integer, integer) OWNER TO pgsql;

--
-- TOC entry 7965 (class 0 OID 0)
-- Dependencies: 1224
-- Name: FUNCTION af_get_question_reponse_solution(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_question_reponse_solution(integer, integer) IS 'Obtenir la solution d''une reponse à un qcm.';


--
-- TOC entry 1225 (class 1255 OID 2596043)
-- Dependencies: 2983 5
-- Name: af_get_question_reponse_solutions(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_question_reponse_solutions(integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
	for rec in
	select question_reponse, question,reponse,juste from contraintes.qcm_elements where question_reponse=$1
	loop
		return next rec;
	end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_question_reponse_solutions(integer) OWNER TO postgres;

--
-- TOC entry 7967 (class 0 OID 0)
-- Dependencies: 1225
-- Name: FUNCTION af_get_question_reponse_solutions(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_question_reponse_solutions(integer) IS 'Obtenir les reponses d''une question de qcm pour une question donnÃ©es (auteur : Said, modifiÃ©e par rÃ©mi)';


--
-- TOC entry 1226 (class 1255 OID 2596044)
-- Dependencies: 2983 5
-- Name: af_get_questions(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_questions() RETURNS SETOF record
    AS $$declare
rec record;
begin
	
	for rec in 
		select E_id,E_libelle,E_interpretation_html,E_type  from contraintes.af_get_question_reponse_elements() as (E_id int4,E_libelle varchar,E_interpretation_html bool,E_type int4,E_reponse bool), 
		contraintes.question Q  
		where Q.id=E_id
	loop
		return next rec;
	end loop;
	return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_questions() OWNER TO postgres;

--
-- TOC entry 7969 (class 0 OID 0)
-- Dependencies: 1226
-- Name: FUNCTION af_get_questions(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_questions() IS 'Obtenir les questions.';


--
-- TOC entry 1227 (class 1255 OID 2596045)
-- Dependencies: 2983 5
-- Name: af_get_reponse(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_reponse(integer) RETURNS record
    AS $_$declare
rec record;
begin
	select into rec E_id,E_libelle,E_interpretation_html,E_type from contraintes.af_get_reponses() as (E_id int4,E_libelle varchar,E_interpretation_html bool,E_type int4) where E_id=$1;
	return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_reponse(integer) OWNER TO postgres;

--
-- TOC entry 7971 (class 0 OID 0)
-- Dependencies: 1227
-- Name: FUNCTION af_get_reponse(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_reponse(integer) IS 'Obtenir les informations d''une reponse donnÃ©e (auteur : Said)';


--
-- TOC entry 1228 (class 1255 OID 2596046)
-- Dependencies: 2983 5
-- Name: af_get_reponse_question_reponse_resultats(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_reponse_question_reponse_resultats(integer) RETURNS SETOF record
    AS $_$-- $1 : reponse
declare
rec record;
begin
    for rec in
	select * from contraintes.resultat_serie_question_reponse where reponse=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_reponse_question_reponse_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 7973 (class 0 OID 0)
-- Dependencies: 1228
-- Name: FUNCTION af_get_reponse_question_reponse_resultats(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_reponse_question_reponse_resultats(integer) IS 'retourne les resultats pour une reponse de question_reponse';


--
-- TOC entry 1229 (class 1255 OID 2596047)
-- Dependencies: 2983 5
-- Name: af_get_reponses(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_reponses() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		select  E_id,E_libelle,E_interpretation_html,E_type from contraintes.reponse R, 
		contraintes.af_get_question_reponse_elements() as (E_id int4,E_libelle varchar,E_interpretation_html bool, E_type int4,E_reponse bool)
		where R.id=E_id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_reponses() OWNER TO postgres;

--
-- TOC entry 7975 (class 0 OID 0)
-- Dependencies: 1229
-- Name: FUNCTION af_get_reponses(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_reponses() IS 'Obtenir les réponses.';


--
-- TOC entry 1230 (class 1255 OID 2596048)
-- Dependencies: 2983 5
-- Name: af_get_reponses(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_reponses(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		select  E.id, libelle, interpretation_html, type from contraintes.reponse R, contraintes.af_get_question_reponse_elements($1) E
		where R.id=E.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_reponses(integer) OWNER TO postgres;

--
-- TOC entry 7977 (class 0 OID 0)
-- Dependencies: 1230
-- Name: FUNCTION af_get_reponses(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_reponses(integer) IS 'Obtenir toutes les reponses d''un type donnÃ©.';


--
-- TOC entry 1231 (class 1255 OID 2596049)
-- Dependencies: 2983 5
-- Name: af_get_ressource(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_ressource(integer) RETURNS record
    AS $_$-- $1 : ressource
declare
rec record;
begin
    select into rec r.id,e.libelle,fichier,mots_cles, er.id 
	from contraintes.ressource r,contraintes.etape_ressource er, contraintes.etape e
     where r.id=$1 and r.id=ressource AND e.id=er.id;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_ressource(integer) OWNER TO pgsql;

--
-- TOC entry 7979 (class 0 OID 0)
-- Dependencies: 1231
-- Name: FUNCTION af_get_ressource(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_ressource(integer) IS 'retourne les infos ressource';


--
-- TOC entry 1232 (class 1255 OID 2596050)
-- Dependencies: 2983 5
-- Name: af_get_resultat(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat(integer, integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 formation
--$2 stagiaire
--$3 parcours
--$4 etape
rec RECORD;
BEGIN
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree
	FROM contraintes.resultat
	WHERE formation=$1
	AND stagiaire=$2
	AND parcours=$3
	AND etape=$4;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1233 (class 1255 OID 2596051)
-- Dependencies: 2983 5
-- Name: af_get_resultat(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat(bigint) RETURNS record
    AS $_$DECLARE
--$1 resultat
rec RECORD;
BEGIN
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree
	FROM contraintes.resultat
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat(bigint) OWNER TO pgsql;

--
-- TOC entry 1234 (class 1255 OID 2596052)
-- Dependencies: 2983 5
-- Name: af_get_resultat_etape_tentative(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_etape_tentative(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
begin
    -- Initialisation 
    -- recup des paramètres du resultat
    select into rec_resultat * from contraintes.af_get_resultat($1)
    as  (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval);
    if rec_resultat.id is null then
	select into rec_resultat * from contraintes.af_get_resultat_tentative($1)  
	as  (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval,tentative integer);
    end if;
    -- boucle sur les resultats stockés
    for rec in 
	select id,formation,stagiaire,parcours,etape,date_debut,duree,tentative from contraintes.resultat_tentative 
	where formation=rec_resultat.formation 
	and stagiaire=rec_resultat.stagiaire 
	and parcours=rec_resultat.parcours 
	and etape=rec_resultat.etape

    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_etape_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 7983 (class 0 OID 0)
-- Dependencies: 1234
-- Name: FUNCTION af_get_resultat_etape_tentative(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_etape_tentative(bigint) IS 'retourne les tentatives deja effectuées';


--
-- TOC entry 1861 (class 1255 OID 2596053)
-- Dependencies: 2983 5
-- Name: af_get_resultat_exotlc(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_exotlc(bigint) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT R_id,R_formation,R_stagiaire, R_parcours, R_etape, R_date_debut, R_duree, commentaire, correction, fichier_rendu, date_correction 
		FROM contraintes.af_get_resultat($1) AS (R_id int8,R_formation int4,R_stagiaire int4, R_parcours int4, R_etape int4, R_date_debut timestamp, R_duree interval)
		LEFT OUTER JOIN contraintes.resultat_exotlc RE ON( R_id=RE.id)
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_exotlc(bigint) OWNER TO pgsql;

--
-- TOC entry 1862 (class 1255 OID 2596054)
-- Dependencies: 2983 5
-- Name: af_get_resultat_exotlc_critere(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_exotlc_critere(bigint, integer) RETURNS record
    AS $_$-- $1 : id resultat
-- $2 : critere
declare
rec record;
begin
    select into rec id,critere,note,note_max,commentaire 
    from contraintes.resultat_exotlc_critere 
    where id=$1 and critere=$2;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_exotlc_critere(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 7986 (class 0 OID 0)
-- Dependencies: 1862
-- Name: FUNCTION af_get_resultat_exotlc_critere(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_exotlc_critere(bigint, integer) IS 'retourne le resultat d''un critere pour un identifiant de resultat';


--
-- TOC entry 1235 (class 1255 OID 2596055)
-- Dependencies: 2983 5
-- Name: af_get_resultat_exotlc_critere_sous_criteres(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_exotlc_critere_sous_criteres(bigint, integer) RETURNS SETOF record
    AS $_$-- $1 : id resultat
-- $2 : critere
declare
rec record;
begin
    for rec in
	select id_sc,$2,sous_critere,libelle_sc,note,note_max 
	from contraintes.af_get_resultat_exotlc_sous_criteres($1) as (id_sc int8,sous_critere int4,libelle_sc varchar,note int4,note_max int4),
	contraintes.af_get_critere_sous_criteres($2) as (id int4,libelle varchar,theme int4,pere int4)
	where sous_critere=id
	
    loop
	return next rec;
    end loop;
end;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_exotlc_critere_sous_criteres(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 7988 (class 0 OID 0)
-- Dependencies: 1235
-- Name: FUNCTION af_get_resultat_exotlc_critere_sous_criteres(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_exotlc_critere_sous_criteres(bigint, integer) IS 'retourne les resultats des sous criteres d''un exotlc pour un identifiant de resultat et un critere';


--
-- TOC entry 1236 (class 1255 OID 2596056)
-- Dependencies: 2983 5
-- Name: af_get_resultat_exotlc_criteres(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_exotlc_criteres(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
begin
    for rec in 
	select R.id, R.critere, C.libelle, note, note_max, commentaire from contraintes.resultat_exotlc_critere R,
	contraintes.critere C
	where R.id=$1
	AND C.id=R.critere
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_exotlc_criteres(bigint) OWNER TO pgsql;

--
-- TOC entry 7990 (class 0 OID 0)
-- Dependencies: 1236
-- Name: FUNCTION af_get_resultat_exotlc_criteres(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_exotlc_criteres(bigint) IS 'retourne les resultats des criteres pour un identifiant de resultat';


--
-- TOC entry 1237 (class 1255 OID 2596057)
-- Dependencies: 2983 5
-- Name: af_get_resultat_exotlc_moyenne(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_exotlc_moyenne(bigint) RETURNS double precision
    AS $_$-- $1 : id resultat
declare
rec record;
ind integer:=0;
score double precision:=0;
begin 
    -- recup des notes des critere
    for rec in
	select * from contraintes.af_get_resultat_exotlc_criteres($1) as (id int8,critere int4,libelle varchar,note int4,note_max int4,commentaire text)
    loop
	if rec.note is not null and rec.note_max is not null then
	    ind:=ind+1;
	    score:=score + ((20*cast(rec.note as double precision))/cast(rec.note_max as double precision));
	end if;
    end loop;
    -- recup des note des sous criteres
    for rec in
	select * from contraintes.af_get_resultat_exotlc_sous_criteres($1) as (id int8,critere int4,libelle varchar,note int4,note_max int4)
    loop
	if rec.note is not null and rec.note_max is not null then
	    ind:=ind+1;
	    score:=score + ((20*cast(rec.note as double precision))/cast(rec.note_max as double precision));
	end if;
    end loop;
    return (score/ind);	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_exotlc_moyenne(bigint) OWNER TO pgsql;

--
-- TOC entry 7992 (class 0 OID 0)
-- Dependencies: 1237
-- Name: FUNCTION af_get_resultat_exotlc_moyenne(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_exotlc_moyenne(bigint) IS 'retourne la note general sur 20 pour un identifiant de resultat';


--
-- TOC entry 1238 (class 1255 OID 2596058)
-- Dependencies: 2983 5
-- Name: af_get_resultat_exotlc_sous_critere(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_exotlc_sous_critere(bigint, integer) RETURNS record
    AS $_$-- $1 : id resultat
-- $2 : sous critere
declare
rec record;
begin
    select into rec R.id,R.sous_critere, C.libelle,R.note,R.note_max 
    from contraintes.resultat_exotlc_sous_critere R,contraintes.critere C
    where R.id=$1 and C.id=$2 
	AND sous_critere=C.id;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_exotlc_sous_critere(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 7994 (class 0 OID 0)
-- Dependencies: 1238
-- Name: FUNCTION af_get_resultat_exotlc_sous_critere(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_exotlc_sous_critere(bigint, integer) IS 'retourne les resultat pour un sous_critere';


--
-- TOC entry 1863 (class 1255 OID 2596059)
-- Dependencies: 2983 5
-- Name: af_get_resultat_exotlc_sous_criteres(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_exotlc_sous_criteres(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
begin
    for rec in
	select R.id, sous_critere,libelle, note, note_max from contraintes.resultat_exotlc_sous_critere R,
	contraintes.critere C
	where R.id=$1
	AND C.id=sous_critere
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_exotlc_sous_criteres(bigint) OWNER TO pgsql;

--
-- TOC entry 7996 (class 0 OID 0)
-- Dependencies: 1863
-- Name: FUNCTION af_get_resultat_exotlc_sous_criteres(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_exotlc_sous_criteres(bigint) IS 'retourne les resultats des sous criteres pour un identifiant de resultat';


--
-- TOC entry 1864 (class 1255 OID 2596060)
-- Dependencies: 2983 5
-- Name: af_get_resultat_formation(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_formation(integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 formation
--$2 individu
--$3 parcours (doit etre NULL à l'appel de la fonction, sert uniquement pour la recursivité)
id_parcours int4;
rec RECORD;
rec_p RECORD;
rec_pp RECORD;
id_resultat bigint; 
sous_parcours integer; 
BEGIN
	------------------------------
	--VERIFICATION DES PARAMETRES
	------------------------------
	IF $1 IS NULL OR $2 IS NULL THEN
		RAISE EXCEPTION 'La fonction n''accepte pas une formation (%) et/ou un individu(%) nulls',$1,$2;
	ELSE 
		RAISE NOTICE 'params f=% i=% p=%',$1,$2,$3;
	END IF;

	IF $3 IS NULL THEN
		--on récupère le parcours de la formation
		SELECT INTO id_parcours parcours FROM contraintes.af_get_formation($1) 
		AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4,ressources_fusionnees boolean);
		
		IF id_parcours IS NULL THEN
			RAISE EXCEPTION 'Pas de parcours principal pour la formation';
		END IF;
 
		RAISE NOTICE 'Le parcours principal est le parcours n°%', id_parcours;	
	ELSE 
		id_parcours:=$3;
	END IF;
 
	------------------------------
	--AVANCEMENT PARCOURS APPELLE ($3 ou parcours principal)
	------------------------------

	--on recupere l'avancement max du parcours passé en argument
	SELECT INTO rec * FROM contraintes.af_get_formation_avancement_max_parcours($1, id_parcours, $2) AS (parcours int4, etape int4, type int4,formation int4, individu int4, date_debut timestamp, duree interval);
	--raise notice 'Type etape a suivre=%',rec.type;
 
	IF rec.type IS NULL THEN
		--raise notice 'ds le test du type avt retour (%)',rec.type;
		RETURN NULL;
	END IF;
	--raise notice 'ds le test du type apres retour';

	--si l'avancement max est un parcours  on recupere l'avancement max de ce dernier
	IF rec.type=1 THEN
		--RAISE NOTICE 'L''etape en cours est le parcours n°% de type% deb=%, d=%', rec.etape,rec.type, rec.date_debut,rec.duree  ;
		
		IF rec.date_debut IS NOT NULL THEN

			--IF rec.duree IS NULL THEN
				--RAISE NOTICE 'AAAA';
				--appel recursif: on réappel la fonction en changeant de parcours courant
				SELECT INTO rec_p * FROM contraintes.af_get_resultat_formation($1, $2,rec.etape) AS (parcours int4, etape int4,type int4, formation int4, individu int4, date_debut timestamp, duree interval);	
				--RAISE NOTICE 'AAAA L''etape du parcours trouvée:parcours(%) n°% de type% deb=%, d=%',rec_p.parcours, rec_p.etape,rec_p.type, rec_p.date_debut,rec_p.duree  ;
				
				--Si l'avancement max du nouveau parcours courant est null (ligne vide)
				IF rec_p.type IS NULL THEN
					RETURN rec;
				ELSE 
					RETURN rec_p;
				END IF;
					
		ELSE 
		
			RETURN rec;
		END IF;
	ELSE

			--RAISE EXCEPTION 'DANS LE ELSE';
		-- traitement etape parcours oriente
		if rec.type=10 THEN--and rec.date_debut IS NOT NULL 
			--recup sous parcours
			-- recup id_resultat
			--RAISE NOTICE 'parcours=% et etape=%', id_parcours,rec.etape;
			select into id_resultat id from contraintes.af_get_resultat($1,$2,id_parcours,rec.etape)
			AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
			--RAISE NOTICE 'id_resultat=%', id_resultat;
			if id_resultat is null then
			    --raise exception 'le parcours oriente pas commence';
			    return rec;
			end if;

			select into sous_parcours * from contraintes.af_get_resultat_parcours_parcours_oriente(id_resultat);
			--RAISE NOTICE 'sous_parcours=%', sous_parcours;
			select into rec_p * FROM contraintes.af_get_resultat_formation($1, $2,sous_parcours) AS (parcours int4, etape int4,type int4, formation int4, individu int4, date_debut timestamp, duree interval);	
			--Si l'avancement max du nouveau parcours courant est null (ligne vide)
				IF rec_p.type IS NULL THEN
					RETURN rec;
				ELSE 
					RETURN rec_p;
				END IF;
			
			
		else
			RETURN rec;
		end if;
		

		--RAISE NOTICE 'L''etape en cours est de type % n°%',rec.type, rec.etape;
		--
	    
		--RAISE NOTICE 'L''etape en cours est de type % n°%',rec.type, rec.etape;
		--RETURN rec;
	END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_formation(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1239 (class 1255 OID 2596061)
-- Dependencies: 2983 5
-- Name: af_get_resultat_ftb_langue_ams_reponse(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_ftb_langue_ams_reponse(bigint, integer) RETURNS record
    AS $_$-- $1 : resultat
-- $2 : ftb
declare
rec record;
lettre char;
rec_final record;
langue integer;
begin
    -- recup reponse
    select into  rec  
	RFTB.reponse FROM  contraintes.resultat_serie_ftb RFTB WHERE RFTB.ftb=$2 AND RFTB.id=$1;	
    -- la langue	
    lettre:=substring(rec.reponse from 6 for 1);
    langue:=cast(lettre as integer);
    raise notice 'lang=%',langue;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_ftb_langue_ams_reponse(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 7999 (class 0 OID 0)
-- Dependencies: 1239
-- Name: FUNCTION af_get_resultat_ftb_langue_ams_reponse(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_ftb_langue_ams_reponse(bigint, integer) IS 'retourne pour un ftb corrigé la langue de sa reponse et sa reponse';


--
-- TOC entry 1240 (class 1255 OID 2596062)
-- Dependencies: 2983 5
-- Name: af_get_resultat_parcours_exotlcs_score_partiel(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_parcours_exotlcs_score_partiel(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
res_exotlc real;
nb integer;
id_resultat bigint;
begin
    -- recup composants id resultat
    select into rec_resultat * from contraintes.af_get_resultat($1) 
    as (id bigint,  formation integer, stagiaire integer,parcours integer, etape integer,  date_debut timestamp, duree interval); 
    -- Initialisation
    total:=0;
    nb:=0;
    -- boucle sur les etapes du parcours
    for rec in 
	select * from contraintes.af_get_parcours_etapes(rec_resultat.parcours)
	AS (id int4, libelle varchar, libelle_bis varchar, libelle_alias  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    loop
	if rec.type='10' then
	    exit;
	end if;
	-- traitemement serie
    if rec.type ='5' and rec.obligatoire is true then
	-- recup id resultat
	select into id_resultat id from contraintes.af_get_resultat(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours,rec.id)
	AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	select into res_exotlc * from contraintes.af_get_resultat_exotlc_moyenne(id_resultat);
	total:=total+res_serie;
	nb:=nb+1;


    end if;

    end loop;
    if nb>0 then
	return total/nb;
    else
	return null;
    end if;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_parcours_exotlcs_score_partiel(bigint) OWNER TO pgsql;

--
-- TOC entry 8001 (class 0 OID 0)
-- Dependencies: 1240
-- Name: FUNCTION af_get_resultat_parcours_exotlcs_score_partiel(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_parcours_exotlcs_score_partiel(bigint) IS 'retourne le score aux exotlcs d''un parcours avant etape parcours oriente';


--
-- TOC entry 1241 (class 1255 OID 2596063)
-- Dependencies: 2983 5
-- Name: af_get_resultat_parcours_parcours_oriente(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_parcours_parcours_oriente(bigint) RETURNS integer
    AS $_$-- $1 : id resultat
declare
rec record;
rec2 record;
rec_resultat record;
seuil_individu real;
seuil_type real;
passage_type integer;
begin
    -- Initialisation
    -- recup param resultat
    select into rec_resultat * from contraintes.af_get_resultat($1) 
    as (id bigint,  formation integer, stagiaire integer,parcours integer, etape integer,  date_debut timestamp, duree interval); 
    -- recup score pour le parcours (avant l'etape parcours oriente)
    --select into seuil_individu * from contraintes.af_get_formation_individu_parcours_score(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours);
    select into seuil_individu * from contraintes.af_get_resultat_parcours_score_partiel($1);
    -- boucle sur les sous parcours de la configuration de l'etape parcours oriente
    for rec in 
	select * from contraintes.af_get_parcours_oriente_sous_parcours(rec_resultat.etape)
	as (id integer,libelle varchar,filiere integer,ordre integer) order by ordre desc
    loop
	-- recup des seuils pour le sous parcours courant
	passage_type=0;
	for rec2 in 
	    select * from contraintes.af_get_parcours_oriente_configuration(rec_resultat.etape) 
	    as (etape integer,sous_parcours integer,type integer,seuil integer)
	    where sous_parcours=rec.id
	loop
	    if rec2.type =4 then
		-- recup score pour ce type
		select into seuil_type * from contraintes.af_get_formation_individu_parcours_series_score(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours);
		if seuil_type<rec2.seuil then
		    exit;
		else
		    passage_type:=passage_type+1;
		end if;
	    else
		if rec2.type=5 then
		    -- recup score pour ce type
		    select into seuil_type * from contraintes.af_get_formation_individu_parcours_exotlcs_score(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours);
		    if seuil_type<rec2.seuil then
		        exit;
		    else
			passage_type:=passage_type+1;
		    end if;
		else

		end if;
	    end if;

	end loop;
	if passage_type>0 then
	    return rec2.sous_parcours;
	else
	    if seuil_individu>rec2.seuil then
		return rec2.sous_parcours;
	    end if;	
	end if;
	
    end loop;
    return rec2.sous_parcours ;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_parcours_parcours_oriente(bigint) OWNER TO pgsql;

--
-- TOC entry 8003 (class 0 OID 0)
-- Dependencies: 1241
-- Name: FUNCTION af_get_resultat_parcours_parcours_oriente(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_parcours_parcours_oriente(bigint) IS 'retourne le numero du sous_parcours issu de la configuration de l''etape parcours_oriente et des resultat de l''individu';


--
-- TOC entry 1865 (class 1255 OID 2596064)
-- Dependencies: 2983 5
-- Name: af_get_resultat_parcours_score_partiel(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_parcours_score_partiel(bigint) RETURNS real
    AS $_$-- $1 : identifiant resultat
declare
rec record;
rec_resultat record;
id_resultat bigint;
total real;
res_serie real;
res_exotlc real;
nb integer;
begin
    -- recup des composant de l'identifiant résultat
    select into rec_resultat * from contraintes.af_get_resultat($1) 
    as (id bigint,  formation integer, stagiaire integer,parcours integer, etape integer,  date_debut timestamp, duree interval); 
    -- Initialisation
    total:=0;
    nb:=0;
    -- boucle sur les etapes du parcours
    for rec in 
	select * from contraintes.af_get_parcours_etapes(rec_resultat.parcours)
	AS (id int4, libelle varchar, libelle_bis varchar, libelle_alias  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    loop
	if rec.type='10' then
	    exit;
	end if;
	-- traitement serie
	if (rec.type like 4 || '%') then
	    -- recup identifiant resultat pour cette etape
	    select into id_resultat id from contraintes.af_get_resultat(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours,rec.id)
	    AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	    select into res_serie * from contraintes.af_get_resultat_serie_score(id_resultat);
	    total:=total+res_serie;
	    nb:=nb+1;

	end if;
	if rec.type='5' then
	    -- recup identifiant resultat pour cette etape
	    select into id_resultat id from contraintes.af_get_resultat(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours,rec.id)
	    AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	    select into res_exotlc * from contraintes.af_get_resultat_exotlc_moyenne(id_resultat);
	    total:=total+res_exotlc;
	    nb:=nb+1;
	end if;

    end loop;
    if nb>0 then
	return total/nb;
    else
	return null;
    end if;


end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_parcours_score_partiel(bigint) OWNER TO pgsql;

--
-- TOC entry 8005 (class 0 OID 0)
-- Dependencies: 1865
-- Name: FUNCTION af_get_resultat_parcours_score_partiel(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_parcours_score_partiel(bigint) IS 'retourne le score d''in individu pour un parcours avant l''etape parcours oriente';


--
-- TOC entry 1242 (class 1255 OID 2596065)
-- Dependencies: 2983 5
-- Name: af_get_resultat_parcours_series_score_partiel(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_parcours_series_score_partiel(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
res_serie real;
nb integer;
id_resultat bigint;
begin
    -- recup composants id resultat
    select into rec_resultat * from contraintes.af_get_resultat($1) 
    as (id bigint,  formation integer, stagiaire integer,parcours integer, etape integer,  date_debut timestamp, duree interval); 
    -- Initialisation
    total:=0;
    nb:=0;
    -- boucle sur les etapes du parcours
    for rec in 
	select * from contraintes.af_get_parcours_etapes(rec_resultat.parcours)
	AS (id int4, libelle varchar, libelle_bis varchar, libelle_alias  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    loop
	if rec.type='10' then
	    exit;
	end if;
	-- traitemement serie
    if (rec.type like 4 || '%') and rec.type <> '4_1_0_2' and rec.obligatoire is true then
	-- recup id resultat
	select into id_resultat id from contraintes.af_get_resultat(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours,rec.id)
	AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	select into res_serie * from contraintes.af_get_resultat_serie_score(id_resultat);
	total:=total+res_serie;
	nb:=nb+1;


    end if;

    end loop;
    if nb>0 then
	return total/nb;
    else
	return null;
    end if;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_parcours_series_score_partiel(bigint) OWNER TO pgsql;

--
-- TOC entry 8007 (class 0 OID 0)
-- Dependencies: 1242
-- Name: FUNCTION af_get_resultat_parcours_series_score_partiel(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_parcours_series_score_partiel(bigint) IS 'retourne le score aux series d''un parcours avant etape parcours oriente';


--
-- TOC entry 1866 (class 1255 OID 2596066)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_aleatoire_avancement_max(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_aleatoire_avancement_max(bigint) RETURNS record
    AS $_$-- $1 : identifiant resultat
declare
rec RECORD;
resultat RECORD;
indice integer:=1;
BEGIN
	SELECT INTO resultat *
	FROM contraintes.af_get_resultat($1)  AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);

	
	IF resultat.etape IS NULL THEN
		RAISE EXCEPTION 'Erreur: ne peut determiner l''avancement d''une serie aleatoire sans son identifiant.';
	END IF;

	--selection de l'indice
	SELECT INTO indice MIN(elt2.ind) FROM contraintes.af_gen_get_elements('contraintes.serie_aleatoire_evaluations', 'evaluation', NULL, 'AND serie='||resultat.etape||' AND formation='||resultat.formation||' AND parcours='||resultat.parcours||' AND stagiaire='||resultat.stagiaire,0) elt2
	LEFT OUTER JOIN contraintes.resultat_serie R2 ON (R2.id = $1 AND evaluation=elt2.id)
	WHERE R2.id IS NULL;
	
	SELECT INTO rec resultat.id,resultat.formation , resultat.stagiaire , resultat.parcours, resultat.etape, E.id, E.type,elt.ind,cast(NULL as interval) as duree
	FROM contraintes.evaluation E ,contraintes.af_gen_get_elements('contraintes.serie_aleatoire_evaluations', 'evaluation', NULL, 'AND serie='||resultat.etape||' AND formation='||resultat.formation||' AND parcours='||resultat.parcours||' AND stagiaire='||resultat.stagiaire ,0) elt
	WHERE E.id=elt.id
	AND elt.ind = indice;
	
	select into rec.duree * from contraintes.af_get_resultat_serie_aleatoire_evaluations_duree_totale($1);
	--rec.duree:=10;
	RETURN rec; 
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_aleatoire_avancement_max(bigint) OWNER TO pgsql;

--
-- TOC entry 8009 (class 0 OID 0)
-- Dependencies: 1866
-- Name: FUNCTION af_get_resultat_serie_aleatoire_avancement_max(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_aleatoire_avancement_max(bigint) IS 'retourne l''evaluation à faire d''une serie aleatoire';


--
-- TOC entry 1867 (class 1255 OID 2596067)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_aleatoire_evaluation(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_aleatoire_evaluation(bigint, integer) RETURNS SETOF record
    AS $_$-- $1 : resultat
-- $2 : evaluation
declare
rec RECORD;
rec_resultat RECORD;
BEGIN
	SELECT INTO rec_resultat * FROM contraintes.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RS.date_debut,s.bareme,s.chrono
		FROM contraintes.resultat_serie RS,
		contraintes.serie_aleatoire_evaluations SE,
		contraintes.serie s
		WHERE RS.id=$1
		AND RS.evaluation=$2
		AND SE.serie=rec_resultat.etape and formation=rec_resultat.formation 
		and parcours=rec_resultat.parcours and stagiaire=rec_resultat.stagiaire 
		AND SE.evaluation=RS.evaluation 
		and rec_resultat.etape=s.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_aleatoire_evaluation(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 8011 (class 0 OID 0)
-- Dependencies: 1867
-- Name: FUNCTION af_get_resultat_serie_aleatoire_evaluation(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_aleatoire_evaluation(bigint, integer) IS 'retourne le resultat d''une evaluation';


--
-- TOC entry 26 (class 1255 OID 2596068)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_aleatoire_evaluations_duree_totale(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_aleatoire_evaluations_duree_totale(bigint) RETURNS interval
    AS $_$DECLARE
duree_totale INTERVAL;
resultat RECORD;
BEGIN

	SELECT INTO resultat *
	FROM contraintes.af_get_resultat($1)  AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);

	IF resultat.etape IS NULL THEN
		RAISE EXCEPTION 'Erreur: ne peut determiner la duree des evaluations d''une serie sans son identifiant.';
	END IF;

	

	SELECT INTO duree_totale SUM(RS.date_fin-RS.date_debut)
	FROM contraintes.af_gen_get_elements('contraintes.serie_aleatoire_evaluations', 'evaluation', NULL,  'AND serie='||resultat.etape||' AND formation='||resultat.formation||' AND parcours='||resultat.parcours||' AND stagiaire='||resultat.stagiaire,0) elt,
	contraintes.resultat_serie RS
	WHERE RS.id=resultat.id
	AND elt.id=RS.evaluation
	AND RS.date_debut IS NOT NULL
	AND RS.date_fin IS NOT NULL;

	RETURN duree_totale;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_aleatoire_evaluations_duree_totale(bigint) OWNER TO pgsql;

--
-- TOC entry 1243 (class 1255 OID 2596069)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_aleatoire_evaluations_scores(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_aleatoire_evaluations_scores(bigint) RETURNS SETOF record
    AS $_$DECLARE
--$1 identifiant resultat
rec RECORD;
rec_resultat RECORD;
res_sondage integer;
rec_serie record;
BEGIN
    SELECT INTO rec_resultat * FROM contraintes.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	FOR rec IN
	    /*
	    SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
	    FROM contraintes.af_get_serie_evaluations(rec_resultat.etape) 
	    AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	    */
	    select $1,rec_resultat.etape,id_evaluation,type_evaluation,cast(null as varchar) as commentaire,cast(null as integer) as bareme,cast(null as integer) as chrono,1, CAST(NULL AS real)  AS score 
	    from contraintes.af_get_serie_aleatoire_evaluations(rec_resultat.etape,rec_resultat.formation,rec_resultat.parcours,rec_resultat.stagiaire) 
	    as (id_evaluation int4, libelle varchar, serie int4, pere int4,  type_evaluation int4 )
	    --AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	   
	LOOP

	raise notice 'type=%',rec.type_evaluation;
	    --QCM 
	    IF rec.type_evaluation=1 or rec.type_evaluation=4 THEN
	        SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_aleatoire_questionreponses_scores(rec_resultat.id, rec.id_evaluation);
	    END IF;
	    -- FTB
	    if rec.type_evaluation=3 then
		SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_ftb_scores(rec_resultat.id, rec.id_evaluation);
	    end if;
	    -- complete le record
	    select into rec_serie bareme,chrono from contraintes.af_get_serie_aleatoire(rec_resultat.etape) as (id integer,libelle varchar,bareme integer,chrono integer,type integer,date_creation timestamp);
	    rec.bareme:=rec_serie.bareme;
	    rec.chrono:=rec_serie.chrono;
	    rec.commentaire:=null;
		RETURN NEXT rec;
	END LOOP;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_aleatoire_evaluations_scores(bigint) OWNER TO pgsql;

--
-- TOC entry 8014 (class 0 OID 0)
-- Dependencies: 1243
-- Name: FUNCTION af_get_resultat_serie_aleatoire_evaluations_scores(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_scores(bigint) IS 'Obtenir les résultats des evaluations d''une serie aleatoire(test sur qcm).';


--
-- TOC entry 1244 (class 1255 OID 2596070)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_aleatoire_question_reponse(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_aleatoire_question_reponse(bigint, integer) RETURNS SETOF record
    AS $_$-- $1 : identifiant resultat
-- $2 : question_reponse
DECLARE
rec RECORD;
type_evaluation integer;
resultat real;

BEGIN
	
	SELECT INTO type_evaluation type FROM contraintes.af_get_question_reponse($2) AS (id integer, libelle varchar, type integer, date_creation timestamp, radio bool);
	
	FOR rec IN 
		SELECT id, rs_evaluation, question,reponse,rs_date_creation, coche, CAST(s_juste AS integer)
		FROM  contraintes.resultat_serie_question_reponse QR
		INNER JOIN contraintes.af_get_resultat_serie_aleatoire_evaluation($1,$2) AS (rs_id int8, rs_evaluation integer, rs_date_creation timestamp,bareme integer,chrono integer)
		ON(	QR.id=rs_id AND QR.id=$1 AND QR.question_reponse=rs_evaluation )
		
		LEFT OUTER JOIN contraintes.af_get_question_reponse_solutions($2) AS (s_question_reponse integer, s_question integer,s_reponse integer ,s_juste bool )
		ON (	$2=s_question_reponse AND QR.reponse=s_reponse 
			AND QR.question=s_question AND s_question_reponse=$2)
	LOOP
		IF type_evaluation=2 OR type_evaluation=5 THEN
			--SELECT INTO rec.s_juste * FROM contraintes.af_get_resultat_serie_sondage($2);
			--rec.s_juste:=80;
			-- verifier si fonctionne avec un sondage aleatoire
			select into resultat * from contraintes.af_get_resultat_sondage_question_reponse_score($1,$2,rec.question,rec.reponse);
		    rec.s_juste:=resultat*100;
		END IF;

		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_aleatoire_question_reponse(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 8016 (class 0 OID 0)
-- Dependencies: 1244
-- Name: FUNCTION af_get_resultat_serie_aleatoire_question_reponse(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_aleatoire_question_reponse(bigint, integer) IS 'retourne les resultat d''un question_reponse';


--
-- TOC entry 1245 (class 1255 OID 2596071)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) RETURNS real
    AS $_$-- $1 : $id_resultat
-- $2 : n° question reponse
declare
rec record;
rec_bareme record;
serie integer;
bareme integer;
point real;
somme real;
total real;
begin
    
    -- recup n° serie de l'evaluation
    select into rec * from contraintes.af_get_resultat($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    serie:=rec.etape;
    -- recup n° bareme 
    select into bareme * from contraintes.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from contraintes.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from contraintes.af_get_evaluation_point(serie,$2);
    raise notice 'point=%',point;
    -- boucle sur les reponses
    somme:=0;
    total:=0;	
    for rec in
	select * from contraintes.af_get_resultat_serie_aleatoire_question_reponse($1,$2) as (id int8, question_reponse integer, question integer, reponse integer,  date_creation timestamp, coche boolean, juste integer)
    loop
	if (rec.coche is true and rec.juste=1) or (rec.coche is false and rec.juste=0) then
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;

    end loop;
    if total>0 then
    somme:=(somme/total)*point;
    end if;
    if somme<0 then
	somme:=0;
    end if;
    return somme;
     
     
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 8018 (class 0 OID 0)
-- Dependencies: 1245
-- Name: FUNCTION af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) IS 'retoune le score pour un qcm de serie aleatoire';


--
-- TOC entry 1246 (class 1255 OID 2596072)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_aleatoire_score(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_aleatoire_score(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
nb integer;
point_evaluation integer;
begin
    -- Initialisation
    point_evaluation:=1;
    -- recupe etape,formation,parcours et individu
    SELECT INTO rec_resultat * FROM contraintes.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    total:=0;
    nb:=0;
    FOR rec IN
	/*
	SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
		FROM contraintes.af_get_serie_evaluations(rec_resultat.etape) 
		AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	*/
	select id_evaluation,libelle,serie,pere,type_evaluation, CAST(NULL AS real)  AS score 
	from contraintes.af_get_serie_aleatoire_evaluations(rec_resultat.etape,rec_resultat.formation,rec_resultat.parcours,rec_resultat.stagiaire) 
	as (id_evaluation int4, libelle varchar, serie int4, pere int4,  type_evaluation int4 )
    LOOP
	--QCM et QRC
	raise notice 'type=%',rec.type_evaluation;
	IF rec.type_evaluation=1 OR rec.type_evaluation=4 THEN
	    SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_aleatoire_questionreponses_scores(rec_resultat.id, rec.id_evaluation);		
	
	end if;
	IF rec.type_evaluation=3 THEN
	    SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_ftb_scores(rec_resultat.id, rec.id_evaluation);
			--rec.score=CAST(NULL AS integer);
			--FTB
			--SELECT RSFTB.id, RSFTB.ftb, RSFTB.reponse
			--FROM contraintes.resultat_serie_ftb RSFTB
			--WHERE RSFTB.ftb=rec.id_evaluation 
			--AND RSFTB.id=rec_resultat.id;
	END IF;
	    raise notice 'recscore=%',rec.score;
	    -- calcul à suivre
	    total:=total+(rec.score*20)/point_evaluation;
	    nb:=nb+1;
	END LOOP;
	return total/nb;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_aleatoire_score(bigint) OWNER TO pgsql;

--
-- TOC entry 8020 (class 0 OID 0)
-- Dependencies: 1246
-- Name: FUNCTION af_get_resultat_serie_aleatoire_score(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_aleatoire_score(bigint) IS 'retourne le score pour une serie aleatoire';


--
-- TOC entry 1247 (class 1255 OID 2596073)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_avancement_max(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_avancement_max(bigint) RETURNS record
    AS $_$DECLARE
--$1 resultat
rec RECORD;
resultat RECORD;
BEGIN
	SELECT INTO resultat *
	FROM contraintes.af_get_resultat($1)  AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);

	IF resultat.etape IS NULL THEN
		RAISE EXCEPTION 'Erreur: ne peut determiner l''avancement d''une serie sans son identifiant.';
	END IF;

	SELECT INTO rec resultat.id,resultat.formation , resultat.stagiaire , resultat.parcours, resultat.etape, E.id, E.type,elt.ind, CAST(NULL AS interval) AS duree
	FROM contraintes.evaluation E ,contraintes.af_gen_get_elements('contraintes.serie_evaluations', 'evaluation', NULL, 'AND serie='||resultat.etape,0) elt
		
	WHERE E.id=elt.id
	AND elt.ind = 
	 (
		SELECT MIN(elt2.ind) FROM contraintes.af_gen_get_elements('contraintes.serie_evaluations', 'evaluation', NULL, 'AND serie='||resultat.etape,0) elt2
		LEFT OUTER JOIN contraintes.resultat_serie R2 ON (R2.id = $1 AND evaluation=elt2.id)
		WHERE R2.date_fin IS  NULL
	);


	select INTO rec.duree * from contraintes.af_get_resultat_serie_evaluations_duree_totale($1);

	RETURN rec; 
END;  $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_avancement_max(bigint) OWNER TO pgsql;

--
-- TOC entry 1248 (class 1255 OID 2596074)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_evaluation(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_evaluation(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 evaluation
rec RECORD;
rec_resultat RECORD;
BEGIN
	SELECT INTO rec_resultat * FROM contraintes.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RS.date_debut, RS.date_fin
		FROM contraintes.resultat_serie RS
		WHERE id=$1
		AND RS.evaluation=$2
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_evaluation(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1249 (class 1255 OID 2596075)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_evaluation_old(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_evaluation_old(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 evaluation
rec RECORD;
rec_resultat RECORD;
BEGIN
	SELECT INTO rec_resultat * FROM contraintes.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RS.date_debut, SE.commentaire, SE.bareme, SE.chrono, SE.points
		FROM contraintes.resultat_serie RS,
		contraintes.serie_evaluations SE
		WHERE id=$1
		AND RS.evaluation=$2
		AND SE.serie=rec_resultat.etape
		AND SE.evaluation=RS.evaluation
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_evaluation_old(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1250 (class 1255 OID 2596076)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_evaluation_tentative(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_evaluation_tentative(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 evaluation
rec RECORD;
rec_resultat RECORD;
BEGIN
	SELECT INTO rec_resultat * FROM contraintes.af_get_resultat_tentative($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval,tentative integer);
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RS.date_debut,RS.date_fin , SE.commentaire, SE.bareme, SE.chrono, SE.points
		FROM contraintes.resultat_serie_tentative RS,
		contraintes.serie_evaluations SE
		WHERE id=$1
		AND RS.evaluation=$2
		AND SE.serie=rec_resultat.etape
		AND SE.evaluation=RS.evaluation
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_evaluation_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1251 (class 1255 OID 2596077)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_evaluations(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_evaluations(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
begin
    for rec in 
	select * from contraintes.resultat_serie where id=$1
    loop
	return next rec;
    end loop;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_evaluations(bigint) OWNER TO pgsql;

--
-- TOC entry 8026 (class 0 OID 0)
-- Dependencies: 1251
-- Name: FUNCTION af_get_resultat_serie_evaluations(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_evaluations(bigint) IS 'retourne les evaluations d''une serie effecutées par l''individu';


--
-- TOC entry 27 (class 1255 OID 2596078)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_evaluations_duree_totale(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_evaluations_duree_totale(bigint) RETURNS interval
    AS $_$DECLARE
duree_totale INTERVAL;
resultat RECORD;
BEGIN

	SELECT INTO resultat *
	FROM contraintes.af_get_resultat($1)  AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);

	IF resultat.etape IS NULL THEN
		RAISE EXCEPTION 'Erreur: ne peut determiner la duree des evaluations d''une serie sans son identifiant.';
	END IF;

	

	SELECT INTO duree_totale SUM(RS.date_fin-RS.date_debut)
	FROM contraintes.af_gen_get_elements('contraintes.serie_evaluations', 'evaluation', NULL, 'AND serie='||resultat.etape,0) elt,
	contraintes.resultat_serie RS
	WHERE RS.id=resultat.id
	AND elt.id=RS.evaluation
	AND RS.date_debut IS NOT NULL
	AND RS.date_fin IS NOT NULL;

	RETURN duree_totale;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_evaluations_duree_totale(bigint) OWNER TO pgsql;

--
-- TOC entry 1252 (class 1255 OID 2596079)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_evaluations_scores_tentative(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_evaluations_scores_tentative(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec RECORD;
rec_resultat RECORD;
begin
    SELECT INTO rec_resultat * FROM contraintes.af_get_resultat_tentative($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval,tentative integer);
	FOR rec IN
	    SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
	    FROM contraintes.af_get_serie_evaluations(rec_resultat.etape) 
	    AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	LOOP

	raise notice 'type=%',rec.type_evaluation;
	    --QCM 
	    IF rec.type_evaluation=1 or rec.type_evaluation=4 THEN
	        SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_questionreponses_scores_tentative(rec_resultat.id, rec.id_evaluation);
	    END IF;
	    -- FTB
	    if rec.type_evaluation=3 then
		SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_ftb_scores_tentative(rec_resultat.id, rec.id_evaluation);
	    end if;
		RETURN NEXT rec;
	END LOOP;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_evaluations_scores_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 8029 (class 0 OID 0)
-- Dependencies: 1252
-- Name: FUNCTION af_get_resultat_serie_evaluations_scores_tentative(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_evaluations_scores_tentative(bigint) IS 'retourne les scores des evaluation d''une serie (tentative)';


--
-- TOC entry 1253 (class 1255 OID 2596080)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_evaluations_scores_toto(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_evaluations_scores_toto(bigint) RETURNS SETOF record
    AS $_$DECLARE
--$1 identifiant resultat
rec RECORD;
rec_resultat RECORD;
res_sondage integer;
BEGIN
    SELECT INTO rec_resultat * FROM contraintes.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	FOR rec IN
	    SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
	    FROM contraintes.af_get_serie_evaluations(rec_resultat.etape) 
	    AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	LOOP

	raise notice 'type=%',rec.type_evaluation;
	    --QCM 
	    IF rec.type_evaluation=1 or rec.type_evaluation=4 THEN
	        SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_questionreponses_scores(rec_resultat.id, rec.id_evaluation);
	    END IF;
	    -- FTB
	    if rec.type_evaluation=3 then
		SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_ftb_scores(rec_resultat.id, rec.id_evaluation);
	    end if;
		RETURN NEXT rec;
	END LOOP;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_evaluations_scores_toto(bigint) OWNER TO pgsql;

--
-- TOC entry 8031 (class 0 OID 0)
-- Dependencies: 1253
-- Name: FUNCTION af_get_resultat_serie_evaluations_scores_toto(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_evaluations_scores_toto(bigint) IS 'Obtenir les résultats des evaluations d''une serie(test sur qcm).';


--
-- TOC entry 1254 (class 1255 OID 2596081)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_evaluations_tentative(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_evaluations_tentative(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
begin
    for rec in 
	select * from contraintes.resultat_serie_tentative where id=$1
    loop
	return next rec;
    end loop;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_evaluations_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 8033 (class 0 OID 0)
-- Dependencies: 1254
-- Name: FUNCTION af_get_resultat_serie_evaluations_tentative(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_evaluations_tentative(bigint) IS 'retourne les evaluations d''une serie effecutées par l''individu';


--
-- TOC entry 1255 (class 1255 OID 2596082)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_ftb(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_ftb(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 ftb
rec RECORD;
rec_final RECORD;
chaine varchar;
langue integer;
mot varchar;
i integer;
j integer;
tab text[];

continu boolean;
BEGIN
    select into  rec RS.id, RS.evaluation,  RFTB.reponse,RS.date_debut
    FROM  contraintes.resultat_serie_ftb RFTB,contraintes.resultat_serie RS
    WHERE RS.id=$1
    AND RS.evaluation=$2
    AND RS.evaluation=RFTB.ftb
    AND RFTB.id=RS.id;
    if rec.reponse is not null then
    -- stock les réponses en tableau
    -- recup de la chaine
    SELECT INTO chaine SUBSTRING(rec.reponse,'##AMS[0-9]+##{"(.*?)"}');
    raise notice 'chaine=%',chaine;
    -- numero langue
    SELECT INTO langue  SUBSTRING(rec.reponse FROM '##AMS([0-9]+)##{');
    raise notice 'langue=%',langue;
    -- boucle sur les reponses
    j:=1;
    
    continu:=true;
    while continu is true
	loop
	mot=split_part(chaine,',',j);
	raise notice 'mot=%',mot;
	if mot ='' then
	    continu:=false;
	else
	    tab[j]:=mot;
	    j:=j+1;
	end if;
	end loop;

    FOR rec_final IN
	SELECT cast($1 as int8), cast($2 as integer),cast(tab as text[]), cast(rec.date_debut as timestamp),langue
	LOOP
	    RETURN NEXT rec_final;
	END LOOP;
    else
	FOR rec_final IN
	SELECT cast($1 as int8), cast($2 as integer),cast(null as text[]), cast(null as timestamp),cast(null as integer)
	LOOP
	    RETURN NEXT rec_final;
	END LOOP;
    end if;
    RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_ftb(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1256 (class 1255 OID 2596083)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_ftb_scores(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_ftb_scores(bigint, integer) RETURNS real
    AS $_$-- $1 : id resultat
-- $2 : evaluation

declare
rec record;
rec_ftb record;
rec_liste_mot text[];
rec_resultat_liste_mot record;
rec_bareme record;
mot text;
serie integer;
bareme integer;
langue_ams integer;
longueur_mot integer;
point real;
somme real;
total real;
begin
    
    -- recup n° serie de l'evaluation
    select into rec * from contraintes.af_get_resultat($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    serie:=rec.etape;
    -- recup n° bareme 
    select into bareme * from contraintes.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from contraintes.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from contraintes.af_get_evaluation_point(serie,$2);
    somme:=0;
    total:=0;
    
    -- recup resultat ftb
    select into rec_ftb * from contraintes.af_get_resultat_serie_ftb($1,$2) as (id int8, ftb integer, reponse text[],  date_creation timestamp,langue integer);
    
    -- recup de la liste des mots dans le texte du ftb
    -- Note : en fonction de la langue ams de la reponse
        
    select into rec_liste_mot * from contraintes.af_get_ftb_liste_mot($2,rec_ftb.langue);
    
    -- boucle sur les listes de mots
    FOR i IN array_lower(rec_liste_mot, 1) .. array_upper(rec_liste_mot, 1)
    
 
    loop
	
	-- supprime les cotes
	longueur_mot:=char_length(rec_ftb.reponse[i]);
	mot:=substring(rec_ftb.reponse[i] from 2 for longueur_mot -2);
	raise notice 'ftb_rep=%',rec_ftb.reponse[i];
	raise notice 'lst_mot=%',rec_liste_mot[i];
	-- traitement spécial pour mots séparés par ~ ex : lune~plume~brume
	if split_part(rec_liste_mot[i],'~',1)=mot or lower(mot)= lower(rec_liste_mot[i]) then
	--if lower(mot)= lower(rec_liste_mot[i]) then
	--if strpos(lower(rec_liste_mot[i]),lower(mot))>0 then
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;	
    end loop;
    somme:=(somme/total)*point;
    if somme<0 then
	somme:=0;
    end if;





    return somme;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_ftb_scores(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 8036 (class 0 OID 0)
-- Dependencies: 1256
-- Name: FUNCTION af_get_resultat_serie_ftb_scores(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_ftb_scores(bigint, integer) IS 'retourne le score d''un blanc de serie';


--
-- TOC entry 1868 (class 1255 OID 2596084)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_ftb_scores_tentative(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_ftb_scores_tentative(bigint, integer) RETURNS real
    AS $_$-- $1 : id resultat
-- $2 : evaluation
declare
rec record;
rec_ftb record;
rec_liste_mot text[];
rec_resultat_liste_mot record;
rec_bareme record;
mot text;
serie integer;
bareme integer;
longueur_mot integer;
point real;
somme real;
total real;
begin
    
    -- recup n° serie de l'evaluation
    select into rec * from contraintes.af_get_resultat_tentative($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    serie:=rec.etape;
    -- recup n° bareme 
    select into bareme * from contraintes.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from contraintes.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from contraintes.af_get_evaluation_point(serie,$2);
    somme:=0;
    total:=0;
    
    -- recup resultat ftb
    select into rec_ftb * from contraintes.af_get_resultat_serie_ftb($1,$2) as (id int8, ftb integer, reponse text[],  date_creation timestamp,langue integer);
    
    -- recup de la liste des mots dans le texte du ftb
    
    select into rec_liste_mot * from contraintes.af_get_ftb_liste_mot($2);
    
    -- boucle sur les listes de mots
    FOR i IN array_lower(rec_liste_mot, 1) .. array_upper(rec_liste_mot, 1) 
    loop
	
	-- supprime les cotes
	longueur_mot:=char_length(rec_ftb.reponse[i]);
	mot:=substring(rec_ftb.reponse[i] from 2 for longueur_mot -2);
	--raise notice 'ftb_rep=%',mot;
	--raise notice 'lst_mot=%',rec_liste_mot[i];
	if lower(mot)=lower(rec_liste_mot[i]) then
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;	
    end loop;
    somme:=(somme/total)*point;
    if somme<0 then
	somme:=0;
    end if;





    return somme;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_ftb_scores_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 8038 (class 0 OID 0)
-- Dependencies: 1868
-- Name: FUNCTION af_get_resultat_serie_ftb_scores_tentative(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_ftb_scores_tentative(bigint, integer) IS 'retourne le score d''un blans de serie';


--
-- TOC entry 1257 (class 1255 OID 2596085)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_ftb_tentative(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_ftb_tentative(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 ftb
rec RECORD;
BEGIN
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RFTB.reponse,RS.date_creation
		FROM  contraintes.resultat_serie_tentative_ftb RFTB,
		contraintes.resultat_serie RS
		WHERE RS.id=$1
		AND RS.evaluation=$2
		AND RS.evaluation=RFTB.ftb
		AND RFTB.id=RS.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_ftb_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1258 (class 1255 OID 2596086)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_melangee_avancement_max(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_melangee_avancement_max(bigint) RETURNS record
    AS $_$-- $1 : identifiant resultat
declare
rec record;
resultat record;
indice integer;
begin
    SELECT INTO resultat *
    FROM contraintes.af_get_resultat($1)  AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);

    IF resultat.etape IS NULL THEN
	RAISE EXCEPTION 'Erreur: ne peut determiner l''avancement d''une serie aleatoire sans son identifiant.';
    END IF;
     
	select into rec resultat.id,resultat.formation , resultat.stagiaire , resultat.parcours, resultat.etape, e_id, e_type,cast(e_id * 0 + random()as integer) as ind 
	from contraintes.af_get_serie_evaluations(resultat.etape)as  (e_id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, e_type int4 )
	left outer join contraintes.resultat_serie on (evaluation=e_id and id=$1)
	where id is null order by ind limit 1;
    
/*
	select into rec resultat.id,resultat.formation , resultat.stagiaire , resultat.parcours, resultat.etape, e_id, e_type,cast(e_id * 0 + random()as integer) as ind 
	from contraintes.af_get_serie_evaluations(resultat.etape)as  (e_id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, e_type int4 )
	left outer join contraintes.resultat_serie on (evaluation=e_id and id=$1)
	where id is null order by ind limit 1;
*/
	-- recup indice reel
	--select into indice * from contraintes.af_get_serie_evaluation_indice(resultat.etape,rec.e_id);
	
	select into indice count(*) +1 from contraintes.resultat_serie where id=$1;
	rec.ind:=indice;

	return rec;
	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_melangee_avancement_max(bigint) OWNER TO pgsql;

--
-- TOC entry 8041 (class 0 OID 0)
-- Dependencies: 1258
-- Name: FUNCTION af_get_resultat_serie_melangee_avancement_max(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_melangee_avancement_max(bigint) IS 'Retourne l''evaluation à faire d''une serie aleatoire configuree';


--
-- TOC entry 1259 (class 1255 OID 2596087)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_question_reponse(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_question_reponse(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 question_reponse
rec RECORD;
type_evaluation integer;
resultat real;

BEGIN
	SELECT INTO type_evaluation type FROM contraintes.af_get_question_reponse($2) AS (id integer, libelle varchar, type integer, date_creation timestamp, radio bool);
	raise notice 'type=%',type_evaluation;

	
	FOR rec IN 



/*
select $1,$2,QQ.question,QQ.reponse,rs_date_debut,coche,CAST(s_juste AS integer)
	    from contraintes.question_reponse_elements QQ
		LEFT OUTER JOIN 
		contraintes.af_get_question_reponse_solutions($2) AS (s_question_reponse integer, s_question integer,s_reponse integer ,s_juste bool )
	        on ( s_question_reponse=$2 AND QQ.question_reponse= s_question_reponse AND   QQ.question_reponse=$2  AND QQ.reponse = s_reponse AND QQ.question = s_question )
		left outer join contraintes.resultat_serie_question_reponse QR
		on ( QR.id=$1 AND QR.question_reponse=$2 AND QR.question_reponse=QQ.question_reponse AND QQ.reponse = QR.reponse AND QQ.question = QR.question)
		LEFT OUTER JOIN contraintes.af_get_resultat_serie_evaluation($1,$2) AS (rs_id int8, rs_evaluation integer, rs_date_debut timestamp, rs_date_fin timestamp)--commentaire varchar, bareme integer, chrono integer, points integer)
		ON (rs_id=$1 and $2=QQ.question_reponse AND QQ.question_reponse=rs_evaluation)
		WHERE QQ.question_reponse=$2
*/

select $1,$2,QQ.question_reponse_element,QQR.question_reponse_element as qre,rs_date_debut,coche,CAST(s_juste AS integer)
	    from contraintes.question_reponse_elements QQ
		left outer join
		contraintes.question_reponse_elements QQR
		on (QQ.question_reponse=QQR.question_reponse)
		LEFT OUTER JOIN 
		contraintes.af_get_question_reponse_solutions($2) AS (s_question_reponse integer, s_question integer,s_reponse integer ,s_juste bool )
	        on ( 
	        s_question_reponse=$2 
	        AND QQ.question_reponse= s_question_reponse
	        AND QQR.question_reponse= s_question_reponse 
	        AND QQ.question_reponse=$2 
	        and QQR.question_reponse=$2  
	        AND QQR.question_reponse_element = s_reponse 
	        AND QQ.question_reponse_element = s_question 
	        )
		left outer join contraintes.resultat_serie_question_reponse QR
		on ( 
		QR.id=$1 
		AND QR.question_reponse=$2 
		AND QR.question_reponse=QQ.question_reponse
		AND QR.question_reponse=QQR.question_reponse
		AND QQR.question_reponse_element = QR.reponse
		AND QQ.question_reponse_element = QR.question
		)
		LEFT OUTER JOIN contraintes.af_get_resultat_serie_evaluation($1,$2) AS (rs_id int8, rs_evaluation integer, rs_date_debut timestamp, rs_date_fin timestamp)--commentaire varchar, bareme integer, chrono integer, points integer)
		ON (
		rs_id=$1 
		and $2=QQ.question_reponse 
		and $2=QQR.question_reponse 
		AND QQ.question_reponse=rs_evaluation
		AND QQR.question_reponse=rs_evaluation
		)
		WHERE 
		QQ.question_reponse=$2 
		and QQR.question_reponse=$2 
		and QQ.question_reponse_element in (select id from contraintes.question_reponse_element where reponse is false) 
		and QQR.question_reponse_element in (select id from contraintes.question_reponse_element where reponse is true) 
		and QQ.question_reponse=$2 and QQR.question_reponse=$2




--version rémi
/*
select $1,$2,s_question,s_reponse,rs_date_debut,coche,CAST(s_juste AS integer)
	    from --contraintes.question_reponse_elements QQ
		--LEFT OUTER JOIN 
		contraintes.af_get_question_reponse_solutions($2) AS (s_question_reponse integer, s_question integer,s_reponse integer ,s_juste bool )
	        --on ( s_question_reponse=$2 AND QQ.question_reponse= s_question_reponse AND   QQ.question_reponse=$2  AND QQ.reponse = s_reponse AND QQ.question = s_question )
	        
		left outer join contraintes.resultat_serie_question_reponse QR
		on ( QR.id=$1 AND QR.question_reponse=$2 AND QR.question_reponse=s_question_reponse AND s_reponse = QR.reponse AND s_question = QR.question)
		
		LEFT OUTER JOIN contraintes.af_get_resultat_serie_evaluation($1,$2) AS (rs_id int8, rs_evaluation integer, rs_date_debut timestamp, rs_date_fin timestamp)--commentaire varchar, bareme integer, chrono integer, points integer)
		ON (rs_id=$1 and $2=s_question_reponse AND s_question_reponse=rs_evaluation)
		WHERE s_question_reponse=$2
*/

	LOOP
	raise notice 'type=%',type_evaluation;
	raise notice 'rec1=%',rec.question_reponse_element;
		IF type_evaluation=2 OR type_evaluation=5 THEN
			
			--SELECT INTO rec.s_juste * FROM contraintes.af_get_resultat_serie_sondage($2);
			--rec.s_juste:=60;
		--raise notice 'q=% et r=%',rec.QQ.question_reponse_element,rec.QQR.question_reponse_element;
		    select into resultat * from contraintes.af_get_resultat_sondage_question_reponse_score($1,$2,rec.question_reponse_element,rec.qre);
		--raise notice 'res=%',resultat;
		    rec.s_juste:=cast(resultat*100 as integer);
		END IF;

		RETURN NEXT rec;
	END LOOP;

	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_question_reponse(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1260 (class 1255 OID 2596088)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_question_reponse_tentative(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_question_reponse_tentative(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 question_reponse
rec RECORD;
type_evaluation integer;
resultat real;
BEGIN
	SELECT INTO type_evaluation type FROM contraintes.af_get_question_reponse($2) AS (id integer, libelle varchar, type integer, date_creation timestamp, radio bool);
	
	FOR rec IN 
		SELECT id, rs_evaluation, question,reponse,rs_date_debut,rs_date_fin, coche, CAST(s_juste AS integer)
		FROM  contraintes.resultat_serie_tentative_question_reponse QR
		INNER JOIN contraintes.af_get_resultat_serie_evaluation_tentative($1,$2) AS (rs_id int8, rs_evaluation integer, rs_date_debut timestamp,rs_date_fin timestamp, commentaire varchar, bareme integer, chrono integer, points integer)
		ON(	QR.id=rs_id AND QR.id=$1 AND QR.question_reponse=rs_evaluation)
		LEFT OUTER JOIN contraintes.af_get_question_reponse_solutions($2) AS (s_question_reponse integer, s_question integer,s_reponse integer ,s_juste bool )
		ON (	$2=s_question_reponse AND QR.reponse=s_reponse 
			AND QR.question=s_question AND s_question_reponse=$2)
	LOOP
		IF type_evaluation=2 OR type_evaluation=5 THEN
			--SELECT INTO rec.s_juste * FROM contraintes.af_get_resultat_serie_sondage($2);
			--rec.s_juste:=60;
		    select into resultat * from contraintes.af_get_resultat_sondage_question_reponse_score($1,$2,rec.question,rec.reponse);
		    rec.s_juste:=resultat*100;
		END IF;

		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_question_reponse_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1261 (class 1255 OID 2596089)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_questionreponses_scores(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_questionreponses_scores(bigint, integer) RETURNS real
    AS $_$-- $1 : $id_resultat
-- $2 : n° question reponse
declare
rec record;
rec_bareme record;
serie integer;
bareme integer;
point real;
somme real;
total real;
begin
    
    -- recup n° serie de l'evaluation
    select into rec * from contraintes.af_get_resultat($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    serie:=rec.etape;
    -- recup n° bareme 
    select into bareme * from contraintes.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from contraintes.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from contraintes.af_get_evaluation_point(serie,$2);
    --raise notice 'point=% et bareme=% et serie=%',point,bareme,serie;
    -- boucle sur les reponses
    somme:=0;
    total:=0;
    raise notice '$1=% et $2=%',$1,$2;	
    for rec in
	select * from contraintes.af_get_resultat_serie_question_reponse($1,$2) as (id int8, question_reponse integer, question integer, reponse integer,  date_creation timestamp, coche boolean, juste integer)
    loop
	raise notice 'rec.coche=% et rec.juste=%',rec.coche,rec.juste;
	if (rec.coche is true and rec.juste=1) or (rec.coche is false and rec.juste=0) then
       
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;

    end loop;
    if total>0 then
    --raise notice 'somme=%',somme;
    somme:=(somme/total)*point;
    end if;
    if somme<0 then
	somme:=0;
    end if;
    return somme;
     
     
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_questionreponses_scores(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 8045 (class 0 OID 0)
-- Dependencies: 1261
-- Name: FUNCTION af_get_resultat_serie_questionreponses_scores(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_questionreponses_scores(bigint, integer) IS 'retoune le score pour un qcm ';


--
-- TOC entry 1262 (class 1255 OID 2596090)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) RETURNS real
    AS $_$-- $1 : $id_resultat
-- $2 : n° question reponse
declare
rec record;
rec_bareme record;
serie integer;
bareme integer;
point real;
somme real;
total real;
begin
    
    -- recup n° serie de l'evaluation
    select into rec * from contraintes.af_get_resultat_tentative($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval,tentative integer);
    serie:=rec.etape;
    -- recup n° bareme 
    select into bareme * from contraintes.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from contraintes.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from contraintes.af_get_evaluation_point(serie,$2);
    -- boucle sur les reponses
    somme:=0;
    total:=0;	
    for rec in
	select * from contraintes.af_get_resultat_serie_question_reponse_tentative($1,$2) as (id int8, question_reponse integer, question integer, reponse integer,  date_debut timestamp, date_fin timestamp, coche boolean, juste integer)
    loop
	if (rec.coche is true and rec.juste=1) or (rec.coche is false and rec.juste=0) then
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;

    end loop;
    if total>0 then
    somme:=(somme/total)*point;
    end if;
    if somme<0 then
	somme:=0;
    end if;
raise notice '---------------score qr tentative =%',somme;
    
    return somme;
     
     
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 8047 (class 0 OID 0)
-- Dependencies: 1262
-- Name: FUNCTION af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) IS 'retoune le score pour un qcm ';


--
-- TOC entry 1263 (class 1255 OID 2596091)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_questionreponses_stagiaires(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_questionreponses_stagiaires(bigint, integer) RETURNS SETOF record
    AS $_$-- $1 : id resultat
-- $2 : evaluation
declare
rec_resultat record;
rec record;
rec2 record;
rec_stagiaire record;
begin
    -- Initialisation
    -- recup infos resultat
    select into rec_resultat * from contraintes.af_get_resultat($1) 
    AS (id int8,  formation int4, stagiaire int4,parcours int4, etape int4,  date_debut timestamp, duree interval);
    -- boucle sur les evaluation
    for rec in 
	select distinct srq.id from contraintes.resultat_serie_question_reponse srq 
	where question_reponse=$2
    loop
	-- formation courante
	select into rec2 * from contraintes.af_get_resultat(rec.id) 
	AS (id int8,  formation int4, stagiaire int4,parcours int4, etape int4,  date_debut timestamp, duree interval);
	if (rec_resultat.formation=rec2.formation) and (rec_resultat.parcours=rec2.parcours) and (rec_resultat.etape=rec2.etape) then
	    select into rec_stagiaire * from contraintes.af_get_individu_nom_prenom(rec2.stagiaire) as (s_id integer,s_nom varchar,s_prenom varchar);
	    return next rec_stagiaire;
	end if;
	

    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_questionreponses_stagiaires(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 8049 (class 0 OID 0)
-- Dependencies: 1263
-- Name: FUNCTION af_get_resultat_serie_questionreponses_stagiaires(bigint, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_questionreponses_stagiaires(bigint, integer) IS 'retourne les stagiaires ayants repondu à une evaluation(meme formation)';


--
-- TOC entry 1264 (class 1255 OID 2596092)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_score(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_score(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
nb integer;
point integer;
begin
    --total:=null;
    -- recupe etape
    SELECT INTO rec_resultat * FROM contraintes.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    total:=0;
    nb:=0;
    point:=0;
    FOR rec IN
	SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
		FROM contraintes.af_get_serie_evaluations(rec_resultat.etape) 
		AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
    LOOP
	--QCM et QRC
	IF rec.type_evaluation=1 OR rec.type_evaluation=4 THEN
	    SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_questionreponses_scores(rec_resultat.id, rec.id_evaluation);		
	--raise notice 'rec.type_evaluation=%',rec.type_evaluation;
	end if;
	IF rec.type_evaluation=3 THEN
	    SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_ftb_scores(rec_resultat.id, rec.id_evaluation);
			--rec.score=CAST(NULL AS integer);
			--FTB
			--SELECT RSFTB.id, RSFTB.ftb, RSFTB.reponse
			--FROM contraintes.resultat_serie_ftb RSFTB
			--WHERE RSFTB.ftb=rec.id_evaluation 
			--AND RSFTB.id=rec_resultat.id;
	END IF;
	
	    -- calcul à suivre
	    if rec.points_evaluation is not null then
	    --total:=total+(rec.score*20)/rec.points_evaluation;
	    total:=total + rec.score;
	    raise notice 'total=% et points=% et score=%',total,rec.points_evaluation,rec.score;
	    nb:=nb+1;
	    point:=point + rec.points_evaluation;	
	    end if;
	END LOOP;
	--raise notice 'total=%',total;
	if nb > 0 then
	    --return total/nb;
	    return (total*20)/point;
	else
	    return null;
	end if;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_score(bigint) OWNER TO pgsql;

--
-- TOC entry 8051 (class 0 OID 0)
-- Dependencies: 1264
-- Name: FUNCTION af_get_resultat_serie_score(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_score(bigint) IS 'retourne le score pour une serie ';


--
-- TOC entry 1265 (class 1255 OID 2596093)
-- Dependencies: 2983 5
-- Name: af_get_resultat_serie_score_tentative(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_serie_score_tentative(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
nb integer;
begin
    -- recupe etape
    SELECT INTO rec_resultat * FROM contraintes.af_get_resultat_tentative($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval,tentative integer);
    total:=0;
    nb:=0;
    FOR rec IN
	SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
		FROM contraintes.af_get_serie_evaluations(rec_resultat.etape) 
		AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
    LOOP
	--QCM et QRC
	IF rec.type_evaluation=1 OR rec.type_evaluation=4 THEN
	    SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_questionreponses_scores_tentative(rec_resultat.id, rec.id_evaluation);		
	raise notice 'QCM QRC---------------serie score =% (%,%) ',rec.score,rec_resultat.id, rec.id_evaluation;
	end if;
	IF rec.type_evaluation=3 THEN
	    SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_ftb_scores_tentative(rec_resultat.id, rec.id_evaluation);
			--rec.score=CAST(NULL AS integer);
			--FTB
			--SELECT RSFTB.id, RSFTB.ftb, RSFTB.reponse
			--FROM contraintes.resultat_serie_ftb RSFTB
			--WHERE RSFTB.ftb=rec.id_evaluation 
			--AND RSFTB.id=rec_resultat.id;
			raise notice 'FTB---------------serie score =% (%,%) ',rec.score,rec_resultat.id, rec.id_evaluation;
	END IF;
	raise notice '---------------serie score =% (%,%) ',rec.score,rec_resultat.id, rec.id_evaluation;

	
	-- calcul à suivre
	IF rec.score IS NOT NULL THEN
		total:=total+(rec.score*20)/rec.points_evaluation;
		nb:=nb+1;
	END IF;
	
	END LOOP;
	raise notice '---------------serie score tentative =%  (%)',total,total/nb;
	return total/nb;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_serie_score_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 8053 (class 0 OID 0)
-- Dependencies: 1265
-- Name: FUNCTION af_get_resultat_serie_score_tentative(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_serie_score_tentative(bigint) IS 'retourne le score pour une serie(tentative)';


--
-- TOC entry 1266 (class 1255 OID 2596094)
-- Dependencies: 2983 5
-- Name: af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) RETURNS real
    AS $_$-- $1 : id resultat
-- $2 : evaluation
-- $3 : question
-- $4 : reponse
declare
rec_resultat record;
rec record;
rec2 record;
nb_votant real;
nb_coche real;
begin
    -- Initialisation
    nb_votant:=0;
    nb_coche:=0;
    -- recup la formation
    select into rec_resultat * from contraintes.af_get_resultat($1) 
    AS (id int8,  formation int4, stagiaire int4,parcours int4, etape int4,  date_debut timestamp, duree interval);
    -- boucle sur la reponse cochée
    for rec in 
	select * from contraintes.resultat_serie_question_reponse srq 
	where question_reponse=$2 and question=$3 and reponse=$4 
	 --and coche is true
    loop
	-- formation courante
	select into rec2 * from contraintes.af_get_resultat(rec.id) 
	AS (id int8,  formation int4, stagiaire int4,parcours int4, etape int4,  date_debut timestamp, duree interval);
	if (rec_resultat.formation=rec2.formation) and (rec_resultat.parcours=rec2.parcours) and (rec_resultat.etape=rec2.etape) then
	    --raise notice 'form1=% et form2=%',rec_resultat.formation,rec2.formation;
	    if rec.coche is true then
		raise notice 'coucougg';
		nb_coche:=nb_coche + 1;
	    end if;
	    nb_votant:=nb_votant + 1;
	    --raise notice 'coche=% et votant=%',nb_coche,nb_votant;	
	end if;
    end loop;
    return (nb_coche/nb_votant);
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8055 (class 0 OID 0)
-- Dependencies: 1266
-- Name: FUNCTION af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) IS 'retourne le pourcentage pour une reponse de sondage';


--
-- TOC entry 1869 (class 1255 OID 2596095)
-- Dependencies: 2983 5
-- Name: af_get_resultat_tentative(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_tentative(integer, integer, integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : parcours
-- $4 : etape
-- $5 : numero tentative
declare
rec record;
begin
    if $5 <1 then
	-- On prend l'enregistrement de la derniere tentative
/*
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree,tentative
	FROM contraintes.resultat_tentative
	WHERE formation=$1
	AND stagiaire=$2
	AND parcours=$3
	AND etape=$4 
	group by id,formation,stagiaire,parcours,etape,date_debut, duree,tentative having tentative=max(tentative);
*/
	SELECT into rec R1.id,R1.formation, R1.stagiaire, R1.parcours, R1.etape, R1.date_debut, R1.duree,R1.tentative 
	FROM contraintes.resultat_tentative R1, contraintes.resultat_tentative R2
	WHERE R1.formation=$1
	AND R1.stagiaire=$2
	AND R1.parcours=$3
	AND R1.etape=$4
	--and R1.tentative=max(R2.tentative)
	group by R1.id,R1.formation,R1.stagiaire,R1.parcours,R1.etape,R1.date_debut, R1.duree,R1.tentative
	having R1.tentative=max(R2.tentative);
	
    else
	-- On prend l'enregistrement correspondant à la tentative
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree,tentative
	FROM contraintes.resultat_tentative
	WHERE formation=$1
	AND stagiaire=$2
	AND parcours=$3
	AND etape=$4
	and tentative=$5;
    end if;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_tentative(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8057 (class 0 OID 0)
-- Dependencies: 1869
-- Name: FUNCTION af_get_resultat_tentative(integer, integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_tentative(integer, integer, integer, integer, integer) IS 'retourne le dernier identifiant resultat_tentative ou celui correspondant à un numero de tentative';


--
-- TOC entry 1267 (class 1255 OID 2596096)
-- Dependencies: 2983 5
-- Name: af_get_resultat_tentative(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_resultat_tentative(bigint) RETURNS record
    AS $_$DECLARE
--$1 resultat
rec RECORD;
BEGIN
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree,tentative
	FROM contraintes.resultat_tentative
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_resultat_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 8059 (class 0 OID 0)
-- Dependencies: 1267
-- Name: FUNCTION af_get_resultat_tentative(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_resultat_tentative(bigint) IS 'retourne les attributs associes à un id resultat (tentative)';


--
-- TOC entry 1268 (class 1255 OID 2596097)
-- Dependencies: 2983 5
-- Name: af_get_salle(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_salle(integer) RETURNS record
    AS $_$-- $1 : numero salle
declare
rec record;
begin
    select into rec * from contraintes.af_get_salles() as (id int4,libelle varchar) where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_salle(integer) OWNER TO pgsql;

--
-- TOC entry 8061 (class 0 OID 0)
-- Dependencies: 1268
-- Name: FUNCTION af_get_salle(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_salle(integer) IS 'retourne une salle';


--
-- TOC entry 1269 (class 1255 OID 2596098)
-- Dependencies: 2983 5
-- Name: af_get_salle_evenements(integer, date); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_salle_evenements(integer, date) RETURNS SETOF record
    AS $_$-- $1 : numero salle
-- $2 : date
declare
rec record;
begin
    for rec in 
	select * from contraintes.evenement 
	where salle=$1 and cast(date as date)=$2
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_salle_evenements(integer, date) OWNER TO pgsql;

--
-- TOC entry 8063 (class 0 OID 0)
-- Dependencies: 1269
-- Name: FUNCTION af_get_salle_evenements(integer, date); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_salle_evenements(integer, date) IS 'retourne les evvenements dans une salle pour une journee de formation';


--
-- TOC entry 1270 (class 1255 OID 2596099)
-- Dependencies: 2983 5
-- Name: af_get_salles(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_salles() RETURNS SETOF record
    AS $$declare
rec record;
begin
	for rec in 
		select * from contraintes.salle order by libelle
	loop
		return next rec;
	end loop;
	return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_salles() OWNER TO postgres;

--
-- TOC entry 8065 (class 0 OID 0)
-- Dependencies: 1270
-- Name: FUNCTION af_get_salles(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_salles() IS 'Obtenir les salles de la plate-forme (auteur : Said)';


--
-- TOC entry 1271 (class 1255 OID 2596100)
-- Dependencies: 2983 5
-- Name: af_get_scenario(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_scenario(integer) RETURNS record
    AS $_$DECLARE
--$1 scenario
rec RECORD;
BEGIN
	SELECT INTO rec E_id, E_libelle, E_type, S.fichier ,F_libelle, F_connecte, E_date_creation
	FROM contraintes.af_get_etape($1)AS (E_id int4, E_libelle varchar, E_type int4,E_date_creation timestamp),
	contraintes.scenario S, contraintes.af_get_fichiers() AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool) 
	WHERE S.id=E_id
	AND S.fichier = F_id;

	IF rec.F_connecte IS FALSE THEN
		RAISE EXCEPTION 'Vous tentez de récuperer les informations d\'un scénario dont le fichier est déconnécté';
	END IF;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_scenario(integer) OWNER TO pgsql;

--
-- TOC entry 1272 (class 1255 OID 2596101)
-- Dependencies: 2983 5
-- Name: af_get_scenario_dynamique(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_scenario_dynamique(integer) RETURNS record
    AS $_$DECLARE
--$1 scenario
rec RECORD;
BEGIN
	SELECT INTO rec E_id, E_libelle, E_type, S.fichier ,F_libelle, F_connecte, E_date_creation
	FROM contraintes.af_get_etape($1)AS (E_id int4, E_libelle varchar, E_type int4,E_date_creation timestamp),
	contraintes.scenario_dynamique S, contraintes.af_get_fichiers() AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool) 
	WHERE S.id=E_id
	AND S.fichier = F_id;

	IF rec.F_connecte IS FALSE THEN
		RAISE EXCEPTION 'Vous tentez de récuperer les informations d\'un scenario dynamique dont le fichier est déconnécté';
	END IF;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_scenario_dynamique(integer) OWNER TO pgsql;

--
-- TOC entry 1273 (class 1255 OID 2596102)
-- Dependencies: 2983 5
-- Name: af_get_scenario_dynamique_fichier(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_scenario_dynamique_fichier(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du fichier
scenario_id int4;
BEGIN

	SELECT INTO scenario_id id FROM contraintes.scenario_dynamique
	WHERE fichier=$1;

	RETURN scenario_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_scenario_dynamique_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 8069 (class 0 OID 0)
-- Dependencies: 1273
-- Name: FUNCTION af_get_scenario_dynamique_fichier(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_scenario_dynamique_fichier(integer) IS 'Obtenir un scenario dynamque à partir de son numero de fichier.
';


--
-- TOC entry 1274 (class 1255 OID 2596103)
-- Dependencies: 2983 5
-- Name: af_get_scenario_fichier(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_scenario_fichier(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du fichier
scenario_id int4;
BEGIN

	SELECT INTO scenario_id id FROM contraintes.scenario
	WHERE fichier=$1;

	RETURN scenario_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_scenario_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 8071 (class 0 OID 0)
-- Dependencies: 1274
-- Name: FUNCTION af_get_scenario_fichier(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_scenario_fichier(integer) IS 'Obtenir un scenario à partir de son numero de fichier.
';


--
-- TOC entry 1275 (class 1255 OID 2596104)
-- Dependencies: 2983 5
-- Name: af_get_section(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_section(integer) RETURNS record
    AS $_$-- s1 : numero section
declare
rec record;
begin
    select into rec * from contraintes.af_get_sections() as (id int4,libelle varchar,icone int4) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_section(integer) OWNER TO pgsql;

--
-- TOC entry 8073 (class 0 OID 0)
-- Dependencies: 1275
-- Name: FUNCTION af_get_section(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_section(integer) IS 'retourne une section';


--
-- TOC entry 1276 (class 1255 OID 2596105)
-- Dependencies: 2983 5
-- Name: af_get_sections(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_sections() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select * from contraintes.section 
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_sections() OWNER TO pgsql;

--
-- TOC entry 8075 (class 0 OID 0)
-- Dependencies: 1276
-- Name: FUNCTION af_get_sections(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_sections() IS 'retourne les sections de la plateforme';


--
-- TOC entry 1277 (class 1255 OID 2596106)
-- Dependencies: 2983 5
-- Name: af_get_serie(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec E.id , E.libelle , S.bareme , S.chrono, E.date_creation 
	FROM contraintes.etape E, contraintes.serie S
	WHERE E.id= S.id
	AND E.id=$1;

	RETURN rec;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie(integer) OWNER TO pgsql;

--
-- TOC entry 8077 (class 0 OID 0)
-- Dependencies: 1277
-- Name: FUNCTION af_get_serie(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie(integer) IS 'Obtenir les informations d''une serie.';


--
-- TOC entry 1278 (class 1255 OID 2596107)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire(integer) RETURNS record
    AS $_$declare
rec record;
begin
    select into rec S_id,S_libelle,S_bareme,S_chrono,sa.type, date_creation from 
    contraintes.af_get_serie($1) as (S_id int4,S_libelle varchar, S_bareme int4, S_chrono int4, date_creation timestamp) ,
    contraintes.serie_aleatoire sa
    where sa.id=$1 and S_id=sa.id;

    
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire(integer) OWNER TO pgsql;

--
-- TOC entry 8079 (class 0 OID 0)
-- Dependencies: 1278
-- Name: FUNCTION af_get_serie_aleatoire(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire(integer) IS 'retourne les infos d''une serie aleatoire';


--
-- TOC entry 1279 (class 1255 OID 2596108)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_evaluations(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_evaluations(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : individu

declare
rec record;
begin
    FOR rec IN
		SELECT E.evaluation, EV.libelle, E.serie, E.pere,  EV.type 
		FROM contraintes.serie_aleatoire_evaluations E, 
		contraintes.af_gen_get_elements('contraintes.serie_aleatoire_evaluations', 'evaluation', NULL,' AND serie='||$1||' AND formation='||$2||' AND parcours='||$3||' AND stagiaire='||$4 ,0) G_id,
		contraintes.evaluation EV
		WHERE E.evaluation=G_id.id
		AND E.serie=$1
		AND E.evaluation=EV.id
		AND E.stagiaire=$4
		and E.parcours=$3
		ORDER BY G_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_evaluations(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8081 (class 0 OID 0)
-- Dependencies: 1279
-- Name: FUNCTION af_get_serie_aleatoire_evaluations(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire_evaluations(integer, integer, integer, integer) IS 'retourne les evaluations d''une serie aleatoire';


--
-- TOC entry 1280 (class 1255 OID 2596109)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_melangee_themes(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_melangee_themes() RETURNS SETOF record
    AS $$declare
rec record;

begin
    for rec in 
	select * from contraintes.af_get_serie_aleatoire_themes(1) as (id int4,libelle varchar)
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_melangee_themes() OWNER TO pgsql;

--
-- TOC entry 8083 (class 0 OID 0)
-- Dependencies: 1280
-- Name: FUNCTION af_get_serie_aleatoire_melangee_themes(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire_melangee_themes() IS 'retourne les themes pour les serie aleatoires configurees';


--
-- TOC entry 28 (class 1255 OID 2596110)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_multiserie_evaluation(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION af_get_serie_aleatoire_multiserie_evaluation(integer, integer, integer, integer, integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec * FROM contraintes.af_get_serie_aleatoire_multiserie_evaluations($1, $2, $3, $4)
	AS (id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4,type int4 )
	WHERE id=$5;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_multiserie_evaluation(integer, integer, integer, integer, integer) OWNER TO www;

--
-- TOC entry 1281 (class 1255 OID 2596111)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : individu

declare
rec record;
begin
    FOR rec IN
		SELECT E.evaluation, EV.libelle, E.serie, E.pere, SOURCE.commentaire,  SOURCE.bareme ,  SOURCE.chrono ,  SOURCE.points ,  EV.type 
		FROM contraintes.serie_aleatoire_evaluations E, 
		contraintes.af_gen_get_elements('contraintes.serie_aleatoire_evaluations', 'evaluation', NULL,' AND serie='||$1||' AND formation='||$2||' AND parcours='||$3||' AND stagiaire='||$4 ,0) G_id,
		contraintes.evaluation EV,
		contraintes.serie_evaluations SOURCE
		WHERE E.evaluation=G_id.id
		AND E.serie=$1
		AND E.evaluation=EV.id
		AND E.stagiaire=$4
		and E.parcours=$3
		AND SOURCE.serie=E.source
		AND SOURCE.evaluation=E.evaluation
		ORDER BY G_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8086 (class 0 OID 0)
-- Dependencies: 1281
-- Name: FUNCTION af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) IS 'retourne les evaluations d''une serie aleatoire';


--
-- TOC entry 1870 (class 1255 OID 2596112)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_multiserie_somme_chronos(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_multiserie_somme_chronos(integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : individu
somme int4;
BEGIN
	SELECT INTO somme SUM(chrono)
	FROM contraintes.af_get_serie_aleatoire_multiserie_evaluations($1, $2, $3, $4)
	AS (id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4,type int4 );
	
	RETURN somme;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_multiserie_somme_chronos(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1871 (class 1255 OID 2596113)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : individu
somme int4;
BEGIN
	SELECT INTO somme SUM(points) 
	FROM contraintes.af_get_serie_aleatoire_multiserie_evaluations($1, $2, $3, $4)
	AS (id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4,type int4 );
	
	RETURN somme;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8089 (class 0 OID 0)
-- Dependencies: 1871
-- Name: FUNCTION af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer) IS 'Obtenir la somme des points d''une série.';


--
-- TOC entry 1872 (class 1255 OID 2596114)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_multiserie_themes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_multiserie_themes(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;

begin
    for rec in 
	select * from contraintes.af_get_serie_aleatoire_themes(2,$1) as (id int4,libelle varchar)
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_multiserie_themes(integer) OWNER TO pgsql;

--
-- TOC entry 8091 (class 0 OID 0)
-- Dependencies: 1872
-- Name: FUNCTION af_get_serie_aleatoire_multiserie_themes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire_multiserie_themes(integer) IS 'retourne les themes pour les series aleatoires multiserie pour le root ou formateur';


--
-- TOC entry 1282 (class 1255 OID 2596115)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_series_associations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_series_associations(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
    for rec in
	select serie,serie_source,nb_evaluations,type_evaluations 
	from contraintes.serie_aleatoire_multiserie where 
	serie=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_series_associations(integer) OWNER TO pgsql;

--
-- TOC entry 8093 (class 0 OID 0)
-- Dependencies: 1282
-- Name: FUNCTION af_get_serie_aleatoire_series_associations(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire_series_associations(integer) IS 'retourne la configuration d''une serie aleatoire multiserie';


--
-- TOC entry 1283 (class 1255 OID 2596116)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_series_sources(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_series_sources(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
    for rec in
	select distinct serie_source from 
	contraintes.serie_aleatoire_multiserie where 
	serie=$1
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_series_sources(integer) OWNER TO pgsql;

--
-- TOC entry 8095 (class 0 OID 0)
-- Dependencies: 1283
-- Name: FUNCTION af_get_serie_aleatoire_series_sources(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire_series_sources(integer) IS 'retourne les series sources d''une serie aleatoire multiserie';


--
-- TOC entry 1284 (class 1255 OID 2596117)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_themes(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_themes(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : type de serie aleatoire
-- $2 individu
declare
rec record;

begin
    if contraintes.fw_is_root($2) then
    for rec in 
	select distinct t.id,t.libelle from 
	contraintes.theme t,
	contraintes.serie_aleatoire sa,
	contraintes.theme_categories tc where
	tc.categorie=19 and
	tc.theme=t.id and
	tc.id=sa.id and
	sa.type=$1
    loop
	return next rec;
    end loop;
    else
    for rec in 
	select distinct t.id,t.libelle from 
	contraintes.theme t,
	contraintes.serie_aleatoire sa,
	contraintes.theme_categories tc where
	tc.categorie=19 and
	tc.theme=t.id and
	tc.id=sa.id and
	sa.type=$1 and (t.individu=$2 OR t.individu IS NULL)
    loop
	return next rec;
    end loop;
    end if;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_themes(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8097 (class 0 OID 0)
-- Dependencies: 1284
-- Name: FUNCTION af_get_serie_aleatoire_themes(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire_themes(integer, integer) IS 'retourne les themes pour les series aleatoires pour un type de serie pour le root ou formateur';


--
-- TOC entry 1285 (class 1255 OID 2596118)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_themes_associations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_themes_associations(integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
for rec in
	select  serie,theme_source,nb_evaluations,type_evaluations 
	from contraintes.serie_aleatoire_multitheme  where 
	serie=$1 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_themes_associations(integer) OWNER TO pgsql;

--
-- TOC entry 8099 (class 0 OID 0)
-- Dependencies: 1285
-- Name: FUNCTION af_get_serie_aleatoire_themes_associations(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_aleatoire_themes_associations(integer) IS 'retourne la configuration d''une serie aleatoire multitheme';


--
-- TOC entry 1286 (class 1255 OID 2596119)
-- Dependencies: 2155 2983 5
-- Name: af_get_serie_aleatoire_type(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_type(integer) RETURNS type_element
    AS $_$DECLARE
--$1 serie aleatoire
retour contraintes.type_element;
serie_type contraintes.type_element;
type_eval int4;
libelle_type_eval varchar;
BEGIN
	SELECT INTO serie_type  S_type AS type, libelle
	FROM contraintes.af_get_serie_aleatoire($1) AS  (S_id int4,S_libelle varchar, S_bareme int4, S_chrono int4, S_type int4, date_creation timestamp),
	contraintes.serie_aleatoire_type T
	WHERE S_type=T.id;

	--AFFECTE LE TYPE DE SERIE ALEATOIRE
	retour.libelle:=serie_type.libelle;
	retour.id:=serie_type.id;

	IF serie_type.id=3 THEN --multi-themes
		SELECT INTO type_eval type_evaluations FROM contraintes.serie_aleatoire_multitheme
		WHERE serie=$1
		GROUP BY type_evaluations
		HAVING COUNT(type_evaluations)=1;
	ELSEIF serie_type.id=2 THEN --multi-serie
		SELECT INTO type_eval type_evaluations FROM contraintes.serie_aleatoire_multiserie
		WHERE serie=$1
		GROUP BY type_evaluations
		HAVING COUNT(type_evaluations)=1;
	END IF;

	IF type_eval IS NOT NULL THEN
		SELECT INTO libelle_type_eval libelle
		FROM contraintes.evaluation_type
		WHERE id=type_eval;

		--AFFECTE LE TYPE (D'EVALUATION)DE SERIE
		retour.libelle:=retour.libelle||'.''(''.'||libelle_type_eval||'.'')''';
		retour.id:=retour.id||'_'||type_eval;
	END IF;

	RETURN retour;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_type(integer) OWNER TO pgsql;

--
-- TOC entry 1873 (class 1255 OID 2596120)
-- Dependencies: 2983 5
-- Name: af_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
req varchar;
req2 varchar;
BEGIN
    req:='select distinct T.id, T.libelle, T.code, CAST(COUNT(T.id) AS integer), couleur
    from contraintes.evaluation_type T, contraintes.evaluation E, ';
    req2:=' GROUP BY T.id, T.libelle, T.code,couleur';
    req:=req || 'contraintes.serie_aleatoire_evaluations S WHERE T.id=E.type AND E.id=S.evaluation AND S.serie=' || $1||' and S.formation=' ||$2||' and S.parcours=' ||$3||' and S.stagiaire=' ||$4||req2;
	raise notice 'req=%',req;
	FOR rec IN EXECUTE req
	LOOP
			RETURN NEXT rec;
	END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1287 (class 1255 OID 2596121)
-- Dependencies: 2983 5
-- Name: af_get_serie_avancement(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_avancement(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
	
		SELECT RQR_formation, RQR_stagiaire, RQR_parcours,  $1 AS serie, RQR_question_response AS evaluation
		--FROM (contraintes.af_get_serie_evaluations($1) AS (SE_id int4, SE_libelle varchar, SE_serie int4, SE_pere int4, SE_commentaire varchar, SE_bareme int4, SE_chrono int4, SE_points int4, SE_type int4 )
		FROM (contraintes.af_gen_get_elements('contraintes.serie_evaluations', 'evaluation', NULL,' AND serie='||$1 ,0) G_id
		LEFT OUTER JOIN contraintes.af_get_serie_question_reponse_resultats($1) AS (RQR_id int4, RQR_formation int4,  RQR_classe int4, RQR_stagiaire int4, RQR_parcours int4,  RQR_etape int4, RQR_date_debut timestamp, RQR_date_fin timestamp, RQR_question_response int4, RQR_reponse int4, coche bool)
		ON (G_id.id=RQR_question_response))
		LEFT OUTER JOIN contraintes.af_get_serie_ftb_resultats($1) AS (RFTB_id int4, RFTB_formation int4,  RFTB_classe int4, RFTB_stagiaire int4, RFTB_parcours int4,  RFTB_etape int4, RFTB_date_debut timestamp, RFTB_date_fin timestamp, RFTB_ftb int4, RFTB_reponse text)
		ON (G_id.id=RFTB_ftb )
		--ORDER BY SE_id,G_id.ind, RQR_question_response, RQR_formation,RQR_classe, RQR_parcours, RQR_stagiaire 
		ORDER BY G_id.ind, RQR_question_response, RQR_formation,RQR_classe, RQR_parcours, RQR_stagiaire 
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_avancement(integer) OWNER TO pgsql;

--
-- TOC entry 1288 (class 1255 OID 2596122)
-- Dependencies: 2983 5
-- Name: af_get_serie_avancement_max(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_avancement_max(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	/*SELECT INTO rec  RQR_formation,  RQR_stagiaire, RQR_parcours,  RFTB_id AS serie, RQR_question_response AS evaluation
	--FROM (contraintes.af_get_serie_evaluations($1) AS (SE_id int4, SE_libelle varchar, SE_serie int4, SE_pere int4, SE_commentaire varchar, SE_bareme int4, SE_chrono int4, SE_points int4, SE_type int4 )
	FROM (contraintes.af_gen_get_elements('contraintes.serie_evaluations', 'evaluation', NULL,' AND serie='||$1 ,0) G_id
	LEFT OUTER JOIN contraintes.af_get_serie_question_reponse_resultats($1) AS (RQR_id int4, RQR_formation int4,  RQR_classe int4, RQR_stagiaire int4, RQR_parcours int4,  RQR_etape int4, RQR_date_debut timestamp, RQR_date_fin timestamp, RQR_question_response int4, RQR_reponse int4, coche bool)
	ON (G_id.id=RQR_question_response))
	LEFT OUTER JOIN contraintes.af_get_serie_ftb_resultats($1) AS (RFTB_id int4, RFTB_formation int4,  RFTB_classe int4, RFTB_stagiaire int4, RFTB_parcours int4,  RFTB_etape int4, RFTB_date_debut timestamp, RFTB_date_fin timestamp, RFTB_ftb int4, RFTB_reponse text)
	ON (G_id.id=RFTB_ftb )
	GROUP BY RFTB_id,G_id.ind, RQR_question_response, RQR_formation,RQR_classe, RQR_parcours, RQR_stagiaire
	HAVING G_id.ind=MAX(G_id.ind);
	
	RETURN rec;*/

	RETURN NULL;
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_avancement_max(integer) OWNER TO pgsql;

--
-- TOC entry 1289 (class 1255 OID 2596123)
-- Dependencies: 2983 5
-- Name: af_get_serie_bloquante_configuration(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_bloquante_configuration(integer, integer, integer) RETURNS record
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
declare
rec record;
begin
    select into rec * from contraintes.serie_bloquante where serie=$1 and formation=$2 and parcours=$3;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_bloquante_configuration(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8105 (class 0 OID 0)
-- Dependencies: 1289
-- Name: FUNCTION af_get_serie_bloquante_configuration(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_bloquante_configuration(integer, integer, integer) IS 'retourne la configuration d''une serie bloquante';


--
-- TOC entry 29 (class 1255 OID 2596124)
-- Dependencies: 2983 5
-- Name: af_get_serie_bloquante_tentative(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_bloquante_tentative(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
rec_resultat RECORD;
BEGIN

	FOR rec IN 
		SELECT id,formation,stagiaire,parcours,etape,date_debut,duree,tentative 
		FROM contraintes.resultat_tentative 
		WHERE formation=$1
		AND stagiaire=$2
		AND parcours=$3
		AND etape=$4

	LOOP
		RETURN NEXT rec;
	END LOOP;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_bloquante_tentative(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1290 (class 1255 OID 2596125)
-- Dependencies: 2983 5
-- Name: af_get_serie_commentaires(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_commentaires(integer) RETURNS SETOF record
    AS $_$-- $1 : numero serie
declare
rec record;
begin
    for rec in
	select etape,min,max,commentaire 
	from contraintes.commentaire_etape 
	where etape=$1
    loop
    return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_commentaires(integer) OWNER TO pgsql;

--
-- TOC entry 8108 (class 0 OID 0)
-- Dependencies: 1290
-- Name: FUNCTION af_get_serie_commentaires(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_commentaires(integer) IS 'retourne les commentaire d''une serie';


--
-- TOC entry 1291 (class 1255 OID 2596126)
-- Dependencies: 2983 5
-- Name: af_get_serie_distincts_types(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_distincts_types(integer) RETURNS SETOF record
    AS $_$-- $1 : serie
declare
rec record;
begin
    for rec in 
	select distinct ev.type from 
	contraintes.evaluation ev,contraintes.serie_evaluations se 
	where ev.id=se.evaluation and se.serie=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_distincts_types(integer) OWNER TO pgsql;

--
-- TOC entry 8110 (class 0 OID 0)
-- Dependencies: 1291
-- Name: FUNCTION af_get_serie_distincts_types(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_distincts_types(integer) IS 'retourne les différents types d''évaluation d''une serie';


--
-- TOC entry 1292 (class 1255 OID 2596127)
-- Dependencies: 2983 5
-- Name: af_get_serie_evaluation(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_evaluation(integer, integer) RETURNS record
    AS $_$
DECLARE
rec RECORD;
BEGIN

	SELECT INTO rec * FROM
	contraintes.af_get_serie_evaluations($1) AS (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 )
	WHERE evaluation=$2;
	 
	RETURN rec;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_evaluation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8112 (class 0 OID 0)
-- Dependencies: 1292
-- Name: FUNCTION af_get_serie_evaluation(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_evaluation(integer, integer) IS 'Obtenir les info d''une evaluation d''une serie.';


--
-- TOC entry 1293 (class 1255 OID 2596128)
-- Dependencies: 2983 5
-- Name: af_get_serie_evaluation_indice(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_evaluation_indice(integer, integer) RETURNS integer
    AS $_$-- $1 : serie
-- $2 : evaluation
declare
rec record;
ind integer;
begin
    ind:=0;
    for rec in 
	select * from contraintes.af_get_serie_evaluations($1) 
	as (id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 )
    loop
	if rec.id=$2 then
	    return ind;
	else
	    ind:=ind+1;
	end if;
    end loop;
    return ind;    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_evaluation_indice(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8114 (class 0 OID 0)
-- Dependencies: 1293
-- Name: FUNCTION af_get_serie_evaluation_indice(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_evaluation_indice(integer, integer) IS 'retourne l''indice d''une evaluation de serie';


--
-- TOC entry 30 (class 1255 OID 2596129)
-- Dependencies: 2983 5
-- Name: af_get_serie_evaluation_resultats(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_evaluation_resultats(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : serie
-- $2 : evaluation
declare
rec record;
begin
    for rec in
	select * from contraintes.resultat_serie where id=$1 and evaluation=$2
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_evaluation_resultats(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1294 (class 1255 OID 2596130)
-- Dependencies: 2983 5
-- Name: af_get_serie_evaluations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_evaluations(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	IF $1 IS NULL THEN
		RAISE EXCEPTION 'af_get_serie_evaluations requiert un parametre';
	END IF;
	FOR rec IN
		SELECT E.evaluation, EV.libelle, E.serie, E.pere, E.commentaire, E.bareme, E.chrono, E.points, EV.type 
		FROM contraintes.serie_evaluations E, 
		contraintes.af_gen_get_elements('contraintes.serie_evaluations', 'evaluation', NULL,' AND serie='||$1 ,0) G_id,
		contraintes.evaluation EV
		WHERE E.evaluation=G_id.id
		AND E.serie=$1
		AND E.evaluation=EV.id
		ORDER BY G_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_evaluations(integer) OWNER TO pgsql;

--
-- TOC entry 8117 (class 0 OID 0)
-- Dependencies: 1294
-- Name: FUNCTION af_get_serie_evaluations(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_evaluations(integer) IS 'Obtenir les evaluations d''une serie.';


--
-- TOC entry 1295 (class 1255 OID 2596131)
-- Dependencies: 2983 5
-- Name: af_get_serie_evaluations_disponibles_theme(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_evaluations_disponibles_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 serie
--$2 theme
--$3 type d'evaluation
rec RECORD;
BEGIN

	FOR rec IN
		SELECT E.id,lower(E.libelle) AS min_text, E.type
		FROM contraintes.evaluation E,
		contraintes.af_get_theme_elements($2) AS (T_id int4 , T_categorie int4)
		WHERE E.id= T_id 
		AND E.id NOT IN
			(SELECT evaluation FROM contraintes.af_get_serie_evaluations($1) AS (evaluation int4,  libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) )
		ORDER BY E.type, min_text
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_evaluations_disponibles_theme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8119 (class 0 OID 0)
-- Dependencies: 1295
-- Name: FUNCTION af_get_serie_evaluations_disponibles_theme(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_evaluations_disponibles_theme(integer, integer) IS 'Obtenir les evaluations disponibles  d''un theme donné pour une serie. ';


--
-- TOC entry 1296 (class 1255 OID 2596132)
-- Dependencies: 2983 5
-- Name: af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 serie
--$2 theme
--$3 categorie d'evaluation
rec RECORD;
BEGIN

	FOR rec IN
		SELECT E.id,lower(E.libelle) AS min_text, E.type
		FROM contraintes.evaluation E,
		contraintes.af_get_categorie_elements_theme($3, $2) AS T_id
		WHERE E.id= T_id 
		AND E.id NOT IN
			(SELECT evaluation FROM contraintes.af_get_serie_evaluations($1) AS (evaluation int4,  libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) )
		ORDER BY E.type, min_text
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8121 (class 0 OID 0)
-- Dependencies: 1296
-- Name: FUNCTION af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) IS 'Obtenir les evaluations disponibles  d''un theme et d''une categorie donnés pour une serie. ';


--
-- TOC entry 1297 (class 1255 OID 2596133)
-- Dependencies: 2983 5
-- Name: af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 serie
--$2 theme
--$3 type d'evaluation
rec RECORD;
BEGIN

	FOR rec IN
		-- lower génant pour AMS
		--SELECT DISTINCT E.id,lower(E.libelle) AS min_text, E.type
		SELECT  distinct E.id,cast(E.libelle as text) , E.type
		FROM contraintes.evaluation E,
		contraintes.af_get_theme_elements($2) AS (T_id int4 , T_categorie int4)
		WHERE E.id= T_id 
		AND E.type=$3
		AND E.id NOT IN
			(SELECT evaluation FROM contraintes.af_get_serie_evaluations($1) AS (evaluation int4,  libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) )
		--ORDER BY E.type, min_text
		--ORDER BY E.type
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8123 (class 0 OID 0)
-- Dependencies: 1297
-- Name: FUNCTION af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) IS 'Obtenir les evaluations disponibles  d''un theme et d''un type donnés pour une serie. ';


--
-- TOC entry 1874 (class 1255 OID 2596134)
-- Dependencies: 2983 5
-- Name: af_get_serie_ftb_resultats(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_ftb_resultats(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
		FOR rec IN
			/*SELECT
			FROM contraintes.af_get_serie_evaluations($1) AS (SE_id int4, SE_libelle varchar, SE_serie int4, SE_pere int4, SE_commentaire varchar, SE_bareme int4, SE_chrono int4, SE_points int4, SE_type int4 )
			LEFT OUTER JOIN 
				(contraintes.resultat_serie_question_reponse RSQR 
					INNER JOIN contraintes.af_get_etape_resultats($1) AS (R_id int4, R_formation int4,  R_classe int4, R_stagiaire int4, R_parcours int4,  R_etape int4, R_date_debut timestamp, R_date_fin timestamp)
					ON (RSQR.id=R_id)
			ON (serie=RSQR.serie)*/

			SELECT R_id , R_formation ,  R_classe , R_stagiaire , R_parcours ,  R_etape , R_date_debut, R_date_fin , RSFTB.ftb, RSFTB.reponse
			FROM contraintes.af_get_etape_resultats($1) AS (R_id int4, R_formation int4,  R_classe int4, R_stagiaire int4, R_parcours int4,  R_etape int4, R_date_debut timestamp, R_date_fin timestamp),
			contraintes.resultat_serie_ftb RSFTB
			WHERE R_id=RSFTB.id
			AND R_etape=RSFTB.serie

		LOOP
			RETURN NEXT rec;
		END LOOP;

		RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_ftb_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 1298 (class 1255 OID 2596135)
-- Dependencies: 2983 5
-- Name: af_get_serie_individus(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_individus(integer) RETURNS SETOF record
    AS $_$-- $1 : serie
declare
rec record;
begin
    for rec in
	select r.formation,f.libelle,r.stagiaire,i.nom,i.prenom,r.parcours,e.libelle,r.etape
	from contraintes.resultat r,contraintes.formation f,contraintes.fw_individu i,contraintes.etape e 
	where r.etape=$1 
	and r.formation=f.id
	and r.stagiaire=i.id 
	and r.parcours=e.id
    loop
	return next rec;

    end loop;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_individus(integer) OWNER TO pgsql;

--
-- TOC entry 8126 (class 0 OID 0)
-- Dependencies: 1298
-- Name: FUNCTION af_get_serie_individus(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_individus(integer) IS 'retourne les individus et formations pour la serie donnée';


--
-- TOC entry 1299 (class 1255 OID 2596136)
-- Dependencies: 2983 5
-- Name: af_get_serie_question_reponse_resultats(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_question_reponse_resultats(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
		FOR rec IN
			/*SELECT
			FROM contraintes.af_get_serie_evaluations($1) AS (SE_id int4, SE_libelle varchar, SE_serie int4, SE_pere int4, SE_commentaire varchar, SE_bareme int4, SE_chrono int4, SE_points int4, SE_type int4 )
			LEFT OUTER JOIN 
				(contraintes.resultat_serie_question_reponse RSQR 
					INNER JOIN contraintes.af_get_etape_resultats($1) AS (R_id int4, R_formation int4,  R_classe int4, R_stagiaire int4, R_parcours int4,  R_etape int4, R_date_debut timestamp, R_date_fin timestamp)
					ON (RSQR.id=R_id)
			ON (serie=RSQR.serie)*/
			-- CE QUI SUIT NE FONCTIONNE PAS !!!
			SELECT R_id , R_formation ,  R_classe , R_stagiaire , R_parcours ,  R_etape , R_date_debut, R_date_fin , RSQR.question_reponse, RSQR.reponse, RSQR.coche
			FROM contraintes.af_get_etape_resultats($1) AS (R_id int4, R_formation int4,  R_classe int4, R_stagiaire int4, R_parcours int4,  R_etape int4, R_date_debut timestamp, R_ddate_fin timestamp),
			contraintes.resultat_serie_question_reponse RSQR
			WHERE R_id=RSQR.id
			AND R_etape=RSQR.serie

		LOOP
			RETURN NEXT rec;
		END LOOP;

		RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_question_reponse_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 1300 (class 1255 OID 2596137)
-- Dependencies: 2983 5
-- Name: af_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 serie
--$2 theme
--$3 type d'evaluation
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT ELT.id,ELT.libelle, ELT.type, lower(ELT.libelle) as minlib
		FROM contraintes.af_get_categorie_elements_theme(17,$2) T_id ,
		contraintes.question_reponse_elements QR,
		contraintes.question_reponse_element ELT,
		contraintes.evaluation E
		WHERE E.type=$3 
		--AND (QR.question=T_id)
		AND (QR.question_reponse_element=T_id)
		--AND ELT.id=QR.question
		AND ELT.id=QR.question_reponse_element
		AND E.id=QR.question_reponse
		AND E.id NOT IN
			(SELECT evaluation FROM contraintes.af_get_serie_evaluations($1) AS (evaluation int4,  libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) )
		and QR.question_reponse_element in (select id from contraintes.question_reponse_element where reponse is false)
		ORDER BY minlib
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1301 (class 1255 OID 2596138)
-- Dependencies: 2983 5
-- Name: af_get_serie_series_aleatoires(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_series_aleatoires(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT id, libelle,type, date_creation  FROM contraintes.serie_aleatoire_multiserie, contraintes.af_get_etape($1) AS (id int4, libelle varchar, type int4, date_creation timestamp)
		WHERE serie_source=$1
		AND id=serie
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_series_aleatoires(integer) OWNER TO pgsql;

--
-- TOC entry 1875 (class 1255 OID 2596139)
-- Dependencies: 2983 5
-- Name: af_get_serie_simple(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_simple(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec E.id , E.libelle , S.bareme , S.chrono,date_creation  
	FROM contraintes.etape E, contraintes.serie S LEFT OUTER JOIN contraintes.serie_aleatoire SA
	ON (S.id=SA.id)
	WHERE E.id= S.id
	AND E.id=$1
	AND SA.id IS NULL;

	RETURN rec;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_simple(integer) OWNER TO pgsql;

--
-- TOC entry 8131 (class 0 OID 0)
-- Dependencies: 1875
-- Name: FUNCTION af_get_serie_simple(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_simple(integer) IS 'Obtenir les informations d''une serie simple.';


--
-- TOC entry 1302 (class 1255 OID 2596140)
-- Dependencies: 2155 2983 5
-- Name: af_get_serie_simple_type(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_simple_type(integer) RETURNS type_element
    AS $_$DECLARE
--$1 serie
type_serie contraintes.type_element;
nb_types int4;
BEGIN
	IF $1 IS NULL THEN
		RAISE EXCEPTION 'af_get_serie_type requiert un parametre';
	END IF;

	--compte le nombre de type différents
	SELECT INTO nb_types sum(cnt) 
	FROM(
		--compte 1 pour chaque type différent
		SELECT 1 AS cnt
		FROM contraintes.af_get_serie_evaluations($1) 
		AS (S_id int4, S_libelle varchar, S_serie int4, S_pere int4, S_commentaire varchar, S_bareme int4, S_chrono int4, S_points int4, S_type int4 )
		GROUP BY S_type
	) AS t;
	--si un seul type, on récupere le type des evaluations (qui est le meme normalement)
	IF nb_types=1 THEN
		
		FOR type_serie IN
			SELECT S_type AS T_id, E.libelle AS T_libelle
			FROM contraintes.af_get_serie_evaluations($1) 
			AS (S_id int4, S_libelle varchar, S_serie int4, S_pere int4, S_commentaire varchar, S_bareme int4, S_chrono int4, S_points int4, S_type int4 ),
			contraintes.evaluation_type E
			WHERE E.id=S_type
			GROUP BY S_type,E.libelle
		LOOP 
			--rien ;)
		END LOOP;
	END IF;
	RETURN type_serie;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_simple_type(integer) OWNER TO pgsql;

--
-- TOC entry 1303 (class 1255 OID 2596141)
-- Dependencies: 2983 5
-- Name: af_get_serie_somme_chronos(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_somme_chronos(integer) RETURNS integer
    AS $_$DECLARE
--$1 serie
somme int4;
BEGIN
	SELECT INTO somme SUM(chrono)
	FROM contraintes.af_get_serie_evaluations($1) AS(id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );

	RETURN somme;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_somme_chronos(integer) OWNER TO pgsql;

--
-- TOC entry 1304 (class 1255 OID 2596142)
-- Dependencies: 2983 5
-- Name: af_get_serie_somme_points(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_somme_points(integer) RETURNS integer
    AS $_$DECLARE
somme int4;
BEGIN
	SELECT INTO somme SUM(points) FROM contraintes.serie_evaluations where serie=$1;
	RETURN somme;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_somme_points(integer) OWNER TO pgsql;

--
-- TOC entry 8135 (class 0 OID 0)
-- Dependencies: 1304
-- Name: FUNCTION af_get_serie_somme_points(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_serie_somme_points(integer) IS 'Obtenir la somme des points d''une série.';


--
-- TOC entry 1305 (class 1255 OID 2596143)
-- Dependencies: 2983 5
-- Name: af_get_serie_types_evaluations_type(integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_serie_types_evaluations_type(integer, boolean) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
req varchar;
req2 varchar;
BEGIN
	req:='select distinct T.id, T.libelle, T.code, CAST(COUNT(T.id) AS integer), couleur
	from contraintes.evaluation_type T, contraintes.evaluation E, ';

	req2:=' GROUP BY T.id, T.libelle, T.code,couleur';

	IF($2 IS TRUE)THEN
		req:=req || 'contraintes.serie_aleatoire_evaluations S WHERE T.id=E.type AND E.id=S.serie AND S.serie=' || $1||req2;
	ELSE
		req:=req || 'contraintes.serie_evaluations S WHERE T.id=E.type AND E.id=S.evaluation AND S.serie=' || $1||req2;
	END IF;
	raise notice 'req=%',req;
	FOR rec IN EXECUTE req
	LOOP
			RETURN NEXT rec;
	END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_serie_types_evaluations_type(integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1306 (class 1255 OID 2596144)
-- Dependencies: 2983 5
-- Name: af_get_series_aleatoires_type(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_series_aleatoires_type(integer) RETURNS SETOF record
    AS $_$declare
rec record;
req varchar;
table_aleatoire varchar;
begin
/*
    if($1=2) then
	table_aleatoire:='serie_aleatoire_multiserie';
    else
	table_aleatoire:='serie_aleatoire_multitheme';
    end if;
    req:='select  e.id,e.libelle from contraintes.etape e,contraintes.'||table_aleatoire||' a
    where e.id=a.serie' ;
    --raise exception 'sql=%',req;
*/    
    for rec in
	--execute req
	select e.id,e.libelle from 
	contraintes.etape e,
	contraintes.serie_aleatoire sa where
	e.id=sa.id and sa.type=$1
    loop
	return next rec;
    end loop;
    return;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_series_aleatoires_type(integer) OWNER TO pgsql;

--
-- TOC entry 8138 (class 0 OID 0)
-- Dependencies: 1306
-- Name: FUNCTION af_get_series_aleatoires_type(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_series_aleatoires_type(integer) IS 'Obtenir les series aleatoires pour un type donné';


--
-- TOC entry 1307 (class 1255 OID 2596145)
-- Dependencies: 2983 5
-- Name: af_get_session_individus(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_session_individus() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select individu,nom,prenom,formation 
	from contraintes.fw_individu,contraintes.session where id=individu
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_session_individus() OWNER TO pgsql;

--
-- TOC entry 8140 (class 0 OID 0)
-- Dependencies: 1307
-- Name: FUNCTION af_get_session_individus(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_session_individus() IS 'retourne les individus en session';


--
-- TOC entry 1308 (class 1255 OID 2596146)
-- Dependencies: 2983 5
-- Name: af_get_sondage_elements(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_sondage_elements() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		select * from contraintes.af_get_question_reponse_elements(2) as (E_id int4,E_libelle varchar,E_interpretation_html bool,E_reponse bool)
		--select E_id,E_libelle,E_interpretation_html,E_reponse from contraintes.af_get_question_reponse_elements(2) as (E_id int4,E_libelle varchar,E_interpretation_html bool,E_reponse bool) 
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_sondage_elements() OWNER TO postgres;

--
-- TOC entry 8142 (class 0 OID 0)
-- Dependencies: 1308
-- Name: FUNCTION af_get_sondage_elements(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_sondage_elements() IS 'FONCTION PRIVEE: Obtenir les enregistrements de la table question_reponse_element pour un type donnÃ©';


--
-- TOC entry 31 (class 1255 OID 2596147)
-- Dependencies: 2983 5
-- Name: af_get_sondage_propositions(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_sondage_propositions(integer) RETURNS SETOF record
    AS $_$-- $1 : question_reponse
declare
rec record;
begin
    for rec in 
	select $1,a.question_reponse_element,b.question_reponse_element 
	from contraintes.question_reponse_elements a,contraintes.question_reponse_elements b 
	where a.question_reponse_element 
	in (select id from contraintes.question_reponse_element where reponse is false) 
	and b.question_reponse_element 
	in (select id from contraintes.question_reponse_element where reponse is true) 
	and a.question_reponse=$1 and b.question_reponse=$1
    loop
	return next rec;
    end loop;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_sondage_propositions(integer) OWNER TO pgsql;

--
-- TOC entry 8144 (class 0 OID 0)
-- Dependencies: 31
-- Name: FUNCTION af_get_sondage_propositions(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_sondage_propositions(integer) IS 'retourne les proposition d''un sondage';


--
-- TOC entry 1309 (class 1255 OID 2596148)
-- Dependencies: 2983 5
-- Name: af_get_stagiaire_exotlcs_corriges_formation(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_stagiaire_exotlcs_corriges_formation(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : stagiaire
-- $2 : formation
declare
rec record;
begin
    for rec in
	select * from 
	contraintes.af_get_formation_etapes_type($2,'5') 
	as(id int4, libelle_pour_parcours varchar, libelle_etape  varchar,libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool,libelle_type_original varchar, modifiable bool,indice integer) 
	where id in 
	(select r.etape from contraintes.resultat r where r.formation=$2 and r.stagiaire=$1 and r.id in 
	(select re.id from contraintes.resultat_exotlc re where re.date_correction is not null))
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_stagiaire_exotlcs_corriges_formation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8146 (class 0 OID 0)
-- Dependencies: 1309
-- Name: FUNCTION af_get_stagiaire_exotlcs_corriges_formation(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_stagiaire_exotlcs_corriges_formation(integer, integer) IS 'retourne ts les exotlcs corriges pour un stagiaire et une formtion';


--
-- TOC entry 1310 (class 1255 OID 2596149)
-- Dependencies: 2983 5
-- Name: af_get_stagiaires_formation(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_stagiaires_formation() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct i.id,i.nom,i.prenom
	from contraintes.fw_individu i,contraintes.classe_individus ci,contraintes.formation_participants fp
	where i.id=ci.individu and ci.classe=fp.classe
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_stagiaires_formation() OWNER TO pgsql;

--
-- TOC entry 8148 (class 0 OID 0)
-- Dependencies: 1310
-- Name: FUNCTION af_get_stagiaires_formation(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_stagiaires_formation() IS 'retourne les stagiaires des formations de la plateforme';


--
-- TOC entry 1311 (class 1255 OID 2596150)
-- Dependencies: 2983 5
-- Name: af_get_template(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_template(integer) RETURNS record
    AS $_$-- $1 : numero modele
declare
rec record;
begin
    select into rec id,libelle from contraintes.modele_correction where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_template(integer) OWNER TO pgsql;

--
-- TOC entry 8150 (class 0 OID 0)
-- Dependencies: 1311
-- Name: FUNCTION af_get_template(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_template(integer) IS 'retourne un modele de correction (id,libelle)';


SET default_tablespace = '';

SET default_with_oids = true;

--
-- TOC entry 3927 (class 1259 OID 2596151)
-- Dependencies: 4952 5
-- Name: modele_correction_criteres; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE modele_correction_criteres (
    modele_correction integer NOT NULL,
    critere integer NOT NULL,
    pere integer,
    note_max integer,
    CONSTRAINT check_note_max CHECK ((note_max > 0))
);


ALTER TABLE contraintes.modele_correction_criteres OWNER TO postgres;

--
-- TOC entry 1312 (class 1255 OID 2596154)
-- Dependencies: 2160 2983 5
-- Name: af_get_template_associations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_template_associations(integer) RETURNS SETOF modele_correction_criteres
    AS $_$-- $1 : numero modele
declare
rec record;
rec2 record;
trans int4;
begin
    for rec in 
	select modele_correction,id,pere,note_max from contraintes.af_get_template_criteres($1) as (modele_correction int4,id int4,libelle varchar,pere int4,note_max int4)
    loop
	if rec.note_max is null then
	    return next rec;
	    -- cas d'un critere avec sous criteres
	    -- boucle sur ses sous criteres 
	
	    for rec2 in 
		select modele_correction,id,pere,note_max from contraintes.af_get_template_sous_criteres($1,rec.id) as (modele_correction int4,id int4,libelle varchar,pere int4,note_max int4)
	    loop
		trans:=rec2.id;
		rec2.id:=rec2.pere;
		rec2.pere:=trans;
		return next rec2;
	    end loop;
	else
	    return next rec;
        end if;
    end loop;
		
	
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_template_associations(integer) OWNER TO pgsql;

--
-- TOC entry 8153 (class 0 OID 0)
-- Dependencies: 1312
-- Name: FUNCTION af_get_template_associations(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_template_associations(integer) IS 'retourne les associations pour un modele de correction';


--
-- TOC entry 1313 (class 1255 OID 2596155)
-- Dependencies: 2983 5
-- Name: af_get_template_criteres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_template_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : nnumero modele
declare
rec record;
t_ids _int4;
i int4 :=0;
begin
    -- recup les criteres du modele ds 1 tablo
    for rec in 
	select c_id
	from contraintes.af_get_template_criteres_non_ordonnes($1) as (c_modele_correction int4,c_id int4,c_libelle varchar,c_pere int4,c_note_max int4)
    loop
	t_ids[i]:=rec.c_id;
	i:=i+1;
    end loop;	
    for rec in 
	select c_modele_correction,c_id,c_libelle,c_pere,c_note_max 
	from contraintes.af_gen_get_elements('contraintes.modele_correction_criteres','critere',NULL,'and modele_correction='||$1,1,t_ids) ID,
	contraintes.af_get_template_criteres_non_ordonnes($1) as (c_modele_correction int4,c_id int4,c_libelle varchar,c_pere int4,c_note_max int4)
	where ID.id=c_id order by ID.ind
    loop
	return next rec;

    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_template_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 8155 (class 0 OID 0)
-- Dependencies: 1313
-- Name: FUNCTION af_get_template_criteres(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_template_criteres(integer) IS 'retourne les criteres d''un modele de correction (ds l''ordre)';


--
-- TOC entry 1314 (class 1255 OID 2596156)
-- Dependencies: 2983 5
-- Name: af_get_template_criteres_non_ordonnes(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_template_criteres_non_ordonnes(integer) RETURNS SETOF record
    AS $_$-- $1 : numero modele
declare
rec record;
begin
    for rec in
	select distinct mc.modele_correction,c_id,c_libelle,c_pere,mc.note_max from contraintes.af_get_criteres() as (c_id int4,c_libelle varchar,c_pere int4),
	contraintes.modele_correction_criteres mc 
	where mc.modele_correction=$1 and c_id=mc.critere and c_pere is null
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_template_criteres_non_ordonnes(integer) OWNER TO pgsql;

--
-- TOC entry 8157 (class 0 OID 0)
-- Dependencies: 1314
-- Name: FUNCTION af_get_template_criteres_non_ordonnes(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_template_criteres_non_ordonnes(integer) IS 'retourne les criteres d''un modele de correction';


--
-- TOC entry 1876 (class 1255 OID 2596157)
-- Dependencies: 2983 5
-- Name: af_get_template_sous_critere(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_template_sous_critere(integer, integer, integer) RETURNS record
    AS $_$-- $1 : numero modele
-- $2 : numero critere
-- $3 : numero ss critere
declare
rec record;

begin
	SELECT INTO rec * FROM contraintes.af_get_template_sous_criteres($1,$2)
	AS (modele_correction int4,id int4,libelle varchar,pere int4,note_max int4)
	WHERE id=$3;

	RETURN rec;
   
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_template_sous_critere(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8159 (class 0 OID 0)
-- Dependencies: 1876
-- Name: FUNCTION af_get_template_sous_critere(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_template_sous_critere(integer, integer, integer) IS 'retourne un sous critere d''un modele ds l''ordre';


--
-- TOC entry 1315 (class 1255 OID 2596158)
-- Dependencies: 2983 5
-- Name: af_get_template_sous_criteres(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_template_sous_criteres(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero modele
-- $2 : numero critere
declare
rec record;
t_ids _int4;
i int4 :=0;
begin
    -- recup les sous criteres du modele ds 1 tablo
    for rec in 
	select c_id
	from contraintes.af_get_template_sous_criteres_non_ordonnes($1,$2) as (c_modele_correction int4,c_id int4,c_libelle varchar,c_pere int4,c_note_max int4)
    loop
	t_ids[i]:=rec.c_id;
	i:=i+1;
    end loop;	
    for rec in 
	select c_modele_correction,c_id,c_libelle,c_pere,c_note_max 
	from contraintes.af_gen_get_elements('contraintes.modele_correction_criteres','critere',NULL,'and modele_correction='||$1,1,t_ids) ID,
	contraintes.af_get_template_sous_criteres_non_ordonnes($1,$2) as (c_modele_correction int4,c_id int4,c_libelle varchar,c_pere int4,c_note_max int4)
	where ID.id=c_id order by ID.ind
    loop
	return next rec;

    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_template_sous_criteres(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8161 (class 0 OID 0)
-- Dependencies: 1315
-- Name: FUNCTION af_get_template_sous_criteres(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_template_sous_criteres(integer, integer) IS 'retourne les sous criteres d''un modele ds l''ordre';


--
-- TOC entry 1316 (class 1255 OID 2596159)
-- Dependencies: 2983 5
-- Name: af_get_template_sous_criteres_non_ordonnes(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_template_sous_criteres_non_ordonnes(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero modele
-- $2 : numero critere
declare
rec record;
begin
    for rec in 
	select distinct mc.modele_correction,c_id,c_libelle,c_pere,mc.note_max from contraintes.af_get_criteres() as (c_id int4,c_libelle varchar,c_pere int4),
	contraintes.modele_correction_criteres mc where 
	mc.modele_correction=$1 and c_id=mc.critere and c_pere=$2
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_template_sous_criteres_non_ordonnes(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8163 (class 0 OID 0)
-- Dependencies: 1316
-- Name: FUNCTION af_get_template_sous_criteres_non_ordonnes(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_template_sous_criteres_non_ordonnes(integer, integer) IS 'retourn les sous critere pour un critere d''un modele de correction';


--
-- TOC entry 1317 (class 1255 OID 2596160)
-- Dependencies: 2983 5
-- Name: af_get_test(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_test(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec * FROM contraintes.af_get_tests() AS (id int4, libelle varchar, dynamique bool, continu bool, media int4, hauteur_media int4, largeur_media int4,date_creation timestamp)
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_test(integer) OWNER TO pgsql;

--
-- TOC entry 1318 (class 1255 OID 2596161)
-- Dependencies: 2983 5
-- Name: af_get_test_last_positionnement(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_test_last_positionnement(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du test
id int4;
BEGIN
	SELECT INTO id * FROM contraintes.af_gen_get_last_element('contraintes.test_positionnements', 'positionnement', ' AND test='||$1);
	RETURN id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_test_last_positionnement(integer) OWNER TO pgsql;

--
-- TOC entry 1319 (class 1255 OID 2596162)
-- Dependencies: 2983 5
-- Name: af_get_test_parcours(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_test_parcours(integer) RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT P_id, P_libelle, P_filiere, P_duree, P_date_creation  FROM contraintes.af_get_parcours() AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool, P_date_creation timestamp),
		contraintes.parcours_etapes E
		WHERE E.parcours=P_id

	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_test_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 1320 (class 1255 OID 2596163)
-- Dependencies: 2983 5
-- Name: af_get_test_positionnements(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_test_positionnements(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT P.test, P.positionnement, P.pere
		FROM contraintes.af_gen_get_elements('contraintes.test_positionnements', 'positionnement', NULL, ' AND test='||$1,1) P_id,
		contraintes.test_positionnements P
		WHERE P_id.id=P.positionnement
		AND P.test=$1
		ORDER BY P_id.ind
		
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_test_positionnements(integer) OWNER TO pgsql;

--
-- TOC entry 1321 (class 1255 OID 2596164)
-- Dependencies: 2983 5
-- Name: af_get_test_positionnements_disponibles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_test_positionnements_disponibles(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM contraintes.af_get_positionnements() AS (id int4, libelle varchar, type_question int4, chrono int4, serie_aleatoire int4, bareme int4, chrono_gen int4)
		WHERE id NOT IN (
			SELECT DISTINCT positionnement 
			FROM contraintes.af_get_test_positionnements($1) AS (test int4, positionnement int4, pere int4)
				)
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_test_positionnements_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 1322 (class 1255 OID 2596165)
-- Dependencies: 2983 5
-- Name: af_get_test_positionnements_infos(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_test_positionnements_infos(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT PO.id, PO.libelle, PO.type_question, PO.chrono, PO.serie_aleatoire, PO.question_reponse, $1
		FROM contraintes.af_gen_get_elements('contraintes.test_positionnements', 'positionnement', NULL, ' AND test='||$1,1) P_id,
		contraintes.test_positionnements P, contraintes.positionnement PO
		WHERE P_id.id=P.positionnement
		AND P.test=$1
		AND P_id.id=PO.id
		ORDER BY P_id.ind
		
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_test_positionnements_infos(integer) OWNER TO pgsql;

--
-- TOC entry 1323 (class 1255 OID 2596166)
-- Dependencies: 2983 5
-- Name: af_get_test_somme_chronos(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_test_somme_chronos(integer) RETURNS integer
    AS $_$DECLARE
--$1 serie
somme int4;
BEGIN
	SELECT INTO somme SUM(chrono)
	FROM contraintes.af_get_test_positionnements_infos($1) AS  ( id int4, libelle varchar, type  int4, chrono  int4, serie_aleatoire int4, question_reponse int4, test int4 );

	RETURN somme;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_test_somme_chronos(integer) OWNER TO pgsql;

--
-- TOC entry 1324 (class 1255 OID 2596167)
-- Dependencies: 2983 5
-- Name: af_get_tests(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_tests() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT E_id , E_libelle,  T.dynamique, T.continu,  M.media, M.hauteur , M.largeur,date_creation  
		FROM (
			( contraintes.af_get_etapes() AS (E_id int4, E_libelle varchar, E_type int4,date_creation timestamp) INNER JOIN  contraintes.test T  ON  E_id=T.id )
			LEFT OUTER JOIN contraintes.media_test M ON T.id=M.test
		     )
		ORDER BY E_libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_tests() OWNER TO pgsql;

--
-- TOC entry 1325 (class 1255 OID 2596168)
-- Dependencies: 2983 5
-- Name: af_get_theme(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_theme(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;

BEGIN
	--pour la conversion du int4 en varchar, on utilise un masque de 9999999999 car les valeurs d'un int4
	--vont de -2147483648 Ã  +2147483647, il faut ensuite supprimer les blancs du dÃ©but de la chaine du aux '9' inutiles par rapport aux
	--nombres de chiffres rÃ©els du nombre 
	SELECT INTO rec id, libelle,  trim(leading ' ' from (CAST(to_char(id, '9999999999') AS varchar))),individu FROM contraintes.theme WHERE id=$1;
	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme(integer) OWNER TO postgres;

--
-- TOC entry 8173 (class 0 OID 0)
-- Dependencies: 1325
-- Name: FUNCTION af_get_theme(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_theme(integer) IS 'Obtenir le theme dont l''identifiant est passÃ© en paramettre';


--
-- TOC entry 1326 (class 1255 OID 2596169)
-- Dependencies: 2983 5
-- Name: af_get_theme(character varying); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_theme(character varying) RETURNS record
    AS $_$DECLARE
rec RECORD;

BEGIN
	--pour la conversion du int4 en varchar, on utilise un masque de 9999999999 car les valeurs d'un int4
	--vont de -2147483648 Ã  +2147483647, il faut ensuite supprimer les blancs du dÃ©but de la chaine du aux '9' inutiles par rapport aux
	--nombres de chiffres rÃ©els du nombre 
	SELECT INTO rec id, libelle,  trim(leading ' ' from (CAST(to_char(id, '9999999999') AS varchar))) FROM contraintes.theme WHERE libelle LIKE $1;
	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme(character varying) OWNER TO postgres;

--
-- TOC entry 8175 (class 0 OID 0)
-- Dependencies: 1326
-- Name: FUNCTION af_get_theme(character varying); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_theme(character varying) IS 'Obtenir le theme dont le libéllé est passé en paramettre';


--
-- TOC entry 1327 (class 1255 OID 2596170)
-- Dependencies: 2983 5
-- Name: af_get_theme_capacites(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_capacites(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select c.id,c.libelle from contraintes.capacite c,
	contraintes.af_get_categorie_elements_theme(10,$1) tc 
	where c.id=tc
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_capacites(integer) OWNER TO pgsql;

--
-- TOC entry 8177 (class 0 OID 0)
-- Dependencies: 1327
-- Name: FUNCTION af_get_theme_capacites(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_capacites(integer) IS 'retourne les capacite pour un theme';


--
-- TOC entry 1328 (class 1255 OID 2596171)
-- Dependencies: 2983 5
-- Name: af_get_theme_capacites_titres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_capacites_titres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select c.id,c.libelle from contraintes.capacite_titre c,
	contraintes.af_get_categorie_elements_theme(11,$1) tc 
	where c.id=tc
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_capacites_titres(integer) OWNER TO pgsql;

--
-- TOC entry 8179 (class 0 OID 0)
-- Dependencies: 1328
-- Name: FUNCTION af_get_theme_capacites_titres(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_capacites_titres(integer) IS 'retourne les titres de capacite pour un theme';


--
-- TOC entry 1329 (class 1255 OID 2596172)
-- Dependencies: 2983 5
-- Name: af_get_theme_categories(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_theme_categories(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT C_id, C_libelle, C_table_cible, C_gestionnaire_contenu, C_code FROM contraintes.af_get_categories() AS (C_id int4, C_libelle varchar, C_table_cible varchar, C_gestionnaire_contenu bool, C_code varchar), contraintes.theme_categories TC
		WHERE TC.theme=$1
		AND TC.categorie=C_id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_categories(integer) OWNER TO postgres;

--
-- TOC entry 8181 (class 0 OID 0)
-- Dependencies: 1329
-- Name: FUNCTION af_get_theme_categories(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_theme_categories(integer) IS 'Obtenir les categories qui ont des éléments dans un theme.';


--
-- TOC entry 1330 (class 1255 OID 2596173)
-- Dependencies: 2983 5
-- Name: af_get_theme_criteres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select C_id,C_libelle,C_pere from contraintes.af_get_criteres()  as (C_id int4,C_libelle varchar,C_pere int4),
	contraintes.af_get_categorie_elements_theme(12,$1) ET 
	where C_id=ET and C_pere is null
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 8183 (class 0 OID 0)
-- Dependencies: 1330
-- Name: FUNCTION af_get_theme_criteres(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_criteres(integer) IS 'retourne les criteres de correction pour un theme';


--
-- TOC entry 1331 (class 1255 OID 2596174)
-- Dependencies: 2983 5
-- Name: af_get_theme_elements(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_elements(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT A_id,A_categorie FROM contraintes.af_get_theme_elements_all($1) AS (A_id int4, A_categorie int4, theme int4)	,
		contraintes.fichier_type T
		WHERE A_categorie NOT IN (SELECT categorie FROM contraintes.fichier_type WHERE categorie IS NOT NULL)
		UNION
		SELECT A_id,A_categorie FROM contraintes.af_get_theme_elements_all($1) AS (A_id int4, A_categorie int4, theme int4)	,
		contraintes.fichier_type T, contraintes.fichier F
		WHERE T.id=F.type
		AND F.connecte=TRUE
		AND A_categorie=T.categorie
		AND A_id=F.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
	
END				$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_elements(integer) OWNER TO pgsql;

--
-- TOC entry 8185 (class 0 OID 0)
-- Dependencies: 1331
-- Name: FUNCTION af_get_theme_elements(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_elements(integer) IS 'Obtenir les éléments (et leur categorie) d''un theme.';


--
-- TOC entry 1332 (class 1255 OID 2596175)
-- Dependencies: 2983 5
-- Name: af_get_theme_elements_all(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_elements_all(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;

BEGIN

	FOR rec IN
		SELECT id, categorie, theme FROM contraintes.theme_categories 
		WHERE theme=$1 ORDER BY categorie
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_elements_all(integer) OWNER TO pgsql;

--
-- TOC entry 8187 (class 0 OID 0)
-- Dependencies: 1332
-- Name: FUNCTION af_get_theme_elements_all(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_elements_all(integer) IS 'FONCTION PRIVEE:
Retourne tous les Ã©lÃ©ments d''un theme, y compris les fichiers non connectÃ©s';


--
-- TOC entry 1333 (class 1255 OID 2596176)
-- Dependencies: 2983 5
-- Name: af_get_theme_etapes_forum(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_etapes_forum(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in
	select ef.id,e.libelle,f.id,f.libelle,f.description,f.moderation,f.moderateur_pwd,f.fils,f.messages,f.upload,f.theme,fe.environnement,date_creation 
	from contraintes.etape e ,
	contraintes.af_get_categorie_elements_theme(61,$1) tc,
	contraintes.etape_forum ef  left outer join contraintes.forum f on (f.id=ef.forum)
	left outer join contraintes.forum_environnements fe ON (fe.forum=f.id) 
	where e.id=ef.id
	and ef.id=tc
	
	
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_etapes_forum(integer) OWNER TO pgsql;

--
-- TOC entry 8189 (class 0 OID 0)
-- Dependencies: 1333
-- Name: FUNCTION af_get_theme_etapes_forum(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_etapes_forum(integer) IS 'retourne les etapes forum d''un theme';


--
-- TOC entry 1334 (class 1255 OID 2596177)
-- Dependencies: 2983 5
-- Name: af_get_theme_etapes_ressource(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_etapes_ressource(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in 
	SELECT er.id,e.libelle,er.espace,er.section,fm.id,er.fichier,fm.mots_cles 
	FROM contraintes.etape e,
	contraintes.af_get_categorie_elements_theme(39,$1) tc,
	contraintes.etape_ressource er LEFT OUTER JOIN
	(contraintes.fichier_ressource fr LEFT OUTER JOIN
	contraintes.fichier_metadata fm ON (fr.id=fm.id)) ON (er.fichier=fr.id)
	WHERE er.id=e.id
	AND tc=e.id 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_etapes_ressource(integer) OWNER TO pgsql;

--
-- TOC entry 8191 (class 0 OID 0)
-- Dependencies: 1334
-- Name: FUNCTION af_get_theme_etapes_ressource(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_etapes_ressource(integer) IS 'retourne les etapes ressource d''un theme';


--
-- TOC entry 1335 (class 1255 OID 2596178)
-- Dependencies: 2983 5
-- Name: af_get_theme_evaluations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_evaluations(integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
    for rec in
	select distinct e.id,e.type from contraintes.evaluation e,
	contraintes.categorie_evaluation ce--,
	--contraintes.serie_evaluations se
	where 
	--e.id=se.evaluation 
	--and 
	e.id=ce.id 
	and ce.theme=$1
    loop
    return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_evaluations(integer) OWNER TO pgsql;

--
-- TOC entry 8193 (class 0 OID 0)
-- Dependencies: 1335
-- Name: FUNCTION af_get_theme_evaluations(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_evaluations(integer) IS 'retourne les évaluations pour un theme';


--
-- TOC entry 1336 (class 1255 OID 2596179)
-- Dependencies: 2983 5
-- Name: af_get_theme_exostlc_titre(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_exostlc_titre(integer, character varying) RETURNS SETOF record
    AS $_$-- $1 : numero theme
-- $2 : asc ou desc
declare
rec record;
req varchar;
begin
    req:='select  GE_id ,GE_libelle ,lower(GE_libelle) as minus,E.type , GE_date_creation from contraintes.af_get_etapes() as (GE_id int4,GE_libelle varchar,GE_type int4, GE_date_creation timestamp) ,
    contraintes.categorie_exotlc CE,contraintes.exotlc E where GE_id=CE.id and GE_id=E.id and CE.theme='||$1||' order by minus ' || $2;
    for rec in
	execute req
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_exostlc_titre(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8195 (class 0 OID 0)
-- Dependencies: 1336
-- Name: FUNCTION af_get_theme_exostlc_titre(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_exostlc_titre(integer, character varying) IS 'retourne les exos tlc (classés par titre)pour un theme';


--
-- TOC entry 1337 (class 1255 OID 2596180)
-- Dependencies: 2983 5
-- Name: af_get_theme_exostlc_type(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_exostlc_type(integer, character varying) RETURNS SETOF record
    AS $_$-- $1 : numero theme
-- $2 : asc ou desc
declare
rec record;
req varchar;
begin
    req:='select  GE_id ,GE_libelle,lower(GE_libelle) ,E.type, GE_date_creation from contraintes.af_get_etapes() as (GE_id int4,GE_libelle varchar,GE_type int4, GE_date_creation timestamp) ,
    contraintes.categorie_exotlc CE,contraintes.exotlc E where GE_id=CE.id and GE_id=E.id and CE.theme='||$1||' order by E.type ' || $2;
    for rec in
	execute req
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_exostlc_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8197 (class 0 OID 0)
-- Dependencies: 1337
-- Name: FUNCTION af_get_theme_exostlc_type(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_exostlc_type(integer, character varying) IS 'retourne les exos tlc (classés par type) pour un theme';


--
-- TOC entry 1877 (class 1255 OID 2596181)
-- Dependencies: 2983 5
-- Name: af_get_theme_fichiers_blocs_scenarios(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_theme_fichiers_blocs_scenarios(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT F_id, F_libelle, F_type , F_connecte, BS.date_modification,58,$1
		FROM contraintes.af_get_fichiers() AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool),
		contraintes.fichier_bloc_scenario BS,
		contraintes.af_get_categorie_elements_theme(58,$1) C_id
		WHERE BS.id=F_id
		AND C_id=F_id
		
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_fichiers_blocs_scenarios(integer) OWNER TO postgres;

--
-- TOC entry 1338 (class 1255 OID 2596182)
-- Dependencies: 2983 5
-- Name: af_get_theme_fichiers_scenarios_dynamiques(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_fichiers_scenarios_dynamiques(integer, character varying) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
--$1 theme
--$2 message
req varchar;
msg alias for $2;
BEGIN

	req:='SELECT F_id, F_libelle, F_type , F_connecte, SD.style, SD.date_modification
	FROM contraintes.af_get_fichiers() AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool),
	contraintes.fichier_scenario_dynamique SD,
	contraintes.af_get_categorie_elements_theme(59,'||$1||') AS elt
	WHERE SD.id=F_id
	AND F_id=elt';
	if $2 is not null then
		req:=req || ' and F_libelle like '''||msg||''''; 
	end if;
	FOR rec IN
		execute req
	LOOP
		
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_fichiers_scenarios_dynamiques(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1339 (class 1255 OID 2596183)
-- Dependencies: 2983 5
-- Name: af_get_theme_fichiers_slides_scenarios(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_theme_fichiers_slides_scenarios(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT F_id, F_libelle, F_type , F_connecte, BS.date_modification,62,$1
		FROM contraintes.af_get_fichiers() AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool),
		contraintes.fichier_slide_scenario BS,
		contraintes.af_get_categorie_elements_theme(62,$1) C_id
		WHERE BS.id=F_id
		AND C_id=F_id
		
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_fichiers_slides_scenarios(integer) OWNER TO postgres;

--
-- TOC entry 1340 (class 1255 OID 2596184)
-- Dependencies: 2983 5
-- Name: af_get_theme_ftbs(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_ftbs(integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
for rec in
    select DISTINCT f.id,f.text,f.voir_mots,f.interpretation_html
    from contraintes.ftb f,contraintes.af_get_categorie_elements_theme($2,$1) e_id
    where f.id=e_id
loop
    return next rec;
end loop;
return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_ftbs(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8202 (class 0 OID 0)
-- Dependencies: 1340
-- Name: FUNCTION af_get_theme_ftbs(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_ftbs(integer, integer) IS 'retourn les exos "remplir les blancs" pour le theme';


--
-- TOC entry 32 (class 1255 OID 2596185)
-- Dependencies: 2983 5
-- Name: af_get_theme_glossaires(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_theme_glossaires(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in
	select g.id,g.libelle from contraintes.glossaire g,
	contraintes.af_get_categorie_elements_theme(67,$1) tc 
	where g.id=tc
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_glossaires(integer) OWNER TO postgres;

--
-- TOC entry 8204 (class 0 OID 0)
-- Dependencies: 32
-- Name: FUNCTION af_get_theme_glossaires(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_theme_glossaires(integer) IS 'retourne les glossaire pour un theme';


--
-- TOC entry 1341 (class 1255 OID 2596186)
-- Dependencies: 2983 5
-- Name: af_get_theme_grilles(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_grilles(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select c.id,c.libelle from contraintes.grille c,
	contraintes.af_get_categorie_elements_theme(15,$1) tc 
	where c.id=tc
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_grilles(integer) OWNER TO pgsql;

--
-- TOC entry 8206 (class 0 OID 0)
-- Dependencies: 1341
-- Name: FUNCTION af_get_theme_grilles(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_grilles(integer) IS 'retourne les grilles presentielles pour un theme';


--
-- TOC entry 1342 (class 1255 OID 2596187)
-- Dependencies: 2983 5
-- Name: af_get_theme_grilles_capacite(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_grilles_capacite(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in
	select distinct g_id,g_libelle from contraintes.af_get_theme_grilles($1) as (g_id int4,g_libelle varchar),
	contraintes.grille_capacites_titres gct,contraintes.capacite_titre_capacites ctc 
	where g_id=gct.grille and gct.capacite_titre=ctc.capacite_titre
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_grilles_capacite(integer) OWNER TO pgsql;

--
-- TOC entry 8208 (class 0 OID 0)
-- Dependencies: 1342
-- Name: FUNCTION af_get_theme_grilles_capacite(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_grilles_capacite(integer) IS 'retourne les grilles (avec capacite) pour le theme';


--
-- TOC entry 1343 (class 1255 OID 2596188)
-- Dependencies: 2983 5
-- Name: af_get_theme_modeles_correction(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_modeles_correction(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select mc.id,mc.libelle from contraintes.modele_correction mc,
	contraintes.af_get_categorie_elements_theme(16,$1) tc 
	where mc.id=tc
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_modeles_correction(integer) OWNER TO pgsql;

--
-- TOC entry 8210 (class 0 OID 0)
-- Dependencies: 1343
-- Name: FUNCTION af_get_theme_modeles_correction(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_modeles_correction(integer) IS 'retorne les modeles de correction pour un theme';


--
-- TOC entry 1344 (class 1255 OID 2596189)
-- Dependencies: 2983 5
-- Name: af_get_theme_positionnements(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_positionnements(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT P.id, P.libelle, P.type_question, P.chrono, P.serie_aleatoire, P.question_reponse, C_theme 
		FROM contraintes.positionnement P,
		contraintes.af_get_categorie_elements(22) AS (C_id int4, C_theme int4, C_categorie int4)
		WHERE P.id=C_id
		AND C_theme=$1
		ORDER BY P.libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_positionnements(integer) OWNER TO pgsql;

--
-- TOC entry 1345 (class 1255 OID 2596190)
-- Dependencies: 2983 5
-- Name: af_get_theme_qsrcs(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_qsrcs(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 le theme
--$2 la categorie
--$3 le type de question_reponse
rec RECORD;
BEGIN
	FOR rec IN
	
		SELECT  E.id , E.libelle, E.type, QS.question, QS.id 
		FROM contraintes.evaluation E,
		contraintes.af_get_categorie_elements_theme($2, $1) T_ID,
		contraintes.qsrc QS
		WHERE E.type=$3
		AND E.id=T_ID
		AND QS.id=T_ID

	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_qsrcs(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8213 (class 0 OID 0)
-- Dependencies: 1345
-- Name: FUNCTION af_get_theme_qsrcs(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_qsrcs(integer, integer, integer) IS 'Obtenir les qsrc d''un theme.';


--
-- TOC entry 1346 (class 1255 OID 2596191)
-- Dependencies: 2983 5
-- Name: af_get_theme_question_reponse_elements(integer, integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_question_reponse_elements(integer, integer, integer, boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 le theme
--$2 la categorie
--$3 le type de question_reponse_element
--$4 reponse ou pas
rec RECORD;

BEGIN

	FOR rec IN
	
		SELECT E.id, E.libelle , E.interpretation_html , E.type, E.reponse FROM contraintes.question_reponse_element E,
		contraintes.af_get_categorie_elements_theme($2, $1) C_id
		WHERE E.id=C_id
		AND E.reponse=$4
		AND E.type=$3
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_question_reponse_elements(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 8215 (class 0 OID 0)
-- Dependencies: 1346
-- Name: FUNCTION af_get_theme_question_reponse_elements(integer, integer, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_question_reponse_elements(integer, integer, integer, boolean) IS 'Obtenir les question_reponse_elements d''un theme.';


--
-- TOC entry 1878 (class 1255 OID 2596192)
-- Dependencies: 2983 5
-- Name: af_get_theme_question_reponse_reponses(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_theme_question_reponse_reponses(integer, integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
null_value int4:=NULL;
begin
	for rec in
		--les elements qui ne sont pas associés
		(select distinct R_id,R_libelle, null_value,  R_inter, R_type from 
		--les reponses
		contraintes.af_get_reponses() as (R_id int4,R_libelle varchar,R_inter bool,R_type int4),
		--les elements rangÃ©s dans un theme
		contraintes.af_get_categorie_elements_theme($2,$1) C_id
		--les associations question reponse
		--,contraintes.question_reponse_elements E
		--where E.question_reponse=C_id 
		--and E.question=R_id
		WHERE C_id=R_id
		AND R_type=$3
		AND C_id NOT IN 
			(select distinct E.reponse from 
			--les associations question reponse
			contraintes.question_reponse_elements E)	
		)

		UNION

		--les elements associés
		(select distinct R_id,R_libelle, E.question_reponse , R_inter, R_type from 
		--les reponses
		contraintes.af_get_reponses() as (R_id int4,R_libelle varchar,R_inter bool,R_type int4),
		--les elements rangÃ©s dans un theme
		contraintes.af_get_categorie_elements_theme($2,$1) C_id
		--les associations question reponse
		,contraintes.question_reponse_elements E
		where E.reponse=C_id
		AND R_type=$3
		and E.reponse=R_id)
		

	loop
		return next rec;
	end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_question_reponse_reponses(integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 8217 (class 0 OID 0)
-- Dependencies: 1878
-- Name: FUNCTION af_get_theme_question_reponse_reponses(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_theme_question_reponse_reponses(integer, integer, integer) IS 'Obtenir les questions de qcm pour un theme (auteur : said modifié par rémi)';


--
-- TOC entry 1347 (class 1255 OID 2596193)
-- Dependencies: 2983 5
-- Name: af_get_theme_question_reponses(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_question_reponses(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 le theme
--$2 la categorie
--$3 le type de question_reponse
rec RECORD;
BEGIN
	FOR rec IN
	
		SELECT DISTINCT QR.id , QR.type, QR.radio 
		FROM contraintes.question_reponse QR,
		contraintes.af_get_categorie_elements_theme($2, $1) T_ID
		WHERE QR.type=$3
		AND QR.id=T_ID

	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_question_reponses(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8219 (class 0 OID 0)
-- Dependencies: 1347
-- Name: FUNCTION af_get_theme_question_reponses(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_question_reponses(integer, integer, integer) IS 'Obtenir les question_reponses d''un theme.';


--
-- TOC entry 1348 (class 1255 OID 2596194)
-- Dependencies: 2983 5
-- Name: af_get_theme_ressources(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_ressources(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in 
	/* non! pas d'étape ici!
	select r.id,e.libelle,fichier,mots_cles from contraintes.ressource r,
	contraintes.etape_ressource er,
	contraintes.af_get_categorie_elements_theme(39,$1) tc, 
	contraintes.etape e
	where er.id=tc and er.ressource=r.id and e.id=er.id
	*/
	SELECT f.id,f.libelle,f.id,fm.mots_cles 
	FROM
	contraintes.af_get_categorie_elements_theme(43,$1) fichier_ressource_id,
	contraintes.fichier_ressource fr,
	contraintes.fichier f LEFT OUTER JOIN 
	contraintes.fichier_metadata fm ON (f.id=fm.id)
	WHERE fichier_ressource_id=fr.id
	AND fr.id=f.id
	AND f.connecte IS TRUE

    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_ressources(integer) OWNER TO pgsql;

--
-- TOC entry 8221 (class 0 OID 0)
-- Dependencies: 1348
-- Name: FUNCTION af_get_theme_ressources(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_ressources(integer) IS 'retourne les ressources d''un theme';


--
-- TOC entry 1349 (class 1255 OID 2596195)
-- Dependencies: 2983 5
-- Name: af_get_theme_scenarios_dynamiques_colonnes_libelles(integer, character varying, integer, character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_scenarios_dynamiques_colonnes_libelles(integer, character varying, integer, character varying, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
-- $1 : theme
--$2 message
-- $3 : numero du champ pour l'order by
-- $4 : classement (asc ou desc)
-- $5 : limit
-- $6 : offset
rec record;
req varchar;
func varchar;
msg varchar;
begin
	IF $2 IS NULL THEN
		func:='contraintes.af_get_theme_fichiers_scenarios_dynamiques('||$1||',NULL) ';
	ELSE
		func:='contraintes.af_get_theme_fichiers_scenarios_dynamiques('||$1||','''||$2||''') ';
	END IF;

	req:='SELECT id, libelle,date_creation
	FROM '||func||'
	AS (id int4, libelle varchar, type int4, connecte bool, style integer,date_creation date)
	ORDER BY '||( CAST($3 AS integer)+1)||' '||$4
	||' LIMIT '||$5
	||' OFFSET '|| $6||';';

	RAISE NOTICE 'req=%',req;
    FOR rec IN
	EXECUTE req
    LOOP
	RETURN NEXT rec;
    END LOOP;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_scenarios_dynamiques_colonnes_libelles(integer, character varying, integer, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1350 (class 1255 OID 2596196)
-- Dependencies: 2983 5
-- Name: af_get_theme_series(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_series(integer) RETURNS SETOF record
    AS $_$declare
rec record;
type_serie contraintes.type_element;
begin
    for rec in
	select S.id,E.libelle, CAST(NULL AS int4) as type_evaluations, CAST(NULL AS varchar) as libelle_type_evaluations  from 
	contraintes.serie S  LEFT OUTER JOIN contraintes.serie_aleatoire SA ON (S.id=SA.id) and type!=1 LEFT OUTER JOIN  contraintes.categorie_serie CS ON (CS.theme=$1 AND S.id=CS.id)
	LEFT OUTER JOIN contraintes.etape E ON (E.id=CS.id)
	WHERE SA.id IS NULL
	AND CS.id IS NOT NULL
	ORDER BY e.libelle
    loop
	SELECT INTO type_serie * FROM contraintes.af_get_serie_simple_type(rec.id);
	rec.type_evaluations:=type_serie.id;
	rec.libelle_type_evaluations:=type_serie.libelle;
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_series(integer) OWNER TO pgsql;

--
-- TOC entry 8224 (class 0 OID 0)
-- Dependencies: 1350
-- Name: FUNCTION af_get_theme_series(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_series(integer) IS 'retourne les serie associées à un theme';


--
-- TOC entry 1351 (class 1255 OID 2596197)
-- Dependencies: 2983 5
-- Name: af_get_theme_series_aleatoire_melangees(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_series_aleatoire_melangees(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in
	select id ,libelle , type , libelle_type,formation,parcours  from 
	contraintes.af_get_theme_series($1) as (id int4,libelle varchar, type int4, libelle_type varchar),
	contraintes.serie_aleatoire_melangee 
	where id=serie
    loop
	return next rec;
   end loop; 
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_series_aleatoire_melangees(integer) OWNER TO pgsql;

--
-- TOC entry 8226 (class 0 OID 0)
-- Dependencies: 1351
-- Name: FUNCTION af_get_theme_series_aleatoire_melangees(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_series_aleatoire_melangees(integer) IS 'retourne les series existantes configurees en mode aleatoire pour un theme donne';


--
-- TOC entry 1879 (class 1255 OID 2596198)
-- Dependencies: 2983 5
-- Name: af_get_theme_series_aleatoires(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_series_aleatoires(integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
sous_type contraintes.type_element;
begin
    for rec in
	select e.id,e.libelle, CAST(e.type AS varchar), T.libelle AS libelle_type_original from 
	contraintes.etape e,
	contraintes.categorie_serie cs,
	contraintes.liste l,
	contraintes.serie_aleatoire sa,
	contraintes.etape_type T
	where 
	e.id=cs.id and 
	cs.categorie=19 and
	cs.theme=$1 and
	l.type=1 and l.id=e.id
	and e.id=sa.id and
	sa.type=$2
	AND e.type=T.id
    loop
	SELECT INTO sous_type * FROM contraintes.af_get_etape_type_sous_type(rec.id, CAST(rec.type AS int4), rec.libelle_type_original);
	rec.type:=sous_type.id;
	rec.libelle_type_original:=sous_type.libelle;
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_series_aleatoires(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8228 (class 0 OID 0)
-- Dependencies: 1879
-- Name: FUNCTION af_get_theme_series_aleatoires(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_series_aleatoires(integer, integer) IS 'retourne les series aleatoires pour un type et un theme';


--
-- TOC entry 1352 (class 1255 OID 2596199)
-- Dependencies: 2983 5
-- Name: af_get_theme_series_non_vide(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_series_non_vide(integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
    for rec in 
	select distinct gt_id,gt_libelle,gt_type_evaluations ,gt_libelle_type_evaluations  from contraintes.af_get_theme_series($1) as (gt_id int4,gt_libelle varchar, gt_type_evaluations int4, gt_libelle_type_evaluations varchar),
	contraintes.serie_evaluations e 
	where gt_id=e.serie
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_series_non_vide(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8230 (class 0 OID 0)
-- Dependencies: 1352
-- Name: FUNCTION af_get_theme_series_non_vide(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_series_non_vide(integer, integer) IS 'retourne les series (avec evaluations) pour un theme';


--
-- TOC entry 1353 (class 1255 OID 2596200)
-- Dependencies: 2983 5
-- Name: af_get_theme_sous_criteres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_theme_sous_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select C_id,C_libelle,C_pere from contraintes.af_get_criteres()  as (C_id int4,C_libelle varchar,C_pere int4),
	contraintes.af_get_categorie_elements_theme(12,$1) ET 
	where C_id=ET and C_pere is not null
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_theme_sous_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 8232 (class 0 OID 0)
-- Dependencies: 1353
-- Name: FUNCTION af_get_theme_sous_criteres(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_theme_sous_criteres(integer) IS 'retourne les sous criteres pour un theme';


--
-- TOC entry 1354 (class 1255 OID 2596201)
-- Dependencies: 2983 5
-- Name: af_get_themes(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_get_themes(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
    if contraintes.fw_is_root($1) then
	FOR rec IN
	--pour la conversion du int4 en varchar, on utilise un masque de 9999999999 car les valeurs d'un int4
	--vont de -2147483648 Ã  +2147483647, il faut ensuite supprimer les blancs du dÃ©but de la chaine du aux '9' inutiles par rapport aux
	--nombres de chiffres rÃ©els du nombre 

		SELECT id, libelle, trim(leading ' ' from (CAST(to_char(id, '9999999999') AS varchar))),individu FROM contraintes.theme ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;
    else
	FOR rec IN
	--pour la conversion du int4 en varchar, on utilise un masque de 9999999999 car les valeurs d'un int4
	--vont de -2147483648 Ã  +2147483647, il faut ensuite supprimer les blancs du dÃ©but de la chaine du aux '9' inutiles par rapport aux
	--nombres de chiffres rÃ©els du nombre 

		SELECT id, libelle, trim(leading ' ' from (CAST(to_char(id, '9999999999') AS varchar))),individu 
		FROM contraintes.theme where (individu=$1 OR individu IS NULL) ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;
    end if;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_themes(integer) OWNER TO postgres;

--
-- TOC entry 8234 (class 0 OID 0)
-- Dependencies: 1354
-- Name: FUNCTION af_get_themes(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_get_themes(integer) IS 'Obtenir tous les themes de la plate-forme';


--
-- TOC entry 1355 (class 1255 OID 2596202)
-- Dependencies: 2983 5
-- Name: af_get_themes_ressource(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_themes_ressource() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in

    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_themes_ressource() OWNER TO pgsql;

--
-- TOC entry 8236 (class 0 OID 0)
-- Dependencies: 1355
-- Name: FUNCTION af_get_themes_ressource(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_themes_ressource() IS 'retourne les themes des ressources';


--
-- TOC entry 1356 (class 1255 OID 2596203)
-- Dependencies: 2983 5
-- Name: af_get_themes_ressource_fichier_texte(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_get_themes_ressource_fichier_texte(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;
begin
    for rec in
	select * from contraintes.af_get_categorie_themes(7,$1) as (id int4,libelle varchar)
	union
	select * from contraintes.af_get_categorie_themes(26,$1) as (id int4,libelle varchar)
	union
	select * from contraintes.af_get_categorie_themes(1,$1) as (id int4,libelle varchar)
	union
	select * from contraintes.af_get_categorie_themes(59,$1) as (id integer,libelle varchar)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_get_themes_ressource_fichier_texte(integer) OWNER TO pgsql;

--
-- TOC entry 8238 (class 0 OID 0)
-- Dependencies: 1356
-- Name: FUNCTION af_get_themes_ressource_fichier_texte(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_get_themes_ressource_fichier_texte(integer) IS 'retourne les themes des fichiers ressource (fichier et texte et scenario et scenario dynamique) pour un individu';


--
-- TOC entry 1357 (class 1255 OID 2596204)
-- Dependencies: 2983 5
-- Name: af_is_capacite_titre_capacite_supprimable(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_capacite_titre_capacite_supprimable(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
-- $2 : numero capacite
begin
    perform * from contraintes.grille_resultats where capacite_titre=$1 and capacite=$2;
    return not found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_capacite_titre_capacite_supprimable(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8240 (class 0 OID 0)
-- Dependencies: 1357
-- Name: FUNCTION af_is_capacite_titre_capacite_supprimable(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_capacite_titre_capacite_supprimable(integer, integer) IS 'retourne vrai si le couple capacite_titre / capacite peut etre supprimer';


--
-- TOC entry 1880 (class 1255 OID 2962811)
-- Dependencies: 2983 5
-- Name: af_is_fichier_scenario_dynamique_supprimable(integer); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION af_is_fichier_scenario_dynamique_supprimable(integer) RETURNS boolean
    AS $_$DECLARE
scenario integer;
used1 boolean:=FALSE;
used2 boolean:=FALSE;
BEGIN
	SELECT INTO scenario * FROM contraintes.af_get_scenario_dynamique_fichier($1);

	IF scenario IS NOT NULL THEN
		SELECT INTO used1 *  FROM contraintes.af_fk_finder('etape', 'id', scenario);
		RAISE NOTICE '-----scenario utilise---%--', used1;
	END IF;
		

	SELECT INTO used2 *  FROM contraintes.af_fk_finder('fichier_ressource', 'id', $1);
	RAISE NOTICE '----- fichier scenario utilise----%--', used2;
	RETURN NOT (used1 OR used2);
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_fichier_scenario_dynamique_supprimable(integer) OWNER TO www;

--
-- TOC entry 1358 (class 1255 OID 2596205)
-- Dependencies: 2983 5
-- Name: af_is_fichier_scenario_dynamique_used(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_fichier_scenario_dynamique_used(integer) RETURNS boolean
    AS $_$DECLARE
--$1 scenario bloc
rec RECORD;
search_string varchar;
BEGIN

	--recherche la chaine \"id_fichier\"
	search_string:='.*\\"'||$1||'\\".*';
	FOR rec IN
		SELECT bloc_vars_values FROM contraintes.fichier_scenario_dynamique_blocs
	LOOP	
		--FOR i IN array_lower(rec.bloc_vars_values,1)..array_upper(rec.bloc_vars_values,1)
		--LOOP
			
			--RAISE NOTICE 'cherche % dans %',search_string,rec.bloc_vars_values[i];
			IF(rec.bloc_vars_values ~* search_string) THEN
				--RAISE NOTICE 'trouve';
				RETURN TRUE;
			END IF;
		--END LOOP;
	END LOOP;
	RETURN FALSE;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_fichier_scenario_dynamique_used(integer) OWNER TO pgsql;

--
-- TOC entry 1359 (class 1255 OID 2596206)
-- Dependencies: 2983 5
-- Name: af_is_filiere_libelle_ok(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_filiere_libelle_ok(integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 filiere 
--$2 libelle
ok bool;
BEGIN
	IF $2 LIKE '%/%' THEN 
		--RAISE NOTICE 'Caractère ''/'' interdit dans le libellé d''une filière ';
		RETURN FALSE; 
	END IF;
	RAISE NOTICE 'ici';
	IF $1 IS NOT NULL THEN
		PERFORM * FROM contraintes.filiere
		WHERE pere=$1 
		AND libelle LIKE $2;
	ELSE
		PERFORM * FROM contraintes.filiere
		WHERE pere IS NULL
		AND libelle LIKE $2;
	END IF;
	RETURN NOT FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_filiere_libelle_ok(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1360 (class 1255 OID 2596207)
-- Dependencies: 2983 5
-- Name: af_is_formation_evenement_supprimable(integer, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_formation_evenement_supprimable(integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : timestamp
begin
    perform * from contraintes.grille_resultats
    where formation=$1 and date=$2;
    return not found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_formation_evenement_supprimable(integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 8245 (class 0 OID 0)
-- Dependencies: 1360
-- Name: FUNCTION af_is_formation_evenement_supprimable(integer, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_formation_evenement_supprimable(integer, timestamp without time zone) IS 'teste si un evenement de formation est supprimable';


--
-- TOC entry 1361 (class 1255 OID 2596208)
-- Dependencies: 2983 5
-- Name: af_is_formation_evenements_hors_periode(integer, date, date); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_formation_evenements_hors_periode(integer, date, date) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date debut
-- $3 : date fin
begin
    perform * from contraintes.evenement 
    where formation=$1
    and (cast(date as date)<$2 or cast(date as date)>$3);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_formation_evenements_hors_periode(integer, date, date) OWNER TO pgsql;

--
-- TOC entry 8247 (class 0 OID 0)
-- Dependencies: 1361
-- Name: FUNCTION af_is_formation_evenements_hors_periode(integer, date, date); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_formation_evenements_hors_periode(integer, date, date) IS 'retourne vrai si un evenement est hors date de formation';


--
-- TOC entry 1362 (class 1255 OID 2596209)
-- Dependencies: 2983 5
-- Name: af_is_formation_evenements_supprimable(integer, date); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_formation_evenements_supprimable(integer, date) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date
begin
    perform * from contraintes.grille_resultats 
    where formation=$1 and cast(date as date)=$2;
    return not found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_formation_evenements_supprimable(integer, date) OWNER TO pgsql;

--
-- TOC entry 8249 (class 0 OID 0)
-- Dependencies: 1362
-- Name: FUNCTION af_is_formation_evenements_supprimable(integer, date); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_formation_evenements_supprimable(integer, date) IS 'teste si une journée de formation est supprimable';


--
-- TOC entry 1363 (class 1255 OID 2596210)
-- Dependencies: 2983 5
-- Name: af_is_grille_capacite_titre_supprimable(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_grille_capacite_titre_supprimable(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero grille
-- $2 : numero capacite_titre
begin
    perform * from contraintes.grille_resultats where grille=$1 and capacite_titre=$2;
    return not found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_grille_capacite_titre_supprimable(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8251 (class 0 OID 0)
-- Dependencies: 1363
-- Name: FUNCTION af_is_grille_capacite_titre_supprimable(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_grille_capacite_titre_supprimable(integer, integer) IS 'retourne vrai si le couple grille / capacite_titre est supprimable';


--
-- TOC entry 1364 (class 1255 OID 2596211)
-- Dependencies: 2983 5
-- Name: af_is_individu_droit_classe(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_individu_droit_classe(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero individu
-- $2 : numero classe
-- $3 : numero droit
begin
    perform * from contraintes.individu_droits where individu=$1 and classe=$2 and droit=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_individu_droit_classe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8253 (class 0 OID 0)
-- Dependencies: 1364
-- Name: FUNCTION af_is_individu_droit_classe(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_individu_droit_classe(integer, integer, integer) IS 'retourne vrai si un individu possede le droit pour la classe,faux sinon';


--
-- TOC entry 1365 (class 1255 OID 2596212)
-- Dependencies: 2983 5
-- Name: af_is_individu_supprimable(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_individu_supprimable(integer) RETURNS boolean
    AS $_$-- $1 : individu
declare
nb_rec int4;
begin
    -- si admin ou formateur temporaire,alors pas de suppression
    perform * from contraintes.fw_individu where id=$1 and login='temporaire' and password='temporaire';
    if found then
	return false;
    end if;
    perform * from contraintes.fw_individu where id=$1 and login='admin' and password='admin';
    if found then
	return false;
    end if;
    -- si intervenant ou formateur,alors pas de suppression
    perform * from contraintes.evenement where intervenant=$1;
    if found then
	return false;
    end if;
    perform * from contraintes.formation_participants where formateur=$1;
    if found then
	return false;
    end if;
    -- si affilié à une classe,alors pas de suppression
    perform * from contraintes.af_get_individu_classes($1) as (id int4,libelle varchar,pere int4,min int4,max int4);
    GET DIAGNOSTICS nb_rec = ROW_COUNT;
    if nb_rec>0 then
	return false;
    end if;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_individu_supprimable(integer) OWNER TO pgsql;

--
-- TOC entry 8255 (class 0 OID 0)
-- Dependencies: 1365
-- Name: FUNCTION af_is_individu_supprimable(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_individu_supprimable(integer) IS 'retourne vrai si un individu est supprimable';


--
-- TOC entry 1366 (class 1255 OID 2596213)
-- Dependencies: 2983 5
-- Name: af_is_locked_by_constraint(character varying, character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_locked_by_constraint(character varying, character varying, character varying) RETURNS void
    AS $$BEGIN
SELECT

	--NULL::text AS PKTABLE_CAT,
	pknam.nspname AS PKTABLE_SCHEM,
	pkc.relname AS PKTABLE_NAME,
	pka.attname AS PKCOLUMN_NAME,
	--NULL::text AS FKTABLE_CAT,
	fknam.nspname AS FKTABLE_SCHEM,
	fkc.relname AS FKTABLE_NAME,
	fka.attname AS FKCOLUMN_NAME
	--fkcon.conkey[1] AS KEY_SEQ,
	--CASE
	---	WHEN fkcon.confupdtype = 'c' THEN 0
	--	WHEN fkcon.confupdtype = 'r' THEN 1
	--	WHEN fkcon.confupdtype = 'n' THEN 2
	--	WHEN fkcon.confupdtype = 'a' THEN 3
	--	WHEN fkcon.confupdtype = 'd' THEN 4
	--END AS UPDATE_RULE
	--CASE
	--	WHEN fkcon.confdeltype = 'c' THEN 0
	--	WHEN fkcon.confdeltype = 'r' THEN 1
	--	WHEN fkcon.confdeltype = 'n' THEN 2
	--	WHEN fkcon.confdeltype = 'a' THEN 3
	--	WHEN fkcon.confdeltype = 'd' THEN 4
	--END AS DELETE_RULE,
	--fkcon.conname AS FK_NAME,
	--pkcon.conname AS PK_NAME,
	--CASE
	--	WHEN fkcon.condeferrable = 'f' THEN 7
	--	WHEN fkcon.condeferred = 't' THEN 6
	--	WHEN fkcon.condeferred = 'f' THEN 5
	--END AS DEFERRABILITY,
	--CASE
	--	WHEN pkcon.contype = 'p' THEN 'PRIMARY'
	--	WHEN pkcon.contype = 'u' THEN 'UNIQUE'
	--END AS UNIQUE_OR_PRIMARY
	FROM
		pg_constraint AS fkcon
	JOIN
		pg_constraint AS pkcon ON fkcon.confrelid=pkcon.conrelid
			AND fkcon.confkey=pkcon.conkey
	JOIN
		pg_class fkc ON fkc.oid=fkcon.conrelid
	JOIN
		pg_class pkc ON pkc.oid=fkcon.confrelid
	JOIN
		pg_namespace pknam ON pkcon.connamespace=pknam.oid
	JOIN
		pg_namespace fknam ON fkcon.connamespace=fknam.oid
	JOIN
		pg_attribute fka ON fka.attnum=fkcon.conkey[1] AND fka.attrelid=fkc.oid
	JOIN
		pg_attribute pka ON pka.attnum=pkcon.conkey[1] AND pka.attrelid=pkc.oid

	WHERE pkc.relname='fichier';
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_locked_by_constraint(character varying, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 1881 (class 1255 OID 2596214)
-- Dependencies: 2983 5
-- Name: af_is_login_inscription_ok(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_login_inscription_ok(character varying) RETURNS boolean
    AS $_$begin
    perform login from contraintes.inscription where login LIKE $1;
    return NOT found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_login_inscription_ok(character varying) OWNER TO pgsql;

--
-- TOC entry 8258 (class 0 OID 0)
-- Dependencies: 1881
-- Name: FUNCTION af_is_login_inscription_ok(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_login_inscription_ok(character varying) IS 'teste si un login est deja utilise dans la table inscription';


--
-- TOC entry 1367 (class 1255 OID 2596215)
-- Dependencies: 2983 5
-- Name: af_is_login_ok(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_login_ok(character varying) RETURNS boolean
    AS $_$begin
    perform login from contraintes.fw_individu where login LIKE $1;
    return NOT found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_login_ok(character varying) OWNER TO pgsql;

--
-- TOC entry 8260 (class 0 OID 0)
-- Dependencies: 1367
-- Name: FUNCTION af_is_login_ok(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_login_ok(character varying) IS 'teste si un login est deja utilise';


--
-- TOC entry 1882 (class 1255 OID 2596216)
-- Dependencies: 2983 5
-- Name: af_is_parcours_etape_modifiable(integer, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_parcours_etape_modifiable(integer, integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 type de l'étape
--rec_etape RECORD;
tmp bool;
rec record;
rec2 record;
nb integer;
BEGIN
	--selection de l'étape
	--SELECT INTO rec_etape * FROM contraintes.etape WHERE etape=$2;	IF 

	--etape de type test de positionnement dynamique
    /*
	IF $3='4_3' THEN
		SELECT INTO tmp dynamique FROM contraintes.af_get_test($2) AS (id int4, libelle varchar, dynamique bool, continu bool, media int4, hauteur_media int4, largeur_media int4,date_creation timestamp);
	END IF;
	
	IF tmp IS TRUE THEN
		RETURN FALSE; 
	ELSE
		RETURN TRUE;
	END IF;
    */
    -- test si l'étape du parcours est enregistrée
    select into rec * from contraintes.af_get_parcours_etape_resultats($1,$2)
    as (id bigint, formation int4, stagiaire int4, parcours int4,  etape int4, date_debut timestamp, duree interval);
    
    if rec.id is not null then
	return false;
    else
    
    
	-- si etape notée et parcours configuré en orientation alors pas de modif
	nb:=0;
	for rec2 in 
	    select * from contraintes.parcours_etapes
	    where parcours=$1 and etape in 
	    (select id from contraintes.etape where type=10)
	loop
	    nb:=nb+1;
	    raise notice 'nb=%',nb;
	end loop;
	raise notice 'nb=%',nb;
	if nb>0 and ($3 like 4 || '%' or $3 like 5 || '%')then
	    return false;
	else
	    return true;
	
	end if;
    end if;
    
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_parcours_etape_modifiable(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1883 (class 1255 OID 2596217)
-- Dependencies: 2983 5
-- Name: af_is_parcours_oriente(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_parcours_oriente(integer) RETURNS boolean
    AS $_$-- $1 : parcours
declare
rec record;
nb integer;
begin
    nb:=0;
    for rec in 
	select * from contraintes.af_get_parcours_oriente_configuration($1)
	as ( etape int4,  sous_parcours int4, type_evaluation int4, seuil int4)
    loop
	nb:=nb+1;
	raise notice 'nb=%',nb;
    end loop;
    if nb=0 then
	return false;
    else
	return true;
    end if;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_parcours_oriente(integer) OWNER TO pgsql;

--
-- TOC entry 8263 (class 0 OID 0)
-- Dependencies: 1883
-- Name: FUNCTION af_is_parcours_oriente(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_parcours_oriente(integer) IS 'retourne vrai si le parcours est configuré en orientation,faux sinon';


--
-- TOC entry 1884 (class 1255 OID 2596218)
-- Dependencies: 2983 5
-- Name: af_is_resultat_exotlc_critere(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_resultat_exotlc_critere(integer, integer) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : critere
begin
    perform * from contraintes.resultat_exotlc_critere where id=$1 and critere=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_resultat_exotlc_critere(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8265 (class 0 OID 0)
-- Dependencies: 1884
-- Name: FUNCTION af_is_resultat_exotlc_critere(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_resultat_exotlc_critere(integer, integer) IS 'Verifie si un critere existe pour un identifiant de resultat';


--
-- TOC entry 1885 (class 1255 OID 2596219)
-- Dependencies: 2983 5
-- Name: af_is_resultat_exotlc_sous_critere(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_resultat_exotlc_sous_critere(integer, integer) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : sous critere
begin
    perform * from contraintes.resultat_exotlc_sous_critere where id=$1 and sous_critere=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_resultat_exotlc_sous_critere(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8267 (class 0 OID 0)
-- Dependencies: 1885
-- Name: FUNCTION af_is_resultat_exotlc_sous_critere(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_resultat_exotlc_sous_critere(integer, integer) IS 'Verifie si un sous critere existe pour un identifiant de resultat';


--
-- TOC entry 1368 (class 1255 OID 2596220)
-- Dependencies: 2983 5
-- Name: af_is_resultat_formation_parcours_etape(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_resultat_formation_parcours_etape(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : etape
declare


begin
    perform * from contraintes.resultat where formation=$1 and parcours=$2 and etape=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_resultat_formation_parcours_etape(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8269 (class 0 OID 0)
-- Dependencies: 1368
-- Name: FUNCTION af_is_resultat_formation_parcours_etape(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_resultat_formation_parcours_etape(integer, integer, integer) IS 'test si resultat pour une etape,un parcours et une formation';


--
-- TOC entry 1369 (class 1255 OID 2596221)
-- Dependencies: 2983 5
-- Name: af_is_serie_aleatoire(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_serie_aleatoire(integer) RETURNS boolean
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec *
	FROM contraintes.etape E, contraintes.serie S LEFT OUTER JOIN contraintes.serie_aleatoire SA
	ON (S.id=SA.id)
	WHERE E.id= S.id
	AND E.id=$1
	AND SA.id IS NOT NULL;

	RETURN FOUND;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_serie_aleatoire(integer) OWNER TO pgsql;

--
-- TOC entry 8271 (class 0 OID 0)
-- Dependencies: 1369
-- Name: FUNCTION af_is_serie_aleatoire(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_serie_aleatoire(integer) IS 'savoir si une serie est aleatoire.';


--
-- TOC entry 1370 (class 1255 OID 2596222)
-- Dependencies: 2983 5
-- Name: af_is_serie_aleatoire_melangee(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_serie_aleatoire_melangee(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
declare
resultat int4:=0;
begin
    select into resultat count(*) from contraintes.serie_aleatoire_melangee where serie=$1 and formation=$2 and parcours=$3;
    if(resultat>0) then
	return true;
    else
	return false;
    end if;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_serie_aleatoire_melangee(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8273 (class 0 OID 0)
-- Dependencies: 1370
-- Name: FUNCTION af_is_serie_aleatoire_melangee(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_serie_aleatoire_melangee(integer, integer, integer) IS 'retourne vrai si une serie existante est configuree en mode aleatoire';


--
-- TOC entry 1371 (class 1255 OID 2596223)
-- Dependencies: 2983 5
-- Name: af_is_serie_bloquante_configuree(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_is_serie_bloquante_configuree(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
declare
resultat int4:=0;
begin
    select into resultat count(*) from contraintes.serie_bloquante where serie=$1 and formation=$2 and parcours=$3;
    if(resultat>0) then
	return true;
    else
	return false;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_is_serie_bloquante_configuree(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8275 (class 0 OID 0)
-- Dependencies: 1371
-- Name: FUNCTION af_is_serie_bloquante_configuree(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_is_serie_bloquante_configuree(integer, integer, integer) IS 'retourne vrai si une serie est configurée en mode bloquant';


--
-- TOC entry 1372 (class 1255 OID 2596224)
-- Dependencies: 2983 5
-- Name: af_maj_alerte(integer, character varying, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_alerte(integer, character varying, integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero alerte
-- $2 : libelle
-- $3 : nb jours
-- $4 : texte
declare
ams_libelle varchar;
ams_texte varchar;
begin
    SELECT INTO ams_libelle contraintes.fw_get_ams_libelle('alerte','libelle','id='||$1,$2);
    SELECT INTO ams_texte contraintes.fw_get_ams_libelle('alerte','texte','id='||$1,$4);
    update contraintes.alerte set libelle=ams_libelle,jours=$3,texte=ams_texte where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_alerte(integer, character varying, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8277 (class 0 OID 0)
-- Dependencies: 1372
-- Name: FUNCTION af_maj_alerte(integer, character varying, integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_alerte(integer, character varying, integer, character varying) IS 'met à jour une alerte';


--
-- TOC entry 1373 (class 1255 OID 2596225)
-- Dependencies: 2983 5
-- Name: af_maj_bareme(integer, character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_bareme(integer, character varying, integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero bareme
-- $2 : libelle
-- $3 : juste
-- $4 : fausse
-- $5 : pas coché
-- $6 : tout coché
begin
    update contraintes.bareme set libelle=$2,juste=$3,fausse=$4,manquantes=$5,toutes=$6 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_bareme(integer, character varying, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8279 (class 0 OID 0)
-- Dependencies: 1373
-- Name: FUNCTION af_maj_bareme(integer, character varying, integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_bareme(integer, character varying, integer, integer, integer, integer) IS 'modifie un bareme';


--
-- TOC entry 1374 (class 1255 OID 2596226)
-- Dependencies: 2983 5
-- Name: af_maj_capacite(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_capacite(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero capacite
-- $2 : libelle capacite
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('capacite','libelle','id='||$1,$2);

    update contraintes.capacite set libelle =ams where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_capacite(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8281 (class 0 OID 0)
-- Dependencies: 1374
-- Name: FUNCTION af_maj_capacite(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_capacite(integer, character varying) IS 'met à jour une capacite';


--
-- TOC entry 1375 (class 1255 OID 2596227)
-- Dependencies: 2983 5
-- Name: af_maj_capacite_titre(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_capacite_titre(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
-- $2 : libelle capacite_titre
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('capacite_titre','libelle','id='||$1,$2);

    update contraintes.capacite_titre set libelle=ams where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_capacite_titre(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8283 (class 0 OID 0)
-- Dependencies: 1375
-- Name: FUNCTION af_maj_capacite_titre(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_capacite_titre(integer, character varying) IS 'met à jour un titre de capacite';


--
-- TOC entry 1376 (class 1255 OID 2596228)
-- Dependencies: 2983 5
-- Name: af_maj_categorie(integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_maj_categorie(integer, character varying, boolean) RETURNS boolean
    AS $_$--$1 identifiant de la categorie
--$2 libellÃ© de la catÃ©gorie
--$3 aparait dans le gestionnaire de contenus
declare
ams varchar;
BEGIN
	SELECT INTO ams contraintes.fw_get_ams_libelle('categorie','libelle','id='||$1,$2);
	UPDATE contraintes.categorie SET libelle=ams, gestionnaire_contenu=$3 WHERE id=$1;

	RETURN FOUND;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_categorie(integer, character varying, boolean) OWNER TO postgres;

--
-- TOC entry 8285 (class 0 OID 0)
-- Dependencies: 1376
-- Name: FUNCTION af_maj_categorie(integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_maj_categorie(integer, character varying, boolean) IS 'Mise a jour d''une categorie.';


--
-- TOC entry 1377 (class 1255 OID 2596229)
-- Dependencies: 2983 5
-- Name: af_maj_classe(integer, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_classe(integer, character varying, integer) RETURNS boolean
    AS $_$-- $1 numero de la classe
-- $2 nouveau nom de la classe
-- $3 numero du pere
declare

begin
    -- test doublon
    if $3 is null then
	perform * from contraintes.classe where lower(libelle) like lower($2) and pere is null;
    else
	perform * from contraintes.classe where lower(libelle) like lower($2) and pere =$3;
    end if;
    if not found then
	update contraintes.classe set libelle=$2 where id=$1;
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_classe(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 8287 (class 0 OID 0)
-- Dependencies: 1377
-- Name: FUNCTION af_maj_classe(integer, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_classe(integer, character varying, integer) IS 'met à jour le nom d''une classe';


--
-- TOC entry 1378 (class 1255 OID 2596230)
-- Dependencies: 2983 5
-- Name: af_maj_classe_places(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_classe_places(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero de la classe
-- $2 : min
-- $3 : max
begin
    update contraintes.classe set min=$2,max=$3 where id=$1;
    return found;
end;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_classe_places(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8289 (class 0 OID 0)
-- Dependencies: 1378
-- Name: FUNCTION af_maj_classe_places(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_classe_places(integer, integer, integer) IS 'met à jour le nombre de place min et max d''une classe';


--
-- TOC entry 1379 (class 1255 OID 2596231)
-- Dependencies: 2983 5
-- Name: af_maj_commentaire(integer, integer, integer, character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_commentaire(integer, integer, integer, character varying, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero etape
-- $2 : min
-- $3 : max
-- $4 : commentaire
-- $5 : old min
-- $6 : old max
begin
    update contraintes.commentaire_etape 
    set min=$2,max=$3,commentaire=$4 
    where etape=$1 and min=$5 and max=$6;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_commentaire(integer, integer, integer, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8291 (class 0 OID 0)
-- Dependencies: 1379
-- Name: FUNCTION af_maj_commentaire(integer, integer, integer, character varying, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_commentaire(integer, integer, integer, character varying, integer, integer) IS 'mettre à jour un commentaire';


--
-- TOC entry 1380 (class 1255 OID 2596232)
-- Dependencies: 2983 5
-- Name: af_maj_critere(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_critere(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero critere
-- $2 : libelle
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('critere','libelle','id='||$1,$2);

    update contraintes.critere set libelle=ams where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_critere(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8293 (class 0 OID 0)
-- Dependencies: 1380
-- Name: FUNCTION af_maj_critere(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_critere(integer, character varying) IS 'met à jour un critere';


--
-- TOC entry 1381 (class 1255 OID 2596233)
-- Dependencies: 2983 5
-- Name: af_maj_droit(integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_droit(integer, character varying, boolean) RETURNS boolean
    AS $_$-- $1 : numero droit
-- $2 : libelle
-- $3 : defaut
begin
    update contraintes.droit set libelle=$2,defaut=$3 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_droit(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 8295 (class 0 OID 0)
-- Dependencies: 1381
-- Name: FUNCTION af_maj_droit(integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_droit(integer, character varying, boolean) IS 'met à jour un droit';


--
-- TOC entry 1382 (class 1255 OID 2596234)
-- Dependencies: 2983 5
-- Name: af_maj_espace(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_espace(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero espace
-- $2 : libelle
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('espace','libelle','id='||$1,$2);

    update contraintes.espace set libelle=ams 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_espace(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8297 (class 0 OID 0)
-- Dependencies: 1382
-- Name: FUNCTION af_maj_espace(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_espace(integer, character varying) IS 'met à jour un espace';


--
-- TOC entry 1383 (class 1255 OID 2596235)
-- Dependencies: 2983 5
-- Name: af_maj_etape_chat(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_etape_chat(integer, character varying) RETURNS boolean
    AS $_$-- $1 : etape
-- $2 : libelle
declare
ok bool;
begin
    SELECT INTO ok * FROM contraintes.af_maj_etape_libelle($1, $2);
    return ok;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_etape_chat(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8299 (class 0 OID 0)
-- Dependencies: 1383
-- Name: FUNCTION af_maj_etape_chat(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_etape_chat(integer, character varying) IS 'modifie une etape chat';


--
-- TOC entry 1384 (class 1255 OID 2596236)
-- Dependencies: 2983 5
-- Name: af_maj_etape_forum(integer, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_etape_forum(integer, character varying, integer) RETURNS boolean
    AS $_$-- $1 : etape
-- $2 : libelle
-- $3 : forum
declare
ok bool;
begin
    SELECT INTO ok * FROM contraintes.af_maj_etape_libelle($1, $2);
    update contraintes.etape_forum set forum=$3 where id=$1;
    return found OR ok;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_etape_forum(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 8301 (class 0 OID 0)
-- Dependencies: 1384
-- Name: FUNCTION af_maj_etape_forum(integer, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_etape_forum(integer, character varying, integer) IS 'modifier une etape forum';


--
-- TOC entry 1385 (class 1255 OID 2596237)
-- Dependencies: 2983 5
-- Name: af_maj_etape_libelle(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_etape_libelle(integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 etape
--$2 libelle de l'etape
ams varchar;
BEGIN
	SELECT INTO ams contraintes.fw_get_ams_libelle('etape','libelle','id='||$1,$2);
	UPDATE contraintes.etape SET libelle=ams WHERE id=$1;
	--RAISE NOTICE 'met a jour l''Ã©tape % avec %',$1,$2;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_etape_libelle(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8303 (class 0 OID 0)
-- Dependencies: 1385
-- Name: FUNCTION af_maj_etape_libelle(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_etape_libelle(integer, character varying) IS 'Mise a jour du libellé d''une étape.';


--
-- TOC entry 1386 (class 1255 OID 2596238)
-- Dependencies: 2983 5
-- Name: af_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 libelle_type_etape 
--$4 obligatoire
--$5 chrono
--$6 fin de page
ams varchar;
BEGIN
	SELECT INTO ams contraintes.fw_get_ams_libelle('parcours_etapes','libelle_type_etape','parcours='||$1||'and etape='||$2,$3);
	
	
	UPDATE contraintes.parcours_etapes
	SET libelle_type_etape=ams, obligatoire=$4, chrono=$5, fin=$6
	WHERE parcours=$1 AND etape=$2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1387 (class 1255 OID 2596239)
-- Dependencies: 2983 5
-- Name: af_maj_etape_ressource(integer, character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_etape_ressource(integer, character varying, integer, integer, integer) RETURNS boolean
    AS $_$
DECLARE
-- $1 : etape
-- $2 : libelle
-- $3 : ressource
-- $4 : espace
-- $5 : section
ok bool;
--ams varchar;
begin
    --SELECT INTO ams contraintes.fw_get_ams_libelle('critere','libelle','id='||$1,$2);

    SELECT INTO ok * FROM contraintes.af_maj_etape_libelle($1, $2);

    update contraintes.etape_ressource set fichier=$3,espace=$4 , section=$5
    where id=$1;

    return found OR ok;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_etape_ressource(integer, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8306 (class 0 OID 0)
-- Dependencies: 1387
-- Name: FUNCTION af_maj_etape_ressource(integer, character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_etape_ressource(integer, character varying, integer, integer, integer) IS 'modifie une étape ressource';


--
-- TOC entry 1388 (class 1255 OID 2596240)
-- Dependencies: 2983 5
-- Name: af_maj_etapes_libelles(integer[], character varying[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_etapes_libelles(integer[], character varying[]) RETURNS integer
    AS $_$DECLARE
i integer;

BEGIN

	FOR i IN array_lower($1, 1) .. array_upper($1, 1) 
	LOOP
		PERFORM * FROM contraintes.af_maj_etape_libelle($1[i],$2[i]);
	END LOOP; 

	RETURN i;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_etapes_libelles(integer[], character varying[]) OWNER TO pgsql;

--
-- TOC entry 8308 (class 0 OID 0)
-- Dependencies: 1388
-- Name: FUNCTION af_maj_etapes_libelles(integer[], character varying[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_etapes_libelles(integer[], character varying[]) IS 'Mise a jour des libelles d''un ensemble d''étapes.';


--
-- TOC entry 1389 (class 1255 OID 2596241)
-- Dependencies: 2983 5
-- Name: af_maj_evaluation(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_evaluation(integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 l'evaluation
--$2 le libelle	
ams varchar;
BEGIN 
	SELECT INTO ams contraintes.fw_get_ams_libelle('evaluation','libelle','id='||$1,$2);

	UPDATE contraintes.evaluation SET libelle=ams WHERE id=$1;
	RETURN FOUND;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_evaluation(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8310 (class 0 OID 0)
-- Dependencies: 1389
-- Name: FUNCTION af_maj_evaluation(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_evaluation(integer, character varying) IS 'Mise a jour d''une evaluation.';


--
-- TOC entry 1390 (class 1255 OID 2596242)
-- Dependencies: 2983 5
-- Name: af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) RETURNS boolean
    AS $_$-- $1 : numero exotlc
-- $2 : titre
-- $3 : commentaire
-- $4 : texte
-- $5 : enonce
-- $6 : remarque
-- $7 : numero formateur
declare
modif1 bool:=false;
modif2 bool:=false;
v_commentaire  text;
v_texte  text;
v_enonce  text;
v_remarque  text;
ams  text;
begin
	SELECT INTO ams contraintes.fw_get_ams_libelle('etape','libelle','id='||$1,$2);

    -- mise à jour du titre
    UPDATE contraintes.etape SET libelle=ams WHERE id=$1;
    modif1:=found;
    -- mise à jour exotlc

SELECT INTO v_commentaire contraintes.fw_get_ams_libelle('exotlc','commentaire','id='||$1,$3);
SELECT INTO v_texte contraintes.fw_get_ams_libelle('exotlc','texte','id='||$1,$4);
SELECT INTO v_enonce contraintes.fw_get_ams_libelle('exotlc','enonce','id='||$1,$5);
SELECT INTO v_remarque contraintes.fw_get_ams_libelle('exotlc','remarque','id='||$1,$6);

    update contraintes.exotlc set commentaire=v_commentaire,texte=v_texte,enonce=v_enonce,remarque=v_remarque
    where id=$1;

    modif2:=found;
    -- mise à jour fformateur
    update contraintes.exotlc_mail set formateur=$7 where id=$1;
    return modif1 or modif2 or found;


end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 8312 (class 0 OID 0)
-- Dependencies: 1390
-- Name: FUNCTION af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) IS 'met à jour un exotlc mail';


--
-- TOC entry 33 (class 1255 OID 2596243)
-- Dependencies: 2983 5
-- Name: af_maj_exotlc_modele_correction(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_exotlc_modele_correction(integer, integer) RETURNS boolean
    AS $_$-- $1 : exotlc
-- $2 : modele de correction
begin
    if $2 is not null then
	update contraintes.exotlc_modele_correction set modele_correction=$2 where id=$1;
	if not found then
	    insert into contraintes.exotlc_modele_correction(id,modele_correction) values($1,$2);
	end if;
    else
	delete from contraintes.exotlc_modele_correction where id=$1;
    end if;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_exotlc_modele_correction(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8314 (class 0 OID 0)
-- Dependencies: 33
-- Name: FUNCTION af_maj_exotlc_modele_correction(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_exotlc_modele_correction(integer, integer) IS 'Met à jour un modele de correction pour 
exo pf autocorrigé';


--
-- TOC entry 1391 (class 1255 OID 2596244)
-- Dependencies: 2983 5
-- Name: af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean) RETURNS boolean
    AS $_$-- $1 : numero exotlc
-- $2 : titre exotlc
-- $3 : commentaire
-- $4 : texte
-- $5 : enonce
-- $6 : remarque
-- $7 : fichier rendu
-- $8 : autocorrection
declare
modif1 bool:=false;
modif2 bool:=false;
v_commentaire  text;
v_texte  text;
v_enonce  text;
v_remarque  text;

ams  text;
begin
	
    -- mise à jour du titre
    SELECT INTO ams contraintes.fw_get_ams_libelle('etape','libelle','id='||$1,$2);

    UPDATE contraintes.etape SET libelle=ams WHERE id=$1;
    modif1:=found;
    -- mise à jour exotlc
    SELECT INTO v_commentaire contraintes.fw_get_ams_libelle('exotlc','commentaire','id='||$1,$3);
    SELECT INTO v_texte contraintes.fw_get_ams_libelle('exotlc','texte','id='||$1,$4);
    SELECT INTO v_enonce contraintes.fw_get_ams_libelle('exotlc','enonce','id='||$1,$5);
    SELECT INTO v_remarque contraintes.fw_get_ams_libelle('exotlc','remarque','id='||$1,$6);

RAISE NOTICE '%new_remarque=',v_commentaire;
    update contraintes.exotlc set commentaire=v_commentaire,texte=v_texte,enonce=v_enonce,remarque=v_remarque
    where id=$1;
    modif2:=found;
    -- mise à jour fichier rendu
   
    update contraintes.exotlc_plate_forme set fichier_rendu=$7 , autocorrection=$8 where id=$1;
    return modif1 or modif2 or found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 8316 (class 0 OID 0)
-- Dependencies: 1391
-- Name: FUNCTION af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean) IS 'met à jour un exotlc plateforme';


--
-- TOC entry 1392 (class 1255 OID 2596245)
-- Dependencies: 2983 5
-- Name: af_maj_fichier(integer, character varying, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_fichier(integer, character varying, integer, boolean) RETURNS boolean
    AS $_$DECLARE

BEGIN
	
	UPDATE contraintes.fichier SET libelle=$2, "type"=$3, connecte=$4 WHERE id=$1;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_fichier(integer, character varying, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 8318 (class 0 OID 0)
-- Dependencies: 1392
-- Name: FUNCTION af_maj_fichier(integer, character varying, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_fichier(integer, character varying, integer, boolean) IS 'Mise a jour d''un fichier.';


--
-- TOC entry 1886 (class 1255 OID 2596246)
-- Dependencies: 2983 5
-- Name: af_maj_fichier_libelle(integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_fichier_libelle(integer, text) RETURNS boolean
    AS $_$-- $1 :  id
-- $2 : libelle
begin
    update contraintes.fichier set libelle=$2 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_fichier_libelle(integer, text) OWNER TO pgsql;

--
-- TOC entry 1393 (class 1255 OID 2596247)
-- Dependencies: 2983 5
-- Name: af_maj_fichier_scenario_dynamique(integer, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_maj_fichier_scenario_dynamique(integer, character varying, integer) RETURNS boolean
    AS $_$DECLARE
--$1 id
--$2 libelle
--$3 style
ok bool;
ams varchar;
BEGIN
	SELECT INTO ams contraintes.fw_get_ams_libelle('fichier','libelle','id='||$1,$2);

	UPDATE contraintes.fichier_scenario_dynamique 
	SET style=$3 where id=$1;
	ok:=FOUND;

	UPDATE contraintes.fichier 
	SET libelle=ams where id=$1;

	RETURN ok OR FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_fichier_scenario_dynamique(integer, character varying, integer) OWNER TO postgres;

--
-- TOC entry 1394 (class 1255 OID 2596248)
-- Dependencies: 2983 5
-- Name: af_maj_fichier_scenario_dynamique_bloc(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_fichier_scenario_dynamique_bloc(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 scenario
--$2 ordre
--$3 direction si positif  on monte, si negatif ou egal à 0 on descend
ok1 boolean;
ok2 boolean;
ok3 boolean;
ok4 boolean;
rec RECORD;
BEGIN

	--on monte le bloc
	IF $3>0 THEN
		FOR rec IN
			SELECT id, ordre
			FROM contraintes.fichier_scenario_dynamique_blocs
			WHERE id=$1
			ORDER BY ordre ASC
		LOOP		
			IF rec.ordre < $2 THEN
				--on décale tous les prédecesseurs
				UPDATE contraintes.fichier_scenario_dynamique_blocs
				SET ordre=ordre-1
				WHERE id=rec.id
				AND ordre=rec.ordre;
				--RAISE NOTICE 'decale predecesseurs';

			ELSEIF 	rec.ordre = $2 THEN
				--on decale le bloc
				UPDATE contraintes.fichier_scenario_dynamique_blocs
				SET ordre=ordre-1
				WHERE id=rec.id
				AND ordre=rec.ordre;
				--RAISE NOTICE 'decale bloc';

			END IF;
		END LOOP;
			
		--on decale le bloc dont on a pris la place
		UPDATE contraintes.fichier_scenario_dynamique_blocs
		SET ordre=ordre+2
		WHERE id=$1
		AND ordre=$2-2;
		--RAISE NOTICE 'decale bloc remplace';
		
		--on recale tous les prédecesseurs
		FOR rec IN
			SELECT id, ordre
			FROM contraintes.fichier_scenario_dynamique_blocs
			WHERE id=$1
			AND ordre < $2-1 
			ORDER BY ordre DESC
		LOOP			
			UPDATE contraintes.fichier_scenario_dynamique_blocs
			SET ordre=ordre+1
			WHERE id=$1
			AND ordre=rec.ordre;
			--RAISE NOTICE 'recale predecesseurs (ordre=%)',rec.ordre;

		END LOOP;
		
			
		RETURN TRUE;
	--on descend le bloc
	ELSE
		FOR rec IN
			SELECT id, ordre
			FROM contraintes.fichier_scenario_dynamique_blocs
			WHERE id=$1
			ORDER BY ordre DESC
		LOOP		
			IF rec.ordre > $2 THEN
				--on décale tous les successeurs
				UPDATE contraintes.fichier_scenario_dynamique_blocs
				SET ordre=ordre+1
				WHERE id=rec.id
				AND ordre=rec.ordre;
				--RAISE NOTICE 'decale successeurs';
			ELSEIF 	rec.ordre = $2 THEN
				--on decale le bloc
				UPDATE contraintes.fichier_scenario_dynamique_blocs
				SET ordre=ordre+1
				WHERE id=rec.id
				AND ordre=rec.ordre;
				--RAISE NOTICE 'decale bloc';
			END IF;
		END LOOP;
		
		--on decale le bloc dont on a pris la place
		UPDATE contraintes.fichier_scenario_dynamique_blocs
		SET ordre=ordre-2
		WHERE id=$1
		AND ordre=$2+2;
		--RAISE NOTICE 'decale bloc remplace';
		
		FOR rec IN
			SELECT id, ordre
			FROM contraintes.fichier_scenario_dynamique_blocs
			WHERE id=$1
			AND ordre> $2+1 
			ORDER BY ordre ASC
		LOOP		
			--on recale tous les successeurs
			UPDATE contraintes.fichier_scenario_dynamique_blocs
			SET ordre=ordre-1
			WHERE id=$1
			AND ordre=rec.ordre;
		END LOOP;
		
		RETURN TRUE;
	END IF;
	
	RETURN FALSE;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_fichier_scenario_dynamique_bloc(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1395 (class 1255 OID 2596249)
-- Dependencies: 2983 5
-- Name: af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 id du fichier
--$2 libelle du fichier texte
--$3 titre du lien
--$4 adresse du lien
--$5 description
--$6 mise en forme
--$7 connectÃ©
fait boolean;
ams2 varchar;
ams3 varchar;
ams4 varchar;
ams5 varchar;
ams6 varchar;
BEGIN
	-- mise à jour du libelle fichier
	SELECT INTO ams2 contraintes.fw_get_ams_libelle('fichier','libelle','id='||$1,$2);
	UPDATE contraintes.fichier SET libelle=$2, connecte=$7 WHERE id=$1;
	fait:=FOUND;

	-- mise à jour fichier_texte
	SELECT INTO ams3 contraintes.fw_get_ams_libelle('fichier_ressource_texte','libelle','id='||$1,$3);
	SELECT INTO ams4 contraintes.fw_get_ams_libelle('fichier_ressource_texte','adresse','id='||$1,$4);
	SELECT INTO ams5 contraintes.fw_get_ams_libelle('fichier_ressource_texte','description','id='||$1,$5);
	SELECT INTO ams6 contraintes.fw_get_ams_libelle('fichier_ressource_texte','mise_en_forme','id='||$1,$6);
	UPDATE contraintes.fichier_ressource_texte SET libelle=ams3, adresse=ams4, description=ams5, mise_en_forme=ams6, date_modification=now() WHERE id=$1;
	fait:=fait OR FOUND;
		
	RETURN fait;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) OWNER TO pgsql;

--
-- TOC entry 8323 (class 0 OID 0)
-- Dependencies: 1395
-- Name: FUNCTION af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) IS 'Mise a jour d''un fichier texte.';


--
-- TOC entry 1396 (class 1255 OID 2596250)
-- Dependencies: 2983 5
-- Name: af_maj_fichiers_connection(integer[], boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_fichiers_connection(integer[], boolean) RETURNS integer
    AS $_$DECLARE
i integer;

BEGIN

	FOR i IN array_lower($1, 1) .. array_upper($1, 1) 
	LOOP
		UPDATE contraintes.fichier SET connecte=$2 WHERE id=$1[i];
		RAISE NOTICE 'met a jour le fichier % d''indice%',$1[i],i;
	END LOOP; 

	RETURN i;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_fichiers_connection(integer[], boolean) OWNER TO pgsql;

--
-- TOC entry 8325 (class 0 OID 0)
-- Dependencies: 1396
-- Name: FUNCTION af_maj_fichiers_connection(integer[], boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_fichiers_connection(integer[], boolean) IS 'Mise a jour d''un ensemble de connections de fichiers.';


--
-- TOC entry 1397 (class 1255 OID 2596251)
-- Dependencies: 2983 5
-- Name: af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]) RETURNS boolean
    AS $_$-- $1 : tableau d'identifiants
-- $2 : tableau de libelles
declare
i integer;
begin
    IF array_upper($2, 1) !=array_upper($2, 1) THEN
	RAISE EXCEPTION '% identifiants % textes',array_upper($1, 1),array_upper($2, 1); 
    END IF;

    FOR i IN array_lower($1, 1) .. array_upper($1, 1) 
	LOOP
	    PERFORM * FROM contraintes.af_maj_fichier_libelle($1[i],$2[i]);
	END LOOP; 
    return found;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]) OWNER TO pgsql;

--
-- TOC entry 8327 (class 0 OID 0)
-- Dependencies: 1397
-- Name: FUNCTION af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]) IS 'Modifie des messages de langue';


--
-- TOC entry 1398 (class 1255 OID 2596252)
-- Dependencies: 2983 5
-- Name: af_maj_filiere(integer, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_filiere(integer, character varying, integer) RETURNS boolean
    AS $_$DECLARE
--$1 filiere
--$2 libelle
--$3 pere
ams varchar;
BEGIN
	SELECT INTO ams contraintes.fw_get_ams_libelle('filiere','libelle','id='||$1,$2);

	UPDATE contraintes.filiere SET libelle=ams, pere=$3
	WHERE id=$1;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_filiere(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1399 (class 1255 OID 2596253)
-- Dependencies: 2983 5
-- Name: af_maj_formation(integer, character varying, date, date, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_formation(integer, character varying, date, date, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : libelle
-- $3 : debut
-- $4 : fin
-- $5 : langue defaut
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('formation','libelle','id='||$1,$2);

	
    update contraintes.formation set libelle=ams,date_debut=$3,date_fin=$4,langue=$5 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_formation(integer, character varying, date, date, integer) OWNER TO pgsql;

--
-- TOC entry 8330 (class 0 OID 0)
-- Dependencies: 1399
-- Name: FUNCTION af_maj_formation(integer, character varying, date, date, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_formation(integer, character varying, date, date, integer) IS 'met à jour une formation';


--
-- TOC entry 1400 (class 1255 OID 2596254)
-- Dependencies: 2983 5
-- Name: af_maj_formation_dates(integer, date, date); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_formation_dates(integer, date, date) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date debut
-- $3 : date fin
begin
    update contraintes.formation set
	date_debut=$2,
	date_fin=$3
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_formation_dates(integer, date, date) OWNER TO pgsql;

--
-- TOC entry 8332 (class 0 OID 0)
-- Dependencies: 1400
-- Name: FUNCTION af_maj_formation_dates(integer, date, date); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_formation_dates(integer, date, date) IS 'Mettre à jour les dates d''une formation';


--
-- TOC entry 1401 (class 1255 OID 2596255)
-- Dependencies: 2983 5
-- Name: af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : libelle
-- $3 : date
-- $4 : duree
-- $5 : modalite
-- $6 : intervention
-- $7 : intervenant
-- $8 : salle
-- $9 : ancienne date
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('evenement','libelle','formation='||$1||' and date='''||$9||'''',$2);

    update contraintes.evenement set
	libelle=ams,
	date=$3,
	duree=$4  ,
	modalite=$5,
	intervention=$6,
	intervenant=$7,
	salle=$8
    where formation=$1 and date=$9;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 8334 (class 0 OID 0)
-- Dependencies: 1401
-- Name: FUNCTION af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) IS 'met à jour un evenement de formation';


--
-- TOC entry 1402 (class 1255 OID 2596256)
-- Dependencies: 2983 5
-- Name: af_maj_formation_langues(integer, integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_formation_langues(integer, integer[], integer[]) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : tableau des langue à inserer
-- $3 : tableau des langues à supprimer
declare
i int4;
ok1 bool;
begin
    --LANGUES à ajouter
    if array_upper($2,1)>0 then
    FOR i IN array_lower($2, 1) .. array_upper($2, 1) 
    LOOP
	SELECT INTO ok1 *  FROM contraintes.af_set_formation_langue($1,$2[i]);
	IF NOT ok1 THEN
	    RAISE EXCEPTION 'Les langues n''ont pu etre ajouté .';
	END IF;
    END LOOP;
    end if;
 
    --LANGUES à supprimer
    if array_upper($3,1)>0 then
    FOR i IN array_lower($3, 1) .. array_upper($3, 1) 
    LOOP
	SELECT INTO ok1 *  FROM contraintes.af_del_formation_langue($1,$3[i]);
	IF NOT ok1 THEN
	    RAISE EXCEPTION 'Les langues n''ont pu etre supprimee.';
	END IF;
    END LOOP;
    end if;
    return ok1;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_formation_langues(integer, integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 8336 (class 0 OID 0)
-- Dependencies: 1402
-- Name: FUNCTION af_maj_formation_langues(integer, integer[], integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_formation_langues(integer, integer[], integer[]) IS 'met à jour les langues disponibles de la formation';


--
-- TOC entry 1403 (class 1255 OID 2596257)
-- Dependencies: 2983 5
-- Name: af_maj_formation_libelle(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_formation_libelle(integer, character varying) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : titre
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('formation','libelle','id='||$1,$2);

    update contraintes.formation set libelle=ams where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_formation_libelle(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8338 (class 0 OID 0)
-- Dependencies: 1403
-- Name: FUNCTION af_maj_formation_libelle(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_formation_libelle(integer, character varying) IS 'mettre à jour le nom d''une formation';


--
-- TOC entry 1404 (class 1255 OID 2596258)
-- Dependencies: 2983 5
-- Name: af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : ressource
-- $3 : ancien espace
-- $4 : ancienne section
-- $5 : libelle ressource
-- $6 : debut
-- $7 : fin
-- $8 : duree nouveaute
-- $9 : mots cles
-- $10 : espace
-- $11 : section
declare
etape int4;
ok bool;
ok2 bool;
ams varchar;
begin
    -- recup n° etape
    -- mise en commentaire par said (19/06/08)
    --select into etape id from contraintes.etape_ressource where fichier_ressource=$2;
    -- maj libelle etape
    -- mise en commentaire par said (19/06/08)
    --select into ok * from contraintes.af_maj_etape_libelle(etape,$5);
    -- maj table formation_ressource
    update contraintes.formation_ressources set 
    debut_disponibilite=$6,fin_disponibilite=$7,duree_nouveaute=$8,espace=$10,section=$11 
    where formation=$1 and fichier_ressource=$2 and espace=$3 and section=$4;
    ok2:=found;	
    -- maj table ressource (mot cles)
    SELECT INTO ams contraintes.fw_get_ams_libelle('fichier_metadata','mots_cles','id='||$2,$9);
    update contraintes.fichier_metadata set mots_cles=ams where id=$2;
    --return found or ok or ok2;
    return found or ok2;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8340 (class 0 OID 0)
-- Dependencies: 1404
-- Name: FUNCTION af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer) IS 'modifie une ressource de formation';


--
-- TOC entry 1405 (class 1255 OID 2596259)
-- Dependencies: 2983 5
-- Name: af_maj_formation_ressources_fusionnees(integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_formation_ressources_fusionnees(integer, boolean) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : booleen fusion
begin
    update contraintes.formation set ressources_fusionnees=$2 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_formation_ressources_fusionnees(integer, boolean) OWNER TO pgsql;

--
-- TOC entry 8342 (class 0 OID 0)
-- Dependencies: 1405
-- Name: FUNCTION af_maj_formation_ressources_fusionnees(integer, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_formation_ressources_fusionnees(integer, boolean) IS 'modifie le booleen de fusion des ressources pour une formation';


--
-- TOC entry 1407 (class 1255 OID 2596260)
-- Dependencies: 2983 5
-- Name: af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) RETURNS boolean
    AS $_$-- $1 : forum
-- $2 : libelle forum
-- $3 : description
-- $4 : upload
-- $5 : theme
-- $6 : arbo par page
-- $7 : msg par page
begin
    update contraintes.forum 
    set libelle=$2,description=$3,fils=$6,messages=$7,upload=$4,theme=$5 
    where id=$1;
    return found;     
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8344 (class 0 OID 0)
-- Dependencies: 1407
-- Name: FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) IS 'modifier un forum';


--
-- TOC entry 1406 (class 1255 OID 2596261)
-- Dependencies: 2983 5
-- Name: af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : forum
-- $2 : libelle
-- $3 : description
-- $4 : upload
-- $5 : theme
-- $6 : arbo par page
-- $7 : msg par page
-- $8 : configuration
declare
ams_libelle varchar;
ams_description varchar;
begin
    SELECT INTO ams_libelle contraintes.fw_get_ams_libelle('forum','libelle','id='||$1,$2);
    SELECT INTO ams_description contraintes.fw_get_ams_libelle('forum','description','id='||$1,$3);
    update contraintes.forum 
    set libelle=ams_libelle,description=ams_description,upload=$4,theme=$5,fils=$6,messages=$7 
    where id=$1;
    update contraintes.forum_environnements set environnement=$8 where forum=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8346 (class 0 OID 0)
-- Dependencies: 1406
-- Name: FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) IS 'Mettre à jour les donées d''un forum';


--
-- TOC entry 34 (class 1255 OID 2596262)
-- Dependencies: 2983 5
-- Name: af_maj_forum_environnement(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, integer, integer, boolean, boolean, boolean, boolean, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_forum_environnement(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, integer, integer, boolean, boolean, boolean, boolean, character varying) RETURNS boolean
    AS $_$BEGIN

  UPDATE contraintes.forum_environnement 
  SET
  libelle =$2,
  chemin =$3,
  db_type =$4,
  db_serveur =$5,
  db_name = $6,
  db_user = $7,
  db_pwd = $8,
  admin = $9,
  admin_pwd =$10,
  email_valide =$11,
  email_verification =$12,
  interpretation_html =$13,
  citation =$14,
  noms_longs =$15,
  taille_pj =$16,
  lignes =$17,
  block_ip =$18,
  compte_vus =$19,
  fils_fermes =$20,
  affiche_fils =$21,
  encodage =$22
  WHERE id=$1;

  RETURN FOUND;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_forum_environnement(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, integer, integer, boolean, boolean, boolean, boolean, character varying) OWNER TO pgsql;

--
-- TOC entry 1408 (class 1255 OID 2596263)
-- Dependencies: 2983 5
-- Name: af_maj_ftb(integer, text, boolean, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_ftb(integer, text, boolean, boolean) RETURNS boolean
    AS $_$declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('ftb','text','id='||$1,$2);

    update contraintes.ftb set text=ams,voir_mots=$3,interpretation_html=$4 
    where id=$1;
    -- Ajout said le 03/09/08 (mise à jour dans évaluation)
    perform * from contraintes.af_maj_evaluation($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_ftb(integer, text, boolean, boolean) OWNER TO pgsql;

--
-- TOC entry 8349 (class 0 OID 0)
-- Dependencies: 1408
-- Name: FUNCTION af_maj_ftb(integer, text, boolean, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_ftb(integer, text, boolean, boolean) IS 'met à jour un remplir les blancs (ftb)';


--
-- TOC entry 1409 (class 1255 OID 2596264)
-- Dependencies: 2983 5
-- Name: af_maj_grille(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_grille(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero grille
-- $2 : libelle
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('grille','libelle','id='||$1,$2);

    update contraintes.grille set libelle =ams where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_grille(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8351 (class 0 OID 0)
-- Dependencies: 1409
-- Name: FUNCTION af_maj_grille(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_grille(integer, character varying) IS 'met à jour une grille';


--
-- TOC entry 1410 (class 1255 OID 2596265)
-- Dependencies: 2983 5
-- Name: af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) RETURNS boolean
    AS $_$declare
fait boolean;
begin
    update contraintes.fw_individu 
    set login=$2,password=$3,nom=$4,prenom=$5,adresse=$6,code=$7,ville=$8,email=$9,tel_fixe=$10,tel_port=$11,langue=$12,organisme=$13,photo=$14 
    where id=$1;
    fait:=found;
    return fait;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8353 (class 0 OID 0)
-- Dependencies: 1410
-- Name: FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) IS 'met à jour un individu';


--
-- TOC entry 1411 (class 1255 OID 2596266)
-- Dependencies: 2983 5
-- Name: af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer) RETURNS boolean
    AS $_$declare
fait boolean;
begin
    update contraintes.fw_individu 
    set password=$2,nom=$3,prenom=$4,adresse=$5,code=$6,ville=$7,email=$8,tel_fixe=$9,tel_port=$10,langue=$11,photo=$12
    where id=$1;
    fait:=found;
    return fait;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1412 (class 1255 OID 2596267)
-- Dependencies: 2983 5
-- Name: af_maj_individu_date_deconnexion(integer, timestamp without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_individu_date_deconnexion(integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : individu
-- $2 : date deconnexion
begin
    update contraintes.connexion set deconnexion=$2 
    where individu=$1 
    and connexion in 
    (select max(connexion) from contraintes.connexion where individu=$1);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_individu_date_deconnexion(integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 8356 (class 0 OID 0)
-- Dependencies: 1412
-- Name: FUNCTION af_maj_individu_date_deconnexion(integer, timestamp without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_individu_date_deconnexion(integer, timestamp without time zone) IS 'met à jour la date de deconnexion pour un individu';


--
-- TOC entry 1413 (class 1255 OID 2596268)
-- Dependencies: 2983 5
-- Name: af_maj_individu_session(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_individu_session(integer, integer) RETURNS boolean
    AS $_$-- $1 : individu
-- $2 : formation
begin
    update contraintes.session set formation=$2 where individu=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_individu_session(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8358 (class 0 OID 0)
-- Dependencies: 1413
-- Name: FUNCTION af_maj_individu_session(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_individu_session(integer, integer) IS 'met à jour la session d''un individu';


--
-- TOC entry 1414 (class 1255 OID 2596269)
-- Dependencies: 2983 5
-- Name: af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) RETURNS boolean
    AS $_$declare
fait boolean;
begin
    update contraintes.inscription 
    set login=$2,password=$3,nom=$4,prenom=$5,adresse=$6,code=$7,ville=$8,email=$9,tel_fixe=$10,tel_port=$11,langue=$12,organisme=$13,photo=$14 
    where id=$1;
    fait:=found;
   
    return fait;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8360 (class 0 OID 0)
-- Dependencies: 1414
-- Name: FUNCTION af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) IS 'met à jour une inscription';


--
-- TOC entry 1415 (class 1255 OID 2596270)
-- Dependencies: 2983 5
-- Name: af_maj_intervention(integer, character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_intervention(integer, character varying, character varying) RETURNS boolean
    AS $_$-- $1 : numero intervention
-- $2 : libelle
-- $3 : couleur
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('intervention','libelle','id='||$1,$2);

    update contraintes.intervention set libelle=ams,couleur=$3 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_intervention(integer, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 8362 (class 0 OID 0)
-- Dependencies: 1415
-- Name: FUNCTION af_maj_intervention(integer, character varying, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_intervention(integer, character varying, character varying) IS 'met à jour une intervention';


--
-- TOC entry 1416 (class 1255 OID 2596271)
-- Dependencies: 2983 5
-- Name: af_maj_langue_libelle(integer, integer, integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_langue_libelle(integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : langue
-- $2 : type
-- $3 : id
-- $4 : libelle
begin
    update contraintes.langue_message set libelle=$4 
    where langue=$1 and type=$2 and id=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_langue_libelle(integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 8364 (class 0 OID 0)
-- Dependencies: 1416
-- Name: FUNCTION af_maj_langue_libelle(integer, integer, integer, text); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_langue_libelle(integer, integer, integer, text) IS 'met à jour un libelle de langue';


--
-- TOC entry 1417 (class 1255 OID 2596272)
-- Dependencies: 2983 5
-- Name: af_maj_langue_libelles(integer, integer, integer[], text[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_langue_libelles(integer, integer, integer[], text[]) RETURNS boolean
    AS $_$-- $1 : le numero de langue
-- $2 : le numero de type
-- $3 : tableau d'identifiants
-- $4 : tableau de messages
declare
i integer;
begin
    IF array_upper($3, 1) !=array_upper($4, 1) THEN
	RAISE EXCEPTION '% identifiants % textes',array_upper($3, 1),array_upper($4, 1); 
    END IF;

    FOR i IN array_lower($3, 1) .. array_upper($3, 1) 
	LOOP
	    PERFORM * FROM contraintes.af_maj_langue_libelle($1,$2,$3[i],$4[i]);
	END LOOP; 
    return found;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_langue_libelles(integer, integer, integer[], text[]) OWNER TO pgsql;

--
-- TOC entry 8366 (class 0 OID 0)
-- Dependencies: 1417
-- Name: FUNCTION af_maj_langue_libelles(integer, integer, integer[], text[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_langue_libelles(integer, integer, integer[], text[]) IS 'Modifie des messages de langue';


--
-- TOC entry 1418 (class 1255 OID 2596273)
-- Dependencies: 2983 5
-- Name: af_maj_modele_correction_criteres_note(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_modele_correction_criteres_note(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero modele
-- $2 : numero critere
-- $3 : numero pere
-- $4 : note
begin
    if $3 is not null then	
    update contraintes.modele_correction_criteres set note_max=$4 
    where modele_correction=$1 and critere=$2 and pere=$3;
    else
    update contraintes.modele_correction_criteres set note_max=$4 
    where modele_correction=$1 and critere=$2 and pere is null;
    end if;
    return found;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_modele_correction_criteres_note(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8368 (class 0 OID 0)
-- Dependencies: 1418
-- Name: FUNCTION af_maj_modele_correction_criteres_note(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_modele_correction_criteres_note(integer, integer, integer, integer) IS 'met à jour la note dans un modele de correction';


--
-- TOC entry 1419 (class 1255 OID 2596274)
-- Dependencies: 2983 5
-- Name: af_maj_organisme(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_organisme(integer, character varying) RETURNS boolean
    AS $_$begin
    update contraintes.organisme 
    set libelle=$2 where id=$1;
    return FOUND;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_organisme(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8370 (class 0 OID 0)
-- Dependencies: 1419
-- Name: FUNCTION af_maj_organisme(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_organisme(integer, character varying) IS 'met à jour un organisme';


--
-- TOC entry 1420 (class 1255 OID 2596275)
-- Dependencies: 2983 5
-- Name: af_maj_parcours_duree(integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_parcours_duree(integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 affichage duree fo
BEGIN
	UPDATE contraintes.parcours
	SET duree=$2
	WHERE id=$1; 
	
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_parcours_duree(integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1421 (class 1255 OID 2596276)
-- Dependencies: 2983 5
-- Name: af_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 pere
--$3 nouvelle tape
--$4 obligation
--$5 chrono
--$6 fin de page
BEGIN
	IF $2 IS NOT NULL THEN
		UPDATE contraintes.parcours_etapes
		SET etape=$3, obligatoire=$4, chrono=$5, fin=$6
		WHERE parcours=$1 AND pere=$2;
	ELSE
		UPDATE contraintes.parcours_etapes
		SET etape=$3, obligatoire=$4, chrono=$5, fin=$6
		WHERE parcours=$1 AND pere IS NULL;
	END IF;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1422 (class 1255 OID 2596277)
-- Dependencies: 2983 5
-- Name: af_maj_parcours_etape_duree(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_parcours_etape_duree(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 duree
val int4;
BEGIN
	IF $3=0 THEN
		val:=NULL;
	ELSE
		val:=$3;
	END IF;

	UPDATE contraintes.parcours_etapes
	SET chrono=val
	WHERE parcours=$1 AND etape=$2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_parcours_etape_duree(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1887 (class 1255 OID 2596278)
-- Dependencies: 2983 5
-- Name: af_maj_parcours_etape_ordre(integer, integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_parcours_etape_ordre(integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape source
--$3 etape destination
pere_src int4;
pere_dst int4;
suivant_src int4;
precedent_dst int4;
tmp int4;
BEGIN

	--recup du pere de la source
	SELECT INTO pere_src pere FROM contraintes.af_get_parcours_etape($1,$2)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar);

	--recup du pere de la destination
	SELECT INTO pere_dst pere FROM contraintes.af_get_parcours_etape($1,$3)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar);

	--maj de la source (1ere etape -> petite astuce: on met le pere à l'id du dernier, (pas utilisé pour un pere) pour eviter les conflits)
	SELECT INTO tmp P.id FROM contraintes.af_gen_get_last_element('contraintes.parcours_etapes', 'etape',' AND parcours='||$1) P;
	UPDATE contraintes.parcours_etapes SET pere=tmp WHERE parcours=$1 AND etape=$2;

	--maj du suivant de la source
	UPDATE contraintes.parcours_etapes SET pere=pere_src WHERE parcours=$1 AND pere=$2;
		
--INSERTION AVANT
IF $4 THEN

	--recup du suivant de la source
	SELECT INTO suivant_src etape FROM contraintes.parcours_etapes WHERE parcours=$1 AND pere=$2;

	--maj de la destination
	UPDATE contraintes.parcours_etapes SET pere=$2   WHERE parcours=$1 AND etape=$3;

	--maj de la source (2eme etape -> on met la bonne valeur au pere)
	UPDATE contraintes.parcours_etapes SET pere=pere_dst WHERE parcours=$1 AND etape=$2; 

--INSERTION APRES
ELSE
	--maj du suivant de la destination
	UPDATE contraintes.parcours_etapes SET pere=$2   WHERE parcours=$1 AND pere=$3;

	--maj de la source (2eme etape -> on met la bonne valeur au pere)
	UPDATE contraintes.parcours_etapes SET pere=$3 WHERE parcours=$1 AND etape=$2; 
END IF;

	RETURN TRUE;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_parcours_etape_ordre(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1423 (class 1255 OID 2596279)
-- Dependencies: 2983 5
-- Name: af_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 libelle
BEGIN
	UPDATE contraintes.parcours_etapes
	SET libelle_type_etape=$3
	WHERE parcours=$1
	AND etape=$2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1424 (class 1255 OID 2596280)
-- Dependencies: 2983 5
-- Name: af_maj_parcours_etapes_duree_type(integer, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_parcours_etapes_duree_type(integer, character varying, integer) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 type
--$3 duree
val int4;
BEGIN
	IF $3=0 THEN
		val:=NULL;
	ELSE
		val:=$3;
	END IF;

	UPDATE contraintes.parcours_etapes 
	SET chrono=val
	FROM contraintes.af_get_parcours_etapes($1)AS (E_id int4, E_libelle_alias varchar, E_libelle varchar, E_libelle_type_etape  varchar, E_type varchar,  E_pere int4, E_parcours int4, E_obligatoire bool, E_chrono int4, E_fin bool, E_libelle_type_original varchar, E_modifiable bool) 
	WHERE parcours=$1 AND E_type LIKE $2||'%'
	AND E_type NOT LIKE '4_1_4%'
	AND etape=E_id;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_parcours_etapes_duree_type(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1425 (class 1255 OID 2596281)
-- Dependencies: 2983 5
-- Name: af_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 identifiant de l'étape
--$2 libelle etape
--$3 les sous parcours
--$4 types d'étapes
--$5 nombre de types d'etapes
--$6 seuil
ok1 bool;
ok2 bool;
val int4;
i int4;
j int4;
curs int4:=1;
BEGIN
	--modif de l'etape
	SELECT INTO ok1 * FROM contraintes.af_maj_etape_libelle($1,$2); 
	
	--suppression de la configuration
	DELETE FROM contraintes.parcours_oriente WHERE id=$1;
	ok2:=FOUND;

	--insertion de la nouvelle configuration
	FOR i IN array_lower($3, 1) .. array_upper($3, 1)  
	LOOP
		--le 1er sous parcours
		IF i=1 THEN
			INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil,ordre) values($1,$3[i],NULL,NULL, i);
			raise notice '1er parcours %: INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',curs,$1,$3[i],'NULL','NULL';
		--les autres
		ELSE
			--seuil global
			IF $4[curs]=-1 THEN
				INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil,ordre) values($1,$3[i],NULL,$6[curs],i);
				raise notice 'global %: INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',curs,$1,$3[i],'NULL',$6[curs];
				curs:=curs+1;
			--seuil par type
			ELSE
				--pour chacun des types
				FOR j IN 1 .. $5
				LOOP
					--cas ou pas de seuil pour le type
					IF $6[curs] =-1 THEN
						val:=NULL;
					ELSE
						val:=$6[curs];
					END IF;
					INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil,ordre) values($1,$3[i],$4[curs],val,i);
					raise notice 'type %: INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',curs,$1,$3[i],$4[curs],val;
					curs:=curs+1;
				END LOOP;
			END IF;
		END IF;
	END LOOP;
	
	RETURN ok1 OR ok2;
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 1426 (class 1255 OID 2596282)
-- Dependencies: 2983 5
-- Name: af_maj_parcours_type_etape_personnalise(integer, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_parcours_type_etape_personnalise(integer, integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 type d'etape
--$3 libelle
BEGIN
	UPDATE contraintes.parcours_etapes
	SET libelle_type_etape=$3
	FROM contraintes.etape
	WHERE parcours=$1
	AND contraintes.parcours_etapes.etape=contraintes.etape.id
	AND contraintes.etape.type=$2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_parcours_type_etape_personnalise(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1427 (class 1255 OID 2596283)
-- Dependencies: 2983 5
-- Name: af_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 id
--$2 libelle
--$3 media
--$4 hauteur
--$5 largeur
--$6 chrono
--$7 chrono evaluations generees
--$8 bareme evaluations generees
ok bool;
ok1 bool;
eval int4;
serie_al int4;
qr int4;
BEGIN 

	--on selectionne la serie aleatoire associée au positionnement
	SELECT INTO serie_al serie_aleatoire FROM contraintes.positionnement where id=$1;

	--on selectionne le question reponse associée au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	--on maj la serie aleatoire
	PERFORM contraintes.af_maj_serie(serie_al, $2, $8, $7);

	--on maj l'evaluation
	PERFORM contraintes.af_maj_evaluation($1, $2);

	--on maj le positionnement
	UPDATE contraintes.positionnement SET
	libelle=$2, chrono=$6
	WHERE id=$1;	
	ok:=FOUND;

	IF $3 IS NOT NULL THEN
		SELECT INTO ok1 * FROM contraintes.af_maj_question_reponse_media(qr,$3,$4,$5);
		IF ok1=FALSE THEN
			PERFORM * FROM contraintes.af_set_question_reponse_media(qr,$3,$4,$5);
		END IF;
	ELSE
		PERFORM * FROM contraintes.af_del_question_reponse_media(qr);
	END IF;

	RETURN ok;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1888 (class 1255 OID 2596284)
-- Dependencies: 2983 5
-- Name: af_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 choix
--$3 nouveau choix
--$4 bareme
--$5 media
--$6 hauteur
--$7 largeur
r1 boolean;
r2 boolean;
qr int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	UPDATE contraintes.choix
	SET id=$3, bareme=$4
	WHERE positionnement=$1
	AND id=$2;
	r1 := FOUND;

	IF $5 IS NOT NULL THEN
		UPDATE contraintes.media_question_reponse_element
		SET media=$5, hauteur=$6, largeur=$7
		WHERE question_reponse=qr
		AND question_reponse_element=$3;
		r2 := FOUND;
		
		IF r2!=TRUE THEN
			INSERT INTO contraintes.media_question_reponse_element (question_reponse, question_reponse_element, media, hauteur, largeur )
			VALUES (qr, $3, $5, $6, $7);
			r2 := FOUND;
		END IF;
	ELSE 
		DELETE FROM contraintes.media_question_reponse_element 
		WHERE question_reponse=qr
		AND question_reponse_element=$2;
		r2 := FOUND;
	END IF;

	RETURN r1 OR r2;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1428 (class 1255 OID 2596285)
-- Dependencies: 2983 5
-- Name: af_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 choix
--$3array int4 : type |  nb_a_generer | taille_chapeau
i int4;
qr int4;
j int4;
k int4;
BEGIN
FOR i IN array_lower($3,1) .. array_upper($3,1)
LOOP
	IF $3[i][3]=-1 THEN
		j:=NULL;
	ELSE
		j:=$3[i][3];
	END IF;

	IF $3[i][2]=-1 THEN
		k:=0;
	ELSE
		k:=$3[i][2];
	END IF;

	--on met a jour les nombres d'evaluations a generer
	UPDATE contraintes.positionnement_choix_evaluations
	SET nombre=k, nombre_max=j
	WHERE positionnement=$1 
	AND choix=$2
	AND type=$3[i][1];
	
END LOOP;
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 1429 (class 1255 OID 2596286)
-- Dependencies: 2983 5
-- Name: af_maj_positionnement_question_positionnement_solution(integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_positionnement_question_positionnement_solution(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3array int4 : choix |  juste (0 ou 1)
i int4;
qr int4;
b_value bool;
ok bool;
ok2 bool;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	FOR i IN array_lower($3,1) .. array_upper($3,1)
	LOOP
		IF $3[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		RAISE NOTICE 'maj: %, %, %, %==%',qr, $2, $3[i][1], b_value, $3[i][2];
		SELECT INTO ok * FROM contraintes.af_maj_question_reponse_solution(qr, $2, $3[i][1], b_value);
		IF ok IS FALSE THEN
			RAISE NOTICE 'set: %, %, %, %==%',qr, $2, $3[i][1], b_value, $3[i][2];
			SELECT INTO ok2 * FROM contraintes.af_set_question_reponse_solution(qr, $2, $3[i][1], b_value);
			IF ok2 IS FALSE THEN RAISE EXCEPTION 'Erreur sur l''insertion de la solution.'; END IF;
		END IF;
	END LOOP;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_positionnement_question_positionnement_solution(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 1430 (class 1255 OID 2596287)
-- Dependencies: 2983 5
-- Name: af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
-- $7 : carton
begin
    update contraintes.grille_resultats 
    set carton =$7
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) OWNER TO pgsql;

--
-- TOC entry 8384 (class 0 OID 0)
-- Dependencies: 1430
-- Name: FUNCTION af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) IS 'met à jour le carton pour une capacite à une date';


--
-- TOC entry 1431 (class 1255 OID 2596288)
-- Dependencies: 2983 5
-- Name: af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
-- $7 : commentaire
-- $8 : note
-- $9 : notesur
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('grille_resultats','commentaire','formation='||$1||'and stagiaire='||$2||' and grille='||$3||' and capacite_titre='||$4||' and capacite='||$5||' and date='''||$6||'''',$7);
    update contraintes.grille_resultats 
    set commentaire=ams,note=$8,note_max=$9 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8386 (class 0 OID 0)
-- Dependencies: 1431
-- Name: FUNCTION af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) IS 'met à jour la note pour une capacite à une date';


--
-- TOC entry 1432 (class 1255 OID 2596289)
-- Dependencies: 2983 5
-- Name: af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : bool
begin
    update contraintes.stagiaire_grille set visible=$4 
    where formation=$1 and stagiaire=$2 and grille=$3;
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 8388 (class 0 OID 0)
-- Dependencies: 1432
-- Name: FUNCTION af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) IS 'Met à jour la table stagiaire_grille(voir ou pas) pour un stagiaire';


--
-- TOC entry 1433 (class 1255 OID 2596290)
-- Dependencies: 2983 5
-- Name: af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) RETURNS boolean
    AS $_$
--$1 Identifiant du question_reponse
--$2 libelle
--$3 question commmune
--$4 radio?
--$5 questions
--$6 reponses
--$7 : tableau des juste/faux
DECLARE
prec_i integer:=NULL;
prec_j integer:=NULL;
maj_ok boolean;
assos_ok_q boolean:=TRUE;
assos_ok_r boolean:=TRUE;
assos_ok_s boolean:=TRUE;
rep_ok boolean:=TRUE;
ins_ok boolean;
b_value boolean;
k integer=1;
BEGIN
    SELECT INTO maj_ok * FROM contraintes.af_maj_qsrc($1, $2,$3,$4);
    DELETE FROM contraintes.question_reponse_elements
    WHERE question_reponse = $1;
    
    -- boucle d'enregistrement des questions
    IF array_upper($5, 1) IS NOT NULL THEN
	FOR i IN array_lower($5, 1) .. array_upper($5, 1)  
	LOOP 
	    IF i-1>0 THEN
		prec_i:=$5[i-1];
	    END IF;
	    SELECT INTO ins_ok contraintes.af_set_question_reponse_association_element($1,$5[i], prec_i);
	    IF NOT ins_ok THEN
		assos_ok_q:=FALSE;
	    END IF;
	end loop;
    end if;
    -- boucle d'enregistrement des reponses
    IF array_upper($6, 1) IS NOT NULL THEN
	FOR j IN array_lower($6, 1) .. array_upper($6, 1)  
	LOOP 
	    IF j-1>0 THEN
		prec_j:=$6[j-1];
	    END IF;
	    SELECT INTO ins_ok contraintes.af_set_question_reponse_association_element($1,$6[j], prec_j);
	    IF NOT ins_ok THEN
		assos_ok_r:=FALSE;
	    END IF;
	end loop;
    end if;

    -- boucles d'enregistrement des vrai faux
    IF array_upper($5, 1) IS NOT NULL THEN
	FOR i IN array_lower($5, 1) .. array_upper($5, 1)  
	LOOP 
	    IF array_upper($6, 1) IS NOT NULL THEN
		FOR j IN array_lower($6, 1) .. array_upper($6, 1)  
		LOOP
		    IF $7[k][1]=$5[i] AND $7[k][2]=$6[j] AND $7[k][3]=1 THEN
			b_value:=TRUE;
		    ELSE 
			b_value:=FALSE;
		    END IF;
		    SELECT INTO rep_ok * FROM contraintes.af_set_question_reponse_solution($1, $5[i], $6[j], b_value);
		    IF NOT rep_ok THEN
			assos_ok_s:=FALSE;
		    END IF;
		    k:=k+1;
		end loop;
	    end if;
	end loop;
    end if;
    

    /*
    IF array_upper($5, 1) IS NOT NULL THEN
	FOR i IN array_lower($5, 1) .. array_upper($5, 1)  
	LOOP 
	    IF i-1>0 THEN
		prec_i:=$5[i-1];
	    END IF;
	    IF array_upper($6, 1) IS NOT NULL THEN
		FOR j IN array_lower($6, 1) .. array_upper($6, 1)  
		LOOP
		    SELECT INTO ins_ok contraintes.af_set_question_reponse_association_element($1,$5[i], $6[j],prec_i);
		    IF NOT ins_ok THEN
			assos_ok:=FALSE;
		    END IF;
		    RAISE NOTICE 'lit juste = %',$7[k][3];
		    IF $7[k][1]=$5[i] AND $7[k][2]=$6[j] AND $7[k][3]=1 THEN
			b_value:=TRUE;
		    ELSE 
			b_value:=FALSE;
		    END IF;
		    SELECT INTO rep_ok * FROM contraintes.af_set_question_reponse_solution($1, $5[i], $6[j], b_value);
		    IF NOT rep_ok THEN
			assos_ok:=FALSE;
		    END IF;
		    k:=k+1;
		END LOOP;
	    END IF;
	END LOOP;
    END IF;
    */

   
    RETURN maj_ok AND assos_ok_q and assos_ok_r and assos_ok_s;
end 
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 8390 (class 0 OID 0)
-- Dependencies: 1433
-- Name: FUNCTION af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) IS 'Enregistre un qrc';


--
-- TOC entry 1889 (class 1255 OID 2596291)
-- Dependencies: 2983 5
-- Name: af_maj_qrc_question_solution(integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_qrc_question_solution(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 qrc
--$2 question
--$3 array int4 : choix |  juste (0 ou 1)
i int4;
b_value bool;
ok bool;
ok2 bool;
BEGIN

	FOR i IN array_lower($3,1) .. array_upper($3,1)
	LOOP
		IF $3[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		--RAISE NOTICE 'maj: %, %, %, %==%',$1, $2, $3[i][1], b_value, $3[i][2];
		SELECT INTO ok * FROM contraintes.af_maj_question_reponse_solution($1, $2, $3[i][1], b_value);
		IF ok IS FALSE THEN
			RAISE NOTICE 'set: %, %, %, %==%',$1, $2, $3[i][1], b_value, $3[i][2];
			SELECT INTO ok2 * FROM contraintes.af_set_question_reponse_solution($1, $2, $3[i][1], b_value);
			IF ok2 IS FALSE THEN RAISE EXCEPTION 'Erreur sur l''insertion de la solution.'; END IF;
		END IF;
	END LOOP;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_qrc_question_solution(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 1434 (class 1255 OID 2596292)
-- Dependencies: 2983 5
-- Name: af_maj_qsrc(integer, character varying, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_qsrc(integer, character varying, character varying, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 qsrc
--$2 libelle
--$3 question commune
--$4 radio?
ok bool;
ok1 bool;
ams varchar;

BEGIN

	SELECT INTO ok * FROM contraintes.af_maj_evaluation($1,$2);
	SELECT INTO ams contraintes.fw_get_ams_libelle('qsrc','question','id='||$1,$3);

	UPDATE contraintes.qsrc SET question=ams WHERE id=$1; 
	ok1=FOUND;

	UPDATE contraintes.question_reponse SET radio=$4 WHERE id=$1; 

	RETURN FOUND OR ok OR ok1;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_qsrc(integer, character varying, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 1435 (class 1255 OID 2596293)
-- Dependencies: 2983 5
-- Name: af_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 qsrc
--$2 question
--$3 libelle
--$4 media
--$5 hauteur
--$6 largeur
--$7 interpretation html

ok1 bool;
ok2 bool;
rec RECORD;
maj_rec RECORD;
existe int4;
BEGIN

	--on met a jour la question 
	SELECT INTO ok1 * FROM contraintes.af_maj_question_reponse_element($2, $3, $7);
	RAISE NOTICE 'maj de la question: % % % % -->%',$1, $2, $3, $7,ok1;

	--on recupere la question (pour avaoir le champ pere)
	SELECT INTO maj_rec * 
	FROM  contraintes.question_reponse_elements
	WHERE question_reponse=$1
	AND question=$2;

	--on met a jour le media de la question de positionnement
	IF $4 IS NOT NULL THEN
		SELECT INTO ok2 * FROM contraintes.af_maj_question_reponse_element_media($1, $2, $4, $5, $6);
		IF NOT ok2 THEN
			SELECT INTO ok2 * FROM contraintes.af_set_media_question_reponse_element($1, $2, $4, $5, $6);
		END IF;
	ELSE
		PERFORM * FROM contraintes.af_del_question_reponse_element_media($1, $2);
	END IF;
	ok2:=FOUND;

	FOR rec IN
		--on selectionne les choix du question_reponse
		SELECT id FROM contraintes.choix where question_reponse=$1

	--pour chacun des choix
	LOOP
		SELECT INTO existe COUNT (*) 
		FROM contraintes.question_reponse_elements
		WHERE question_reponse=$1
		AND question=$2
		AND reponse=rec.id;

		IF existe= 0 THEN

			--on associe les elements du question reponse
			PERFORM * FROM contraintes.af_set_question_reponse_association_element($1, $2, rec.id, maj_rec.pere);

			--on enregistre l'association en tant qu'element de positionnement 
			INSERT INTO contraintes.positionnement_elements(question_reponse, question, choix)
			VALUES ($1, $2, rec.id);

		END IF;
	END LOOP;
	
	RETURN ok1 OR ok2;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1436 (class 1255 OID 2596294)
-- Dependencies: 2983 5
-- Name: af_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3 libelle
--$4 media
--$5 hauteur
--$6 largeur
--$7 interpretation html
qr int4;
ok1 bool;
ok2 bool;
rec RECORD;
maj_rec RECORD;
existe int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement
	WHERE id=$1;

	--on met a jour la question 
	SELECT INTO ok1 * FROM contraintes.af_maj_question_reponse_element($2, $3, $7);
	RAISE NOTICE 'maj de la question: % % % % -->%',qr, $2, $3, $7,ok1;

	--on recupere la question (pour avaoir le champ pere)
	SELECT INTO maj_rec * 
	FROM  contraintes.question_reponse_elements
	WHERE question_reponse=$1
	AND question=$2;

	--on met a jour le media de la question de positionnement
	IF $4 IS NOT NULL THEN
		SELECT INTO ok2 * FROM contraintes.af_maj_question_reponse_element_media(qr, $2, $4, $5, $6);
		IF NOT ok2 THEN
			SELECT INTO ok2 * FROM contraintes.af_set_media_question_reponse_element(qr, $2, $4, $5, $6);
		END IF;
	ELSE
		PERFORM * FROM contraintes.af_del_question_reponse_element_media(qr, $2);
	END IF;
	ok2:=FOUND;

	FOR rec IN
		--on selectionne les choix du positionnement
		SELECT id FROM contraintes.choix where positionnement=$1

	--pour chacun des choix
	LOOP
		SELECT INTO existe COUNT (*) 
		FROM contraintes.question_reponse_elements
		WHERE question_reponse=qr
		AND question=$2
		AND reponse=rec.id;

		IF existe= 0 THEN

			--on associe les elements du question reponse
			PERFORM * FROM contraintes.af_set_question_reponse_association_element(qr, $2, rec.id, maj_rec.pere);

			--on enregistre l'association en tant qu'element de positionnement 
			INSERT INTO contraintes.positionnement_elements(question_reponse, question, choix)
			VALUES (qr, $2, rec.id);

		END IF;
	END LOOP;
	
	RETURN ok1 OR ok2;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1437 (class 1255 OID 2596295)
-- Dependencies: 2983 5
-- Name: af_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 question_reponse
--$2 choix
--$3 nouveau choix
--$4 bareme
--$5 media
--$6 hauteur
--$7 largeur
r1 boolean;
r2 boolean;
qr int4;
BEGIN
	
	UPDATE contraintes.choix
	SET id=$3, bareme=$4
	WHERE question_reponse=$1
	AND id=$2;
	r1 := FOUND;

	IF $5 IS NOT NULL THEN
		UPDATE contraintes.media_question_reponse_element
		SET media=$5, hauteur=$6, largeur=$7
		WHERE question_reponse=$1
		AND question_reponse_element=$3;
		r2 := FOUND;
		
		IF r2!=TRUE THEN
			INSERT INTO contraintes.media_question_reponse_element (question_reponse, question_reponse_element, media, hauteur, largeur )
			VALUES ($1, $3, $5, $6, $7);
			r2 := FOUND;
		END IF;
	ELSE 
		DELETE FROM contraintes.media_question_reponse_element 
		WHERE question_reponse=$1
		AND question_reponse_element=$2;
		r2 := FOUND;
	END IF;

	RETURN r1 OR r2;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1438 (class 1255 OID 2596296)
-- Dependencies: 2983 5
-- Name: af_maj_question_reponse_element(integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_question_reponse_element(integer, character varying, boolean) RETURNS boolean
    AS $_$DECLARE
ams varchar;
BEGIN
	SELECT INTO ams contraintes.fw_get_ams_libelle('question_reponse_element','libelle','id='||$1,$2);

	UPDATE contraintes.question_reponse_element SET libelle=ams , interpretation_html=$3 WHERE id=$1;
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_question_reponse_element(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 8397 (class 0 OID 0)
-- Dependencies: 1438
-- Name: FUNCTION af_maj_question_reponse_element(integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_question_reponse_element(integer, character varying, boolean) IS 'Mise à jour d''un question_reponse_element.';


--
-- TOC entry 1439 (class 1255 OID 2596297)
-- Dependencies: 2983 5
-- Name: af_maj_question_reponse_element_media(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_question_reponse_element_media(integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE 
rec RECORD;
BEGIN

	SELECT INTO rec * from contraintes.af_get_question_reponse_element_media($1,$2) AS (question_reponse int4, question_reponse_element int4, media int4, libelle varchar, hauteur int4, largeur int4);

	IF $3 IS NULL THEN
		PERFORM * FROM contraintes.af_del_media_question_reponse_element($1,$2,$3,$4,$5);
		RAISE NOTICE 'DELETE % % % ',$1,$2,$3;
		RETURN FOUND;

	ELSEIF rec.media IS NOT NULL THEN
		UPDATE contraintes.media_question_reponse_element 
		SET media=$3, largeur=$4, hauteur=$5 WHERE question_reponse_element=$2 AND question_reponse=$1;
		RAISE NOTICE 'UPDATE % % % ',$1,$2,$3;
		RETURN FOUND;
	ELSE 
		PERFORM * FROM contraintes.af_set_media_question_reponse_element($1,$2,$3,$4,$5);
		RAISE NOTICE 'INSERT % % % ',$1,$2,$3;
		RETURN FOUND;
	END IF;
	
	RETURN FALSE;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_question_reponse_element_media(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8399 (class 0 OID 0)
-- Dependencies: 1439
-- Name: FUNCTION af_maj_question_reponse_element_media(integer, integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_question_reponse_element_media(integer, integer, integer, integer, integer) IS 'Mise à jour d''un media de question_reponse_element.';


--
-- TOC entry 1440 (class 1255 OID 2596298)
-- Dependencies: 2983 5
-- Name: af_maj_question_reponse_media(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_question_reponse_media(integer, integer, integer, integer) RETURNS boolean
    AS $_$BEGIN
	UPDATE contraintes.media_question_reponse 
	SET media=$2, largeur=$3, hauteur=$4 WHERE  question_reponse=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_question_reponse_media(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8401 (class 0 OID 0)
-- Dependencies: 1440
-- Name: FUNCTION af_maj_question_reponse_media(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_question_reponse_media(integer, integer, integer, integer) IS 'Mise à jour d''un media de question_reponse_element.';


--
-- TOC entry 1890 (class 1255 OID 2596299)
-- Dependencies: 2983 5
-- Name: af_maj_question_reponse_solution(integer, integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_question_reponse_solution(integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 question reponse(qcm)
--$2 question
--$3 reponse
--$4 juste (vrai ou faux)

BEGIN
	UPDATE contraintes.qcm_elements 
	SET juste=$4
	WHERE question_reponse=$1
	AND question=$2
	AND reponse=$3;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_question_reponse_solution(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 8403 (class 0 OID 0)
-- Dependencies: 1890
-- Name: FUNCTION af_maj_question_reponse_solution(integer, integer, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_question_reponse_solution(integer, integer, integer, boolean) IS 'Mise a jour d''une association d''element de QCM.';


--
-- TOC entry 1891 (class 1255 OID 2596300)
-- Dependencies: 2983 5
-- Name: af_maj_ressource(integer, integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_ressource(integer, integer, text) RETURNS boolean
    AS $_$-- $1 : ressource
-- $2 : fichier
-- $3 : mots cles
begin
    update contraintes.ressource set fichier=$2,mots_cles=$3
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_ressource(integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 8405 (class 0 OID 0)
-- Dependencies: 1891
-- Name: FUNCTION af_maj_ressource(integer, integer, text); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_ressource(integer, integer, text) IS 'modifie une ressource';


--
-- TOC entry 1441 (class 1255 OID 2596301)
-- Dependencies: 2983 5
-- Name: af_maj_resultat_debut(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_resultat_debut(integer) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
date_deb timestamp;
BEGIN
	SELECT INTO date_deb date_debut FROM contraintes.resultat
	WHERE id=$1;

	IF date_deb IS NULL THEN
		RAISE EXCEPTION 'Erreur: la date de début ne peut etre mise jour, elle n''a pas été affectée auparavent';
	END IF;

	UPDATE contraintes.resultat
	SET date_debut=now()
	WHERE id=$1;
	
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_resultat_debut(integer) OWNER TO pgsql;

--
-- TOC entry 1442 (class 1255 OID 2596302)
-- Dependencies: 2983 5
-- Name: af_maj_resultat_exotlc(integer, text, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_resultat_exotlc(integer, text, boolean) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : commentaire
-- $3 : correction
declare
ams varchar;
begin
    --SELECT INTO ams contraintes.fw_get_ams_libelle('resultat_exotlc','commentaire','id='||$1,$2);

    update contraintes.resultat_exotlc 
    set commentaire=$2,correction=$3,date_correction=now() 
    where id=$1;
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_resultat_exotlc(integer, text, boolean) OWNER TO pgsql;

--
-- TOC entry 8408 (class 0 OID 0)
-- Dependencies: 1442
-- Name: FUNCTION af_maj_resultat_exotlc(integer, text, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_resultat_exotlc(integer, text, boolean) IS 'met à jour les reultats pour un identifiant de resultat';


--
-- TOC entry 1443 (class 1255 OID 2596303)
-- Dependencies: 2983 5
-- Name: af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : critere
-- $3 : note
-- $4 : note_max
-- $5 : commentaire
declare
ams varchar;
begin
    --SELECT INTO ams contraintes.fw_get_ams_libelle('resultat_exotlc_critere','commentaire','id='||$1||' and critere='||$2,$5);

    update contraintes.resultat_exotlc_critere 
    set note=$3,note_max=$4,commentaire=$5 
    where id=$1 and critere=$2;
    return found;	
end; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 8410 (class 0 OID 0)
-- Dependencies: 1443
-- Name: FUNCTION af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) IS 'Modifie les resultats d''un critere pour un identifiant de resultat';


--
-- TOC entry 1444 (class 1255 OID 2596304)
-- Dependencies: 2983 5
-- Name: af_maj_resultat_exotlc_plateforme(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_resultat_exotlc_plateforme(bigint, integer) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 fichier_rendu
ok boolean;
BEGIN
	--SELECT INTO ok * FROM contraintes.af_set_resultat_fin($1);

	UPDATE contraintes.resultat_exotlc
	SET fichier_rendu=$2
	WHERE id=$1;
	
	RETURN FOUND ;--AND ok;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_resultat_exotlc_plateforme(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1445 (class 1255 OID 2596305)
-- Dependencies: 2983 5
-- Name: af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : sous critere
-- $3 : note
-- $4 : note max
begin
    update contraintes.resultat_exotlc_sous_critere 
    set note=$3,note_max=$4 
    where id=$1 and sous_critere=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8413 (class 0 OID 0)
-- Dependencies: 1445
-- Name: FUNCTION af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) IS 'modifie les resultats d''un sous critere pour un identifiant de resultat';


--
-- TOC entry 1892 (class 1255 OID 2596306)
-- Dependencies: 2983 5
-- Name: af_maj_resultat_fin(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_resultat_fin(integer) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
duree_init interval;
BEGIN
	SELECT INTO duree_init duree FROM contraintes.resultat WHERE id=$1;
	
	IF duree_init IS NULL THEN
		RAISE EXCEPTION 'Erreur: la durée doit avoir déjà été affectée pour la fin de l''étape';
	ELSE
		UPDATE contraintes.resultat
		SET duree=cast(now() AS timestamp without time zone)-date_debut+duree_init
		WHERE id=$1;

		RETURN FOUND;
		
	END IF;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_resultat_fin(integer) OWNER TO pgsql;

--
-- TOC entry 1446 (class 1255 OID 2596307)
-- Dependencies: 2983 5
-- Name: af_maj_salle(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_salle(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero salle
-- $2 : libelle
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('salle','libelle','id='||$1,$2);

    update contraintes.salle set libelle=ams where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_salle(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8416 (class 0 OID 0)
-- Dependencies: 1446
-- Name: FUNCTION af_maj_salle(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_salle(integer, character varying) IS 'met à jour une salle';


--
-- TOC entry 1447 (class 1255 OID 2596308)
-- Dependencies: 2983 5
-- Name: af_maj_section(integer, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_section(integer, character varying, integer) RETURNS boolean
    AS $_$-- $1 : numero section
-- $2 : libelle
-- $3 : numero icone
declare
ams varchar;
begin
    SELECT INTO ams contraintes.fw_get_ams_libelle('section','libelle','id='||$1,$2);

    update contraintes.section set libelle=ams,icone=$3 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_section(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 8418 (class 0 OID 0)
-- Dependencies: 1447
-- Name: FUNCTION af_maj_section(integer, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_section(integer, character varying, integer) IS 'met à jour une section';


--
-- TOC entry 1448 (class 1255 OID 2596309)
-- Dependencies: 2983 5
-- Name: af_maj_serie(integer, character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_serie(integer, character varying, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 serie
--$2 libelle
--$3 bareme
--$4 chrono
mod bool:=FALSE;
ams varchar;
BEGIN
	SELECT INTO ams contraintes.fw_get_ams_libelle('etape','libelle','id='||$1,$2);

	UPDATE contraintes.etape SET libelle=ams
	WHERE id=$1;

	mod:=FOUND;

	UPDATE contraintes.serie SET bareme=$3, chrono=$4
	WHERE id=$1;

	RETURN mod OR FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_serie(integer, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8420 (class 0 OID 0)
-- Dependencies: 1448
-- Name: FUNCTION af_maj_serie(integer, character varying, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_serie(integer, character varying, integer, integer) IS 'Mise à jour d''une série.';


--
-- TOC entry 1449 (class 1255 OID 2596310)
-- Dependencies: 2983 5
-- Name: af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : seuil
-- $5 : etape retour
-- $6 : tentative
-- $7 : correction
-- $8 : blocage parcours
begin
    update contraintes.serie_bloquante 
    set seuil=$4,etape_retour=$5,tentatives=$6,correction=$7,blocage_parcours=$8 
    where serie=$1 and formation=$2 and parcours=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) OWNER TO pgsql;

--
-- TOC entry 8422 (class 0 OID 0)
-- Dependencies: 1449
-- Name: FUNCTION af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) IS 'Met à jour la configuration d''une serie bloquante';


--
-- TOC entry 1450 (class 1255 OID 2596311)
-- Dependencies: 2983 5
-- Name: af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 serie
--$2 evaluation
--$3 pere
--$4 commentaire
--$5 bareme
--$6 chrono
--$7 point
req varchar;
cond varchar;
cond1 varchar;
cond2 varchar;
ams varchar;
BEGIN

	IF $3 IS NULL THEN
		cond:=' IS NULL';
		cond2:=' NULL';
	ELSE
		cond:=' ='||$3;
		cond2:=$3;

	END IF;

	IF $5 IS NULL THEN
		cond1:=' NULL';
	ELSE
		cond1:= $5;

	END IF;
	
	-- mise à jour du commentaire
	SELECT INTO ams contraintes.fw_get_ams_libelle('serie_evaluations','commentaire','serie='||$1||'and evaluation='||$2,$4);

	req:='UPDATE contraintes.serie_evaluations
	SET evaluation='||$2||', pere='||cond2||', points='||$7||', bareme='||cond1||', chrono='||$6||', commentaire='''||ams||'''
	WHERE serie='||$1||' AND pere '||cond;
	
	EXECUTE req;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8424 (class 0 OID 0)
-- Dependencies: 1450
-- Name: FUNCTION af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) IS 'Mise à jour d''une évaluation d''une serie.';


--
-- TOC entry 1452 (class 1255 OID 2596312)
-- Dependencies: 2983 5
-- Name: af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 serie
--$2 numero du pere
--$3 commentaire pour la correction
--$4 bareme
--$5 chrono
--$6 points
req varchar;
cond varchar;
cond1 varchar;
BEGIN


	IF $2 IS NULL THEN
		cond:=' IS NULL';
	ELSE
		cond:='='||$2;

	END IF;


	IF $4 IS NULL THEN
		cond1:=' NULL';
	ELSE
		cond1:=$4;

	END IF;

	req:='UPDATE contraintes.serie_evaluations 
	SET commentaire='''||$3||''', bareme='||cond1||', chrono='||$5||', points='||$6||'  
	WHERE serie='||$1||' AND pere '||cond||';';

	RAISE NOTICE 'req=%',req;

	EXECUTE req;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8426 (class 0 OID 0)
-- Dependencies: 1452
-- Name: FUNCTION af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) IS 'Met ajour une association d''une evaluation pour une série en fonction du numero du pere.';


--
-- TOC entry 1451 (class 1255 OID 2596313)
-- Dependencies: 2983 5
-- Name: af_maj_serie_evaluation_ordre(integer, integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_serie_evaluation_ordre(integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 serie
--$2 evaluation source
--$3 evaluation destination
pere_src int4;
pere_dst int4;
suivant_src int4;
precedent_dst int4;
tmp int4;
BEGIN

	--recup du pere de la source
	SELECT INTO pere_src pere FROM contraintes.af_get_serie_evaluation($1,$2)AS (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );

	--recup du pere de la destination
	SELECT INTO pere_dst pere FROM contraintes.af_get_serie_evaluation($1,$3)AS (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) ;

	--maj de la source (1ere etape -> petite astuce: on met le pere à l'id du dernier, (pas utilisé pour un pere) pour eviter les conflits)
	SELECT INTO tmp P.id FROM contraintes.af_gen_get_last_element('contraintes.serie_evaluations', 'evaluation',' AND serie='||$1) P;
	UPDATE contraintes.serie_evaluations SET pere=tmp WHERE serie=$1 AND evaluation=$2;

	--maj du suivant de la source
	UPDATE contraintes.serie_evaluations SET pere=pere_src WHERE serie=$1 AND pere=$2;
		
--INSERTION AVANT
IF $4 THEN

	--recup du suivant de la source
	SELECT INTO suivant_src evaluation FROM contraintes.serie_evaluations WHERE serie=$1 AND pere=$2;

	--maj de la destination
	UPDATE contraintes.serie_evaluations SET pere=$2   WHERE serie=$1 AND evaluation=$3;

	--maj de la source (2eme etape -> on met la bonne valeur au pere)
	UPDATE contraintes.serie_evaluations SET pere=pere_dst WHERE serie=$1 AND evaluation=$2; 

--INSERTION APRES
ELSE
	--maj du suivant de la destination
	UPDATE contraintes.serie_evaluations SET pere=$2   WHERE serie=$1 AND pere=$3;

	--maj de la source (2eme etape -> on met la bonne valeur au pere)
	UPDATE contraintes.serie_evaluations SET pere=$3 WHERE serie=$1 AND evaluation=$2; 
END IF;

	RETURN 't';
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_serie_evaluation_ordre(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1893 (class 1255 OID 2596314)
-- Dependencies: 2983 5
-- Name: af_maj_src(integer, character varying, character varying, boolean, integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_src(integer, character varying, character varying, boolean, integer[], integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 Identifiant du question_reponse
--$2 libelle
--$3 question commmune
--$4 radio?
--$5 questions
--$6 reponses
prec_i integer;
prec_j integer;
maj_ok boolean;
assos_ok_q boolean:=TRUE;
assos_ok_r boolean:=TRUE;
ins_ok boolean;
BEGIN
    SELECT INTO maj_ok * FROM contraintes.af_maj_qsrc($1, $2,$3,$4);
    DELETE FROM contraintes.question_reponse_elements
    WHERE question_reponse = $1;
    /*
    FOR i IN array_lower($5, 1) .. array_upper($5, 1)  
    LOOP
	IF i-1>0 THEN
	    prec_i:=$5[i-1];
	END IF;

	FOR j IN array_lower($6, 1) .. array_upper($6, 1)  
	LOOP
	    SELECT INTO ins_ok contraintes.af_set_question_reponse_association_element($1,$5[i], $6[j],prec_i);
	    IF NOT ins_ok THEN
		assos_ok:=FALSE;
	    END IF;
	END LOOP;
    END LOOP;
    */
    
    -- boucle d'enregistrement des questions
    FOR i IN array_lower($5, 1) .. array_upper($5, 1)  
    LOOP
	IF i-1>0 THEN
	    prec_i:=$5[i-1];
	END IF;
	SELECT INTO ins_ok contraintes.af_set_question_reponse_association_element($1,$5[i], prec_i);
	IF NOT ins_ok THEN
		assos_ok_q:=FALSE;
	    END IF;
    end loop;

    -- boucle d'enregistrements des reponses
    FOR j IN array_lower($6, 1) .. array_upper($6, 1)  
    LOOP
	IF j-1>0 THEN
	    prec_j:=$6[j-1];
	END IF;
	SELECT INTO ins_ok contraintes.af_set_question_reponse_association_element($1, $6[j],prec_j);
	    IF NOT ins_ok THEN
		assos_ok_r:=FALSE;
	    END IF;
	
    END LOOP;
    RETURN maj_ok AND assos_ok_q and assos_ok_r;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_src(integer, character varying, character varying, boolean, integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 1894 (class 1255 OID 2596315)
-- Dependencies: 2983 5
-- Name: af_maj_test(integer, character varying, boolean, boolean, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_test(integer, character varying, boolean, boolean, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
id_positionnement int4;
id_test int4;
oid_id int4;
BEGIN 
 ---a continuer!!
/*	INSERT INTO contraintes.etape(libelle, type) VALUES ($1, 4);
	GET DIAGNOSTICS new_id = RESULT_OID;
	
	SELECT INTO res id FROM contraintes.etape WHERE oid=new_id;
	
	INSERT INTO contraintes.liste (id, type) VALUES (res, $4);
	
	INSERT INTO contraintes.serie(id, bareme, chrono) VALUES (res, $2, $3);
	RETURN res;;

	SELECT INTO id_positionnement * FROM contraintes.af_set_positionnement($1,$2,$3,$4,$5,$6);
	
	INSERT INTO contraintes.positionnement 
	(libelle, type_question, chrono)
	VALUES ($1, $2, $6);

	GET DIAGNOSTICS oid_id = RESULT_OID;

	SELECT INTO id id FROM contraintes.positionnement WHERE oid=oid_id;

	INSERT INTO contraintes.media_positionnement 
	(positionnement, media, hauteur, largeur)
	VALUES ($3, $4, $5);


	RETURN id;*/
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_test(integer, character varying, boolean, boolean, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1453 (class 1255 OID 2596316)
-- Dependencies: 2983 5
-- Name: af_maj_theme(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_maj_theme(integer, character varying) RETURNS boolean
    AS $_$-- $1 : theme
-- $2 : libelle
declare
ams varchar;
BEGIN
	SELECT INTO ams contraintes.fw_get_ams_libelle('theme','libelle','id='||$1,$2);

	UPDATE contraintes.theme SET libelle=ams WHERE id=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_theme(integer, character varying) OWNER TO postgres;

--
-- TOC entry 8431 (class 0 OID 0)
-- Dependencies: 1453
-- Name: FUNCTION af_maj_theme(integer, character varying); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_maj_theme(integer, character varying) IS 'Mise a jour d''un theme.';


--
-- TOC entry 35 (class 1255 OID 2596317)
-- Dependencies: 2983 5
-- Name: af_maj_theme_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_maj_theme_individu(integer, integer) RETURNS boolean
    AS $_$-- $1 : theme
-- $2 : libelle

BEGIN

	UPDATE contraintes.theme SET individu=$2 WHERE id=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_maj_theme_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1454 (class 1255 OID 2596318)
-- Dependencies: 2983 5
-- Name: af_set_alerte(character varying, integer, date, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_alerte(character varying, integer, date, integer, character varying) RETURNS integer
    AS $_$-- $1 : libelle alerte (titre)
-- $2 : numero formation
-- $3 : date (timestamp)
-- $4 : nombre de jours
-- $5 : texte de l'alerte
declare
new_id int4;
res int4;
begin
    insert into contraintes.alerte(libelle,formation,date,jours,texte) values($1,$2,$3,$4,$5);
    --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.alerte WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_alerte(character varying, integer, date, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8434 (class 0 OID 0)
-- Dependencies: 1454
-- Name: FUNCTION af_set_alerte(character varying, integer, date, integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_alerte(character varying, integer, date, integer, character varying) IS 'enregistre une alerte';


--
-- TOC entry 1455 (class 1255 OID 2596319)
-- Dependencies: 2983 5
-- Name: af_set_bareme(character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_bareme(character varying, integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
new_id int4;
res int4;
BEGIN
	
	INSERT INTO contraintes.bareme(libelle, juste,fausse,manquantes,toutes) 
	VALUES($1,$2,$3,$4,$5);

	--RECUPERE L'IDENTIFIANT DE LA NOUVELLE CATEGORIE
	GET DIAGNOSTICS new_id = RESULT_OID;

	SELECT INTO res id FROM contraintes.bareme WHERE oid=new_id;

	RAISE NOTICE 'insertion du bareme d''id: % (oid=%)',res, new_id;
	RETURN res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_bareme(character varying, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8436 (class 0 OID 0)
-- Dependencies: 1455
-- Name: FUNCTION af_set_bareme(character varying, integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_bareme(character varying, integer, integer, integer, integer) IS 'Création d''un bareme';


--
-- TOC entry 1456 (class 1255 OID 2596320)
-- Dependencies: 2983 5
-- Name: af_set_capacite(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_capacite(character varying) RETURNS integer
    AS $_$-- $1 : libelle capacite
declare
new_id int4;
res int4;
begin
    insert into contraintes.capacite(libelle) values($1);
    --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.capacite WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_capacite(character varying) OWNER TO pgsql;

--
-- TOC entry 8438 (class 0 OID 0)
-- Dependencies: 1456
-- Name: FUNCTION af_set_capacite(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_capacite(character varying) IS 'enregistre une capacite';


--
-- TOC entry 1457 (class 1255 OID 2596321)
-- Dependencies: 2983 5
-- Name: af_set_capacite_titre(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_capacite_titre(character varying) RETURNS integer
    AS $_$-- $1 : libelle capacite_titre
declare
new_id int4;
res int4;
begin
    insert into contraintes.capacite_titre(libelle) values($1);
    --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.capacite_titre WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_capacite_titre(character varying) OWNER TO pgsql;

--
-- TOC entry 8440 (class 0 OID 0)
-- Dependencies: 1457
-- Name: FUNCTION af_set_capacite_titre(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_capacite_titre(character varying) IS 'enregistre un titre de capacite';


--
-- TOC entry 1458 (class 1255 OID 2596322)
-- Dependencies: 2983 5
-- Name: af_set_capacite_titre_capacite(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_capacite_titre_capacite(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
-- $2 : numero capacite
begin
    insert into contraintes.capacite_titre_capacites(capacite_titre,capacite) values($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_capacite_titre_capacite(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8442 (class 0 OID 0)
-- Dependencies: 1458
-- Name: FUNCTION af_set_capacite_titre_capacite(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_capacite_titre_capacite(integer, integer) IS 'enregistre le couple capacite_titre / capacite';


--
-- TOC entry 1895 (class 1255 OID 2596323)
-- Dependencies: 2983 5
-- Name: af_set_categorie(character varying, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_categorie(character varying, character varying, boolean) RETURNS integer
    AS $_$--$1 libÃÂ©llÃÂ© de la nouvelle catÃÂ©gorie
--$2 nom de la table associÃÂ© ou NULL si repertoire
--$3 TRUE si la catÃÂ©gorie doit apparaitre dans le gestionaire de contenu, FALSE sinon.
DECLARE
--identifiant de la nouvelle catÃÂ©gorie
new_id int4;
res int4;
--requete de creation de la table associee ÃÂ  la categorie
req_create text;
BEGIN
	--INSERE LA NOUVELLE CATEGORIE
	INSERT INTO contraintes.categorie (libelle, table_cible, gestionnaire_contenu) VALUES ($1,$2,$3); 
	--RECUPERE L'IDENTIFIANT DE LA NOUVELLE CATEGORIE
	GET DIAGNOSTICS new_id = RESULT_OID;

	IF ($2 IS NOT NULL) THEN
		--CREE LA TABLE PERMETTANT DE GERER LES CONTRAINTES SUR LE CHAMP ID DE LA TABLE THEME_CATEGORIES
		req_create:='CREATE TABLE contraintes.categorie_'|| $2  ||'
		(
		  id int4 NOT NULL,
		  categorie int4 NOT NULL,
		  theme int4 NOT NULL,
		  CONSTRAINT pk_categorie_'|| $2 ||' PRIMARY KEY (id),
		  CONSTRAINT fk_categorie_'|| $2 ||'_1 FOREIGN KEY (id, categorie, theme) REFERENCES contraintes.theme_categories (id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE,
		  CONSTRAINT fk_categorie_'|| $2 ||'_2 FOREIGN KEY (id) REFERENCES contraintes.'|| $2 ||' (id) ON UPDATE RESTRICT ON DELETE CASCADE
		) 
		WITH OIDS;
		ALTER TABLE contraintes.categorie_'|| $2 ||' OWNER TO postgres;
		GRANT ALL ON TABLE contraintes.categorie_'|| $2 ||' TO "www";
		CREATE TRIGGER del_theme_categorie
		AFTER DELETE
		ON contraintes.categorie_'|| $2 ||'
		FOR EACH ROW
		EXECUTE PROCEDURE contraintes.del_theme_categorie();';
		EXECUTE req_create;
	END IF;
	select into res id from contraintes.categorie where oid=new_id;
	RETURN res;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_categorie(character varying, character varying, boolean) OWNER TO postgres;

--
-- TOC entry 8444 (class 0 OID 0)
-- Dependencies: 1895
-- Name: FUNCTION af_set_categorie(character varying, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_categorie(character varying, character varying, boolean) IS 'Fonction qui crÃ©ee une nouvelle catÃ©gorie. 
Un enregistrement est ajoutÃ© dans la table categorie et une table nommÃ©e categorie_nomtable est crÃ©e, avec les contraintes requises.

Param1:
Libelle de la catÃ©gorie

Param2:
Nom de la table ciblÃ©e par la catÃ©gorie, NULL si pas de table.

Param3:
TRUE si la catÃ©gorie doit etre visible dans le gestionnaire de contenu, false sinon.

Retourne: le numero de la nouvelle ligne insÃ©rÃ©e dans la table catÃ©gorie.

exemple d''appel:
select  contraintes.af_set_categorie(varchar ''Positionnement'', varchar ''positionnement'' , FALSE);';


--
-- TOC entry 1896 (class 1255 OID 2596324)
-- Dependencies: 2983 5
-- Name: af_set_categorie_element_theme(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_categorie_element_theme(integer, integer, integer) RETURNS boolean
    AS $_$declare
val_theme alias for $2;
val_categorie alias for $1;
val_id alias for $3;
table_fic varchar;
req varchar;
begin

	--RAISE NOTICE 'theme= % categorie=% id=%',val_theme,val_categorie,val_id;
	--recupere la table de sa categorie
	SELECT INTO table_fic table_cible FROM contraintes.categorie 
	WHERE id=val_categorie;

	--insert dans la table principale
	insert into contraintes.theme_categories(theme,categorie,id) values(val_theme,val_categorie,val_id);

	--insert dans la table de la categorie
	req:='INSERT INTO contraintes.categorie_'||table_fic||'(id, categorie, theme) VALUES ('||val_id||','||val_categorie||','||val_theme||')';
	EXECUTE req;

	return FOUND;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_categorie_element_theme(integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 8446 (class 0 OID 0)
-- Dependencies: 1896
-- Name: FUNCTION af_set_categorie_element_theme(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_categorie_element_theme(integer, integer, integer) IS 'association theme/categorie/element';


--
-- TOC entry 1459 (class 1255 OID 2596325)
-- Dependencies: 2983 5
-- Name: af_set_categorie_fichier_glossaire_theme(character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_categorie_fichier_glossaire_theme(character varying, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle du fichier glossaire
--$2 theme
--$3 categorie
new_id int4;
BEGIN
	--cree le fichier (table pÃ¨re)
	SELECT INTO new_id * FROM contraintes.af_set_categorie_fichier_theme($1,true,$2,$3);

	--cree le fichier glossaire (table fille)
	INSERT INTO contraintes.fichier_glossaire (id,date_modification) 
	VALUES (new_id, now());

	--enregistre dans les themes (ce n'est pas fait par af_set_categorie_fichier_theme car
	--il faut inserer dans fichier_texte avant)
	PERFORM contraintes.af_set_categorie_element_theme($3, $2,new_id);
	RETURN new_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_categorie_fichier_glossaire_theme(character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8448 (class 0 OID 0)
-- Dependencies: 1459
-- Name: FUNCTION af_set_categorie_fichier_glossaire_theme(character varying, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_categorie_fichier_glossaire_theme(character varying, integer, integer) IS 'Crée un fichier glossaire et l''enregistre dans un theme et une categorie';


--
-- TOC entry 1460 (class 1255 OID 2596326)
-- Dependencies: 2983 5
-- Name: af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle du fichier texte
--$2 titre du lien
--$3 adresse du lien
--$4 description
--$5 mise en forme
--$6 connectÃ©
--$7 theme
--$8 categorie
new_id int4;
BEGIN
	--cree le fichier (table pÃ¨re)
	SELECT INTO new_id * FROM contraintes.af_set_categorie_fichier_theme($1,$6,$7,$8);

	--cree le fichier texte (table fille)
	INSERT INTO contraintes.fichier_ressource_texte (id,libelle,adresse,description,mise_en_forme) 
	VALUES (new_id, $2, $3, $4, $5);

	--enregistre dans les themes (ce n'est pas fait par af_set_categorie_fichier_theme car
	--il faut inserer dans fichier_texte avant)
	PERFORM contraintes.af_set_categorie_element_theme($8, $7,new_id);
	RETURN new_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8450 (class 0 OID 0)
-- Dependencies: 1460
-- Name: FUNCTION af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) IS 'Crée un fichier texte et l''enregistre dans un theme et une categorie';


--
-- TOC entry 1461 (class 1255 OID 2596327)
-- Dependencies: 2983 5
-- Name: af_set_categorie_fichier_theme(character varying, boolean, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_categorie_fichier_theme(character varying, boolean, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 connecte
--$3 theme
--$4 categorie
type_fic int4;
table_fic varchar;
new_id int4;
new_oid  int4;
req varchar; 
BEGIN
	--RAISE NOTICE 'theme=% categorie=%',$3,$4;
	--selectionne le type du fichier
	SELECT INTO type_fic id  FROM contraintes.fichier_type
	WHERE categorie=$4;

	--recupere la table de sa categorie
	SELECT INTO table_fic table_cible FROM contraintes.categorie 
	WHERE id=$4;	

	--enregistre le fichier dans la table principale
	INSERT INTO contraintes.fichier (libelle, connecte, "type")
	VALUES ($1, $2, type_fic);

	--recupere l'oid et le numero du nouvel enregistrement
	GET DIAGNOSTICS new_oid = RESULT_OID;
	SELECT INTO new_id id FROM contraintes.fichier WHERE oid=new_oid;

	IF $4!=26 and $4!=66 THEN
		--enregistre le fichier dans la table de sa categorie
		req:='INSERT INTO contraintes.'||table_fic||' (id) VALUES ('||new_id||')';
		--req:='INSERT INTO contraintes.fichier_'||table_fic||' (id) VALUES ('||new_id||')';
		EXECUTE req;
		RAISE NOTICE 'req=%',req;

		--enregistre dans les themes
		PERFORM contraintes.af_set_categorie_element_theme($4, $3,new_id);
	END IF;



	RETURN new_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_categorie_fichier_theme(character varying, boolean, integer, integer) OWNER TO postgres;

--
-- TOC entry 8452 (class 0 OID 0)
-- Dependencies: 1461
-- Name: FUNCTION af_set_categorie_fichier_theme(character varying, boolean, integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_categorie_fichier_theme(character varying, boolean, integer, integer) IS 'Crée un fichier 
 et l''enregistre dans un theme et une categorie';


--
-- TOC entry 1462 (class 1255 OID 2596328)
-- Dependencies: 2983 5
-- Name: af_set_categorie_sondage_element(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_categorie_sondage_element(integer, integer, integer) RETURNS boolean
    AS $_$begin
	insert into contraintes.categorie_sondage_element(id,categorie,theme) values ($1,$2,$3);
	return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_categorie_sondage_element(integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 8454 (class 0 OID 0)
-- Dependencies: 1462
-- Name: FUNCTION af_set_categorie_sondage_element(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_categorie_sondage_element(integer, integer, integer) IS 'Association sondage/categorie/theme';


--
-- TOC entry 1463 (class 1255 OID 2596329)
-- Dependencies: 2983 5
-- Name: af_set_categories_elements_theme(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_categories_elements_theme(integer) RETURNS void
    AS $_$DECLARE
--$1 le theme
rec RECORD;
req1 varchar;
req2 varchar;
BEGIN

	FOR rec IN 
		SELECT id, table_cible
		FROM contraintes.categorie WHERE --table_cible NOT IN
		--(SELECT table_etape FROM contraintes.categorie WHERE table_etape IS NOT NULL)
		--AND 
		id !=28 AND id!=29 AND id!=43
		ORDER BY id
	LOOP
		req1:='INSERT INTO contraintes.theme_categories
		(id, categorie, theme) SELECT id,'||rec.id||','||$1||
		' FROM contraintes.'||rec.table_cible||'';
		EXECUTE req1;

		req2:='INSERT INTO contraintes.categorie_'||rec.table_cible||'
		(id, categorie, theme) SELECT id,'||rec.id||','||$1||
		' FROM contraintes.'||rec.table_cible||'';
		EXECUTE req2;
		RAISE NOTICE 'CATEGORIE %: ajoutee AU theme %',rec.id,$1;
	END LOOP;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_categories_elements_theme(integer) OWNER TO pgsql;

--
-- TOC entry 1464 (class 1255 OID 2596330)
-- Dependencies: 2983 5
-- Name: af_set_classe(character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_classe(character varying, integer, integer, integer) RETURNS integer
    AS $_$-- $1 nom de la classe
-- $2 n° pere (null si racine)
-- $3 nombre de places min
-- $4 nombre de places max
declare
req varchar;
new_id int4;
res int4;
begin
    -- test doublon
    --req:='select * from contraintes.classe where lower(libelle) like lower('||$1||') and ';
    if $2 is null then
	--req:=req || ' pere is null';
	perform * from contraintes.classe where lower(libelle) like lower($1) and pere is null;
    else
	--req:=req || ' pere='||$2;
	perform * from contraintes.classe where lower(libelle) like lower($1) and pere =$2;
    end if;
    --execute req;
    if not found then
	insert into contraintes.classe(libelle,pere,min,max) values($1,$2,$3,$4);
	get diagnostics new_id=result_oid;
	SELECT INTO res id FROM contraintes.classe WHERE oid=new_id;

    else
	raise exception 'ce nom existe déjà !';
	res=0;
    end if;

    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_classe(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8457 (class 0 OID 0)
-- Dependencies: 1464
-- Name: FUNCTION af_set_classe(character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_classe(character varying, integer, integer, integer) IS 'enregistre une classe';


--
-- TOC entry 1465 (class 1255 OID 2596331)
-- Dependencies: 2983 5
-- Name: af_set_classe_droit(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_classe_droit(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero clase
-- $2 : numero droit
declare
rec contraintes.organisme_type_individu;
ret bool;
begin
    -- boucle sur les individu de la classe
    for rec in
	select * from contraintes.af_get_classe_individus($1,0,'desc',false) 
    loop
	-- insertion droit si l'individu ne le possède pas
	select into ret * from contraintes.af_is_individu_droit_classe(rec.id,$1,$2);
	
	if ret is false then
		
	    perform * from contraintes.af_set_individu_droit_classe(rec.id,$1,$2);
	end if;
    end loop;
    return found;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_classe_droit(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8459 (class 0 OID 0)
-- Dependencies: 1465
-- Name: FUNCTION af_set_classe_droit(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_classe_droit(integer, integer) IS 'enregistre un droit pour une classe';


--
-- TOC entry 1897 (class 1255 OID 2596332)
-- Dependencies: 2983 5
-- Name: af_set_classe_individu(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_classe_individu(integer, integer) RETURNS boolean
    AS $_$-- $1 n°classe
-- $2 n° individu
declare

begin
    insert into contraintes.classe_individus(classe,individu) values($1,$2);
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_classe_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8461 (class 0 OID 0)
-- Dependencies: 1897
-- Name: FUNCTION af_set_classe_individu(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_classe_individu(integer, integer) IS 'affilie un individu à une classe';


--
-- TOC entry 1466 (class 1255 OID 2596333)
-- Dependencies: 2983 5
-- Name: af_set_classe_individu(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_classe_individu() RETURNS boolean
    AS $_$-- $1 n°classe
-- $2 n° individu
declare

begin
    insert into contraintes.classe_individus(classe,individu) values($1,$2);
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_classe_individu() OWNER TO pgsql;

--
-- TOC entry 1467 (class 1255 OID 2596334)
-- Dependencies: 2983 5
-- Name: af_set_commentaire(integer, integer, integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_commentaire(integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : numero etape
-- $2 : min
-- $3 : max
-- $4 : commentaire
begin
    insert into contraintes.commentaire_etape(etape,min,max,commentaire) values($1,$2,$3,$4);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_commentaire(integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 8464 (class 0 OID 0)
-- Dependencies: 1467
-- Name: FUNCTION af_set_commentaire(integer, integer, integer, text); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_commentaire(integer, integer, integer, text) IS 'enregistre un commentaire';


--
-- TOC entry 1468 (class 1255 OID 2596335)
-- Dependencies: 2983 5
-- Name: af_set_critere(character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_critere(character varying, integer) RETURNS integer
    AS $_$-- $1 : libelle
-- $2 : pere

declare
new_id int4;
res int4;
begin
    insert into contraintes.critere(libelle,pere) values($1,$2);
    --RECUPERE L'IDENTIFIANT DU NOUVEAU CRITERE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.critere WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_critere(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 8466 (class 0 OID 0)
-- Dependencies: 1468
-- Name: FUNCTION af_set_critere(character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_critere(character varying, integer) IS 'enregistre un critere de correction';


--
-- TOC entry 1469 (class 1255 OID 2596336)
-- Dependencies: 2983 5
-- Name: af_set_espace(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_espace(character varying) RETURNS integer
    AS $_$-- $1 : libelle
declare
new_id int4;
res int4;
begin
    insert into contraintes.espace(libelle) values($1);
    --RECUPERE L'IDENTIFIANT DU NOUVEL ESPACE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.espace WHERE oid=new_id;
    -- RAISE NOTICE 'insertion du bareme d''id: % (oid=%)',res, new_id;
    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_espace(character varying) OWNER TO pgsql;

--
-- TOC entry 8468 (class 0 OID 0)
-- Dependencies: 1469
-- Name: FUNCTION af_set_espace(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_espace(character varying) IS 'enregistre un nouvel espace';


--
-- TOC entry 1470 (class 1255 OID 2596337)
-- Dependencies: 2983 5
-- Name: af_set_etape(character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_etape(character varying, integer) RETURNS integer
    AS $_$declare
	titre alias for $1;
	typ alias for $2;
	new_id int4;
	res int4;
begin
	insert into contraintes.etape(libelle,type) values($1,$2);
	GET DIAGNOSTICS new_id = RESULT_OID;
	select into res id from contraintes.etape where oid=new_id;
	
	return res;

	

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_etape(character varying, integer) OWNER TO postgres;

--
-- TOC entry 8470 (class 0 OID 0)
-- Dependencies: 1470
-- Name: FUNCTION af_set_etape(character varying, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_etape(character varying, integer) IS 'crÃ©e une etape';


--
-- TOC entry 1471 (class 1255 OID 2596338)
-- Dependencies: 2983 5
-- Name: af_set_etape_chat(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_etape_chat(character varying) RETURNS integer
    AS $_$-- $1 : libelle
declare
res int4;
new_id oid;
begin
    -- etape
    insert into contraintes.etape(libelle, type) VALUES ($1, 8);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.etape WHERE oid=new_id;
    -- etape chat
    insert INTO contraintes.etape_chat(id) VALUES (res);

    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_etape_chat(character varying) OWNER TO pgsql;

--
-- TOC entry 8472 (class 0 OID 0)
-- Dependencies: 1471
-- Name: FUNCTION af_set_etape_chat(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_etape_chat(character varying) IS 'enregistre une etape chat';


--
-- TOC entry 1472 (class 1255 OID 2596339)
-- Dependencies: 2983 5
-- Name: af_set_etape_forum(character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_etape_forum(character varying, integer) RETURNS integer
    AS $_$-- $1 : libelle
-- $2 : forum
declare
res int4;
new_id oid;
begin
    -- etape
    insert into contraintes.etape(libelle, type) VALUES ($1, 2);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.etape WHERE oid=new_id;
    -- etape forum
    insert INTO contraintes.etape_forum(id,forum) VALUES (res,$2);

	RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_etape_forum(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 8474 (class 0 OID 0)
-- Dependencies: 1472
-- Name: FUNCTION af_set_etape_forum(character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_etape_forum(character varying, integer) IS 'Enregistre une etape forum';


--
-- TOC entry 1473 (class 1255 OID 2596340)
-- Dependencies: 2983 5
-- Name: af_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 etape
--$2 types
--$3 seuils
--$4 sous parcours
BEGIN
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 1474 (class 1255 OID 2596341)
-- Dependencies: 2983 5
-- Name: af_set_etape_ressource(character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_etape_ressource(character varying, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 fichier ressource
--$3 espace
--$4 section
res int4;
new_id oid;
BEGIN
	-- insertion dans etape
	INSERT INTO contraintes.etape(libelle, type) VALUES ($1, 7);
	GET DIAGNOSTICS new_id = RESULT_OID;
	SELECT INTO res id FROM contraintes.etape WHERE oid=new_id;

	-- insertion dans etape_ressource
	INSERT INTO contraintes.etape_ressource(id,fichier,espace,section) VALUES (res,$2,$3,$4);

	RETURN res;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_etape_ressource(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1898 (class 1255 OID 2596342)
-- Dependencies: 2983 5
-- Name: af_set_evaluation(character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_evaluation(character varying, integer) RETURNS integer
    AS $_$DECLARE
val_libelle ALIAS FOR $1;
val_type ALIAS FOR $2;
new_id int4;
res int4;
BEGIN
	
	insert into contraintes.evaluation(libelle, "type") VALUES(val_libelle, val_type);

	--RECUPERE L'IDENTIFIANT DE LA NOUVELLE CATEGORIE
	GET DIAGNOSTICS new_id = RESULT_OID;

	select into res id from contraintes.evaluation where oid=new_id;
	return res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_evaluation(character varying, integer) OWNER TO postgres;

--
-- TOC entry 8478 (class 0 OID 0)
-- Dependencies: 1898
-- Name: FUNCTION af_set_evaluation(character varying, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_evaluation(character varying, integer) IS 'FONCTION PRIVEE: creer une nouvelle evaluation. retourne le numero de la nouvelle evaluation.';


--
-- TOC entry 1475 (class 1255 OID 2596343)
-- Dependencies: 2983 5
-- Name: af_set_exotlc_corrections(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_exotlc_corrections(integer, integer[]) RETURNS integer
    AS $_$-- $1 : numero exotlc
-- $2 : tableau de fichiers correction
declare
i int4;
nb int4 :=0;
begin
    for i in array_lower($2,1) .. array_upper($2,1)
loop
    insert into contraintes.exotlc_corrections(exotlc,correction) 
    values($1,$2[i]);
    if found then
	nb:=nb+1;
    end if;
end loop;
return nb;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_exotlc_corrections(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 8480 (class 0 OID 0)
-- Dependencies: 1475
-- Name: FUNCTION af_set_exotlc_corrections(integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_exotlc_corrections(integer, integer[]) IS 'enregistre les fichiers correzction pour un exotlc';


--
-- TOC entry 1476 (class 1255 OID 2596344)
-- Dependencies: 2983 5
-- Name: af_set_exotlc_fichiers(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_exotlc_fichiers(integer, integer[]) RETURNS integer
    AS $_$-- $1 : numero exotlc
-- $2 : tableau de fichiers
declare
i int4;
nb int4 :=0;
begin
    for i in array_lower($2,1) .. array_upper($2,1)
loop
    insert into contraintes.exotlc_fichiers(exotlc,fichier) 
    values($1,$2[i]);
    if found then
	nb:=nb+1;
    end if;
end loop;
return nb;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_exotlc_fichiers(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 8482 (class 0 OID 0)
-- Dependencies: 1476
-- Name: FUNCTION af_set_exotlc_fichiers(integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_exotlc_fichiers(integer, integer[]) IS 'enregistre les fichiers pour un exotlc';


--
-- TOC entry 1477 (class 1255 OID 2596345)
-- Dependencies: 2983 5
-- Name: af_set_exotlc_fichiers_all(integer, integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_exotlc_fichiers_all(integer, integer[], integer[]) RETURNS boolean
    AS $_$-- $1 : numero exotlc
-- $2 : tableau des fichiers exotlc
-- $3 : tableau des fichiers correction
declare
nb_fichier_exotlc int4;
nb_fichier_correction int4;
begin
    select into nb_fichier_exotlc * from contraintes.af_set_exotlc_fichiers($1,$2);
    select into nb_fichier_correction * from contraintes.af_set_exotlc_corrections($1,$3);
    return (nb_fichier_exotlc>0 and nb_fichier_correction>0);
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_exotlc_fichiers_all(integer, integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 8484 (class 0 OID 0)
-- Dependencies: 1477
-- Name: FUNCTION af_set_exotlc_fichiers_all(integer, integer[], integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_exotlc_fichiers_all(integer, integer[], integer[]) IS 'enregistre les fichiers exotlc et fichiers correction pour un exotlc';


--
-- TOC entry 1478 (class 1255 OID 2596346)
-- Dependencies: 2983 5
-- Name: af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) RETURNS integer
    AS $_$-- $1 : titre exo
-- $2 : commentaire
-- $3 : texte
-- $4 : enonce
-- $5 : remarque
-- $6 : numero formateur
declare
new_id int4;
res int4;
begin
    INSERT INTO contraintes.etape(libelle, type) VALUES ($1, 5);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.etape WHERE oid=new_id;
    -- insertion ds exotlc
    insert into contraintes.exotlc(id,commentaire,texte,enonce,remarque,type) 
    values(res,$2,$3,$4,$5,2);
    -- insertion fichier rendu
    insert into contraintes.exotlc_mail(id,formateur) values(res,$6);
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 8486 (class 0 OID 0)
-- Dependencies: 1478
-- Name: FUNCTION af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) IS 'enregistre un exotlc mail';


--
-- TOC entry 1479 (class 1255 OID 2596347)
-- Dependencies: 2983 5
-- Name: af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean) RETURNS integer
    AS $_$-- $1 : titre exo
-- $2 : commentaire
-- $3 : texte
-- $4 : ennoce
-- $5 : remarque
-- $6 : nom fichier rendu
-- $7 : autocorrection
declare
new_id int4;
res int4;
begin
    INSERT INTO contraintes.etape(libelle, type) VALUES ($1, 5);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.etape WHERE oid=new_id;
    -- insertion ds exotlc
    insert into contraintes.exotlc(id,commentaire,texte,enonce,remarque,type) 
    values(res,$2,$3,$4,$5,1);
    -- insertion fichier rendu
    insert into contraintes.exotlc_plate_forme(id,fichier_rendu,autocorrection) values(res,$6,$7);
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 8488 (class 0 OID 0)
-- Dependencies: 1479
-- Name: FUNCTION af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean) IS 'enregistre un exotlc plateforme';


--
-- TOC entry 1480 (class 1255 OID 2596348)
-- Dependencies: 2983 5
-- Name: af_set_fichier(character varying, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_fichier(character varying, integer, boolean) RETURNS integer
    AS $_$DECLARE
--$1 libelle du fichier
--$2 type
--$3 connecte
new_oid oid;
new_id integer;
BEGIN
	--enregistre le fichier dans la table principale
	INSERT INTO contraintes.fichier (libelle,type,connecte)
	VALUES ($1, $2, $3);

	--recupere l'oid et le numero du nouvel enregistrement
	GET DIAGNOSTICS new_oid = RESULT_OID;
	SELECT INTO new_id id FROM contraintes.fichier WHERE oid=new_oid;

	RETURN new_id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_fichier(character varying, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 1481 (class 1255 OID 2596349)
-- Dependencies: 2983 5
-- Name: af_set_fichier_icone(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_fichier_icone(character varying) RETURNS integer
    AS $_$-- $1 : libelle fichier
declare
new_id integer;
begin
    -- enregistre dans la table principale (fichier)
    select into new_id * from contraintes.af_set_fichier($1,6,false);
    -- enregistre dans la table fichier_icone
    insert into contraintes.fichier_icone(id) values(new_id);
    return new_id;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_fichier_icone(character varying) OWNER TO pgsql;

--
-- TOC entry 8491 (class 0 OID 0)
-- Dependencies: 1481
-- Name: FUNCTION af_set_fichier_icone(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_fichier_icone(character varying) IS 'Enregistre un fichier icone';


--
-- TOC entry 1482 (class 1255 OID 2596350)
-- Dependencies: 2983 5
-- Name: af_set_fichier_metadata(integer, text, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_fichier_metadata(integer, text, integer) RETURNS boolean
    AS $_$DECLARE
--$1 fichier
--$2 mots clés
--$3 individu proprietaite
ams varchar;
BEGIN
	PERFORM id FROM contraintes.fichier_metadata
	WHERE id=$1;

	IF FOUND THEN
		SELECT INTO ams contraintes.fw_get_ams_libelle('fichier_metadata','mots_cles','id='||$1,$2);

		UPDATE contraintes.fichier_metadata SET mots_cles=ams, individu=$3
		--WHERE individu=$1 ;
		where id=$1;
	ELSE
		INSERT INTO contraintes.fichier_metadata (id, mots_cles, individu) values($1,$2,$3);
	END IF;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_fichier_metadata(integer, text, integer) OWNER TO pgsql;

--
-- TOC entry 36 (class 1255 OID 2596351)
-- Dependencies: 2983 5
-- Name: af_set_fichier_photo(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_fichier_photo(character varying) RETURNS integer
    AS $_$DECLARE
--$1 nom fichier photo
fic_id integer;
BEGIN
	select INTO fic_id * from contraintes.af_set_fichier($1,4,TRUE);
	INSERT INTO contraintes.fichier_photo (id) VALUES (fic_id);

	RETURN fic_id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_fichier_photo(character varying) OWNER TO pgsql;

--
-- TOC entry 1483 (class 1255 OID 2596352)
-- Dependencies: 2983 5
-- Name: af_set_fichier_scenario_dynamique(character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_fichier_scenario_dynamique(character varying, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 style
new_oid OID ;
new_id integer;
BEGIN
	INSERT INTO contraintes.fichier (libelle,type)
	VALUES ($1,15);

	GET DIAGNOSTICS new_oid = RESULT_OID;
	SELECT INTO new_id id FROM contraintes.fichier WHERE oid=new_oid;

	--INSERT INTO contraintes.fichier_scenario (id)
	---VALUES (new_id);
	
	INSERT INTO contraintes.fichier_scenario_dynamique (id,style)
	VALUES (new_id,$2);
	RETURN new_id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_fichier_scenario_dynamique(character varying, integer) OWNER TO postgres;

--
-- TOC entry 1484 (class 1255 OID 2596353)
-- Dependencies: 2983 5
-- Name: af_set_fichier_scenario_dynamique_bloc(integer, integer, integer, text[], text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_fichier_scenario_dynamique_bloc(integer, integer, integer, text[], text) RETURNS boolean
    AS $_$DECLARE
--$1 scenario
--$2 bloc
--$3 ordre
--$4 bloc_vars_keys
--$5 bloc_vars_values
ams varchar;
BEGIN

	PERFORM * FROM contraintes.fichier_scenario_dynamique_blocs
	WHERE id=$1
	AND ordre=$3;

	IF NOT FOUND THEN
		INSERT INTO contraintes.fichier_scenario_dynamique_blocs
		(id, fichier_bloc_scenario, ordre,bloc_vars_keys,bloc_vars_values)
		VALUES($1,$2,$3,$4,$5);
	ELSE
		SELECT INTO ams contraintes.fw_get_ams_libelle('fichier_scenario_dynamique_blocs','bloc_vars_values','id='||$1||' and ordre='||$3,$5);
		raise notice 'ams=%',ams;
		UPDATE contraintes.fichier_scenario_dynamique_blocs
		SET fichier_bloc_scenario=$2, bloc_vars_keys=$4,bloc_vars_values=ams
		WHERE id=$1
		AND ordre=$3;
	END IF;

	RETURN FOUND;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_fichier_scenario_dynamique_bloc(integer, integer, integer, text[], text) OWNER TO pgsql;

--
-- TOC entry 1485 (class 1255 OID 2596354)
-- Dependencies: 2983 5
-- Name: af_set_filiere(character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_filiere(character varying, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 pere
new_id int4;
new_oid int4;
BEGIN
	INSERT INTO contraintes.filiere (libelle, pere) VALUES ($1,$2);
	GET DIAGNOSTICS new_oid = RESULT_OID;
	SELECT INTO new_id id FROM contraintes.filiere WHERE oid=new_oid;
	RETURN new_id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_filiere(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1486 (class 1255 OID 2596355)
-- Dependencies: 2983 5
-- Name: af_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle de la formation
--$2 date de debut
--$3 date de fin
--$4 classe virtuelle
--$5 formateur
--$6 parcours
--$7 langue par defaut
--$8 langues disponibles en front office
new_id int4;
res int4;
i int4;
ok1 bool;
ok2 bool;
fusion bool:=false;
BEGIN
	--CREATION DE LA FORMATION
	INSERT INTO contraintes.formation(libelle, parcours, date_debut, date_fin, langue)
	VALUES($1, $6, $2, $3, $7);
	--recupere l'identifiant
	GET DIAGNOSTICS new_id = RESULT_OID;
	SELECT INTO res id FROM contraintes.formation WHERE oid=new_id;
	
	--ASSOCIATION DU GROUPE ET DU FORMATEUR
	SELECT INTO ok1 * FROM contraintes.af_set_formation_participants(res, $5, $4);
	IF NOT ok1 THEN
		RAISE EXCEPTION 'Les participants n''ont pu etre ajouté lors de la création de la formation.';
	END IF;

	--LANGUES DE LA FORMATION EN FRONT OFFICE
	if array_upper($8,1)>0 then
	FOR i IN array_lower($8, 1) .. array_upper($8, 1) 
	LOOP
		SELECT INTO ok2 *  FROM contraintes.af_set_formation_langue(res,$8[i]);
		IF NOT ok2 THEN
			RAISE EXCEPTION 'Les langues n''ont pu etre ajouté lors de la création de la formation.';
		END IF;
	END LOOP;
	end if; 

	return res;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 1899 (class 1255 OID 2596356)
-- Dependencies: 2983 5
-- Name: af_set_formation_droit(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_formation_droit(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero formation
-- $2 : numero droit
begin
    insert into contraintes.formateur_droits(formation,droit) values($1,$2);
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_formation_droit(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8499 (class 0 OID 0)
-- Dependencies: 1899
-- Name: FUNCTION af_set_formation_droit(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_formation_droit(integer, integer) IS 'ajoute un droit à une formation';


--
-- TOC entry 1900 (class 1255 OID 2596357)
-- Dependencies: 2983 5
-- Name: af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : libelle
-- $3 : date
-- $4 : duree
-- $5 : modalite
-- $6 : intervention
-- $7 : intervenant
-- $8 : salle
begin
    insert into contraintes.evenement(formation,libelle,date,duree,modalite,intervention,intervenant,salle) 
    values($1,$2,$3,$4,$5,$6,$7,$8);
    if $5=3 then
	insert into contraintes.evenement_presentiel(formation,date) 
	values($1,$3);
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8501 (class 0 OID 0)
-- Dependencies: 1900
-- Name: FUNCTION af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) IS 'enregistre un evenement de formation';


--
-- TOC entry 1487 (class 1255 OID 2596358)
-- Dependencies: 2983 5
-- Name: af_set_formation_forum(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_formation_forum(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : forum
begin
    insert into contraintes.formation_forums(formation,forum) 
    values($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_formation_forum(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8503 (class 0 OID 0)
-- Dependencies: 1487
-- Name: FUNCTION af_set_formation_forum(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_formation_forum(integer, integer) IS 'associer un forum à une formation';


--
-- TOC entry 1488 (class 1255 OID 2596359)
-- Dependencies: 2983 5
-- Name: af_set_formation_langue(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_formation_langue(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 formation
--$2 langue
BEGIN
	INSERT INTO contraintes.formation_langues
	(formation, langue) VALUES
	($1, $2);

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_formation_langue(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1489 (class 1255 OID 2596360)
-- Dependencies: 2983 5
-- Name: af_set_formation_participants(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_formation_participants(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 formation
--$2 formateur
--$3 classe
BEGIN
	INSERT INTO contraintes.formation_participants
	(formation, formateur, classe) VALUES
	($1, $2, $3);

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_formation_participants(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1490 (class 1255 OID 2596361)
-- Dependencies: 2983 5
-- Name: af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : fichier_ressource
-- $3 : debut
-- $4 : fin
-- $5 : duree
-- $6 : espace
-- $7 : section
declare

begin
    -- test existence (formation,ressource,espace,section)
    perform * from contraintes.formation_ressources where formation=$1 and fichier_ressource=$2 and espace=$6 and section=$7;
    if found then
	update contraintes.formation_ressources 
	set debut_disponibilite=$3,fin_disponibilite=$4,duree_nouveaute=$5 
	where formation=$1 and fichier_ressource=$2 and espace=$6 and section=$7;
    else
	insert into contraintes.formation_ressources(formation,fichier_ressource,debut_disponibilite,fin_disponibilite,duree_nouveaute,espace,section) 
	values($1,$2,$3,$4,$5,$6,$7);
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8507 (class 0 OID 0)
-- Dependencies: 1490
-- Name: FUNCTION af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer) IS 'associe une ressource à une formation';


--
-- TOC entry 1491 (class 1255 OID 2596362)
-- Dependencies: 2983 5
-- Name: af_set_formation_session(integer, time without time zone, time without time zone); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_formation_session(integer, time without time zone, time without time zone) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : durée d'inactivité
-- $3 : durée session
begin
    delete from contraintes.formation_session where formation=$1;	
    insert into contraintes.formation_session(formation,inactivite,duree_session) 
    values($1,$2,$3);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_formation_session(integer, time without time zone, time without time zone) OWNER TO pgsql;

--
-- TOC entry 8509 (class 0 OID 0)
-- Dependencies: 1491
-- Name: FUNCTION af_set_formation_session(integer, time without time zone, time without time zone); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_formation_session(integer, time without time zone, time without time zone) IS 'enregistre les temps d''inactivité et de session pour une formation';


--
-- TOC entry 1492 (class 1255 OID 2596363)
-- Dependencies: 2983 5
-- Name: af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) RETURNS integer
    AS $_$-- $1 : libelle forum
-- $2 : description
-- $3 : upload
-- $4 : theme
-- $5 : arbo par page
-- $6 : msg par page
-- $7 : configuration
declare
new_id int4;
res int4;
begin
    insert into contraintes.forum (libelle,description ,  moderation ,  moderateur_pwd ,fils,messages ,upload ,theme) 
    values($1,$2,false,'',$5,$6,$3,$4);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.forum WHERE oid=new_id;
    -- environnement (configuration)
    insert into contraintes.forum_environnements(forum,environnement) values(res,$7);
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8511 (class 0 OID 0)
-- Dependencies: 1492
-- Name: FUNCTION af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) IS 'enregistre un forum';


--
-- TOC entry 1493 (class 1255 OID 2596364)
-- Dependencies: 2983 5
-- Name: af_set_ftb(text, boolean, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_ftb(text, boolean, boolean) RETURNS integer
    AS $_$declare
new_id int4;
res int4;
begin
	select into new_id * from contraintes.af_set_evaluation($1,3);
	insert into contraintes.ftb(id,text,voir_mots,interpretation_html) values(new_id,$1,$2,$3);
	
	return new_id;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_ftb(text, boolean, boolean) OWNER TO pgsql;

--
-- TOC entry 8513 (class 0 OID 0)
-- Dependencies: 1493
-- Name: FUNCTION af_set_ftb(text, boolean, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_ftb(text, boolean, boolean) IS 'enregistre un "remplir les blancs"';


--
-- TOC entry 37 (class 1255 OID 2596365)
-- Dependencies: 2983 5
-- Name: af_set_glossaire(character varying); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_glossaire(character varying) RETURNS integer
    AS $_$-- $1 : libelle
declare
new_id integer;
res integer;
begin
    insert into contraintes.glossaire(libelle) values($1);
    -- recup id
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.glossaire WHERE oid=new_id;
    return res;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_glossaire(character varying) OWNER TO postgres;

--
-- TOC entry 8515 (class 0 OID 0)
-- Dependencies: 37
-- Name: FUNCTION af_set_glossaire(character varying); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_glossaire(character varying) IS 'enregistre un glossaire';


--
-- TOC entry 38 (class 1255 OID 2596366)
-- Dependencies: 2983 5
-- Name: af_set_glossaire_fichier(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_glossaire_fichier(integer, integer) RETURNS boolean
    AS $_$-- $1 : glossaire
-- $2 : fichier
begin
    insert into contraintes.glossaire_fichiers(id,fichier) values($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_glossaire_fichier(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8517 (class 0 OID 0)
-- Dependencies: 38
-- Name: FUNCTION af_set_glossaire_fichier(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_glossaire_fichier(integer, integer) IS 'associe un glossaire à un fichier';


--
-- TOC entry 1494 (class 1255 OID 2596367)
-- Dependencies: 2983 5
-- Name: af_set_grille(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_grille(character varying) RETURNS integer
    AS $_$-- $1 : libelle grille
declare
new_id int4;
res int4;
begin
    insert into contraintes.grille(libelle) values($1);
     --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.grille WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_grille(character varying) OWNER TO pgsql;

--
-- TOC entry 8519 (class 0 OID 0)
-- Dependencies: 1494
-- Name: FUNCTION af_set_grille(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_grille(character varying) IS 'enregistre une grille';


--
-- TOC entry 1495 (class 1255 OID 2596368)
-- Dependencies: 2983 5
-- Name: af_set_grille_capacite_titre(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_grille_capacite_titre(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero grille
-- $2 : numero capacite_titre
begin
    insert into contraintes.grille_capacites_titres(grille,capacite_titre) values($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_grille_capacite_titre(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8521 (class 0 OID 0)
-- Dependencies: 1495
-- Name: FUNCTION af_set_grille_capacite_titre(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_grille_capacite_titre(integer, integer) IS 'enregistre le couple grille / capacite_titre';


--
-- TOC entry 1496 (class 1255 OID 2596369)
-- Dependencies: 2983 5
-- Name: af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) RETURNS integer
    AS $_$declare
new_id int4;
res int4;
i int4;
begin
    insert into 
    contraintes.fw_individu(identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo) 
    values($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14);
    -- recup id
    GET DIAGNOSTICS new_id=RESULT_OID;
    select into res id from contraintes.fw_individu 
    where oid=new_id;
    -- insertion type (formateur,utilisateur ...)
    if $15 is not null then
    for i in array_lower($15,1)..array_upper($15,1)
	loop
	perform * from contraintes.af_set_individu_type(res,$15[i]);
	end loop;
    end if;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 8523 (class 0 OID 0)
-- Dependencies: 1496
-- Name: FUNCTION af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) IS 'enregistre un individu';


--
-- TOC entry 1497 (class 1255 OID 2596370)
-- Dependencies: 2983 5
-- Name: af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) RETURNS boolean
    AS $_$-- $1 : individu
-- $2 : date connexion (int4)
-- $3 : date deconnexion (int4)
-- $4 : ip
begin
    insert into contraintes.connexion(individu,connexion,deconnexion,ip) values($1,$2,$2,$4);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) OWNER TO pgsql;

--
-- TOC entry 8525 (class 0 OID 0)
-- Dependencies: 1497
-- Name: FUNCTION af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) IS 'enregistre les dates  connexion et deconnexion pour un individu';


--
-- TOC entry 1498 (class 1255 OID 2596371)
-- Dependencies: 2983 5
-- Name: af_set_individu_droit_classe(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_individu_droit_classe(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero individu
-- $2 : numero classe
-- $3 : numero droit
begin
    insert into contraintes.individu_droits(individu,classe,droit) values ($1,$2,$3);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_individu_droit_classe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8527 (class 0 OID 0)
-- Dependencies: 1498
-- Name: FUNCTION af_set_individu_droit_classe(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_individu_droit_classe(integer, integer, integer) IS 'enregistre un droit pour un individu et une classe';


--
-- TOC entry 1499 (class 1255 OID 2596372)
-- Dependencies: 2983 5
-- Name: af_set_individu_droits_classe(integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_individu_droits_classe(integer, integer, integer[]) RETURNS boolean
    AS $_$-- $1 n° individu
-- $2 n° classe
-- $3 tableau de droits
declare
i int4;
begin
    for i in array_lower($3,1) .. array_upper($3,1)
loop
    insert into contraintes.individu_droits(individu,classe,droit) values ($1,$2,$3[i]);
end loop;
return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_individu_droits_classe(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 8529 (class 0 OID 0)
-- Dependencies: 1499
-- Name: FUNCTION af_set_individu_droits_classe(integer, integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_individu_droits_classe(integer, integer, integer[]) IS 'enregistre les droits pour un individu et une classe';


--
-- TOC entry 1500 (class 1255 OID 2596373)
-- Dependencies: 2983 5
-- Name: af_set_individu_session(integer, character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_individu_session(integer, character varying, integer) RETURNS boolean
    AS $_$-- $1 : individu
-- $2 : id session
-- $3 : formation
begin
    insert into contraintes.session (individu,session,formation) values($1,$2,$3);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_individu_session(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 8531 (class 0 OID 0)
-- Dependencies: 1500
-- Name: FUNCTION af_set_individu_session(integer, character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_individu_session(integer, character varying, integer) IS 'enregistre la session pour un individu';


--
-- TOC entry 1501 (class 1255 OID 2596374)
-- Dependencies: 2983 5
-- Name: af_set_individu_type(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_individu_type(integer, integer) RETURNS boolean
    AS $_$begin
    insert into contraintes.fw_individu_types(individu,"type") values($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_individu_type(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8533 (class 0 OID 0)
-- Dependencies: 1501
-- Name: FUNCTION af_set_individu_type(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_individu_type(integer, integer) IS 'enregistre un type (formateur,utilisateur,intervenant...) pour un individu';


--
-- TOC entry 1502 (class 1255 OID 2596375)
-- Dependencies: 2983 5
-- Name: af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) RETURNS integer
    AS $_$declare
new_id int4;
res int4;
i int4;
begin
    insert into 
    contraintes.inscription(identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo) 
    values($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14);
    -- recup id
    GET DIAGNOSTICS new_id=RESULT_OID;
    select into res id from contraintes.inscription
    where oid=new_id;
    
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8535 (class 0 OID 0)
-- Dependencies: 1502
-- Name: FUNCTION af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) IS 'enregistre un individu';


--
-- TOC entry 39 (class 1255 OID 2596376)
-- Dependencies: 2983 5
-- Name: af_set_inscriptions(integer, character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_inscriptions(integer, character varying, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 nombre d'inscriptions
--$2 base de libelle pour le login
--$3 langue
--$4 organisme
i integer:=1;
login_part varchar;
login varchar;
password varchar;
identifiant_md5 varchar;
nom varchar;
prenom varchar;
BEGIN
	
	FOR i IN 1 .. $1
	LOOP
		SELECT INTO login_part * FROM contraintes.get_random_string(2);
		login:=$2||'_'||login_part||i;
		SELECT INTO password * FROM  contraintes.get_random_string_2(8);
		identifiant_md5:=md5(password);
		nom:=login;
		prenom:=login;
		
		PERFORM contraintes.af_set_inscription(identifiant_md5,login,password,nom,prenom,NULL,NULL,NULL,NULL,NULL,NULL,$3,$4,NULL);

	END LOOP;

	--RAISE NOTICE '% == %',i,$1;
	RETURN i=$1;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_inscriptions(integer, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1503 (class 1255 OID 2596377)
-- Dependencies: 2983 5
-- Name: af_set_intervention(character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_intervention(character varying, character varying) RETURNS integer
    AS $_$-- $1 : libelle intervention
-- $2 : code couleur
declare
new_id int4;
res int4;
begin
    insert into contraintes.intervention(libelle,couleur) values($1,$2);
    --RECUPERE L'IDENTIFIANT DU NOUVEL ESPACE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.intervention WHERE oid=new_id;
    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_intervention(character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 8538 (class 0 OID 0)
-- Dependencies: 1503
-- Name: FUNCTION af_set_intervention(character varying, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_intervention(character varying, character varying) IS 'enregistre une intervention';


--
-- TOC entry 1505 (class 1255 OID 2596378)
-- Dependencies: 2983 5
-- Name: af_set_langue_message(integer, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_langue_message(integer, integer, character varying) RETURNS integer
    AS $_$-- $1 : numero langue
-- $2 : type
-- $3 : libelle
declare
numero integer;
begin
    -- détermine le prochain id pour l'insertion
    select into numero max(id) from contraintes.langue_message where langue=$1 and type=$2;
    if numero is null then
	numero:=1;
    else
	numero:=numero+1;
    end if;
    -- insertion
    perform * from contraintes.af_set_langue_message(numero,$1,$2,$3);
    return numero; 
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_langue_message(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8540 (class 0 OID 0)
-- Dependencies: 1505
-- Name: FUNCTION af_set_langue_message(integer, integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_langue_message(integer, integer, character varying) IS 'insert un nouveau message de langue et
retourne son numero';


--
-- TOC entry 1504 (class 1255 OID 2596379)
-- Dependencies: 2983 5
-- Name: af_set_langue_message(integer, integer, integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_langue_message(integer, integer, integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero message
-- $2 : numero langue
-- $3 : type message
-- $4 : libelle message
declare

begin
    insert into contraintes.langue_message(id,langue,type,libelle) 
    values($1,$2,$3,$4);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_langue_message(integer, integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8542 (class 0 OID 0)
-- Dependencies: 1504
-- Name: FUNCTION af_set_langue_message(integer, integer, integer, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_langue_message(integer, integer, integer, character varying) IS 'enregistre un message de langue';


--
-- TOC entry 1506 (class 1255 OID 2596380)
-- Dependencies: 2983 5
-- Name: af_set_langues_messages_incomplets(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_langues_messages_incomplets() RETURNS boolean
    AS $$declare
rec record;
rec2 record;
rec_langue record;
texte text;
begin
    texte:='A completer';
    -- boucle sur les messages de langue french (1)
    for rec in
	select * from contraintes.af_get_langue_messages(1) 
	as (id int4,libelle text,type int4,langue int4,variable text)
    loop
	--raise notice 'id=%,lib=%,typ=%,lang=%',rec.id,rec.libelle,rec.type,rec.langue;
	-- boucle sur les autres langues
	for rec_langue in 
	    select * from contraintes.af_get_langues() as (id int4,libelle varchar, code varchar, locale varchar) 
	    where id<>1
	loop
	
	    select into rec2 * from contraintes.af_get_langue_message_libelle(rec.id,rec_langue.id,rec.type) as (id int4,libelle text,type int4,langue int4);
	    if rec2.id is null then
	        --raise notice 'lang=% rec_id=% rec_type=%',rec_langue.id,rec.id,rec.type;
	        perform * from contraintes.af_set_langue_message(rec.id,rec_langue.id,rec.type,texte);
	    end if;
	end loop;
        
    end loop;
return true;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_langues_messages_incomplets() OWNER TO pgsql;

--
-- TOC entry 8544 (class 0 OID 0)
-- Dependencies: 1506
-- Name: FUNCTION af_set_langues_messages_incomplets(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_langues_messages_incomplets() IS 'insere le texte ''A completer'' pour les libelles manquants.
Langue de référence : french';


--
-- TOC entry 1507 (class 1255 OID 2596381)
-- Dependencies: 2101 2983 5
-- Name: af_set_media(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_media(integer) RETURNS information_schema.cardinal_number
    AS $_$BEGIN
	insert into media (id) values ($1);
	return FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_media(integer) OWNER TO postgres;

--
-- TOC entry 8546 (class 0 OID 0)
-- Dependencies: 1507
-- Name: FUNCTION af_set_media(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_media(integer) IS 'FONCTION PRIVEE: creer un nouveau media (enregistre un fichier en tant que media)';


--
-- TOC entry 1901 (class 1255 OID 2596382)
-- Dependencies: 2983 5
-- Name: af_set_media_question_reponse_element(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_media_question_reponse_element(integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
val_question_reponse ALIAS FOR $1;
val_question_reponse_element ALIAS FOR $2;
val_media ALIAS FOR $3;
val_hauteur ALIAS FOR $4;
val_largeur ALIAS FOR $5;

BEGIN
	insert into contraintes.media_question_reponse_element(question_reponse,question_reponse_element,media,hauteur, largeur ) 
	values (val_question_reponse, val_question_reponse_element, val_media, val_hauteur, val_largeur);

	return FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_media_question_reponse_element(integer, integer, integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 8548 (class 0 OID 0)
-- Dependencies: 1901
-- Name: FUNCTION af_set_media_question_reponse_element(integer, integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_media_question_reponse_element(integer, integer, integer, integer, integer) IS 'ajoute un media Ã  un element d''un question_reponse. retourne true si l''operation s''est bien passÃ©e.';


--
-- TOC entry 1508 (class 1255 OID 2596383)
-- Dependencies: 2983 5
-- Name: af_set_modele_correction(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_modele_correction(character varying) RETURNS integer
    AS $_$-- $1 : libelle modele correction
declare
new_id int4;
res int4;
begin
    insert into contraintes.modele_correction(libelle) values($1);
    --RECUPERE L'IDENTIFIANT DU NOUVEAU CRITERE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.modele_correction WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_modele_correction(character varying) OWNER TO pgsql;

--
-- TOC entry 8550 (class 0 OID 0)
-- Dependencies: 1508
-- Name: FUNCTION af_set_modele_correction(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_modele_correction(character varying) IS 'enregistre un modele de correction';


--
-- TOC entry 1509 (class 1255 OID 2596384)
-- Dependencies: 2983 5
-- Name: af_set_modele_correction_criteres(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_modele_correction_criteres(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero modele
-- $2 : numero critere
-- $3 : numero pere
-- $4 : note
begin
    insert into contraintes.modele_correction_criteres(modele_correction,critere,pere,note_max) 
    values($1,$2,$3,$4);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_modele_correction_criteres(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8552 (class 0 OID 0)
-- Dependencies: 1509
-- Name: FUNCTION af_set_modele_correction_criteres(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_modele_correction_criteres(integer, integer, integer, integer) IS 'enregistre dans modele_correction_criteres';


--
-- TOC entry 1510 (class 1255 OID 2596385)
-- Dependencies: 2983 5
-- Name: af_set_organisme(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_organisme(character varying) RETURNS integer
    AS $_$declare
new_id int4;
res int4;
begin
    insert into contraintes.organisme(libelle) values($1);
    -- recup id
    GET DIAGNOSTICS new_id=RESULT_OID;
    select into res id from contraintes.organisme 
    where oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_organisme(character varying) OWNER TO pgsql;

--
-- TOC entry 8554 (class 0 OID 0)
-- Dependencies: 1510
-- Name: FUNCTION af_set_organisme(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_organisme(character varying) IS 'enregistre un organisme';


--
-- TOC entry 1511 (class 1255 OID 2596386)
-- Dependencies: 2983 5
-- Name: af_set_page_annuaire_configuration(integer, integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_page_annuaire_configuration(integer, integer, integer, integer[]) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : type individu
-- $4 : tableau d'elements
declare
i int4;
begin
    for i in array_lower($4,1) .. array_upper($4,1)
    loop
	insert into contraintes.page_annuaire_configuration values ($1,$2,$3,$4[i]);
    end loop;
return true;


end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_page_annuaire_configuration(integer, integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 8556 (class 0 OID 0)
-- Dependencies: 1511
-- Name: FUNCTION af_set_page_annuaire_configuration(integer, integer, integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_page_annuaire_configuration(integer, integer, integer, integer[]) IS 'enregistre la configuration de la page annuaire';


--
-- TOC entry 1512 (class 1255 OID 2596387)
-- Dependencies: 2983 5
-- Name: af_set_page_commentaire(integer, integer, integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_page_commentaire(integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : page
-- $2 : formation
-- $3 : stagiaire
-- $4 : commentaire
declare
ams varchar;
begin
    -- test si existe
    perform * from contraintes.page_commentaire where page=$1 and formation=$2 and stagiaire=$3;
    if found then
	SELECT INTO ams contraintes.fw_get_ams_libelle('page_commentaire','commentaire','page='||$1||' and formation='||$2||' and stagiaire='||$3,$4);
	update contraintes.page_commentaire set commentaire=ams
	where page=$1 and formation=$2 and stagiaire=$3;
    else
	insert into contraintes.page_commentaire (page,formation,stagiaire,commentaire) 
	values($1,$2,$3,$4);
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_page_commentaire(integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 8558 (class 0 OID 0)
-- Dependencies: 1512
-- Name: FUNCTION af_set_page_commentaire(integer, integer, integer, text); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_page_commentaire(integer, integer, integer, text) IS 'Enregistre le commentaire pour une page';


--
-- TOC entry 1513 (class 1255 OID 2596388)
-- Dependencies: 2983 5
-- Name: af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : liste
-- $4 : page
-- $5 : tableau d'element
-- $6 : titre
-- $7 : commentaire
declare
i int4;
begin
    for i in array_lower($5,1) .. array_upper($5,1)
    loop
	insert into contraintes.page_liste_configuration values ($1,$2,$3,$4,$5[i]);
    end loop;
    insert into contraintes.page_liste values ($1,$2,$3,$4,$6,$7);
return true;
end;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) OWNER TO pgsql;

--
-- TOC entry 8560 (class 0 OID 0)
-- Dependencies: 1513
-- Name: FUNCTION af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) IS 'Enregistre la configuration d''une page de liste';


--
-- TOC entry 1514 (class 1255 OID 2596389)
-- Dependencies: 2983 5
-- Name: af_set_page_ressource_configuration(integer, integer, integer, integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_page_ressource_configuration(integer, integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : parcours
-- $4 : etape_ressource
-- $5 : commentaire
begin
    -- test si existe
    perform * from contraintes.page_ressource_configuration where formation=$1 and page=$2 and parcours=$3 and etape_ressource=$4;
    if found then 
	update contraintes.page_ressource_configuration set commentaire=$5
	where formation=$1 and page=$2 and parcours=$3 and etape_ressource=$4;
    else
	insert into contraintes.page_ressource_configuration (formation,page,parcours,etape_ressource,commentaire) 
	values($1,$2,$3,$4,$5);
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_page_ressource_configuration(integer, integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 8562 (class 0 OID 0)
-- Dependencies: 1514
-- Name: FUNCTION af_set_page_ressource_configuration(integer, integer, integer, integer, text); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_page_ressource_configuration(integer, integer, integer, integer, text) IS 'Enregistre la configuration d''une page de ressource';


--
-- TOC entry 1515 (class 1255 OID 2596390)
-- Dependencies: 2983 5
-- Name: af_set_parcours(character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_parcours(character varying, integer) RETURNS integer
    AS $_$declare
	num_etape int4;
begin
	
	select into num_etape contraintes.af_set_etape($1,1); 
	insert into contraintes.parcours(id,filiere) values(num_etape,$2);
	return num_etape;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_parcours(character varying, integer) OWNER TO postgres;

--
-- TOC entry 8564 (class 0 OID 0)
-- Dependencies: 1515
-- Name: FUNCTION af_set_parcours(character varying, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_parcours(character varying, integer) IS 'crÃ©e un parcours';


--
-- TOC entry 1516 (class 1255 OID 2596391)
-- Dependencies: 2983 5
-- Name: af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 pere
--$4 obligation
--$5 duree
--$6 fin de page
/*BEGIN
	INSERT INTO contraintes.parcours_etapes (parcours, etape, pere, obligatoire, chrono, fin)
	VALUES ($1, $2, $3, $4, $5, $6);

	RETURN FOUND;
END;
declare*/
	
	insere bool;
	chaine varchar;
	req text;
	rec record;
begin
	
	chaine:=','||$1||','||
	case when $4 then 
		
		'true'
	else
		
		'false'
	end
	||' ,';

	IF $5 IS NOT NULL THEN chaine:=chaine||$5;
	ELSE chaine:=chaine||'NULL';
	END IF;
 
	chaine:=chaine||','||
	case when $6 then 
		
		'true'
	else
		
		'false'
	end
	||' ';

	
	raise notice '%',chaine;
	req:='select  contraintes.af_gen_set_element(varchar ''contraintes.parcours_etapes'', varchar ''etape'' ,';
	IF $3 is null then 
		req:=req||' NULL';
	else
		req:=req||$3;
	end if;
	req:=req||','||$2||', text'', parcours,obligatoire,chrono,fin'',text '''||chaine||''', text ''AND parcours='||$1||''');';
	--raise notice '%',req;
	

	execute req;

	--IF FOUND THEN 
		return  TRUE;
	--ELSE 
	--	RETURN FALSE;
	--END IF;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) OWNER TO postgres;

--
-- TOC entry 8566 (class 0 OID 0)
-- Dependencies: 1516
-- Name: FUNCTION af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) IS 'ajoute une etape au parcours';


--
-- TOC entry 1517 (class 1255 OID 2596392)
-- Dependencies: 2983 5
-- Name: af_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle etape
--$2 les sous parcours
--$3 types d'étapes
--$4 nombre de types d'etapes
--$5 seuil
num_etape int4;
val int4;
i int4;
j int4;
curs int4:=1;
BEGIN
	--creation de l'etape
	SELECT INTO num_etape contraintes.af_set_etape($1,10); 
	
	--insertion de la configuration
	FOR i IN array_lower($2, 1) .. array_upper($2, 1)  
	LOOP
		--le 1er sous parcours
		IF i=1 THEN
			raise notice '1er parcours %: INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',i,num_etape,$2[i],'NULL','NULL';
			INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil,ordre) values(num_etape,$2[i],NULL,NULL, i);
		--les autres
		ELSE
			--seuil global
			IF $3[curs]=-1 THEN
				raise notice 'global %: INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',i,num_etape,$2[i],'NULL',$5[curs];
				INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil,ordre) values(num_etape,$2[i],NULL,$5[curs],i);
				curs:=curs+1;
			--seuil par type
			ELSE
				--pour chacun des types
				FOR j IN 1 .. $4
				LOOP
					--cas ou pas de seuil pour le type
					IF $5[curs] =-1 THEN
						val:=NULL;
					ELSE
						val:=$5[curs];
					END IF;
					raise notice 'type %: INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',i,num_etape,$2[i],$3[curs],val;
					INSERT INTO contraintes.parcours_oriente(id,sous_parcours,type,seuil,ordre) values(num_etape,$2[i],$3[curs],val,i);
					curs:=curs+1;
				END LOOP;
			END IF;
		END IF;
	END LOOP;
	
	RETURN num_etape;
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 1518 (class 1255 OID 2596393)
-- Dependencies: 2983 5
-- Name: af_set_positionnement(character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_positionnement(character varying, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 chrono
--$3 qsrc
--$4 serie_generee
new_id int4;
oid_id int4;
BEGIN 
	
	INSERT INTO contraintes.positionnement 
	(libelle, chrono, qsrc, serie_generee)
	VALUES ($1, $2, $3, $4);
	GET DIAGNOSTICS oid_id = RESULT_OID;
	--RAISE NOTICE 'oid inseree: % ',oid_id;

	SELECT INTO new_id id FROM contraintes.positionnement WHERE oid=oid_id;
	--RAISE NOTICE 'valeur inseree: % ',new_id;

	RETURN new_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_positionnement(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1902 (class 1255 OID 2596394)
-- Dependencies: 2983 5
-- Name: af_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 reponse
--$3 pere
--$4 bareme
--$5 media
--$6 hauteur
--$7 largeur
r1 boolean;
r2 boolean;
qr int4;
rec RECORD;
v_pere integer;
BEGIN
	--on recupere le pere pour l'insertion
	select INTO v_pere * from contraintes.af_gen_get_last_element('contraintes.choix', 'id',' AND positionnement='||$1);

	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	--insert le nouveau choix
	INSERT INTO contraintes.choix (positionnement, id, pere, bareme )
	VALUES ($1, $2, $3, $4);
	r1 := FOUND;

	--selection les questions existantes
	FOR rec IN 
		SELECT id FROM contraintes.af_get_positionnement_questions($1) AS (id integer, libelle varchar, interpretationHTML boolean, reponse boolean)
	LOOP 
		PERFORM * FROM contraintes.af_set_question_reponse_association_element(qr, rec.id, $2, v_pere);
		IF NOT FOUND THEN
			RAISE EXCEPTION 'af_set_positionnement: erreur association choix/question_reponse';
		END IF;
	END LOOP;

	--SELECT * FROM contraintes.af_set_question_reponse_association_element(qr, integer, $2, $3)

	IF $5 IS NOT NULL THEN
		INSERT INTO contraintes.media_question_reponse_element (question_reponse, question_reponse_element, media, hauteur, largeur )
		VALUES (qr, $2, $5, $6, $7);
		r2 := FOUND;
	END IF;

	RETURN r1 OR r2;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1903 (class 1255 OID 2596395)
-- Dependencies: 2983 5
-- Name: af_set_positionnement_evaluation_a_generer(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_positionnement_evaluation_a_generer(integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question de positionnement
--$3 choix
--$4 evaluation
qr int4;
id_pere int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	--on selectionne le dernier element
	SELECT INTO id_pere * FROM
	contraintes.af_gen_get_last_element('contraintes.positionnement_evaluations', 'evaluation', ' AND question_reponse='||qr||' AND question='||$2||' AND choix='||$3);

	INSERT INTO contraintes.positionnement_evaluations
	(question_reponse, question, choix, evaluation, pere)
	VALUES (qr, $2, $3,$4,id_pere);

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_positionnement_evaluation_a_generer(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1519 (class 1255 OID 2596396)
-- Dependencies: 2983 5
-- Name: af_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 choix
--$3 type
--$4 nb_a_generer
--$5 taille_chapeau
BEGIN

	INSERT INTO contraintes.positionnement_choix_evaluations
	(positionnement, choix, type, nombre, nombre_max)
	VALUES ($1,$2,$3,$4,$5);

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1520 (class 1255 OID 2596397)
-- Dependencies: 2983 5
-- Name: af_set_positionnement_question_positionnement_solution(integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_positionnement_question_positionnement_solution(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3array int4 : choix |  juste (0 ou 1)
i int4;
qr int4;
b_value bool;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;

	FOR i IN array_lower($3,1) .. array_upper($3,1)
	LOOP
		IF $3[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		PERFORM * FROM contraintes.af_set_question_reponse_solution(qr, $2, $3[i][1], b_value);
	END LOOP;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_positionnement_question_positionnement_solution(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 1521 (class 1255 OID 2596398)
-- Dependencies: 2983 5
-- Name: af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
-- $7 : carton
begin
    perform * from contraintes.stagiaire_grille where formation=$1 and stagiaire=$2 and grille=$3;
    if not found then
	insert into contraintes.stagiaire_grille(formation,stagiaire,grille,visible) 
	values($1,$2,$3,true);
    end if;
    insert into contraintes.grille_resultats (formation,stagiaire,grille,capacite_titre,capacite,carton,date) 
    values($1,$2,$3,$4,$5,$7,$6);
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) OWNER TO pgsql;

--
-- TOC entry 8574 (class 0 OID 0)
-- Dependencies: 1521
-- Name: FUNCTION af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) IS 'enregistre le carton pour une capacite à une date';


--
-- TOC entry 1522 (class 1255 OID 2596399)
-- Dependencies: 2983 5
-- Name: af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type
--$3 radio
--$4 questions
--$5 reponses
--$6 justes
i integer;
b_value boolean;
val_id integer;
BEGIN	

	SELECT INTO val_id * FROM contraintes.af_set_question_reponse($1, $2, $3, $4,$5 );

	FOR i IN array_lower($6,1) .. array_upper($6,1)
	LOOP
		IF $6[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		--note: un QCM à une seule question, dc pas besoin de parcourir le tableau
		PERFORM * FROM contraintes.af_set_question_reponse_solution(val_id, $4[1], $6[i][1], b_value);
	END LOOP;

	RETURN val_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) OWNER TO postgres;

--
-- TOC entry 8576 (class 0 OID 0)
-- Dependencies: 1522
-- Name: FUNCTION af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) IS 'Créer un QCM complet';


--
-- TOC entry 1523 (class 1255 OID 2596400)
-- Dependencies: 2983 5
-- Name: af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) RETURNS integer
    AS $_$-- $1 : libelle qrc
-- $2 : type evaluation qrc
-- $3 : libelle question commune
-- $4 : tableau de questions
-- $5 : tableau de reponses
-- $6 : type radio ou checkbox
-- $7 : tableau des juste/faux
declare
i integer;
j integer;
k integer :=1;
b_value boolean;
val_id int4;
begin
    SELECT INTO val_id * FROM contraintes.af_set_question_reponse($1, $2, $6, $4,$5 );
    INSERT INTO contraintes.qsrc (id, question) VALUES (val_id, $3);
    ---raise notice 'On a fin insert';
    FOR i IN array_lower($4,1) .. array_upper($4,1)
	LOOP
	for j in array_lower($5,1) .. array_upper($5,1)
	    loop
		--raise notice 'On traite % % % % ',$4[i],$5[j],$7[k][1],$7[k][2];
		IF $4[i]=$7[k][1] and $5[j]=$7[k][2] THEN
		    if $7[k][3]=1 then
			b_value:=TRUE;
		    ELSE 
			b_value:=FALSE;
	       	    end if;
		    k:=k+1;
		else
		    return null;
		END IF;
		
		PERFORM * FROM contraintes.af_set_question_reponse_solution(val_id, $4[i], $5[j], b_value);
		
	    end loop;
	END LOOP;

	RETURN val_id;
end; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) OWNER TO pgsql;

--
-- TOC entry 8578 (class 0 OID 0)
-- Dependencies: 1523
-- Name: FUNCTION af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) IS 'Enregistre un qrc';


--
-- TOC entry 1524 (class 1255 OID 2596401)
-- Dependencies: 2983 5
-- Name: af_set_qrc_question_solution(integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_qrc_question_solution(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 qrc
--$2 question
--$3 array int4 : choix |  juste (0 ou 1)
i int4;
qr int4;
b_value bool;
BEGIN

	FOR i IN array_lower($3,1) .. array_upper($3,1)
	LOOP
		IF $3[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		PERFORM * FROM contraintes.af_set_question_reponse_solution($1, $2, $3[i][1], b_value);
	END LOOP;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_qrc_question_solution(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 1525 (class 1255 OID 2596402)
-- Dependencies: 2983 5
-- Name: af_set_qsrc(character varying, integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_qsrc(character varying, integer, character varying, boolean) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type (4 ou 5)
--$3 question commmune
--$4 radio?
new_id int4;
v_question_reponse integer;
ok boolean;
BEGIN
	--cree l'evaluation
	SELECT INTO new_id * FROM contraintes.af_set_evaluation($1,$2);

	--cree le question reponse
	SELECT INTO ok * FROM contraintes.af_set_question_reponse(new_id, $2, $4);

	--cree le qsrc
	INSERT INTO contraintes.qsrc (id, question)
	VALUES (new_id, $3);

	IF FOUND AND ok THEN
		RETURN new_id;
	ELSE
		RAISE NOTICE 'erreur lors de la creation du SRC';
	END IF;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_qsrc(character varying, integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 1526 (class 1255 OID 2596403)
-- Dependencies: 2983 5
-- Name: af_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 qsrc
--$2 libelle
--$3 interHTML
--$4 media
--$5 largeur
--$6 hauteur
--$7 pere
rec RECORD;
id_quest int4;
v_type integer;
BEGIN
	SELECT INTO v_type type FROM contraintes.af_get_question_reponse($1) AS (id int4, libelle varchar, type int4, date_creation timestamp, radio bool);

	
	--on cree la question et son media
	SELECT INTO id_quest * FROM contraintes.af_set_question_reponse_element($2, $3, v_type,FALSE);

	FOR rec IN
		--on selectionne les choix du positionnement
		SELECT id FROM contraintes.choix where question_reponse=$1

	--pour chacun des choix
	LOOP
RAISE NOTICE 'pere=%',$7;
		--on associe les elements du question reponse
		--PERFORM * FROM contraintes.af_set_question_reponse_association_element(qr, id_quest, rec.id, $7);
		PERFORM * FROM contraintes.af_gen_set_element('contraintes.question_reponse_elements', 'question', $7, id_quest, ',question_reponse, reponse', ','||$1||','||rec.id,'and question_reponse='||$1||' and reponse='||rec.id);
		--on enregistre l'association en tant qu'element de positionnement 
		--INSERT INTO contraintes.positionnement_elements(question_reponse, question, choix)
		--VALUES ($1, id_quest, rec.id);
 
	END LOOP;

	IF $4 IS NOT NULL THEN
		--RAISE NOTICE 'insertion image % / % / % / % / %',$1, id_quest, $4,$5,$6;
		PERFORM * FROM contraintes.af_set_media_question_reponse_element($1, id_quest, $4,$5,$6);
	END IF;

	RETURN id_quest;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1904 (class 1255 OID 2596404)
-- Dependencies: 2983 5
-- Name: af_set_question(character varying, boolean, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_question(character varying, boolean, integer) RETURNS integer
    AS $_$DECLARE
libelle ALIAS FOR $1;
interpretation_HTML ALIAS  FOR $2;
val_type ALIAS FOR $3;

res int4;
BEGIN

	--insertion dans la table des elements 
	select into res contraintes.af_set_question_reponse_element(libelle, interpretation_HTML, val_type, FALSE);

	--insertion dans la table des questions
	--insert into contraintes.question(id) VALUES (res);

	--on retourne l'id de l'enregistrement
	return res;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_question(character varying, boolean, integer) OWNER TO postgres;

--
-- TOC entry 8583 (class 0 OID 0)
-- Dependencies: 1904
-- Name: FUNCTION af_set_question(character varying, boolean, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_question(character varying, boolean, integer) IS 'FONCTION PRIVEE:
Insere une question.';


--
-- TOC entry 1527 (class 1255 OID 2596405)
-- Dependencies: 2983 5
-- Name: af_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 positionnement
--$2 libelle
--$3 interHTML
--$4 media
--$5 largeur
--$6 hauteur
--$7 pere
rec RECORD;
qr int4;
id_quest int4;
BEGIN
	--on selectionne le question-reponse associé au positionnement
	SELECT INTO qr question_reponse FROM contraintes.positionnement where id=$1;
		
	--on cree la question et son media
	SELECT INTO id_quest * FROM contraintes.af_set_question_reponse_element($2, $3, 6,FALSE);

	FOR rec IN
		--on selectionne les choix du positionnement
		SELECT id FROM contraintes.choix where positionnement=$1

	--pour chacun des choix
	LOOP

		--on associe les elements du question reponse
		--PERFORM * FROM contraintes.af_set_question_reponse_association_element(qr, id_quest, rec.id, $7);
		PERFORM * FROM contraintes.af_gen_set_element('contraintes.question_reponse_elements', 'question', $7, id_quest, ',question_reponse, reponse', ','||qr||','||rec.id,'and question_reponse='||qr||' and reponse='||rec.id);
		--on enregistre l'association en tant qu'element de positionnement 
		INSERT INTO contraintes.positionnement_elements(question_reponse, question, choix)
		VALUES (qr, id_quest, rec.id);

	END LOOP;

	IF $4 IS NOT NULL THEN
		RAISE NOTICE 'insertion image % / % / % / % / %',qr, id_quest, $4,$5,$6;
		PERFORM * FROM contraintes.af_set_media_question_reponse_element(qr, id_quest, $4,$5,$6);
	END IF;

	RETURN id_quest;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1528 (class 1255 OID 2596406)
-- Dependencies: 2983 5
-- Name: af_set_question_reponse(integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_question_reponse(integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
val_id ALIAS FOR $1;
val_type ALIAS FOR $2;
val_radio ALIAS FOR $3;
BEGIN	
	insert into contraintes.question_reponse (id, "type", radio) values (val_id, val_type, val_radio) ;
	return FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_question_reponse(integer, integer, boolean) OWNER TO postgres;

--
-- TOC entry 8586 (class 0 OID 0)
-- Dependencies: 1528
-- Name: FUNCTION af_set_question_reponse(integer, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_question_reponse(integer, integer, boolean) IS 'FONCTION PRIVEE';


--
-- TOC entry 1529 (class 1255 OID 2596407)
-- Dependencies: 2983 5
-- Name: af_set_question_reponse(character varying, integer, boolean, integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_question_reponse(character varying, integer, boolean, integer[], integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type
--$3 radio
--$4 questions
--$5 reponses
i integer;
j integer;
prec_i integer:=NULL;
prec_j integer:=NULL;
val_id integer;
BEGIN	
    SELECT INTO val_id * FROM contraintes.af_set_evaluation($1,$2);
    PERFORM contraintes.af_set_question_reponse(val_id, $2, $3);
    /*
    FOR i IN array_lower($4, 1) .. array_upper($4, 1)  
    LOOP
	FOR j IN array_lower($5, 1) .. array_upper($5, 1)  
	LOOP
	    IF j-1>0 THEN
		prec_j:=$5[j-1];--precedent reponse
	    END IF;
	    --RAISE NOTICE 'association: %, %,%,%',val_id,$4[i], $5[j],prec_i;
	    PERFORM contraintes.af_set_question_reponse_association_element(val_id,$4[i], $5[j],prec_j);
	END LOOP;
    END LOOP;
    */
    -- Boucle d'enregistrement des questions
    FOR i IN array_lower($4, 1) .. array_upper($4, 1)  
    LOOP
	IF i-1>0 THEN
		prec_i:=$4[i-1];--precedent question
	END IF;
	--RAISE NOTICE 'association: %, %,%,%',val_id,$4[i], $5[j],prec_i;
	PERFORM contraintes.af_set_question_reponse_association_element(val_id,$4[i],prec_i);
    END LOOP;
    -- Boucle d'enregistrement des reponse
    FOR j IN array_lower($5, 1) .. array_upper($5, 1)  
    LOOP
	IF j-1>0 THEN
		prec_j:=$5[j-1];--precedent reponse
	END IF;
	--RAISE NOTICE 'association: %, %,%,%',val_id,$4[i], $5[j],prec_i;
	PERFORM contraintes.af_set_question_reponse_association_element(val_id,$5[j],prec_j);
    END LOOP;
    
    RETURN val_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_question_reponse(character varying, integer, boolean, integer[], integer[]) OWNER TO postgres;

--
-- TOC entry 8588 (class 0 OID 0)
-- Dependencies: 1529
-- Name: FUNCTION af_set_question_reponse(character varying, integer, boolean, integer[], integer[]); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_question_reponse(character varying, integer, boolean, integer[], integer[]) IS 'Créer un Question Réponse complet';


--
-- TOC entry 1905 (class 1255 OID 2596408)
-- Dependencies: 2983 5
-- Name: af_set_question_reponse_association_element(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_question_reponse_association_element(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
val_question_reponse ALIAS FOR $1;
val_question_reponse_element ALIAS FOR $2;

val_pere ALIAS FOR $3;
BEGIN
	--RAISE NOTICE 'qr=% q=% r=% pere=%',val_question_reponse, val_question, val_reponse, val_pere;
	insert into contraintes.question_reponse_elements (question_reponse, question_reponse_element, pere) values  (val_question_reponse, val_question_reponse_element, val_pere) ;
	return FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_question_reponse_association_element(integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 8590 (class 0 OID 0)
-- Dependencies: 1905
-- Name: FUNCTION af_set_question_reponse_association_element(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_question_reponse_association_element(integer, integer, integer) IS 'ajoute un element de question_reponse, c''est Ã  dire une paire question reponse. Le champs pere s''applique Ã  la rÃ©ponse pour permettre de conserver l''ordre des reponses.';


--
-- TOC entry 1530 (class 1255 OID 2596409)
-- Dependencies: 2983 5
-- Name: af_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 question_reponse
--$2 reponse
--$3 pere
--$4 bareme
--$5 media
--$6 hauteur
--$7 largeur
r1 boolean;
r2 boolean;
qr int4;
rec RECORD;
v_pere integer;
v_type integer;
BEGIN
	SELECT INTO v_type type FROM contraintes.af_get_question_reponse($1) AS (id int4, libelle varchar, type int4, date_creation timestamp, radio bool);

	--insert le nouveau choix
	INSERT INTO contraintes.choix (question_reponse, id, pere, bareme )
	VALUES ($1, $2, $3, $4);
	r1 := FOUND;

	--selection les questions existantes
	FOR rec IN 
		SELECT id FROM contraintes.af_get_question_reponse_elements($1,TRUE) as (id int4,libelle varchar,interpretation_html bool,type int4, reponse bool, indice integer)
	LOOP 
		PERFORM * FROM contraintes.af_set_question_reponse_association_element(qr, rec.id, $2, v_pere);
		IF NOT FOUND THEN
			RAISE EXCEPTION 'af_set_question_reponse_choix: erreur association choix/question_reponse';
		END IF;
	END LOOP;

	--SELECT * FROM contraintes.af_set_question_reponse_association_element(qr, integer, $2, $3)

	IF $5 IS NOT NULL THEN
		INSERT INTO contraintes.media_question_reponse_element (question_reponse, question_reponse_element, media, hauteur, largeur )
		VALUES (qr, $2, $5, $6, $7);
		r2 := FOUND;
	END IF;

	RETURN r1 OR r2;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1531 (class 1255 OID 2596410)
-- Dependencies: 2983 5
-- Name: af_set_question_reponse_element(character varying, boolean, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_question_reponse_element(character varying, boolean, integer, boolean) RETURNS integer
    AS $_$DECLARE

res int4;
new_id int4;

BEGIN

	insert into contraintes.question_reponse_element(libelle, interpretation_HTML, "type", reponse) values($1,$2,$3,$4);
	GET DIAGNOSTICS new_id = RESULT_OID;
	
	select into res id from contraintes.question_reponse_element where oid=new_id;
	
	return res;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_question_reponse_element(character varying, boolean, integer, boolean) OWNER TO postgres;

--
-- TOC entry 8593 (class 0 OID 0)
-- Dependencies: 1531
-- Name: FUNCTION af_set_question_reponse_element(character varying, boolean, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_question_reponse_element(character varying, boolean, integer, boolean) IS 'FONCTION PRIVEE:
Insere un element de question reponse. ';


--
-- TOC entry 1532 (class 1255 OID 2596411)
-- Dependencies: 2983 5
-- Name: af_set_question_reponse_media(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_question_reponse_media(integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
val_question_reponse ALIAS FOR $1;
val_media ALIAS FOR $2;
val_hauteur ALIAS FOR $3;
val_largeur ALIAS FOR $4;

BEGIN
	insert into contraintes.media_question_reponse(question_reponse,media,hauteur, largeur ) 
	values (val_question_reponse,  val_media, val_hauteur, val_largeur);

	return FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_question_reponse_media(integer, integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 8595 (class 0 OID 0)
-- Dependencies: 1532
-- Name: FUNCTION af_set_question_reponse_media(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_question_reponse_media(integer, integer, integer, integer) IS 'ajoute un media Ã  un question_reponse. retourne true si l''operation s''est bien passÃ©e.';


--
-- TOC entry 1533 (class 1255 OID 2596412)
-- Dependencies: 2983 5
-- Name: af_set_question_reponse_solution(integer, integer, integer, boolean); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_question_reponse_solution(integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
val_question_reponse ALIAS FOR $1;
val_question ALIAS FOR $2;
val_reponse ALIAS FOR $3;
val_juste ALIAS FOR $4;
BEGIN
	--RAISE NOTICE 'INSERT SOLUTION qr=%  q=%  r=% j=%',val_question_reponse, val_question, val_reponse, val_juste;
	insert into contraintes.qcm_elements(question_reponse, question, reponse, juste) values (val_question_reponse, val_question, val_reponse, val_juste) ;
	return FOUND;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_question_reponse_solution(integer, integer, integer, boolean) OWNER TO postgres;

--
-- TOC entry 8597 (class 0 OID 0)
-- Dependencies: 1533
-- Name: FUNCTION af_set_question_reponse_solution(integer, integer, integer, boolean); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_question_reponse_solution(integer, integer, integer, boolean) IS 'FONCTION PRIVEE: ajoute un enregistrement  dans la table qcm_elements';


--
-- TOC entry 1534 (class 1255 OID 2596413)
-- Dependencies: 2983 5
-- Name: af_set_reponse(character varying, boolean, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_reponse(character varying, boolean, integer) RETURNS integer
    AS $_$DECLARE
libelle ALIAS FOR $1;
interpretation_HTML ALIAS  FOR $2;
"type" ALIAS FOR $3;

res int4;
BEGIN

	--insertion dans la table generique
	select into res contraintes.af_set_question_reponse_element(libelle, interpretation_HTML, "type", TRUE);
	
	--insertion dans la table des reponses
	--insert into contraintes.reponse(id) VALUES (res);
	
	--on retourne l'id
	return res;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_reponse(character varying, boolean, integer) OWNER TO postgres;

--
-- TOC entry 8599 (class 0 OID 0)
-- Dependencies: 1534
-- Name: FUNCTION af_set_reponse(character varying, boolean, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_reponse(character varying, boolean, integer) IS 'FONCTION PRIVEE:
Insere une reponse.';


--
-- TOC entry 1535 (class 1255 OID 2596414)
-- Dependencies: 2983 5
-- Name: af_set_ressource(integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_ressource(integer, text) RETURNS integer
    AS $_$
-- $1 : fichier
-- $2 : mots cles
declare
new_id oid;
res int4;
begin
    -- insertion ressource
    INSERT INTO contraintes.ressource( fichier,mots_cles) VALUES ($1, $2);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.ressource WHERE oid=new_id;

    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_ressource(integer, text) OWNER TO pgsql;

--
-- TOC entry 8601 (class 0 OID 0)
-- Dependencies: 1535
-- Name: FUNCTION af_set_ressource(integer, text); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_ressource(integer, text) IS 'enregistre une ressource';


--
-- TOC entry 1536 (class 1255 OID 2596415)
-- Dependencies: 2983 5
-- Name: af_set_resultat_debut(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_debut(integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 formation
--$2 stagiaire
--$3 parcours
--$5 etape
new_oid oid;
new_id int4;
BEGIN

	SELECT INTO new_id * FROM contraintes.resultat
	WHERE formation=$1
	AND stagiaire=$2
	AND parcours=$3
	AND etape=$4
	AND date_debut IS NOT NULL;

	IF NOT FOUND THEN
		INSERT INTO contraintes.resultat
		(formation,stagiaire,parcours,etape, date_debut)
		VALUES ($1,$2,$3,$4, now());

		--RECUPERE L'IDENTIFIANT DU NOUVEAU RESULTAT
		GET DIAGNOSTICS new_oid = RESULT_OID;

		select into new_id id from contraintes.resultat where oid=new_oid;
	END IF;

	return new_id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_debut(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1537 (class 1255 OID 2596416)
-- Dependencies: 2983 5
-- Name: af_set_resultat_exotlc(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_exotlc(bigint) RETURNS boolean
    AS $_$DECLARE
-- $1 : id resultat
exotlc_type integer;
ok boolean;
begin
	
	 
    -- test si existe
    perform * from contraintes.resultat_exotlc where id=$1;
    if not found then
	insert into contraintes.resultat_exotlc (id,date_correction) values($1,now());
ELSE
	UPDATE contraintes.resultat_exotlc SET date_correction=now()
	WHERE id=$1 AND date_correction IS NULL;
    end if;

	ok:=FOUND;
	--recuperation du type d'exotlc
	SELECT INTO exotlc_type E.type 
	FROM contraintes.af_get_resultat($1) AS (R_id int8,  formation int4, stagiaire int4,parcours int4, etape int4,  date_debut timestamp, duree interval),
	contraintes.exotlc E
	WHERE etape=E.id;

	IF exotlc_type=2 THEN
		 perform * from contraintes.af_set_resultat_fin($1);
	END IF;
	
    return ok;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_exotlc(bigint) OWNER TO pgsql;

--
-- TOC entry 8604 (class 0 OID 0)
-- Dependencies: 1537
-- Name: FUNCTION af_set_resultat_exotlc(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_resultat_exotlc(bigint) IS 'insere l''identifiant de resultat dans la table resultat_exotlc';


--
-- TOC entry 1538 (class 1255 OID 2596417)
-- Dependencies: 2983 5
-- Name: af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : critere
-- $3 : note
-- $4 : note_max
-- $5 : commentaire
begin
    insert into contraintes.resultat_exotlc_critere(id,critere,note,note_max,commentaire) 
    values($1,$2,$3,$4,$5);
    return found;	
end; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 8606 (class 0 OID 0)
-- Dependencies: 1538
-- Name: FUNCTION af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) IS 'Enregistre les resultats d''un critere pour un identifiant de resultat';


--
-- TOC entry 1539 (class 1255 OID 2596418)
-- Dependencies: 2983 5
-- Name: af_set_resultat_exotlc_plateforme(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_exotlc_plateforme(bigint, integer) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 fichier_rendu
ok boolean;
BEGIN

	PERFORM * FROM contraintes.resultat_exotlc WHERE id=$1;
	IF NOT FOUND THEN
		INSERT INTO contraintes.resultat_exotlc
		(id,fichier_rendu)
		VALUES ($1,$2);
	ELSE
		UPDATE contraintes.resultat_exotlc SET fichier_rendu=$2
		WHERE id=$1;
	END IF;
	
	RETURN FOUND ;--AND ok;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_exotlc_plateforme(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1540 (class 1255 OID 2596419)
-- Dependencies: 2983 5
-- Name: af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : sous critere
-- $3 : note
-- $4 : note max
begin
    insert into contraintes.resultat_exotlc_sous_critere(id,sous_critere,note,note_max) 
    values($1,$2,$3,$4);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8609 (class 0 OID 0)
-- Dependencies: 1540
-- Name: FUNCTION af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) IS 'enregistre les resultats d''un sous critere pour un identifiant de resultat';


--
-- TOC entry 1541 (class 1255 OID 2596420)
-- Dependencies: 2983 5
-- Name: af_set_resultat_fin(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_fin(bigint) RETURNS interval
    AS $_$DECLARE
--$1 resultat
duree_init interval;
date_debut_init timestamp;
nouvelle_duree interval;
BEGIN
	SELECT INTO duree_init duree FROM contraintes.resultat WHERE id=$1;
	SELECT INTO date_debut_init date_debut FROM contraintes.resultat WHERE id=$1;

	IF duree_init IS NOT NULL THEN
		RAISE EXCEPTION 'Erreur: la durée a déjà été affectée pour la fin de l''étape';
	ELSE
		nouvelle_duree:=cast(now() AS timestamp without time zone)-date_debut_init;
		
		UPDATE contraintes.resultat
		SET duree=nouvelle_duree
		WHERE id=$1;

		RETURN nouvelle_duree;
		
	END IF;

	RETURN NULL;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_fin(bigint) OWNER TO pgsql;

--
-- TOC entry 1542 (class 1255 OID 2596421)
-- Dependencies: 2983 5
-- Name: af_set_resultat_meilleure_tentative(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_meilleure_tentative(bigint) RETURNS boolean
    AS $_$-- $1 : id resultat
/*declare
rec_resultat record;
rec record;
rec2 record;
rec_resultat_evaluation record;
score real;
score_courant real;
meilleure_tentative integer;
meilleur_identifiant bigint;
begin
    -- recup info resultat
    select into rec_resultat * from contraintes.af_get_resultat($1) 
    as (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval); 
    -- boucle sur les tentatives
    score:=0;
    meilleure_tentative:=0;
    for rec in 
	select * from contraintes.resultat_tentative where 
	formation=rec_resultat.formation and 
	stagiaire=rec_resultat.stagiaire and 
	parcours=rec_resultat.parcours and 
	etape=rec_resultat.etape
    loop
	-- recup score courant
	select into score_courant * from contraintes.af_get_resultat_serie_score_tentative(rec.id);
	raise notice '---------------score tentative %=%',rec.id,score_courant;
	if score_courant > score then
	    score:=score_courant;
	    meilleure_tentative:=rec.tentative;
	    meilleur_identifiant:=rec.id;
	end if;


    end loop;

    -- recup score serie
    select into score_courant * from contraintes.af_get_resultat_serie_score($1);
   -- raise notice 'sco=% et score_cour=%',score,score_courant;
raise notice '---------------score resultat %=%',$1,score_courant;   
 if score > score_courant then


	-- mise à jour des resultats
	-- boucle sur les evaluations de la serie
	for rec2 in
	    select * from contraintes.af_get_serie_evaluations(rec_resultat.etape) 
	    as (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	loop
	    -- suivant le type d'évaluation
	    -- question reponse
	    if rec2.type_evaluation=1 or rec2.type_evaluation=4 then
		for rec_resultat_evaluation in
		    select * from contraintes.af_get_resultat_serie_question_reponse_tentative(meilleur_identifiant,rec2.id_evaluation) 
		    as (id bigint, question_reponse integer, question integer, reponse integer,  date_debut timestamp,  date_fin timestamp,coche boolean, juste integer)
		loop
		    -- mise à jour
		    --raise notice 'mise a jour';

			--TODO décocher aussi les réponses!!!!
			---TODO mettre a jouyr TOUS les champs
		    update contraintes.resultat_serie_question_reponse set coche=rec_resultat_evaluation.coche 
			where
		    id=$1 and 
		    question_reponse=rec_resultat_evaluation.question_reponse and
		    question=rec_resultat_evaluation.question and 
		    reponse=rec_resultat_evaluation.reponse;

		end loop;

	    end if;
	    -- ftb
	    if rec2.type_evaluation=3 then
		for rec_resultat_evaluation in
		    select * from contraintes.af_get_resultat_serie_ftb_tentative(meilleur_identifiant,rec2.id_evaluation)
		    as (id bigint, ftb integer, reponse character varying[],  date_creation timestamp)
		loop
		    -- mise à jour
		    update contraintes.resultat_serie_ftb set reponse=rec_resultat_evaluation.reponse where 
		    id=$1 and ftb=rec_resultat_evaluation.ftb; 
		end loop;
	    end if;
	    

	end loop;


    end if;
    return true;	


end;*/

-- $1 : id resultat
declare
rec record;
rec_resultat record;
rec_best record;
nb_tentative integer;
nb_tentatives integer;
res_id integer;
score real;
score_courant real;
meilleure_tentative integer;
meilleur_identifiant bigint;
begin


    -- recup info resultat
    select into rec_resultat * from contraintes.af_get_resultat($1) 
    as (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval); 
    -- boucle sur les tentatives
    score:=NULL;
    meilleure_tentative:=NULL;
    meilleur_identifiant:= NULL;
    for rec in 
	select * from contraintes.resultat_tentative where 
	formation=rec_resultat.formation and 
	stagiaire=rec_resultat.stagiaire and 
	parcours=rec_resultat.parcours and 
	etape=rec_resultat.etape
	ORDER BY tentative DESC --ordre important pour garder la derniere si pas de meilleure
    loop
	-- recup score courant
	select into score_courant * from contraintes.af_get_resultat_serie_score_tentative(rec.id);
	raise notice '---------------score tentative %=%',rec.tentative,score_courant;

	--meilleur score
	if ((meilleure_tentative IS NULL) OR (score_courant >= score) ) then
	    score:=score_courant;
	    meilleure_tentative:=rec.tentative;
	    meilleur_identifiant:=rec.id;
	end if;


    end loop;
    raise notice '---------------meilleure tentative %=%',meilleure_tentative,score;
    -- meilleur resultat_tentative
    select into rec_best * from contraintes.af_get_resultat_tentative(meilleur_identifiant) 
    as (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval,tentative integer); 

	--enregistre dans resultat
	UPDATE contraintes.resultat SET
	duree= rec_best.duree
	WHERE id=$1;
	 raise notice '---------------duree finale =%',rec_best.duree;

	
    -- insertion dans resultat_serie
    for rec in
	select * from contraintes.af_get_resultat_serie_evaluations_tentative(rec_best.id) 
	--as (id bigint,evaluation integer,date_creation timestamp)
	as (id bigint,evaluation integer,date_debut timestamp,date_fin timestamp)
    loop
	insert into contraintes.resultat_serie(id,evaluation,date_debut,date_fin) 
	values($1,rec.evaluation,rec.date_debut,rec.date_fin);
	raise notice '---------------insert eval';
    end loop;

    -- Les evaluations (question_reponse et ftb)
    for rec in 
	select * from contraintes.resultat_serie_tentative_question_reponse where id=rec_best.id
    loop
	insert into contraintes.resultat_serie_question_reponse(id,question_reponse,question,reponse,coche) 
	values($1,rec.question_reponse,rec.question,rec.reponse,rec.coche);
	raise notice '---------------insert qr';
    end loop;
    for rec in 
	select * from contraintes.resultat_serie_tentative_ftb where id=rec_best.id
    loop
	insert into contraintes.resultat_serie_ftb(id,ftb,reponse) 
	values($1,rec.ftb,rec.reponse);
	raise notice '---------------insert ftb';
    end loop;


    	--supprime la date de début de l'étape maintenant qu'elle est sauvegardés
	--UPDATE contraintes.resultat SET duree = NULL
	--WHERE id=$1;
	--RAISE NOTICE 'RAZ duree id=%',$1;

	--supprime les évaludations du resultat maintenant qu'elles sont sauvegardés
	--DELETE FROM contraintes.resultat_serie
	--WHERE id=$1;
	
    return true;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_meilleure_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 8612 (class 0 OID 0)
-- Dependencies: 1542
-- Name: FUNCTION af_set_resultat_meilleure_tentative(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_resultat_meilleure_tentative(bigint) IS 'enregistre la meilleurs tentative pour une serie bloquante';


--
-- TOC entry 1543 (class 1255 OID 2596423)
-- Dependencies: 2983 5
-- Name: af_set_resultat_serie_debut(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_serie_debut(bigint, integer) RETURNS timestamp without time zone
    AS $_$DECLARE
--$1 resultat
--$2 evaluation
new_oid OID;
date_deb timestamp;
BEGIN
	INSERT INTO contraintes.resultat_serie
	(id,evaluation)
	VALUES ($1,$2);
	
	--RECUPERE L'IDENTIFIANT DU NOUVEAU RESULTAT
	GET DIAGNOSTICS new_oid = RESULT_OID;

	select into date_deb date_debut from contraintes.resultat_serie where oid=new_oid;
	return date_deb;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_serie_debut(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1544 (class 1255 OID 2596424)
-- Dependencies: 2983 5
-- Name: af_set_resultat_serie_fin(bigint, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_serie_fin(bigint, integer) RETURNS timestamp without time zone
    AS $_$DECLARE
--$1 resultat
--$2 evaluation
date_fin_return timestamp;
BEGIN

	select into date_fin_return date_fin 
	from contraintes.resultat_serie  
	WHERE id=$1 AND evaluation=$2;

	IF date_fin_return IS NULL THEN
		UPDATE contraintes.resultat_serie
		set date_fin = now()
		WHERE id=$1 AND evaluation=$2;
	
		select into date_fin_return date_fin 
		from contraintes.resultat_serie  
		WHERE id=$1 AND evaluation=$2;
		return date_fin_return;
	ELSE
		RAISE EXCEPTION 'la fin de l''evaluation a deja ete affectee res=% et id=%',$1,$2;
		RETURN NULL;
	END IF;
	
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_serie_fin(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 1545 (class 1255 OID 2596425)
-- Dependencies: 2983 5
-- Name: af_set_resultat_serie_ftb(bigint, integer, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_serie_ftb(bigint, integer, text) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 ftb
--$3 reponse
BEGIN
	INSERT INTO contraintes.resultat_serie_ftb
	(id,ftb, reponse)
	VALUES ($1,$2,$3);
	
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_serie_ftb(bigint, integer, text) OWNER TO pgsql;

--
-- TOC entry 1546 (class 1255 OID 2596426)
-- Dependencies: 2983 5
-- Name: af_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 qsrc
--$3 id questions 
--$4 id reponses
--$5 valeurs coche
ok integer:=0;
cpt integer:=1;
BEGIN

	IF (array_upper($3, 1) IS NULL) OR (array_upper($4, 1) IS NULL) THEN
		RAISE EXCEPTION 'Il est impossible qu''un qsrc (%) n''ai pas de réponse et/ou de question',$2;
	END IF;
	
	FOR i IN array_lower($3, 1) .. array_upper($3, 1)  
	LOOP

		FOR j IN array_lower($4, 1) .. array_upper($4, 1)  
		LOOP
			INSERT INTO contraintes.resultat_serie_question_reponse
			(id,question_reponse, question, reponse, coche)
			VALUES ($1,$2,$3[i],$4[j], CAST($5[cpt] AS BOOLEAN) );

			IF FOUND THEN ok:=ok+1; END IF;
			cpt:=cpt+1;
		END LOOP;
	END LOOP;

	RETURN ok=array_upper($5, 1);
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 1547 (class 1255 OID 2596427)
-- Dependencies: 2983 5
-- Name: af_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 question_reponse
--$3 id questions 
--$4 id reponses
--$5 valeur coche
ok integer:=0;

BEGIN
	--INSERT INTO contraintes.resultat_serie
	--(id,evaluation)
	--VALUES ($1,$2 );
	
	FOR i IN array_lower($3, 1) .. array_upper($3, 1)  
	LOOP

		FOR j IN array_lower($4, 1) .. array_upper($4, 1)  
		LOOP
			INSERT INTO contraintes.resultat_serie_question_reponse
			(id,question_reponse, question, reponse, coche)
			VALUES ($1,$2,$3[i],$4[j], CAST($5[j] AS BOOLEAN) );

			IF FOUND THEN ok:=ok+1; END IF;
		END LOOP;
	END LOOP;

	RETURN ok=array_upper($4, 1);
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 1548 (class 1255 OID 2596428)
-- Dependencies: 2983 5
-- Name: af_set_resultat_tentative(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_resultat_tentative(bigint) RETURNS boolean
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
nb_tentative integer;
nb_tentatives integer;
res_id integer;
new_id integer;
begin
    
    -- recup nb_tentative deja faite
    perform * from contraintes.af_get_resultat_etape_tentative($1) 
    as (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp,duree interval,tentative integer);
    GET DIAGNOSTICS nb_tentative = ROW_COUNT;
    nb_tentatives:=nb_tentative + 1;

    -- insertion dans resultat_tentative
    select into rec * from contraintes.af_get_resultat($1) 
    as (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval); 
    
    insert into contraintes.resultat_tentative(formation,stagiaire,parcours,etape,date_debut,duree,tentative) 
    values(rec.formation,rec.stagiaire,rec.parcours,rec.etape,rec.date_debut,rec.duree,nb_tentatives);
    GET DIAGNOSTICS res_id = RESULT_OID;
    select into new_id id from contraintes.resultat_tentative where oid=res_id;

	
    -- insertion dans resultat_serie_tentative
    for rec in
	select * from contraintes.af_get_resultat_serie_evaluations($1) 
	--as (id bigint,evaluation integer,date_creation timestamp)
	as (id bigint,evaluation integer,date_debut timestamp,date_fin timestamp)
    loop
	insert into contraintes.resultat_serie_tentative(id,evaluation,date_debut,date_fin) 
	values(new_id,rec.evaluation,rec.date_debut,rec.date_fin);
    end loop;

    -- Les evaluations (question_reponse et ftb)
    for rec in 
	select * from contraintes.resultat_serie_question_reponse where id=$1
    loop
	insert into contraintes.resultat_serie_tentative_question_reponse(id,question_reponse,question,reponse,coche) 
	values(new_id,rec.question_reponse,rec.question,rec.reponse,rec.coche);
    end loop;
    for rec in 
	select * from contraintes.resultat_serie_ftb where id=$1
    loop
	insert into contraintes.resultat_serie_tentative_ftb(id,ftb,reponse) 
	values(new_id,rec.ftb,rec.reponse);
    end loop;


    	--supprime la date de fin de l'étape maintenant qu'elle est sauvegardés
	UPDATE contraintes.resultat SET duree = NULL
	WHERE id=$1;
	RAISE NOTICE 'RAZ duree id=%',$1;

	--supprime les évaludations du resultat maintenant qu'elles sont sauvegardés
	DELETE FROM contraintes.resultat_serie
	WHERE id=$1;
	
    return true;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_resultat_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 8619 (class 0 OID 0)
-- Dependencies: 1548
-- Name: FUNCTION af_set_resultat_tentative(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_resultat_tentative(bigint) IS 'stocke tous les resultats pour un identifiant de resultat (serie bloquante)';


--
-- TOC entry 1549 (class 1255 OID 2596429)
-- Dependencies: 2983 5
-- Name: af_set_salle(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_salle(character varying) RETURNS integer
    AS $_$-- $1 : libelle salle
declare
new_id int4;
res int4;
begin
    insert into contraintes.salle(libelle) values($1);
    --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.salle WHERE oid=new_id;
    return res;    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_salle(character varying) OWNER TO pgsql;

--
-- TOC entry 8621 (class 0 OID 0)
-- Dependencies: 1549
-- Name: FUNCTION af_set_salle(character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_salle(character varying) IS 'enregistre une salle';


--
-- TOC entry 1906 (class 1255 OID 2596430)
-- Dependencies: 2983 5
-- Name: af_set_section(character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_section(character varying, integer) RETURNS integer
    AS $_$-- $1 : libelle
-- $2 : numero icone
declare
new_id int4;
res int4;
begin
    insert into contraintes.section(libelle,icone) values($1,$2);
    --RECUPERE L'IDENTIFIANT DU NOUVEL ESPACE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM contraintes.section WHERE oid=new_id;
    -- RAISE NOTICE 'insertion du bareme d''id: % (oid=%)',res, new_id;
    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_section(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 8623 (class 0 OID 0)
-- Dependencies: 1906
-- Name: FUNCTION af_set_section(character varying, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_section(character varying, integer) IS 'enregistre une section';


--
-- TOC entry 1550 (class 1255 OID 2596431)
-- Dependencies: 2983 5
-- Name: af_set_serie(character varying, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie(character varying, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 numero de bareme global
--$3 valeur du chrono global


res int4;
BEGIN	
	SELECT INTO res * FROM contraintes.af_set_serie($1,$2,$3,1);
		
	RETURN res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie(character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8625 (class 0 OID 0)
-- Dependencies: 1550
-- Name: FUNCTION af_set_serie(character varying, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie(character varying, integer, integer) IS 'Crée une série.';


--
-- TOC entry 1551 (class 1255 OID 2596432)
-- Dependencies: 2983 5
-- Name: af_set_serie(character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie(character varying, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 numero de bareme global
--$3 valeur du chrono global
--$4 type de la liste
new_id int4;
res int4;
BEGIN
	--RAISE NOTICE 'libelle=% bareme=% valeur=%',$1,$2, $3;
	INSERT INTO contraintes.etape(libelle, type) VALUES ($1, 4);
	GET DIAGNOSTICS new_id = RESULT_OID;
	
	SELECT INTO res id FROM contraintes.etape WHERE oid=new_id;
	
	INSERT INTO contraintes.liste (id, type) VALUES (res, $4);
	
	INSERT INTO contraintes.serie(id, bareme, chrono) VALUES (res, $2, $3);
	RETURN res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8627 (class 0 OID 0)
-- Dependencies: 1551
-- Name: FUNCTION af_set_serie(character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie(character varying, integer, integer, integer) IS 'FONCTION PRIVEE: Crée une série d''un type donné .';


--
-- TOC entry 1552 (class 1255 OID 2596433)
-- Dependencies: 2983 5
-- Name: af_set_serie_aleatoire(character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie_aleatoire(character varying, integer, integer, integer) RETURNS integer
    AS $_$declare
res int4;
begin
    SELECT INTO res * FROM contraintes.af_set_serie($1,$2,$3,1);
    insert into contraintes.serie_aleatoire(id,type) values(res,$4);
    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie_aleatoire(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8629 (class 0 OID 0)
-- Dependencies: 1552
-- Name: FUNCTION af_set_serie_aleatoire(character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie_aleatoire(character varying, integer, integer, integer) IS 'enregistre un serie aleatoire';


--
-- TOC entry 1553 (class 1255 OID 2596434)
-- Dependencies: 2983 5
-- Name: af_set_serie_aleatoire_melangee(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie_aleatoire_melangee(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
begin
    -- isertion dans serie aleatoire
    insert into contraintes.serie_aleatoire(id,type) values($1,1);
    insert into contraintes.serie_aleatoire_melangee(serie,formation,parcours) 
    values($1,$2,$3);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie_aleatoire_melangee(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8631 (class 0 OID 0)
-- Dependencies: 1553
-- Name: FUNCTION af_set_serie_aleatoire_melangee(integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie_aleatoire_melangee(integer, integer, integer) IS 'Enregistre une serie existante en mode aleatoire';


--
-- TOC entry 1554 (class 1255 OID 2596435)
-- Dependencies: 2983 5
-- Name: af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : stagiaire
declare
rec record;
precedent int4:=NULL;
ok boolean;
begin
    -- recuperation aleatoire des evaluations de la serie
    for rec in 
	select  $1, e_id, $2,$3,$4,e_type,cast(e_id * 0 + random()as integer) as ind 
	from contraintes.af_get_serie_evaluations($1) 
	as  (e_id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, e_type int4 )
	--left outer join contraintes.resultat_serie on (evaluation=e_id and id=$1)
	--where id is null order by ind limit 1
	order by ind
    
    loop
	insert into contraintes.serie_aleatoire_evaluations (serie,evaluation,formation,parcours,stagiaire,pere) 
	values ($1,rec.e_id,$2,$3,$4,precedent);
	precedent:=rec.e_id;
	if not found then
	    ok:=false;
	end if;
    end loop;
    --return ok;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8633 (class 0 OID 0)
-- Dependencies: 1554
-- Name: FUNCTION af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) IS 'remplit la table serie_aleatoire_melangee';


--
-- TOC entry 1907 (class 1255 OID 2596436)
-- Dependencies: 2983 5
-- Name: af_set_serie_aleatoire_multiserie_configuration(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie_aleatoire_multiserie_configuration(integer, integer[]) RETURNS boolean
    AS $_$declare
i int4;
begin
for i in array_lower($2,1) .. array_upper($2,1)
loop
    insert into contraintes.serie_aleatoire_multiserie values
    ($1,$2[i][1],$2[i][2],$2[i][3]);
end loop;
return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie_aleatoire_multiserie_configuration(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 8635 (class 0 OID 0)
-- Dependencies: 1907
-- Name: FUNCTION af_set_serie_aleatoire_multiserie_configuration(integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie_aleatoire_multiserie_configuration(integer, integer[]) IS 'enregistre la configuration d''une serie aleatoire multiserie';


--
-- TOC entry 1555 (class 1255 OID 2596437)
-- Dependencies: 2983 5
-- Name: af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : individu
declare
rec record;
rec2 record;
precedent int4:=NULL;
nb_insert integer:=0;
nb_to_insert integer:=0;
begin
    -- Boucle sur la recuperation de la configuration
    for rec in 
	select * from contraintes.af_get_serie_aleatoire_series_associations($1) 
        as (serie int4,serie_source int4,nb_evaluation int4,type_evaluations int4)
    loop
	-- ici on recupere aleatoirement les evaluations de la serie source
	nb_to_insert:=nb_to_insert+rec.nb_evaluation;
	for rec2 in 
	    select id,id * 0 + random() as ordre 
	    from contraintes.af_get_serie_evaluations(rec.serie_source)
	    as (id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 )
	    
	    where type=rec.type_evaluations order by ordre limit rec.nb_evaluation	
	loop
	    insert into contraintes.serie_aleatoire_evaluations (serie,evaluation,formation,parcours,stagiaire,pere,source) 
	    values ($1,rec2.id,$2,$3,$4,precedent,rec.serie_source);
	    
	    if not found then
		RETURN FALSE;
	    else
		nb_insert:=nb_insert+1;
	    end if;
	    precedent:=rec2.id;
	end loop;

    end loop;

RAISE NOTICE '-------------fin de la fonction: % == %',nb_insert,nb_to_insert;
    return nb_insert=nb_to_insert;   

end; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8637 (class 0 OID 0)
-- Dependencies: 1555
-- Name: FUNCTION af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) IS 'rempli la table serie_aleatoire_evaluation pour une serie aleatoire multiserie';


--
-- TOC entry 1556 (class 1255 OID 2596438)
-- Dependencies: 2983 5
-- Name: af_set_serie_aleatoire_multitheme_configuration(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie_aleatoire_multitheme_configuration(integer, integer[]) RETURNS boolean
    AS $_$declare
i int4;
tmp int4:=NULL;
begin
 
for i in array_lower($2,1) .. array_upper($2,1)
loop
    IF ($2[i][1]!=tmp OR tmp IS NULL)THEN
	tmp:=$2[i][1];
	RAISE NOTICE 'enregistre nveau theme: %',tmp;
	PERFORM * from contraintes.af_set_categorie_element_theme(19,tmp,$1);
    ELSE
	RAISE NOTICE 'pas nveau theme: %',tmp;
    END IF;
	
    insert into contraintes.serie_aleatoire_multitheme values
    ($1,$2[i][1],$2[i][2],$2[i][3]);
end loop;
return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie_aleatoire_multitheme_configuration(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 8639 (class 0 OID 0)
-- Dependencies: 1556
-- Name: FUNCTION af_set_serie_aleatoire_multitheme_configuration(integer, integer[]); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie_aleatoire_multitheme_configuration(integer, integer[]) IS 'enregistre la configuration d''une serie aleatoire multitheme';


--
-- TOC entry 1557 (class 1255 OID 2596439)
-- Dependencies: 2983 5
-- Name: af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : individu
declare
rec record;
rec2 record;
precedent int4:=NULL;
ok bool:=true;
begin
    -- Boucle sur la recuperation de la configuration
    for rec in 
	select * from contraintes.af_get_serie_aleatoire_themes_associations($1) 
        as (serie int4,theme_source int4,nb_evaluation int4,type_evaluations int4)
    loop
	-- ici on recupere aleatoirement les evaluations du theme source
	for rec2 in 
	    select id,id * 0 + random() as ordre 
	    from contraintes.af_get_theme_evaluations(rec.theme_source)
	    as (id int4, type int4 )
	    
	    where type=rec.type_evaluations order by ordre limit rec.nb_evaluation	
	loop
	    insert into contraintes.serie_aleatoire_evaluations (serie,evaluation,formation,parcours,stagiaire,pere) 
	    values ($1,rec2.id,$2,$3,$4,precedent);
	    precedent:=rec2.id;
	    if not found then
		ok:=false;
	    end if;
	    
	end loop;

    end loop;

    return ok;   

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8641 (class 0 OID 0)
-- Dependencies: 1557
-- Name: FUNCTION af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) IS 'remplit la table serie_aleatoire pour une serie aleatoire multitheme';


--
-- TOC entry 1908 (class 1255 OID 2596440)
-- Dependencies: 2983 5
-- Name: af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : seuil
-- $5 : etape retour
-- $6 : tentative
-- $7 : correction
-- $8 : blocage parcours
begin
    insert into contraintes.serie_bloquante (serie,formation,parcours,seuil,etape_retour,tentatives,correction,blocage_parcours) 
    values($1,$2,$3,$4,$5,$6,$7,$8);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) OWNER TO pgsql;

--
-- TOC entry 8643 (class 0 OID 0)
-- Dependencies: 1908
-- Name: FUNCTION af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) IS 'enregistre la configuration d''une serie bloquante';


--
-- TOC entry 1909 (class 1255 OID 2596441)
-- Dependencies: 2983 5
-- Name: af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 evaluation
--$2 serie
--$3 pere
--$4 commentaire
--$5 bareme
--$6 chrono
--$7 points

BEGIN
	INSERT INTO contraintes.serie_evaluations  (evaluation, serie,pere,commentaire,bareme,chrono, points)
	VALUES($1,$2,$3,$4,$5,$6,$7);

	RETURN $1;
END


$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 8645 (class 0 OID 0)
-- Dependencies: 1909
-- Name: FUNCTION af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) IS 'Associe une evaluation à une série.';


--
-- TOC entry 1558 (class 1255 OID 2596442)
-- Dependencies: 2983 5
-- Name: af_set_sondage(character varying, integer, boolean, integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_sondage(character varying, integer, boolean, integer[], integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type
--$3 radio
--$4 questions
--$5 reponses

i integer;
b_value boolean;
val_id integer;
BEGIN	

	SELECT INTO val_id * FROM contraintes.af_set_question_reponse($1, $2, $3, $4,$5 );

	

	RETURN val_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_sondage(character varying, integer, boolean, integer[], integer[]) OWNER TO postgres;

--
-- TOC entry 8647 (class 0 OID 0)
-- Dependencies: 1558
-- Name: FUNCTION af_set_sondage(character varying, integer, boolean, integer[], integer[]); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_sondage(character varying, integer, boolean, integer[], integer[]) IS 'Créer un Sondage complet';


--
-- TOC entry 1559 (class 1255 OID 2596443)
-- Dependencies: 2983 5
-- Name: af_set_src(character varying, integer, character varying, boolean, integer[], integer[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_src(character varying, integer, character varying, boolean, integer[], integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type (4 ou 5)
--$3 question commmune
--$4 radio?
--$5 questions
--$6 reponses
val_id int4;
BEGIN

	SELECT INTO val_id * FROM contraintes.af_set_question_reponse($1, $2, $4, $5,$6 );
	INSERT INTO contraintes.qsrc (id, question) VALUES (val_id, $3);

	RETURN val_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_src(character varying, integer, character varying, boolean, integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 1560 (class 1255 OID 2596444)
-- Dependencies: 2983 5
-- Name: af_set_test(character varying, boolean, boolean, integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_test(character varying, boolean, boolean, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 dynamique
--$3 continu
--$4 media
--$5 hauteur
--$6 largeur
res int4;
new_id int4;
BEGIN 
	INSERT INTO contraintes.etape(libelle, type) VALUES ($1, 4);
	GET DIAGNOSTICS new_id = RESULT_OID;
	
	SELECT INTO res id FROM contraintes.etape WHERE oid=new_id;
	
	INSERT INTO contraintes.liste (id, type) VALUES (res, 3);
	
	INSERT INTO contraintes.test(id, dynamique, continu) VALUES (res, $2, $3);

	IF $4 IS NOT NULL THEN
		INSERT INTO contraintes.media_test
		(test, media, hauteur, largeur)
		VALUES (res,$4, $5, $6);
	END IF;

	RETURN res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_test(character varying, boolean, boolean, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1561 (class 1255 OID 2596445)
-- Dependencies: 2983 5
-- Name: af_set_test_positionnement(integer, integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION af_set_test_positionnement(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 test
--$2 positionnement
--$3 id du positionnement pere
BEGIN
	--INSERT INTO contraintes.test_positionnements (test, positionnement, pere)
	--VALUES ($1, $2, $3);
	--RAISE EXCEPTION '% % % ',$1, $2, $3;
	PERFORM * FROM contraintes.af_gen_set_element('contraintes.test_positionnements', 'positionnement', $3, $2, ', test ', ','||$1, ' AND test='||$1);
	RETURN FOUND;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_test_positionnement(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1562 (class 1255 OID 2596446)
-- Dependencies: 2983 5
-- Name: af_set_theme(character varying, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION af_set_theme(character varying, integer) RETURNS integer
    AS $_$DECLARE
new_id int4;
res int4;
BEGIN
	
	insert into contraintes.theme(libelle,individu) VALUES($1,$2);

	--RECUPERE L'IDENTIFIANT DU NOUVEAU THEME
	GET DIAGNOSTICS new_id = RESULT_OID;

	select into res id from contraintes.theme where oid=new_id;
	return res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.af_set_theme(character varying, integer) OWNER TO postgres;

--
-- TOC entry 8652 (class 0 OID 0)
-- Dependencies: 1562
-- Name: FUNCTION af_set_theme(character varying, integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION af_set_theme(character varying, integer) IS 'CrÃ©er un nouveau theme';


--
-- TOC entry 1563 (class 1255 OID 2596447)
-- Dependencies: 2983 5
-- Name: ag_get_stagiaires_formation(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION ag_get_stagiaires_formation() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct i.id,i.nom,i.prenom
	from contraintes.fw_individu i,contraintes.classe_individus ci,contraintes.formation_participants fp
	where i.id=ci.individu and ci.classe=fp.classe
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.ag_get_stagiaires_formation() OWNER TO pgsql;

--
-- TOC entry 8654 (class 0 OID 0)
-- Dependencies: 1563
-- Name: FUNCTION ag_get_stagiaires_formation(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION ag_get_stagiaires_formation() IS 'retourne les stagiaires des formation de la plateforme';


--
-- TOC entry 1564 (class 1255 OID 2596448)
-- Dependencies: 2983 5
-- Name: check_alerte_dates(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_alerte_dates() RETURNS "trigger"
    AS $$DECLARE
 duree_jour varchar(255):=  NEW.jours ||' day'; 
BEGIN

IF NEW.formation IS NULL AND OLD.formation IS NOT NULL THEN
	RETURN NEW;
END IF;
IF NEW.date IS NULL THEN
 if NEW.jours is null THEN
	return new;
 else
  RAISE EXCEPTION 'pas de duree pour une date null';
 end if;
 
END IF;
--vÃÂ©rifie que la date est d'au moins un jour
IF (NEW.jours IS NULL OR NEW.jours <1)
THEN
 RAISE EXCEPTION 'UNE DUREE > 1 jour DOIT ETRE SPECIFIEE';
END IF;

--verifie que la date de l'alerte est bien comprise dans les dates de la formation
PERFORM * FROM contraintes.formation
WHERE contraintes.formation.id= NEW.formation 
AND  NEW.date BETWEEN contraintes.formation.date_debut AND contraintes.formation.date_fin 
AND ( NEW.date + CAST( duree_jour AS interval) ) < ( contraintes.formation.date_fin );

IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LA DATE ET LA DUREE DE L\' ALERTE NE SONT PAS COMPRISES DANS LES DATES DE LA FORMATION ';
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_alerte_dates() OWNER TO postgres;

--
-- TOC entry 8656 (class 0 OID 0)
-- Dependencies: 1564
-- Name: FUNCTION check_alerte_dates(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_alerte_dates() IS 'VÃ©rifie que la date de l''alerte est correcte et que sa durÃ©e est bien supÃ©rieure Ã  1 jour....';


--
-- TOC entry 1565 (class 1255 OID 2596449)
-- Dependencies: 2983 5
-- Name: check_calendrier_date(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_calendrier_date() RETURNS "trigger"
    AS $$DECLARE
duree_secondes varchar(255):=  NEW.duree ||' second'; 
BEGIN
PERFORM * FROM contraintes.formation
WHERE contraintes.formation.id= NEW.formation 
AND  NEW.date BETWEEN contraintes.formation.date_debut AND contraintes.formation.date_fin 
AND ( NEW.date + CAST( duree_secondes AS interval) ) < ( contraintes.formation.date_fin );
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LA DATE ET LA DUREE DE L\' ELEMENT DE CALENDRIER NE SONT PAS COMPRISES DANS LES DATES DE LA FORMATION ';
ELSE	
 RETURN NEW;
END IF;
END;						$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_calendrier_date() OWNER TO postgres;

--
-- TOC entry 8658 (class 0 OID 0)
-- Dependencies: 1565
-- Name: FUNCTION check_calendrier_date(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_calendrier_date() IS 'VÃ©rifie que la date de l''element de calendrier est bien compris dans les dates de la formation';


--
-- TOC entry 1566 (class 1255 OID 2596450)
-- Dependencies: 2983 5
-- Name: check_classe_organisme(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION check_classe_organisme() RETURNS "trigger"
    AS $$declare
ok bool;
res int4;
newres int4;
begin
    select into res distinct organisme from contraintes.af_get_classe_individus(NEW.classe,0,'asc',false)
    where organisme is not null ;
    ok:=found;
    
    if ok then
	select into newres organisme from contraintes.fw_get_individu(NEW.individu) 
	as (id int4,identifiant_md5 varchar,login varchar,password varchar,nom varchar,prenom varchar,adresse varchar,code varchar,ville varchar,
	   email varchar,tel_fix varchar,tel_port varchar,langue int4,organisme int4,photo int4);
	if res=newres or newres is null then
	    return NEW;
	else
	    raise exception 'La classe doit contenir que des individus de meme organisme ET/OU multi-organisme';
	    return NULL;
	end if;
    else
	return NEW;
    end if;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_classe_organisme() OWNER TO pgsql;

--
-- TOC entry 8660 (class 0 OID 0)
-- Dependencies: 1566
-- Name: FUNCTION check_classe_organisme(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION check_classe_organisme() IS 'verifie que les organismes de la classe sont identiques ET/OU NULL';


--
-- TOC entry 1567 (class 1255 OID 2596451)
-- Dependencies: 2983 5
-- Name: check_evaluation_qsrc_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_evaluation_qsrc_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.evaluation 
WHERE contraintes.evaluation.id=NEW.id
AND (contraintes.evaluation.type=4
OR contraintes.evaluation.type=5);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'EVALUATION DU QSRC DOIT ETRE DE TYPE QRC(4) ou SRC(5) ';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_evaluation_qsrc_type() OWNER TO postgres;

--
-- TOC entry 8662 (class 0 OID 0)
-- Dependencies: 1567
-- Name: FUNCTION check_evaluation_qsrc_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_qsrc_type() IS 'VÃ©rifie qu''un QSRC corresponde bien Ã  un type d''Ã©valuation SRC ou QRC';


--
-- TOC entry 1568 (class 1255 OID 2596452)
-- Dependencies: 2983 5
-- Name: check_evaluation_question_reponse_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_evaluation_question_reponse_type() RETURNS "trigger"
    AS $$DECLARE
v_type int4;
BEGIN

SELECT INTO v_type contraintes.evaluation.type FROM contraintes.evaluation 
WHERE contraintes.evaluation.id=NEW.id
AND (contraintes.evaluation.type=1
OR contraintes.evaluation.type=2
OR contraintes.evaluation.type=6);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'ERREUR (type=%):L\'EVALUATION DU QUESTION_REPONSE DOIT ETRE DE TYPE QCM(1) ou SONDAGE(2) ',v_type;
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_evaluation_question_reponse_type() OWNER TO postgres;

--
-- TOC entry 8664 (class 0 OID 0)
-- Dependencies: 1568
-- Name: FUNCTION check_evaluation_question_reponse_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_question_reponse_type() IS 'VÃ©rifie qu''un question_reponse correspond bien Ã  une Ã©valuation de type qcm ou sondage';


--
-- TOC entry 1569 (class 1255 OID 2596453)
-- Dependencies: 2983 5
-- Name: check_evaluation_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_evaluation_type() RETURNS "trigger"
    AS $$BEGIN
raise notice '% % ',new.id,tg_argv[0];
PERFORM * FROM contraintes.evaluation 
WHERE contraintes.evaluation.id=NEW.id
AND contraintes.evaluation.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'Le \' % \' DOIT ETRE DE TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_evaluation_type() OWNER TO postgres;

--
-- TOC entry 8666 (class 0 OID 0)
-- Dependencies: 1569
-- Name: FUNCTION check_evaluation_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_type() IS 'Fonction gÃ©nÃ©rique pour vÃ©rifier que le type d''un objet hÃ©ritant de evaluation est bien le bon. Le type requis est un entier passÃ© en parametre du trigger.';


--
-- TOC entry 1570 (class 1255 OID 2596454)
-- Dependencies: 2983 5
-- Name: check_evaluation_type2(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_evaluation_type2() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.evaluation
WHERE contraintes.evaluation.id=NEW.evaluation
AND contraintes.evaluation.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'EVALUATION associee au \' % \' doit etre de TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_evaluation_type2() OWNER TO postgres;

--
-- TOC entry 8668 (class 0 OID 0)
-- Dependencies: 1570
-- Name: FUNCTION check_evaluation_type2(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_type2() IS 'VÃ©rifie que le champ evaluation de la table appelante a bien le type spÃ©cifiÃ© par le trigger.';


--
-- TOC entry 1571 (class 1255 OID 2596455)
-- Dependencies: 2983 5
-- Name: check_evaluation_type2_question_reponse(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_evaluation_type2_question_reponse() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.evaluation
WHERE contraintes.evaluation.id=NEW.evaluation
AND ( contraintes.evaluation.type=1
OR contraintes.evaluation.type=2);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'EVALUATION associee au SERIE_BLOQUANTE_TENTATIVE_QUESTION_REPONSE doit etre de TYPE QCM(1) ou SONDAGE(2) ';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_evaluation_type2_question_reponse() OWNER TO postgres;

--
-- TOC entry 8670 (class 0 OID 0)
-- Dependencies: 1571
-- Name: FUNCTION check_evaluation_type2_question_reponse(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_type2_question_reponse() IS 'VÃ©rifie que le champ evaluation de la table appelante a bien le type sondage ou qcm.
';


--
-- TOC entry 1572 (class 1255 OID 2596456)
-- Dependencies: 2983 5
-- Name: check_exotlc_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_exotlc_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM contraintes.exotlc E
WHERE E.id= NEW.id 
AND E.type=TG_ARGV[0];

IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE TYPE DE L\'EXOTLC ASSOCIE AU % DOIT ETRE DE TYPE % ',TG_NAME,TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_exotlc_type() OWNER TO postgres;

--
-- TOC entry 8672 (class 0 OID 0)
-- Dependencies: 1572
-- Name: FUNCTION check_exotlc_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_exotlc_type() IS 'Fonction gÃ©nÃ©rique pour vÃ©rifier que le type d''un objet hÃ©ritant de exotlc est bien le bon. Le type requis est un entier passÃ© en parametre du trigger.';


--
-- TOC entry 1573 (class 1255 OID 2596457)
-- Dependencies: 2983 5
-- Name: check_fichier_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_fichier_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.fichier
WHERE contraintes.fichier.id=NEW.id
AND contraintes.fichier.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE FICHIER ASSOCIE AU \' % \' DOIT ETRE DE TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_fichier_type() OWNER TO postgres;

--
-- TOC entry 8674 (class 0 OID 0)
-- Dependencies: 1573
-- Name: FUNCTION check_fichier_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_fichier_type() IS 'Fonction gÃ©nÃ©rique pour vÃ©rifier que le type d''un objet hÃ©ritant de fichier est bien le bon. Le type requis est un entier passÃ© en parametre du trigger.';


--
-- TOC entry 1574 (class 1255 OID 2596458)
-- Dependencies: 2983 5
-- Name: check_fichier_types(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_fichier_types() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.fichier
WHERE contraintes.fichier.id=NEW.id
AND (contraintes.fichier.type=TG_ARGV[0] OR contraintes.fichier.type=TG_ARGV[1]);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE FICHIER ASSOCIE AU \' % \' DOIT ETRE DE TYPE % ou %', TG_RELNAME, TG_ARGV[0], TG_ARGV[1];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_fichier_types() OWNER TO postgres;

--
-- TOC entry 1575 (class 1255 OID 2596459)
-- Dependencies: 2983 5
-- Name: check_formateur_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_formateur_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.fw_individu_types
WHERE contraintes.fw_individu_types.individu=NEW.formateur
AND contraintes.fw_individu_types.type=2;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE FORMATEUR de la table \'%\'DOIT ETRE UN INDIVIDU POSSEDANT LE TYPE Formateur(2) ', TG_RELNAME;
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_formateur_type() OWNER TO postgres;

--
-- TOC entry 8677 (class 0 OID 0)
-- Dependencies: 1575
-- Name: FUNCTION check_formateur_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_formateur_type() IS 'vÃ©rifie que le formateur de la table appelante correspond bien Ã  un individu ayant le type formateur(2)';


--
-- TOC entry 1576 (class 1255 OID 2596460)
-- Dependencies: 2983 5
-- Name: check_intervenant(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_intervenant() RETURNS "trigger"
    AS $$BEGIN

IF NEW.intervenant IS NULL THEN
RETURN NEW;
END IF;

PERFORM * FROM contraintes.af_get_formation_individus_except_individus_types(NEW.formation,_int4'{1,5}') as (id int4,nom varchar,prenom varchar,organisme int4)
WHERE NEW.intervenant=id ;

IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\' INTERVENANT de la table \' % \' doit etre associe au groupe ', TG_RELNAME;
ELSE	
 RETURN NEW; 
END IF;

END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_intervenant() OWNER TO postgres;

--
-- TOC entry 8679 (class 0 OID 0)
-- Dependencies: 1576
-- Name: FUNCTION check_intervenant(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_intervenant() IS 'VÃ©rifie que le champ intervenant de la table appelante correspond bien Ã  un individu possedant le type intervenant (3)';


--
-- TOC entry 1577 (class 1255 OID 2596461)
-- Dependencies: 2983 5
-- Name: check_liste_resultats_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_liste_resultats_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.etape 
WHERE contraintes.etape.id=NEW.etape
AND contraintes.etape.type=4;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'ETAPE ASSOCIEE A LA LISTE DOIT ETRE DE TYPE LISTE(4) ';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_liste_resultats_type() OWNER TO postgres;

--
-- TOC entry 8681 (class 0 OID 0)
-- Dependencies: 1577
-- Name: FUNCTION check_liste_resultats_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_liste_resultats_type() IS 'VÃ©rifie que le champ etape de la table appelante a  bien le type liste(4)';


--
-- TOC entry 1578 (class 1255 OID 2596462)
-- Dependencies: 2983 5
-- Name: check_liste_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_liste_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.liste
WHERE contraintes.liste.id=NEW.id
AND contraintes.liste.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'La LISTE associee au \' % \' doit etre de TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_liste_type() OWNER TO postgres;

--
-- TOC entry 8683 (class 0 OID 0)
-- Dependencies: 1578
-- Name: FUNCTION check_liste_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_liste_type() IS 'Fonction gÃ©nÃ©rique qui vÃ©rifie que le champ id de la table appelante correspond bien Ã  une liste du type spÃ©cifiÃ© par le paremetre du trigger';


--
-- TOC entry 1579 (class 1255 OID 2596463)
-- Dependencies: 2983 5
-- Name: check_liste_type_serie(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_liste_type_serie() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.liste
WHERE contraintes.liste.id=NEW.id
AND( contraintes.liste.type=1
OR contraintes.liste.type=2);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'La LISTE associee à la série doit etre de TYPE serie(1) ou serie alétoire (2) ';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_liste_type_serie() OWNER TO postgres;

--
-- TOC entry 8685 (class 0 OID 0)
-- Dependencies: 1579
-- Name: FUNCTION check_liste_type_serie(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_liste_type_serie() IS 'VÃ©rifie qu''une champ id correspond bien Ã  une table de type serie ou serie alÃ©atoire';


--
-- TOC entry 1580 (class 1255 OID 2596464)
-- Dependencies: 2983 5
-- Name: check_media_question_reponse_element(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION check_media_question_reponse_element() RETURNS "trigger"
    AS $$DECLARE
cnt int4;
BEGIN
	SELECT INTO cnt COUNT(*) FROM contraintes.question_reponse_elements
	WHERE NEW.question_reponse=question_reponse
	AND (NEW.question_reponse_element=question_reponse_element OR NEW.question_reponse_element=question_reponse_element);

	IF cnt > 0 THEN
		RETURN NEW;
	ELSE
		RAISE EXCEPTION 'La ligne inseree dans media_question_reponse_element ne correspond pas à un element associé a un question reponse.';
	END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_media_question_reponse_element() OWNER TO pgsql;

--
-- TOC entry 1581 (class 1255 OID 2596465)
-- Dependencies: 2983 5
-- Name: check_modalite(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_modalite() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM contraintes.evenement
WHERE contraintes.evenement.formation= NEW.formation 
AND contraintes.evenement.date= NEW.date
AND contraintes.evenement.modalite=3;
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'PAS D''EVENEMENT DE TYPE ''PRESENTIEL''(3) POUR LA FORMATION % A LA DATE %',NEW.formation, NEW.date;
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_modalite() OWNER TO postgres;

--
-- TOC entry 8688 (class 0 OID 0)
-- Dependencies: 1581
-- Name: FUNCTION check_modalite(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_modalite() IS 'Vérifie qu''une intervention correspond bien à  un element de calendrier de type présentiel';


--
-- TOC entry 1582 (class 1255 OID 2596466)
-- Dependencies: 2983 5
-- Name: check_positionnement_evaluations_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_positionnement_evaluations_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM contraintes.positionnement
WHERE contraintes.positionnement.id= NEW.positionnement
AND contraintes.positionnement.type=TG_ARGV[0];

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'L\'ELEMENT INSERE DOIT CORRESPONDRE A UN POSITIONNEMENT DE TYPE TG_ARGV[0] ',TG_ARGV[0];
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_positionnement_evaluations_type() OWNER TO postgres;

--
-- TOC entry 8690 (class 0 OID 0)
-- Dependencies: 1582
-- Name: FUNCTION check_positionnement_evaluations_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_positionnement_evaluations_type() IS 'Fonction gÃ©nÃ©rique pour vÃ©rifier qu''un qrcs correspond Ã  un positionnement dont le type passÃ© en paramettre';


--
-- TOC entry 1583 (class 1255 OID 2596467)
-- Dependencies: 2983 5
-- Name: check_positionnement_questions_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_positionnement_questions_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM contraintes.question_reponse_element, contraintes.positionnement
WHERE contraintes.question_reponse_element.id= NEW.question 
AND contraintes.positionnement.id= NEW.positionnement
AND contraintes.question_reponse_element.type=contraintes.positionnement.type;

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'LE TYPE DE LA QUESTION DOIT CORRESPONDRE AU TYPE DU POSITIONNEMENT';
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_positionnement_questions_type() OWNER TO postgres;

--
-- TOC entry 8692 (class 0 OID 0)
-- Dependencies: 1583
-- Name: FUNCTION check_positionnement_questions_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_positionnement_questions_type() IS 'vÃ©rifie que le type des questions d''un postionnement correspond au type du positionnement';


--
-- TOC entry 1584 (class 1255 OID 2596468)
-- Dependencies: 2983 5
-- Name: check_positionnement_reponses_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_positionnement_reponses_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM contraintes.question_reponse_element, contraintes.positionnement
WHERE contraintes.question_reponse_element.id= NEW.reponse
AND contraintes.positionnement.id= NEW.positionnement
AND contraintes.question_reponse_element.type=contraintes.positionnement.type;

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'LE TYPE DE LA REPONSE DOIT CORRESPONDRE AU TYPE DU POSITIONNEMENT';
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_positionnement_reponses_type() OWNER TO postgres;

--
-- TOC entry 8694 (class 0 OID 0)
-- Dependencies: 1584
-- Name: FUNCTION check_positionnement_reponses_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_positionnement_reponses_type() IS 'vÃ©rifie que le type des reponses d''un postionnement correspond au type du positionnement';


--
-- TOC entry 1585 (class 1255 OID 2596469)
-- Dependencies: 2983 5
-- Name: check_qcm_elements_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_qcm_elements_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM contraintes.question_reponse
WHERE contraintes.question_reponse.id= NEW.question_reponse
AND (contraintes.question_reponse.type=1 OR
contraintes.question_reponse.type=4);
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE QUESTION_REPONSE DU QCM_ELEMENTS DOIT ETRE DE TYPE QCM(1) ou QRC (4) ';
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_qcm_elements_type() OWNER TO postgres;

--
-- TOC entry 8696 (class 0 OID 0)
-- Dependencies: 1585
-- Name: FUNCTION check_qcm_elements_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_qcm_elements_type() IS 'Vérifie qu''un qcm_elements correspond bien Ã  un question_reponse de type qcm ou qrc
';


--
-- TOC entry 1586 (class 1255 OID 2596470)
-- Dependencies: 2983 5
-- Name: check_qrc_correction_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_qrc_correction_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.evaluation 
WHERE contraintes.evaluation.id=NEW.qrc
AND contraintes.evaluation.type=4;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'UN QRC_CORRECTION DOIT CORRESPONDRE A UNE EVALUATION DE TYPE QRC (1)';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_qrc_correction_type() OWNER TO postgres;

--
-- TOC entry 8698 (class 0 OID 0)
-- Dependencies: 1586
-- Name: FUNCTION check_qrc_correction_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_qrc_correction_type() IS 'VÃ©rifie qu''un element de la table qrc_correction correspond bien a une evaluation de type qrc';


--
-- TOC entry 1587 (class 1255 OID 2596471)
-- Dependencies: 2983 5
-- Name: check_qsrc_positionnement_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_qsrc_positionnement_type() RETURNS "trigger"
    AS $$DECLARE
        -- on met la requete dans une chaine que l'on execute ensuite
        req varchar ;
	type_evaluation int4;
	type_question int4;
BEGIN

--on recupere le type de l'evaluation qui doit etre QRC(4) ou SRC(5) 
SELECT type INTO type_evaluation FROM contraintes.evaluation E, contraintes.qsrc QSRC
WHERE E.id=QSRC.id
AND QSRC.positionnement=NEW.id;

--si pas d'enregistrement dans la table evaluation, il ne s'agit pas d'un src ou d'un qrc
IF(NOT FOUND)THEN
	RETURN NEW;
END IF;

--on recupere le type_question du positionnement qui doit etre QCM(1) ou SONDAGE(2)
type_question:=NEW.type_question;

IF(type_evaluation=4)THEN
	IF(type_question=1)THEN
		RETURN NEW;
	ELSE
		RAISE EXCEPTION 'UN POSITIONNEMENT DE TYPE QCM(1) DOIT CORRESPONDRE A UN QRC(4)';
	END IF;
ELSE
	IF(type_evaluation=5)THEN
		IF(type_question=2)THEN
			RETURN NEW;
		ELSE
			RAISE EXCEPTION 'UN POSITIONNEMENT DE TYPE SONDAGE(2) DOIT CORRESPONDRE A UN SRC(5)';
		END IF;
	END IF;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_qsrc_positionnement_type() OWNER TO postgres;

--
-- TOC entry 8700 (class 0 OID 0)
-- Dependencies: 1587
-- Name: FUNCTION check_qsrc_positionnement_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_qsrc_positionnement_type() IS 'VÃ©rifie que les type d''un positionnement correspond bien au type de l''Ã©valuation:
QCM=>QRC
Sondage=>SRC';


--
-- TOC entry 40 (class 1255 OID 2596472)
-- Dependencies: 2983 5
-- Name: check_question_reponse_element_pere_types(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_question_reponse_element_pere_types() RETURNS "trigger"
    AS $$declare
    rec1 boolean;
    rec2 boolean;
begin
    if new.pere is not null then
	select into rec1 reponse from contraintes.question_reponse_element where id=new.question_reponse_element;
	select into rec2 reponse from contraintes.question_reponse_element where id=new.pere;
	raise notice 'rec2=%',rec2;
	if rec1=rec2 then
	    return new;
	else
	    raise exception 'le question_reponse_element et le pere doivent être tous les deux question ou reponse';
	    return null;
	end if;
    else
        return new;
    end if;
    
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_question_reponse_element_pere_types() OWNER TO postgres;

--
-- TOC entry 8702 (class 0 OID 0)
-- Dependencies: 40
-- Name: FUNCTION check_question_reponse_element_pere_types(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_question_reponse_element_pere_types() IS 'vérifie q''un question_reponse_element et un pere sont de même type (question ou reponse)';


--
-- TOC entry 1588 (class 1255 OID 2596473)
-- Dependencies: 2983 5
-- Name: check_question_reponse_elements_types(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_question_reponse_elements_types() RETURNS "trigger"
    AS $$DECLARE
rec RECORD;
BEGIN
/*SELECT INTO rec QR.type AS T1 , Q.type AS T2, R.type AS T3 FROM contraintes.question_reponse QR,contraintes.question_reponse_element Q, contraintes.question_reponse_element R
WHERE QR.id=NEW.question_reponse
AND Q.id= NEW.question 
AND R.id= NEW.reponse 
AND QR.type=Q.type
AND QR.type=R.type;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'QUESTION_REPONSE_ELEMENTS: LE QUESTION_REPONSE % (type=%), LA QUESTION % (type=%) ET LA REPONSE % (type=%) DOIVENT ETRE DE MEMES TYPES', NEW.question_reponse,rec.T1, NEW.question, rec.T2, NEW.reponse, rec.T3;
ELSE	*/
 RETURN NEW;
--END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_question_reponse_elements_types() OWNER TO postgres;

--
-- TOC entry 8703 (class 0 OID 0)
-- Dependencies: 1588
-- Name: FUNCTION check_question_reponse_elements_types(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_question_reponse_elements_types() IS 'VÃ©rifie l''Ã©galitÃ© des types entre un question_reponse_elements, la question, et la reponse
';


--
-- TOC entry 1589 (class 1255 OID 2596474)
-- Dependencies: 2983 5
-- Name: check_ressource_dates(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_ressource_dates() RETURNS "trigger"
    AS $$DECLARE 
formation_date_debut TIMESTAMP; 
formation_date_fin TIMESTAMP; 
fin_nouveaute TIMESTAMP;
duree_jour varchar(255):=  NEW.duree_nouveaute ||' day'; 

BEGIN
SELECT date_debut INTO formation_date_debut 
FROM contraintes.formation
WHERE contraintes.formation.id= NEW.formation;

SELECT date_fin INTO formation_date_fin 
FROM contraintes.formation
WHERE contraintes.formation.id= NEW.formation;

fin_nouveaute:=NEW.debut_disponibilite+CAST(duree_jour AS INTERVAL);

IF(formation_date_fin<fin_nouveaute)
THEN
	RAISE EXCEPTION 'La duree de nouveaute est superieure a la date de fin de la formation';
END IF;

IF( 
((NEW.debut_disponibilite IS NOT NULL)AND(NEW.debut_disponibilite NOT BETWEEN formation_date_debut AND formation_date_fin))
OR ((NEW.fin_disponibilite IS NOT NULL)AND(NEW.fin_disponibilite NOT BETWEEN formation_date_debut AND formation_date_fin))
)
THEN
	RAISE EXCEPTION 'Les dates de disponibilite et d\'indisponibilite de la ressource doivent etre comprises dans les dates de la formation';	
END IF;

IF(NEW.debut_disponibilite IS NOT NULL
AND NEW.fin_disponibilite IS NOT NULL)
THEN
	IF(NEW.debut_disponibilite > NEW.fin_disponibilite)
	THEN
		RAISE EXCEPTION 'Une ressource doit avoir une date d\'indisponibilite ANTERIEURE a sa date de disponibilite';
	ELSE
		RETURN NEW;
	END IF;
ELSE
	RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_ressource_dates() OWNER TO postgres;

--
-- TOC entry 8705 (class 0 OID 0)
-- Dependencies: 1589
-- Name: FUNCTION check_ressource_dates(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_ressource_dates() IS 'Verifie la compatibilitÃ© des dates d''une ressource avec celles de la formation qui lui est associÃ©e';


--
-- TOC entry 1590 (class 1255 OID 2596475)
-- Dependencies: 2983 5
-- Name: check_ressource_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_ressource_type() RETURNS "trigger"
    AS $$BEGIN

--RAISE EXCEPTION 'trigger!';
PERFORM * FROM contraintes.fichier
WHERE contraintes.fichier.id=NEW.id
AND (contraintes.fichier.type=1 OR contraintes.fichier.type=7 OR contraintes.fichier.type=5 OR contraintes.fichier.type=15 OR contraintes.fichier.type=17);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE FICHIER DE LA RESSOURCE DOIT ETRE DE TYPE 1 ou 7 ou 5 ou 15';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_ressource_type() OWNER TO postgres;

--
-- TOC entry 8707 (class 0 OID 0)
-- Dependencies: 1590
-- Name: FUNCTION check_ressource_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_ressource_type() IS 'Fonction gÃ©nÃ©rique pour vÃ©rifier que le type de fichier pour une ressource est bien le bon. Le type requis est un entier passÃ© en parametre du trigger.';


--
-- TOC entry 1591 (class 1255 OID 2596476)
-- Dependencies: 2983 5
-- Name: check_serie_aleatoire_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_serie_aleatoire_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.serie_aleatoire
WHERE contraintes.serie_aleatoire.id=NEW.serie
AND contraintes.serie_aleatoire.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'La SERIE_ALEATOIRE associee au \' % \' doit etre de TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_serie_aleatoire_type() OWNER TO postgres;

--
-- TOC entry 8709 (class 0 OID 0)
-- Dependencies: 1591
-- Name: FUNCTION check_serie_aleatoire_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_serie_aleatoire_type() IS 'Fonction gÃ©nÃ©rique qui verifie que le type d''une serie alÃ©atoire est bien du type spÃ©cifiÃ© en parametre.
';


--
-- TOC entry 1592 (class 1255 OID 2596477)
-- Dependencies: 2983 5
-- Name: check_serie_evaluation(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION check_serie_evaluation() RETURNS "trigger"
    AS $$DECLARE
r_type integer;
BEGIN
	SELECT INTO r_type type 
	FROM contraintes.evaluation
	WHERE id=NEW.evaluation;

	IF (r_type IN (2,5)) 
		AND (NEW.bareme IS NOT NULL OR NEW.points IS NOT NULL) 
	THEN
		RAISE EXCEPTION 'Impossible d''associer un bareme (%) et/ou des points (%) pour la série % et l''evaluation % .Le type % ne les acceptent pas.',NEW.bareme, NEW.points, NEW.serie, NEW.evaluation, r_type;
		RETURN NULL;
	ELSE
		RETURN NEW;
	END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_serie_evaluation() OWNER TO pgsql;

--
-- TOC entry 1593 (class 1255 OID 2596478)
-- Dependencies: 2983 5
-- Name: check_stagiaire_formation(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_stagiaire_formation() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM contraintes.formation_participants FP, contraintes.classe_individus CI
WHERE FP.formation= NEW.formation 
AND CI.individu=NEW.stagiaire
AND FP.classe= CI.classe;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE STAGIAIRE N\'EST PAS DANS LA CLASSE ASSOCIEE A LA FORMATION';
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_stagiaire_formation() OWNER TO postgres;

--
-- TOC entry 8712 (class 0 OID 0)
-- Dependencies: 1593
-- Name: FUNCTION check_stagiaire_formation(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_stagiaire_formation() IS 'VÃ©rifie que le stagiaire est bien prÃ©sent dans la classe d''une formation';


--
-- TOC entry 1594 (class 1255 OID 2596479)
-- Dependencies: 2983 5
-- Name: check_stagiaire_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_stagiaire_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.fw_individu_types
WHERE contraintes.fw_individu_types.individu=NEW.stagiaire
AND contraintes.fw_individu_types.type=1;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'Le STAGIAIRE de la table \' % \' doit etre de TYPE Stagiaire(1) ', TG_RELNAME;
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_stagiaire_type() OWNER TO postgres;

--
-- TOC entry 8714 (class 0 OID 0)
-- Dependencies: 1594
-- Name: FUNCTION check_stagiaire_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_stagiaire_type() IS 'VÃ©rifie que le champ stagiaire de la table appelante correspond bien Ã  un individu possedant le type stagiaire (1)';


--
-- TOC entry 1595 (class 1255 OID 2596480)
-- Dependencies: 2983 5
-- Name: check_type_etape(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_type_etape() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.etape 
WHERE contraintes.etape.id=NEW.id
AND contraintes.etape.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'ETAPE ASSOCIEE AU \' % \' DOIT ETRE DE TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_type_etape() OWNER TO postgres;

--
-- TOC entry 8716 (class 0 OID 0)
-- Dependencies: 1595
-- Name: FUNCTION check_type_etape(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_type_etape() IS 'Fonction gÃ©nÃ©rique pour vÃ©rifier que le type d''un objet hÃ©ritant de etape est bien le bon. Le type requis est un entier passÃ© en parametre du trigger.';


--
-- TOC entry 1596 (class 1255 OID 2596481)
-- Dependencies: 2983 5
-- Name: check_type_question(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_type_question() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM contraintes.question_reponse_element
WHERE contraintes.question_reponse_element.reponse= FALSE 
AND contraintes.question_reponse_element.id= NEW.id ;

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'ERREUR TYPAGE QUESTION';
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_type_question() OWNER TO postgres;

--
-- TOC entry 8718 (class 0 OID 0)
-- Dependencies: 1596
-- Name: FUNCTION check_type_question(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_type_question() IS 'VÃ©rifie qu''une question est bien un question_reponse_element de type question';


--
-- TOC entry 1597 (class 1255 OID 2596482)
-- Dependencies: 2983 5
-- Name: check_type_reponse(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION check_type_reponse() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM contraintes.question_reponse_element
WHERE contraintes.question_reponse_element.reponse= TRUE 
AND contraintes.question_reponse_element.id= NEW.id ;

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'ERREUR TYPAGE REPONSE';
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.check_type_reponse() OWNER TO postgres;

--
-- TOC entry 8720 (class 0 OID 0)
-- Dependencies: 1597
-- Name: FUNCTION check_type_reponse(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION check_type_reponse() IS 'VÃ©rifie qu''une reponse est bien un question_reponse_element de type reponse';


--
-- TOC entry 1598 (class 1255 OID 2596483)
-- Dependencies: 2983 5
-- Name: cls_check_classe_organisme(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION cls_check_classe_organisme() RETURNS "trigger"
    AS $$declare
ok bool;
res int4;
newres int4;
begin
    select into res distinct organisme from contraintes.cls_get_classe_individus(NEW.classe,0,'asc',false)
    where organisme is not null ;
    ok:=found;
    
    if ok then
	select into newres organisme from contraintes.af_get_individu(NEW.individu) 
	as (id int4,identifiant_md5 varchar,login varchar,password varchar,nom varchar,prenom varchar,adresse varchar,code varchar,ville varchar,
	   email varchar,tel_fix varchar,tel_port varchar,langue int4,organisme int4,photo int4);
	if res=newres or newres is null then
	    return NEW;
	else
	    raise exception 'La classe doit contenir que des individus de meme organisme ET/OU multi-organisme';
	    return NULL;
	end if;
    else
	return NEW;
    end if;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.cls_check_classe_organisme() OWNER TO pgsql;

--
-- TOC entry 8722 (class 0 OID 0)
-- Dependencies: 1598
-- Name: FUNCTION cls_check_classe_organisme(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION cls_check_classe_organisme() IS 'verifie que les organismes de la classe sont identiques ET/OU NULL';


--
-- TOC entry 1599 (class 1255 OID 2596484)
-- Dependencies: 2151 2983 5
-- Name: cls_get_classe_individus(integer, integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean) RETURNS SETOF fw_organisme_type_individu
    AS $_$-- Parametres :
-- 1. Identifiant de la classe
-- 2. Type : 0=tous, 1=formateurs & 2=stagiaires
-- 3. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 4. exclusif : si VRAI alors que les 'u' ou les 'f'
declare
rec record;
rec2 contraintes.fw_organisme_type_individu;
req varchar;
begin
    for rec in 
	select id,nom,prenom,organisme 
	from contraintes.fw_get_individus($2,$3,$4) as (id int4,nom varchar,prenom varchar,organisme int4),contraintes.cls_classe_individus CI 
	where CI.classe=$1 and CI.individu=id
    loop
	rec2.id:=rec.id;
	rec2.nom:=rec.nom;
	rec2.prenom:=rec.prenom;
	rec2.organisme:=rec.organisme;
	rec2.types:=NULL;
	return next rec2;
	--return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.cls_get_classe_individus(integer, integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 8724 (class 0 OID 0)
-- Dependencies: 1599
-- Name: FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean) IS 'retourne les nÂ°,nom prenom et tabtype des individu d''une classe';


--
-- TOC entry 1600 (class 1255 OID 2596485)
-- Dependencies: 2983 5
-- Name: copy_langue(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION copy_langue() RETURNS boolean
    AS $$declare
rec record;
begin
for rec in 
    select * from contraintes.langue_message where langue=1
loop
    insert into contraintes.langue_message(id,langue,type,libelle) values(rec.id,8,rec.type,rec.libelle);
    --raise notice 'id=% type=% libelle=%',rec.id,rec.type,rec.libelle;	
end loop;
return true;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.copy_langue() OWNER TO pgsql;

--
-- TOC entry 8726 (class 0 OID 0)
-- Dependencies: 1600
-- Name: FUNCTION copy_langue(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION copy_langue() IS 'copie une nouvelle langue
(portuguais à partir du francais)';


--
-- TOC entry 1601 (class 1255 OID 2596486)
-- Dependencies: 2983 5
-- Name: create_error(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION create_error() RETURNS "trigger"
    AS $$BEGIN

	RAISE EXCEPTION 'erreur sur la table';

END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.create_error() OWNER TO pgsql;

--
-- TOC entry 8728 (class 0 OID 0)
-- Dependencies: 1601
-- Name: FUNCTION create_error(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION create_error() IS 'cette fonction est utile pour générer une erreur lors d''une action quelquonque sur une table';


--
-- TOC entry 1602 (class 1255 OID 2596487)
-- Dependencies: 2983 5
-- Name: del_classe(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_classe() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS DE LA CLASSE
	-- avec ses individus
	delete from classe_individu where classe=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_classe() OWNER TO www;

--
-- TOC entry 8730 (class 0 OID 0)
-- Dependencies: 1602
-- Name: FUNCTION del_classe(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_classe() IS 'Supprime la totalitÃ© des enregistrements liÃ©s Ã  une classe.';


--
-- TOC entry 1603 (class 1255 OID 2596488)
-- Dependencies: 2983 5
-- Name: del_classe_individu(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_classe_individu() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS D'UNE CLASSE ET D'UN INDIVIDU
	--avec ses droits
	delete from individu_droits where classe=new.classe and individu=new.individu;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_classe_individu() OWNER TO www;

--
-- TOC entry 8732 (class 0 OID 0)
-- Dependencies: 1603
-- Name: FUNCTION del_classe_individu(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_classe_individu() IS 'Supprime la totalitÃ© des enregistrements liÃ©s Ã  une classe et un individu.';


--
-- TOC entry 1604 (class 1255 OID 2596489)
-- Dependencies: 2983 5
-- Name: del_etape(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_etape() RETURNS "trigger"
    AS $$begin
	--SUPPRIME UNE ETAPE ASSOCIEE A UN ELEMENT
	delete from contraintes.etape where id=old.id;
	
	return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_etape() OWNER TO www;

--
-- TOC entry 8734 (class 0 OID 0)
-- Dependencies: 1604
-- Name: FUNCTION del_etape(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_etape() IS 'Supprime la totalitÃ© des enregistrements liÃ©s Ã  une Ã©tape.';


--
-- TOC entry 1605 (class 1255 OID 2596490)
-- Dependencies: 2983 5
-- Name: del_etape_resultats(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_etape_resultats() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS (FORMATION,STAGIAIRE,ETAPE)
	--avec les tentatives de sÃÂ©ries bloquantes (question_reponse)
	delete from serie_bloquante_tentative_question_reponse where
		formation=new.formation and
		stagiaire=new.stagiaire and
		serie=new.etape;
	--avec les tentatives de sÃÂ©rie bloquantes (remplir les blancs)
	delete from serie_bloquante_tentative_ftb where
		formation=new.formation and
		stagiaire=new.stagiaire and
		serie=new.etape;
	--avec les positionnements
	delete from test_resultats_positionnement where
		formation=new.formation and
		stagiaire=new.stagiaire and
		test=new.etape;
	--avec les questions reponses des positionnements 
	delete from positionnement_resultats_question_reponse where
		formation=new.formation and
		stagiaire=new.stagiaire and
		test=new.etape;
	--avec les resultats des sÃÂ©rie de remplir les blancs
	delete from serie_resultats_ftb where
		formation=new.formation and
		stagiaire=new.stagiaire and
		serie=new.etape;
	--avec les rÃÂ©sultats des sÃÂ©rie de questions reponses
	delete from serie_resultats_question_reponse where
		formation=new.formation and
		stagiaire=new.stagiaire and
		serie=new.etape;
	--avec les rÃÂ©sultats des listes
	delete from liste_resultats where
		formation=new.formation and
		stagiaire=new.stagiaire and
		liste=new.etape;
	--avec les resultats des sous critÃÅ¡res des exercices ÃÂ  tÃÂ©lÃÂ©charger
	delete from exotlc_resultats_sous_criteres where
		formation=new.formation and
		stagiaire=new.stagiaire and
		exotlc=new.etape;
	--avec les resultats des critÃÅ¡res des exercices ÃÂ  tÃÂ©lÃÂ©charger
	delete from exotlc_resultats_criteres where
		formation=new.formation and
		stagiaire=new.stagiaire and
		exotlc=new.etape;
	--avec les rÃÂ©sultats des ecercices ÃÂ  tÃÂ©lÃÂ©charger
	delete from exotlc_resultats where
		formation=new.formation and
		stagiaire=new.stagiaire and
		exotlc=new.etape;
	
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_etape_resultats() OWNER TO www;

--
-- TOC entry 8736 (class 0 OID 0)
-- Dependencies: 1605
-- Name: FUNCTION del_etape_resultats(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_etape_resultats() IS 'Supprime la totalitÃ©  des enregistrements liÃ©s Ã  une formation,un stagiaire et une etape.';


--
-- TOC entry 1606 (class 1255 OID 2596491)
-- Dependencies: 2983 5
-- Name: del_evaluation(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_evaluation() RETURNS "trigger"
    AS $$begin
	--SUPPRIME UNE EVALUATION ASSOCIEE A UN ELEMENT
	delete from contraintes.evaluation where id=old.id;
	
	return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_evaluation() OWNER TO www;

--
-- TOC entry 8738 (class 0 OID 0)
-- Dependencies: 1606
-- Name: FUNCTION del_evaluation(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_evaluation() IS 'Supprime un element d'' evaluation de la table evaluation';


--
-- TOC entry 1607 (class 1255 OID 2596492)
-- Dependencies: 2983 5
-- Name: del_evenement_presentiel(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_evenement_presentiel() RETURNS "trigger"
    AS $$
begin
    if old.modalite=3 then
    delete from contraintes.evenement_presentiel 
    where old.formation=contraintes.evenement_presentiel.formation and old.date=contraintes.evenement_presentiel.date;
    end if;
    return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_evenement_presentiel() OWNER TO pgsql;

--
-- TOC entry 8740 (class 0 OID 0)
-- Dependencies: 1607
-- Name: FUNCTION del_evenement_presentiel(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION del_evenement_presentiel() IS 'supprime un evet pres';


--
-- TOC entry 1608 (class 1255 OID 2596493)
-- Dependencies: 2983 5
-- Name: del_exotlc(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION del_exotlc() RETURNS "trigger"
    AS $$BEGIN

	--supprime ses resultats
	DELETE FROM exotlc_resultats 
	WHERE exotlc=NEW.id;

	--supprime l'association avec ses fichiers d'exotlc
	DELETE FROM exotlc_fichiers
	WHERE exotlc=NEW.id;

	--supprime l'association avec ses fichiers de correction
	DELETE FROM exotlc_corrections
	WHERE exotlc=NEW.id;

	
RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_exotlc() OWNER TO postgres;

--
-- TOC entry 1609 (class 1255 OID 2596494)
-- Dependencies: 2983 5
-- Name: del_fichier_correction(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_fichier_correction() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATION D'UN FICHIER DE CORRECTION
	--avec ses exotlc
	delete from exotlc_corrections where correction=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_fichier_correction() OWNER TO www;

--
-- TOC entry 8743 (class 0 OID 0)
-- Dependencies: 1609
-- Name: FUNCTION del_fichier_correction(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_fichier_correction() IS 'Supprime la totalitÃ© des enregistrement liÃ©s Ã  un fichier de correction.';


--
-- TOC entry 1610 (class 1255 OID 2596495)
-- Dependencies: 2983 5
-- Name: del_fichier_exotlc(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_fichier_exotlc() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS D'UN FICHIER
	--avec ses exotlc
	delete from exotlc_fichiers where fichier=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_fichier_exotlc() OWNER TO www;

--
-- TOC entry 8745 (class 0 OID 0)
-- Dependencies: 1610
-- Name: FUNCTION del_fichier_exotlc(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_fichier_exotlc() IS 'Supprime la totalitÃ© des enregistrements liÃ©s Ã  un fichier d''exotlc';


--
-- TOC entry 1611 (class 1255 OID 2596496)
-- Dependencies: 2983 5
-- Name: del_formation(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_formation() RETURNS "trigger"
    AS $$begin
	-- SUPPRIME LES ASSOCIATIONS DE LA FORMATION
	--avec ses forums
	delete from formation_forums where formation=new.id;
	--avec ses langues
	delete from formation_langues where formation=new.id;
	--avec ses ressources
	delete from formation_ressources where formation=new.id;
	--avec les avancements des individus
	delete from formation_avancement where formation=new.id;
	--avec les droits (du formateur)
	delete from droits_formateur where formation=new.id;
	--avec ses participants (formateur et classe)
	delete from formation_participants where formation=new.id;
	--avec ses grilles de resultats 
	delete from grille_resultats where formation=new.id;
	--avec ses dates de cours prÃÂ©sentiel
	delete from calendrier_presentiel where formation=new.id;
	--avec les etapes (des stagiaires)
	delete from etape_resultats where formation=new.id;
	--avec ses sÃÂ©ries alÃÂ©atoires configurÃÂ©es
	delete from serie_aleatoire_configuree where formation=new.id;
	--avec ses sÃÂ©ries bloquantes
	delete from serie_bloquante where formation=new.id;
	--avec ses cours
	delete from calendrier where formation=new.id;
	--avec ses alertes
	delete from alerte where formation=new.id;
	--avec les sessions des individus
	delete from "session" where formation=new.id;
	--avec ses commentaires pour sÃÂ©rie
	delete from page_serie_commentaire where formation=new.id;
	--avec ses titres de sÃÂ©rie
	delete from page_serie_titre where formation=new.id;
	--avec ses commentaires
	delete from page_commentaire where formation=new.id;
	--avec ses configurations de pages d'annuaire
	delete from page_annuaire_configuration where formation=new.id;
	--avec ses configuration de pages de sÃÂ©rie
	delete from page_serie_configuration where formation=new.id;
	--avec ses evaluations de sÃÂ©ries aleatoires
	delete from serie_aleatoire_evaluations where formation=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_formation() OWNER TO www;

--
-- TOC entry 8747 (class 0 OID 0)
-- Dependencies: 1611
-- Name: FUNCTION del_formation(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_formation() IS 'supprime la totalitÃ© des enregistrements liÃ©s Ã  une formation';


--
-- TOC entry 1612 (class 1255 OID 2596497)
-- Dependencies: 2983 5
-- Name: del_individu(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_individu() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS INDIVIDU
	--avec sa classe
	delete from classe_individu where individu=new.id;
	--avec ses types
	delete from fw_individu_types where individu=new.id;
	--avec ses grilles de resultats
	delete from grille_resultats where stagiaire=new.id;
	--avec ses grilles
	delete from stagiaire_grille where stagiaire=new.id;
	--avec ses commentaires de pages serie
	delete from page_serie_commentaire where stagiaire=new.id;
	--avec ses commentaires de pages
	delete from page_commentaire where stagiaire=new.id;
	--avec ses connexions
	delete from connexion where individu=new.id; 
	--avec ses ÃÂ©tapes
	delete from etape_resultats where stagiaire=new.id;
	--avec son avancement
	delete from formation_avancement where stagiaire=new.id;
	--avec ses ÃÂ©valuations de sÃÂ©ries alÃÂ©atoires
	delete from serie_aleatoire_evaluations where stagiaire=new.id;
	-- NOTE : DÃÂ©calage ÃÂ  prÃÂ©voir car suppression d'evaluations qui peuvent ÃÂªtre pÃÅ¡re et suppression d'un pÃÅ¡re (A Suivre ....)



	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_individu() OWNER TO www;

--
-- TOC entry 8749 (class 0 OID 0)
-- Dependencies: 1612
-- Name: FUNCTION del_individu(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_individu() IS 'supprime la totalitÃ© des enregistrement liÃ©s Ã  un individu.';


--
-- TOC entry 1613 (class 1255 OID 2596498)
-- Dependencies: 2983 5
-- Name: del_parcours(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_parcours() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS DU PARCOURS
	--avec ses etapes
	delete from contraintes.parcours_etapes where parcours=old.id;
	--avec son orientation
	delete from contraintes.parcours_oriente where id=old.id;
	
	return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_parcours() OWNER TO www;

--
-- TOC entry 8751 (class 0 OID 0)
-- Dependencies: 1613
-- Name: FUNCTION del_parcours(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_parcours() IS 'Supprime la totalitÃƒÂ© des enregistrements liÃƒÂ©s ÃƒÂ  un parcours';


--
-- TOC entry 1614 (class 1255 OID 2596499)
-- Dependencies: 2983 5
-- Name: del_parcours_etape(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_parcours_etape() RETURNS "trigger"
    AS $$declare
rec record;
begin
    select into rec * from contraintes.af_get_etape(old.etape) as (id int4, libelle varchar, type int4, date_creation timestamp);
    if rec.type=10 then
	perform * from contraintes.af_del_etape(old.etape);
    end if;
    return old;

end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_parcours_etape() OWNER TO pgsql;

--
-- TOC entry 8753 (class 0 OID 0)
-- Dependencies: 1614
-- Name: FUNCTION del_parcours_etape(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION del_parcours_etape() IS 'pour supprimer l''etape de type 10
(etape oriente)';


--
-- TOC entry 1615 (class 1255 OID 2596500)
-- Dependencies: 2983 5
-- Name: del_positionnement(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION del_positionnement() RETURNS "trigger"
    AS $$BEGIN

--supprime les media associÃÂ©s au positionnement
DELETE FROM media_positionnement WHERE positionnement=NEW.id;

--supprime les media associÃÂ©s ÃÂ  un la reponse d'un positionnement
DELETE FROM media_positionnement_reponse WHERE positionnement=NEW.id;

--supprime les reponses d'un positionnement
DELETE FROM positionnement_reponses WHERE positionnement=NEW.id;

--supprime les questions d'un positionnement
DELETE FROM positionnement_questions WHERE positionnement=NEW.id;

--supprime les evaluations gÃÂ©nÃÂ©rÃÂ©es d'un positionnement
DELETE FROM positionnement_evaluations WHERE positionnement=NEW.id;

--supprime la configuration du nombre d'exercices gÃÂ©nÃÂ©rÃÂ©s d'un positionnement de type qcm
DELETE FROM positionnement_qcm_evaluations WHERE positionnement=NEW.id;

--supprime la configuration du nombre d'exercices gÃÂ©nÃÂ©rÃÂ©s d'un positionnement de type sondage
DELETE FROM positionnement_qcm_sondages WHERE positionnement=NEW.id;

RETURN NEW;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_positionnement() OWNER TO postgres;

--
-- TOC entry 1616 (class 1255 OID 2596501)
-- Dependencies: 2983 5
-- Name: del_positionnement_evaluations_a_generer(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_positionnement_evaluations_a_generer() RETURNS "trigger"
    AS $$DECLARE
qr int4;
BEGIN

	IF (NEW.nombre!=OLD.nombre OR NEW.nombre_max!=OLD.nombre_max)
	OR (NEW.nombre IS NULL AND OLD.nombre IS NOT NULL)
	OR (NEW.nombre_max IS NULL AND OLD.nombre_max IS NOT NULL)
	OR (OLD.nombre IS NULL AND NEW.nombre IS NOT NULL)
	OR (OLD.nombre_max IS NULL AND NEW.nombre_max IS NOT NULL)	
	THEN
		
		--on recupere le question_reponse du positionnement
		SELECT INTO qr question_reponse FROM contraintes.positionnement
		WHERE id=NEW.positionnement;
 
		--on supprime les evaluations déjà associées au choix modifié
		DELETE FROM contraintes.positionnement_evaluations
		WHERE question_reponse = qr
		AND choix=NEW.choix;
	END IF;

	RETURN NEW;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_positionnement_evaluations_a_generer() OWNER TO pgsql;

--
-- TOC entry 1617 (class 1255 OID 2596502)
-- Dependencies: 2983 5
-- Name: del_qsrc(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION del_qsrc() RETURNS "trigger"
    AS $$BEGIN

--supprime la correction d'un qrc
DELETE FROM qrc_correction WHERE qrc=NEW.id
AND positionnement=NEW.positionnement;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_qsrc() OWNER TO postgres;

--
-- TOC entry 1618 (class 1255 OID 2596503)
-- Dependencies: 2983 5
-- Name: del_question_reponse(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_question_reponse() RETURNS "trigger"
    AS $$BEGIN

--supprime les media associÃÂ©s au question reponse
DELETE FROM media_question_reponse WHERE question_reponse=NEW.id;

--supprime les media associÃÂ©s ÃÂ  un couple question_reponse/question_reponse_element
DELETE FROM media_question_reponse_element WHERE question_reponse=NEW.id;

--supprime les question_reponse_element associÃÂ©s au question_reponse
DELETE FROM question_reponse_elements WHERE question_reponse=NEW.id;
RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_question_reponse() OWNER TO www;

--
-- TOC entry 1619 (class 1255 OID 2596504)
-- Dependencies: 2983 5
-- Name: del_question_reponse_element(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION del_question_reponse_element() RETURNS "trigger"
    AS $$BEGIN

--supprime le media associÃÂ© au question_reponse_element
DELETE FROM media_question_reponse_element WHERE question_reponse_element=NEW.id;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_question_reponse_element() OWNER TO postgres;

--
-- TOC entry 1620 (class 1255 OID 2596505)
-- Dependencies: 2983 5
-- Name: del_question_reponse_element_media(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_question_reponse_element_media() RETURNS "trigger"
    AS $$BEGIN
	DELETE FROM contraintes.media_question_reponse_element
	WHERE question_reponse=OLD.question_reponse
	AND (question_reponse_element=OLD.question
	OR question_reponse_element=OLD.reponse);

	RETURN OLD;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_question_reponse_element_media() OWNER TO pgsql;

--
-- TOC entry 1621 (class 1255 OID 2596506)
-- Dependencies: 2983 5
-- Name: del_ressource(); Type: FUNCTION; Schema: contraintes; Owner: www
--

CREATE FUNCTION del_ressource() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS DE LA RESSOURCE
	-- avec ses formation
	delete from formation_ressources where ressource=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_ressource() OWNER TO www;

--
-- TOC entry 8761 (class 0 OID 0)
-- Dependencies: 1621
-- Name: FUNCTION del_ressource(); Type: COMMENT; Schema: contraintes; Owner: www
--

COMMENT ON FUNCTION del_ressource() IS 'Supprime la totalitÃ© des enregistrements liÃ©s Ã  une ressource.';


--
-- TOC entry 41 (class 1255 OID 2596507)
-- Dependencies: 2983 5
-- Name: del_resultat_duree(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_resultat_duree() RETURNS "trigger"
    AS $$declare
parc integer;
begin
    -- recup du parcours du sous parcours
    select into parc distinct pe.parcours from contraintes.parcours_etapes pe,contraintes.parcours_etapes pp
    where pe.etape=old.parcours and pp.etape=pe.pere;
    -- maj
    update contraintes.resultat set duree=NULL 
    where formation=old.formation and stagiaire=old.stagiaire and parcours=parc and etape=old.parcours;
    return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_resultat_duree() OWNER TO pgsql;

--
-- TOC entry 8763 (class 0 OID 0)
-- Dependencies: 41
-- Name: FUNCTION del_resultat_duree(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION del_resultat_duree() IS 'maj duree sur table resultat';


--
-- TOC entry 1622 (class 1255 OID 2596508)
-- Dependencies: 2983 5
-- Name: del_serie(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION del_serie() RETURNS "trigger"
    AS $$BEGIN

	--supprime les associations avec ses evaluations
	DELETE FROM serie_evaluations 
	WHERE serie=NEW.id;

	--supprime les configuration de page qui lui sont associÃÂ©s
	DELETE FROM page_serie_configuration 
	WHERE serie=NEW.id;
	DELETE FROM page_serie_commentaire 
	WHERE serie=NEW.id;
	DELETE FROM page_serie_titre
	WHERE serie=NEW.id;


RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_serie() OWNER TO postgres;

--
-- TOC entry 1623 (class 1255 OID 2596509)
-- Dependencies: 2983 5
-- Name: del_serie_aleatoire(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION del_serie_aleatoire() RETURNS "trigger"
    AS $$BEGIN

	--supprime les associations avec ses evaluations
	DELETE FROM serie_aleatoire_evaluations 
	WHERE serie=NEW.id;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_serie_aleatoire() OWNER TO postgres;

--
-- TOC entry 1624 (class 1255 OID 2596510)
-- Dependencies: 2983 5
-- Name: del_serie_aleatoire_configuree_evaluations(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_serie_aleatoire_configuree_evaluations() RETURNS "trigger"
    AS $$DECLARE
resultat RECORD;
BEGIN
RAISE NOTICE 'TRIGGER %',OLD.id;

	SELECT INTO resultat * FROM contraintes.af_get_resultat(OLD.id) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	RAISE NOTICE 'Supprime les evaluations de la serie %',resultat.etape;
	-- NOTE : un autre trigger fait la meme chose si on supprime les resultats d'une etape serie aleatoire
	/*
	DELETE FROM contraintes.serie_aleatoire_evaluations 
	WHERE serie=resultat.etape
	AND formation=resultat.formation
	AND parcours=resultat.parcours
	AND serie IN(SELECT id FROM contraintes.serie_aleatoire);
	*/
	RETURN OLD;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_serie_aleatoire_configuree_evaluations() OWNER TO pgsql;

--
-- TOC entry 1625 (class 1255 OID 2596511)
-- Dependencies: 2983 5
-- Name: del_serie_aleatoire_evaluations(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_serie_aleatoire_evaluations() RETURNS "trigger"
    AS $$declare
rec record;
aleatoire boolean;
begin
    -- si l'etape est une serie aleatoire monotheme ou multitheme
    select into aleatoire * from contraintes.af_is_serie_aleatoire(old.etape);
    if aleatoire is true then
	select into rec * from contraintes.af_get_serie_aleatoire(old.etape) 
	as (id int4,libelle varchar,bareme int4,chrono int4,type int4,date_creation timestamp);
	
	if rec.type=2 or rec.type=3 or rec.type=1 then
	    delete from contraintes.serie_aleatoire_evaluations 
	    where serie=old.etape and formation=old.formation and parcours=old.parcours and stagiaire=old.stagiaire;
	end if;
    end if;
    return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_serie_aleatoire_evaluations() OWNER TO pgsql;

--
-- TOC entry 8767 (class 0 OID 0)
-- Dependencies: 1625
-- Name: FUNCTION del_serie_aleatoire_evaluations(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION del_serie_aleatoire_evaluations() IS 'supprime les associations serie/evaluation d''une serie aleatoire';


--
-- TOC entry 1626 (class 1255 OID 2596512)
-- Dependencies: 2983 5
-- Name: del_serie_evaluations(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION del_serie_evaluations() RETURNS "trigger"
    AS $$begin
	
	--SUPPRESSION DES DONNEES ASSOCIEES A UNE EVALUATION D'UNE SERIE
	--la supprimer des series alÃÂ©atoires
	delete from serie_aleatoire_evaluations 
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;
	
	--SUPPRESSION DES RESULTATS ASSOCIES
	--pour les ÃÂ©valuations de type question_reponse
	delete from serie_resultats_question_reponse 
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;

	--pour les ÃÂ©valuations de type ftb (blanc)
	delete from serie_resultats_ftb
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;

	--pour les ÃÂ©valuations des series bloquantes de type ftb (blanc)
	delete from serie_bloquante_tentative_ftb
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;

	--pour les ÃÂ©valuations des series bloquantes de type question_reponse
	delete from serie_bloquante_tentative_question_reponse
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;
	
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_serie_evaluations() OWNER TO postgres;

--
-- TOC entry 1627 (class 1255 OID 2596513)
-- Dependencies: 2983 5
-- Name: del_stagiaire_grille(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_stagiaire_grille() RETURNS "trigger"
    AS $$-- test s'il y a encore des reference pour la formation,stagiaire,grille
begin
    perform * from contraintes.grille_resultats where old.formation=formation and old.stagiaire=stagiaire and old.grille=grille;
    if not found then
	delete from contraintes.stagiaire_grille where formation=old.formation and stagiaire=old.stagiaire and grille=old.grille;
    end if;
    return old;	
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_stagiaire_grille() OWNER TO pgsql;

--
-- TOC entry 8770 (class 0 OID 0)
-- Dependencies: 1627
-- Name: FUNCTION del_stagiaire_grille(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION del_stagiaire_grille() IS 'supprime dans stagiaire_grille si plus de reference ds grille_resultats';


--
-- TOC entry 1628 (class 1255 OID 2596514)
-- Dependencies: 2983 5
-- Name: del_test(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION del_test() RETURNS "trigger"
    AS $$BEGIN

--supprime le mÃÂ©dia du test
DELETE FROM media_test WHERE test=NEW.id;

--supprime les positionnements du test
DELETE FROM test_positionnements WHERE test=NEW.id;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_test() OWNER TO postgres;

--
-- TOC entry 1629 (class 1255 OID 2596515)
-- Dependencies: 2983 5
-- Name: del_test_positonnements(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION del_test_positonnements() RETURNS "trigger"
    AS $$BEGIN

--supprime les resultats du positionnement pour ce test
DELETE FROM test_resultats_positionnement 
WHERE test=NEW.test
AND positionnement=NEW.positionnement;

--supprime les resultats des questions_reponses du postionnement pour ce test
DELETE FROM positionnement_resultats_question_reponse WHERE test=NEW.test
AND positionnement=NEW.positionnement;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_test_positonnements() OWNER TO postgres;

--
-- TOC entry 1630 (class 1255 OID 2596516)
-- Dependencies: 2983 5
-- Name: del_theme_categorie(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_theme_categorie() RETURNS "trigger"
    AS $$BEGIN

	DELETE FROM contraintes.theme_categories WHERE id=OLD.id
	AND categorie=OLD.categorie;
	
	RETURN OLD;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_theme_categorie() OWNER TO pgsql;

--
-- TOC entry 1631 (class 1255 OID 2596517)
-- Dependencies: 2983 5
-- Name: del_theme_etape(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION del_theme_etape() RETURNS "trigger"
    AS $$declare

begin 
    delete  from contraintes.categorie_etape 
    where id=OLD.id ;
    return OLD;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.del_theme_etape() OWNER TO pgsql;

--
-- TOC entry 8775 (class 0 OID 0)
-- Dependencies: 1631
-- Name: FUNCTION del_theme_etape(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION del_theme_etape() IS 'supprime le theme enregistré pour  l''etape';


--
-- TOC entry 42 (class 1255 OID 2596518)
-- Dependencies: 2983 5
-- Name: delete_module_submodules_individu_type(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION delete_module_submodules_individu_type() RETURNS "trigger"
    AS $$DECLARE
	
curs CURSOR (n_module integer) FOR 
		SELECT DISTINCT M.id
		FROM contraintes.fw_module_submodules SM, 
		contraintes.fw_module M
		WHERE SM.module=n_module 
		AND SM.submodule=M.id;

sub_modules integer [];
i integer:=0;
cur_sub_module integer;
BEGIN
	OPEN curs(OLD.module);

	<<sub_module_loop>>
	LOOP
		i:=i+1;
		RAISE NOTICE 'ss_module %',i;





		
		FETCH curs INTO cur_sub_module ;
		
		IF FOUND THEN
			sub_modules[i]:=cur_sub_module;
			RAISE NOTICE 'ID %',cur_sub_module;
		ELSE
			RAISE NOTICE 'NOT FOUND ';
			EXIT sub_module_loop;
		END IF;
	END LOOP;
	CLOSE curs;

	IF ARRAY_UPPER(sub_modules , 1)>0 THEN
		RAISE NOTICE 'DEL  %',OLD.individu_type;
		PERFORM contraintes.fw_del_individu_type_modules(OLD.individu_type, sub_modules);
	END IF;

	RETURN OLD;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.delete_module_submodules_individu_type() OWNER TO pgsql;

--
-- TOC entry 1632 (class 1255 OID 2596519)
-- Dependencies: 2983 5
-- Name: delete_serie_aleatoire_multitheme_categorie_serie(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION delete_serie_aleatoire_multitheme_categorie_serie() RETURNS "trigger"
    AS $$begin
	delete from contraintes.categorie_serie 
	where id=old.serie and theme=old.theme_source;
	return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.delete_serie_aleatoire_multitheme_categorie_serie() OWNER TO pgsql;

--
-- TOC entry 8777 (class 0 OID 0)
-- Dependencies: 1632
-- Name: FUNCTION delete_serie_aleatoire_multitheme_categorie_serie(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION delete_serie_aleatoire_multitheme_categorie_serie() IS 'supprime un enregistrement dans la table categorie serie';


--
-- TOC entry 1634 (class 1255 OID 2596520)
-- Dependencies: 2983 5
-- Name: fmt_check_formateur_type(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fmt_check_formateur_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM contraintes.fw_individu_types
WHERE contraintes.fw_individu_types.individu=NEW.formateur
AND contraintes.fw_individu_types.type=2;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE FORMATEUR de la table \'%\'DOIT ETRE UN INDIVIDU POSSEDANT LE TYPE Formateur(2) ', TG_RELNAME;
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fmt_check_formateur_type() OWNER TO postgres;

--
-- TOC entry 8779 (class 0 OID 0)
-- Dependencies: 1634
-- Name: FUNCTION fmt_check_formateur_type(); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION fmt_check_formateur_type() IS 'vÃÂ©rifie que le formateur de la table appelante correspond bien ÃÂ  un individu ayant le type formateur(2)';


--
-- TOC entry 1633 (class 1255 OID 2596521)
-- Dependencies: 2983 5
-- Name: fmt_get_filiere_formations(integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fmt_get_filiere_formations(integer, character varying, boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
--$2 ASC(ou n'importe quoi) ou DESC pour le classement du resultat
--$3 TRUE, classement par date de dÃ©but, ou FALSE classement par libelle
req varchar;
rec record;
BEGIN
	req:='SELECT F.id, F.libelle, F.parcours, F.date_debut, F.date_fin, F.langue, P.filiere 
		FROM contraintes.fmt_formation F , contraintes.pc_parcours P
		WHERE P.filiere='||$1||' AND F.parcours=P.id ';

	IF $3 IS TRUE THEN
		req:=req||' ORDER BY F.date_debut';
	ELSE 
		req:=req||' ORDER BY F.libelle';
	END IF;

	IF $2 LIKE 'DESC' THEN
		req:=req||' DESC';
	END IF;
	FOR rec IN
	    EXECUTE req
	LOOP
	    RETURN next rec;
	END LOOP;

		
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fmt_get_filiere_formations(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 1635 (class 1255 OID 2596522)
-- Dependencies: 2983 5
-- Name: fmt_get_formation(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fmt_get_formation(integer) RETURNS record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN 
	SELECT INTO rec id, libelle, parcours, date_debut, date_fin, langue  
	FROM contraintes.fmt_formation
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fmt_get_formation(integer) OWNER TO pgsql;

--
-- TOC entry 1636 (class 1255 OID 2596523)
-- Dependencies: 2983 5
-- Name: fmt_get_formation_langues(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fmt_get_formation_langues(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, libelle , code , locale , formation 
		FROM contraintes.fmt_formation_langues, contraintes.fw_get_langues() AS (id int4,libelle varchar, code varchar, locale varchar) 
		WHERE formation=$1
		AND langue=id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fmt_get_formation_langues(integer) OWNER TO pgsql;

--
-- TOC entry 1638 (class 1255 OID 2596524)
-- Dependencies: 2983 5
-- Name: fmt_get_individu_filieres(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fmt_get_individu_filieres(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;
begin
    for rec in
	--voir avec remi pour l'optimisation
	/*
	select fil.id,fil.libelle from 
	contraintes.filiere fil,
	contraintes.parcours par,
	contraintes.formation for,
	contraintes.formation_participants fp,
	contraintes.classe_individus ci 
	where ...
	*/
	select fil.id,fil.libelle from contraintes.pc_filiere fil where fil.id in 
	(select par.filiere from contraintes.pc_parcours par where par.id in 
	(select form.parcours from contraintes.fmt_formation form where form.id in 
	(select fp.formation from contraintes.fmt_formation_participants fp where fp.classe in 
	(select ci.classe from contraintes.cls_classe_individus ci where ci.individu=$1))))
	
    loop
	return next rec;
    end loop;
	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fmt_get_individu_filieres(integer) OWNER TO pgsql;

--
-- TOC entry 8784 (class 0 OID 0)
-- Dependencies: 1638
-- Name: FUNCTION fmt_get_individu_filieres(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fmt_get_individu_filieres(integer) IS 'retourne les filieres de formation d''un individu';


--
-- TOC entry 1637 (class 1255 OID 2596525)
-- Dependencies: 2983 5
-- Name: fmt_insert_formateur_droits_defaut(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fmt_insert_formateur_droits_defaut() RETURNS "trigger"
    AS $$DECLARE

BEGIN
	INSERT INTO contraintes.fmt_formateur_droits
	(formation, droit) 
	SELECT NEW.formation, D_id  
	FROM contraintes.fw_get_droits_defaut(1) AS (D_id int4, D_libelle varchar,D_type int4); 
	
	RETURN NEW;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fmt_insert_formateur_droits_defaut() OWNER TO pgsql;

--
-- TOC entry 43 (class 1255 OID 2596526)
-- Dependencies: 2983 5
-- Name: fw_check_individu_modules_access_by_type(integer, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_check_individu_modules_access_by_type(integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 individu
--$2 module type

BEGIN
	PERFORM DISTINCT M.id
	FROM contraintes.FW_module M ,contraintes.fw_get_individu_droits($1) AS (D_module integer, D_droit integer)
	WHERE active IS TRUE
	AND D_module=M.id
	AND type LIKE $2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_check_individu_modules_access_by_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1639 (class 1255 OID 2596527)
-- Dependencies: 2983 5
-- Name: fw_del_individu_individus_types(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_del_individu_individus_types(integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 module
--$2 individu_type []
BEGIN
	FOR i IN array_lower($2,1)..array_upper($2,1)
	LOOP
		DELETE FROM contraintes.fw_individu_types
		WHERE individu=$1
		AND type=$2[i];
	END LOOP;
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_del_individu_individus_types(integer, integer[]) OWNER TO postgres;

--
-- TOC entry 1640 (class 1255 OID 2596528)
-- Dependencies: 2983 5
-- Name: fw_del_individu_type_modules(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_del_individu_type_modules(integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 individu_type
--$2  module[]
BEGIN
	FOR i IN array_lower($2,1)..array_upper($2,1)
	LOOP
		DELETE FROM contraintes.fw_module_individus_types
		WHERE individu_type=$1
		AND module=$2[i];
	END LOOP;
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_del_individu_type_modules(integer, integer[]) OWNER TO postgres;

--
-- TOC entry 1641 (class 1255 OID 2596529)
-- Dependencies: 2983 5
-- Name: fw_del_module(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_del_module(integer) RETURNS boolean
    AS $_$DECLARE
--$1 code: identifiant unique du module (!= id)
rec RECORD;
ok BOOLEAN;
BEGIN

	FOR rec IN
		SELECT id FROM contraintes.fw_get_module_submodules($1) AS (id integer,libelle character varying,code character varying ,type character varying,version character varying, directory text,active boolean,description character varying)
	LOOP
		PERFORM contraintes.fw_del_module(rec.id);
	END LOOP;

	DELETE FROM contraintes.FW_module
	WHERE id=$1;

	ok:=FOUND;

	RETURN ok;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_del_module(integer) OWNER TO pgsql;

--
-- TOC entry 1642 (class 1255 OID 2596530)
-- Dependencies: 2983 5
-- Name: fw_del_module_individus_types(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_del_module_individus_types(integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 module
--$2 individu_type []
BEGIN
	FOR i IN array_lower($2,1)..array_upper($2,1)
	LOOP
		DELETE FROM contraintes.fw_module_individus_types
		WHERE module=$1
		AND individu_type=$2[i];
	END LOOP;
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_del_module_individus_types(integer, integer[]) OWNER TO postgres;

--
-- TOC entry 1643 (class 1255 OID 2596531)
-- Dependencies: 2983 5
-- Name: fw_get_ams_libelle(character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_get_ams_libelle(character varying, character varying, character varying, character varying) RETURNS character varying
    AS $_$DECLARE
--$1 nom table
--$2 nom colonne
--$3 selection
--$4 ams
req text;
ams_new varchar;
langue_new varchar;

ams_in varchar;
slash varchar:='\\';
BEGIN
	--recupération de la langue de l'ams à ajouter dans le champ destination
	SELECT INTO langue_new  SUBSTRING($4 FROM '##AMS([0-9]+)##{');
RAISE NOTICE 'langue_new=%',langue_new;	

	--recupération de la chaine(texte) de l'ams à ajouter dans le champ destination
	SELECT INTO ams_new SUBSTRING($4,'##AMS[0-9]+##{"(.*?[^\\\\])"}');
RAISE NOTICE 'ams_new=%',ams_new;		

	--selection du champ destination
	req:='SELECT '||$2||' FROM contraintes.'||$1||' WHERE '||$3;
	EXECUTE  req INTO ams_in ; 
RAISE NOTICE 'ams_in=%',ams_in;

RAISE NOTICE '%',CAST ('##AMS('||langue_new||')##' AS varchar);
	--y a t il un ams de meme langue dans le champ?
	IF ams_in ~* CAST ('##AMS('||langue_new||')##' AS varchar)
	--OUI
	THEN
		--RETURN regexp_replace(ams_in,  '##AMS'||langue_new||'##{"(.*?)"}','##AMS'||langue_new||'##{"'||ams_new||'"}');
		RETURN regexp_replace(ams_in,  '##AMS'||langue_new||'##{"(.*?[^\\\\])"}(,|$)','##AMS'||langue_new||'##{"'||ams_new||'"}\\2','gi');
	--NON
	ELSE
		--y a t il un ams quelquonque dans le champ?
		IF ams_in ~* CAST ('##AMS[0-9]+##' AS varchar) THEN
			--on retourne le champ concaténé avec le nouvel ams
			RETURN ams_in||','||$4;--replace( $4, '\\', '\\\\');
		ELSE
			RETURN $4;
		END IF;
	END IF;

END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_ams_libelle(character varying, character varying, character varying, character varying) OWNER TO postgres;

--
-- TOC entry 1910 (class 1255 OID 2596532)
-- Dependencies: 2983 5
-- Name: fw_get_connexions(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_connexions() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT * FROM contraintes.connexion
		ORDER BY start_time
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_connexions() OWNER TO pgsql;

--
-- TOC entry 1911 (class 1255 OID 2596533)
-- Dependencies: 2983 5
-- Name: fw_get_droits(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_get_droits() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, libelle, code, defaut
		FROM contraintes.fw_droit
		ORDER BY id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_droits() OWNER TO postgres;

--
-- TOC entry 1644 (class 1255 OID 2596534)
-- Dependencies: 2983 5
-- Name: fw_get_droits_defaut(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_droits_defaut(integer) RETURNS SETOF record
    AS $_$-- $1 type d'individu (1 : formateur, 2 : utilisateur, 3 : intervenant)
declare
rec record;
begin
    for rec in 
	select id,libelle,type from contraintes.fw_droit where defaut is true and type=$1
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_droits_defaut(integer) OWNER TO pgsql;

--
-- TOC entry 8795 (class 0 OID 0)
-- Dependencies: 1644
-- Name: FUNCTION fw_get_droits_defaut(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_droits_defaut(integer) IS 'retourne les droits par defaut';


--
-- TOC entry 1645 (class 1255 OID 2596535)
-- Dependencies: 2983 5
-- Name: fw_get_individu(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_individu(integer) RETURNS record
    AS $_$declare
rec record;

begin
       select into rec id, identifiant_md5 ,login ,password ,nom ,prenom ,adresse ,code ,ville ,
		email ,tel_fixe ,tel_port ,langue,organisme ,photo  from contraintes.fw_individu where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individu(integer) OWNER TO pgsql;

--
-- TOC entry 8797 (class 0 OID 0)
-- Dependencies: 1645
-- Name: FUNCTION fw_get_individu(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_individu(integer) IS 'retourne les in infos d''un individu';


--
-- TOC entry 1646 (class 1255 OID 2596536)
-- Dependencies: 2983 5
-- Name: fw_get_individu_droits(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_get_individu_droits(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 individu
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT module,droit 
		FROM contraintes.fw_individu_types IT,contraintes.fw_module_individus_types MIT
		WHERE IT.type=MIT.individu_type
		AND IT.individu=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individu_droits(integer) OWNER TO postgres;

--
-- TOC entry 1647 (class 1255 OID 2596537)
-- Dependencies: 2983 5
-- Name: fw_get_individu_modules(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_get_individu_modules(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 individu
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT id,libelle,code, type,version,directory,active,description
		FROM contraintes.FW_get_modules(TRUE) AS (id integer,libelle character varying,code character varying , type character varying,version character varying, directory text,active boolean,description character varying),
		contraintes.FW_get_individu_droits($1) AS (module integer, droit integer)
		WHERE id=module
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individu_modules(integer) OWNER TO postgres;

--
-- TOC entry 1648 (class 1255 OID 2596538)
-- Dependencies: 2983 5
-- Name: fw_get_individu_nom_prenom(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_individu_nom_prenom(integer) RETURNS record
    AS $_$-- $1 : numero individu
declare
rec record;
begin
    select into rec 
    id,nom,prenom from contraintes.fw_individu where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individu_nom_prenom(integer) OWNER TO pgsql;

--
-- TOC entry 8801 (class 0 OID 0)
-- Dependencies: 1648
-- Name: FUNCTION fw_get_individu_nom_prenom(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_individu_nom_prenom(integer) IS 'retourne nom et prenom d''un individu';


--
-- TOC entry 1649 (class 1255 OID 2596539)
-- Dependencies: 2983 5
-- Name: fw_get_individu_type_modules(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_get_individu_type_modules(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 individu_type
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT DISTINCT M.id, M.libelle,M.code,M.type,M.version, M.directory,M.active, MIT.individu_type
		FROM contraintes.fw_module_individus_types MIT, contraintes.FW_module M 
		WHERE MIT.individu_type=$1
		AND MIT.module=M.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individu_type_modules(integer) OWNER TO postgres;

--
-- TOC entry 1651 (class 1255 OID 2596540)
-- Dependencies: 2983 5
-- Name: fw_get_individu_types(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_individu_types(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
    for rec in 
	select id,libelle from contraintes.fw_individu_type,contraintes.fw_individu_types 
	where id=type and individu=$1 order by id
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individu_types(integer) OWNER TO pgsql;

--
-- TOC entry 8804 (class 0 OID 0)
-- Dependencies: 1651
-- Name: FUNCTION fw_get_individu_types(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_individu_types(integer) IS 'retourne les types d''un individu';


--
-- TOC entry 1650 (class 1255 OID 2596541)
-- Dependencies: 2983 5
-- Name: fw_get_individu_types(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_individu_types() RETURNS SETOF record
    AS $$DECLARE

rec record;

BEGIN
	FOR rec IN
	  SELECT id,libelle,code 
	  FROM contraintes.fw_individu_type
	  ORDER BY libelle

	LOOP
	  return next rec;
	END LOOP;
return;

END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individu_types() OWNER TO pgsql;

--
-- TOC entry 8806 (class 0 OID 0)
-- Dependencies: 1650
-- Name: FUNCTION fw_get_individu_types(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_individu_types() IS 'retourne tout les types';


--
-- TOC entry 1652 (class 1255 OID 2596542)
-- Dependencies: 2983 5
-- Name: fw_get_individus(integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_individus(integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 (0=>tous sinon le type d'individu)
-- $2 (asc ou desc)
-- $3 (vrai => que les utilisateurs ou que les formateurs)
declare
rec record;
req varchar;
begin
    /*
    req:='select distinct id,nom,prenom,organisme from contraintes.fw_individu,contraintes.fw_individu_types IT1 ';
    if $3 is true then
	req:= req || ',contraintes.fw_individu_types IT2 ' ;
    end if;
    if $1 !=0 then
	req:= req || ' where ';
    end if;
    -- suite req
    if $1=1 then -- LES FORMATEURS
	if $3 is true then -- LES FORMATEURS STRICT
	    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1   ';
	    req:=req || ' and id =IT1.individu AND IT1.type=2';
	else
	    req:=req || ' id =IT1.individu AND IT1.type=2';
	end if;
	
    else
	if $1=2 then -- LES STAGIAIRES
	    if $3 is true then -- LES STAGIAIRES STRICT
	        req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		req:=req || ' and id =IT1.individu AND IT1.type=1';
	    else
		req:=req || ' id =IT1.individu AND IT1.type=1';
	    end if;
	    
	
	else
	    if $1=3 then --LES INTERVENANTS
		if $3 is true then -- LES INTERVENANTS STRICT 
		    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		    req:=req || ' and id =IT1.individu AND IT1.type=3';
	        else
		    req:=req || ' id =IT1.individu AND IT1.type=3';     
	        end if;
	    --else
		--raise exception 'la valeur pour le paramÃ¨tre 3 (type) doit Ãªtre 1,2 ou 0';
	    end if;
	
	end if;
	
    end if;

    -- classement
    if $2 like 'DESC' then
	req:=req || ' order by nom desc ';
    else
	req:=req || ' order by nom ';
    end if;

	 raise notice 'req=%',req;
    */
	 
    --for rec in
	--execute req
	if $1=0 then 
	    if $2 like 'desc' then 
	        for rec in	
		    select distinct id,nom,prenom,organisme from contraintes.fw_individu order by nom desc
	        loop
		    return next rec;
		end loop;
	    else
	        for rec in	
		    select distinct id,nom,prenom,organisme from contraintes.fw_individu order by nom
	        loop
		    return next rec;
		end loop;
	    end if;
	else
	    if $3 is true then
	        if $2 like 'desc' then 
	            for rec in	
		    select distinct id,nom,prenom,organisme from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1,contraintes.fw_individu_types IT2 
		    where id= IT2.individu group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,organisme 
		    having count(IT1.type)=1 and id=IT1.individu and IT1.type=$1 order by nom desc
		    loop
			return next rec;
		    end loop;
	        else
	            for rec in	
		    select distinct id,nom,prenom,organisme from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1,contraintes.fw_individu_types IT2 
		    where id= IT2.individu group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,organisme 
		    having count(IT1.type)=1 and id=IT1.individu and IT1.type=$1 order by nom 
		    loop
			return next rec;
		    end loop;  
	        end if;
	         
	    
	    else
		if $2 like 'desc' then
		    for rec in	
		    select distinct id,nom,prenom,organisme from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1 
		    where id=IT1.individu and IT1.type=$1 order by nom desc
		    loop
			return next rec;
		    end loop;
		else
		    for rec in	
		    select distinct id,nom,prenom,organisme from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1 
		    where id=IT1.individu and IT1.type=$1 order by nom 
		    loop
			return next rec;
		    end loop;
		end if;
		
	    end if;
	end if;
/*    
    loop
        return next rec;
    end loop;
*/
return ;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individus(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 8808 (class 0 OID 0)
-- Dependencies: 1652
-- Name: FUNCTION fw_get_individus(integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_individus(integer, character varying, boolean) IS 'retourne les individus de la plateforme';


--
-- TOC entry 1653 (class 1255 OID 2596543)
-- Dependencies: 2983 5
-- Name: fw_get_individus_except_individus_types(integer[], character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_individus_except_individus_types(integer[], character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 (NULL=>tous sinon un tableau avec les types d'individus à ne pas selectionner)
-- $2 (asc ou desc)
-- $3 (vrai => que les utilisateurs ou que les formateurs)
declare
rec record;
rec2 record;
req varchar;
liste text;
begin
    -- transforme le tableau de type en liste
    --liste:='('''||array_to_string($1,''',''')||''')';
    liste:=array_to_string($1,',');
    raise notice 'lst=%',liste;
   --FOR i IN array_lower($1, 1) .. array_upper($1, 1) 
    
	    if $3 is true then
	        
	    --if $3 is false then
	    --exemple: utilisateur de type 1,8 et $1={1,5} => elimine pas
	        if $2 like 'desc' then 
	            for rec in	
			    select distinct id,nom,prenom,organisme from contraintes.fw_individu,
			    contraintes.fw_individu_types IT1,contraintes.fw_individu_types IT2 
			    where id= IT2.individu group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,organisme 
			    having count(IT1.type)=1 and id=IT1.individu and IT1.type !=  ANY ($1) order by nom desc
		    loop
			return next rec;
		    end loop;
	        else
	            raise notice 'coucou true asc';
	            for rec in	
			    select id,nom,prenom,organisme,IT1.type from contraintes.fw_individu,
			    contraintes.fw_individu_types IT1
			    --,contraintes.fw_individu_types IT2 
			    where id= IT1.individu 
			    --group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,organisme 
			    --group by IT1.individu,id,IT1.type,nom,prenom,organisme 
			    
			    --having count(IT1.type)=1 and id=IT1.individu 
			    --and IT1.type NOT in (liste) order by nom
			    --and IT1.type not in (1,5) order by nom    
		    loop
		        
			return next rec;
		    end loop;  
	        end if;
	         
	    
	    else
		raise notice 'coucou false';
		if $2 like 'desc' then
    		--exemple: utilisateur de type 1,8 et $1={1,5} => elimine 
		    for rec in	
			    select distinct id,nom,prenom,organisme from contraintes.fw_individu,
			    contraintes.fw_individu_types IT1 
			    where id=IT1.individu and IT1.type !=  ALL($1) order by nom desc
		    loop
			return next rec;
		    end loop;
		else
		    for rec in	
			    select distinct id,nom,prenom,organisme from contraintes.fw_individu,
			    contraintes.fw_individu_types IT1 
			    where id=IT1.individu 
			    and IT1.type !=  ALL ($1) order by nom 
			    --and IT1.type =  SOME ($1) order by nom 
			    --and IT1.type not in (1,5) order by nom 
			    --and IT1.type not in $1 order by nom 
		    loop
			return next rec;
		    end loop;
		end if;
		
	    end if;
	
return ;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individus_except_individus_types(integer[], character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 8810 (class 0 OID 0)
-- Dependencies: 1653
-- Name: FUNCTION fw_get_individus_except_individus_types(integer[], character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_individus_except_individus_types(integer[], character varying, boolean) IS 'retourne les individus de la plateforme';


--
-- TOC entry 1912 (class 1255 OID 2596544)
-- Dependencies: 2983 5
-- Name: fw_get_individus_infos(integer, character varying, boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_individus_infos(integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 : type d'individu (0=tous, 1=formateurs & 2=stagiaires)
-- $2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- $3. exclusif : si VRAI alors que les 'u' ou les
declare
rec record;
req varchar;
begin
    /*
    req:='select distinct id,identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo from contraintes.fw_individu,contraintes.fw_individu_types IT1 ';
    if $3 is true then
	req:= req || ',contraintes.fw_individu_types IT2 ' ;
    end if;
    if $1 !=0 then
	req:= req || ' where ';
    end if;
    -- suite req
    if $1=1 then -- LES FORMATEURS
	if $3 is true then -- LES FORMATEURS STRICT
	    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type,identifiant_md5,login,password, nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  having count(IT2.type)=1   ';
	    req:=req || ' and id =IT1.individu AND IT1.type=2';
	else
	    req:=req || ' id =IT1.individu AND IT1.type=2';
	end if;
	
    else
	if $1=2 then -- LES STAGIAIRES
	    if $3 is true then -- LES STAGIAIRES STRICT
	        req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type,identifiant_md5,login,password, nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  having count(IT2.type)=1 '; 
		req:=req || ' and id =IT1.individu AND IT1.type=1';
	    else
		req:=req || ' id =IT1.individu AND IT1.type=1';
	    end if;
	    
	
	else
	    if $1=3 then --LES INTERVENANTS
		if $3 is true then -- LES INTERVENANTS STRICT 
		    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		    req:=req || ' and id =IT1.individu AND IT1.type=3';
	        else
		    req:=req || ' id =IT1.individu AND IT1.type=3';     
	        end if;
	    else --LES AUTRES
		if $3 is true then -- LES AUTRES STRICT 
		    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		    req:=req || ' and id =IT1.individu AND IT1.type='|| $1;
	        else
		    req:=req || ' id =IT1.individu AND IT1.type='||$1;     
	        end if;
		--raise exception 'la valeur pour le paramètre 3 (type) doit être 1,2 ou 0';
	    end if;
	
	end if;
	
    end if;

    -- classement
    if $2 like 'DESC' then
	req:=req || ' order by nom desc ';
    else
	req:=req || ' order by nom ';
    end if;

	 raise notice 'req=%',req; 
    for rec in
	execute req
    loop
	return next rec;
    end loop;
    */

    if $1=0 then 
	    if $2 like 'desc' then 
	        for rec in	
		    select distinct id,identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo from contraintes.fw_individu order by nom desc
	        loop
		    return next rec;
		end loop;
	    else
	        for rec in	
		    select distinct id,identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  from contraintes.fw_individu order by nom
	        loop
		    return next rec;
		end loop;
	    end if;
	else
	    if $3 is true then
	        if $2 like 'desc' then 
	            for rec in	
		    select distinct id,identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1,contraintes.fw_individu_types IT2 
		    where id= IT2.individu group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,organisme 
		    having count(IT1.type)=1 and id=IT1.individu and IT1.type=$1 order by nom desc
		    loop
			return next rec;
		    end loop;
	        else
	            for rec in	
		    select distinct id,identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1,contraintes.fw_individu_types IT2 
		    where id= IT2.individu group by IT2.individu,IT1.individu,id,IT1.type,nom,prenom,organisme 
		    having count(IT1.type)=1 and id=IT1.individu and IT1.type=$1 order by nom 
		    loop
			return next rec;
		    end loop;  
	        end if;
	         
	    
	    else
		if $2 like 'desc' then
		    for rec in	
		    select distinct id,identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1 
		    where id=IT1.individu and IT1.type=$1 order by nom desc
		    loop
			return next rec;
		    end loop;
		else
		    for rec in	
		    select distinct id,identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  from contraintes.fw_individu,
		    contraintes.fw_individu_types IT1 
		    where id=IT1.individu and IT1.type=$1 order by nom 
		    loop
			return next rec;
		    end loop;
		end if;
		
	    end if;
	end if;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individus_infos(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 8812 (class 0 OID 0)
-- Dependencies: 1912
-- Name: FUNCTION fw_get_individus_infos(integer, character varying, boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_individus_infos(integer, character varying, boolean) IS 'Retourne les infos individus de la plateforme';


--
-- TOC entry 1913 (class 1255 OID 2596545)
-- Dependencies: 2983 5
-- Name: fw_get_individus_types(boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_individus_types(boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 retourne le profile root si besoin
rec record;

BEGIN
	FOR rec IN
	  SELECT id,libelle,code 
	  FROM contraintes.fw_individu_type
	  ORDER BY libelle

	LOOP
		IF $1 IS FALSE THEN
			IF rec.code NOT LIKE 'root' THEN
				return next rec;
			END IF;
		ELSE
			return next rec;
		END IF;
	END LOOP;
return;

END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individus_types(boolean) OWNER TO pgsql;

--
-- TOC entry 8814 (class 0 OID 0)
-- Dependencies: 1913
-- Name: FUNCTION fw_get_individus_types(boolean); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_individus_types(boolean) IS 'retourne tous les types d''individus';


--
-- TOC entry 44 (class 1255 OID 2596546)
-- Dependencies: 2983 5
-- Name: fw_get_individus_types_libelles_by_codes(character varying[]); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_individus_types_libelles_by_codes(character varying[]) RETURNS character varying
    AS $_$DECLARE
--tableau de codes de types d'individus
i integer;
chaine_libelles character varying='';
tmp  character varying;
max_ind integer;
BEGIN
	max_ind:=array_upper($1, 1) ;

	FOR i IN array_lower($1, 1) .. max_ind
	LOOP
		RAISE NOTICE '% code=%',i,$1[i];
		SELECT INTO tmp libelle FROM contraintes.fw_individu_type
		WHERE ''''||code||'''' =$1[i];
		RAISE NOTICE '% lib=%',i,tmp;
		
		IF NOT FOUND THEN
			RAISE EXCEPTION 'Erreur, code d''individu type non reconnu (%)',tmp;
		ELSEIF i < max_ind THEN
			chaine_libelles:=chaine_libelles||tmp||',';
		ELSE
			chaine_libelles:=chaine_libelles||tmp;
		END IF;
	END LOOP; 

	RETURN chaine_libelles;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individus_types_libelles_by_codes(character varying[]) OWNER TO pgsql;

--
-- TOC entry 1914 (class 1255 OID 2596547)
-- Dependencies: 2983 5
-- Name: fw_get_individus_types_modules_droits(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_get_individus_types_modules_droits() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT individu_type,module,droit
		FROM contraintes.fw_module_individus_types
		ORDER BY individu_type,module,droit
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_individus_types_modules_droits() OWNER TO postgres;

--
-- TOC entry 1915 (class 1255 OID 2596548)
-- Dependencies: 2983 5
-- Name: fw_get_langue(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_langue(integer) RETURNS record
    AS $_$declare
rec record;
begin
    select into rec * from contraintes.fw_get_langues() as (id int4,libelle varchar, code varchar, locale varchar) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_langue(integer) OWNER TO pgsql;

--
-- TOC entry 8818 (class 0 OID 0)
-- Dependencies: 1915
-- Name: FUNCTION fw_get_langue(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_langue(integer) IS 'retourne les info langue Ã  partir de l''idendifiant';


--
-- TOC entry 1654 (class 1255 OID 2596549)
-- Dependencies: 2983 5
-- Name: fw_get_langues(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_langues() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle, code, locale from contraintes.fw_langue
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_langues() OWNER TO pgsql;

--
-- TOC entry 8820 (class 0 OID 0)
-- Dependencies: 1654
-- Name: FUNCTION fw_get_langues(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_langues() IS 'retourne les langues de la plateforme';


--
-- TOC entry 1655 (class 1255 OID 2596550)
-- Dependencies: 2983 5
-- Name: fw_get_module(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_module(character varying) RETURNS record
    AS $_$DECLARE
--$1 code: identifiant unique du module (!= id)
rec RECORD;
BEGIN
	SELECT INTO rec M.id, M.libelle,M.code,M.type,M.version, M.directory,M.active,M.description
	FROM contraintes.FW_module M 
	WHERE M.code LIKE $1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_module(character varying) OWNER TO pgsql;

--
-- TOC entry 1656 (class 1255 OID 2596551)
-- Dependencies: 2983 5
-- Name: fw_get_module_individus_types(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_module_individus_types(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 module
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT DISTINCT IT.id, IT.libelle, IT.code, MIT.module
		FROM contraintes.fw_module_individus_types MIT, contraintes.fw_individu_type IT
		WHERE MIT.module=$1
		AND MIT.individu_type=IT.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_module_individus_types(integer) OWNER TO pgsql;

--
-- TOC entry 1657 (class 1255 OID 2596552)
-- Dependencies: 2983 5
-- Name: fw_get_module_individus_types_droits(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_get_module_individus_types_droits(integer) RETURNS SETOF record
    AS $_$
DECLARE
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT module,individu_type,droit
		FROM contraintes.fw_module_individus_types
		WHERE module=$1
		ORDER BY module,individu_type,droit
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_module_individus_types_droits(integer) OWNER TO postgres;

--
-- TOC entry 1658 (class 1255 OID 2596553)
-- Dependencies: 2983 5
-- Name: fw_get_module_pages(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_module_pages(character varying) RETURNS SETOF record
    AS $_$DECLARE
--$1 code
rec RECORD;
BEGIN
	FOR rec IN
		SELECT mp.id, mp.module,mp.libelle,mp.type, mp.url, mp.description
		FROM contraintes.fw_module_pages mp,
		contraintes.fw_module m
		WHERE mp.module=m.id
		AND m.code=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_module_pages(character varying) OWNER TO pgsql;

--
-- TOC entry 1659 (class 1255 OID 2596554)
-- Dependencies: 2983 5
-- Name: fw_get_module_submodules(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_module_submodules(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 module
rec RECORD;
BEGIN
	FOR rec IN
		SELECT M.id, M.libelle,M.code,M.type,M.version, M.directory,M.active, M.description
		FROM contraintes.fw_module_submodules SM, 
		contraintes.fw_module M
		WHERE SM.module=$1
		AND M.active IS TRUE
		AND SM.submodule=M.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_module_submodules(integer) OWNER TO pgsql;

--
-- TOC entry 1661 (class 1255 OID 2596555)
-- Dependencies: 2983 5
-- Name: fw_get_modules(boolean); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_modules(boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 TRUE=installÃÂ©s, FALSE=prÃÂ©sents
rec RECORD;
BEGIN
	FOR rec IN
		SELECT M.id, M.libelle,M.code,M.type,M.version, M.directory,M.active,M.description
		FROM contraintes.FW_module M LEFT OUTER JOIN contraintes.FW_module_submodules SM ON (id=submodule)
		WHERE submodule IS NULL
		AND active=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_modules(boolean) OWNER TO pgsql;

--
-- TOC entry 1660 (class 1255 OID 2596556)
-- Dependencies: 2983 5
-- Name: fw_get_modules(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_get_modules() RETURNS SETOF record
    AS $_$DECLARE
--$1 TRUE=installÃÂ©s, FALSE=prÃÂ©sents
rec RECORD;
BEGIN
	FOR rec IN
		SELECT M.id, M.libelle,M.code,M.type,M.version, M.directory,M.active,M.description
		FROM contraintes.FW_module M LEFT OUTER JOIN contraintes.FW_module_submodules SM ON (id=submodule)
		WHERE submodule IS NULL
	LOOP
		RETURN NEXT rec;
	END LOOP;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_modules() OWNER TO pgsql;

--
-- TOC entry 1662 (class 1255 OID 2596557)
-- Dependencies: 2983 5
-- Name: fw_get_modules_individus_types_droits(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_get_modules_individus_types_droits() RETURNS SETOF record
    AS $$
DECLARE
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT module,individu_type,droit
		FROM contraintes.fw_module_individus_types
		ORDER BY module,individu_type,droit
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_get_modules_individus_types_droits() OWNER TO postgres;

--
-- TOC entry 1916 (class 1255 OID 2596558)
-- Dependencies: 2983 5
-- Name: fw_is_formateur(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_is_formateur(integer) RETURNS boolean
    AS $_$-- $1 : individu

begin
    perform * from contraintes.fw_individu_types where individu=$1 and type=2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_is_formateur(integer) OWNER TO pgsql;

--
-- TOC entry 8830 (class 0 OID 0)
-- Dependencies: 1916
-- Name: FUNCTION fw_is_formateur(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_is_formateur(integer) IS 'retourne true si individu est formateur';


--
-- TOC entry 1917 (class 1255 OID 2596559)
-- Dependencies: 2983 5
-- Name: fw_is_root(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_is_root(integer) RETURNS boolean
    AS $_$-- $1 : individu

begin
    perform * from contraintes.fw_individu_types where individu=$1 and type=5;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_is_root(integer) OWNER TO pgsql;

--
-- TOC entry 8832 (class 0 OID 0)
-- Dependencies: 1917
-- Name: FUNCTION fw_is_root(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_is_root(integer) IS 'retourne true si individu est root';


--
-- TOC entry 1663 (class 1255 OID 2596560)
-- Dependencies: 2983 5
-- Name: fw_maj_individu_langue(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_maj_individu_langue(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 individu
--$2 langue
BEGIN
	UPDATE contraintes.fw_individu 
	SET langue=$2
	WHERE id=$1;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_maj_individu_langue(integer, integer) OWNER TO postgres;

--
-- TOC entry 1664 (class 1255 OID 2596561)
-- Dependencies: 2983 5
-- Name: fw_maj_module_activation(integer, boolean, boolean); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_maj_module_activation(integer, boolean, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 module
--$2 actif/inactif
--$3 recursif?
rec RECORD;
BEGIN
	UPDATE contraintes.fw_module SET active=$2
	WHERE id=$1;

	IF $3 IS TRUE THEN
		FOR rec IN
			SELECT id FROM contraintes.fw_get_module_submodules($1) 
			 AS (id integer,libelle character varying,code character varying ,type character varying,version character varying, directory text,active boolean,description character varying)
			--AS (id integer,libelle character varying,code character varying ,type character varying,version character varying, directory text,active boolean,submodule integer,description character varying)
		LOOP
			PERFORM contraintes.fw_maj_module_activation(rec.id,$2,$3);
		END LOOP;
	END IF;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_maj_module_activation(integer, boolean, boolean) OWNER TO postgres;

--
-- TOC entry 1665 (class 1255 OID 2596562)
-- Dependencies: 2983 5
-- Name: fw_root_nodel(); Type: FUNCTION; Schema: contraintes; Owner: skel
--

CREATE FUNCTION fw_root_nodel() RETURNS "trigger"
    AS $$BEGIN
	IF OLD.login LIKE 'root' THEN
		RETURN NULL;
	END IF;

	RETURN OLD;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_root_nodel() OWNER TO skel;

--
-- TOC entry 1667 (class 1255 OID 2596563)
-- Dependencies: 2983 5
-- Name: fw_root_noupdate(); Type: FUNCTION; Schema: contraintes; Owner: skel
--

CREATE FUNCTION fw_root_noupdate() RETURNS "trigger"
    AS $$BEGIN
	IF OLD.login LIKE 'root' OR NEW.login LIKE 'root' THEN
		NEW.login:=OLD.login;
	END IF;
	
	RETURN NEW;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_root_noupdate() OWNER TO skel;

--
-- TOC entry 1666 (class 1255 OID 2596564)
-- Dependencies: 2983 5
-- Name: fw_set_individu_individus_types(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_set_individu_individus_types(integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 individu
--$2 individu_type []
BEGIN
	FOR i IN array_lower($2,1)..array_upper($2,1)
	LOOP

		PERFORM * FROM contraintes.fw_individu_types
		WHERE type=$2[i]
		AND individu=$1;

		IF NOT FOUND THEN 
			INSERT INTO contraintes.fw_individu_types (individu, type)
			VALUES ($1, $2[i]);
		END IF;
	END LOOP;
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_individu_individus_types(integer, integer[]) OWNER TO postgres;

--
-- TOC entry 45 (class 1255 OID 2596565)
-- Dependencies: 2983 5
-- Name: fw_set_individu_type(character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_set_individu_type(character varying) RETURNS integer
    AS $_$DECLARE
--$1 libelle 
new_id integer;
res integer;
BEGIN
	INSERT INTO contraintes.fw_individu_type (libelle)
	VALUES ($1);

	--RECUPERE L'IDENTIFIANT 
	GET DIAGNOSTICS new_id = RESULT_OID;
	SELECT INTO res id FROM contraintes.fw_individu_type WHERE oid=new_id;
	RETURN res;
    
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_individu_type(character varying) OWNER TO pgsql;

--
-- TOC entry 1668 (class 1255 OID 2596566)
-- Dependencies: 2983 5
-- Name: fw_set_individu_type_module_droits(integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_set_individu_type_module_droits(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 individu_type
--$2 module
--$3 droits[]
rec_to_del RECORD;
rec_to_keep RECORD;
array_to_keep _int4;
array_deleted _int4;
offset int4:=0;
i int4:=1;
cherche boolean:=FALSE;
nb_droits_in int4:=0;
nb_droits_out int4:=0;
BEGIN

	--selection des droits à conserver
	FOR rec_to_keep IN
		(SELECT droit
		FROM contraintes.fw_module_individus_types
		WHERE individu_type=$1
		AND module=$2
		AND droit 
		IN (
			SELECT droit 
			FROM contraintes.fw_module_individus_types
			WHERE  droit = ANY($3)
			)
		)
		ORDER BY droit
	LOOP
		array_to_keep[i]:=rec_to_keep.droit;
		i:=i+1;
	END LOOP;
	
	--ajout des droits manquants
	FOR k IN array_lower($3,1) .. array_upper($3,1)
	LOOP
		--RAISE NOTICE '% % nb=% arra=%',k,$3,array_upper(array_to_keep,1),array_to_keep;
		IF array_upper(array_to_keep,1) > 0 THEN
			--RAISE NOTICE 'cherche';
			<<to_keep>>
			FOR l IN (array_lower(array_to_keep,1)+offset) .. array_upper(array_to_keep,1)
			LOOP
				
				IF ($3[k] = array_to_keep[l]) THEN
					--RAISE NOTICE 'triuve';
					offset:=offset+1;
					cherche:=TRUE;
				 
					EXIT to_keep;
				END IF;
				
			END LOOP to_keep; 
		END IF; 
		
		--RAISE NOTICE 'cherche??? %',cherche;
		IF cherche IS FALSE THEN	
			--RAISE NOTICE 'insert';	
			INSERT INTO contraintes.fw_module_individus_types
			(individu_type,module,droit) VALUES ($1,$2,$3[k]);
		END IF;
		cherche:=FALSE;
	END LOOP;

	i:=1;
	--suppression des droits en trop
	FOR rec_to_del IN
		(SELECT droit 
		FROM contraintes.fw_module_individus_types
		WHERE individu_type=$1
		AND module=$2 
		AND droit 
		NOT IN (
			SELECT droit 
			FROM contraintes.fw_module_individus_types
			WHERE  droit = ANY ($3)
			)
		)
		ORDER BY droit
	LOOP
		RAISE NOTICE 'del %',rec_to_del.droit;
		DELETE FROM contraintes.fw_module_individus_types
		WHERE individu_type=$1
		AND module=$2
		AND droit=rec_to_del.droit;
		array_deleted[i]:=rec_to_del.droit;
		i:=i+1;
	END LOOP;

	--verification 
	nb_droits_in := array_upper($3,1);
	SELECT INTO nb_droits_out 
		COUNT (*)
		FROM contraintes.fw_module_individus_types
		WHERE individu_type=$1
		AND module=$2;

	--RAISE NOTICE '% = %',nb_droits_in,nb_droits_out;
	RETURN nb_droits_in=nb_droits_out;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_individu_type_module_droits(integer, integer, integer[]) OWNER TO postgres;

--
-- TOC entry 1918 (class 1255 OID 2596567)
-- Dependencies: 2983 5
-- Name: fw_set_individu_type_modules(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_set_individu_type_modules(integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 individu_type
--$2 module []
rec RECORD;
nb int4:=0;
j int4:=0;
BEGIN

	FOR rec IN
		SELECT id FROM contraintes.fw_droit
		WHERE defaut IS TRUE
		
	LOOP
		FOR i IN array_lower($2,1)..array_upper($2,1)
		LOOP
			PERFORM * FROM contraintes.fw_module_individus_types
			WHERE individu_type=$1
			AND module=$2[i]
			AND droit=rec.id;

			IF NOT FOUND THEN 
				INSERT INTO contraintes.fw_module_individus_types (individu_type,module,droit)
				VALUES ($1, $2[i], rec.id);
				j:=j+1;
				IF FOUND THEN
					nb:=nb+1;
				END IF;
			END IF;
		END LOOP; 
	END LOOP;
	RAISE NOTICE 'insertion de % ligne(s) sur % éffectuée', nb,j;
	RETURN j=nb;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_individu_type_modules(integer, integer[]) OWNER TO postgres;

--
-- TOC entry 1669 (class 1255 OID 2596568)
-- Dependencies: 2983 5
-- Name: fw_set_individu_type_modules_old(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_set_individu_type_modules_old(integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 individu_type
--$2 module []
rec RECORD;
nb int4:=0;
j int4:=0;
BEGIN

	FOR rec IN
		SELECT id FROM contraintes.fw_droit
		WHERE defaut IS TRUE
	LOOP
		FOR i IN array_lower($2,1)..array_upper($2,1)
		LOOP
			INSERT INTO contraintes.fw_module_individus_types (individu_type,module,droit)
			VALUES ($1, $2[i], rec.id);
			j:=j+1;
			IF FOUND THEN
				nb:=nb+1;
			END IF;
		END LOOP; 
	END LOOP;
	RAISE NOTICE 'insertion de % ligne(s) sur % éffectuée', nb,j;
	RETURN j=nb;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_individu_type_modules_old(integer, integer[]) OWNER TO postgres;

--
-- TOC entry 1670 (class 1255 OID 2596569)
-- Dependencies: 2983 5
-- Name: fw_set_langue(character varying, character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_set_langue(character varying, character varying, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 libelle
--$2 code
--$3 locale
BEGIN

	INSERT INTO contraintes.fw_langue (libelle,code,locale)
	VALUES ($1,$2,$3);

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_langue(character varying, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 1671 (class 1255 OID 2596570)
-- Dependencies: 2983 5
-- Name: fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 code
--$3 type
--$4 version
--$5 directory
--$6 actif?
--$7 description
res integer;
new_id oid;
old RECORD;
BEGIN
	SELECT INTO old * FROM contraintes.fw_get_module($2)as (id integer,libelle character varying,code character varying , type character varying,version character varying, directory text,active boolean,description character varying);

	IF old.id IS NULL THEN
		INSERT INTO contraintes.fw_module (libelle, code,type, version, directory,active,description)
		VALUES ($1,$2,$3,$4, $5,$6,$7);
		-- recup id
		GET DIAGNOSTICS new_id=RESULT_OID; 
		select into res id from contraintes.fw_module 
		where oid=new_id;
		RETURN res;
	ELSE
		RETURN old.id;
	END IF;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying) OWNER TO pgsql;

--
-- TOC entry 8844 (class 0 OID 0)
-- Dependencies: 1671
-- Name: FUNCTION fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying) IS 'Enregistre un module et retourne son identifiant. Si un module avec un code identique existe deja, n''enregistre rien et retourne l''identifiant du module déjà existant';


--
-- TOC entry 1672 (class 1255 OID 2596571)
-- Dependencies: 2983 5
-- Name: fw_set_module_individu_type_droits(integer, integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_set_module_individu_type_droits(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 module
--$2 individu_type 
--$3 droits[]
BEGIN
	FOR i IN array_lower($3,1)..array_upper($3,1)
	LOOP
		INSERT INTO contraintes.fw_module_individus_types (module, individu_type,droit)
		VALUES ($1, $2, $3[i]);
	END LOOP;
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_module_individu_type_droits(integer, integer, integer[]) OWNER TO postgres;

--
-- TOC entry 1673 (class 1255 OID 2596572)
-- Dependencies: 2983 5
-- Name: fw_set_module_individus_types(integer, integer[]); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION fw_set_module_individus_types(integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 module
--$2 individu_type []
rec RECORD;
nb int4:=0;
j int4:=0;
BEGIN

	FOR rec IN
		SELECT id FROM contraintes.fw_droit
		WHERE defaut IS TRUE
	LOOP
		FOR i IN array_lower($2,1)..array_upper($2,1)
		LOOP
			PERFORM * FROM contraintes.fw_module_individus_types
			WHERE individu_type=$2[i]
			AND module=$1
			AND droit=rec.id;
			
			IF NOT FOUND THEN 

				INSERT INTO contraintes.fw_module_individus_types (module,individu_type,droit)
				VALUES ($1, $2[i], rec.id);
				j:=j+1;
				IF FOUND THEN
					nb:=nb+1;
				END IF;
			END IF;
		END LOOP; 
	END LOOP;
	RAISE NOTICE 'insertion de % ligne(s) sur % éffectuée', nb,j;
	RETURN j=nb;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_module_individus_types(integer, integer[]) OWNER TO postgres;

--
-- TOC entry 1674 (class 1255 OID 2596573)
-- Dependencies: 2983 5
-- Name: fw_set_module_page(integer, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_set_module_page(integer, character varying, character varying, character varying, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 module
--$2 libelle
--$3 type
--$4 url
--$5 desciption
BEGIN
	INSERT INTO contraintes.FW_module_pages (module,libelle, type,url,description)
	VALUES ($1,$2,$3,$4,$5);

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_module_page(integer, character varying, character varying, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 1676 (class 1255 OID 2596574)
-- Dependencies: 2983 5
-- Name: fw_set_module_submodule(integer, character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_set_module_submodule(integer, character varying, character varying) RETURNS boolean
    AS $_$DECLARE
--$1module
--$2 code
--$3 version
BEGIN
	INSERT INTO contraintes.fw_module_submodules (module,code, version)
	VALUES ($1,$2,$3);

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_module_submodule(integer, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 1675 (class 1255 OID 2596575)
-- Dependencies: 2983 5
-- Name: fw_set_module_submodule(integer, integer, character varying, character varying); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION fw_set_module_submodule(integer, integer, character varying, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 module
--$2 sous_module
--$3 code
--$4 version
BEGIN
	INSERT INTO contraintes.fw_module_submodules (module, submodule, code, version)
	VALUES ($1,$2,$3,4);

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.fw_set_module_submodule(integer, integer, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 46 (class 1255 OID 2596576)
-- Dependencies: 2983 5
-- Name: get_random_string(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION get_random_string(string_length integer) RETURNS text
    AS $$
DECLARE
possible_chars TEXT = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
output TEXT = '';
i INT4;
pos INT4;
BEGIN
FOR i IN 1..string_length LOOP
pos := 1 + cast( random() * ( length(possible_chars) - 1) as INT4 );
output := output || substr(possible_chars, pos, 1);
END LOOP;
RETURN output;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.get_random_string(string_length integer) OWNER TO pgsql;

--
-- TOC entry 47 (class 1255 OID 2596577)
-- Dependencies: 2983 5
-- Name: get_random_string_2(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION get_random_string_2(string_length integer) RETURNS text
    AS $$
DECLARE
possible_chars TEXT = '&"#''([{-|_\^@)]=}%*!:/;.?,<>0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
output TEXT = '';
i INT4;
pos INT4;
BEGIN
FOR i IN 1..string_length LOOP
pos := 1 + cast( random() * ( length(possible_chars) - 1) as INT4 );
output := output || substr(possible_chars, pos, 1);
END LOOP;
RETURN output;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.get_random_string_2(string_length integer) OWNER TO pgsql;

--
-- TOC entry 1677 (class 1255 OID 2596578)
-- Dependencies: 2983 5
-- Name: insert_categorie_etape(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_categorie_etape() RETURNS "trigger"
    AS $$BEGIN
	PERFORM * FROM contraintes.af_set_categorie_element_theme(29, NEW.theme,NEW.id);
	--RAISE NOTICE 'af_set_categorie_element_theme(%,%,%)',29, NEW.theme,NEW.id;
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_categorie_etape() OWNER TO pgsql;

--
-- TOC entry 1678 (class 1255 OID 2596579)
-- Dependencies: 2983 5
-- Name: insert_categorie_evaluation(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_categorie_evaluation() RETURNS "trigger"
    AS $$BEGIN
	PERFORM * FROM contraintes.af_set_categorie_element_theme(28, NEW.theme,NEW.id);
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_categorie_evaluation() OWNER TO pgsql;

--
-- TOC entry 1679 (class 1255 OID 2596580)
-- Dependencies: 2983 5
-- Name: insert_categorie_fichier_ressource(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_categorie_fichier_ressource() RETURNS "trigger"
    AS $$BEGIN
	PERFORM * FROM contraintes.af_set_categorie_element_theme(43, NEW.theme,NEW.id);
	--RAISE NOTICE 'af_set_categorie_element_theme(%,%,%)',43, NEW.theme,NEW.id;
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_categorie_fichier_ressource() OWNER TO pgsql;

--
-- TOC entry 1680 (class 1255 OID 2596581)
-- Dependencies: 2983 5
-- Name: insert_categorie_glossaire(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_categorie_glossaire() RETURNS "trigger"
    AS $$DECLARE
id_glossaire integer;
BEGIN

	SELECT INTO id_glossaire * FROM contraintes.af_get_glossaire_fichier(NEW.id);

	PERFORM * FROM contraintes.af_set_categorie_element_theme(67, NEW.theme,id_glossaire);
	
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_categorie_glossaire() OWNER TO pgsql;

--
-- TOC entry 1681 (class 1255 OID 2596582)
-- Dependencies: 2983 5
-- Name: insert_categorie_scenario(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_categorie_scenario() RETURNS "trigger"
    AS $$DECLARE
id_scenario integer;
BEGIN

	SELECT INTO id_scenario *FROM contraintes.af_get_scenario_fichier(NEW.id);

	PERFORM * FROM contraintes.af_set_categorie_element_theme(35, NEW.theme,id_scenario);
	
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_categorie_scenario() OWNER TO pgsql;

--
-- TOC entry 1682 (class 1255 OID 2596583)
-- Dependencies: 2983 5
-- Name: insert_categorie_scenario_dynamique(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_categorie_scenario_dynamique() RETURNS "trigger"
    AS $$DECLARE
id_scenario integer;
BEGIN

	SELECT INTO id_scenario * FROM contraintes.af_get_scenario_dynamique_fichier(NEW.id);

	PERFORM * FROM contraintes.af_set_categorie_element_theme(60, NEW.theme,id_scenario);
	
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_categorie_scenario_dynamique() OWNER TO pgsql;

--
-- TOC entry 1683 (class 1255 OID 2596584)
-- Dependencies: 2983 5
-- Name: insert_categorie_scenarios(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_categorie_scenarios() RETURNS "trigger"
    AS $$BEGIN
	PERFORM * FROM contraintes.af_set_categorie_element_theme(35, NEW.theme,NEW.id);
	--RAISE NOTICE 'af_set_categorie_element_theme(%,%,%)',43, NEW.theme,NEW.id;
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_categorie_scenarios() OWNER TO pgsql;

--
-- TOC entry 1684 (class 1255 OID 2596585)
-- Dependencies: 2983 5
-- Name: insert_etape_scorm(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_etape_scorm() RETURNS "trigger"
    AS $$DECLARE
id_etape int4;
lib varchar;
BEGIN
	--selection du libelle du fichier pour le libelle de l'etape (table principale)
	SELECT INTO lib libelle FROM contraintes.fichier WHERE id=NEW.id;

	--creation de l'etape (table principale)
	SELECT INTO id_etape  contraintes.af_set_etape(lib, 3);
	
	--insertion dans la table spÃ©cifique au scenario
	INSERT INTO contraintes.etape_scorm (id, fichier) VALUES (id_etape, NEW.id);

	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_etape_scorm() OWNER TO pgsql;

--
-- TOC entry 1685 (class 1255 OID 2596586)
-- Dependencies: 2983 5
-- Name: insert_fichier_ressource(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_fichier_ressource() RETURNS "trigger"
    AS $$BEGIN
	INSERT INTO contraintes.fichier_ressource
	(id) VALUES (NEW.id);

	RETURN NEW;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_fichier_ressource() OWNER TO pgsql;

--
-- TOC entry 1686 (class 1255 OID 2596587)
-- Dependencies: 2983 5
-- Name: insert_formateur_droits_defaut(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_formateur_droits_defaut() RETURNS "trigger"
    AS $$DECLARE

BEGIN
	INSERT INTO contraintes.formateur_droits
	(formation, droit) 
	SELECT NEW.formation, D_id  
	FROM contraintes.af_get_droits_defaut(1) AS (D_id int4, D_libelle varchar,D_type int4); 
	
	RETURN NEW;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_formateur_droits_defaut() OWNER TO pgsql;

--
-- TOC entry 1687 (class 1255 OID 2596588)
-- Dependencies: 2983 5
-- Name: insert_glossaire(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_glossaire() RETURNS "trigger"
    AS $$DECLARE
id_etape int4;
lib varchar;
BEGIN
	--selection du libelle du fichier pour le libelle de l'etape (table principale)
	SELECT INTO lib libelle FROM contraintes.fichier WHERE id=NEW.id;

	--creation de l'etape (table principale)
	--SELECT INTO id_etape  contraintes.af_set_etape(lib, 11);
	
	--insertion dans la table spÃ©cifique au scenario
	INSERT INTO contraintes.glossaire (fichier,libelle) VALUES (NEW.id,lib);

	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_glossaire() OWNER TO pgsql;

--
-- TOC entry 48 (class 1255 OID 2596589)
-- Dependencies: 2983 5
-- Name: insert_langue_message_others(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_langue_message_others() RETURNS "trigger"
    AS $$DECLARE
	
curs CURSOR (n_langue integer,n_id integer,n_type integer) FOR 
		SELECT L.id
		FROM contraintes.langue_message LM
		RIGHT OUTER JOIN contraintes.langue L
		ON (L.id=LM.langue AND  LM.type=n_type
		AND LM.id=n_id)
		WHERE LM.langue IS NULL;
		
row_langue_id integer;
BEGIN
	OPEN curs(NEW.langue,NEW.id,NEW.type);
	
	FETCH curs INTO row_langue_id;

	CLOSE curs;

	IF NOT FOUND THEN
		--RAISE NOTICE 'no more langue';
	ELSE
		--RAISE NOTICE 'insert for language %',row_langue_id;
		PERFORM * FROM contraintes.af_set_langue_message(NEW.id,row_langue_id, NEW.type,NEW.libelle);
	END IF;
	
	RETURN NEW;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_langue_message_others() OWNER TO pgsql;

--
-- TOC entry 1688 (class 1255 OID 2596590)
-- Dependencies: 2983 5
-- Name: insert_liste(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_liste() RETURNS "trigger"
    AS $_$DECLARE
val_type int4:=TG_ARGV[0];
--$1 le type de liste
BEGIN
	RAISE NOTICE 'NEW.id=% TG_ARGV[0]=%',NEW.id, val_type;
	INSERT INTO contraintes.liste (id, type) VALUES (NEW.id, int4 (val_type));
	
	RETURN NEW;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_liste() OWNER TO pgsql;

--
-- TOC entry 49 (class 1255 OID 2596591)
-- Dependencies: 2983 5
-- Name: insert_qcm_sondage(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_qcm_sondage() RETURNS boolean
    AS $$declare
qcm record;
question_qcm integer;
rep record;
begin
    -- boucle sur les qcm et sondage de la plate forme
    for qcm in 
	select id from contraintes.question_reponse where type=2 or type=1 order by id
    loop
        --raise notice 'qcm=%',qcm.id;
	-- recup le numero de question
	select into question_qcm distinct question from contraintes.question_reponse_elements 
	where question_reponse=qcm.id;
	--raise notice 'question_qcm=%',question_qcm;
	-- enregistre la question
	insert into contraintes.question_reponse_elements_new(question_reponse,question_reponse_element,pere) 
	values(qcm.id,question_qcm,null);
	-- boucle sur les reponses du qcm
	for rep in
	    select distinct reponse,pere from contraintes.question_reponse_elements 
	    where question_reponse=qcm.id 
	loop
	    insert into contraintes.question_reponse_elements_new(question_reponse,question_reponse_element,pere) 
	values(qcm.id,rep.reponse,rep.pere);
	end loop;
	
    end loop;
    return true;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_qcm_sondage() OWNER TO pgsql;

--
-- TOC entry 8865 (class 0 OID 0)
-- Dependencies: 49
-- Name: FUNCTION insert_qcm_sondage(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION insert_qcm_sondage() IS 'insert les qcm de question_reponse_elements dans
question_reponse_elements_new';


--
-- TOC entry 1919 (class 1255 OID 2596592)
-- Dependencies: 2983 5
-- Name: insert_qsrc(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_qsrc() RETURNS boolean
    AS $$declare
qsrc record;
quest record;
rep record;
rep_pere integer;
begin
    -- boucle sur les qrc de la plate forme
    for qsrc in 
        select id from contraintes.question_reponse where type=4 or type=5 order by id
    loop
	--raise notice 'qsrc=%',qsrc.id;
	-- boucle sur les question du qsrc
	for quest in
	    select distinct question,pere from contraintes.question_reponse_elements where question_reponse=qsrc.id
		
	    loop
	raise notice 'qsrc=% question=% pere=%',qsrc.id,quest.question,quest.pere;
		insert into contraintes.question_reponse_elements_new(question_reponse,question_reponse_element,pere) 
		values(qsrc.id,quest.question,quest.pere);
	    end loop;
	-- boucle sur les reponse du qsrc
	rep_pere:=null;
	for rep in
	    select distinct reponse from contraintes.question_reponse_elements where question_reponse=qsrc.id
	    
	loop
	    insert into contraintes.question_reponse_elements_new(question_reponse,question_reponse_element,pere)
	    values(qsrc.id,rep.reponse,rep_pere);
	    rep_pere:=rep.reponse;

	end loop;
    end loop;

    return true;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_qsrc() OWNER TO pgsql;

--
-- TOC entry 8867 (class 0 OID 0)
-- Dependencies: 1919
-- Name: FUNCTION insert_qsrc(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION insert_qsrc() IS 'insert les qsrc de la table question_reponse_elements dans la
table question_reponse_elements_new';


--
-- TOC entry 1689 (class 1255 OID 2596593)
-- Dependencies: 2983 5
-- Name: insert_question_reponse_element(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_question_reponse_element() RETURNS "trigger"
    AS $_$--$1 reponse?
BEGIN
	IF NEW.reponse IS TRUE THEN
		INSERT INTO contraintes.reponse (id) VALUES (NEW.id);
	ELSE
		INSERT INTO contraintes.question (id) VALUES (NEW.id);
	END IF;

	RETURN NEW;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_question_reponse_element() OWNER TO pgsql;

--
-- TOC entry 1690 (class 1255 OID 2596594)
-- Dependencies: 2983 5
-- Name: insert_ressource(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_ressource() RETURNS "trigger"
    AS $$DECLARE
id_etape int4;
lib varchar;
BEGIN
	--selection du libelle du fichier pour le libelle de l'etape (table principale)
	SELECT INTO lib libelle FROM contraintes.fichier WHERE id=NEW.id;

	--creation de l'etape (table principale)
	SELECT INTO id_etape  contraintes.af_set_etape(lib, 7);
	
	--insertion dans la table spÃ©cifique au scenario
	INSERT INTO contraintes.ressource (id, fichier) VALUES (id_etape, NEW.id);

	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_ressource() OWNER TO pgsql;

--
-- TOC entry 1691 (class 1255 OID 2596595)
-- Dependencies: 2983 5
-- Name: insert_scenario(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_scenario() RETURNS "trigger"
    AS $$DECLARE
id_etape int4;
lib varchar;
BEGIN
	--selection du libelle du fichier pour le libelle de l'etape (table principale)
	SELECT INTO lib libelle FROM contraintes.fichier WHERE id=NEW.id;

	--creation de l'etape (table principale)
	SELECT INTO id_etape  contraintes.af_set_etape(lib, 6);
	
	--insertion dans la table spÃ©cifique au scenario
	INSERT INTO contraintes.scenario (id, fichier) VALUES (id_etape, NEW.id);

	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_scenario() OWNER TO pgsql;

--
-- TOC entry 1692 (class 1255 OID 2596596)
-- Dependencies: 2983 5
-- Name: insert_scenario_dynamique(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_scenario_dynamique() RETURNS "trigger"
    AS $$DECLARE
id_etape int4;
lib varchar;
BEGIN
	--selection du libelle du fichier pour le libelle de l'etape (table principale)
	SELECT INTO lib libelle FROM contraintes.fichier WHERE id=NEW.id;

	--creation de l'etape (table principale)
	SELECT INTO id_etape  contraintes.af_set_etape(lib, 11);
	
	--insertion dans la table spÃ©cifique au scenario
	INSERT INTO contraintes.scenario_dynamique (id, fichier) VALUES (id_etape, NEW.id);

	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_scenario_dynamique() OWNER TO pgsql;

--
-- TOC entry 1693 (class 1255 OID 2596597)
-- Dependencies: 2983 5
-- Name: insert_serie_aleatoire_multitheme_theme_categorie(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_serie_aleatoire_multitheme_theme_categorie() RETURNS "trigger"
    AS $$begin
  perform * from contraintes.af_set_categorie_element_theme(19,new.theme_source,new.serie);
 return new; 
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_serie_aleatoire_multitheme_theme_categorie() OWNER TO pgsql;

--
-- TOC entry 8873 (class 0 OID 0)
-- Dependencies: 1693
-- Name: FUNCTION insert_serie_aleatoire_multitheme_theme_categorie(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION insert_serie_aleatoire_multitheme_theme_categorie() IS 'enregistre un theme d''une serie aleatoire multitheme dans categorie_serie';


--
-- TOC entry 1694 (class 1255 OID 2596598)
-- Dependencies: 2983 5
-- Name: insert_session_debut(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION insert_session_debut() RETURNS "trigger"
    AS $$BEGIN
	INSERT INTO contraintes.session
	(sid,name,debut) VALUES (NEW.sid, NEW.name, now());

	IF FOUND THEN
		RETURN NEW;
	ELSE
		RETURN NULL;
	END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_session_debut() OWNER TO postgres;

--
-- TOC entry 1695 (class 1255 OID 2596599)
-- Dependencies: 2983 5
-- Name: insert_session_fin(); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION insert_session_fin() RETURNS "trigger"
    AS $$BEGIN
	UPDATE contraintes.session
	SET fin=now()
	WHERE sid=OLD.sid
	AND name=OLD.name ;

	IF FOUND THEN
		RETURN OLD;
	ELSE
		RETURN NULL;
	END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_session_fin() OWNER TO postgres;

--
-- TOC entry 51 (class 1255 OID 2596600)
-- Dependencies: 2983 5
-- Name: insert_submodule_module_individu_type(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION insert_submodule_module_individu_type() RETURNS "trigger"
    AS $$DECLARE
module_pere integer;
tab_type integer[];
BEGIN
	SELECT INTO module_pere module 
	FROM contraintes.fw_module_submodules
	WHERE NEW.module=submodule;

	IF module_pere IS NOT NULL THEN
		tab_type[1]:=NEW.individu_type;
		PERFORM contraintes.fw_set_module_individus_types(module_pere,tab_type );
	END IF;

	RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.insert_submodule_module_individu_type() OWNER TO pgsql;

--
-- TOC entry 50 (class 1255 OID 2596601)
-- Dependencies: 2983 5
-- Name: is_individu_individu_type(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION is_individu_individu_type(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 individu
--$2 type_individu
BEGIN
	PERFORM * FROM contraintes.fw_individu_types
	WHERE individu=$1
	AND type=$2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.is_individu_individu_type(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1696 (class 1255 OID 2596602)
-- Dependencies: 2983 5
-- Name: old_af_get_formations(integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION old_af_get_formations(integer) RETURNS SETOF record
    AS $_$-- $1 : periode (ex : 100 -> passe, 010 -> present, 001 -> future)
declare
rec record;

begin
    if $1=1 then 
        for rec in 
	    select id,libelle,date_debut,date_fin,langue 
	    from contraintes.af_get_formation() as 
	    (id int4,libelle varchar,parcours int4,date_debut timestamp,date_fin timestamp,langue int4) 
	    where date_fin<current_date
	loop
	return next rec;
    end loop;
    else
	if $1=2 then
	    for rec in 
		select id,libelle,date_debut,date_fin,langue 
	        from contraintes.af_get_formation() as 
	        (id int4,libelle varchar,parcours int4,date_debut timestamp,date_fin timestamp,langue int4) 
	        where current_date between date_debut and date_fin
	    loop
	         return next rec;
            end loop;
	else
	    for rec in 
		select id,libelle,date_debut,date_fin,langue 
	        from contraintes.af_get_formation() as 
	        (id int4,libelle varchar,parcours int4,date_debut timestamp,date_fin timestamp,langue int4) 
	        where date_debut>current_date
	    loop
		return next rec;
	    end loop;
	end if;
    end if;
    
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.old_af_get_formations(integer) OWNER TO pgsql;

--
-- TOC entry 8878 (class 0 OID 0)
-- Dependencies: 1696
-- Name: FUNCTION old_af_get_formations(integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION old_af_get_formations(integer) IS 'retourne les formations de la plateforme en fonction d''une periode';


--
-- TOC entry 1697 (class 1255 OID 2596603)
-- Dependencies: 2983 5
-- Name: old_af_get_question_reponse_elements(integer); Type: FUNCTION; Schema: contraintes; Owner: postgres
--

CREATE FUNCTION old_af_get_question_reponse_elements(integer) RETURNS SETOF record
    AS $_$declare 
rec record;
begin
	for rec in
		select id,libelle,interpretation_html,reponse from contraintes.question_reponse_element 
		--select * from contraintes.question_reponse_element 
		where type=$1
	loop
		return next rec;
	end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.old_af_get_question_reponse_elements(integer) OWNER TO postgres;

--
-- TOC entry 8880 (class 0 OID 0)
-- Dependencies: 1697
-- Name: FUNCTION old_af_get_question_reponse_elements(integer); Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON FUNCTION old_af_get_question_reponse_elements(integer) IS 'FONCTION PRIVEE: Obtenir las enregistrements de la table question_reponse_element pour un type donnÃ©';


--
-- TOC entry 1698 (class 1255 OID 2596604)
-- Dependencies: 2983 5
-- Name: old_af_get_resultat_serie_evaluations_scores(bigint); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION old_af_get_resultat_serie_evaluations_scores(bigint) RETURNS SETOF record
    AS $_$DECLARE
--$1 identifiant resultat
rec RECORD;
rec_resultat RECORD;
res_sondage integer;
BEGIN
	SELECT INTO rec_resultat * FROM contraintes.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	
	FOR rec IN
		SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS integer)  AS score
		FROM contraintes.af_get_serie_evaluations(rec_resultat.etape) 
		AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	LOOP
		--QCM et QRC
		/*IF rec.type_evaluation=1 OR rec.type_evaluation=4 THEN
			--SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_questionreponses_scores(rec_resultat.id, rec.evaluation);
			rec.score=12;
			--SELECT RSQR.id, RSQR.question_reponse, RSQR.question, RSQR.reponse, RSQR.coche
			--FROM contraintes.resultat_serie_question_reponse RSQR
			--WHERE RSQR.question_reponse=rec.id_evaluation 
			--AND RSQR.id=rec_resultat.id;
		
		--Sondage et SRC
		ELSE*/
		IF rec.type_evaluation=2 THEN --OR rec.type_evaluation=5 
			SELECT INTO res_sondage RSQR.reponse
			FROM contraintes.resultat_serie_question_reponse RSQR
			WHERE RSQR.question_reponse=rec.id_evaluation 
			AND RSQR.id=rec_resultat.id
			AND coche IS TRUE;
			--pas de note pour les sondages, on met l'identifiant de la réponse du stagiaire
			rec.score=res_sondage;
		/*--FTB
		ELSEIF rec.type_evaluation=3 THEN
			SELECT INTO rec.score * FROM contraintes.af_get_resultat_serie_ftb_scores(rec_resultat.id, rec.evaluation);
			rec.score=CAST(NULL AS integer);
			--FTB
			--SELECT RSFTB.id, RSFTB.ftb, RSFTB.reponse
			--FROM contraintes.resultat_serie_ftb RSFTB
			--WHERE RSFTB.ftb=rec.id_evaluation 
			--AND RSFTB.id=rec_resultat.id;
		ELSE
			RAISE EXCEPTION 'Le type d''evaluation ''%'' est inconnu de la fonction af_get_resultat_serie_evaluations_scores($resultat)',rec.type_evaluation;
		*/END IF;
		RETURN NEXT rec;
	END LOOP;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.old_af_get_resultat_serie_evaluations_scores(bigint) OWNER TO pgsql;

--
-- TOC entry 8882 (class 0 OID 0)
-- Dependencies: 1698
-- Name: FUNCTION old_af_get_resultat_serie_evaluations_scores(bigint); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION old_af_get_resultat_serie_evaluations_scores(bigint) IS 'Obtenir les résultats des evaluations d''une serie.';


--
-- TOC entry 1699 (class 1255 OID 2596605)
-- Dependencies: 2983 5
-- Name: old_af_get_theme_series(integer, integer); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION old_af_get_theme_series(integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
type_serie RECORD;
begin
    for rec in
	select e.id,e.libelle from 
	contraintes.etape e,
	contraintes.categorie_serie cs,
	contraintes.liste l
	where 
	e.id=cs.id and 
	cs.categorie=$2 and
	cs.theme=$1 and
	l.type=1 and l.id=e.id
	ORDER BY e.libelle
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.old_af_get_theme_series(integer, integer) OWNER TO pgsql;

--
-- TOC entry 8884 (class 0 OID 0)
-- Dependencies: 1699
-- Name: FUNCTION old_af_get_theme_series(integer, integer); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION old_af_get_theme_series(integer, integer) IS 'retourne les serie associées à un theme';


--
-- TOC entry 1700 (class 1255 OID 2596606)
-- Dependencies: 2983 5
-- Name: substr_count(text, text); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION substr_count(chaine text, souschaine text) RETURNS integer
    AS $$
/* Compte le nombre d'occurence d'une souschaine dans une chaine
   
   Exemple : SELECT stroccurence('Ici un mot, et la un deuxieme mot','mot');
             2
 */
BEGIN
 return array_upper(string_to_array(chaine,souschaine),1)-1;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.substr_count(chaine text, souschaine text) OWNER TO pgsql;

--
-- TOC entry 1701 (class 1255 OID 2596607)
-- Dependencies: 2983 5
-- Name: update_serie_aleatoire_multitheme_categorie_serie(); Type: FUNCTION; Schema: contraintes; Owner: pgsql
--

CREATE FUNCTION update_serie_aleatoire_multitheme_categorie_serie() RETURNS "trigger"
    AS $$begin
	update contraintes.categorie_serie 
	set theme=new.theme_source 
	where id=new.id and theme=old.theme_source;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION contraintes.update_serie_aleatoire_multitheme_categorie_serie() OWNER TO pgsql;

--
-- TOC entry 8887 (class 0 OID 0)
-- Dependencies: 1701
-- Name: FUNCTION update_serie_aleatoire_multitheme_categorie_serie(); Type: COMMENT; Schema: contraintes; Owner: pgsql
--

COMMENT ON FUNCTION update_serie_aleatoire_multitheme_categorie_serie() IS 'met à jour un enregistrement de la table categorie_serie';


SET search_path = public, pg_catalog;

--
-- TOC entry 1702 (class 1255 OID 2596608)
-- Dependencies: 2983 6
-- Name: _af_check_access(character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_check_access(character varying, integer, integer) RETURNS integer
    AS $_$DECLARE
	ok int:=0;

BEGIN
			ok:= (select count(*) from DROIT
			where libelle_droit =$1 and num_droit in
 	  			(select distinct g_num_droit from GESTIONNAIRE
				where g_num_cal =$2 
				and g_num_user =$3));
	
			RETURN ok;
	
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_check_access(character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1703 (class 1255 OID 2596609)
-- Dependencies: 2983 6
-- Name: _af_check_aleatoire_serie(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_check_aleatoire_serie(integer) RETURNS integer
    AS $_$-- paramÃštre : numÃ©ro de sÃ©rie
BEGIN
RETURN(select count(num_serie) from serie_aleatoire where num_serie=$1);
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_check_aleatoire_serie(integer) OWNER TO pgsql;

--
-- TOC entry 1704 (class 1255 OID 2596610)
-- Dependencies: 2983 6
-- Name: _af_check_dynamique_parcours(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_check_dynamique_parcours(integer) RETURNS SETOF record
    AS $_$-- paramÃštre : numÃ©ro de calendrier

DECLARE
   rec RECORD;
BEGIN
   FOR rec IN select num_parcours from config_orientation where num_parcours in (select distinct                       
              g_num_parcours from gestionnaire where g_num_cal=$1)
   LOOP
     RETURN NEXT rec;
   END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_check_dynamique_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 1705 (class 1255 OID 2596611)
-- Dependencies: 2983 6
-- Name: _af_check_groupe(integer, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_check_groupe(integer, character varying) RETURNS integer
    AS $_$--verifie si un groupe existe deja
--$1 numero du groupe pere
--$2 nom du groupe
DECLARE
nb integer;
pos integer;
BEGIN

	pos:=position('/' IN $2);

	IF (pos=0)
		THEN

		nb:=(select count(*) from classe
					where id_pere=$1
					and LOWER(nom) LIKE LOWER($2));

		IF (nb<=0)
			THEN 
		
				RETURN 0;
			
		ELSE 
			--RAISE EXCEPTION '%/% existe deja % fois',$1,$2,nb;
			RETURN 1;

		END IF;

	ELSE
		--RAISE EXCEPTION 'p%',pos;
		RETURN 0;
	END IF;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_check_groupe(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1706 (class 1255 OID 2596612)
-- Dependencies: 2983 6
-- Name: _af_del_avancement_stagiaire(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_del_avancement_stagiaire(integer, integer, integer) RETURNS integer
    AS $_$--$1 numero du stagiaire
--$2 numero du groupe du stagiaire
--$3 numero de la formation

DECLARE
parcours integer;

BEGIN

	PERFORM _af_del_exotlc_stagiaire($1,$3,null);

	DELETE FROM res_serie WHERE id_stag=$1 AND id_formation=$3 ;
	DELETE FROM res_serie_exo WHERE id_stag=$1 AND id_formation=$3 ;

	DELETE FROM gestionqst WHERE gqst_num_user=$1 AND num_cal=$3 ;

	PERFORM	_af_del_series_bloquantes_stagiaire($1, $3,null);

	SELECT _af_get_parcours_formation($3) INTO parcours;

	PERFORM _af_set_avancement_stagiaire($1, $2 ,  $3, parcours, 0, '0', 0);

	RETURN 1;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_del_avancement_stagiaire(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1707 (class 1255 OID 2596613)
-- Dependencies: 2983 6
-- Name: _af_del_exotlc_stagiaire(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_del_exotlc_stagiaire(integer, integer, integer) RETURNS integer
    AS $_$-- $1 numero de stagiaire
-- $2 numero de formation
--	$3 numero de l'exercice (facultatif)
DECLARE
req varchar;
req1 varchar;
BEGIN
	
	--suppression des resultats
	DELETE FROM resexouser 
	WHERE num_user=$1 
	AND num_cal=$2 ;
 	
	--suppression des commentaires de correction
	req:='delete from COMMENTUSERRUB 
	where num_user='||$1;

	IF($3 IS NOT NULL)
		THEN
		req:=req||'and num_exo='||$3;
	END IF;
	
	req:=req||'and num_cal='||$2||';';

	EXECUTE req;
	
	--suppression des commentaires de correction
	req1:='DELETE FROM gestexotlc 
	where gesttlc_user='||$1;

	IF($3 IS NOT NULL)
		THEN
		req1:=req1||'and num_exo='||$3;
	END IF;
	
	req1:=req1||'and num_cal='||$2||';';

	EXECUTE req1;

	RETURN 1;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_del_exotlc_stagiaire(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1708 (class 1255 OID 2596614)
-- Dependencies: 2983 6
-- Name: _af_del_groupe(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_del_groupe(integer) RETURNS integer
    AS $_$--$1 numero du groupe
DECLARE
rec RECORD;
num integer;
BEGIN
				num:=$1;
        	--suppression du pere courant
        	delete from classe where id=num;

				--suppression du lien avec la formation
        delete from gestionutil where gu_num_gest_gr=num;
			  --suppression des places du groupe
        delete from placegroupe where num_gest_groupe=num;
				
        --recup de ses fils
        FOR rec IN
					select * from classe where id_pere=num
				LOOP
					num:=rec.id;
					PERFORM _af_del_groupe(num);
				END LOOP;

        return 1;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_del_groupe(integer) OWNER TO pgsql;

--
-- TOC entry 1709 (class 1255 OID 2596615)
-- Dependencies: 2983 6
-- Name: _af_del_individu_groupe(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_del_individu_groupe(integer, integer, integer) RETURNS integer
    AS $_$--$1 numero de l'individu
--$2 numero du groupe
--$3 numero de formation
--DECLARE
--rec RECORD; --pour le resultat du select(qui ne sert pas par la suite)
BEGIN

--on supprimme l'individu du groupe
delete from gestionutil where gu_num_user=$1 and gu_num_gest_gr=$2;

IF(FOUND)
	THEN
		--IF($3>=0 AND $3 NOT NULL)THEN
		-- on le supprime de la formation
		--delete from gestionparcours where gp_num_groupe=$2 and gp_num_user=$1 and num_cal=$3;
		--END IF;
	--IF(FOUND)
		--THEN
		--test si le groupe existe encore

		PERFORM 'select * from gestionutil where gu_num_gest_gr=$2';

		-- s'il n'existe plus on le supprime
		IF(NOT FOUND)
			THEN
      --on supprime dans gestionnaire
			--delete from gestionnaire where g_num_gest_g=$2;

		END IF;
		
		RETURN 1;
--	ELSE
		--RAISE EXCEPTION 'L''individu % n''a pu etre supprime de la formation %(groupe %)', $1, $3, $2;
	--	RETURN 0;
	--END IF;
ELSE
	RAISE EXCEPTION 'L''individu % n''a pu etre supprime du groupe % ', $1, $2;
	RETURN 0;
END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_del_individu_groupe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1710 (class 1255 OID 2596616)
-- Dependencies: 2983 6
-- Name: _af_del_series_bloquantes_stagi(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_del_series_bloquantes_stagi(integer, integer, integer) RETURNS integer
    AS $_$-- $1 numero de stagiaire
-- $2 numero de formation
--	$3 numero de la serie(facultatif)
DECLARE
req varchar;

BEGIN

	req:='	DELETE FROM stockresultserie 
				WHERE num_user='||$1;

	IF($3 IS NOT NULL)
		THEN
		req:=req||'and num_exo='||$3;
	END IF;
	
	req:=req||'and num_cal='||$2||';';

	EXECUTE req;
	
	IF(FOUND)
		THEN
			RETURN 1;
	ELSE 
			RETURN 0;
	END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_del_series_bloquantes_stagi(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1711 (class 1255 OID 2596617)
-- Dependencies: 2983 6
-- Name: _af_get_avancement_stagiaire(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_avancement_stagiaire(integer, integer) RETURNS record
    AS $_$declare 
		rec record;
begin
	select avancement,etape_libre into rec 
  from gestionparcours 
	where gp_num_user=$1 
	and num_cal=$2;

return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_avancement_stagiaire(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1712 (class 1255 OID 2596618)
-- Dependencies: 2983 6
-- Name: _af_get_avancement_stagiaires_f(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_avancement_stagiaires_f(integer) RETURNS SETOF record
    AS $_$--obtenir l'avancement de tous les stagiaires d'une formation--
--$1 numero de la formation
DECLARE
rec RECORD;

BEGIN

	FOR rec IN
		select distinct gp_num_user, avancement, etape_libre
		from gestionparcours
		where  num_cal=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_avancement_stagiaires_f(integer) OWNER TO pgsql;

--
-- TOC entry 1713 (class 1255 OID 2596619)
-- Dependencies: 2983 6
-- Name: _af_get_classes_formateur(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_classes_formateur(integer) RETURNS SETOF record
    AS $_$-- $1 le fomrateur pour lequel on veut les classes --
DECLARE 
rec RECORD;
BEGIN

	FOR rec IN 
		SELECT DISTINCT id,CL.nom
		from GESTIONNAIRE G, CALENDRIER C, CLASSE CL
		where G.g_num_cal=C.num_cal 
		and g_num_user=$1
		and G.g_num_gest_g=CL.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN rec;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_classes_formateur(integer) OWNER TO pgsql;

--
-- TOC entry 1714 (class 1255 OID 2596620)
-- Dependencies: 2983 6
-- Name: _af_get_connexions(integer, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_connexions(integer, character varying) RETURNS SETOF record
    AS $_$--retourne les connexions et deconnexions
--d'un stagiaire pour un mois donne

declare
	rec record;
	mois varchar;

begin
mois:=$2 || '%';
for rec in 
        SELECT date_connexion,date_deconnexion,nom,prenom
      FROM connexion, utilisateurs
      WHERE connexion.num_user=$1
      AND utilisateurs.num_user= connexion.num_user
      AND date_connexion LIKE mois
      ORDER BY date_connexion
loop
	return next rec;
end loop;
return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_connexions(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1715 (class 1255 OID 2596621)
-- Dependencies: 2983 6
-- Name: _af_get_droits_defaut(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_droits_defaut(integer) RETURNS SETOF record
    AS $_$--RETOURNE LES DROITS PAR DEFAULT
--$1 categorie 0 tous, 1 formateurs, 2 stagiaires
DECLARE
rec RECORD;
selection1 varchar;
selection2 varchar;
BEGIN
	IF($1=0)THEN
		selection1='u';
		selection2= 'f';
	ELSE
			IF($1=1)THEN
				selection1='f';
				selection2= 'f';
			ELSE
				IF($1=2)THEN
					selection1='u';
					selection2='u'; 	
					
				ELSE
					RAISE EXCEPTION 'la categorie selectionnee est invalide.';
				END IF;	

			END IF;	

	END IF;	

	FOR rec IN 
		select * from droit 
		where defaut=1 and type_droit LIKE selection1 or type_droit LIKE selection2
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_droits_defaut(integer) OWNER TO pgsql;

--
-- TOC entry 1716 (class 1255 OID 2596622)
-- Dependencies: 2983 6
-- Name: _af_get_droits_groupe_individu(integer, integer, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_droits_groupe_individu(integer, integer, character varying) RETURNS SETOF record
    AS $_$
-- Fonction qui donne les droits d'un individu dans un groupe
-- CHABOISSIER Jonathan 07/06/2004

-- Parametres :
-- 1. Identifiant de l'infividu en base de donnees
-- 2. Identifiant du groupe
-- 3. ASC ou DESC = affichage dans l'ordre croissant ou decroissant

DECLARE

        rec RECORD;

        -- on met la requete dans une chaine que l'on execute ensuite
        req varchar ;

        id_individu ALIAS FOR $1 ; -- Identifiant de l'infividu
        id_groupe ALIAS FOR $2 ; -- Identifiant du groupe
        ordre_affich ALIAS FOR $3 ; -- croissant ou decroissant

BEGIN

        -- Construction de la requete

        req := 'SELECT DISTINCT num_droit, libelle_droit, type_droit, acces_fichier, defaut
        FROM droit, gestionutil
        WHERE num_droit=gu_num_droit
        AND gu_num_gest_gr=' || id_groupe || '
        AND gu_num_user=' || id_individu || '
        ORDER BY libelle_droit ' ;

        -- Classement : 'ASC ou 'DESC'
        -- Si c'est autre chose que 'DESC', on ne met rien (ASC par dÃ¯Â¿Âœfaut)
        IF (ordre_affich='DESC') THEN
                req := req || ' DESC ;' ;
        ELSE
                req := req || ' ;' ;
        END IF ;

        -- Execution de la requete construite
        FOR rec IN
                EXECUTE req
        LOOP
                RETURN NEXT rec ;
        END LOOP;

        RETURN;
END;




$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_droits_groupe_individu(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1717 (class 1255 OID 2596623)
-- Dependencies: 2983 6
-- Name: _af_get_dynamique_parcours(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_dynamique_parcours(integer) RETURNS SETOF record
    AS $_$-- paramÃštre : numÃ©ro de calendrier

DECLARE
   rec RECORD;
BEGIN
   FOR rec IN select num_parcours from config_orientation where num_parcours in (select distinct                       
              g_num_parcours from gestionnaire where g_num_cal=$1)
   LOOP
     RETURN NEXT rec;
   END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_dynamique_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 1718 (class 1255 OID 2596624)
-- Dependencies: 2983 6
-- Name: _af_get_etapes_libres_parcours(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_etapes_libres_parcours(integer) RETURNS SETOF record
    AS $_$--$1 numero du parcours
DECLARE
rec RECORD;

BEGIN

	FOR rec IN

		SELECT num_etape
	 	FROM gestparcours 
		WHERE g_num_parcours=$1
		AND obligation='l' 
		AND type_etape<>'I'
	
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_etapes_libres_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 1719 (class 1255 OID 2596625)
-- Dependencies: 2983 6
-- Name: _af_get_form_de_groupe(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_form_de_groupe(integer) RETURNS SETOF record
    AS $_$
DECLARE
    rec RECORD;
BEGIN
FOR rec IN select distinct g_num_cal
           from gestionnaire
           where g_num_gest_g=$1
           and g_num_cal <>0
LOOP
   RETURN NEXT rec;
END LOOP;
RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_form_de_groupe(integer) OWNER TO pgsql;

--
-- TOC entry 1720 (class 1255 OID 2596626)
-- Dependencies: 2983 6
-- Name: _af_get_form_user_groupe_eval(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_form_user_groupe_eval(integer, integer) RETURNS SETOF record
    AS $_$
DECLARE 
     rec RECORD;
BEGIN
     FOR rec IN select distinct r.num_cal, nom_cal
                from resexouser r, calendrier c, gestionnaire
                where g_num_gest_g=$1
                and surtotal <> 0
                and r.num_cal <>0
                and num_user=$2
                and r.num_cal=c.num_cal
                and c.num_cal=g_num_cal
                group by r.num_cal, nom_cal
                union
                select distinct id_formation, nom_cal
                from res_serie,calendrier c, gestionnaire
                where g_num_gest_g=$1
                and score >=0
                and date_fin>0
                and id_stag=$2
                and id_formation=num_cal
                and num_cal=g_num_cal
                group by id_formation,nom_cal
                order by nom_cal
     LOOP
       RETURN NEXT rec;
     END LOOP;
RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_form_user_groupe_eval(integer, integer) OWNER TO pgsql;

--
-- TOC entry 52 (class 1255 OID 2596627)
-- Dependencies: 2983 6
-- Name: _af_get_formation_langues(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formation_langues(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
rec RECORD;
rec_res RECORD;
nb int4;
cur_langue varchar;
chaine_langues varchar;
BEGIN
	SELECT INTO rec 0 AS id, langue AS libelle, langue , langue AS locale, num_cal
	FROM calendrier
	WHERE num_cal=$1;

	chaine_langues:=rec.libelle;
	nb:=contraintes.substr_count(chaine_langues, ';')+1;
	
	FOR i IN 2 .. nb
	LOOP
		cur_langue:=split_part(chaine_langues, ';', i);
		raise notice '% langue:%',i,cur_langue;
		rec.langue:=cur_langue;
		raise notice 'rec=%',rec;
		IF cur_langue='french' THEN
			rec.id=1;
			rec.libelle:='$MSG_1594';
			rec.locale:='fr_FR';
		ELSEIF cur_langue='english' THEN
			rec.id=2;
			rec.libelle:='$MSG_1595';
			rec.locale:='en_GB';
		ELSEIF cur_langue='chinese' THEN
			rec.id=3;
			rec.libelle:='$MSG_1596';
			rec.locale:='zn_CN';
		ELSEIF cur_langue='japanese' THEN
			rec.id=4;
			rec.libelle:='$MSG_1597';
			rec.locale:='ja_JP';
		ELSEIF cur_langue='korean' THEN
			rec.id=5;
			rec.libelle:='$MSG_1598';
			rec.locale:='ko_KR';
		ELSEIF cur_langue='russian' THEN
			rec.id=6;
			rec.libelle:='$MSG_2175';
			rec.locale:='ru_RU';
		ELSEIF cur_langue='sudan' THEN
			rec.id=7;
			rec.libelle:='$MSG_2176';
			rec.locale:='sd_SD';
		ELSE 
			RAISE EXCEPTION 'la langue % n''a pas été implémentée pour la fonction _af_get_formation_langues(int4)',langue;
		END IF;
		RETURN NEXT rec;
	END LOOP; 

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formation_langues(integer) OWNER TO pgsql;

--
-- TOC entry 1721 (class 1255 OID 2596628)
-- Dependencies: 2983 6
-- Name: _af_get_formations(character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations(character varying, integer) RETURNS SETOF record
    AS $_$DECLARE 
     rec RECORD;
BEGIN
      IF ($1='current')
      THEN
         IF($2=1)
         THEN
            FOR rec IN select distinct id_formation, nom_cal
            from res_serie, calendrier, dates
            where score >=0
            and jour >= current_timestamp
            and id_formation=num_cal
            and datefin=num_date
            union
            select distinct rs.num_cal, nom_cal
            from resexouser rs, calendrier c, dates
            where rs.num_cal <>0
            and surtotal <>0
            and jour >= current_timestamp
            and rs.num_cal=c.num_cal
            and datefin=num_date
            order by nom_cal asc
            LOOP 
                RETURN NEXT rec;
            END LOOP;
         ELSE
            FOR rec IN select distinct id_formation, nom_cal
            from res_serie, calendrier, dates
            where score >=0
            and jour >= current_timestamp
            and id_formation=num_cal
            and datefin=num_date
            union
            select distinct rs.num_cal, nom_cal
            from resexouser rs, calendrier c, dates
            where rs.num_cal <>0
            and surtotal <>0
            and jour >= current_timestamp
            and rs.num_cal=c.num_cal
            and datefin=num_date
            LOOP 
                RETURN NEXT rec;
            END LOOP;
         END IF;
      ELSE
          IF($2=1)
          THEN  
            FOR rec IN select distinct id_formation, nom_cal
            from res_serie, calendrier, dates
            where score >=0
            and jour < current_timestamp
            and id_formation=num_cal
            and datefin=num_date
            union
            select distinct rs.num_cal, nom_cal
            from resexouser rs, calendrier c, dates
            where rs.num_cal <>0
            and surtotal <>0
            and jour < current_timestamp
            and rs.num_cal=c.num_cal
            and datefin=num_date
            order by nom_cal asc
            LOOP 
                RETURN NEXT rec;
            END LOOP;
          ELSE
            FOR rec IN select distinct id_formation, nom_cal
            from res_serie, calendrier, dates
            where score >=0
            and jour < current_timestamp
            and id_formation=num_cal
            and datefin=num_date
            union
            select distinct rs.num_cal, nom_cal
            from resexouser rs, calendrier c, dates
            where rs.num_cal <>0
            and surtotal <>0
            and jour < current_timestamp
            and rs.num_cal=c.num_cal
            and datefin=num_date
            LOOP 
                RETURN NEXT rec;
            END LOOP;
          END IF; 
      END IF;
    
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1722 (class 1255 OID 2596629)
-- Dependencies: 2983 6
-- Name: _af_get_formations_filiere(integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_filiere(integer, character varying, integer) RETURNS SETOF record
    AS $_$
-- Fonction qui donne les formations d'une filiere donnÃÂ©e
-- CHABOISSIER Jonathan 14/06/2004

-- Parametres :
-- 1. Identifiant de la filiere en base de donnees
-- 2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 3. si VRAI alors on ordonne par date et non plus par nom de formation

DECLARE

        rec RECORD;

        -- on met la requete dans une chaine que l'on execute ensuite
        req varchar ;

        id_filiere ALIAS FOR $1 ; -- Identifiant de la filiere
        ordre_affich ALIAS FOR $2 ; -- croissant ou decroissant
        par_date ALIAS FOR $3 ; -- ordonner par date ou par nom

BEGIN

        -- Construction de la requete

        req := 'SELECT DISTINCT num_cal, nom_cal, d1.jour, d2.jour
        FROM calendrier, gestionnaire, dates d1, dates d2
        WHERE g_num_gest_c=' || id_filiere || '
        AND g_num_cal=num_cal
        AND d1.num_date=datedeb AND d2.num_date=datefin
        ORDER BY ' ;

        -- Ordonner les formations par date de debut ?
        IF (par_date=1) THEN
                req := req || ' d1.jour ' ;
        ELSE
                req := req || ' nom_cal ' ;
        END IF ;

        -- Classement : 'ASC ou 'DESC'
        -- Si c'est autre chose que 'DESC', on ne met rien (ASC par dÃÂ¯ÃÂ¿ÃÂœfaut)
        IF (ordre_affich='DESC') THEN
                req := req || ' DESC ;' ;
        ELSE
                req := req || ' ;' ;
        END IF ;

        -- Execution de la requete construite
        FOR rec IN
            EXECUTE req
        LOOP
            RETURN NEXT rec ;
        END LOOP ;

        RETURN;
END;

$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_filiere(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1723 (class 1255 OID 2596630)
-- Dependencies: 2983 6
-- Name: _af_get_formations_formateur(integer, integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_formateur(integer, integer, character varying, integer) RETURNS SETOF record
    AS $_$

--$1 numreo d'utilisateur
--$2 periode (1,2,3)
--$3 DESC ou ASC
--$4 boolean ordonne par classe?

DECLARE
req varchar(4000); -- on met la requete dans une chaine que l'on execute ensuite--
rec RECORD; --l'enregistrement a retourner--

BEGIN

    -- debut conscrution de la requete
    req:= 'SELECT DISTINCT C.num_cal, C.nom_cal, g_num_gest_g ,CL.nom, datedeb, datefin , CAST (lower(C.nom_cal) AS varchar)AS ordre , CL.id'; 
    req:=req|| ' from GESTIONNAIRE G, CALENDRIER C, CLASSE CL  , dates D  ' ;

    -- si la periode est 2 on a besoin d'une deuxieme table date
    IF($2=2)THEN req:= req||', dates D2 ';
    END IF;
    
    -- suite de la requete
    req:=req ||'where G.g_num_cal=C.num_cal and g_num_user='||$1||
          'and G.g_num_gest_g=CL.id';


    -- on choisi la periode
    IF($2=1)THEN
        req:=req ||' and  datefin =D.num_date
              and jour < current_date order by ';
    
    ELSE
       BEGIN
         IF($2=2)THEN
            req:=req ||' and datedeb=D.num_date
                 and datefin =  D2.num_date
                 and   current_timestamp BETWEEN D.jour AND D2.jour
                  order by ';
            
         ELSE
            BEGIN
                IF($2=3)THEN
                    req:=req ||' and   datedeb =num_date
                    and jour > current_date
                    order by ';
                
                ELSE
                    RAISE EXCEPTION 'la periode specifiee est invalide';
                RETURN NULL;
                END IF;
            END;
         END IF;
       END;
    END IF;

    -- si on veut un classement par classe
    IF($4=1)THEN
          req:=req || ' CL.nom, ';   --on groupe sur les classes
    END IF;
    
    --croissant ou decroissant
    IF ($3='DESC' OR $3='ASC')THEN
       req:=req||' ordre '||$3; -- dÃÂ©croissant ou non...
    ELSE
       RAISE EXCEPTION 'l odre doit etre ASC ou DESC';
    END IF;

-- execution de la requete
FOR rec IN 
   EXECUTE req
LOOP 
   RETURN NEXT rec;
END LOOP;  

--retourne le resultat
  RETURN;

END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_formateur(integer, integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1724 (class 1255 OID 2596631)
-- Dependencies: 2983 6
-- Name: _af_get_formations_formateur(integer, character varying, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_formateur(integer, character varying, character varying, integer, integer) RETURNS SETOF record
    AS $_$-- FONCTION par Jonathan CHABOISSIER le 28/05/2004

-- On retourne : num_cal, nom_cal, langue, debut, fin, num_groupe, nom_groupe

-- DECLARATION DES VARIABLES
DECLARE

        -- Parametres recus
        id_formateur ALIAS FOR $1 ; -- Identifiant du formateur
        ordre_affich1 ALIAS FOR $2 ; -- croissant ou decroissant
        ordre_affich2 ALIAS FOR $3 ; -- croissant ou decroissant
        classement1 ALIAS FOR $4 ; -- numero du champ sur lequel on fait le tri
        classement2 ALIAS FOR $5 ; -- numero du champ sur lequel on fait le tri

        -- on met la requete dans une chaine que l'on execute ensuite
        req varchar(4000);

        -- RECORD est une sorte de tableau associatif
        rec RECORD;

-- CORPS DE LA FONCTION
 
BEGIN

        -- Construction de la requete qui retourne toutes les infos des formations du formateurs
        req := 'SELECT DISTINCT num_cal, nom_cal, D1.jour AS debut, D2.jour AS fin,
        langue, Cl.id AS num_groupe, Cl.nom AS nom_groupe
        FROM gestionnaire G, calendrier C,  dates D1,  dates D2, classe Cl
        WHERE G.g_num_user=' || id_formateur || '
        AND G.g_num_cal=C.num_cal
        AND G.g_num_gest_g=Cl.id
        AND datedeb=D1.num_date
        AND datefin=D2.num_date
	ORDER BY ';

        -- Classement par ordre chronologique sinon par ordre alphabetique
        IF (classement1=1) THEN
            req := req || ' nom_cal ';
        ELSE
            IF (classement1=2) THEN
               req := req || ' debut ';
            ELSE
               IF (classement1=3) THEN
                   req := req || ' nom_groupe ';
               ELSE
                   RAISE EXCEPTION 'PLPGSQL erreur : parametre 3 doit etre 1, 2 ou 3';                
               END IF ;
            END IF ;
        END IF ;
        -- fin classement 1

        -- Affichage dans l'ordre croissant ou decroissant 1
        IF (ordre_affich1='DESC') THEN
           req := req || 'DESC' ;
        ELSE
           req := req || 'ASC' ;           
        END IF ;
        -- fin ordre croissant ou dÃÂ©croissant 1

        -----------------------
        -- Deuxieme classement
        -----------------------

        -- classement2=0 > on ne fait pas de classement sur deux champs
        IF(classement2 = 0) THEN
            req := req || ' ; ';
        -- Sinon le champ dÃÂ©pend de la valeur de classement2
        ELSE
           -- Trois type de classement : par nom_cal, par date de debut ou par nom_groupe
           req:=req || ' , ' ;

           -- Choix du champ
           IF (classement2=1) THEN
                req := req || ' nom_cal ';
           ELSE
                IF (classement2=2) THEN
                    req := req || ' debut ';
                ELSE
                    IF (classement2=3) THEN
                         req := req || ' nom_groupe ';
                    ELSE
                      -- Le parametre classement2 a une mauvaise valeur
                      RAISE EXCEPTION 'PLPGSQL erreur : parametre 4 doit etre 0, 1, 2 ou 3';
                    END IF ;
                END IF ;
           END IF ;

           -- Affichage dans l'ordre croissant ou decroissant pour ce deuxiÃ¯Â¿Âœme classement
           IF (ordre_affich2='DESC') THEN
            req := req || ' DESC ;' ;
           ELSE
             req := req || ' ASC ;' ;
           END IF ;
        END IF;
        -- Fin deuxieme classement


        -- Execution de la requete construite
        FOR rec IN
                EXECUTE req

        -- Chaque ligne trouvees est stockee dans rec
        LOOP
                RETURN NEXT rec ;
        END LOOP ;

        -- Fin de fonction
        RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_formateur(integer, character varying, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1725 (class 1255 OID 2596632)
-- Dependencies: 2983 6
-- Name: _af_get_formations_formateur_pe(integer, integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_formateur_pe(integer, integer, character varying, integer) RETURNS SETOF record
    AS $_$-- Fonction de Remi Cocquet. Modifiee par Jonathan Chaboissier le 04/06/2004

--$1 numero d'utilisateur
--$2 periode (1,2,3)
--$3 DESC ou ASC
--$4 boolean ordonne par classe?


DECLARE
req varchar(4000); -- on met la requete dans une chaine que l'on execute ensuite--
rec RECORD; --l'enregistrement a retourner--

BEGIN

    -- debut conscrution de la requete
    req:= 'SELECT DISTINCT C.num_cal, C.nom_cal, D1.jour AS debut, D2.jour AS fin,
							langue, CL.id AS num_groupe, CL.nom AS nom_groupe, CAST (lower(C.nom_cal) AS varchar)AS ordre
 					FROM GESTIONNAIRE G, CALENDRIER C, CLASSE CL, dates D1, dates D2
					WHERE G.g_num_cal=C.num_cal and g_num_user=' || $1 || '
           AND G.g_num_gest_g=CL.id
					AND D1.num_date=datedeb AND D2.num_date=datefin';


    -- on choisi la periode
    IF($2=1) THEN
        req:=req || ' AND D2.jour < current_date ORDER BY ';
    
    ELSE
       BEGIN
         IF($2=2)THEN
            req:=req ||' AND current_timestamp BETWEEN D1.jour AND D2.jour ORDER BY ';
            
         ELSE
            BEGIN
                IF($2=3)THEN
                    req:=req ||' AND D1.jour > current_date ORDER BY ';
                
                ELSE
                    RAISE EXCEPTION 'Erreur parametre 2 : La periode specifiee est invalide!' ;
                RETURN NULL;
                END IF;
            END;
         END IF;
       END;
    END IF;

    
    -- si on veut un classement par classe
    IF($4=1)THEN
          req:=req || ' num_groupe, ';   --on groupe sur les classes
    END IF;
    

    --croissant ou decroissant
    IF ($3='DESC')THEN
       req:=req||' ordre DESC' ;
    ELSE
 -- si ce n'est pas DESC, ce sera ASC
       req:=req||' ordre ASC' ;
    END IF;





-- execution de la requete
FOR rec IN 
   EXECUTE req
LOOP 
   RETURN NEXT rec;
END LOOP;  

--retourne le resultat
  RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_formateur_pe(integer, integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1726 (class 1255 OID 2596633)
-- Dependencies: 2983 6
-- Name: _af_get_formations_groupe(integer, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_groupe(integer, character varying) RETURNS SETOF record
    AS $_$
-- Fonction qui donne les formations d'un groupe
-- Modif par CHABOISSIER Jonathan

-- $1 numero de groupe
-- $2 'ASC' ou 'DESC'

DECLARE
    rec RECORD ;
    req varchar ;
BEGIN

    req :='SELECT DISTINCT num_cal, g_num_parcours, nom_cal, d1.jour, d2.jour
           FROM gestionnaire, calendrier, dates d1, dates d2
           WHERE g_num_gest_g=' || $1 || '
           AND g_num_cal=num_cal
           AND datedeb=d1.num_date
           AND datefin=d2.num_date
           ORDER by nom_cal ' ;
    
      -- CLASSEMENT

      -- On ne verifie pas la validite du parametre.
      -- Si c'est autre chose que 'DESC', on ne met rien (ASC par dÃÂÃÂ©faut)
      IF ($2='DESC') THEN
          req := req || ' DESC ;' ;      
      ELSE
          req := req || ' ;' ;
      END IF ;

      FOR rec IN
        EXECUTE req
      LOOP
        RETURN NEXT rec;
      END LOOP;
RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_groupe(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1727 (class 1255 OID 2596634)
-- Dependencies: 2983 6
-- Name: _af_get_formations_groupe(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_groupe(integer, integer, integer) RETURNS SETOF record
    AS $_$
-- Donne toutes les formations d'un groupe pour une periode

-- $1 = numero du groupe --
-- $2 = numero du user --
-- $3 = numero de periode --
DECLARE
rec RECORD;
BEGIN

        IF($3=1) THEN

                FOR rec IN SELECT DISTINCT G.g_num_cal
                           from GESTIONNAIRE G, CALENDRIER C,  dates D,  dates D2
                           where G.g_num_gest_g=$1
                           and G.g_num_cal=C.num_cal
                           and G.g_num_user=$2
                           and  datefin =D.num_date and D.jour < current_date
                LOOP 
                    RETURN NEXT rec;
                END LOOP;

                ELSE IF($3=2) THEN

                    FOR rec IN SELECT DISTINCT G.g_num_cal
                        from GESTIONNAIRE G, CALENDRIER C,  dates D,  dates D2
                        where G.g_num_gest_g=$1
                        and G.g_num_cal=C.num_cal
                        and G.g_num_user=$2
                        and datedeb=D.num_date
                        and datefin =  D2.num_date
                        and   current_date BETWEEN D.jour AND D2.jour
                    LOOP 
                       RETURN NEXT rec;
                    END LOOP;

                        
                        ELSE IF($3=3) THEN

                    FOR rec IN SELECT DISTINCT G.g_num_cal
                        from GESTIONNAIRE G, CALENDRIER C,  dates D,  dates D2
                        where G.g_num_gest_g=$1
                        and G.g_num_cal=C.num_cal
                        and G.g_num_user=$2
                        and datedeb =D.num_date
                        and D.jour > current_date
                    LOOP 
                       RETURN NEXT rec;
                    END LOOP;
        
                        ELSE RAISE EXCEPTION 'La periode specifiee n''est pas valide';
                        
                        END IF;
                
                END IF;

        END IF;
RETURN;

END;



$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_groupe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1728 (class 1255 OID 2596635)
-- Dependencies: 2983 6
-- Name: _af_get_formations_groupe(integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_groupe(integer, character varying, integer) RETURNS SETOF record
    AS $_$
-- Fonction qui donne les formations d'un groupe
-- Modif par CHABOISSIER Jonathan

-- $1 numero de groupe
-- $2 'ASC' ou 'DESC'
-- $3 si VRAI alors on classe par date et non plus par nom de formation

DECLARE
    rec RECORD ;
    req varchar ;
BEGIN

    req :='SELECT DISTINCT num_cal, g_num_parcours, nom_cal, d1.jour, d2.jour
           FROM gestionnaire, calendrier, dates d1, dates d2
           WHERE g_num_gest_g=' || $1 || '
           AND g_num_cal=num_cal
           AND datedeb=d1.num_date
           AND datefin=d2.num_date
           ORDER by ' ;
    
      -- sur quel attribut ordonner ?

      -- Par date de debut
      IF ($3=1) THEN
          req := req || ' d1.jour ' ;      
      -- Par nom de formation
      ELSE
          req := req || ' nom_cal ' ;
      END IF ;


      -- CLASSEMENT (asc ou desc)

      -- On ne verifie pas la validite du parametre.
      -- Si c'est autre chose que 'DESC', on ne met rien (ASC par dÃÂÃÂ©faut)
      IF ($2='DESC') THEN
          req := req || ' DESC ;' ;      
      ELSE
          req := req || ' ;' ;
      END IF ;

      -- Execution requete
      FOR rec IN
        EXECUTE req
      LOOP
        RETURN NEXT rec;
      END LOOP;
RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_groupe(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1729 (class 1255 OID 2596636)
-- Dependencies: 2983 6
-- Name: _af_get_formations_individu(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_individu(integer) RETURNS SETOF record
    AS $_$
DECLARE 
rec RECORD;
f varchar(4); 
u varchar(4);
BEGIN 

f:='form';
u:='util';

FOR rec IN 
    select num_cal,nom_cal, f from calendrier 
     where num_cal in (select distinct g_num_cal 
                       from gestionnaire 
                       where g_num_user=$1) 
     and num_cal in (select distinct num_cal 
                     from CALENDRIER, DATES A, DATES B 
                     where datedeb=A.num_date 
                     and datefin=B.num_date 
                     and current_timestamp between A.jour and B.jour
                     )
    

    UNION 
      select num_cal,nom_cal,u 
       from calendrier 
       where num_cal in (select g_num_cal 
                         from gestionnaire 
                         where g_num_gest_g in (select distinct gu_num_gest_gr 
                                                from gestionutil 
                                                where gu_num_user=$1)
                         ) 
      and num_cal in ( select distinct num_cal 
                       from CALENDRIER, DATES A, DATES B 
                       where datedeb=A.num_date 
                       and datefin=B.num_date 
                       and current_timestamp between A.jour and B.jour
                      )
   


      LOOP 
          RETURN NEXT rec; 
      END LOOP;  
   RETURN; 
END;
 















$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_individu(integer) OWNER TO pgsql;

--
-- TOC entry 1730 (class 1255 OID 2596637)
-- Dependencies: 2983 6
-- Name: _af_get_formations_individu(integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_individu(integer, character varying, integer) RETURNS SETOF record
    AS $_$-- Fonction de Remi Cocquet, modifiee par Jonathan CHABOISSIER le 03/06/2004
-- Retourne toutes les formations d'un individu. Pour chaque formation, la categorie est specifiee

-- Parametres :
-- 1. Identifiant de l'infividu en base de donnees
-- 2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 3. Entier = 0 > classement pas nom, =1 > classement par date de debut


DECLARE

        rec RECORD;

        -- f et u seront remplaces par form et util (3eme champ)
        f varchar;
        u varchar;

        -- on met la requete dans une chaine que l'on execute ensuite
        req varchar ;

BEGIN

        f:='form';
        u:='util';        

        req := 'select num_cal,nom_cal, '''||f||''', d1.jour AS debut, d2.jour AS fin, langue
        from calendrier, dates d1, dates d2
        where d1.num_date=datedeb AND d2.num_date=datefin
        AND num_cal in (select distinct g_num_cal
                        from gestionnaire
                        where g_num_user=' || $1 || ')
        and num_cal in (select distinct num_cal
                        from CALENDRIER, DATES A, DATES B
                        where datedeb=A.num_date
                        and datefin=B.num_date
                        and current_timestamp between A.jour and B.jour
                        )

        UNION

        select num_cal,nom_cal, '''||u||''', d1.jour AS debut, d2.jour AS fin, langue
        from calendrier, dates d1, dates d2
        where d1.num_date=datedeb and d2.num_date=datefin
        and num_cal in (select g_num_cal
                                from gestionnaire
                                where g_num_gest_g in (select distinct gu_num_gest_gr
                                                        from gestionutil
                                                        where gu_num_user=' || $1 || ')
                                )
        and num_cal in ( select distinct num_cal
                        from CALENDRIER, DATES A, DATES B
                        where datedeb=A.num_date
                        and datefin=B.num_date
                        and current_timestamp between A.jour and B.jour
                        )
        order by ' ;


        -- ORDER BY

        -- Le second parametre est egal a 1 s'il faut afficher les formations dans l'ordre chronologique
        IF ($3=1) THEN
                req := req || 'debut' ;
        ELSE
                req := req || 'nom_cal' ;
        END IF ;


        -- CLASSEMENT

        -- On ne verifie pas la validite du parametre.
        -- Si c'est autre chose que 'DESC', on ne met rien (ASC par dÃÂ©faut)
        IF ($2='DESC') THEN
                req := req || ' DESC ;' ;      
        ELSE
                req := req || ' ;' ;
        END IF ;

-- RAISE EXCEPTION 'ma requete%',req ;


      -- Execution de la requete construite
      FOR rec IN
        EXECUTE req
      LOOP
        RETURN NEXT rec;
      END LOOP;

        RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_individu(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1731 (class 1255 OID 2596638)
-- Dependencies: 2983 6
-- Name: _af_get_formations_sondage_fini(character varying, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_sondage_fini(character varying, character varying) RETURNS SETOF record
    AS $_$declare
	rec record;
	req varchar;
	signe varchar;
begin
	if($1='current')
	then signe:='>=';
	else signe:='<';
	end if;

req:='select id_formation,nom_cal,lower(nom_cal) as minus
            from res_serie_exo, calendrier, dates
            where type_exo=''s''
            and jour '||signe||' '|| $2 ||'
            and id_formation=num_cal
            and datefin=num_date
            group by id_formation,nom_cal
            order by minus asc';

--raise exception 'error %',req;

for rec in execute req
loop
	return next rec;
end loop;
return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_sondage_fini(character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 1732 (class 1255 OID 2596639)
-- Dependencies: 2983 6
-- Name: _af_get_formations_stagiaire_ev(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_formations_stagiaire_ev(integer, integer) RETURNS SETOF record
    AS $_$DECLARE 
     rec RECORD;
BEGIN
     FOR rec IN select distinct r.num_cal, nom_cal
                from resexouser r, calendrier c, gestionnaire
                where g_num_gest_g=$1
                and surtotal <> 0
                and r.num_cal <>0
                and num_user=$2
                and r.num_cal=c.num_cal
                and c.num_cal=g_num_cal
                group by r.num_cal, nom_cal
                union
                select distinct id_formation, nom_cal
                from res_serie,calendrier c, gestionnaire
                where g_num_gest_g=$1
                and score >=0
                and date_fin>0
                and id_stag=$2
                and id_formation=num_cal
                and num_cal=g_num_cal
                group by id_formation,nom_cal
                order by nom_cal
     LOOP
       RETURN NEXT rec;
     END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_formations_stagiaire_ev(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1733 (class 1255 OID 2596640)
-- Dependencies: 2983 6
-- Name: _af_get_groupes_evaluation_fini(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_groupes_evaluation_fini(integer) RETURNS SETOF record
    AS $_$DECLARE
    rec RECORD;
		req varchar;
BEGIN

req:='select distinct gu_num_gest_gr,nom
                from gestionutil, classe
                where gu_num_gest_gr=id
                and gu_num_user in ( select distinct id_stag
                                                from res_serie
                                                where score >=0
                                                union
                                                select distinct num_user
                                                from resexouser
                                                where num_cal <>0)
                and gu_num_user in ( select num_user
                                                from utilisateurs
                                                where categorie like ''%u%'')';

IF $1=1
THEN    
		req:=req || 'order by nom asc';
END IF;



     FOR rec IN EXECUTE req
     LOOP
        RETURN NEXT rec;
     END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_groupes_evaluation_fini(integer) OWNER TO pgsql;

--
-- TOC entry 1734 (class 1255 OID 2596641)
-- Dependencies: 2983 6
-- Name: _af_get_groupes_individu(integer, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_groupes_individu(integer, character varying) RETURNS SETOF record
    AS $_$
-- Fonction qui donne les informations des groupes dont fait partie un individu.
-- CHABOISSIER Jonathan 07/06/2004

-- Parametres :
-- 1. Identifiant de l'infividu en base de donnees
-- 2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant

DECLARE

        rec RECORD;

        -- on met la requete dans une chaine que l'on execute ensuite
        req varchar ;

        id_individu ALIAS FOR $1 ; -- Identifiant de l'infividu
        ordre_affich ALIAS FOR $2 ; -- croissant ou decroissant

BEGIN

        -- Construction de la requete

        req := 'SELECT DISTINCT id, nom, id_pere, minplace, maxplace
        FROM classe, placegroupe, gestionutil
        WHERE num_gest_groupe=id
        AND id=gu_num_gest_gr
        AND gu_num_user=' || id_individu || '
        ORDER BY nom ' ;

        -- Classement : 'ASC ou 'DESC'
        -- Si c'est autre chose que 'DESC', on ne met rien (ASC par dÃ¯Â¿Âœfaut)
        IF (ordre_affich='DESC') THEN
                req := req || ' DESC ;' ;
        ELSE
                req := req || ' ;' ;
        END IF ;

        -- Execution de la requete construite
        FOR rec IN
                EXECUTE req
        LOOP
                RETURN NEXT rec ;
        END LOOP;

        RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_groupes_individu(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1735 (class 1255 OID 2596642)
-- Dependencies: 2983 6
-- Name: _af_get_individus(); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_individus() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;

BEGIN
	
	FOR rec IN
		SELECT * FROM utilisateurs
		ORDER BY nom	

	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_individus() OWNER TO pgsql;

--
-- TOC entry 1736 (class 1255 OID 2596643)
-- Dependencies: 2983 6
-- Name: _af_get_individus_affiliables(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_individus_affiliables(integer) RETURNS SETOF record
    AS $_$--$1 numero du groupe

DECLARE

ordre character varying;
nb_individus_groupes integer;
rec0 RECORD;
rec1 RECORD;
rec2 RECORD;

BEGIN

	ordre:='ASC';
	
	--on compte le nombre d'individus du groupe
	SELECT COUNT(*) INTO nb_individus_groupes FROM  _af_get_individus_groupe($1, 1, ordre,0)
	AS (num_user integer ,nom varchar ,prenom varchar ,categorie varchar); 

	IF(nb_individus_groupes<=0 )THEN

		--on renvoie tous les indivus
		FOR rec1 IN
			SELECT * FROM _af_get_individus() AS (num_user integer, id_user varchar, login varchar, password varchar, nom varchar, prenom varchar,
            adresse varchar, code varchar, ville varchar, email varchar, telfixe varchar, telport varchar,
            langue varchar, num_org integer, categorie varchar, session varchar, total varchar , temps integer, fic_photo varchar)
		LOOP
			RETURN NEXT rec1;
		END LOOP;		
RETURN;	
	ELSE
		
		--on renvoie tous les individus pas dans le groupe
		-- et d'organismes communs aux individus du groupe
		FOR rec2 IN
			select * FROM utilisateurs
       where   num_org in (	select num_org 
														from utilisateurs 
														where num_user in
        																		(select gu_num_user 
																		from gestionutil 
																		where gu_num_gest_gr=$1)
														UNION SELECT 0
														)
			
			and num_user not in
       						(select gu_num_user 
						from gestionutil 
						where gu_num_gest_gr=$1)
			order by nom, prenom

		LOOP
			RETURN NEXT rec2;
		END LOOP;		

	RETURN;	
	
	END IF;

	
	RETURN;	

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_individus_affiliables(integer) OWNER TO pgsql;

--
-- TOC entry 1737 (class 1255 OID 2596644)
-- Dependencies: 2983 6
-- Name: _af_get_individus_formation(integer, integer, integer, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_individus_formation(integer, integer, integer, character varying) RETURNS SETOF record
    AS $_$-- Fonction modifiee par CHABOISSIER Jonathan
-- Donne liste d'individus appartenant ÃÂ  une formation
-- num_user, nom, prenom, categorie

-- $1 numero de formation
-- $2 categorie (1=tous, 2=formateur, 3=stagiaires)
-- $3 Si = 1 > exclusivite ('f' ou 'u' et pas de 'fu')
-- $4 ASC ou DESC

DECLARE 
    rec RECORD;
    req varchar ;
    sel varchar ;
BEGIN
    
    
    -- ON DETERMINE LA SELECTION
    IF($2=0) THEN 
        sel:='%%';
    ELSE                 
        IF($2=1)THEN
             IF($3=1)THEN
                  sel:='f';
             ELSE
                   sel:='%f%';
             END IF;
        ELSE                        
             IF ($2=2) THEN
                  IF($3=1)THEN
                      sel:='u';
                  ELSE
                      sel:='%u%';
                  END IF;
                                                
             ELSE
                  RAISE EXCEPTION 'Erreur sur la selection';
             END IF;                        
        END IF;                
    END IF;



req := 'SELECT DISTINCT num_user, nom, prenom, categorie
        FROM gestionparcours, utilisateurs, gestionnaire
        WHERE num_cal=' || $1 || '
        AND num_user=gp_num_user
				AND num_cal=g_num_cal
				AND num_user<>g_num_user
        AND categorie LIKE ''' || sel || ''' 
        ORDER BY nom ' ;

        IF($4='DESC') THEN
          req := req || 'DESC ;' ;
        ELSE
          req := req || ' ;' ;
        END IF ;

        -- RAISE EXCEPTION 'Requete : %',req ;


        -- Execution de la requete construite
        FOR rec IN
                EXECUTE req

        -- Chaque ligne trouvees est stockee dans rec
        LOOP
                RETURN NEXT rec ;
        END LOOP ;

        -- Fin de fonction
        RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_individus_formation(integer, integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1738 (class 1255 OID 2596645)
-- Dependencies: 2983 6
-- Name: _af_get_individus_groupe(integer, integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_individus_groupe(integer, integer, character varying, integer) RETURNS SETOF record
    AS $_$--$1 numero de groupe
--$2 0 les individus, 1 les formateurs, 2 les utilisateurs
--$3 DESC sinon ASC
--$4 SI EGAL A 1 CHOIX EXCLUSIF
DECLARE
rec RECORD;
clas varchar(4);
sel varchar(10);

BEGIN

	-- ON DETERMINE LA SELECTION
	if($2=0)then 
		sel:='%%';
	else 
		
		if($2=1)then

			IF($4=1)THEN
				sel:='f';
			ELSE
				sel:='%f%';
			END IF;

		else
			
			if($2=2)then
				IF($4=1)THEN
					sel:='u';
				ELSE
					sel:='%u%';
				END IF;
						
			else raise exception 'Erreur sur la selection';

			end if;			

		end if;	
	
	end if;

	--REQUETE

	--DECROISSANT

	if($3 = 'DESC')THEN
		IF($1>=0)THEN

		FOR rec IN
			
			select num_user,nom, prenom, categorie 
			from utilisateurs
			where categorie like sel
			and num_user in (select gu_num_user 
											from gestionutil 
											where gu_num_gest_gr=$1)
			order by nom DESC, prenom ASC 
		LOOP
			RETURN NEXT rec;
		END LOOP;

	ELSE RAISE EXCEPTION 'Le numero de groupe est incorrect';
  END IF;

	--CROISSANT
	else 

	IF($1>=0)THEN

		FOR rec IN
			
			select num_user,nom, prenom, categorie 
			from utilisateurs
			where categorie like sel
			and num_user in (select gu_num_user 
											from gestionutil 
											where gu_num_gest_gr=$1)
			order by nom, prenom 
		LOOP
			RETURN NEXT rec;
		END LOOP;

	ELSE RAISE EXCEPTION 'Le numero de groupe est incorrect';
  END IF;

	end if;


	
	
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_individus_groupe(integer, integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1739 (class 1255 OID 2596646)
-- Dependencies: 2983 6
-- Name: _af_get_individus_organisme(integer, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_individus_organisme(integer, character varying) RETURNS SETOF record
    AS $_$
-- Fonction de Jonathan CHABOISSIER - 09/06/2004
-- Retourne les informations des infividus appartenant ÃÂ  l'organisme

-- Parametres :
-- 1. Identifiant de l'organisme
-- 2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant

DECLARE

        rec RECORD;

        -- on met la requete dans une chaine que l'on execute ensuite
        req varchar ;

BEGIN

        req := 'SELECT num_user, nom, prenom, categorie
        FROM utilisateurs
        WHERE num_org=' || $1 || '
        ORDER BY nom ' ;

        -- CLASSEMENT

        -- On ne verifie pas la validite du parametre.
        -- Si c'est autre chose que 'DESC', on ne met rien (ASC par dÃÂ©faut)
        IF ($2='DESC') THEN
                req := req || ' DESC ;' ;      
        ELSE
                req := req || ' ;' ;
        END IF ;

      -- Execution de la requete construite
      FOR rec IN
        EXECUTE req
      LOOP
        RETURN NEXT rec;
      END LOOP;

   RETURN;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_individus_organisme(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1740 (class 1255 OID 2596647)
-- Dependencies: 2983 6
-- Name: _af_get_individus_organisme(integer, character varying, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_individus_organisme(integer, character varying, integer, integer) RETURNS SETOF record
    AS $_$
-- Fonction de Jonathan CHABOISSIER - 09/06/2004
-- Retourne les informations des infividus appartenant ÃÂ  l'organisme

-- Parametres :
-- 1. Identifiant de l'organisme
-- 2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 3. Categorie : 0=tous, 1=formateurs & 2=stagiaires
-- 4. exclusif : si VRAI alors que les 'u' ou les 'f'

DECLARE

        rec RECORD;

        -- on met la requete dans une chaine que l'on execute ensuite
        req varchar ;

BEGIN

        req := 'SELECT num_user, nom, prenom, categorie
        FROM utilisateurs
        WHERE num_org=' || $1 ;


        -- les formateurs
        IF($3=1) THEN
            IF ($4=1) THEN
                req := req || ' AND categorie=''f'' ' ;
            ELSE
                req := req || ' AND categorie LIKE ''%f%'' ' ;
            END IF ;
        ELSE
            -- les stagiaires
            IF ($4=1) THEN
                req := req || ' AND categorie=''u'' ' ;
            ELSE
                req := req || ' AND categorie LIKE ''%u%'' ' ;
            END IF ;
        END IF ;

        -- CLASSEMENT

        -- On ne verifie pas la validite du parametre.
        -- Si c'est autre chose que 'DESC', on ne met rien (ASC par dÃÂ©faut)
        IF ($2='DESC') THEN
            req := req || ' ORDER BY nom DESC ;' ;      
        ELSE
            req := req || ' ORDER BY nom ;' ;
        END IF ;

      -- Execution de la requete construite
      FOR rec IN
        EXECUTE req
      LOOP
        RETURN NEXT rec;
      END LOOP;

   RETURN;
END

$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_individus_organisme(integer, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1741 (class 1255 OID 2596648)
-- Dependencies: 2983 6
-- Name: _af_get_infos_exos_formation(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_infos_exos_formation(integer) RETURNS SETOF record
    AS $_$-- parametre : numero de formation
declare
    rec record;
begin

for rec in select *
           from resexouser
           where num_cal=$1
           and num_cal <> 0
           group by num_resexouser, num_user, num_exo, commentaire, surtotal, score, date_correction, num_cal 
loop
   return next rec;
end loop;
return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_infos_exos_formation(integer) OWNER TO pgsql;

--
-- TOC entry 1742 (class 1255 OID 2596649)
-- Dependencies: 2983 6
-- Name: _af_get_infos_formation(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_infos_formation(integer) RETURNS record
    AS $_$
-- Fonction qui retourne les information utiles concernant une formation dont le num_cal est passÃÂ© en paramÃÂštre
-- Jonathan CHABOISSIER

-- Parametre : identifiant BD de la formation (calendrier)

DECLARE
    rec RECORD;
    num_formation ALIAS FOR $1 ;

BEGIN

    -- On ne selectionne que les infos utiles : infos formation + num formateur, groupe et filiÃÂšre

    SELECT DISTINCT num_cal, nom_cal, d1.jour AS debut, d2.jour AS fin, langue, g_num_user, g_num_gest_g, g_num_gest_c,g_num_parcours INTO rec
    FROM calendrier, gestionnaire, dates d1, dates d2
    WHERE num_cal=g_num_cal
    AND num_cal=num_formation
    AND datedeb=d1.num_date AND datefin=d2.num_date;
    
    RETURN rec;
END;




$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_infos_formation(integer) OWNER TO pgsql;

--
-- TOC entry 1743 (class 1255 OID 2596650)
-- Dependencies: 2983 6
-- Name: _af_get_infos_groupe(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_infos_groupe(integer) RETURNS record
    AS $_$--$1 numero du groupe
DECLARE
rec RECORD ;

BEGIN

	
	SELECT id, nom, id_pere, maxplace, minplace INTO rec FROM classe, placegroupe 
	WHERE id=$1
	AND id=num_gest_groupe;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_infos_groupe(integer) OWNER TO pgsql;

--
-- TOC entry 1744 (class 1255 OID 2596651)
-- Dependencies: 2983 6
-- Name: _af_get_infos_individu(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_infos_individu(integer) RETURNS record
    AS $_$
-- Fonction qui retourne la ligne num_user de la table utilisateurs
-- Jonathan CHABOISSIER

-- ParamÃÂštre : identifiant BD de l'individu (utilisateur)

DECLARE
    rec RECORD;
    mon_num_user ALIAS FOR $1 ;

BEGIN

    -- On ne selectionne que les informations utiles    
    SELECT login, password, nom, prenom, id_user,
    adresse, code, ville, email, telfixe, telport,
    langue, num_org, categorie, fic_photo INTO rec
    FROM utilisateurs
    WHERE num_user=mon_num_user ;
    
    RETURN rec;
END;






$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_infos_individu(integer) OWNER TO pgsql;

--
-- TOC entry 1745 (class 1255 OID 2596652)
-- Dependencies: 2983 6
-- Name: _af_get_infos_presentiel_stagia(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_infos_presentiel_stagia(integer, integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- recupere les infos du suivi presentiel
-- pour un stagiaire (null par defaut), une
-- formation et une grille donne
declare
	rec record;
	req varchar;


begin
	req:='select * from comment_presentiel where num_cal=' || $1;

	if($2 != null)
	then
				req:=req || 'and num_user=' || $2 || 'and num_grille=' || $3;
				if($4 != null)
				then
							req:=req || ' and num_titrecapacite=' || $4;
				end if;

				if($5 != null)
				then
							req:=req || ' and num_capacite=' || $5;
				end if;
	else
				req:=req || ' and num_grille=' || $3;
				
				if($4 != null)
				then
							req:=req || ' and num_titrecapacite=' || $4;
				end if;

				if($5 != null)
				then
							req:=req || ' and num_capacite=' || $5;
				end if;
				
				
	end if;

	req:=req || ' and notesur<>0 ';

	--raise exception 'ici %',req;
	for rec in execute req
	loop
			return next rec;
	end loop;
return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_infos_presentiel_stagia(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1746 (class 1255 OID 2596653)
-- Dependencies: 2983 6
-- Name: _af_get_infos_series_formation(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_infos_series_formation(integer) RETURNS SETOF record
    AS $_$-- parametre : numero de formation

declare
   rec record;

begin

    for rec in select *    
               from res_serie
               where id_formation=$1
               and score >=0
               and date_fin>0
               --group by id_serie,score
    loop
       return next rec;
    end loop;
return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_infos_series_formation(integer) OWNER TO pgsql;

--
-- TOC entry 1747 (class 1255 OID 2596654)
-- Dependencies: 2983 6
-- Name: _af_get_liste_groupe_eval(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_liste_groupe_eval(integer) RETURNS SETOF record
    AS $_$
DECLARE
    rec RECORD;
BEGIN
IF $1=1
THEN    
     FOR rec IN select distinct gu_num_gest_gr,nom
                from gestionutil, classe
                where gu_num_gest_gr=id
                and gu_num_user in ( select distinct id_stag
                                                from res_serie
                                                where score >=0
                                                union
                                                select distinct num_user
                                                from resexouser
                                                where num_cal <>0)
                and gu_num_user in ( select num_user
                                                from utilisateurs
                                                where categorie='u')
                order by nom asc
     LOOP
        RETURN NEXT rec;
     END LOOP;
ELSE
     FOR rec IN select distinct gu_num_gest_gr,nom
                from gestionutil, classe
                where gu_num_gest_gr=id
                and gu_num_user in ( select distinct id_stag
                                                from res_serie
                                                where score >=0
                                                union
                                                select distinct num_user
                                                from resexouser
                                                where num_cal <>0)
                and gu_num_user in ( select num_user
                                                from utilisateurs
                                                where categorie='u')
                
     LOOP
        RETURN NEXT rec;
     END LOOP;
END IF;
RETURN;
END;

$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_liste_groupe_eval(integer) OWNER TO pgsql;

--
-- TOC entry 1748 (class 1255 OID 2596655)
-- Dependencies: 2983 6
-- Name: _af_get_liste_stag_avec_eval(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_liste_stag_avec_eval(integer) RETURNS SETOF record
    AS $_$
DECLARE
    rec RECORD;
BEGIN
   IF $1=1
   THEN
     FOR rec IN select id_stag, nom
            from res_serie, utilisateurs
            where num_user=id_stag
            and score >=0
            union
            select ru.num_user, nom
            from resexouser ru, utilisateurs u
            where u.num_user=ru.num_user
            and num_cal <>0
            order by nom asc
     LOOP
        RETURN NEXT rec;
     END LOOP;
   ELSE
     FOR rec IN select id_stag, nom
            from res_serie, utilisateurs
            where num_user=id_stag
            and score >=0
            union
            select ru.num_user, nom
            from resexouser ru, utilisateurs u
            where u.num_user=ru.num_user
            and num_cal <>0
     LOOP
        RETURN NEXT rec;
     END LOOP;
   END IF;
RETURN;
END;

$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_liste_stag_avec_eval(integer) OWNER TO pgsql;

--
-- TOC entry 1749 (class 1255 OID 2596656)
-- Dependencies: 2983 6
-- Name: _af_get_liste_stag_groupe_eval(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_liste_stag_groupe_eval(integer) RETURNS SETOF record
    AS $_$
DECLARE 
    rec RECORD;
BEGIN
    FOR rec IN select distinct gu_num_user, nom, prenom
                        from gestionutil, utilisateurs
                        where gu_num_gest_gr=$1
                        and gu_num_user in ( select distinct id_stag
                                             from res_serie
                                             where score >=0
                                             union
                                             select distinct num_user
                                             from resexouser
                                             where num_cal <>0
                                             and surtotal <>0)
                        and num_user=gu_num_user
                        order by nom,prenom,gu_num_user
    LOOP
      RETURN NEXT rec;
    END LOOP;
RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_liste_stag_groupe_eval(integer) OWNER TO pgsql;

--
-- TOC entry 1750 (class 1255 OID 2596657)
-- Dependencies: 2983 6
-- Name: _af_get_mode_affichage_parcours(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_mode_affichage_parcours(integer) RETURNS integer
    AS $_$
-- Fonction qui donne le mode d'affichage d'un parcours (0,1 ou 2)
-- CHABOISSIER Jonathan le 01/07/2004
DECLARE

mode_affich integer ;

BEGIN

    SELECT count(*) INTO mode_affich
    FROM gestparcours
    WHERE g_num_parcours = $1
    AND num_etape_suivante = 1 ;

    IF (mode_affich>0) THEN
        RETURN(2) ;
    END IF ;

    SELECT count(*) INTO mode_affich
    FROM gestparcours
    WHERE g_num_parcours = $1
    AND type_etape = 'I' ;

    IF (mode_affich>0) THEN
        RETURN(1) ;
    ELSE
        RETURN(0) ;
    END IF ;

END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_mode_affichage_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 1751 (class 1255 OID 2596658)
-- Dependencies: 2983 6
-- Name: _af_get_nb_classes(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_classes(integer) RETURNS integer
    AS $_$-- $1 le fomrateur pour lequel on cherche le nombre de classes --

BEGIN

	return (SELECT count(DISTINCT CL.nom)
	from GESTIONNAIRE G, CALENDRIER C, CLASSE CL
	where G.g_num_cal=C.num_cal and g_num_user=$1
	and G.g_num_gest_g=CL.id);

END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_classes(integer) OWNER TO pgsql;

--
-- TOC entry 1752 (class 1255 OID 2596659)
-- Dependencies: 2983 6
-- Name: _af_get_nb_exos(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_exos(integer) RETURNS integer
    AS $_$BEGIN
RETURN(select count(*)
       from gestparcours
       where g_num_parcours in (select distinct g_num_parcours
                                from gestionnaire
                                where g_num_cal=$1)

       and type_etape='E');
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_exos(integer) OWNER TO pgsql;

--
-- TOC entry 1753 (class 1255 OID 2596660)
-- Dependencies: 2983 6
-- Name: _af_get_nb_exos_faits(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_exos_faits(integer, integer) RETURNS integer
    AS $_$
BEGIN
RETURN(select count(*)
       from resexouser
       where num_cal=$1
       and  num_user=$2);
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_exos_faits(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1754 (class 1255 OID 2596661)
-- Dependencies: 2983 6
-- Name: _af_get_nb_exos_finis(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_exos_finis(integer, integer) RETURNS integer
    AS $_$BEGIN
RETURN(select count(*)
       from resexouser
       where num_cal=$1
       and  num_user=$2);
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_exos_finis(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1755 (class 1255 OID 2596662)
-- Dependencies: 2983 6
-- Name: _af_get_nb_exos_form(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_exos_form(integer) RETURNS integer
    AS $_$
BEGIN
RETURN(select count(*)
       from gestparcours
       where g_num_parcours in (select distinct g_num_parcours
                                from gestionnaire
                                where g_num_cal=$1)

       and type_etape='E');
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_exos_form(integer) OWNER TO pgsql;

--
-- TOC entry 1756 (class 1255 OID 2596663)
-- Dependencies: 2983 6
-- Name: _af_get_nb_formations(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_formations(integer, integer, integer) RETURNS integer
    AS $_$-- $1 = numero du groupe --
-- $2 = numero du user --
-- $3 = numero de periode --
DECLARE
nb int:=0;

BEGIN

	IF($3=1) THEN

		nb:=SELECT DISTINCT G.g_num_cal
		from GESTIONNAIRE G, CALENDRIER C,  dates D,  dates D2
		where G.g_num_gest_g=$1
		and G.g_num_cal=C.num_cal
		and G.g_num_user=$2
		and  datefin =D.num_date and D.jour < current_date;

		ELSE IF($3=2) THEN

			nb:=SELECT DISTINCT G.g_num_cal
			from GESTIONNAIRE G, CALENDRIER C,  dates D,  dates D2
			where G.g_num_gest_g=$1
			and G.g_num_cal=C.num_cal
			and G.g_num_user=$2
			and datedeb=D.num_date
          and datefin =  D2.num_date
          and   current_date BETWEEN D.jour AND D2.jour;

			
			ELSE IF($3=3) THEN

			nb:=SELECT DISTINCT G.g_num_cal
			from GESTIONNAIRE G, CALENDRIER C,  dates D,  dates D2
			where G.g_num_gest_g=$1
			and G.g_num_cal=C.num_cal
			and G.g_num_user=$2
			and datedeb =D.num_date
      			and D.jour > current_date;
	
			ELSE RAISE EXCEPTION "La pÃÂ©riode spÃÂ©cifiÃÂ©e n'est pas valide";
			
			END IF;
		
		END IF;

	END IF;

return nb;

END;

$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_formations(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1757 (class 1255 OID 2596664)
-- Dependencies: 2983 6
-- Name: _af_get_nb_series(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_series(integer) RETURNS integer
    AS $_$BEGIN

RETURN(select count(*)
       from gestparcours
       where g_num_parcours in (select distinct g_num_parcours
                                from gestionnaire
                                where g_num_cal=$1)

       and (type_etape='B' or type_etape='C'));
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_series(integer) OWNER TO pgsql;

--
-- TOC entry 1758 (class 1255 OID 2596665)
-- Dependencies: 2983 6
-- Name: _af_get_nb_series_faites(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_series_faites(integer, integer) RETURNS integer
    AS $_$
BEGIN
RETURN(select count(*)
       from res_serie
       where id_formation=$1
       and id_stag=$2
       and score >=0
       and date_fin>0);
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_series_faites(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1759 (class 1255 OID 2596666)
-- Dependencies: 2983 6
-- Name: _af_get_nb_series_finies(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_series_finies(integer, integer) RETURNS integer
    AS $_$BEGIN
RETURN(select count(*)
       from res_serie
       where id_formation=$1
       and id_stag=$2
       and score >=0
       and date_fin>0);
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_series_finies(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1760 (class 1255 OID 2596667)
-- Dependencies: 2983 6
-- Name: _af_get_nb_series_form(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nb_series_form(integer) RETURNS integer
    AS $_$
BEGIN

RETURN(select count(*)
       from gestparcours
       where g_num_parcours in (select distinct g_num_parcours
                                from gestionnaire
                                where g_num_cal=$1)

       and (type_etape='B' or type_etape='C'));
END;    
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nb_series_form(integer) OWNER TO pgsql;

--
-- TOC entry 1761 (class 1255 OID 2596668)
-- Dependencies: 2983 6
-- Name: _af_get_niveau_groupe(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_niveau_groupe(integer) RETURNS integer
    AS $_$--$1 numero du groupe
DECLARE
parent integer;
nb integer;
BEGIN
	parent:=$1;
	nb:=0;
  WHILE(parent<>0)
		LOOP
			parent:=(select id_pere from classe where id=parent);
			nb:=nb+1;
    END LOOP;
	
	RETURN nb;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_niveau_groupe(integer) OWNER TO pgsql;

--
-- TOC entry 1762 (class 1255 OID 2596669)
-- Dependencies: 2983 6
-- Name: _af_get_nom_calendrier(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nom_calendrier(integer) RETURNS character varying
    AS $_$BEGIN

	IF($1>=0 AND $1 IS NOT NULL)
		THEN
		return (SELECT nom_cal FROM calendrier WHERE num_cal=$1);
	ELSE
		RAISE EXCEPTION 'Le calendrier numero [%] n''existe pas.',$1;
	END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nom_calendrier(integer) OWNER TO pgsql;

--
-- TOC entry 1763 (class 1255 OID 2596670)
-- Dependencies: 2983 6
-- Name: _af_get_nom_groupe(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nom_groupe(integer) RETURNS character varying
    AS $_$--$1 numero du groupe
DECLARE
parent integer;
nomgroupe varchar;
ligne Classe%ROWTYPE;
BEGIN

    parent:=$1;
    
    while(parent<>0)
			LOOP
    
        	select * INTO ligne from Classe where id=parent;
				
				IF(nomgroupe IS NULL)
					THEN
        			nomgroupe:= ligne.nom;
    				ELSE
        			nomgroupe:= ligne.nom||'/'|| nomgroupe;    
				END IF;

				parent:=ligne.id_pere;
   
 			END LOOP;
    
    RETURN nomgroupe;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nom_groupe(integer) OWNER TO pgsql;

--
-- TOC entry 1764 (class 1255 OID 2596671)
-- Dependencies: 2983 6
-- Name: _af_get_nom_prenom_individu(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nom_prenom_individu(integer) RETURNS record
    AS $_$--$1 numuser
DECLARE
rec RECORD;

BEGIN

   IF($1>=0)THEN
      select nom, prenom INTO rec from utilisateurs where num_user=$1;
       
          
     
 
   ELSE
       RAISE EXCEPTION 'Le numero d\'utilisateur est incorrect';
   END IF;

RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nom_prenom_individu(integer) OWNER TO pgsql;

--
-- TOC entry 1765 (class 1255 OID 2596672)
-- Dependencies: 2983 6
-- Name: _af_get_nom_prenom_utilisateur(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_nom_prenom_utilisateur(integer) RETURNS record
    AS $_$
--$1 numuser
DECLARE
rec RECORD;

BEGIN

   IF($1>=0)THEN
      select nom, prenom INTO rec from utilisateurs where num_user=$1;




   ELSE
       RAISE EXCEPTION 'Le numero d\'utilisateur est incorrect';
   END IF;

RETURN rec;
END;











$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_nom_prenom_utilisateur(integer) OWNER TO pgsql;

--
-- TOC entry 1766 (class 1255 OID 2596673)
-- Dependencies: 2983 6
-- Name: _af_get_numero_groupe(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_numero_groupe(integer) RETURNS integer
    AS $_$BEGIN

	RETURN (select distinct g_num_gest_g from gestionnaire where g_num_cal=$1);

END;


$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_numero_groupe(integer) OWNER TO pgsql;

--
-- TOC entry 1767 (class 1255 OID 2596674)
-- Dependencies: 2983 6
-- Name: _af_get_numero_parcours(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_numero_parcours(integer, integer) RETURNS integer
    AS $_$
--$1 numero user
--$2 numero clendrier

DECLARE
num integer;

BEGIN

       num:=  select gp_num_parcours 
              from gestionparcours
              where gp_num_user='$1' 
              and num_cal='$2';

RETURN num;

END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_numero_parcours(integer, integer) OWNER TO pgsql;

--
-- TOC entry 53 (class 1255 OID 2596675)
-- Dependencies: 2983 6
-- Name: _af_get_parcours_etapes_disponibles_theme(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_parcours_etapes_disponibles_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
--$2 theme
rec RECORD;
v_rang int4:=1;
v_exo int4:=0;
v_tmp RECORD;
v_tmp_nb int4:=0;
BEGIN
	--ETAPE TITRE
	FOR rec IN 
		select CAST(NULL AS int4) ,varchar '$MSG_113' ,varchar  '01-I' , CAST('$MSG_113' AS text)
	LOOP
		RETURN NEXT rec;
	END LOOP;

	--SCENARIOS
	FOR rec IN 
		select CAST(NULL AS int4) ,varchar '$MSG_922' ,varchar  '02-S' , CAST('$MSG_922' AS text)
	LOOP
		RETURN NEXT rec;
	END LOOP;


	--PARCOURS 
	FOR rec IN 
		select num_parcours ,nom_parcours, varchar '03-T',  lower(nom_parcours)  AS ordre  from parcours where num_parcours in
		    (select distinct g_num_parcours from gestparcours where num_rang=v_rang and num_thematik=$2 and num_etape='1')
		    and num_parcours not in (select num_parcours from config_orientation) and num_parcours not in
		    (select attach_parcours from gestparcours where g_num_parcours=$1) ORDER by ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	--EXOTLCS
	FOR rec IN 
		select num_exo,titre , varchar  '04-E' ,lower(titre)  AS ordre from exotlc where num_exo in
		    (select gestfic_num_exo from gestfic where gestfic_num_fic in
		    (select num_fic from fictlc where num_themedir=$2)) and num_exo not in
		    (select num_c_q_e_d from gestparcours where type_etape='E' and g_num_parcours=$1 and num_c_q_e_d<>v_exo) ORDER by ordre       
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	--SERIES MULTIEXO
	FOR rec IN 
		select id ,titre , varchar  '05-B' ,lower(titre)  AS ordre from serie_exo where theme=$2 and id in
		    (select id_serie from asso_exo_serie group by id_serie having count(distinct type_exo) >1) and id not in
		    (select num_c_q_e_d from gestparcours where type_etape='B' and g_num_parcours=$1 and num_c_q_e_d<>v_exo) ORDER by ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	--SERIES QCMS
	FOR rec IN 
		select id ,titre , varchar  '06-Bq' ,lower(titre)  AS ordre from serie_exo where theme=$2 and id in
		    (select id_serie from asso_exo_serie group by id_serie having count(distinct type_exo) =1) and id in
		    (select distinct id_serie from asso_exo_serie where type_exo='q') and id not in
		    (select num_c_q_e_d from gestparcours where type_etape='B' and g_num_parcours=$1 and num_c_q_e_d <>v_exo)  ORDER by ordre   
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	--SERIES FTBS
	FOR rec IN 
		select id ,titre ,  varchar '07-Bf' ,lower(titre)  AS ordre from serie_exo where theme=$2 and id in
		    (select id_serie from asso_exo_serie group by id_serie having count(distinct type_exo) =1) and id in
		    (select distinct id_serie from asso_exo_serie where type_exo='f') and id not in
		    (select num_c_q_e_d from gestparcours where type_etape='B' and g_num_parcours=$1 and num_c_q_e_d<>v_exo)  ORDER by ordre  
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	--SERIES SONDAGES
	FOR rec IN   
		select id,titre ,  varchar '08-Bs' ,lower(titre)  AS ordre from serie_exo where theme=$2 and id in
		    (select id_serie from asso_exo_serie group by id_serie having count(distinct type_exo) =1) and id in
		    (select distinct id_serie from asso_exo_serie where type_exo='s') and id not in
		    (select num_c_q_e_d from gestparcours where type_etape='B' and g_num_parcours=$1 and num_c_q_e_d<>v_exo) ORDER by ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	--SERIES QRCS
	FOR rec IN 
		select id ,titre , varchar  '09-Bm' ,lower(titre)  AS ordre from serie_exo where theme=$2 and id in
		    (select id_serie from asso_exo_serie group by id_serie having count(distinct type_exo) =1) and id in
		    (select distinct id_serie from asso_exo_serie where type_exo='m') and id not in
		    (select num_c_q_e_d from gestparcours where type_etape='B' and g_num_parcours=$1 and num_c_q_e_d<>v_exo)  
				and id not in (select id_test from test) ORDER by ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	--SERIES SRC
	FOR rec IN 
				
		select id ,titre , varchar  '10-Bo' ,lower(titre)  AS ordre from serie_exo where theme=$2 and id in
		    (select id_serie from asso_exo_serie group by id_serie having count(distinct type_exo) =1) and id in
		    (select distinct id_serie from asso_exo_serie where type_exo='o') and id not in
		    (select num_c_q_e_d from gestparcours where type_etape='B' and g_num_parcours=$1 and num_c_q_e_d<>v_exo)  
				and id not in (select id_test from test) ORDER by ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	--SERIES MONOTHEMES
	FOR rec IN 	
		select id ,titre , varchar  '11-Cmono' AS type ,lower(titre)  AS ordre from serie_exo where id in
		    (select distinct num_serie from serie_aleatoire where theme=$2 and mode=1) and id not in
		    (select num_c_q_e_d from gestparcours where type_etape='C' and g_num_parcours=$1 and num_c_q_e_d<>v_exo) ORDER by ordre
	LOOP
	--mono ou multi exos?
	SELECT INTO v_tmp SUM(qcm) AS qcm, SUM(ftb) AS ftb,SUM(sondage) as sondage ,SUM(qrc)AS qrc ,SUM(src) AS src FROM(

		SELECT count(Cmonoqcm.num_serie) AS qcm, 0 AS ftb, 0 AS sondage, 0 AS qrc, 0 AS src
		FROM serie_aleatoire Cmonoqcm 
		WHERE Cmonoqcm.num_serie=rec.id AND Cmonoqcm.mode=1
		AND Cmonoqcm.nbexo_par_type LIKE '%q%'

		UNION
		SELECT 0 AS qcm, count(Cmonoblanc.num_serie) AS ftb, 0 AS sondage, 0 AS qrc, 0 AS src
		FROM serie_aleatoire Cmonoblanc 
		WHERE Cmonoblanc.num_serie=rec.id AND Cmonoblanc.mode=1
		AND Cmonoblanc.nbexo_par_type LIKE '%f%'

		UNION
		SELECT  0 AS qcm, 0 AS ftb, count(Cmonosondage.num_serie) AS sondage, 0 AS qrc, 0 AS src
		FROM serie_aleatoire Cmonosondage 
		WHERE Cmonosondage.num_serie=rec.id AND Cmonosondage.mode=1
		AND Cmonosondage.nbexo_par_type LIKE '%s%'  

		UNION
		SELECT  0 AS qcm, 0 AS ftb, 0 AS sondage, count(Cmonoqrc.num_serie) AS qrc, 0 AS src
		FROM serie_aleatoire Cmonoqrc 
		WHERE Cmonoqrc.num_serie=rec.id AND Cmonoqrc.mode=1
		AND Cmonoqrc.nbexo_par_type LIKE '%m%'

		UNION
		SELECT  0 AS qcm, 0 AS ftb, 0 AS sondage, 0 AS qrc, count(Cmonosrc.num_serie) AS src
		FROM serie_aleatoire Cmonosrc 
		WHERE Cmonosrc.num_serie=rec.id AND Cmonosrc.mode=1
		AND Cmonosrc.nbexo_par_type LIKE '%o%'
	) AS Cmonos;

		IF v_tmp.qcm>0 THEN 
			rec.type:='12-Cmonoqcm';
			v_tmp_nb:=v_tmp_nb+1;
		END IF; 

		IF v_tmp.ftb>0 THEN 
			rec.type:='13-Cmonoblanc';
			v_tmp_nb:=v_tmp_nb+1;
		END IF;

		IF v_tmp.sondage>0 THEN 
			rec.type:='14-Cmonosondage';
			v_tmp_nb:=v_tmp_nb+1;
		END IF;

		IF v_tmp.qrc>0 THEN 
			rec.type:='15-Cmonoqrc';
			v_tmp_nb:=v_tmp_nb+1;
		END IF;

		IF v_tmp.src>0 THEN 
			rec.type:='16-Cmonosrc';
			v_tmp_nb:=v_tmp_nb+1;
		END IF;
		
		IF v_tmp_nb>1 THEN 
			rec.type:='17-Cmonomulti';
		--ELSE 
		--	RAISE EXCEPTION 'serie=% , q=% , f=%, s=%, m=%, o=%, nb=%',rec.id,v_tmp.qcm,v_tmp.ftb,v_tmp.sondage,v_tmp.qrc,v_tmp.src, v_tmp_nb;
		END IF;		
		RAISE NOTICE 'serie=% , q=% , f=%, s=%, m=%, o=%, nb=%',rec.id,v_tmp.qcm,v_tmp.ftb,v_tmp.sondage,v_tmp.qrc,v_tmp.src, v_tmp_nb;
		v_tmp_nb:=0;
		
		RETURN NEXT rec;
	END LOOP;
	
	--SERIES MULTITHEMES
	FOR rec IN   
		select id , titre , varchar '18-Cmulti' AS type  ,lower(titre)  AS ordre from serie_exo where id in
		    (select distinct num_serie from serie_aleatoire where mode=2) and id not in
		    (select num_c_q_e_d from gestparcours where type_etape='C' and g_num_parcours=$1 and num_c_q_e_d<>v_exo)  ORDER by ordre
	LOOP
	--mono ou multi exos?
	SELECT INTO v_tmp SUM(qcm) AS qcm, SUM(ftb) AS ftb,SUM(sondage) as sondage ,SUM(qrc)AS qrc ,SUM(src) AS src FROM(

		SELECT count(Cmultiqcm.num_serie) AS qcm, 0 AS ftb, 0 AS sondage, 0 AS qrc, 0 AS src
		FROM serie_aleatoire Cmultiqcm 
		WHERE Cmultiqcm.num_serie=rec.id AND Cmultiqcm.mode=2
		AND Cmultiqcm.nbexo_par_type LIKE '%q%'

		UNION
		SELECT 0 AS qcm, count(Cmultiblanc.num_serie) AS ftb, 0 AS sondage, 0 AS qrc, 0 AS src
		FROM serie_aleatoire Cmultiblanc 
		WHERE Cmultiblanc.num_serie=rec.id AND Cmultiblanc.mode=2
		AND Cmultiblanc.nbexo_par_type LIKE '%f%'

		UNION
		SELECT  0 AS qcm, 0 AS ftb, count(Cmultisondage.num_serie) AS sondage, 0 AS qrc, 0 AS src
		FROM serie_aleatoire Cmultisondage 
		WHERE Cmultisondage.num_serie=rec.id AND Cmultisondage.mode=2
		AND Cmultisondage.nbexo_par_type LIKE '%s%'  

		UNION
		SELECT  0 AS qcm, 0 AS ftb, 0 AS sondage, count(Cmultiqrc.num_serie) AS qrc, 0 AS src
		FROM serie_aleatoire Cmultiqrc 
		WHERE Cmultiqrc.num_serie=rec.id AND Cmultiqrc.mode=2
		AND Cmultiqrc.nbexo_par_type LIKE '%m%'

		UNION
		SELECT  0 AS qcm, 0 AS ftb, 0 AS sondage, 0 AS qrc, count(Cmultisrc.num_serie) AS src
		FROM serie_aleatoire Cmultisrc 
		WHERE Cmultisrc.num_serie=rec.id AND Cmultisrc.mode=2
		AND Cmultisrc.nbexo_par_type LIKE '%o%'
	) AS Cmultis;
				
		IF v_tmp.qcm>0 THEN 
			rec.type:='19-Cmultiqcm';
			v_tmp_nb:=v_tmp_nb+1;
		END IF; 

		IF v_tmp.ftb>0 THEN 
			rec.type:='20-Cmultiblanc';
			v_tmp_nb:=v_tmp_nb+1;
		END IF;

		IF v_tmp.sondage>0 THEN 
			rec.type:='21-Cmultisondage';
			v_tmp_nb:=v_tmp_nb+1;
		END IF;

		IF v_tmp.qrc>0 THEN 
			rec.type:='22-Cmultiqrc';
			v_tmp_nb:=v_tmp_nb+1;
		END IF;

		IF v_tmp.src>0 THEN 
			rec.type:='23-Cmultisrc';
			v_tmp_nb:=v_tmp_nb+1;
		END IF;
		
		IF v_tmp_nb>1 THEN 
			rec.type:='24-Cmultimulti';
		END IF;		
		v_tmp_nb:=0;


		RETURN NEXT rec;
	END LOOP;

	--SCORMS
	FOR rec IN  
		select id ,name ,  varchar '25-Z' ,lower(name) AS ordre from scorm where num_theme=$2 and  id not in
		    (select num_c_q_e_d from gestparcours where type_etape='Z' and g_num_parcours=$1 and num_c_q_e_d<>v_exo) ORDER by ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	--FORUM
	FOR rec IN 
		select CAST(NULL AS int4) ,varchar '$MSG_926' , varchar '26-F' , CAST('$MSG_926' AS text) 
	LOOP
		RETURN NEXT rec;
	END LOOP;

	--CHAT
	FOR rec IN 
		select CAST(NULL AS int4) ,varchar '$MSG_928' , varchar '27-P' , CAST('$MSG_928' AS text)
	LOOP
		RETURN NEXT rec;
	END LOOP;

	--RESSOURCES
	FOR rec IN 
		--select CAST(NULL AS int4) ,varchar '$MSG_927' ,varchar  '28-R' , CAST('$MSG_927' AS text)
		SELECT G.num_gest_res, G.libelle, varchar '28-R', lower(G.libelle) AS ordre  
		FROM ressource_gest G LEFT OUTER JOIN  ressource_txt T
		ON (G.num_fic=T.num_text AND T.num_themedir=$2)
		LEFT OUTER JOIN ressource_fic F
		ON (G.num_fic=F.num_fic AND F.num_themedir=$2 )
	LOOP
		RETURN NEXT rec;
	END LOOP;

	--TESTS
	FOR rec IN 
		SELECT T.id_liste_test, nom_liste_test, varchar '29-L', lower(nom_liste_test) AS ordre
		FROM liste_test T, asso_liste_test A, serie_exo S
		WHERE theme=$2 AND T.id_liste_test=A.id_liste_test AND A.id_test=s.id AND T.id_liste_test NOT IN
		    (SELECT num_c_q_e_d FROM gestparcours WHERE type_etape='L' AND g_num_parcours=$1 AND num_c_q_e_d<>v_exo) ORDER BY ordre       
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_parcours_etapes_disponibles_theme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1768 (class 1255 OID 2596677)
-- Dependencies: 2983 6
-- Name: _af_get_parcours_formation(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_parcours_formation(integer) RETURNS integer
    AS $_$--OBTENIR LES PARCOURS D'UNE FORMATION
--$1 numero de la formation
DECLARE
--rec RECORD;
parcours integer;

BEGIN
--	FOR rec IN
--	select distinct g_num_parcours 
	--	from gestionnaire 
	--	where g_num_cal=$1
--	LOOP
	--	RETURN NEXT rec;
--	END LOOP;

--	RETURN;
	select  distinct g_num_parcours into parcours
	from gestionnaire 
	where g_num_cal=$1;

	return parcours;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_parcours_formation(integer) OWNER TO pgsql;

--
-- TOC entry 1769 (class 1255 OID 2596678)
-- Dependencies: 2983 6
-- Name: _af_get_places_groupe(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_places_groupe(integer) RETURNS record
    AS $_$--$1 numero du groupe

DECLARE
rec RECORD;

BEGIN
	
	
		select minplace, maxplace INTO rec from placegroupe where num_gest_groupe=$1;
		
		
--IF NOT FOUND THEN RAISE EXCEPTION 'pas de place fixe'; END IF;
		RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_places_groupe(integer) OWNER TO pgsql;

--
-- TOC entry 1770 (class 1255 OID 2596679)
-- Dependencies: 2983 6
-- Name: _af_get_resultats_exos_formatio(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_resultats_exos_formatio(integer) RETURNS SETOF record
    AS $_$declare
		rec record;

begin
	for rec in select *
            from resexouser
            where num_cal=$1
            and num_cal>0
            and surtotal<>0
 	loop
		return next rec;
	end loop;
return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_resultats_exos_formatio(integer) OWNER TO pgsql;

--
-- TOC entry 1771 (class 1255 OID 2596680)
-- Dependencies: 2983 6
-- Name: _af_get_resultats_series_format(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_resultats_series_format(integer) RETURNS SETOF record
    AS $_$declare 
		rec record;

begin
	for rec in select * from res_serie where id_formation=$1
	loop
		return next rec;
	end loop;
return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_resultats_series_format(integer) OWNER TO pgsql;

--
-- TOC entry 54 (class 1255 OID 2596681)
-- Dependencies: 2983 6
-- Name: _af_get_serie_evaluations(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_serie_evaluations(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
lib varchar;
BEGIN
	FOR rec IN 
		SELECT DISTINCT id_exo, CAST('' AS varchar) AS libelle, id_serie, ordre, commentaire, bareme, chrono, point, type_exo 
		FROM asso_exo_serie WHERE id_serie=$1 order by ordre
	LOOP	
		--QCM
		IF rec.type_exo='q' THEN
			SELECT INTO lib libelle_question FROM question WHERE num_question=rec.id_exo;
			rec.libelle:=lib;
			RETURN NEXT rec;
			CONTINUE;
		END IF;

		--FTB
		IF rec.type_exo='f' THEN
			SELECT INTO lib substring(text FROM 0 FOR 59) FROM gest_ftb WHERE id=rec.id_exo;
			rec.libelle:=lib;
			RETURN NEXT rec;
			CONTINUE;
		END IF;
		
		--SONDAGE
		IF rec.type_exo='s' THEN
			SELECT INTO lib question FROM question_sondage WHERE num_sondage=rec.id_exo;
			rec.libelle:=lib;
			RETURN NEXT rec;
			CONTINUE;
		END IF;

		--QRC ou SRC
		IF rec.type_exo='m'OR rec.type_exo='o' THEN
			SELECT INTO lib question_commune FROM test WHERE id_test=rec.id_exo;
			rec.libelle:=lib;
			RETURN NEXT rec;
			CONTINUE;
		END IF;
		
		--erreur :type inconnu
		rec.libelle:='Libelle introuvable (id='||rec.id_exo||' type='||rec.type_exo||')';
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_serie_evaluations(integer) OWNER TO pgsql;

--
-- TOC entry 1772 (class 1255 OID 2596682)
-- Dependencies: 2983 6
-- Name: _af_get_sous_parcours(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_sous_parcours(integer) RETURNS SETOF record
    AS $_$-- paramÃštre : numÃ©ro de parcours
DECLARE
   rec RECORD;
BEGIN
   FOR rec IN select sousparcours from config_orientation where num_parcours=$1
   LOOP
     RETURN NEXT rec;
   END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_sous_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 1773 (class 1255 OID 2596683)
-- Dependencies: 2983 6
-- Name: _af_get_stag_avec_eval(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_stag_avec_eval(integer) RETURNS SETOF record
    AS $_$
DECLARE 
   rec RECORD;
BEGIN
   FOR rec IN select distinct id_stag
                        from res_serie
                        where id_formation=$1
                        union
                        select distinct num_user
                        from resexouser
                        where num_cal=$1
   LOOP
      RETURN NEXT rec;
   END LOOP;
RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_stag_avec_eval(integer) OWNER TO pgsql;

--
-- TOC entry 1774 (class 1255 OID 2596684)
-- Dependencies: 2983 6
-- Name: _af_get_stag_form(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_stag_form(integer) RETURNS SETOF record
    AS $_$
DECLARE 
    rec RECORD;
BEGIN
    FOR rec IN select distinct gp_num_user from gestionparcours where num_cal=$1
    LOOP
       RETURN NEXT rec;
    END LOOP;
RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_stag_form(integer) OWNER TO pgsql;

--
-- TOC entry 1775 (class 1255 OID 2596685)
-- Dependencies: 2983 6
-- Name: _af_get_stagiaires_evaluation_f(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_stagiaires_evaluation_f(integer) RETURNS SETOF record
    AS $_$DECLARE
    rec RECORD;
		req varchar;
BEGIN
      
		req:='select id_stag, nom
            from res_serie, utilisateurs
            where num_user=id_stag
            and score >=0
					 and id_formation in (select distinct g_num_cal from gestionnaire)
            union
            select ru.num_user, nom
            from resexouser ru, utilisateurs u
            where u.num_user=ru.num_user
            and num_cal <>0
					 and num_cal in (select distinct g_num_cal from gestionnaire)';
		IF($1=1)
		then
				req:=req || 'order by nom asc';
		end if;
     FOR rec IN execute req
     LOOP
        RETURN NEXT rec;
     END LOOP;
   
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_stagiaires_evaluation_f(integer) OWNER TO pgsql;

--
-- TOC entry 1776 (class 1255 OID 2596686)
-- Dependencies: 2983 6
-- Name: _af_get_types_etapes_serie(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_get_types_etapes_serie(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
	rec RECORD;
	req varchar;
BEGIN
	req:='select distinct type_exo from ';

	IF($2 > 0)
	THEN
			req:=req || 'asso_exo_serie_aleatoire where id_serie=' || $1;
	ELSE
			req:=req || 'asso_exo_serie where id_serie=' || $1;
  END IF;

	FOR rec IN EXECUTE req
	LOOP
			RETURN NEXT rec;
	END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_get_types_etapes_serie(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1777 (class 1255 OID 2596687)
-- Dependencies: 2983 6
-- Name: _af_liste_exos_form(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_liste_exos_form(integer) RETURNS SETOF record
    AS $_$
DECLARE
    rec RECORD;
BEGIN
    FOR rec IN select num_exo,score,surtotal
               from resexouser
               where num_cal=$1
    LOOP 
       RETURN NEXT rec;
    END LOOP;
RETURN;
END;

$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_liste_exos_form(integer) OWNER TO pgsql;

--
-- TOC entry 1778 (class 1255 OID 2596688)
-- Dependencies: 2983 6
-- Name: _af_liste_series_form(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_liste_series_form(integer) RETURNS SETOF record
    AS $_$
DECLARE 
   rec RECORD;
BEGIN
   FOR rec IN select id_serie,score
                        from res_serie
                        where id_formation=$1
                        and score>=0
                        and date_fin>0
   LOOP
      RETURN NEXT rec;
   END LOOP;
RETURN;
END


$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_liste_series_form(integer) OWNER TO pgsql;

--
-- TOC entry 1779 (class 1255 OID 2596689)
-- Dependencies: 2983 6
-- Name: _af_maj_infos_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_maj_infos_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying) RETURNS integer
    AS $_$-- ProcÃÂ©dure de mise ÃÂ  jour d'un enregistrement en table utilisateurs
-- Jonathan CHABOISSIER 03/06/2004

-- ParamÃÂštres reÃÂ§u :
-- num_user, login, password, nom, prenom, adresse, code,
-- ville, email, telfixe,telport,langue, num_org, categorie, fic_photo

BEGIN 

    -- Mettre des verifications ici ?
    -- Si un jour il faut verifier l'unicitÃÂ© du login ou du nom par exemple,
    -- on pourrait le faire avant l'insertion

    -- Penser aussi ÃÂ  inserer NULL plutot que ' ' si le paramÃÂštre est vide

    UPDATE utilisateurs
    SET login=$2,
    password=$3,
    nom=$4,
    prenom=$5,
    adresse=$6,
    code=$7,
    ville=$8,
    email=$9,
    telfixe=$10,
    telport=$11,
    langue=$12,
    num_org=$13,
    categorie=$14,
    fic_photo=$15
    WHERE num_user=$1 ;
        
    IF NOT FOUND THEN
        RETURN 0;
    ELSE 
        RETURN 1;
    END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_maj_infos_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 1780 (class 1255 OID 2596690)
-- Dependencies: 2983 6
-- Name: _af_maj_nom_groupe(integer, character varying); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_maj_nom_groupe(integer, character varying) RETURNS integer
    AS $_$
--Changer le nom d'un groupe --$1 le numero du groupe --$2 le nouveau nom du groupe BEGIN IF($1>=0 AND $2<>'') THEN  update classe set nom=$2 where id=$1; IF(NOT FOUND) THEN RAISE EXCEPTION 'Le nom du groupe n''a pas ete modifie (%/%)',$1,$2; RETURN 0; ELSE RETURN 1; END IF; ELSE RAISE EXCEPTION 'Parametres incorrects. (numero de groupe=%)(nouveau nom=%)',$1,$2; RETURN 0; END IF; END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_maj_nom_groupe(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 1781 (class 1255 OID 2596691)
-- Dependencies: 2983 6
-- Name: _af_maj_nom_groupe(integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_maj_nom_groupe(integer, character varying, integer) RETURNS integer
    AS $_$--Changer le nom d'un groupe
--$1 le numero du groupe
--$2	le nouveau nom du groupe
--$3 le numero du pere
DECLARE 
REC RECORD;
requete varchar;
existe_deja integer;
BEGIN
		existe_deja:=_af_check_groupe($3,$2);
	
	IF(existe_deja=0)
		THEN
		
		IF($1>=0 AND $2<>'')
			THEN
				BEGIN
		
					update classe set nom=$2 where id=$1;

					IF NOT FOUND
						THEN
						RAISE EXCEPTION 'Le nom du groupe n''a pas ete modifie (%/%)%',$1,$2,requete;
						RETURN 0;
					ELSE
					--RAISE EXCEPTION 'toto';
						RETURN 1;
					END IF;	
				END;
	
			ELSE
				RAISE EXCEPTION 'Parametres incorrects. (numero de groupe=%)(nouveau nom=%)',$1,$2;
				RETURN 0;
			END IF;
	ELSE
		RETURN 0;
	END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_maj_nom_groupe(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 55 (class 1255 OID 2596692)
-- Dependencies: 2983 6
-- Name: _af_maj_parcours_etape_duree(integer, "char", character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_maj_parcours_etape_duree(integer, "char", character varying, integer) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 type
--$3 idendifiant de l'etape, sauf pour les forums, le chats et les ressources on passe le num d'étape (ordre)
--$4 duree
BEGIN
	--scenarios et ressources
	IF $2 = 'S' THEN
		UPDATE gestparcours SET temps_etape=$4 WHERE g_num_parcours=$1 AND attach_fic LIKE $3 AND type_etape=$2;
	ELSEIF $2='T' THEN
		UPDATE gestparcours SET temps_etape=$4 WHERE g_num_parcours=$1 AND attach_parcours=$3 AND type_etape=$2;
	ELSEIF $2 = 'E' OR $2 = 'F' OR $2 = 'S' OR $2 = 'P' THEN  
		UPDATE gestparcours SET temps_etape=$4 WHERE g_num_parcours=$1 AND num_c_q_e_d=$3 AND type_etape=$2;
	ELSEIF $2 = 'R' OR $2 = 'P' OR $2 = 'F'  THEN  
		UPDATE gestparcours SET temps_etape=$4 WHERE g_num_parcours=$1 AND num_etape=$3 AND type_etape=$2;
	ELSEIF $2 = 'B' THEN  
		UPDATE serie_exo SET chrono=$4 WHERE id=$3 ;
	END IF;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_maj_parcours_etape_duree(integer, "char", character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1782 (class 1255 OID 2596693)
-- Dependencies: 2983 6
-- Name: _af_maj_places_groupe(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_maj_places_groupe(integer, integer, integer) RETURNS integer
    AS $_$--$1 numero du groupe 
--$2 max 
--$3 min 

BEGIN 

		UPDATE placegroupe 
		set maxplace=$2 ,minplace=$3 
		where num_gest_groupe=$1; 

	
		IF NOT FOUND THEN
				RETURN 0;
				RAISE EXCEPTION 'l''UPDATE a echoue (% % %)',$1,$2,$3;
		ELSE 
				RETURN 1;
		END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_maj_places_groupe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1783 (class 1255 OID 2596694)
-- Dependencies: 2983 6
-- Name: _af_recup_ss_parcours(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_recup_ss_parcours(integer) RETURNS SETOF record
    AS $_$
-- paramÃštre : numÃ©ro de parcours
DECLARE
   rec RECORD;
BEGIN
   FOR rec IN select sousparcours from config_orientation where num_parcours=$1
   LOOP
     RETURN NEXT rec;
   END LOOP;
RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_recup_ss_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 1784 (class 1255 OID 2596695)
-- Dependencies: 2983 6
-- Name: _af_set_avancement_stagiaire(integer, integer, integer, integer, integer, character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_set_avancement_stagiaire(integer, integer, integer, integer, integer, character varying, integer) RETURNS integer
    AS $_$--INSERTION D'UN AVANCEMENT--
-----------------------------

--$1 numero du stagiaire
--$2 numero du groupe
--$3	numero du calendrier
--$4	numero du parcours
--$5 numero d'etape ou le stagiaire est (avancement)
--$6 chaine etape_libre
--$7 avancement libre (ne sert pas actuellement)

BEGIN

--test champs obligatoires
IF( $1>=0 AND $2>=0 AND $3>=0 AND $4>=0)
	THEN
		--test si un enregistrement pour le stagiaire
    PERFORM 'select * from gestionparcours
    where gp_num_groupe=$2
		and gp_num_user=$1
		and gp_num_parcours=$4
		and num_cal=$3';

		IF(NOT FOUND)
				THEN
					--insert si yen a pas
					insert into gestionparcours
					 values($4,$2,$1,$5,$7,'$6',$3);
					RETURN 1;
			ELSE
					
					--update si ya 		
					update gestionparcours
							SET 		 avancement=$5 ,
										etape_libre=$6 ,
										avancement_libre=$7
							WHERE		gp_num_groupe=$2
							and gp_num_user=$1
							and gp_num_parcours=$4
							and num_cal=$3;

					RETURN 1;
			

		END IF;

ELSE

	RAISE EXCEPTION 'Erreur sur les parametres identifiant le stagiaire (%,%,%,%,%,%,%)',$1,$2,$3,$4,$5,$6,$7;
	RETURN 0;

END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_set_avancement_stagiaire(integer, integer, integer, integer, integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1785 (class 1255 OID 2596696)
-- Dependencies: 2983 6
-- Name: _af_set_droit_individu(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_set_droit_individu(integer, integer, integer) RETURNS integer
    AS $_$--METTRE UN DROIT A UN INDIVIDU
--$1 numero de l'individu
--$2 numero du groupe de l'individu
--$3 numero du droit
BEGIN

	IF($1>=0 AND $2>=0 AND $3>=0)
		THEN
			insert into gestionutil 
				(gu_num_user , gu_num_gest_gr , gu_num_droit) 
				values ($1,$2,$3);
	
			IF(NOT FOUND)
				THEN
	
				RAISE EXCEPTION 'Erreur lors de l''insertion du droit';
				RETURN 0;
			END IF;

	ELSE
		RAISE EXCEPTION 'Erreur dans les paramettres (%,%,%)',$1,$2,$3;
		RETURN 0;
	END IF;

	RETURN 1;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_set_droit_individu(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1786 (class 1255 OID 2596697)
-- Dependencies: 2983 6
-- Name: _af_set_groupe(character varying, integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_set_groupe(character varying, integer, integer, integer) RETURNS integer
    AS $_$--$1 nom du groupe
--$2 numero du pere
--$3 nombre de places au minimum
--$4 nombre de places au maximum

DECLARE
existe_deja integer;
num_oid integer;
numrec integer;

BEGIN
	existe_deja:=_af_check_groupe($2,$1);
	
	IF(existe_deja=0)
		THEN
		
		insert into classe (nom,id_pere) 
						values($1,$2);

		GET DIAGNOSTICS num_oid= RESULT_OID;
	
		numrec:=(SELECT id FROM classe WHERE OID=num_oid);
		--RAISE EXCEPTION 'enregistrement numero %', numrec; 

		PERFORM (SELECT _af_set_places_groupe(numrec,$4,$3));

		RETURN numrec;

	ELSE
		
		RETURN 0;
	END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_set_groupe(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1787 (class 1255 OID 2596698)
-- Dependencies: 2983 6
-- Name: _af_set_places_groupe(integer, integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_set_places_groupe(integer, integer, integer) RETURNS integer
    AS $_$--$1 numero du groupe
--$2 max
--$3 min
DECLARE

nbrows integer;
trouve integer;
rec RECORD;
BEGIN

	trouve:=0;

	SELECT minplace, maxplace INTO rec from placegroupe where num_gest_groupe=$1;
	
	IF (FOUND)
		THEN
		 PERFORM (SELECT _af_maj_places_groupe($1,$2,$3));
			--RAISE EXCEPTION 'trouve % maj % % %',trouve, $1,$2,$3;
	ELSE

		INSERT into placegroupe values($1,$2,$3);
		--RAISE EXCEPTION 'insert % % %', $1,$2,$3;
	END IF;

		GET DIAGNOSTICS nbrows = ROW_COUNT;

		RETURN nbrows;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_set_places_groupe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 1788 (class 1255 OID 2596699)
-- Dependencies: 2983 6
-- Name: _af_stats_exo_formation(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_stats_exo_formation(integer, integer) RETURNS record
    AS $_$declare
	rec record;
begin
	select score,surtotal into rec
	from resexouser
  where num_cal=$1
  and num_exo=$2;

return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_stats_exo_formation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1789 (class 1255 OID 2596700)
-- Dependencies: 2983 6
-- Name: _af_stats_exos_formation(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_stats_exos_formation(integer) RETURNS SETOF record
    AS $_$DECLARE
    rec RECORD;
BEGIN
    FOR rec IN select num_exo,score,surtotal
               from resexouser
               where num_cal=$1
						  and surtotal <>0
    LOOP 
       RETURN NEXT rec;
    END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_stats_exos_formation(integer) OWNER TO pgsql;

--
-- TOC entry 1790 (class 1255 OID 2596701)
-- Dependencies: 2983 6
-- Name: _af_stats_liste_formations(character varying, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_stats_liste_formations(character varying, integer) RETURNS record
    AS $_$
DECLARE
     rec RECORD;
BEGIN
      IF ($1='current')
      THEN
         IF($2=1)
         THEN
            FOR rec IN select distinct id_formation, nom_cal
            from res_serie, calendrier, dates
            where score >=0
            and jour >= current_timestamp
            and id_formation=num_cal
            and datefin=num_date
            union
            select distinct rs.num_cal, nom_cal
            from resexouser rs, calendrier c, dates
            where rs.num_cal <>0
            and surtotal <>0
            and jour >= current_timestamp
            and rs.num_cal=c.num_cal
            and datefin=num_date
            order by nom_cal asc
            LOOP
                RETURN NEXT rec;
            END LOOP;
         ELSE
            FOR rec IN select distinct id_formation, nom_cal
            from res_serie, calendrier, dates
            where score >=0
            and jour >= current_timestamp
            and id_formation=num_cal
            and datefin=num_date
            union
            select distinct rs.num_cal, nom_cal
            from resexouser rs, calendrier c, dates
            where rs.num_cal <>0
            and surtotal <>0
            and jour >= current_timestamp
            and rs.num_cal=c.num_cal
            and datefin=num_date
            LOOP
                RETURN NEXT rec;
            END LOOP;
         END IF;
      ELSE
          IF($2=1)
          THEN
            FOR rec IN select distinct id_formation, nom_cal
            from res_serie, calendrier, dates
            where score >=0
            and jour < current_timestamp
            and id_formation=num_cal
            and datefin=num_date
            union
            select distinct rs.num_cal, nom_cal
            from resexouser rs, calendrier c, dates
            where rs.num_cal <>0
            and surtotal <>0
            and jour < current_time_stamp
            and rs.num_cal=c.num_cal
            and datefin=num_date
            order by nom_cal asc
            LOOP
                RETURN NEXT rec;
            END LOOP;
          ELSE
            FOR rec IN select distinct id_formation, nom_cal
            from res_serie, calendrier, dates
            where score >=0
            and jour < current_timestamp
            and id_formation=num_cal
            and datefin=num_date
            union
            select distinct rs.num_cal, nom_cal
            from resexouser rs, calendrier c, dates
            where rs.num_cal <>0
            and surtotal <>0
            and jour < current_timestamp
            and rs.num_cal=c.num_cal
            and datefin=num_date
            LOOP
                RETURN NEXT rec;
            END LOOP;
          END IF;
      END IF;

RETURN;
END;












$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_stats_liste_formations(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 1791 (class 1255 OID 2596702)
-- Dependencies: 2983 6
-- Name: _af_stats_serie_formation(integer, integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_stats_serie_formation(integer, integer) RETURNS record
    AS $_$declare 
	rec record;
begin
	select score into rec
  from res_serie
  where id_formation=$1
  and id_serie=$2
  and score>=0;

return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_stats_serie_formation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 1792 (class 1255 OID 2596703)
-- Dependencies: 2983 6
-- Name: _af_stats_series_formation(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_stats_series_formation(integer) RETURNS SETOF record
    AS $_$DECLARE 
   rec RECORD;
BEGIN
   FOR rec IN select id_serie,score
                        from res_serie
                        where id_formation=$1
                        and score>=0
                        and date_fin>0
   LOOP
      RETURN NEXT rec;
   END LOOP;
RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_stats_series_formation(integer) OWNER TO pgsql;

--
-- TOC entry 1793 (class 1255 OID 2596704)
-- Dependencies: 2983 6
-- Name: _af_test(); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_test() RETURNS boolean
    AS $$
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_test() OWNER TO pgsql;

--
-- TOC entry 1794 (class 1255 OID 2596705)
-- Dependencies: 2983 6
-- Name: _af_test_parcours_dyn(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_test_parcours_dyn(integer) RETURNS SETOF record
    AS $_$
-- paramÃštre : numÃ©ro de calendrier

DECLARE
   rec RECORD;
BEGIN
   FOR rec IN select num_parcours from config_orientation where num_parcours in (select distinct                       
              g_num_parcours from gestionnaire where g_num_cal=$1)
   LOOP
     RETURN NEXT rec;
   END LOOP;
RETURN;
END;
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_test_parcours_dyn(integer) OWNER TO pgsql;

--
-- TOC entry 1795 (class 1255 OID 2596706)
-- Dependencies: 2983 6
-- Name: _af_test_serie_aleatoire(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION _af_test_serie_aleatoire(integer) RETURNS integer
    AS $_$
-- paramÃštre : numÃ©ro de sÃ©rie
BEGIN
RETURN(select count(num_serie) from serie_aleatoire where num_serie=$1);
END;


$_$
    LANGUAGE plpgsql;


ALTER FUNCTION public._af_test_serie_aleatoire(integer) OWNER TO pgsql;

--
-- TOC entry 56 (class 1255 OID 2596707)
-- Dependencies: 2983 6
-- Name: get_random_string(integer); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION get_random_string(string_length integer) RETURNS text
    AS $$
DECLARE
possible_chars TEXT = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
output TEXT = '';
i INT4;
pos INT4;
BEGIN
FOR i IN 1..string_length LOOP
pos := 1 + cast( random() * ( length(possible_chars) - 1) as INT4 );
output := output || substr(possible_chars, pos, 1);
END LOOP;
RETURN output;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.get_random_string(string_length integer) OWNER TO pgsql;

--
-- TOC entry 57 (class 1255 OID 2596708)
-- Dependencies: 2983 6
-- Name: substr_count(text, text); Type: FUNCTION; Schema: public; Owner: pgsql
--

CREATE FUNCTION substr_count(chaine text, souschaine text) RETURNS integer
    AS $$
/* Compte le nombre d'occurence d'une souschaine dans une chaine
   
   Exemple : SELECT stroccurence('Ici un mot, et la un deuxieme mot','mot');
             2
 */
BEGIN
 return array_upper(string_to_array(chaine,souschaine),1)-1;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION public.substr_count(chaine text, souschaine text) OWNER TO pgsql;

SET search_path = v2, pg_catalog;

--
-- TOC entry 58 (class 1255 OID 2596709)
-- Dependencies: 2983 7
-- Name: c_get_etapes_chats(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION c_get_etapes_chats() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select ec.id,e.libelle,e.type,e.date_creation 
	from v2.etape e , v2.etape_chat ec  
	where e.id=ec.id
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.c_get_etapes_chats() OWNER TO pgsql;

--
-- TOC entry 8983 (class 0 OID 0)
-- Dependencies: 58
-- Name: FUNCTION c_get_etapes_chats(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION c_get_etapes_chats() IS 'retourne les etapes chat de la plateforme';


--
-- TOC entry 59 (class 1255 OID 2596710)
-- Dependencies: 2983 7
-- Name: c_get_parcours_chats_disponibles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION c_get_parcours_chats_disponibles(integer) RETURNS SETOF record
    AS $_$-- $1 : parcours
declare
rec record;
begin
    for rec in
	select ef_id,ef_libelle_etape from v2.af_get_etapes_chats() 
	as 
	(ef_id int4,ef_libelle_etape varchar,type int4,date_creation timestamp)
	left outer join v2.af_gen_get_elements('v2.parcours_etapes', 'etape', NULL, 'AND parcours='||$1,1) elt 
	on (elt.id=ef_id) 
	where elt.id is null
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.c_get_parcours_chats_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 8984 (class 0 OID 0)
-- Dependencies: 59
-- Name: FUNCTION c_get_parcours_chats_disponibles(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION c_get_parcours_chats_disponibles(integer) IS 'retourne les chats disponible pour un parcours';


--
-- TOC entry 60 (class 1255 OID 2596711)
-- Dependencies: 2983 7
-- Name: c_maj_etape_chat(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION c_maj_etape_chat(integer, character varying) RETURNS boolean
    AS $_$-- $1 : etape
-- $2 : libelle
declare
ok bool;
begin
    SELECT INTO ok * FROM v2.af_maj_etape_libelle($1, $2);
    return ok;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.c_maj_etape_chat(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 8985 (class 0 OID 0)
-- Dependencies: 60
-- Name: FUNCTION c_maj_etape_chat(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION c_maj_etape_chat(integer, character varying) IS 'modifie une etape chat';


--
-- TOC entry 61 (class 1255 OID 2596712)
-- Dependencies: 2983 7
-- Name: c_set_etape_chat(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION c_set_etape_chat(character varying) RETURNS integer
    AS $_$-- $1 : libelle
declare
res int4;
new_id oid;
begin
    -- etape
    insert into v2.etape(libelle, type) VALUES ($1, 8);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.etape WHERE oid=new_id;
    -- etape chat
    insert INTO v2.etape_chat(id) VALUES (res);

    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.c_set_etape_chat(character varying) OWNER TO pgsql;

--
-- TOC entry 8986 (class 0 OID 0)
-- Dependencies: 61
-- Name: FUNCTION c_set_etape_chat(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION c_set_etape_chat(character varying) IS 'enregistre une etape chat';


--
-- TOC entry 1796 (class 1255 OID 2596713)
-- Dependencies: 2983 7
-- Name: check_alerte_dates(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_alerte_dates() RETURNS "trigger"
    AS $$DECLARE
 duree_jour varchar(255):=  NEW.jours ||' day'; 
BEGIN
IF NEW.date IS NULL THEN
 if NEW.jours is null THEN
	return new;
 else
  RAISE EXCEPTION 'pas de duree pour une date null';
 end if;
 
END IF;
--vÃƒÂƒÃ‚Â©rifie que la date est d'au moins un jour
IF (NEW.jours IS NULL OR NEW.jours <1)
THEN
 RAISE EXCEPTION 'UNE DUREE > 1 jour DOIT ETRE SPECIFIEE';
END IF;

--verifie que la date de l'alerte est bien comprise dans les dates de la formation
PERFORM * FROM v2.formation
WHERE v2.formation.id= NEW.formation 
AND  NEW.date BETWEEN v2.formation.date_debut AND v2.formation.date_fin 
AND ( NEW.date + CAST( duree_jour AS interval) ) < ( v2.formation.date_fin );

IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LA DATE ET LA DUREE DE L\' ALERTE NE SONT PAS COMPRISES DANS LES DATES DE LA FORMATION ';
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_alerte_dates() OWNER TO postgres;

--
-- TOC entry 8987 (class 0 OID 0)
-- Dependencies: 1796
-- Name: FUNCTION check_alerte_dates(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_alerte_dates() IS 'VÃƒÂ©rifie que la date de l''alerte est correcte et que sa durÃƒÂ©e est bien supÃƒÂ©rieure ÃƒÂ  1 jour....';


--
-- TOC entry 1797 (class 1255 OID 2596714)
-- Dependencies: 2983 7
-- Name: check_calendrier_date(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_calendrier_date() RETURNS "trigger"
    AS $$DECLARE
duree_secondes varchar(255):=  NEW.duree ||' second'; 
BEGIN
PERFORM * FROM v2.formation
WHERE v2.formation.id= NEW.formation 
AND  NEW.date BETWEEN v2.formation.date_debut AND v2.formation.date_fin 
AND ( NEW.date + CAST( duree_secondes AS interval) ) < ( v2.formation.date_fin );
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LA DATE ET LA DUREE DE L\' ELEMENT DE CALENDRIER NE SONT PAS COMPRISES DANS LES DATES DE LA FORMATION ';
ELSE	
 RETURN NEW;
END IF;
END;						$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_calendrier_date() OWNER TO postgres;

--
-- TOC entry 8989 (class 0 OID 0)
-- Dependencies: 1797
-- Name: FUNCTION check_calendrier_date(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_calendrier_date() IS 'VÃƒÂ©rifie que la date de l''element de calendrier est bien compris dans les dates de la formation';


--
-- TOC entry 62 (class 1255 OID 2596715)
-- Dependencies: 2983 7
-- Name: check_classe_organisme(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION check_classe_organisme() RETURNS "trigger"
    AS $$declare
ok bool;
res int4;
newres int4;
begin
    select into res distinct organisme from v2.af_get_classe_individus(NEW.classe,0,'asc',false)
    where organisme is not null ;
    ok:=found;
    
    if ok then
	select into newres organisme from v2.af_get_individu(NEW.individu) 
	as (id int4,identifiant_md5 varchar,login varchar,password varchar,nom varchar,prenom varchar,adresse varchar,code varchar,ville varchar,
	   email varchar,tel_fix varchar,tel_port varchar,langue int4,organisme int4,photo int4);
	if res=newres or newres is null then
	    return NEW;
	else
	    raise exception 'La classe doit contenir que des individus de meme organisme ET/OU multi-organisme';
	    return NULL;
	end if;
    else
	return NEW;
    end if;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_classe_organisme() OWNER TO pgsql;

--
-- TOC entry 8991 (class 0 OID 0)
-- Dependencies: 62
-- Name: FUNCTION check_classe_organisme(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION check_classe_organisme() IS 'verifie que les organismes de la classe sont identiques ET/OU NULL';


--
-- TOC entry 1798 (class 1255 OID 2596716)
-- Dependencies: 2983 7
-- Name: check_evaluation_qsrc_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_evaluation_qsrc_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.evaluation 
WHERE v2.evaluation.id=NEW.id
AND (v2.evaluation.type=4
OR v2.evaluation.type=5);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'EVALUATION DU QSRC DOIT ETRE DE TYPE QRC(4) ou SRC(5) ';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_evaluation_qsrc_type() OWNER TO postgres;

--
-- TOC entry 8992 (class 0 OID 0)
-- Dependencies: 1798
-- Name: FUNCTION check_evaluation_qsrc_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_qsrc_type() IS 'VÃƒÂ©rifie qu''un QSRC corresponde bien ÃƒÂ  un type d''ÃƒÂ©valuation SRC ou QRC';


--
-- TOC entry 63 (class 1255 OID 2596717)
-- Dependencies: 2983 7
-- Name: check_evaluation_question_reponse_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_evaluation_question_reponse_type() RETURNS "trigger"
    AS $$DECLARE
v_type int4;
BEGIN

SELECT INTO v_type v2.evaluation.type FROM v2.evaluation 
WHERE v2.evaluation.id=NEW.id
AND (v2.evaluation.type=1
OR v2.evaluation.type=2
OR v2.evaluation.type=6);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'ERREUR (type=%):L\'EVALUATION DU QUESTION_REPONSE DOIT ETRE DE TYPE QCM(1) ou SONDAGE(2) ',v_type;
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_evaluation_question_reponse_type() OWNER TO postgres;

--
-- TOC entry 8994 (class 0 OID 0)
-- Dependencies: 63
-- Name: FUNCTION check_evaluation_question_reponse_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_question_reponse_type() IS 'VÃƒÂ©rifie qu''un question_reponse correspond bien ÃƒÂ  une ÃƒÂ©valuation de type qcm ou sondage';


--
-- TOC entry 1799 (class 1255 OID 2596718)
-- Dependencies: 2983 7
-- Name: check_evaluation_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_evaluation_type() RETURNS "trigger"
    AS $$BEGIN
raise notice '% % ',new.id,tg_argv[0];
PERFORM * FROM v2.evaluation 
WHERE v2.evaluation.id=NEW.id
AND v2.evaluation.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'Le \' % \' DOIT ETRE DE TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_evaluation_type() OWNER TO postgres;

--
-- TOC entry 8995 (class 0 OID 0)
-- Dependencies: 1799
-- Name: FUNCTION check_evaluation_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_type() IS 'Fonction gÃƒÂ©nÃƒÂ©rique pour vÃƒÂ©rifier que le type d''un objet hÃƒÂ©ritant de evaluation est bien le bon. Le type requis est un entier passÃƒÂ© en parametre du trigger.';


--
-- TOC entry 1800 (class 1255 OID 2596719)
-- Dependencies: 2983 7
-- Name: check_evaluation_type2(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_evaluation_type2() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.evaluation
WHERE v2.evaluation.id=NEW.evaluation
AND v2.evaluation.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'EVALUATION associee au \' % \' doit etre de TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_evaluation_type2() OWNER TO postgres;

--
-- TOC entry 8997 (class 0 OID 0)
-- Dependencies: 1800
-- Name: FUNCTION check_evaluation_type2(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_type2() IS 'VÃƒÂ©rifie que le champ evaluation de la table appelante a bien le type spÃƒÂ©cifiÃƒÂ© par le trigger.';


--
-- TOC entry 64 (class 1255 OID 2596720)
-- Dependencies: 2983 7
-- Name: check_evaluation_type2_question_reponse(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_evaluation_type2_question_reponse() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.evaluation
WHERE v2.evaluation.id=NEW.evaluation
AND ( v2.evaluation.type=1
OR v2.evaluation.type=2);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'EVALUATION associee au SERIE_BLOQUANTE_TENTATIVE_QUESTION_REPONSE doit etre de TYPE QCM(1) ou SONDAGE(2) ';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_evaluation_type2_question_reponse() OWNER TO postgres;

--
-- TOC entry 8999 (class 0 OID 0)
-- Dependencies: 64
-- Name: FUNCTION check_evaluation_type2_question_reponse(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_evaluation_type2_question_reponse() IS 'VÃƒÂ©rifie que le champ evaluation de la table appelante a bien le type sondage ou qcm.
';


--
-- TOC entry 1801 (class 1255 OID 2596721)
-- Dependencies: 2983 7
-- Name: check_exotlc_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_exotlc_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM v2.exotlc E
WHERE E.id= NEW.id 
AND E.type=TG_ARGV[0];

IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE TYPE DE L\'EXOTLC ASSOCIE AU % DOIT ETRE DE TYPE % ',TG_NAME,TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_exotlc_type() OWNER TO postgres;

--
-- TOC entry 9000 (class 0 OID 0)
-- Dependencies: 1801
-- Name: FUNCTION check_exotlc_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_exotlc_type() IS 'Fonction gÃƒÂ©nÃƒÂ©rique pour vÃƒÂ©rifier que le type d''un objet hÃƒÂ©ritant de exotlc est bien le bon. Le type requis est un entier passÃƒÂ© en parametre du trigger.';


--
-- TOC entry 1802 (class 1255 OID 2596722)
-- Dependencies: 2983 7
-- Name: check_fichier_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_fichier_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.fichier
WHERE v2.fichier.id=NEW.id
AND v2.fichier.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE FICHIER ASSOCIE AU \' % \' DOIT ETRE DE TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_fichier_type() OWNER TO postgres;

--
-- TOC entry 9002 (class 0 OID 0)
-- Dependencies: 1802
-- Name: FUNCTION check_fichier_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_fichier_type() IS 'Fonction gÃƒÂ©nÃƒÂ©rique pour vÃƒÂ©rifier que le type d''un objet hÃƒÂ©ritant de fichier est bien le bon. Le type requis est un entier passÃƒÂ© en parametre du trigger.';


--
-- TOC entry 1803 (class 1255 OID 2596723)
-- Dependencies: 2983 7
-- Name: check_formateur_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_formateur_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.individu_types
WHERE v2.individu_types.individu=NEW.formateur
AND v2.individu_types.type=2;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE FORMATEUR de la table \'%\'DOIT ETRE UN INDIVIDU POSSEDANT LE TYPE Formateur(2) ', TG_RELNAME;
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_formateur_type() OWNER TO postgres;

--
-- TOC entry 9004 (class 0 OID 0)
-- Dependencies: 1803
-- Name: FUNCTION check_formateur_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_formateur_type() IS 'vÃƒÂ©rifie que le formateur de la table appelante correspond bien ÃƒÂ  un individu ayant le type formateur(2)';


--
-- TOC entry 1804 (class 1255 OID 2596724)
-- Dependencies: 2983 7
-- Name: check_intervenant_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_intervenant_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.individu_types
WHERE v2.individu_types.individu=NEW.intervenant
AND v2.individu_types.type=3;

IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\' INTERVENANT de la table \' % \' doit etre de TYPE Intervenant(3) ', TG_RELNAME;
ELSE	
 RETURN NEW;
END IF;

END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_intervenant_type() OWNER TO postgres;

--
-- TOC entry 9006 (class 0 OID 0)
-- Dependencies: 1804
-- Name: FUNCTION check_intervenant_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_intervenant_type() IS 'VÃƒÂ©rifie que le champ intervenant de la table appelante correspond bien ÃƒÂ  un individu possedant le type intervenant (3)';


--
-- TOC entry 65 (class 1255 OID 2596725)
-- Dependencies: 2983 7
-- Name: check_liste_resultats_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_liste_resultats_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.etape 
WHERE v2.etape.id=NEW.etape
AND v2.etape.type=4;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'ETAPE ASSOCIEE A LA LISTE DOIT ETRE DE TYPE LISTE(4) ';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_liste_resultats_type() OWNER TO postgres;

--
-- TOC entry 9008 (class 0 OID 0)
-- Dependencies: 65
-- Name: FUNCTION check_liste_resultats_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_liste_resultats_type() IS 'VÃƒÂ©rifie que le champ etape de la table appelante a  bien le type liste(4)';


--
-- TOC entry 1805 (class 1255 OID 2596726)
-- Dependencies: 2983 7
-- Name: check_liste_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_liste_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.liste
WHERE v2.liste.id=NEW.id
AND v2.liste.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'La LISTE associee au \' % \' doit etre de TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_liste_type() OWNER TO postgres;

--
-- TOC entry 9009 (class 0 OID 0)
-- Dependencies: 1805
-- Name: FUNCTION check_liste_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_liste_type() IS 'Fonction gÃƒÂ©nÃƒÂ©rique qui vÃƒÂ©rifie que le champ id de la table appelante correspond bien ÃƒÂ  une liste du type spÃƒÂ©cifiÃƒÂ© par le paremetre du trigger';


--
-- TOC entry 1806 (class 1255 OID 2596727)
-- Dependencies: 2983 7
-- Name: check_liste_type_serie(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_liste_type_serie() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.liste
WHERE v2.liste.id=NEW.id
AND( v2.liste.type=1
OR v2.liste.type=2);
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'La LISTE associee Ã  la sÃ©rie doit etre de TYPE serie(1) ou serie alÃ©toire (2) ';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_liste_type_serie() OWNER TO postgres;

--
-- TOC entry 9011 (class 0 OID 0)
-- Dependencies: 1806
-- Name: FUNCTION check_liste_type_serie(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_liste_type_serie() IS 'VÃƒÂ©rifie qu''une champ id correspond bien ÃƒÂ  une table de type serie ou serie alÃƒÂ©atoire';


--
-- TOC entry 66 (class 1255 OID 2596728)
-- Dependencies: 2983 7
-- Name: check_media_question_reponse_element(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION check_media_question_reponse_element() RETURNS "trigger"
    AS $$DECLARE
cnt int4;
BEGIN
	SELECT INTO cnt COUNT(*) FROM v2.question_reponse_elements
	WHERE NEW.question_reponse=question_reponse
	AND (NEW.question_reponse_element=question OR NEW.question_reponse_element=reponse);

	IF cnt > 0 THEN
		RETURN NEW;
	ELSE
		RAISE EXCEPTION 'La ligne inseree dans media_question_reponse_element ne correspond pas Ã  un element associÃ© a un question reponse.';
	END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_media_question_reponse_element() OWNER TO pgsql;

--
-- TOC entry 1807 (class 1255 OID 2596729)
-- Dependencies: 2983 7
-- Name: check_modalite(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_modalite() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM v2.evenement
WHERE v2.evenement.formation= NEW.formation 
AND v2.evenement.date= NEW.date
AND v2.evenement.modalite=3;
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'PAS D''EVENEMENT DE TYPE ''PRESENTIEL''(3) POUR LA FORMATION % A LA DATE %',NEW.formation, NEW.date;
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_modalite() OWNER TO postgres;

--
-- TOC entry 9013 (class 0 OID 0)
-- Dependencies: 1807
-- Name: FUNCTION check_modalite(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_modalite() IS 'VÃ©rifie qu''une intervention correspond bien Ã Â  un element de calendrier de type prÃ©sentiel';


--
-- TOC entry 67 (class 1255 OID 2596730)
-- Dependencies: 2983 7
-- Name: check_positionnement_evaluations_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_positionnement_evaluations_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM v2.positionnement
WHERE v2.positionnement.id= NEW.positionnement
AND v2.positionnement.type=TG_ARGV[0];

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'L\'ELEMENT INSERE DOIT CORRESPONDRE A UN POSITIONNEMENT DE TYPE TG_ARGV[0] ',TG_ARGV[0];
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_positionnement_evaluations_type() OWNER TO postgres;

--
-- TOC entry 9015 (class 0 OID 0)
-- Dependencies: 67
-- Name: FUNCTION check_positionnement_evaluations_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_positionnement_evaluations_type() IS 'Fonction gÃƒÂ©nÃƒÂ©rique pour vÃƒÂ©rifier qu''un qrcs correspond ÃƒÂ  un positionnement dont le type passÃƒÂ© en paramettre';


--
-- TOC entry 68 (class 1255 OID 2596731)
-- Dependencies: 2983 7
-- Name: check_positionnement_questions_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_positionnement_questions_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM v2.question_reponse_element, v2.positionnement
WHERE v2.question_reponse_element.id= NEW.question 
AND v2.positionnement.id= NEW.positionnement
AND v2.question_reponse_element.type=v2.positionnement.type;

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'LE TYPE DE LA QUESTION DOIT CORRESPONDRE AU TYPE DU POSITIONNEMENT';
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_positionnement_questions_type() OWNER TO postgres;

--
-- TOC entry 9016 (class 0 OID 0)
-- Dependencies: 68
-- Name: FUNCTION check_positionnement_questions_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_positionnement_questions_type() IS 'vÃƒÂ©rifie que le type des questions d''un postionnement correspond au type du positionnement';


--
-- TOC entry 69 (class 1255 OID 2596732)
-- Dependencies: 2983 7
-- Name: check_positionnement_reponses_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_positionnement_reponses_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM v2.question_reponse_element, v2.positionnement
WHERE v2.question_reponse_element.id= NEW.reponse
AND v2.positionnement.id= NEW.positionnement
AND v2.question_reponse_element.type=v2.positionnement.type;

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'LE TYPE DE LA REPONSE DOIT CORRESPONDRE AU TYPE DU POSITIONNEMENT';
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_positionnement_reponses_type() OWNER TO postgres;

--
-- TOC entry 9017 (class 0 OID 0)
-- Dependencies: 69
-- Name: FUNCTION check_positionnement_reponses_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_positionnement_reponses_type() IS 'vÃƒÂ©rifie que le type des reponses d''un postionnement correspond au type du positionnement';


--
-- TOC entry 1808 (class 1255 OID 2596733)
-- Dependencies: 2983 7
-- Name: check_qcm_elements_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_qcm_elements_type() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM v2.question_reponse
WHERE v2.question_reponse.id= NEW.question_reponse
AND (v2.question_reponse.type=1 OR
v2.question_reponse.type=4);
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE QUESTION_REPONSE DU QCM_ELEMENTS DOIT ETRE DE TYPE QCM(1) ou QRC (4) ';
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_qcm_elements_type() OWNER TO postgres;

--
-- TOC entry 9018 (class 0 OID 0)
-- Dependencies: 1808
-- Name: FUNCTION check_qcm_elements_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_qcm_elements_type() IS 'VÃ©rifie qu''un qcm_elements correspond bien ÃƒÂ  un question_reponse de type qcm ou qrc
';


--
-- TOC entry 70 (class 1255 OID 2596734)
-- Dependencies: 2983 7
-- Name: check_qrc_correction_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_qrc_correction_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.evaluation 
WHERE v2.evaluation.id=NEW.qrc
AND v2.evaluation.type=4;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'UN QRC_CORRECTION DOIT CORRESPONDRE A UNE EVALUATION DE TYPE QRC (1)';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_qrc_correction_type() OWNER TO postgres;

--
-- TOC entry 9020 (class 0 OID 0)
-- Dependencies: 70
-- Name: FUNCTION check_qrc_correction_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_qrc_correction_type() IS 'VÃƒÂ©rifie qu''un element de la table qrc_correction correspond bien a une evaluation de type qrc';


--
-- TOC entry 71 (class 1255 OID 2596735)
-- Dependencies: 2983 7
-- Name: check_qsrc_positionnement_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_qsrc_positionnement_type() RETURNS "trigger"
    AS $$DECLARE
        -- on met la requete dans une chaine que l'on execute ensuite
        req varchar ;
	type_evaluation int4;
	type_question int4;
BEGIN

--on recupere le type de l'evaluation qui doit etre QRC(4) ou SRC(5) 
SELECT type INTO type_evaluation FROM v2.evaluation E, v2.qsrc QSRC
WHERE E.id=QSRC.id
AND QSRC.positionnement=NEW.id;

--si pas d'enregistrement dans la table evaluation, il ne s'agit pas d'un src ou d'un qrc
IF(NOT FOUND)THEN
	RETURN NEW;
END IF;

--on recupere le type_question du positionnement qui doit etre QCM(1) ou SONDAGE(2)
type_question:=NEW.type_question;

IF(type_evaluation=4)THEN
	IF(type_question=1)THEN
		RETURN NEW;
	ELSE
		RAISE EXCEPTION 'UN POSITIONNEMENT DE TYPE QCM(1) DOIT CORRESPONDRE A UN QRC(4)';
	END IF;
ELSE
	IF(type_evaluation=5)THEN
		IF(type_question=2)THEN
			RETURN NEW;
		ELSE
			RAISE EXCEPTION 'UN POSITIONNEMENT DE TYPE SONDAGE(2) DOIT CORRESPONDRE A UN SRC(5)';
		END IF;
	END IF;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_qsrc_positionnement_type() OWNER TO postgres;

--
-- TOC entry 9021 (class 0 OID 0)
-- Dependencies: 71
-- Name: FUNCTION check_qsrc_positionnement_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_qsrc_positionnement_type() IS 'VÃƒÂ©rifie que les type d''un positionnement correspond bien au type de l''ÃƒÂ©valuation:
QCM=>QRC
Sondage=>SRC';


--
-- TOC entry 1809 (class 1255 OID 2596736)
-- Dependencies: 2983 7
-- Name: check_question_reponse_elements_types(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_question_reponse_elements_types() RETURNS "trigger"
    AS $$DECLARE
rec RECORD;
BEGIN
/*SELECT INTO rec QR.type AS T1 , Q.type AS T2, R.type AS T3 FROM v2.question_reponse QR,v2.question_reponse_element Q, v2.question_reponse_element R
WHERE QR.id=NEW.question_reponse
AND Q.id= NEW.question 
AND R.id= NEW.reponse 
AND QR.type=Q.type
AND QR.type=R.type;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'QUESTION_REPONSE_ELEMENTS: LE QUESTION_REPONSE % (type=%), LA QUESTION % (type=%) ET LA REPONSE % (type=%) DOIVENT ETRE DE MEMES TYPES', NEW.question_reponse,rec.T1, NEW.question, rec.T2, NEW.reponse, rec.T3;
ELSE	*/
 RETURN NEW;
--END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_question_reponse_elements_types() OWNER TO postgres;

--
-- TOC entry 9022 (class 0 OID 0)
-- Dependencies: 1809
-- Name: FUNCTION check_question_reponse_elements_types(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_question_reponse_elements_types() IS 'VÃƒÂ©rifie l''ÃƒÂ©galitÃƒÂ© des types entre un question_reponse_elements, la question, et la reponse
';


--
-- TOC entry 1810 (class 1255 OID 2596737)
-- Dependencies: 2983 7
-- Name: check_ressource_dates(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_ressource_dates() RETURNS "trigger"
    AS $$DECLARE 
formation_date_debut TIMESTAMP; 
formation_date_fin TIMESTAMP; 
fin_nouveaute TIMESTAMP;
duree_jour varchar(255):=  NEW.duree_nouveaute ||' day'; 

BEGIN
SELECT date_debut INTO formation_date_debut 
FROM v2.formation
WHERE v2.formation.id= NEW.formation;

SELECT date_fin INTO formation_date_fin 
FROM v2.formation
WHERE v2.formation.id= NEW.formation;

fin_nouveaute:=NEW.debut_disponibilite+CAST(duree_jour AS INTERVAL);

IF(formation_date_fin<fin_nouveaute)
THEN
	RAISE EXCEPTION 'La duree de nouveaute est superieure a la date de fin de la formation';
END IF;

IF( 
((NEW.debut_disponibilite IS NOT NULL)AND(NEW.debut_disponibilite NOT BETWEEN formation_date_debut AND formation_date_fin))
OR ((NEW.fin_disponibilite IS NOT NULL)AND(NEW.fin_disponibilite NOT BETWEEN formation_date_debut AND formation_date_fin))
)
THEN
	RAISE EXCEPTION 'Les dates de disponibilite et d\'indisponibilite de la ressource doivent etre comprises dans les dates de la formation';	
END IF;

IF(NEW.debut_disponibilite IS NOT NULL
AND NEW.fin_disponibilite IS NOT NULL)
THEN
	IF(NEW.debut_disponibilite > NEW.fin_disponibilite)
	THEN
		RAISE EXCEPTION 'Une ressource doit avoir une date d\'indisponibilite ANTERIEURE a sa date de disponibilite';
	ELSE
		RETURN NEW;
	END IF;
ELSE
	RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_ressource_dates() OWNER TO postgres;

--
-- TOC entry 9024 (class 0 OID 0)
-- Dependencies: 1810
-- Name: FUNCTION check_ressource_dates(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_ressource_dates() IS 'Verifie la compatibilitÃƒÂ© des dates d''une ressource avec celles de la formation qui lui est associÃƒÂ©e';


--
-- TOC entry 1811 (class 1255 OID 2596738)
-- Dependencies: 2983 7
-- Name: check_ressource_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_ressource_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.fichier
WHERE v2.fichier.id=NEW.id
AND v2.fichier.type=1 OR v2.fichier.type=7 ;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE FICHIER DE LA RESSOURCE DOIT ETRE DE TYPE 1 ou 7';
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_ressource_type() OWNER TO postgres;

--
-- TOC entry 9026 (class 0 OID 0)
-- Dependencies: 1811
-- Name: FUNCTION check_ressource_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_ressource_type() IS 'Fonction gÃƒÂ©nÃƒÂ©rique pour vÃƒÂ©rifier que le type de fichier pour une ressource est bien le bon. Le type requis est un entier passÃƒÂ© en parametre du trigger.';


--
-- TOC entry 1812 (class 1255 OID 2596739)
-- Dependencies: 2983 7
-- Name: check_serie_aleatoire_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_serie_aleatoire_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.serie_aleatoire
WHERE v2.serie_aleatoire.id=NEW.serie
AND v2.serie_aleatoire.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'La SERIE_ALEATOIRE associee au \' % \' doit etre de TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_serie_aleatoire_type() OWNER TO postgres;

--
-- TOC entry 9028 (class 0 OID 0)
-- Dependencies: 1812
-- Name: FUNCTION check_serie_aleatoire_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_serie_aleatoire_type() IS 'Fonction gÃƒÂ©nÃƒÂ©rique qui verifie que le type d''une serie alÃƒÂ©atoire est bien du type spÃƒÂ©cifiÃƒÂ© en parametre.
';


--
-- TOC entry 72 (class 1255 OID 2596740)
-- Dependencies: 2983 7
-- Name: check_serie_evaluation(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION check_serie_evaluation() RETURNS "trigger"
    AS $$DECLARE
r_type integer;
BEGIN
	SELECT INTO r_type type 
	FROM v2.evaluation
	WHERE id=NEW.evaluation;

	IF (r_type IN (2,5)) 
		AND (NEW.bareme IS NOT NULL OR NEW.points IS NOT NULL) 
	THEN
		RAISE EXCEPTION 'Impossible d''associer un bareme (%) et/ou des points (%) pour la sÃ©rie % et l''evaluation % .Le type % ne les acceptent pas.',NEW.bareme, NEW.points, NEW.serie, NEW.evaluation, r_type;
		RETURN NULL;
	ELSE
		RETURN NEW;
	END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_serie_evaluation() OWNER TO pgsql;

--
-- TOC entry 1813 (class 1255 OID 2596741)
-- Dependencies: 2983 7
-- Name: check_stagiaire_formation(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_stagiaire_formation() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM v2.formation_participants FP, v2.classe_individus CI
WHERE FP.formation= NEW.formation 
AND CI.individu=NEW.stagiaire
AND FP.classe= CI.classe;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'LE STAGIAIRE N\'EST PAS DANS LA CLASSE ASSOCIEE A LA FORMATION';
ELSE	
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_stagiaire_formation() OWNER TO postgres;

--
-- TOC entry 9030 (class 0 OID 0)
-- Dependencies: 1813
-- Name: FUNCTION check_stagiaire_formation(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_stagiaire_formation() IS 'VÃƒÂ©rifie que le stagiaire est bien prÃƒÂ©sent dans la classe d''une formation';


--
-- TOC entry 1814 (class 1255 OID 2596742)
-- Dependencies: 2983 7
-- Name: check_stagiaire_type(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_stagiaire_type() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.individu_types
WHERE v2.individu_types.individu=NEW.stagiaire
AND v2.individu_types.type=1;
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'Le STAGIAIRE de la table \' % \' doit etre de TYPE Stagiaire(1) ', TG_RELNAME;
ELSE	
 RETURN NEW;
END IF;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_stagiaire_type() OWNER TO postgres;

--
-- TOC entry 9032 (class 0 OID 0)
-- Dependencies: 1814
-- Name: FUNCTION check_stagiaire_type(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_stagiaire_type() IS 'VÃƒÂ©rifie que le champ stagiaire de la table appelante correspond bien ÃƒÂ  un individu possedant le type stagiaire (1)';


--
-- TOC entry 1815 (class 1255 OID 2596743)
-- Dependencies: 2983 7
-- Name: check_type_etape(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_type_etape() RETURNS "trigger"
    AS $$BEGIN

PERFORM * FROM v2.etape 
WHERE v2.etape.id=NEW.id
AND v2.etape.type=TG_ARGV[0];
 
IF(NOT FOUND)	
THEN	
 RAISE EXCEPTION 'L\'ETAPE ASSOCIEE AU \' % \' DOIT ETRE DE TYPE % ', TG_RELNAME, TG_ARGV[0];
ELSE	
 RETURN NEW;
END IF;

END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_type_etape() OWNER TO postgres;

--
-- TOC entry 9034 (class 0 OID 0)
-- Dependencies: 1815
-- Name: FUNCTION check_type_etape(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_type_etape() IS 'Fonction gÃƒÂ©nÃƒÂ©rique pour vÃƒÂ©rifier que le type d''un objet hÃƒÂ©ritant de etape est bien le bon. Le type requis est un entier passÃƒÂ© en parametre du trigger.';


--
-- TOC entry 1816 (class 1255 OID 2596744)
-- Dependencies: 2983 7
-- Name: check_type_question(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_type_question() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM v2.question_reponse_element
WHERE v2.question_reponse_element.reponse= FALSE 
AND v2.question_reponse_element.id= NEW.id ;

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'ERREUR TYPAGE QUESTION';
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_type_question() OWNER TO postgres;

--
-- TOC entry 9036 (class 0 OID 0)
-- Dependencies: 1816
-- Name: FUNCTION check_type_question(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_type_question() IS 'VÃƒÂ©rifie qu''une question est bien un question_reponse_element de type question';


--
-- TOC entry 1817 (class 1255 OID 2596745)
-- Dependencies: 2983 7
-- Name: check_type_reponse(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION check_type_reponse() RETURNS "trigger"
    AS $$BEGIN
PERFORM * FROM v2.question_reponse_element
WHERE v2.question_reponse_element.reponse= TRUE 
AND v2.question_reponse_element.id= NEW.id ;

IF(NOT FOUND)	
THEN
 RAISE EXCEPTION 'ERREUR TYPAGE REPONSE';
ELSE
 RETURN NEW;
END IF;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.check_type_reponse() OWNER TO postgres;

--
-- TOC entry 9038 (class 0 OID 0)
-- Dependencies: 1817
-- Name: FUNCTION check_type_reponse(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION check_type_reponse() IS 'VÃƒÂ©rifie qu''une reponse est bien un question_reponse_element de type reponse';


--
-- TOC entry 73 (class 1255 OID 2596746)
-- Dependencies: 2983 7
-- Name: cls_del_classe(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_del_classe(integer) RETURNS boolean
    AS $_$declare
rec record;
num int4;
begin
    num:=$1;
    delete from v2.classe where id=num;
    -- recup des classes filles
    for rec in
	select * from v2.classe where pere=num
    loop
	num:=rec.id;
	perform v2.af_del_classe(num);
    end loop;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_del_classe(integer) OWNER TO pgsql;

--
-- TOC entry 9040 (class 0 OID 0)
-- Dependencies: 73
-- Name: FUNCTION cls_del_classe(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_del_classe(integer) IS 'Supprime une classe (et ses classes filles si necessaire)';


--
-- TOC entry 74 (class 1255 OID 2596747)
-- Dependencies: 2983 7
-- Name: cls_del_classe_droit(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_del_classe_droit(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero classe
-- $2 : numero droit
begin
    delete from v2.individu_droits where classe=$1 and droit=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_del_classe_droit(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9041 (class 0 OID 0)
-- Dependencies: 74
-- Name: FUNCTION cls_del_classe_droit(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_del_classe_droit(integer, integer) IS 'Supprime un droit Ãƒ  une classe';


--
-- TOC entry 75 (class 1255 OID 2596748)
-- Dependencies: 2983 7
-- Name: cls_del_classe_individu(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_del_classe_individu(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero classe
-- $2 : numero individu
-- $3 : numero formation
declare

begin
    -- supprime l'individu de la classe
    delete from v2.classe_individus where classe=$1 and individu=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_del_classe_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9042 (class 0 OID 0)
-- Dependencies: 75
-- Name: FUNCTION cls_del_classe_individu(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_del_classe_individu(integer, integer) IS 'supprime un individu d''une classe';


--
-- TOC entry 76 (class 1255 OID 2596749)
-- Dependencies: 2983 7
-- Name: cls_del_individu_droit_classe(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_del_individu_droit_classe(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero individu
-- $2 : numero classe
-- $3 : numero droit
begin
    delete from v2.individu_droits where individu=$1 and classe=$2 and droit=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_del_individu_droit_classe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9043 (class 0 OID 0)
-- Dependencies: 76
-- Name: FUNCTION cls_del_individu_droit_classe(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_del_individu_droit_classe(integer, integer, integer) IS 'Supprime un droit pour un individu et une classe';


--
-- TOC entry 77 (class 1255 OID 2596750)
-- Dependencies: 2983 7
-- Name: cls_get_classe(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec * from 
    v2.af_get_classes() as(id int4,libelle varchar,pere int4,min int4,max int4) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe(integer) OWNER TO pgsql;

--
-- TOC entry 9044 (class 0 OID 0)
-- Dependencies: 77
-- Name: FUNCTION cls_get_classe(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe(integer) IS 'retourne les infos d''une classe';


--
-- TOC entry 78 (class 1255 OID 2596751)
-- Dependencies: 2983 7
-- Name: cls_get_classe_droits_communs(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_droits_communs(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero classe
-- $2 : nombre d'individu ds la classe
declare
rec record;
begin
    for rec in
	select droit from v2.individu_droits where classe=$1 
	group by droit having count(*)=$2
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_droits_communs(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9045 (class 0 OID 0)
-- Dependencies: 78
-- Name: FUNCTION cls_get_classe_droits_communs(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_droits_communs(integer, integer) IS 'retourne les droits communs pour les individus d''une classe';


--
-- TOC entry 79 (class 1255 OID 2596752)
-- Dependencies: 2983 7
-- Name: cls_get_classe_droits_non_affilies(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_droits_non_affilies(integer) RETURNS SETOF record
    AS $_$-- $1 : numero classe
declare
rec record;
begin
    for rec in 
	select distinct d.id from v2.droit d
	left outer join
	v2.individu_droits id  
	on d.id=id.droit and id.classe=$1 and d.type=2
	where  id.droit is null  
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_droits_non_affilies(integer) OWNER TO pgsql;

--
-- TOC entry 9046 (class 0 OID 0)
-- Dependencies: 79
-- Name: FUNCTION cls_get_classe_droits_non_affilies(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_droits_non_affilies(integer) IS 'retourne les droits non affilies pour une classe (droit que personne ne possede)';


--
-- TOC entry 80 (class 1255 OID 2596753)
-- Dependencies: 2983 7
-- Name: cls_get_classe_evenements(integer, date); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_evenements(integer, date) RETURNS SETOF record
    AS $_$-- $1 : classe
-- $2 : date
declare
rec record;
begin
    for rec in
	select e.formation,e.libelle,e.date,e.duree,e.modalite,e.intervention,e.intervenant,e.salle 
	from v2.evenement e,v2.formation_participants fp 
	where e.formation=fp.formation and fp.classe=$1 and cast(e.date as date)=$2
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_evenements(integer, date) OWNER TO pgsql;

--
-- TOC entry 9047 (class 0 OID 0)
-- Dependencies: 80
-- Name: FUNCTION cls_get_classe_evenements(integer, date); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_evenements(integer, date) IS 'retourne les evenements d''une classe pour un jour de formation';


--
-- TOC entry 81 (class 1255 OID 2596754)
-- Dependencies: 2983 7
-- Name: cls_get_classe_formations(integer, character varying, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_formations(integer, character varying, character varying, integer) RETURNS SETOF record
    AS $_$-- $1 numero de la classe
-- $2 ordre pour classement ('asc' ou 'desc')
-- $3 'date_debut' ou 'libelle' (orderby)
-- $4 periode (1 : passÃƒÂ©es, 2 : prÃƒÂ©sentes, 3 : futures, 0 : toutes)
declare
rec record;
begin
    for rec in 
	select id,libelle,parcours,date_debut,date_fin,langue,fp.classe
	from v2.af_get_formations($2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4),
	v2.formation_participants fp 
	where fp.classe=$1 and fp.formation=id
    loop
	return next rec;
    end loop;
    return;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_formations(integer, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9048 (class 0 OID 0)
-- Dependencies: 81
-- Name: FUNCTION cls_get_classe_formations(integer, character varying, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_formations(integer, character varying, character varying, integer) IS 'retourne les formations pour une classe';


--
-- TOC entry 82 (class 1255 OID 2596755)
-- Dependencies: 2157 2983 7
-- Name: cls_get_classe_individus(integer, integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean) RETURNS SETOF organisme_type_individu
    AS $_$-- Parametres :
-- 1. Identifiant de la classe
-- 2. Type : 0=tous, 1=formateurs & 2=stagiaires
-- 3. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 4. exclusif : si VRAI alors que les 'u' ou les 'f'
declare
rec record;
rec2 v2.organisme_type_individu;
req varchar;
begin
    for rec in 
	select id,nom,prenom,organisme 
	from v2.af_get_individus($2,$3,$4) as (id int4,nom varchar,prenom varchar,organisme int4),v2.classe_individus CI 
	where CI.classe=$1 and CI.individu=id
	order by nom, prenom
    loop
	rec2.id:=rec.id;
	rec2.nom:=rec.nom;
	rec2.prenom:=rec.prenom;
	rec2.organisme:=rec.organisme;
	rec2.types:=NULL;
	return next rec2;
	--return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_individus(integer, integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 9049 (class 0 OID 0)
-- Dependencies: 82
-- Name: FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean) IS 'retourne les nÃ‚Â°,nom prenom et tabtype des individu d''une classe';


--
-- TOC entry 83 (class 1255 OID 2596756)
-- Dependencies: 2983 7
-- Name: cls_get_classe_individus_affiliables(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_individus_affiliables(integer) RETURNS SETOF record
    AS $_$declare
nb_individu int4;
org int4;
rec record;
req varchar;
begin
    -- test si la classe est vide
    perform * from v2.af_get_classe_individus($1,0,'asc',false) ;
    if not found then
	-- on renvoie tous les individus
	for rec in
	    select * from v2.af_get_individus(0,'asc',false) as (id int4,nom varchar,prenom varchar,organisme int4)
	loop
	    return next rec;
	end loop;

    else
	-- on renvoie les individus qui ne sont pas affiliÃƒÂ©s Ãƒ  la classe
	-- et ayant un organisme communs aux individus de la classe ou (multi organisme)
	-- recup de l'organisme des individus de la classe
	select into org * from v2.af_get_classe_organisme($1);
	
	if org is null then
	    for rec in 
	    select distinct I_id,I_nom,I_prenom,I_organisme 
	    from v2.af_get_individus(0,'asc',false)  as (I_id int4,I_nom varchar,I_prenom varchar,I_organisme int4) ,
	    v2.af_get_classe_individus($1,0,'asc',false) CI 
	    where I_id!=CI.id 
	    loop
		return next rec;
	    end loop;
	else
	    
	    for rec in 
	    
	    select distinct I_id,I_nom,I_prenom,I_organisme 
	    from v2.af_get_individus(0,'asc',false) as (I_id int4,I_nom varchar,I_prenom varchar,I_organisme int4)
	    where I_id not in (select CI.id from v2.af_get_classe_individus($1,0,'asc',false) CI)
	    and (I_organisme =org or I_organisme is null)
	    
	    loop
		return next rec;
	    end loop;
	end if;
	
	
	

    end if;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_individus_affiliables(integer) OWNER TO pgsql;

--
-- TOC entry 9050 (class 0 OID 0)
-- Dependencies: 83
-- Name: FUNCTION cls_get_classe_individus_affiliables(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_individus_affiliables(integer) IS 'retourne les individus affiliables Ãƒ  une classe';


--
-- TOC entry 84 (class 1255 OID 2596757)
-- Dependencies: 2983 7
-- Name: cls_get_classe_individus_infos(integer, integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_individus_infos(integer, integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 : classe
-- $2 : type d'individu (0=tous, 1=formateurs & 2=stagiaires)
-- 3. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 4. exclusif : si VRAI alors que les 'u' ou les 'f'
declare
rec record;
begin
    for rec in
	select id ,identifiant_md5 ,login,password,nom ,prenom ,adresse ,code ,ville ,email ,tel_fixe ,tel_port ,langue ,organisme ,photo  from v2.af_get_individus_infos($2,$3,$4) 
	as (id int4,identifiant_md5 varchar,login varchar,password varchar,nom varchar,prenom varchar,adresse varchar,code varchar,ville varchar,email varchar,tel_fixe varchar,tel_port varchar,langue int4,organisme int4,photo int4),
	v2.classe_individus CI 
	where CI.classe=$1 and CI.individu=id
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_individus_infos(integer, integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 9051 (class 0 OID 0)
-- Dependencies: 84
-- Name: FUNCTION cls_get_classe_individus_infos(integer, integer, character varying, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_individus_infos(integer, integer, character varying, boolean) IS 'Retourne les infos individu d''une classe';


--
-- TOC entry 85 (class 1255 OID 2596758)
-- Dependencies: 2983 7
-- Name: cls_get_classe_nom_entier(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_nom_entier(integer) RETURNS character varying
    AS $_$declare
parent int4;
nom_classe varchar;
rec record;
begin
    parent=$1;
    while(parent is not null)
    loop
    select * into rec from v2.classe where id=parent;
    if nom_classe is null then
	nom_classe:=rec.libelle;
    else
	nom_classe:=rec.libelle || '/' || nom_classe;
    end if;
    parent:=rec.pere;
    end loop;
    return nom_classe;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_nom_entier(integer) OWNER TO pgsql;

--
-- TOC entry 9052 (class 0 OID 0)
-- Dependencies: 85
-- Name: FUNCTION cls_get_classe_nom_entier(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_nom_entier(integer) IS 'retourne le nom entier de la classe';


--
-- TOC entry 86 (class 1255 OID 2596759)
-- Dependencies: 2983 7
-- Name: cls_get_classe_organisme(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_organisme(integer) RETURNS integer
    AS $_$-- $1 : numero organisme
declare
res int4;
nb_res int4;
begin
    -- recup organisme nom null des individus de la classe
    select into res distinct organisme 
    from v2.af_get_classe_individus($1,0,'asc',false) 
    where organisme is not null;
    if found then
	GET DIAGNOSTICS nb_res:=ROW_COUNT;
	if nb_res=1 then
	    return res;
	end if;
    else
	return NULL;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_organisme(integer) OWNER TO pgsql;

--
-- TOC entry 9053 (class 0 OID 0)
-- Dependencies: 86
-- Name: FUNCTION cls_get_classe_organisme(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_organisme(integer) IS 'retourn l''organisme d''une classe';


--
-- TOC entry 87 (class 1255 OID 2596760)
-- Dependencies: 2983 7
-- Name: cls_get_classe_pere(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION cls_get_classe_pere(integer) RETURNS SETOF record
    AS $_$declare
	id_pere alias for $1;
	req text;
	rec record;

begin
	req:='select * from v2.classe where pere ';
	if (id_pere is null) then
		req:=req||' is null';
	else
		req:=req||'='||id_pere;
	end if;
	for rec in
		execute req
		loop
			return next rec;
		end loop;
	return;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_pere(integer) OWNER TO postgres;

--
-- TOC entry 9054 (class 0 OID 0)
-- Dependencies: 87
-- Name: FUNCTION cls_get_classe_pere(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION cls_get_classe_pere(integer) IS 'Renvoie les classes associÃƒÆ’Ã‚Â©es ÃƒÆ’Ã‚  un pere.';


--
-- TOC entry 88 (class 1255 OID 2596761)
-- Dependencies: 2983 7
-- Name: cls_get_classe_peres_fils(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classe_peres_fils() RETURNS SETOF record
    AS $$declare
rec record;
rec2 record;
begin
    for rec in 
	select * from v2.af_get_classes() as (gc_id int4,gc_nom varchar,gc_id_pere int4,gc_min int4,gc_max int4)
    loop
	/*
	for rec2 in
	    select * from v2.af_get_classe_pere(rec.gc_id) as (id int4,nom varchar,id_pere int4,min int4,max int4)
	loop
		
		return next rec2;
	end loop;
	*/
		return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classe_peres_fils() OWNER TO pgsql;

--
-- TOC entry 9055 (class 0 OID 0)
-- Dependencies: 88
-- Name: FUNCTION cls_get_classe_peres_fils(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classe_peres_fils() IS 'retourne toutes les clases (pere fils)';


--
-- TOC entry 89 (class 1255 OID 2596762)
-- Dependencies: 2983 7
-- Name: cls_get_classes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classes() RETURNS SETOF record
    AS $$declare
rec record;

begin
    for rec in 
	select id,libelle,pere,min,max from v2.classe
    loop
    return next rec;
    end loop;
    return; 
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classes() OWNER TO pgsql;

--
-- TOC entry 9056 (class 0 OID 0)
-- Dependencies: 89
-- Name: FUNCTION cls_get_classes(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classes() IS 'retourne les classes de la plateforme';


--
-- TOC entry 90 (class 1255 OID 2596763)
-- Dependencies: 2983 7
-- Name: cls_get_classes_individu(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_classes_individu() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct id,libelle,pere,max,min from v2.af_get_classes() as (id int4,libelle varchar,pere int4,max int4,min int4),
	v2.classe_individus CI where id=CI.classe
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_classes_individu() OWNER TO pgsql;

--
-- TOC entry 9057 (class 0 OID 0)
-- Dependencies: 90
-- Name: FUNCTION cls_get_classes_individu(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_classes_individu() IS 'retourne les classes avec individu de la plateforme';


--
-- TOC entry 91 (class 1255 OID 2596764)
-- Dependencies: 2983 7
-- Name: cls_get_formations_classes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_formations_classes() RETURNS SETOF record
    AS $$declare
rec record;
begin
	FOR rec IN 
	    select id,libelle,pere,min,max, ft.formation 
	    from v2.af_get_classes() as(id int4,libelle varchar, pere int4,min int4,max int4) ,
	    v2.formation_participants ft 
	    where  ft.classe=id
	    ORDER BY formation
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
end$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_formations_classes() OWNER TO pgsql;

--
-- TOC entry 9058 (class 0 OID 0)
-- Dependencies: 91
-- Name: FUNCTION cls_get_formations_classes(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_formations_classes() IS 'retourne les classes des formations';


--
-- TOC entry 92 (class 1255 OID 2596765)
-- Dependencies: 2983 7
-- Name: cls_get_individu_classes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_individu_classes(integer) RETURNS SETOF record
    AS $_$-- $1 : numero individu
declare
rec record;
begin
    for rec in 
	select id,libelle,pere,min,max from v2.af_get_classes() as (id int4,libelle varchar,pere int4,min int4,max int4),
	v2.classe_individus CI 
	where id=CI.classe and CI.individu=$1 
	ORDER BY libelle
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_individu_classes(integer) OWNER TO pgsql;

--
-- TOC entry 9059 (class 0 OID 0)
-- Dependencies: 92
-- Name: FUNCTION cls_get_individu_classes(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_individu_classes(integer) IS 'retourne les classes d''un individu';


--
-- TOC entry 93 (class 1255 OID 2596766)
-- Dependencies: 2983 7
-- Name: cls_get_individu_droits_classe(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_get_individu_droits_classe(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero individu
-- $2 : numero classe
declare 
rec record;
begin
    for rec in 
	select id,libelle,type,defaut from v2.af_get_droits(2) as (id int4,libelle varchar,type int4,defaut bool),v2.individu_droits ID 
	where id=ID.droit and ID.individu=$1 and ID.classe=$2
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_get_individu_droits_classe(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9060 (class 0 OID 0)
-- Dependencies: 93
-- Name: FUNCTION cls_get_individu_droits_classe(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_get_individu_droits_classe(integer, integer) IS 'retourne les droitts d''un individu pour une classe';


--
-- TOC entry 94 (class 1255 OID 2596767)
-- Dependencies: 2983 7
-- Name: cls_is_individu_droit_classe(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_is_individu_droit_classe(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero individu
-- $2 : numero classe
-- $3 : numero droit
begin
    perform * from v2.individu_droits where individu=$1 and classe=$2 and droit=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_is_individu_droit_classe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9061 (class 0 OID 0)
-- Dependencies: 94
-- Name: FUNCTION cls_is_individu_droit_classe(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_is_individu_droit_classe(integer, integer, integer) IS 'retourne vrai si un individu possede le droit pour la classe,faux sinon';


--
-- TOC entry 95 (class 1255 OID 2596768)
-- Dependencies: 2983 7
-- Name: cls_maj_classe(integer, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_maj_classe(integer, character varying, integer) RETURNS boolean
    AS $_$-- $1 numero de la classe
-- $2 nouveau nom de la classe
-- $3 numero du pere
declare

begin
    -- test doublon
    if $3 is null then
	perform * from v2.classe where lower(libelle) like lower($2) and pere is null;
    else
	perform * from v2.classe where lower(libelle) like lower($2) and pere =$3;
    end if;
    if not found then
	update v2.classe set libelle=$2 where id=$1;
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_maj_classe(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9062 (class 0 OID 0)
-- Dependencies: 95
-- Name: FUNCTION cls_maj_classe(integer, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_maj_classe(integer, character varying, integer) IS 'met Ãƒ  jour le nom d''une classe';


--
-- TOC entry 96 (class 1255 OID 2596769)
-- Dependencies: 2983 7
-- Name: cls_maj_classe_places(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_maj_classe_places(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero de la classe
-- $2 : min
-- $3 : max
begin
    update v2.classe set min=$2,max=$3 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_maj_classe_places(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9063 (class 0 OID 0)
-- Dependencies: 96
-- Name: FUNCTION cls_maj_classe_places(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_maj_classe_places(integer, integer, integer) IS 'met Ãƒ  jour le nombre de place min et max d''une classe';


--
-- TOC entry 97 (class 1255 OID 2596770)
-- Dependencies: 2983 7
-- Name: cls_set_classe(character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_set_classe(character varying, integer, integer, integer) RETURNS integer
    AS $_$-- $1 nom de la classe
-- $2 nÃ‚Â° pere (null si racine)
-- $3 nombre de places min
-- $4 nombre de places max
declare
req varchar;
new_id int4;
res int4;
begin
    -- test doublon
    --req:='select * from v2.classe where lower(libelle) like lower('||$1||') and ';
    if $2 is null then
	--req:=req || ' pere is null';
	perform * from v2.classe where lower(libelle) like lower($1) and pere is null;
    else
	--req:=req || ' pere='||$2;
	perform * from v2.classe where lower(libelle) like lower($1) and pere =$2;
    end if;
    --execute req;
    if not found then
	insert into v2.classe(libelle,pere,min,max) values($1,$2,$3,$4);
	get diagnostics new_id=result_oid;
	SELECT INTO res id FROM v2.classe WHERE oid=new_id;

    else
	raise exception 'ce nom existe dÃƒÂ©jÃƒ  !';
	res=0;
    end if;

    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_set_classe(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9064 (class 0 OID 0)
-- Dependencies: 97
-- Name: FUNCTION cls_set_classe(character varying, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_set_classe(character varying, integer, integer, integer) IS 'enregistre une classe';


--
-- TOC entry 98 (class 1255 OID 2596771)
-- Dependencies: 2983 7
-- Name: cls_set_classe_droit(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_set_classe_droit(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero clase
-- $2 : numero droit
declare
rec v2.organisme_type_individu;
ret bool;
begin
    -- boucle sur les individu de la classe
    for rec in
	select * from v2.af_get_classe_individus($1,2,'desc',false) 
    loop
	-- insertion droit si l'individu ne le possÃƒÂ¨de pas
	select into ret * from v2.af_is_individu_droit_classe(rec.id,$1,$2);
	
	if ret is false then
		
	    perform * from v2.af_set_individu_droit_classe(rec.id,$1,$2);
	end if;
    end loop;
    return found;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_set_classe_droit(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9065 (class 0 OID 0)
-- Dependencies: 98
-- Name: FUNCTION cls_set_classe_droit(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_set_classe_droit(integer, integer) IS 'enregistre un droit pour une classe';


--
-- TOC entry 99 (class 1255 OID 2596772)
-- Dependencies: 2983 7
-- Name: cls_set_classe_individu(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_set_classe_individu(integer, integer) RETURNS boolean
    AS $_$-- $1 nÃ‚Â°classe
-- $2 nÃ‚Â° individu
declare

begin
    insert into v2.classe_individus(classe,individu) values($1,$2);
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_set_classe_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9066 (class 0 OID 0)
-- Dependencies: 99
-- Name: FUNCTION cls_set_classe_individu(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION cls_set_classe_individu(integer, integer) IS 'affilie un individu Ãƒ  une classe';


--
-- TOC entry 100 (class 1255 OID 2596773)
-- Dependencies: 2983 7
-- Name: cls_set_classe_individu(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION cls_set_classe_individu() RETURNS boolean
    AS $_$-- $1 nÃ‚Â°classe
-- $2 nÃ‚Â° individu
declare

begin
    insert into v2.classe_individus(classe,individu) values($1,$2);
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.cls_set_classe_individu() OWNER TO pgsql;

--
-- TOC entry 101 (class 1255 OID 2596774)
-- Dependencies: 2983 7
-- Name: create_error(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION create_error() RETURNS "trigger"
    AS $$BEGIN

	RAISE EXCEPTION 'erreur sur la table';

END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.create_error() OWNER TO pgsql;

--
-- TOC entry 9067 (class 0 OID 0)
-- Dependencies: 101
-- Name: FUNCTION create_error(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION create_error() IS 'cette fonction est utile pour gÃ©nÃ©rer une erreur lors d''une action quelquonque sur une table';


--
-- TOC entry 102 (class 1255 OID 2596775)
-- Dependencies: 2983 7
-- Name: del_classe(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_classe() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS DE LA CLASSE
	-- avec ses individus
	delete from classe_individu where classe=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_classe() OWNER TO www;

--
-- TOC entry 9068 (class 0 OID 0)
-- Dependencies: 102
-- Name: FUNCTION del_classe(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_classe() IS 'Supprime la totalitÃƒÂ© des enregistrements liÃƒÂ©s ÃƒÂ  une classe.';


--
-- TOC entry 103 (class 1255 OID 2596776)
-- Dependencies: 2983 7
-- Name: del_classe_individu(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_classe_individu() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS D'UNE CLASSE ET D'UN INDIVIDU
	--avec ses droits
	delete from individu_droits where classe=new.classe and individu=new.individu;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_classe_individu() OWNER TO www;

--
-- TOC entry 9069 (class 0 OID 0)
-- Dependencies: 103
-- Name: FUNCTION del_classe_individu(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_classe_individu() IS 'Supprime la totalitÃƒÂ© des enregistrements liÃƒÂ©s ÃƒÂ  une classe et un individu.';


--
-- TOC entry 1818 (class 1255 OID 2596777)
-- Dependencies: 2983 7
-- Name: del_etape(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_etape() RETURNS "trigger"
    AS $$begin
	--SUPPRIME UNE ETAPE ASSOCIEE A UN ELEMENT
	delete from v2.etape where id=old.id;
	
	return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_etape() OWNER TO www;

--
-- TOC entry 9070 (class 0 OID 0)
-- Dependencies: 1818
-- Name: FUNCTION del_etape(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_etape() IS 'Supprime la totalitÃƒÂ© des enregistrements liÃƒÂ©s ÃƒÂ  une ÃƒÂ©tape.';


--
-- TOC entry 104 (class 1255 OID 2596778)
-- Dependencies: 2983 7
-- Name: del_etape_resultats(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_etape_resultats() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS (FORMATION,STAGIAIRE,ETAPE)
	--avec les tentatives de sÃƒÂƒÃ‚Â©ries bloquantes (question_reponse)
	delete from serie_bloquante_tentative_question_reponse where
		formation=new.formation and
		stagiaire=new.stagiaire and
		serie=new.etape;
	--avec les tentatives de sÃƒÂƒÃ‚Â©rie bloquantes (remplir les blancs)
	delete from serie_bloquante_tentative_ftb where
		formation=new.formation and
		stagiaire=new.stagiaire and
		serie=new.etape;
	--avec les positionnements
	delete from test_resultats_positionnement where
		formation=new.formation and
		stagiaire=new.stagiaire and
		test=new.etape;
	--avec les questions reponses des positionnements 
	delete from positionnement_resultats_question_reponse where
		formation=new.formation and
		stagiaire=new.stagiaire and
		test=new.etape;
	--avec les resultats des sÃƒÂƒÃ‚Â©rie de remplir les blancs
	delete from serie_resultats_ftb where
		formation=new.formation and
		stagiaire=new.stagiaire and
		serie=new.etape;
	--avec les rÃƒÂƒÃ‚Â©sultats des sÃƒÂƒÃ‚Â©rie de questions reponses
	delete from serie_resultats_question_reponse where
		formation=new.formation and
		stagiaire=new.stagiaire and
		serie=new.etape;
	--avec les rÃƒÂƒÃ‚Â©sultats des listes
	delete from liste_resultats where
		formation=new.formation and
		stagiaire=new.stagiaire and
		liste=new.etape;
	--avec les resultats des sous critÃƒÂƒÃ…Â¡res des exercices ÃƒÂƒÃ‚Â  tÃƒÂƒÃ‚Â©lÃƒÂƒÃ‚Â©charger
	delete from exotlc_resultats_sous_criteres where
		formation=new.formation and
		stagiaire=new.stagiaire and
		exotlc=new.etape;
	--avec les resultats des critÃƒÂƒÃ…Â¡res des exercices ÃƒÂƒÃ‚Â  tÃƒÂƒÃ‚Â©lÃƒÂƒÃ‚Â©charger
	delete from exotlc_resultats_criteres where
		formation=new.formation and
		stagiaire=new.stagiaire and
		exotlc=new.etape;
	--avec les rÃƒÂƒÃ‚Â©sultats des ecercices ÃƒÂƒÃ‚Â  tÃƒÂƒÃ‚Â©lÃƒÂƒÃ‚Â©charger
	delete from exotlc_resultats where
		formation=new.formation and
		stagiaire=new.stagiaire and
		exotlc=new.etape;
	
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_etape_resultats() OWNER TO www;

--
-- TOC entry 9072 (class 0 OID 0)
-- Dependencies: 104
-- Name: FUNCTION del_etape_resultats(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_etape_resultats() IS 'Supprime la totalitÃƒÂ©  des enregistrements liÃƒÂ©s ÃƒÂ  une formation,un stagiaire et une etape.';


--
-- TOC entry 105 (class 1255 OID 2596779)
-- Dependencies: 2983 7
-- Name: del_evaluation(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_evaluation() RETURNS "trigger"
    AS $$begin
	--SUPPRIME UNE EVALUATION ASSOCIEE A UN ELEMENT
	delete from v2.evaluation where id=old.id;
	
	return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_evaluation() OWNER TO www;

--
-- TOC entry 9073 (class 0 OID 0)
-- Dependencies: 105
-- Name: FUNCTION del_evaluation(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_evaluation() IS 'Supprime un element d'' evaluation de la table evaluation';


--
-- TOC entry 106 (class 1255 OID 2596780)
-- Dependencies: 2983 7
-- Name: del_evenement_presentiel(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION del_evenement_presentiel() RETURNS "trigger"
    AS $$
begin
    if old.modalite=3 then
    delete from v2.evenement_presentiel 
    where old.formation=v2.evenement_presentiel.formation and old.date=v2.evenement_presentiel.date;
    end if;
    return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_evenement_presentiel() OWNER TO pgsql;

--
-- TOC entry 9074 (class 0 OID 0)
-- Dependencies: 106
-- Name: FUNCTION del_evenement_presentiel(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION del_evenement_presentiel() IS 'supprime un evet pres';


--
-- TOC entry 107 (class 1255 OID 2596781)
-- Dependencies: 2983 7
-- Name: del_exotlc(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION del_exotlc() RETURNS "trigger"
    AS $$BEGIN

	--supprime ses resultats
	DELETE FROM exotlc_resultats 
	WHERE exotlc=NEW.id;

	--supprime l'association avec ses fichiers d'exotlc
	DELETE FROM exotlc_fichiers
	WHERE exotlc=NEW.id;

	--supprime l'association avec ses fichiers de correction
	DELETE FROM exotlc_corrections
	WHERE exotlc=NEW.id;

	
RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_exotlc() OWNER TO postgres;

--
-- TOC entry 108 (class 1255 OID 2596782)
-- Dependencies: 2983 7
-- Name: del_fichier_correction(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_fichier_correction() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATION D'UN FICHIER DE CORRECTION
	--avec ses exotlc
	delete from exotlc_corrections where correction=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_fichier_correction() OWNER TO www;

--
-- TOC entry 9075 (class 0 OID 0)
-- Dependencies: 108
-- Name: FUNCTION del_fichier_correction(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_fichier_correction() IS 'Supprime la totalitÃƒÂ© des enregistrement liÃƒÂ©s ÃƒÂ  un fichier de correction.';


--
-- TOC entry 109 (class 1255 OID 2596783)
-- Dependencies: 2983 7
-- Name: del_fichier_exotlc(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_fichier_exotlc() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS D'UN FICHIER
	--avec ses exotlc
	delete from exotlc_fichiers where fichier=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_fichier_exotlc() OWNER TO www;

--
-- TOC entry 9076 (class 0 OID 0)
-- Dependencies: 109
-- Name: FUNCTION del_fichier_exotlc(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_fichier_exotlc() IS 'Supprime la totalitÃƒÂ© des enregistrements liÃƒÂ©s ÃƒÂ  un fichier d''exotlc';


--
-- TOC entry 1819 (class 1255 OID 2596784)
-- Dependencies: 2983 7
-- Name: del_formation(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_formation() RETURNS "trigger"
    AS $$begin
	-- SUPPRIME LES ASSOCIATIONS DE LA FORMATION
	--avec ses forums
	delete from formation_forums where formation=new.id;
	--avec ses langues
	delete from formation_langues where formation=new.id;
	--avec ses ressources
	delete from formation_ressources where formation=new.id;
	--avec les avancements des individus
	delete from formation_avancement where formation=new.id;
	--avec les droits (du formateur)
	delete from droits_formateur where formation=new.id;
	--avec ses participants (formateur et classe)
	delete from formation_participants where formation=new.id;
	--avec ses grilles de resultats 
	delete from grille_resultats where formation=new.id;
	--avec ses dates de cours prÃƒÂƒÃ‚Â©sentiel
	delete from calendrier_presentiel where formation=new.id;
	--avec les etapes (des stagiaires)
	delete from etape_resultats where formation=new.id;
	--avec ses sÃƒÂƒÃ‚Â©ries alÃƒÂƒÃ‚Â©atoires configurÃƒÂƒÃ‚Â©es
	delete from serie_aleatoire_configuree where formation=new.id;
	--avec ses sÃƒÂƒÃ‚Â©ries bloquantes
	delete from serie_bloquante where formation=new.id;
	--avec ses cours
	delete from calendrier where formation=new.id;
	--avec ses alertes
	delete from alerte where formation=new.id;
	--avec les sessions des individus
	delete from "session" where formation=new.id;
	--avec ses commentaires pour sÃƒÂƒÃ‚Â©rie
	delete from page_serie_commentaire where formation=new.id;
	--avec ses titres de sÃƒÂƒÃ‚Â©rie
	delete from page_serie_titre where formation=new.id;
	--avec ses commentaires
	delete from page_commentaire where formation=new.id;
	--avec ses configurations de pages d'annuaire
	delete from page_annuaire_configuration where formation=new.id;
	--avec ses configuration de pages de sÃƒÂƒÃ‚Â©rie
	delete from page_serie_configuration where formation=new.id;
	--avec ses evaluations de sÃƒÂƒÃ‚Â©ries aleatoires
	delete from serie_aleatoire_evaluations where formation=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_formation() OWNER TO www;

--
-- TOC entry 9077 (class 0 OID 0)
-- Dependencies: 1819
-- Name: FUNCTION del_formation(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_formation() IS 'supprime la totalitÃƒÂ© des enregistrements liÃƒÂ©s ÃƒÂ  une formation';


--
-- TOC entry 110 (class 1255 OID 2596785)
-- Dependencies: 2983 7
-- Name: del_individu(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_individu() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS INDIVIDU
	--avec sa classe
	delete from classe_individu where individu=new.id;
	--avec ses types
	delete from individu_types where individu=new.id;
	--avec ses grilles de resultats
	delete from grille_resultats where stagiaire=new.id;
	--avec ses grilles
	delete from stagiaire_grille where stagiaire=new.id;
	--avec ses commentaires de pages serie
	delete from page_serie_commentaire where stagiaire=new.id;
	--avec ses commentaires de pages
	delete from page_commentaire where stagiaire=new.id;
	--avec ses connexions
	delete from connexion where individu=new.id; 
	--avec ses ÃƒÂƒÃ‚Â©tapes
	delete from etape_resultats where stagiaire=new.id;
	--avec son avancement
	delete from formation_avancement where stagiaire=new.id;
	--avec ses ÃƒÂƒÃ‚Â©valuations de sÃƒÂƒÃ‚Â©ries alÃƒÂƒÃ‚Â©atoires
	delete from serie_aleatoire_evaluations where stagiaire=new.id;
	-- NOTE : DÃƒÂƒÃ‚Â©calage ÃƒÂƒÃ‚Â  prÃƒÂƒÃ‚Â©voir car suppression d'evaluations qui peuvent ÃƒÂƒÃ‚Âªtre pÃƒÂƒÃ…Â¡re et suppression d'un pÃƒÂƒÃ…Â¡re (A Suivre ....)



	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_individu() OWNER TO www;

--
-- TOC entry 9079 (class 0 OID 0)
-- Dependencies: 110
-- Name: FUNCTION del_individu(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_individu() IS 'supprime la totalitÃƒÂ© des enregistrement liÃƒÂ©s ÃƒÂ  un individu.';


--
-- TOC entry 1820 (class 1255 OID 2596786)
-- Dependencies: 2983 7
-- Name: del_parcours(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_parcours() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS DU PARCOURS
	--avec ses etapes
	delete from contraintes.parcours_etapes where parcours=old.id;
	--avec son orientation
	delete from contraintes.parcours_oriente where id=old.id;
	
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_parcours() OWNER TO www;

--
-- TOC entry 9080 (class 0 OID 0)
-- Dependencies: 1820
-- Name: FUNCTION del_parcours(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_parcours() IS 'Supprime la totalitÃƒÂ© des enregistrements liÃƒÂ©s ÃƒÂ  un parcours';


--
-- TOC entry 111 (class 1255 OID 2596787)
-- Dependencies: 2983 7
-- Name: del_parcours_etape(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION del_parcours_etape() RETURNS "trigger"
    AS $$declare
rec record;
begin
    select into rec * from v2.af_get_etape(old.etape) as (id int4, libelle varchar, type int4, date_creation timestamp);
    if rec.type=10 then
	perform * from v2.af_del_etape(old.etape);
    end if;
    return old;

end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_parcours_etape() OWNER TO pgsql;

--
-- TOC entry 9082 (class 0 OID 0)
-- Dependencies: 111
-- Name: FUNCTION del_parcours_etape(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION del_parcours_etape() IS 'pour supprimer l''etape de type 10
(etape oriente)';


--
-- TOC entry 112 (class 1255 OID 2596788)
-- Dependencies: 2983 7
-- Name: del_positionnement_evaluations_a_generer(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION del_positionnement_evaluations_a_generer() RETURNS "trigger"
    AS $$DECLARE
qr int4;
BEGIN

	IF (NEW.nombre!=OLD.nombre OR NEW.nombre_max!=OLD.nombre_max)
	OR (NEW.nombre IS NULL AND OLD.nombre IS NOT NULL)
	OR (NEW.nombre_max IS NULL AND OLD.nombre_max IS NOT NULL)
	OR (OLD.nombre IS NULL AND NEW.nombre IS NOT NULL)
	OR (OLD.nombre_max IS NULL AND NEW.nombre_max IS NOT NULL)	
	THEN
		
		--on recupere le question_reponse du positionnement
		SELECT INTO qr question_reponse FROM v2.positionnement
		WHERE id=NEW.positionnement;
 
		--on supprime les evaluations dÃ©jÃ  associÃ©es au choix modifiÃ©
		DELETE FROM v2.positionnement_evaluations
		WHERE question_reponse = qr
		AND choix=NEW.choix;
	END IF;

	RETURN NEW;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_positionnement_evaluations_a_generer() OWNER TO pgsql;

--
-- TOC entry 113 (class 1255 OID 2596789)
-- Dependencies: 2983 7
-- Name: del_qsrc(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION del_qsrc() RETURNS "trigger"
    AS $$BEGIN

--supprime la correction d'un qrc
DELETE FROM qrc_correction WHERE qrc=NEW.id
AND positionnement=NEW.positionnement;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_qsrc() OWNER TO postgres;

--
-- TOC entry 114 (class 1255 OID 2596790)
-- Dependencies: 2983 7
-- Name: del_question_reponse(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_question_reponse() RETURNS "trigger"
    AS $$BEGIN

--supprime les media associÃƒÂƒÃ‚Â©s au question reponse
DELETE FROM media_question_reponse WHERE question_reponse=NEW.id;

--supprime les media associÃƒÂƒÃ‚Â©s ÃƒÂƒÃ‚Â  un couple question_reponse/question_reponse_element
DELETE FROM media_question_reponse_element WHERE question_reponse=NEW.id;

--supprime les question_reponse_element associÃƒÂƒÃ‚Â©s au question_reponse
DELETE FROM question_reponse_elements WHERE question_reponse=NEW.id;
RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_question_reponse() OWNER TO www;

--
-- TOC entry 115 (class 1255 OID 2596791)
-- Dependencies: 2983 7
-- Name: del_question_reponse_element(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION del_question_reponse_element() RETURNS "trigger"
    AS $$BEGIN

--supprime le media associÃƒÂƒÃ‚Â© au question_reponse_element
DELETE FROM media_question_reponse_element WHERE question_reponse_element=NEW.id;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_question_reponse_element() OWNER TO postgres;

--
-- TOC entry 116 (class 1255 OID 2596792)
-- Dependencies: 2983 7
-- Name: del_question_reponse_element_media(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION del_question_reponse_element_media() RETURNS "trigger"
    AS $$BEGIN
	DELETE FROM v2.media_question_reponse_element
	WHERE question_reponse=OLD.question_reponse
	AND (question_reponse_element=OLD.question
	OR question_reponse_element=OLD.reponse);

	RETURN OLD;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_question_reponse_element_media() OWNER TO pgsql;

--
-- TOC entry 117 (class 1255 OID 2596793)
-- Dependencies: 2983 7
-- Name: del_ressource(); Type: FUNCTION; Schema: v2; Owner: www
--

CREATE FUNCTION del_ressource() RETURNS "trigger"
    AS $$begin
	--SUPPRIME LES ASSOCIATIONS DE LA RESSOURCE
	-- avec ses formation
	delete from formation_ressources where ressource=new.id;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_ressource() OWNER TO www;

--
-- TOC entry 9083 (class 0 OID 0)
-- Dependencies: 117
-- Name: FUNCTION del_ressource(); Type: COMMENT; Schema: v2; Owner: www
--

COMMENT ON FUNCTION del_ressource() IS 'Supprime la totalitÃƒÂ© des enregistrements liÃƒÂ©s ÃƒÂ  une ressource.';


--
-- TOC entry 118 (class 1255 OID 2596794)
-- Dependencies: 2983 7
-- Name: del_serie(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION del_serie() RETURNS "trigger"
    AS $$BEGIN

	--supprime les associations avec ses evaluations
	DELETE FROM serie_evaluations 
	WHERE serie=NEW.id;

	--supprime les configuration de page qui lui sont associÃƒÂƒÃ‚Â©s
	DELETE FROM page_serie_configuration 
	WHERE serie=NEW.id;
	DELETE FROM page_serie_commentaire 
	WHERE serie=NEW.id;
	DELETE FROM page_serie_titre
	WHERE serie=NEW.id;


RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_serie() OWNER TO postgres;

--
-- TOC entry 119 (class 1255 OID 2596795)
-- Dependencies: 2983 7
-- Name: del_serie_aleatoire(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION del_serie_aleatoire() RETURNS "trigger"
    AS $$BEGIN

	--supprime les associations avec ses evaluations
	DELETE FROM serie_aleatoire_evaluations 
	WHERE serie=NEW.id;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_serie_aleatoire() OWNER TO postgres;

--
-- TOC entry 120 (class 1255 OID 2596796)
-- Dependencies: 2983 7
-- Name: del_serie_aleatoire_configuree_evaluations(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION del_serie_aleatoire_configuree_evaluations() RETURNS "trigger"
    AS $$DECLARE
resultat RECORD;
BEGIN
RAISE NOTICE 'TRIGGER %',OLD.id;

	SELECT INTO resultat * FROM v2.af_get_resultat(OLD.id) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	RAISE NOTICE 'Supprime les evaluations de la serie %',resultat.etape;
	-- NOTE : un autre trigger fait la meme chose si on supprime les resultats d'une etape serie aleatoire
	/*
	DELETE FROM v2.serie_aleatoire_evaluations 
	WHERE serie=resultat.etape
	AND formation=resultat.formation
	AND parcours=resultat.parcours
	AND serie IN(SELECT id FROM v2.serie_aleatoire);
	*/
	RETURN OLD;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_serie_aleatoire_configuree_evaluations() OWNER TO pgsql;

--
-- TOC entry 121 (class 1255 OID 2596797)
-- Dependencies: 2983 7
-- Name: del_serie_aleatoire_evaluations(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION del_serie_aleatoire_evaluations() RETURNS "trigger"
    AS $$declare
rec record;
aleatoire boolean;
begin
    -- si l'etape est une serie aleatoire monotheme ou multitheme
    select into aleatoire * from v2.af_is_serie_aleatoire(old.etape);
    if aleatoire is true then
	select into rec * from v2.af_get_serie_aleatoire(old.etape) 
	as (id int4,libelle varchar,bareme int4,chrono int4,type int4,date_creation timestamp);
	
	if rec.type=2 or rec.type=3 or rec.type=1 then
	    delete from v2.serie_aleatoire_evaluations 
	    where serie=old.etape and formation=old.formation and parcours=old.parcours and stagiaire=old.stagiaire;
	end if;
    end if;
    return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_serie_aleatoire_evaluations() OWNER TO pgsql;

--
-- TOC entry 9084 (class 0 OID 0)
-- Dependencies: 121
-- Name: FUNCTION del_serie_aleatoire_evaluations(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION del_serie_aleatoire_evaluations() IS 'supprime les associations serie/evaluation d''une serie aleatoire';


--
-- TOC entry 122 (class 1255 OID 2596798)
-- Dependencies: 2983 7
-- Name: del_serie_evaluations(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION del_serie_evaluations() RETURNS "trigger"
    AS $$begin
	
	--SUPPRESSION DES DONNEES ASSOCIEES A UNE EVALUATION D'UNE SERIE
	--la supprimer des series alÃƒÂƒÃ‚Â©atoires
	delete from serie_aleatoire_evaluations 
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;
	
	--SUPPRESSION DES RESULTATS ASSOCIES
	--pour les ÃƒÂƒÃ‚Â©valuations de type question_reponse
	delete from serie_resultats_question_reponse 
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;

	--pour les ÃƒÂƒÃ‚Â©valuations de type ftb (blanc)
	delete from serie_resultats_ftb
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;

	--pour les ÃƒÂƒÃ‚Â©valuations des series bloquantes de type ftb (blanc)
	delete from serie_bloquante_tentative_ftb
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;

	--pour les ÃƒÂƒÃ‚Â©valuations des series bloquantes de type question_reponse
	delete from serie_bloquante_tentative_question_reponse
	where serie=NEW.serie 
	AND evaluation=NEW.evaluation;
	
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_serie_evaluations() OWNER TO postgres;

--
-- TOC entry 123 (class 1255 OID 2596799)
-- Dependencies: 2983 7
-- Name: del_stagiaire_grille(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION del_stagiaire_grille() RETURNS "trigger"
    AS $$-- test s'il y a encore des reference pour la formation,stagiaire,grille
begin
    perform * from v2.grille_resultats where old.formation=formation and old.stagiaire=stagiaire and old.grille=grille;
    if not found then
	delete from v2.stagiaire_grille where formation=old.formation and stagiaire=old.stagiaire and grille=old.grille;
    end if;
    return old;	
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_stagiaire_grille() OWNER TO pgsql;

--
-- TOC entry 9085 (class 0 OID 0)
-- Dependencies: 123
-- Name: FUNCTION del_stagiaire_grille(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION del_stagiaire_grille() IS 'supprime dans stagiaire_grille si plus de reference ds grille_resultats';


--
-- TOC entry 124 (class 1255 OID 2596800)
-- Dependencies: 2983 7
-- Name: del_test(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION del_test() RETURNS "trigger"
    AS $$BEGIN

--supprime le mÃƒÂƒÃ‚Â©dia du test
DELETE FROM media_test WHERE test=NEW.id;

--supprime les positionnements du test
DELETE FROM test_positionnements WHERE test=NEW.id;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_test() OWNER TO postgres;

--
-- TOC entry 125 (class 1255 OID 2596801)
-- Dependencies: 2983 7
-- Name: del_test_positonnements(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION del_test_positonnements() RETURNS "trigger"
    AS $$BEGIN

--supprime les resultats du positionnement pour ce test
DELETE FROM test_resultats_positionnement 
WHERE test=NEW.test
AND positionnement=NEW.positionnement;

--supprime les resultats des questions_reponses du postionnement pour ce test
DELETE FROM positionnement_resultats_question_reponse WHERE test=NEW.test
AND positionnement=NEW.positionnement;

RETURN NEW;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_test_positonnements() OWNER TO postgres;

--
-- TOC entry 1821 (class 1255 OID 2596802)
-- Dependencies: 2983 7
-- Name: del_theme_categorie(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION del_theme_categorie() RETURNS "trigger"
    AS $$BEGIN

	DELETE FROM v2.theme_categories WHERE id=OLD.id
	AND categorie=OLD.categorie;
	
	RETURN OLD;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_theme_categorie() OWNER TO pgsql;

--
-- TOC entry 126 (class 1255 OID 2596803)
-- Dependencies: 2983 7
-- Name: del_theme_etape(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION del_theme_etape() RETURNS "trigger"
    AS $$declare

begin 
    delete  from v2.categorie_etape 
    where id=OLD.id ;
    return OLD;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.del_theme_etape() OWNER TO pgsql;

--
-- TOC entry 9087 (class 0 OID 0)
-- Dependencies: 126
-- Name: FUNCTION del_theme_etape(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION del_theme_etape() IS 'supprime le theme enregistrÃ© pour  l''etape';


--
-- TOC entry 127 (class 1255 OID 2596804)
-- Dependencies: 2983 7
-- Name: delete_serie_aleatoire_multitheme_categorie_serie(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION delete_serie_aleatoire_multitheme_categorie_serie() RETURNS "trigger"
    AS $$begin
	delete from v2.categorie_serie 
	where id=old.serie and theme=old.theme_source;
	return old;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.delete_serie_aleatoire_multitheme_categorie_serie() OWNER TO pgsql;

--
-- TOC entry 9088 (class 0 OID 0)
-- Dependencies: 127
-- Name: FUNCTION delete_serie_aleatoire_multitheme_categorie_serie(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION delete_serie_aleatoire_multitheme_categorie_serie() IS 'supprime un enregistrement dans la table categorie serie';


--
-- TOC entry 128 (class 1255 OID 2596805)
-- Dependencies: 2983 7
-- Name: fb_get_ftb(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fb_get_ftb(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec E.id,E.libelle,text,voir_mots,interpretation_html, date_creation
    from v2.ftb F, v2.evaluation E
    where E.id=$1
    and F.id=E.id;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fb_get_ftb(integer) OWNER TO pgsql;

--
-- TOC entry 9089 (class 0 OID 0)
-- Dependencies: 128
-- Name: FUNCTION fb_get_ftb(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fb_get_ftb(integer) IS 'retourne les infos d''un ftb(remplir les blancs)';


--
-- TOC entry 129 (class 1255 OID 2596806)
-- Dependencies: 2983 7
-- Name: fb_get_ftb_liste_mot(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fb_get_ftb_liste_mot(integer) RETURNS text[]
    AS $_$-- $1 : le ftb
declare
rec text[];
rec_ftb record;
mot_courant text;
texte text;
lettre char;
lettre_suivante char;
longueur_texte integer;
i integer;
j integer;
k integer;
begin
    -- recupere le texte du blanc
    select into rec_ftb * from v2.af_get_ftb($1) as (id int4, libelle varchar,text text,voir_mots bool,interpretation_html bool, date_creation timestamp);
    texte:=rec_ftb.text;
    
    longueur_texte:=char_length(texte);
	
    -- boucle sur le texte
    i:=1;
    k:=1;
    mot_courant:='';
    while i < longueur_texte
    loop
	if (substring(texte from i for 1))='[' then
	    i:=i+1;
	    if (substring(texte from i for 1))=':' then
		-- debut d'un mot
		
		i:=i+1;
		lettre:=substring(texte from i for 1);
		--raise notice 'lettre=%',lettre;
		mot_courant:=mot_courant || lettre;
		-- boucle jusqu'Ãƒ  ':]'
		i:=i+1;
		lettre:=substring(texte from i for 1);
		j:=i+1;
		lettre_suivante:=substring(texte from j for 1);
		while (lettre!=':' and lettre_suivante!=']')
		loop
		    mot_courant:=mot_courant || lettre;
		    i:=i+1;
		lettre:=substring(texte from i for 1);
		j:=i+1;
		lettre_suivante:=substring(texte from j for 1);
		end loop;
		-- stocke le mot
		rec[k]:=mot_courant;
		--rec[k]:='toto';
		k:=k+1;
		mot_courant:='';
	    else
		i:=i+1;
	    end if;
	else
	    i:=i+1;
	end if;
	
    end loop;
	
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fb_get_ftb_liste_mot(integer) OWNER TO pgsql;

--
-- TOC entry 9090 (class 0 OID 0)
-- Dependencies: 129
-- Name: FUNCTION fb_get_ftb_liste_mot(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fb_get_ftb_liste_mot(integer) IS 'retourne la liste des mots d''un ftb';


--
-- TOC entry 130 (class 1255 OID 2596807)
-- Dependencies: 2983 7
-- Name: fb_get_theme_ftbs(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fb_get_theme_ftbs(integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
for rec in
    select DISTINCT f.id,f.text,f.voir_mots,f.interpretation_html
    from v2.ftb f,v2.af_get_categorie_elements_theme($2,$1) e_id
    where f.id=e_id
loop
    return next rec;
end loop;
return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fb_get_theme_ftbs(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9091 (class 0 OID 0)
-- Dependencies: 130
-- Name: FUNCTION fb_get_theme_ftbs(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fb_get_theme_ftbs(integer, integer) IS 'retourn les exos ';


--
-- TOC entry 131 (class 1255 OID 2596808)
-- Dependencies: 2983 7
-- Name: fb_maj_ftb(integer, text, boolean, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fb_maj_ftb(integer, text, boolean, boolean) RETURNS boolean
    AS $_$begin
    update v2.ftb set text=$2,voir_mots=$3,interpretation_html=$4 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fb_maj_ftb(integer, text, boolean, boolean) OWNER TO pgsql;

--
-- TOC entry 9092 (class 0 OID 0)
-- Dependencies: 131
-- Name: FUNCTION fb_maj_ftb(integer, text, boolean, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fb_maj_ftb(integer, text, boolean, boolean) IS 'met Ãƒ  jour un remplir les blancs (ftb)';


--
-- TOC entry 132 (class 1255 OID 2596809)
-- Dependencies: 2983 7
-- Name: fb_set_ftb(text, boolean, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fb_set_ftb(text, boolean, boolean) RETURNS integer
    AS $_$declare
new_id int4;
res int4;
begin
	select into new_id * from v2.af_set_evaluation($1,3);
	insert into v2.ftb(id,text,voir_mots,interpretation_html) values(new_id,$1,$2,$3);
	
	return new_id;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fb_set_ftb(text, boolean, boolean) OWNER TO pgsql;

--
-- TOC entry 9093 (class 0 OID 0)
-- Dependencies: 132
-- Name: FUNCTION fb_set_ftb(text, boolean, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fb_set_ftb(text, boolean, boolean) IS 'enregistre un ';


--
-- TOC entry 133 (class 1255 OID 2596810)
-- Dependencies: 2983 7
-- Name: fchr_get_categorie_fichiers_all_theme(integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fchr_get_categorie_fichiers_all_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
type_categorie int4;
BEGIN

	--recupere le type de fichier correspondant ÃƒÆ’Ã‚  la categorie
	SELECT INTO type_categorie id FROM v2.fichier_type
	WHERE categorie = $1;

	IF type_categorie IS NULL THEN
		RAISE EXCEPTION 'La categorie % n''a pas de type de fichier associÃƒÆ’Ã‚Â©',$1;
	END IF;


		--req:='SELECT id, libelle,"type",connecte FROM v2.af_get_fichiers_type('||type_categorie||') AS (id int4, libelle varchar, "type" int4, connecte bool),
		--	v2.af_get_categorie_elements_all_theme('||$1||','||$2||') E_id
		--	WHERE id=E_id ORDER BY libelle';
	
	FOR rec IN
		SELECT id, libelle,"type",connecte FROM v2.af_get_fichiers_type(type_categorie) AS (id int4, libelle varchar, "type" int4, connecte bool),
		v2.af_get_categorie_elements_all_theme($1,$2) E_id
		WHERE id=E_id ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_get_categorie_fichiers_all_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 9094 (class 0 OID 0)
-- Dependencies: 133
-- Name: FUNCTION fchr_get_categorie_fichiers_all_theme(integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fchr_get_categorie_fichiers_all_theme(integer, integer) IS 'Obtenir tous les fichiers d''un theme pour une categorie.';


--
-- TOC entry 134 (class 1255 OID 2596811)
-- Dependencies: 2983 7
-- Name: fchr_get_categorie_fichiers_textes_all_theme(integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fchr_get_categorie_fichiers_textes_all_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
type_categorie int4;
BEGIN

	--recupere le type de fichier correspondant ÃƒÆ’Ã‚  la categorie
	SELECT INTO type_categorie id FROM v2.fichier_type
	WHERE categorie = $1;

	IF type_categorie IS NULL THEN
		RAISE EXCEPTION 'La categorie % n''a pas de type de fichier associÃƒÆ’Ã‚Â©',$1;
	END IF;

	--req:='SELECT T_id, T_libelle,"type",connecte, T.libelle, T.adresse, T.description, T.mise_en_forme, TO_CHAR(T.date_modification,''DD/MM/YYYY'') FROM v2.af_get_fichiers_type('||type_categorie||') AS (T_id int4, T_libelle varchar, "type" int4, connecte bool),
	--		v2.af_get_categorie_elements_all_theme('||$1||','||$2||') E_id, v2.fichier_texte T
	--		WHERE T_id=E_id
	--		AND T_id=T.id  ORDER BY T_libelle';
	

	RAISE NOTICE 'req: %',req;

	FOR rec IN
		SELECT T_id, T_libelle,"type",connecte, T.libelle, T.adresse, T.description, T.mise_en_forme, TO_CHAR(T.date_modification,'DD/MM/YYYY') FROM v2.af_get_fichiers_type(type_categorie) AS (T_id int4, T_libelle varchar, "type" int4, connecte bool),
		v2.af_get_categorie_elements_all_theme($1,$2) E_id, v2.fichier_ressource_texte T
		WHERE T_id=E_id
		AND T_id=T.id  ORDER BY T_libelle
	
	LOOP
		RETURN NEXT rec;
	END LOOP;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_get_categorie_fichiers_textes_all_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 9095 (class 0 OID 0)
-- Dependencies: 134
-- Name: FUNCTION fchr_get_categorie_fichiers_textes_all_theme(integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fchr_get_categorie_fichiers_textes_all_theme(integer, integer) IS 'Obtenir tous les fichiers textes d''un theme pour une categorie.';


--
-- TOC entry 135 (class 1255 OID 2596812)
-- Dependencies: 2983 7
-- Name: fchr_get_categorie_fichiers_textes_theme(integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fchr_get_categorie_fichiers_textes_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
type_categorie int4;
BEGIN

	--recupere le type de fichier correspondant ÃƒÆ’Ã‚  la categorie
	SELECT INTO type_categorie id FROM v2.fichier_type
	WHERE categorie = $1;

	IF type_categorie IS NULL THEN
		RAISE EXCEPTION 'La categorie % n''a pas de type de fichier associÃƒÆ’Ã‚Â©',$1;
	END IF;

	--req:='SELECT T_id, T_libelle,"type",connecte, T.libelle, T.adresse, T.description, T.mise_en_forme, TO_CHAR(T.date_modification,''DD/MM/YYYY'') FROM v2.af_get_fichiers_type('||type_categorie||') AS (T_id int4, T_libelle varchar, "type" int4, connecte bool),
	--		v2.af_get_categorie_elements_all_theme('||$1||','||$2||') E_id, v2.fichier_texte T
	--		WHERE T_id=E_id
	--		AND T_id=T.id  ORDER BY T_libelle';
	

	RAISE NOTICE 'req: %',req;

	FOR rec IN
		SELECT T_id, T_libelle,"type",connecte, T.libelle, T.adresse, T.description, T.mise_en_forme, TO_CHAR(T.date_modification,'DD/MM/YYYY') FROM v2.af_get_fichiers_type(type_categorie) AS (T_id int4, T_libelle varchar, "type" int4, connecte bool),
		v2.af_get_categorie_elements_theme($1,$2) E_id, v2.fichier_ressource_texte T
		WHERE T_id=E_id
		AND T_id=T.id  ORDER BY T_libelle
	
	LOOP
		RETURN NEXT rec;
	END LOOP;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_get_categorie_fichiers_textes_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 9096 (class 0 OID 0)
-- Dependencies: 135
-- Name: FUNCTION fchr_get_categorie_fichiers_textes_theme(integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fchr_get_categorie_fichiers_textes_theme(integer, integer) IS 'Obtenir les fichiers textes connectÃƒÂ©s d''un theme pour une categorie.';


--
-- TOC entry 136 (class 1255 OID 2596813)
-- Dependencies: 2983 7
-- Name: fchr_get_categorie_fichiers_theme(integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fchr_get_categorie_fichiers_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
type_categorie int4;
BEGIN

	--recupere le type de fichier correspondant ÃƒÆ’Ã‚  la categorie
	SELECT INTO type_categorie id FROM v2.fichier_type
	WHERE categorie = $1;

	IF type_categorie IS NULL THEN
		RAISE EXCEPTION 'La categorie % n''a pas de type de fichier associÃƒÆ’Ã‚Â©',$1;
	END IF;


		--req:='SELECT id, libelle,"type",connecte FROM v2.af_get_fichiers_type('||type_categorie||') AS (id int4, libelle varchar, "type" int4, connecte bool),
		--	v2.af_get_categorie_elements_all_theme('||$1||','||$2||') E_id
		--	WHERE id=E_id ORDER BY libelle';
	
	FOR rec IN
		SELECT id, libelle,"type",connecte FROM v2.af_get_fichiers_type(type_categorie) AS (id int4, libelle varchar, "type" int4, connecte bool),
		v2.af_get_categorie_elements_theme($1,$2) E_id
		WHERE id=E_id ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_get_categorie_fichiers_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 9097 (class 0 OID 0)
-- Dependencies: 136
-- Name: FUNCTION fchr_get_categorie_fichiers_theme(integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fchr_get_categorie_fichiers_theme(integer, integer) IS 'Obtenir les fichiers connectÃƒÂ©s d''un theme pour une categorie.';


--
-- TOC entry 137 (class 1255 OID 2596814)
-- Dependencies: 2983 7
-- Name: fchr_get_etapes_fichiers(integer[], character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fchr_get_etapes_fichiers(integer[], character varying) RETURNS SETOF record
    AS $_$DECLARE
--$1 les numeros de fichier
--$2 la table de correspondance fichier/etape
rec RECORD;
req varchar;
BEGIN

	req:='SELECT DISTINCT E.id, E.libelle, E.type, T.fichier, E.date_creation  FROM v2.'||$2||' T, v2.etape E
	WHERE T.fichier IN ('||array_to_string ($1, ',')||')
	AND E.id=T.id;';
	--RAISE NOTICE 'req=%', req;

	FOR rec IN 
		EXECUTE req
	LOOP
		RETURN NEXT rec;
	END LOOP; 

	RETURN;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_get_etapes_fichiers(integer[], character varying) OWNER TO pgsql;

--
-- TOC entry 9098 (class 0 OID 0)
-- Dependencies: 137
-- Name: FUNCTION fchr_get_etapes_fichiers(integer[], character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fchr_get_etapes_fichiers(integer[], character varying) IS 'Obtenir les informations sur les etapes d''un ensemble de fichiers d''apres leurs numeros.';


--
-- TOC entry 138 (class 1255 OID 2596815)
-- Dependencies: 2983 7
-- Name: fchr_get_fichier(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fchr_get_fichier(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN

	SELECT into rec * FROM v2.af_get_fichiers() AS ( id int4, libelle varchar, "type" int4, connecte bool)
	WHERE id=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_get_fichier(integer) OWNER TO postgres;

--
-- TOC entry 9099 (class 0 OID 0)
-- Dependencies: 138
-- Name: FUNCTION fchr_get_fichier(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fchr_get_fichier(integer) IS 'Obtenir les informations d''un fichier.';


--
-- TOC entry 139 (class 1255 OID 2596816)
-- Dependencies: 2983 7
-- Name: fchr_get_fichier_texte(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fchr_get_fichier_texte(integer) RETURNS record
    AS $_$DECLARE
--$1 identifiant du fichier
rec RECORD;
BEGIN
	SELECT into rec F_id, F_libelle, F_type , F_connecte, libelle, adresse, description, mise_en_forme, TO_CHAR(date_modification,'DD/MM/YYYY') FROM v2.af_get_fichiers() AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool),
	v2.fichier_ressource_texte
	WHERE F_id=$1
	AND F_id=id;
	
	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_get_fichier_texte(integer) OWNER TO pgsql;

--
-- TOC entry 9100 (class 0 OID 0)
-- Dependencies: 139
-- Name: FUNCTION fchr_get_fichier_texte(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fchr_get_fichier_texte(integer) IS 'obtenir les informations d''un fichier texte.';


--
-- TOC entry 140 (class 1255 OID 2596817)
-- Dependencies: 2983 7
-- Name: fchr_get_fichiers(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fchr_get_fichiers() RETURNS SETOF record
    AS $$DECLARE
rec record;
BEGIN

	for rec in
		select * from v2.fichier
	loop
		return next rec;
	end loop;

	return;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_get_fichiers() OWNER TO postgres;

--
-- TOC entry 9101 (class 0 OID 0)
-- Dependencies: 140
-- Name: FUNCTION fchr_get_fichiers(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fchr_get_fichiers() IS 'Obtenirs tous les fichiers de la plate-forme.';


--
-- TOC entry 141 (class 1255 OID 2596818)
-- Dependencies: 2983 7
-- Name: fchr_get_fichiers_type(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fchr_get_fichiers_type(integer) RETURNS SETOF record
    AS $_$--$1 le typo de fichier voulu
DECLARE
rec record;
BEGIN
	
	FOR rec IN
		select * from v2.af_get_fichiers()AS ( id int4, libelle varchar, "type" int4, connecte bool) where "type" = $1
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_get_fichiers_type(integer) OWNER TO postgres;

--
-- TOC entry 9102 (class 0 OID 0)
-- Dependencies: 141
-- Name: FUNCTION fchr_get_fichiers_type(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fchr_get_fichiers_type(integer) IS 'Obtenir tous les fichiers d''un type particulier.
';


--
-- TOC entry 142 (class 1255 OID 2596819)
-- Dependencies: 2983 7
-- Name: fchr_maj_fichier(integer, character varying, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fchr_maj_fichier(integer, character varying, integer, boolean) RETURNS boolean
    AS $_$DECLARE

BEGIN
	
	UPDATE v2.fichier SET libelle=$2, "type"=$3, connecte=$4 WHERE id=$1;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_maj_fichier(integer, character varying, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 9103 (class 0 OID 0)
-- Dependencies: 142
-- Name: FUNCTION fchr_maj_fichier(integer, character varying, integer, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fchr_maj_fichier(integer, character varying, integer, boolean) IS 'Mise a jour d''un fichier.';


--
-- TOC entry 143 (class 1255 OID 2596820)
-- Dependencies: 2983 7
-- Name: fchr_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fchr_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 id du fichier
--$2 libelle du fichier texte
--$3 titre du lien
--$4 adresse du lien
--$5 description
--$6 mise en forme
--$7 connectÃƒÆ’Ã‚Â©
fait boolean;
BEGIN
	
	UPDATE v2.fichier SET libelle=$2, connecte=$7 WHERE id=$1;
	fait:=FOUND;

	UPDATE v2.fichier_texte SET libelle=$3, adresse=$4, description=$5, mise_en_forme=$6, date_modification=now() WHERE id=$1;
	fait:=fait OR FOUND;
		
	RETURN fait;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) OWNER TO pgsql;

--
-- TOC entry 9104 (class 0 OID 0)
-- Dependencies: 143
-- Name: FUNCTION fchr_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fchr_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) IS 'Mise a jour d''un fichier texte.';


--
-- TOC entry 144 (class 1255 OID 2596821)
-- Dependencies: 2983 7
-- Name: fchr_maj_fichiers_connection(integer[], boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fchr_maj_fichiers_connection(integer[], boolean) RETURNS integer
    AS $_$DECLARE
i integer;

BEGIN

	FOR i IN array_lower($1, 1) .. array_upper($1, 1) 
	LOOP
		UPDATE v2.fichier SET connecte=$2 WHERE id=$1[i];
		RAISE NOTICE 'met a jour le fichier % d''indice%',$1[i],i;
	END LOOP; 

	RETURN i;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_maj_fichiers_connection(integer[], boolean) OWNER TO pgsql;

--
-- TOC entry 9105 (class 0 OID 0)
-- Dependencies: 144
-- Name: FUNCTION fchr_maj_fichiers_connection(integer[], boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fchr_maj_fichiers_connection(integer[], boolean) IS 'Mise a jour d''un ensemble de connections de fichiers.';


--
-- TOC entry 145 (class 1255 OID 2596822)
-- Dependencies: 2983 7
-- Name: fchr_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fchr_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle du fichier texte
--$2 titre du lien
--$3 adresse du lien
--$4 description
--$5 mise en forme
--$6 connectÃƒÆ’Ã‚Â©
--$7 theme
--$8 categorie
new_id int4;
BEGIN
	--cree le fichier (table pÃƒÆ’Ã‚Â¨re)
	SELECT INTO new_id * FROM v2.af_set_categorie_fichier_theme($1,$6,$7,$8);

	--cree le fichier texte (table fille)
	INSERT INTO v2.fichier_ressource_texte (id,libelle,adresse,description,mise_en_forme) 
	VALUES (new_id, $2, $3, $4, $5);

	--enregistre dans les themes (ce n'est pas fait par af_set_categorie_fichier_theme car
	--il faut inserer dans fichier_texte avant)
	PERFORM v2.af_set_categorie_element_theme($8, $7,new_id);
	RETURN new_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9106 (class 0 OID 0)
-- Dependencies: 145
-- Name: FUNCTION fchr_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fchr_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) IS 'CrÃƒÂ©e un fichier texte et l''enregistre dans un theme et une categorie';


--
-- TOC entry 146 (class 1255 OID 2596823)
-- Dependencies: 2983 7
-- Name: fchr_set_categorie_fichier_theme(character varying, boolean, integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fchr_set_categorie_fichier_theme(character varying, boolean, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 connecte
--$3 theme
--$4 categorie
type_fic int4;
table_fic varchar;
new_id int4;
new_oid  int4;
req varchar; 
BEGIN
	--RAISE NOTICE 'theme=% categorie=%',$3,$4;
	--selectionne le type du fichier
	SELECT INTO type_fic id  FROM v2.fichier_type
	WHERE categorie=$4;

	--recupere la table de sa categorie
	SELECT INTO table_fic table_cible FROM v2.categorie 
	WHERE id=$4;	

	--enregistre le fichier dans la table principale
	INSERT INTO v2.fichier (libelle, connecte, "type")
	VALUES ($1, $2, type_fic);

	--recupere l'oid et le numero du nouvel enregistrement
	GET DIAGNOSTICS new_oid = RESULT_OID;
	SELECT INTO new_id id FROM v2.fichier WHERE oid=new_oid;

	IF $4!=26 THEN
		--enregistre le fichier dans la table de sa categorie
		req:='INSERT INTO v2.'||table_fic||' (id) VALUES ('||new_id||')';
		--req:='INSERT INTO v2.fichier_'||table_fic||' (id) VALUES ('||new_id||')';
		EXECUTE req;
		RAISE NOTICE 'req=%',req;

		--enregistre dans les themes
		PERFORM v2.af_set_categorie_element_theme($4, $3,new_id);
	END IF;



	RETURN new_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_set_categorie_fichier_theme(character varying, boolean, integer, integer) OWNER TO postgres;

--
-- TOC entry 9107 (class 0 OID 0)
-- Dependencies: 146
-- Name: FUNCTION fchr_set_categorie_fichier_theme(character varying, boolean, integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fchr_set_categorie_fichier_theme(character varying, boolean, integer, integer) IS 'CrÃƒÂ©e un fichier 
 et l''enregistre dans un theme et une categorie';


--
-- TOC entry 147 (class 1255 OID 2596824)
-- Dependencies: 2983 7
-- Name: fchr_set_fichier(character varying, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fchr_set_fichier(character varying, integer, boolean) RETURNS integer
    AS $_$DECLARE
--$1 libelle du fichier
--$2 type
--$3 connecte
new_oid oid;
new_id integer;
BEGIN
	--enregistre le fichier dans la table principale
	INSERT INTO v2.fichier (libelle,type,connecte)
	VALUES ($1, $2, $3);

	--recupere l'oid et le numero du nouvel enregistrement
	GET DIAGNOSTICS new_oid = RESULT_OID;
	SELECT INTO new_id id FROM v2.fichier WHERE oid=new_oid;

	RETURN new_id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_set_fichier(character varying, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 148 (class 1255 OID 2596825)
-- Dependencies: 2983 7
-- Name: fchr_set_fichier_icone(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fchr_set_fichier_icone(character varying) RETURNS integer
    AS $_$-- $1 : libelle fichier
declare
new_id integer;
begin
    -- enregistre dans la table principale (fichier)
    select into new_id * from v2.af_set_fichier($1,6,false);
    -- enregistre dans la table fichier_icone
    insert into v2.fichier_icone(id) values(new_id);
    return new_id;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fchr_set_fichier_icone(character varying) OWNER TO pgsql;

--
-- TOC entry 9108 (class 0 OID 0)
-- Dependencies: 148
-- Name: FUNCTION fchr_set_fichier_icone(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fchr_set_fichier_icone(character varying) IS 'Enregistre un fichier icone';


--
-- TOC entry 149 (class 1255 OID 2596826)
-- Dependencies: 2983 7
-- Name: flr_get_filiere_etapes_disponibles_theme(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_get_filiere_etapes_disponibles_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
--$2 theme
rec RECORD;
sous_type v2.type_element;
rec_spe RECORD;
rec_ss_parcours RECORD;
BEGIN
	FOR rec IN 
		SELECT I_D AS id,  E.libelle AS libelle,CAST(E.type AS varchar) AS type, T.libelle  AS libelle_type
		FROM v2.etape E 
		LEFT OUTER JOIN v2.af_get_categorie_elements_theme(29 ,$2) I_D
		ON E.id=I_D,v2.etape_type T
		WHERE I_D IS NOT NULL
		AND E.type=T.id
		ORDER BY E.type

	LOOP
		--Cas speciaux: les types ayant des sous types
		SELECT INTO sous_type * FROM v2.af_get_etape_type_sous_type(rec.id, CAST(rec.type AS int4), rec.libelle_type)
		ORDER BY sous_type.id;
		rec.type:=sous_type.id;
		rec.libelle_type:=sous_type.libelle;
		RETURN NEXT rec;
	END LOOP;

	----------------------------------
	--      ETAPES SANS THEMES      --
	----------------------------------

	--les types d'ÃƒÂ©tapes spÃƒÂ©ciales: forum (2), chat(8) et etape titre(9)
	FOR rec_spe IN 
		SELECT CAST(NULL AS int4) AS id,  CAST(NULL AS varchar) AS  libelle, CAST(id AS varchar) AS type, libelle  AS libelle_type
		FROM v2.etape_type T
		WHERE id IN (8,9)
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	--les types d'ÃƒÂ©tapes forum (2)
	
	FOR rec_spe IN 
		SELECT P_id,  P_libelle_etape, cast('2' as varchar), T.libelle  AS libelle_type
		FROM v2.etape_type T,v2.af_get_etapes_forum() as
		(P_id int4,P_libelle_etape varchar,forum int4,libelle varchar,description varchar,moderation bool,moderateur_pwd varchar,fils int4,messages int4,upload bool,theme varchar,configuration int4,date_creation timestamp)
 
		WHERE T.id=2 
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	-- type chat(8)

	FOR rec_spe IN 
		SELECT P_id,  P_libelle_etape, cast('8' as varchar), T.libelle  AS libelle_type
		FROM v2.etape_type T,v2.af_get_etapes_chats() as
		(P_id int4,P_libelle_etape varchar,chat int4,date_creation timestamp)
 
		WHERE T.id=8 
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;
	

	FOR rec_ss_parcours IN 
		SELECT P_id,  P_libelle, CAST('1'AS varchar) AS type, libelle  AS libelle_type
		FROM v2.af_get_filiere_sous_parcourss_disponibles($1) AS (P_id int4, P_libelle varchar, filiere int4, duree bool),
		v2.etape_type T
		WHERE 1=T.id
	LOOP
		RETURN NEXT rec_ss_parcours;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_get_filiere_etapes_disponibles_theme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 150 (class 1255 OID 2596827)
-- Dependencies: 2983 7
-- Name: flr_get_filiere_formations(integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_get_filiere_formations(integer, character varying, boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
--$2 ASC(ou n'importe quoi) ou DESC pour le classement du resultat
--$3 TRUE, classement par date de dÃƒÂ©but, ou FALSE classement par libelle
req varchar;
rec record;
BEGIN
	req:='SELECT F.id, F.libelle, F.parcours, F.date_debut, F.date_fin, F.langue, P.filiere FROM v2.formation F , v2.parcours P
		WHERE P.filiere='||$1||' AND F.parcours=P.id ';

	IF $3 IS TRUE THEN
		req:=req||' ORDER BY F.date_debut';
	ELSE 
		req:=req||' ORDER BY F.libelle';
	END IF;

	IF $2 LIKE 'DESC' THEN
		req:=req||' DESC';
	END IF;
	FOR rec IN
	    EXECUTE req
	LOOP
	    RETURN next rec;
	END LOOP;

		
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_get_filiere_formations(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 151 (class 1255 OID 2596828)
-- Dependencies: 2983 7
-- Name: flr_get_filiere_libelle_complet(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_get_filiere_libelle_complet(integer) RETURNS character varying
    AS $_$DECLARE
--$1 filiere
rec_pere RECORD;
libelle_complet varchar;
libelle_part varchar;
BEGIN
	IF $1 IS NULL THEN
		RETURN NULL;
	ELSE
		--selectionne le libelle et le pere de la filiere
		SELECT INTO rec_pere libelle, pere FROM v2.filiere
		WHERE id=$1;
		
		--recupere le libelle complet du pere
		SELECT INTO libelle_part * FROM v2.af_get_filiere_libelle_complet(rec_pere.pere);
	
		--ajoute le libellÃƒÂ© complet du pÃƒÂªre Ãƒ  la filiere pour former le libellÃƒÂ© complet de la filiere
		IF libelle_part IS NOT NULL THEN			
			libelle_complet:=libelle_part||'/'||rec_pere.libelle;
		ELSE
			libelle_complet:=rec_pere.libelle;
		END IF;

		RETURN libelle_complet;
	END IF;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_get_filiere_libelle_complet(integer) OWNER TO pgsql;

--
-- TOC entry 152 (class 1255 OID 2596829)
-- Dependencies: 2983 7
-- Name: flr_get_filiere_parcourss(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_get_filiere_parcourss(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT E.id, E.libelle, P.filiere, P.duree FROM v2.parcours P, v2.etape E 
		WHERE P.id=E.id
		AND P.filiere=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;
		
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_get_filiere_parcourss(integer) OWNER TO pgsql;

--
-- TOC entry 153 (class 1255 OID 2596830)
-- Dependencies: 2983 7
-- Name: flr_get_filiere_pere(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION flr_get_filiere_pere(integer) RETURNS SETOF record
    AS $_$declare
	id_pere alias for $1;
	req text;
	rec record;
begin
	req:='select * from v2.filiere where pere ';
	if (id_pere is null) then
		req:=req||' is null';
	else
		req:=req||'='||id_pere;
	end if;
	for rec in
		execute req
		loop
			return next rec;
		end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_get_filiere_pere(integer) OWNER TO postgres;

--
-- TOC entry 9109 (class 0 OID 0)
-- Dependencies: 153
-- Name: FUNCTION flr_get_filiere_pere(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION flr_get_filiere_pere(integer) IS 'Renvoie les filiÃƒÆ’Ã‚Â¨res associÃƒÆ’Ã‚Â©es ÃƒÆ’Ã‚  un pÃƒÆ’Ã‚Â¨re.';


--
-- TOC entry 154 (class 1255 OID 2596831)
-- Dependencies: 2983 7
-- Name: flr_get_filiere_sous_filieres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_get_filiere_sous_filieres(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
rec RECORD;
BEGIN

	IF $1 IS NOT NULL THEN
		FOR rec IN
			SELECT id, libelle, pere FROM v2.filiere
			WHERE pere=$1 ORDER BY libelle
		LOOP
			RETURN NEXT rec;
		END LOOP;
	ELSE
		FOR rec IN
			SELECT id, libelle, pere FROM v2.filiere
			WHERE pere IS NULL ORDER BY libelle
		LOOP
			RETURN NEXT rec;
		END LOOP;
	END IF;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_get_filiere_sous_filieres(integer) OWNER TO pgsql;

--
-- TOC entry 155 (class 1255 OID 2596832)
-- Dependencies: 2983 7
-- Name: flr_get_filieres(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_get_filieres() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT F.id, F.libelle, F.pere, F_ID.ind FROM v2.filiere F,
		v2.af_gen_get_elements('v2.filiere', 'id', NULL, ' ', 0) F_ID
		WHERE F.id=F_ID.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_get_filieres() OWNER TO pgsql;

--
-- TOC entry 156 (class 1255 OID 2596833)
-- Dependencies: 2983 7
-- Name: flr_get_filieres_formation(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_get_filieres_formation() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct fi.id,fi.libelle,fi.pere 
	from v2.filiere fi,v2.formation fo,v2.parcours p
	where fi.id=p.filiere and p.id=fo.parcours

    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_get_filieres_formation() OWNER TO pgsql;

--
-- TOC entry 9110 (class 0 OID 0)
-- Dependencies: 156
-- Name: FUNCTION flr_get_filieres_formation(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION flr_get_filieres_formation() IS 'retourne les filieres des formation de la plateforme';


--
-- TOC entry 157 (class 1255 OID 2596834)
-- Dependencies: 2983 7
-- Name: flr_get_filieres_parcours(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_get_filieres_parcours(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 idendifiant de la filiere de depart 

--Il doit etre Ãƒ  NULL pour obtenir toutes les filieres et sous filieres ayant des parcours,
--dans l'ordre (une filiere et ses sous filieres, puis une autre filiere et ses sous filieres, etc...
rec RECORD;
rec1 RECORD;
BEGIN
	FOR rec IN
		--on recupere toutes les filieres principales
		SELECT id, libelle, pere 
		FROM v2.af_get_filiere_sous_filieres($1) AS (id int4, libelle varchar, pere int4)
		ORDER BY libelle
		
	LOOP
		--si la filiere principale a des parcours, on la retourne
		PERFORM P_filiere
		FROM v2.af_get_parcours() AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool,date_creation timestamp)
		WHERE P_filiere=rec.id ;
		
		IF TRUE THEN
			RETURN NEXT rec;
		END IF;

		FOR rec1 IN
			SELECT * FROM v2.af_get_filieres_parcours(rec.id) AS (id int4, libelle varchar, pere int4)
		LOOP
			RETURN NEXT rec1;
		END LOOP;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_get_filieres_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 9111 (class 0 OID 0)
-- Dependencies: 157
-- Name: FUNCTION flr_get_filieres_parcours(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION flr_get_filieres_parcours(integer) IS 'Obtenir les filieres ayant des parcours.
$1 doit etre Ãƒ  NULL pour obtenir toutes les filieres et sous filieres ayant des parcours, dans l''ordre (une filiere et ses sous filieres, puis une autre filiere et ses sous filieres, etc...';


--
-- TOC entry 158 (class 1255 OID 2596835)
-- Dependencies: 2983 7
-- Name: flr_is_filiere_libelle_ok(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_is_filiere_libelle_ok(integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 filiere 
--$2 libelle
ok bool;
BEGIN
	IF $2 LIKE '%/%' THEN 
		--RAISE NOTICE 'CaractÃƒÂ¨re ''/'' interdit dans le libellÃƒÂ© d''une filiÃƒÂ¨re ';
		RETURN FALSE; 
	END IF;
	RAISE NOTICE 'ici';
	IF $1 IS NOT NULL THEN
		PERFORM * FROM v2.filiere
		WHERE pere=$1 
		AND libelle LIKE $2;
	ELSE
		PERFORM * FROM v2.filiere
		WHERE pere IS NULL
		AND libelle LIKE $2;
	END IF;
	RETURN NOT FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_is_filiere_libelle_ok(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 159 (class 1255 OID 2596836)
-- Dependencies: 2983 7
-- Name: flr_maj_filiere(integer, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_maj_filiere(integer, character varying, integer) RETURNS boolean
    AS $_$DECLARE
--$1 filiere
--$2 libelle
--$3 pere
BEGIN
	UPDATE v2.filiere SET libelle=$2, pere=$3
	WHERE id=$1;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_maj_filiere(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 160 (class 1255 OID 2596837)
-- Dependencies: 2983 7
-- Name: flr_set_filiere(character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION flr_set_filiere(character varying, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 pere
new_id int4;
new_oid int4;
BEGIN
	INSERT INTO v2.filiere (libelle, pere) VALUES ($1,$2);
	GET DIAGNOSTICS new_oid = RESULT_OID;
	SELECT INTO new_id id FROM v2.filiere WHERE oid=new_oid;
	RETURN new_id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.flr_set_filiere(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 161 (class 1255 OID 2596838)
-- Dependencies: 2983 7
-- Name: frm_del_formation_forum(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_del_formation_forum(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : forum
begin
    delete from v2.formation_forums where formation=$1 and forum=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_del_formation_forum(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9112 (class 0 OID 0)
-- Dependencies: 161
-- Name: FUNCTION frm_del_formation_forum(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_del_formation_forum(integer, integer) IS 'Supprime une association formation / forum';


--
-- TOC entry 162 (class 1255 OID 2596839)
-- Dependencies: 2983 7
-- Name: frm_del_formation_langue(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_del_formation_langue(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : nÃ‚Â° langue
begin
    delete from v2.formation_langues where formation=$1 and langue=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_del_formation_langue(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9113 (class 0 OID 0)
-- Dependencies: 162
-- Name: FUNCTION frm_del_formation_langue(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_del_formation_langue(integer, integer) IS 'Supprime une langue dispo d''une formation';


--
-- TOC entry 163 (class 1255 OID 2596840)
-- Dependencies: 2983 7
-- Name: frm_get_classes_formation(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_classes_formation() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct c.id,c.libelle,c.pere 
	from v2.classe c,v2.formation_participants fp
	where c.id=fp.classe
    loop
	return next rec;
    end loop;
	
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_classes_formation() OWNER TO pgsql;

--
-- TOC entry 9114 (class 0 OID 0)
-- Dependencies: 163
-- Name: FUNCTION frm_get_classes_formation(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_classes_formation() IS 'retourne les classes des fromations de la plateforme';


--
-- TOC entry 164 (class 1255 OID 2596841)
-- Dependencies: 2983 7
-- Name: frm_get_etape_forum(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_etape_forum(integer) RETURNS record
    AS $_$-- $1 : etape
declare
rec record;
begin
    select into rec * from v2.af_get_etapes_forum() 
    as (id int4,libelle_etape varchar,forum int4,libelle varchar,description varchar,moderation bool,moderateur_pwd varchar,fils int4,messages int4,upload bool,theme varchar,configuration int4,date_creation timestamp)
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_etape_forum(integer) OWNER TO pgsql;

--
-- TOC entry 9115 (class 0 OID 0)
-- Dependencies: 164
-- Name: FUNCTION frm_get_etape_forum(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_etape_forum(integer) IS 'retourne les donnÃƒÂ©es d''une etape forum';


--
-- TOC entry 165 (class 1255 OID 2596842)
-- Dependencies: 2983 7
-- Name: frm_get_etapes_forum(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_etapes_forum() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select ef.id,e.libelle,f.id,f.libelle,f.description,f.moderation,f.moderateur_pwd,f.fils,f.messages,f.upload,f.theme,fe.environnement,date_creation 
	from v2.etape e , v2.etape_forum ef  left outer join v2.forum f on (f.id=ef.forum)
	left outer join v2.forum_environnements fe ON (fe.forum=f.id) 
	where e.id=ef.id
	
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_etapes_forum() OWNER TO pgsql;

--
-- TOC entry 9116 (class 0 OID 0)
-- Dependencies: 165
-- Name: FUNCTION frm_get_etapes_forum(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_etapes_forum() IS 'retourne les etapes forum de la plateforme';


--
-- TOC entry 166 (class 1255 OID 2596843)
-- Dependencies: 2983 7
-- Name: frm_get_formation_forums(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_formation_forums(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in 
	select id,libelle,description,moderation,moderateur_pwd,fils,messages,upload,theme from v2.forum,v2.formation_forums 
	where id=forum and formation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_formation_forums(integer) OWNER TO pgsql;

--
-- TOC entry 9117 (class 0 OID 0)
-- Dependencies: 166
-- Name: FUNCTION frm_get_formation_forums(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_formation_forums(integer) IS 'retourne les forums d''une formation';


--
-- TOC entry 167 (class 1255 OID 2596844)
-- Dependencies: 2983 7
-- Name: frm_get_formation_forums_disponibles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_formation_forums_disponibles(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in 
	select id,libelle from v2.forum 
	where id not in (select forum from v2.formation_forums where formation=$1)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_formation_forums_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 9118 (class 0 OID 0)
-- Dependencies: 167
-- Name: FUNCTION frm_get_formation_forums_disponibles(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_formation_forums_disponibles(integer) IS 'retourne les forums dispo pour une formation';


--
-- TOC entry 168 (class 1255 OID 2596845)
-- Dependencies: 2983 7
-- Name: frm_get_formations_forums(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_formations_forums() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select fi.id,fi.libelle,fu.id,fu.libelle 
	from v2.formation fi,v2.forum fu,v2.formation_forums 
	where fi.id=formation and fu.id=forum
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_formations_forums() OWNER TO pgsql;

--
-- TOC entry 9119 (class 0 OID 0)
-- Dependencies: 168
-- Name: FUNCTION frm_get_formations_forums(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_formations_forums() IS 'retourne les associations formations/forums de la plateforme';


--
-- TOC entry 169 (class 1255 OID 2596846)
-- Dependencies: 2983 7
-- Name: frm_get_forum(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_forum(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec * from v2.forum where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_forum(integer) OWNER TO pgsql;

--
-- TOC entry 9120 (class 0 OID 0)
-- Dependencies: 169
-- Name: FUNCTION frm_get_forum(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_forum(integer) IS 'retourne les donnees d''un forum';


--
-- TOC entry 170 (class 1255 OID 2596847)
-- Dependencies: 2983 7
-- Name: frm_get_forum_environnement(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_forum_environnement(integer) RETURNS record
    AS $_$-- $1 : environnement
declare
rec record;
begin
    select into rec * from v2.af_get_forum_environnements() 
    as (id int4,libelle varchar,chemin varchar,db_type varchar,db_serveur varchar,db_name varchar,db_user varchar,db_pwd varchar,
		admin varchar,admin_pwd varchar,email_valide bool,email_verification bool,interpretation_html bool,citation bool,noms_longs bool,
		taille_pj int4,lignes int4,block_ip bool,compte_vus bool,fils_fermes bool,affiche_fils bool,encodage varchar);
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_forum_environnement(integer) OWNER TO pgsql;

--
-- TOC entry 9121 (class 0 OID 0)
-- Dependencies: 170
-- Name: FUNCTION frm_get_forum_environnement(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_forum_environnement(integer) IS 'retourne les donnÃƒÂ©es d''un environnement de forum';


--
-- TOC entry 171 (class 1255 OID 2596848)
-- Dependencies: 2983 7
-- Name: frm_get_forum_environnements(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_forum_environnements() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select * from v2.forum_environnement
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_forum_environnements() OWNER TO pgsql;

--
-- TOC entry 9122 (class 0 OID 0)
-- Dependencies: 171
-- Name: FUNCTION frm_get_forum_environnements(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_forum_environnements() IS 'retourne les configurations pour les forums';


--
-- TOC entry 172 (class 1255 OID 2596849)
-- Dependencies: 2983 7
-- Name: frm_get_forums(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_forums() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select * from v2.forum
    loop
	return next rec;
    end loop;
	
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_forums() OWNER TO pgsql;

--
-- TOC entry 9123 (class 0 OID 0)
-- Dependencies: 172
-- Name: FUNCTION frm_get_forums(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_forums() IS 'retourne les forrum de la plateforme';


--
-- TOC entry 173 (class 1255 OID 2596850)
-- Dependencies: 2983 7
-- Name: frm_get_parcours_all_formations(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_parcours_all_formations(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
rec record;
rec1 RECORD;
rec2 RECORD;
rec3 RECORD;
rec4 RECORD;
id_pere int4;
parcours_pere integer;
nb_formations int4;
BEGIN
	--raise notice 'parc=%',$1;
    FOR rec1 IN
	--selectionne la formation
	SELECT * FROM v2.af_get_formations() AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4)
	WHERE parcours=$1
    LOOP
	RETURN NEXT rec1;
	
    END LOOP;

    -- boucle sur les peres du parcours
    for rec in
	select pere from v2.af_get_parcours_parcours_pere($1) pere
    loop
	--raise notice 'pere=%',rec.pere;
	for rec2 in
	    SELECT * FROM v2.af_get_parcours_all_formations(rec.pere) AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4)
	loop
	    return next rec2;
	end loop;
    end loop;

    -- boucle sur les parcours orientes ayant le parcours comme sous_parcours

    for rec4 in 
	select distinct parcours from v2.af_get_parcourss_orientes() 
	as(parcours integer,sous_parcours integer) 
	where sous_parcours=$1
    loop
	raise notice 'parcours=%',rec4.parcours;
	for rec3 in
	    SELECT * FROM v2.af_get_parcours_all_formations(rec4.parcours) AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4)
	loop
	    return next rec3;
	end loop;

    end loop;

    
		

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_parcours_all_formations(integer) OWNER TO pgsql;

--
-- TOC entry 9124 (class 0 OID 0)
-- Dependencies: 173
-- Name: FUNCTION frm_get_parcours_all_formations(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_parcours_all_formations(integer) IS 'Obtenir les formations qui utilisent un parcours';


--
-- TOC entry 174 (class 1255 OID 2596851)
-- Dependencies: 2983 7
-- Name: frm_get_parcours_forums_disponibles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_get_parcours_forums_disponibles(integer) RETURNS SETOF record
    AS $_$-- $1 : parcours
declare
rec record;
begin
    for rec in
	select ef_id,ef_libelle_etape from v2.af_get_etapes_forum() 
	as 
	(ef_id int4,ef_libelle_etape varchar,forum int4,libelle varchar,description varchar,moderation bool,moderateur_pwd varchar,fils int4,messages int4,upload bool,theme varchar,configuration int4,date_creation timestamp)
	left outer join v2.af_gen_get_elements('v2.parcours_etapes', 'etape', NULL, 'AND parcours='||$1,1) elt 
	on (elt.id=ef_id) 
	where elt.id is null
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_get_parcours_forums_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 9125 (class 0 OID 0)
-- Dependencies: 174
-- Name: FUNCTION frm_get_parcours_forums_disponibles(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_get_parcours_forums_disponibles(integer) IS 'retourne les etapes forums disponibles pour un parcours';


--
-- TOC entry 175 (class 1255 OID 2596852)
-- Dependencies: 2983 7
-- Name: frm_maj_etape_forum(integer, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_maj_etape_forum(integer, character varying, integer) RETURNS boolean
    AS $_$-- $1 : etape
-- $2 : libelle
-- $3 : forum
declare
ok bool;
begin
    SELECT INTO ok * FROM v2.af_maj_etape_libelle($1, $2);
    update v2.etape_forum set forum=$3 where id=$1;
    return found OR ok;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_maj_etape_forum(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9126 (class 0 OID 0)
-- Dependencies: 175
-- Name: FUNCTION frm_maj_etape_forum(integer, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_maj_etape_forum(integer, character varying, integer) IS 'modifier une etape forum';


--
-- TOC entry 176 (class 1255 OID 2596853)
-- Dependencies: 2983 7
-- Name: frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) RETURNS boolean
    AS $_$-- $1 : forum
-- $2 : libelle forum
-- $3 : description
-- $4 : upload
-- $5 : theme
-- $6 : arbo par page
-- $7 : msg par page
begin
    update v2.forum 
    set libelle=$2,description=$3,fils=$6,messages=$7,upload=$4,theme=$5 
    where id=$1;
    return found;     
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9127 (class 0 OID 0)
-- Dependencies: 176
-- Name: FUNCTION frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) IS 'modifier un forum';


--
-- TOC entry 177 (class 1255 OID 2596854)
-- Dependencies: 2983 7
-- Name: frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : forum
-- $2 : libelle
-- $3 : description
-- $4 : upload
-- $5 : theme
-- $6 : arbo par page
-- $7 : msg par page
-- $8 : configuration
begin
    update v2.forum 
    set libelle=$2,description=$3,upload=$4,theme=$5,fils=$6,messages=$7 
    where id=$1;
    update v2.forum_environnements set environnement=$8 where forum=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9128 (class 0 OID 0)
-- Dependencies: 177
-- Name: FUNCTION frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) IS 'Mettre Ãƒ  jour les donÃƒÂ©es d''un forum';


--
-- TOC entry 178 (class 1255 OID 2596855)
-- Dependencies: 2983 7
-- Name: frm_set_etape_forum(character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_set_etape_forum(character varying, integer) RETURNS integer
    AS $_$-- $1 : libelle
-- $2 : forum
declare
res int4;
new_id oid;
begin
    -- etape
    insert into v2.etape(libelle, type) VALUES ($1, 2);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.etape WHERE oid=new_id;
    -- etape forum
    insert INTO v2.etape_forum(id,forum) VALUES (res,$2);

	RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_set_etape_forum(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9129 (class 0 OID 0)
-- Dependencies: 178
-- Name: FUNCTION frm_set_etape_forum(character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_set_etape_forum(character varying, integer) IS 'Enregistre une etape forum';


--
-- TOC entry 179 (class 1255 OID 2596856)
-- Dependencies: 2983 7
-- Name: frm_set_formation_forum(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_set_formation_forum(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : forum
begin
    insert into v2.formation_forums(formation,forum) 
    values($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_set_formation_forum(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9130 (class 0 OID 0)
-- Dependencies: 179
-- Name: FUNCTION frm_set_formation_forum(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_set_formation_forum(integer, integer) IS 'associer un forum Ãƒ  une formation';


--
-- TOC entry 180 (class 1255 OID 2596857)
-- Dependencies: 2983 7
-- Name: frm_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frm_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) RETURNS integer
    AS $_$-- $1 : libelle forum
-- $2 : description
-- $3 : upload
-- $4 : theme
-- $5 : arbo par page
-- $6 : msg par page
-- $7 : configuration
declare
new_id int4;
res int4;
begin
    insert into v2.forum (libelle,description ,  moderation ,  moderateur_pwd ,fils,messages ,upload ,theme) 
    values($1,$2,false,'',$5,$6,$3,$4);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.forum WHERE oid=new_id;
    -- environnement (configuration)
    insert into v2.forum_environnements(forum,environnement) values(res,$7);
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frm_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9131 (class 0 OID 0)
-- Dependencies: 180
-- Name: FUNCTION frm_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frm_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) IS 'enregistre un forum';


--
-- TOC entry 181 (class 1255 OID 2596858)
-- Dependencies: 2983 7
-- Name: frmt_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmt_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) RETURNS integer[]
    AS $_$-- $1 : numero formation
-- $2 : date
-- $3 : debut
-- $4 : fin
-- $5 : ancien debut
-- $6 : mode ('add' ou 'edit')
-- $7 : copie
declare
rec record;
classe int4;
tab_conflit _int4;
i int4:=0;
begin
    -- Teste sur les heures debut et fin
    if $6='edit' and $7 is null then
	perform * from v2.af_get_evenements_dates($2,$3,$4) 
	as (formation int4,libelle varchar,date timestamp,duree interval,modalite int4,intervention int4,intervenant int4,salle int4)
	where formation=$1 
	and cast(date as time)!=$5;
    else
	perform * from v2.af_get_evenements_dates($2,$3,$4) 
	as (formation int4,libelle varchar,date timestamp,duree interval,modalite int4,intervention int4,intervenant int4,salle int4)
	where formation=$1; 
    end if;
    if found then
	tab_conflit[i]:=1;
	i:=i+1;
    end if;
	
    -- teste si le groupe n'est pas pris Ãƒ  ces heures dans d'autres formations
    -- recup du numero de classe
    select into rec * from v2.af_get_formation_classes($1) as(id int4,libelle varchar, pere int4,min int4,max int4);
    classe=rec.id;
    perform * from v2.af_get_evenements_dates($2,$3,$4) 
    as (ed_formation int4,ed_libelle varchar,ed_date timestamp,ed_duree interval,ed_modalite int4,ed_intervention int4,ed_intervenant int4,ed_salle int4) ,
    v2.formation_participants fp
    where (ed_formation=fp.formation and classe=fp.classe)

    and ed_formation!=$1
    and cast(ed_date as time)!=$5;
	
    if found then
	tab_conflit[i]:=2;
	i:=i+1;
    end if;

    -- teste si la salle est libre

    perform * from v2.af_get_evenements_dates($2,$3,$4) 
    as (ed_formation int4,ed_libelle varchar,ed_date timestamp,ed_duree interval,ed_modalite int4,ed_intervention int4,ed_intervenant int4,ed_salle int4) ,
    v2.af_get_evenements() 
    as (ef_formation int4,ef_libelle varchar,ef_date timestamp,ef_duree interval,ef_modalite int4,ef_intervention int4,ef_intervenant int4,ef_salle int4)
    where ed_salle=ef_salle
    and not (cast(ed_date as time)=$5 and ed_formation=$1); 
    if found then
	tab_conflit[i]:=3;
	i:=i+1;
    end if;

    -- teste si l'intervenant est libre
    perform * from v2.af_get_evenements_dates($2,$3,$4) 
    as (ed_formation int4,ed_libelle varchar,ed_date timestamp,ed_duree interval,ed_modalite int4,ed_intervention int4,ed_intervenant int4,ed_salle int4) ,
    v2.af_get_evenements() 
    as (ef_formation int4,ef_libelle varchar,ef_date timestamp,ef_duree interval,ef_modalite int4,ef_intervention int4,ef_intervenant int4,ef_salle int4)
    where ed_intervenant=ef_intervenant
    and not (cast(ed_date as time)=$5 and ed_formation=$1); 
    if found then
	tab_conflit[i]:=4;
	i:=i+1;
    end if;
    --raise notice '%,%',tab_conflit[0],tab_conflit[1];
    return tab_conflit;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmt_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9132 (class 0 OID 0)
-- Dependencies: 181
-- Name: FUNCTION frmt_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmt_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) IS 'retourne un tableau de conflits pour un evenement de formation';


--
-- TOC entry 182 (class 1255 OID 2596859)
-- Dependencies: 2983 7
-- Name: frmtn_del_filiere(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_del_filiere(integer) RETURNS boolean
    AS $_$DECLARE
--$1 filiere
BEGIN
	DELETE FROM v2.filiere WHERE id=$1;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_del_filiere(integer) OWNER TO pgsql;

--
-- TOC entry 183 (class 1255 OID 2596860)
-- Dependencies: 2983 7
-- Name: frmtn_del_formation_droit(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_del_formation_droit(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero formation
-- $2 : numero droit
begin
    delete from v2.formateur_droits where formation=$1 and droit=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_del_formation_droit(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9133 (class 0 OID 0)
-- Dependencies: 183
-- Name: FUNCTION frmtn_del_formation_droit(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_del_formation_droit(integer, integer) IS 'supprime un droit Ãƒ  une formation';


--
-- TOC entry 184 (class 1255 OID 2596861)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation(integer) RETURNS record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN 
	SELECT INTO rec id, libelle, parcours, date_debut, date_fin, langue  
	FROM v2.formation
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation(integer) OWNER TO pgsql;

--
-- TOC entry 185 (class 1255 OID 2596862)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_alerte(integer, date); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_alerte(integer, date) RETURNS record
    AS $_$-- $1 : numero formation
-- $2 : date (timestamp)
declare
rec record;
begin
    select into rec id,libelle,formation,date,jours,texte 
    from v2.alerte 
    where formation=$1 and date=$2;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_alerte(integer, date) OWNER TO pgsql;

--
-- TOC entry 9134 (class 0 OID 0)
-- Dependencies: 185
-- Name: FUNCTION frmtn_get_formation_alerte(integer, date); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_alerte(integer, date) IS 'retourne l''alerte d''une date de formation';


--
-- TOC entry 186 (class 1255 OID 2596863)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_alertes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_alertes(integer) RETURNS SETOF record
    AS $_$-- $1 : numero formation
declare
rec record;
begin
    for rec in 
	select id,libelle,formation,date,jours,texte 
        from v2.alerte where formation=$1
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_alertes(integer) OWNER TO pgsql;

--
-- TOC entry 9135 (class 0 OID 0)
-- Dependencies: 186
-- Name: FUNCTION frmtn_get_formation_alertes(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_alertes(integer) IS 'retourne les alertes d''une formation';


--
-- TOC entry 187 (class 1255 OID 2596864)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) RETURNS SETOF record
    AS $_$-- $1 : numero formation
-- $2 : debut periode
-- $3 : fin periode
declare
rec record;
begin
    for rec in
	select id,libelle,formation,date,jours,texte
	from v2.alerte
	where formation=$1
	and date between $2 and $3
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9136 (class 0 OID 0)
-- Dependencies: 187
-- Name: FUNCTION frmtn_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) IS 'retourne les alertes d''une formation pour une periode (debut,fin)';


--
-- TOC entry 188 (class 1255 OID 2596865)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_avancement(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_avancement(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
id_parcours int4;
rec RECORD;
rec_p RECORD;
BEGIN
	--on rÃƒÂ©cupÃƒÂ¨re le parcours de la formation
	SELECT INTO id_parcours parcours FROM v2.af_get_formation($1) 
	AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4);
	if id_parcours is null then
		raise exception 'Pas de parcours principal pour la formation';
	end if;

	FOR rec IN
		SELECT F_parcours, F_etape, F_formation, F_stagiaire, F_type FROM v2.af_get_formation_avancement_parcours($1, id_parcours) AS (F_parcours int4, F_etape int4, F_formation int4, F_stagiaire int4, F_type varchar)
	LOOP
		IF rec.F_type=1 THEN
			FOR rec_p IN
				SELECT * FROM v2.af_get_formation_avancement_parcours($1,rec.F_etape) AS (parcours int4, etape int4, formation int4,  stagiaire int4, type varchar)
			LOOP
				RETURN NEXT rec_p;
			END LOOP;
		ELSE
			RETURN NEXT rec;
		END IF;
		
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_avancement(integer) OWNER TO pgsql;

--
-- TOC entry 189 (class 1255 OID 2596866)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_avancement_individu(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_avancement_individu(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu

declare
rec record;
begin
    for rec in
	select * from v2.af_get_formation_avancement($1) 
	as (parcours int4, etape int4, formation int4, stagiaire int4, type varchar)
	where stagiaire=$2 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_avancement_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9137 (class 0 OID 0)
-- Dependencies: 189
-- Name: FUNCTION frmtn_get_formation_avancement_individu(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_avancement_individu(integer, integer) IS 'retourne les etapes rÃƒÂ©alisÃƒÂ©es pour une formation et un individu';


--
-- TOC entry 190 (class 1255 OID 2596867)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_avancement_max(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_avancement_max(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 formation
--$2 individu
id_parcours int4;
rec RECORD;
rec_p RECORD;
BEGIN
	--on rÃƒÂ©cupÃƒÂ¨re le parcours de la formation
	SELECT INTO id_parcours parcours FROM v2.af_get_formation($1) 
	AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4);
	
	RAISE NOTICE 'Parcours principal pour la formation: %', id_parcours;
	IF id_parcours IS NULL THEN
		RAISE EXCEPTION 'Pas de parcours principal pour la formation';
	END IF;

	
	SELECT INTO rec * FROM v2.af_get_formation_avancement_max_parcours($1, id_parcours, $2) AS (parcours int4, etape int4, type int4,formation int4, individu int4, date_debut timestamp);
	
	IF rec.type=1 THEN
	
		SELECT INTO rec_p * FROM v2.af_get_formation_avancement_max_parcours($1,rec.etape, $2) AS (parcours int4, etape int4,type int4, formation int4, individu int4, date_debut timestamp);
			
		RETURN rec_p;
		
	ELSE
		RETURN rec;
	END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_avancement_max(integer, integer) OWNER TO pgsql;

--
-- TOC entry 191 (class 1255 OID 2596868)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_avancement_max_parcours(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_avancement_max_parcours(integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 formation
--$2 parcours
--$3 individu 
rec RECORD; 
BEGIN
	SELECT INTO rec $2, E.id, E.type , $1, $3, R1.date_debut, R1.duree
	FROM v2.etape E,v2.af_gen_get_elements('v2.parcours_etapes', 'etape', NULL, 'AND parcours='||$2,0) elt
	LEFT OUTER JOIN v2.resultat R1 ON (R1.parcours = $2 AND elt.id=R1.etape AND R1.formation=$1 AND R1.stagiaire=$3)
	WHERE E.id=elt.id
	AND elt.ind = 
	 (
		SELECT MIN(elt2.ind) FROM v2.af_gen_get_elements('v2.parcours_etapes', 'etape', NULL, 'AND parcours='||$2,0) elt2
		LEFT OUTER JOIN v2.resultat R2 ON (R2.parcours = $2 AND elt2.id=R2.etape AND R2.formation=$1 AND R2.stagiaire=$3)
		WHERE R2.duree IS NULL
	);

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_avancement_max_parcours(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 192 (class 1255 OID 2596869)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_avancement_parcours(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_avancement_parcours(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
--$2 parcours
rec RECORD;
BEGIN
	

	--on recupere les etapes du parcours
	FOR rec IN
		SELECT * FROM v2.af_get_parcours_avancement($2) 
		AS (parcours int4,etape int4, formation int4, stagiaire int4, type varchar)
		WHERE formation=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_avancement_parcours(integer, integer) OWNER TO pgsql;

--
-- TOC entry 193 (class 1255 OID 2596870)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_avancement_parcours_individu(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_avancement_parcours_individu(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : parcours
declare
rec record;
begin
    for rec in
	select * from v2.af_get_formation_avancement($1) 
	as (parcours int4, etape int4, formation int4, stagiaire int4, type varchar)
	where stagiaire=$2 and parcours=$3 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_avancement_parcours_individu(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9138 (class 0 OID 0)
-- Dependencies: 193
-- Name: FUNCTION frmtn_get_formation_avancement_parcours_individu(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_avancement_parcours_individu(integer, integer, integer) IS 'retourne les etapes rÃƒÂ©alisÃƒÂ©es pour une formation,un parcours et un individu';


--
-- TOC entry 194 (class 1255 OID 2596871)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_classes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_classes(integer) RETURNS record
    AS $_$declare
rec record;
begin
    select into rec id,libelle,pere,min,max 
    from v2.af_get_classes() as(id int4,libelle varchar, pere int4,min int4,max int4) ,
    v2.formation_participants ft 
    where ft.formation=$1 and ft.classe=id;
    return rec; 
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_classes(integer) OWNER TO pgsql;

--
-- TOC entry 9139 (class 0 OID 0)
-- Dependencies: 194
-- Name: FUNCTION frmtn_get_formation_classes(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_classes(integer) IS 'retourne la classe d''une formation';


--
-- TOC entry 195 (class 1255 OID 2596872)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_droits(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_droits(integer) RETURNS SETOF record
    AS $_$-- $1 : numero formation
declare
rec record;
begin
    for rec in
	select d.id,d.libelle from v2.droit d,v2.formateur_droits fd
	where d.id=fd.droit and fd.formation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_droits(integer) OWNER TO pgsql;

--
-- TOC entry 9140 (class 0 OID 0)
-- Dependencies: 195
-- Name: FUNCTION frmtn_get_formation_droits(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_droits(integer) IS 'retourne les droits (du formateur) d''une formation';


--
-- TOC entry 196 (class 1255 OID 2596873)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_espace_ressources(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_espace_ressources(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : espace
declare
rec record;
begin
    for rec in 
	select 
	FR.ressource,R.fichier,FR.espace,E.libelle, FR.section,S.libelle,ET.libelle,FR.formation,FI.type,R.mots_cles, 
	cast(FR.debut_disponibilite as date), cast(FR.fin_disponibilite as date), FR.duree_nouveaute,S.icone
	FROM 
	v2.formation_ressources FR,
	v2.ressource R,
	v2.etape ET,
	v2.etape_ressource ER,
	v2.fichier FI,
	v2.espace E,
	v2.section S
	WHERE 
	FR.formation=$1 and FR.espace=$2 
	and FR.ressource=R.id 
	and FR.espace=E.id 
	and FR.section=S.id 
	and R.fichier=FI.id 
	and ET.id=ER.id and ER.ressource=FR.ressource
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_espace_ressources(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9141 (class 0 OID 0)
-- Dependencies: 196
-- Name: FUNCTION frmtn_get_formation_espace_ressources(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_espace_ressources(integer, integer) IS 'retourne les ressources d''une formation pour un espace';


--
-- TOC entry 197 (class 1255 OID 2596874)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_espace_section_ressources(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_espace_section_ressources(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : espace
-- $3 : section
declare
rec record;
begin
    for rec in
    select 
	FR.ressource,R.fichier,FR.espace,E.libelle, FR.section,S.libelle,ET.libelle,FR.formation,FI.type,R.mots_cles, 
	cast(FR.debut_disponibilite as date), cast(FR.fin_disponibilite as date), FR.duree_nouveaute,S.icone
	FROM 
	v2.formation_ressources FR,
	v2.ressource R,
	v2.etape ET,
	v2.etape_ressource ER,
	v2.fichier FI,
	v2.espace E,
	v2.section S
	WHERE 
	FR.formation=$1 and FR.espace=$2 and FR.section=$3 
	and FR.ressource=R.id 
	and FR.espace=E.id 
	and FR.section=S.id 
	and R.fichier=FI.id 
	and ET.id=ER.id and ER.ressource=FR.ressource
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_espace_section_ressources(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9142 (class 0 OID 0)
-- Dependencies: 197
-- Name: FUNCTION frmtn_get_formation_espace_section_ressources(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_espace_section_ressources(integer, integer, integer) IS 'retourne les ressources pour une formation,un espace et une section';


--
-- TOC entry 198 (class 1255 OID 2596875)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_etapes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_etapes(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
id_parcours int4;
rec RECORD;
rec_p RECORD;
indice integer:=0;
BEGIN
	--on rÃƒÂ©cupÃƒÂ¨re le parcours de la formation
	SELECT INTO id_parcours parcours FROM v2.af_get_formation($1) 
	AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4);
	--raise notice 'parc=%',id_parcours;
	--on recupere les etapes du parcours
	FOR rec IN
		--SELECT * FROM v2.af_get_parcours_etapes_deroulees(id_parcours) AS (id int4, libelle_pour_parcours varchar, libelle_etape  varchar, type int4,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool)
		-- Modif said 17/11/06
		SELECT *,indice AS indic FROM v2.af_get_parcours_etapes_deroulees(id_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
	
	LOOP
		IF rec.type=1 THEN
			FOR rec_p IN
				--SELECT * FROM v2.af_get_parcours_etapes_deroulees(rec.id) AS (id int4, libelle_pour_parcours varchar, libelle_etape  varchar, type int4,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool)
				-- Modif said 17/11/06
				SELECT *,indice AS indic FROM v2.af_get_parcours_etapes_deroulees(rec.id) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
			
			LOOP
				rec_p.indic:=indice;
				RETURN NEXT rec_p;
				indice:=indice+1;
			END LOOP;
		ELSE 
			rec.indic:=indice;
			RETURN NEXT rec;
			indice:=indice+1;
		END IF;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_etapes(integer) OWNER TO pgsql;

--
-- TOC entry 199 (class 1255 OID 2596876)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_etapes_individu(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_etapes_individu(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
--$2 individu
id_parcours int4;
sous_parcours integer;
rec_resultat record;
rec RECORD;
rec_p RECORD;
indice integer:=0;
BEGIN
    --on rÃƒÂ©cupÃƒÂ¨re le parcours de la formation
    SELECT INTO id_parcours parcours FROM v2.af_get_formation($1) 
    AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4);
    raise notice 'parc=%',id_parcours;
    --on recupere les etapes du parcours
    FOR rec IN
	--SELECT * FROM v2.af_get_parcours_etapes_deroulees(id_parcours) AS (id int4, libelle_pour_parcours varchar, libelle_etape  varchar, type int4,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool)
	-- Modif said 17/11/06
	SELECT *,indice AS indic FROM v2.af_get_parcours_etapes_deroulees(id_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
	
	LOOP
	    IF rec.type=1 THEN
		FOR rec_p IN
		    --SELECT * FROM v2.af_get_parcours_etapes_deroulees(rec.id) AS (id int4, libelle_pour_parcours varchar, libelle_etape  varchar, type int4,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool)
		    -- Modif said 17/11/06
		    SELECT *,indice AS indic FROM v2.af_get_parcours_etapes_deroulees_formation_individu($1,$2,rec.id) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
			
		    LOOP
			rec_p.indic:=indice;
			RETURN NEXT rec_p;
			indice:=indice+1;
		    END LOOP;
	    ELSE 
		rec.indic:=indice;
		RETURN NEXT rec;
		indice:=indice+1;
		-- traitement spÃƒÂ©cial (sous parcours issu d'etape "parcours orientÃƒÂ©")
		raise notice 'type=%',rec.type;
		if rec.type=10 then
		    -- test si l'etape a ÃƒÂ©tÃƒÂ© faite
		    select into rec_resultat * from v2.af_get_resultat($1,$2,rec.parcours,rec.id) 
		    as (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
		    if rec_resultat.id is not null then
			raise notice 'rec_resultat.id=%',rec_resultat.id;
		        -- recup sous-parcours 
		        select into sous_parcours * from v2.af_get_resultat_parcours_parcours_oriente(rec_resultat.id);
		        
		        for rec_p in 
			    SELECT *,indice AS indic FROM v2.af_get_parcours_etapes_deroulees_formation_individu($1,$2,sous_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		        loop
			    rec_p.indic:=indice;
			    RETURN NEXT rec_p;
			    indice:=indice+1;
		        end loop;
		    end if;
		end if;--else
		    
		
	    END IF;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_etapes_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9143 (class 0 OID 0)
-- Dependencies: 199
-- Name: FUNCTION frmtn_get_formation_etapes_individu(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_etapes_individu(integer, integer) IS 'deroule les etapes d''une formation pour un individu y compris les etapes de sous-parcours issus d''etape parcours oriente
(suivant les resultats de l''individu)';


--
-- TOC entry 200 (class 1255 OID 2596877)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_etapes_series(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_etapes_series(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select fe_id , libelle_alias , libelle, libelle_type_etape,fe_type,  pere , parcours, obligatoire, chrono , fin,libelle_type_original,modifiable
	from 
	v2.af_get_formation_etapes_type($1,'4_1%') AS (fe_id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, fe_type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool,indice int4)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_etapes_series(integer) OWNER TO pgsql;

--
-- TOC entry 9144 (class 0 OID 0)
-- Dependencies: 200
-- Name: FUNCTION frmtn_get_formation_etapes_series(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_etapes_series(integer) IS 'retourne les series d''une formation';


--
-- TOC entry 201 (class 1255 OID 2596878)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_etapes_type(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_etapes_type(integer, character varying) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : type
declare
rec record;
begin
    for rec in 
	select * from v2.af_get_formation_etapes($1) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool,indice int4)
	where type LIKE $2
    loop 
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_etapes_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9145 (class 0 OID 0)
-- Dependencies: 201
-- Name: FUNCTION frmtn_get_formation_etapes_type(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_etapes_type(integer, character varying) IS 'Retourne les etapes d''un type pour une formation';


--
-- TOC entry 202 (class 1255 OID 2596879)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_evenement(integer, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_evenement(integer, timestamp without time zone) RETURNS record
    AS $_$-- $1 numero formation
-- $2 date (timestamp)
declare
rec record;
begin
    select into rec formation,libelle,date,duree,modalite,intervention,intervenant,salle 
    from v2.evenement where formation=$1 and date=$2;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_evenement(integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9146 (class 0 OID 0)
-- Dependencies: 202
-- Name: FUNCTION frmtn_get_formation_evenement(integer, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_evenement(integer, timestamp without time zone) IS 'retourne un evenement d''une formation';


--
-- TOC entry 203 (class 1255 OID 2596880)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_evenements(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_evenements(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select * from v2.evenement 
	where formation=$1 order by date
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_evenements(integer) OWNER TO pgsql;

--
-- TOC entry 9147 (class 0 OID 0)
-- Dependencies: 203
-- Name: FUNCTION frmtn_get_formation_evenements(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_evenements(integer) IS 'retourne tous les evenements d''une formation';


--
-- TOC entry 204 (class 1255 OID 2596881)
-- Dependencies: 2983 7
-- Name: frmtn_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) RETURNS SETOF record
    AS $_$-- $1 : numero formation
-- $2 : debut
-- $3 : fin
declare
rec record;
req varchar;
begin
    /*	
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle
	from v2.evenement
	where formation=$1
	and date between $2 and $3
    loop
	return next rec;
    end loop;
   */ 

    req:='select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
		from v2.evenement where formation='||$1;
    if $2!=$3 then
	req:=req||' and date between '''||$2||''' and '''||$3||'''';
    else
	req:=req||' and date='''||$2||'''';
    end if;
    --RAISE NOTICE 'req: %',req;
    for rec in
	execute req
    loop
	return next rec;
    end loop;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9148 (class 0 OID 0)
-- Dependencies: 204
-- Name: FUNCTION frmtn_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) IS 'retourne les evenements d''une formation pour une periode donnÃƒÂ©e';


--
-- TOC entry 205 (class 1255 OID 2596882)
-- Dependencies: 2983 7
-- Name: frmtn_get_formations(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formations() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,parcours,date_debut,date_fin,langue from v2.formation
    loop
    return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formations() OWNER TO pgsql;

--
-- TOC entry 9149 (class 0 OID 0)
-- Dependencies: 205
-- Name: FUNCTION frmtn_get_formations(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formations() IS 'retourne toutes les formations de la plateforme';


--
-- TOC entry 206 (class 1255 OID 2596883)
-- Dependencies: 2983 7
-- Name: frmtn_get_formations(character varying, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formations(character varying, character varying, integer) RETURNS SETOF record
    AS $_$-- $1 ordre de classement ('asc' ou 'desc')
-- $2 'libelle' ou 'date_debut' (order by)
-- $3 pÃƒÂ©riode (1 : passÃƒÂ©es, 2 : prÃƒÂ©sentes, 3 : futures, 0 toutes)
declare
rec record;
req varchar;
condition_periode varchar;
begin
    -- traitement periode
    if $3=1 then
	condition_periode:='  date_fin<current_date ';
    else
	if $3=2 then
	    condition_periode:='  not(date_debut>current_date or date_fin<current_date) ';
	else
	    if $3=3 then
		condition_periode:='  date_debut>current_date ';
	    end if;
	end if;
    end if;
    req:='select id,libelle,parcours,date_debut,date_fin,langue from v2.af_get_formations() as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4)';
    if $3 !=0 then
	req:=req || 'where '||condition_periode;
    end if;
    req:=req || 'order by '||$2||' '||$1;
    raise notice 'req=%',req;
    for rec in 
	execute req
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formations(character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9150 (class 0 OID 0)
-- Dependencies: 206
-- Name: FUNCTION frmtn_get_formations(character varying, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_formations(character varying, character varying, integer) IS 'retourne les formations (avec critÃƒÂ¨res de classement)';


--
-- TOC entry 207 (class 1255 OID 2596884)
-- Dependencies: 2983 7
-- Name: frmtn_get_formations_dates_bornes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_formations_dates_bornes() RETURNS record
    AS $$DECLARE
rec RECORD;

BEGIN
	SELECT INTO rec MIN(F1.date_debut) AS premier, MAX(F2.date_fin) AS dernier
	FROM v2.formation F1, v2.formation F2;

	RETURN rec;
 
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_formations_dates_bornes() OWNER TO pgsql;

--
-- TOC entry 208 (class 1255 OID 2596885)
-- Dependencies: 2983 7
-- Name: frmtn_get_individu_formations(integer, character varying, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_individu_formations(integer, character varying, character varying, integer) RETURNS SETOF record
    AS $_$-- $1 : numero user
-- $2 : ordre pour classement ('asc' ou 'desc')
-- $3 'date_debut' ou 'libelle' (orderby)
-- $4 periode (1 : passÃƒÂ©es, 2 : prÃƒÂ©sentes, 3 : futures, 0 : toutes)
declare
rec record;
begin
    for rec in 
	select id,libelle,parcours,date_debut,date_fin,langue,ci.individu 
	from v2.af_get_formations($2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4),
	v2.formation_participants fp,v2.classe_individus ci 
	where fp.classe=ci.classe and fp.formation=id and ci.individu=$1 
    loop
	return next rec;
    end loop;
    return;   
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_individu_formations(integer, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9151 (class 0 OID 0)
-- Dependencies: 208
-- Name: FUNCTION frmtn_get_individu_formations(integer, character varying, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_individu_formations(integer, character varying, character varying, integer) IS 'retourne les formations d''un individu';


--
-- TOC entry 209 (class 1255 OID 2596886)
-- Dependencies: 2983 7
-- Name: frmtn_get_parcours_formations(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_parcours_formations(integer) RETURNS SETOF record
    AS $_$-- $1 : parcours
declare
rec record;
begin
    for rec in
	SELECT * FROM v2.af_get_formations() AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4)
	WHERE parcours=$1
    loop
	return next rec;
    end loop;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_parcours_formations(integer) OWNER TO pgsql;

--
-- TOC entry 9152 (class 0 OID 0)
-- Dependencies: 209
-- Name: FUNCTION frmtn_get_parcours_formations(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_parcours_formations(integer) IS 'retourne les formations dont le parcours est principal';


--
-- TOC entry 210 (class 1255 OID 2596887)
-- Dependencies: 2983 7
-- Name: frmtn_get_stagiaires_formation(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_get_stagiaires_formation() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct i.id,i.nom,i.prenom
	from v2.individu i,v2.classe_individus ci,v2.formation_participants fp
	where i.id=ci.individu and ci.classe=fp.classe
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_get_stagiaires_formation() OWNER TO pgsql;

--
-- TOC entry 9153 (class 0 OID 0)
-- Dependencies: 210
-- Name: FUNCTION frmtn_get_stagiaires_formation(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_get_stagiaires_formation() IS 'retourne les stagiaires des formation de la plateforme';


--
-- TOC entry 211 (class 1255 OID 2596888)
-- Dependencies: 2983 7
-- Name: frmtn_is_resultat_formation_parcours_etape(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_is_resultat_formation_parcours_etape(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : etape
declare


begin
    perform * from v2.resultat where formation=$1 and parcours=$2 and etape=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_is_resultat_formation_parcours_etape(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9154 (class 0 OID 0)
-- Dependencies: 211
-- Name: FUNCTION frmtn_is_resultat_formation_parcours_etape(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_is_resultat_formation_parcours_etape(integer, integer, integer) IS 'test si resultat pour une etape,un parcours et une formation';


--
-- TOC entry 212 (class 1255 OID 2596889)
-- Dependencies: 2983 7
-- Name: frmtn_maj_formation(integer, character varying, date, date, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_maj_formation(integer, character varying, date, date, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : libelle
-- $3 : debut
-- $4 : fin
-- $5 : langue defaut
begin
    update v2.formation set libelle=$2,date_debut=$3,date_fin=$4,langue=$5 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_maj_formation(integer, character varying, date, date, integer) OWNER TO pgsql;

--
-- TOC entry 9155 (class 0 OID 0)
-- Dependencies: 212
-- Name: FUNCTION frmtn_maj_formation(integer, character varying, date, date, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_maj_formation(integer, character varying, date, date, integer) IS 'met Ãƒ  jour une formation';


--
-- TOC entry 213 (class 1255 OID 2596890)
-- Dependencies: 2983 7
-- Name: frmtn_maj_formation_dates(integer, date, date); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_maj_formation_dates(integer, date, date) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date debut
-- $3 : date fin
begin
    update v2.formation set
	date_debut=$2,
	date_fin=$3
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_maj_formation_dates(integer, date, date) OWNER TO pgsql;

--
-- TOC entry 9156 (class 0 OID 0)
-- Dependencies: 213
-- Name: FUNCTION frmtn_maj_formation_dates(integer, date, date); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_maj_formation_dates(integer, date, date) IS 'Mettre Ãƒ  jour les dates d''une formation';


--
-- TOC entry 214 (class 1255 OID 2596891)
-- Dependencies: 2983 7
-- Name: frmtn_maj_formation_langues(integer, integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_maj_formation_langues(integer, integer[], integer[]) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : tableau des langue Ãƒ  inserer
-- $3 : tableau des langues Ãƒ  supprimer
declare
i int4;
ok1 bool;
begin
    --LANGUES Ãƒ  ajouter
    if array_upper($2,1)>0 then
    FOR i IN array_lower($2, 1) .. array_upper($2, 1) 
    LOOP
	SELECT INTO ok1 *  FROM v2.af_set_formation_langue($1,$2[i]);
	IF NOT ok1 THEN
	    RAISE EXCEPTION 'Les langues n''ont pu etre ajoutÃƒÂ© .';
	END IF;
    END LOOP;
    end if;
 
    --LANGUES Ãƒ  supprimer
    if array_upper($3,1)>0 then
    FOR i IN array_lower($3, 1) .. array_upper($3, 1) 
    LOOP
	SELECT INTO ok1 *  FROM v2.af_del_formation_langue($1,$3[i]);
	IF NOT ok1 THEN
	    RAISE EXCEPTION 'Les langues n''ont pu etre supprimee.';
	END IF;
    END LOOP;
    end if;
    return ok1;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_maj_formation_langues(integer, integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 9157 (class 0 OID 0)
-- Dependencies: 214
-- Name: FUNCTION frmtn_maj_formation_langues(integer, integer[], integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_maj_formation_langues(integer, integer[], integer[]) IS 'met Ãƒ  jour les langues disponibles de la formation';


--
-- TOC entry 215 (class 1255 OID 2596892)
-- Dependencies: 2983 7
-- Name: frmtn_maj_formation_libelle(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_maj_formation_libelle(integer, character varying) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : titre
begin
    update v2.formation set libelle=$2 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_maj_formation_libelle(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9158 (class 0 OID 0)
-- Dependencies: 215
-- Name: FUNCTION frmtn_maj_formation_libelle(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_maj_formation_libelle(integer, character varying) IS 'mettre Ãƒ  jour le nom d''une formation';


--
-- TOC entry 216 (class 1255 OID 2596893)
-- Dependencies: 2983 7
-- Name: frmtn_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, integer, text, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, integer, text, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : ressource
-- $3 : ancien espace
-- $4 : ancienne section
-- $5 : libelle ressource
-- $6 : debut
-- $7 : fin
-- $8 : duree nouveaute
-- $9 : mots cles
-- $10 : espace
-- $11 : section
declare
etape int4;
ok bool;
ok2 bool;
begin
    -- recup nÃ‚Â° etape
    select into etape id from v2.etape_ressource where ressource=$2;
    -- maj libelle etape
    select into ok * from v2.af_maj_etape_libelle(etape,$5);
    -- maj table formation_ressource
    update v2.formation_ressources set 
    debut_disponibilite=$6,fin_disponibilite=$7,duree_nouveaute=$8,espace=$10,section=$11 
    where formation=$1 and ressource=$2 and espace=$3 and section=$4;
    ok2:=found;	
    -- maj table ressource (mot cles)
    update v2.ressource set mots_cles=$9 where id=$2;
    return found or ok or ok2;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, integer, text, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9159 (class 0 OID 0)
-- Dependencies: 216
-- Name: FUNCTION frmtn_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, integer, text, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, integer, text, integer, integer) IS 'modifie une ressource de formation';


--
-- TOC entry 217 (class 1255 OID 2596894)
-- Dependencies: 2983 7
-- Name: frmtn_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle de la formation
--$2 date de debut
--$3 date de fin
--$4 classe virtuelle
--$5 formateur
--$6 parcours
--$7 langue par defaut
--$8 langues disponibles en front office
new_id int4;
res int4;
i int4;
ok1 bool;
ok2 bool;
BEGIN
	--CREATION DE LA FORMATION
	INSERT INTO v2.formation(libelle, parcours, date_debut, date_fin, langue)
	VALUES($1, $6, $2, $3, $7);
	--recupere l'identifiant
	GET DIAGNOSTICS new_id = RESULT_OID;
	SELECT INTO res id FROM v2.formation WHERE oid=new_id;
	
	--ASSOCIATION DU GROUPE ET DU FORMATEUR
	SELECT INTO ok1 * FROM v2.af_set_formation_participants(res, $5, $4);
	IF NOT ok1 THEN
		RAISE EXCEPTION 'Les participants n''ont pu etre ajoutÃƒÂ© lors de la crÃƒÂ©ation de la formation.';
	END IF;

	--LANGUES DE LA FORMATION EN FRONT OFFICE
	FOR i IN array_lower($8, 1) .. array_upper($8, 1) 
	LOOP
		SELECT INTO ok2 *  FROM v2.af_set_formation_langue(res,$8[i]);
		IF NOT ok2 THEN
			RAISE EXCEPTION 'Les langues n''ont pu etre ajoutÃƒÂ© lors de la crÃƒÂ©ation de la formation.';
		END IF;
	END LOOP; 

	return res;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 218 (class 1255 OID 2596895)
-- Dependencies: 2983 7
-- Name: frmtn_set_formation_droit(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_set_formation_droit(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero formation
-- $2 : numero droit
begin
    insert into v2.formateur_droits(formation,droit) values($1,$2);
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_set_formation_droit(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9160 (class 0 OID 0)
-- Dependencies: 218
-- Name: FUNCTION frmtn_set_formation_droit(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_set_formation_droit(integer, integer) IS 'ajoute un droit Ãƒ  une formation';


--
-- TOC entry 219 (class 1255 OID 2596896)
-- Dependencies: 2983 7
-- Name: frmtn_set_formation_langue(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_set_formation_langue(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 formation
--$2 langue
BEGIN
	INSERT INTO v2.formation_langues
	(formation, langue) VALUES
	($1, $2);

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_set_formation_langue(integer, integer) OWNER TO pgsql;

--
-- TOC entry 220 (class 1255 OID 2596897)
-- Dependencies: 2983 7
-- Name: frmtn_set_formation_participants(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_set_formation_participants(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 formation
--$2 formateur
--$3 classe
BEGIN
	INSERT INTO v2.formation_participants
	(formation, formateur, classe) VALUES
	($1, $2, $3);

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_set_formation_participants(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 221 (class 1255 OID 2596898)
-- Dependencies: 2983 7
-- Name: frmtn_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION frmtn_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : ressource
-- $3 : debut
-- $4 : fin
-- $5 : duree
-- $6 : espace
-- $7 : section
declare

begin
    -- test existence (formation,ressource,espace,section)
    perform * from v2.formation_ressources where formation=$1 and ressource=$2 and espace=$6 and section=$7;
    if found then
	update v2.formation_ressources 
	set debut=$3,fin=$4,duree=$5 
	where formation=$1 and ressource=$2 and espace=$6 and section=$7;
    else
	insert into v2.formation_ressources(formation,ressource,debut_disponibilite,fin_disponibilite,duree_nouveaute,espace,section) 
	values($1,$2,$3,$4,$5,$6,$7);
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.frmtn_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9161 (class 0 OID 0)
-- Dependencies: 221
-- Name: FUNCTION frmtn_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION frmtn_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, integer, integer, integer) IS 'associe une ressource Ãƒ  une formation';


--
-- TOC entry 222 (class 1255 OID 2596899)
-- Dependencies: 2983 7
-- Name: fw_del_fichier(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_del_fichier(integer) RETURNS boolean
    AS $_$DECLARE
table_cible_fic VARCHAR;
req VARCHAR;
BEGIN
	

	DELETE FROM v2.fichier WHERE id=$1;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_del_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 9162 (class 0 OID 0)
-- Dependencies: 222
-- Name: FUNCTION fw_del_fichier(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_del_fichier(integer) IS 'Supprime un fichier.';


--
-- TOC entry 223 (class 1255 OID 2596900)
-- Dependencies: 2983 7
-- Name: fw_del_fichier_texte(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_del_fichier_texte(integer) RETURNS boolean
    AS $_$DECLARE
req VARCHAR;
BEGIN
	--SUPPRESSION
	DELETE FROM v2.fichier_texte WHERE id=$1;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_del_fichier_texte(integer) OWNER TO pgsql;

--
-- TOC entry 9163 (class 0 OID 0)
-- Dependencies: 223
-- Name: FUNCTION fw_del_fichier_texte(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_del_fichier_texte(integer) IS 'Supprime un fichier_texte.';


--
-- TOC entry 224 (class 1255 OID 2596901)
-- Dependencies: 2983 7
-- Name: fw_del_individu(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_del_individu(integer) RETURNS boolean
    AS $_$begin
    delete from v2.individu where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_del_individu(integer) OWNER TO pgsql;

--
-- TOC entry 9164 (class 0 OID 0)
-- Dependencies: 224
-- Name: FUNCTION fw_del_individu(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_del_individu(integer) IS 'supprime un individu';


--
-- TOC entry 225 (class 1255 OID 2596902)
-- Dependencies: 2983 7
-- Name: fw_fk_finder(character varying, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_fk_finder(character varying, character varying, integer) RETURNS boolean
    AS $_$DECLARE
--$1 nom de la table
--$2 nom de la colonne
--$3 valeur de la colonne
start_oid_values _int4;
rec RECORD;
i int4:=0;
req varchar;
nb_referenced_records int4;
BEGIN 

	--(A) on selection les oid du shema, de la table et le numero de la colonne
	SELECT INTO start_oid_values * FROM v2.af_fk_finder_oid($1,$2);
	--RAISE NOTICE '% % %',start_oid_values[1], start_oid_values[2],start_oid_values[3]; 
	
	--(B)on selectionne les noms du shema, des tables et des colonnes des tables ayant une rÃƒÆ’Ã‚Â©fÃƒÆ’Ã‚Â©rence vers (B)
	FOR rec IN 
		SELECT * FROM v2.af_fk_finder_tree(start_oid_values[1], start_oid_values[2], start_oid_values[3]) AS fkeys_infos
	LOOP
		--RAISE NOTICE '%: % %',i, rec.fkeys_infos[1],rec.fkeys_infos[2];
		i:=i+1;
		--(C) pour chacunes de ces tables on execute une requete pour avoir le nombre d'enregistrements refÃƒÆ’Ã‚Â©renÃƒÆ’Ã‚Â§ant la colonne de (A) avec l'identifiant voulu
		--cela en ignorant les tables de categories (car tout y est forcement!)
		IF rec.fkeys_infos[2]NOT LIKE '%categorie_%' THEN
	
			req:='SELECT '||rec.fkeys_infos[1]||' FROM v2.'||rec.fkeys_infos[2]||' WHERE '||rec.fkeys_infos[1]||'= '||$3;
			--RAISE NOTICE 'req=%',req;
			EXECUTE req; 

			GET DIAGNOSTICS nb_referenced_records = ROW_COUNT;

			IF nb_referenced_records>0 THEN
				--RAISE NOTICE 'nombre de liens trouvÃƒÆ’Ã‚Â©:%',nb_referenced_records;
				RETURN TRUE;
			ELSE
				CONTINUE;
			END IF;
		END IF;
	END LOOP;

	RETURN FALSE;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_fk_finder(character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9165 (class 0 OID 0)
-- Dependencies: 225
-- Name: FUNCTION fw_fk_finder(character varying, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_fk_finder(character varying, character varying, integer) IS 'Savoir si un ÃƒÆ’Ã‚Â©lÃƒÆ’Ã‚Â©ment est vÃƒÆ’Ã‚Â©rouillÃƒÆ’Ã‚Â©.
Retourne TRUE si l''element $3 de la table $2 et du shema $1 est prÃƒÆ’Ã‚Â©sent dans une table avec laquelle il serait liÃƒÆ’Ã‚Â© par une clÃƒÆ’Ã‚Â© ÃƒÆ’Ã‚Â©trangÃƒÆ’Ã‚Â¨re.';


--
-- TOC entry 226 (class 1255 OID 2596903)
-- Dependencies: 2983 7
-- Name: fw_fk_finder_oid(character varying, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_fk_finder_oid(character varying, character varying) RETURNS oid[]
    AS $_$DECLARE
--$1 nom de la table
--$2 nom de la colonne
nom_shema varchar:='v2';
tmp1 oid;
tmp2 oid;
tmp3 int4; --attention, ce n'est pas un oid, mais le numÃƒÆ’Ã‚Â©ro de la colonne! (nb: de 1 ÃƒÆ’Ã‚  n)
BEGIN

	--recupere l'oid du schema
	SELECT INTO tmp1 oid FROM pg_catalog.pg_namespace WHERE nspname LIKE nom_shema;
	
	--recupere l'oid de la table
	SELECT INTO tmp2 oid FROM pg_catalog.pg_class WHERE relname LIKE $1;
	
	--recupere l'oid de la colonne
	SELECT INTO tmp3 attnum FROM pg_catalog.pg_attribute WHERE attname LIKE $2 AND attrelid=tmp2;
	
	RETURN ARRAY[tmp1,tmp2,tmp3];
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_fk_finder_oid(character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 9166 (class 0 OID 0)
-- Dependencies: 226
-- Name: FUNCTION fw_fk_finder_oid(character varying, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_fk_finder_oid(character varying, character varying) IS 'FONCTION PRIVEE
Composante de la fonction af_fk_finder.

Retourne un tableau de 2 ÃƒÆ’Ã‚Â©lÃƒÆ’Ã‚Â©ments contenant, dans l''ordre:
-l''oid du shema v2
-l''oid de la table passÃƒÆ’Ã‚Â© en 1er paramatre
-le numero de la colonne passÃƒÆ’Ã‚Â© en 2ÃƒÆ’Ã‚Â¨me parametre';


--
-- TOC entry 227 (class 1255 OID 2596904)
-- Dependencies: 2983 7
-- Name: fw_fk_finder_tree(oid, oid, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_fk_finder_tree(oid, oid, integer) RETURNS SETOF character varying[]
    AS $_$DECLARE
--$1 oid du schema
--$2 oid de la table
--$3 numero de la colonne
nb int4:=0;
rec RECORD;
BEGIN

FOR rec IN
	SELECT DISTINCT
	--fka.attrelid AS FKTABLE_OID,
	--fka.attnum AS FKCOL_OID
	fka.attname AS FKTABLE_NAME,
	fkc.relname AS FKCOL_NAME
	FROM
		pg_constraint AS fkcon
	JOIN
		pg_constraint AS pkcon ON fkcon.confrelid=pkcon.conrelid
			AND fkcon.confkey=pkcon.conkey
	JOIN
		pg_class fkc ON fkc.oid=fkcon.conrelid
	JOIN
		pg_class pkc ON pkc.oid=fkcon.confrelid
	JOIN
		pg_attribute fka ON  fka.attrelid=fkc.oid  AND fka.attnum=fkcon.conkey[1]
	JOIN
		pg_attribute pka ON pka.attrelid=pkc.oid  AND pka.attnum=pkcon.conkey[1]
	WHERE pkcon.connamespace=$1
	AND pkc.oid=$2
	AND pka.attnum=$3
LOOP
	RETURN NEXT ARRAY[rec.FKTABLE_NAME, rec.FKCOL_NAME];
	--RETURN NEXT ARRAY[rec.FKTABLE_NAME, rec.FKCOL_NAME];
	--RAISE NOTICE '% % %',$1, rec.FKTABLE_NAME,rec.FKCOL_NAME; 
	nb:=nb+1;
END LOOP;
	--RAISE NOTICE 'Nombre de table liÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â©es trouvÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â©es:%',nb;
RETURN;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_fk_finder_tree(oid, oid, integer) OWNER TO pgsql;

--
-- TOC entry 9167 (class 0 OID 0)
-- Dependencies: 227
-- Name: FUNCTION fw_fk_finder_tree(oid, oid, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_fk_finder_tree(oid, oid, integer) IS 'FONCTION PRIVEE
Composante de la fonction af_fk_finder.

Retourne le nom des tables et de leurs colonnes liÃƒÆ’Ã‚Â©es aux parametres de la fonction.';


--
-- TOC entry 228 (class 1255 OID 2596905)
-- Dependencies: 2983 7
-- Name: fw_gen_del_element(character varying, character varying, integer, text); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fw_gen_del_element(character varying, character varying, integer, text) RETURNS integer
    AS $_$DECLARE
	-- nom de la table sur laquelle executer la requete
	nom_table ALIAS FOR $1;
	-- nom du champ lie au champ pere ( le champ id )
	nom_id ALIAS FOR $2;
	-- numero de l'element (id) que l'on veut supprimer
	indice ALIAS FOR $3;
	-- condition de selection d'une ligne
	cond ALIAS FOR  $4;
	-- variable ou l'on stock une ligne du resultat de la 1ere requete
	rec1 record;
	-- variable ou l'on stock une ligne du resultat de la 2eme requete
	rec2 record;
	-- variable dans laquelle on stock la chaine de la 1ere requete pour sa contruction
	req1 text;
	-- variable dans laquelle on stock la chaine de la 2eme  requete pour sa contruction
	req2 text;
	-- variable dans laquelle on stock la chaine de la 3eme  requete pour sa contruction
	req3 text;
	-- variable dans laquelle on stock la chaine de la 4eme requete pour sa contruction
	req4 text;
	--permet de stocker le nombre de lignes supprimees
	nb_del int4;
	--variable tmp
	rec1_pere varchar;
	--variable temporaire
	tmp_id RECORD;
	fait bool:=FALSE;
BEGIN
	RAISE NOTICE 'p1:% p2:% p3:% p4:%',$1,$2,$3,$4;
	
	--SELECTION DES LIGNES QUI SONT PERES DES ENREGISTREMENTS A SUPPRIMER
	--on construit la requete
	req1:='SELECT  pere  FROM '|| nom_table;
	req1:=req1   ||' WHERE '||nom_id||'='|| indice ||' '|| cond ||' ;';

	--chaque ligne du resultat est stockee temporairement dans rec1
	FOR rec1 IN 
		EXECUTE req1
			LOOP
				--SELECTION DES LIGNES QUI SONT FILLES DES ENREGISTREMENTS A SUPPRIMER
				--on construit la requete
				req2:='SELECT  '||nom_id||' AS id  FROM '|| nom_table;
				req2:=req2   ||' WHERE pere ='|| indice ||' '|| cond ||' ;';
			
				--chaque ligne du resultat est stockee temporairement dans rec2
				FOR rec2 IN 
					EXECUTE req2
						LOOP
							IF rec1.pere IS NULL THEN
								rec1_pere:='=NULL ';
							ELSE
								rec1_pere:='= '||rec1.pere;
							END IF;

							--ASTUCE: ON RECUPERE L'id DU DERNIER POUR LE METTRE TEMPORAIREMENT COMME PERE, AU LIEU DE rec1_pere
							--(pour respecter les v2)
							FOR tmp_id IN
								SELECT * FROM v2.af_gen_get_last_element(nom_table, nom_id, cond)
							LOOP
							END LOOP;

							--RAISE NOTICE 'rec1.pere:% rec2.id % ',rec1.pere,rec2.id;
							--EFFECTUE L'UPDATE DES FILS AVEC LA VALEUR TEMPORAIRE
							req3='UPDATE  '||nom_table ||' SET pere ='|| tmp_id.id ||' WHERE '||nom_id||'='|| rec2.id ||' '|| cond ||' ;';
							RAISE NOTICE 'req3=%',req3;
							EXECUTE req3;

							--SUPPRIME LES ENREGISTREMENTS VOULUS
							req4='DELETE FROM  '||nom_table ||'  WHERE '||nom_id||'='|| indice ||' '|| cond ||' ;';
							EXECUTE req4;
							--recupere le nombre de lignes modifiees par la derniere requete (ici le delete)
							GET DIAGNOSTICS nb_del = ROW_COUNT;

							--EFFECTUE L'UPDATE DES FILS AVEC LE NOUVEAU PERE 
							req3='UPDATE  '||nom_table ||' SET pere '|| rec1_pere ||' WHERE '||nom_id||'='|| rec2.id ||' '|| cond ||' ;';
							EXECUTE req3;
						
							fait:=TRUE;
						END LOOP;	
			END LOOP;
	--CAS OU L'ELEMENT A SUPPRIMER EST LE DERNIER
	IF fait IS FALSE THEN
		--SUPPRIME LES ENREGISTREMENTS VOULUS
		req4='DELETE FROM  '||nom_table ||'  WHERE '||nom_id||'='|| indice ||' '|| cond ||' ;';
		EXECUTE req4;
		--recupere le nombre de lignes modifiees par la derniere requete (ici le delete)
		GET DIAGNOSTICS nb_del = ROW_COUNT;
	END IF;
	RETURN  nb_del;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_gen_del_element(character varying, character varying, integer, text) OWNER TO postgres;

--
-- TOC entry 9168 (class 0 OID 0)
-- Dependencies: 228
-- Name: FUNCTION fw_gen_del_element(character varying, character varying, integer, text); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fw_gen_del_element(character varying, character varying, integer, text) IS 'Supprimer un element dans une table avec une notion de parentalitÃƒÆ’Ã‚Â©.

param1:
Le nom de la table

param2:
Le nom du champ liÃƒÆ’Ã‚Â© au champ pere (id)

param3:
Le numero du champ param2 (id) ÃƒÆ’Ã‚  supprimer

param4:
La condition de selection de l''element ÃƒÆ’Ã‚  supprimer.

retourne le nombre d''ÃƒÆ’Ã‚Â©lÃƒÆ’Ã‚Â©ments supprimÃƒÆ’Ã‚Â©s dans la table.';


--
-- TOC entry 229 (class 1255 OID 2596906)
-- Dependencies: 2983 7
-- Name: fw_gen_get_element_niveau(character varying, character varying, integer, text, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fw_gen_get_element_niveau(character varying, character varying, integer, text, integer) RETURNS integer
    AS $_$declare
	--stock le resultat de la requete
	rec record;
	-- variable dans laquelle on stock la chaine de la requete pour sa contruction
	req text;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© au champ pÃƒÆ’Ã‚Æ’Ãƒâ€¦Ã‚Â¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--3eme parametre : numero de l'element dont on cherche le niveau
	id ALIAS FOR  $3;
	--5eme parametre :condition de selection d'une ligne 
	cond ALIAS FOR  $4;
	-- l'indice 
	ind ALIAS FOR $5;
	--variable  permettant l'incrÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©mentation de l'indice 
	indice int4;
	--nombre de lignes trouvÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©es par la requete
	trouve int4;
begin

	--si l'id est null on retourne l'indice
	if(id is null) then
		--raise notice 'detection de la fin, ind=%', ind;
		return ind;
		exit;
	end if;

	--on incrÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©mente l'indice 
	indice:=ind+1;

	--on construit la requete
	req:='SELECT  '||nom_id||' AS id, pere, '||indice ||' AS ind  FROM ';
	req:=req || nom_table|| ' where id= ' || id;
	--fin de la construction de la requete
	req:=req ||' ' || cond ||' ;';

	for rec in
		execute req
	loop
		if( rec.id is not null) then
			--raise notice 'appel recursif, indice=%',indice;
			select into indice v2.af_gen_get_element_niveau(nom_table,nom_id,  rec.pere, cond, indice);
		end if;
	end loop;
	--on recupere le nombre de lignes trouvÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©es par le execute 
	GET DIAGNOSTICS trouve = ROW_COUNT;
	if(trouve =0 )then 
		--met l'indice a 0 pour faire la distinction entre le niveau 1 et pas de niveau
		indice := null;
	end if;
	--retourne le niveau
	return indice ;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_gen_get_element_niveau(character varying, character varying, integer, text, integer) OWNER TO postgres;

--
-- TOC entry 9169 (class 0 OID 0)
-- Dependencies: 229
-- Name: FUNCTION fw_gen_get_element_niveau(character varying, character varying, integer, text, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fw_gen_get_element_niveau(character varying, character varying, integer, text, integer) IS 'fonction gÃƒÆ’Ã‚Â©nÃƒÆ’Ã‚Â©rique permettant d''obtenir le niveau d''un element dans une table ayant une notion de parentalitÃƒÆ’Ã‚Â© (commence ÃƒÆ’Ã‚  1)';


--
-- TOC entry 230 (class 1255 OID 2596907)
-- Dependencies: 2983 7
-- Name: fw_gen_get_elements(character varying, character varying, integer, text); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fw_gen_get_elements(character varying, character varying, integer, text) RETURNS SETOF integer
    AS $_$DECLARE
	-- nom de la table sur laquelle executer la requete
	nom_table ALIAS FOR $1;
	-- nom du champ liÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© au champ pÃƒÆ’Ã‚Æ’Ãƒâ€¦Ã‚Â¡re ( le champ id )
	nom_id ALIAS FOR $2;
	-- numero de l'element (id) ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  partir duquel ont veut les elements
	debut ALIAS FOR $3;
	-- condition de selection d'une ligne
	cond ALIAS FOR  $4;
	-- variable ou l'on stock une ligne du resultat de la requete
	rec record;
	--variable locale permettant l'initialisation de l'indice pour le tris dans l'odre ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  partir du 1er element (sans pere)
	ind_init int4;
BEGIN
	--initialisation de l'indice
	ind_init:=0;

	--chaque ligne du resultat est stockÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e temporairement dans rec
	FOR rec IN 
		-- la requete ordonnÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© par l'indice
		SELECT id, ind FROM v2.af_gen_get_elements(nom_table, nom_id, debut,cond, ind_init) 
		ORDER BY ind 
			
			LOOP
				--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof int4 )
				RETURN NEXT rec.id;
			END LOOP;
	-- retourne le resultat de la fonction (setof int4)
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_gen_get_elements(character varying, character varying, integer, text) OWNER TO postgres;

--
-- TOC entry 9170 (class 0 OID 0)
-- Dependencies: 230
-- Name: FUNCTION fw_gen_get_elements(character varying, character varying, integer, text); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fw_gen_get_elements(character varying, character varying, integer, text) IS 'Fonction gÃƒÆ’Ã‚Â©nÃƒÆ’Ã‚Â©rique permettant d''obtenir les elements d''une table ayant une notion de parentalitÃƒÆ’Ã‚Â© dans l''ordre.

Le 1er parametre indique le nom de la table, le 2eme indique le nom du champ liÃƒÆ’Ã‚Â© au champ pÃƒÆ’Ã‚Â¨re (celui que l''on veut recuperer), le 3eme le numero du champ 2 ÃƒÆ’Ã‚  partir duquel on veut les enregistrements et le 4eme une chaine permetant de preciser la condition d''une ligne ( ex: ''AND toto= 8'')

exemple d''appel: 
select * from v2.af_gen_get_elements(varchar ''v2.parcours_etapes'', varchar ''etape'' , NULL ,text ''AND parcours=1'');';


--
-- TOC entry 231 (class 1255 OID 2596908)
-- Dependencies: 2158 2983 7
-- Name: fw_gen_get_elements(character varying, character varying, integer, text, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fw_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) RETURNS SETOF parents
    AS $_$DECLARE
	--permet de stocker le resultat de la requete
	rec v2.parents;
	--permet de stocker le resultat de la fonction appelÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e recursivement
	rec_tmp v2.parents;
	-- variable dans laquelle on stock la chaine de la requete pour sa contruction
	req text;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© au champ pÃƒÆ’Ã‚Æ’Ãƒâ€¦Ã‚Â¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--3eme parametre : numero de l'element (id) ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  partir duquel ont veut les elements (valeur du champ pere)
	id_pere ALIAS FOR  $3;
	--4eme parametre :condition de selection d'une ligne 
	cond ALIAS FOR  $4;
	--variable locale permettant l'incrÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©mentation de l'indice pour le tris 
	ind int4;
BEGIN
	--on incrÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©mente l'indice (5eme paramettre)
	ind:=$5 +1;
	--on construit la requete
	req:='SELECT  DISTINCT '||nom_id||' AS id, pere, '||ind ||' AS ind  FROM ';
	req:=req || nom_table ;	
	
	--on test la variable id_pere qui peut etre NULL et construit la requete en fonction
	IF id_pere IS NOT NULL THEN
		req:=req || ' where pere= ' || id_pere;
	ELSE 
		req:= req || ' where pere IS NULL ';
	END IF;

	--fin de la construction de la requete
	req:=req ||' ' || cond ||' and '||nom_id||' in ('||array_to_string($6,',')||');';

	--chaque ligne du resultat est stockÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e temporairement dans rec
	FOR rec IN 
		--execution de la requete construite
		EXECUTE req
			--pour chaque ligne de resultat (rec)
			LOOP
				--on retourne le resultat (setof v2.parents) de la fonction si fin de la recursivite
				IF rec.id IS NULL THEN
					RETURN ;
				ELSE 
					--sinon :
					--chaque ligne du resultat de la requete recursive est stockÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e temporairement dans rec_tmp
					FOR rec_tmp IN
						---on rappelle la fonction recursivement avec un nouveau id_pere
						SELECT * FROM v2.af_gen_get_elements( nom_table, nom_id, rec.id, cond, ind) 
					LOOP
						--on ajoute les elements voulus de la ligne de resultat temporaire (rec_tmp) au retour de la fonction ( setof parents )
						RETURN NEXT rec_tmp ;
					END LOOP;
						--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof parents )
					RETURN NEXT rec;
				END IF;
			END LOOP;
	-- retourne le resultat de la fonction (setof parents)
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) OWNER TO postgres;

--
-- TOC entry 9171 (class 0 OID 0)
-- Dependencies: 231
-- Name: FUNCTION fw_gen_get_elements(character varying, character varying, integer, text, integer, integer[]); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fw_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) IS 'FONCTION PRIVEE:
est appellee par la fonction v2.af_gen_get_elements(varchar, varchar, int4, text)

Fonction gÃƒÆ’Ã‚Â©nÃƒÆ’Ã‚Â©rique permettant d''obtenir les elements d''une table ayant une notion de parentalitÃƒÆ’Ã‚Â© .

Le 1er parametre indique le nom de la table, le 2eme indique le nom du champ liÃƒÆ’Ã‚Â© au champ pÃƒÆ’Ã‚Â¨re (celui que l''on veut recuperer), le 3eme le numero du champ 2 ÃƒÆ’Ã‚  partir duquel on veut les enregistrements,  le 4eme une chaine permetant de preciser la condition d''une ligne ( ex: ''AND toto= 8'') et le 5 eme l''indice du prÃƒÆ’Ã‚Â©cÃƒÆ’Ã‚Â©dent appel de fonction.';


--
-- TOC entry 232 (class 1255 OID 2596909)
-- Dependencies: 2158 2983 7
-- Name: fw_gen_get_elements(character varying, character varying, integer, text, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fw_gen_get_elements(character varying, character varying, integer, text, integer) RETURNS SETOF parents
    AS $_$DECLARE
	--permet de stocker le resultat de la requete
	rec v2.parents;
	--permet de stocker le resultat de la fonction appelÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e recursivement
	rec_tmp v2.parents;
	-- variable dans laquelle on stock la chaine de la requete pour sa contruction
	req text;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© au champ pÃƒÆ’Ã‚Æ’Ãƒâ€¦Ã‚Â¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--3eme parametre : numero de l'element (id) ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  partir duquel ont veut les elements (valeur du champ pere)
	id_pere ALIAS FOR  $3;
	--4eme parametre :condition de selection d'une ligne 
	cond ALIAS FOR  $4;
	--variable locale permettant l'incrÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©mentation de l'indice pour le tris 
	ind int4;
BEGIN
	--on incrÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©mente l'indice (5eme paramettre)
	ind:=$5 +1;
	--on construit la requete
	req:='SELECT  DISTINCT '||nom_id||' AS id, pere, '||ind ||' AS ind  FROM ';
	req:=req || nom_table ;	
	
	--on test la variable id_pere qui peut etre NULL et construit la requete en fonction
	IF id_pere IS NOT NULL THEN
		req:=req || ' where pere= ' || id_pere;
	ELSE 
		req:= req || ' where pere IS NULL ';
	END IF;

	--fin de la construction de la requete
	req:=req ||' ' || cond ||' ;';

	--chaque ligne du resultat est stockÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e temporairement dans rec
	FOR rec IN 
		--execution de la requete construite
		EXECUTE req
			--pour chaque ligne de resultat (rec)
			LOOP
				--on retourne le resultat (setof v2.parents) de la fonction si fin de la recursivite
				IF rec.id IS NULL THEN
					RETURN ;
				ELSE 
					--sinon :
					--chaque ligne du resultat de la requete recursive est stockÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e temporairement dans rec_tmp
					FOR rec_tmp IN
						---on rappelle la fonction recursivement avec un nouveau id_pere
						SELECT * FROM v2.af_gen_get_elements( nom_table, nom_id, rec.id, cond, ind) 
					LOOP
						--on ajoute les elements voulus de la ligne de resultat temporaire (rec_tmp) au retour de la fonction ( setof parents )
						RETURN NEXT rec_tmp ;
					END LOOP;
						--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof parents )
					RETURN NEXT rec;
				END IF;
			END LOOP;
	-- retourne le resultat de la fonction (setof parents)
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_gen_get_elements(character varying, character varying, integer, text, integer) OWNER TO postgres;

--
-- TOC entry 9172 (class 0 OID 0)
-- Dependencies: 232
-- Name: FUNCTION fw_gen_get_elements(character varying, character varying, integer, text, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fw_gen_get_elements(character varying, character varying, integer, text, integer) IS 'FONCTION PRIVEE:
est appellee par la fonction v2.af_gen_get_elements(varchar, varchar, int4, text)

Fonction gÃƒÆ’Ã‚Â©nÃƒÆ’Ã‚Â©rique permettant d''obtenir les elements d''une table ayant une notion de parentalitÃƒÆ’Ã‚Â© .

Le 1er parametre indique le nom de la table, le 2eme indique le nom du champ liÃƒÆ’Ã‚Â© au champ pÃƒÆ’Ã‚Â¨re (celui que l''on veut recuperer), le 3eme le numero du champ 2 ÃƒÆ’Ã‚  partir duquel on veut les enregistrements,  le 4eme une chaine permetant de preciser la condition d''une ligne ( ex: ''AND toto= 8'') et le 5 eme l''indice du prÃƒÆ’Ã‚Â©cÃƒÆ’Ã‚Â©dent appel de fonction.';


--
-- TOC entry 233 (class 1255 OID 2596910)
-- Dependencies: 2158 2983 7
-- Name: fw_gen_get_last_element(character varying, character varying, integer[], text); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fw_gen_get_last_element(character varying, character varying, integer[], text) RETURNS SETOF parents
    AS $_$DECLARE
	-- nom de la table sur laquelle executer la requete
	nom_table ALIAS FOR $1;
	-- nom du champ liÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© au champ pÃƒÆ’Ã‚Æ’Ãƒâ€¦Ã‚Â¡re ( le champ id )
	nom_id ALIAS FOR $2;
	-- tableau des valeurs pour le champ nom_id
	val_id alias for $3;
	-- condition de selection d'une ligne
	cond ALIAS FOR  $4;
	-- variable ou l'on stock une ligne du resultat de la requete
	rec record;
	--variable locale permettant l'initialisation de l'indice pour le tris dans l'odre ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  partir du 1er element (sans pere)
	ind_init int4;
	--variable pour stocker l'indice maximal
	ind_max int4;
	--varable pour afficher le nombre de ligne retournÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©es
	nb_lignes int4;
BEGIN
	--initialisations 
	ind_init:=0;
	nb_lignes:=0;
	-- On recupere l'indice maximal
	SELECT  MAX (ind) INTO ind_max FROM v2.af_gen_get_elements(nom_table, nom_id, NULL,cond, ind_init,val_id) ;
	
	--chaque ligne du resultat est stockÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e temporairement dans rec
	FOR rec IN 
		-- la requete ordonnÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© par l'indice
		SELECT  id, pere, ind  FROM v2.af_gen_get_elements(nom_table, nom_id, NULL,cond, ind_init,val_id) 
		WHERE ind = ind_max
			LOOP
				--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof int4 )
				RETURN NEXT rec;
			END LOOP;
	GET DIAGNOSTICS nb_lignes = ROW_COUNT;
	RAISE NOTICE 'nombre de lignes: %', nb_lignes;
	-- retourne le resultat de la fonction (setof v2.parents)
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_gen_get_last_element(character varying, character varying, integer[], text) OWNER TO postgres;

--
-- TOC entry 9173 (class 0 OID 0)
-- Dependencies: 233
-- Name: FUNCTION fw_gen_get_last_element(character varying, character varying, integer[], text); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fw_gen_get_last_element(character varying, character varying, integer[], text) IS 'Retourne le dernier element d''une table ayant une notion de parentalitÃƒÆ’Ã‚Â© 

param1:
Nom de la table

param 2:
Nom du champ liÃƒÆ’Ã‚Â© au champ pere (id)

param3:
condition supplÃƒÆ’Ã‚Â©mÃƒÆ’Ã‚Â©ntaire la selection des enregistrements

exemple d''appel:
select * from v2.af_gen_get_last_element(varchar ''v2.parcours_etapes'', varchar ''etape'' ,text ''AND parcours=1'');
 ';


--
-- TOC entry 234 (class 1255 OID 2596911)
-- Dependencies: 2158 2983 7
-- Name: fw_gen_get_last_element(character varying, character varying, text); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fw_gen_get_last_element(character varying, character varying, text) RETURNS SETOF parents
    AS $_$DECLARE
	-- nom de la table sur laquelle executer la requete
	nom_table ALIAS FOR $1;
	-- nom du champ liÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© au champ pÃƒÆ’Ã‚Æ’Ãƒâ€¦Ã‚Â¡re ( le champ id )
	nom_id ALIAS FOR $2;
	-- condition de selection d'une ligne
	cond ALIAS FOR  $3;
	-- variable ou l'on stock une ligne du resultat de la requete
	rec record;
	--variable locale permettant l'initialisation de l'indice pour le tris dans l'odre ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  partir du 1er element (sans pere)
	ind_init int4;
	--variable pour stocker l'indice maximal
	ind_max int4;
	--varable pour afficher le nombre de ligne retournÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©es
	nb_lignes int4;
BEGIN
	--initialisations 
	ind_init:=0;
	nb_lignes:=0;
	-- On recupere l'indice maximal
	SELECT  MAX (ind) INTO ind_max FROM v2.af_gen_get_elements(nom_table, nom_id, NULL,cond, ind_init) ;
	
	--chaque ligne du resultat est stockÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e temporairement dans rec
	FOR rec IN 
		-- la requete ordonnÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© par l'indice
		SELECT  id, pere, ind  FROM v2.af_gen_get_elements(nom_table, nom_id, NULL,cond, ind_init) 
		WHERE ind = ind_max
			LOOP
				--on ajoute les elements voulus de la ligne de resultat temporaire (rec) au retour de la fonction ( setof int4 )
				RETURN NEXT rec;
			END LOOP;
	GET DIAGNOSTICS nb_lignes = ROW_COUNT;
	--RAISE NOTICE 'nombre de lignes: %', nb_lignes;
	-- retourne le resultat de la fonction (setof v2.parents)
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_gen_get_last_element(character varying, character varying, text) OWNER TO postgres;

--
-- TOC entry 9174 (class 0 OID 0)
-- Dependencies: 234
-- Name: FUNCTION fw_gen_get_last_element(character varying, character varying, text); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fw_gen_get_last_element(character varying, character varying, text) IS 'Retourne le dernier element d''une table ayant une notion de parentalitÃƒÆ’Ã‚Â© 

param1:
Nom de la table

param 2:
Nom du champ liÃƒÆ’Ã‚Â© au champ pere (id)

param3:
condition supplÃƒÆ’Ã‚Â©mÃƒÆ’Ã‚Â©ntaire la selection des enregistrements

exemple d''appel:
select * from v2.af_gen_get_last_element(varchar ''v2.parcours_etapes'', varchar ''etape'' ,text ''AND parcours=1'');
 ';


--
-- TOC entry 235 (class 1255 OID 2596912)
-- Dependencies: 2983 7
-- Name: fw_gen_invert_elements(character varying, character varying, integer, integer, text); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fw_gen_invert_elements(character varying, character varying, integer, integer, text) RETURNS boolean
    AS $_$DECLARE
	-- variable dans laquelle on stock la chaine de la 1ere requete pour sa contruction (1ere select)
	req1 text;
	-- variable dans laquelle on stock la chaine de la 2eme requete pour sa contruction (2eme select)
	req2 text;
	req3 text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction(1er update)
	req1U text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction(2eme update)
	req2U text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction(3eme update)
	req3U text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction(4eme update)
	req4U text;
	--resultat du premier select
	rec1 record; 
	--resultat du second select
	rec2 record;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© au champ pÃƒÆ’Ã‚Æ’Ãƒâ€¦Ã‚Â¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--numero d'un des 2 enregistrements que l'on veut inverser
	numero1 ALIAS FOR $3;
	--numero de l'autre enregistrement que l'on veut inverser
	numero2 ALIAS FOR $4;
	--condition de selection d'une ligne pour SELECT et UPDATE
	cond ALIAS FOR  $5;
	--boolÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©en pour savoir si une l'inversion ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  eut lieu
	inverse boolean;
	--variable pour socker le nombre de ligne modifiÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©es pour le premier update
	nb1 int4;
	--variable pour socker le nombre de ligne modifiÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©es pour le deuxieme update
	nb2 int4;
	p1 varchar;
	p2 varchar;
	id int4;
BEGIN
	--initialisations
	inverse:=FALSE;
	nb1:=0;
	nb2:=0;

	--ON VERIFIE QUE LES 2 ELEMENTS A INVERSER NE SONT PAS NULL
	IF((numero1 IS NOT NULL  ) AND (numero2 IS NOT NULL)) THEN
	
		--ON RECUPERE LE PERE DU PREMIER ENREGISTREMENT
		req1:='SELECT   pere FROM '|| nom_table ||' WHERE '|| nom_id ||'='||numero1||' '||cond ||';';
		RAISE NOTICE 'req1=%',req1;
		--ON RECUPERE LE PERE DU SECOND ENREGISTREMENT
		req2:='SELECT   pere FROM '|| nom_table ||' WHERE '|| nom_id ||'='||numero2||' '||cond ||';';
		RAISE NOTICE 'req2=%',req2;
		--ON RECUPERE L'ID DU PERE DU PREMIER ENREGISTREMENT
		req3:='SELECT '|| nom_id ||' FROM '|| nom_table ||' WHERE  pere ='||numero1||' '||cond ||';';
		RAISE NOTICE 'req3=%',req3;
	
		EXECUTE req3 INTO id;
		
		FOR rec1 IN		
			EXECUTE req1
		LOOP
			IF rec1.pere IS NULL THEN
				p1:=' NULL';
			ELSE
				p1:=rec1.pere;
			END IF;

			FOR rec2 IN
				EXECUTE req2
			LOOP
				IF rec2.pere IS NULL THEN
					p2:=' NULL';
				ELSE
					p2:=rec2.pere;
				END IF;	


				--celui qui a B pour pere reÃƒÂ§oit A
				req1U:= 'UPDATE '||nom_table ||' SET pere='||numero1||' WHERE  pere  =' || numero2 ||' '|| cond ||';';
				RAISE NOTICE 'req1U=%',req1U;
				EXECUTE req1U;

				--celui qui a A pour pere reÃƒÂ§oit B (cad id reÃƒÂ§oit B )
				IF numero2!=id THEN
					req2U:= 'UPDATE '||nom_table ||' SET pere='||numero2||' WHERE '|| nom_id|| ' =' ||id ||' '|| cond ||';';
					RAISE NOTICE 'req2U=%',req2U;
					EXECUTE req2U;
				END IF;

				--A reÃƒÂ§oit le pere de B (ou B)
				IF numero1!=p2 THEN 
					req3U:= 'UPDATE '||nom_table ||' SET pere='||p2 ||' WHERE '|| nom_id|| ' =' || numero1 ||' '|| cond ||';';
					RAISE NOTICE '1req3U=%',req3U;
					EXECUTE req3U;
				ELSE
					req3U:= 'UPDATE '||nom_table ||' SET pere='||numero2||' WHERE '|| nom_id|| ' =' || numero1 ||' '|| cond ||';';
					RAISE NOTICE '2req3U=%',req3U;
					EXECUTE req3U;
				END IF;
		
				--B reÃƒÂ§oit le pere de A (ou A)
				IF numero2!=p1 THEN 
					req4U:= 'UPDATE '||nom_table ||' SET pere='||p1||' WHERE '|| nom_id|| ' =' || numero2 ||' '|| cond ||';';
					RAISE NOTICE '1req4U=%',req4U;
					EXECUTE req4U;
				ELSE
					req4U:= 'UPDATE '||nom_table ||' SET pere='||numero1||' WHERE '|| nom_id|| ' =' || numero2 ||' '|| cond ||';';
					RAISE NOTICE '2req4U=%',req4U;
					EXECUTE req4U;
				END IF;


				-- OBTIENT LE NOMBRE DE LIGNES UPDATEE POUR LE PREMIER NUMERO
				--GET DIAGNOSTICS nb1 = ROW_COUNT;
		
				-- OBTIENT LE NOMBRE DE LIGNES UPDATEE  POUR LE DEUXIEME NUMERO
				--GET DIAGNOSTICS nb2= ROW_COUNT;
				--IF ( (nb1>0)AND( nb2>0) )THEN
					inverse:=TRUE;
				--END IF;
			END LOOP;
		END LOOP;
	
	ELSE
			RAISE EXCEPTION 'Les numeros des elements ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  inverser ne peuvent etre NULL';
	END IF;
	

	--RETOURNE TRUE SI AU MOINS 2*1 LIGNE A ETE UPDATEE
	RETURN inverse;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_gen_invert_elements(character varying, character varying, integer, integer, text) OWNER TO postgres;

--
-- TOC entry 9175 (class 0 OID 0)
-- Dependencies: 235
-- Name: FUNCTION fw_gen_invert_elements(character varying, character varying, integer, integer, text); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fw_gen_invert_elements(character varying, character varying, integer, integer, text) IS 'Fonction gÃƒÆ’Ã‚Â©nÃƒÆ’Ã‚Â©rÃƒÆ’Ã‚Â©ique pour inverser deux elements dans une table avec une notion de parentalitÃƒÆ’Ã‚Â©.

Param1:
nom de la table

Param2:
Nom du champ liÃƒÆ’Ã‚Â© au pere (id)

Param3:
Numero du premier element ÃƒÆ’Ã‚  inverser

Param4:
Numero du second element ÃƒÆ’Ã‚  inverser

Param5:
Condition de selection d''une ligne

Exemple d''execution:
select v2.af_gen_invert_elements(varchar ''v2.parcours_etapes'', varchar ''etape'' ,2, 9 ,text ''AND parcours=1'');

Retourne TRUE si l''invertion s''est bien passÃƒÆ’Ã‚Â©e.';


--
-- TOC entry 236 (class 1255 OID 2596913)
-- Dependencies: 2983 7
-- Name: fw_gen_set_element(character varying, character varying, integer, integer, text, text, text); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION fw_gen_set_element(character varying, character varying, integer, integer, text, text, text) RETURNS boolean
    AS $_$DECLARE
	--permet de stocker le resultat de la requete
	rec1 v2.parents;
	rec1_pere varchar;
	--permet de stocker le resultat de la fonction appelÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e recursivement
	rec_tmp v2.parents;
	-- variable dans laquelle on stock la chaine de la 1ere requete pour sa contruction
	req1 text;
	-- variable dans laquelle on stock la chaine de la 2eme requete pour sa contruction
	req2 text;
	-- variable dans laquelle on stock la chaine de la 3eme requete pour sa contruction
	req3 text;
	--1er parametre : nom de la table sur laquelle on fait la requete
	nom_table ALIAS FOR  $1;
	--2eme parametre :nom du champ liÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© au champ pÃƒÆ’Ã‚Æ’Ãƒâ€¦Ã‚Â¡re ( le champ id )
	nom_id ALIAS FOR $2;
	--numero de l'enregistrement pour lequel on veut inserer avant
	indice ALIAS FOR $3;
	--numero de l'enregistrement ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  inserer
	nouveau ALIAS FOR $4;
	--chaine des champs supplÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©mÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©ntaires pour l'insertion
	champs ALIAS FOR  $5;
	--chaine des valeurs des champs pour l'insertion
	champs_values ALIAS FOR  $6;
	--condition de selection d'une ligne pour SELECT et UPDATE
	cond ALIAS FOR  $7;
	--boolÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©en pour savoir si une insertion ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  eut lieu
	insere boolean;
	--nombre de lignes inserees
	nb int4 :=0;
BEGIN
	--initialisation
	insere:=FALSE;

	--SI ON INSERE AU DEBUT OU AU MILIEU
	--raise notice 'on insere avant %=%',nom_id, indice;
	IF (indice IS NOT NULL) THEN
		--ON RECUPERE LE PERE DE LA LIGNE OU L'ON INSERE AVANT
		req1:='SELECT '|| nom_id ||' AS id, pere, NULL FROM '|| nom_table ||' WHERE '|| nom_id ;
		IF (indice IS NULL) THEN
			req1:=req1 ||' IS NULL' ;
		ELSE
			req1:=req1 ||' =' || indice ;
		END IF;
		req1:=req1 ||' '|| cond ||';';
	--SI ON INSERE A LA FIN
	ELSE
		req1:='select pere, id, ind from v2.af_gen_get_last_element(varchar '''|| nom_table ||''', varchar '''|| nom_id ||'''  ,text '''||cond||''');';
	END IF; 
	--chaque ligne du resultat est stockÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©e temporairement dans rec
	raise notice 'req1=%',req1;
	FOR rec1 IN 
		--execution de la requete construite
		EXECUTE req1
	--pour chaque ligne de resultat (rec)
	LOOP
		nb:= nb+1;
		IF rec1.pere IS NULL THEN
			rec1_pere := 'NULL';
		ELSE
			rec1_pere :=rec1.pere ;
		END IF;
		--ON INSERE LE NOUVEL ELEMENT
		req2:='INSERT INTO  '||nom_table||' ( ' || nom_id || ', pere '|| champs ||')  VALUES ( '|| nouveau  ||', '|| rec1_pere  || champs_values  ||') ;';		
		raise notice 'req2a=% ', req2;
		EXECUTE req2;
		-- OBTIENT LE NOMBRE DE LIGNES INSEREES
		--GET DIAGNOSTICS nb := ROW_COUNT;
		IF  nb>0 THEN
			--raise notice 'insere';
			insere:=TRUE;
		END IF;
	END LOOP;
	
	IF (nb = 0) AND (insere IS FALSE) THEN
		req2:='INSERT INTO  '||nom_table||' ( ' || nom_id || ', pere '|| champs ||')  VALUES ( '|| nouveau  ||', NULL '|| champs_values  ||') ;';		
		raise notice 'req2b=% ', req2;
		EXECUTE req2;
		RETURN FOUND;
	END IF;
	--UPDATE DES LIGNES POUR LEQUELLES IL FAUT CHANGER LE PERE
	req3:= 'UPDATE '||nom_table ||' SET pere='||nouveau ||' WHERE '|| nom_id ;
	IF indice IS NULL THEN
		req3:=req3 ||' IS NULL' ;
	ELSE
		req3:=req3 ||' =' || indice ;
	END IF;
	req3:=req3 ||' '|| cond ||';';
	raise notice 'req3=%',req3;
	EXECUTE req3;

	--RETOURNE TRUE SI AU MOINS UNE LIGNE INSEREE
	RETURN insere;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_gen_set_element(character varying, character varying, integer, integer, text, text, text) OWNER TO postgres;

--
-- TOC entry 9176 (class 0 OID 0)
-- Dependencies: 236
-- Name: FUNCTION fw_gen_set_element(character varying, character varying, integer, integer, text, text, text); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION fw_gen_set_element(character varying, character varying, integer, integer, text, text, text) IS 'Fonction gÃƒÆ’Ã‚Â©nÃƒÆ’Ã‚Â©rÃƒÆ’Ã‚Â©ique pour inserer un nouvel element dans une table avec une notion de parentalitÃƒÆ’Ã‚Â© AVANT un champ spÃƒÆ’Ã‚Â©cifiÃƒÆ’Ã‚Â©.

Param1:
nom de la table

Param2:
Nom du champ liÃƒÆ’Ã‚Â© au pere (id)

Param3:
Numero de l''ÃƒÆ’Ã‚Â©lÃƒÆ’Ã‚Â©ment(id) avant lequel on insere. NULL pour inserer ÃƒÆ’Ã‚  la fin.

Param4:
Numero du nouvel ÃƒÆ’Ã‚Â©lÃƒÆ’Ã‚Â©ment

Param5:
champs suplÃƒÆ’Ã‚Â©mentaires pour l''insertion.

Param6:
valeurs des champs supplÃƒÆ’Ã‚Â©mentaires pour l''insertion 

Param7:
Condition de selection d''une ligne pour l''update

Exemple d''execution:
select v2.af_gen_insert_element(varchar ''v2.parcours_etapes'', varchar ''etape'' , 5, 9 , varchar '', parcours'',varchar '',1'',text ''AND parcours=1'');

Retourne TRUE si l''insertion c''est bien passÃƒÆ’Ã‚Â©e.';


--
-- TOC entry 237 (class 1255 OID 2596914)
-- Dependencies: 2983 7
-- Name: fw_get_categorie_fichiers_themes(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_get_categorie_fichiers_themes(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero categorie
-- $2 : theme
-- $3 : theme modele
declare
rec record;
type_categorie int4;
begin
    for rec in
	select distinct * from
	(select * from v2.af_get_categorie_fichiers_theme($1,$2) as (id int4,libelle varchar,type int4,connecte bool) 
	union
	select * from v2.af_get_categorie_fichiers_theme($1,$3) as (id int4,libelle varchar,type int4,connecte bool)) CF
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_get_categorie_fichiers_themes(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9177 (class 0 OID 0)
-- Dependencies: 237
-- Name: FUNCTION fw_get_categorie_fichiers_themes(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_categorie_fichiers_themes(integer, integer, integer) IS 'retourne les fichiers pour une categorie et deux themes';


--
-- TOC entry 238 (class 1255 OID 2596915)
-- Dependencies: 2983 7
-- Name: fw_get_connexion_dates_max(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_get_connexion_dates_max(integer) RETURNS record
    AS $_$-- $1 : individu
declare
rec record;
begin
    select into rec max(c1.connexion),max(c2.deconnexion) 
    from v2.connexion c1,v2.connexion c2 where c1.individu=$1 and c2.individu=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_get_connexion_dates_max(integer) OWNER TO pgsql;

--
-- TOC entry 9178 (class 0 OID 0)
-- Dependencies: 238
-- Name: FUNCTION fw_get_connexion_dates_max(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_connexion_dates_max(integer) IS 'retourne les dates max de connexion et deconnexion pour un individu';


--
-- TOC entry 239 (class 1255 OID 2596916)
-- Dependencies: 2983 7
-- Name: fw_get_droit(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_get_droit(integer) RETURNS record
    AS $_$-- $1 : numero droit
declare
rec record;
begin
    select into rec id,libelle,type,defaut from v2.droit where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_get_droit(integer) OWNER TO pgsql;

--
-- TOC entry 9179 (class 0 OID 0)
-- Dependencies: 239
-- Name: FUNCTION fw_get_droit(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_droit(integer) IS 'retourne les info d''un droit';


--
-- TOC entry 240 (class 1255 OID 2596917)
-- Dependencies: 2983 7
-- Name: fw_get_droits(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_get_droits(integer) RETURNS SETOF record
    AS $_$-- $1 : type individu (0=tous,1=formateur,2=utilisateur,3=intervenant
declare
rec record;
req varchar;
begin
    if $1=0 then
	req:='select id,libelle,type,defaut from v2.droit';
    else
	req:='select id,libelle,type,defaut from v2.droit where type='||$1;
    end if;
    for rec in
	execute req
    loop
	return next rec;
    end loop;
    return;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_get_droits(integer) OWNER TO pgsql;

--
-- TOC entry 9180 (class 0 OID 0)
-- Dependencies: 240
-- Name: FUNCTION fw_get_droits(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_droits(integer) IS 'retourne tous les droits de la plateforme
pour un type d''individu';


--
-- TOC entry 241 (class 1255 OID 2596918)
-- Dependencies: 2983 7
-- Name: fw_get_droits_defaut(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_get_droits_defaut(integer) RETURNS SETOF record
    AS $_$-- $1 type d'individu (1 : formateur, 2 : utilisateur, 3 : intervenant)
declare
rec record;
begin
    for rec in 
	select id,libelle,type from v2.droit where defaut is true and type=$1
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_get_droits_defaut(integer) OWNER TO pgsql;

--
-- TOC entry 9181 (class 0 OID 0)
-- Dependencies: 241
-- Name: FUNCTION fw_get_droits_defaut(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_droits_defaut(integer) IS 'retourne les droits par defaut';


--
-- TOC entry 242 (class 1255 OID 2596919)
-- Dependencies: 2983 7
-- Name: fw_get_formation_langues(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_get_formation_langues(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, libelle , code , locale , formation 
		FROM v2.formation_langues, v2.af_get_langues() AS (id int4,libelle varchar, code varchar, locale varchar) 
		WHERE formation=$1
		AND langue=id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_get_formation_langues(integer) OWNER TO pgsql;

--
-- TOC entry 243 (class 1255 OID 2596920)
-- Dependencies: 2983 7
-- Name: fw_get_langue(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_get_langue(integer) RETURNS record
    AS $_$declare
rec record;
begin
    select into rec * from v2.af_get_langues() as (id int4,libelle varchar, code varchar, locale varchar) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_get_langue(integer) OWNER TO pgsql;

--
-- TOC entry 9182 (class 0 OID 0)
-- Dependencies: 243
-- Name: FUNCTION fw_get_langue(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_langue(integer) IS 'retourne les info langue';


--
-- TOC entry 244 (class 1255 OID 2596921)
-- Dependencies: 2983 7
-- Name: fw_get_langue(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_get_langue(character varying) RETURNS record
    AS $_$declare
rec record;
begin
    select into rec * from contraintes.fw_get_langues() as (id int4,libelle varchar, code varchar, locale varchar) 
    where code=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_get_langue(character varying) OWNER TO pgsql;

--
-- TOC entry 9183 (class 0 OID 0)
-- Dependencies: 244
-- Name: FUNCTION fw_get_langue(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_langue(character varying) IS 'retourne les info langue à partir du code';


--
-- TOC entry 245 (class 1255 OID 2596922)
-- Dependencies: 2983 7
-- Name: fw_get_langues(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_get_langues() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle, code, locale from v2.langue
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_get_langues() OWNER TO pgsql;

--
-- TOC entry 9184 (class 0 OID 0)
-- Dependencies: 245
-- Name: FUNCTION fw_get_langues(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_get_langues() IS 'retourne les langues de la plateforme';


--
-- TOC entry 246 (class 1255 OID 2596923)
-- Dependencies: 2983 7
-- Name: fw_is_locked_by_constraint(character varying, character varying, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_is_locked_by_constraint(character varying, character varying, character varying) RETURNS void
    AS $$BEGIN
SELECT

	--NULL::text AS PKTABLE_CAT,
	pknam.nspname AS PKTABLE_SCHEM,
	pkc.relname AS PKTABLE_NAME,
	pka.attname AS PKCOLUMN_NAME,
	--NULL::text AS FKTABLE_CAT,
	fknam.nspname AS FKTABLE_SCHEM,
	fkc.relname AS FKTABLE_NAME,
	fka.attname AS FKCOLUMN_NAME
	--fkcon.conkey[1] AS KEY_SEQ,
	--CASE
	---	WHEN fkcon.confupdtype = 'c' THEN 0
	--	WHEN fkcon.confupdtype = 'r' THEN 1
	--	WHEN fkcon.confupdtype = 'n' THEN 2
	--	WHEN fkcon.confupdtype = 'a' THEN 3
	--	WHEN fkcon.confupdtype = 'd' THEN 4
	--END AS UPDATE_RULE
	--CASE
	--	WHEN fkcon.confdeltype = 'c' THEN 0
	--	WHEN fkcon.confdeltype = 'r' THEN 1
	--	WHEN fkcon.confdeltype = 'n' THEN 2
	--	WHEN fkcon.confdeltype = 'a' THEN 3
	--	WHEN fkcon.confdeltype = 'd' THEN 4
	--END AS DELETE_RULE,
	--fkcon.conname AS FK_NAME,
	--pkcon.conname AS PK_NAME,
	--CASE
	--	WHEN fkcon.condeferrable = 'f' THEN 7
	--	WHEN fkcon.condeferred = 't' THEN 6
	--	WHEN fkcon.condeferred = 'f' THEN 5
	--END AS DEFERRABILITY,
	--CASE
	--	WHEN pkcon.contype = 'p' THEN 'PRIMARY'
	--	WHEN pkcon.contype = 'u' THEN 'UNIQUE'
	--END AS UNIQUE_OR_PRIMARY
	FROM
		pg_constraint AS fkcon
	JOIN
		pg_constraint AS pkcon ON fkcon.confrelid=pkcon.conrelid
			AND fkcon.confkey=pkcon.conkey
	JOIN
		pg_class fkc ON fkc.oid=fkcon.conrelid
	JOIN
		pg_class pkc ON pkc.oid=fkcon.confrelid
	JOIN
		pg_namespace pknam ON pkcon.connamespace=pknam.oid
	JOIN
		pg_namespace fknam ON fkcon.connamespace=fknam.oid
	JOIN
		pg_attribute fka ON fka.attnum=fkcon.conkey[1] AND fka.attrelid=fkc.oid
	JOIN
		pg_attribute pka ON pka.attnum=pkcon.conkey[1] AND pka.attrelid=pkc.oid

	WHERE pkc.relname='fichier';
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_is_locked_by_constraint(character varying, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 247 (class 1255 OID 2596924)
-- Dependencies: 2983 7
-- Name: fw_is_login_ok(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_is_login_ok(character varying) RETURNS boolean
    AS $_$begin
    perform login from v2.individu where login LIKE $1;
    return NOT found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_is_login_ok(character varying) OWNER TO pgsql;

--
-- TOC entry 9185 (class 0 OID 0)
-- Dependencies: 247
-- Name: FUNCTION fw_is_login_ok(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_is_login_ok(character varying) IS 'teste si un login est deja utilise';


--
-- TOC entry 248 (class 1255 OID 2596925)
-- Dependencies: 2983 7
-- Name: fw_maj_droit(integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_maj_droit(integer, character varying, boolean) RETURNS boolean
    AS $_$-- $1 : numero droit
-- $2 : libelle
-- $3 : defaut
begin
    update v2.droit set libelle=$2,defaut=$3 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_maj_droit(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 9186 (class 0 OID 0)
-- Dependencies: 248
-- Name: FUNCTION fw_maj_droit(integer, character varying, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION fw_maj_droit(integer, character varying, boolean) IS 'met Ãƒ  jour un droit';


--
-- TOC entry 249 (class 1255 OID 2596926)
-- Dependencies: 2983 7
-- Name: fw_substr_count(text, text); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION fw_substr_count(text, text) RETURNS integer
    AS $$
-- Compte le nombre d'occurence d'une souschaine dans une chaine
--   
--   Exemple : SELECT stroccurence('Ici un mot, et la un deuxieme mot','mot');
--             2
--
BEGIN
 return array_upper(string_to_array(chaine,souschaine),1)-1;
END;
$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.fw_substr_count(text, text) OWNER TO pgsql;

--
-- TOC entry 250 (class 1255 OID 2596927)
-- Dependencies: 2983 7
-- Name: grll_del_capacite(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_del_capacite(integer) RETURNS boolean
    AS $_$-- $1 : numero capacite
begin
    delete from v2.capacite where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_del_capacite(integer) OWNER TO pgsql;

--
-- TOC entry 9187 (class 0 OID 0)
-- Dependencies: 250
-- Name: FUNCTION grll_del_capacite(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_del_capacite(integer) IS 'supprime une capacite';


--
-- TOC entry 251 (class 1255 OID 2596928)
-- Dependencies: 2983 7
-- Name: grll_del_capacite_titre(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_del_capacite_titre(integer) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
begin
    delete from v2.capacite_titre where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_del_capacite_titre(integer) OWNER TO pgsql;

--
-- TOC entry 9188 (class 0 OID 0)
-- Dependencies: 251
-- Name: FUNCTION grll_del_capacite_titre(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_del_capacite_titre(integer) IS 'supprime un titre de capacite';


--
-- TOC entry 252 (class 1255 OID 2596929)
-- Dependencies: 2983 7
-- Name: grll_del_capacite_titre_capacite(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_del_capacite_titre_capacite(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
-- $2 : numero capacite
begin
    delete from v2.capacite_titre_capacites where capacite_titre=$1 and capacite=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_del_capacite_titre_capacite(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9189 (class 0 OID 0)
-- Dependencies: 252
-- Name: FUNCTION grll_del_capacite_titre_capacite(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_del_capacite_titre_capacite(integer, integer) IS 'supprime le couple capacite_titre / capacite';


--
-- TOC entry 253 (class 1255 OID 2596930)
-- Dependencies: 2983 7
-- Name: grll_del_grille(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_del_grille(integer) RETURNS boolean
    AS $_$-- $1 : numero grille
begin  
    delete from v2.grille where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_del_grille(integer) OWNER TO pgsql;

--
-- TOC entry 9190 (class 0 OID 0)
-- Dependencies: 253
-- Name: FUNCTION grll_del_grille(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_del_grille(integer) IS 'supprime une grille';


--
-- TOC entry 254 (class 1255 OID 2596931)
-- Dependencies: 2983 7
-- Name: grll_del_grille_capacite_titre(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_del_grille_capacite_titre(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero grille
-- $2 : numero capacite_titre
begin
    delete from v2.grille_capacites_titres where grille=$1 and capacite_titre=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_del_grille_capacite_titre(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9191 (class 0 OID 0)
-- Dependencies: 254
-- Name: FUNCTION grll_del_grille_capacite_titre(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_del_grille_capacite_titre(integer, integer) IS 'supprime le couple grille / capacite_titre';


--
-- TOC entry 255 (class 1255 OID 2596932)
-- Dependencies: 2983 7
-- Name: grll_get_capacite(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_capacite(integer) RETURNS record
    AS $_$-- $1 : numero capacite
declare
rec record;
begin
    select into rec id,libelle from v2.capacite where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_capacite(integer) OWNER TO pgsql;

--
-- TOC entry 9192 (class 0 OID 0)
-- Dependencies: 255
-- Name: FUNCTION grll_get_capacite(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_capacite(integer) IS 'retourne les infos d''une capacite';


--
-- TOC entry 256 (class 1255 OID 2596933)
-- Dependencies: 2983 7
-- Name: grll_get_capacite_titre(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_capacite_titre(integer) RETURNS record
    AS $_$-- $1 : numro capacite_titre
declare
rec record;
begin
    select into rec id,libelle from v2.capacite_titre where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_capacite_titre(integer) OWNER TO pgsql;

--
-- TOC entry 9193 (class 0 OID 0)
-- Dependencies: 256
-- Name: FUNCTION grll_get_capacite_titre(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_capacite_titre(integer) IS 'retourne les infos d''un titre de capacite';


--
-- TOC entry 257 (class 1255 OID 2596934)
-- Dependencies: 2983 7
-- Name: grll_get_capacite_titre_capacite_themes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_capacite_titre_capacite_themes() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct t.id,t.libelle from
	(v2.theme t
	left outer join
	--(v2.af_get_categorie_themes(11) as (ct_id int4,ct_libelle varchar)
	v2.categorie_capacite_titre cct
	on t.id=cct.theme
	left outer join 
	v2.capacite_titre_capacites ctc
	on ctc.capacite_titre=cct.id)
	where cct.theme is not null and ctc.capacite_titre is not null 
	
	
	
     loop
	return next rec;
     end loop;
     return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_capacite_titre_capacite_themes() OWNER TO pgsql;

--
-- TOC entry 9194 (class 0 OID 0)
-- Dependencies: 257
-- Name: FUNCTION grll_get_capacite_titre_capacite_themes(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_capacite_titre_capacite_themes() IS 'retourne les themes des couples capacite_titre / capacite';


--
-- TOC entry 258 (class 1255 OID 2596935)
-- Dependencies: 2983 7
-- Name: grll_get_capacite_titre_capacites(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_capacite_titre_capacites(integer) RETURNS SETOF record
    AS $_$-- $1 : numero capacite_titre
declare
rec record;
begin
    for rec in 
	select c.id,c.libelle,ctc.capacite_titre from v2.capacite c,v2.capacite_titre_capacites ctc
	where ctc.capacite_titre=$1 and c.id=ctc.capacite
    loop
	return next rec;
    end loop;
    return;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_capacite_titre_capacites(integer) OWNER TO pgsql;

--
-- TOC entry 9195 (class 0 OID 0)
-- Dependencies: 258
-- Name: FUNCTION grll_get_capacite_titre_capacites(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_capacite_titre_capacites(integer) IS 'retourne les capacites pour un titre de capacite';


--
-- TOC entry 259 (class 1255 OID 2596936)
-- Dependencies: 2983 7
-- Name: grll_get_capacite_titre_capacites_disponibles(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_capacite_titre_capacites_disponibles(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero capacite_titre
-- $2 : numero theme
declare
rec record;
begin
    for rec in 
	
	select distinct c.id,c.libelle,$1 as capacite_titre from
	(v2.capacite c
	left outer join
	v2.capacite_titre_capacites ctc
	on c.id=ctc.capacite and ctc.capacite_titre=$1),

	v2.af_get_categorie_elements_theme(10,$2) et 
	
	
	where 
	ctc.capacite is null and 
	c.id=et
	
	
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_capacite_titre_capacites_disponibles(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9196 (class 0 OID 0)
-- Dependencies: 259
-- Name: FUNCTION grll_get_capacite_titre_capacites_disponibles(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_capacite_titre_capacites_disponibles(integer, integer) IS 'retourne les capacites disponible pour un titre de capacite et un theme';


--
-- TOC entry 260 (class 1255 OID 2596937)
-- Dependencies: 2983 7
-- Name: grll_get_formation_grilles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_formation_grilles(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select distinct id,libelle from 
	v2.grille,
	v2.grille_resultats gr 
	where gr.formation=$1 and id=gr.grille
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_formation_grilles(integer) OWNER TO pgsql;

--
-- TOC entry 9197 (class 0 OID 0)
-- Dependencies: 260
-- Name: FUNCTION grll_get_formation_grilles(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_formation_grilles(integer) IS 'retourne les grilles presentielles pour une formation';


--
-- TOC entry 261 (class 1255 OID 2596938)
-- Dependencies: 2983 7
-- Name: grll_get_grille(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_grille(integer) RETURNS record
    AS $_$-- $1 : numero grille
declare
rec record;
begin
    select into rec id,libelle from v2.grille where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_grille(integer) OWNER TO pgsql;

--
-- TOC entry 9198 (class 0 OID 0)
-- Dependencies: 261
-- Name: FUNCTION grll_get_grille(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_grille(integer) IS 'retourne les infos d''une grille';


--
-- TOC entry 262 (class 1255 OID 2596939)
-- Dependencies: 2983 7
-- Name: grll_get_grille_capacite_titre_themes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_grille_capacite_titre_themes() RETURNS SETOF record
    AS $$declare 
rec record;
begin
    for rec in 
	select distinct t.id,t.libelle from
	(v2.theme t
	left outer join
	--(v2.af_get_categorie_themes(11) as (ct_id int4,ct_libelle varchar)
	v2.categorie_grille cg
	on t.id=cg.theme
	left outer join 
	v2.grille_capacites_titres gtc
	on gtc.grille=cg.id)
	where cg.theme is not null and gtc.grille is not null 
	
	
	
     loop
	return next rec;
     end loop;
     return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_grille_capacite_titre_themes() OWNER TO pgsql;

--
-- TOC entry 9199 (class 0 OID 0)
-- Dependencies: 262
-- Name: FUNCTION grll_get_grille_capacite_titre_themes(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_grille_capacite_titre_themes() IS 'retourne les themes des couples grille / capacite_titre';


--
-- TOC entry 263 (class 1255 OID 2596940)
-- Dependencies: 2983 7
-- Name: grll_get_grille_capacites_titres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_grille_capacites_titres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero grille
declare
rec record;
begin
    for rec in 
	select ct.id,ct.libelle,gct.grille from v2.capacite_titre ct,v2.grille_capacites_titres gct 
	where gct.grille=$1 and ct.id=gct.capacite_titre
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_grille_capacites_titres(integer) OWNER TO pgsql;

--
-- TOC entry 9200 (class 0 OID 0)
-- Dependencies: 263
-- Name: FUNCTION grll_get_grille_capacites_titres(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_grille_capacites_titres(integer) IS 'retourne les titres de capacite pour une grille';


--
-- TOC entry 264 (class 1255 OID 2596941)
-- Dependencies: 2983 7
-- Name: grll_get_grille_capacites_titres_disponibles(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_grille_capacites_titres_disponibles(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero grille
-- $2 : numero theme
declare 
rec record;
begin
    for rec in 
	select distinct ct.id,ct.libelle,$1 as grille from 
	
	(v2.capacite_titre ct
	left outer join
	v2.capacite_titre_capacites ctc
	on ct.id=ctc.capacite_titre) ,
	
	
	
	(v2.capacite_titre c
	left outer join
	v2.grille_capacites_titres gct
	on c.id=gct.capacite_titre and gct.grille=$1) ,
	v2.af_get_categorie_elements_theme(11,$2) et
	where gct.capacite_titre is null and ctc.capacite_titre is not null and ct.id=et
	and ct.id=c.id

    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_grille_capacites_titres_disponibles(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9201 (class 0 OID 0)
-- Dependencies: 264
-- Name: FUNCTION grll_get_grille_capacites_titres_disponibles(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_grille_capacites_titres_disponibles(integer, integer) IS 'retourne tous les capacites_titres disponibles pour une grille et un theme';


--
-- TOC entry 265 (class 1255 OID 2596942)
-- Dependencies: 2983 7
-- Name: grll_get_grille_stagiaires_formation(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_grille_stagiaires_formation(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : grille
-- $2 : formation
declare
rec record;
begin
    for rec in 
	select distinct id,nom,prenom from 
	v2.individu,
	v2.stagiaire_grille sg 
	where id=sg.stagiaire and sg.formation=$2 and sg.grille=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_grille_stagiaires_formation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9202 (class 0 OID 0)
-- Dependencies: 265
-- Name: FUNCTION grll_get_grille_stagiaires_formation(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_grille_stagiaires_formation(integer, integer) IS 'retourne les stagiaires de la table stagiaire_grille pour une grille et une formation';


--
-- TOC entry 266 (class 1255 OID 2596943)
-- Dependencies: 2983 7
-- Name: grll_get_intervenant_formations_grille(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_intervenant_formations_grille(integer) RETURNS SETOF record
    AS $_$-- $1 : intervenant
declare
rec record;
begin
    for rec in 
	select distinct id,f.libelle from 
	v2.formation f,
	v2.evenement e,
	v2.grille_resultats gr 
	where id=e.formation and e.intervenant=$1 and e.modalite=3 and id=gr.formation
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_intervenant_formations_grille(integer) OWNER TO pgsql;

--
-- TOC entry 9203 (class 0 OID 0)
-- Dependencies: 266
-- Name: FUNCTION grll_get_intervenant_formations_grille(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_intervenant_formations_grille(integer) IS 'retourne les formations avec grille pour un intervenant';


--
-- TOC entry 267 (class 1255 OID 2596944)
-- Dependencies: 2983 7
-- Name: grll_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
declare
rec record;
begin
    for rec in
	select * from v2.grille_resultats 
	where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9204 (class 0 OID 0)
-- Dependencies: 267
-- Name: FUNCTION grll_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) IS 'retourne les resultat presentiel d''un individu pour une capacite';


--
-- TOC entry 268 (class 1255 OID 2596945)
-- Dependencies: 2983 7
-- Name: grll_get_presentiel_resultats_individu_grille(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_presentiel_resultats_individu_grille(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
declare
rec record;
begin
    for rec in 
	select formation,stagiaire,grille,g.libelle,capacite_titre,ct.libelle,capacite,c.libelle,commentaire,note,note_max,carton,date 
	from v2.grille_resultats,
	v2.grille g,
	v2.capacite_titre ct,
	v2.capacite c 
	where formation=$1 and stagiaire=$2 and grille=$3 
	and grille=g.id and capacite_titre=ct.id and capacite=c.id
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_presentiel_resultats_individu_grille(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9205 (class 0 OID 0)
-- Dependencies: 268
-- Name: FUNCTION grll_get_presentiel_resultats_individu_grille(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_presentiel_resultats_individu_grille(integer, integer, integer) IS 'Obtenir les resultats presentiels pour un individu et une grille';


--
-- TOC entry 269 (class 1255 OID 2596946)
-- Dependencies: 2983 7
-- Name: grll_get_presentiel_stagiaire_grille(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_presentiel_stagiaire_grille(integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
declare
rec record;
begin
    select into rec * from v2.stagiaire_grille 
    where formation=$1 and stagiaire=$2 and grille=$3;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_presentiel_stagiaire_grille(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9206 (class 0 OID 0)
-- Dependencies: 269
-- Name: FUNCTION grll_get_presentiel_stagiaire_grille(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_presentiel_stagiaire_grille(integer, integer, integer) IS 'retourne les infos de la table stagiaire_grille pour un stagiaire';


--
-- TOC entry 270 (class 1255 OID 2596947)
-- Dependencies: 2983 7
-- Name: grll_get_theme_grilles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_theme_grilles(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select c.id,c.libelle from v2.grille c,
	v2.af_get_categorie_elements_theme(15,$1) tc 
	where c.id=tc
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_theme_grilles(integer) OWNER TO pgsql;

--
-- TOC entry 9207 (class 0 OID 0)
-- Dependencies: 270
-- Name: FUNCTION grll_get_theme_grilles(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_theme_grilles(integer) IS 'retourne les grilles presentielles pour un theme';


--
-- TOC entry 271 (class 1255 OID 2596948)
-- Dependencies: 2983 7
-- Name: grll_get_theme_grilles_capacite(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_get_theme_grilles_capacite(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in
	select distinct g_id,g_libelle from v2.af_get_theme_grilles($1) as (g_id int4,g_libelle varchar),
	v2.grille_capacites_titres gct,v2.capacite_titre_capacites ctc 
	where g_id=gct.grille and gct.capacite_titre=ctc.capacite_titre
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_get_theme_grilles_capacite(integer) OWNER TO pgsql;

--
-- TOC entry 9208 (class 0 OID 0)
-- Dependencies: 271
-- Name: FUNCTION grll_get_theme_grilles_capacite(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_get_theme_grilles_capacite(integer) IS 'retourne les grilles (avec capacite) pour le theme';


--
-- TOC entry 272 (class 1255 OID 2596949)
-- Dependencies: 2983 7
-- Name: grll_is_capacite_titre_capacite_supprimable(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_is_capacite_titre_capacite_supprimable(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
-- $2 : numero capacite
begin
    perform * from v2.grille_resultats where capacite_titre=$1 and capacite=$2;
    return not found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_is_capacite_titre_capacite_supprimable(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9209 (class 0 OID 0)
-- Dependencies: 272
-- Name: FUNCTION grll_is_capacite_titre_capacite_supprimable(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_is_capacite_titre_capacite_supprimable(integer, integer) IS 'retourne vrai si le couple capacite_titre / capacite peut etre supprimer';


--
-- TOC entry 273 (class 1255 OID 2596950)
-- Dependencies: 2983 7
-- Name: grll_is_grille_capacite_titre_supprimable(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_is_grille_capacite_titre_supprimable(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero grille
-- $2 : numero capacite_titre
begin
    perform * from v2.grille_resultats where grille=$1 and capacite_titre=$2;
    return not found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_is_grille_capacite_titre_supprimable(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9210 (class 0 OID 0)
-- Dependencies: 273
-- Name: FUNCTION grll_is_grille_capacite_titre_supprimable(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_is_grille_capacite_titre_supprimable(integer, integer) IS 'retourne vrai si le couple grille / capacite_titre est supprimable';


--
-- TOC entry 274 (class 1255 OID 2596951)
-- Dependencies: 2983 7
-- Name: grll_maj_capacite(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_maj_capacite(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero capacite
-- $2 : libelle capacite
begin
    update v2.capacite set libelle =$2 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_maj_capacite(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9211 (class 0 OID 0)
-- Dependencies: 274
-- Name: FUNCTION grll_maj_capacite(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_maj_capacite(integer, character varying) IS 'met Ãƒ  jour une capacite';


--
-- TOC entry 275 (class 1255 OID 2596952)
-- Dependencies: 2983 7
-- Name: grll_maj_capacite_titre(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_maj_capacite_titre(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
-- $2 : libelle capacite_titre
begin
    update v2.capacite_titre set libelle=$2 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_maj_capacite_titre(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9212 (class 0 OID 0)
-- Dependencies: 275
-- Name: FUNCTION grll_maj_capacite_titre(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_maj_capacite_titre(integer, character varying) IS 'met Ãƒ  jour un titre de capacite';


--
-- TOC entry 276 (class 1255 OID 2596953)
-- Dependencies: 2983 7
-- Name: grll_maj_grille(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_maj_grille(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero grille
-- $2 : libelle
begin
    update v2.grille set libelle =$2 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_maj_grille(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9213 (class 0 OID 0)
-- Dependencies: 276
-- Name: FUNCTION grll_maj_grille(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_maj_grille(integer, character varying) IS 'met Ãƒ  jour une grille';


--
-- TOC entry 277 (class 1255 OID 2596954)
-- Dependencies: 2983 7
-- Name: grll_set_capacite(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_set_capacite(character varying) RETURNS integer
    AS $_$-- $1 : libelle capacite
declare
new_id int4;
res int4;
begin
    insert into v2.capacite(libelle) values($1);
    --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.capacite WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_set_capacite(character varying) OWNER TO pgsql;

--
-- TOC entry 9214 (class 0 OID 0)
-- Dependencies: 277
-- Name: FUNCTION grll_set_capacite(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_set_capacite(character varying) IS 'enregistre une capacite';


--
-- TOC entry 278 (class 1255 OID 2596955)
-- Dependencies: 2983 7
-- Name: grll_set_capacite_titre(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_set_capacite_titre(character varying) RETURNS integer
    AS $_$-- $1 : libelle capacite_titre
declare
new_id int4;
res int4;
begin
    insert into v2.capacite_titre(libelle) values($1);
    --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.capacite_titre WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_set_capacite_titre(character varying) OWNER TO pgsql;

--
-- TOC entry 9215 (class 0 OID 0)
-- Dependencies: 278
-- Name: FUNCTION grll_set_capacite_titre(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_set_capacite_titre(character varying) IS 'enregistre un titre de capacite';


--
-- TOC entry 279 (class 1255 OID 2596956)
-- Dependencies: 2983 7
-- Name: grll_set_capacite_titre_capacite(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_set_capacite_titre_capacite(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero capacite_titre
-- $2 : numero capacite
begin
    insert into v2.capacite_titre_capacites(capacite_titre,capacite) values($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_set_capacite_titre_capacite(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9216 (class 0 OID 0)
-- Dependencies: 279
-- Name: FUNCTION grll_set_capacite_titre_capacite(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_set_capacite_titre_capacite(integer, integer) IS 'enregistre le couple capacite_titre / capacite';


--
-- TOC entry 280 (class 1255 OID 2596957)
-- Dependencies: 2983 7
-- Name: grll_set_grille(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_set_grille(character varying) RETURNS integer
    AS $_$-- $1 : libelle grille
declare
new_id int4;
res int4;
begin
    insert into v2.grille(libelle) values($1);
     --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.grille WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_set_grille(character varying) OWNER TO pgsql;

--
-- TOC entry 9217 (class 0 OID 0)
-- Dependencies: 280
-- Name: FUNCTION grll_set_grille(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_set_grille(character varying) IS 'enregistre une grille';


--
-- TOC entry 281 (class 1255 OID 2596958)
-- Dependencies: 2983 7
-- Name: grll_set_grille_capacite_titre(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION grll_set_grille_capacite_titre(integer, integer) RETURNS boolean
    AS $_$-- $1 : numero grille
-- $2 : numero capacite_titre
begin
    insert into v2.grille_capacites_titres(grille,capacite_titre) values($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.grll_set_grille_capacite_titre(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9218 (class 0 OID 0)
-- Dependencies: 281
-- Name: FUNCTION grll_set_grille_capacite_titre(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION grll_set_grille_capacite_titre(integer, integer) IS 'enregistre le couple grille / capacite_titre';


--
-- TOC entry 282 (class 1255 OID 2596959)
-- Dependencies: 2983 7
-- Name: insert_categorie_etape(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_categorie_etape() RETURNS "trigger"
    AS $$BEGIN
	PERFORM * FROM v2.af_set_categorie_element_theme(29, NEW.theme,NEW.id);
	RAISE NOTICE 'af_set_categorie_element_theme(%,%,%)',29, NEW.theme,NEW.id;
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_categorie_etape() OWNER TO pgsql;

--
-- TOC entry 283 (class 1255 OID 2596960)
-- Dependencies: 2983 7
-- Name: insert_categorie_evaluation(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_categorie_evaluation() RETURNS "trigger"
    AS $$BEGIN
	PERFORM * FROM v2.af_set_categorie_element_theme(28, NEW.theme,NEW.id);
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_categorie_evaluation() OWNER TO pgsql;

--
-- TOC entry 284 (class 1255 OID 2596961)
-- Dependencies: 2983 7
-- Name: insert_categorie_fichier_ressource(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_categorie_fichier_ressource() RETURNS "trigger"
    AS $$BEGIN
	PERFORM * FROM v2.af_set_categorie_element_theme(43, NEW.theme,NEW.id);
	--RAISE NOTICE 'af_set_categorie_element_theme(%,%,%)',43, NEW.theme,NEW.id;
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_categorie_fichier_ressource() OWNER TO pgsql;

--
-- TOC entry 285 (class 1255 OID 2596962)
-- Dependencies: 2983 7
-- Name: insert_categorie_scenario(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_categorie_scenario() RETURNS "trigger"
    AS $$DECLARE
NEW_SCENARIO int4;
BEGIN
	--on selectionne le scenario associÃ© au fichier
	SELECT INTO NEW_SCENARIO fichier FROM v2.scenario
	WHERE fichier=NEW.id;
	
	--on insert le scenario dans sa categorie avec le meme theme que le fichier
	INSERT INTO v2.categorie_scenario
	(id, categorie, theme)
	VALUES(NEW_SCENARIO, 35, NEW.theme);
	
	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_categorie_scenario() OWNER TO pgsql;

--
-- TOC entry 1822 (class 1255 OID 2596963)
-- Dependencies: 2983 7
-- Name: insert_etape_scorm(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_etape_scorm() RETURNS "trigger"
    AS $$DECLARE
id_etape int4;
lib varchar;
BEGIN
	--selection du libelle du fichier pour le libelle de l'etape (table principale)
	SELECT INTO lib libelle FROM v2.fichier WHERE id=NEW.id;

	--creation de l'etape (table principale)
	SELECT INTO id_etape  v2.af_set_etape(lib, 3);
	
	--insertion dans la table spÃƒÂ©cifique au scenario
	INSERT INTO v2.etape_scorm (id, fichier) VALUES (id_etape, NEW.id);

	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_etape_scorm() OWNER TO pgsql;

--
-- TOC entry 286 (class 1255 OID 2596964)
-- Dependencies: 2983 7
-- Name: insert_fichier_ressource(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_fichier_ressource() RETURNS "trigger"
    AS $$BEGIN
	INSERT INTO v2.fichier_ressource
	(id) VALUES (NEW.id);

	RETURN NEW;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_fichier_ressource() OWNER TO pgsql;

--
-- TOC entry 287 (class 1255 OID 2596965)
-- Dependencies: 2983 7
-- Name: insert_formateur_droits_defaut(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_formateur_droits_defaut() RETURNS "trigger"
    AS $$DECLARE

BEGIN
	INSERT INTO v2.formateur_droits
	(formation, droit) 
	SELECT NEW.formation, D_id  
	FROM v2.af_get_droits_defaut(1) AS (D_id int4, D_libelle varchar,D_type int4); 
	
	RETURN NEW;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_formateur_droits_defaut() OWNER TO pgsql;

--
-- TOC entry 288 (class 1255 OID 2596966)
-- Dependencies: 2983 7
-- Name: insert_liste(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_liste() RETURNS "trigger"
    AS $_$DECLARE
val_type int4:=TG_ARGV[0];
--$1 le type de liste
BEGIN
	RAISE NOTICE 'NEW.id=% TG_ARGV[0]=%',NEW.id, val_type;
	INSERT INTO v2.liste (id, type) VALUES (NEW.id, int4 (val_type));
	
	RETURN NEW;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_liste() OWNER TO pgsql;

--
-- TOC entry 1823 (class 1255 OID 2596967)
-- Dependencies: 2983 7
-- Name: insert_question_reponse_element(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_question_reponse_element() RETURNS "trigger"
    AS $_$--$1 reponse?
BEGIN
	IF NEW.reponse IS TRUE THEN
		INSERT INTO v2.reponse (id) VALUES (NEW.id);
	ELSE
		INSERT INTO v2.question (id) VALUES (NEW.id);
	END IF;

	RETURN NEW;
END
$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_question_reponse_element() OWNER TO pgsql;

--
-- TOC entry 289 (class 1255 OID 2596968)
-- Dependencies: 2983 7
-- Name: insert_ressource(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_ressource() RETURNS "trigger"
    AS $$DECLARE
id_etape int4;
lib varchar;
BEGIN
	--selection du libelle du fichier pour le libelle de l'etape (table principale)
	SELECT INTO lib libelle FROM v2.fichier WHERE id=NEW.id;

	--creation de l'etape (table principale)
	SELECT INTO id_etape  v2.af_set_etape(lib, 7);
	
	--insertion dans la table spÃƒÂ©cifique au scenario
	INSERT INTO v2.ressource (id, fichier) VALUES (id_etape, NEW.id);

	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_ressource() OWNER TO pgsql;

--
-- TOC entry 1824 (class 1255 OID 2596969)
-- Dependencies: 2983 7
-- Name: insert_scenario(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_scenario() RETURNS "trigger"
    AS $$DECLARE
id_etape int4;
lib varchar;
BEGIN
	--selection du libelle du fichier pour le libelle de l'etape (table principale)
	SELECT INTO lib libelle FROM v2.fichier WHERE id=NEW.id;

	--creation de l'etape (table principale)
	SELECT INTO id_etape  v2.af_set_etape(lib, 6);
	
	--insertion dans la table spÃƒÂ©cifique au scenario
	INSERT INTO v2.scenario (id, fichier) VALUES (id_etape, NEW.id);

	RETURN NEW;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_scenario() OWNER TO pgsql;

--
-- TOC entry 290 (class 1255 OID 2596970)
-- Dependencies: 2983 7
-- Name: insert_serie_aleatoire_multitheme_theme_categorie(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION insert_serie_aleatoire_multitheme_theme_categorie() RETURNS "trigger"
    AS $$begin
  perform * from v2.af_set_categorie_element_theme(19,new.theme_source,new.serie);
 return new; 
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.insert_serie_aleatoire_multitheme_theme_categorie() OWNER TO pgsql;

--
-- TOC entry 9222 (class 0 OID 0)
-- Dependencies: 290
-- Name: FUNCTION insert_serie_aleatoire_multitheme_theme_categorie(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION insert_serie_aleatoire_multitheme_theme_categorie() IS 'enregistre un theme d''une serie aleatoire multitheme dans categorie_serie';


--
-- TOC entry 291 (class 1255 OID 2596971)
-- Dependencies: 2983 7
-- Name: lrt_del_alerte(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lrt_del_alerte(integer) RETURNS boolean
    AS $_$-- $1 : numero alerte
begin
    delete from v2.alerte where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lrt_del_alerte(integer) OWNER TO pgsql;

--
-- TOC entry 9223 (class 0 OID 0)
-- Dependencies: 291
-- Name: FUNCTION lrt_del_alerte(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lrt_del_alerte(integer) IS 'supprime une alerte';


--
-- TOC entry 292 (class 1255 OID 2596972)
-- Dependencies: 2983 7
-- Name: lrt_get_alerte(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lrt_get_alerte(integer) RETURNS record
    AS $_$-- $1 : numero alerte
declare
rec record;
begin
    select into rec id,libelle,formation,date,jours,texte from v2.alerte where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lrt_get_alerte(integer) OWNER TO pgsql;

--
-- TOC entry 9224 (class 0 OID 0)
-- Dependencies: 292
-- Name: FUNCTION lrt_get_alerte(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lrt_get_alerte(integer) IS 'retourne les infos d''une alerte';


--
-- TOC entry 293 (class 1255 OID 2596973)
-- Dependencies: 2983 7
-- Name: lrt_get_alerte_periode_max(integer, date); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lrt_get_alerte_periode_max(integer, date) RETURNS integer
    AS $_$-- $1 : numero formation
-- $2 : date
declare
my_date date;
periode int4;

begin
    -- recup la date suivante
    select into my_date min(date) from v2.alerte 
    where date>$2 and formation=$1;
    if my_date is not null then
	periode:=my_date - $2;
    else
	periode:=15;
    end if;
    return periode;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lrt_get_alerte_periode_max(integer, date) OWNER TO pgsql;

--
-- TOC entry 9225 (class 0 OID 0)
-- Dependencies: 293
-- Name: FUNCTION lrt_get_alerte_periode_max(integer, date); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lrt_get_alerte_periode_max(integer, date) IS 'retourne la periode maxi pour une alerte de formation';


--
-- TOC entry 294 (class 1255 OID 2596974)
-- Dependencies: 2983 7
-- Name: lrt_get_alertes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lrt_get_alertes() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,formation,date,jours,texte from v2.alerte
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lrt_get_alertes() OWNER TO pgsql;

--
-- TOC entry 9226 (class 0 OID 0)
-- Dependencies: 294
-- Name: FUNCTION lrt_get_alertes(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lrt_get_alertes() IS 'retourne les alertes de la plateforme';


--
-- TOC entry 295 (class 1255 OID 2596975)
-- Dependencies: 2983 7
-- Name: lrt_get_alertes_liees(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lrt_get_alertes_liees() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,formation,date,jours,texte from v2.alerte where formation is not null
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lrt_get_alertes_liees() OWNER TO pgsql;

--
-- TOC entry 9227 (class 0 OID 0)
-- Dependencies: 295
-- Name: FUNCTION lrt_get_alertes_liees(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lrt_get_alertes_liees() IS 'retourne les alertes de la plateforme qui sont liees Ãƒ  une gormation';


--
-- TOC entry 296 (class 1255 OID 2596976)
-- Dependencies: 2983 7
-- Name: lrt_get_alertes_non_liees(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lrt_get_alertes_non_liees() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,formation,date,jours,texte from v2.alerte where formation is null
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lrt_get_alertes_non_liees() OWNER TO pgsql;

--
-- TOC entry 9228 (class 0 OID 0)
-- Dependencies: 296
-- Name: FUNCTION lrt_get_alertes_non_liees(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lrt_get_alertes_non_liees() IS 'retourne les alertes non liees Ãƒ  une formation';


--
-- TOC entry 297 (class 1255 OID 2596977)
-- Dependencies: 2983 7
-- Name: lrt_maj_alerte(integer, character varying, integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lrt_maj_alerte(integer, character varying, integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero alerte
-- $2 : libelle
-- $3 : nb jours
-- $4 : texte
begin
    update v2.alerte set libelle=$2,jours=$3,texte=$4 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lrt_maj_alerte(integer, character varying, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9229 (class 0 OID 0)
-- Dependencies: 297
-- Name: FUNCTION lrt_maj_alerte(integer, character varying, integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lrt_maj_alerte(integer, character varying, integer, character varying) IS 'met Ãƒ  jour une alerte';


--
-- TOC entry 298 (class 1255 OID 2596978)
-- Dependencies: 2983 7
-- Name: lrt_set_alerte(character varying, integer, date, integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lrt_set_alerte(character varying, integer, date, integer, character varying) RETURNS integer
    AS $_$-- $1 : libelle alerte (titre)
-- $2 : numero formation
-- $3 : date (timestamp)
-- $4 : nombre de jours
-- $5 : texte de l'alerte
declare
new_id int4;
res int4;
begin
    insert into v2.alerte(libelle,formation,date,jours,texte) values($1,$2,$3,$4,$5);
    --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.alerte WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lrt_set_alerte(character varying, integer, date, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9230 (class 0 OID 0)
-- Dependencies: 298
-- Name: FUNCTION lrt_set_alerte(character varying, integer, date, integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lrt_set_alerte(character varying, integer, date, integer, character varying) IS 'enregistre une alerte';


--
-- TOC entry 299 (class 1255 OID 2596979)
-- Dependencies: 2983 7
-- Name: lst_get_liste(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lst_get_liste(integer) RETURNS record
    AS $_$DECLARE
--$1 liste
rec RECORD;
BEGIN
	SELECT INTO rec id, E_libelle, type, date_creation FROM v2.liste, v2.af_get_etape($1) AS (E_id int4, E_libelle varchar, E_type int4,date_creation timestamp)
	WHERE id=$1 
	AND id=E_id;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lst_get_liste(integer) OWNER TO pgsql;

--
-- TOC entry 300 (class 1255 OID 2596980)
-- Dependencies: 2983 7
-- Name: lst_get_liste_themes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lst_get_liste_themes(integer) RETURNS SETOF record
    AS $_$declare
rec record;
rec_tmp record;
--$1 liste
categorie int4;
BEGIN
	--recup le type de la liste
	SELECT INTO rec_tmp id, type FROM v2.af_get_liste($1) AS (id int4, libelle varchar, type int4);
	
	IF rec_tmp.id IS NULL THEN
		RAISE EXCEPTION 'La liste d''identifiant % n''existe pas', $1;
	END IF;

	--categorie
	IF rec_tmp.type=1 THEN
		categorie:=19;
	ELSEIF rec_tmp.type=3 THEN
		categorie:=44;
	ELSE 
		RAISE EXCEPTION 'Le type % n''est pas un liste_type valide',rec_tmp.type;
	END IF;

	--requete
	FOR rec IN 
		SELECT * FROM v2.af_get_element_themes_categorie($1,categorie) AS (id int4, libelle varchar)
	LOOP
		return next rec;
	end loop;

	RETURN;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lst_get_liste_themes(integer) OWNER TO pgsql;

--
-- TOC entry 9231 (class 0 OID 0)
-- Dependencies: 300
-- Name: FUNCTION lst_get_liste_themes(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lst_get_liste_themes(integer) IS 'retourne les themes d''une liste ';


--
-- TOC entry 301 (class 1255 OID 2596981)
-- Dependencies: 2983 7
-- Name: lst_get_page_liste(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lst_get_page_liste(integer, integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : liste
-- $4 : page
declare
rec record;
begin
    select into rec titre,commentaire,formation,parcours,liste,page 
    from v2.page_liste 
    where formation=$1 and parcours=$2 and liste=$3 and page=$4;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lst_get_page_liste(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9232 (class 0 OID 0)
-- Dependencies: 301
-- Name: FUNCTION lst_get_page_liste(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lst_get_page_liste(integer, integer, integer, integer) IS 'retourne titre et commentaire d''une page de liste';


--
-- TOC entry 302 (class 1255 OID 2596982)
-- Dependencies: 2983 7
-- Name: lst_get_page_liste_configuration(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lst_get_page_liste_configuration(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : liste
-- $4 : page
declare
rec record;
begin
    for rec in
	select page_element,formation,parcours,liste,page
	from v2.page_liste_configuration 
	where formation=$1 and parcours=$2 and liste=$3 and page=$4
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lst_get_page_liste_configuration(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9233 (class 0 OID 0)
-- Dependencies: 302
-- Name: FUNCTION lst_get_page_liste_configuration(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lst_get_page_liste_configuration(integer, integer, integer, integer) IS 'retourne la configuration d''une page de liste';


--
-- TOC entry 303 (class 1255 OID 2596983)
-- Dependencies: 2983 7
-- Name: lst_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION lst_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : liste
-- $4 : page
-- $5 : tableau d'element
-- $6 : titre
-- $7 : commentaire
declare
i int4;
begin
    for i in array_lower($5,1) .. array_upper($5,1)
    loop
	insert into v2.page_liste_configuration values ($1,$2,$3,$4,$5[i]);
    end loop;
    insert into v2.page_liste values ($1,$2,$3,$4,$6,$7);
return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.lst_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) OWNER TO pgsql;

--
-- TOC entry 9234 (class 0 OID 0)
-- Dependencies: 303
-- Name: FUNCTION lst_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION lst_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) IS 'Enregistre la configuration d''une page de liste';


--
-- TOC entry 304 (class 1255 OID 2596984)
-- Dependencies: 2983 7
-- Name: md_get_medias(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION md_get_medias() RETURNS SETOF record
    AS $$DECLARE
rec record;
BEGIN
	
	FOR  rec IN
		select  id from v2.media
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.md_get_medias() OWNER TO postgres;

--
-- TOC entry 9235 (class 0 OID 0)
-- Dependencies: 304
-- Name: FUNCTION md_get_medias(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION md_get_medias() IS 'retourne le contenu de la table media';


--
-- TOC entry 305 (class 1255 OID 2596985)
-- Dependencies: 2101 2983 7
-- Name: md_set_media(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION md_set_media(integer) RETURNS information_schema.cardinal_number
    AS $_$BEGIN
	insert into media (id) values ($1);
	return FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.md_set_media(integer) OWNER TO postgres;

--
-- TOC entry 9236 (class 0 OID 0)
-- Dependencies: 305
-- Name: FUNCTION md_set_media(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION md_set_media(integer) IS 'FONCTION PRIVEE: creer un nouveau media (enregistre un fichier en tant que media)';


--
-- TOC entry 306 (class 1255 OID 2596986)
-- Dependencies: 2983 7
-- Name: ndvd_del_individu_session(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_del_individu_session(integer) RETURNS boolean
    AS $_$-- $1 : individu
begin
    delete from v2.session where individu=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_del_individu_session(integer) OWNER TO pgsql;

--
-- TOC entry 9237 (class 0 OID 0)
-- Dependencies: 306
-- Name: FUNCTION ndvd_del_individu_session(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_del_individu_session(integer) IS 'supprime la session d''un individu';


--
-- TOC entry 307 (class 1255 OID 2596987)
-- Dependencies: 2983 7
-- Name: ndvd_del_individu_type(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_del_individu_type(integer, integer) RETURNS boolean
    AS $_$begin
    delete from v2.individu_types 
    where individu=$1 and type=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_del_individu_type(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9238 (class 0 OID 0)
-- Dependencies: 307
-- Name: FUNCTION ndvd_del_individu_type(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_del_individu_type(integer, integer) IS 'supprime un type Ãƒ  un individu';


--
-- TOC entry 308 (class 1255 OID 2596988)
-- Dependencies: 2983 7
-- Name: ndvd_del_organisme(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_del_organisme(integer) RETURNS boolean
    AS $_$begin
    delete from v2.organisme
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_del_organisme(integer) OWNER TO pgsql;

--
-- TOC entry 9239 (class 0 OID 0)
-- Dependencies: 308
-- Name: FUNCTION ndvd_del_organisme(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_del_organisme(integer) IS 'supprime un organisme';


--
-- TOC entry 309 (class 1255 OID 2596989)
-- Dependencies: 2983 7
-- Name: ndvd_get_formateur_classes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formateur_classes(integer) RETURNS SETOF record
    AS $_$-- $1 : numero formateur
declare
rec record;

begin
    for rec in 
	select distinct c.id,c.libelle,c.pere,c.min,c.max from v2.classe c ,
	v2.formation_participants pf
	where c.id=pf.classe and pf.formateur=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formateur_classes(integer) OWNER TO pgsql;

--
-- TOC entry 9240 (class 0 OID 0)
-- Dependencies: 309
-- Name: FUNCTION ndvd_get_formateur_classes(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_formateur_classes(integer) IS 'retourne les classes d''un formateur';


--
-- TOC entry 310 (class 1255 OID 2596990)
-- Dependencies: 2983 7
-- Name: ndvd_get_formateur_droits(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formateur_droits(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formateur
-- $2 : classe
declare
rec record;
begin
    for rec in 
	(select * from v2.af_get_formation_droits($1) as (id int4,libelle varchar))
	union
	(select id,libelle from v2.droit,v2.individu_droits where 
	id=droit and classe=$2)
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formateur_droits(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9241 (class 0 OID 0)
-- Dependencies: 310
-- Name: FUNCTION ndvd_get_formateur_droits(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_formateur_droits(integer, integer) IS 'retourne les droits du formateur';


--
-- TOC entry 311 (class 1255 OID 2596991)
-- Dependencies: 2983 7
-- Name: ndvd_get_formateur_formations(integer, character varying, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formateur_formations(integer, character varying, character varying, integer) RETURNS SETOF record
    AS $_$-- $1 : numero formateur
-- $2 : classement (asc ou desc)
-- $3 : order by (libelle ou date debut)
-- $4 : periode (1 : passÃƒÂ©es, 2 : prÃƒÂ©sentes, 3 : futures, 0 toutes)
declare
rec record;
req varchar;
begin
    for rec in
	select f_id,f_libelle,f_parcours,f_date_debut,f_date_fin,f_langue,fp.formateur
	from v2.af_get_formations($2,$3,$4) as (f_id int4,f_libelle varchar,f_parcours int4,f_date_debut date,f_date_fin date,f_langue int4),
	v2.formation_participants fp
	where f_id=fp.formation and fp.formateur=$1
    loop
	return next rec;
    end loop;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formateur_formations(integer, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9242 (class 0 OID 0)
-- Dependencies: 311
-- Name: FUNCTION ndvd_get_formateur_formations(integer, character varying, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_formateur_formations(integer, character varying, character varying, integer) IS 'retourne les formation d''un formateur';


--
-- TOC entry 312 (class 1255 OID 2596992)
-- Dependencies: 2983 7
-- Name: ndvd_get_formateur_individu_formations(integer, character varying, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formateur_individu_formations(integer, character varying, character varying, integer) RETURNS SETOF record
    AS $_$-- $1 : numero formateur
-- $2 : classement (asc ou desc)
-- $3 : order by (libelle ou date debut)
-- $4 : periode (1 : passÃƒÂ©es, 2 : prÃƒÂ©sentes, 3 : futures, 0 toutes)
declare
rec record;
begin
    for rec in
	(select distinct id ,libelle ,parcours ,date_debut ,date_fin ,langue ,formateur, 1
	from v2.af_get_formateur_formations($1,$2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4,formateur int4))
	union
	(select distinct id ,libelle ,parcours ,date_debut ,date_fin ,langue ,formateur, 2
	from v2.af_get_individu_formations($1,$2,$3,$4) 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4,formateur int4))
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formateur_individu_formations(integer, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9243 (class 0 OID 0)
-- Dependencies: 312
-- Name: FUNCTION ndvd_get_formateur_individu_formations(integer, character varying, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_formateur_individu_formations(integer, character varying, character varying, integer) IS 'retourne les formations pour un formateur en tant que formateur et individu';


--
-- TOC entry 313 (class 1255 OID 2596993)
-- Dependencies: 2983 7
-- Name: ndvd_get_formateurs(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formateurs() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select distinct I.id,textcat(textcat(I.nom,text ' '),I.prenom)
	from v2.individu I,v2.formation_participants PF
	where PF.formateur=I.id
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formateurs() OWNER TO pgsql;

--
-- TOC entry 9244 (class 0 OID 0)
-- Dependencies: 313
-- Name: FUNCTION ndvd_get_formateurs(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_formateurs() IS 'retourne les formateurs de la plateforme';


--
-- TOC entry 314 (class 1255 OID 2596994)
-- Dependencies: 2983 7
-- Name: ndvd_get_formation_formateur(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formation_formateur(integer) RETURNS record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
	
	SELECT INTO rec I.id,  I.nom ||' '|| I.prenom, PF.formation
	FROM v2.formation_participants PF, v2.individu I
	WHERE formation=$1
	AND PF.formateur=I.id;

	RETURN rec;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formation_formateur(integer) OWNER TO pgsql;

--
-- TOC entry 315 (class 1255 OID 2596995)
-- Dependencies: 2983 7
-- Name: ndvd_get_formation_individus(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formation_individus(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : classe
declare
rec record;
rec2 record;
begin
    -- Boucle sur les classes de la formation
    for rec in
	select id,libelle,pere,min,max from v2.af_get_formation_classes($1)
    loop
	for rec2 in
	    select distinct id,nom,prenom,organisme 
	    from v2.af_get_classe_individus(rec.id,0,'asc',false) 
        loop
	    return next rec2;
        end loop;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formation_individus(integer, integer) OWNER TO pgsql;

--
-- TOC entry 316 (class 1255 OID 2596996)
-- Dependencies: 2983 7
-- Name: ndvd_get_formation_individus(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formation_individus(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : classe
declare
rec record;
rec2 record;
begin
    -- Boucle sur les classes de la formation
    for rec in
	select id,libelle,pere,min,max from v2.af_get_formation_classes($1)  as (id int4,libelle varchar, pere int4,min int4,max int4)
    loop
	for rec2 in
	    select distinct id,nom,prenom,organisme 
	    from v2.af_get_classe_individus(rec.id,0,'asc',false)  
        loop
	    return next rec2;
        end loop;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formation_individus(integer) OWNER TO pgsql;

--
-- TOC entry 9245 (class 0 OID 0)
-- Dependencies: 316
-- Name: FUNCTION ndvd_get_formation_individus(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_formation_individus(integer) IS 'retourne les individus d''une formation 
(ceux qui sont dans la classe)';


--
-- TOC entry 317 (class 1255 OID 2596997)
-- Dependencies: 2983 7
-- Name: ndvd_get_formation_intervenants(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formation_intervenants(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select distinct id,nom,prenom from v2.individu i ,v2.evenement 
	where id=intervenant and formation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formation_intervenants(integer) OWNER TO pgsql;

--
-- TOC entry 9246 (class 0 OID 0)
-- Dependencies: 317
-- Name: FUNCTION ndvd_get_formation_intervenants(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_formation_intervenants(integer) IS 'retourne les intervenants de la formation';


--
-- TOC entry 318 (class 1255 OID 2596998)
-- Dependencies: 2983 7
-- Name: ndvd_get_formation_participants(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_formation_participants(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
	FOR rec IN
		SELECT formation, formateur, classe
		FROM v2.formation_participants
		WHERE formation=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_formation_participants(integer) OWNER TO pgsql;

--
-- TOC entry 319 (class 1255 OID 2596999)
-- Dependencies: 2983 7
-- Name: ndvd_get_individu(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individu(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec id, identifiant_md5 ,login ,password ,nom ,prenom ,adresse ,code ,ville ,
		email ,tel_fixe ,tel_port ,langue,organisme ,photo  from v2.individu where id=$1;
    return rec;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individu(integer) OWNER TO pgsql;

--
-- TOC entry 9247 (class 0 OID 0)
-- Dependencies: 319
-- Name: FUNCTION ndvd_get_individu(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_individu(integer) IS 'retourne les in infos d''un individu';


--
-- TOC entry 320 (class 1255 OID 2597000)
-- Dependencies: 2983 7
-- Name: ndvd_get_individu(character varying, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individu(character varying, character varying) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec id , identifiant_md5 ,login , password, nom , prenom , adresse , code , ville ,email , tel_fixe , tel_port , langue , organisme, photo FROM v2.individu
	WHERE login LIKE $1
	AND password LIKE $2;
	
	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individu(character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 321 (class 1255 OID 2597001)
-- Dependencies: 2983 7
-- Name: ndvd_get_individu_date_connexion_max(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individu_date_connexion_max(integer) RETURNS record
    AS $_$-- $1 : individu
declare
rec record;
begin
    select into rec max(connexion) from v2.connexion where individu=$1;
    return rec;    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individu_date_connexion_max(integer) OWNER TO pgsql;

--
-- TOC entry 9248 (class 0 OID 0)
-- Dependencies: 321
-- Name: FUNCTION ndvd_get_individu_date_connexion_max(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_individu_date_connexion_max(integer) IS 'retourne la date de connexion max pour un individu';


--
-- TOC entry 322 (class 1255 OID 2597002)
-- Dependencies: 2983 7
-- Name: ndvd_get_individu_date_deconnexion_max(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individu_date_deconnexion_max(integer) RETURNS record
    AS $_$-- $1 : individu
declare
rec record;
begin
    select into rec max(deconnexion) from v2.connexion where individu=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individu_date_deconnexion_max(integer) OWNER TO pgsql;

--
-- TOC entry 9249 (class 0 OID 0)
-- Dependencies: 322
-- Name: FUNCTION ndvd_get_individu_date_deconnexion_max(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_individu_date_deconnexion_max(integer) IS 'retourne la date de deconnexion max pour un individu';


--
-- TOC entry 323 (class 1255 OID 2597003)
-- Dependencies: 2983 7
-- Name: ndvd_get_individu_filieres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individu_filieres(integer) RETURNS SETOF record
    AS $_$-- $1 : individu
declare
rec record;
begin
    for rec in
	--voir avec remi pour l'optimisation
	/*
	select fil.id,fil.libelle from 
	v2.filiere fil,
	v2.parcours par,
	v2.formation for,
	v2.formation_participants fp,
	v2.classe_individus ci 
	where ...
	*/
	select fil.id,fil.libelle from v2.filiere fil where fil.id in 
	(select par.filiere from v2.parcours par where par.id in 
	(select form.parcours from v2.formation form where form.id in 
	(select fp.formation from v2.formation_participants fp where fp.classe in 
	(select ci.classe from v2.classe_individus ci where ci.individu=$1))))
	
    loop
	return next rec;
    end loop;
	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individu_filieres(integer) OWNER TO pgsql;

--
-- TOC entry 9250 (class 0 OID 0)
-- Dependencies: 323
-- Name: FUNCTION ndvd_get_individu_filieres(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_individu_filieres(integer) IS 'retourne les filieres de formation d''un individu';


--
-- TOC entry 324 (class 1255 OID 2597004)
-- Dependencies: 2983 7
-- Name: ndvd_get_individu_nom_prenom(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individu_nom_prenom(integer) RETURNS record
    AS $_$-- $1 : numero individu
declare
rec record;
begin
    select into rec 
    id,nom,prenom from v2.individu where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individu_nom_prenom(integer) OWNER TO pgsql;

--
-- TOC entry 9251 (class 0 OID 0)
-- Dependencies: 324
-- Name: FUNCTION ndvd_get_individu_nom_prenom(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_individu_nom_prenom(integer) IS 'retourne nom et prenom d''un individu';


--
-- TOC entry 325 (class 1255 OID 2597005)
-- Dependencies: 2983 7
-- Name: ndvd_get_individu_types(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individu_types(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
    for rec in 
	select id,libelle from v2.individu_type,v2.individu_types 
	where id=type and individu=$1 order by id
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individu_types(integer) OWNER TO pgsql;

--
-- TOC entry 9252 (class 0 OID 0)
-- Dependencies: 325
-- Name: FUNCTION ndvd_get_individu_types(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_individu_types(integer) IS 'retourne les types d''un individu';


--
-- TOC entry 326 (class 1255 OID 2597006)
-- Dependencies: 2983 7
-- Name: ndvd_get_individus(integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individus(integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 (0=>tous, 1=>formateurs, 2=>utilisateurs)
-- $2 (asc ou desc)
-- $3 (vrai => que les utilisateurs ou que les formateurs)
declare
rec record;
req varchar;
begin
    req:='select distinct id,nom,prenom,organisme from v2.individu,v2.individu_types IT1 ';
    if $3 is true then
	req:= req || ',v2.individu_types IT2 ' ;
    end if;
    if $1 !=0 then
	req:= req || ' where ';
    end if;
    -- suite req
    if $1=1 then -- LES FORMATEURS
	if $3 is true then -- LES FORMATEURS STRICT
	    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1   ';
	    req:=req || ' and id =IT1.individu AND IT1.type=2';
	else
	    req:=req || ' id =IT1.individu AND IT1.type=2';
	end if;
	
    else
	if $1=2 then -- LES STAGIAIRES
	    if $3 is true then -- LES STAGIAIRES STRICT
	        req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		req:=req || ' and id =IT1.individu AND IT1.type=1';
	    else
		req:=req || ' id =IT1.individu AND IT1.type=1';
	    end if;
	    
	--/*
	else
	    if $1=3 then --LES INTERVENANTS
		if $3 is true then -- LES INTERVENANTS STRICT 
		    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		    req:=req || ' and id =IT1.individu AND IT1.type=3';
	        else
		    req:=req || ' id =IT1.individu AND IT1.type=3';     
	        end if;
	    --else
		--raise exception 'la valeur pour le paramÃƒÂ¨tre 3 (type) doit ÃƒÂªtre 1,2 ou 0';
	    end if;
	--*/
	end if;
	
    end if;

    -- classement
    if $2 like 'DESC' then
	req:=req || ' order by nom desc ';
    else
	req:=req || ' order by nom ';
    end if;

	 raise notice 'req=%',req;
for rec in
	execute req
loop
return next rec;
end loop;
return ;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individus(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 9253 (class 0 OID 0)
-- Dependencies: 326
-- Name: FUNCTION ndvd_get_individus(integer, character varying, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_individus(integer, character varying, boolean) IS 'retourne les individus de la plateforme';


--
-- TOC entry 327 (class 1255 OID 2597007)
-- Dependencies: 2983 7
-- Name: ndvd_get_individus_infos(integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individus_infos(integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 : type d'individu (0=tous, 1=formateurs & 2=stagiaires)
-- $2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- $3. exclusif : si VRAI alors que les 'u' ou les
declare
rec record;
req varchar;
begin
    req:='select distinct id,identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo from v2.individu,v2.individu_types IT1 ';
    if $3 is true then
	req:= req || ',v2.individu_types IT2 ' ;
    end if;
    if $1 !=0 then
	req:= req || ' where ';
    end if;
    -- suite req
    if $1=1 then -- LES FORMATEURS
	if $3 is true then -- LES FORMATEURS STRICT
	    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type,identifiant_md5,login,password, nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  having count(IT2.type)=1   ';
	    req:=req || ' and id =IT1.individu AND IT1.type=2';
	else
	    req:=req || ' id =IT1.individu AND IT1.type=2';
	end if;
	
    else
	if $1=2 then -- LES STAGIAIRES
	    if $3 is true then -- LES STAGIAIRES STRICT
	        req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type,identifiant_md5,login,password, nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo  having count(IT2.type)=1 '; 
		req:=req || ' and id =IT1.individu AND IT1.type=1';
	    else
		req:=req || ' id =IT1.individu AND IT1.type=1';
	    end if;
	    
	--/*
	else
	    if $1=3 then --LES INTERVENANTS
		if $3 is true then -- LES INTERVENANTS STRICT 
		    req:=req || '  id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom,organisme  having count(IT2.type)=1 '; 
		    req:=req || ' and id =IT1.individu AND IT1.type=3';
	        else
		    req:=req || ' id =IT1.individu AND IT1.type=3';     
	        end if;
	    --else
		--raise exception 'la valeur pour le paramÃƒÂ¨tre 3 (type) doit ÃƒÂªtre 1,2 ou 0';
	    end if;
	--*/
	end if;
	
    end if;

    -- classement
    if $2 like 'DESC' then
	req:=req || ' order by nom desc ';
    else
	req:=req || ' order by nom ';
    end if;

	 raise notice 'req=%',req; 
    for rec in
	execute req
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individus_infos(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 9254 (class 0 OID 0)
-- Dependencies: 327
-- Name: FUNCTION ndvd_get_individus_infos(integer, character varying, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_individus_infos(integer, character varying, boolean) IS 'Retourne les infos individus de la plateforme';


--
-- TOC entry 328 (class 1255 OID 2597008)
-- Dependencies: 2983 7
-- Name: ndvd_get_individus_initiale(character varying, integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_individus_initiale(character varying, integer, character varying, boolean) RETURNS SETOF record
    AS $_$-- $1 : initiale
-- $2 : type d'individu
-- $3 : classement (asc ou desc)
-- $4 : bool (excusif)
declare
rec record;
begin
    for rec in 
	select distinct id,nom,prenom from v2.af_get_individus($2,$3,$4) 
	--select * from v2.af_get_individus($2,$3,$4) 
	AS (id integer, nom varchar, prenom varchar,organisme int4) 
	where nom like $1 || '%' 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_individus_initiale(character varying, integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 9255 (class 0 OID 0)
-- Dependencies: 328
-- Name: FUNCTION ndvd_get_individus_initiale(character varying, integer, character varying, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_individus_initiale(character varying, integer, character varying, boolean) IS 'retourne les individus dont le nom commence par l''initiale';


--
-- TOC entry 329 (class 1255 OID 2597009)
-- Dependencies: 2983 7
-- Name: ndvd_get_organisme(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_organisme(integer) RETURNS record
    AS $_$declare
rec record;

begin
    select into rec id,libelle 
    from v2.organisme where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_organisme(integer) OWNER TO pgsql;

--
-- TOC entry 9256 (class 0 OID 0)
-- Dependencies: 329
-- Name: FUNCTION ndvd_get_organisme(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_organisme(integer) IS 'retourne lid et le libelle d''un organisme';


--
-- TOC entry 330 (class 1255 OID 2597010)
-- Dependencies: 2983 7
-- Name: ndvd_get_organisme_individus(integer, character varying, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_organisme_individus(integer, character varying, integer, boolean) RETURNS SETOF record
    AS $_$-- Retourne les informations des infividus appartenant ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  l'organisme

-- Parametres :
-- 1. Identifiant de l'organisme
-- 2. ASC ou DESC = affichage dans l'ordre croissant ou decroissant
-- 3. Type : 0=tous, 1=formateurs & 2=stagiaires
-- 4. exclusif : si VRAI alors que les 'u' ou les 'f'
declare
rec record;
req varchar;

begin
    req:='select distinct id,nom,prenom,login,password from v2.individu,v2.individu_types IT1 ' ;
    if $4 is true then
	req:= req || ',v2.individu_types IT2 ' ;
    end if;
    req:= req || 'where IT1.individu=id and ';
    -- multi org ?
    if $1 is null then
	req:=req || 'organisme is null ';
    else
	req:=req || 'organisme ='||$1;
    end if;
    -- suite req
    if $3=1 then -- LES FORMATEURS
	if $4 is true then -- LES FORMATEURS STRICT
	    req:=req || ' and id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom  having count(IT2.type)=1   ';
	end if;
	req:=req || 'and id =IT1.individu AND IT1.type=2';
    else
	if $3=2 then -- LES STAGIAIRES
	    if $4 is true then -- LES STAGIAIRES STRICT
	        req:=req || ' and id =IT2.individu group by IT2.individu, IT1.individu, id, IT1.type, nom,prenom  having count(IT2.type)=1 '; 
	    end if;
	    req:=req || 'and id =IT1.individu AND IT1.type=1';
	else
	    if $3=0 then --LES FORMATEURS ET STAGIAIRES
		if $4 is true then -- LES FORMATEURS STRICT ET STAGIAIRES STRICT
		    req='select individu,nom,prenom,login,password from v2.individu,v2.individu_types where individu=id and organisme ='||$1||' group by individu,nom,prenom having count(individu)=1'; 
	        end if;
	    else
		raise exception 'la valeur pour le paramÃƒÂ¨tre 3 (type) doit ÃƒÂªtre 1,2 ou 0';
	    end if;
	end if;

    end if;

    -- classement
    if $2 like 'DESC' then
	req:=req || 'order by nom desc ';
    else
	req:=req || 'order by nom ';
    end if;

	raise notice 'req=%',req;
for rec in
	execute req
loop
return next rec;
end loop;
return ;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_organisme_individus(integer, character varying, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 9257 (class 0 OID 0)
-- Dependencies: 330
-- Name: FUNCTION ndvd_get_organisme_individus(integer, character varying, integer, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_organisme_individus(integer, character varying, integer, boolean) IS 'retourne les individus d''un organisme';


--
-- TOC entry 331 (class 1255 OID 2597011)
-- Dependencies: 2983 7
-- Name: ndvd_get_organismes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_organismes() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle from v2.organisme order by libelle
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_organismes() OWNER TO pgsql;

--
-- TOC entry 9258 (class 0 OID 0)
-- Dependencies: 331
-- Name: FUNCTION ndvd_get_organismes(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_organismes() IS 'retourne les organismes de la plateforme';


--
-- TOC entry 332 (class 1255 OID 2597012)
-- Dependencies: 2983 7
-- Name: ndvd_get_organismes_non_vide(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_organismes_non_vide() RETURNS SETOF record
    AS $$declare
rec record;

begin
    for rec in 
	select distinct O_id,O_libelle from v2.af_get_organismes() as (O_id int4,O_libelle "varchar"),v2.individu I 
	where O_id=I.organisme
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_organismes_non_vide() OWNER TO pgsql;

--
-- TOC entry 9259 (class 0 OID 0)
-- Dependencies: 332
-- Name: FUNCTION ndvd_get_organismes_non_vide(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_organismes_non_vide() IS 'retourne les organismes pour lesquels il y a des individus';


--
-- TOC entry 333 (class 1255 OID 2597013)
-- Dependencies: 2983 7
-- Name: ndvd_get_stagiaires_formation(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_get_stagiaires_formation() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct i.id,i.nom,i.prenom
	from v2.individu i,v2.classe_individus ci,v2.formation_participants fp
	where i.id=ci.individu and ci.classe=fp.classe
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_get_stagiaires_formation() OWNER TO pgsql;

--
-- TOC entry 9260 (class 0 OID 0)
-- Dependencies: 333
-- Name: FUNCTION ndvd_get_stagiaires_formation(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_get_stagiaires_formation() IS 'retourne les stagiaires des formations de la plateforme';


--
-- TOC entry 334 (class 1255 OID 2597014)
-- Dependencies: 2983 7
-- Name: ndvd_is_individu_supprimable(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_is_individu_supprimable(integer) RETURNS boolean
    AS $_$-- $1 : individu
declare
nb_rec int4;
begin
    -- si admin ou formateur temporaire,alors pas de suppression
    perform * from v2.individu where id=$1 and login='temporaire' and password='temporaire';
    if found then
	return false;
    end if;
    perform * from v2.individu where id=$1 and login='admin' and password='admin';
    if found then
	return false;
    end if;
    -- si intervenant ou formateur,alors pas de suppression
    perform * from v2.evenement where intervenant=$1;
    if found then
	return false;
    end if;
    perform * from v2.formation_participants where formateur=$1;
    if found then
	return false;
    end if;
    -- si affiliÃƒÂ© Ãƒ  une classe,alors pas de suppression
    perform * from v2.af_get_individu_classes($1) as (id int4,libelle varchar,pere int4,min int4,max int4);
    GET DIAGNOSTICS nb_rec = ROW_COUNT;
    if nb_rec>0 then
	return false;
    end if;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_is_individu_supprimable(integer) OWNER TO pgsql;

--
-- TOC entry 9261 (class 0 OID 0)
-- Dependencies: 334
-- Name: FUNCTION ndvd_is_individu_supprimable(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_is_individu_supprimable(integer) IS 'retourne vrai si un individu est supprimable';


--
-- TOC entry 335 (class 1255 OID 2597015)
-- Dependencies: 2983 7
-- Name: ndvd_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) RETURNS boolean
    AS $_$declare
fait boolean;
begin
    update v2.individu 
    set login=$2,password=$3,nom=$4,prenom=$5,adresse=$6,code=$7,ville=$8,email=$9,tel_fixe=$10,tel_port=$11,langue=$12,organisme=$13,photo=$14 
    where id=$1;
    fait:=found;
    -- insertion type (formateur,utilisateur ...)
    -- On efface avant
    delete from v2.individu_types where individu=$1;
    for i in array_lower($15,1)..array_upper($15,1)
	loop
	perform * from v2.af_set_individu_type($15[i],$1);
	end loop;
    fait:=fait or found;
    return fait;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 9262 (class 0 OID 0)
-- Dependencies: 335
-- Name: FUNCTION ndvd_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) IS 'met Ãƒ  jour un individu';


--
-- TOC entry 336 (class 1255 OID 2597016)
-- Dependencies: 2983 7
-- Name: ndvd_maj_individu_date_deconnexion(integer, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_maj_individu_date_deconnexion(integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : individu
-- $2 : date deconnexion
begin
    update v2.connexion set deconnexion=$2 
    where individu=$1 
    and connexion in 
    (select max(connexion) from v2.connexion where individu=$1);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_maj_individu_date_deconnexion(integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9263 (class 0 OID 0)
-- Dependencies: 336
-- Name: FUNCTION ndvd_maj_individu_date_deconnexion(integer, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_maj_individu_date_deconnexion(integer, timestamp without time zone) IS 'met Ãƒ  jour la date de deconnexion pour un individu';


--
-- TOC entry 337 (class 1255 OID 2597017)
-- Dependencies: 2983 7
-- Name: ndvd_maj_individu_session(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_maj_individu_session(integer, integer) RETURNS boolean
    AS $_$-- $1 : individu
-- $2 : formation
begin
    update v2.session set formation=$2 where individu=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_maj_individu_session(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9264 (class 0 OID 0)
-- Dependencies: 337
-- Name: FUNCTION ndvd_maj_individu_session(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_maj_individu_session(integer, integer) IS 'met Ãƒ  jour la session d''un individu';


--
-- TOC entry 338 (class 1255 OID 2597018)
-- Dependencies: 2983 7
-- Name: ndvd_maj_organisme(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_maj_organisme(integer, character varying) RETURNS boolean
    AS $_$begin
    update v2.organisme 
    set libelle=$2 where id=$1;
    return FOUND;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_maj_organisme(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9265 (class 0 OID 0)
-- Dependencies: 338
-- Name: FUNCTION ndvd_maj_organisme(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_maj_organisme(integer, character varying) IS 'met Ãƒ  jour un organisme';


--
-- TOC entry 339 (class 1255 OID 2597019)
-- Dependencies: 2983 7
-- Name: ndvd_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) RETURNS integer
    AS $_$declare
new_id int4;
res int4;
i int4;
begin
    insert into 
    v2.individu(identifiant_md5,login,password,nom,prenom,adresse,code,ville,email,tel_fixe,tel_port,langue,organisme,photo) 
    values($1,$2,$3,$4,$5,$6,$7,$8,$9,$10,$11,$12,$13,$14);
    -- recup id
    GET DIAGNOSTICS new_id=RESULT_OID;
    select into res id from v2.individu 
    where oid=new_id;
    -- insertion type (formateur,utilisateur ...)
    for i in array_lower($15,1)..array_upper($15,1)
	loop
	perform * from v2.af_set_individu_type($15[i],res);
	end loop;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 9266 (class 0 OID 0)
-- Dependencies: 339
-- Name: FUNCTION ndvd_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) IS 'enregistre un individu';


--
-- TOC entry 340 (class 1255 OID 2597020)
-- Dependencies: 2983 7
-- Name: ndvd_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) RETURNS boolean
    AS $_$-- $1 : individu
-- $2 : date connexion (int4)
-- $3 : date deconnexion (int4)
-- $4 : ip
begin
    insert into v2.connexion(individu,connexion,deconnexion,ip) values($1,$2,$2,$4);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) OWNER TO pgsql;

--
-- TOC entry 9267 (class 0 OID 0)
-- Dependencies: 340
-- Name: FUNCTION ndvd_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) IS 'enregistre les dates  connexion et deconnexion pour un individu';


--
-- TOC entry 341 (class 1255 OID 2597021)
-- Dependencies: 2983 7
-- Name: ndvd_set_individu_droit_classe(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_set_individu_droit_classe(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero individu
-- $2 : numero classe
-- $3 : numero droit
begin
    insert into v2.individu_droits(individu,classe,droit) values ($1,$2,$3);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_set_individu_droit_classe(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9268 (class 0 OID 0)
-- Dependencies: 341
-- Name: FUNCTION ndvd_set_individu_droit_classe(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_set_individu_droit_classe(integer, integer, integer) IS 'enregistre un droit pour un individu et une classe';


--
-- TOC entry 342 (class 1255 OID 2597022)
-- Dependencies: 2983 7
-- Name: ndvd_set_individu_droits_classe(integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_set_individu_droits_classe(integer, integer, integer[]) RETURNS boolean
    AS $_$-- $1 nÃ‚Â° individu
-- $2 nÃ‚Â° classe
-- $3 tableau de droits
declare
i int4;
begin
    for i in array_lower($3,1) .. array_upper($3,1)
loop
    insert into v2.individu_droits(individu,classe,droit) values ($1,$2,$3[i]);
end loop;
return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_set_individu_droits_classe(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 9269 (class 0 OID 0)
-- Dependencies: 342
-- Name: FUNCTION ndvd_set_individu_droits_classe(integer, integer, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_set_individu_droits_classe(integer, integer, integer[]) IS 'enregistre les droits pour un individu et une classe';


--
-- TOC entry 343 (class 1255 OID 2597023)
-- Dependencies: 2983 7
-- Name: ndvd_set_individu_session(integer, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_set_individu_session(integer, character varying, integer) RETURNS boolean
    AS $_$-- $1 : individu
-- $2 : id session
-- $3 : formation
begin
    insert into v2.session (individu,session,formation) values($1,$2,$3);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_set_individu_session(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9270 (class 0 OID 0)
-- Dependencies: 343
-- Name: FUNCTION ndvd_set_individu_session(integer, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_set_individu_session(integer, character varying, integer) IS 'enregistre la session pour un individu';


--
-- TOC entry 344 (class 1255 OID 2597024)
-- Dependencies: 2983 7
-- Name: ndvd_set_individu_type(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_set_individu_type(integer, integer) RETURNS boolean
    AS $_$begin
    insert into v2.individu_types("type",individu) values($1,$2);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_set_individu_type(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9271 (class 0 OID 0)
-- Dependencies: 344
-- Name: FUNCTION ndvd_set_individu_type(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_set_individu_type(integer, integer) IS 'enregistre un type (formateur,utilisateur,intervenant...) pour un individu';


--
-- TOC entry 345 (class 1255 OID 2597025)
-- Dependencies: 2983 7
-- Name: ndvd_set_organisme(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION ndvd_set_organisme(character varying) RETURNS integer
    AS $_$declare
new_id int4;
res int4;
begin
    insert into v2.organisme(libelle) values($1);
    -- recup id
    GET DIAGNOSTICS new_id=RESULT_OID;
    select into res id from v2.organisme 
    where oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.ndvd_set_organisme(character varying) OWNER TO pgsql;

--
-- TOC entry 9272 (class 0 OID 0)
-- Dependencies: 345
-- Name: FUNCTION ndvd_set_organisme(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION ndvd_set_organisme(character varying) IS 'enregistre un organisme';


--
-- TOC entry 346 (class 1255 OID 2597026)
-- Dependencies: 2983 7
-- Name: pg_del_page_annuaire_configuration(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pg_del_page_annuaire_configuration(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : type individu
begin
    delete from v2.page_annuaire_configuration 
    where formation=$1 and page=$2 and individu_type=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pg_del_page_annuaire_configuration(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9273 (class 0 OID 0)
-- Dependencies: 346
-- Name: FUNCTION pg_del_page_annuaire_configuration(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pg_del_page_annuaire_configuration(integer, integer, integer) IS 'Supprime la configuration de la page d''annuaire';


--
-- TOC entry 347 (class 1255 OID 2597027)
-- Dependencies: 2983 7
-- Name: pg_del_page_liste_configuration(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pg_del_page_liste_configuration(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : liste
-- $4 : page
begin
    delete from v2.page_liste_configuration 
    where formation=$1 and parcours=$2 and liste=$3 and page=$4;
    delete from v2.page_liste 
    where formation=$1 and parcours=$2 and liste=$3 and page=$4;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pg_del_page_liste_configuration(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9274 (class 0 OID 0)
-- Dependencies: 347
-- Name: FUNCTION pg_del_page_liste_configuration(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pg_del_page_liste_configuration(integer, integer, integer, integer) IS 'Supprile la configuration d''une page de liste';


--
-- TOC entry 348 (class 1255 OID 2597028)
-- Dependencies: 2983 7
-- Name: pg_get_page_annuaire_configuration(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pg_get_page_annuaire_configuration(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : type individu
declare
rec record;
begin
    for rec in 
	select page_element,formation,page,individu_type
	from v2.page_annuaire_configuration 
	where formation=$1 and individu_type=$3
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pg_get_page_annuaire_configuration(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9275 (class 0 OID 0)
-- Dependencies: 348
-- Name: FUNCTION pg_get_page_annuaire_configuration(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pg_get_page_annuaire_configuration(integer, integer, integer) IS 'retourne la configuration d''une page d''annuaire';


--
-- TOC entry 349 (class 1255 OID 2597029)
-- Dependencies: 2983 7
-- Name: pg_get_page_commentaire(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pg_get_page_commentaire(integer, integer, integer) RETURNS record
    AS $_$-- $1 : page
-- $2 : formation
-- $3 : stagiaire
declare
rec record;
begin
    select into rec * from v2.page_commentaire 
    where page=$1 and formation=$2 and stagiaire=$3;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pg_get_page_commentaire(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9276 (class 0 OID 0)
-- Dependencies: 349
-- Name: FUNCTION pg_get_page_commentaire(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pg_get_page_commentaire(integer, integer, integer) IS 'retourne le commentaire pour une page';


--
-- TOC entry 350 (class 1255 OID 2597030)
-- Dependencies: 2983 7
-- Name: pg_get_page_elements(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pg_get_page_elements(integer) RETURNS SETOF record
    AS $_$-- $1 : page
declare
rec record;
begin
    for rec in
	select id,libelle,page from v2.af_get_page_elements() as (id int4,libelle varchar),v2.page_elements 
	where id=page_element and page=$1 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pg_get_page_elements(integer) OWNER TO pgsql;

--
-- TOC entry 9277 (class 0 OID 0)
-- Dependencies: 350
-- Name: FUNCTION pg_get_page_elements(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pg_get_page_elements(integer) IS 'retourne les elements pour une page';


--
-- TOC entry 351 (class 1255 OID 2597031)
-- Dependencies: 2983 7
-- Name: pg_get_page_elements(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pg_get_page_elements() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select id,libelle from v2.page_element
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pg_get_page_elements() OWNER TO pgsql;

--
-- TOC entry 9278 (class 0 OID 0)
-- Dependencies: 351
-- Name: FUNCTION pg_get_page_elements(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pg_get_page_elements() IS 'retourne les elements (des pages) de la plateforme';


--
-- TOC entry 352 (class 1255 OID 2597032)
-- Dependencies: 2983 7
-- Name: pg_get_page_type_pages(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pg_get_page_type_pages(integer) RETURNS SETOF record
    AS $_$-- $1 : type de page
declare
rec record;
begin
    for rec in
	select * from v2.page where type=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pg_get_page_type_pages(integer) OWNER TO pgsql;

--
-- TOC entry 9279 (class 0 OID 0)
-- Dependencies: 352
-- Name: FUNCTION pg_get_page_type_pages(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pg_get_page_type_pages(integer) IS 'retourne les page d''un type de page';


--
-- TOC entry 353 (class 1255 OID 2597033)
-- Dependencies: 2983 7
-- Name: pg_get_pages_types(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pg_get_pages_types() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,code from v2.page_type
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pg_get_pages_types() OWNER TO pgsql;

--
-- TOC entry 9280 (class 0 OID 0)
-- Dependencies: 353
-- Name: FUNCTION pg_get_pages_types(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pg_get_pages_types() IS 'retourne les types de page de la plateforme';


--
-- TOC entry 354 (class 1255 OID 2597034)
-- Dependencies: 2983 7
-- Name: pg_set_page_annuaire_configuration(integer, integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pg_set_page_annuaire_configuration(integer, integer, integer, integer[]) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : type individu
-- $4 : tableau d'elements
declare
i int4;
begin
    for i in array_lower($4,1) .. array_upper($4,1)
    loop
	insert into v2.page_annuaire_configuration values ($1,$2,$3,$4[i]);
    end loop;
return true;


end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pg_set_page_annuaire_configuration(integer, integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 9281 (class 0 OID 0)
-- Dependencies: 354
-- Name: FUNCTION pg_set_page_annuaire_configuration(integer, integer, integer, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pg_set_page_annuaire_configuration(integer, integer, integer, integer[]) IS 'enregistre la configuration de la page annuaire';


--
-- TOC entry 355 (class 1255 OID 2597035)
-- Dependencies: 2983 7
-- Name: prcrs_get_etape_parcours_oriente_configuration(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_etape_parcours_oriente_configuration(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 etape
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, type, seuil, sous_parcours
		FROM v2.parcours_oriente PO
		WHERE PO.id=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_etape_parcours_oriente_configuration(integer) OWNER TO pgsql;

--
-- TOC entry 356 (class 1255 OID 2597036)
-- Dependencies: 2983 7
-- Name: prcrs_get_etape_parcourss(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_etape_parcourss(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT parcours ,libelle , filiere , duree, etape , date_creation 
		FROM v2.parcours_etapes LEFT OUTER JOIN 
		v2.af_get_parcours() AS (id int4, libelle varchar, filiere int4, duree bool, date_creation timestamp) 
		ON (parcours=id)
		WHERE etape=$1
		ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_etape_parcourss(integer) OWNER TO pgsql;

--
-- TOC entry 9282 (class 0 OID 0)
-- Dependencies: 356
-- Name: FUNCTION prcrs_get_etape_parcourss(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_etape_parcourss(integer) IS 'Obtenir les numero des parcours qui contiennent une ÃƒÆ’Ã‚Â©tape donnÃƒÆ’Ã‚Â©e';


--
-- TOC entry 357 (class 1255 OID 2597037)
-- Dependencies: 2983 7
-- Name: prcrs_get_filiere(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_filiere(integer) RETURNS record
    AS $_$DECLARE
--$1 filiere
rec RECORD;
BEGIN
	SELECT INTO rec id, libelle, pere FROM v2.filiere
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_filiere(integer) OWNER TO pgsql;

--
-- TOC entry 358 (class 1255 OID 2597038)
-- Dependencies: 2983 7
-- Name: prcrs_get_filiere_sous_parcourss_disponibles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_filiere_sous_parcourss_disponibles(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 filiere
ss_filieres RECORD;
parcourss RECORD;
BEGIN
	--selection des sous filieres de la filiere
	FOR ss_filieres IN
		SELECT id FROM v2.af_get_filiere_sous_filieres($1) AS (id int4, libelle varchar, pere int4)
	LOOP
		--selection des parcours de chacunes des filieres
		FOR parcourss IN
			SELECT * FROM v2.af_get_filiere_parcourss(ss_filieres.id) AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool)
		LOOP
			RETURN NEXT parcourss;
			
		END LOOP;
		
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_filiere_sous_parcourss_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 359 (class 1255 OID 2597039)
-- Dependencies: 2983 7
-- Name: prcrs_get_filieres_parcours(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_filieres_parcours() RETURNS SETOF record
    AS $_$DECLARE
--$1 idendifiant de la filiere de depart 

--Il doit etre Ãƒ  NULL pour obtenir toutes les filieres et sous filieres ayant des parcours,
--dans l'ordre (une filiere et ses sous filieres, puis une autre filiere et ses sous filieres, etc...
rec RECORD;
BEGIN
	FOR rec IN
		--on recupere toutes les filieres principales
		SELECT id, libelle, pere 
		FROM v2.af_get_filieres_sous_filieres(NULL) AS (id int4, libelle varchar, pere int4)
		
	LOOP
		--si la filiere principale a des parcours, on la retourne
		PERFORM P_filiere
		FROM v2.af_get_parcours() AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool)
		WHERE P_filiere=rec.id;
		
		IF FOUND THEN
			RETURN NEXT rec;
		END IF;

		--FOR rec1 IN
		--	SELECT v2.af_get_filieres_parcours()
		--on recupere les sous filieres de la filiere principale en cours
		SELECT DISTINCT id, libelle, pere 
		FROM v2.af_get_filieres_sous_filieres(rec.id) AS (id int4, libelle varchar, pere int4)
		LEFT OUTER JOIN
		v2.af_get_parcours() AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool)
		ON (id=P_filiere)
		WHERE P_id IS NOT NULL;
	
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_filieres_parcours() OWNER TO pgsql;

--
-- TOC entry 9283 (class 0 OID 0)
-- Dependencies: 359
-- Name: FUNCTION prcrs_get_filieres_parcours(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_filieres_parcours() IS 'Obtenir les filieres ayant des parcours.
$1 doit etre Ãƒ  NULL pour obtenir toutes les filieres et sous filieres ayant des parcours, dans l''ordre (une filiere et ses sous filieres, puis une autre filiere et ses sous filieres, etc...';


--
-- TOC entry 360 (class 1255 OID 2597040)
-- Dependencies: 2983 7
-- Name: prcrs_get_formation_individu_parcours_score(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_formation_individu_parcours_score(integer, integer, integer) RETURNS real
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : parcours
declare
score_series real;
score_exotlcs real;
total real;
nb integer;
begin
    nb:=0;
    total:=0;
    select into score_series * from v2.af_get_formation_individu_parcours_series_score($1,$2,$3);
    if score_series is not null then
	total:=total+score_series;
	nb:=nb+1;
    end if;
    select into score_exotlcs * from v2.af_get_formation_individu_parcours_exotlcs_score($1,$2,$3);
    if score_exotlcs is not null then
	total:=total+score_exotlcs;
	nb:=nb+1;
    end if;
    if nb=0 then
	return false;
    else
	return total/nb;
    end if;
    

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_formation_individu_parcours_score(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9284 (class 0 OID 0)
-- Dependencies: 360
-- Name: FUNCTION prcrs_get_formation_individu_parcours_score(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_formation_individu_parcours_score(integer, integer, integer) IS 'retourne le score pour un parcours,un individu et une formation';


--
-- TOC entry 361 (class 1255 OID 2597041)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours(integer) RETURNS record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	IF $1 IS NULL THEN
		RETURN NULL;
	END IF;

	SELECT INTO rec  E.id, E.libelle, P.filiere, P.duree, E.date_creation  FROM v2.etape E 
	LEFT OUTER JOIN v2.parcours P  
	ON (P.id=E.id)
	WHERE E.id=$1;
	
	/*SELECT INTO rec * FROM v2.af_get_parcours() AS (id int4, libelle varchar, filiere int4, duree bool, date_creation timestamp) 
	WHERE id=$1;*/

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 362 (class 1255 OID 2597042)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT E.id, E.libelle, P.filiere, P.duree, E.date_creation  FROM v2.etape E 
		, v2.parcours P  
		WHERE P.id = E.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours() OWNER TO pgsql;

--
-- TOC entry 363 (class 1255 OID 2597043)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_avancement(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_avancement(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN

	FOR rec IN
		SELECT e_parcours, e_id, A.formation, A.stagiaire, type
		FROM v2.af_get_parcours_etapes($1) 
		AS (e_id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, e_parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar,modifiable bool)
		LEFT OUTER JOIN v2.resultat  A
		ON(etape=e_id AND e_parcours=A.parcours)
		WHERE e_parcours=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_avancement(integer) OWNER TO pgsql;

--
-- TOC entry 364 (class 1255 OID 2597044)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_avancement_max(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_avancement_max(integer) RETURNS record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
rec_etape RECORD;
etape_prec int4:=NULL;
BEGIN
	FOR rec IN 
		--on recupere l'avancement du parcours
		SELECT * FROM v2.af_get_parcours_avancement($1) AS (parcours int4, etape int4, formation int4, stagiaire int4 , type varchar)
	LOOP
		--cas pour la premiere etape
		IF etape_prec IS NULL THEN
			etape_prec:=rec.etape;
		ELSE
		
			--on suppose que si l'etape n'a pas encore ÃƒÂ©tÃƒÂ© faite, etape_prec contient la derniere etape faite
			IF rec.formation IS NULL THEN
				--on recupere donc les informations de etape_prec
				SELECT INTO rec_etape * FROM v2.af_get_parcours_etape($1, etape_prec)  AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar);
				
				--si etape_prec est une etape obligatoire, il s'agit bien de la derniere etape faite
				IF rec_etape.obligatoire IS TRUE THEN
					--on la renvoie donc, sinon on continu a chercher	
					RETURN rec_etape;
				END IF;
			END IF;
			etape_prec:=rec.etape;
		END IF;

	END LOOP;

	RETURN NULL;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_avancement_max(integer) OWNER TO pgsql;

--
-- TOC entry 365 (class 1255 OID 2597045)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etape_fille(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etape_fille(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 parcours
--$2 identifiant de l'etape pÃƒÂ¨re
rec RECORD;
BEGIN
	IF $2 IS NOT NULL THEN
		SELECT INTO rec * FROM v2.af_get_parcours_etapes($1)
		AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape varchar, type varchar, pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		WHERE pere=$2;
	ELSE
		SELECT INTO rec * FROM v2.af_get_parcours_etapes($1)
		AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape varchar, type varchar, pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		WHERE pere IS NULL;
	END IF;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etape_fille(integer, integer) OWNER TO pgsql;

--
-- TOC entry 366 (class 1255 OID 2597046)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 numÃƒÂ©ro du parcours
/*filiere_id int4;
niveau int4;*/
ss_parcours RECORD;
BEGIN
	FOR ss_parcours IN
		SELECT * FROM v2.af_get_parcours_sous_parcourss_disponibles($1) 
		AS  (id int4, libelle varchar, filiere int4, duree bool, date_creation timestamp, indice integer)
	LOOP
		RETURN NEXT ss_parcours;
	END LOOP;

	RETURN;
	/*--selection de la filiere du parcours
	SELECT INTO filiere_id filiere FROM v2.parcours
	WHERE id =$1;

	--selection du niveau de la filiere
	SELECT INTO niveau * FROM v2.af_gen_get_element_niveau('v2.filiere','id', filiere_id, '',0);
	RAISE NOTICE 'filiere parcours: % niveau parcours=%',filiere_id,niveau;
	
	--selection des sous parcours disponibles pour le parcours
	FOR ss_parcours IN
		SELECT P_id, P_libelle, P_filiere, P_duree, P_date_creation,F_indice FROM v2.af_get_filieres()AS (F_id int4, F_libelle varchar, F_pere int4, F_indice int4),
		v2.af_get_parcours()AS (P_id integer, P_libelle varchar, P_filiere int4 , P_duree bool, P_date_creation timestamp)
		WHERE F_indice=(niveau+1)
		AND P_filiere=F_id
	LOOP
		RETURN NEXT ss_parcours;
	END LOOP;

	RETURN;*/
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 367 (class 1255 OID 2597047)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etape_resultats(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etape_resultats(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, formation, stagiaire, parcours,  etape, date_debut, duree
		FROM v2.resultat
		WHERE parcours=$1 and etape=$2
	LOOP 
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etape_resultats(integer, integer) OWNER TO pgsql;

--
-- TOC entry 368 (class 1255 OID 2597048)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etapes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etapes(integer) RETURNS SETOF record
    AS $_$DECLARE 
--$1 parcours
rec RECORD;
modif bool;
sous_type v2.type_element;
BEGIN
	FOR rec IN
		SELECT PE.etape, E.libelle, E.libelle, PE.libelle_type_etape, CAST(E.type AS varchar) AS type,  PE.pere, PE.parcours, PE.obligatoire, PE.chrono, PE.fin, T.libelle AS libelle_type_original, CAST(NULL AS bool) AS modifiable
		FROM v2.af_gen_get_elements('v2.parcours_etapes', 'etape', NULL, 'AND parcours='||$1,1) elt, v2.parcours_etapes PE, v2.etape E, v2.etape_type T
		WHERE elt.id=PE.etape AND PE.etape=E.id
		AND E.type=T.id
		AND PE.parcours=$1
		ORDER BY elt.ind
	LOOP
		--Cas speciaux: les types ayant des sous types
		SELECT INTO sous_type * FROM v2.af_get_etape_type_sous_type(rec.etape, CAST(rec.type AS int4), rec.libelle_type_original);
		rec.type:=sous_type.id;
		rec.libelle_type_original:=sous_type.libelle;

		--l'etape est elle modifiable?
		SELECT INTO modif * FROM v2.af_is_parcours_etape_modifiable($1, rec.etape, rec.type);
		rec.modifiable:=modif;

		--les series gÃƒÂ©nÃƒÂ©rÃƒÂ©es par les test
		IF rec.type='4_1_4' THEN

		END IF;

		RETURN NEXT rec;
	END LOOP;

	/*----------------------------------
	--      ETAPES SANS THEMES      --
	----------------------------------

	--les types d'ÃƒÂ©tapes spÃƒÂ©ciales: forum (2), chat(8) et etape titre(9)
	FOR rec_spe IN 
		SELECT CAST(NULL AS int4) AS id,  CAST(NULL AS varchar) AS  libelle,CAST(NULL AS varchar) AS  libelle2,CAST(id AS varchar) AS type, libelle  AS libelle_type
		FROM v2.etape_type T
		WHERE id IN (2,8,9)
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	FOR rec_ss_parcours IN 
		SELECT P_id,  P_libelle, P_libelle, CAST('1' AS varchar) AS type, libelle  AS libelle_type
		FROM v2.af_get_parcours_sous_parcourss_disponibles(num_parcours) AS (P_id int4, P_libelle varchar, filiere int4, duree bool),
		v2.etape_type T
		WHERE 1=T.id
	LOOP
		RETURN NEXT rec_ss_parcours;
	END LOOP;*/

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etapes(integer) OWNER TO pgsql;

--
-- TOC entry 369 (class 1255 OID 2597049)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etapes_deroulees(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etapes_deroulees(integer) RETURNS SETOF record
    AS $_$DECLARE 
--$1 parcours
rec RECORD;
rec_p RECORD;
BEGIN
	--recup des etapes du parcours
	FOR rec IN
		SELECT * FROM v2.af_get_parcours_etapes($1) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		--SELECT PE.etape AS id_etape, E.libelle, E.libelle, E.type,  PE.pere, PE.parcours, PE.obligatoire, PE.chrono, PE.fin 
		--FROM v2.af_gen_get_elements('v2.parcours_etapes', 'etape', NULL, 'AND parcours='||$1) P_ID, v2.parcours_etapes PE, v2.etape E
		--WHERE P_ID=PE.etape AND PE.etape=E.id and PE.parcours=$1
	LOOP
		--Si etape de type parcours attachÃƒÂ©, on recuperes ses etapes par recursivite
		IF rec.type='1' THEN
			FOR rec_p IN
				SELECT * FROM v2.af_get_parcours_etapes_deroulees(rec.id) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
			LOOP
				RETURN NEXT rec_p;
			END LOOP;
		ELSE
			RETURN NEXT rec;
		END IF;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etapes_deroulees(integer) OWNER TO pgsql;

--
-- TOC entry 370 (class 1255 OID 2597050)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE 
--$1 formation
--$2 individu
--$3 parcours
rec RECORD;
rec_resultat record;
rec_p RECORD;
sous_parcours integer;
indice integer;
BEGIN
    --recup des etapes du parcours
    FOR rec IN
	SELECT * FROM v2.af_get_parcours_etapes($3) 
	AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    LOOP
	--Si etape de type parcours attachÃƒÂ©, on recuperes ses etapes par recursivite
	IF rec.type='1' THEN
	    FOR rec_p IN
		SELECT * FROM v2.af_get_parcours_etapes_deroulees_formation_individu($1,$2,rec.id) 
		AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
	    LOOP
		RETURN NEXT rec_p;
	    END LOOP;
	ELSE
	    RETURN NEXT rec;
	    -- si etape parcours oriente
	    if rec.type='10' then
		-- test si l'etape a ÃƒÂ©tÃƒÂ© faite
		select into rec_resultat * from v2.af_get_resultat($1,$2,$3,rec.id) 
		as (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
		if rec_resultat.id is not null then
		    -- recup sous-parcours 
		    select into sous_parcours * from v2.af_get_resultat_parcours_parcours_oriente(rec_resultat.id);
		    for rec_p in 
			--SELECT *,indice AS indic FROM v2.af_get_parcours_etapes_deroulees_formation_individu($1,$2,sous_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
			SELECT * FROM v2.af_get_parcours_etapes_deroulees_formation_individu($1,$2,sous_parcours) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		
		    loop
			    --rec_p.indic:=indice;
			RETURN NEXT rec_p;
			    --indice:=indice+1;
		    end loop;
		end if;
	    --end if;--else
	    end if;
	END IF;
    END LOOP;
    RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9285 (class 0 OID 0)
-- Dependencies: 370
-- Name: FUNCTION prcrs_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) IS 'deroule les etapes d''un parcours pour un individu y compris les etapes de sous-parcours issus d''etape parcours oriente
(suivant les resultats de l''individu)';


--
-- TOC entry 371 (class 1255 OID 2597051)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etapes_disponibles_theme(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etapes_disponibles_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
--$2 theme
rec RECORD;
rec_spe RECORD;
rec_ss_parcours RECORD;
num_parcours int4;
nb_serie_generee int4;
sous_type v2.type_element;
BEGIN
	num_parcours:=$1;
	--IF num_parcours IS NULL THEN
	--	num_parcours:=0;
	--END IF;

	--on recupere tous les elements de la categorie etape, avec les type_d'etapes
	FOR rec IN 
		SELECT I_D AS id,  E.libelle AS libelle, CAST(E.type AS varchar) AS type, T.libelle  AS libelle_type
		FROM (v2.etape E 
		LEFT OUTER JOIN v2.parcours_etapes P
		ON E.id=P.etape AND P.parcours=num_parcours) 
		LEFT OUTER JOIN v2.af_get_categorie_elements_theme(29 ,$2) I_D
		ON E.id=I_D,v2.etape_type T
		WHERE P.etape IS NULL
		AND I_D IS NOT NULL
		AND E.type=T.id
		AND E.type!=10
		ORDER BY T.ordre

	LOOP
		--Cas speciaux: les types ayant des sous types
		SELECT INTO sous_type * FROM v2.af_get_etape_type_sous_type(rec.id, CAST(rec.type AS int4), rec.libelle_type)
		ORDER BY sous_type.id;
		rec.type:=sous_type.id;
		rec.libelle_type:=sous_type.libelle;

		--cas des sÃƒÂ©ries gÃƒÂ©nÃƒÂ©rÃƒÂ©es par les test de positionnement
		IF FALSE AND rec.type='4_1_4' THEN
			SELECT INTO nb_serie_generee COUNT(*) FROM (
				--recup de toutes les sÃƒÂ©ries gÃƒÂ©nÃƒÂ©rÃƒÂ©es par les test dynamiques du parcours
				SELECT P.serie_aleatoire FROM v2.af_get_parcours_etapes_type($1, '4_3') AS (PE_id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool, indice int4),
				v2.test T, v2.test_positionnements TP, v2.positionnement P
				WHERE PE_id=T.id
				AND T.dynamique IS TRUE
				AND T.id=TP.test
				AND P.id=TP.positionnement
			) as series_aleatoires
			--recup des sÃƒÂ©ries gÃƒÂ©nÃƒÂ©rÃƒÂ©es dÃƒÂ©jÃƒ  dans le parcours
			LEFT OUTER JOIN v2.af_get_parcours_etapes_type($1, '4_1_4') AS (series_aleatoire_id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool, indice int4)
			ON (series_aleatoire_id=series_aleatoires.serie_aleatoire)
			WHERE series_aleatoire_id IS NULL
			AND series_aleatoires.serie_aleatoire=rec.id;
			
			IF nb_serie_generee>0 THEN
				RETURN NEXT rec;
			END IF;
		ELSE
			RETURN NEXT rec;
		END IF;
	END LOOP;
	
	----------------------------------
	--      ETAPES SANS THEMES      --
	----------------------------------

	--les types d'ÃƒÂ©tapes spÃƒÂ©ciales: forum (2), chat(8) et etape titre(9)
	FOR rec_spe IN 
		SELECT CAST(NULL AS int4) AS id,  CAST(NULL AS varchar) AS  libelle, CAST(9 AS varchar) AS type, libelle  AS libelle_type
		FROM v2.etape_type T
		WHERE T.id=9
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	--les types d'ÃƒÂ©tapes forum (2)
	
	FOR rec_spe IN 
		SELECT P_id,  P_libelle, cast('2' as varchar), T.libelle  AS libelle_type
		FROM v2.etape_type T,v2.af_get_parcours_forums_disponibles(num_parcours) AS (P_id int4, P_libelle varchar)
		WHERE T.id=2 
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	-- type chat
	FOR rec_spe IN 
		SELECT P_id,  P_libelle, cast('8' as varchar), T.libelle  AS libelle_type
		FROM v2.etape_type T,v2.af_get_parcours_chats_disponibles(num_parcours) AS (P_id int4, P_libelle varchar)
		WHERE T.id=8 
	LOOP
		RETURN NEXT rec_spe;
	END LOOP;

	

	--les sous parcours
	FOR rec_ss_parcours IN 
		SELECT P_id,  P_libelle, CAST('1' AS varchar) AS type, libelle  AS libelle_type
		FROM v2.af_get_parcours_sous_parcourss_disponibles(num_parcours) AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool, P_date_creation timestamp, P_indice integer),
		v2.etape_type T
		WHERE 1=T.id
	LOOP
		RETURN NEXT rec_ss_parcours;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etapes_disponibles_theme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 372 (class 1255 OID 2597052)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etapes_duree_type(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etapes_duree_type(integer, character varying) RETURNS integer
    AS $_$DECLARE
--$1 parcours
--$2 type
rec RECORD;
somme int4;
BEGIN
	SELECT INTO somme SUM(chrono)
	FROM v2.af_get_parcours_etapes($1)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
	WHERE type NOT LIKE '4_1_4%'
	AND type LIKE $2||'%';
	
	RETURN somme;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etapes_duree_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 373 (class 1255 OID 2597053)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etapes_durees_type(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etapes_durees_type(integer, character varying) RETURNS SETOF integer
    AS $_$DECLARE
--$1 parcours
--$2 type
rec RECORD;
somme int4;
BEGIN
	FOR rec IN
		SELECT DISTINCT chrono
		FROM v2.af_get_parcours_etapes($1)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		WHERE type NOT LIKE '4_1_4%'
		AND chrono IS NOT NULL
		AND type LIKE $2||'%'
	LOOP
		RETURN NEXT rec.chrono;
	END LOOP;
	
	RETURN;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etapes_durees_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 374 (class 1255 OID 2597054)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etapes_durees_type_distincts(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etapes_durees_type_distincts(integer, character varying) RETURNS SETOF integer
    AS $_$DECLARE
--$1 parcours
--$2 type
rec RECORD;
somme int4;
BEGIN
	FOR rec IN
		SELECT DISTINCT chrono
		FROM v2.af_get_parcours_etapes($1)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		WHERE type NOT LIKE '4_1_4%'
		AND type LIKE $2||'%'
	LOOP
		RETURN NEXT rec.chrono;
	END LOOP;
	
	RETURN;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etapes_durees_type_distincts(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 375 (class 1255 OID 2597055)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etapes_durees_valuees(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etapes_durees_valuees(integer) RETURNS SETOF integer
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	FOR rec IN
		SELECT chrono 
		FROM v2.parcours_etapes P--, v2.etape E
		WHERE chrono IS NOT NULL
		AND parcours=$1
		/*WHERE P.etape=E.id 
		AND P.parcours=$1
		AND E.type !=6
		AND E.type !=2
		AND E.type !=8
		AND E.type !=7
		AND E.type !=5*/
	LOOP
		RETURN NEXT rec.chrono;
	END LOOP;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etapes_durees_valuees(integer) OWNER TO pgsql;

--
-- TOC entry 376 (class 1255 OID 2597056)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_etapes_type(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_etapes_type(integer, character varying) RETURNS SETOF record
    AS $_$declare
--$1 parcours
--$2 type d'ÃƒÂ©tape
rec record;
indice int4;

begin
    indice:=0;
    for rec in
	SELECT id , libelle_alias, libelle , libelle_type_etape  , type ,  pere , parcours , obligatoire , chrono , fin , libelle_type_original , modifiable , CAST(NULL AS int4) AS ind
	FROM v2.af_get_parcours_etapes($1) 
	AS  (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    loop
	indice :=indice + 1;
	if(rec.type like $2||'%') then
	     rec.ind:=indice;	
	    return next rec;
	end if;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_etapes_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 377 (class 1255 OID 2597057)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_mode_affichage(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_mode_affichage(integer) RETURNS integer
    AS $_$DECLARE
--$1 parcours
BEGIN

    SELECT count(*) INTO mode_affich
    FROM gestparcours
    WHERE g_num_parcours = $1
    AND num_etape_suivante = 1 ;

    IF (mode_affich>0) THEN
        RETURN(2) ;
    END IF ;

    SELECT count(*) INTO mode_affich
    FROM gestparcours
    WHERE g_num_parcours = $1
    AND type_etape = 'I' ;

    IF (mode_affich>0) THEN
        RETURN(1) ;
    ELSE
        RETURN(0) ;
    END IF ;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_mode_affichage(integer) OWNER TO pgsql;

--
-- TOC entry 378 (class 1255 OID 2597058)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_oriente_configuration(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_oriente_configuration(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 etape parcours oriente
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id,sous_parcours, type, seuil
		FROM v2.parcours_oriente
		WHERE id=$1
		ORDER BY ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_oriente_configuration(integer) OWNER TO pgsql;

--
-- TOC entry 379 (class 1255 OID 2597059)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_oriente_sous_parcours(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_oriente_sous_parcours(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT P_id, libelle, filiere, ordre 
		FROM v2.parcours_oriente PO, v2.af_get_parcours() AS (P_id int4, libelle varchar, filiere int4, duree bool,date_creation timestamp)
		WHERE sous_parcours=P_id
		AND PO.id=$1
		ORDER BY ordre
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_oriente_sous_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 380 (class 1255 OID 2597060)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_orientes_sous_parcours(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_orientes_sous_parcours() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT P_id, libelle, filiere 
		FROM v2.parcours_oriente PO, v2.af_get_parcours() AS (P_id int4, libelle varchar, filiere int4, duree bool,date_creation timestamp)
		WHERE sous_parcours=P_id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_orientes_sous_parcours() OWNER TO pgsql;

--
-- TOC entry 381 (class 1255 OID 2597061)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_parcours_pere(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_parcours_pere(integer) RETURNS SETOF integer
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
	    /*
		SELECT E.pere AS id FROM v2.parcours_etapes E, v2.parcours P
		WHERE E.etape=$1
		AND E.pere IS NOT NULL
		AND E.pere=P.id
	    */
	    select E.parcours as id from v2.parcours_etapes E,v2.parcours P
	    where E.etape=$1
	    and p.id=E.parcours
	LOOP
		RETURN NEXT rec.id;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_parcours_pere(integer) OWNER TO pgsql;

--
-- TOC entry 382 (class 1255 OID 2597062)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_sous_parcourss_disponibles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_sous_parcourss_disponibles(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 numÃƒÂ©ro du parcours
filiere_id int4;
niveau int4;
ss_parcours RECORD;
BEGIN
	--selection de la filiere du parcours
	SELECT INTO filiere_id filiere FROM v2.parcours
	WHERE id =$1;

	--selection du niveau de la filiere
	SELECT INTO niveau * FROM v2.af_gen_get_element_niveau('v2.filiere','id', filiere_id, '',0);
	--RAISE NOTICE 'filiere parcours: % niveau parcours=%',filiere_id,niveau;
	
	--selection des sous parcours disponibles pour le parcours
	FOR ss_parcours IN
		SELECT P_id, P_libelle, P_filiere, P_duree, P_date_creation,F_indice FROM v2.af_get_filieres()AS (F_id int4, F_libelle varchar, F_pere int4, F_indice int4),
		v2.af_get_parcours()AS (P_id integer, P_libelle varchar, P_filiere int4 , P_duree bool, P_date_creation timestamp) 
		LEFT OUTER JOIN v2.af_get_parcours_etapes(727) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		ON (P_id=id AND type LIKE '1')
		WHERE F_indice=(niveau+1)
		AND P_filiere=F_id
		AND id IS NULL
	LOOP
		RETURN NEXT ss_parcours;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_sous_parcourss_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 383 (class 1255 OID 2597063)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_type_etape_personnalise(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_type_etape_personnalise(integer, character varying) RETURNS SETOF character varying
    AS $_$DECLARE
--$1 parcours
--$2 type d'etape
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT P.libelle_type_etape AS libelle
		FROM v2.parcours_etapes P, v2.etape E
		WHERE P.parcours=$1
		AND E.type LIKE $2||'%'
		AND E.id=P.etape
	LOOP
		RETURN NEXT rec.libelle;
	END LOOP;
	
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_type_etape_personnalise(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 384 (class 1255 OID 2597064)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_types_etapes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_types_etapes(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	FOR rec IN
		SELECT  type, libelle_type_original, CAST(COUNT (type)AS int4) FROM v2.af_get_parcours_etapes($1) AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
		GROUP BY type,libelle_type_original
		ORDER BY type
		/*SELECT DISTINCT T.id, T.libelle 
		FROM v2.parcours_etapes P, v2.etape_type T, v2.etape E
		WHERE P.parcours=$1 
		AND P.etape=E.id
		AND E.type=T.id*/
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_types_etapes(integer) OWNER TO pgsql;

--
-- TOC entry 385 (class 1255 OID 2597065)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcours_types_etapes_personnalises(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcours_types_etapes_personnalises(integer) RETURNS SETOF character varying
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT libelle_type_etape FROM v2.parcours_etapes
		WHERE parcours=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcours_types_etapes_personnalises(integer) OWNER TO pgsql;

--
-- TOC entry 386 (class 1255 OID 2597066)
-- Dependencies: 2983 7
-- Name: prcrs_get_parcourss_orientes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_parcourss_orientes() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,sous_parcours from v2.parcours_oriente
    loop
	return next rec;
    end loop;
    return;

end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_parcourss_orientes() OWNER TO pgsql;

--
-- TOC entry 9286 (class 0 OID 0)
-- Dependencies: 386
-- Name: FUNCTION prcrs_get_parcourss_orientes(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_parcourss_orientes() IS 'retourne les parcours oriente de la plateforme';


--
-- TOC entry 387 (class 1255 OID 2597067)
-- Dependencies: 2983 7
-- Name: prcrs_get_resultat(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_resultat(integer, integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 formation
--$2 stagiaire
--$3 parcours
--$4 etape
rec RECORD;
BEGIN
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree
	FROM v2.resultat
	WHERE formation=$1
	AND stagiaire=$2
	AND parcours=$3
	AND etape=$4;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_resultat(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 388 (class 1255 OID 2597068)
-- Dependencies: 2983 7
-- Name: prcrs_get_resultat(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_resultat(bigint) RETURNS record
    AS $_$DECLARE
--$1 resultat
rec RECORD;
BEGIN
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree
	FROM v2.resultat
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_resultat(bigint) OWNER TO pgsql;

--
-- TOC entry 389 (class 1255 OID 2597069)
-- Dependencies: 2983 7
-- Name: prcrs_get_resultat_etape_tentative(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_resultat_etape_tentative(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
begin
    -- Initialisation 
    -- recup des paramÃƒÂ¨tres du resultat
    select into rec_resultat * from v2.af_get_resultat($1)
    as  (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval);
    if rec_resultat.id is null then
	select into rec_resultat * from v2.af_get_resultat_tentative($1)  
	as  (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval,tentative integer);
    end if;
    -- boucle sur les resultats stockÃƒÂ©s
    for rec in 
	select id,formation,stagiaire,parcours,etape,date_debut,duree,tentative from v2.resultat_tentative 
	where formation=rec_resultat.formation 
	and stagiaire=rec_resultat.stagiaire 
	and parcours=rec_resultat.parcours 
	and etape=rec_resultat.etape

    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_resultat_etape_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 9287 (class 0 OID 0)
-- Dependencies: 389
-- Name: FUNCTION prcrs_get_resultat_etape_tentative(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_resultat_etape_tentative(bigint) IS 'retourne les tentatives deja effectuÃƒÂ©es';


--
-- TOC entry 390 (class 1255 OID 2597070)
-- Dependencies: 2983 7
-- Name: prcrs_get_resultat_formation(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_resultat_formation(integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 formation
--$2 individu
--$3 parcours (doit etre NULL Ãƒ  l'appel de la fonction, sert uniquement pour la recursivitÃƒÂ©)
id_parcours int4;
rec RECORD;
rec_p RECORD;
rec_pp RECORD;
id_resultat bigint; 
sous_parcours integer; 
BEGIN
	------------------------------
	--VERIFICATION DES PARAMETRES
	------------------------------
	IF $1 IS NULL OR $2 IS NULL THEN
		RAISE EXCEPTION 'La fonction n''accepte pas une formation (%) et/ou un individu(%) nulls',$1,$2;
	ELSE 
		RAISE NOTICE 'params f=% i=% p=%',$1,$2,$3;
	END IF;

	IF $3 IS NULL THEN
		--on rÃƒÂ©cupÃƒÂ¨re le parcours de la formation
		SELECT INTO id_parcours parcours FROM v2.af_get_formation($1) 
		AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue int4);
		
		IF id_parcours IS NULL THEN
			RAISE EXCEPTION 'Pas de parcours principal pour la formation';
		END IF;
 
		RAISE NOTICE 'Le parcours principal est le parcours nÃ‚Â°%', id_parcours;	
	ELSE 
		id_parcours:=$3;
	END IF;
 
	------------------------------
	--AVANCEMENT PARCOURS APPELLE ($3 ou parcours principal)
	------------------------------

	--on recupere l'avancement max du parcours passÃƒÂ© en argument
	SELECT INTO rec * FROM v2.af_get_formation_avancement_max_parcours($1, id_parcours, $2) AS (parcours int4, etape int4, type int4,formation int4, individu int4, date_debut timestamp, duree interval);
	raise notice 'Type etape a suivre=%',rec.type;
 
	IF rec.type IS NULL THEN
		raise notice 'ds le test du type avt retour (%)',rec.type;
		RETURN NULL;
	END IF;
	raise notice 'ds le test du type apres retour';

	--si l'avancement max est un parcours  on recupere l'avancement max de ce dernier
	IF rec.type=1 THEN
		RAISE NOTICE 'L''etape en cours est le parcours nÃ‚Â°% de type% deb=%, d=%', rec.etape,rec.type, rec.date_debut,rec.duree  ;
		
		IF rec.date_debut IS NOT NULL THEN

			--IF rec.duree IS NULL THEN
				RAISE NOTICE 'AAAA';
				--appel recursif: on rÃƒÂ©appel la fonction en changeant de parcours courant
				SELECT INTO rec_p * FROM v2.af_get_resultat_formation($1, $2,rec.etape) AS (parcours int4, etape int4,type int4, formation int4, individu int4, date_debut timestamp, duree interval);	
				RAISE NOTICE 'AAAA L''etape du parcours trouvÃƒÂ©e:parcours(%) nÃ‚Â°% de type% deb=%, d=%',rec_p.parcours, rec_p.etape,rec_p.type, rec_p.date_debut,rec_p.duree  ;
				
				--Si l'avancement max du nouveau parcours courant est null (ligne vide)
				IF rec_p.type IS NULL THEN
					RETURN rec;
				ELSE 
					RETURN rec_p;
				END IF;
					
		ELSE 
		
			RETURN rec;
		END IF;
	ELSE

			--RAISE EXCEPTION 'DANS LE ELSE';
		    -- traitement etape parcours oriente
		if rec.type=10 THEN--and rec.date_debut IS NOT NULL 
			--recup sous parcours
			-- recup id_resultat
			RAISE NOTICE 'parcours=% et etape=%', id_parcours,rec.etape;
			select into id_resultat id from v2.af_get_resultat($1,$2,id_parcours,rec.etape)
			AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
			RAISE NOTICE 'id_resultat=%', id_resultat;
			if id_resultat is null then
			    --raise exception 'le parcours oriente pas commence';
			    return rec;
			end if;

			select into sous_parcours * from v2.af_get_resultat_parcours_parcours_oriente(id_resultat);
			RAISE NOTICE 'sous_parcours=%', sous_parcours;
			select into rec_p * FROM v2.af_get_resultat_formation($1, $2,sous_parcours) AS (parcours int4, etape int4,type int4, formation int4, individu int4, date_debut timestamp, duree interval);	
			--Si l'avancement max du nouveau parcours courant est null (ligne vide)
				IF rec_p.type IS NULL THEN
					RETURN rec;
				ELSE 
					RETURN rec_p;
				END IF;
			
			
		else
			RETURN rec;
		end if;
		

		RAISE NOTICE 'L''etape en cours est de type % nÃ‚Â°%',rec.type, rec.etape;
		--
	    
		--RAISE NOTICE 'L''etape en cours est de type % nÃ‚Â°%',rec.type, rec.etape;
		--RETURN rec;
	END IF;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_resultat_formation(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 391 (class 1255 OID 2597071)
-- Dependencies: 2983 7
-- Name: prcrs_get_resultat_parcours_parcours_oriente(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_resultat_parcours_parcours_oriente(bigint) RETURNS integer
    AS $_$-- $1 : id resultat
declare
rec record;
rec2 record;
rec_resultat record;
seuil_individu real;
seuil_type real;
passage_type integer;
begin
    -- Initialisation
    -- recup param resultat
    select into rec_resultat * from v2.af_get_resultat($1) 
    as (id bigint,  formation integer, stagiaire integer,parcours integer, etape integer,  date_debut timestamp, duree interval); 
    -- recup score pour le parcours (avant l'etape parcours oriente)
    --select into seuil_individu * from v2.af_get_formation_individu_parcours_score(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours);
    select into seuil_individu * from v2.af_get_resultat_parcours_score_partiel($1);
    -- boucle sur les sous parcours de la configuration de l'etape parcours oriente
    for rec in 
	select * from v2.af_get_parcours_oriente_sous_parcours(rec_resultat.etape)
	as (id integer,libelle varchar,filiere integer,ordre integer) order by ordre desc
    loop
	-- recup des seuils pour le sous parcours courant
	passage_type=0;
	for rec2 in 
	    select * from v2.af_get_parcours_oriente_configuration(rec_resultat.etape) 
	    as (etape integer,sous_parcours integer,type integer,seuil integer)
	    where sous_parcours=rec.id
	loop
	    if rec2.type =4 then
		-- recup score pour ce type
		select into seuil_type * from v2.af_get_formation_individu_parcours_series_score(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours);
		if seuil_type<rec2.seuil then
		    exit;
		else
		    passage_type:=passage_type+1;
		end if;
	    else
		if rec2.type=5 then
		    -- recup score pour ce type
		    select into seuil_type * from v2.af_get_formation_individu_parcours_exotlcs_score(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours);
		    if seuil_type<rec2.seuil then
		        exit;
		    else
			passage_type:=passage_type+1;
		    end if;
		else

		end if;
	    end if;

	end loop;
	if passage_type>0 then
	    return rec2.sous_parcours;
	else
	    if seuil_individu>rec2.seuil then
		return rec2.sous_parcours;
	    end if;	
	end if;
	
    end loop;
    return rec2.sous_parcours ;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_resultat_parcours_parcours_oriente(bigint) OWNER TO pgsql;

--
-- TOC entry 9288 (class 0 OID 0)
-- Dependencies: 391
-- Name: FUNCTION prcrs_get_resultat_parcours_parcours_oriente(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_resultat_parcours_parcours_oriente(bigint) IS 'retourne le numero du sous_parcours issu de la configuration de l''etape parcours_oriente et des resultat de l''individu';


--
-- TOC entry 392 (class 1255 OID 2597072)
-- Dependencies: 2983 7
-- Name: prcrs_get_resultat_parcours_score_partiel(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_resultat_parcours_score_partiel(bigint) RETURNS real
    AS $_$-- $1 : identifiant resultat
declare
rec record;
rec_resultat record;
id_resultat bigint;
total real;
res_serie real;
res_exotlc real;
nb integer;
begin
    -- recup des composant de l'identifiant rÃƒÂ©sultat
    select into rec_resultat * from v2.af_get_resultat($1) 
    as (id bigint,  formation integer, stagiaire integer,parcours integer, etape integer,  date_debut timestamp, duree interval); 
    -- Initialisation
    total:=0;
    nb:=0;
    -- boucle sur les etapes du parcours
    for rec in 
	select * from v2.af_get_parcours_etapes(rec_resultat.parcours)
	AS (id int4, libelle varchar, libelle_bis varchar, libelle_alias  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    loop
	if rec.type='10' then
	    exit;
	end if;
	-- traitement serie
	if (rec.type like 4 || '%') then
	    -- recup identifiant resultat pour cette etape
	    select into id_resultat id from v2.af_get_resultat(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours,rec.id)
	    AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	    select into res_serie * from v2.af_get_resultat_serie_score(id_resultat);
	    total:=total+res_serie;
	    nb:=nb+1;

	end if;
	if rec.type='5' then
	    -- recup identifiant resultat pour cette etape
	    select into id_resultat id from v2.af_get_resultat(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours,rec.id)
	    AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	    select into res_exotlc * from v2.af_get_resultat_exotlc_moyenne(id_resultat);
	    total:=total+res_exotlc;
	    nb:=nb+1;
	end if;

    end loop;
    if nb>0 then
	return total/nb;
    else
	return null;
    end if;


end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_resultat_parcours_score_partiel(bigint) OWNER TO pgsql;

--
-- TOC entry 9289 (class 0 OID 0)
-- Dependencies: 392
-- Name: FUNCTION prcrs_get_resultat_parcours_score_partiel(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_resultat_parcours_score_partiel(bigint) IS 'retourne le score d''in individu pour un parcours avant l''etape parcours oriente';


--
-- TOC entry 393 (class 1255 OID 2597073)
-- Dependencies: 2983 7
-- Name: prcrs_get_resultat_tentative(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_resultat_tentative(integer, integer, integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : parcours
-- $4 : etape
-- $5 : numero tentative
declare
rec record;
begin
    if $5 <1 then
	-- On prend l'enregistrement de la derniere tentative
/*
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree,tentative
	FROM v2.resultat_tentative
	WHERE formation=$1
	AND stagiaire=$2
	AND parcours=$3
	AND etape=$4 
	group by id,formation,stagiaire,parcours,etape,date_debut, duree,tentative having tentative=max(tentative);
*/
	SELECT into rec R1.id,R1.formation, R1.stagiaire, R1.parcours, R1.etape, R1.date_debut, R1.duree,R1.tentative 
	FROM v2.resultat_tentative R1, v2.resultat_tentative R2
	WHERE R1.formation=$1
	AND R1.stagiaire=$2
	AND R1.parcours=$3
	AND R1.etape=$4
	--and R1.tentative=max(R2.tentative)
	group by R1.id,R1.formation,R1.stagiaire,R1.parcours,R1.etape,R1.date_debut, R1.duree,R1.tentative
	having R1.tentative=max(R2.tentative);
	
    else
	-- On prend l'enregistrement correspondant Ãƒ  la tentative
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree,tentative
	FROM v2.resultat_tentative
	WHERE formation=$1
	AND stagiaire=$2
	AND parcours=$3
	AND etape=$4
	and tentative=$5;
    end if;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_resultat_tentative(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9290 (class 0 OID 0)
-- Dependencies: 393
-- Name: FUNCTION prcrs_get_resultat_tentative(integer, integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_resultat_tentative(integer, integer, integer, integer, integer) IS 'retourne le dernier identifiant resultat_tentative ou celui correspondant Ãƒ  un numero de tentative';


--
-- TOC entry 394 (class 1255 OID 2597074)
-- Dependencies: 2983 7
-- Name: prcrs_get_resultat_tentative(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_get_resultat_tentative(bigint) RETURNS record
    AS $_$DECLARE
--$1 resultat
rec RECORD;
BEGIN
	SELECT INTO rec id,formation, stagiaire, parcours, etape, date_debut, duree,tentative
	FROM v2.resultat_tentative
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_get_resultat_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 9291 (class 0 OID 0)
-- Dependencies: 394
-- Name: FUNCTION prcrs_get_resultat_tentative(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_get_resultat_tentative(bigint) IS 'retourne les attributs associes Ãƒ  un id resultat (tentative)';


--
-- TOC entry 395 (class 1255 OID 2597075)
-- Dependencies: 2983 7
-- Name: prcrs_is_parcours_etape_modifiable(integer, integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_is_parcours_etape_modifiable(integer, integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 type de l'ÃƒÂ©tape
--rec_etape RECORD;
tmp bool;
rec record;
rec2 record;
nb integer;
BEGIN
	--selection de l'ÃƒÂ©tape
	--SELECT INTO rec_etape * FROM v2.etape WHERE etape=$2;	IF 

	--etape de type test de positionnement dynamique
    /*
	IF $3='4_3' THEN
		SELECT INTO tmp dynamique FROM v2.af_get_test($2) AS (id int4, libelle varchar, dynamique bool, continu bool, media int4, hauteur_media int4, largeur_media int4,date_creation timestamp);
	END IF;
	
	IF tmp IS TRUE THEN
		RETURN FALSE; 
	ELSE
		RETURN TRUE;
	END IF;
    */
    -- test si l'ÃƒÂ©tape du parcours est enregistrÃƒÂ©e
    select into rec * from v2.af_get_parcours_etape_resultats($1,$2)
    as (id bigint, formation int4, stagiaire int4, parcours int4,  etape int4, date_debut timestamp, duree interval);
    
    if rec.id is not null then
	return false;
    else
    
    
	-- si etape notÃƒÂ©e et parcours configurÃƒÂ© en orientation alors pas de modif
	nb:=0;
	for rec2 in 
	    select * from v2.parcours_etapes
	    where parcours=$1 and etape in 
	    (select id from v2.etape where type=10)
	loop
	    nb:=nb+1;
	    raise notice 'nb=%',nb;
	end loop;
	raise notice 'nb=%',nb;
	if nb>0 and ($3 like 4 || '%' or $3 like 5 || '%')then
	    return false;
	else
	    return true;
	
	end if;
    end if;
    
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_is_parcours_etape_modifiable(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 396 (class 1255 OID 2597076)
-- Dependencies: 2983 7
-- Name: prcrs_is_parcours_oriente(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_is_parcours_oriente(integer) RETURNS boolean
    AS $_$-- $1 : parcours
declare
rec record;
nb integer;
begin
    nb:=0;
    for rec in 
	select * from v2.af_get_parcours_oriente_configuration($1)
	as ( etape int4,  sous_parcours int4, type_evaluation int4, seuil int4)
    loop
	nb:=nb+1;
	raise notice 'nb=%',nb;
    end loop;
    if nb=0 then
	return false;
    else
	return true;
    end if;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_is_parcours_oriente(integer) OWNER TO pgsql;

--
-- TOC entry 9292 (class 0 OID 0)
-- Dependencies: 396
-- Name: FUNCTION prcrs_is_parcours_oriente(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_is_parcours_oriente(integer) IS 'retourne vrai si le parcours est configurÃƒÂ© en orientation,faux sinon';


--
-- TOC entry 397 (class 1255 OID 2597077)
-- Dependencies: 2983 7
-- Name: prcrs_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 libelle_type_etape 
--$4 obligatoire
--$5 chrono
--$6 fin de page
BEGIN
	UPDATE v2.parcours_etapes
	SET libelle_type_etape=$3, obligatoire=$4, chrono=$5, fin=$6
	WHERE parcours=$1 AND etape=$2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 398 (class 1255 OID 2597078)
-- Dependencies: 2983 7
-- Name: prcrs_maj_parcours_duree(integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_parcours_duree(integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 affichage duree fo
BEGIN
	UPDATE v2.parcours
	SET duree=$2
	WHERE id=$1; 
	
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_parcours_duree(integer, boolean) OWNER TO pgsql;

--
-- TOC entry 399 (class 1255 OID 2597079)
-- Dependencies: 2983 7
-- Name: prcrs_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 pere
--$3 nouvelle tape
--$4 obligation
--$5 chrono
--$6 fin de page
BEGIN
	IF $2 IS NOT NULL THEN
		UPDATE v2.parcours_etapes
		SET etape=$3, obligatoire=$4, chrono=$5, fin=$6
		WHERE parcours=$1 AND pere=$2;
	ELSE
		UPDATE v2.parcours_etapes
		SET etape=$3, obligatoire=$4, chrono=$5, fin=$6
		WHERE parcours=$1 AND pere IS NULL;
	END IF;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 400 (class 1255 OID 2597080)
-- Dependencies: 2983 7
-- Name: prcrs_maj_parcours_etape_duree(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_parcours_etape_duree(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 duree
val int4;
BEGIN
	IF $3=0 THEN
		val:=NULL;
	ELSE
		val:=$3;
	END IF;

	UPDATE v2.parcours_etapes
	SET chrono=val
	WHERE parcours=$1 AND etape=$2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_parcours_etape_duree(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 401 (class 1255 OID 2597081)
-- Dependencies: 2983 7
-- Name: prcrs_maj_parcours_etape_ordre(integer, integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_parcours_etape_ordre(integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape source
--$3 etape destination
pere_src int4;
pere_dst int4;
suivant_src int4;
precedent_dst int4;
tmp int4;
BEGIN

	--recup du pere de la source
	SELECT INTO pere_src pere FROM v2.af_get_parcours_etape($1,$2)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar);

	--recup du pere de la destination
	SELECT INTO pere_dst pere FROM v2.af_get_parcours_etape($1,$3)AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar);

	--maj de la source (1ere etape -> petite astuce: on met le pere Ãƒ  l'id du dernier, (pas utilisÃƒÂ© pour un pere) pour eviter les conflits)
	SELECT INTO tmp P.id FROM v2.af_gen_get_last_element('v2.parcours_etapes', 'etape',' AND parcours='||$1) P;
	UPDATE v2.parcours_etapes SET pere=tmp WHERE parcours=$1 AND etape=$2;

	--maj du suivant de la source
	UPDATE v2.parcours_etapes SET pere=pere_src WHERE parcours=$1 AND pere=$2;
		
--INSERTION AVANT
IF $4 THEN

	--recup du suivant de la source
	SELECT INTO suivant_src etape FROM v2.parcours_etapes WHERE parcours=$1 AND pere=$2;

	--maj de la destination
	UPDATE v2.parcours_etapes SET pere=$2   WHERE parcours=$1 AND etape=$3;

	--maj de la source (2eme etape -> on met la bonne valeur au pere)
	UPDATE v2.parcours_etapes SET pere=pere_dst WHERE parcours=$1 AND etape=$2; 

--INSERTION APRES
ELSE
	--maj du suivant de la destination
	UPDATE v2.parcours_etapes SET pere=$2   WHERE parcours=$1 AND pere=$3;

	--maj de la source (2eme etape -> on met la bonne valeur au pere)
	UPDATE v2.parcours_etapes SET pere=$3 WHERE parcours=$1 AND etape=$2; 
END IF;

	RETURN TRUE;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_parcours_etape_ordre(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 402 (class 1255 OID 2597082)
-- Dependencies: 2983 7
-- Name: prcrs_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 libelle
BEGIN
	UPDATE v2.parcours_etapes
	SET libelle_type_etape=$3
	WHERE parcours=$1
	AND etape=$2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 403 (class 1255 OID 2597083)
-- Dependencies: 2983 7
-- Name: prcrs_maj_parcours_etapes_duree_type(integer, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_parcours_etapes_duree_type(integer, character varying, integer) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 type
--$3 duree
val int4;
BEGIN
	IF $3=0 THEN
		val:=NULL;
	ELSE
		val:=$3;
	END IF;

	UPDATE v2.parcours_etapes 
	SET chrono=val
	FROM v2.af_get_parcours_etapes($1)AS (E_id int4, E_libelle_alias varchar, E_libelle varchar, E_libelle_type_etape  varchar, E_type varchar,  E_pere int4, E_parcours int4, E_obligatoire bool, E_chrono int4, E_fin bool, E_libelle_type_original varchar, E_modifiable bool) 
	WHERE parcours=$1 AND E_type LIKE $2||'%'
	AND E_type NOT LIKE '4_1_4%'
	AND etape=E_id;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_parcours_etapes_duree_type(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 404 (class 1255 OID 2597084)
-- Dependencies: 2983 7
-- Name: prcrs_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 identifiant de l'ÃƒÂ©tape
--$2 libelle etape
--$3 les sous parcours
--$4 types d'ÃƒÂ©tapes
--$5 nombre de types d'etapes
--$6 seuil
ok1 bool;
ok2 bool;
val int4;
i int4;
j int4;
curs int4:=1;
BEGIN
	--modif de l'etape
	SELECT INTO ok1 * FROM v2.af_maj_etape_libelle($1,$2); 
	
	--suppression de la configuration
	DELETE FROM v2.parcours_oriente WHERE id=$1;
	ok2:=FOUND;

	--insertion de la nouvelle configuration
	FOR i IN array_lower($3, 1) .. array_upper($3, 1)  
	LOOP
		--le 1er sous parcours
		IF i=1 THEN
			INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil,ordre) values($1,$3[i],NULL,NULL, i);
			raise notice '1er parcours %: INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',curs,$1,$3[i],'NULL','NULL';
		--les autres
		ELSE
			--seuil global
			IF $4[curs]=-1 THEN
				INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil,ordre) values($1,$3[i],NULL,$6[curs],i);
				raise notice 'global %: INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',curs,$1,$3[i],'NULL',$6[curs];
				curs:=curs+1;
			--seuil par type
			ELSE
				--pour chacun des types
				FOR j IN 1 .. $5
				LOOP
					--cas ou pas de seuil pour le type
					IF $6[curs] =-1 THEN
						val:=NULL;
					ELSE
						val:=$6[curs];
					END IF;
					INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil,ordre) values($1,$3[i],$4[curs],val,i);
					raise notice 'type %: INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',curs,$1,$3[i],$4[curs],val;
					curs:=curs+1;
				END LOOP;
			END IF;
		END IF;
	END LOOP;
	
	RETURN ok1 OR ok2;
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 405 (class 1255 OID 2597085)
-- Dependencies: 2983 7
-- Name: prcrs_maj_parcours_type_etape_personnalise(integer, integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_parcours_type_etape_personnalise(integer, integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 type d'etape
--$3 libelle
BEGIN
	UPDATE v2.parcours_etapes
	SET libelle_type_etape=$3
	FROM v2.etape
	WHERE parcours=$1
	AND v2.parcours_etapes.etape=v2.etape.id
	AND v2.etape.type=$2;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_parcours_type_etape_personnalise(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 406 (class 1255 OID 2597086)
-- Dependencies: 2983 7
-- Name: prcrs_maj_resultat_debut(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_resultat_debut(integer) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
date_deb timestamp;
BEGIN
	SELECT INTO date_deb date_debut FROM v2.resultat
	WHERE id=$1;

	IF date_deb IS NULL THEN
		RAISE EXCEPTION 'Erreur: la date de dÃƒÂ©but ne peut etre mise jour, elle n''a pas ÃƒÂ©tÃƒÂ© affectÃƒÂ©e auparavent';
	END IF;

	UPDATE v2.resultat
	SET date_debut=now()
	WHERE id=$1;
	
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_resultat_debut(integer) OWNER TO pgsql;

--
-- TOC entry 407 (class 1255 OID 2597087)
-- Dependencies: 2983 7
-- Name: prcrs_maj_resultat_fin(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_maj_resultat_fin(integer) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
duree_init interval;
BEGIN
	SELECT INTO duree_init duree FROM v2.resultat WHERE id=$1;
	
	IF duree_init IS NULL THEN
		RAISE EXCEPTION 'Erreur: la durÃƒÂ©e doit avoir dÃƒÂ©jÃƒ  ÃƒÂ©tÃƒÂ© affectÃƒÂ©e pour la fin de l''ÃƒÂ©tape';
	ELSE
		UPDATE v2.resultat
		SET duree=cast(now() AS timestamp without time zone)-date_debut+duree_init
		WHERE id=$1;

		RETURN FOUND;
	END IF;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_maj_resultat_fin(integer) OWNER TO pgsql;

--
-- TOC entry 408 (class 1255 OID 2597088)
-- Dependencies: 2983 7
-- Name: prcrs_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 etape
--$2 types
--$3 seuils
--$4 sous parcours
BEGIN
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 409 (class 1255 OID 2597089)
-- Dependencies: 2983 7
-- Name: prcrs_set_parcours(character varying, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION prcrs_set_parcours(character varying, integer) RETURNS integer
    AS $_$declare
	num_etape int4;
begin
	
	select into num_etape v2.af_set_etape($1,1); 
	insert into v2.parcours(id,filiere) values(num_etape,$2);
	return num_etape;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_set_parcours(character varying, integer) OWNER TO postgres;

--
-- TOC entry 9293 (class 0 OID 0)
-- Dependencies: 409
-- Name: FUNCTION prcrs_set_parcours(character varying, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION prcrs_set_parcours(character varying, integer) IS 'crÃƒÆ’Ã‚Â©e un parcours';


--
-- TOC entry 410 (class 1255 OID 2597090)
-- Dependencies: 2983 7
-- Name: prcrs_set_parcours_etape(integer, integer, integer, boolean, integer, boolean); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION prcrs_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
--$3 pere
--$4 obligation
--$5 duree
--$6 fin de page
/*BEGIN
	INSERT INTO v2.parcours_etapes (parcours, etape, pere, obligatoire, chrono, fin)
	VALUES ($1, $2, $3, $4, $5, $6);

	RETURN FOUND;
END;
declare*/
	
	insere bool;
	chaine varchar;
	req text;
	rec record;
begin
	
	chaine:=','||$1||','||
	case when $4 then 
		
		'true'
	else
		
		'false'
	end
	||' ,';

	IF $5 IS NOT NULL THEN chaine:=chaine||$5;
	ELSE chaine:=chaine||'NULL';
	END IF;
 
	chaine:=chaine||','||
	case when $6 then 
		
		'true'
	else
		
		'false'
	end
	||' ';

	
	raise notice '%',chaine;
	req:='select  v2.af_gen_set_element(varchar ''v2.parcours_etapes'', varchar ''etape'' ,';
	IF $3 is null then 
		req:=req||' NULL';
	else
		req:=req||$3;
	end if;
	req:=req||','||$2||', text'', parcours,obligatoire,chrono,fin'',text '''||chaine||''', text ''AND parcours='||$1||''');';
	--raise notice '%',req;
	

	execute req;

	--IF FOUND THEN 
		return  TRUE;
	--ELSE 
	--	RETURN FALSE;
	--END IF;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) OWNER TO postgres;

--
-- TOC entry 9294 (class 0 OID 0)
-- Dependencies: 410
-- Name: FUNCTION prcrs_set_parcours_etape(integer, integer, integer, boolean, integer, boolean); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION prcrs_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) IS 'ajoute une etape au parcours';


--
-- TOC entry 411 (class 1255 OID 2597091)
-- Dependencies: 2983 7
-- Name: prcrs_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle etape
--$2 les sous parcours
--$3 types d'ÃƒÂ©tapes
--$4 nombre de types d'etapes
--$5 seuil
num_etape int4;
val int4;
i int4;
j int4;
curs int4:=1;
BEGIN
	--creation de l'etape
	SELECT INTO num_etape v2.af_set_etape($1,10); 
	
	--insertion de la configuration
	FOR i IN array_lower($2, 1) .. array_upper($2, 1)  
	LOOP
		--le 1er sous parcours
		IF i=1 THEN
			raise notice '1er parcours %: INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',i,num_etape,$2[i],'NULL','NULL';
			INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil,ordre) values(num_etape,$2[i],NULL,NULL, i);
		--les autres
		ELSE
			--seuil global
			IF $3[curs]=-1 THEN
				raise notice 'global %: INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',i,num_etape,$2[i],'NULL',$5[curs];
				INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil,ordre) values(num_etape,$2[i],NULL,$5[curs],i);
				curs:=curs+1;
			--seuil par type
			ELSE
				--pour chacun des types
				FOR j IN 1 .. $4
				LOOP
					--cas ou pas de seuil pour le type
					IF $5[curs] =-1 THEN
						val:=NULL;
					ELSE
						val:=$5[curs];
					END IF;
					raise notice 'type %: INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil) values(%,%,%,%);',i,num_etape,$2[i],$3[curs],val;
					INSERT INTO v2.parcours_oriente(id,sous_parcours,type,seuil,ordre) values(num_etape,$2[i],$3[curs],val,i);
					curs:=curs+1;
				END LOOP;
			END IF;
		END IF;
	END LOOP;
	
	RETURN num_etape;
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 412 (class 1255 OID 2597092)
-- Dependencies: 2983 7
-- Name: prcrs_set_resultat_debut(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_set_resultat_debut(integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 formation
--$2 stagiaire
--$3 parcours
--$5 etape
new_oid oid;
new_id int4;
BEGIN
	INSERT INTO v2.resultat
	(formation,stagiaire,parcours,etape, date_debut)
	VALUES ($1,$2,$3,$4, now());

	--RECUPERE L'IDENTIFIANT DU NOUVEAU RESULTAT
	GET DIAGNOSTICS new_oid = RESULT_OID;

	select into new_id id from v2.resultat where oid=new_oid;
	return new_id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_set_resultat_debut(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 413 (class 1255 OID 2597093)
-- Dependencies: 2983 7
-- Name: prcrs_set_resultat_fin(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_set_resultat_fin(bigint) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
duree_init interval;
BEGIN
	SELECT INTO duree_init duree FROM v2.resultat WHERE id=$1;

	IF duree_init IS NOT NULL THEN
		RAISE EXCEPTION 'Erreur: la durÃƒÂ©e a dÃƒÂ©jÃƒ  ÃƒÂ©tÃƒÂ© affectÃƒÂ©e pour la fin de l''ÃƒÂ©tape';
	ELSE
		UPDATE v2.resultat
		SET duree=cast(now() AS timestamp without time zone)-date_debut
		WHERE id=$1;

		RETURN FOUND;
	END IF;
	
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_set_resultat_fin(bigint) OWNER TO pgsql;

--
-- TOC entry 414 (class 1255 OID 2597094)
-- Dependencies: 2983 7
-- Name: prcrs_set_resultat_meilleure_tentative(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_set_resultat_meilleure_tentative(bigint) RETURNS boolean
    AS $_$-- $1 : id resultat
declare
rec_resultat record;
rec record;
rec2 record;
rec_resultat_evaluation record;
score real;
score_courant real;
meilleure_tentative integer;
meilleur_identifiant bigint;
begin
    -- recup info resultat
    select into rec_resultat * from v2.af_get_resultat($1) 
    as (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval); 
    -- boucle sur les tentatives
    score:=0;
    meilleure_tentative:=0;
    for rec in 
	select * from v2.resultat_tentative where 
	formation=rec_resultat.formation and 
	stagiaire=rec_resultat.stagiaire and 
	parcours=rec_resultat.parcours and 
	etape=rec_resultat.etape
    loop
	-- recup score courant
	select into score_courant * from v2.af_get_resultat_serie_score_tentative(rec.id);
	raise notice 'scor_cou=%',score_courant;
	if score_courant > score then
	    score:=score_courant;
	    meilleure_tentative:=rec.tentative;
	    meilleur_identifiant:=rec.id;
	end if;


    end loop;

    -- recup score serie
    select into score_courant * from v2.af_get_resultat_serie_score($1);
    raise notice 'sco=% et score_cour=%',score,score_courant;
    if score > score_courant then
	-- mise Ãƒ  jour des resultats
	-- boucle sur les evaluations de la serie
	for rec2 in
	    select * from v2.af_get_serie_evaluations(rec_resultat.etape) 
	    as (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	loop
	    -- suivant le type d'ÃƒÂ©valuation
	    -- question reponse
	    if rec2.type_evaluation=1 or rec2.type_evaluation=4 then
		for rec_resultat_evaluation in
		    select * from v2.af_get_resultat_serie_question_reponse_tentative(meilleur_identifiant,rec2.id_evaluation) 
		    as (id bigint, question_reponse integer, question integer, reponse integer,  date_creation timestamp, coche boolean, juste integer)
		loop
		    -- mise Ãƒ  jour
		    --raise notice 'mise a jour';
		    update v2.resultat_serie_question_reponse set coche=rec_resultat_evaluation.coche where
		    id=$1 and 
		    question_reponse=rec_resultat_evaluation.question_reponse and
		    question=rec_resultat_evaluation.question and 
		    reponse=rec_resultat_evaluation.reponse;

		end loop;

	    end if;
	    -- ftb
	    if rec2.type_evaluation=3 then
		for rec_resultat_evaluation in
		    select * from v2.af_get_resultat_serie_ftb_tentative(meilleur_identifiant,rec2.id_evaluation)
		    as (id bigint, ftb integer, reponse character varying[],  date_creation timestamp)
		loop
		    -- mise Ãƒ  jour
		    update v2.resultat_serie_ftb set reponse=rec_resultat_evaluation.reponse where 
		    id=$1 and ftb=rec_resultat_evaluation.ftb; 
		end loop;
	    end if;
	    

	end loop;


    end if;
    return true;	


end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_set_resultat_meilleure_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 9295 (class 0 OID 0)
-- Dependencies: 414
-- Name: FUNCTION prcrs_set_resultat_meilleure_tentative(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_set_resultat_meilleure_tentative(bigint) IS 'enregistre la meilleurs tentative pour une serie bloquante';


--
-- TOC entry 415 (class 1255 OID 2597095)
-- Dependencies: 2983 7
-- Name: prcrs_set_resultat_tentative(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION prcrs_set_resultat_tentative(bigint) RETURNS boolean
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
nb_tentative integer;
nb_tentatives integer;
res_id integer;
new_id integer;
begin
    
    -- recup nb_tentative deja faite
    perform * from v2.af_get_resultat_etape_tentative($1) 
    as (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp,duree interval,tentative integer);
    GET DIAGNOSTICS nb_tentative = ROW_COUNT;
    nb_tentatives:=nb_tentative + 1;

    -- insertion dans resultat_tentative
    select into rec * from v2.af_get_resultat($1) 
    as (id bigint,formation integer,stagiaire integer,parcours integer,etape integer,date_debut timestamp, duree interval); 
    insert into v2.resultat_tentative(formation,stagiaire,parcours,etape,date_debut,duree,tentative) 
    values(rec.formation,rec.stagiaire,rec.parcours,rec.etape,rec.date_debut,rec.duree,nb_tentatives);
    GET DIAGNOSTICS res_id = RESULT_OID;
    select into new_id id from v2.resultat_tentative where oid=res_id;

    -- insertion dans resultat_serie_tentative
    for rec in
	select * from v2.af_get_resultat_serie_evaluations($1) 
	as (id bigint,evaluation integer,date_creation timestamp)
    loop
	insert into v2.resultat_serie_tentative(id,evaluation,date_creation) 
	values(new_id,rec.evaluation,rec.date_creation);
    end loop;

    -- Les evaluations (question_reponse et ftb)
    for rec in 
	select * from v2.resultat_serie_question_reponse where id=$1
    loop
	insert into v2.resultat_serie_tentative_question_reponse(id,question_reponse,question,reponse,coche) 
	values(new_id,rec.question_reponse,rec.question,rec.reponse,rec.coche);
    end loop;
    for rec in 
	select * from v2.resultat_serie_ftb where id=$1
    loop
	insert into v2.resultat_serie_tentative_ftb(id,ftb,reponse) 
	values(new_id,rec.ftb,rec.reponse);
    end loop;
    return true;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.prcrs_set_resultat_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 9296 (class 0 OID 0)
-- Dependencies: 415
-- Name: FUNCTION prcrs_set_resultat_tentative(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION prcrs_set_resultat_tentative(bigint) IS 'stocke tous les resultats pour un identifiant de resultat (serie bloquante)';


--
-- TOC entry 416 (class 1255 OID 2597096)
-- Dependencies: 2983 7
-- Name: pstnnmnt_del_positionnement(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_del_positionnement(integer) RETURNS boolean
    AS $_$BEGIN
	DELETE FROM v2.positionnement
	WHERE id=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_del_positionnement(integer) OWNER TO pgsql;

--
-- TOC entry 417 (class 1255 OID 2597097)
-- Dependencies: 2983 7
-- Name: pstnnmnt_del_positionnement_choix(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_del_positionnement_choix(integer, integer) RETURNS boolean
    AS $_$DECLARE
qr int4;
nb_del int4:=0;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	--SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	SELECT INTO nb_del * FROM v2.af_gen_del_element('v2.choix', 'id', $2, ' AND positionnement='||$1);

	RETURN nb_del>0;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_del_positionnement_choix(integer, integer) OWNER TO pgsql;

--
-- TOC entry 418 (class 1255 OID 2597098)
-- Dependencies: 2983 7
-- Name: pstnnmnt_del_positionnement_evaluations_a_generer(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_del_positionnement_evaluations_a_generer(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question de positionnement
--$3 choix
--$4 evaluation
qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	DELETE FROM v2.positionnement_evaluations
	WHERE question_reponse=qr
	AND question=$2
	AND choix=$3;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_del_positionnement_evaluations_a_generer(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 419 (class 1255 OID 2597099)
-- Dependencies: 2983 7
-- Name: pstnnmnt_del_positionnement_question(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_del_positionnement_question(integer, integer) RETURNS boolean
    AS $_$DECLARE
qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	PERFORM * FROM v2.af_gen_del_element('v2.question_reponse_elements', 'question', $2, ' AND question_reponse='||qr);

	RETURN TRUE;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_del_positionnement_question(integer, integer) OWNER TO pgsql;

--
-- TOC entry 420 (class 1255 OID 2597100)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN

	
	SELECT INTO rec P.id, P.libelle, QR.type, P.chrono, P.serie_generee, S.bareme, S.chrono AS chrono_genere, QR.radio, P.qsrc, E.date_creation
	FROM v2.positionnement P, v2.serie S, v2.qsrc Q, v2.question_reponse QR, v2.evaluation E
	WHERE P.id=$1
	AND P.serie_generee=S.id
	AND P.qsrc=Q.id
	AND Q.id=QR.id
	AND P.qsrc=E.id;

	RETURN rec;
	
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement(integer) OWNER TO pgsql;

--
-- TOC entry 421 (class 1255 OID 2597101)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_choix(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_choix(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;
	raise notice 'question_reponse=%',qr;
	FOR rec IN
		SELECT DISTINCT O_id,R.libelle,R.interpretation_html,R.reponse
		FROM v2.af_gen_get_elements('v2.choix', 'id', NULL, 'AND positionnement='||$1 ) O_id
		LEFT OUTER JOIN
		v2.question_reponse_element R
		ON O_id=R.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_choix(integer) OWNER TO pgsql;

--
-- TOC entry 422 (class 1255 OID 2597102)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_choix_infos(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_choix_infos(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;

qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;
	
	FOR rec IN
		SELECT C_id  , A_libelle, A_interpretationHTML ,C.positionnement, C.bareme, C.pere ,M.media, M.hauteur, M.largeur 
		FROM (v2.choix C INNER JOIN 
		v2.af_gen_get_elements('v2.choix', 'id', NULL, 'AND positionnement='||$1 ) C_id 
		ON C_id= C.id)
		LEFT OUTER JOIN v2.media_question_reponse_element M 
		ON C_id=M.question_reponse_element AND M.question_reponse=qr
		LEFT OUTER JOIN v2.af_get_positionnement_choix($1) AS (A_id int4, A_libelle varchar, A_interpretationHTML bool, A_question bool)
		ON C_id=A_id
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_choix_infos(integer) OWNER TO pgsql;

--
-- TOC entry 423 (class 1255 OID 2597103)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_choix_infos(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_choix_infos(integer, integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	
	
	SELECT INTO rec * FROM v2.af_get_positionnement_choix_infos($1)AS (id int4, libelle varchar, interpretationHTML bool, positionnement int4, bareme int4, pere int4, media int4, longueur int4, largeur int4)
	WHERE id=$2;
	

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_choix_infos(integer, integer) OWNER TO pgsql;

--
-- TOC entry 424 (class 1255 OID 2597104)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_count_evaluations_a_associer(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_count_evaluations_a_associer(integer) RETURNS integer
    AS $_$DECLARE
nb int4:=0;
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM v2.af_get_positionnement_nb_evaluations_a_generer($1) 
		AS (id int4, reponse int4, type int4, nb_a_generer int4, taille_chapeau int4)
	LOOP
		IF rec.taille_chapeau IS NULL THEN
			nb:=nb+rec.nb_a_generer;
		ELSE
			nb:=nb+rec.taille_chapeau;
		END IF;
	END LOOP;
	RETURN nb; 
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_count_evaluations_a_associer(integer) OWNER TO pgsql;

--
-- TOC entry 425 (class 1255 OID 2597105)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_elements(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_elements(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;
	
	FOR rec IN
		SELECT DISTINCT E.question , E.choix
		FROM v2.positionnement_elements E, 
		v2.af_gen_get_elements('v2.question_reponse_elements', 'question', NULL, 'AND question_reponse='||qr ) O_id
		WHERE E.question=O_id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_elements(integer) OWNER TO pgsql;

--
-- TOC entry 426 (class 1255 OID 2597106)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_evaluation_a_generer(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_evaluation_a_generer(integer, integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3 reponse
--$4 ordre
rec RECORD;
qr int4;
v_i int4:=0;
BEGIN

	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	FOR rec IN
		
		SELECT E.id, E.libelle, E.type, P.pere 
		FROM 
		
		v2.af_gen_get_elements('v2.positionnement_evaluations', 'evaluation', NULL, ' AND question_reponse='||qr ||' AND question='||$2||' AND choix='||$3) AS O_id,
		v2.evaluation E ,
		v2.positionnement_evaluations P 
			
		     
		WHERE P.evaluation=O_id
		AND E.id=O_id
		AND P.question_reponse=qr 
		AND P.question=$2
		AND P.choix=$3
	LOOP
		RAISE NOTICE '% % %',qr,$2,$3;
		v_i:=v_i+1;
		IF v_i=$4 THEN
			RETURN rec;
		END IF;
	END LOOP; 

	RETURN NULL;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_evaluation_a_generer(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 427 (class 1255 OID 2597107)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_evaluations_a_generer(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_evaluations_a_generer(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	SELECT INTO qr question_reponse FROM v2.positionnement
	WHERE id=$1;
 
	FOR rec IN
		SELECT  E.id, E.libelle, E.type, EV.pere
		FROM v2.af_gen_get_elements('v2.positionnement_evaluations', 'evaluation', NULL, 'AND question_reponse='||qr||' AND question='||$2||' AND choix='||$3 ) O_id,
		v2.evaluation E,
		v2.positionnement_evaluations EV
		WHERE E.id=O_id
		AND E.type=$4
		AND EV.question_reponse=qr
		AND EV.question=$2
		AND EV.choix=$3 
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_evaluations_a_generer(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 428 (class 1255 OID 2597108)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_evaluations_a_generer(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_evaluations_a_generer(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	SELECT INTO qr question_reponse FROM v2.positionnement
	WHERE positionnement=$1;
 
	FOR rec IN
		SELECT  T.id, T.libelle, T.type, E.question, E.reponse
		FROM v2.positionnement_elements E,
		v2.positionnement_evaluations V,
		--v2.af_gen_get_elements('v2.q', 'evaluation', NULL, 'AND question_reponse='||qr ) O_id,
		v2.evaluation T
		--WHERE O_id=V.question_reponse
		WHERE V.question_reponse=E.question_reponse
		AND E.question=$2
		AND E.choix=$3
		AND V.evaluation=T.id
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_evaluations_a_generer(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 429 (class 1255 OID 2597109)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_evaluations_a_generer(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_evaluations_a_generer(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	SELECT INTO qr qsrc FROM v2.positionnement
	WHERE id=$1;
 
	FOR rec IN
		SELECT  T.id, T.libelle, T.type, V.question, V.choix, CAST(NULL AS int4) AS pere
		FROM 
		--v2.positionnement_elements E,
		v2.positionnement_evaluations V,
		v2.evaluation T
		WHERE V.question_reponse=qr
		--AND V.question_reponse=E.question_reponse
		AND V.evaluation=T.id
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_evaluations_a_generer(integer) OWNER TO pgsql;

--
-- TOC entry 430 (class 1255 OID 2597110)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_evaluations_affiliables_type(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_evaluations_affiliables_type(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 positionnement
--$2 theme
--$3 type
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;
	
	FOR rec IN
		SELECT DISTINCT E.id, E.libelle, E.type
		FROM ((v2.evaluation E INNER JOIN 
		v2.af_get_theme_evaluations($2) AS (T_id int4, T_type int4) ON T_id=E.id)
		LEFT OUTER JOIN	v2.positionnement_evaluations PE 
		ON T_id=PE.evaluation AND PE.question_reponse=qr)
		WHERE E.type=$3
		AND T_type=$3 
		AND PE.evaluation IS NULL 
		 
		--GROUP BY E.id,PE.evaluation, PE.question_reponse, E.libelle, E.type
		--HAVING E.id!=PE.evaluation 
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_evaluations_affiliables_type(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 431 (class 1255 OID 2597111)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_last_question(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_last_question(integer) RETURNS integer
    AS $_$DECLARE 
last_id int4;
question_reponse_id int4;

BEGIN
	--on recupere le question_reponse correscpondant au positionnement
	SELECT INTO question_reponse_id  question_reponse FROM v2.positionnement WHERE id=$1;
	
	IF question_reponse_id IS NOT NULL THEN
		SELECT INTO last_id ID FROM v2.af_gen_get_last_element('v2.question_reponse_elements', 'question',' AND question_reponse='||question_reponse_id);
		RETURN last_id;
	ELSE
		RETURN NULL;
	END IF;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_last_question(integer) OWNER TO pgsql;

--
-- TOC entry 432 (class 1255 OID 2597112)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_media(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_media(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	SELECT INTO rec media, hauteur, largeur, question_reponse 
	FROM v2.af_get_question_reponse_media(qr) AS (  question_reponse int4, media int4, flash int4, hauteur int4, largeur int4 );

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_media(integer) OWNER TO pgsql;

--
-- TOC entry 433 (class 1255 OID 2597113)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_nb_evaluations_a_generer(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_nb_evaluations_a_generer(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;

BEGIN
 
	FOR rec IN
		SELECT E.positionnement , E.choix , E.type , E.nombre , E.nombre_max 
		FROM v2.positionnement_choix_evaluations E,
		v2.af_gen_get_elements('v2.choix', 'id', NULL, 'AND positionnement='||$1 ) O_id
		WHERE O_id=E.choix
		AND E.positionnement=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_nb_evaluations_a_generer(integer) OWNER TO pgsql;

--
-- TOC entry 434 (class 1255 OID 2597114)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_question_positionnement_solution(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_question_positionnement_solution(integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3 reponse
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	SELECT INTO rec * FROM v2.qcm_elements
	WHERE question_reponse=qr
	AND question=$2
	AND reponse=$3;
	raise notice 'qr=% q=% r=%', qr, $2,$3;
	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_question_positionnement_solution(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 435 (class 1255 OID 2597115)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnement_questions(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnement_questions(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;
	
	FOR rec IN
		SELECT DISTINCT Q.id,Q.libelle,Q.interpretation_html,Q.reponse, O_id.ind
		FROM v2.af_gen_get_elements('v2.question_reponse_elements', 'question', NULL, 'AND question_reponse='||qr , 0) O_id,
		v2.question_reponse_element Q
		WHERE O_id.id=Q.id
		ORDER BY O_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnement_questions(integer) OWNER TO pgsql;

--
-- TOC entry 436 (class 1255 OID 2597116)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_positionnements(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_positionnements() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT P.id, P.libelle, P.type_question, P.chrono, P.serie_aleatoire, S.bareme, S.chrono
		FROM v2.positionnement P, v2.serie S
		WHERE P.serie_aleatoire=S.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_positionnements() OWNER TO pgsql;

--
-- TOC entry 437 (class 1255 OID 2597117)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_question_positionnement_media(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_question_positionnement_media(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 idenfifiant de la question de positionnement
--$2 idenfifiant du positionnement
rec RECORD;
qr int4;
BEGIN
	SELECT INTO qr question_reponse FROM v2.positionnement
	WHERE id=$2;

	SELECT INTO rec question_reponse, question_reponse_element, media, media, hauteur, largeur 
	FROM v2.af_get_question_reponse_element_media(qr,$1) AS (question_reponse int4, question_reponse_element int4, media int4, flash int4, hauteur int4, largeur int4);
	

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_question_positionnement_media(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9297 (class 0 OID 0)
-- Dependencies: 437
-- Name: FUNCTION pstnnmnt_get_question_positionnement_media(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION pstnnmnt_get_question_positionnement_media(integer, integer) IS 'Obtenir le media d''une question de positionnement pour un positionnement.';


--
-- TOC entry 438 (class 1255 OID 2597118)
-- Dependencies: 2983 7
-- Name: pstnnmnt_get_theme_positionnements(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_get_theme_positionnements(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT P.id, P.libelle, P.type_question, P.chrono, P.serie_aleatoire, P.question_reponse, C_theme 
		FROM v2.positionnement P,
		v2.af_get_categorie_elements(22) AS (C_id int4, C_theme int4, C_categorie int4)
		WHERE P.id=C_id
		AND C_theme=$1
		ORDER BY P.libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_get_theme_positionnements(integer) OWNER TO pgsql;

--
-- TOC entry 439 (class 1255 OID 2597119)
-- Dependencies: 2983 7
-- Name: pstnnmnt_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 id
--$2 libelle
--$3 media
--$4 hauteur
--$5 largeur
--$6 chrono
--$7 chrono evaluations generees
--$8 bareme evaluations generees
ok bool;
ok1 bool;
eval int4;
serie_al int4;
qr int4;
BEGIN 

	--on selectionne la serie aleatoire associÃƒÂ©e au positionnement
	SELECT INTO serie_al serie_aleatoire FROM v2.positionnement where id=$1;

	--on selectionne le question reponse associÃƒÂ©e au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	--on maj la serie aleatoire
	PERFORM v2.af_maj_serie(serie_al, $2, $8, $7);

	--on maj l'evaluation
	PERFORM v2.af_maj_evaluation($1, $2);

	--on maj le positionnement
	UPDATE v2.positionnement SET
	libelle=$2, chrono=$6
	WHERE id=$1;	
	ok:=FOUND;

	IF $3 IS NOT NULL THEN
		SELECT INTO ok1 * FROM v2.af_maj_question_reponse_media(qr,$3,$4,$5);
		IF ok1=FALSE THEN
			PERFORM * FROM v2.af_set_question_reponse_media(qr,$3,$4,$5);
		END IF;
	ELSE
		PERFORM * FROM v2.af_del_question_reponse_media(qr);
	END IF;

	RETURN ok;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 440 (class 1255 OID 2597120)
-- Dependencies: 2983 7
-- Name: pstnnmnt_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 choix
--$3 nouveau choix
--$4 bareme
--$5 media
--$6 hauteur
--$7 largeur
r1 boolean;
r2 boolean;
qr int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	UPDATE v2.choix
	SET id=$3, bareme=$4
	WHERE positionnement=$1
	AND id=$2;
	r1 := FOUND;

	IF $5 IS NOT NULL THEN
		UPDATE v2.media_question_reponse_element
		SET media=$5, hauteur=$6, largeur=$7
		WHERE question_reponse=qr
		AND question_reponse_element=$3;
		r2 := FOUND;
		
		IF r2!=TRUE THEN
			INSERT INTO v2.media_question_reponse_element (question_reponse, question_reponse_element, media, hauteur, largeur )
			VALUES (qr, $3, $5, $6, $7);
			r2 := FOUND;
		END IF;
	ELSE 
		DELETE FROM v2.media_question_reponse_element 
		WHERE question_reponse=qr
		AND question_reponse_element=$2;
		r2 := FOUND;
	END IF;

	RETURN r1 OR r2;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 441 (class 1255 OID 2597121)
-- Dependencies: 2983 7
-- Name: pstnnmnt_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 choix
--$3array int4 : type |  nb_a_generer | taille_chapeau
i int4;
qr int4;
j int4;
k int4;
BEGIN
FOR i IN array_lower($3,1) .. array_upper($3,1)
LOOP
	IF $3[i][3]=-1 THEN
		j:=NULL;
	ELSE
		j:=$3[i][3];
	END IF;

	IF $3[i][2]=-1 THEN
		k:=0;
	ELSE
		k:=$3[i][2];
	END IF;

	--on met a jour les nombres d'evaluations a generer
	UPDATE v2.positionnement_choix_evaluations
	SET nombre=k, nombre_max=j
	WHERE positionnement=$1 
	AND choix=$2
	AND type=$3[i][1];
	
END LOOP;
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 442 (class 1255 OID 2597122)
-- Dependencies: 2983 7
-- Name: pstnnmnt_maj_positionnement_question_positionnement_solution(integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_maj_positionnement_question_positionnement_solution(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3array int4 : choix |  juste (0 ou 1)
i int4;
qr int4;
b_value bool;
ok bool;
ok2 bool;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	FOR i IN array_lower($3,1) .. array_upper($3,1)
	LOOP
		IF $3[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		RAISE NOTICE 'maj: %, %, %, %==%',qr, $2, $3[i][1], b_value, $3[i][2];
		SELECT INTO ok * FROM v2.af_maj_question_reponse_solution(qr, $2, $3[i][1], b_value);
		IF ok IS FALSE THEN
			RAISE NOTICE 'set: %, %, %, %==%',qr, $2, $3[i][1], b_value, $3[i][2];
			SELECT INTO ok2 * FROM v2.af_set_question_reponse_solution(qr, $2, $3[i][1], b_value);
			IF ok2 IS FALSE THEN RAISE EXCEPTION 'Erreur sur l''insertion de la solution.'; END IF;
		END IF;
	END LOOP;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_maj_positionnement_question_positionnement_solution(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 443 (class 1255 OID 2597123)
-- Dependencies: 2983 7
-- Name: pstnnmnt_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3 libelle
--$4 media
--$5 hauteur
--$6 largeur
--$7 interpretation html
qr int4;
ok1 bool;
ok2 bool;
rec RECORD;
maj_rec RECORD;
existe int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement
	WHERE id=$1;

	--on met a jour la question 
	SELECT INTO ok1 * FROM v2.af_maj_question_reponse_element($2, $3, $7);
	RAISE NOTICE 'maj de la question: % % % % -->%',qr, $2, $3, $7,ok1;

	--on recupere la question (pour avaoir le champ pere)
	SELECT INTO maj_rec * 
	FROM  v2.question_reponse_elements
	WHERE question_reponse=$1
	AND question=$2;

	--on met a jour le media de la question de positionnement
	IF $4 IS NOT NULL THEN
		SELECT INTO ok2 * FROM v2.af_maj_question_reponse_element_media(qr, $2, $4, $5, $6);
		IF NOT ok2 THEN
			SELECT INTO ok2 * FROM v2.af_set_media_question_reponse_element(qr, $2, $4, $5, $6);
		END IF;
	ELSE
		PERFORM * FROM v2.af_del_question_reponse_element_media(qr, $2);
	END IF;
	ok2:=FOUND;

	FOR rec IN
		--on selectionne les choix du positionnement
		SELECT id FROM v2.choix where positionnement=$1

	--pour chacun des choix
	LOOP
		SELECT INTO existe COUNT (*) 
		FROM v2.question_reponse_elements
		WHERE question_reponse=qr
		AND question=$2
		AND reponse=rec.id;

		IF existe= 0 THEN

			--on associe les elements du question reponse
			PERFORM * FROM v2.af_set_question_reponse_association_element(qr, $2, rec.id, maj_rec.pere);

			--on enregistre l'association en tant qu'element de positionnement 
			INSERT INTO v2.positionnement_elements(question_reponse, question, choix)
			VALUES (qr, $2, rec.id);

		END IF;
	END LOOP;
	
	RETURN ok1 OR ok2;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 444 (class 1255 OID 2597124)
-- Dependencies: 2983 7
-- Name: pstnnmnt_set_positionnement(character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_set_positionnement(character varying, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 chrono
--$3 qsrc
--$4 serie_generee
new_id int4;
oid_id int4;
BEGIN 
	
	INSERT INTO v2.positionnement 
	(libelle, chrono, qsrc, serie_generee)
	VALUES ($1, $2, $3, $4);
	GET DIAGNOSTICS oid_id = RESULT_OID;
	--RAISE NOTICE 'oid inseree: % ',oid_id;

	SELECT INTO new_id id FROM v2.positionnement WHERE oid=oid_id;
	--RAISE NOTICE 'valeur inseree: % ',new_id;

	RETURN new_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_set_positionnement(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 445 (class 1255 OID 2597125)
-- Dependencies: 2983 7
-- Name: pstnnmnt_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 reponse
--$3 pere
--$4 bareme
--$5 media
--$6 hauteur
--$7 largeur
r1 boolean;
r2 boolean;
qr int4;
rec RECORD;
v_pere integer;
BEGIN
	--on recupere le pere pour l'insertion
	select INTO v_pere * from v2.af_gen_get_last_element('v2.choix', 'id',' AND positionnement='||$1);

	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	--insert le nouveau choix
	INSERT INTO v2.choix (positionnement, id, pere, bareme )
	VALUES ($1, $2, $3, $4);
	r1 := FOUND;

	--selection les questions existantes
	FOR rec IN 
		SELECT id FROM v2.af_get_positionnement_questions($1) AS (id integer, libelle varchar, interpretationHTML boolean, reponse boolean)
	LOOP 
		PERFORM * FROM v2.af_set_question_reponse_association_element(qr, rec.id, $2, v_pere);
		IF NOT FOUND THEN
			RAISE EXCEPTION 'af_set_positionnement: erreur association choix/question_reponse';
		END IF;
	END LOOP;

	--SELECT * FROM v2.af_set_question_reponse_association_element(qr, integer, $2, $3)

	IF $5 IS NOT NULL THEN
		INSERT INTO v2.media_question_reponse_element (question_reponse, question_reponse_element, media, hauteur, largeur )
		VALUES (qr, $2, $5, $6, $7);
		r2 := FOUND;
	END IF;

	RETURN r1 OR r2;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 446 (class 1255 OID 2597126)
-- Dependencies: 2983 7
-- Name: pstnnmnt_set_positionnement_evaluation_a_generer(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_set_positionnement_evaluation_a_generer(integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question de positionnement
--$3 choix
--$4 evaluation
qr int4;
id_pere int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	--on selectionne le dernier element
	SELECT INTO id_pere * FROM
	v2.af_gen_get_last_element('v2.positionnement_evaluations', 'evaluation', ' AND question_reponse='||qr||' AND question='||$2||' AND choix='||$3);

	INSERT INTO v2.positionnement_evaluations
	(question_reponse, question, choix, evaluation, pere)
	VALUES (qr, $2, $3,$4,id_pere);

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_set_positionnement_evaluation_a_generer(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 447 (class 1255 OID 2597127)
-- Dependencies: 2983 7
-- Name: pstnnmnt_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 choix
--$3 type
--$4 nb_a_generer
--$5 taille_chapeau
BEGIN

	INSERT INTO v2.positionnement_choix_evaluations
	(positionnement, choix, type, nombre, nombre_max)
	VALUES ($1,$2,$3,$4,$5);

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 448 (class 1255 OID 2597128)
-- Dependencies: 2983 7
-- Name: pstnnmnt_set_positionnement_question_positionnement_solution(integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_set_positionnement_question_positionnement_solution(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 positionnement
--$2 question
--$3array int4 : choix |  juste (0 ou 1)
i int4;
qr int4;
b_value bool;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;

	FOR i IN array_lower($3,1) .. array_upper($3,1)
	LOOP
		IF $3[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		PERFORM * FROM v2.af_set_question_reponse_solution(qr, $2, $3[i][1], b_value);
	END LOOP;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_set_positionnement_question_positionnement_solution(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 449 (class 1255 OID 2597129)
-- Dependencies: 2983 7
-- Name: pstnnmnt_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 positionnement
--$2 libelle
--$3 interHTML
--$4 media
--$5 largeur
--$6 hauteur
--$7 pere
rec RECORD;
qr int4;
id_quest int4;
BEGIN
	--on selectionne le question-reponse associÃƒÂ© au positionnement
	SELECT INTO qr question_reponse FROM v2.positionnement where id=$1;
		
	--on cree la question et son media
	SELECT INTO id_quest * FROM v2.af_set_question_reponse_element($2, $3, 6,FALSE);

	FOR rec IN
		--on selectionne les choix du positionnement
		SELECT id FROM v2.choix where positionnement=$1

	--pour chacun des choix
	LOOP

		--on associe les elements du question reponse
		--PERFORM * FROM v2.af_set_question_reponse_association_element(qr, id_quest, rec.id, $7);
		PERFORM * FROM v2.af_gen_set_element('v2.question_reponse_elements', 'question', $7, id_quest, ',question_reponse, reponse', ','||qr||','||rec.id,'and question_reponse='||qr||' and reponse='||rec.id);
		--on enregistre l'association en tant qu'element de positionnement 
		INSERT INTO v2.positionnement_elements(question_reponse, question, choix)
		VALUES (qr, id_quest, rec.id);

	END LOOP;

	IF $4 IS NOT NULL THEN
		RAISE NOTICE 'insertion image % / % / % / % / %',qr, id_quest, $4,$5,$6;
		PERFORM * FROM v2.af_set_media_question_reponse_element(qr, id_quest, $4,$5,$6);
	END IF;

	RETURN id_quest;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 450 (class 1255 OID 2597130)
-- Dependencies: 2983 7
-- Name: pstnnmnt_set_test_positionnement(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION pstnnmnt_set_test_positionnement(integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 test
--$2 positionnement
--$3 id du positionnement pere
BEGIN
	--INSERT INTO v2.test_positionnements (test, positionnement, pere)
	--VALUES ($1, $2, $3);
	--RAISE EXCEPTION '% % % ',$1, $2, $3;
	PERFORM * FROM v2.af_gen_set_element('v2.test_positionnements', 'positionnement', $3, $2, ', test ', ','||$1, ' AND test='||$1);
	RETURN FOUND;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.pstnnmnt_set_test_positionnement(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 451 (class 1255 OID 2597131)
-- Dependencies: 2983 7
-- Name: qc_del_qsrc_question(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_del_qsrc_question(integer, integer) RETURNS boolean
    AS $_$DECLARE
BEGIN
	PERFORM * FROM v2.af_gen_del_element('v2.question_reponse_elements', 'question', $2, ' AND question_reponse='||$1);

	RETURN TRUE;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_del_qsrc_question(integer, integer) OWNER TO pgsql;

--
-- TOC entry 452 (class 1255 OID 2597132)
-- Dependencies: 2983 7
-- Name: qc_get_qrc_question_solution(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_get_qrc_question_solution(integer, integer, integer) RETURNS record
    AS $_$DECLARE
--$1 qrc
--$2 question
--$3 reponse
rec RECORD;
qr int4;
BEGIN

	SELECT INTO rec * FROM v2.qcm_elements
	WHERE question_reponse=$1
	AND question=$2
	AND reponse=$3;
	--raise notice 'qr=% q=% r=%', qr, $2,$3;
	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_get_qrc_question_solution(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 453 (class 1255 OID 2597133)
-- Dependencies: 2983 7
-- Name: qc_get_qsrc(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_get_qsrc(integer) RETURNS record
    AS $_$DECLARE
--$1 identifiant du qsrc
rec RECORD;
BEGIN
	SELECT INTO rec Q.id, E_libelle, Q.question, E_type,E_date_modification, radio
	FROM v2.qsrc Q, v2.af_get_evaluation($1) AS (E_id int4, E_libelle varchar, E_type int4,  E_date_modification timestamp),
	v2.question_reponse QR
	WHERE Q.id=E_id
	AND Q.id=$1
	AND QR.id=Q.id;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_get_qsrc(integer) OWNER TO pgsql;

--
-- TOC entry 454 (class 1255 OID 2597134)
-- Dependencies: 2983 7
-- Name: qc_get_qsrc_question_reponse(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_get_qsrc_question_reponse(integer) RETURNS integer
    AS $_$DECLARE
v_question_reponse integer;
BEGIN
	SELECT INTO v_question_reponse question_reponse 
	FROM v2.qsrc Q, v2.positionnement P
	WHERE Q.id=$1 
	AND Q.positionnement=P.id;

	RETURN v_question_reponse;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_get_qsrc_question_reponse(integer) OWNER TO pgsql;

--
-- TOC entry 455 (class 1255 OID 2597135)
-- Dependencies: 2983 7
-- Name: qc_get_qsrc_questions(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_get_qsrc_questions(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	
	FOR rec IN
		SELECT DISTINCT Q.id,Q.libelle,Q.interpretation_html,Q.reponse, O_id.ind
		FROM v2.af_gen_get_elements('v2.question_reponse_elements', 'question', NULL, 'AND question_reponse='||$1 , 0) O_id,
		v2.question_reponse_element Q
		WHERE O_id.id=Q.id
		ORDER BY O_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_get_qsrc_questions(integer) OWNER TO pgsql;

--
-- TOC entry 456 (class 1255 OID 2597136)
-- Dependencies: 2983 7
-- Name: qc_get_theme_qsrcs(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_get_theme_qsrcs(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 le theme
--$2 la categorie
--$3 le type de question_reponse
rec RECORD;
BEGIN
	FOR rec IN
	
		SELECT  E.id , E.libelle, E.type, QS.question, QS.id 
		FROM v2.evaluation E,
		v2.af_get_categorie_elements_theme($2, $1) T_ID,
		v2.qsrc QS
		WHERE E.type=$3
		AND E.id=T_ID
		AND QS.id=T_ID

	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_get_theme_qsrcs(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9298 (class 0 OID 0)
-- Dependencies: 456
-- Name: FUNCTION qc_get_theme_qsrcs(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qc_get_theme_qsrcs(integer, integer, integer) IS 'Obtenir les qsrc d''un theme.';


--
-- TOC entry 457 (class 1255 OID 2597137)
-- Dependencies: 2983 7
-- Name: qc_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) RETURNS boolean
    AS $_$--$1 Identifiant du question_reponse
--$2 libelle
--$3 question commmune
--$4 radio?
--$5 questions
--$6 reponses
--$7 : tableau des juste/faux
DECLARE
prec_i integer:=NULL;
maj_ok boolean;
assos_ok boolean:=TRUE;
rep_ok boolean:=TRUE;
ins_ok boolean;
b_value boolean;
k integer=1;
BEGIN
	SELECT INTO maj_ok * FROM v2.af_maj_qsrc($1, $2,$3,$4);
	
	DELETE FROM v2.question_reponse_elements
	WHERE question_reponse = $1;

	FOR i IN array_lower($5, 1) .. array_upper($5, 1)  
	LOOP 
		IF i-1>0 THEN
			prec_i:=$5[i-1];
		END IF;

		FOR j IN array_lower($6, 1) .. array_upper($6, 1)  
		LOOP
			SELECT INTO ins_ok v2.af_set_question_reponse_association_element($1,$5[i], $6[j],prec_i);
			IF NOT ins_ok THEN
				assos_ok:=FALSE;
			END IF;

			RAISE NOTICE 'lit juste = %',$7[k][3];
			IF $7[k][1]=$5[i] AND $7[k][2]=$6[j] AND $7[k][3]=1 THEN
				b_value:=TRUE;
			ELSE 
				b_value:=FALSE;
			END IF;
			
			SELECT INTO rep_ok * FROM v2.af_set_question_reponse_solution($1, $5[i], $6[j], b_value);
			IF NOT rep_ok THEN
				assos_ok:=FALSE;
			END IF;
			k:=k+1;
		END LOOP;
	END LOOP;

	RETURN maj_ok AND assos_ok;

end $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 9299 (class 0 OID 0)
-- Dependencies: 457
-- Name: FUNCTION qc_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qc_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) IS 'Enregistre un qrc';


--
-- TOC entry 458 (class 1255 OID 2597138)
-- Dependencies: 2983 7
-- Name: qc_maj_qrc_question_solution(integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_maj_qrc_question_solution(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 qrc
--$2 question
--$3 array int4 : choix |  juste (0 ou 1)
i int4;
b_value bool;
ok bool;
ok2 bool;
BEGIN

	FOR i IN array_lower($3,1) .. array_upper($3,1)
	LOOP
		IF $3[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		--RAISE NOTICE 'maj: %, %, %, %==%',$1, $2, $3[i][1], b_value, $3[i][2];
		SELECT INTO ok * FROM v2.af_maj_question_reponse_solution($1, $2, $3[i][1], b_value);
		IF ok IS FALSE THEN
			RAISE NOTICE 'set: %, %, %, %==%',$1, $2, $3[i][1], b_value, $3[i][2];
			SELECT INTO ok2 * FROM v2.af_set_question_reponse_solution($1, $2, $3[i][1], b_value);
			IF ok2 IS FALSE THEN RAISE EXCEPTION 'Erreur sur l''insertion de la solution.'; END IF;
		END IF;
	END LOOP;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_maj_qrc_question_solution(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 459 (class 1255 OID 2597139)
-- Dependencies: 2983 7
-- Name: qc_maj_qsrc(integer, character varying, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_maj_qsrc(integer, character varying, character varying, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 qsrc
--$2 libelle
--$3 question commune
--$4 radio?
ok bool;
ok1 bool;

BEGIN

	SELECT INTO ok * FROM v2.af_maj_evaluation($1,$2);
	
	UPDATE v2.qsrc SET question=$3 WHERE id=$1; 
	ok1=FOUND;

	UPDATE v2.question_reponse SET radio=$4 WHERE id=$1; 

	RETURN FOUND OR ok OR ok1;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_maj_qsrc(integer, character varying, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 460 (class 1255 OID 2597140)
-- Dependencies: 2983 7
-- Name: qc_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 qsrc
--$2 question
--$3 libelle
--$4 media
--$5 hauteur
--$6 largeur
--$7 interpretation html

ok1 bool;
ok2 bool;
rec RECORD;
maj_rec RECORD;
existe int4;
BEGIN

	--on met a jour la question 
	SELECT INTO ok1 * FROM v2.af_maj_question_reponse_element($2, $3, $7);
	RAISE NOTICE 'maj de la question: % % % % -->%',$1, $2, $3, $7,ok1;

	--on recupere la question (pour avaoir le champ pere)
	SELECT INTO maj_rec * 
	FROM  v2.question_reponse_elements
	WHERE question_reponse=$1
	AND question=$2;

	--on met a jour le media de la question de positionnement
	IF $4 IS NOT NULL THEN
		SELECT INTO ok2 * FROM v2.af_maj_question_reponse_element_media($1, $2, $4, $5, $6);
		IF NOT ok2 THEN
			SELECT INTO ok2 * FROM v2.af_set_media_question_reponse_element($1, $2, $4, $5, $6);
		END IF;
	ELSE
		PERFORM * FROM v2.af_del_question_reponse_element_media($1, $2);
	END IF;
	ok2:=FOUND;

	FOR rec IN
		--on selectionne les choix du question_reponse
		SELECT id FROM v2.choix where question_reponse=$1

	--pour chacun des choix
	LOOP
		SELECT INTO existe COUNT (*) 
		FROM v2.question_reponse_elements
		WHERE question_reponse=$1
		AND question=$2
		AND reponse=rec.id;

		IF existe= 0 THEN

			--on associe les elements du question reponse
			PERFORM * FROM v2.af_set_question_reponse_association_element($1, $2, rec.id, maj_rec.pere);

			--on enregistre l'association en tant qu'element de positionnement 
			INSERT INTO v2.positionnement_elements(question_reponse, question, choix)
			VALUES ($1, $2, rec.id);

		END IF;
	END LOOP;
	
	RETURN ok1 OR ok2;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 461 (class 1255 OID 2597141)
-- Dependencies: 2983 7
-- Name: qc_maj_src(integer, character varying, character varying, boolean, integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_maj_src(integer, character varying, character varying, boolean, integer[], integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 Identifiant du question_reponse
--$2 libelle
--$3 question commmune
--$4 radio?
--$5 questions
--$6 reponses
prec_i integer;
maj_ok boolean;
assos_ok boolean:=TRUE;
ins_ok boolean;
BEGIN
	SELECT INTO maj_ok * FROM v2.af_maj_qsrc($1, $2,$3,$4);
	
	DELETE FROM v2.question_reponse_elements
	WHERE question_reponse = $1;

	FOR i IN array_lower($5, 1) .. array_upper($5, 1)  
	LOOP
		IF i-1>0 THEN
			prec_i:=$5[i-1];
		END IF;

		FOR j IN array_lower($6, 1) .. array_upper($6, 1)  
		LOOP
			SELECT INTO ins_ok v2.af_set_question_reponse_association_element($1,$5[i], $6[j],prec_i);
			IF NOT ins_ok THEN
				assos_ok:=FALSE;
			END IF;
		END LOOP;
	END LOOP;

	RETURN maj_ok AND assos_ok;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_maj_src(integer, character varying, character varying, boolean, integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 462 (class 1255 OID 2597142)
-- Dependencies: 2983 7
-- Name: qc_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) RETURNS integer
    AS $_$-- $1 : libelle qrc
-- $2 : type evaluation qrc
-- $3 : libelle question commune
-- $4 : tableau de questions
-- $5 : tableau de reponses
-- $6 : type radio ou checkbox
-- $7 : tableau des juste/faux
declare
i integer;
j integer;
k integer :=1;
b_value boolean;
val_id int4;
begin
    SELECT INTO val_id * FROM v2.af_set_question_reponse($1, $2, $6, $4,$5 );
    INSERT INTO v2.qsrc (id, question) VALUES (val_id, $3);
    raise notice 'On a fin insert';
    FOR i IN array_lower($4,1) .. array_upper($4,1)
	LOOP
	for j in array_lower($5,1) .. array_upper($5,1)
	    loop
		raise notice 'On traite % % % % ',$4[i],$5[j],$7[k][1],$7[k][2];
		IF $4[i]=$7[k][1] and $5[j]=$7[k][2] THEN
		    if $7[k][3]=1 then
			b_value:=TRUE;
		    ELSE 
			b_value:=FALSE;
	       	    end if;
		    k:=k+1;
		else
		    return null;
		END IF;
		--note: un QCM Ãƒ  une seule question, dc pas besoin de parcourir le tableau
		PERFORM * FROM v2.af_set_question_reponse_solution(val_id, $4[i], $5[j], b_value);
		
	    end loop;
	END LOOP;

	RETURN val_id;
end; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) OWNER TO pgsql;

--
-- TOC entry 9300 (class 0 OID 0)
-- Dependencies: 462
-- Name: FUNCTION qc_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qc_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) IS 'Enregistre un qrc';


--
-- TOC entry 463 (class 1255 OID 2597143)
-- Dependencies: 2983 7
-- Name: qc_set_qrc_question_solution(integer, integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_set_qrc_question_solution(integer, integer, integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 qrc
--$2 question
--$3 array int4 : choix |  juste (0 ou 1)
i int4;
qr int4;
b_value bool;
BEGIN

	FOR i IN array_lower($3,1) .. array_upper($3,1)
	LOOP
		IF $3[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		PERFORM * FROM v2.af_set_question_reponse_solution($1, $2, $3[i][1], b_value);
	END LOOP;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_set_qrc_question_solution(integer, integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 464 (class 1255 OID 2597144)
-- Dependencies: 2983 7
-- Name: qc_set_qsrc(character varying, integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_set_qsrc(character varying, integer, character varying, boolean) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type (4 ou 5)
--$3 question commmune
--$4 radio?
new_id int4;
v_question_reponse integer;
ok boolean;
BEGIN
	--cree l'evaluation
	SELECT INTO new_id * FROM v2.af_set_evaluation($1,$2);

	--cree le question reponse
	SELECT INTO ok * FROM v2.af_set_question_reponse(new_id, $2, $4);

	--cree le qsrc
	INSERT INTO v2.qsrc (id, question)
	VALUES (new_id, $3);

	IF FOUND AND ok THEN
		RETURN new_id;
	ELSE
		RAISE NOTICE 'erreur lors de la creation du SRC';
	END IF;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_set_qsrc(character varying, integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 465 (class 1255 OID 2597145)
-- Dependencies: 2983 7
-- Name: qc_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 qsrc
--$2 libelle
--$3 interHTML
--$4 media
--$5 largeur
--$6 hauteur
--$7 pere
rec RECORD;
id_quest int4;
v_type integer;
BEGIN
	SELECT INTO v_type type FROM v2.af_get_question_reponse($1) AS (id int4, libelle varchar, type int4, date_creation timestamp, radio bool);

	
	--on cree la question et son media
	SELECT INTO id_quest * FROM v2.af_set_question_reponse_element($2, $3, v_type,FALSE);

	FOR rec IN
		--on selectionne les choix du positionnement
		SELECT id FROM v2.choix where question_reponse=$1

	--pour chacun des choix
	LOOP
RAISE NOTICE 'pere=%',$7;
		--on associe les elements du question reponse
		--PERFORM * FROM v2.af_set_question_reponse_association_element(qr, id_quest, rec.id, $7);
		PERFORM * FROM v2.af_gen_set_element('v2.question_reponse_elements', 'question', $7, id_quest, ',question_reponse, reponse', ','||$1||','||rec.id,'and question_reponse='||$1||' and reponse='||rec.id);
		--on enregistre l'association en tant qu'element de positionnement 
		--INSERT INTO v2.positionnement_elements(question_reponse, question, choix)
		--VALUES ($1, id_quest, rec.id);
 
	END LOOP;

	IF $4 IS NOT NULL THEN
		--RAISE NOTICE 'insertion image % / % / % / % / %',$1, id_quest, $4,$5,$6;
		PERFORM * FROM v2.af_set_media_question_reponse_element($1, id_quest, $4,$5,$6);
	END IF;

	RETURN id_quest;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 466 (class 1255 OID 2597146)
-- Dependencies: 2983 7
-- Name: qc_set_src(character varying, integer, character varying, boolean, integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qc_set_src(character varying, integer, character varying, boolean, integer[], integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type (4 ou 5)
--$3 question commmune
--$4 radio?
--$5 questions
--$6 reponses
val_id int4;
BEGIN

	SELECT INTO val_id * FROM v2.af_set_question_reponse($1, $2, $4, $5,$6 );
	INSERT INTO v2.qsrc (id, question) VALUES (val_id, $3);

	RETURN val_id;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qc_set_src(character varying, integer, character varying, boolean, integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 467 (class 1255 OID 2597147)
-- Dependencies: 2983 7
-- Name: qr_del_question_reponse_association_element(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_del_question_reponse_association_element(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 numero de question_reponse
--$2 numero de question_reponse_element
cond varchar;
res integer;
BEGIN
	
	
	--les questions
	DELETE FROM v2.question_reponse_elements 
	WHERE question_reponse=$1
	AND question=$2;

	IF $1 IS NULL THEN
		cond:=' AND question_reponse IS NULL';
	ELSE
		cond:=' AND question_reponse='||$1;
	END IF;

	--les rÃƒÂ©ponses
	SELECT INTO res * FROM v2.af_gen_del_element(varchar 'v2.question_reponse_elements',varchar 'reponse', $2, cond);

	RETURN res>1;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_del_question_reponse_association_element(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9301 (class 0 OID 0)
-- Dependencies: 467
-- Name: FUNCTION qr_del_question_reponse_association_element(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_del_question_reponse_association_element(integer, integer) IS 'Supprime un ÃƒÂ©lÃƒÂ©ment d''un question rÃƒÂ©ponse.';


--
-- TOC entry 468 (class 1255 OID 2597148)
-- Dependencies: 2983 7
-- Name: qr_del_question_reponse_choix(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_del_question_reponse_choix(integer, integer) RETURNS boolean
    AS $_$DECLARE
nb_del int4:=0;
BEGIN


	SELECT INTO nb_del * FROM v2.af_gen_del_element('v2.choix', 'id', $2, ' AND question_reponse='||$1);

	RETURN nb_del>0;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_del_question_reponse_choix(integer, integer) OWNER TO pgsql;

--
-- TOC entry 469 (class 1255 OID 2597149)
-- Dependencies: 2983 7
-- Name: qr_del_question_reponse_element(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_del_question_reponse_element(integer) RETURNS boolean
    AS $_$BEGIN
	DELETE FROM v2.question_reponse_element
	WHERE id=$1;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_del_question_reponse_element(integer) OWNER TO pgsql;

--
-- TOC entry 9302 (class 0 OID 0)
-- Dependencies: 469
-- Name: FUNCTION qr_del_question_reponse_element(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_del_question_reponse_element(integer) IS 'Supprime un question_reponse_element.';


--
-- TOC entry 470 (class 1255 OID 2597150)
-- Dependencies: 2983 7
-- Name: qr_del_question_reponse_element_media(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_del_question_reponse_element_media(integer, integer) RETURNS boolean
    AS $_$BEGIN
	DELETE FROM v2.media_question_reponse_element
	WHERE question_reponse=$1
	AND question_reponse_element=$2;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_del_question_reponse_element_media(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9303 (class 0 OID 0)
-- Dependencies: 470
-- Name: FUNCTION qr_del_question_reponse_element_media(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_del_question_reponse_element_media(integer, integer) IS 'Supprime un mÃƒÂ©dia d''un question_reponse_element.';


--
-- TOC entry 471 (class 1255 OID 2597151)
-- Dependencies: 2983 7
-- Name: qr_del_question_reponse_media(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_del_question_reponse_media(integer) RETURNS boolean
    AS $_$BEGIN
	DELETE FROM v2.media_question_reponse
	WHERE question_reponse=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_del_question_reponse_media(integer) OWNER TO pgsql;

--
-- TOC entry 9304 (class 0 OID 0)
-- Dependencies: 471
-- Name: FUNCTION qr_del_question_reponse_media(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_del_question_reponse_media(integer) IS 'Supprime un mÃƒÂ©dia d''un question_reponse.';


--
-- TOC entry 472 (class 1255 OID 2597152)
-- Dependencies: 2983 7
-- Name: qr_get_question(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_question(integer) RETURNS record
    AS $_$DECLARE
rec record;
BEGIN
	
	--select into rec from v2.af_get_question_reponse_element E, v2.question Q
	select  into rec E.id,E.libelle,E.interpretation_html from v2.question_reponse_element E, v2.question Q
	WHERE E.id=$1 AND E.id=Q.id;
	return rec;
	
	

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question(integer) OWNER TO postgres;

--
-- TOC entry 9305 (class 0 OID 0)
-- Dependencies: 472
-- Name: FUNCTION qr_get_question(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_question(integer) IS 'Obtenir une question.';


--
-- TOC entry 473 (class 1255 OID 2597153)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse(integer) RETURNS record
    AS $_$DECLARE
--$1 question_reponse
rec RECORD;
BEGIN
	SELECT INTO rec E.id, E.libelle, E.type, E.date_creation, QR.radio
	FROM v2.question_reponse QR, v2.evaluation E
	WHERE QR.id = $1
	AND QR.id=E.id;

	return rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse(integer) OWNER TO pgsql;

--
-- TOC entry 9306 (class 0 OID 0)
-- Dependencies: 473
-- Name: FUNCTION qr_get_question_reponse(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse(integer) IS 'Obtenir un question_reponse.';


--
-- TOC entry 474 (class 1255 OID 2597154)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_association_elements(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_association_elements(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN

	FOR rec IN

		SELECT * FROM v2.question_reponse_elements
		WHERE question_reponse=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

		RETURN;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_association_elements(integer) OWNER TO pgsql;

--
-- TOC entry 9307 (class 0 OID 0)
-- Dependencies: 474
-- Name: FUNCTION qr_get_question_reponse_association_elements(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_association_elements(integer) IS 'Obtenir les ÃƒÂ©lÃƒÂ©ments associÃƒÂ©s Ãƒ  un question_reponse.';


--
-- TOC entry 475 (class 1255 OID 2597155)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_choix(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_choix(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 question_reponse
rec RECORD;
BEGIN
	FOR rec IN
		SELECT C_id.id  , R.libelle, R.interpretation_html ,C.question_reponse, C.bareme, C.pere ,M.media, M.hauteur, M.largeur 
		FROM (v2.choix C INNER JOIN 
		v2.af_gen_get_elements('v2.choix', 'id', NULL, 'AND question_reponse='||$1,0 ) C_id 
		ON C_id.id= C.id)
		LEFT OUTER JOIN v2.media_question_reponse_element M 
		ON C_id.id=M.question_reponse_element AND M.question_reponse=$1
		LEFT OUTER JOIN v2.question_reponse_element R
		ON R.id=C_id.id
		ORDER BY C_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_choix(integer) OWNER TO pgsql;

--
-- TOC entry 476 (class 1255 OID 2597156)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_element(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_question_reponse_element(integer) RETURNS record
    AS $_$declare 
rec record;
begin
	
	select INTO rec id,libelle,interpretation_html, "type", reponse from v2.question_reponse_element 
	where id=$1;
	
	return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_element(integer) OWNER TO postgres;

--
-- TOC entry 9308 (class 0 OID 0)
-- Dependencies: 476
-- Name: FUNCTION qr_get_question_reponse_element(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_question_reponse_element(integer) IS 'FONCTION PRIVEE: Obtenir las enregistrements de la table question_reponse_element pour un type donnÃƒÆ’Ã‚Â©';


--
-- TOC entry 477 (class 1255 OID 2597157)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_element_evaluations(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_element_evaluations(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT E.id, E.libelle, E.type FROM v2.question_reponse_elements QR,
		v2.evaluation E
		WHERE (QR.question=$1 OR QR.reponse=$1)
		AND E.id=QR.question_reponse
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_element_evaluations(integer) OWNER TO pgsql;

--
-- TOC entry 9309 (class 0 OID 0)
-- Dependencies: 477
-- Name: FUNCTION qr_get_question_reponse_element_evaluations(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_element_evaluations(integer) IS 'obtenir les evaluations utilisÃƒÂ©es par un question_reponse_element.';


--
-- TOC entry 478 (class 1255 OID 2597158)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_element_media(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_element_media(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 idenfifiant du question reponse
--$2 idenfifiant du question reponse element
rec RECORD;
libelle_media character varying;
BEGIN
	SELECT INTO rec question_reponse, question_reponse_element, media, CAST( NULL AS varchar) AS libelle, hauteur, largeur 
	FROM v2.af_get_question_reponse_elements_media($1) AS (question_reponse int4, question_reponse_element int4, media int4, flash int4, hauteur int4, largeur int4)
	WHERE question_reponse_element=$2;

	SELECT INTO libelle_media libelle FROM v2.af_get_fichier(rec.media) AS ( id int4, libelle varchar, "type" int4, connecte bool);

	rec.libelle:= libelle_media;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_element_media(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9310 (class 0 OID 0)
-- Dependencies: 478
-- Name: FUNCTION qr_get_question_reponse_element_media(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_element_media(integer, integer) IS 'Obtenir le media d''un question_reponse_element pour un question_reponse.';


--
-- TOC entry 479 (class 1255 OID 2597159)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_element_media(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_element_media(integer) RETURNS record
    AS $_$DECLARE
--$1 idenfifiant du question reponse element
rec RECORD;
BEGIN
	SELECT INTO rec  question_reponse, question_reponse_element, media, media, hauteur, largeur 
	FROM v2.media_question_reponse_element, v2.question Q
	WHERE question_reponse_element=$1
	AND question_reponse_element=Q.id;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_element_media(integer) OWNER TO pgsql;

--
-- TOC entry 9311 (class 0 OID 0)
-- Dependencies: 479
-- Name: FUNCTION qr_get_question_reponse_element_media(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_element_media(integer) IS 'Obtenir le media d''un question_reponse_element.
Le question_reponse_element doit etre une question.';


--
-- TOC entry 480 (class 1255 OID 2597160)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_elements(integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_elements(integer, boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 le numero de question_rÃƒÂ©ponse
--$2 question ou rÃƒÂ©ponse?
rec RECORD;
BEGIN


	FOR rec IN
/*		SELECT DISTINCT id , libelle , interpretation_html , $2, reponse 
		FROM v2.af_get_question_reponse_association_elements($1) AS (E_question_reponse int4, E_question int4, E_reponse int4, E_pere int4)
		WHERE (id=E_question
		OR id=E_reponse)
		AND reponse=$2
*/

		SELECT DISTINCT Q.id,Q.libelle,Q.interpretation_html,Q.type, Q.reponse, CASE WHEN Q.reponse IS FALSE THEN O_id.ind ELSE NULL END AS ind 
		FROM v2.question_reponse_elements E 
		LEFT OUTER JOIN v2.question_reponse_element Q ON (E.question=Q.id OR E.Reponse=Q.id)
		LEFT OUTER JOIN v2.af_gen_get_elements('v2.question_reponse_elements', 'question', NULL, 'AND question_reponse='||$1 , 0) O_id
		ON (O_id.id=E.question)
		WHERE E.question_reponse=$1
		AND Q.reponse=$2
		ORDER BY ind
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_elements(integer, boolean) OWNER TO pgsql;

--
-- TOC entry 9312 (class 0 OID 0)
-- Dependencies: 480
-- Name: FUNCTION qr_get_question_reponse_elements(integer, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_elements(integer, boolean) IS 'Obtenir les informations des question_reponse_elements pour un question rÃƒÂ©ponse.';


--
-- TOC entry 481 (class 1255 OID 2597161)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_elements(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_question_reponse_elements(integer) RETURNS SETOF record
    AS $_$declare 
rec record;
begin
	for rec in
		select id,libelle,interpretation_html,type,reponse from v2.question_reponse_element 
		--select * from v2.question_reponse_element 
		where type=$1
	loop
		return next rec;
	end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_elements(integer) OWNER TO postgres;

--
-- TOC entry 9313 (class 0 OID 0)
-- Dependencies: 481
-- Name: FUNCTION qr_get_question_reponse_elements(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_question_reponse_elements(integer) IS 'FONCTION PRIVEE: Obtenir las enregistrements de la table question_reponse_element pour un type donnÃƒÆ’Ã‚Â©';


--
-- TOC entry 482 (class 1255 OID 2597162)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_elements(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_question_reponse_elements() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM v2.question_reponse_element
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_elements() OWNER TO postgres;

--
-- TOC entry 9314 (class 0 OID 0)
-- Dependencies: 482
-- Name: FUNCTION qr_get_question_reponse_elements(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_question_reponse_elements() IS 'FONCTION PRIVEE: Obtenir les enregistrements de la table question_reponse_element';


--
-- TOC entry 483 (class 1255 OID 2597163)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_elements_infos(integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_elements_infos(integer, integer, boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 le numero de question_rÃƒÂ©ponse
--$2 le type de question rÃƒÂ©ponse
--$3 question ou rÃƒÂ©ponse?
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT id , libelle , interpretation_html , $2, reponse 
		FROM v2.af_get_question_reponse_association_elements($1) AS (E_question_reponse int4, E_question int4, E_reponse int4, E_pere int4),
		v2.af_get_question_reponse_elements($2) AS (id int4, libelle varchar, interpretation_html boolean,type integer, reponse boolean)
		WHERE (id=E_question
		OR id=E_reponse)
		AND reponse=$3
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_elements_infos(integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 9315 (class 0 OID 0)
-- Dependencies: 483
-- Name: FUNCTION qr_get_question_reponse_elements_infos(integer, integer, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_elements_infos(integer, integer, boolean) IS 'Obtenir les informations des question_reponse_elements.';


--
-- TOC entry 484 (class 1255 OID 2597164)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_elements_media(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_elements_media(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 idenfifiant du question reponse element
rec RECORD;
BEGIN
	FOR rec IN
		SELECT  question_reponse, question_reponse_element, media, media, hauteur, largeur FROM v2.media_question_reponse_element
		WHERE question_reponse=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_elements_media(integer) OWNER TO pgsql;

--
-- TOC entry 9316 (class 0 OID 0)
-- Dependencies: 484
-- Name: FUNCTION qr_get_question_reponse_elements_media(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_elements_media(integer) IS 'Obtenir les medias de tous les question_reponse_elements.';


--
-- TOC entry 485 (class 1255 OID 2597165)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_media(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_media(integer) RETURNS record
    AS $_$DECLARE
--$1 idenfifiant du question reponse
rec RECORD;
BEGIN
	SELECT INTO rec  question_reponse, media, media, hauteur, largeur FROM v2.media_question_reponse
	WHERE question_reponse=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_media(integer) OWNER TO pgsql;

--
-- TOC entry 9317 (class 0 OID 0)
-- Dependencies: 485
-- Name: FUNCTION qr_get_question_reponse_media(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_media(integer) IS 'Obtenir le media d''un question_reponse.';


--
-- TOC entry 486 (class 1255 OID 2597166)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_questions(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_questions(integer) RETURNS SETOF integer
    AS $_$DECLARE
--$1 numero de question_reponse
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT question FROM v2.question_reponse_elements
		WHERE question_reponse=$1
	LOOP
		RETURN NEXT rec.question;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_questions(integer) OWNER TO pgsql;

--
-- TOC entry 9318 (class 0 OID 0)
-- Dependencies: 486
-- Name: FUNCTION qr_get_question_reponse_questions(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_questions(integer) IS 'Obtenir les questions d''un question_reponse.';


--
-- TOC entry 487 (class 1255 OID 2597167)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_solution(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_question_reponse_solution(integer, integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec question_reponse, question,reponse,juste 
	FROM v2.qcm_elements
	WHERE question_reponse=$1
	AND reponse=$2;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_solution(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9319 (class 0 OID 0)
-- Dependencies: 487
-- Name: FUNCTION qr_get_question_reponse_solution(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_question_reponse_solution(integer, integer) IS 'Obtenir la solution d''une reponse Ãƒ  un qcm.';


--
-- TOC entry 488 (class 1255 OID 2597168)
-- Dependencies: 2983 7
-- Name: qr_get_question_reponse_solutions(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_question_reponse_solutions(integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
	for rec in
	select question_reponse, question,reponse,juste from v2.qcm_elements where question_reponse=$1
	loop
		return next rec;
	end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_question_reponse_solutions(integer) OWNER TO postgres;

--
-- TOC entry 9320 (class 0 OID 0)
-- Dependencies: 488
-- Name: FUNCTION qr_get_question_reponse_solutions(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_question_reponse_solutions(integer) IS 'Obtenir les reponses d''une question de qcm pour une question donnÃƒÆ’Ã‚Â©es (auteur : Said, modifiÃƒÆ’Ã‚Â©e par rÃƒÆ’Ã‚Â©mi)';


--
-- TOC entry 489 (class 1255 OID 2597169)
-- Dependencies: 2983 7
-- Name: qr_get_questions(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_questions() RETURNS SETOF record
    AS $$declare
rec record;
begin
	
	for rec in 
		select E_id,E_libelle,E_interpretation_html,E_type  from v2.af_get_question_reponse_elements() as (E_id int4,E_libelle varchar,E_interpretation_html bool,E_type int4,E_reponse bool), 
		v2.question Q  
		where Q.id=E_id
	loop
		return next rec;
	end loop;
	return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_questions() OWNER TO postgres;

--
-- TOC entry 9321 (class 0 OID 0)
-- Dependencies: 489
-- Name: FUNCTION qr_get_questions(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_questions() IS 'Obtenir les questions.';


--
-- TOC entry 490 (class 1255 OID 2597170)
-- Dependencies: 2983 7
-- Name: qr_get_reponse(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_reponse(integer) RETURNS record
    AS $_$declare
rec record;
begin
	select into rec E_id,E_libelle,E_interpretation_html,E_type from v2.af_get_reponses() as (E_id int4,E_libelle varchar,E_interpretation_html bool,E_type int4) where E_id=$1;
	return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_reponse(integer) OWNER TO postgres;

--
-- TOC entry 9322 (class 0 OID 0)
-- Dependencies: 490
-- Name: FUNCTION qr_get_reponse(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_reponse(integer) IS 'Obtenir les informations d''une reponse donnÃƒÆ’Ã‚Â©e (auteur : Said)';


--
-- TOC entry 491 (class 1255 OID 2597171)
-- Dependencies: 2983 7
-- Name: qr_get_reponse_question_reponse_resultats(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_reponse_question_reponse_resultats(integer) RETURNS SETOF record
    AS $_$-- $1 : reponse
declare
rec record;
begin
    for rec in
	select * from v2.resultat_serie_question_reponse where reponse=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_reponse_question_reponse_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 9323 (class 0 OID 0)
-- Dependencies: 491
-- Name: FUNCTION qr_get_reponse_question_reponse_resultats(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_reponse_question_reponse_resultats(integer) IS 'retourne les resultats pour une reponse de question_reponse';


--
-- TOC entry 492 (class 1255 OID 2597172)
-- Dependencies: 2983 7
-- Name: qr_get_reponses(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_reponses(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		select  E.id, libelle, interpretation_html, type from v2.reponse R, v2.af_get_question_reponse_elements($1) E
		where R.id=E.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_reponses(integer) OWNER TO postgres;

--
-- TOC entry 9324 (class 0 OID 0)
-- Dependencies: 492
-- Name: FUNCTION qr_get_reponses(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_reponses(integer) IS 'Obtenir toutes les reponses d''un type donnÃƒÆ’Ã‚Â©.';


--
-- TOC entry 493 (class 1255 OID 2597173)
-- Dependencies: 2983 7
-- Name: qr_get_reponses(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_reponses() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		select  E_id,E_libelle,E_interpretation_html,E_type from v2.reponse R, 
		v2.af_get_question_reponse_elements() as (E_id int4,E_libelle varchar,E_interpretation_html bool, E_type int4,E_reponse bool)
		where R.id=E_id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_reponses() OWNER TO postgres;

--
-- TOC entry 9325 (class 0 OID 0)
-- Dependencies: 493
-- Name: FUNCTION qr_get_reponses(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_reponses() IS 'Obtenir les rÃƒÂ©ponses.';


--
-- TOC entry 494 (class 1255 OID 2597174)
-- Dependencies: 2983 7
-- Name: qr_get_sondage_elements(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_sondage_elements() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		select * from v2.af_get_question_reponse_elements(2) as (E_id int4,E_libelle varchar,E_interpretation_html bool,E_reponse bool)
		--select E_id,E_libelle,E_interpretation_html,E_reponse from v2.af_get_question_reponse_elements(2) as (E_id int4,E_libelle varchar,E_interpretation_html bool,E_reponse bool) 
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;

END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_sondage_elements() OWNER TO postgres;

--
-- TOC entry 9326 (class 0 OID 0)
-- Dependencies: 494
-- Name: FUNCTION qr_get_sondage_elements(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_sondage_elements() IS 'FONCTION PRIVEE: Obtenir les enregistrements de la table question_reponse_element pour un type donnÃƒÆ’Ã‚Â©';


--
-- TOC entry 495 (class 1255 OID 2597175)
-- Dependencies: 2983 7
-- Name: qr_get_theme_question_reponse_elements(integer, integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_theme_question_reponse_elements(integer, integer, integer, boolean) RETURNS SETOF record
    AS $_$DECLARE
--$1 le theme
--$2 la categorie
--$3 le type de question_reponse_element
--$4 reponse ou pas
rec RECORD;

BEGIN

	FOR rec IN
	
		SELECT E.id, E.libelle , E.interpretation_html , E.type, E.reponse FROM v2.question_reponse_element E,
		v2.af_get_categorie_elements_theme($2, $1) C_id
		WHERE E.id=C_id
		AND E.reponse=$4
		AND E.type=$3
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_theme_question_reponse_elements(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 9327 (class 0 OID 0)
-- Dependencies: 495
-- Name: FUNCTION qr_get_theme_question_reponse_elements(integer, integer, integer, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_theme_question_reponse_elements(integer, integer, integer, boolean) IS 'Obtenir les question_reponse_elements d''un theme.';


--
-- TOC entry 496 (class 1255 OID 2597176)
-- Dependencies: 2983 7
-- Name: qr_get_theme_question_reponse_reponses(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_get_theme_question_reponse_reponses(integer, integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
null_value int4:=NULL;
begin
	for rec in
		--les elements qui ne sont pas associÃƒÂ©s
		(select distinct R_id,R_libelle, null_value,  R_inter, R_type from 
		--les reponses
		v2.af_get_reponses() as (R_id int4,R_libelle varchar,R_inter bool,R_type int4),
		--les elements rangÃƒÆ’Ã‚Â©s dans un theme
		v2.af_get_categorie_elements_theme($2,$1) C_id
		--les associations question reponse
		--,v2.question_reponse_elements E
		--where E.question_reponse=C_id 
		--and E.question=R_id
		WHERE C_id=R_id
		AND R_type=$3
		AND C_id NOT IN 
			(select distinct E.reponse from 
			--les associations question reponse
			v2.question_reponse_elements E)	
		)

		UNION

		--les elements associÃƒÂ©s
		(select distinct R_id,R_libelle, E.question_reponse , R_inter, R_type from 
		--les reponses
		v2.af_get_reponses() as (R_id int4,R_libelle varchar,R_inter bool,R_type int4),
		--les elements rangÃƒÆ’Ã‚Â©s dans un theme
		v2.af_get_categorie_elements_theme($2,$1) C_id
		--les associations question reponse
		,v2.question_reponse_elements E
		where E.reponse=C_id
		AND R_type=$3
		and E.reponse=R_id)
		

	loop
		return next rec;
	end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_theme_question_reponse_reponses(integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 9328 (class 0 OID 0)
-- Dependencies: 496
-- Name: FUNCTION qr_get_theme_question_reponse_reponses(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_get_theme_question_reponse_reponses(integer, integer, integer) IS 'Obtenir les questions de qcm pour un theme (auteur : said modifiÃƒÂ© par rÃƒÂ©mi)';


--
-- TOC entry 497 (class 1255 OID 2597177)
-- Dependencies: 2983 7
-- Name: qr_get_theme_question_reponses(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_get_theme_question_reponses(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 le theme
--$2 la categorie
--$3 le type de question_reponse
rec RECORD;
BEGIN
	FOR rec IN
	
		SELECT DISTINCT QR.id , QR.type, QR.radio 
		FROM v2.question_reponse QR,
		v2.af_get_categorie_elements_theme($2, $1) T_ID
		WHERE QR.type=$3
		AND QR.id=T_ID

	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_get_theme_question_reponses(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9329 (class 0 OID 0)
-- Dependencies: 497
-- Name: FUNCTION qr_get_theme_question_reponses(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_get_theme_question_reponses(integer, integer, integer) IS 'Obtenir les question_reponses d''un theme.';


--
-- TOC entry 498 (class 1255 OID 2597178)
-- Dependencies: 2983 7
-- Name: qr_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 question_reponse
--$2 choix
--$3 nouveau choix
--$4 bareme
--$5 media
--$6 hauteur
--$7 largeur
r1 boolean;
r2 boolean;
qr int4;
BEGIN
	
	UPDATE v2.choix
	SET id=$3, bareme=$4
	WHERE question_reponse=$1
	AND id=$2;
	r1 := FOUND;

	IF $5 IS NOT NULL THEN
		UPDATE v2.media_question_reponse_element
		SET media=$5, hauteur=$6, largeur=$7
		WHERE question_reponse=$1
		AND question_reponse_element=$3;
		r2 := FOUND;
		
		IF r2!=TRUE THEN
			INSERT INTO v2.media_question_reponse_element (question_reponse, question_reponse_element, media, hauteur, largeur )
			VALUES ($1, $3, $5, $6, $7);
			r2 := FOUND;
		END IF;
	ELSE 
		DELETE FROM v2.media_question_reponse_element 
		WHERE question_reponse=$1
		AND question_reponse_element=$2;
		r2 := FOUND;
	END IF;

	RETURN r1 OR r2;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 499 (class 1255 OID 2597179)
-- Dependencies: 2983 7
-- Name: qr_maj_question_reponse_element(integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_maj_question_reponse_element(integer, character varying, boolean) RETURNS boolean
    AS $_$BEGIN
	UPDATE v2.question_reponse_element SET libelle=$2, interpretation_html=$3 WHERE id=$1;
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_maj_question_reponse_element(integer, character varying, boolean) OWNER TO pgsql;

--
-- TOC entry 9330 (class 0 OID 0)
-- Dependencies: 499
-- Name: FUNCTION qr_maj_question_reponse_element(integer, character varying, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_maj_question_reponse_element(integer, character varying, boolean) IS 'Mise Ãƒ  jour d''un question_reponse_element.';


--
-- TOC entry 500 (class 1255 OID 2597180)
-- Dependencies: 2983 7
-- Name: qr_maj_question_reponse_element_media(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_maj_question_reponse_element_media(integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE 
rec RECORD;
BEGIN

	SELECT INTO rec * from v2.af_get_question_reponse_element_media($1,$2) AS (question_reponse int4, question_reponse_element int4, media int4, libelle varchar, hauteur int4, largeur int4);

	IF $3 IS NULL THEN
		PERFORM * FROM v2.af_del_media_question_reponse_element($1,$2,$3,$4,$5);
		RAISE NOTICE 'DELETE % % % ',$1,$2,$3;
		RETURN FOUND;

	ELSEIF rec.media IS NOT NULL THEN
		UPDATE v2.media_question_reponse_element 
		SET media=$3, largeur=$4, hauteur=$5 WHERE question_reponse_element=$2 AND question_reponse=$1;
		RAISE NOTICE 'UPDATE % % % ',$1,$2,$3;
		RETURN FOUND;
	ELSE 
		PERFORM * FROM v2.af_set_media_question_reponse_element($1,$2,$3,$4,$5);
		RAISE NOTICE 'INSERT % % % ',$1,$2,$3;
		RETURN FOUND;
	END IF;
	
	RETURN FALSE;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_maj_question_reponse_element_media(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9331 (class 0 OID 0)
-- Dependencies: 500
-- Name: FUNCTION qr_maj_question_reponse_element_media(integer, integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_maj_question_reponse_element_media(integer, integer, integer, integer, integer) IS 'Mise Ãƒ  jour d''un media de question_reponse_element.';


--
-- TOC entry 501 (class 1255 OID 2597181)
-- Dependencies: 2983 7
-- Name: qr_maj_question_reponse_media(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_maj_question_reponse_media(integer, integer, integer, integer) RETURNS boolean
    AS $_$BEGIN
	UPDATE v2.media_question_reponse 
	SET media=$2, largeur=$3, hauteur=$4 WHERE  question_reponse=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_maj_question_reponse_media(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9332 (class 0 OID 0)
-- Dependencies: 501
-- Name: FUNCTION qr_maj_question_reponse_media(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_maj_question_reponse_media(integer, integer, integer, integer) IS 'Mise Ãƒ  jour d''un media de question_reponse_element.';


--
-- TOC entry 502 (class 1255 OID 2597182)
-- Dependencies: 2983 7
-- Name: qr_maj_question_reponse_solution(integer, integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_maj_question_reponse_solution(integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 question reponse(qcm)
--$2 question
--$3 reponse
--$4 juste (vrai ou faux)

BEGIN
	UPDATE v2.qcm_elements 
	SET juste=$4
	WHERE question_reponse=$1
	AND question=$2
	AND reponse=$3;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_maj_question_reponse_solution(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 9333 (class 0 OID 0)
-- Dependencies: 502
-- Name: FUNCTION qr_maj_question_reponse_solution(integer, integer, integer, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION qr_maj_question_reponse_solution(integer, integer, integer, boolean) IS 'Mise a jour d''une association d''element de QCM.';


--
-- TOC entry 503 (class 1255 OID 2597183)
-- Dependencies: 2983 7
-- Name: qr_set_categorie_sondage_element(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_categorie_sondage_element(integer, integer, integer) RETURNS boolean
    AS $_$begin
	insert into v2.categorie_sondage_element(id,categorie,theme) values ($1,$2,$3);
	return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_categorie_sondage_element(integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 9334 (class 0 OID 0)
-- Dependencies: 503
-- Name: FUNCTION qr_set_categorie_sondage_element(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_categorie_sondage_element(integer, integer, integer) IS 'Association sondage/categorie/theme';


--
-- TOC entry 504 (class 1255 OID 2597184)
-- Dependencies: 2983 7
-- Name: qr_set_media_question_reponse_element(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_media_question_reponse_element(integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
val_question_reponse ALIAS FOR $1;
val_question_reponse_element ALIAS FOR $2;
val_media ALIAS FOR $3;
val_hauteur ALIAS FOR $4;
val_largeur ALIAS FOR $5;

BEGIN
	insert into v2.media_question_reponse_element(question_reponse,question_reponse_element,media,hauteur, largeur ) 
	values (val_question_reponse, val_question_reponse_element, val_media, val_hauteur, val_largeur);

	return FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_media_question_reponse_element(integer, integer, integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 9335 (class 0 OID 0)
-- Dependencies: 504
-- Name: FUNCTION qr_set_media_question_reponse_element(integer, integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_media_question_reponse_element(integer, integer, integer, integer, integer) IS 'ajoute un media ÃƒÆ’Ã‚  un element d''un question_reponse. retourne true si l''operation s''est bien passÃƒÆ’Ã‚Â©e.';


--
-- TOC entry 505 (class 1255 OID 2597185)
-- Dependencies: 2983 7
-- Name: qr_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type
--$3 radio
--$4 questions
--$5 reponses
--$6 justes
i integer;
b_value boolean;
val_id integer;
BEGIN	

	SELECT INTO val_id * FROM v2.af_set_question_reponse($1, $2, $3, $4,$5 );

	FOR i IN array_lower($6,1) .. array_upper($6,1)
	LOOP
		IF $6[i][2]=1 THEN
			b_value:=TRUE;
		ELSE 
			b_value:=FALSE;
		END IF;
		--note: un QCM Ãƒ  une seule question, dc pas besoin de parcourir le tableau
		PERFORM * FROM v2.af_set_question_reponse_solution(val_id, $4[1], $6[i][1], b_value);
	END LOOP;

	RETURN val_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) OWNER TO postgres;

--
-- TOC entry 9336 (class 0 OID 0)
-- Dependencies: 505
-- Name: FUNCTION qr_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) IS 'CrÃƒÂ©er un QCM complet';


--
-- TOC entry 506 (class 1255 OID 2597186)
-- Dependencies: 2983 7
-- Name: qr_set_question(character varying, boolean, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_question(character varying, boolean, integer) RETURNS integer
    AS $_$DECLARE
libelle ALIAS FOR $1;
interpretation_HTML ALIAS  FOR $2;
val_type ALIAS FOR $3;

res int4;
BEGIN

	--insertion dans la table des elements 
	select into res v2.af_set_question_reponse_element(libelle, interpretation_HTML, val_type, FALSE);

	--insertion dans la table des questions
	--insert into v2.question(id) VALUES (res);

	--on retourne l'id de l'enregistrement
	return res;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_question(character varying, boolean, integer) OWNER TO postgres;

--
-- TOC entry 9337 (class 0 OID 0)
-- Dependencies: 506
-- Name: FUNCTION qr_set_question(character varying, boolean, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_question(character varying, boolean, integer) IS 'FONCTION PRIVEE:
Insere une question.';


--
-- TOC entry 507 (class 1255 OID 2597187)
-- Dependencies: 2983 7
-- Name: qr_set_question_reponse(integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_question_reponse(integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
val_id ALIAS FOR $1;
val_type ALIAS FOR $2;
val_radio ALIAS FOR $3;
BEGIN	
	insert into v2.question_reponse (id, "type", radio) values (val_id, val_type, val_radio) ;
	return FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_question_reponse(integer, integer, boolean) OWNER TO postgres;

--
-- TOC entry 9338 (class 0 OID 0)
-- Dependencies: 507
-- Name: FUNCTION qr_set_question_reponse(integer, integer, boolean); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_question_reponse(integer, integer, boolean) IS 'FONCTION PRIVEE';


--
-- TOC entry 508 (class 1255 OID 2597188)
-- Dependencies: 2983 7
-- Name: qr_set_question_reponse(character varying, integer, boolean, integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_question_reponse(character varying, integer, boolean, integer[], integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type
--$3 radio
--$4 questions
--$5 reponses
i integer;
j integer;
prec_i integer:=NULL;
val_id integer;
BEGIN	
	SELECT INTO val_id * FROM v2.af_set_evaluation($1,$2);

	PERFORM v2.af_set_question_reponse(val_id, $2, $3);

	FOR i IN array_lower($4, 1) .. array_upper($4, 1)  
	LOOP
		IF i-1>0 THEN
			prec_i:=$4[i-1];
		END IF;

		FOR j IN array_lower($5, 1) .. array_upper($5, 1)  
		LOOP
			PERFORM v2.af_set_question_reponse_association_element(val_id,$4[i], $5[j],prec_i);
		END LOOP;
	END LOOP;

	RETURN val_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_question_reponse(character varying, integer, boolean, integer[], integer[]) OWNER TO postgres;

--
-- TOC entry 9339 (class 0 OID 0)
-- Dependencies: 508
-- Name: FUNCTION qr_set_question_reponse(character varying, integer, boolean, integer[], integer[]); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_question_reponse(character varying, integer, boolean, integer[], integer[]) IS 'CrÃƒÂ©er un Question RÃƒÂ©ponse complet';


--
-- TOC entry 509 (class 1255 OID 2597189)
-- Dependencies: 2983 7
-- Name: qr_set_question_reponse_association_element(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_question_reponse_association_element(integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
val_question_reponse ALIAS FOR $1;
val_question ALIAS FOR $2;
val_reponse ALIAS FOR $3;
val_pere ALIAS FOR $4;
BEGIN
	RAISE NOTICE 'qr=% q=% r=% pere=%',val_question_reponse, val_question, val_reponse, val_pere;
	insert into v2.question_reponse_elements (question_reponse, question, reponse, pere) values  (val_question_reponse, val_question, val_reponse, val_pere) ;
	return FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_question_reponse_association_element(integer, integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 9340 (class 0 OID 0)
-- Dependencies: 509
-- Name: FUNCTION qr_set_question_reponse_association_element(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_question_reponse_association_element(integer, integer, integer, integer) IS 'ajoute un element de question_reponse, c''est ÃƒÆ’Ã‚  dire une paire question reponse. Le champs pere s''applique ÃƒÆ’Ã‚  la rÃƒÆ’Ã‚Â©ponse pour permettre de conserver l''ordre des reponses.';


--
-- TOC entry 510 (class 1255 OID 2597190)
-- Dependencies: 2983 7
-- Name: qr_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION qr_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 question_reponse
--$2 reponse
--$3 pere
--$4 bareme
--$5 media
--$6 hauteur
--$7 largeur
r1 boolean;
r2 boolean;
qr int4;
rec RECORD;
v_pere integer;
v_type integer;
BEGIN
	SELECT INTO v_type type FROM v2.af_get_question_reponse($1) AS (id int4, libelle varchar, type int4, date_creation timestamp, radio bool);

	--insert le nouveau choix
	INSERT INTO v2.choix (question_reponse, id, pere, bareme )
	VALUES ($1, $2, $3, $4);
	r1 := FOUND;

	--selection les questions existantes
	FOR rec IN 
		SELECT id FROM v2.af_get_question_reponse_elements($1,TRUE) as (id int4,libelle varchar,interpretation_html bool,type int4, reponse bool, indice integer)
	LOOP 
		PERFORM * FROM v2.af_set_question_reponse_association_element(qr, rec.id, $2, v_pere);
		IF NOT FOUND THEN
			RAISE EXCEPTION 'af_set_question_reponse_choix: erreur association choix/question_reponse';
		END IF;
	END LOOP;

	--SELECT * FROM v2.af_set_question_reponse_association_element(qr, integer, $2, $3)

	IF $5 IS NOT NULL THEN
		INSERT INTO v2.media_question_reponse_element (question_reponse, question_reponse_element, media, hauteur, largeur )
		VALUES (qr, $2, $5, $6, $7);
		r2 := FOUND;
	END IF;

	RETURN r1 OR r2;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 511 (class 1255 OID 2597191)
-- Dependencies: 2983 7
-- Name: qr_set_question_reponse_element(character varying, boolean, integer, boolean); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_question_reponse_element(character varying, boolean, integer, boolean) RETURNS integer
    AS $_$DECLARE

res int4;
new_id int4;

BEGIN

	insert into v2.question_reponse_element(libelle, interpretation_HTML, "type", reponse) values($1,$2,$3,$4);
	GET DIAGNOSTICS new_id = RESULT_OID;
	
	select into res id from v2.question_reponse_element where oid=new_id;
	
	return res;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_question_reponse_element(character varying, boolean, integer, boolean) OWNER TO postgres;

--
-- TOC entry 9341 (class 0 OID 0)
-- Dependencies: 511
-- Name: FUNCTION qr_set_question_reponse_element(character varying, boolean, integer, boolean); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_question_reponse_element(character varying, boolean, integer, boolean) IS 'FONCTION PRIVEE:
Insere un element de question reponse. ';


--
-- TOC entry 512 (class 1255 OID 2597192)
-- Dependencies: 2983 7
-- Name: qr_set_question_reponse_media(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_question_reponse_media(integer, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
val_question_reponse ALIAS FOR $1;
val_media ALIAS FOR $2;
val_hauteur ALIAS FOR $3;
val_largeur ALIAS FOR $4;

BEGIN
	insert into v2.media_question_reponse(question_reponse,media,hauteur, largeur ) 
	values (val_question_reponse,  val_media, val_hauteur, val_largeur);

	return FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_question_reponse_media(integer, integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 9342 (class 0 OID 0)
-- Dependencies: 512
-- Name: FUNCTION qr_set_question_reponse_media(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_question_reponse_media(integer, integer, integer, integer) IS 'ajoute un media ÃƒÆ’Ã‚  un question_reponse. retourne true si l''operation s''est bien passÃƒÆ’Ã‚Â©e.';


--
-- TOC entry 513 (class 1255 OID 2597193)
-- Dependencies: 2983 7
-- Name: qr_set_question_reponse_solution(integer, integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_question_reponse_solution(integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
val_question_reponse ALIAS FOR $1;
val_question ALIAS FOR $2;
val_reponse ALIAS FOR $3;
val_juste ALIAS FOR $4;
BEGIN
	RAISE NOTICE 'INSERT SOLUTION qr=%  q=%  r=% j=%',val_question_reponse, val_question, val_reponse, val_juste;
	insert into v2.qcm_elements(question_reponse, question, reponse, juste) values (val_question_reponse, val_question, val_reponse, val_juste) ;
	return FOUND;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_question_reponse_solution(integer, integer, integer, boolean) OWNER TO postgres;

--
-- TOC entry 9343 (class 0 OID 0)
-- Dependencies: 513
-- Name: FUNCTION qr_set_question_reponse_solution(integer, integer, integer, boolean); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_question_reponse_solution(integer, integer, integer, boolean) IS 'FONCTION PRIVEE: ajoute un enregistrement  dans la table qcm_elements';


--
-- TOC entry 514 (class 1255 OID 2597194)
-- Dependencies: 2983 7
-- Name: qr_set_reponse(character varying, boolean, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_reponse(character varying, boolean, integer) RETURNS integer
    AS $_$DECLARE
libelle ALIAS FOR $1;
interpretation_HTML ALIAS  FOR $2;
"type" ALIAS FOR $3;

res int4;
BEGIN

	--insertion dans la table generique
	select into res v2.af_set_question_reponse_element(libelle, interpretation_HTML, "type", TRUE);
	
	--insertion dans la table des reponses
	--insert into v2.reponse(id) VALUES (res);
	
	--on retourne l'id
	return res;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_reponse(character varying, boolean, integer) OWNER TO postgres;

--
-- TOC entry 9344 (class 0 OID 0)
-- Dependencies: 514
-- Name: FUNCTION qr_set_reponse(character varying, boolean, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_reponse(character varying, boolean, integer) IS 'FONCTION PRIVEE:
Insere une reponse.';


--
-- TOC entry 515 (class 1255 OID 2597195)
-- Dependencies: 2983 7
-- Name: qr_set_sondage(character varying, integer, boolean, integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION qr_set_sondage(character varying, integer, boolean, integer[], integer[]) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 type
--$3 radio
--$4 questions
--$5 reponses

i integer;
b_value boolean;
val_id integer;
BEGIN	

	SELECT INTO val_id * FROM v2.af_set_question_reponse($1, $2, $3, $4,$5 );

	

	RETURN val_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.qr_set_sondage(character varying, integer, boolean, integer[], integer[]) OWNER TO postgres;

--
-- TOC entry 9345 (class 0 OID 0)
-- Dependencies: 515
-- Name: FUNCTION qr_set_sondage(character varying, integer, boolean, integer[], integer[]); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION qr_set_sondage(character varying, integer, boolean, integer[], integer[]) IS 'CrÃƒÂ©er un Sondage complet';


--
-- TOC entry 516 (class 1255 OID 2597196)
-- Dependencies: 2983 7
-- Name: rssrc_del_espace(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_del_espace(integer) RETURNS boolean
    AS $_$-- $1 : numero espace
begin
    delete from v2.espace 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_del_espace(integer) OWNER TO pgsql;

--
-- TOC entry 9346 (class 0 OID 0)
-- Dependencies: 516
-- Name: FUNCTION rssrc_del_espace(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_del_espace(integer) IS 'supprime un espace';


--
-- TOC entry 517 (class 1255 OID 2597197)
-- Dependencies: 2983 7
-- Name: rssrc_del_formation_espace(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_del_formation_espace(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : espace
begin
    delete from v2.formation_ressources 
    where formation=$1 and espace=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_del_formation_espace(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9347 (class 0 OID 0)
-- Dependencies: 517
-- Name: FUNCTION rssrc_del_formation_espace(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_del_formation_espace(integer, integer) IS 'supprime un espace (ressource) de la formation';


--
-- TOC entry 518 (class 1255 OID 2597198)
-- Dependencies: 2983 7
-- Name: rssrc_del_formation_espace_section(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_del_formation_espace_section(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : espace
-- $3 : section
begin
    delete from v2.formation_ressources 
    where formation=$1 and espace=$2 and section=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_del_formation_espace_section(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9348 (class 0 OID 0)
-- Dependencies: 518
-- Name: FUNCTION rssrc_del_formation_espace_section(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_del_formation_espace_section(integer, integer, integer) IS 'supprime une section d''un espace (ressource) d''une formation';


--
-- TOC entry 519 (class 1255 OID 2597199)
-- Dependencies: 2983 7
-- Name: rssrc_del_formation_ressource(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_del_formation_ressource(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : ressource
-- $3 : espace
-- $4 : section
begin
    delete from v2.formation_ressources 
    where formation=$1 and ressource=$2 and espace=$3 and section=$4;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_del_formation_ressource(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9349 (class 0 OID 0)
-- Dependencies: 519
-- Name: FUNCTION rssrc_del_formation_ressource(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_del_formation_ressource(integer, integer, integer, integer) IS 'supprime une ressource d''une formation';


--
-- TOC entry 520 (class 1255 OID 2597200)
-- Dependencies: 2983 7
-- Name: rssrc_del_section(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_del_section(integer) RETURNS boolean
    AS $_$-- $1 : numero section
begin
    delete from v2.section 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_del_section(integer) OWNER TO pgsql;

--
-- TOC entry 9350 (class 0 OID 0)
-- Dependencies: 520
-- Name: FUNCTION rssrc_del_section(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_del_section(integer) IS 'supprime une section';


--
-- TOC entry 521 (class 1255 OID 2597201)
-- Dependencies: 2983 7
-- Name: rssrc_get_espace(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_espace(integer) RETURNS record
    AS $_$-- $1 : numero espace
declare
rec record;
begin
    select into rec * from v2.af_get_espaces() as (id int4,libelle varchar) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_espace(integer) OWNER TO pgsql;

--
-- TOC entry 9351 (class 0 OID 0)
-- Dependencies: 521
-- Name: FUNCTION rssrc_get_espace(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_espace(integer) IS 'retourne un espace';


--
-- TOC entry 522 (class 1255 OID 2597202)
-- Dependencies: 2983 7
-- Name: rssrc_get_espaces(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_espaces() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select * from v2.espace 
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_espaces() OWNER TO pgsql;

--
-- TOC entry 9352 (class 0 OID 0)
-- Dependencies: 522
-- Name: FUNCTION rssrc_get_espaces(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_espaces() IS 'retourne les espaces de la plateforme';


--
-- TOC entry 523 (class 1255 OID 2597203)
-- Dependencies: 2983 7
-- Name: rssrc_get_etape_ressource(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_etape_ressource(integer) RETURNS record
    AS $_$DECLARE
-- $1 : id de l'ÃƒÂ©tape
rec record;
BEGIN
	SELECT INTO rec er.id,e.libelle,er.espace,er.section,r.id,r.fichier,r.mots_cles, e.date_creation from v2.ressource r RIGHT OUTER JOIN
	v2.etape_ressource er ON (er.ressource=r.id) , v2.etape e
	WHERE e.id=er.id
	AND er.id=$1;
	
	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_etape_ressource(integer) OWNER TO pgsql;

--
-- TOC entry 524 (class 1255 OID 2597204)
-- Dependencies: 2983 7
-- Name: rssrc_get_formation_ressource(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_formation_ressource(integer, integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : espace
-- $3 : section
-- $4 : ressource
declare
rec record;
begin
    select into rec
	FR.ressource,R.fichier,FR.espace,E.libelle, FR.section,S.libelle,ET.libelle,FR.formation,FI.type,R.mots_cles, 
	cast(FR.debut_disponibilite as date), cast(FR.fin_disponibilite as date), FR.duree_nouveaute
	FROM 
	v2.formation_ressources FR,
	v2.ressource R,
	v2.etape ET,
	v2.etape_ressource ER,
	v2.fichier FI,
	v2.espace E,
	v2.section S
	WHERE 
	FR.formation=$1 and FR.espace=$2 and FR.section=$3 and FR.ressource=$4  
	and FR.ressource=R.id 
	and FR.espace=E.id 
	and FR.section=S.id 
	and R.fichier=FI.id 
	and ET.id=ER.id and ER.ressource=FR.ressource;
	return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_formation_ressource(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9353 (class 0 OID 0)
-- Dependencies: 524
-- Name: FUNCTION rssrc_get_formation_ressource(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_formation_ressource(integer, integer, integer, integer) IS 'retourne les info d''une ressource de formation';


--
-- TOC entry 525 (class 1255 OID 2597205)
-- Dependencies: 2983 7
-- Name: rssrc_get_formation_ressources(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_formation_ressources(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 formation
rec RECORD;
BEGIN
    FOR rec IN
	SELECT FR.ressource,R.fichier,FR.espace,E.libelle, FR.section,S.libelle,ET.libelle,FR.formation,FI.type,R.mots_cles, FR.debut_disponibilite, FR.fin_disponibilite, FR.duree_nouveaute,S.icone
	FROM 
	v2.formation_ressources FR,
	v2.ressource R,
	v2.etape ET,
	v2.etape_ressource ER,
	v2.fichier FI,
	v2.espace E,
	v2.section S
	WHERE 
	FR.formation=$1 
	and FR.ressource=R.id 
	and FR.espace=E.id 
	and FR.section=S.id 
	and R.fichier=FI.id 
	and ET.id=ER.id and ER.ressource=FR.ressource
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_formation_ressources(integer) OWNER TO pgsql;

--
-- TOC entry 526 (class 1255 OID 2597206)
-- Dependencies: 2983 7
-- Name: rssrc_get_icones(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_icones() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select f.id,f.libelle from v2.fichier f,v2.fichier_icone fi
	where f.id=fi.id
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_icones() OWNER TO pgsql;

--
-- TOC entry 9354 (class 0 OID 0)
-- Dependencies: 526
-- Name: FUNCTION rssrc_get_icones(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_icones() IS 'retourne les icones de la plateforme';


--
-- TOC entry 527 (class 1255 OID 2597207)
-- Dependencies: 2983 7
-- Name: rssrc_get_page_ressource_configuration(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_page_ressource_configuration(integer, integer, integer, integer) RETURNS record
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : parcours
-- $4 : etape_ressource
declare
rec record;
begin
    select into rec formation,page,parcours,etape_ressource,commentaire  
    from v2.page_ressource_configuration
    where formation=$1 and page=$2 and parcours=$3 and etape_ressource=$4;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_page_ressource_configuration(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9355 (class 0 OID 0)
-- Dependencies: 527
-- Name: FUNCTION rssrc_get_page_ressource_configuration(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_page_ressource_configuration(integer, integer, integer, integer) IS 'retourne la configuration d''une page de ressource';


--
-- TOC entry 528 (class 1255 OID 2597208)
-- Dependencies: 2983 7
-- Name: rssrc_get_parcours_ressources(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_parcours_ressources(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 parcours
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT R.id, R.fichier , ER.espace , ER.section , PE_id , PE_parcours 
		FROM v2.af_get_parcours_etapes($1) AS (PE_id int4, PE_libelle varchar, PE_libelle_type_etape  varchar, PE_type int4,  PE_pere int4, PE_parcours int4, PE_obligatoire bool, PE_chrono int4, PE_fin bool),
		v2.ressource R, v2.etape_ressource ER
		WHERE PE_parcours=$1 
		AND PE_type=7
		AND ER.id=PE_id
		AND ER.ressource=R.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_parcours_ressources(integer) OWNER TO pgsql;

--
-- TOC entry 529 (class 1255 OID 2597209)
-- Dependencies: 2983 7
-- Name: rssrc_get_ressource(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_ressource(integer) RETURNS record
    AS $_$-- $1 : ressource
declare
rec record;
begin
    select into rec r.id,e.libelle,fichier,mots_cles, er.id from v2.ressource r,v2.etape_ressource er, v2.etape e
     where r.id=$1 and r.id=ressource AND e.id=er.id;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_ressource(integer) OWNER TO pgsql;

--
-- TOC entry 9356 (class 0 OID 0)
-- Dependencies: 529
-- Name: FUNCTION rssrc_get_ressource(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_ressource(integer) IS 'retourne les infos ressource';


--
-- TOC entry 530 (class 1255 OID 2597210)
-- Dependencies: 2983 7
-- Name: rssrc_get_section(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_section(integer) RETURNS record
    AS $_$-- s1 : numero section
declare
rec record;
begin
    select into rec * from v2.af_get_sections() as (id int4,libelle varchar,icone int4) 
    where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_section(integer) OWNER TO pgsql;

--
-- TOC entry 9357 (class 0 OID 0)
-- Dependencies: 530
-- Name: FUNCTION rssrc_get_section(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_section(integer) IS 'retourne une section';


--
-- TOC entry 531 (class 1255 OID 2597211)
-- Dependencies: 2983 7
-- Name: rssrc_get_sections(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_sections() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select * from v2.section 
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_sections() OWNER TO pgsql;

--
-- TOC entry 9358 (class 0 OID 0)
-- Dependencies: 531
-- Name: FUNCTION rssrc_get_sections(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_sections() IS 'retourne les sections de la plateforme';


--
-- TOC entry 532 (class 1255 OID 2597212)
-- Dependencies: 2983 7
-- Name: rssrc_get_theme_etapes_ressource(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_theme_etapes_ressource(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in 
	select er.id,e.libelle,er.espace,er.section,r.id,r.fichier,r.mots_cles from v2.ressource r RIGHT OUTER JOIN
	v2.etape_ressource er ON (er.ressource=r.id),
	v2.af_get_categorie_elements_theme(39,$1) tc , v2.etape e
	where er.id=tc AND e.id=er.id
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_theme_etapes_ressource(integer) OWNER TO pgsql;

--
-- TOC entry 9359 (class 0 OID 0)
-- Dependencies: 532
-- Name: FUNCTION rssrc_get_theme_etapes_ressource(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_theme_etapes_ressource(integer) IS 'retourne les etapes ressource d''un theme';


--
-- TOC entry 533 (class 1255 OID 2597213)
-- Dependencies: 2983 7
-- Name: rssrc_get_theme_ressources(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_theme_ressources(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in 
	select r.id,e.libelle,fichier,mots_cles from v2.ressource r,
	v2.etape_ressource er,
	v2.af_get_categorie_elements_theme(39,$1) tc, 
	v2.etape e
	where er.id=tc and er.ressource=r.id and e.id=er.id
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_theme_ressources(integer) OWNER TO pgsql;

--
-- TOC entry 9360 (class 0 OID 0)
-- Dependencies: 533
-- Name: FUNCTION rssrc_get_theme_ressources(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_theme_ressources(integer) IS 'retourne les ressources d''un theme';


--
-- TOC entry 534 (class 1255 OID 2597214)
-- Dependencies: 2983 7
-- Name: rssrc_get_themes_ressource(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_themes_ressource() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in

    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_themes_ressource() OWNER TO pgsql;

--
-- TOC entry 9361 (class 0 OID 0)
-- Dependencies: 534
-- Name: FUNCTION rssrc_get_themes_ressource(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_themes_ressource() IS 'retourne les themes des ressources';


--
-- TOC entry 535 (class 1255 OID 2597215)
-- Dependencies: 2983 7
-- Name: rssrc_get_themes_ressource_fichier_texte(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_get_themes_ressource_fichier_texte() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select * from v2.af_get_categorie_themes(7) as (id int4,libelle varchar)
	union
	select * from v2.af_get_categorie_themes(26) as (id int4,libelle varchar)
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_get_themes_ressource_fichier_texte() OWNER TO pgsql;

--
-- TOC entry 9362 (class 0 OID 0)
-- Dependencies: 535
-- Name: FUNCTION rssrc_get_themes_ressource_fichier_texte(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_get_themes_ressource_fichier_texte() IS 'retourne les themes des fichiers ressource (fichier et texte)';


--
-- TOC entry 536 (class 1255 OID 2597216)
-- Dependencies: 2983 7
-- Name: rssrc_maj_espace(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_maj_espace(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero espace
-- $2 : libelle
begin
    update v2.espace set libelle=$2 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_maj_espace(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9363 (class 0 OID 0)
-- Dependencies: 536
-- Name: FUNCTION rssrc_maj_espace(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_maj_espace(integer, character varying) IS 'met Ãƒ  jour un espace';


--
-- TOC entry 537 (class 1255 OID 2597217)
-- Dependencies: 2983 7
-- Name: rssrc_maj_etape_ressource(integer, character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_maj_etape_ressource(integer, character varying, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
-- $1 : etape
-- $2 : libelle
-- $3 : ressource
-- $4 : espace
-- $5 : section
ok bool;
begin
    SELECT INTO ok * FROM v2.af_maj_etape_libelle($1, $2);

    update v2.etape_ressource set ressource=$3,espace=$4 , section=$5
    where id=$1;

    return found OR ok;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_maj_etape_ressource(integer, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9364 (class 0 OID 0)
-- Dependencies: 537
-- Name: FUNCTION rssrc_maj_etape_ressource(integer, character varying, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_maj_etape_ressource(integer, character varying, integer, integer, integer) IS 'modifie une ÃƒÂ©tape ressource';


--
-- TOC entry 538 (class 1255 OID 2597218)
-- Dependencies: 2983 7
-- Name: rssrc_maj_ressource(integer, integer, text); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_maj_ressource(integer, integer, text) RETURNS boolean
    AS $_$-- $1 : ressource
-- $2 : fichier
-- $3 : mots cles
begin
    update v2.ressource set fichier=$2,mots_cles=$3
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_maj_ressource(integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 9365 (class 0 OID 0)
-- Dependencies: 538
-- Name: FUNCTION rssrc_maj_ressource(integer, integer, text); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_maj_ressource(integer, integer, text) IS 'modifie une ressource';


--
-- TOC entry 539 (class 1255 OID 2597219)
-- Dependencies: 2983 7
-- Name: rssrc_maj_section(integer, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_maj_section(integer, character varying, integer) RETURNS boolean
    AS $_$-- $1 : numero section
-- $2 : libelle
-- $3 : numero icone
begin
    update v2.section set libelle=$2,icone=$3 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_maj_section(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9366 (class 0 OID 0)
-- Dependencies: 539
-- Name: FUNCTION rssrc_maj_section(integer, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_maj_section(integer, character varying, integer) IS 'met Ãƒ  jour une section';


--
-- TOC entry 540 (class 1255 OID 2597220)
-- Dependencies: 2983 7
-- Name: rssrc_set_espace(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_set_espace(character varying) RETURNS integer
    AS $_$-- $1 : libelle
declare
new_id int4;
res int4;
begin
    insert into v2.espace(libelle) values($1);
    --RECUPERE L'IDENTIFIANT DU NOUVEL ESPACE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.espace WHERE oid=new_id;
    -- RAISE NOTICE 'insertion du bareme d''id: % (oid=%)',res, new_id;
    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_set_espace(character varying) OWNER TO pgsql;

--
-- TOC entry 9367 (class 0 OID 0)
-- Dependencies: 540
-- Name: FUNCTION rssrc_set_espace(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_set_espace(character varying) IS 'enregistre un nouvel espace';


--
-- TOC entry 541 (class 1255 OID 2597221)
-- Dependencies: 2983 7
-- Name: rssrc_set_etape_ressource(character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_set_etape_ressource(character varying, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 ressource
--$3 espace
--$4 section
res int4;
new_id oid;
BEGIN
	-- insertion dans etape
	INSERT INTO v2.etape(libelle, type) VALUES ($1, 7);
	GET DIAGNOSTICS new_id = RESULT_OID;
	SELECT INTO res id FROM v2.etape WHERE oid=new_id;

	-- insertion dans etape_ressource
	INSERT INTO v2.etape_ressource(id,ressource,espace,section) VALUES (res,$2,$3,$4);

	RETURN res;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_set_etape_ressource(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 542 (class 1255 OID 2597222)
-- Dependencies: 2983 7
-- Name: rssrc_set_page_ressource_configuration(integer, integer, integer, integer, text); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_set_page_ressource_configuration(integer, integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : page
-- $3 : parcours
-- $4 : etape_ressource
-- $5 : commentaire
begin
    -- test si existe
    perform * from v2.page_ressource_configuration where formation=$1 and page=$2 and parcours=$3 and etape_ressource=$4;
    if found then 
	update v2.page_ressource_configuration set commentaire=$5
	where formation=$1 and page=$2 and parcours=$3 and etape_ressource=$4;
    else
	insert into v2.page_ressource_configuration (formation,page,parcours,etape_ressource,commentaire) 
	values($1,$2,$3,$4,$5);
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_set_page_ressource_configuration(integer, integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 9368 (class 0 OID 0)
-- Dependencies: 542
-- Name: FUNCTION rssrc_set_page_ressource_configuration(integer, integer, integer, integer, text); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_set_page_ressource_configuration(integer, integer, integer, integer, text) IS 'Enregistre la configuration d''une page de ressource';


--
-- TOC entry 543 (class 1255 OID 2597223)
-- Dependencies: 2983 7
-- Name: rssrc_set_ressource(integer, text); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_set_ressource(integer, text) RETURNS integer
    AS $_$-- $1 : fichier
-- $2 : mots cles
declare
new_id oid;
res int4;
begin
    -- insertion ressource
    INSERT INTO v2.ressource( fichier,mots_cles) VALUES ($1, $2);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.ressource WHERE oid=new_id;

    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_set_ressource(integer, text) OWNER TO pgsql;

--
-- TOC entry 9369 (class 0 OID 0)
-- Dependencies: 543
-- Name: FUNCTION rssrc_set_ressource(integer, text); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_set_ressource(integer, text) IS 'enregistre une ressource';


--
-- TOC entry 544 (class 1255 OID 2597224)
-- Dependencies: 2983 7
-- Name: rssrc_set_section(character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION rssrc_set_section(character varying, integer) RETURNS integer
    AS $_$-- $1 : libelle
-- $2 : numero icone
declare
new_id int4;
res int4;
begin
    insert into v2.section(libelle,icone) values($1,$2);
    --RECUPERE L'IDENTIFIANT DU NOUVEL ESPACE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.section WHERE oid=new_id;
    -- RAISE NOTICE 'insertion du bareme d''id: % (oid=%)',res, new_id;
    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.rssrc_set_section(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9370 (class 0 OID 0)
-- Dependencies: 544
-- Name: FUNCTION rssrc_set_section(character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION rssrc_set_section(character varying, integer) IS 'enregistre une section';


--
-- TOC entry 545 (class 1255 OID 2597225)
-- Dependencies: 2983 7
-- Name: scnr_get_scenario(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION scnr_get_scenario(integer) RETURNS record
    AS $_$DECLARE
--$1 scenario
rec RECORD;
BEGIN
	SELECT INTO rec E_id, E_libelle, E_type, S.fichier ,F_libelle, F_connecte, E_date_creation
	FROM v2.af_get_etape($1)AS (E_id int4, E_libelle varchar, E_type int4,E_date_creation timestamp),
	v2.scenario S, v2.af_get_fichiers() AS ( F_id int4, F_libelle varchar, F_type int4, F_connecte bool) 
	WHERE S.id=E_id
	AND S.fichier = F_id;

	IF rec.F_connecte IS FALSE THEN
		RAISE EXCEPTION 'Vous tentez de rÃƒÂ©cuperer les informations d\'un scÃƒÂ©nario dont le fichier est dÃƒÂ©connÃƒÂ©ctÃƒÂ©';
	END IF;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.scnr_get_scenario(integer) OWNER TO pgsql;

--
-- TOC entry 546 (class 1255 OID 2597226)
-- Dependencies: 2983 7
-- Name: scnr_get_scenario_fichier(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION scnr_get_scenario_fichier(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du fichier
scenario_id int4;
BEGIN

	SELECT INTO scenario_id id FROM v2.scenario
	WHERE fichier=$1;

	RETURN scenario_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.scnr_get_scenario_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 9371 (class 0 OID 0)
-- Dependencies: 546
-- Name: FUNCTION scnr_get_scenario_fichier(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION scnr_get_scenario_fichier(integer) IS 'Obtenir un scenario Ãƒ  partir de son numero de fichier.';


--
-- TOC entry 547 (class 1255 OID 2597227)
-- Dependencies: 2983 7
-- Name: scrm_get_etape_scorm_fichier(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION scrm_get_etape_scorm_fichier(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du fichier
etape_scorm_id int4;
BEGIN

	SELECT INTO etape_scorm_id id FROM v2.etape_scorm
	WHERE fichier=$1;

	RETURN etape_scorm_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.scrm_get_etape_scorm_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 9372 (class 0 OID 0)
-- Dependencies: 547
-- Name: FUNCTION scrm_get_etape_scorm_fichier(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION scrm_get_etape_scorm_fichier(integer) IS 'Obtenir l''identifiant d''une etape scorm a partir de son numero de fichier.';


--
-- TOC entry 548 (class 1255 OID 2597228)
-- Dependencies: 2983 7
-- Name: sr_del_serie_bloquante_configuration(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_del_serie_bloquante_configuration(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
begin
    delete from v2.serie_bloquante 
    where serie=$1 and formation=$2 and parcours=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_del_serie_bloquante_configuration(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9373 (class 0 OID 0)
-- Dependencies: 548
-- Name: FUNCTION sr_del_serie_bloquante_configuration(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_del_serie_bloquante_configuration(integer, integer, integer) IS 'Supprime la configuration d''une serie bloquante';


--
-- TOC entry 549 (class 1255 OID 2597229)
-- Dependencies: 2983 7
-- Name: sr_del_serie_evaluation(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_del_serie_evaluation(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 la serie
--$2 l'evaluation a supprimer de l'assoc
ok bool;
BEGIN

	SELECT INTO ok v2.af_gen_del_element('v2.serie_evaluations', 'evaluation', $2, ' AND serie='||$1); 
	RETURN ok;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_del_serie_evaluation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 550 (class 1255 OID 2597230)
-- Dependencies: 2983 7
-- Name: sr_del_serie_evaluation_ordre(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_del_serie_evaluation_ordre(integer, integer) RETURNS boolean
    AS $_$DECLARE
req varchar;
cond varchar;
BEGIN

	IF $2 IS NULL THEN
		cond:=' IS NULL';
	ELSE
		cond:=' ='||$3;

	END IF;

	req:='DELETE FROM v2.serie_evaluations 
	WHERE id=$1 AND pere '||cond;

	EXECUTE req;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_del_serie_evaluation_ordre(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9374 (class 0 OID 0)
-- Dependencies: 550
-- Name: FUNCTION sr_del_serie_evaluation_ordre(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_del_serie_evaluation_ordre(integer, integer) IS 'Supprime une ÃƒÂ©valuation d''une sÃƒÂ©rie en fonction du numero du pÃƒÂ¨re.';


--
-- TOC entry 551 (class 1255 OID 2597231)
-- Dependencies: 2983 7
-- Name: sr_get_evaluation_series(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION sr_get_evaluation_series(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
	
	for rec in
		select serie, E.libelle, evaluation from v2.serie_evaluations, v2.etape E where evaluation=$1
		AND serie= E.id order by E.libelle
	loop
		return next rec;
	end loop;
	return;
	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_evaluation_series(integer) OWNER TO postgres;

--
-- TOC entry 9375 (class 0 OID 0)
-- Dependencies: 551
-- Name: FUNCTION sr_get_evaluation_series(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION sr_get_evaluation_series(integer) IS 'Obtenir les sÃƒÆ’Ã‚Â©ries pour une evaluation donnÃƒÆ’Ã‚Â©e (auteur : Said)';


--
-- TOC entry 552 (class 1255 OID 2597232)
-- Dependencies: 2983 7
-- Name: sr_get_formation_individu_parcours_series_score(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_formation_individu_parcours_series_score(integer, integer, integer) RETURNS real
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : parcours
declare
rec record;
rec_resultat record;
id_resultat bigint;
total real;
res real;
nb integer;
begin
    -- boucle sur les series du parcours
    nb:=0;
    total:=0;
    for rec in
	select * from v2.af_get_parcours_etapes_type($3,'4') 
	AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool, indice int4)
    loop
	if rec.type<>'4_1_0_2' and rec.obligatoire is true then
	    -- recup id resultat
	    select into rec_resultat * from v2.af_get_resultat($1,$2,$3,rec.id) 
	    AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	    raise notice 'rec=%',rec_resultat.id;
	    select into res * from v2.af_get_resultat_serie_score(rec_resultat.id);
	    raise notice 'res=%',res;
	    total:=total+res;
	    nb:=nb+1;
	end if;
    end loop;
    if nb=0 then
	return null;
    else
        return total/nb;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_formation_individu_parcours_series_score(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9376 (class 0 OID 0)
-- Dependencies: 552
-- Name: FUNCTION sr_get_formation_individu_parcours_series_score(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_formation_individu_parcours_series_score(integer, integer, integer) IS 'retoune la note sur 20 pour les series d''un parcours (pour un individu,une formation)';


--
-- TOC entry 553 (class 1255 OID 2597233)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_parcours_series_score_partiel(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_parcours_series_score_partiel(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
res_serie real;
nb integer;
id_resultat bigint;
begin
    -- recup composants id resultat
    select into rec_resultat * from v2.af_get_resultat($1) 
    as (id bigint,  formation integer, stagiaire integer,parcours integer, etape integer,  date_debut timestamp, duree interval); 
    -- Initialisation
    total:=0;
    nb:=0;
    -- boucle sur les etapes du parcours
    for rec in 
	select * from v2.af_get_parcours_etapes(rec_resultat.parcours)
	AS (id int4, libelle varchar, libelle_bis varchar, libelle_alias  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    loop
	if rec.type='10' then
	    exit;
	end if;
	-- traitemement serie
    if (rec.type like 4 || '%') and rec.type <> '4_1_0_2' and rec.obligatoire is true then
	-- recup id resultat
	select into id_resultat id from v2.af_get_resultat(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours,rec.id)
	AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	select into res_serie * from v2.af_get_resultat_serie_score(id_resultat);
	total:=total+res_serie;
	nb:=nb+1;


    end if;

    end loop;
    if nb>0 then
	return total/nb;
    else
	return null;
    end if;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_parcours_series_score_partiel(bigint) OWNER TO pgsql;

--
-- TOC entry 9377 (class 0 OID 0)
-- Dependencies: 553
-- Name: FUNCTION sr_get_resultat_parcours_series_score_partiel(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_parcours_series_score_partiel(bigint) IS 'retourne le score aux series d''un parcours avant etape parcours oriente';


--
-- TOC entry 554 (class 1255 OID 2597234)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_avancement_max(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_avancement_max(bigint) RETURNS record
    AS $_$DECLARE
--$1 resultat
rec RECORD;
resultat RECORD;
BEGIN
	SELECT INTO resultat *
	FROM v2.af_get_resultat($1)  AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);

	IF resultat.etape IS NULL THEN
		RAISE EXCEPTION 'Erreur: ne peut determiner l''avancement d''une serie sans son identifiant.';
	END IF;
	SELECT INTO rec resultat.id,resultat.formation , resultat.stagiaire , resultat.parcours, resultat.etape, E.id, E.type,elt.ind
	FROM v2.evaluation E ,v2.af_gen_get_elements('v2.serie_evaluations', 'evaluation', NULL, 'AND serie='||resultat.etape,0) elt
	WHERE E.id=elt.id
	AND elt.ind = 
	 (
		SELECT MIN(elt2.ind) FROM v2.af_gen_get_elements('v2.serie_evaluations', 'evaluation', NULL, 'AND serie='||resultat.etape,0) elt2
		LEFT OUTER JOIN v2.resultat_serie R2 ON (R2.id = $1 AND evaluation=elt2.id)
		WHERE R2.id IS NULL
	);

	RETURN rec; 
END;  $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_avancement_max(bigint) OWNER TO pgsql;

--
-- TOC entry 555 (class 1255 OID 2597235)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_evaluation(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_evaluation(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 evaluation
rec RECORD;
rec_resultat RECORD;
BEGIN
	SELECT INTO rec_resultat * FROM v2.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RS.date_creation, SE.commentaire, SE.bareme, SE.chrono, SE.points
		FROM v2.resultat_serie RS,
		v2.serie_evaluations SE
		WHERE id=$1
		AND RS.evaluation=$2
		AND SE.serie=rec_resultat.etape
		AND SE.evaluation=RS.evaluation
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_evaluation(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 556 (class 1255 OID 2597236)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_evaluation_tentative(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_evaluation_tentative(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 evaluation
rec RECORD;
rec_resultat RECORD;
BEGIN
	SELECT INTO rec_resultat * FROM v2.af_get_resultat_tentative($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval,tentative integer);
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RS.date_creation, SE.commentaire, SE.bareme, SE.chrono, SE.points
		FROM v2.resultat_serie_tentative RS,
		v2.serie_evaluations SE
		WHERE id=$1
		AND RS.evaluation=$2
		AND SE.serie=rec_resultat.etape
		AND SE.evaluation=RS.evaluation
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_evaluation_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 557 (class 1255 OID 2597237)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_evaluations(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_evaluations(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
begin
    for rec in 
	select * from v2.resultat_serie where id=$1
    loop
	return next rec;
    end loop;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_evaluations(bigint) OWNER TO pgsql;

--
-- TOC entry 9378 (class 0 OID 0)
-- Dependencies: 557
-- Name: FUNCTION sr_get_resultat_serie_evaluations(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_evaluations(bigint) IS 'retourne les evaluations d''une serie effecutÃƒÂ©es par l''individu';


--
-- TOC entry 558 (class 1255 OID 2597238)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_evaluations_scores(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_evaluations_scores(bigint) RETURNS SETOF record
    AS $_$DECLARE
--$1 identifiant resultat
rec RECORD;
rec_resultat RECORD;
res_sondage integer;
BEGIN
    SELECT INTO rec_resultat * FROM v2.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	FOR rec IN
	    SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
	    FROM v2.af_get_serie_evaluations(rec_resultat.etape) 
	    AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	LOOP

	raise notice 'type=%',rec.type_evaluation;
	    --QCM 
	    IF rec.type_evaluation=1 or rec.type_evaluation=4 THEN
	        SELECT INTO rec.score * FROM v2.af_get_resultat_serie_questionreponses_scores(rec_resultat.id, rec.id_evaluation);
	    END IF;
	    -- FTB
	    if rec.type_evaluation=3 then
		SELECT INTO rec.score * FROM v2.af_get_resultat_serie_ftb_scores(rec_resultat.id, rec.id_evaluation);
	    end if;
		RETURN NEXT rec;
	END LOOP;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_evaluations_scores(bigint) OWNER TO pgsql;

--
-- TOC entry 9379 (class 0 OID 0)
-- Dependencies: 558
-- Name: FUNCTION sr_get_resultat_serie_evaluations_scores(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_evaluations_scores(bigint) IS 'Obtenir les rÃƒÂ©sultats des evaluations d''une serie(test sur qcm).';


--
-- TOC entry 559 (class 1255 OID 2597239)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_evaluations_scores_tentative(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_evaluations_scores_tentative(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec RECORD;
rec_resultat RECORD;
begin
    SELECT INTO rec_resultat * FROM v2.af_get_resultat_tentative($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval,tentative integer);
	FOR rec IN
	    SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
	    FROM v2.af_get_serie_evaluations(rec_resultat.etape) 
	    AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	LOOP

	raise notice 'type=%',rec.type_evaluation;
	    --QCM 
	    IF rec.type_evaluation=1 or rec.type_evaluation=4 THEN
	        SELECT INTO rec.score * FROM v2.af_get_resultat_serie_questionreponses_scores_tentative(rec_resultat.id, rec.id_evaluation);
	    END IF;
	    -- FTB
	    if rec.type_evaluation=3 then
		SELECT INTO rec.score * FROM v2.af_get_resultat_serie_ftb_scores_tentative(rec_resultat.id, rec.id_evaluation);
	    end if;
		RETURN NEXT rec;
	END LOOP;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_evaluations_scores_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 9380 (class 0 OID 0)
-- Dependencies: 559
-- Name: FUNCTION sr_get_resultat_serie_evaluations_scores_tentative(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_evaluations_scores_tentative(bigint) IS 'retourne les scores des evaluation d''une serie (tentative)';


--
-- TOC entry 560 (class 1255 OID 2597240)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_evaluations_tentative(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_evaluations_tentative(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
begin
    for rec in 
	select * from v2.resultat_serie_tentative where id=$1
    loop
	return next rec;
    end loop;
    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_evaluations_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 9381 (class 0 OID 0)
-- Dependencies: 560
-- Name: FUNCTION sr_get_resultat_serie_evaluations_tentative(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_evaluations_tentative(bigint) IS 'retourne les evaluations d''une serie effecutÃƒÂ©es par l''individu';


--
-- TOC entry 561 (class 1255 OID 2597241)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_ftb(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_ftb(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 ftb
rec RECORD;
BEGIN
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RFTB.reponse,RS.date_creation
		FROM  v2.resultat_serie_ftb RFTB,
		v2.resultat_serie RS
		WHERE RS.id=$1
		AND RS.evaluation=$2
		AND RS.evaluation=RFTB.ftb
		AND RFTB.id=RS.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_ftb(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 562 (class 1255 OID 2597242)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_ftb_scores(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_ftb_scores(bigint, integer) RETURNS real
    AS $_$-- $1 : id resultat
-- $2 : evaluation
declare
rec record;
rec_ftb record;
rec_liste_mot text[];
rec_resultat_liste_mot record;
rec_bareme record;
mot text;
serie integer;
bareme integer;
longueur_mot integer;
point real;
somme real;
total real;
begin
    
    -- recup nÃ‚Â° serie de l'evaluation
    select into rec * from v2.af_get_resultat($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    serie:=rec.etape;
    -- recup nÃ‚Â° bareme 
    select into bareme * from v2.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from v2.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from v2.af_get_evaluation_point(serie,$2);
    somme:=0;
    total:=0;
    
    -- recup resultat ftb
    select into rec_ftb * from v2.af_get_resultat_serie_ftb($1,$2) as (id int8, ftb integer, reponse character varying[],  date_creation timestamp);
    
    -- recup de la liste des mots dans le texte du ftb
    
    select into rec_liste_mot * from v2.af_get_ftb_liste_mot($2);
    
    -- boucle sur les listes de mots
    FOR i IN array_lower(rec_liste_mot, 1) .. array_upper(rec_liste_mot, 1) 
    loop
	
	-- supprime les cotes
	longueur_mot:=char_length(rec_ftb.reponse[i]);
	mot:=substring(rec_ftb.reponse[i] from 2 for longueur_mot -2);
	--raise notice 'ftb_rep=%',mot;
	--raise notice 'lst_mot=%',rec_liste_mot[i];
	if lower(mot)=lower(rec_liste_mot[i]) then
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;	
    end loop;
    somme:=(somme/total)*point;
    if somme<0 then
	somme:=0;
    end if;





    return somme;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_ftb_scores(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9382 (class 0 OID 0)
-- Dependencies: 562
-- Name: FUNCTION sr_get_resultat_serie_ftb_scores(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_ftb_scores(bigint, integer) IS 'retourne le score d''un blans de serie';


--
-- TOC entry 563 (class 1255 OID 2597243)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_ftb_scores_tentative(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_ftb_scores_tentative(bigint, integer) RETURNS real
    AS $_$-- $1 : id resultat
-- $2 : evaluation
declare
rec record;
rec_ftb record;
rec_liste_mot text[];
rec_resultat_liste_mot record;
rec_bareme record;
mot text;
serie integer;
bareme integer;
longueur_mot integer;
point real;
somme real;
total real;
begin
    
    -- recup nÃ‚Â° serie de l'evaluation
    select into rec * from v2.af_get_resultat_tentative($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    serie:=rec.etape;
    -- recup nÃ‚Â° bareme 
    select into bareme * from v2.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from v2.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from v2.af_get_evaluation_point(serie,$2);
    somme:=0;
    total:=0;
    
    -- recup resultat ftb
    select into rec_ftb * from v2.af_get_resultat_serie_ftb($1,$2) as (id int8, ftb integer, reponse character varying[],  date_creation timestamp);
    
    -- recup de la liste des mots dans le texte du ftb
    
    select into rec_liste_mot * from v2.af_get_ftb_liste_mot($2);
    
    -- boucle sur les listes de mots
    FOR i IN array_lower(rec_liste_mot, 1) .. array_upper(rec_liste_mot, 1) 
    loop
	
	-- supprime les cotes
	longueur_mot:=char_length(rec_ftb.reponse[i]);
	mot:=substring(rec_ftb.reponse[i] from 2 for longueur_mot -2);
	--raise notice 'ftb_rep=%',mot;
	--raise notice 'lst_mot=%',rec_liste_mot[i];
	if lower(mot)=lower(rec_liste_mot[i]) then
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;	
    end loop;
    somme:=(somme/total)*point;
    if somme<0 then
	somme:=0;
    end if;





    return somme;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_ftb_scores_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9383 (class 0 OID 0)
-- Dependencies: 563
-- Name: FUNCTION sr_get_resultat_serie_ftb_scores_tentative(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_ftb_scores_tentative(bigint, integer) IS 'retourne le score d''un blans de serie';


--
-- TOC entry 564 (class 1255 OID 2597244)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_ftb_tentative(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_ftb_tentative(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 ftb
rec RECORD;
BEGIN
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RFTB.reponse,RS.date_creation
		FROM  v2.resultat_serie_tentative_ftb RFTB,
		v2.resultat_serie RS
		WHERE RS.id=$1
		AND RS.evaluation=$2
		AND RS.evaluation=RFTB.ftb
		AND RFTB.id=RS.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_ftb_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 565 (class 1255 OID 2597245)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_question_reponse(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_question_reponse(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 question_reponse
rec RECORD;
type_evaluation integer;
resultat real;
BEGIN
	SELECT INTO type_evaluation type FROM v2.af_get_question_reponse($2) AS (id integer, libelle varchar, type integer, date_creation timestamp, radio bool);
	
	FOR rec IN 
		SELECT id, rs_evaluation, question,reponse,rs_date_creation, coche, CAST(s_juste AS integer)
		FROM  v2.resultat_serie_question_reponse QR
		INNER JOIN v2.af_get_resultat_serie_evaluation($1,$2) AS (rs_id int8, rs_evaluation integer, rs_date_creation timestamp, commentaire varchar, bareme integer, chrono integer, points integer)
		ON(	QR.id=rs_id AND QR.id=$1 AND QR.question_reponse=rs_evaluation)
		LEFT OUTER JOIN v2.af_get_question_reponse_solutions($2) AS (s_question_reponse integer, s_question integer,s_reponse integer ,s_juste bool )
		ON (	$2=s_question_reponse AND QR.reponse=s_reponse 
			AND QR.question=s_question AND s_question_reponse=$2)
	LOOP
		IF type_evaluation=2 OR type_evaluation=5 THEN
			--SELECT INTO rec.s_juste * FROM v2.af_get_resultat_serie_sondage($2);
			--rec.s_juste:=60;
		    select into resultat * from v2.af_get_resultat_sondage_question_reponse_score($1,$2,rec.question,rec.reponse);
		    rec.s_juste:=resultat*100;
		END IF;

		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_question_reponse(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 566 (class 1255 OID 2597246)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_question_reponse_tentative(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_question_reponse_tentative(bigint, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
--$2 question_reponse
rec RECORD;
type_evaluation integer;
resultat real;
BEGIN
	SELECT INTO type_evaluation type FROM v2.af_get_question_reponse($2) AS (id integer, libelle varchar, type integer, date_creation timestamp, radio bool);
	
	FOR rec IN 
		SELECT id, rs_evaluation, question,reponse,rs_date_creation, coche, CAST(s_juste AS integer)
		FROM  v2.resultat_serie_tentative_question_reponse QR
		INNER JOIN v2.af_get_resultat_serie_evaluation_tentative($1,$2) AS (rs_id int8, rs_evaluation integer, rs_date_creation timestamp, commentaire varchar, bareme integer, chrono integer, points integer)
		ON(	QR.id=rs_id AND QR.id=$1 AND QR.question_reponse=rs_evaluation)
		LEFT OUTER JOIN v2.af_get_question_reponse_solutions($2) AS (s_question_reponse integer, s_question integer,s_reponse integer ,s_juste bool )
		ON (	$2=s_question_reponse AND QR.reponse=s_reponse 
			AND QR.question=s_question AND s_question_reponse=$2)
	LOOP
		IF type_evaluation=2 OR type_evaluation=5 THEN
			--SELECT INTO rec.s_juste * FROM v2.af_get_resultat_serie_sondage($2);
			--rec.s_juste:=60;
		    select into resultat * from v2.af_get_resultat_sondage_question_reponse_score($1,$2,rec.question,rec.reponse);
		    rec.s_juste:=resultat*100;
		END IF;

		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_question_reponse_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 567 (class 1255 OID 2597247)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_questionreponses_scores(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_questionreponses_scores(bigint, integer) RETURNS real
    AS $_$-- $1 : $id_resultat
-- $2 : nÃ‚Â° question reponse
declare
rec record;
rec_bareme record;
serie integer;
bareme integer;
point real;
somme real;
total real;
begin
    
    -- recup nÃ‚Â° serie de l'evaluation
    select into rec * from v2.af_get_resultat($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    serie:=rec.etape;
    -- recup nÃ‚Â° bareme 
    select into bareme * from v2.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from v2.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from v2.af_get_evaluation_point(serie,$2);
    raise notice 'point=% et bareme=% et serie=%',point,bareme,serie;
    -- boucle sur les reponses
    somme:=0;
    total:=0;	
    for rec in
	select * from v2.af_get_resultat_serie_question_reponse($1,$2) as (id int8, question_reponse integer, question integer, reponse integer,  date_creation timestamp, coche boolean, juste integer)
    loop
	if (rec.coche is true and rec.juste=1) or (rec.coche is false and rec.juste=0) then
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;

    end loop;
    if total>0 then
    somme:=(somme/total)*point;
    end if;
    if somme<0 then
	somme:=0;
    end if;
    return somme;
     
     
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_questionreponses_scores(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9384 (class 0 OID 0)
-- Dependencies: 567
-- Name: FUNCTION sr_get_resultat_serie_questionreponses_scores(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_questionreponses_scores(bigint, integer) IS 'retoune le score pour un qcm ';


--
-- TOC entry 568 (class 1255 OID 2597248)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_questionreponses_scores_tentative(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) RETURNS real
    AS $_$-- $1 : $id_resultat
-- $2 : nÃ‚Â° question reponse
declare
rec record;
rec_bareme record;
serie integer;
bareme integer;
point real;
somme real;
total real;
begin
    
    -- recup nÃ‚Â° serie de l'evaluation
    select into rec * from v2.af_get_resultat_tentative($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval,tentative integer);
    serie:=rec.etape;
    -- recup nÃ‚Â° bareme 
    select into bareme * from v2.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from v2.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from v2.af_get_evaluation_point(serie,$2);
    -- boucle sur les reponses
    somme:=0;
    total:=0;	
    for rec in
	select * from v2.af_get_resultat_serie_question_reponse_tentative($1,$2) as (id int8, question_reponse integer, question integer, reponse integer,  date_creation timestamp, coche boolean, juste integer)
    loop
	if (rec.coche is true and rec.juste=1) or (rec.coche is false and rec.juste=0) then
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;

    end loop;
    if total>0 then
    somme:=(somme/total)*point;
    end if;
    if somme<0 then
	somme:=0;
    end if;
    return somme;
     
     
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9385 (class 0 OID 0)
-- Dependencies: 568
-- Name: FUNCTION sr_get_resultat_serie_questionreponses_scores_tentative(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) IS 'retoune le score pour un qcm ';


--
-- TOC entry 569 (class 1255 OID 2597249)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_questionreponses_stagiaires(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_questionreponses_stagiaires(bigint, integer) RETURNS SETOF record
    AS $_$-- $1 : id resultat
-- $2 : evaluation
declare
rec_resultat record;
rec record;
rec2 record;
rec_stagiaire record;
begin
    -- Initialisation
    -- recup infos resultat
    select into rec_resultat * from v2.af_get_resultat($1) 
    AS (id int8,  formation int4, stagiaire int4,parcours int4, etape int4,  date_debut timestamp, duree interval);
    -- boucle sur les evaluation
    for rec in 
	select distinct srq.id from v2.resultat_serie_question_reponse srq 
	where question_reponse=$2
    loop
	-- formation courante
	select into rec2 * from v2.af_get_resultat(rec.id) 
	AS (id int8,  formation int4, stagiaire int4,parcours int4, etape int4,  date_debut timestamp, duree interval);
	if (rec_resultat.formation=rec2.formation) and (rec_resultat.parcours=rec2.parcours) and (rec_resultat.etape=rec2.etape) then
	    select into rec_stagiaire * from v2.af_get_individu_nom_prenom(rec2.stagiaire) as (s_id integer,s_nom varchar,s_prenom varchar);
	    return next rec_stagiaire;
	end if;
	

    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_questionreponses_stagiaires(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9386 (class 0 OID 0)
-- Dependencies: 569
-- Name: FUNCTION sr_get_resultat_serie_questionreponses_stagiaires(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_questionreponses_stagiaires(bigint, integer) IS 'retourne les stagiaires ayants repondu Ãƒ  une evaluation(meme formation)';


--
-- TOC entry 570 (class 1255 OID 2597250)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_score(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_score(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
nb integer;
begin
    -- recupe etape
    SELECT INTO rec_resultat * FROM v2.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    total:=0;
    nb:=0;
    FOR rec IN
	SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
		FROM v2.af_get_serie_evaluations(rec_resultat.etape) 
		AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
    LOOP
	--QCM et QRC
	IF rec.type_evaluation=1 OR rec.type_evaluation=4 THEN
	    SELECT INTO rec.score * FROM v2.af_get_resultat_serie_questionreponses_scores(rec_resultat.id, rec.id_evaluation);		
	
	end if;
	IF rec.type_evaluation=3 THEN
	    SELECT INTO rec.score * FROM v2.af_get_resultat_serie_ftb_scores(rec_resultat.id, rec.id_evaluation);
			--rec.score=CAST(NULL AS integer);
			--FTB
			--SELECT RSFTB.id, RSFTB.ftb, RSFTB.reponse
			--FROM v2.resultat_serie_ftb RSFTB
			--WHERE RSFTB.ftb=rec.id_evaluation 
			--AND RSFTB.id=rec_resultat.id;
	END IF;
	
	    -- calcul Ãƒ  suivre
	    total:=total+(rec.score*20)/rec.points_evaluation;
	    nb:=nb+1;
	END LOOP;
	return total/nb;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_score(bigint) OWNER TO pgsql;

--
-- TOC entry 9387 (class 0 OID 0)
-- Dependencies: 570
-- Name: FUNCTION sr_get_resultat_serie_score(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_score(bigint) IS 'retourne le score pour une serie ';


--
-- TOC entry 571 (class 1255 OID 2597251)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_serie_score_tentative(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_serie_score_tentative(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
nb integer;
begin
    -- recupe etape
    SELECT INTO rec_resultat * FROM v2.af_get_resultat_tentative($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval,tentative integer);
    total:=0;
    nb:=0;
    FOR rec IN
	SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
		FROM v2.af_get_serie_evaluations(rec_resultat.etape) 
		AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
    LOOP
	--QCM et QRC
	IF rec.type_evaluation=1 OR rec.type_evaluation=4 THEN
	    SELECT INTO rec.score * FROM v2.af_get_resultat_serie_questionreponses_scores_tentative(rec_resultat.id, rec.id_evaluation);		
	
	end if;
	IF rec.type_evaluation=3 THEN
	    SELECT INTO rec.score * FROM v2.af_get_resultat_serie_ftb_scores_tentative(rec_resultat.id, rec.id_evaluation);
			--rec.score=CAST(NULL AS integer);
			--FTB
			--SELECT RSFTB.id, RSFTB.ftb, RSFTB.reponse
			--FROM v2.resultat_serie_ftb RSFTB
			--WHERE RSFTB.ftb=rec.id_evaluation 
			--AND RSFTB.id=rec_resultat.id;
	END IF;
	
	    -- calcul Ãƒ  suivre
	    total:=total+(rec.score*20)/rec.points_evaluation;
	    nb:=nb+1;
	END LOOP;
	return total/nb;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_serie_score_tentative(bigint) OWNER TO pgsql;

--
-- TOC entry 9388 (class 0 OID 0)
-- Dependencies: 571
-- Name: FUNCTION sr_get_resultat_serie_score_tentative(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_serie_score_tentative(bigint) IS 'retourne le score pour une serie(tentative)';


--
-- TOC entry 572 (class 1255 OID 2597252)
-- Dependencies: 2983 7
-- Name: sr_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) RETURNS real
    AS $_$-- $1 : id resultat
-- $2 : evaluation
-- $3 : question
-- $4 : reponse
declare
rec_resultat record;
rec record;
rec2 record;
nb_votant real;
nb_coche real;
begin
    -- Initialisation
    nb_votant:=0;
    nb_coche:=0;
    -- recup la formation
    select into rec_resultat * from v2.af_get_resultat($1) 
    AS (id int8,  formation int4, stagiaire int4,parcours int4, etape int4,  date_debut timestamp, duree interval);
    -- boucle sur la reponse cochÃƒÂ©e
    for rec in 
	select * from v2.resultat_serie_question_reponse srq 
	where question_reponse=$2 and question=$3 and reponse=$4 
	-- and coche is true
    loop
	-- formation courante
	select into rec2 * from v2.af_get_resultat(rec.id) 
	AS (id int8,  formation int4, stagiaire int4,parcours int4, etape int4,  date_debut timestamp, duree interval);
	if (rec_resultat.formation=rec2.formation) and (rec_resultat.parcours=rec2.parcours) and (rec_resultat.etape=rec2.etape) then
	    --raise notice 'form1=% et form2=%',rec_resultat.formation,rec2.formation;
	    if rec.coche is true then
		raise notice 'coucou';
		nb_coche:=nb_coche + 1;
	    end if;
	    nb_votant:=nb_votant + 1;
	    --raise notice 'coche=% et votant=%',nb_coche,nb_votant;	
	end if;
    end loop;
    return (nb_coche/nb_votant);
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9389 (class 0 OID 0)
-- Dependencies: 572
-- Name: FUNCTION sr_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) IS 'retourne le pourcentage pour une reponse de sondage';


--
-- TOC entry 573 (class 1255 OID 2597253)
-- Dependencies: 2983 7
-- Name: sr_get_serie(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec E.id , E.libelle , S.bareme , S.chrono, E.date_creation 
	FROM v2.etape E, v2.serie S
	WHERE E.id= S.id
	AND E.id=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie(integer) OWNER TO pgsql;

--
-- TOC entry 9390 (class 0 OID 0)
-- Dependencies: 573
-- Name: FUNCTION sr_get_serie(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie(integer) IS 'Obtenir les informations d''une serie.';


--
-- TOC entry 574 (class 1255 OID 2597254)
-- Dependencies: 2983 7
-- Name: sr_get_serie_avancement(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_avancement(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
	
		SELECT RQR_formation, RQR_stagiaire, RQR_parcours,  $1 AS serie, RQR_question_response AS evaluation
		--FROM (v2.af_get_serie_evaluations($1) AS (SE_id int4, SE_libelle varchar, SE_serie int4, SE_pere int4, SE_commentaire varchar, SE_bareme int4, SE_chrono int4, SE_points int4, SE_type int4 )
		FROM (v2.af_gen_get_elements('v2.serie_evaluations', 'evaluation', NULL,' AND serie='||$1 ,0) G_id
		LEFT OUTER JOIN v2.af_get_serie_question_reponse_resultats($1) AS (RQR_id int4, RQR_formation int4,  RQR_classe int4, RQR_stagiaire int4, RQR_parcours int4,  RQR_etape int4, RQR_date_debut timestamp, RQR_date_fin timestamp, RQR_question_response int4, RQR_reponse int4, coche bool)
		ON (G_id.id=RQR_question_response))
		LEFT OUTER JOIN v2.af_get_serie_ftb_resultats($1) AS (RFTB_id int4, RFTB_formation int4,  RFTB_classe int4, RFTB_stagiaire int4, RFTB_parcours int4,  RFTB_etape int4, RFTB_date_debut timestamp, RFTB_date_fin timestamp, RFTB_ftb int4, RFTB_reponse text)
		ON (G_id.id=RFTB_ftb )
		ORDER BY SE_id,G_id.ind, RQR_question_response, RQR_formation,RQR_classe, RQR_parcours, RQR_stagiaire 
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_avancement(integer) OWNER TO pgsql;

--
-- TOC entry 575 (class 1255 OID 2597255)
-- Dependencies: 2983 7
-- Name: sr_get_serie_avancement_max(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_avancement_max(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	/*SELECT INTO rec  RQR_formation,  RQR_stagiaire, RQR_parcours,  RFTB_id AS serie, RQR_question_response AS evaluation
	--FROM (v2.af_get_serie_evaluations($1) AS (SE_id int4, SE_libelle varchar, SE_serie int4, SE_pere int4, SE_commentaire varchar, SE_bareme int4, SE_chrono int4, SE_points int4, SE_type int4 )
	FROM (v2.af_gen_get_elements('v2.serie_evaluations', 'evaluation', NULL,' AND serie='||$1 ,0) G_id
	LEFT OUTER JOIN v2.af_get_serie_question_reponse_resultats($1) AS (RQR_id int4, RQR_formation int4,  RQR_classe int4, RQR_stagiaire int4, RQR_parcours int4,  RQR_etape int4, RQR_date_debut timestamp, RQR_date_fin timestamp, RQR_question_response int4, RQR_reponse int4, coche bool)
	ON (G_id.id=RQR_question_response))
	LEFT OUTER JOIN v2.af_get_serie_ftb_resultats($1) AS (RFTB_id int4, RFTB_formation int4,  RFTB_classe int4, RFTB_stagiaire int4, RFTB_parcours int4,  RFTB_etape int4, RFTB_date_debut timestamp, RFTB_date_fin timestamp, RFTB_ftb int4, RFTB_reponse text)
	ON (G_id.id=RFTB_ftb )
	GROUP BY RFTB_id,G_id.ind, RQR_question_response, RQR_formation,RQR_classe, RQR_parcours, RQR_stagiaire
	HAVING G_id.ind=MAX(G_id.ind);
	
	RETURN rec;*/

	RETURN NULL;
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_avancement_max(integer) OWNER TO pgsql;

--
-- TOC entry 576 (class 1255 OID 2597256)
-- Dependencies: 2983 7
-- Name: sr_get_serie_bloquante_configuration(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_bloquante_configuration(integer, integer, integer) RETURNS record
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
declare
rec record;
begin
    select into rec * from v2.serie_bloquante where serie=$1 and formation=$2 and parcours=$3;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_bloquante_configuration(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9391 (class 0 OID 0)
-- Dependencies: 576
-- Name: FUNCTION sr_get_serie_bloquante_configuration(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_bloquante_configuration(integer, integer, integer) IS 'retourne la configuration d''une serie bloquante';


--
-- TOC entry 577 (class 1255 OID 2597257)
-- Dependencies: 2983 7
-- Name: sr_get_serie_commentaires(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_commentaires(integer) RETURNS SETOF record
    AS $_$-- $1 : numero serie
declare
rec record;
begin
    for rec in
	select etape,min,max,commentaire 
	from v2.commentaire_etape 
	where etape=$1
    loop
    return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_commentaires(integer) OWNER TO pgsql;

--
-- TOC entry 9392 (class 0 OID 0)
-- Dependencies: 577
-- Name: FUNCTION sr_get_serie_commentaires(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_commentaires(integer) IS 'retourne les commentaire d''une serie';


--
-- TOC entry 578 (class 1255 OID 2597258)
-- Dependencies: 2983 7
-- Name: sr_get_serie_distincts_types(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_distincts_types(integer) RETURNS SETOF record
    AS $_$-- $1 : serie
declare
rec record;
begin
    for rec in 
	select distinct ev.type from 
	v2.evaluation ev,v2.serie_evaluations se 
	where ev.id=se.evaluation and se.serie=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_distincts_types(integer) OWNER TO pgsql;

--
-- TOC entry 9393 (class 0 OID 0)
-- Dependencies: 578
-- Name: FUNCTION sr_get_serie_distincts_types(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_distincts_types(integer) IS 'retourne les diffÃƒÂ©rents types d''ÃƒÂ©valuation d''une serie';


--
-- TOC entry 579 (class 1255 OID 2597259)
-- Dependencies: 2983 7
-- Name: sr_get_serie_evaluation(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_evaluation(integer, integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN

	SELECT INTO rec * FROM
	v2.af_get_serie_evaluations($1) AS (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 )
	WHERE evaluation=$2;
	 
	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_evaluation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9394 (class 0 OID 0)
-- Dependencies: 579
-- Name: FUNCTION sr_get_serie_evaluation(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_evaluation(integer, integer) IS 'Obtenir les info d''une evaluation d''une serie.';


--
-- TOC entry 580 (class 1255 OID 2597260)
-- Dependencies: 2983 7
-- Name: sr_get_serie_evaluation_indice(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_evaluation_indice(integer, integer) RETURNS integer
    AS $_$-- $1 : serie
-- $2 : evaluation
declare
rec record;
ind integer;
begin
    ind:=0;
    for rec in 
	select * from v2.af_get_serie_evaluations($1) 
	as (id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 )
    loop
	if rec.id=$2 then
	    return ind;
	else
	    ind:=ind+1;
	end if;
    end loop;
    return ind;    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_evaluation_indice(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9395 (class 0 OID 0)
-- Dependencies: 580
-- Name: FUNCTION sr_get_serie_evaluation_indice(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_evaluation_indice(integer, integer) IS 'retourne l''indice d''une evaluation de serie';


--
-- TOC entry 581 (class 1255 OID 2597261)
-- Dependencies: 2983 7
-- Name: sr_get_serie_evaluations(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_evaluations(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	IF $1 IS NULL THEN
		RAISE EXCEPTION 'af_get_serie_evaluations requiert un parametre';
	END IF;
	FOR rec IN
		SELECT E.evaluation, EV.libelle, E.serie, E.pere, E.commentaire, E.bareme, E.chrono, E.points, EV.type 
		FROM v2.serie_evaluations E, 
		v2.af_gen_get_elements('v2.serie_evaluations', 'evaluation', NULL,' AND serie='||$1 ,0) G_id,
		v2.evaluation EV
		WHERE E.evaluation=G_id.id
		AND E.serie=$1
		AND E.evaluation=EV.id
		ORDER BY G_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_evaluations(integer) OWNER TO pgsql;

--
-- TOC entry 9396 (class 0 OID 0)
-- Dependencies: 581
-- Name: FUNCTION sr_get_serie_evaluations(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_evaluations(integer) IS 'Obtenir les evaluations d''une serie.';


--
-- TOC entry 582 (class 1255 OID 2597262)
-- Dependencies: 2983 7
-- Name: sr_get_serie_evaluations_disponibles_theme(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_evaluations_disponibles_theme(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 serie
--$2 theme
--$3 type d'evaluation
rec RECORD;
BEGIN

	FOR rec IN
		SELECT E.id,lower(E.libelle) AS min_text, E.type
		FROM v2.evaluation E,
		v2.af_get_theme_elements($2) AS (T_id int4 , T_categorie int4)
		WHERE E.id= T_id 
		AND E.id NOT IN
			(SELECT evaluation FROM v2.af_get_serie_evaluations($1) AS (evaluation int4,  libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) )
		ORDER BY E.type, min_text
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_evaluations_disponibles_theme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9397 (class 0 OID 0)
-- Dependencies: 582
-- Name: FUNCTION sr_get_serie_evaluations_disponibles_theme(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_evaluations_disponibles_theme(integer, integer) IS 'Obtenir les evaluations disponibles  d''un theme donnÃƒÂ© pour une serie. ';


--
-- TOC entry 583 (class 1255 OID 2597263)
-- Dependencies: 2983 7
-- Name: sr_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 serie
--$2 theme
--$3 categorie d'evaluation
rec RECORD;
BEGIN

	FOR rec IN
		SELECT E.id,lower(E.libelle) AS min_text, E.type
		FROM v2.evaluation E,
		v2.af_get_categorie_elements_theme($3, $2) AS T_id
		WHERE E.id= T_id 
		AND E.id NOT IN
			(SELECT evaluation FROM v2.af_get_serie_evaluations($1) AS (evaluation int4,  libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) )
		ORDER BY E.type, min_text
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9398 (class 0 OID 0)
-- Dependencies: 583
-- Name: FUNCTION sr_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) IS 'Obtenir les evaluations disponibles  d''un theme et d''une categorie donnÃƒÂ©s pour une serie. ';


--
-- TOC entry 584 (class 1255 OID 2597264)
-- Dependencies: 2983 7
-- Name: sr_get_serie_evaluations_disponibles_theme_type(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 serie
--$2 theme
--$3 type d'evaluation
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT E.id,lower(E.libelle) AS min_text, E.type
		FROM v2.evaluation E,
		v2.af_get_theme_elements($2) AS (T_id int4 , T_categorie int4)
		WHERE E.id= T_id 
		AND E.type=$3
		AND E.id NOT IN
			(SELECT evaluation FROM v2.af_get_serie_evaluations($1) AS (evaluation int4,  libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) )
		ORDER BY E.type, min_text
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9399 (class 0 OID 0)
-- Dependencies: 584
-- Name: FUNCTION sr_get_serie_evaluations_disponibles_theme_type(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) IS 'Obtenir les evaluations disponibles  d''un theme et d''un type donnÃƒÂ©s pour une serie. ';


--
-- TOC entry 585 (class 1255 OID 2597265)
-- Dependencies: 2983 7
-- Name: sr_get_serie_ftb_resultats(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_ftb_resultats(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
		FOR rec IN
			/*SELECT
			FROM v2.af_get_serie_evaluations($1) AS (SE_id int4, SE_libelle varchar, SE_serie int4, SE_pere int4, SE_commentaire varchar, SE_bareme int4, SE_chrono int4, SE_points int4, SE_type int4 )
			LEFT OUTER JOIN 
				(v2.resultat_serie_question_reponse RSQR 
					INNER JOIN v2.af_get_etape_resultats($1) AS (R_id int4, R_formation int4,  R_classe int4, R_stagiaire int4, R_parcours int4,  R_etape int4, R_date_debut timestamp, R_date_fin timestamp)
					ON (RSQR.id=R_id)
			ON (serie=RSQR.serie)*/

			SELECT R_id , R_formation ,  R_classe , R_stagiaire , R_parcours ,  R_etape , R_date_debut, R_date_fin , RSFTB.ftb, RSFTB.reponse
			FROM v2.af_get_etape_resultats($1) AS (R_id int4, R_formation int4,  R_classe int4, R_stagiaire int4, R_parcours int4,  R_etape int4, R_date_debut timestamp, R_date_fin timestamp),
			v2.resultat_serie_ftb RSFTB
			WHERE R_id=RSFTB.id
			AND R_etape=RSFTB.serie

		LOOP
			RETURN NEXT rec;
		END LOOP;

		RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_ftb_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 586 (class 1255 OID 2597266)
-- Dependencies: 2983 7
-- Name: sr_get_serie_question_reponse_resultats(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_question_reponse_resultats(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
		FOR rec IN
			/*SELECT
			FROM v2.af_get_serie_evaluations($1) AS (SE_id int4, SE_libelle varchar, SE_serie int4, SE_pere int4, SE_commentaire varchar, SE_bareme int4, SE_chrono int4, SE_points int4, SE_type int4 )
			LEFT OUTER JOIN 
				(v2.resultat_serie_question_reponse RSQR 
					INNER JOIN v2.af_get_etape_resultats($1) AS (R_id int4, R_formation int4,  R_classe int4, R_stagiaire int4, R_parcours int4,  R_etape int4, R_date_debut timestamp, R_date_fin timestamp)
					ON (RSQR.id=R_id)
			ON (serie=RSQR.serie)*/

			SELECT R_id , R_formation ,  R_classe , R_stagiaire , R_parcours ,  R_etape , R_date_debut, R_date_fin , RSQR.question_reponse, RSQR.reponse, RSQR.coche
			FROM v2.af_get_etape_resultats($1) AS (R_id int4, R_formation int4,  R_classe int4, R_stagiaire int4, R_parcours int4,  R_etape int4, R_date_debut timestamp, R_date_fin timestamp),
			v2.resultat_serie_question_reponse RSQR
			WHERE R_id=RSQR.id
			AND R_etape=RSQR.serie

		LOOP
			RETURN NEXT rec;
		END LOOP;

		RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_question_reponse_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 587 (class 1255 OID 2597267)
-- Dependencies: 2983 7
-- Name: sr_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 serie
--$2 theme
--$3 type d'evaluation
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT ELT.id,ELT.libelle, ELT.type, lower(ELT.libelle) as minlib
		FROM v2.af_get_categorie_elements_theme(17,$2) T_id ,
		v2.question_reponse_elements QR,
		v2.question_reponse_element ELT,
		v2.evaluation E
		WHERE E.type=$3 
		AND (QR.question=T_id)
		AND ELT.id=QR.question
		AND E.id=QR.question_reponse
		AND E.id NOT IN
			(SELECT evaluation FROM v2.af_get_serie_evaluations($1) AS (evaluation int4,  libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) )
		ORDER BY minlib
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 588 (class 1255 OID 2597268)
-- Dependencies: 2983 7
-- Name: sr_get_serie_simple(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_simple(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec E.id , E.libelle , S.bareme , S.chrono,date_creation  
	FROM v2.etape E, v2.serie S LEFT OUTER JOIN v2.serie_aleatoire SA
	ON (S.id=SA.id)
	WHERE E.id= S.id
	AND E.id=$1
	AND SA.id IS NULL;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_simple(integer) OWNER TO pgsql;

--
-- TOC entry 9400 (class 0 OID 0)
-- Dependencies: 588
-- Name: FUNCTION sr_get_serie_simple(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_simple(integer) IS 'Obtenir les informations d''une serie simple.';


--
-- TOC entry 589 (class 1255 OID 2597269)
-- Dependencies: 2159 2983 7
-- Name: sr_get_serie_simple_type(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_simple_type(integer) RETURNS type_element
    AS $_$DECLARE
--$1 serie
type_serie v2.type_element;
nb_types int4;
BEGIN
	IF $1 IS NULL THEN
		RAISE EXCEPTION 'af_get_serie_type requiert un parametre';
	END IF;

	--compte le nombre de type diffÃƒÂ©rents
	SELECT INTO nb_types sum(cnt) 
	FROM(
		--compte 1 pour chaque type diffÃƒÂ©rent
		SELECT 1 AS cnt
		FROM v2.af_get_serie_evaluations($1) 
		AS (S_id int4, S_libelle varchar, S_serie int4, S_pere int4, S_commentaire varchar, S_bareme int4, S_chrono int4, S_points int4, S_type int4 )
		GROUP BY S_type
	) AS t;
	--si un seul type, on rÃƒÂ©cupere le type des evaluations (qui est le meme normalement)
	IF nb_types=1 THEN
		
		FOR type_serie IN
			SELECT S_type AS T_id, E.libelle AS T_libelle
			FROM v2.af_get_serie_evaluations($1) 
			AS (S_id int4, S_libelle varchar, S_serie int4, S_pere int4, S_commentaire varchar, S_bareme int4, S_chrono int4, S_points int4, S_type int4 ),
			v2.evaluation_type E
			WHERE E.id=S_type
			GROUP BY S_type,E.libelle
		LOOP 
			--rien ;)
		END LOOP;
	END IF;
	RETURN type_serie;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_simple_type(integer) OWNER TO pgsql;

--
-- TOC entry 590 (class 1255 OID 2597270)
-- Dependencies: 2983 7
-- Name: sr_get_serie_somme_chronos(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_somme_chronos(integer) RETURNS integer
    AS $_$DECLARE
--$1 serie
somme int4;
BEGIN
	SELECT INTO somme SUM(chrono)
	FROM v2.af_get_serie_evaluations($1) AS(id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );

	RETURN somme;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_somme_chronos(integer) OWNER TO pgsql;

--
-- TOC entry 591 (class 1255 OID 2597271)
-- Dependencies: 2983 7
-- Name: sr_get_serie_somme_points(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_somme_points(integer) RETURNS integer
    AS $_$DECLARE
somme int4;
BEGIN
	SELECT INTO somme SUM(points) FROM v2.serie_evaluations where serie=$1;
	RETURN somme;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_somme_points(integer) OWNER TO pgsql;

--
-- TOC entry 9401 (class 0 OID 0)
-- Dependencies: 591
-- Name: FUNCTION sr_get_serie_somme_points(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_serie_somme_points(integer) IS 'Obtenir la somme des points d''une sÃƒÂ©rie.';


--
-- TOC entry 592 (class 1255 OID 2597272)
-- Dependencies: 2983 7
-- Name: sr_get_serie_types_evaluations_type(integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_serie_types_evaluations_type(integer, boolean) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
req varchar;
req2 varchar;
BEGIN
	req:='select distinct T.id, T.libelle, T.code, CAST(COUNT(T.id) AS integer), couleur
	from v2.evaluation_type T, v2.evaluation E, ';

	req2:=' GROUP BY T.id, T.libelle, T.code,couleur';

	IF($2 IS TRUE)THEN
		req:=req || 'v2.serie_aleatoire_evaluations S WHERE T.id=E.type AND E.id=S.serie AND S.serie=' || $1||req2;
	ELSE
		req:=req || 'v2.serie_evaluations S WHERE T.id=E.type AND E.id=S.evaluation AND S.serie=' || $1||req2;
	END IF;
	raise notice 'req=%',req;
	FOR rec IN EXECUTE req
	LOOP
			RETURN NEXT rec;
	END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_serie_types_evaluations_type(integer, boolean) OWNER TO pgsql;

--
-- TOC entry 593 (class 1255 OID 2597273)
-- Dependencies: 2983 7
-- Name: sr_get_theme_series(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_theme_series(integer) RETURNS SETOF record
    AS $_$declare
rec record;
type_serie v2.type_element;
begin
    for rec in
	select S.id,E.libelle, CAST(NULL AS int4) as type_evaluations, CAST(NULL AS varchar) as libelle_type_evaluations  from 
	v2.serie S  LEFT OUTER JOIN v2.serie_aleatoire SA ON (S.id=SA.id) and type!=1 LEFT OUTER JOIN  v2.categorie_serie CS ON (CS.theme=$1 AND S.id=CS.id)
	LEFT OUTER JOIN v2.etape E ON (E.id=CS.id)
	WHERE SA.id IS NULL
	AND CS.id IS NOT NULL
	ORDER BY e.libelle
    loop
	SELECT INTO type_serie * FROM v2.af_get_serie_simple_type(rec.id);
	rec.type_evaluations:=type_serie.id;
	rec.libelle_type_evaluations:=type_serie.libelle;
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_theme_series(integer) OWNER TO pgsql;

--
-- TOC entry 9402 (class 0 OID 0)
-- Dependencies: 593
-- Name: FUNCTION sr_get_theme_series(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_theme_series(integer) IS 'retourne les serie associÃƒÂ©es Ãƒ  un theme';


--
-- TOC entry 594 (class 1255 OID 2597274)
-- Dependencies: 2983 7
-- Name: sr_get_theme_series_non_vide(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_get_theme_series_non_vide(integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
    for rec in 
	select distinct gt_id,gt_libelle,gt_type_evaluations ,gt_libelle_type_evaluations  from v2.af_get_theme_series($1) as (gt_id int4,gt_libelle varchar, gt_type_evaluations int4, gt_libelle_type_evaluations varchar),
	v2.serie_evaluations e 
	where gt_id=e.serie
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_get_theme_series_non_vide(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9403 (class 0 OID 0)
-- Dependencies: 594
-- Name: FUNCTION sr_get_theme_series_non_vide(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_get_theme_series_non_vide(integer, integer) IS 'retourne les series (avec evaluations) pour un theme';


--
-- TOC entry 595 (class 1255 OID 2597275)
-- Dependencies: 2983 7
-- Name: sr_is_serie_bloquante_configuree(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_is_serie_bloquante_configuree(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
declare
resultat int4:=0;
begin
    select into resultat count(*) from v2.serie_bloquante where serie=$1 and formation=$2 and parcours=$3;
    if(resultat>0) then
	return true;
    else
	return false;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_is_serie_bloquante_configuree(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9404 (class 0 OID 0)
-- Dependencies: 595
-- Name: FUNCTION sr_is_serie_bloquante_configuree(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_is_serie_bloquante_configuree(integer, integer, integer) IS 'retourne vrai si une serie est configurÃƒÂ©e en mode bloquant';


--
-- TOC entry 596 (class 1255 OID 2597276)
-- Dependencies: 2983 7
-- Name: sr_maj_serie(integer, character varying, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_maj_serie(integer, character varying, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 serie
--$2 libelle
--$3 bareme
--$4 chrono
mod bool:=FALSE;
BEGIN
	UPDATE v2.etape SET libelle=$2
	WHERE id=$1;

	mod:=FOUND;

	UPDATE v2.serie SET bareme=$3, chrono=$4
	WHERE id=$1;

	RETURN mod OR FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_maj_serie(integer, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9405 (class 0 OID 0)
-- Dependencies: 596
-- Name: FUNCTION sr_maj_serie(integer, character varying, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_maj_serie(integer, character varying, integer, integer) IS 'Mise Ãƒ  jour d''une sÃƒÂ©rie.';


--
-- TOC entry 597 (class 1255 OID 2597277)
-- Dependencies: 2983 7
-- Name: sr_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : seuil
-- $5 : etape retour
-- $6 : tentative
-- $7 : correction
-- $8 : blocage parcours
begin
    update v2.serie_bloquante 
    set seuil=$4,etape_retour=$5,tentatives=$6,correction=$7,blocage_parcours=$8 
    where serie=$1 and formation=$2 and parcours=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) OWNER TO pgsql;

--
-- TOC entry 9406 (class 0 OID 0)
-- Dependencies: 597
-- Name: FUNCTION sr_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) IS 'Met Ãƒ  jour la configuration d''une serie bloquante';


--
-- TOC entry 598 (class 1255 OID 2597278)
-- Dependencies: 2983 7
-- Name: sr_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 serie
--$2 evaluation
--$3 pere
--$4 commentaire
--$5 bareme
--$6 chrono
--$7 point
req varchar;
cond varchar;
cond1 varchar;
cond2 varchar;
BEGIN

	IF $3 IS NULL THEN
		cond:=' IS NULL';
		cond2:=' NULL';
	ELSE
		cond:=' ='||$3;
		cond2:=$3;

	END IF;

	IF $5 IS NULL THEN
		cond1:=' NULL';
	ELSE
		cond1:= $5;

	END IF;

	req:='UPDATE v2.serie_evaluations
	SET evaluation='||$2||', pere='||cond2||', points='||$7||', bareme='||cond1||', chrono='||$6||', commentaire='''||$4||'''
	WHERE serie='||$1||' AND pere '||cond;
	
	EXECUTE req;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9407 (class 0 OID 0)
-- Dependencies: 598
-- Name: FUNCTION sr_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) IS 'Mise Ãƒ  jour d''une ÃƒÂ©valuation d''une serie.';


--
-- TOC entry 599 (class 1255 OID 2597279)
-- Dependencies: 2983 7
-- Name: sr_maj_serie_evaluation_ordre(integer, integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_maj_serie_evaluation_ordre(integer, integer, integer, boolean) RETURNS boolean
    AS $_$DECLARE
--$1 serie
--$2 evaluation source
--$3 evaluation destination
pere_src int4;
pere_dst int4;
suivant_src int4;
precedent_dst int4;
tmp int4;
BEGIN

	--recup du pere de la source
	SELECT INTO pere_src pere FROM v2.af_get_serie_evaluation($1,$2)AS (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );

	--recup du pere de la destination
	SELECT INTO pere_dst pere FROM v2.af_get_serie_evaluation($1,$3)AS (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 ) ;

	--maj de la source (1ere etape -> petite astuce: on met le pere Ãƒ  l'id du dernier, (pas utilisÃƒÂ© pour un pere) pour eviter les conflits)
	SELECT INTO tmp P.id FROM v2.af_gen_get_last_element('v2.serie_evaluations', 'evaluation',' AND serie='||$1) P;
	UPDATE v2.serie_evaluations SET pere=tmp WHERE serie=$1 AND evaluation=$2;

	--maj du suivant de la source
	UPDATE v2.serie_evaluations SET pere=pere_src WHERE serie=$1 AND pere=$2;
		
--INSERTION AVANT
IF $4 THEN

	--recup du suivant de la source
	SELECT INTO suivant_src evaluation FROM v2.serie_evaluations WHERE serie=$1 AND pere=$2;

	--maj de la destination
	UPDATE v2.serie_evaluations SET pere=$2   WHERE serie=$1 AND evaluation=$3;

	--maj de la source (2eme etape -> on met la bonne valeur au pere)
	UPDATE v2.serie_evaluations SET pere=pere_dst WHERE serie=$1 AND evaluation=$2; 

--INSERTION APRES
ELSE
	--maj du suivant de la destination
	UPDATE v2.serie_evaluations SET pere=$2   WHERE serie=$1 AND pere=$3;

	--maj de la source (2eme etape -> on met la bonne valeur au pere)
	UPDATE v2.serie_evaluations SET pere=$3 WHERE serie=$1 AND evaluation=$2; 
END IF;

	RETURN 't';
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_maj_serie_evaluation_ordre(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 600 (class 1255 OID 2597280)
-- Dependencies: 2983 7
-- Name: sr_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 serie
--$2 numero du pere
--$3 commentaire pour la correction
--$4 bareme
--$5 chrono
--$6 points
req varchar;
cond varchar;
cond1 varchar;
BEGIN


	IF $2 IS NULL THEN
		cond:=' IS NULL';
	ELSE
		cond:='='||$2;

	END IF;


	IF $4 IS NULL THEN
		cond1:=' NULL';
	ELSE
		cond1:=$4;

	END IF;

	req:='UPDATE v2.serie_evaluations 
	SET commentaire='''||$3||''', bareme='||cond1||', chrono='||$5||', points='||$6||'  
	WHERE serie='||$1||' AND pere '||cond||';';

	RAISE NOTICE 'req=%',req;

	EXECUTE req;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9408 (class 0 OID 0)
-- Dependencies: 600
-- Name: FUNCTION sr_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) IS 'Met ajour une association d''une evaluation pour une sÃƒÂ©rie en fonction du numero du pere.';


--
-- TOC entry 601 (class 1255 OID 2597281)
-- Dependencies: 2983 7
-- Name: sr_set_resultat_serie(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_set_resultat_serie(bigint, integer) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 evaluation
BEGIN
	INSERT INTO v2.resultat_serie
	(id,evaluation)
	VALUES ($1,$2);
	
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_set_resultat_serie(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 602 (class 1255 OID 2597282)
-- Dependencies: 2983 7
-- Name: sr_set_resultat_serie_ftb(bigint, integer, character varying[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_set_resultat_serie_ftb(bigint, integer, character varying[]) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 ftb
--$3 reponse
BEGIN
	INSERT INTO v2.resultat_serie_ftb
	(id,ftb, reponse)
	VALUES ($1,$2,$3);
	
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_set_resultat_serie_ftb(bigint, integer, character varying[]) OWNER TO pgsql;

--
-- TOC entry 603 (class 1255 OID 2597283)
-- Dependencies: 2983 7
-- Name: sr_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 qsrc
--$3 id questions 
--$4 id reponses
--$5 valeurs coche
ok integer:=0;
cpt integer:=1;
BEGIN
	
	FOR i IN array_lower($3, 1) .. array_upper($3, 1)  
	LOOP

		FOR j IN array_lower($4, 1) .. array_upper($4, 1)  
		LOOP
			INSERT INTO v2.resultat_serie_question_reponse
			(id,question_reponse, question, reponse, coche)
			VALUES ($1,$2,$3[i],$4[j], CAST($5[cpt] AS BOOLEAN) );

			IF FOUND THEN ok:=ok+1; END IF;
			cpt:=cpt+1;
		END LOOP;
	END LOOP;

	RETURN ok=array_upper($5, 1);
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 604 (class 1255 OID 2597284)
-- Dependencies: 2983 7
-- Name: sr_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 question_reponse
--$3 id questions 
--$4 id reponses
--$5 valeur coche
ok integer:=0;

BEGIN
	--INSERT INTO v2.resultat_serie
	--(id,evaluation)
	--VALUES ($1,$2 );
	
	FOR i IN array_lower($3, 1) .. array_upper($3, 1)  
	LOOP

		FOR j IN array_lower($4, 1) .. array_upper($4, 1)  
		LOOP
			INSERT INTO v2.resultat_serie_question_reponse
			(id,question_reponse, question, reponse, coche)
			VALUES ($1,$2,$3[i],$4[j], CAST($5[j] AS BOOLEAN) );

			IF FOUND THEN ok:=ok+1; END IF;
		END LOOP;
	END LOOP;

	RETURN ok=array_upper($4, 1);
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 605 (class 1255 OID 2597285)
-- Dependencies: 2983 7
-- Name: sr_set_serie(character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_set_serie(character varying, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 numero de bareme global
--$3 valeur du chrono global
--$4 type de la liste
new_id int4;
res int4;
BEGIN
	--RAISE NOTICE 'libelle=% bareme=% valeur=%',$1,$2, $3;
	INSERT INTO v2.etape(libelle, type) VALUES ($1, 4);
	GET DIAGNOSTICS new_id = RESULT_OID;
	
	SELECT INTO res id FROM v2.etape WHERE oid=new_id;
	
	INSERT INTO v2.liste (id, type) VALUES (res, $4);
	
	INSERT INTO v2.serie(id, bareme, chrono) VALUES (res, $2, $3);
	RETURN res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_set_serie(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9409 (class 0 OID 0)
-- Dependencies: 605
-- Name: FUNCTION sr_set_serie(character varying, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_set_serie(character varying, integer, integer, integer) IS 'FONCTION PRIVEE: CrÃƒÂ©e une sÃƒÂ©rie d''un type donnÃƒÂ© .';


--
-- TOC entry 606 (class 1255 OID 2597286)
-- Dependencies: 2983 7
-- Name: sr_set_serie(character varying, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_set_serie(character varying, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 numero de bareme global
--$3 valeur du chrono global


res int4;
BEGIN	
	SELECT INTO res * FROM v2.af_set_serie($1,$2,$3,1);
		
	RETURN res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_set_serie(character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9410 (class 0 OID 0)
-- Dependencies: 606
-- Name: FUNCTION sr_set_serie(character varying, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_set_serie(character varying, integer, integer) IS 'CrÃƒÂ©e une sÃƒÂ©rie.';


--
-- TOC entry 607 (class 1255 OID 2597287)
-- Dependencies: 2983 7
-- Name: sr_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : seuil
-- $5 : etape retour
-- $6 : tentative
-- $7 : correction
-- $8 : blocage parcours
begin
    insert into v2.serie_bloquante (serie,formation,parcours,seuil,etape_retour,tentatives,correction,blocage_parcours) 
    values($1,$2,$3,$4,$5,$6,$7,$8);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) OWNER TO pgsql;

--
-- TOC entry 9411 (class 0 OID 0)
-- Dependencies: 607
-- Name: FUNCTION sr_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) IS 'enregistre la configuration d''une serie bloquante';


--
-- TOC entry 608 (class 1255 OID 2597288)
-- Dependencies: 2983 7
-- Name: sr_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION sr_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 evaluation
--$2 serie
--$3 pere
--$4 commentaire
--$5 bareme
--$6 chrono
--$7 points

BEGIN
	INSERT INTO v2.serie_evaluations  (evaluation, serie,pere,commentaire,bareme,chrono, points)
	VALUES($1,$2,$3,$4,$5,$6,$7);

	RETURN $1;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.sr_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9412 (class 0 OID 0)
-- Dependencies: 608
-- Name: FUNCTION sr_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION sr_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) IS 'Associe une evaluation Ãƒ  une sÃƒÂ©rie.';


--
-- TOC entry 609 (class 1255 OID 2597289)
-- Dependencies: 2983 7
-- Name: srltr_del_serie_aleatoire_configuration(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_del_serie_aleatoire_configuration(integer, integer) RETURNS boolean
    AS $_$declare

begin
    if $2=2 then
	delete from v2.serie_aleatoire_multiserie where serie=$1;
    else
	if $2=3 then
	    delete from v2.serie_aleatoire_multitheme where serie=$1;
	else
	    raise exception 'Mode invalide';
	end if;
     end if;
     return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_del_serie_aleatoire_configuration(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9413 (class 0 OID 0)
-- Dependencies: 609
-- Name: FUNCTION srltr_del_serie_aleatoire_configuration(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_del_serie_aleatoire_configuration(integer, integer) IS 'Supprime la configuration d''une serie aleatoire multiserie ou multitheme';


--
-- TOC entry 610 (class 1255 OID 2597290)
-- Dependencies: 2983 7
-- Name: srltr_get_resultat_serie_aleatoire_avancement_max(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_resultat_serie_aleatoire_avancement_max(bigint) RETURNS record
    AS $_$-- $1 : identifiant resultat
declare
rec RECORD;
resultat RECORD;
BEGIN
	SELECT INTO resultat *
	FROM v2.af_get_resultat($1)  AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);

	IF resultat.etape IS NULL THEN
		RAISE EXCEPTION 'Erreur: ne peut determiner l''avancement d''une serie aleatoire sans son identifiant.';
	END IF;
	SELECT INTO rec resultat.id,resultat.formation , resultat.stagiaire , resultat.parcours, resultat.etape, E.id, E.type,elt.ind
	FROM v2.evaluation E ,v2.af_gen_get_elements('v2.serie_aleatoire_evaluations', 'evaluation', NULL, 'AND serie='||resultat.etape,0) elt
	WHERE E.id=elt.id
	AND elt.ind = 
	 (
		SELECT MIN(elt2.ind) FROM v2.af_gen_get_elements('v2.serie_aleatoire_evaluations', 'evaluation', NULL, 'AND serie='||resultat.etape,0) elt2
		LEFT OUTER JOIN v2.resultat_serie R2 ON (R2.id = $1 AND evaluation=elt2.id)
		WHERE R2.id IS NULL
	);

	RETURN rec; 
END; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_resultat_serie_aleatoire_avancement_max(bigint) OWNER TO pgsql;

--
-- TOC entry 9414 (class 0 OID 0)
-- Dependencies: 610
-- Name: FUNCTION srltr_get_resultat_serie_aleatoire_avancement_max(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_resultat_serie_aleatoire_avancement_max(bigint) IS 'retourne l''evaluation Ãƒ  faire d''une serie aleatoire';


--
-- TOC entry 611 (class 1255 OID 2597291)
-- Dependencies: 2983 7
-- Name: srltr_get_resultat_serie_aleatoire_evaluation(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_resultat_serie_aleatoire_evaluation(bigint, integer) RETURNS SETOF record
    AS $_$-- $1 : resultat
-- $2 : evaluation
declare
rec RECORD;
rec_resultat RECORD;
BEGIN
	SELECT INTO rec_resultat * FROM v2.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	
	FOR rec IN 
		SELECT RS.id, RS.evaluation, RS.date_creation,s.bareme,s.chrono
		FROM v2.resultat_serie RS,
		v2.serie_aleatoire_evaluations SE,
		v2.serie s
		WHERE RS.id=$1
		AND RS.evaluation=$2
		AND SE.serie=rec_resultat.etape and formation=rec_resultat.formation 
		and parcours=rec_resultat.parcours and stagiaire=rec_resultat.stagiaire 
		AND SE.evaluation=RS.evaluation 
		and rec_resultat.etape=s.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_resultat_serie_aleatoire_evaluation(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9415 (class 0 OID 0)
-- Dependencies: 611
-- Name: FUNCTION srltr_get_resultat_serie_aleatoire_evaluation(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_resultat_serie_aleatoire_evaluation(bigint, integer) IS 'retourne le resultat d''une evaluation';


--
-- TOC entry 612 (class 1255 OID 2597292)
-- Dependencies: 2983 7
-- Name: srltr_get_resultat_serie_aleatoire_evaluations_scores(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_resultat_serie_aleatoire_evaluations_scores(bigint) RETURNS SETOF record
    AS $_$DECLARE
--$1 identifiant resultat
rec RECORD;
rec_resultat RECORD;
res_sondage integer;
rec_serie record;
BEGIN
    SELECT INTO rec_resultat * FROM v2.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	FOR rec IN
	    /*
	    SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
	    FROM v2.af_get_serie_evaluations(rec_resultat.etape) 
	    AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	    */
	    select $1,rec_resultat.etape,id_evaluation,type_evaluation,cast(null as varchar) as commentaire,cast(null as integer) as bareme,cast(null as integer) as chrono,1, CAST(NULL AS real)  AS score 
	    from v2.af_get_serie_aleatoire_evaluations(rec_resultat.etape,rec_resultat.formation,rec_resultat.parcours,rec_resultat.stagiaire) 
	    as (id_evaluation int4, libelle varchar, serie int4, pere int4,  type_evaluation int4 )
	    --AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	   
	LOOP

	raise notice 'type=%',rec.type_evaluation;
	    --QCM 
	    IF rec.type_evaluation=1 or rec.type_evaluation=4 THEN
	        SELECT INTO rec.score * FROM v2.af_get_resultat_serie_aleatoire_questionreponses_scores(rec_resultat.id, rec.id_evaluation);
	    END IF;
	    -- FTB
	    if rec.type_evaluation=3 then
		SELECT INTO rec.score * FROM v2.af_get_resultat_serie_ftb_scores(rec_resultat.id, rec.id_evaluation);
	    end if;
	    -- complete le record
	    select into rec_serie bareme,chrono from v2.af_get_serie_aleatoire(rec_resultat.etape) as (id integer,libelle varchar,bareme integer,chrono integer,type integer,date_creation timestamp);
	    rec.bareme:=rec_serie.bareme;
	    rec.chrono:=rec_serie.chrono;
	    rec.commentaire:=null;
		RETURN NEXT rec;
	END LOOP;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_resultat_serie_aleatoire_evaluations_scores(bigint) OWNER TO pgsql;

--
-- TOC entry 9416 (class 0 OID 0)
-- Dependencies: 612
-- Name: FUNCTION srltr_get_resultat_serie_aleatoire_evaluations_scores(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_resultat_serie_aleatoire_evaluations_scores(bigint) IS 'Obtenir les rÃƒÂ©sultats des evaluations d''une serie aleatoire(test sur qcm).';


--
-- TOC entry 613 (class 1255 OID 2597293)
-- Dependencies: 2983 7
-- Name: srltr_get_resultat_serie_aleatoire_question_reponse(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_resultat_serie_aleatoire_question_reponse(bigint, integer) RETURNS SETOF record
    AS $_$-- $1 : identifiant resultat
-- $2 : question_reponse
DECLARE
rec RECORD;
type_evaluation integer;
resultat real;

BEGIN
	
	SELECT INTO type_evaluation type FROM v2.af_get_question_reponse($2) AS (id integer, libelle varchar, type integer, date_creation timestamp, radio bool);
	
	FOR rec IN 
		SELECT id, rs_evaluation, question,reponse,rs_date_creation, coche, CAST(s_juste AS integer)
		FROM  v2.resultat_serie_question_reponse QR
		INNER JOIN v2.af_get_resultat_serie_aleatoire_evaluation($1,$2) AS (rs_id int8, rs_evaluation integer, rs_date_creation timestamp,bareme integer,chrono integer)
		ON(	QR.id=rs_id AND QR.id=$1 AND QR.question_reponse=rs_evaluation )
		
		LEFT OUTER JOIN v2.af_get_question_reponse_solutions($2) AS (s_question_reponse integer, s_question integer,s_reponse integer ,s_juste bool )
		ON (	$2=s_question_reponse AND QR.reponse=s_reponse 
			AND QR.question=s_question AND s_question_reponse=$2)
	LOOP
		IF type_evaluation=2 OR type_evaluation=5 THEN
			--SELECT INTO rec.s_juste * FROM v2.af_get_resultat_serie_sondage($2);
			--rec.s_juste:=80;
			-- verifier si fonctionne avec un sondage aleatoire
			select into resultat * from v2.af_get_resultat_sondage_question_reponse_score($1,$2,rec.question,rec.reponse);
		    rec.s_juste:=resultat*100;
		END IF;

		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_resultat_serie_aleatoire_question_reponse(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9417 (class 0 OID 0)
-- Dependencies: 613
-- Name: FUNCTION srltr_get_resultat_serie_aleatoire_question_reponse(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_resultat_serie_aleatoire_question_reponse(bigint, integer) IS 'retourne les resultat d''un question_reponse';


--
-- TOC entry 614 (class 1255 OID 2597294)
-- Dependencies: 2983 7
-- Name: srltr_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) RETURNS real
    AS $_$-- $1 : $id_resultat
-- $2 : nÃ‚Â° question reponse
declare
rec record;
rec_bareme record;
serie integer;
bareme integer;
point real;
somme real;
total real;
begin
    
    -- recup nÃ‚Â° serie de l'evaluation
    select into rec * from v2.af_get_resultat($1) as (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    serie:=rec.etape;
    -- recup nÃ‚Â° bareme 
    select into bareme * from v2.af_get_evaluation_bareme(serie,$2);
    -- les attributs du bareme
    select into rec_bareme * from v2.af_get_bareme(bareme) as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4);
    -- recup point de l'evaluation de la serie
    select into point * from v2.af_get_evaluation_point(serie,$2);
    raise notice 'point=%',point;
    -- boucle sur les reponses
    somme:=0;
    total:=0;	
    for rec in
	select * from v2.af_get_resultat_serie_aleatoire_question_reponse($1,$2) as (id int8, question_reponse integer, question integer, reponse integer,  date_creation timestamp, coche boolean, juste integer)
    loop
	if (rec.coche is true and rec.juste=1) or (rec.coche is false and rec.juste=0) then
	    somme:=somme + rec_bareme.juste;
	else
	    somme:=somme - rec_bareme.fausse;
	end if;
	total:=total + rec_bareme.juste;

    end loop;
    if total>0 then
    somme:=(somme/total)*point;
    end if;
    if somme<0 then
	somme:=0;
    end if;
    return somme;
     
     
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9418 (class 0 OID 0)
-- Dependencies: 614
-- Name: FUNCTION srltr_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) IS 'retoune le score pour un qcm de serie aleatoire';


--
-- TOC entry 615 (class 1255 OID 2597295)
-- Dependencies: 2983 7
-- Name: srltr_get_resultat_serie_aleatoire_score(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_resultat_serie_aleatoire_score(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
nb integer;
point_evaluation integer;
begin
    -- Initialisation
    point_evaluation:=1;
    -- recupe etape,formation,parcours et individu
    SELECT INTO rec_resultat * FROM v2.af_get_resultat($1) AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
    total:=0;
    nb:=0;
    FOR rec IN
	/*
	SELECT $1, serie, id_evaluation, type_evaluation, commentaire_evaluation, bareme_evaluation, chrono_evaluation, points_evaluation, CAST(NULL AS real)  AS score
		FROM v2.af_get_serie_evaluations(rec_resultat.etape) 
		AS (id_evaluation integer, libelle_evaluation varchar, serie integer, pere_evaluation integer, commentaire_evaluation varchar, bareme_evaluation integer, chrono_evaluation integer, points_evaluation integer, type_evaluation integer )
	*/
	select id_evaluation,libelle,serie,pere,type_evaluation, CAST(NULL AS real)  AS score 
	from v2.af_get_serie_aleatoire_evaluations(rec_resultat.etape,rec_resultat.formation,rec_resultat.parcours,rec_resultat.stagiaire) 
	as (id_evaluation int4, libelle varchar, serie int4, pere int4,  type_evaluation int4 )
    LOOP
	--QCM et QRC
	raise notice 'type=%',rec.type_evaluation;
	IF rec.type_evaluation=1 OR rec.type_evaluation=4 THEN
	    SELECT INTO rec.score * FROM v2.af_get_resultat_serie_aleatoire_questionreponses_scores(rec_resultat.id, rec.id_evaluation);		
	
	end if;
	IF rec.type_evaluation=3 THEN
	    SELECT INTO rec.score * FROM v2.af_get_resultat_serie_ftb_scores(rec_resultat.id, rec.id_evaluation);
			--rec.score=CAST(NULL AS integer);
			--FTB
			--SELECT RSFTB.id, RSFTB.ftb, RSFTB.reponse
			--FROM v2.resultat_serie_ftb RSFTB
			--WHERE RSFTB.ftb=rec.id_evaluation 
			--AND RSFTB.id=rec_resultat.id;
	END IF;
	    raise notice 'recscore=%',rec.score;
	    -- calcul Ãƒ  suivre
	    total:=total+(rec.score*20)/point_evaluation;
	    nb:=nb+1;
	END LOOP;
	return total/nb;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_resultat_serie_aleatoire_score(bigint) OWNER TO pgsql;

--
-- TOC entry 9419 (class 0 OID 0)
-- Dependencies: 615
-- Name: FUNCTION srltr_get_resultat_serie_aleatoire_score(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_resultat_serie_aleatoire_score(bigint) IS 'retourne le score pour une serie aleatoire';


--
-- TOC entry 616 (class 1255 OID 2597296)
-- Dependencies: 2983 7
-- Name: srltr_get_serie_aleatoire(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_serie_aleatoire(integer) RETURNS record
    AS $_$declare
rec record;
begin
    select into rec S_id,S_libelle,S_bareme,S_chrono,sa.type, date_creation from 
    v2.af_get_serie($1) as (S_id int4,S_libelle varchar, S_bareme int4, S_chrono int4, date_creation timestamp) ,
    v2.serie_aleatoire sa
    where sa.id=$1 and S_id=sa.id;

    
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_serie_aleatoire(integer) OWNER TO pgsql;

--
-- TOC entry 9420 (class 0 OID 0)
-- Dependencies: 616
-- Name: FUNCTION srltr_get_serie_aleatoire(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_serie_aleatoire(integer) IS 'retourne les infos d''une serie aleatoire';


--
-- TOC entry 617 (class 1255 OID 2597297)
-- Dependencies: 2983 7
-- Name: srltr_get_serie_aleatoire_evaluations(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_serie_aleatoire_evaluations(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : individu

declare
rec record;
begin
    FOR rec IN
		SELECT E.evaluation, EV.libelle, E.serie, E.pere,  EV.type 
		FROM v2.serie_aleatoire_evaluations E, 
		v2.af_gen_get_elements('v2.serie_aleatoire_evaluations', 'evaluation', NULL,' AND serie='||$1||' AND formation='||$2||' AND parcours='||$3||' AND stagiaire='||$4 ,0) G_id,
		v2.evaluation EV
		WHERE E.evaluation=G_id.id
		AND E.serie=$1
		AND E.evaluation=EV.id
		ORDER BY G_id.ind
	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_serie_aleatoire_evaluations(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9421 (class 0 OID 0)
-- Dependencies: 617
-- Name: FUNCTION srltr_get_serie_aleatoire_evaluations(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_serie_aleatoire_evaluations(integer, integer, integer, integer) IS 'retourne les evaluations d''une serie aleatoire';


--
-- TOC entry 618 (class 1255 OID 2597298)
-- Dependencies: 2983 7
-- Name: srltr_get_serie_aleatoire_series_associations(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_serie_aleatoire_series_associations(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
    for rec in
	select serie,serie_source,nb_evaluations,type_evaluations 
	from v2.serie_aleatoire_multiserie where 
	serie=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_serie_aleatoire_series_associations(integer) OWNER TO pgsql;

--
-- TOC entry 9422 (class 0 OID 0)
-- Dependencies: 618
-- Name: FUNCTION srltr_get_serie_aleatoire_series_associations(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_serie_aleatoire_series_associations(integer) IS 'retourne la configuration d''une serie aleatoire multiserie';


--
-- TOC entry 619 (class 1255 OID 2597299)
-- Dependencies: 2983 7
-- Name: srltr_get_serie_aleatoire_themes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_serie_aleatoire_themes(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
    for rec in 
	select distinct t.id,t.libelle from 
	v2.theme t,
	v2.serie_aleatoire sa,
	v2.theme_categories tc where
	tc.categorie=19 and
	tc.theme=t.id and
	tc.id=sa.id and
	sa.type=$1
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_serie_aleatoire_themes(integer) OWNER TO pgsql;

--
-- TOC entry 9423 (class 0 OID 0)
-- Dependencies: 619
-- Name: FUNCTION srltr_get_serie_aleatoire_themes(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_serie_aleatoire_themes(integer) IS 'retourne les themes pour les series aleatoires pour un type de serie';


--
-- TOC entry 620 (class 1255 OID 2597300)
-- Dependencies: 2159 2983 7
-- Name: srltr_get_serie_aleatoire_type(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_serie_aleatoire_type(integer) RETURNS type_element
    AS $_$DECLARE
--$1 serie aleatoire
retour v2.type_element;
serie_type v2.type_element;
type_eval int4;
libelle_type_eval varchar;
BEGIN
	SELECT INTO serie_type  S_type AS type, libelle
	FROM v2.af_get_serie_aleatoire($1) AS  (S_id int4,S_libelle varchar, S_bareme int4, S_chrono int4, S_type int4, date_creation timestamp),
	v2.serie_aleatoire_type T
	WHERE S_type=T.id;

	--AFFECTE LE TYPE DE SERIE ALEATOIRE
	retour.libelle:=serie_type.libelle;
	retour.id:=serie_type.id;

	IF serie_type.id=3 THEN --multi-themes
		SELECT INTO type_eval type_evaluations FROM v2.serie_aleatoire_multitheme
		WHERE serie=$1
		GROUP BY type_evaluations
		HAVING COUNT(type_evaluations)=1;
	ELSEIF serie_type.id=2 THEN --multi-serie
		SELECT INTO type_eval type_evaluations FROM v2.serie_aleatoire_multiserie
		WHERE serie=$1
		GROUP BY type_evaluations
		HAVING COUNT(type_evaluations)=1;
	END IF;

	IF type_eval IS NOT NULL THEN
		SELECT INTO libelle_type_eval libelle
		FROM v2.evaluation_type
		WHERE id=type_eval;

		--AFFECTE LE TYPE (D'EVALUATION)DE SERIE
		retour.libelle:=retour.libelle||'.''(''.'||libelle_type_eval||'.'')''';
		retour.id:=retour.id||'_'||type_eval;
	END IF;

	RETURN retour;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_serie_aleatoire_type(integer) OWNER TO pgsql;

--
-- TOC entry 621 (class 1255 OID 2597301)
-- Dependencies: 2983 7
-- Name: srltr_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
req varchar;
req2 varchar;
BEGIN
    req:='select distinct T.id, T.libelle, T.code, CAST(COUNT(T.id) AS integer), couleur
    from v2.evaluation_type T, v2.evaluation E, ';
    req2:=' GROUP BY T.id, T.libelle, T.code,couleur';
    req:=req || 'v2.serie_aleatoire_evaluations S WHERE T.id=E.type AND E.id=S.evaluation AND S.serie=' || $1||' and S.formation=' ||$2||' and S.parcours=' ||$3||' and S.stagiaire=' ||$4||req2;
	raise notice 'req=%',req;
	FOR rec IN EXECUTE req
	LOOP
			RETURN NEXT rec;
	END LOOP;
RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 622 (class 1255 OID 2597302)
-- Dependencies: 2983 7
-- Name: srltr_get_serie_series_aleatoires(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_serie_series_aleatoires(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT DISTINCT id, libelle,type, date_creation  FROM v2.serie_aleatoire_multiserie, v2.af_get_etape($1) AS (id int4, libelle varchar, type int4, date_creation timestamp)
		WHERE serie_source=$1
		AND id=serie
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_serie_series_aleatoires(integer) OWNER TO pgsql;

--
-- TOC entry 623 (class 1255 OID 2597303)
-- Dependencies: 2983 7
-- Name: srltr_get_series_aleatoires_type(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_series_aleatoires_type(integer) RETURNS SETOF record
    AS $_$declare
rec record;
req varchar;
table_aleatoire varchar;
begin
/*
    if($1=2) then
	table_aleatoire:='serie_aleatoire_multiserie';
    else
	table_aleatoire:='serie_aleatoire_multitheme';
    end if;
    req:='select  e.id,e.libelle from v2.etape e,v2.'||table_aleatoire||' a
    where e.id=a.serie' ;
    --raise exception 'sql=%',req;
*/    
    for rec in
	--execute req
	select e.id,e.libelle from 
	v2.etape e,
	v2.serie_aleatoire sa where
	e.id=sa.id and sa.type=$1
    loop
	return next rec;
    end loop;
    return;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_series_aleatoires_type(integer) OWNER TO pgsql;

--
-- TOC entry 9424 (class 0 OID 0)
-- Dependencies: 623
-- Name: FUNCTION srltr_get_series_aleatoires_type(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_series_aleatoires_type(integer) IS 'Obtenir les series aleatoires pour un type donnÃƒÂ©';


--
-- TOC entry 624 (class 1255 OID 2597304)
-- Dependencies: 2983 7
-- Name: srltr_get_theme_series_aleatoires(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_get_theme_series_aleatoires(integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
sous_type v2.type_element;
begin
    for rec in
	select e.id,e.libelle, CAST(e.type AS varchar), T.libelle AS libelle_type_original from 
	v2.etape e,
	v2.categorie_serie cs,
	v2.liste l,
	v2.serie_aleatoire sa,
	v2.etape_type T
	where 
	e.id=cs.id and 
	cs.categorie=19 and
	cs.theme=$1 and
	l.type=1 and l.id=e.id
	and e.id=sa.id and
	sa.type=$2
	AND e.type=T.id
    loop
	SELECT INTO sous_type * FROM v2.af_get_etape_type_sous_type(rec.id, CAST(rec.type AS int4), rec.libelle_type_original);
	rec.type:=sous_type.id;
	rec.libelle_type_original:=sous_type.libelle;
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_get_theme_series_aleatoires(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9425 (class 0 OID 0)
-- Dependencies: 624
-- Name: FUNCTION srltr_get_theme_series_aleatoires(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_get_theme_series_aleatoires(integer, integer) IS 'retourne les series aleatoires pour un type et un theme';


--
-- TOC entry 625 (class 1255 OID 2597305)
-- Dependencies: 2983 7
-- Name: srltr_is_serie_aleatoire(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_is_serie_aleatoire(integer) RETURNS boolean
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec *
	FROM v2.etape E, v2.serie S LEFT OUTER JOIN v2.serie_aleatoire SA
	ON (S.id=SA.id)
	WHERE E.id= S.id
	AND E.id=$1
	AND SA.id IS NOT NULL;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_is_serie_aleatoire(integer) OWNER TO pgsql;

--
-- TOC entry 9426 (class 0 OID 0)
-- Dependencies: 625
-- Name: FUNCTION srltr_is_serie_aleatoire(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_is_serie_aleatoire(integer) IS 'savoir si une serie est aleatoire.';


--
-- TOC entry 626 (class 1255 OID 2597306)
-- Dependencies: 2983 7
-- Name: srltr_set_serie_aleatoire(character varying, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltr_set_serie_aleatoire(character varying, integer, integer, integer) RETURNS integer
    AS $_$declare
res int4;
begin
    SELECT INTO res * FROM v2.af_set_serie($1,$2,$3,1);
    insert into v2.serie_aleatoire(id,type) values(res,$4);
    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltr_set_serie_aleatoire(character varying, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9427 (class 0 OID 0)
-- Dependencies: 626
-- Name: FUNCTION srltr_set_serie_aleatoire(character varying, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltr_set_serie_aleatoire(character varying, integer, integer, integer) IS 'enregistre un serie aleatoire';


--
-- TOC entry 627 (class 1255 OID 2597307)
-- Dependencies: 2983 7
-- Name: srltrmlg_del_serie_aleatoire_melangee(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmlg_del_serie_aleatoire_melangee(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
begin
    -- suppression dans serie aleatoire
    
    delete from v2.serie_aleatoire_melangee 
    where serie=$1 and formation=$2 and parcours=$3;

    -- suppression dans serie aleatoire (si 
    --delete from v2.serie_aleatoire where id=$1 and type=1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmlg_del_serie_aleatoire_melangee(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9428 (class 0 OID 0)
-- Dependencies: 627
-- Name: FUNCTION srltrmlg_del_serie_aleatoire_melangee(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmlg_del_serie_aleatoire_melangee(integer, integer, integer) IS 'Supprime le mode aleatoire pour une serie existante';


--
-- TOC entry 628 (class 1255 OID 2597308)
-- Dependencies: 2983 7
-- Name: srltrmlg_get_resultat_serie_melangee_avancement_max(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmlg_get_resultat_serie_melangee_avancement_max(bigint) RETURNS record
    AS $_$-- $1 : identifiant resultat
declare
rec record;
resultat record;
indice integer;
begin
    SELECT INTO resultat *
    FROM v2.af_get_resultat($1)  AS (id int8,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);

    IF resultat.etape IS NULL THEN
	RAISE EXCEPTION 'Erreur: ne peut determiner l''avancement d''une serie aleatoire sans son identifiant.';
    END IF;
     
	select into rec resultat.id,resultat.formation , resultat.stagiaire , resultat.parcours, resultat.etape, e_id, e_type,cast(e_id * 0 + random()as integer) as ind 
	from v2.af_get_serie_evaluations(resultat.etape)as  (e_id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, e_type int4 )
	left outer join v2.resultat_serie on (evaluation=e_id and id=$1)
	where id is null order by ind limit 1;
    
/*
	select into rec resultat.id,resultat.formation , resultat.stagiaire , resultat.parcours, resultat.etape, e_id, e_type,cast(e_id * 0 + random()as integer) as ind 
	from v2.af_get_serie_evaluations(resultat.etape)as  (e_id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, e_type int4 )
	left outer join v2.resultat_serie on (evaluation=e_id and id=$1)
	where id is null order by ind limit 1;
*/
	-- recup indice reel
	--select into indice * from v2.af_get_serie_evaluation_indice(resultat.etape,rec.e_id);
	
	select into indice count(*) +1 from v2.resultat_serie where id=$1;
	rec.ind:=indice;

	return rec;
	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmlg_get_resultat_serie_melangee_avancement_max(bigint) OWNER TO pgsql;

--
-- TOC entry 9429 (class 0 OID 0)
-- Dependencies: 628
-- Name: FUNCTION srltrmlg_get_resultat_serie_melangee_avancement_max(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmlg_get_resultat_serie_melangee_avancement_max(bigint) IS 'Retourne l''evaluation Ãƒ  faire d''une serie aleatoire configuree';


--
-- TOC entry 629 (class 1255 OID 2597309)
-- Dependencies: 2983 7
-- Name: srltrmlg_get_serie_aleatoire_melangee_themes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmlg_get_serie_aleatoire_melangee_themes() RETURNS SETOF record
    AS $$declare
rec record;

begin
    for rec in 
	select * from v2.af_get_serie_aleatoire_themes(1) as (id int4,libelle varchar)
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmlg_get_serie_aleatoire_melangee_themes() OWNER TO pgsql;

--
-- TOC entry 9430 (class 0 OID 0)
-- Dependencies: 629
-- Name: FUNCTION srltrmlg_get_serie_aleatoire_melangee_themes(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmlg_get_serie_aleatoire_melangee_themes() IS 'retourne les themes pour les serie aleatoires configurees';


--
-- TOC entry 630 (class 1255 OID 2597310)
-- Dependencies: 2983 7
-- Name: srltrmlg_get_theme_series_aleatoire_melangees(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmlg_get_theme_series_aleatoire_melangees(integer) RETURNS SETOF record
    AS $_$-- $1 : theme
declare
rec record;
begin
    for rec in
	select id ,libelle , type , libelle_type,formation,parcours  from 
	v2.af_get_theme_series($1) as (id int4,libelle varchar, type int4, libelle_type varchar),
	v2.serie_aleatoire_melangee 
	where id=serie
    loop
	return next rec;
   end loop; 
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmlg_get_theme_series_aleatoire_melangees(integer) OWNER TO pgsql;

--
-- TOC entry 9431 (class 0 OID 0)
-- Dependencies: 630
-- Name: FUNCTION srltrmlg_get_theme_series_aleatoire_melangees(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmlg_get_theme_series_aleatoire_melangees(integer) IS 'retourne les series existantes configurees en mode aleatoire pour un theme donne';


--
-- TOC entry 631 (class 1255 OID 2597311)
-- Dependencies: 2983 7
-- Name: srltrmlg_is_serie_aleatoire_melangee(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmlg_is_serie_aleatoire_melangee(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
declare
resultat int4:=0;
begin
    select into resultat count(*) from v2.serie_aleatoire_melangee where serie=$1 and formation=$2 and parcours=$3;
    if(resultat>0) then
	return true;
    else
	return false;
    end if;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmlg_is_serie_aleatoire_melangee(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9432 (class 0 OID 0)
-- Dependencies: 631
-- Name: FUNCTION srltrmlg_is_serie_aleatoire_melangee(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmlg_is_serie_aleatoire_melangee(integer, integer, integer) IS 'retourne vrai si une serie existante est configuree en mode aleatoire';


--
-- TOC entry 632 (class 1255 OID 2597312)
-- Dependencies: 2983 7
-- Name: srltrmlg_set_serie_aleatoire_melangee(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmlg_set_serie_aleatoire_melangee(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
begin
    -- isertion dans serie aleatoire
    insert into v2.serie_aleatoire(id,type) values($1,1);
    insert into v2.serie_aleatoire_melangee(serie,formation,parcours) 
    values($1,$2,$3);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmlg_set_serie_aleatoire_melangee(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9433 (class 0 OID 0)
-- Dependencies: 632
-- Name: FUNCTION srltrmlg_set_serie_aleatoire_melangee(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmlg_set_serie_aleatoire_melangee(integer, integer, integer) IS 'Enregistre une serie existante en mode aleatoire';


--
-- TOC entry 633 (class 1255 OID 2597313)
-- Dependencies: 2983 7
-- Name: srltrmlg_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmlg_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : stagiaire
declare
rec record;
precedent int4:=NULL;
ok boolean;
begin
    -- recuperation aleatoire des evaluations de la serie
    for rec in 
	select  $1, e_id, $2,$3,$4,e_type,cast(e_id * 0 + random()as integer) as ind 
	from v2.af_get_serie_evaluations($1) 
	as  (e_id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, e_type int4 )
	--left outer join v2.resultat_serie on (evaluation=e_id and id=$1)
	--where id is null order by ind limit 1
	order by ind
    
    loop
	insert into v2.serie_aleatoire_evaluations (serie,evaluation,formation,parcours,stagiaire,pere) 
	values ($1,rec.e_id,$2,$3,$4,precedent);
	precedent:=rec.e_id;
	if not found then
	    ok:=false;
	end if;
    end loop;
    --return ok;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmlg_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9434 (class 0 OID 0)
-- Dependencies: 633
-- Name: FUNCTION srltrmlg_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmlg_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) IS 'remplit la table serie_aleatoire_melangee';


--
-- TOC entry 634 (class 1255 OID 2597314)
-- Dependencies: 2983 7
-- Name: srltrmltsr_get_serie_aleatoire_multiserie_themes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmltsr_get_serie_aleatoire_multiserie_themes() RETURNS SETOF record
    AS $$declare
rec record;

begin
    for rec in 
	select * from v2.af_get_serie_aleatoire_themes(2) as (id int4,libelle varchar)
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmltsr_get_serie_aleatoire_multiserie_themes() OWNER TO pgsql;

--
-- TOC entry 9435 (class 0 OID 0)
-- Dependencies: 634
-- Name: FUNCTION srltrmltsr_get_serie_aleatoire_multiserie_themes(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmltsr_get_serie_aleatoire_multiserie_themes() IS 'retourne les themes pour les series aleatoires multiserie';


--
-- TOC entry 635 (class 1255 OID 2597315)
-- Dependencies: 2983 7
-- Name: srltrmltsr_get_serie_aleatoire_series_sources(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmltsr_get_serie_aleatoire_series_sources(integer) RETURNS SETOF record
    AS $_$declare
rec record;

begin
    for rec in
	select distinct serie_source from 
	v2.serie_aleatoire_multiserie where 
	serie=$1
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmltsr_get_serie_aleatoire_series_sources(integer) OWNER TO pgsql;

--
-- TOC entry 9436 (class 0 OID 0)
-- Dependencies: 635
-- Name: FUNCTION srltrmltsr_get_serie_aleatoire_series_sources(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmltsr_get_serie_aleatoire_series_sources(integer) IS 'retourne les series sources d''une serie aleatoire multiserie';


--
-- TOC entry 636 (class 1255 OID 2597316)
-- Dependencies: 2983 7
-- Name: srltrmltsr_set_serie_aleatoire_multiserie_configuration(integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmltsr_set_serie_aleatoire_multiserie_configuration(integer, integer[]) RETURNS boolean
    AS $_$declare
i int4;
begin
for i in array_lower($2,1) .. array_upper($2,1)
loop
    insert into v2.serie_aleatoire_multiserie values
    ($1,$2[i][1],$2[i][2],$2[i][3]);
end loop;
return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmltsr_set_serie_aleatoire_multiserie_configuration(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 9437 (class 0 OID 0)
-- Dependencies: 636
-- Name: FUNCTION srltrmltsr_set_serie_aleatoire_multiserie_configuration(integer, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmltsr_set_serie_aleatoire_multiserie_configuration(integer, integer[]) IS 'enregistre la configuration d''une serie aleatoire multiserie';


--
-- TOC entry 637 (class 1255 OID 2597317)
-- Dependencies: 2983 7
-- Name: srltrmltsr_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmltsr_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : individu
declare
rec record;
rec2 record;
precedent int4:=NULL;
nb_insert integer:=0;
nb_to_insert integer:=0;
begin
    -- Boucle sur la recuperation de la configuration
    for rec in 
	select * from v2.af_get_serie_aleatoire_series_associations($1) 
        as (serie int4,serie_source int4,nb_evaluation int4,type_evaluations int4)
    loop
	-- ici on recupere aleatoirement les evaluations de la serie source
	nb_to_insert:=nb_to_insert+rec.nb_evaluation;
	for rec2 in 
	    select id,id * 0 + random() as ordre 
	    from v2.af_get_serie_evaluations(rec.serie_source)
	    as (id int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 )
	    
	    where type=rec.type_evaluations order by ordre limit rec.nb_evaluation	
	loop
	    insert into v2.serie_aleatoire_evaluations (serie,evaluation,formation,parcours,stagiaire,pere) 
	    values ($1,rec2.id,$2,$3,$4,precedent);
	    
	    if not found then
		RETURN FALSE;
	    else
		nb_insert:=nb_insert+1;
	    end if;
	    precedent:=rec2.id;
	end loop;

    end loop;

RAISE NOTICE '-------------fin de la fonction: % == %',nb_insert,nb_to_insert;
    return nb_insert=nb_to_insert;   

end; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmltsr_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9438 (class 0 OID 0)
-- Dependencies: 637
-- Name: FUNCTION srltrmltsr_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmltsr_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) IS 'rempli la table serie_aleatoire_evaluation pour une serie aleatoire multiserie';


--
-- TOC entry 638 (class 1255 OID 2597318)
-- Dependencies: 2983 7
-- Name: srltrmltthm_get_serie_aleatoire_themes_associations(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmltthm_get_serie_aleatoire_themes_associations(integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
for rec in
	select  serie,theme_source,nb_evaluations,type_evaluations 
	from v2.serie_aleatoire_multitheme  where 
	serie=$1 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmltthm_get_serie_aleatoire_themes_associations(integer) OWNER TO pgsql;

--
-- TOC entry 9439 (class 0 OID 0)
-- Dependencies: 638
-- Name: FUNCTION srltrmltthm_get_serie_aleatoire_themes_associations(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmltthm_get_serie_aleatoire_themes_associations(integer) IS 'retourne la configuration d''une serie aleatoire multitheme';


--
-- TOC entry 639 (class 1255 OID 2597319)
-- Dependencies: 2983 7
-- Name: srltrmltthm_set_serie_aleatoire_multitheme_configuration(integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmltthm_set_serie_aleatoire_multitheme_configuration(integer, integer[]) RETURNS boolean
    AS $_$declare
i int4;
tmp int4:=NULL;
begin
 
for i in array_lower($2,1) .. array_upper($2,1)
loop
    IF ($2[i][1]!=tmp OR tmp IS NULL)THEN
	tmp:=$2[i][1];
	RAISE NOTICE 'enregistre nveau theme: %',tmp;
	PERFORM * from v2.af_set_categorie_element_theme(19,tmp,$1);
    ELSE
	RAISE NOTICE 'pas nveau theme: %',tmp;
    END IF;
	
    insert into v2.serie_aleatoire_multitheme values
    ($1,$2[i][1],$2[i][2],$2[i][3]);
end loop;
return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmltthm_set_serie_aleatoire_multitheme_configuration(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 9440 (class 0 OID 0)
-- Dependencies: 639
-- Name: FUNCTION srltrmltthm_set_serie_aleatoire_multitheme_configuration(integer, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmltthm_set_serie_aleatoire_multitheme_configuration(integer, integer[]) IS 'enregistre la configuration d''une serie aleatoire multitheme';


--
-- TOC entry 640 (class 1255 OID 2597320)
-- Dependencies: 2983 7
-- Name: srltrmltthm_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION srltrmltthm_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : serie
-- $2 : formation
-- $3 : parcours
-- $4 : individu
declare
rec record;
rec2 record;
precedent int4:=NULL;
ok bool:=true;
begin
    -- Boucle sur la recuperation de la configuration
    for rec in 
	select * from v2.af_get_serie_aleatoire_themes_associations($1) 
        as (serie int4,theme_source int4,nb_evaluation int4,type_evaluations int4)
    loop
	-- ici on recupere aleatoirement les evaluations du theme source
	for rec2 in 
	    select id,id * 0 + random() as ordre 
	    from v2.af_get_theme_evaluations(rec.theme_source)
	    as (id int4, type int4 )
	    
	    where type=rec.type_evaluations order by ordre limit rec.nb_evaluation	
	loop
	    insert into v2.serie_aleatoire_evaluations (serie,evaluation,formation,parcours,stagiaire,pere) 
	    values ($1,rec2.id,$2,$3,$4,precedent);
	    precedent:=rec2.id;
	    if not found then
		ok:=false;
	    end if;
	    
	end loop;

    end loop;

    return ok;   

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.srltrmltthm_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9441 (class 0 OID 0)
-- Dependencies: 640
-- Name: FUNCTION srltrmltthm_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION srltrmltthm_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) IS 'remplit la table serie_aleatoire pour une serie aleatoire multitheme';


--
-- TOC entry 641 (class 1255 OID 2597321)
-- Dependencies: 2983 7
-- Name: thm_del_categorie(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_del_categorie(integer) RETURNS boolean
    AS $_$DECLARE
nom_table varchar;
req_del text;
BEGIN
	--SELECTIONE LE NOM DE LA TABLE ASSOCIEE
	SELECT  INTO nom_table table_cible FROM v2.categorie WHERE id=$1;
	
	--SUPPRIME LA TABLE PERMETTANT DE GERER LES CONTRAINTES SUR LE CHAMP ID DE LA TABLE THEME_CATEGORIES
	IF (nom_table IS NOT NULL) THEN	
		req_del:='DELETE TABLE v2.categorie_'|| nom_table  ||'';
		EXECUTE req_del;
	END IF;
	
	--SUPPRIME LES ENREGISTREMENTS DE LA TABLE THEME_CATEGORIES
	--INUTILE CAR DELETE CASCADE DELETE FROM v2.theme_categories where categorie=$1;
	
	--SUPPRIME L'ENREGISTREMENT DANS LA TABLE CATEGORIE
	DELETE FROM v2.categorie WHERE id=$1;

	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_del_categorie(integer) OWNER TO postgres;

--
-- TOC entry 9442 (class 0 OID 0)
-- Dependencies: 641
-- Name: FUNCTION thm_del_categorie(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_del_categorie(integer) IS 'Fonction qui supprime  une  catÃƒÆ’Ã‚Â©gorie ainsi que les tables associÃƒÆ’Ã‚Â©es';


--
-- TOC entry 642 (class 1255 OID 2597322)
-- Dependencies: 2983 7
-- Name: thm_del_categorie_element(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION thm_del_categorie_element(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 categorie
--$2 id de l'element a supprimer
req varchar;
table_ci varchar;
BEGIN

	--recupere la table cible du fichier
	SELECT INTO table_ci table_cible FROM v2.categorie C 
	WHERE C.id=$1;

	IF table_ci IS NULL THEN
		RAISE EXCEPTION 'Erreur lors de la recupÃƒÆ’Ã‚Â©ration des informations pour la suppression de l''ÃƒÆ’Ã‚Â©lÃƒÆ’Ã‚Â©ment %',$1;
	END IF;
	req:='DELETE FROM v2.categorie_'||table_ci||' WHERE id='||$2;
	RAISE NOTICE 'req=%',req;
	EXECUTE req;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_del_categorie_element(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9443 (class 0 OID 0)
-- Dependencies: 642
-- Name: FUNCTION thm_del_categorie_element(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION thm_del_categorie_element(integer, integer) IS 'Supprime un ÃƒÂ©lÃƒÂ©ment d''une catÃƒÂ©gorie';


--
-- TOC entry 643 (class 1255 OID 2597323)
-- Dependencies: 2983 7
-- Name: thm_del_theme(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_del_theme(integer) RETURNS boolean
    AS $_$BEGIN

	DELETE  FROM v2.theme WHERE id=$1;
	
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_del_theme(integer) OWNER TO postgres;

--
-- TOC entry 9444 (class 0 OID 0)
-- Dependencies: 643
-- Name: FUNCTION thm_del_theme(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_del_theme(integer) IS 'Supprimer le theme dont l''identifiant est passÃƒÆ’Ã‚Â© en paramettre';


--
-- TOC entry 644 (class 1255 OID 2597324)
-- Dependencies: 2983 7
-- Name: thm_get_categorie(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_categorie(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;

BEGIN
	SELECT INTO rec * FROM v2.af_get_categories() AS ( id int4 ,  libelle varchar, table_cible varchar,  gestionnaire_contenu bool , code varchar)
	WHERE id=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_categorie(integer) OWNER TO postgres;

--
-- TOC entry 9445 (class 0 OID 0)
-- Dependencies: 644
-- Name: FUNCTION thm_get_categorie(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_categorie(integer) IS 'Obtenir les informations d''une categorie.';


--
-- TOC entry 645 (class 1255 OID 2597325)
-- Dependencies: 2983 7
-- Name: thm_get_categorie_elements(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION thm_get_categorie_elements(integer) RETURNS SETOF record
    AS $$declare
rec record;
begin
	for rec in
	select id,theme,categorie from v2.theme_categories
	loop
	return next rec;
	end loop;
	return;

end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_categorie_elements(integer) OWNER TO pgsql;

--
-- TOC entry 9446 (class 0 OID 0)
-- Dependencies: 645
-- Name: FUNCTION thm_get_categorie_elements(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION thm_get_categorie_elements(integer) IS 'retourne les elements d''une categorie';


--
-- TOC entry 646 (class 1255 OID 2597326)
-- Dependencies: 2983 7
-- Name: thm_get_categorie_elements_all_theme(integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_categorie_elements_all_theme(integer, integer) RETURNS SETOF integer
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
table_cible varchar;
BEGIN

	--recupere la table correspondant ÃƒÆ’Ã‚  la categorie
	SELECT INTO table_cible  C_table_cible FROM v2.af_get_categorie($1)AS ( C_id int4 ,  C_libelle varchar, C_table_cible varchar,  C_gestionnaire_contenu bool, code varchar);

	req:='SELECT TC.id FROM v2.theme_categories TC, v2.categorie_'||table_cible||' CI
		WHERE TC.categorie='||$1||'
		AND TC.theme='||$2||'
		AND CI.id=TC.id';
	--RAISE NOTICE 'req: %',req;
	
	FOR rec IN
		EXECUTE req
	LOOP
		RETURN NEXT rec.id; 
	END LOOP;

	RETURN;
		 
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_categorie_elements_all_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 9447 (class 0 OID 0)
-- Dependencies: 646
-- Name: FUNCTION thm_get_categorie_elements_all_theme(integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_categorie_elements_all_theme(integer, integer) IS 'Obtenir tous les ÃƒÂ©lÃƒÂ©ments d''un theme pour une categorie, y compris les fichiers non connectÃƒÂ©s.

Il faur donc utiliser:
af_get_categorie_elements_theme
dans la plate-forme';


--
-- TOC entry 647 (class 1255 OID 2597327)
-- Dependencies: 2983 7
-- Name: thm_get_categorie_elements_theme(integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_categorie_elements_theme(integer, integer) RETURNS SETOF integer
    AS $_$DECLARE
--$1 categorie
--$2 theme
rec RECORD;
req varchar;
table_cible varchar;
BEGIN

	--recupere la table correspondant ÃƒÆ’Ã‚  la categorie
	SELECT INTO table_cible  C_table_cible FROM v2.af_get_categorie($1)AS ( C_id int4 ,  C_libelle varchar, C_table_cible varchar,  C_gestionnaire_contenu bool, code varchar);

	req:='SELECT distinct TC.id FROM v2.theme_categories TC, v2.af_get_theme_elements('||$2||') AS (T_id int4,T_categorie int4), v2.categorie_'||table_cible||' CI
		WHERE TC.categorie='||$1||'
		AND TC.theme='||$2||'
		AND CI.id=TC.id
		AND T_id=TC.id';
	--RAISE NOTICE 'req: %',req;
	
	FOR rec IN
		EXECUTE req
	LOOP
		RETURN NEXT rec.id; 
	END LOOP;

	RETURN;
		 
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_categorie_elements_theme(integer, integer) OWNER TO postgres;

--
-- TOC entry 9448 (class 0 OID 0)
-- Dependencies: 647
-- Name: FUNCTION thm_get_categorie_elements_theme(integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_categorie_elements_theme(integer, integer) IS 'Obtenir tous les ÃƒÂ©lÃƒÂ©ments d''un theme pour une categorie qui sont utilisables dans la plate-forme. (les fichiers non-connectÃƒÂ©s n''aparaissent pas).';


--
-- TOC entry 648 (class 1255 OID 2597328)
-- Dependencies: 2983 7
-- Name: thm_get_categorie_themes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION thm_get_categorie_themes(integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
    for rec in
	select DISTINCT t.id,t.libelle from v2.theme_categories c,v2.theme t 
	where c.categorie=$1
	and c.theme=t.id

    loop
	return next rec;
    end loop;
    return;

end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_categorie_themes(integer) OWNER TO pgsql;

--
-- TOC entry 9449 (class 0 OID 0)
-- Dependencies: 648
-- Name: FUNCTION thm_get_categorie_themes(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION thm_get_categorie_themes(integer) IS 'retourne les themes d''une categorie';


--
-- TOC entry 649 (class 1255 OID 2597329)
-- Dependencies: 2983 7
-- Name: thm_get_categorie_themes_element_infos(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION thm_get_categorie_themes_element_infos(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 categorie
--$2 element
rec RECORD;
BEGIN
	FOR rec IN
		SELECT T.id, T.libelle FROM v2.theme T, v2.theme_categories TC
		WHERE TC.id=$2
		AND TC.categorie=$1
		AND TC.theme=T.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
	
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_categorie_themes_element_infos(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9450 (class 0 OID 0)
-- Dependencies: 649
-- Name: FUNCTION thm_get_categorie_themes_element_infos(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION thm_get_categorie_themes_element_infos(integer, integer) IS 'Obtenir les informations sur les themes d''un element pour une categorie.';


--
-- TOC entry 650 (class 1255 OID 2597330)
-- Dependencies: 2983 7
-- Name: thm_get_categories(boolean); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_categories(boolean) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM v2.af_get_categories()AS (id integer, libelle varchar, table_cible varchar, gestionnaire_contenus boolean, code varchar)
		WHERE gestionnaire_contenus = $1
		ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_categories(boolean) OWNER TO postgres;

--
-- TOC entry 9451 (class 0 OID 0)
-- Dependencies: 650
-- Name: FUNCTION thm_get_categories(boolean); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_categories(boolean) IS 'Obtenir les categories de la plate-formeen fonction de gestionnaire_contenu';


--
-- TOC entry 651 (class 1255 OID 2597331)
-- Dependencies: 2983 7
-- Name: thm_get_categories(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_categories() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM v2.categorie ORDER BY gestionnaire_contenu, libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_categories() OWNER TO postgres;

--
-- TOC entry 9452 (class 0 OID 0)
-- Dependencies: 651
-- Name: FUNCTION thm_get_categories(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_categories() IS 'Obtenir toutes les categories de la plate-forme';


--
-- TOC entry 652 (class 1255 OID 2597332)
-- Dependencies: 2983 7
-- Name: thm_get_element_themes_categorie(integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_element_themes_categorie(integer, integer) RETURNS SETOF record
    AS $_$--$1 l element dont on veut le theme
--$2 la categorie

DECLARE
	rec RECORD;
BEGIN

	FOR rec IN
		SELECT T.id, T.libelle FROM v2.theme_categories TC, v2.theme T 
		WHERE TC.categorie=$2 
		AND TC.id=$1
		AND TC.theme=T.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_element_themes_categorie(integer, integer) OWNER TO postgres;

--
-- TOC entry 9453 (class 0 OID 0)
-- Dependencies: 652
-- Name: FUNCTION thm_get_element_themes_categorie(integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_element_themes_categorie(integer, integer) IS 'Obtenir les themes d''un element de la base

Param1:
NumÃƒÆ’Ã‚Â©ro de la catÃƒÆ’Ã‚Â©gorie

Param2
NumÃƒÆ’Ã‚Â©ro de l''ÃƒÆ’Ã‚Â©lÃƒÆ’Ã‚Â©ment

Retourne;
Les numÃƒÆ’Ã‚Â©ros de thÃƒÆ’Ã‚Â¨mes (setof int4)';


--
-- TOC entry 653 (class 1255 OID 2597333)
-- Dependencies: 2983 7
-- Name: thm_get_theme(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_theme(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;

BEGIN
	--pour la conversion du int4 en varchar, on utilise un masque de 9999999999 car les valeurs d'un int4
	--vont de -2147483648 ÃƒÆ’Ã‚  +2147483647, il faut ensuite supprimer les blancs du dÃƒÆ’Ã‚Â©but de la chaine du aux '9' inutiles par rapport aux
	--nombres de chiffres rÃƒÆ’Ã‚Â©els du nombre 
	SELECT INTO rec id, libelle,  trim(leading ' ' from (CAST(to_char(id, '9999999999') AS varchar))) FROM v2.theme WHERE id=$1;
	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_theme(integer) OWNER TO postgres;

--
-- TOC entry 9454 (class 0 OID 0)
-- Dependencies: 653
-- Name: FUNCTION thm_get_theme(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_theme(integer) IS 'Obtenir le theme dont l''identifiant est passÃƒÆ’Ã‚Â© en paramettre';


--
-- TOC entry 654 (class 1255 OID 2597334)
-- Dependencies: 2983 7
-- Name: thm_get_theme(character varying); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_theme(character varying) RETURNS record
    AS $_$DECLARE
rec RECORD;

BEGIN
	--pour la conversion du int4 en varchar, on utilise un masque de 9999999999 car les valeurs d'un int4
	--vont de -2147483648 ÃƒÆ’Ã‚  +2147483647, il faut ensuite supprimer les blancs du dÃƒÆ’Ã‚Â©but de la chaine du aux '9' inutiles par rapport aux
	--nombres de chiffres rÃƒÆ’Ã‚Â©els du nombre 
	SELECT INTO rec id, libelle,  trim(leading ' ' from (CAST(to_char(id, '9999999999') AS varchar))) FROM v2.theme WHERE libelle LIKE $1;
	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_theme(character varying) OWNER TO postgres;

--
-- TOC entry 9455 (class 0 OID 0)
-- Dependencies: 654
-- Name: FUNCTION thm_get_theme(character varying); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_theme(character varying) IS 'Obtenir le theme dont le libÃƒÂ©llÃƒÂ© est passÃƒÂ© en paramettre';


--
-- TOC entry 655 (class 1255 OID 2597335)
-- Dependencies: 2983 7
-- Name: thm_get_theme_capacites(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION thm_get_theme_capacites(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select c.id,c.libelle from v2.capacite c,
	v2.af_get_categorie_elements_theme(10,$1) tc 
	where c.id=tc
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_theme_capacites(integer) OWNER TO pgsql;

--
-- TOC entry 9456 (class 0 OID 0)
-- Dependencies: 655
-- Name: FUNCTION thm_get_theme_capacites(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION thm_get_theme_capacites(integer) IS 'retourne les capacite pour un theme';


--
-- TOC entry 656 (class 1255 OID 2597336)
-- Dependencies: 2983 7
-- Name: thm_get_theme_capacites_titres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION thm_get_theme_capacites_titres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select c.id,c.libelle from v2.capacite_titre c,
	v2.af_get_categorie_elements_theme(11,$1) tc 
	where c.id=tc
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_theme_capacites_titres(integer) OWNER TO pgsql;

--
-- TOC entry 9457 (class 0 OID 0)
-- Dependencies: 656
-- Name: FUNCTION thm_get_theme_capacites_titres(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION thm_get_theme_capacites_titres(integer) IS 'retourne les titres de capacite pour un theme';


--
-- TOC entry 657 (class 1255 OID 2597337)
-- Dependencies: 2983 7
-- Name: thm_get_theme_categories(integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_theme_categories(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT DISTINCT C_id, C_libelle, C_table_cible, C_gestionnaire_contenu, C_code FROM v2.af_get_categories() AS (C_id int4, C_libelle varchar, C_table_cible varchar, C_gestionnaire_contenu bool, C_code varchar), v2.theme_categories TC
		WHERE TC.theme=$1
		AND TC.categorie=C_id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_theme_categories(integer) OWNER TO postgres;

--
-- TOC entry 9458 (class 0 OID 0)
-- Dependencies: 657
-- Name: FUNCTION thm_get_theme_categories(integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_theme_categories(integer) IS 'Obtenir les categories qui ont des ÃƒÂ©lÃƒÂ©ments dans un theme.';


--
-- TOC entry 658 (class 1255 OID 2597338)
-- Dependencies: 2983 7
-- Name: thm_get_theme_elements(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION thm_get_theme_elements(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT A_id,A_categorie FROM v2.af_get_theme_elements_all($1) AS (A_id int4, A_categorie int4, theme int4)	,
		v2.fichier_type T
		WHERE A_categorie NOT IN (SELECT categorie FROM v2.fichier_type WHERE categorie IS NOT NULL)
		UNION
		SELECT A_id,A_categorie FROM v2.af_get_theme_elements_all($1) AS (A_id int4, A_categorie int4, theme int4)	,
		v2.fichier_type T, v2.fichier F
		WHERE T.id=F.type
		AND F.connecte=TRUE
		AND A_categorie=T.categorie
		AND A_id=F.id
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
	
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_theme_elements(integer) OWNER TO pgsql;

--
-- TOC entry 9459 (class 0 OID 0)
-- Dependencies: 658
-- Name: FUNCTION thm_get_theme_elements(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION thm_get_theme_elements(integer) IS 'Obtenir les ÃƒÂ©lÃƒÂ©ments (et leur categorie) d''un theme.';


--
-- TOC entry 659 (class 1255 OID 2597339)
-- Dependencies: 2983 7
-- Name: thm_get_theme_elements_all(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION thm_get_theme_elements_all(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;

BEGIN

	FOR rec IN
		SELECT id, categorie, theme FROM v2.theme_categories 
		WHERE theme=$1 ORDER BY categorie
	LOOP
		RETURN NEXT rec;
	END LOOP;


	RETURN;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_theme_elements_all(integer) OWNER TO pgsql;

--
-- TOC entry 9460 (class 0 OID 0)
-- Dependencies: 659
-- Name: FUNCTION thm_get_theme_elements_all(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION thm_get_theme_elements_all(integer) IS 'FONCTION PRIVEE:
Retourne tous les ÃƒÆ’Ã‚Â©lÃƒÆ’Ã‚Â©ments d''un theme, y compris les fichiers non connectÃƒÆ’Ã‚Â©s';


--
-- TOC entry 660 (class 1255 OID 2597340)
-- Dependencies: 2983 7
-- Name: thm_get_themes(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_get_themes() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
	--pour la conversion du int4 en varchar, on utilise un masque de 9999999999 car les valeurs d'un int4
	--vont de -2147483648 ÃƒÆ’Ã‚  +2147483647, il faut ensuite supprimer les blancs du dÃƒÆ’Ã‚Â©but de la chaine du aux '9' inutiles par rapport aux
	--nombres de chiffres rÃƒÆ’Ã‚Â©els du nombre 
		SELECT id, libelle, trim(leading ' ' from (CAST(to_char(id, '9999999999') AS varchar))) FROM v2.theme ORDER BY libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_get_themes() OWNER TO postgres;

--
-- TOC entry 9461 (class 0 OID 0)
-- Dependencies: 660
-- Name: FUNCTION thm_get_themes(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_get_themes() IS 'Obtenir tous les themes de la plate-forme';


--
-- TOC entry 661 (class 1255 OID 2597341)
-- Dependencies: 2983 7
-- Name: thm_maj_categorie(integer, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_maj_categorie(integer, character varying, boolean) RETURNS boolean
    AS $_$--$1 identifiant de la categorie
--$2 libellÃƒÆ’Ã‚Â© de la catÃƒÆ’Ã‚Â©gorie
--$3 aparait dans le gestionnaire de contenus
BEGIN
	
	UPDATE v2.categorie SET libelle=$2, gestionnaire_contenu=$3 WHERE id=$1;

	RETURN FOUND;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_maj_categorie(integer, character varying, boolean) OWNER TO postgres;

--
-- TOC entry 9462 (class 0 OID 0)
-- Dependencies: 661
-- Name: FUNCTION thm_maj_categorie(integer, character varying, boolean); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_maj_categorie(integer, character varying, boolean) IS 'Mise a jour d''une categorie.';


--
-- TOC entry 662 (class 1255 OID 2597342)
-- Dependencies: 2983 7
-- Name: thm_maj_theme(integer, character varying); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_maj_theme(integer, character varying) RETURNS boolean
    AS $_$BEGIN
	
	UPDATE v2.theme SET libelle=$2 WHERE id=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_maj_theme(integer, character varying) OWNER TO postgres;

--
-- TOC entry 9463 (class 0 OID 0)
-- Dependencies: 662
-- Name: FUNCTION thm_maj_theme(integer, character varying); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_maj_theme(integer, character varying) IS 'Mise a jour d''un theme.';


--
-- TOC entry 663 (class 1255 OID 2597343)
-- Dependencies: 2983 7
-- Name: thm_set_categorie(character varying, character varying, boolean); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_set_categorie(character varying, character varying, boolean) RETURNS integer
    AS $_$--$1 libÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©llÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© de la nouvelle catÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©gorie
--$2 nom de la table associÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â© ou NULL si repertoire
--$3 TRUE si la catÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©gorie doit apparaitre dans le gestionaire de contenu, FALSE sinon.
DECLARE
--identifiant de la nouvelle catÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚Â©gorie
new_id int4;
res int4;
--requete de creation de la table associee ÃƒÆ’Ã‚Æ’Ãƒâ€šÃ‚  la categorie
req_create text;
BEGIN
	--INSERE LA NOUVELLE CATEGORIE
	INSERT INTO v2.categorie (libelle, table_cible, gestionnaire_contenu) VALUES ($1,$2,$3); 
	--RECUPERE L'IDENTIFIANT DE LA NOUVELLE CATEGORIE
	GET DIAGNOSTICS new_id = RESULT_OID;

	IF ($2 IS NOT NULL) THEN
		--CREE LA TABLE PERMETTANT DE GERER LES CONTRAINTES SUR LE CHAMP ID DE LA TABLE THEME_CATEGORIES
		req_create:='CREATE TABLE v2.categorie_'|| $2  ||'
		(
		  id int4 NOT NULL,
		  categorie int4 NOT NULL,
		  theme int4 NOT NULL,
		  CONSTRAINT pk_categorie_'|| $2 ||' PRIMARY KEY (id),
		  CONSTRAINT fk_categorie_'|| $2 ||'_1 FOREIGN KEY (id, categorie, theme) REFERENCES v2.theme_categories (id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE,
		  CONSTRAINT fk_categorie_'|| $2 ||'_2 FOREIGN KEY (id) REFERENCES v2.'|| $2 ||' (id) ON UPDATE RESTRICT ON DELETE CASCADE
		) 
		WITH OIDS;
		ALTER TABLE v2.categorie_'|| $2 ||' OWNER TO postgres;
		GRANT ALL ON TABLE v2.categorie_'|| $2 ||' TO "www-grp";
		CREATE TRIGGER del_theme_categorie
		AFTER DELETE
		ON v2.categorie_'|| $2 ||'
		FOR EACH ROW
		EXECUTE PROCEDURE v2.del_theme_categorie();';
		EXECUTE req_create;
	END IF;
	select into res id from v2.categorie where oid=new_id;
	RETURN res;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_set_categorie(character varying, character varying, boolean) OWNER TO postgres;

--
-- TOC entry 9464 (class 0 OID 0)
-- Dependencies: 663
-- Name: FUNCTION thm_set_categorie(character varying, character varying, boolean); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_set_categorie(character varying, character varying, boolean) IS 'Fonction qui crÃƒÆ’Ã‚Â©ee une nouvelle catÃƒÆ’Ã‚Â©gorie. 
Un enregistrement est ajoutÃƒÆ’Ã‚Â© dans la table categorie et une table nommÃƒÆ’Ã‚Â©e categorie_nomtable est crÃƒÆ’Ã‚Â©e, avec les contraintes requises.

Param1:
Libelle de la catÃƒÆ’Ã‚Â©gorie

Param2:
Nom de la table ciblÃƒÆ’Ã‚Â©e par la catÃƒÆ’Ã‚Â©gorie, NULL si pas de table.

Param3:
TRUE si la catÃƒÆ’Ã‚Â©gorie doit etre visible dans le gestionnaire de contenu, false sinon.

Retourne: le numero de la nouvelle ligne insÃƒÆ’Ã‚Â©rÃƒÆ’Ã‚Â©e dans la table catÃƒÆ’Ã‚Â©gorie.

exemple d''appel:
select  v2.af_set_categorie(varchar ''Positionnement'', varchar ''positionnement'' , FALSE);';


--
-- TOC entry 664 (class 1255 OID 2597344)
-- Dependencies: 2983 7
-- Name: thm_set_categorie_element_theme(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_set_categorie_element_theme(integer, integer, integer) RETURNS boolean
    AS $_$declare
val_theme alias for $2;
val_categorie alias for $1;
val_id alias for $3;
table_fic varchar;
req varchar;
begin

	--RAISE NOTICE 'theme= % categorie=% id=%',val_theme,val_categorie,val_id;
	--recupere la table de sa categorie
	SELECT INTO table_fic table_cible FROM v2.categorie 
	WHERE id=val_categorie;

	--insert dans la table principale
	insert into v2.theme_categories(theme,categorie,id) values(val_theme,val_categorie,val_id);

	--insert dans la table de la categorie
	req:='INSERT INTO v2.categorie_'||table_fic||'(id, categorie, theme) VALUES ('||val_id||','||val_categorie||','||val_theme||')';
	EXECUTE req;

	return FOUND;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_set_categorie_element_theme(integer, integer, integer) OWNER TO postgres;

--
-- TOC entry 9465 (class 0 OID 0)
-- Dependencies: 664
-- Name: FUNCTION thm_set_categorie_element_theme(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_set_categorie_element_theme(integer, integer, integer) IS 'association theme/categorie/element';


--
-- TOC entry 665 (class 1255 OID 2597345)
-- Dependencies: 2983 7
-- Name: thm_set_categories_elements_theme(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION thm_set_categories_elements_theme(integer) RETURNS void
    AS $_$DECLARE
--$1 le theme
rec RECORD;
req1 varchar;
req2 varchar;
BEGIN

	FOR rec IN 
		SELECT id, table_cible
		FROM v2.categorie WHERE --table_cible NOT IN
		--(SELECT table_etape FROM v2.categorie WHERE table_etape IS NOT NULL)
		--AND 
		id !=28 AND id!=29 AND id!=43
		ORDER BY id
	LOOP
		req1:='INSERT INTO v2.theme_categories
		(id, categorie, theme) SELECT id,'||rec.id||','||$1||
		' FROM v2.'||rec.table_cible||'';
		EXECUTE req1;

		req2:='INSERT INTO v2.categorie_'||rec.table_cible||'
		(id, categorie, theme) SELECT id,'||rec.id||','||$1||
		' FROM v2.'||rec.table_cible||'';
		EXECUTE req2;
		RAISE NOTICE 'CATEGORIE %: ajoutee AU theme %',rec.id,$1;
	END LOOP;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_set_categories_elements_theme(integer) OWNER TO pgsql;

--
-- TOC entry 666 (class 1255 OID 2597346)
-- Dependencies: 2983 7
-- Name: thm_set_theme(character varying); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION thm_set_theme(character varying) RETURNS integer
    AS $_$DECLARE
new_id int4;
res int4;
BEGIN
	
	insert into v2.theme(libelle) VALUES($1);

	--RECUPERE L'IDENTIFIANT DU NOUVEAU THEME
	GET DIAGNOSTICS new_id = RESULT_OID;

	select into res id from v2.theme where oid=new_id;
	return res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.thm_set_theme(character varying) OWNER TO postgres;

--
-- TOC entry 9466 (class 0 OID 0)
-- Dependencies: 666
-- Name: FUNCTION thm_set_theme(character varying); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION thm_set_theme(character varying) IS 'CrÃƒÆ’Ã‚Â©er un nouveau theme';


--
-- TOC entry 667 (class 1255 OID 2597347)
-- Dependencies: 2983 7
-- Name: tp_del_etape(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_del_etape(integer) RETURNS boolean
    AS $_$begin
    delete from v2.etape where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_del_etape(integer) OWNER TO pgsql;

--
-- TOC entry 9467 (class 0 OID 0)
-- Dependencies: 667
-- Name: FUNCTION tp_del_etape(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_del_etape(integer) IS 'supprime une etape';


--
-- TOC entry 668 (class 1255 OID 2597348)
-- Dependencies: 2983 7
-- Name: tp_del_etape_resultat_individu(integer, integer, integer[], integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_del_etape_resultat_individu(integer, integer, integer[], integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : tableau d'etapes
-- $4 : parcours
declare
i integer;
begin
    for i in array_lower($3,1)..array_upper($3,1)
    loop
	delete from v2.resultat where formation=$1 and stagiaire=$2 and etape=$3[i] and parcours=$4;
	-- si etape serie aleatoire (# mode 1) alors supprimer dans serie_aleatoire_evaluations A Suivre ....
    end loop;
    return true;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_del_etape_resultat_individu(integer, integer, integer[], integer) OWNER TO pgsql;

--
-- TOC entry 9468 (class 0 OID 0)
-- Dependencies: 668
-- Name: FUNCTION tp_del_etape_resultat_individu(integer, integer, integer[], integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_del_etape_resultat_individu(integer, integer, integer[], integer) IS 'raz des resultat des etapes pour un individu (une formation)';


--
-- TOC entry 669 (class 1255 OID 2597349)
-- Dependencies: 2983 7
-- Name: tp_del_etape_resultat_tentative_individu(integer, integer, integer[], integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : tableau d'etapes
-- $4 : parcours
declare
i integer;
begin
    for i in array_lower($3,1)..array_upper($3,1)
    loop
	delete from v2.resultat_tentative where formation=$1 and stagiaire=$2 and etape=$3[i] and parcours=$4;
    end loop;
    return true;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) OWNER TO pgsql;

--
-- TOC entry 9469 (class 0 OID 0)
-- Dependencies: 669
-- Name: FUNCTION tp_del_etape_resultat_tentative_individu(integer, integer, integer[], integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) IS 'raz des resultats (tentative) des etapes pour un individu (une formation)';


--
-- TOC entry 670 (class 1255 OID 2597350)
-- Dependencies: 2983 7
-- Name: tp_del_formation_resultat_individu(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_del_formation_resultat_individu(integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : individu

begin
    delete from v2.resultat where formation=$1 and stagiaire=$2;
    delete from v2.resultat_tentative where formation=$1 and stagiaire=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_del_formation_resultat_individu(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9470 (class 0 OID 0)
-- Dependencies: 670
-- Name: FUNCTION tp_del_formation_resultat_individu(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_del_formation_resultat_individu(integer, integer) IS 'raz parcours d''un individu (pour une formation)';


--
-- TOC entry 671 (class 1255 OID 2597351)
-- Dependencies: 2983 7
-- Name: tp_del_parcours_etape(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_del_parcours_etape(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 parcours
--$2 etape
res int4;
type_etape int4;
BEGIN
	SELECT INTO res * FROM v2.af_gen_del_element('v2.parcours_etapes','etape',$2,'AND parcours='||$1);
	
	--traitement particulier pour les etapes titres: on les supprimme systematiquement
	SELECT INTO type_etape type FROM v2.af_get_etape($2) AS (id int4, libelle varchar, type int4,date_creation timestamp);
	IF type_etape=9 THEN
		PERFORM v2.af_del_etape($2);
	END IF;

	RETURN res>0;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_del_parcours_etape(integer, integer) OWNER TO pgsql;

--
-- TOC entry 672 (class 1255 OID 2597352)
-- Dependencies: 2983 7
-- Name: tp_get_etape(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_get_etape(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec id, libelle, "type", date_creation FROM v2.etape
	WHERE id=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_get_etape(integer) OWNER TO pgsql;

--
-- TOC entry 9471 (class 0 OID 0)
-- Dependencies: 672
-- Name: FUNCTION tp_get_etape(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_get_etape(integer) IS 'Obtenir les informations d''une etape.';


--
-- TOC entry 673 (class 1255 OID 2597353)
-- Dependencies: 2983 7
-- Name: tp_get_etape_classes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_get_etape_classes(integer) RETURNS SETOF record
    AS $_$DECLARE
rec1 RECORD;
rec2 RECORD;
BEGIN
	FOR rec1 IN
		--on selectionne les parcours de l'ÃƒÂ©tape
		SELECT id
		FROM v2.af_get_etape_parcourss($1) AS (id int4, libelle varchar, filiere int4, duree bool, etape int, date_creation timestamp) 

	LOOP
		raise notice 'etape % parcours % trouvÃƒÂ©', $1, rec1.id;
		--pour chacun des parcours, on recupere ses formations et leurs classes
		FOR rec2 IN
			SELECT DISTINCT id ,libelle ,pere ,min ,max ,  rec1.id AS parcours
			FROM v2.af_get_parcours_formations(rec1.id)  AS (P_id int4, P_libelle varchar, P_parcours int4, P_date_debut date, P_date_fin date, P_langue_defaut int4),
			v2.af_get_formations_classes() AS (id int4,libelle varchar,pere int4,min int4,max int4, formation int4)
			WHERE formation=P_id
		LOOP
			raise notice 'la';
			RETURN NEXT rec2;
		END LOOP;
	END LOOP;
	
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_get_etape_classes(integer) OWNER TO pgsql;

--
-- TOC entry 674 (class 1255 OID 2597354)
-- Dependencies: 2983 7
-- Name: tp_get_etape_filieres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_get_etape_filieres(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT F_id, F_libelle, F_pere, id
		FROM v2.af_get_etape_parcourss($1) AS (id int4,libelle varchar, filiere int4, duree bool, etape int4, date_creation timestamp)
		LEFT OUTER JOIN 
		v2.af_get_filieres() AS (F_id int4, F_libelle varchar, F_pere int4, niveau int4)
		ON (filiere=F_id)
		ORDER BY F_libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_get_etape_filieres(integer) OWNER TO pgsql;

--
-- TOC entry 675 (class 1255 OID 2597355)
-- Dependencies: 2983 7
-- Name: tp_get_etape_formations(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_get_etape_formations(integer) RETURNS SETOF record
    AS $_$DECLARE
rec1 RECORD;
rec2 RECORD;
BEGIN
	FOR rec1 IN
		--on selectionne les parcours de l'ÃƒÂ©tape
		SELECT id
		FROM v2.af_get_etape_parcourss($1) AS (id int4, libelle varchar, filiere int4, duree bool, etape int, date_creation timestamp) 

	LOOP
		--pour chacun des parcours, on recupere ses formations
		FOR rec2 IN
			SELECT  *
			FROM v2.af_get_parcours_formations(rec1.id)  AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4)
			ORDER BY libelle
		LOOP
			RETURN NEXT rec2;
		END LOOP;
	END LOOP;
	
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_get_etape_formations(integer) OWNER TO pgsql;

--
-- TOC entry 676 (class 1255 OID 2597356)
-- Dependencies: 2983 7
-- Name: tp_get_etape_formations_classe(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_get_etape_formations_classe(integer, integer) RETURNS SETOF record
    AS $_$DECLARE
rec1 RECORD;
rec2 RECORD;
BEGIN
	FOR rec1 IN
		--on selectionne les parcours de l'ÃƒÂ©tape
		SELECT id
		FROM v2.af_get_etape_parcourss($1) AS (id int4, libelle varchar, filiere int4, duree bool, etape int, date_creation timestamp) 

	LOOP
		--pour chacun des parcours, on recupere ses formations
		FOR rec2 IN
			SELECT  id , libelle , parcours , date_debut , date_fin , langue_defaut , classe
			FROM v2.af_get_parcours_formations(rec1.id)  AS (id int4, libelle varchar, parcours int4, date_debut date, date_fin date, langue_defaut int4),
			v2.formation_participants
			WHERE classe=$2 
			AND id=formation
		LOOP
			RETURN NEXT rec2;
		END LOOP;
	END LOOP;
	
	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_get_etape_formations_classe(integer, integer) OWNER TO pgsql;

--
-- TOC entry 677 (class 1255 OID 2597357)
-- Dependencies: 2983 7
-- Name: tp_get_etape_resultats(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_get_etape_resultats(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, formation, stagiaire, parcours,  etape, date_debut, duree
		FROM v2.resultat
		WHERE etape=$1
	LOOP 
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_get_etape_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 678 (class 1255 OID 2597358)
-- Dependencies: 2159 2983 7
-- Name: tp_get_etape_type_sous_type(integer, integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_get_etape_type_sous_type(integer, integer, character varying) RETURNS type_element
    AS $_$DECLARE
--$1 identifiant d'etape
--$2 type d'etape
--$3 libelle du type d'etape
rec_spe_1 RECORD;
serie_aleatoire bool;
retour v2.type_element;
retour_serie v2.type_element;
BEGIN

--AFFECTE LE TYPE ETAPE (ORIGINAL)
retour.id:=$2;
retour.libelle:=$3;

--type liste
IF $2=4 THEN
	SELECT INTO rec_spe_1 libelle, L_type AS type
	FROM v2.af_get_liste($1) AS  (L_id int4,L_libelle varchar, L_type int4, date_creation timestamp),
	v2.liste_type T
	WHERE L_type=T.id;
	
	--AFFECTE LE TYPE LISTE
	retour.id:=retour.id||'_'||rec_spe_1.type;
	retour.libelle:=rec_spe_1.libelle;

	--type serie
	IF rec_spe_1.type=1 THEN

		--serie alÃƒÂ©atoire ?
		SELECT INTO serie_aleatoire * FROM v2.af_is_serie_aleatoire($1);		
		IF serie_aleatoire THEN
			SELECT INTO retour_serie * FROM v2.af_get_serie_aleatoire_type($1);
			--si la serie est mono evaluation on l'indique, sinon on laisse le sous type tel quel
			IF retour_serie.id IS NOT NULL THEN
				--AFFECTE LE TYPE (D'EVALUATION)DE SERIE
				retour.libelle:='''   - ''.'||retour_serie.libelle;
				retour.id:=retour.id||'_'||retour_serie.id;
			END IF;
		ELSE
			SELECT INTO retour_serie * FROM v2.af_get_serie_simple_type($1);
			--si la serie est mono evaluation on l'indique, sinon on laisse le sous type tel quel
			IF retour_serie.id IS NOT NULL THEN
				--AFFECTE LE TYPE (D'EVALUATION)DE SERIE
				retour.libelle:='''   - ''.'||retour.libelle||'.'' (''.'||retour_serie.libelle||'.'')''';
				retour.id:=retour.id||'_0_'||retour_serie.id;
			END IF;
		END IF;
	--type test
	ELSE
		retour.libelle:=rec_spe_1.libelle;
	END IF;
END IF;

RETURN retour;

END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_get_etape_type_sous_type(integer, integer, character varying) OWNER TO pgsql;

--
-- TOC entry 679 (class 1255 OID 2597359)
-- Dependencies: 2983 7
-- Name: tp_get_etapes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_get_etapes() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT id, libelle, "type",date_creation  FROM v2.etape
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_get_etapes() OWNER TO pgsql;

--
-- TOC entry 680 (class 1255 OID 2597360)
-- Dependencies: 2983 7
-- Name: tp_get_parcours_etape(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_get_parcours_etape(integer, integer) RETURNS record
    AS $_$DECLARE
--$1 parcours
--$2 etape
rec RECORD;
BEGIN
	SELECT INTO rec PE.etape, E.libelle, E.libelle, PE.libelle_type_etape, CAST(E.type AS varchar),  PE.pere, PE.parcours, PE.obligatoire, PE.chrono, PE.fin, T.libelle 
	FROM v2.parcours_etapes PE, v2.etape E, v2.etape_type T
	WHERE PE.etape=$2 AND PE.etape=E.id
	AND E.type=T.id
	AND PE.parcours=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_get_parcours_etape(integer, integer) OWNER TO pgsql;

--
-- TOC entry 681 (class 1255 OID 2597361)
-- Dependencies: 2983 7
-- Name: tp_maj_commentaire(integer, integer, integer, character varying, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_maj_commentaire(integer, integer, integer, character varying, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero etape
-- $2 : min
-- $3 : max
-- $4 : commentaire
-- $5 : old min
-- $6 : old max
begin
    update v2.commentaire_etape 
    set min=$2,max=$3,commentaire=$4 
    where etape=$1 and min=$5 and max=$6;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_maj_commentaire(integer, integer, integer, character varying, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9472 (class 0 OID 0)
-- Dependencies: 681
-- Name: FUNCTION tp_maj_commentaire(integer, integer, integer, character varying, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_maj_commentaire(integer, integer, integer, character varying, integer, integer) IS 'mettre Ãƒ  jour un commentaire';


--
-- TOC entry 682 (class 1255 OID 2597362)
-- Dependencies: 2983 7
-- Name: tp_maj_etape_libelle(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_maj_etape_libelle(integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 etape
--$2 libelle de l'etape
BEGIN

	UPDATE v2.etape SET libelle=$2 WHERE id=$1;
	--RAISE NOTICE 'met a jour l''ÃƒÆ’Ã‚Â©tape % avec %',$1,$2;
	
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_maj_etape_libelle(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9473 (class 0 OID 0)
-- Dependencies: 682
-- Name: FUNCTION tp_maj_etape_libelle(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_maj_etape_libelle(integer, character varying) IS 'Mise a jour du libellÃƒÂ© d''une ÃƒÂ©tape.';


--
-- TOC entry 683 (class 1255 OID 2597363)
-- Dependencies: 2983 7
-- Name: tp_maj_etapes_libelles(integer[], character varying[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_maj_etapes_libelles(integer[], character varying[]) RETURNS integer
    AS $_$DECLARE
i integer;

BEGIN

	FOR i IN array_lower($1, 1) .. array_upper($1, 1) 
	LOOP
		PERFORM * FROM v2.af_maj_etape_libelle($1[i],$2[i]);
	END LOOP; 

	RETURN i;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_maj_etapes_libelles(integer[], character varying[]) OWNER TO pgsql;

--
-- TOC entry 9474 (class 0 OID 0)
-- Dependencies: 683
-- Name: FUNCTION tp_maj_etapes_libelles(integer[], character varying[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_maj_etapes_libelles(integer[], character varying[]) IS 'Mise a jour des libelles d''un ensemble d''ÃƒÂ©tapes.';


--
-- TOC entry 684 (class 1255 OID 2597364)
-- Dependencies: 2983 7
-- Name: tp_set_commentaire(integer, integer, integer, text); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_set_commentaire(integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : numero etape
-- $2 : min
-- $3 : max
-- $4 : commentaire
begin
    insert into v2.commentaire_etape(etape,min,max,commentaire) values($1,$2,$3,$4);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_set_commentaire(integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 9475 (class 0 OID 0)
-- Dependencies: 684
-- Name: FUNCTION tp_set_commentaire(integer, integer, integer, text); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_set_commentaire(integer, integer, integer, text) IS 'enregistre un commentaire';


--
-- TOC entry 685 (class 1255 OID 2597365)
-- Dependencies: 2983 7
-- Name: tp_set_etape(character varying, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION tp_set_etape(character varying, integer) RETURNS integer
    AS $_$declare
	titre alias for $1;
	typ alias for $2;
	new_id int4;
	res int4;
begin
	insert into v2.etape(libelle,type) values($1,$2);
	GET DIAGNOSTICS new_id = RESULT_OID;
	select into res id from v2.etape where oid=new_id;
	
	return res;

	

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_set_etape(character varying, integer) OWNER TO postgres;

--
-- TOC entry 9476 (class 0 OID 0)
-- Dependencies: 685
-- Name: FUNCTION tp_set_etape(character varying, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION tp_set_etape(character varying, integer) IS 'crÃƒÆ’Ã‚Â©e une etape';


--
-- TOC entry 686 (class 1255 OID 2597366)
-- Dependencies: 2983 7
-- Name: tp_set_page_commentaire(integer, integer, integer, text); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tp_set_page_commentaire(integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : page
-- $2 : formation
-- $3 : stagiaire
-- $4 : commentaire
begin
    -- test si existe
    perform * from v2.page_commentaire where page=$1 and formation=$2 and stagiaire=$3;
    if found then
	update v2.page_commentaire set commentaire=$4
	where page=$1 and formation=$2 and stagiaire=$3;
    else
	insert into v2.page_commentaire (page,formation,stagiaire,commentaire) 
	values($1,$2,$3,$4);
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tp_set_page_commentaire(integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 9477 (class 0 OID 0)
-- Dependencies: 686
-- Name: FUNCTION tp_set_page_commentaire(integer, integer, integer, text); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION tp_set_page_commentaire(integer, integer, integer, text) IS 'Enregistre le commentaire pour une page';


--
-- TOC entry 687 (class 1255 OID 2597367)
-- Dependencies: 2983 7
-- Name: tst_del_test_positionnement(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_del_test_positionnement(integer, integer) RETURNS boolean
    AS $_$DECLARE
--$1 test
--$2 positionnement
BEGIN
	PERFORM * FROM v2.af_gen_del_element('v2.test_positionnements', 'positionnement', $2, ' AND test='||$1);
	RETURN FOUND;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_del_test_positionnement(integer, integer) OWNER TO pgsql;

--
-- TOC entry 688 (class 1255 OID 2597368)
-- Dependencies: 2983 7
-- Name: tst_del_tests(integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_del_tests(integer[]) RETURNS integer
    AS $_$DECLARE
---$1 tests
i int4;
nb int4:=0;
BEGIN

	FOR i IN array_lower($1, 1) .. array_upper($1, 1) 
	LOOP
		nb:=nb+1;
		DELETE FROM v2.test WHERE id=$1[i];
	END LOOP; 

	raise notice 'nb supprime= %',nb;
	RETURN nb;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_del_tests(integer[]) OWNER TO pgsql;

--
-- TOC entry 689 (class 1255 OID 2597369)
-- Dependencies: 2983 7
-- Name: tst_get_positionnement_tests(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_get_positionnement_tests(integer) RETURNS SETOF record
    AS $_$DECLARE
--$1 positionnement
rec RECORD;
BEGIN
	FOR rec IN

		SELECT DISTINCT E_id, E_libelle,  E_dynamique, E_continu, media , hauteur_media , largeur_media, date_creation   FROM v2.test_positionnements P,
		v2.af_get_tests() AS (E_id int4, E_libelle varchar,  E_dynamique bool, E_continu bool, media int4, hauteur_media int4, largeur_media int4, date_creation timestamp)
		WHERE E_id=P.test
		AND P.positionnement=$1
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_get_positionnement_tests(integer) OWNER TO pgsql;

--
-- TOC entry 690 (class 1255 OID 2597370)
-- Dependencies: 2983 7
-- Name: tst_get_test(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_get_test(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN
	SELECT INTO rec * FROM v2.af_get_tests() AS (id int4, libelle varchar, dynamique bool, continu bool, media int4, hauteur_media int4, largeur_media int4,date_creation timestamp)
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_get_test(integer) OWNER TO pgsql;

--
-- TOC entry 691 (class 1255 OID 2597371)
-- Dependencies: 2983 7
-- Name: tst_get_test_last_positionnement(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_get_test_last_positionnement(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du test
id int4;
BEGIN
	SELECT INTO id * FROM v2.af_gen_get_last_element('v2.test_positionnements', 'positionnement', ' AND test='||$1);
	RETURN id;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_get_test_last_positionnement(integer) OWNER TO pgsql;

--
-- TOC entry 692 (class 1255 OID 2597372)
-- Dependencies: 2983 7
-- Name: tst_get_test_parcours(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_get_test_parcours(integer) RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT P_id, P_libelle, P_filiere, P_duree, P_date_creation  FROM v2.af_get_parcours() AS (P_id int4, P_libelle varchar, P_filiere int4, P_duree bool, P_date_creation timestamp),
		v2.parcours_etapes E
		WHERE E.parcours=P_id

	LOOP
		RETURN NEXT rec;
	END LOOP;
	
	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_get_test_parcours(integer) OWNER TO pgsql;

--
-- TOC entry 693 (class 1255 OID 2597373)
-- Dependencies: 2983 7
-- Name: tst_get_test_positionnements(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_get_test_positionnements(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT P.test, P.positionnement, P.pere
		FROM v2.af_gen_get_elements('v2.test_positionnements', 'positionnement', NULL, ' AND test='||$1,1) P_id,
		v2.test_positionnements P
		WHERE P_id.id=P.positionnement
		AND P.test=$1
		ORDER BY P_id.ind
		
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_get_test_positionnements(integer) OWNER TO pgsql;

--
-- TOC entry 694 (class 1255 OID 2597374)
-- Dependencies: 2983 7
-- Name: tst_get_test_positionnements_disponibles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_get_test_positionnements_disponibles(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT * FROM v2.af_get_positionnements() AS (id int4, libelle varchar, type_question int4, chrono int4, serie_aleatoire int4, bareme int4, chrono_gen int4)
		WHERE id NOT IN (
			SELECT DISTINCT positionnement 
			FROM v2.af_get_test_positionnements($1) AS (test int4, positionnement int4, pere int4)
				)
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_get_test_positionnements_disponibles(integer) OWNER TO pgsql;

--
-- TOC entry 695 (class 1255 OID 2597375)
-- Dependencies: 2983 7
-- Name: tst_get_test_positionnements_infos(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_get_test_positionnements_infos(integer) RETURNS SETOF record
    AS $_$DECLARE
rec RECORD;
BEGIN
	FOR rec IN
		SELECT PO.id, PO.libelle, PO.type_question, PO.chrono, PO.serie_aleatoire, PO.question_reponse, $1
		FROM v2.af_gen_get_elements('v2.test_positionnements', 'positionnement', NULL, ' AND test='||$1,1) P_id,
		v2.test_positionnements P, v2.positionnement PO
		WHERE P_id.id=P.positionnement
		AND P.test=$1
		AND P_id.id=PO.id
		ORDER BY P_id.ind
		
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_get_test_positionnements_infos(integer) OWNER TO pgsql;

--
-- TOC entry 696 (class 1255 OID 2597376)
-- Dependencies: 2983 7
-- Name: tst_get_test_somme_chronos(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_get_test_somme_chronos(integer) RETURNS integer
    AS $_$DECLARE
--$1 serie
somme int4;
BEGIN
	SELECT INTO somme SUM(chrono)
	FROM v2.af_get_test_positionnements_infos($1) AS  ( id int4, libelle varchar, type  int4, chrono  int4, serie_aleatoire int4, question_reponse int4, test int4 );

	RETURN somme;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_get_test_somme_chronos(integer) OWNER TO pgsql;

--
-- TOC entry 697 (class 1255 OID 2597377)
-- Dependencies: 2983 7
-- Name: tst_get_tests(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_get_tests() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT E_id , E_libelle,  T.dynamique, T.continu,  M.media, M.hauteur , M.largeur,date_creation  
		FROM (
			( v2.af_get_etapes() AS (E_id int4, E_libelle varchar, E_type int4,date_creation timestamp) INNER JOIN  v2.test T  ON  E_id=T.id )
			LEFT OUTER JOIN v2.media_test M ON T.id=M.test
		     )
		ORDER BY E_libelle
	LOOP
		RETURN NEXT rec;
	END LOOP;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_get_tests() OWNER TO pgsql;

--
-- TOC entry 698 (class 1255 OID 2597378)
-- Dependencies: 2983 7
-- Name: tst_maj_test(integer, character varying, boolean, boolean, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_maj_test(integer, character varying, boolean, boolean, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
id_positionnement int4;
id_test int4;
oid_id int4;
BEGIN 
 ---a continuer!!
/*	INSERT INTO v2.etape(libelle, type) VALUES ($1, 4);
	GET DIAGNOSTICS new_id = RESULT_OID;
	
	SELECT INTO res id FROM v2.etape WHERE oid=new_id;
	
	INSERT INTO v2.liste (id, type) VALUES (res, $4);
	
	INSERT INTO v2.serie(id, bareme, chrono) VALUES (res, $2, $3);
	RETURN res;;

	SELECT INTO id_positionnement * FROM v2.af_set_positionnement($1,$2,$3,$4,$5,$6);
	
	INSERT INTO v2.positionnement 
	(libelle, type_question, chrono)
	VALUES ($1, $2, $6);

	GET DIAGNOSTICS oid_id = RESULT_OID;

	SELECT INTO id id FROM v2.positionnement WHERE oid=oid_id;

	INSERT INTO v2.media_positionnement 
	(positionnement, media, hauteur, largeur)
	VALUES ($3, $4, $5);


	RETURN id;*/
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_maj_test(integer, character varying, boolean, boolean, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 699 (class 1255 OID 2597379)
-- Dependencies: 2983 7
-- Name: tst_set_test(character varying, boolean, boolean, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION tst_set_test(character varying, boolean, boolean, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
--$1 libelle
--$2 dynamique
--$3 continu
--$4 media
--$5 hauteur
--$6 largeur
res int4;
new_id int4;
BEGIN 
	INSERT INTO v2.etape(libelle, type) VALUES ($1, 4);
	GET DIAGNOSTICS new_id = RESULT_OID;
	
	SELECT INTO res id FROM v2.etape WHERE oid=new_id;
	
	INSERT INTO v2.liste (id, type) VALUES (res, 3);
	
	INSERT INTO v2.test(id, dynamique, continu) VALUES (res, $2, $3);

	IF $4 IS NOT NULL THEN
		INSERT INTO v2.media_test
		(test, media, hauteur, largeur)
		VALUES (res,$4, $5, $6);
	END IF;

	RETURN res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.tst_set_test(character varying, boolean, boolean, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 700 (class 1255 OID 2597380)
-- Dependencies: 2983 7
-- Name: update_serie_aleatoire_multitheme_categorie_serie(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION update_serie_aleatoire_multitheme_categorie_serie() RETURNS "trigger"
    AS $$begin
	update v2.categorie_serie 
	set theme=new.theme_source 
	where id=new.id and theme=old.theme_source;
	return new;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.update_serie_aleatoire_multitheme_categorie_serie() OWNER TO pgsql;

--
-- TOC entry 9478 (class 0 OID 0)
-- Dependencies: 700
-- Name: FUNCTION update_serie_aleatoire_multitheme_categorie_serie(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION update_serie_aleatoire_multitheme_categorie_serie() IS 'met Ã  jour un enregistrement de la table categorie_serie';


--
-- TOC entry 701 (class 1255 OID 2597381)
-- Dependencies: 2983 7
-- Name: vltn_del_bareme(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_del_bareme(integer) RETURNS boolean
    AS $_$-- $1 : numero bareme
begin
    delete from v2.bareme where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_del_bareme(integer) OWNER TO pgsql;

--
-- TOC entry 9479 (class 0 OID 0)
-- Dependencies: 701
-- Name: FUNCTION vltn_del_bareme(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_del_bareme(integer) IS 'supprime un bareme';


--
-- TOC entry 702 (class 1255 OID 2597382)
-- Dependencies: 2983 7
-- Name: vltn_del_commentaire(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_del_commentaire(integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero etape
-- $2 : min
-- $3 : max
begin
    delete from v2.commentaire_etape 
    where etape=$1 and min=$2 and max=$3;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_del_commentaire(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9480 (class 0 OID 0)
-- Dependencies: 702
-- Name: FUNCTION vltn_del_commentaire(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_del_commentaire(integer, integer, integer) IS 'supprime un commentaire';


--
-- TOC entry 703 (class 1255 OID 2597383)
-- Dependencies: 2983 7
-- Name: vltn_del_evaluation(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_del_evaluation(integer) RETURNS boolean
    AS $_$BEGIN

	DELETE FROM v2.evaluation WHERE  id=$1;

	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_del_evaluation(integer) OWNER TO pgsql;

--
-- TOC entry 9481 (class 0 OID 0)
-- Dependencies: 703
-- Name: FUNCTION vltn_del_evaluation(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_del_evaluation(integer) IS 'Supprime une ÃƒÂ©valuation.';


--
-- TOC entry 704 (class 1255 OID 2597384)
-- Dependencies: 2983 7
-- Name: vltn_del_evaluation_resultat_individu(bigint, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_del_evaluation_resultat_individu(bigint, integer[]) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : tableau d'evaluations
declare
i integer;
begin
    for i in array_lower($2,1)..array_upper($2,1)
    loop
	delete from v2.resultat_serie where id=$1 and evaluation=$2[i] ;
    end loop;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_del_evaluation_resultat_individu(bigint, integer[]) OWNER TO pgsql;

--
-- TOC entry 9482 (class 0 OID 0)
-- Dependencies: 704
-- Name: FUNCTION vltn_del_evaluation_resultat_individu(bigint, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_del_evaluation_resultat_individu(bigint, integer[]) IS 'Supprime des resultats d''evaluation pour un individu';


--
-- TOC entry 705 (class 1255 OID 2597385)
-- Dependencies: 2983 7
-- Name: vltn_del_evaluation_resultat_tentative_individu(bigint, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_del_evaluation_resultat_tentative_individu(bigint, integer[]) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : tableau d'evaluations
declare
i integer;
begin
    for i in array_lower($2,1)..array_upper($2,1)
    loop
	delete from v2.resultat_serie_tentative where id=$1 and evaluation=$2[i] ;
    end loop;
    return true;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_del_evaluation_resultat_tentative_individu(bigint, integer[]) OWNER TO pgsql;

--
-- TOC entry 9483 (class 0 OID 0)
-- Dependencies: 705
-- Name: FUNCTION vltn_del_evaluation_resultat_tentative_individu(bigint, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_del_evaluation_resultat_tentative_individu(bigint, integer[]) IS 'Supprime des resultats tentative d''evaluation pour un individu';


--
-- TOC entry 706 (class 1255 OID 2597386)
-- Dependencies: 2983 7
-- Name: vltn_del_evaluations(integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_del_evaluations(integer[]) RETURNS boolean
    AS $_$DECLARE 
i int4;
ok int4:=0;
BEGIN

	FOR i IN array_lower($1,1)..array_upper($1,1)
	LOOP
		DELETE FROM v2.evaluation WHERE  id=$1[i];
		IF FOUND THEN 
			ok:=ok+1;
		END IF;
	END LOOP;
	RETURN ok=i;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_del_evaluations(integer[]) OWNER TO pgsql;

--
-- TOC entry 9484 (class 0 OID 0)
-- Dependencies: 706
-- Name: FUNCTION vltn_del_evaluations(integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_del_evaluations(integer[]) IS 'Supprime des ÃƒÂ©valuations.';


--
-- TOC entry 707 (class 1255 OID 2597387)
-- Dependencies: 2983 7
-- Name: vltn_get_bareme(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_bareme(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN

	SELECT into rec * FROM v2.af_get_baremes() as (id int4, libelle varchar, juste int4, fausse int4, manquantes int4, toutes int4) 
	WHERE id=$1;

	RETURN rec;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_bareme(integer) OWNER TO pgsql;

--
-- TOC entry 9485 (class 0 OID 0)
-- Dependencies: 707
-- Name: FUNCTION vltn_get_bareme(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_get_bareme(integer) IS 'Obtenir les informations d''un bareme.';


--
-- TOC entry 708 (class 1255 OID 2597388)
-- Dependencies: 2983 7
-- Name: vltn_get_baremes(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_baremes() RETURNS SETOF record
    AS $$DECLARE
rec record;
BEGIN
	FOR  rec IN
		SELECT * FROM v2.bareme
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_baremes() OWNER TO pgsql;

--
-- TOC entry 709 (class 1255 OID 2597389)
-- Dependencies: 2983 7
-- Name: vltn_get_categorie_themes_type_evaluation(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_categorie_themes_type_evaluation(integer, integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
    for rec in
        select distinct ct_id,ct_libelle from v2.af_get_categorie_themes($1) as (ct_id int4,ct_libelle varchar),
	v2.af_get_categorie_elements($1) as (c_id int4,c_theme int4,c_categorie int4),
	v2.evaluation e 
	where e.type=$2 and c_theme=ct_id 
	and e.id=c_id
    loop
	return next rec;
    end loop;
    return;
	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_categorie_themes_type_evaluation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9486 (class 0 OID 0)
-- Dependencies: 709
-- Name: FUNCTION vltn_get_categorie_themes_type_evaluation(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_get_categorie_themes_type_evaluation(integer, integer) IS 'retourne les themes pour une categorie et un type d''evaluation';


--
-- TOC entry 710 (class 1255 OID 2597390)
-- Dependencies: 2983 7
-- Name: vltn_get_commentaire(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_commentaire(integer, integer, integer) RETURNS record
    AS $_$-- $1 : numero etape
-- $2 : min
-- $3 : max
declare
rec record;
begin
    select into rec etape,min,max,commentaire 
    from v2.commentaire_etape 
    where etape=$1 and min=$2 and max=$3;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_commentaire(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9487 (class 0 OID 0)
-- Dependencies: 710
-- Name: FUNCTION vltn_get_commentaire(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_get_commentaire(integer, integer, integer) IS 'retourne un commentaire';


--
-- TOC entry 711 (class 1255 OID 2597391)
-- Dependencies: 2983 7
-- Name: vltn_get_evaluation(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_evaluation(integer) RETURNS record
    AS $_$DECLARE
--$1 identifiant de l'evaluation
rec RECORD;
BEGIN
	SELECT INTO rec id, libelle, type, date_creation
	FROM v2.evaluation
	WHERE id=$1;

	RETURN rec;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_evaluation(integer) OWNER TO pgsql;

--
-- TOC entry 712 (class 1255 OID 2597392)
-- Dependencies: 2983 7
-- Name: vltn_get_evaluation_bareme(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_evaluation_bareme(integer, integer) RETURNS integer
    AS $_$-- $1 : serie
-- $2 : evaluation
declare
rec record;
rec_serie record;
aleatoire boolean;
begin
    -- si serie aleatoire monotheme ou multitheme
/*
    select into aleatoire * from v2.af_is_serie_aleatoire($1);
    if aleatoire is true then
	select into rec * from v2.af_get_serie_aleatoire($1) 
	as (id int4,libelle varchar,bareme int4,chrono int4,type int4,date_creation timestamp);
	
    else
	-- recup bareme de l'evaluation
	select into rec * from v2.af_get_serie_evaluation($1,$2) as (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );    
	if rec.bareme is null then
	    select into rec * from v2.af_get_serie($1) as (id int4, libelle varchar, bareme int4, chrono int4, date_creation timestamp);
	
        end if;
    end if;
*/

    -- recup bareme evaluation

    select into rec * from v2.af_get_serie_evaluation($1,$2) as (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );    
    if rec.bareme is null then
	-- recup bareme serie
	select into rec * from v2.af_get_serie($1) as (id int4, libelle varchar, bareme int4, chrono int4, date_creation timestamp);
	if rec.bareme is null then
	    -- si serie aleatoire monotheme ou multitheme
	    select into aleatoire * from v2.af_is_serie_aleatoire($1);
	    if aleatoire is true then
		select into rec * from v2.af_get_serie_aleatoire($1) 
		as (id int4,libelle varchar,bareme int4,chrono int4,type int4,date_creation timestamp);
	    end if;
	end if;
    end if;

    --raise notice 'bareme=%',rec.bareme;
    return rec.bareme;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_evaluation_bareme(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9488 (class 0 OID 0)
-- Dependencies: 712
-- Name: FUNCTION vltn_get_evaluation_bareme(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_get_evaluation_bareme(integer, integer) IS 'retourne le nÃ‚Â° de bareme d''une evaluation de serie';


--
-- TOC entry 713 (class 1255 OID 2597393)
-- Dependencies: 2983 7
-- Name: vltn_get_evaluation_point(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_evaluation_point(integer, integer) RETURNS integer
    AS $_$-- $1 : serie
-- $2 : evaluation
declare
rec record;
aleatoire boolean;
rec_aleatoire record;
val_type integer;
begin
    val_type:=0;
    -- si serie aleatoire on retourne 1
    select into aleatoire * from v2.af_is_serie_aleatoire($1);
    if aleatoire is true then
	-- recup type aleatoire
	select into rec_aleatoire * from v2.af_get_serie_aleatoire($1)
	as (id int4,libelle varchar,bareme int4,chrono int4,type int4,date_creation timestamp);
	val_type:=rec_aleatoire.type;
    end if;
    if aleatoire is true and (val_type=2 or val_type=3) then
	return 1;
    end if;
    select into rec * from v2.af_get_serie_evaluation($1,$2) as (evaluation int4, libelle varchar, serie int4, pere int4, commentaire varchar, bareme int4, chrono int4, points int4, type int4 );  
    return rec.points;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_evaluation_point(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9489 (class 0 OID 0)
-- Dependencies: 713
-- Name: FUNCTION vltn_get_evaluation_point(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_get_evaluation_point(integer, integer) IS 'retourne la valeur du point pour une evaluation de serie';


--
-- TOC entry 714 (class 1255 OID 2597394)
-- Dependencies: 2983 7
-- Name: vltn_get_evaluation_resultats(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_evaluation_resultats(integer) RETURNS SETOF record
    AS $_$-- $1 : evaluation
declare
rec record;
begin
    for rec in
	select * from v2.resultat_serie where evaluation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_evaluation_resultats(integer) OWNER TO pgsql;

--
-- TOC entry 9490 (class 0 OID 0)
-- Dependencies: 714
-- Name: FUNCTION vltn_get_evaluation_resultats(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_get_evaluation_resultats(integer) IS 'retourne les identifiants de resultat pour une evaluation';


--
-- TOC entry 715 (class 1255 OID 2597395)
-- Dependencies: 2983 7
-- Name: vltn_get_evaluation_type(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_evaluation_type(integer) RETURNS record
    AS $_$DECLARE
rec RECORD;
BEGIN

	
	SELECT INTO rec id, libelle, code, couleur FROM v2.evaluation_type
	WHERE id=$1;

	RETURN rec ;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_evaluation_type(integer) OWNER TO pgsql;

--
-- TOC entry 716 (class 1255 OID 2597396)
-- Dependencies: 2983 7
-- Name: vltn_get_evaluation_types(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_evaluation_types() RETURNS SETOF record
    AS $$DECLARE
rec RECORD;
BEGIN

	FOR rec IN
		SELECT * FROM v2.evaluation_type
	LOOP
		RETURN NEXT rec;
	END LOOP;

	RETURN;
END$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_evaluation_types() OWNER TO pgsql;

--
-- TOC entry 717 (class 1255 OID 2597397)
-- Dependencies: 2983 7
-- Name: vltn_get_formation_stagiaires_correction(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_formation_stagiaires_correction(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : exotlc
-- $3 : classe
declare
rec record;
begin
    for rec in 
	select id,stagiaires_non_corriges.nom,stagiaires_non_corriges.prenom,date_correction
	from
	--(
	    --(
		(
		select ci1.id,nom,prenom 
		from v2.af_get_classe_individus($3,2,'asc',false) ci1 
		) as stagiaires_non_corriges 
		
		left outer join
		(
		select ci2.id,nom,prenom,date_correction 
		from v2.af_get_classe_individus($3,2,'asc',false) ci2,
		v2.resultat r,v2.resultat_exotlc re 
		where r.formation=$1 and r.etape=$2 and r.id=re.id and ci2.id=r.stagiaire
		) as stagiaires_corriges 
		using (id)
		
	    --)
	--)
	
		
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_formation_stagiaires_correction(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9491 (class 0 OID 0)
-- Dependencies: 717
-- Name: FUNCTION vltn_get_formation_stagiaires_correction(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_get_formation_stagiaires_correction(integer, integer, integer) IS 'retourne les stagiaires de la formation et leur etat de correction';


--
-- TOC entry 718 (class 1255 OID 2597398)
-- Dependencies: 2983 7
-- Name: vltn_get_theme_evaluations(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_get_theme_evaluations(integer) RETURNS SETOF record
    AS $_$declare
rec record;
begin
    for rec in
	select distinct e.id,e.type from v2.evaluation e,
	v2.categorie_evaluation ce--,
	--v2.serie_evaluations se
	where 
	--e.id=se.evaluation 
	--and 
	e.id=ce.id 
	and ce.theme=$1
    loop
    return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_get_theme_evaluations(integer) OWNER TO pgsql;

--
-- TOC entry 9492 (class 0 OID 0)
-- Dependencies: 718
-- Name: FUNCTION vltn_get_theme_evaluations(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_get_theme_evaluations(integer) IS 'retourne les ÃƒÂ©valuations pour un theme';


--
-- TOC entry 719 (class 1255 OID 2597399)
-- Dependencies: 2983 7
-- Name: vltn_maj_bareme(integer, character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_maj_bareme(integer, character varying, integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero bareme
-- $2 : libelle
-- $3 : juste
-- $4 : fausse
-- $5 : pas cochÃƒÂ©
-- $6 : tout cochÃƒÂ©
begin
    update v2.bareme set libelle=$2,juste=$3,fausse=$4,manquantes=$5,toutes=$6 
    where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_maj_bareme(integer, character varying, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9493 (class 0 OID 0)
-- Dependencies: 719
-- Name: FUNCTION vltn_maj_bareme(integer, character varying, integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_maj_bareme(integer, character varying, integer, integer, integer, integer) IS 'modifie un bareme';


--
-- TOC entry 720 (class 1255 OID 2597400)
-- Dependencies: 2983 7
-- Name: vltn_maj_evaluation(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_maj_evaluation(integer, character varying) RETURNS boolean
    AS $_$DECLARE
--$1 l'evaluation
--$2 le libelle	
BEGIN 
	UPDATE v2.evaluation SET libelle=$2 WHERE id=$1;
	RETURN FOUND;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_maj_evaluation(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9494 (class 0 OID 0)
-- Dependencies: 720
-- Name: FUNCTION vltn_maj_evaluation(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_maj_evaluation(integer, character varying) IS 'Mise a jour d''une evaluation.';


--
-- TOC entry 721 (class 1255 OID 2597401)
-- Dependencies: 2983 7
-- Name: vltn_set_bareme(character varying, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vltn_set_bareme(character varying, integer, integer, integer, integer) RETURNS integer
    AS $_$DECLARE
new_id int4;
res int4;
BEGIN
	
	INSERT INTO v2.bareme(libelle, juste,fausse,manquantes,toutes) 
	VALUES($1,$2,$3,$4,$5);

	--RECUPERE L'IDENTIFIANT DE LA NOUVELLE CATEGORIE
	GET DIAGNOSTICS new_id = RESULT_OID;

	SELECT INTO res id FROM v2.bareme WHERE oid=new_id;

	RAISE NOTICE 'insertion du bareme d''id: % (oid=%)',res, new_id;
	RETURN res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_set_bareme(character varying, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9495 (class 0 OID 0)
-- Dependencies: 721
-- Name: FUNCTION vltn_set_bareme(character varying, integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vltn_set_bareme(character varying, integer, integer, integer, integer) IS 'CrÃƒÂ©ation d''un bareme';


--
-- TOC entry 722 (class 1255 OID 2597402)
-- Dependencies: 2983 7
-- Name: vltn_set_evaluation(character varying, integer); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION vltn_set_evaluation(character varying, integer) RETURNS integer
    AS $_$DECLARE
val_libelle ALIAS FOR $1;
val_type ALIAS FOR $2;
new_id int4;
res int4;
BEGIN
	
	insert into v2.evaluation(libelle, "type") VALUES(val_libelle, val_type);

	--RECUPERE L'IDENTIFIANT DE LA NOUVELLE CATEGORIE
	GET DIAGNOSTICS new_id = RESULT_OID;

	select into res id from v2.evaluation where oid=new_id;
	return res;
END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vltn_set_evaluation(character varying, integer) OWNER TO postgres;

--
-- TOC entry 9496 (class 0 OID 0)
-- Dependencies: 722
-- Name: FUNCTION vltn_set_evaluation(character varying, integer); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION vltn_set_evaluation(character varying, integer) IS 'FONCTION PRIVEE: creer une nouvelle evaluation. retourne le numero de la nouvelle evaluation.';


--
-- TOC entry 723 (class 1255 OID 2597403)
-- Dependencies: 2983 7
-- Name: vnmnt_del_formation_evenement(integer, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_del_formation_evenement(integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date
-- $3 : debut
begin
    delete from v2.evenement 
    where formation=$1 and date=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_del_formation_evenement(integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9497 (class 0 OID 0)
-- Dependencies: 723
-- Name: FUNCTION vnmnt_del_formation_evenement(integer, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_del_formation_evenement(integer, timestamp without time zone) IS 'Supprime un evenement d''une journee de formation';


--
-- TOC entry 724 (class 1255 OID 2597404)
-- Dependencies: 2983 7
-- Name: vnmnt_del_formation_evenements(integer, date); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_del_formation_evenements(integer, date) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date
begin
    delete from v2.evenement 
    where formation=$1 and cast(date as date)=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_del_formation_evenements(integer, date) OWNER TO pgsql;

--
-- TOC entry 9498 (class 0 OID 0)
-- Dependencies: 724
-- Name: FUNCTION vnmnt_del_formation_evenements(integer, date); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_del_formation_evenements(integer, date) IS 'Supprime les evenements d''une journee de formation';


--
-- TOC entry 725 (class 1255 OID 2597405)
-- Dependencies: 2983 7
-- Name: vnmnt_del_intervention(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_del_intervention(integer) RETURNS boolean
    AS $_$-- $1 : numero intervention
begin
    delete from v2.intervention where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_del_intervention(integer) OWNER TO pgsql;

--
-- TOC entry 9499 (class 0 OID 0)
-- Dependencies: 725
-- Name: FUNCTION vnmnt_del_intervention(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_del_intervention(integer) IS 'supprime une intervention';


--
-- TOC entry 726 (class 1255 OID 2597406)
-- Dependencies: 2983 7
-- Name: vnmnt_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
begin
    delete from v2.grille_resultats 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9500 (class 0 OID 0)
-- Dependencies: 726
-- Name: FUNCTION vnmnt_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) IS 'Supprime un carton pour une capacite Ãƒ  une date';


--
-- TOC entry 727 (class 1255 OID 2597407)
-- Dependencies: 2983 7
-- Name: vnmnt_del_salle(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_del_salle(integer) RETURNS boolean
    AS $_$-- $1 : numero salle
begin
    delete from v2.salle where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_del_salle(integer) OWNER TO pgsql;

--
-- TOC entry 9501 (class 0 OID 0)
-- Dependencies: 727
-- Name: FUNCTION vnmnt_del_salle(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_del_salle(integer) IS 'supprime une salle';


--
-- TOC entry 728 (class 1255 OID 2597408)
-- Dependencies: 2983 7
-- Name: vnmnt_get_evenement_intervenants(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_evenement_intervenants(integer) RETURNS SETOF record
    AS $_$-- $1 : modalite (si <> 0)
declare
rec record;
req varchar;
begin
    if $1!=0 then
	req :='select distinct id,nom,prenom from v2.individu,v2.evenement where id=intervenant and modalite='||$1;	
    else
	req :='select distinct id,nom,prenom from v2.individu,v2.evenement where id=intervenant';
    end if;
    for rec in
	execute req
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_evenement_intervenants(integer) OWNER TO pgsql;

--
-- TOC entry 9502 (class 0 OID 0)
-- Dependencies: 728
-- Name: FUNCTION vnmnt_get_evenement_intervenants(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_evenement_intervenants(integer) IS 'retourne les intervenants d''evenement';


--
-- TOC entry 729 (class 1255 OID 2597409)
-- Dependencies: 2983 7
-- Name: vnmnt_get_evenements(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_evenements() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
	from v2.evenement 
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_evenements() OWNER TO pgsql;

--
-- TOC entry 9503 (class 0 OID 0)
-- Dependencies: 729
-- Name: FUNCTION vnmnt_get_evenements(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_evenements() IS 'retourne les evenements de la plateforme';


--
-- TOC entry 730 (class 1255 OID 2597410)
-- Dependencies: 2983 7
-- Name: vnmnt_get_evenements_dates(date, time without time zone, time without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_evenements_dates(date, time without time zone, time without time zone) RETURNS SETOF record
    AS $_$-- $1 : date de l'evenement
-- $2 : heure debut
-- $3 : heure fin
declare
rec record;
begin
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
	from v2.evenement 
	where cast(date as date) =$1
	and ((
	    cast(date as time)>=$2 and cast(date as time)<=$3
	)
	or (
	    cast(date as time)<=$2 and 	cast(date as time) +  duree >=$2)
	)
    loop
	return next rec;
    end loop;
	return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_evenements_dates(date, time without time zone, time without time zone) OWNER TO pgsql;

--
-- TOC entry 9504 (class 0 OID 0)
-- Dependencies: 730
-- Name: FUNCTION vnmnt_get_evenements_dates(date, time without time zone, time without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_evenements_dates(date, time without time zone, time without time zone) IS 'retourne les evenements en fonction des dates,debut et fin';


--
-- TOC entry 731 (class 1255 OID 2597411)
-- Dependencies: 2983 7
-- Name: vnmnt_get_formation_evenements_presentiels(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_formation_evenements_presentiels(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
	from v2.evenement 
	where formation=$1 and modalite=3
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_formation_evenements_presentiels(integer) OWNER TO pgsql;

--
-- TOC entry 9505 (class 0 OID 0)
-- Dependencies: 731
-- Name: FUNCTION vnmnt_get_formation_evenements_presentiels(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_formation_evenements_presentiels(integer) IS 'retourne les evenements presentiels d''une formation';


--
-- TOC entry 732 (class 1255 OID 2597412)
-- Dependencies: 2983 7
-- Name: vnmnt_get_formation_salles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_formation_salles(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare 
rec record;
begin
    for rec in
	select distinct s_id,s_libelle from v2.af_get_salles() as (s_id int4,s_libelle varchar),v2.evenement 
	where s_id=salle and formation=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_formation_salles(integer) OWNER TO pgsql;

--
-- TOC entry 9506 (class 0 OID 0)
-- Dependencies: 732
-- Name: FUNCTION vnmnt_get_formation_salles(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_formation_salles(integer) IS 'retourne les salles de la formation';


--
-- TOC entry 733 (class 1255 OID 2597413)
-- Dependencies: 2983 7
-- Name: vnmnt_get_formations_presentielles(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_formations_presentielles() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select distinct id, f.libelle, parcours, date_debut, date_fin, langue 
	from v2.formation f,v2.evenement 
	where id=formation and modalite=3
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_formations_presentielles() OWNER TO pgsql;

--
-- TOC entry 9507 (class 0 OID 0)
-- Dependencies: 733
-- Name: FUNCTION vnmnt_get_formations_presentielles(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_formations_presentielles() IS 'retourne les formations ayants du presentiel';


--
-- TOC entry 734 (class 1255 OID 2597414)
-- Dependencies: 2983 7
-- Name: vnmnt_get_intervenant_evenements(integer, date); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_intervenant_evenements(integer, date) RETURNS SETOF record
    AS $_$-- $1 : intervenant
-- $2 : date
declare
rec record;
begin
    for rec in 
	select * from v2.evenement 
	where intervenant=$1 and cast(date as date)=$2
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_intervenant_evenements(integer, date) OWNER TO pgsql;

--
-- TOC entry 9508 (class 0 OID 0)
-- Dependencies: 734
-- Name: FUNCTION vnmnt_get_intervenant_evenements(integer, date); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_intervenant_evenements(integer, date) IS 'retourne les evenements d''un intervenant pour un jour de formation';


--
-- TOC entry 735 (class 1255 OID 2597415)
-- Dependencies: 2983 7
-- Name: vnmnt_get_intervenant_evenements_presentiels(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_intervenant_evenements_presentiels(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : intervenant
-- $2 : formation
declare
rec record;
begin
    for rec in
	select formation,libelle,date,duree,modalite,intervention,intervenant,salle 
	from v2.af_get_formation_evenements_presentiels($2) 
	as (formation int4,libelle varchar,date timestamp,duree interval,modalite int4,intervention int4,intervenant int4,salle int4) 
	where intervenant=$1 order by date
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_intervenant_evenements_presentiels(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9509 (class 0 OID 0)
-- Dependencies: 735
-- Name: FUNCTION vnmnt_get_intervenant_evenements_presentiels(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_intervenant_evenements_presentiels(integer, integer) IS 'retourne les evenements presentiels d''une formation pour un intervenant';


--
-- TOC entry 736 (class 1255 OID 2597416)
-- Dependencies: 2983 7
-- Name: vnmnt_get_intervenant_formations_presentielles(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_intervenant_formations_presentielles(integer) RETURNS SETOF record
    AS $_$-- $1 : intervenant
declare
rec record;
begin
    for rec in
	select distinct f.id,f.libelle from v2.formation f,v2.evenement 
	where f.id=formation and intervenant=$1 and modalite=3
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_intervenant_formations_presentielles(integer) OWNER TO pgsql;

--
-- TOC entry 9510 (class 0 OID 0)
-- Dependencies: 736
-- Name: FUNCTION vnmnt_get_intervenant_formations_presentielles(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_intervenant_formations_presentielles(integer) IS 'retourne les formations presentielles d''un intervenant';


--
-- TOC entry 737 (class 1255 OID 2597417)
-- Dependencies: 2983 7
-- Name: vnmnt_get_intervenants(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_intervenants() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select id,nom,prenom from v2.individu i,v2.individu_types it 
	where i.id=it.individu and it.type=3
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_intervenants() OWNER TO pgsql;

--
-- TOC entry 9511 (class 0 OID 0)
-- Dependencies: 737
-- Name: FUNCTION vnmnt_get_intervenants(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_intervenants() IS 'retourne les intervenants de formation';


--
-- TOC entry 738 (class 1255 OID 2597418)
-- Dependencies: 2983 7
-- Name: vnmnt_get_intervenants_presentiel_grille(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_intervenants_presentiel_grille() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct id,nom,prenom from 
	v2.af_get_intervenants() as (id int4,nom varchar,prenom varchar),
	v2.evenement e,
	v2.grille_resultats gr 
	where id=e.intervenant and e.modalite=3 and e.formation=gr.formation
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_intervenants_presentiel_grille() OWNER TO pgsql;

--
-- TOC entry 9512 (class 0 OID 0)
-- Dependencies: 738
-- Name: FUNCTION vnmnt_get_intervenants_presentiel_grille(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_intervenants_presentiel_grille() IS 'retourne les intervenants presentiel avec grille';


--
-- TOC entry 739 (class 1255 OID 2597419)
-- Dependencies: 2983 7
-- Name: vnmnt_get_intervention(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_intervention(integer) RETURNS record
    AS $_$-- $1 : numero intervention
declare
rec record;
begin
    select into rec * from v2.af_get_interventions() as (id int4,libelle varchar,couleur int4) where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_intervention(integer) OWNER TO pgsql;

--
-- TOC entry 9513 (class 0 OID 0)
-- Dependencies: 739
-- Name: FUNCTION vnmnt_get_intervention(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_intervention(integer) IS 'retourne une intervention';


--
-- TOC entry 740 (class 1255 OID 2597420)
-- Dependencies: 2983 7
-- Name: vnmnt_get_interventions(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_interventions() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,couleur from v2.intervention order by libelle
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_interventions() OWNER TO pgsql;

--
-- TOC entry 9514 (class 0 OID 0)
-- Dependencies: 740
-- Name: FUNCTION vnmnt_get_interventions(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_interventions() IS 'retourne les intervention de la plateforme';


--
-- TOC entry 741 (class 1255 OID 2597421)
-- Dependencies: 2983 7
-- Name: vnmnt_get_modalite(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_modalite(integer) RETURNS record
    AS $_$-- $1 : numero modalite
declare
rec record;
begin
    SELECT into rec * FROM v2.af_get_modalites() as (id int4, libelle varchar, code varchar) 
	WHERE id=$1;

	RETURN rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_modalite(integer) OWNER TO pgsql;

--
-- TOC entry 9515 (class 0 OID 0)
-- Dependencies: 741
-- Name: FUNCTION vnmnt_get_modalite(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_modalite(integer) IS 'retourne une modalite';


--
-- TOC entry 742 (class 1255 OID 2597422)
-- Dependencies: 2983 7
-- Name: vnmnt_get_modalites(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_modalites() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	SELECT * FROM v2.modalite
    LOOP
	RETURN NEXT rec;
    END LOOP;

	RETURN;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_modalites() OWNER TO pgsql;

--
-- TOC entry 9516 (class 0 OID 0)
-- Dependencies: 742
-- Name: FUNCTION vnmnt_get_modalites(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_modalites() IS 'retourne les modalites de la plateforme';


--
-- TOC entry 743 (class 1255 OID 2597423)
-- Dependencies: 2983 7
-- Name: vnmnt_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
declare
rec record;
begin
    select into rec carton from v2.grille_resultats 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return rec;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9517 (class 0 OID 0)
-- Dependencies: 743
-- Name: FUNCTION vnmnt_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) IS 'retourne le carton pour une capacite Ãƒ  une date';


--
-- TOC entry 744 (class 1255 OID 2597424)
-- Dependencies: 2983 7
-- Name: vnmnt_get_presentiel_carton_individu(integer, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_presentiel_carton_individu(integer, integer, integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
declare
rec record;
begin
    for rec in
	select * from v2.grille_resultats 
	where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_presentiel_carton_individu(integer, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9518 (class 0 OID 0)
-- Dependencies: 744
-- Name: FUNCTION vnmnt_get_presentiel_carton_individu(integer, integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_presentiel_carton_individu(integer, integer, integer, integer, integer) IS 'retourne les notations presentielles pour un individu';


--
-- TOC entry 745 (class 1255 OID 2597425)
-- Dependencies: 2983 7
-- Name: vnmnt_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
declare
rec record;
begin
    select into rec commentaire,note,note_max from v2.grille_resultats 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9519 (class 0 OID 0)
-- Dependencies: 745
-- Name: FUNCTION vnmnt_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) IS 'retourne la note pour une capacite Ãƒ  une date';


--
-- TOC entry 746 (class 1255 OID 2597426)
-- Dependencies: 2983 7
-- Name: vnmnt_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) RETURNS record
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
declare
rec record;
begin
    select into rec * from v2.grille_resultats 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9520 (class 0 OID 0)
-- Dependencies: 746
-- Name: FUNCTION vnmnt_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) IS 'retourne le resultat pour un individu Ãƒ  une date';


--
-- TOC entry 747 (class 1255 OID 2597427)
-- Dependencies: 2983 7
-- Name: vnmnt_get_salle(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_salle(integer) RETURNS record
    AS $_$-- $1 : numero salle
declare
rec record;
begin
    select into rec * from v2.af_get_salles() as (id int4,libelle varchar) where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_salle(integer) OWNER TO pgsql;

--
-- TOC entry 9521 (class 0 OID 0)
-- Dependencies: 747
-- Name: FUNCTION vnmnt_get_salle(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_salle(integer) IS 'retourne une salle';


--
-- TOC entry 748 (class 1255 OID 2597428)
-- Dependencies: 2983 7
-- Name: vnmnt_get_salle_evenements(integer, date); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_get_salle_evenements(integer, date) RETURNS SETOF record
    AS $_$-- $1 : numero salle
-- $2 : date
declare
rec record;
begin
    for rec in 
	select * from v2.evenement 
	where salle=$1 and cast(date as date)=$2
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_salle_evenements(integer, date) OWNER TO pgsql;

--
-- TOC entry 9522 (class 0 OID 0)
-- Dependencies: 748
-- Name: FUNCTION vnmnt_get_salle_evenements(integer, date); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_get_salle_evenements(integer, date) IS 'retourne les evvenements dans une salle pour une journee de formation';


--
-- TOC entry 749 (class 1255 OID 2597429)
-- Dependencies: 2983 7
-- Name: vnmnt_get_salles(); Type: FUNCTION; Schema: v2; Owner: postgres
--

CREATE FUNCTION vnmnt_get_salles() RETURNS SETOF record
    AS $$declare
rec record;
begin
	for rec in 
		select * from v2.salle order by libelle
	loop
		return next rec;
	end loop;
	return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_get_salles() OWNER TO postgres;

--
-- TOC entry 9523 (class 0 OID 0)
-- Dependencies: 749
-- Name: FUNCTION vnmnt_get_salles(); Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON FUNCTION vnmnt_get_salles() IS 'Obtenir les salles de la plate-forme (auteur : Said)';


--
-- TOC entry 750 (class 1255 OID 2597430)
-- Dependencies: 2983 7
-- Name: vnmnt_is_formation_evenement_supprimable(integer, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_is_formation_evenement_supprimable(integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : timestamp
begin
    perform * from v2.grille_resultats
    where formation=$1 and date=$2;
    return not found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_is_formation_evenement_supprimable(integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9524 (class 0 OID 0)
-- Dependencies: 750
-- Name: FUNCTION vnmnt_is_formation_evenement_supprimable(integer, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_is_formation_evenement_supprimable(integer, timestamp without time zone) IS 'teste si un evenement de formation est supprimable';


--
-- TOC entry 751 (class 1255 OID 2597431)
-- Dependencies: 2983 7
-- Name: vnmnt_is_formation_evenements_hors_periode(integer, date, date); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_is_formation_evenements_hors_periode(integer, date, date) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date debut
-- $3 : date fin
begin
    perform * from v2.evenement 
    where formation=$1
    and (cast(date as date)<$2 or cast(date as date)>$3);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_is_formation_evenements_hors_periode(integer, date, date) OWNER TO pgsql;

--
-- TOC entry 9525 (class 0 OID 0)
-- Dependencies: 751
-- Name: FUNCTION vnmnt_is_formation_evenements_hors_periode(integer, date, date); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_is_formation_evenements_hors_periode(integer, date, date) IS 'retourne vrai si un evenement est hors date de formation';


--
-- TOC entry 752 (class 1255 OID 2597432)
-- Dependencies: 2983 7
-- Name: vnmnt_is_formation_evenements_supprimable(integer, date); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_is_formation_evenements_supprimable(integer, date) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : date
begin
    perform * from v2.grille_resultats 
    where formation=$1 and cast(date as date)=$2;
    return not found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_is_formation_evenements_supprimable(integer, date) OWNER TO pgsql;

--
-- TOC entry 9526 (class 0 OID 0)
-- Dependencies: 752
-- Name: FUNCTION vnmnt_is_formation_evenements_supprimable(integer, date); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_is_formation_evenements_supprimable(integer, date) IS 'teste si une journÃƒÂ©e de formation est supprimable';


--
-- TOC entry 753 (class 1255 OID 2597433)
-- Dependencies: 2983 7
-- Name: vnmnt_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : libelle
-- $3 : date
-- $4 : duree
-- $5 : modalite
-- $6 : intervention
-- $7 : intervenant
-- $8 : salle
-- $9 : ancienne date
begin
    update v2.evenement set
	libelle=$2,
	date=$3,
	duree=$4  ,
	modalite=$5,
	intervention=$6,
	intervenant=$7,
	salle=$8
    where formation=$1 and date=$9;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) OWNER TO pgsql;

--
-- TOC entry 9527 (class 0 OID 0)
-- Dependencies: 753
-- Name: FUNCTION vnmnt_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) IS 'met Ãƒ  jour un evenement de formation';


--
-- TOC entry 754 (class 1255 OID 2597434)
-- Dependencies: 2983 7
-- Name: vnmnt_maj_intervention(integer, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_maj_intervention(integer, character varying, integer) RETURNS boolean
    AS $_$-- $1 : numero intervention
-- $2 : libelle
-- $3 : couleur
begin
    update v2.intervention set libelle=$2,couleur=$3 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_maj_intervention(integer, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9528 (class 0 OID 0)
-- Dependencies: 754
-- Name: FUNCTION vnmnt_maj_intervention(integer, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_maj_intervention(integer, character varying, integer) IS 'met Ãƒ  jour une intervention';


--
-- TOC entry 755 (class 1255 OID 2597435)
-- Dependencies: 2983 7
-- Name: vnmnt_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
-- $7 : carton
begin
    update v2.grille_resultats 
    set carton =$7
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) OWNER TO pgsql;

--
-- TOC entry 9529 (class 0 OID 0)
-- Dependencies: 755
-- Name: FUNCTION vnmnt_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) IS 'met Ãƒ  jour le carton pour une capacite Ãƒ  une date';


--
-- TOC entry 756 (class 1255 OID 2597436)
-- Dependencies: 2983 7
-- Name: vnmnt_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
-- $7 : commentaire
-- $8 : note
-- $9 : notesur
begin
    update v2.grille_resultats 
    set commentaire=$7,note=$8,note_max=$9 
    where formation=$1 and stagiaire=$2 and grille=$3 and capacite_titre=$4 and capacite=$5 and date=$6;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9530 (class 0 OID 0)
-- Dependencies: 756
-- Name: FUNCTION vnmnt_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) IS 'met Ãƒ  jour la note pour une capacite Ãƒ  une date';


--
-- TOC entry 757 (class 1255 OID 2597437)
-- Dependencies: 2983 7
-- Name: vnmnt_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : bool
begin
    update v2.stagiaire_grille set visible=$4 
    where formation=$1 and stagiaire=$2 and grille=$3;
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 9531 (class 0 OID 0)
-- Dependencies: 757
-- Name: FUNCTION vnmnt_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) IS 'Met Ãƒ  jour la table stagiaire_grille(voir ou pas) pour un stagiaire';


--
-- TOC entry 758 (class 1255 OID 2597438)
-- Dependencies: 2983 7
-- Name: vnmnt_maj_salle(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_maj_salle(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero salle
-- $2 : libelle
begin
    update v2.salle set libelle=$2 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_maj_salle(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9532 (class 0 OID 0)
-- Dependencies: 758
-- Name: FUNCTION vnmnt_maj_salle(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_maj_salle(integer, character varying) IS 'met Ãƒ  jour une salle';


--
-- TOC entry 759 (class 1255 OID 2597439)
-- Dependencies: 2983 7
-- Name: vnmnt_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : libelle
-- $3 : date
-- $4 : duree
-- $5 : modalite
-- $6 : intervention
-- $7 : intervenant
-- $8 : salle
begin
    insert into v2.evenement(formation,libelle,date,duree,modalite,intervention,intervenant,salle) 
    values($1,$2,$3,$4,$5,$6,$7,$8);
    if $5=3 then
	insert into v2.evenement_presentiel(formation,date) 
	values($1,$3);
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9533 (class 0 OID 0)
-- Dependencies: 759
-- Name: FUNCTION vnmnt_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) IS 'enregistre un evenement de formation';


--
-- TOC entry 760 (class 1255 OID 2597440)
-- Dependencies: 2983 7
-- Name: vnmnt_set_intervention(character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_set_intervention(character varying, integer) RETURNS integer
    AS $_$-- $1 : libelle intervention
-- $2 : code couleur
declare
new_id int4;
res int4;
begin
    insert into v2.intervention(libelle,couleur) values($1,$2);
    --RECUPERE L'IDENTIFIANT DU NOUVEL ESPACE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.intervention WHERE oid=new_id;
    RETURN res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_set_intervention(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9534 (class 0 OID 0)
-- Dependencies: 760
-- Name: FUNCTION vnmnt_set_intervention(character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_set_intervention(character varying, integer) IS 'enregistre une intervention';


--
-- TOC entry 761 (class 1255 OID 2597441)
-- Dependencies: 2983 7
-- Name: vnmnt_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) RETURNS boolean
    AS $_$-- $1 : formation
-- $2 : stagiaire
-- $3 : grille
-- $4 : titre capacite
-- $5 : capacite
-- $6 : date
-- $7 : carton
begin
    perform * from v2.stagiaire_grille where formation=$1 and stagiaire=$2 and grille=$3;
    if not found then
	insert into v2.stagiaire_grille(formation,stagiaire,grille,visible) 
	values($1,$2,$3,true);
    end if;
    insert into v2.grille_resultats (formation,stagiaire,grille,capacite_titre,capacite,carton,date) 
    values($1,$2,$3,$4,$5,$7,$6);
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) OWNER TO pgsql;

--
-- TOC entry 9535 (class 0 OID 0)
-- Dependencies: 761
-- Name: FUNCTION vnmnt_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) IS 'enregistre le carton pour une capacite Ãƒ  une date';


--
-- TOC entry 762 (class 1255 OID 2597442)
-- Dependencies: 2983 7
-- Name: vnmnt_set_salle(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION vnmnt_set_salle(character varying) RETURNS integer
    AS $_$-- $1 : libelle salle
declare
new_id int4;
res int4;
begin
    insert into v2.salle(libelle) values($1);
    --RECUPERE L'IDENTIFIANT De la nouvelle capacite
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.salle WHERE oid=new_id;
    return res;    
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.vnmnt_set_salle(character varying) OWNER TO pgsql;

--
-- TOC entry 9536 (class 0 OID 0)
-- Dependencies: 762
-- Name: FUNCTION vnmnt_set_salle(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION vnmnt_set_salle(character varying) IS 'enregistre une salle';


--
-- TOC entry 763 (class 1255 OID 2597443)
-- Dependencies: 2983 7
-- Name: xtlc_del_critere(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_del_critere(integer) RETURNS boolean
    AS $_$-- $1 : numero critere
begin
    delete from v2.critere where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_del_critere(integer) OWNER TO pgsql;

--
-- TOC entry 9537 (class 0 OID 0)
-- Dependencies: 763
-- Name: FUNCTION xtlc_del_critere(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_del_critere(integer) IS 'supprime un critere';


--
-- TOC entry 764 (class 1255 OID 2597444)
-- Dependencies: 2983 7
-- Name: xtlc_del_exotlc_fichiers(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_del_exotlc_fichiers(integer) RETURNS boolean
    AS $_$-- $1 : numero exotlc
declare
ok bool;
begin
    -- suppression des fichiers
    delete from v2.exotlc_fichiers where exotlc=$1;
    ok:=found;
    -- suppression fichiers correction
    delete from v2.exotlc_corrections where exotlc=$1;
    return (ok and found);
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_del_exotlc_fichiers(integer) OWNER TO pgsql;

--
-- TOC entry 9538 (class 0 OID 0)
-- Dependencies: 764
-- Name: FUNCTION xtlc_del_exotlc_fichiers(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_del_exotlc_fichiers(integer) IS 'supprime les fichiers et fichiers correction d''un exotlc';


--
-- TOC entry 765 (class 1255 OID 2597445)
-- Dependencies: 2983 7
-- Name: xtlc_del_resultat_exotlc(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_del_resultat_exotlc(integer) RETURNS boolean
    AS $_$-- $1 : id resultat
begin
    delete from v2.resultat_exotlc where id=$1;
    -- mise Ãƒ  jour de la table resultat
    --update v2.resultat set duree=null where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_del_resultat_exotlc(integer) OWNER TO pgsql;

--
-- TOC entry 9539 (class 0 OID 0)
-- Dependencies: 765
-- Name: FUNCTION xtlc_del_resultat_exotlc(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_del_resultat_exotlc(integer) IS 'Supprime les resultats pour un identifiant de resultat';


--
-- TOC entry 766 (class 1255 OID 2597446)
-- Dependencies: 2983 7
-- Name: xtlc_del_template(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_del_template(integer) RETURNS boolean
    AS $_$-- $1 : numero modele
begin
    delete from v2.modele_correction where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_del_template(integer) OWNER TO pgsql;

--
-- TOC entry 9540 (class 0 OID 0)
-- Dependencies: 766
-- Name: FUNCTION xtlc_del_template(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_del_template(integer) IS 'supprime un modele de correction';


--
-- TOC entry 767 (class 1255 OID 2597447)
-- Dependencies: 2983 7
-- Name: xtlc_get_classes_exotlcs_corriges(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_classes_exotlcs_corriges() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select distinct c_id,libelle from v2.af_get_classes() as (c_id int4,libelle varchar,pere int4,min int4,max int4),
	v2.classe_individus CI,
	v2.af_get_individus_exotlcs_corriges() as (id int4,nom varchar,prenom varchar) 
	where c_id=CI.classe and CI.individu=id 
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_classes_exotlcs_corriges() OWNER TO pgsql;

--
-- TOC entry 9541 (class 0 OID 0)
-- Dependencies: 767
-- Name: FUNCTION xtlc_get_classes_exotlcs_corriges(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_classes_exotlcs_corriges() IS 'retourne les classes qui ont des exotlcs corriges';


--
-- TOC entry 768 (class 1255 OID 2597448)
-- Dependencies: 2983 7
-- Name: xtlc_get_critere(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_critere(integer) RETURNS record
    AS $_$-- $1 : numero critere
declare
rec record;
begin
    select into rec c_id,c_libelle,cc.theme,c_pere 
    from v2.af_get_criteres() as (c_id int4,c_libelle varchar,c_pere int4),v2.categorie_critere cc 
    where c_id=$1 and cc.id=c_id;
    return rec; 	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_critere(integer) OWNER TO pgsql;

--
-- TOC entry 9542 (class 0 OID 0)
-- Dependencies: 768
-- Name: FUNCTION xtlc_get_critere(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_critere(integer) IS 'retourne l''id,le libelle et le theme d''un critere';


--
-- TOC entry 769 (class 1255 OID 2597449)
-- Dependencies: 2983 7
-- Name: xtlc_get_critere_sous_criteres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_critere_sous_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero critere
declare
rec record;
begin
    for rec in 
	select c_id,c_libelle,cc.theme,c_pere from v2.af_get_criteres() as (c_id int4,c_libelle varchar,c_pere int4),
	v2.categorie_critere cc
	where c_pere=$1 and c_id=cc.id
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_critere_sous_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 9543 (class 0 OID 0)
-- Dependencies: 769
-- Name: FUNCTION xtlc_get_critere_sous_criteres(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_critere_sous_criteres(integer) IS 'retourne les sous criteres d''un critere';


--
-- TOC entry 770 (class 1255 OID 2597450)
-- Dependencies: 2983 7
-- Name: xtlc_get_criteres(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_criteres() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,libelle,pere from v2.critere 
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_criteres() OWNER TO pgsql;

--
-- TOC entry 9544 (class 0 OID 0)
-- Dependencies: 770
-- Name: FUNCTION xtlc_get_criteres(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_criteres() IS 'retourne tous les criteres de la plateforme';


--
-- TOC entry 771 (class 1255 OID 2597451)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlc(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlc(integer, integer) RETURNS record
    AS $_$-- $1 : numero exotlc
-- $2 : type exo (1=plateforme,2=mail)
declare
rec record;
begin
    if $2=1 then
	select into rec 
	E.id,ET.libelle,EP.fichier_rendu,E.commentaire,E.texte,E.enonce,E.remarque,E.type, ET.date_creation 
	from v2.etape ET,v2.exotlc E,v2.exotlc_plate_forme EP 
	where E.id=$1 and ET.id=$1 and EP.id=$1;
    elseif $2=2 then
	select into rec 
	E.id,ET.libelle, EM.formateur,E.commentaire,E.texte,E.enonce,E.remarque,E.type , ET.date_creation 
	from v2.etape ET,v2.exotlc E,v2.exotlc_mail EM
	where E.id=$1 and ET.id=$1 and EM.id=$1;
    ELSE
	RAISE EXCEPTION 'Le type d''exotlc % n''est pas connu.', $2;
    end if;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlc(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9545 (class 0 OID 0)
-- Dependencies: 771
-- Name: FUNCTION xtlc_get_exotlc(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlc(integer, integer) IS 'retourne les infos d''un exotlc';


--
-- TOC entry 772 (class 1255 OID 2597452)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlc_fichier(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlc_fichier(integer) RETURNS integer
    AS $_$DECLARE
--$1 le numero du fichier
exotlc_id int4;
BEGIN

	SELECT INTO exotlc_id id FROM v2.exotlc_fichiers
	WHERE fichier=$1;

	RETURN exotlc_id;

END$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlc_fichier(integer) OWNER TO pgsql;

--
-- TOC entry 9546 (class 0 OID 0)
-- Dependencies: 772
-- Name: FUNCTION xtlc_get_exotlc_fichier(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlc_fichier(integer) IS 'Obtenir l''identifiant d''un exotcl a partir de son numero de fichier.';


--
-- TOC entry 773 (class 1255 OID 2597453)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlc_fichiers(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlc_fichiers(integer) RETURNS SETOF record
    AS $_$-- $1 numero exotlc
declare
rec record;
begin
    for rec in
	select F.id,F.libelle from v2.fichier F,v2.exotlc_fichiers EF 
	where EF.exotlc=$1 and F.id=EF.fichier
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlc_fichiers(integer) OWNER TO pgsql;

--
-- TOC entry 9547 (class 0 OID 0)
-- Dependencies: 773
-- Name: FUNCTION xtlc_get_exotlc_fichiers(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlc_fichiers(integer) IS 'retourne les fichiers d''un exotlc';


--
-- TOC entry 774 (class 1255 OID 2597454)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlc_fichiers_correction(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlc_fichiers_correction(integer) RETURNS SETOF record
    AS $_$-- $1 : numero exotlc
declare
rec record;
begin
    for rec in 
	select F.id,F.libelle from v2.fichier F,v2.exotlc_corrections EC 
	where EC.exotlc=$1 and F.id=EC.correction
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlc_fichiers_correction(integer) OWNER TO pgsql;

--
-- TOC entry 9548 (class 0 OID 0)
-- Dependencies: 774
-- Name: FUNCTION xtlc_get_exotlc_fichiers_correction(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlc_fichiers_correction(integer) IS 'Obtenir les fichiers de correction d''un exotlc';


--
-- TOC entry 775 (class 1255 OID 2597455)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlc_mail(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlc_mail(integer) RETURNS record
    AS $_$-- $1 : numero exotlc
declare
rec record;
begin
    select into rec 
	id,libelle, formateur ,commentaire,texte,enonce,remarque,type, date_creation 
	from v2.af_get_exotlc($1,2) AS (id integer,libelle character varying,formateur integer,commentaire character varying,texte character varying,enonce character varying,remarque character varying,type integer,date_creation timestamp);
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlc_mail(integer) OWNER TO pgsql;

--
-- TOC entry 9549 (class 0 OID 0)
-- Dependencies: 775
-- Name: FUNCTION xtlc_get_exotlc_mail(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlc_mail(integer) IS 'retourne les infos d''un exotlc mail';


--
-- TOC entry 776 (class 1255 OID 2597456)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlc_plate_forme(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlc_plate_forme(integer) RETURNS record
    AS $_$-- $1 : numero exotlc
declare
rec record;
begin
    select into rec 
	id,libelle, fichier_rendu ,commentaire,texte,enonce,remarque,type, date_creation 
	from v2.af_get_exotlc($1,1) AS (id integer,libelle character varying,fichier_rendu character varying,commentaire character varying,texte character varying,enonce character varying,remarque character varying,type integer,date_creation timestamp);
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlc_plate_forme(integer) OWNER TO pgsql;

--
-- TOC entry 9550 (class 0 OID 0)
-- Dependencies: 776
-- Name: FUNCTION xtlc_get_exotlc_plate_forme(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlc_plate_forme(integer) IS 'retourne les infos d''un exotlc plateforme';


--
-- TOC entry 777 (class 1255 OID 2597457)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) RETURNS SETOF record
    AS $_$-- $1 : exotlc (etape)
-- $2 : parcours
-- $3 : formation
-- $4 : bool (true -> corrige, false -> non corrige)
declare
rec record;
begin
    for rec in 
	select I.id,I.nom,I.prenom
	
	from v2.individu I,
	v2.af_get_etape_resultats($1) as (ger_id int8, formation int4,   stagiaire int4, parcours int4,  etape int4, date_debut timestamp, duree interval)
	left outer join 
	v2.resultat_exotlc re on (ger_id=re.id)
	where I.id=stagiaire and formation=$3 and parcours=$2 
	group by I.id,I.nom,I.prenom ,re.date_correction
	having (CAST(case when re.date_correction is null then false else true end AS boolean)=cast($4 as boolean ))

	
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) OWNER TO pgsql;

--
-- TOC entry 9551 (class 0 OID 0)
-- Dependencies: 777
-- Name: FUNCTION xtlc_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) IS 'retourne les stagiaires corriges ou non corriges pour un exotlc et une formation';


--
-- TOC entry 778 (class 1255 OID 2597458)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) RETURNS SETOF record
    AS $_$-- $1 : formation
-- $2 : parcours
-- $3 : exotlc
declare
rec record;
begin
    for rec in 
	select i.id,nom,prenom,re.fichier_rendu from v2.individu i,v2.resultat r,v2.resultat_exotlc re  
	where i.id=r.stagiaire and r.formation=$1 and r.parcours=$2 and r.etape=$3 and r.id=re.id 
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9552 (class 0 OID 0)
-- Dependencies: 778
-- Name: FUNCTION xtlc_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) IS 'retourne les stagiaires qui ont rendu leur fichier pour un exotlc';


--
-- TOC entry 779 (class 1255 OID 2597459)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlc_type(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlc_type(integer) RETURNS integer
    AS $_$-- $1 : numero exotlc
declare
res int4;
begin
    select into res type from v2.exotlc where id=$1;
    return res;
end;  $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlc_type(integer) OWNER TO pgsql;

--
-- TOC entry 9553 (class 0 OID 0)
-- Dependencies: 779
-- Name: FUNCTION xtlc_get_exotlc_type(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlc_type(integer) IS 'retourne le type d''un exotlc';


--
-- TOC entry 780 (class 1255 OID 2597460)
-- Dependencies: 2983 7
-- Name: xtlc_get_exotlcs(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_exotlcs() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select id,commentaire,texte,enonce,remarque,type
	from v2.exotlc
    loop
	return next rec;
    end loop;
    return;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_exotlcs() OWNER TO pgsql;

--
-- TOC entry 9554 (class 0 OID 0)
-- Dependencies: 780
-- Name: FUNCTION xtlc_get_exotlcs(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_exotlcs() IS 'retourne les exo tlc de la plateforme';


--
-- TOC entry 781 (class 1255 OID 2597461)
-- Dependencies: 2983 7
-- Name: xtlc_get_formation_exostlc_fichier_rendu(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_formation_exostlc_fichier_rendu(integer) RETURNS SETOF record
    AS $_$-- $1 : formation
declare
rec record;
begin
    for rec in 
	select distinct g_id,e.libelle,r.formation,r.parcours from v2.af_get_exotlcs() 
	as (g_id int4,g_commentaire varchar,texte varchar,enonce varchar,remarque varchar,type int4),
	v2.etape e,
	v2.resultat r,v2.resultat_exotlc re 
	where g_id=r.etape and g_id=e.id and r.formation=$1 and r.id=re.id and fichier_rendu is not null
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_formation_exostlc_fichier_rendu(integer) OWNER TO pgsql;

--
-- TOC entry 9555 (class 0 OID 0)
-- Dependencies: 781
-- Name: FUNCTION xtlc_get_formation_exostlc_fichier_rendu(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_formation_exostlc_fichier_rendu(integer) IS 'retourne les exotlc dont le fichier est rendu pour une formation donnee';


--
-- TOC entry 782 (class 1255 OID 2597462)
-- Dependencies: 2983 7
-- Name: xtlc_get_formation_individu_parcours_exotlcs_score(integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) RETURNS real
    AS $_$-- $1 : formation
-- $2 : individu
-- $3 : parcours
declare
rec record;
rec_resultat record;
id_resultat bigint;
total real;
res real;
nb integer;
begin
    -- boucle sur les series du parcours
    nb:=0;
    total:=0;
    for rec in
	select * from v2.af_get_parcours_etapes_type($3,'5') 
	AS (id int4, libelle_alias varchar, libelle varchar, libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool, indice int4)
    loop
	if rec.obligatoire is true then
	    -- recup id resultat
	    select into rec_resultat * from v2.af_get_resultat($1,$2,$3,rec.id) 
	    AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	    raise notice 'rec=%',rec_resultat.id;
	    select into res * from v2.af_get_resultat_exotlc_moyenne(rec_resultat.id);
	    raise notice 'res=%',res;
	    total:=total+res;
	    nb:=nb+1;
	end if;
    end loop;
    if nb=0 then
	return null;
    else
	return total/nb;
    end if;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9556 (class 0 OID 0)
-- Dependencies: 782
-- Name: FUNCTION xtlc_get_formation_individu_parcours_exotlcs_score(integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) IS 'retoune la note sur 20 pour les exotlcs d''un parcours (pour un individu,une formation)';


--
-- TOC entry 783 (class 1255 OID 2597463)
-- Dependencies: 2983 7
-- Name: xtlc_get_formations_exotlcs_corriges(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_formations_exotlcs_corriges() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select id,libelle from v2.af_get_formations() 
	as (id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4),
	v2.formation_participants fp,
	v2.af_get_classes_exotlcs_corriges() as (c_id int4,c_libelle varchar) 
	where id=fp.formation and fp.classe=c_id
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_formations_exotlcs_corriges() OWNER TO pgsql;

--
-- TOC entry 9557 (class 0 OID 0)
-- Dependencies: 783
-- Name: FUNCTION xtlc_get_formations_exotlcs_corriges(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_formations_exotlcs_corriges() IS 'retourne les formations qui ont des exotlcs corriges';


--
-- TOC entry 784 (class 1255 OID 2597464)
-- Dependencies: 2983 7
-- Name: xtlc_get_formations_fichier_rendu(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_formations_fichier_rendu() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in 
	select distinct f_id,libelle from v2.af_get_formations() 
	as (f_id int4,libelle varchar,parcours int4,date_debut date,date_fin date,langue int4),
	v2.resultat r,v2.resultat_exotlc re 
	where f_id=r.formation and re.id=r.id and fichier_rendu is not null
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_formations_fichier_rendu() OWNER TO pgsql;

--
-- TOC entry 9558 (class 0 OID 0)
-- Dependencies: 784
-- Name: FUNCTION xtlc_get_formations_fichier_rendu(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_formations_fichier_rendu() IS 'retourne les formations qui ont des fichier rendu';


--
-- TOC entry 785 (class 1255 OID 2597465)
-- Dependencies: 2983 7
-- Name: xtlc_get_individus_exotlcs_corriges(); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_individus_exotlcs_corriges() RETURNS SETOF record
    AS $$declare
rec record;
begin
    for rec in
	select distinct I.id,I.nom,I.prenom
	
	from v2.individu I where I.id in 
	(select R.stagiaire from v2.resultat R where R.id in
	(select RE.id from v2.resultat_exotlc RE where RE.date_correction is not null))
	
	
    loop
	return next rec;
    end loop;
end;$$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_individus_exotlcs_corriges() OWNER TO pgsql;

--
-- TOC entry 9559 (class 0 OID 0)
-- Dependencies: 785
-- Name: FUNCTION xtlc_get_individus_exotlcs_corriges(); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_individus_exotlcs_corriges() IS 'retourne les individus qui ont des exotlc corriges';


--
-- TOC entry 786 (class 1255 OID 2597466)
-- Dependencies: 2983 7
-- Name: xtlc_get_modele_correction_criteres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_modele_correction_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero modele correction
declare
rec record;
begin
    for rec in 
	select M1.modele_correction, M1.critere, fils.id,M1.note_max
	from v2.modele_correction M1 
	     left outer join(	v2.critere pere 
						left outer join v2.critere fils 
						on (fils.pere=pere.id)
					)
			on (M1.critere=pere.id)
	where M1.modele_correction=$1
	
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_modele_correction_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 9560 (class 0 OID 0)
-- Dependencies: 786
-- Name: FUNCTION xtlc_get_modele_correction_criteres(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_modele_correction_criteres(integer) IS 'retourne les criteres et sous criteres d''un medele de correction';


--
-- TOC entry 787 (class 1255 OID 2597467)
-- Dependencies: 2983 7
-- Name: xtlc_get_resultat_exotlc(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_resultat_exotlc(bigint) RETURNS SETOF record
    AS $_$DECLARE
--$1 resultat
rec RECORD;
BEGIN
	FOR rec IN 
		SELECT R_id,R_formation,R_stagiaire, R_parcours, R_etape, R_date_debut, R_duree, commentaire, correction, fichier_rendu, date_correction FROM v2.af_get_resultat($1) AS (R_id int8,R_formation int4,R_stagiaire int4, R_parcours int4, R_etape int4, R_date_debut timestamp, R_duree interval),
		v2.resultat_exotlc RE
		WHERE R_id=RE.id
	LOOP
		RETURN NEXT rec;
	END LOOP;
	RETURN ;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_resultat_exotlc(bigint) OWNER TO pgsql;

--
-- TOC entry 788 (class 1255 OID 2597468)
-- Dependencies: 2983 7
-- Name: xtlc_get_resultat_exotlc_critere(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_resultat_exotlc_critere(bigint, integer) RETURNS record
    AS $_$-- $1 : id resultat
-- $2 : critere
declare
rec record;
begin
    select into rec id,critere,note,note_max,commentaire 
    from v2.resultat_exotlc_critere 
    where id=$1 and critere=$2;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_resultat_exotlc_critere(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9561 (class 0 OID 0)
-- Dependencies: 788
-- Name: FUNCTION xtlc_get_resultat_exotlc_critere(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_resultat_exotlc_critere(bigint, integer) IS 'retourne le resultat d''un critere pour un identifiant de resultat';


--
-- TOC entry 789 (class 1255 OID 2597469)
-- Dependencies: 2983 7
-- Name: xtlc_get_resultat_exotlc_critere_sous_criteres(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_resultat_exotlc_critere_sous_criteres(bigint, integer) RETURNS SETOF record
    AS $_$-- $1 : id resultat
-- $2 : critere
declare
rec record;
begin
    for rec in
	select id_sc,$2,sous_critere,note,note_max 
	from v2.af_get_resultat_exotlc_sous_criteres($1) as (id_sc int8,sous_critere int4,note int4,note_max int4),
	v2.af_get_critere_sous_criteres($2) as (id int4,libelle varchar,theme int4,pere int4)
	where sous_critere=id
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_resultat_exotlc_critere_sous_criteres(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9562 (class 0 OID 0)
-- Dependencies: 789
-- Name: FUNCTION xtlc_get_resultat_exotlc_critere_sous_criteres(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_resultat_exotlc_critere_sous_criteres(bigint, integer) IS 'retourne les resultats des sous criteres d''un exotlc pour un identifiant de resultat et un critere';


--
-- TOC entry 790 (class 1255 OID 2597470)
-- Dependencies: 2983 7
-- Name: xtlc_get_resultat_exotlc_criteres(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_resultat_exotlc_criteres(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
begin
    for rec in 
	select * from v2.resultat_exotlc_critere 
	where id=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_resultat_exotlc_criteres(bigint) OWNER TO pgsql;

--
-- TOC entry 9563 (class 0 OID 0)
-- Dependencies: 790
-- Name: FUNCTION xtlc_get_resultat_exotlc_criteres(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_resultat_exotlc_criteres(bigint) IS 'retourne les resultats des criteres pour un identifiant de resultat';


--
-- TOC entry 791 (class 1255 OID 2597471)
-- Dependencies: 2983 7
-- Name: xtlc_get_resultat_exotlc_moyenne(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_resultat_exotlc_moyenne(bigint) RETURNS double precision
    AS $_$-- $1 : id resultat
declare
rec record;
ind integer:=0;
score double precision:=0;
begin
    -- recup des notes des critere
    for rec in
	select * from v2.af_get_resultat_exotlc_criteres($1) as (id int8,critere int4,note int4,note_max int4,commentaire text)
    loop
	if rec.note is not null and rec.note_max is not null then
	    ind:=ind+1;
	    score:=score + ((20*cast(rec.note as double precision))/cast(rec.note_max as double precision));
	end if;
    end loop;
    -- recup des note des sous criteres
    for rec in
	select * from v2.af_get_resultat_exotlc_sous_criteres($1) as (id int8,critere int4,note int4,note_max int4)
    loop
	if rec.note is not null and rec.note_max is not null then
	    ind:=ind+1;
	    score:=score + ((20*cast(rec.note as double precision))/cast(rec.note_max as double precision));
	end if;
    end loop;
    return (score/ind);	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_resultat_exotlc_moyenne(bigint) OWNER TO pgsql;

--
-- TOC entry 9564 (class 0 OID 0)
-- Dependencies: 791
-- Name: FUNCTION xtlc_get_resultat_exotlc_moyenne(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_resultat_exotlc_moyenne(bigint) IS 'retourne la note general sur 20 pour un identifiant de resultat';


--
-- TOC entry 792 (class 1255 OID 2597472)
-- Dependencies: 2983 7
-- Name: xtlc_get_resultat_exotlc_sous_critere(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_resultat_exotlc_sous_critere(bigint, integer) RETURNS record
    AS $_$-- $1 : id resultat
-- $2 : sous critere
declare
rec record;
begin
    select into rec id,sous_critere,note,note_max 
    from v2.resultat_exotlc_sous_critere 
    where id=$1 and sous_critere=$2;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_resultat_exotlc_sous_critere(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 9565 (class 0 OID 0)
-- Dependencies: 792
-- Name: FUNCTION xtlc_get_resultat_exotlc_sous_critere(bigint, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_resultat_exotlc_sous_critere(bigint, integer) IS 'retourne les resultat pour un sous_critere';


--
-- TOC entry 793 (class 1255 OID 2597473)
-- Dependencies: 2983 7
-- Name: xtlc_get_resultat_exotlc_sous_criteres(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_resultat_exotlc_sous_criteres(bigint) RETURNS SETOF record
    AS $_$-- $1 : id resultat
declare
rec record;
begin
    for rec in
	select * from v2.resultat_exotlc_sous_critere 
	where id=$1
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_resultat_exotlc_sous_criteres(bigint) OWNER TO pgsql;

--
-- TOC entry 9566 (class 0 OID 0)
-- Dependencies: 793
-- Name: FUNCTION xtlc_get_resultat_exotlc_sous_criteres(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_resultat_exotlc_sous_criteres(bigint) IS 'retourne les resultats des sous criteres pour un identifiant de resultat';


--
-- TOC entry 794 (class 1255 OID 2597474)
-- Dependencies: 2983 7
-- Name: xtlc_get_resultat_parcours_exotlcs_score_partiel(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_resultat_parcours_exotlcs_score_partiel(bigint) RETURNS real
    AS $_$-- $1 : id resultat
declare
rec record;
rec_resultat record;
total real;
res_exotlc real;
nb integer;
id_resultat bigint;
begin
    -- recup composants id resultat
    select into rec_resultat * from v2.af_get_resultat($1) 
    as (id bigint,  formation integer, stagiaire integer,parcours integer, etape integer,  date_debut timestamp, duree interval); 
    -- Initialisation
    total:=0;
    nb:=0;
    -- boucle sur les etapes du parcours
    for rec in 
	select * from v2.af_get_parcours_etapes(rec_resultat.parcours)
	AS (id int4, libelle varchar, libelle_bis varchar, libelle_alias  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool, libelle_type_original varchar, modifiable bool)
    loop
	if rec.type='10' then
	    exit;
	end if;
	-- traitemement serie
    if rec.type ='5' and rec.obligatoire is true then
	-- recup id resultat
	select into id_resultat id from v2.af_get_resultat(rec_resultat.formation,rec_resultat.stagiaire,rec_resultat.parcours,rec.id)
	AS (id bigint,formation int4, stagiaire int4, parcours int4, etape int4, date_debut timestamp, duree interval);
	select into res_exotlc * from v2.af_get_resultat_exotlc_moyenne(id_resultat);
	total:=total+res_serie;
	nb:=nb+1;


    end if;

    end loop;
    if nb>0 then
	return total/nb;
    else
	return null;
    end if;

end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_resultat_parcours_exotlcs_score_partiel(bigint) OWNER TO pgsql;

--
-- TOC entry 9567 (class 0 OID 0)
-- Dependencies: 794
-- Name: FUNCTION xtlc_get_resultat_parcours_exotlcs_score_partiel(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_resultat_parcours_exotlcs_score_partiel(bigint) IS 'retourne le score aux exotlcs d''un parcours avant etape parcours oriente';


--
-- TOC entry 795 (class 1255 OID 2597475)
-- Dependencies: 2983 7
-- Name: xtlc_get_stagiaire_exotlcs_corriges_formation(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_stagiaire_exotlcs_corriges_formation(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : stagiaire
-- $2 : formation
declare
rec record;
begin
    for rec in
	select * from 
	v2.af_get_formation_etapes_type($2,'5') 
	as(id int4, libelle_pour_parcours varchar, libelle_etape  varchar,libelle_type_etape  varchar, type varchar,  pere int4, parcours int4, obligatoire bool, chrono int4, fin bool,libelle_type_original varchar, modifiable bool,indice integer) 
	where id in 
	(select r.etape from v2.resultat r where r.formation=$2 and r.stagiaire=$1 and r.id in 
	(select re.id from v2.resultat_exotlc re where re.date_correction is not null))
    loop
	return next rec;
    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_stagiaire_exotlcs_corriges_formation(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9568 (class 0 OID 0)
-- Dependencies: 795
-- Name: FUNCTION xtlc_get_stagiaire_exotlcs_corriges_formation(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_stagiaire_exotlcs_corriges_formation(integer, integer) IS 'retourne ts les exotlcs corriges pour un stagiaire et une formtion';


--
-- TOC entry 796 (class 1255 OID 2597476)
-- Dependencies: 2983 7
-- Name: xtlc_get_template(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_template(integer) RETURNS record
    AS $_$-- $1 : numero modele
declare
rec record;
begin
    select into rec id,libelle from v2.modele_correction where id=$1;
    return rec;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_template(integer) OWNER TO pgsql;

--
-- TOC entry 9569 (class 0 OID 0)
-- Dependencies: 796
-- Name: FUNCTION xtlc_get_template(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_template(integer) IS 'retourne un modele de correction (id,libelle)';


--
-- TOC entry 3928 (class 1259 OID 2597477)
-- Dependencies: 4953 7
-- Name: xtlc_modele_correction_criteres; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_modele_correction_criteres (
    modele_correction integer NOT NULL,
    critere integer NOT NULL,
    pere integer,
    note_max integer,
    CONSTRAINT check_note_max CHECK ((note_max > 0))
);


ALTER TABLE v2.xtlc_modele_correction_criteres OWNER TO postgres;

--
-- TOC entry 797 (class 1255 OID 2597480)
-- Dependencies: 2161 2983 7
-- Name: xtlc_get_template_associations(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_template_associations(integer) RETURNS SETOF xtlc_modele_correction_criteres
    AS $_$-- $1 : numero modele
declare
rec record;
rec2 record;
trans int4;
begin
    for rec in 
	select modele_correction,id,pere,note_max from v2.af_get_template_criteres($1) as (modele_correction int4,id int4,libelle varchar,pere int4,note_max int4)
    loop
	if rec.note_max is null then
	    return next rec;
	    -- cas d'un critere avec sous criteres
	    -- boucle sur ses sous criteres 
	
	    for rec2 in 
		select modele_correction,id,pere,note_max from v2.af_get_template_sous_criteres($1,rec.id) as (modele_correction int4,id int4,libelle varchar,pere int4,note_max int4)
	    loop
		trans:=rec2.id;
		rec2.id:=rec2.pere;
		rec2.pere:=trans;
		return next rec2;
	    end loop;
	else
	    return next rec;
        end if;
    end loop;
		
	
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_template_associations(integer) OWNER TO pgsql;

--
-- TOC entry 9571 (class 0 OID 0)
-- Dependencies: 797
-- Name: FUNCTION xtlc_get_template_associations(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_template_associations(integer) IS 'retourne les associations pour un modele de correction';


--
-- TOC entry 798 (class 1255 OID 2597481)
-- Dependencies: 2983 7
-- Name: xtlc_get_template_criteres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_template_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : nnumero modele
declare
rec record;
t_ids _int4;
i int4 :=0;
begin
    -- recup les criteres du modele ds 1 tablo
    for rec in 
	select c_id
	from v2.af_get_template_criteres_non_ordonnes($1) as (c_modele_correction int4,c_id int4,c_libelle varchar,c_pere int4,c_note_max int4)
    loop
	t_ids[i]:=rec.c_id;
	i:=i+1;
    end loop;	
    for rec in 
	select c_modele_correction,c_id,c_libelle,c_pere,c_note_max 
	from v2.af_gen_get_elements('v2.xtlc_modele_correction_criteres','critere',NULL,'and modele_correction='||$1,1,t_ids) ID,
	v2.af_get_template_criteres_non_ordonnes($1) as (c_modele_correction int4,c_id int4,c_libelle varchar,c_pere int4,c_note_max int4)
	where ID.id=c_id order by ID.ind
    loop
	return next rec;

    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_template_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 9572 (class 0 OID 0)
-- Dependencies: 798
-- Name: FUNCTION xtlc_get_template_criteres(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_template_criteres(integer) IS 'retourne les criteres d''un modele de correction (ds l''ordre)';


--
-- TOC entry 799 (class 1255 OID 2597482)
-- Dependencies: 2983 7
-- Name: xtlc_get_template_criteres_non_ordonnes(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_template_criteres_non_ordonnes(integer) RETURNS SETOF record
    AS $_$-- $1 : numero modele
declare
rec record;
begin
    for rec in
	select distinct mc.modele_correction,c_id,c_libelle,c_pere,mc.note_max from v2.af_get_criteres() as (c_id int4,c_libelle varchar,c_pere int4),
	v2.xtlc_modele_correction_criteres mc 
	where mc.modele_correction=$1 and c_id=mc.critere and c_pere is null
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_template_criteres_non_ordonnes(integer) OWNER TO pgsql;

--
-- TOC entry 9573 (class 0 OID 0)
-- Dependencies: 799
-- Name: FUNCTION xtlc_get_template_criteres_non_ordonnes(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_template_criteres_non_ordonnes(integer) IS 'retourne les criteres d''un modele de correction';


--
-- TOC entry 800 (class 1255 OID 2597483)
-- Dependencies: 2983 7
-- Name: xtlc_get_template_sous_criteres(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_template_sous_criteres(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero modele
-- $2 : numero critere
declare
rec record;
t_ids _int4;
i int4 :=0;
begin
    -- recup les sous criteres du modele ds 1 tablo
    for rec in 
	select c_id
	from v2.af_get_template_sous_criteres_non_ordonnes($1,$2) as (c_modele_correction int4,c_id int4,c_libelle varchar,c_pere int4,c_note_max int4)
    loop
	t_ids[i]:=rec.c_id;
	i:=i+1;
    end loop;	
    for rec in 
	select c_modele_correction,c_id,c_libelle,c_pere,c_note_max 
	from v2.af_gen_get_elements('v2.xtlc_modele_correction_criteres','critere',NULL,'and modele_correction='||$1,1,t_ids) ID,
	v2.af_get_template_sous_criteres_non_ordonnes($1,$2) as (c_modele_correction int4,c_id int4,c_libelle varchar,c_pere int4,c_note_max int4)
	where ID.id=c_id order by ID.ind
    loop
	return next rec;

    end loop;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_template_sous_criteres(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9574 (class 0 OID 0)
-- Dependencies: 800
-- Name: FUNCTION xtlc_get_template_sous_criteres(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_template_sous_criteres(integer, integer) IS 'retourne les sous criteres d''un modele ds l''ordre';


--
-- TOC entry 801 (class 1255 OID 2597484)
-- Dependencies: 2983 7
-- Name: xtlc_get_template_sous_criteres_non_ordonnes(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_template_sous_criteres_non_ordonnes(integer, integer) RETURNS SETOF record
    AS $_$-- $1 : numero modele
-- $2 : numero critere
declare
rec record;
begin
    for rec in 
	select distinct mc.modele_correction,c_id,c_libelle,c_pere,mc.note_max from v2.af_get_criteres() as (c_id int4,c_libelle varchar,c_pere int4),
	v2.xtlc_modele_correction_criteres mc where 
	mc.modele_correction=$1 and c_id=mc.critere and c_pere=$2
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_template_sous_criteres_non_ordonnes(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9575 (class 0 OID 0)
-- Dependencies: 801
-- Name: FUNCTION xtlc_get_template_sous_criteres_non_ordonnes(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_template_sous_criteres_non_ordonnes(integer, integer) IS 'retourn les sous critere pour un critere d''un modele de correction';


--
-- TOC entry 802 (class 1255 OID 2597485)
-- Dependencies: 2983 7
-- Name: xtlc_get_theme_criteres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_theme_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select C_id,C_libelle,C_pere from v2.af_get_criteres()  as (C_id int4,C_libelle varchar,C_pere int4),
	v2.af_get_categorie_elements_theme(12,$1) ET 
	where C_id=ET and C_pere is null
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_theme_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 9576 (class 0 OID 0)
-- Dependencies: 802
-- Name: FUNCTION xtlc_get_theme_criteres(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_theme_criteres(integer) IS 'retourne les criteres de correction pour un theme';


--
-- TOC entry 803 (class 1255 OID 2597486)
-- Dependencies: 2983 7
-- Name: xtlc_get_theme_exostlc_titre(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_theme_exostlc_titre(integer, character varying) RETURNS SETOF record
    AS $_$-- $1 : numero theme
-- $2 : asc ou desc
declare
rec record;
req varchar;
begin
    req:='select  GE_id ,GE_libelle ,lower(GE_libelle) as minus,E.type , GE_date_creation from v2.af_get_etapes() as (GE_id int4,GE_libelle varchar,GE_type int4, GE_date_creation timestamp) ,
    v2.categorie_exotlc CE,v2.exotlc E where GE_id=CE.id and GE_id=E.id and CE.theme='||$1||' order by minus ' || $2;
    for rec in
	execute req
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_theme_exostlc_titre(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9577 (class 0 OID 0)
-- Dependencies: 803
-- Name: FUNCTION xtlc_get_theme_exostlc_titre(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_theme_exostlc_titre(integer, character varying) IS 'retourne les exos tlc (classÃƒÂ©s par titre)pour un theme';


--
-- TOC entry 804 (class 1255 OID 2597487)
-- Dependencies: 2983 7
-- Name: xtlc_get_theme_exostlc_type(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_theme_exostlc_type(integer, character varying) RETURNS SETOF record
    AS $_$-- $1 : numero theme
-- $2 : asc ou desc
declare
rec record;
req varchar;
begin
    req:='select  GE_id ,GE_libelle,lower(GE_libelle) ,E.type, GE_date_creation from v2.af_get_etapes() as (GE_id int4,GE_libelle varchar,GE_type int4, GE_date_creation timestamp) ,
    v2.categorie_exotlc CE,v2.exotlc E where GE_id=CE.id and GE_id=E.id and CE.theme='||$1||' order by E.type ' || $2;
    for rec in
	execute req
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_theme_exostlc_type(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9578 (class 0 OID 0)
-- Dependencies: 804
-- Name: FUNCTION xtlc_get_theme_exostlc_type(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_theme_exostlc_type(integer, character varying) IS 'retourne les exos tlc (classÃƒÂ©s par type) pour un theme';


--
-- TOC entry 805 (class 1255 OID 2597488)
-- Dependencies: 2983 7
-- Name: xtlc_get_theme_modeles_correction(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_theme_modeles_correction(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select mc.id,mc.libelle from v2.modele_correction mc,
	v2.af_get_categorie_elements_theme(16,$1) tc 
	where mc.id=tc
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_theme_modeles_correction(integer) OWNER TO pgsql;

--
-- TOC entry 9579 (class 0 OID 0)
-- Dependencies: 805
-- Name: FUNCTION xtlc_get_theme_modeles_correction(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_theme_modeles_correction(integer) IS 'retorne les modeles de correction pour un theme';


--
-- TOC entry 806 (class 1255 OID 2597489)
-- Dependencies: 2983 7
-- Name: xtlc_get_theme_sous_criteres(integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_get_theme_sous_criteres(integer) RETURNS SETOF record
    AS $_$-- $1 : numero theme
declare
rec record;
begin
    for rec in 
	select C_id,C_libelle,C_pere from v2.af_get_criteres()  as (C_id int4,C_libelle varchar,C_pere int4),
	v2.af_get_categorie_elements_theme(12,$1) ET 
	where C_id=ET and C_pere is not null
    loop
	return next rec;
    end loop;
    return;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_get_theme_sous_criteres(integer) OWNER TO pgsql;

--
-- TOC entry 9580 (class 0 OID 0)
-- Dependencies: 806
-- Name: FUNCTION xtlc_get_theme_sous_criteres(integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_get_theme_sous_criteres(integer) IS 'retourne les sous criteres pour un theme';


--
-- TOC entry 807 (class 1255 OID 2597490)
-- Dependencies: 2983 7
-- Name: xtlc_is_resultat_exotlc_critere(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_is_resultat_exotlc_critere(integer, integer) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : critere
begin
    perform * from v2.resultat_exotlc_critere where id=$1 and critere=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_is_resultat_exotlc_critere(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9581 (class 0 OID 0)
-- Dependencies: 807
-- Name: FUNCTION xtlc_is_resultat_exotlc_critere(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_is_resultat_exotlc_critere(integer, integer) IS 'Verifie si un critere existe pour un identifiant de resultat';


--
-- TOC entry 808 (class 1255 OID 2597491)
-- Dependencies: 2983 7
-- Name: xtlc_is_resultat_exotlc_sous_critere(integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_is_resultat_exotlc_sous_critere(integer, integer) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : sous critere
begin
    perform * from v2.resultat_exotlc_sous_critere where id=$1 and sous_critere=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_is_resultat_exotlc_sous_critere(integer, integer) OWNER TO pgsql;

--
-- TOC entry 9582 (class 0 OID 0)
-- Dependencies: 808
-- Name: FUNCTION xtlc_is_resultat_exotlc_sous_critere(integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_is_resultat_exotlc_sous_critere(integer, integer) IS 'Verifie si un sous critere existe pour un identifiant de resultat';


--
-- TOC entry 809 (class 1255 OID 2597492)
-- Dependencies: 2983 7
-- Name: xtlc_maj_critere(integer, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_maj_critere(integer, character varying) RETURNS boolean
    AS $_$-- $1 : numero critere
-- $2 : libelle
begin
    update v2.critere set libelle=$2 where id=$1;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_maj_critere(integer, character varying) OWNER TO pgsql;

--
-- TOC entry 9583 (class 0 OID 0)
-- Dependencies: 809
-- Name: FUNCTION xtlc_maj_critere(integer, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_maj_critere(integer, character varying) IS 'met Ãƒ  jour un critere';


--
-- TOC entry 810 (class 1255 OID 2597493)
-- Dependencies: 2983 7
-- Name: xtlc_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) RETURNS boolean
    AS $_$-- $1 : numero exotlc
-- $2 : titre
-- $3 : commentaire
-- $4 : texte
-- $5 : enonce
-- $6 : remarque
-- $7 : numero formateur
declare
modif1 bool:=false;
modif2 bool:=false;
begin
    -- mise Ãƒ  jour du titre
    UPDATE v2.etape SET libelle=$2 WHERE id=$1;
    modif1:=found;
    -- mise Ãƒ  jour exotlc
    update v2.exotlc set commentaire=$3,texte=$4,enonce=$5,remarque=$6 where id=$1;
    modif2:=found;
    -- mise Ãƒ  jour fformateur
    update v2.exotlc_mail set formateur=$7 where id=$1;
    return modif1 or modif2 or found;


end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9584 (class 0 OID 0)
-- Dependencies: 810
-- Name: FUNCTION xtlc_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) IS 'met Ãƒ  jour un exotlc mail';


--
-- TOC entry 811 (class 1255 OID 2597494)
-- Dependencies: 2983 7
-- Name: xtlc_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying) RETURNS boolean
    AS $_$-- $1 : numero exotlc
-- $2 : titre exotlc
-- $3 : commentaire
-- $4 : texte
-- $5 : enonce
-- $6 : remarque
-- $7 : fichier rendu
declare
modif1 bool:=false;
modif2 bool:=false;
begin
    -- mise Ãƒ  jour du titre
    UPDATE v2.etape SET libelle=$2 WHERE id=$1;
    modif1:=found;
    -- mise Ãƒ  jour exotlc
    update v2.exotlc set commentaire=$3,texte=$4,enonce=$5,remarque=$6 where id=$1;
    modif2:=found;
    -- mise Ãƒ  jour fichier rendu
    update v2.exotlc_plate_forme set fichier_rendu=$7 where id=$1;
    return modif1 or modif2 or found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 9585 (class 0 OID 0)
-- Dependencies: 811
-- Name: FUNCTION xtlc_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying) IS 'met Ãƒ  jour un exotlc plateforme';


--
-- TOC entry 812 (class 1255 OID 2597495)
-- Dependencies: 2983 7
-- Name: xtlc_maj_modele_correction_criteres_note(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_maj_modele_correction_criteres_note(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero modele
-- $2 : numero critere
-- $3 : numero pere
-- $4 : note
begin
    if $3 is not null then	
    update v2.xtlc_modele_correction_criteres set note_max=$4 
    where modele_correction=$1 and critere=$2 and pere=$3;
    else
    update v2.xtlc_modele_correction_criteres set note_max=$4 
    where modele_correction=$1 and critere=$2 and pere is null;
    end if;
    return found;
end$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_maj_modele_correction_criteres_note(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9586 (class 0 OID 0)
-- Dependencies: 812
-- Name: FUNCTION xtlc_maj_modele_correction_criteres_note(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_maj_modele_correction_criteres_note(integer, integer, integer, integer) IS 'met Ãƒ  jour la note dans un modele de correction';


--
-- TOC entry 813 (class 1255 OID 2597496)
-- Dependencies: 2983 7
-- Name: xtlc_maj_resultat_exotlc(integer, text, boolean); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_maj_resultat_exotlc(integer, text, boolean) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : commentaire
-- $3 : correction
begin
    update v2.resultat_exotlc 
    set commentaire=$2,correction=$3,date_correction=now() 
    where id=$1;
    return found;	
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_maj_resultat_exotlc(integer, text, boolean) OWNER TO pgsql;

--
-- TOC entry 9587 (class 0 OID 0)
-- Dependencies: 813
-- Name: FUNCTION xtlc_maj_resultat_exotlc(integer, text, boolean); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_maj_resultat_exotlc(integer, text, boolean) IS 'met Ãƒ  jour les reultats pour un identifiant de resultat';


--
-- TOC entry 814 (class 1255 OID 2597497)
-- Dependencies: 2983 7
-- Name: xtlc_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : critere
-- $3 : note
-- $4 : note_max
-- $5 : commentaire
begin
    update v2.resultat_exotlc_critere 
    set note=$3,note_max=$4,commentaire=$5 
    where id=$1 and critere=$2;
    return found;	
end; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 9588 (class 0 OID 0)
-- Dependencies: 814
-- Name: FUNCTION xtlc_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) IS 'Modifie les resultats d''un critere pour un identifiant de resultat';


--
-- TOC entry 815 (class 1255 OID 2597498)
-- Dependencies: 2983 7
-- Name: xtlc_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : sous critere
-- $3 : note
-- $4 : note max
begin
    update v2.resultat_exotlc_sous_critere 
    set note=$3,note_max=$4 
    where id=$1 and sous_critere=$2;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9589 (class 0 OID 0)
-- Dependencies: 815
-- Name: FUNCTION xtlc_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) IS 'modifie les resultats d''un sous critere pour un identifiant de resultat';


--
-- TOC entry 816 (class 1255 OID 2597499)
-- Dependencies: 2983 7
-- Name: xtlc_set_critere(character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_critere(character varying, integer) RETURNS integer
    AS $_$-- $1 : libelle
-- $2 : pere

declare
new_id int4;
res int4;
begin
    insert into v2.critere(libelle,pere) values($1,$2);
    --RECUPERE L'IDENTIFIANT DU NOUVEAU CRITERE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.critere WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_critere(character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9590 (class 0 OID 0)
-- Dependencies: 816
-- Name: FUNCTION xtlc_set_critere(character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_critere(character varying, integer) IS 'enregistre un critere de correction';


--
-- TOC entry 817 (class 1255 OID 2597500)
-- Dependencies: 2983 7
-- Name: xtlc_set_exotlc_corrections(integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_exotlc_corrections(integer, integer[]) RETURNS integer
    AS $_$-- $1 : numero exotlc
-- $2 : tableau de fichiers correction
declare
i int4;
nb int4 :=0;
begin
    for i in array_lower($2,1) .. array_upper($2,1)
loop
    insert into v2.exotlc_corrections(exotlc,correction) 
    values($1,$2[i]);
    if found then
	nb:=nb+1;
    end if;
end loop;
return nb;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_exotlc_corrections(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 9591 (class 0 OID 0)
-- Dependencies: 817
-- Name: FUNCTION xtlc_set_exotlc_corrections(integer, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_exotlc_corrections(integer, integer[]) IS 'enregistre les fichiers correzction pour un exotlc';


--
-- TOC entry 818 (class 1255 OID 2597501)
-- Dependencies: 2983 7
-- Name: xtlc_set_exotlc_fichiers(integer, integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_exotlc_fichiers(integer, integer[]) RETURNS integer
    AS $_$-- $1 : numero exotlc
-- $2 : tableau de fichiers
declare
i int4;
nb int4 :=0;
begin
    for i in array_lower($2,1) .. array_upper($2,1)
loop
    insert into v2.exotlc_fichiers(exotlc,fichier) 
    values($1,$2[i]);
    if found then
	nb:=nb+1;
    end if;
end loop;
return nb;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_exotlc_fichiers(integer, integer[]) OWNER TO pgsql;

--
-- TOC entry 9592 (class 0 OID 0)
-- Dependencies: 818
-- Name: FUNCTION xtlc_set_exotlc_fichiers(integer, integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_exotlc_fichiers(integer, integer[]) IS 'enregistre les fichiers pour un exotlc';


--
-- TOC entry 819 (class 1255 OID 2597502)
-- Dependencies: 2983 7
-- Name: xtlc_set_exotlc_fichiers_all(integer, integer[], integer[]); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_exotlc_fichiers_all(integer, integer[], integer[]) RETURNS boolean
    AS $_$-- $1 : numero exotlc
-- $2 : tableau des fichiers exotlc
-- $3 : tableau des fichiers correction
declare
nb_fichier_exotlc int4;
nb_fichier_correction int4;
begin
    select into nb_fichier_exotlc * from v2.af_set_exotlc_fichiers($1,$2);
    select into nb_fichier_correction * from v2.af_set_exotlc_corrections($1,$3);
    return (nb_fichier_exotlc>0 and nb_fichier_correction>0);
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_exotlc_fichiers_all(integer, integer[], integer[]) OWNER TO pgsql;

--
-- TOC entry 9593 (class 0 OID 0)
-- Dependencies: 819
-- Name: FUNCTION xtlc_set_exotlc_fichiers_all(integer, integer[], integer[]); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_exotlc_fichiers_all(integer, integer[], integer[]) IS 'enregistre les fichiers exotlc et fichiers correction pour un exotlc';


--
-- TOC entry 820 (class 1255 OID 2597503)
-- Dependencies: 2983 7
-- Name: xtlc_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) RETURNS integer
    AS $_$-- $1 : titre exo
-- $2 : commentaire
-- $3 : texte
-- $4 : enonce
-- $5 : remarque
-- $6 : numero formateur
declare
new_id int4;
res int4;
begin
    INSERT INTO v2.etape(libelle, type) VALUES ($1, 5);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.etape WHERE oid=new_id;
    -- insertion ds exotlc
    insert into v2.exotlc(id,commentaire,texte,enonce,remarque,type) 
    values(res,$2,$3,$4,$5,2);
    -- insertion fichier rendu
    insert into v2.exotlc_mail(id,formateur) values(res,$6);
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) OWNER TO pgsql;

--
-- TOC entry 9594 (class 0 OID 0)
-- Dependencies: 820
-- Name: FUNCTION xtlc_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) IS 'enregistre un exotlc mail';


--
-- TOC entry 821 (class 1255 OID 2597504)
-- Dependencies: 2983 7
-- Name: xtlc_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying) RETURNS integer
    AS $_$-- $1 : titre exo
-- $2 : commentaire
-- $3 : texte
-- $4 : ennoce
-- $5 : remarque
-- $6 : nom fichier rendu
declare
new_id int4;
res int4;
begin
    INSERT INTO v2.etape(libelle, type) VALUES ($1, 5);
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.etape WHERE oid=new_id;
    -- insertion ds exotlc
    insert into v2.exotlc(id,commentaire,texte,enonce,remarque,type) 
    values(res,$2,$3,$4,$5,1);
    -- insertion fichier rendu
    insert into v2.exotlc_plate_forme(id,fichier_rendu) values(res,$6);
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying) OWNER TO pgsql;

--
-- TOC entry 9595 (class 0 OID 0)
-- Dependencies: 821
-- Name: FUNCTION xtlc_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying) IS 'enregistre un exotlc plateforme';


--
-- TOC entry 822 (class 1255 OID 2597505)
-- Dependencies: 2983 7
-- Name: xtlc_set_modele_correction(character varying); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_modele_correction(character varying) RETURNS integer
    AS $_$-- $1 : libelle modele correction
declare
new_id int4;
res int4;
begin
    insert into v2.modele_correction(libelle) values($1);
    --RECUPERE L'IDENTIFIANT DU NOUVEAU CRITERE
    GET DIAGNOSTICS new_id = RESULT_OID;
    SELECT INTO res id FROM v2.modele_correction WHERE oid=new_id;
    return res;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_modele_correction(character varying) OWNER TO pgsql;

--
-- TOC entry 9596 (class 0 OID 0)
-- Dependencies: 822
-- Name: FUNCTION xtlc_set_modele_correction(character varying); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_modele_correction(character varying) IS 'enregistre un modele de correction';


--
-- TOC entry 823 (class 1255 OID 2597506)
-- Dependencies: 2983 7
-- Name: xtlc_set_modele_correction_criteres(integer, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_modele_correction_criteres(integer, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : numero modele
-- $2 : numero critere
-- $3 : numero pere
-- $4 : note
begin
    insert into v2.xtlc_modele_correction_criteres(modele_correction,critere,pere,note_max) 
    values($1,$2,$3,$4);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_modele_correction_criteres(integer, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9597 (class 0 OID 0)
-- Dependencies: 823
-- Name: FUNCTION xtlc_set_modele_correction_criteres(integer, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_modele_correction_criteres(integer, integer, integer, integer) IS 'enregistre dans modele_correction_criteres';


--
-- TOC entry 824 (class 1255 OID 2597507)
-- Dependencies: 2983 7
-- Name: xtlc_set_resultat_exotlc(bigint); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_resultat_exotlc(bigint) RETURNS boolean
    AS $_$-- $1 : id resultat

begin
    -- test si existe
    perform * from v2.resultat_exotlc where id=$1;
    if not found then
	insert into v2.resultat_exotlc (id) values($1);
    end if;
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_resultat_exotlc(bigint) OWNER TO pgsql;

--
-- TOC entry 9598 (class 0 OID 0)
-- Dependencies: 824
-- Name: FUNCTION xtlc_set_resultat_exotlc(bigint); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_resultat_exotlc(bigint) IS 'insere l''identifiant de resultat dans la table resultat_exotlc';


--
-- TOC entry 825 (class 1255 OID 2597508)
-- Dependencies: 2983 7
-- Name: xtlc_set_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : critere
-- $3 : note
-- $4 : note_max
-- $5 : commentaire
begin
    insert into v2.resultat_exotlc_critere(id,critere,note,note_max,commentaire) 
    values($1,$2,$3,$4,$5);
    return found;	
end; $_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) OWNER TO pgsql;

--
-- TOC entry 9599 (class 0 OID 0)
-- Dependencies: 825
-- Name: FUNCTION xtlc_set_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) IS 'Enregistre les resultats d''un critere pour un identifiant de resultat';


--
-- TOC entry 826 (class 1255 OID 2597509)
-- Dependencies: 2983 7
-- Name: xtlc_set_resultat_exotlc_plateforme(bigint, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_resultat_exotlc_plateforme(bigint, integer) RETURNS boolean
    AS $_$DECLARE
--$1 resultat
--$2 fichier_rendu
ok boolean;
BEGIN
	SELECT INTO ok * FROM v2.af_set_resultat_fin($1);

	INSERT INTO v2.resultat_exotlc
	(id,fichier_rendu)
	VALUES ($1,$2);
	
	RETURN FOUND AND ok;
END;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_resultat_exotlc_plateforme(bigint, integer) OWNER TO pgsql;

--
-- TOC entry 827 (class 1255 OID 2597510)
-- Dependencies: 2983 7
-- Name: xtlc_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: FUNCTION; Schema: v2; Owner: pgsql
--

CREATE FUNCTION xtlc_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) RETURNS boolean
    AS $_$-- $1 : id resultat
-- $2 : sous critere
-- $3 : note
-- $4 : note max
begin
    insert into v2.resultat_exotlc_sous_critere(id,sous_critere,note,note_max) 
    values($1,$2,$3,$4);
    return found;
end;$_$
    LANGUAGE plpgsql;


ALTER FUNCTION v2.xtlc_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) OWNER TO pgsql;

--
-- TOC entry 9600 (class 0 OID 0)
-- Dependencies: 827
-- Name: FUNCTION xtlc_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: COMMENT; Schema: v2; Owner: pgsql
--

COMMENT ON FUNCTION xtlc_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) IS 'enregistre les resultats d''un sous critere pour un identifiant de resultat';


SET search_path = contraintes, pg_catalog;

--
-- TOC entry 3929 (class 1259 OID 2597511)
-- Dependencies: 4954 4955 4956 5
-- Name: active_sessions; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE active_sessions (
    sid character varying(32) DEFAULT ''::character varying NOT NULL,
    name character varying(32) DEFAULT ''::character varying NOT NULL,
    val text,
    changed character varying(14) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE contraintes.active_sessions OWNER TO pgsql;

--
-- TOC entry 3931 (class 1259 OID 2597521)
-- Dependencies: 5
-- Name: alerte; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE alerte (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    formation integer,
    date date,
    jours integer,
    texte text
);


ALTER TABLE contraintes.alerte OWNER TO postgres;

--
-- TOC entry 9602 (class 0 OID 0)
-- Dependencies: 3931
-- Name: TABLE alerte; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE alerte IS 'Contient les alertes associÃ©es Ã  une formation.';


--
-- TOC entry 3932 (class 1259 OID 2597527)
-- Dependencies: 4958 4959 4960 5
-- Name: articles; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE articles (
    id integer DEFAULT nextval(('"articles_id_seq"'::text)::regclass) NOT NULL,
    "time" timestamp with time zone,
    author character varying(128),
    email character varying(50),
    subject character varying(50),
    body character varying,
    is_parent boolean DEFAULT false,
    subs character varying,
    parent integer,
    "level" integer,
    root integer,
    ip character varying(16),
    views integer,
    forum integer,
    moderation_state integer DEFAULT 0,
    attach character varying(30)
);


ALTER TABLE contraintes.articles OWNER TO pgsql;

--
-- TOC entry 3934 (class 1259 OID 2597537)
-- Dependencies: 5
-- Name: bareme; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE bareme (
    id serial NOT NULL,
    libelle character varying(255),
    juste integer,
    fausse integer,
    manquantes integer,
    toutes integer
);


ALTER TABLE contraintes.bareme OWNER TO postgres;

--
-- TOC entry 9606 (class 0 OID 0)
-- Dependencies: 3934
-- Name: TABLE bareme; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE bareme IS 'Contient les barÃ¨mes de la plateforme';


--
-- TOC entry 3935 (class 1259 OID 2597540)
-- Dependencies: 5
-- Name: block_ip; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE block_ip (
    ip character varying(39)
);


ALTER TABLE contraintes.block_ip OWNER TO postgres;

--
-- TOC entry 3936 (class 1259 OID 2597542)
-- Dependencies: 4962 4963 5
-- Name: c_ban_users; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE c_ban_users (
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    ip character varying(16) NOT NULL,
    rooms character varying(100) NOT NULL,
    ban_until integer DEFAULT 0 NOT NULL
);


ALTER TABLE contraintes.c_ban_users OWNER TO postgres;

--
-- TOC entry 3937 (class 1259 OID 2597546)
-- Dependencies: 4964 4965 4966 5
-- Name: c_messages; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE c_messages (
    "type" smallint DEFAULT (0)::smallint NOT NULL,
    room character varying(256) NOT NULL,
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    m_time integer DEFAULT 0 NOT NULL,
    address character varying(30) NOT NULL,
    message text NOT NULL
);


ALTER TABLE contraintes.c_messages OWNER TO postgres;

--
-- TOC entry 3938 (class 1259 OID 2597554)
-- Dependencies: 4967 4968 4969 5
-- Name: c_reg_users; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE c_reg_users (
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    "password" character varying(32) NOT NULL,
    perms character varying(9) NOT NULL,
    rooms character varying(128) NOT NULL,
    reg_time integer DEFAULT 0 NOT NULL,
    ip character varying(16) NOT NULL,
    gender smallint DEFAULT (0)::smallint NOT NULL
);


ALTER TABLE contraintes.c_reg_users OWNER TO postgres;

--
-- TOC entry 3939 (class 1259 OID 2597559)
-- Dependencies: 4970 4971 5
-- Name: c_users; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE c_users (
    room character varying(256) NOT NULL,
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    u_time integer DEFAULT 0 NOT NULL,
    status character varying(1) NOT NULL,
    ip character varying(16) NOT NULL
);


ALTER TABLE contraintes.c_users OWNER TO postgres;

--
-- TOC entry 3941 (class 1259 OID 2597565)
-- Dependencies: 5
-- Name: capacite; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE capacite (
    id serial NOT NULL,
    libelle character varying(255)
);


ALTER TABLE contraintes.capacite OWNER TO postgres;

--
-- TOC entry 9614 (class 0 OID 0)
-- Dependencies: 3941
-- Name: TABLE capacite; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE capacite IS 'Contient les capacitÃ©s pour le prÃ©sentiel.';


--
-- TOC entry 3943 (class 1259 OID 2597570)
-- Dependencies: 5
-- Name: capacite_titre; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE capacite_titre (
    id serial NOT NULL,
    libelle character varying(255)
);


ALTER TABLE contraintes.capacite_titre OWNER TO postgres;

--
-- TOC entry 9617 (class 0 OID 0)
-- Dependencies: 3943
-- Name: TABLE capacite_titre; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE capacite_titre IS 'Contient les titres de capacitÃ© associÃ©s Ã  une grille (pour le prÃ©sentiel).';


--
-- TOC entry 3944 (class 1259 OID 2597573)
-- Dependencies: 5
-- Name: capacite_titre_capacites; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE capacite_titre_capacites (
    capacite_titre integer NOT NULL,
    capacite integer NOT NULL
);


ALTER TABLE contraintes.capacite_titre_capacites OWNER TO postgres;

--
-- TOC entry 9619 (class 0 OID 0)
-- Dependencies: 3944
-- Name: TABLE capacite_titre_capacites; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE capacite_titre_capacites IS 'Contient les capacitÃ©s associÃ©es Ã  un titre de capacitÃ© (pour le prÃ©sentiel).';


--
-- TOC entry 3946 (class 1259 OID 2597577)
-- Dependencies: 5
-- Name: carton; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE carton (
    id serial NOT NULL,
    libelle character varying(255),
    couleur character varying(6),
    code character varying(3)
);


ALTER TABLE contraintes.carton OWNER TO postgres;

--
-- TOC entry 9622 (class 0 OID 0)
-- Dependencies: 3946
-- Name: TABLE carton; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE carton IS 'Contient les caractÃ©ristiques des cartons pour le prÃ©sentiel.';


--
-- TOC entry 3948 (class 1259 OID 2597582)
-- Dependencies: 4976 5
-- Name: categorie; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie (
    id serial NOT NULL,
    libelle character varying(1024),
    table_cible character varying(1024) NOT NULL,
    gestionnaire_contenu boolean DEFAULT false,
    table_etape character varying
);


ALTER TABLE contraintes.categorie OWNER TO postgres;

--
-- TOC entry 3949 (class 1259 OID 2597589)
-- Dependencies: 5
-- Name: categorie_capacite; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_capacite (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_capacite OWNER TO postgres;

--
-- TOC entry 9626 (class 0 OID 0)
-- Dependencies: 3949
-- Name: TABLE categorie_capacite; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_capacite IS 'Les associations capacitÃ©-theme';


--
-- TOC entry 3950 (class 1259 OID 2597591)
-- Dependencies: 5
-- Name: categorie_capacite_titre; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_capacite_titre (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_capacite_titre OWNER TO postgres;

--
-- TOC entry 9628 (class 0 OID 0)
-- Dependencies: 3950
-- Name: TABLE categorie_capacite_titre; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_capacite_titre IS 'Les association capacite_titre-theme';


--
-- TOC entry 3951 (class 1259 OID 2597593)
-- Dependencies: 5
-- Name: categorie_critere; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_critere (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_critere OWNER TO postgres;

--
-- TOC entry 9630 (class 0 OID 0)
-- Dependencies: 3951
-- Name: TABLE categorie_critere; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_critere IS 'Les associations critere-theme';


--
-- TOC entry 3952 (class 1259 OID 2597595)
-- Dependencies: 5
-- Name: categorie_etape; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_etape (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_etape OWNER TO postgres;

--
-- TOC entry 3953 (class 1259 OID 2597597)
-- Dependencies: 5
-- Name: categorie_etape_forum; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_etape_forum (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_etape_forum OWNER TO postgres;

--
-- TOC entry 3954 (class 1259 OID 2597599)
-- Dependencies: 5
-- Name: categorie_etape_ressource; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_etape_ressource (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_etape_ressource OWNER TO postgres;

--
-- TOC entry 3955 (class 1259 OID 2597601)
-- Dependencies: 5
-- Name: categorie_evaluation; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_evaluation (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_evaluation OWNER TO postgres;

--
-- TOC entry 3956 (class 1259 OID 2597603)
-- Dependencies: 5
-- Name: categorie_exotlc; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_exotlc (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_exotlc OWNER TO postgres;

--
-- TOC entry 3957 (class 1259 OID 2597605)
-- Dependencies: 5
-- Name: categorie_fichier_bloc_scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_bloc_scenario (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_bloc_scenario OWNER TO postgres;

--
-- TOC entry 3958 (class 1259 OID 2597607)
-- Dependencies: 5
-- Name: categorie_fichier_correction; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_correction (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_correction OWNER TO postgres;

--
-- TOC entry 9638 (class 0 OID 0)
-- Dependencies: 3958
-- Name: TABLE categorie_fichier_correction; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_fichier_correction IS 'Les associations fichier_correction-theme';


--
-- TOC entry 3959 (class 1259 OID 2597609)
-- Dependencies: 5
-- Name: categorie_fichier_css; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_css (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_css OWNER TO postgres;

--
-- TOC entry 9640 (class 0 OID 0)
-- Dependencies: 3959
-- Name: TABLE categorie_fichier_css; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_fichier_css IS 'Les associations css-theme';


--
-- TOC entry 3960 (class 1259 OID 2597611)
-- Dependencies: 5
-- Name: categorie_fichier_etape_scorm; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_etape_scorm (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_etape_scorm OWNER TO postgres;

--
-- TOC entry 9642 (class 0 OID 0)
-- Dependencies: 3960
-- Name: TABLE categorie_fichier_etape_scorm; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_fichier_etape_scorm IS 'Les association scorm-theme';


--
-- TOC entry 3961 (class 1259 OID 2597613)
-- Dependencies: 5
-- Name: categorie_fichier_exotlc; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_exotlc (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_exotlc OWNER TO postgres;

--
-- TOC entry 9644 (class 0 OID 0)
-- Dependencies: 3961
-- Name: TABLE categorie_fichier_exotlc; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_fichier_exotlc IS 'Les associations fichier_exotlc-theme';


--
-- TOC entry 3962 (class 1259 OID 2597615)
-- Dependencies: 5
-- Name: categorie_fichier_glossaire; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_glossaire (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_glossaire OWNER TO postgres;

--
-- TOC entry 3963 (class 1259 OID 2597617)
-- Dependencies: 5
-- Name: categorie_fichier_media_evaluation; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_media_evaluation (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_media_evaluation OWNER TO postgres;

--
-- TOC entry 9647 (class 0 OID 0)
-- Dependencies: 3963
-- Name: TABLE categorie_fichier_media_evaluation; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_fichier_media_evaluation IS 'Association theme/mÃ©dias de scenario';


--
-- TOC entry 3964 (class 1259 OID 2597619)
-- Dependencies: 5
-- Name: categorie_fichier_media_exotlc; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_media_exotlc (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_media_exotlc OWNER TO postgres;

--
-- TOC entry 9649 (class 0 OID 0)
-- Dependencies: 3964
-- Name: TABLE categorie_fichier_media_exotlc; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_fichier_media_exotlc IS 'Association theme/mÃ©dias de scenario';


--
-- TOC entry 3965 (class 1259 OID 2597621)
-- Dependencies: 5
-- Name: categorie_fichier_media_scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_media_scenario (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_media_scenario OWNER TO postgres;

--
-- TOC entry 9651 (class 0 OID 0)
-- Dependencies: 3965
-- Name: TABLE categorie_fichier_media_scenario; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_fichier_media_scenario IS 'Association theme/mÃ©dias de scenario';


--
-- TOC entry 3966 (class 1259 OID 2597623)
-- Dependencies: 5
-- Name: categorie_fichier_ressource; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_ressource (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_ressource OWNER TO postgres;

--
-- TOC entry 3967 (class 1259 OID 2597625)
-- Dependencies: 5
-- Name: categorie_fichier_ressource_fichier; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_ressource_fichier (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_ressource_fichier OWNER TO postgres;

--
-- TOC entry 9654 (class 0 OID 0)
-- Dependencies: 3967
-- Name: TABLE categorie_fichier_ressource_fichier; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_fichier_ressource_fichier IS 'Les associations ressource-theme';


--
-- TOC entry 3968 (class 1259 OID 2597627)
-- Dependencies: 5
-- Name: categorie_fichier_ressource_texte; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_ressource_texte (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_ressource_texte OWNER TO postgres;

--
-- TOC entry 3969 (class 1259 OID 2597629)
-- Dependencies: 5
-- Name: categorie_fichier_scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_scenario (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_scenario OWNER TO postgres;

--
-- TOC entry 9657 (class 0 OID 0)
-- Dependencies: 3969
-- Name: TABLE categorie_fichier_scenario; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_fichier_scenario IS 'Les associations scenario-theme';


--
-- TOC entry 3970 (class 1259 OID 2597631)
-- Dependencies: 5
-- Name: categorie_fichier_scenario_dynamique; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_scenario_dynamique (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_scenario_dynamique OWNER TO postgres;

--
-- TOC entry 3971 (class 1259 OID 2597633)
-- Dependencies: 5
-- Name: categorie_fichier_slide_scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_fichier_slide_scenario (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_fichier_slide_scenario OWNER TO postgres;

--
-- TOC entry 3972 (class 1259 OID 2597635)
-- Dependencies: 5
-- Name: categorie_ftb; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_ftb (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_ftb OWNER TO postgres;

--
-- TOC entry 9661 (class 0 OID 0)
-- Dependencies: 3972
-- Name: TABLE categorie_ftb; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_ftb IS 'Les associatons ftb-theme';


--
-- TOC entry 3973 (class 1259 OID 2597637)
-- Dependencies: 5
-- Name: categorie_glossaire; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_glossaire (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_glossaire OWNER TO postgres;

--
-- TOC entry 3974 (class 1259 OID 2597639)
-- Dependencies: 5
-- Name: categorie_grille; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_grille (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_grille OWNER TO postgres;

--
-- TOC entry 9664 (class 0 OID 0)
-- Dependencies: 3974
-- Name: TABLE categorie_grille; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_grille IS 'Les association grille-theme';


--
-- TOC entry 3975 (class 1259 OID 2597641)
-- Dependencies: 5
-- Name: categorie_modele_correction; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_modele_correction (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_modele_correction OWNER TO postgres;

--
-- TOC entry 9667 (class 0 OID 0)
-- Dependencies: 3975
-- Name: TABLE categorie_modele_correction; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_modele_correction IS 'Les associations modele_correction-theme';


--
-- TOC entry 3976 (class 1259 OID 2597643)
-- Dependencies: 5
-- Name: categorie_positionnement; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_positionnement (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_positionnement OWNER TO postgres;

--
-- TOC entry 3977 (class 1259 OID 2597645)
-- Dependencies: 5
-- Name: categorie_qsrc; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_qsrc (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_qsrc OWNER TO postgres;

--
-- TOC entry 3978 (class 1259 OID 2597647)
-- Dependencies: 5
-- Name: categorie_question_reponse; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_question_reponse (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_question_reponse OWNER TO postgres;

--
-- TOC entry 3979 (class 1259 OID 2597649)
-- Dependencies: 5
-- Name: categorie_question_reponse_element; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_question_reponse_element (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_question_reponse_element OWNER TO postgres;

--
-- TOC entry 9672 (class 0 OID 0)
-- Dependencies: 3979
-- Name: TABLE categorie_question_reponse_element; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_question_reponse_element IS 'Les association grille-theme';


--
-- TOC entry 3980 (class 1259 OID 2597651)
-- Dependencies: 5
-- Name: categorie_scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_scenario (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_scenario OWNER TO postgres;

--
-- TOC entry 3981 (class 1259 OID 2597653)
-- Dependencies: 5
-- Name: categorie_scenario_dynamique; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_scenario_dynamique (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_scenario_dynamique OWNER TO postgres;

--
-- TOC entry 3982 (class 1259 OID 2597655)
-- Dependencies: 5
-- Name: categorie_serie; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_serie (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_serie OWNER TO postgres;

--
-- TOC entry 9676 (class 0 OID 0)
-- Dependencies: 3982
-- Name: TABLE categorie_serie; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_serie IS 'Les associations serie-theme';


--
-- TOC entry 3983 (class 1259 OID 2597657)
-- Dependencies: 5
-- Name: categorie_sondage_element; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_sondage_element (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_sondage_element OWNER TO postgres;

--
-- TOC entry 9678 (class 0 OID 0)
-- Dependencies: 3983
-- Name: TABLE categorie_sondage_element; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE categorie_sondage_element IS 'Les association grille-theme';


--
-- TOC entry 3984 (class 1259 OID 2597659)
-- Dependencies: 5
-- Name: categorie_test; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE categorie_test (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE contraintes.categorie_test OWNER TO postgres;

--
-- TOC entry 3985 (class 1259 OID 2597661)
-- Dependencies: 5
-- Name: choix; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE choix (
    id integer NOT NULL,
    question_reponse integer,
    bareme integer,
    pere integer
);


ALTER TABLE contraintes.choix OWNER TO postgres;

--
-- TOC entry 9681 (class 0 OID 0)
-- Dependencies: 3985
-- Name: TABLE choix; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE choix IS 'pour un positionnement,  stockage des réponses et du nombre d''evaluations qu''elles generent.';


--
-- TOC entry 3987 (class 1259 OID 2597665)
-- Dependencies: 5
-- Name: classe; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE classe (
    id serial NOT NULL,
    libelle character varying(255),
    pere integer,
    min integer,
    max integer
);


ALTER TABLE contraintes.classe OWNER TO postgres;

--
-- TOC entry 9683 (class 0 OID 0)
-- Dependencies: 3987
-- Name: TABLE classe; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE classe IS 'Contient les classes virtuelles (les groupes).';


--
-- TOC entry 3988 (class 1259 OID 2597668)
-- Dependencies: 5
-- Name: classe_individus; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE classe_individus (
    classe integer NOT NULL,
    individu integer NOT NULL
);


ALTER TABLE contraintes.classe_individus OWNER TO postgres;

--
-- TOC entry 9686 (class 0 OID 0)
-- Dependencies: 3988
-- Name: TABLE classe_individus; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE classe_individus IS 'Pour affilier des individus Ã  une classe.';


SET default_with_oids = false;

--
-- TOC entry 3989 (class 1259 OID 2597670)
-- Dependencies: 4978 5
-- Name: commentaire_etape; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE commentaire_etape (
    etape integer NOT NULL,
    min integer NOT NULL,
    max integer NOT NULL,
    commentaire text,
    CONSTRAINT check_min_max CHECK ((min <= max))
);


ALTER TABLE contraintes.commentaire_etape OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 3990 (class 1259 OID 2597676)
-- Dependencies: 4979 5
-- Name: connexion; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE connexion (
    sid character varying(32) NOT NULL,
    name character varying(32) NOT NULL,
    start_time timestamp without time zone DEFAULT now() NOT NULL,
    referer character varying(1024) NOT NULL,
    addr character varying(15) NOT NULL,
    user_agent character varying(250) NOT NULL,
    user_id integer
);


ALTER TABLE contraintes.connexion OWNER TO pgsql;

--
-- TOC entry 3991 (class 1259 OID 2597682)
-- Dependencies: 5
-- Name: connexion_old; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE connexion_old (
    individu integer NOT NULL,
    connexion timestamp without time zone NOT NULL,
    deconnexion timestamp without time zone,
    ip character varying(39)
);


ALTER TABLE contraintes.connexion_old OWNER TO postgres;

--
-- TOC entry 9690 (class 0 OID 0)
-- Dependencies: 3991
-- Name: TABLE connexion_old; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE connexion_old IS 'Pour le stockage des connexions d''un individu en front-office.';


--
-- TOC entry 3993 (class 1259 OID 2597686)
-- Dependencies: 5
-- Name: critere; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE critere (
    id serial NOT NULL,
    libelle character varying,
    pere integer
);


ALTER TABLE contraintes.critere OWNER TO postgres;

--
-- TOC entry 9692 (class 0 OID 0)
-- Dependencies: 3993
-- Name: TABLE critere; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE critere IS 'Contient les critÃ¨res de correction (pour les exotlc).';


--
-- TOC entry 3994 (class 1259 OID 2597692)
-- Dependencies: 4981 5
-- Name: droit; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE droit (
    id integer DEFAULT nextval(('contraintes.droit_id_seq'::text)::regclass) NOT NULL,
    libelle character varying(255),
    code character varying NOT NULL,
    "type" integer,
    defaut boolean
);


ALTER TABLE contraintes.droit OWNER TO postgres;

--
-- TOC entry 9695 (class 0 OID 0)
-- Dependencies: 3994
-- Name: TABLE droit; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE droit IS 'Contient les diffÃ©rents droits';


--
-- TOC entry 3995 (class 1259 OID 2597698)
-- Dependencies: 5
-- Name: droit_id_seq; Type: SEQUENCE; Schema: contraintes; Owner: postgres
--

CREATE SEQUENCE droit_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    MINVALUE 0
    CACHE 1;


ALTER TABLE contraintes.droit_id_seq OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 3997 (class 1259 OID 2597702)
-- Dependencies: 5
-- Name: droit_type; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE droit_type (
    id serial NOT NULL,
    libelle character varying NOT NULL
);


ALTER TABLE contraintes.droit_type OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 3999 (class 1259 OID 2597710)
-- Dependencies: 5
-- Name: espace; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE espace (
    id serial NOT NULL,
    libelle character varying(255)
);


ALTER TABLE contraintes.espace OWNER TO postgres;

--
-- TOC entry 9700 (class 0 OID 0)
-- Dependencies: 3999
-- Name: TABLE espace; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE espace IS 'Contient les espaces pour les ressources.';


--
-- TOC entry 4001 (class 1259 OID 2597715)
-- Dependencies: 4985 5
-- Name: etape; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE etape (
    id serial NOT NULL,
    libelle character varying(255),
    "type" integer NOT NULL,
    date_creation timestamp without time zone DEFAULT now() NOT NULL
);


ALTER TABLE contraintes.etape OWNER TO postgres;

--
-- TOC entry 9703 (class 0 OID 0)
-- Dependencies: 4001
-- Name: TABLE etape; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE etape IS 'Contient les Ã©tapes de crÃ©ation d''un parcours';


--
-- TOC entry 4002 (class 1259 OID 2597719)
-- Dependencies: 5
-- Name: etape_chat; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE etape_chat (
    id integer NOT NULL
);


ALTER TABLE contraintes.etape_chat OWNER TO postgres;

--
-- TOC entry 4003 (class 1259 OID 2597721)
-- Dependencies: 5
-- Name: etape_forum; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE etape_forum (
    id integer NOT NULL,
    forum integer
);


ALTER TABLE contraintes.etape_forum OWNER TO postgres;

--
-- TOC entry 4004 (class 1259 OID 2597723)
-- Dependencies: 4986 5
-- Name: etape_ressource; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE etape_ressource (
    id integer NOT NULL,
    fichier integer,
    espace integer,
    section integer,
    CONSTRAINT chek_etape_ressource CHECK (((((((fichier IS NULL) AND (espace IS NULL)) AND (section IS NULL)) OR (((fichier IS NOT NULL) AND (espace IS NOT NULL)) AND (section IS NOT NULL))) OR (((fichier IS NULL) AND (espace IS NOT NULL)) AND (section IS NOT NULL))) OR (((fichier IS NULL) AND (espace IS NOT NULL)) AND (section IS NULL))))
);


ALTER TABLE contraintes.etape_ressource OWNER TO postgres;

--
-- TOC entry 4005 (class 1259 OID 2597726)
-- Dependencies: 5
-- Name: etape_scorm; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE etape_scorm (
    id integer NOT NULL,
    fichier integer NOT NULL,
    scorm integer
);


ALTER TABLE contraintes.etape_scorm OWNER TO postgres;

--
-- TOC entry 4006 (class 1259 OID 2597728)
-- Dependencies: 4987 5
-- Name: etape_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE etape_type (
    id integer DEFAULT nextval(('contraintes.etape_type_id_seq'::text)::regclass) NOT NULL,
    libelle character varying(255),
    code character varying(3),
    ordre integer NOT NULL
);


ALTER TABLE contraintes.etape_type OWNER TO postgres;

--
-- TOC entry 4007 (class 1259 OID 2597731)
-- Dependencies: 5
-- Name: etape_type_id_seq; Type: SEQUENCE; Schema: contraintes; Owner: postgres
--

CREATE SEQUENCE etape_type_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE contraintes.etape_type_id_seq OWNER TO postgres;

--
-- TOC entry 4009 (class 1259 OID 2597735)
-- Dependencies: 4989 5
-- Name: evaluation; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE evaluation (
    id serial NOT NULL,
    libelle character varying(1024) NOT NULL,
    "type" integer NOT NULL,
    date_creation timestamp without time zone DEFAULT now() NOT NULL
);


ALTER TABLE contraintes.evaluation OWNER TO postgres;

--
-- TOC entry 4011 (class 1259 OID 2597744)
-- Dependencies: 4991 5
-- Name: evaluation_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE evaluation_type (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    code character varying(3),
    couleur character(6) DEFAULT 'ffffff'::bpchar
);


ALTER TABLE contraintes.evaluation_type OWNER TO postgres;

--
-- TOC entry 4012 (class 1259 OID 2597748)
-- Dependencies: 5
-- Name: evenement; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE evenement (
    formation integer NOT NULL,
    libelle character varying(255),
    date timestamp without time zone NOT NULL,
    duree interval NOT NULL,
    modalite integer,
    intervention integer,
    intervenant integer,
    salle integer
);


ALTER TABLE contraintes.evenement OWNER TO postgres;

--
-- TOC entry 9716 (class 0 OID 0)
-- Dependencies: 4012
-- Name: TABLE evenement; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE evenement IS 'Contient les cours associÃ©s aux dates d''une formation.';


--
-- TOC entry 4013 (class 1259 OID 2597750)
-- Dependencies: 5
-- Name: evenement_presentiel; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE evenement_presentiel (
    formation integer NOT NULL,
    date timestamp without time zone NOT NULL
);


ALTER TABLE contraintes.evenement_presentiel OWNER TO postgres;

--
-- TOC entry 9718 (class 0 OID 0)
-- Dependencies: 4013
-- Name: TABLE evenement_presentiel; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE evenement_presentiel IS 'Contient les dates de cours presentiels associÃ©s Ã  une formation.';


--
-- TOC entry 4014 (class 1259 OID 2597752)
-- Dependencies: 5
-- Name: exotlc; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE exotlc (
    id integer NOT NULL,
    commentaire text,
    texte text,
    enonce text,
    remarque text,
    "type" integer NOT NULL
);


ALTER TABLE contraintes.exotlc OWNER TO postgres;

--
-- TOC entry 9720 (class 0 OID 0)
-- Dependencies: 4014
-- Name: TABLE exotlc; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE exotlc IS 'Contient les exotlc';


--
-- TOC entry 4015 (class 1259 OID 2597757)
-- Dependencies: 5
-- Name: exotlc_corrections; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE exotlc_corrections (
    exotlc integer NOT NULL,
    correction integer NOT NULL
);


ALTER TABLE contraintes.exotlc_corrections OWNER TO postgres;

--
-- TOC entry 4016 (class 1259 OID 2597759)
-- Dependencies: 5
-- Name: exotlc_fichiers; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE exotlc_fichiers (
    exotlc integer NOT NULL,
    fichier integer NOT NULL
);


ALTER TABLE contraintes.exotlc_fichiers OWNER TO postgres;

--
-- TOC entry 4017 (class 1259 OID 2597761)
-- Dependencies: 5
-- Name: exotlc_mail; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE exotlc_mail (
    id integer NOT NULL,
    formateur integer NOT NULL
);


ALTER TABLE contraintes.exotlc_mail OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4018 (class 1259 OID 2597763)
-- Dependencies: 5
-- Name: exotlc_modele_correction; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE exotlc_modele_correction (
    id integer NOT NULL,
    modele_correction integer NOT NULL
);


ALTER TABLE contraintes.exotlc_modele_correction OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4019 (class 1259 OID 2597765)
-- Dependencies: 4992 5
-- Name: exotlc_plate_forme; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE exotlc_plate_forme (
    id integer NOT NULL,
    fichier_rendu character varying(1024),
    autocorrection boolean DEFAULT false NOT NULL
);


ALTER TABLE contraintes.exotlc_plate_forme OWNER TO postgres;

--
-- TOC entry 4021 (class 1259 OID 2597773)
-- Dependencies: 5
-- Name: exotlc_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE exotlc_type (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    code character varying(3)
);


ALTER TABLE contraintes.exotlc_type OWNER TO postgres;

--
-- TOC entry 4023 (class 1259 OID 2597778)
-- Dependencies: 4995 5
-- Name: fichier; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier (
    id serial NOT NULL,
    libelle character varying(1024) NOT NULL,
    "type" integer,
    connecte boolean DEFAULT false
);


ALTER TABLE contraintes.fichier OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4024 (class 1259 OID 2597785)
-- Dependencies: 4996 5
-- Name: fichier_bloc_scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_bloc_scenario (
    id integer NOT NULL,
    date_modification date DEFAULT now()
);


ALTER TABLE contraintes.fichier_bloc_scenario OWNER TO postgres;

SET default_with_oids = true;

--
-- TOC entry 4025 (class 1259 OID 2597788)
-- Dependencies: 5
-- Name: fichier_correction; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_correction (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_correction OWNER TO postgres;

--
-- TOC entry 4026 (class 1259 OID 2597790)
-- Dependencies: 5
-- Name: fichier_css; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_css (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_css OWNER TO postgres;

--
-- TOC entry 4027 (class 1259 OID 2597792)
-- Dependencies: 5
-- Name: fichier_etape_scorm; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_etape_scorm (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_etape_scorm OWNER TO postgres;

--
-- TOC entry 4028 (class 1259 OID 2597794)
-- Dependencies: 5
-- Name: fichier_exotlc; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_exotlc (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_exotlc OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4029 (class 1259 OID 2597796)
-- Dependencies: 4997 5
-- Name: fichier_glossaire; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_glossaire (
    id integer NOT NULL,
    date_modification date DEFAULT now()
);


ALTER TABLE contraintes.fichier_glossaire OWNER TO postgres;

SET default_with_oids = true;

--
-- TOC entry 4030 (class 1259 OID 2597799)
-- Dependencies: 5
-- Name: fichier_icone; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_icone (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_icone OWNER TO postgres;

--
-- TOC entry 4031 (class 1259 OID 2597801)
-- Dependencies: 5
-- Name: fichier_media_evaluation; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_media_evaluation (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_media_evaluation OWNER TO postgres;

--
-- TOC entry 4032 (class 1259 OID 2597803)
-- Dependencies: 5
-- Name: fichier_media_exotlc; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_media_exotlc (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_media_exotlc OWNER TO postgres;

--
-- TOC entry 4033 (class 1259 OID 2597805)
-- Dependencies: 5
-- Name: fichier_media_scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_media_scenario (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_media_scenario OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4034 (class 1259 OID 2597807)
-- Dependencies: 5
-- Name: fichier_metadata; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE fichier_metadata (
    id integer NOT NULL,
    mots_cles text,
    individu integer
);


ALTER TABLE contraintes.fichier_metadata OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4035 (class 1259 OID 2597812)
-- Dependencies: 5
-- Name: fichier_photo; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_photo (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_photo OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4036 (class 1259 OID 2597814)
-- Dependencies: 5
-- Name: fichier_ressource; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE fichier_ressource (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_ressource OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4037 (class 1259 OID 2597816)
-- Dependencies: 5
-- Name: fichier_ressource_fichier; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_ressource_fichier (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_ressource_fichier OWNER TO postgres;

--
-- TOC entry 4038 (class 1259 OID 2597818)
-- Dependencies: 4998 5
-- Name: fichier_ressource_texte; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_ressource_texte (
    id integer NOT NULL,
    libelle character varying(255),
    adresse character varying(255),
    description character varying(255),
    mise_en_forme text,
    date_modification date DEFAULT ('now'::text)::date
);


ALTER TABLE contraintes.fichier_ressource_texte OWNER TO postgres;

--
-- TOC entry 4039 (class 1259 OID 2597824)
-- Dependencies: 5
-- Name: fichier_scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_scenario (
    id integer NOT NULL
);


ALTER TABLE contraintes.fichier_scenario OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4040 (class 1259 OID 2597826)
-- Dependencies: 4999 5
-- Name: fichier_scenario_dynamique; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_scenario_dynamique (
    id integer NOT NULL,
    style integer,
    date_modification date DEFAULT now()
);


ALTER TABLE contraintes.fichier_scenario_dynamique OWNER TO postgres;

--
-- TOC entry 4041 (class 1259 OID 2597829)
-- Dependencies: 5
-- Name: fichier_scenario_dynamique_blocs; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_scenario_dynamique_blocs (
    id integer NOT NULL,
    ordre integer NOT NULL,
    fichier_bloc_scenario integer,
    bloc_vars_keys text[],
    bloc_vars_values text
);


ALTER TABLE contraintes.fichier_scenario_dynamique_blocs OWNER TO postgres;

--
-- TOC entry 4042 (class 1259 OID 2597834)
-- Dependencies: 5000 5
-- Name: fichier_slide_scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_slide_scenario (
    id integer NOT NULL,
    date_modification date DEFAULT now()
);


ALTER TABLE contraintes.fichier_slide_scenario OWNER TO postgres;

SET default_with_oids = true;

--
-- TOC entry 4044 (class 1259 OID 2597839)
-- Dependencies: 5
-- Name: fichier_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fichier_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3),
    categorie integer
);


ALTER TABLE contraintes.fichier_type OWNER TO postgres;

--
-- TOC entry 4046 (class 1259 OID 2597844)
-- Dependencies: 5
-- Name: filiere; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE filiere (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    pere integer
);


ALTER TABLE contraintes.filiere OWNER TO postgres;

--
-- TOC entry 4047 (class 1259 OID 2597847)
-- Dependencies: 5
-- Name: formateur_droits; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE formateur_droits (
    formation integer NOT NULL,
    droit integer NOT NULL
);


ALTER TABLE contraintes.formateur_droits OWNER TO postgres;

--
-- TOC entry 9754 (class 0 OID 0)
-- Dependencies: 4047
-- Name: TABLE formateur_droits; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE formateur_droits IS 'Les droits du formateur pour une formation.';


--
-- TOC entry 4049 (class 1259 OID 2597851)
-- Dependencies: 5004 5
-- Name: formation; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE formation (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    parcours integer,
    date_debut date NOT NULL,
    date_fin date NOT NULL,
    langue integer NOT NULL,
    ressources_fusionnees boolean,
    CONSTRAINT check_dates CHECK ((date_debut <= date_fin))
);


ALTER TABLE contraintes.formation OWNER TO postgres;

--
-- TOC entry 9756 (class 0 OID 0)
-- Dependencies: 4049
-- Name: TABLE formation; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE formation IS 'Les formations de la plateforme';


--
-- TOC entry 4050 (class 1259 OID 2597855)
-- Dependencies: 5
-- Name: formation_forums; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE formation_forums (
    formation integer NOT NULL,
    forum integer NOT NULL
);


ALTER TABLE contraintes.formation_forums OWNER TO postgres;

--
-- TOC entry 9758 (class 0 OID 0)
-- Dependencies: 4050
-- Name: TABLE formation_forums; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE formation_forums IS 'Contient les forums associÃ©s Ã  une formation.';


--
-- TOC entry 4051 (class 1259 OID 2597857)
-- Dependencies: 5
-- Name: formation_langues; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE formation_langues (
    formation integer NOT NULL,
    langue integer NOT NULL
);


ALTER TABLE contraintes.formation_langues OWNER TO postgres;

--
-- TOC entry 9761 (class 0 OID 0)
-- Dependencies: 4051
-- Name: TABLE formation_langues; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE formation_langues IS 'Contient les langues associÃ©es Ã  une formation.';


--
-- TOC entry 4052 (class 1259 OID 2597859)
-- Dependencies: 5
-- Name: formation_participants; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE formation_participants (
    formation integer NOT NULL,
    formateur integer NOT NULL,
    classe integer NOT NULL
);


ALTER TABLE contraintes.formation_participants OWNER TO postgres;

--
-- TOC entry 9763 (class 0 OID 0)
-- Dependencies: 4052
-- Name: TABLE formation_participants; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE formation_participants IS 'Contient le formateur et la classe associÃ©s Ã  une formation.';


--
-- TOC entry 4053 (class 1259 OID 2597861)
-- Dependencies: 5
-- Name: formation_ressources; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE formation_ressources (
    formation integer NOT NULL,
    fichier_ressource integer NOT NULL,
    debut_disponibilite timestamp without time zone,
    fin_disponibilite timestamp without time zone,
    duree_nouveaute interval,
    espace integer NOT NULL,
    section integer
);


ALTER TABLE contraintes.formation_ressources OWNER TO postgres;

--
-- TOC entry 9765 (class 0 OID 0)
-- Dependencies: 4053
-- Name: TABLE formation_ressources; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE formation_ressources IS 'Contient les ressources associÃ©es Ã  une formation.Une ressource est dÃ©finie par son numÃ©ro,ses dates de dÃ©but et fin et sa durÃ©e de nouveautÃ©.';


SET default_with_oids = false;

--
-- TOC entry 4054 (class 1259 OID 2597863)
-- Dependencies: 5
-- Name: formation_session; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE formation_session (
    formation integer NOT NULL,
    inactivite time without time zone NOT NULL,
    duree_session time without time zone NOT NULL
);


ALTER TABLE contraintes.formation_session OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4056 (class 1259 OID 2597867)
-- Dependencies: 5006 5
-- Name: forum; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE forum (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    description character varying(1024) NOT NULL,
    moderation boolean NOT NULL,
    moderateur_pwd character varying(255),
    fils integer NOT NULL,
    messages integer NOT NULL,
    upload boolean NOT NULL,
    theme character varying(30) DEFAULT 'default'::character varying NOT NULL
);


ALTER TABLE contraintes.forum OWNER TO postgres;

--
-- TOC entry 4058 (class 1259 OID 2597876)
-- Dependencies: 5
-- Name: forum_environnement; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE forum_environnement (
    id serial NOT NULL,
    libelle character varying(255),
    chemin character varying(255),
    db_type character varying(255),
    db_serveur character varying(255),
    db_name character varying(255),
    db_user character varying(255),
    db_pwd character varying(255),
    "admin" character varying(255),
    admin_pwd character varying(255),
    email_valide boolean,
    email_verification boolean,
    interpretation_html boolean,
    citation boolean,
    noms_longs boolean,
    taille_pj integer,
    lignes integer,
    block_ip boolean,
    compte_vus boolean,
    fils_fermes boolean,
    affiche_fils boolean,
    encodage character varying
);


ALTER TABLE contraintes.forum_environnement OWNER TO postgres;

--
-- TOC entry 4059 (class 1259 OID 2597882)
-- Dependencies: 5
-- Name: forum_environnements; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE forum_environnements (
    forum integer NOT NULL,
    environnement integer
);


ALTER TABLE contraintes.forum_environnements OWNER TO postgres;

--
-- TOC entry 4060 (class 1259 OID 2597884)
-- Dependencies: 5
-- Name: ftb; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE ftb (
    id integer NOT NULL,
    text text NOT NULL,
    voir_mots boolean NOT NULL,
    interpretation_html boolean NOT NULL
);


ALTER TABLE contraintes.ftb OWNER TO postgres;

--
-- TOC entry 4062 (class 1259 OID 2597891)
-- Dependencies: 5009 5
-- Name: fw_droit; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_droit (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying,
    defaut boolean DEFAULT false
);


ALTER TABLE contraintes.fw_droit OWNER TO postgres;

--
-- TOC entry 9774 (class 0 OID 0)
-- Dependencies: 4062
-- Name: TABLE fw_droit; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE fw_droit IS 'Contient les diffÃÂ©rents droits';


--
-- TOC entry 4064 (class 1259 OID 2597900)
-- Dependencies: 5011 5
-- Name: fw_individu; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_individu (
    id serial NOT NULL,
    identifiant_md5 character varying(32),
    "login" character varying(255) NOT NULL,
    "password" character varying(255) NOT NULL,
    nom character varying(255) NOT NULL,
    prenom character varying(255) NOT NULL,
    adresse character varying(512),
    code character varying(255),
    ville character varying(512),
    email character varying(512),
    tel_fixe character varying(255),
    tel_port character varying(255),
    langue integer,
    organisme integer,
    photo integer,
    perms character varying,
    CONSTRAINT check_organisme CHECK ((organisme <> 0))
);


ALTER TABLE contraintes.fw_individu OWNER TO postgres;

--
-- TOC entry 4066 (class 1259 OID 2597909)
-- Dependencies: 5
-- Name: fw_individu_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_individu_type (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    code character varying
);


ALTER TABLE contraintes.fw_individu_type OWNER TO postgres;

--
-- TOC entry 4067 (class 1259 OID 2597915)
-- Dependencies: 5
-- Name: fw_individu_types; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_individu_types (
    "type" integer NOT NULL,
    individu integer NOT NULL
);


ALTER TABLE contraintes.fw_individu_types OWNER TO postgres;

--
-- TOC entry 4069 (class 1259 OID 2597919)
-- Dependencies: 5
-- Name: fw_langue; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_langue (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(20),
    locale character varying
);


ALTER TABLE contraintes.fw_langue OWNER TO postgres;

--
-- TOC entry 4071 (class 1259 OID 2597927)
-- Dependencies: 5016 5
-- Name: fw_module; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE fw_module (
    id serial NOT NULL,
    libelle character varying,
    code character varying,
    "type" character varying,
    version character varying,
    directory text,
    active boolean DEFAULT false NOT NULL,
    description character varying
);


ALTER TABLE contraintes.fw_module OWNER TO pgsql;

SET default_with_oids = false;

--
-- TOC entry 4072 (class 1259 OID 2597934)
-- Dependencies: 5
-- Name: fw_module_individus_types; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE fw_module_individus_types (
    module integer NOT NULL,
    individu_type integer NOT NULL,
    droit integer NOT NULL
);


ALTER TABLE contraintes.fw_module_individus_types OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4074 (class 1259 OID 2597938)
-- Dependencies: 5
-- Name: fw_module_pages; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE fw_module_pages (
    id serial NOT NULL,
    module integer,
    libelle character varying,
    "type" character varying,
    url character varying,
    description character varying
);


ALTER TABLE contraintes.fw_module_pages OWNER TO pgsql;

--
-- TOC entry 4075 (class 1259 OID 2597944)
-- Dependencies: 5
-- Name: fw_module_submodules; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE fw_module_submodules (
    module integer NOT NULL,
    submodule integer NOT NULL,
    code character varying,
    version character varying
);


ALTER TABLE contraintes.fw_module_submodules OWNER TO pgsql;

--
-- TOC entry 4076 (class 1259 OID 2597949)
-- Dependencies: 5
-- Name: fw_permission; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE fw_permission (
    id integer NOT NULL,
    libelle character varying,
    code character varying
);


ALTER TABLE contraintes.fw_permission OWNER TO pgsql;

--
-- TOC entry 4077 (class 1259 OID 2597954)
-- Dependencies: 5
-- Name: glossaire_id_seq; Type: SEQUENCE; Schema: contraintes; Owner: postgres
--

CREATE SEQUENCE glossaire_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE contraintes.glossaire_id_seq OWNER TO postgres;

--
-- TOC entry 4078 (class 1259 OID 2597956)
-- Dependencies: 5018 5
-- Name: glossaire; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE glossaire (
    id integer DEFAULT nextval('glossaire_id_seq'::regclass) NOT NULL,
    fichier integer NOT NULL,
    libelle character varying(255) NOT NULL
);


ALTER TABLE contraintes.glossaire OWNER TO postgres;

--
-- TOC entry 4079 (class 1259 OID 2597959)
-- Dependencies: 5
-- Name: glossaire_fichiers; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE glossaire_fichiers (
    id integer NOT NULL,
    fichier integer NOT NULL
);


ALTER TABLE contraintes.glossaire_fichiers OWNER TO postgres;

--
-- TOC entry 4081 (class 1259 OID 2597963)
-- Dependencies: 5
-- Name: grille; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE grille (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL
);


ALTER TABLE contraintes.grille OWNER TO postgres;

--
-- TOC entry 4082 (class 1259 OID 2597966)
-- Dependencies: 5
-- Name: grille_capacites_titres; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE grille_capacites_titres (
    grille integer NOT NULL,
    capacite_titre integer NOT NULL
);


ALTER TABLE contraintes.grille_capacites_titres OWNER TO postgres;

--
-- TOC entry 4083 (class 1259 OID 2597968)
-- Dependencies: 5020 5
-- Name: grille_resultats; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE grille_resultats (
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    grille integer NOT NULL,
    capacite_titre integer NOT NULL,
    capacite integer NOT NULL,
    commentaire text,
    note integer,
    note_max integer,
    carton integer,
    date timestamp without time zone NOT NULL,
    CONSTRAINT grille_resultats_check CHECK ((note <= note_max))
);


ALTER TABLE contraintes.grille_resultats OWNER TO postgres;

--
-- TOC entry 4084 (class 1259 OID 2597974)
-- Dependencies: 5
-- Name: individu_droits; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE individu_droits (
    individu integer NOT NULL,
    classe integer NOT NULL,
    droit integer NOT NULL
);


ALTER TABLE contraintes.individu_droits OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4085 (class 1259 OID 2597976)
-- Dependencies: 5
-- Name: individu_type_droits; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE individu_type_droits (
    individu_type integer NOT NULL,
    droit integer NOT NULL
);


ALTER TABLE contraintes.individu_type_droits OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4087 (class 1259 OID 2597980)
-- Dependencies: 5
-- Name: inscription; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE inscription (
    id serial NOT NULL,
    identifiant_md5 character varying(32),
    "login" character varying(255) NOT NULL,
    "password" character varying(255) NOT NULL,
    nom character varying(255) NOT NULL,
    prenom character varying(255) NOT NULL,
    adresse character varying(512),
    code character varying(255),
    ville character varying(512),
    email character varying(512),
    tel_fixe character varying(255),
    tel_port character varying(255),
    langue integer,
    organisme integer,
    photo integer
);


ALTER TABLE contraintes.inscription OWNER TO postgres;

--
-- TOC entry 4089 (class 1259 OID 2597988)
-- Dependencies: 5
-- Name: intervention; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE intervention (
    id serial NOT NULL,
    libelle character varying(255),
    couleur character varying(6) NOT NULL
);


ALTER TABLE contraintes.intervention OWNER TO postgres;

--
-- TOC entry 4091 (class 1259 OID 2597993)
-- Dependencies: 5
-- Name: langue; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE langue (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(20),
    locale character varying
);


ALTER TABLE contraintes.langue OWNER TO postgres;

--
-- TOC entry 4092 (class 1259 OID 2597999)
-- Dependencies: 5
-- Name: langue_message; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE langue_message (
    id integer NOT NULL,
    langue integer NOT NULL,
    "type" integer NOT NULL,
    libelle text
);


ALTER TABLE contraintes.langue_message OWNER TO postgres;

--
-- TOC entry 4094 (class 1259 OID 2598006)
-- Dependencies: 5
-- Name: langue_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE langue_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(20)
);


ALTER TABLE contraintes.langue_type OWNER TO postgres;

--
-- TOC entry 4095 (class 1259 OID 2598009)
-- Dependencies: 5
-- Name: liste; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE liste (
    id integer NOT NULL,
    "type" integer NOT NULL
);


ALTER TABLE contraintes.liste OWNER TO postgres;

--
-- TOC entry 4097 (class 1259 OID 2598013)
-- Dependencies: 5
-- Name: liste_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE liste_type (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    code character varying(3)
);


ALTER TABLE contraintes.liste_type OWNER TO postgres;

--
-- TOC entry 4098 (class 1259 OID 2598016)
-- Dependencies: 5
-- Name: media; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE media (
    id integer NOT NULL
);


ALTER TABLE contraintes.media OWNER TO postgres;

--
-- TOC entry 4099 (class 1259 OID 2598018)
-- Dependencies: 5
-- Name: media_question_reponse; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE media_question_reponse (
    question_reponse integer NOT NULL,
    media integer NOT NULL,
    hauteur integer,
    largeur integer
);


ALTER TABLE contraintes.media_question_reponse OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4100 (class 1259 OID 2598020)
-- Dependencies: 5
-- Name: media_question_reponse_element; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE media_question_reponse_element (
    question_reponse integer NOT NULL,
    question_reponse_element integer NOT NULL,
    media integer NOT NULL,
    hauteur integer,
    largeur integer
);


ALTER TABLE contraintes.media_question_reponse_element OWNER TO postgres;

SET default_with_oids = true;

--
-- TOC entry 4101 (class 1259 OID 2598022)
-- Dependencies: 5
-- Name: media_test; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE media_test (
    test integer NOT NULL,
    media integer NOT NULL,
    hauteur integer,
    largeur integer
);


ALTER TABLE contraintes.media_test OWNER TO postgres;

--
-- TOC entry 4103 (class 1259 OID 2598026)
-- Dependencies: 5
-- Name: message; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE message (
    id serial NOT NULL,
    libelle character varying(255),
    date integer,
    forum integer,
    auteur integer,
    contenu text,
    parent boolean,
    fils integer,
    pere integer,
    niveau integer,
    racine integer,
    ip character varying(39),
    lu integer,
    moderation boolean,
    "piece-jointe" character varying(255),
    anonyme boolean
);


ALTER TABLE contraintes.message OWNER TO postgres;

--
-- TOC entry 4105 (class 1259 OID 2598034)
-- Dependencies: 5
-- Name: modalite; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE modalite (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3)
);


ALTER TABLE contraintes.modalite OWNER TO postgres;

--
-- TOC entry 4107 (class 1259 OID 2598039)
-- Dependencies: 5
-- Name: modele_correction; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE modele_correction (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL
);


ALTER TABLE contraintes.modele_correction OWNER TO postgres;

--
-- TOC entry 4109 (class 1259 OID 2598044)
-- Dependencies: 5
-- Name: organisme; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE organisme (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL
);


ALTER TABLE contraintes.organisme OWNER TO postgres;

--
-- TOC entry 4111 (class 1259 OID 2598049)
-- Dependencies: 5
-- Name: page; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE page (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    "type" integer,
    script character varying(2048)
);


ALTER TABLE contraintes.page OWNER TO postgres;

--
-- TOC entry 4112 (class 1259 OID 2598055)
-- Dependencies: 5
-- Name: page_annuaire_configuration; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE page_annuaire_configuration (
    formation integer NOT NULL,
    page integer NOT NULL,
    individu_type integer NOT NULL,
    page_element integer NOT NULL
);


ALTER TABLE contraintes.page_annuaire_configuration OWNER TO postgres;

--
-- TOC entry 4113 (class 1259 OID 2598057)
-- Dependencies: 5
-- Name: page_commentaire; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE page_commentaire (
    page integer NOT NULL,
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    commentaire text
);


ALTER TABLE contraintes.page_commentaire OWNER TO postgres;

--
-- TOC entry 4115 (class 1259 OID 2598064)
-- Dependencies: 5
-- Name: page_element; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE page_element (
    id serial NOT NULL,
    libelle character varying(255)
);


ALTER TABLE contraintes.page_element OWNER TO postgres;

--
-- TOC entry 4116 (class 1259 OID 2598067)
-- Dependencies: 5
-- Name: page_elements; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE page_elements (
    page integer NOT NULL,
    page_element integer NOT NULL
);


ALTER TABLE contraintes.page_elements OWNER TO postgres;

--
-- TOC entry 4117 (class 1259 OID 2598069)
-- Dependencies: 5
-- Name: page_liste; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE page_liste (
    formation integer NOT NULL,
    parcours integer NOT NULL,
    liste integer NOT NULL,
    page integer NOT NULL,
    titre character varying(255),
    commentaire text
);


ALTER TABLE contraintes.page_liste OWNER TO postgres;

--
-- TOC entry 4118 (class 1259 OID 2598074)
-- Dependencies: 5
-- Name: page_liste_configuration; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE page_liste_configuration (
    formation integer NOT NULL,
    parcours integer NOT NULL,
    liste integer NOT NULL,
    page integer NOT NULL,
    page_element integer NOT NULL
);


ALTER TABLE contraintes.page_liste_configuration OWNER TO postgres;

--
-- TOC entry 4119 (class 1259 OID 2598076)
-- Dependencies: 5
-- Name: page_ressource_configuration; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE page_ressource_configuration (
    formation integer NOT NULL,
    page integer NOT NULL,
    parcours integer NOT NULL,
    etape_ressource integer NOT NULL,
    commentaire text
);


ALTER TABLE contraintes.page_ressource_configuration OWNER TO postgres;

--
-- TOC entry 4121 (class 1259 OID 2598083)
-- Dependencies: 5
-- Name: page_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE page_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3)
);


ALTER TABLE contraintes.page_type OWNER TO postgres;

--
-- TOC entry 4122 (class 1259 OID 2598086)
-- Dependencies: 5
-- Name: parcours; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE parcours (
    id integer NOT NULL,
    filiere integer NOT NULL,
    duree boolean
);


ALTER TABLE contraintes.parcours OWNER TO postgres;

--
-- TOC entry 4123 (class 1259 OID 2598088)
-- Dependencies: 5033 5034 5035 5
-- Name: parcours_etapes; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE parcours_etapes (
    parcours integer NOT NULL,
    etape integer NOT NULL,
    pere integer,
    obligatoire boolean DEFAULT false NOT NULL,
    chrono integer,
    fin boolean DEFAULT false NOT NULL,
    libelle_type_etape character varying(255),
    CONSTRAINT check_parcours_etape CHECK ((etape <> parcours))
);


ALTER TABLE contraintes.parcours_etapes OWNER TO postgres;

--
-- TOC entry 9837 (class 0 OID 0)
-- Dependencies: 4123
-- Name: TABLE parcours_etapes; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE parcours_etapes IS 'Contient les Ã©tapes des parcours.';


--
-- TOC entry 4124 (class 1259 OID 2598093)
-- Dependencies: 5036 5
-- Name: parcours_oriente; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE parcours_oriente (
    id integer NOT NULL,
    "type" integer,
    seuil integer,
    sous_parcours integer NOT NULL,
    ordre integer,
    CONSTRAINT check_parcours_cycle CHECK ((id <> sous_parcours))
);


ALTER TABLE contraintes.parcours_oriente OWNER TO postgres;

--
-- TOC entry 9839 (class 0 OID 0)
-- Dependencies: 4124
-- Name: TABLE parcours_oriente; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE parcours_oriente IS 'Pour configurer un parcours en orientation.(A la fin du parcours principal, le stagiaire est orientÃ© vers un autre parcours en fonction des rÃ©sultats obtenus).';


--
-- TOC entry 4126 (class 1259 OID 2598098)
-- Dependencies: 5038 5
-- Name: pc_etape; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE pc_etape (
    id serial NOT NULL,
    libelle character varying(255),
    "type" integer NOT NULL,
    date_creation timestamp without time zone DEFAULT now() NOT NULL
);


ALTER TABLE contraintes.pc_etape OWNER TO postgres;

--
-- TOC entry 9841 (class 0 OID 0)
-- Dependencies: 4126
-- Name: TABLE pc_etape; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE pc_etape IS 'Contient les Ã©tapes de crÃ©ation d''un parcours';


--
-- TOC entry 4128 (class 1259 OID 2598104)
-- Dependencies: 5
-- Name: pc_etape_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE pc_etape_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3),
    ordre integer NOT NULL
);


ALTER TABLE contraintes.pc_etape_type OWNER TO postgres;

--
-- TOC entry 4130 (class 1259 OID 2598109)
-- Dependencies: 5
-- Name: pc_filiere; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE pc_filiere (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    pere integer
);


ALTER TABLE contraintes.pc_filiere OWNER TO postgres;

--
-- TOC entry 4131 (class 1259 OID 2598112)
-- Dependencies: 5
-- Name: pc_parcours; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE pc_parcours (
    id integer NOT NULL,
    filiere integer NOT NULL,
    duree boolean
);


ALTER TABLE contraintes.pc_parcours OWNER TO postgres;

--
-- TOC entry 4133 (class 1259 OID 2598116)
-- Dependencies: 5
-- Name: positionnement; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE positionnement (
    id serial NOT NULL,
    libelle character varying NOT NULL,
    chrono integer,
    serie_generee integer NOT NULL,
    qsrc integer NOT NULL
);


ALTER TABLE contraintes.positionnement OWNER TO postgres;

--
-- TOC entry 9849 (class 0 OID 0)
-- Dependencies: 4133
-- Name: TABLE positionnement; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE positionnement IS 'Contient les positionnements';


--
-- TOC entry 4134 (class 1259 OID 2598122)
-- Dependencies: 5042 5
-- Name: positionnement_choix_evaluations; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE positionnement_choix_evaluations (
    positionnement integer NOT NULL,
    reponse integer NOT NULL,
    "type" integer NOT NULL,
    nombre integer,
    nombre_max integer,
    bareme integer,
    CONSTRAINT chech_positif CHECK ((((nombre <= nombre_max) AND (nombre_max > 0)) AND (nombre >= 0)))
);


ALTER TABLE contraintes.positionnement_choix_evaluations OWNER TO postgres;

--
-- TOC entry 9851 (class 0 OID 0)
-- Dependencies: 4134
-- Name: TABLE positionnement_choix_evaluations; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE positionnement_choix_evaluations IS 'Les Ã©valuations Ã  gÃ©nÃ©rer en fonction des rÃ©ponses d''un positionnement (qcm)';


--
-- TOC entry 4135 (class 1259 OID 2598125)
-- Dependencies: 5
-- Name: positionnement_elements; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE positionnement_elements (
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    choix integer NOT NULL
);


ALTER TABLE contraintes.positionnement_elements OWNER TO postgres;

--
-- TOC entry 9853 (class 0 OID 0)
-- Dependencies: 4135
-- Name: TABLE positionnement_elements; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE positionnement_elements IS 'Contient les associations positionnement-questions';


--
-- TOC entry 4136 (class 1259 OID 2598127)
-- Dependencies: 5
-- Name: positionnement_evaluations; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE positionnement_evaluations (
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    choix integer NOT NULL,
    evaluation integer NOT NULL,
    pere integer
);


ALTER TABLE contraintes.positionnement_evaluations OWNER TO postgres;

--
-- TOC entry 4138 (class 1259 OID 2598131)
-- Dependencies: 5
-- Name: positionnement_old; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE positionnement_old (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    type_question integer NOT NULL,
    chrono integer,
    serie_aleatoire integer NOT NULL,
    question_reponse integer
);


ALTER TABLE contraintes.positionnement_old OWNER TO postgres;

--
-- TOC entry 9857 (class 0 OID 0)
-- Dependencies: 4138
-- Name: TABLE positionnement_old; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE positionnement_old IS 'Contient les positionnements';


--
-- TOC entry 4139 (class 1259 OID 2598134)
-- Dependencies: 5
-- Name: qcm_elements; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE qcm_elements (
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    juste boolean
);


ALTER TABLE contraintes.qcm_elements OWNER TO postgres;

--
-- TOC entry 4140 (class 1259 OID 2598136)
-- Dependencies: 5
-- Name: qsrc; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE qsrc (
    id integer NOT NULL,
    question character varying(1024) NOT NULL
);


ALTER TABLE contraintes.qsrc OWNER TO postgres;

--
-- TOC entry 4141 (class 1259 OID 2598141)
-- Dependencies: 5
-- Name: question; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE question (
    id integer NOT NULL
);


ALTER TABLE contraintes.question OWNER TO postgres;

--
-- TOC entry 9862 (class 0 OID 0)
-- Dependencies: 4141
-- Name: TABLE question; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE question IS 'Les numÃ©ros de question de la plateforme';


--
-- TOC entry 4142 (class 1259 OID 2598143)
-- Dependencies: 5
-- Name: question_reponse; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE question_reponse (
    id integer NOT NULL,
    "type" integer NOT NULL,
    radio boolean
);


ALTER TABLE contraintes.question_reponse OWNER TO postgres;

--
-- TOC entry 4144 (class 1259 OID 2598147)
-- Dependencies: 5
-- Name: question_reponse_element; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE question_reponse_element (
    id serial NOT NULL,
    libelle character varying(1024),
    interpretation_html boolean,
    "type" integer,
    reponse boolean
);


ALTER TABLE contraintes.question_reponse_element OWNER TO postgres;

--
-- TOC entry 4145 (class 1259 OID 2598153)
-- Dependencies: 5
-- Name: question_reponse_elements; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE question_reponse_elements (
    question_reponse integer NOT NULL,
    question_reponse_element integer NOT NULL,
    pere integer
);


ALTER TABLE contraintes.question_reponse_elements OWNER TO postgres;

--
-- TOC entry 9867 (class 0 OID 0)
-- Dependencies: 4145
-- Name: TABLE question_reponse_elements; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE question_reponse_elements IS 'Les associations question-reponses (nouvelle table)';


--
-- TOC entry 4146 (class 1259 OID 2598155)
-- Dependencies: 5
-- Name: question_reponse_elements_old; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE question_reponse_elements_old (
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    pere integer
);


ALTER TABLE contraintes.question_reponse_elements_old OWNER TO postgres;

--
-- TOC entry 9869 (class 0 OID 0)
-- Dependencies: 4146
-- Name: TABLE question_reponse_elements_old; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE question_reponse_elements_old IS 'Les associations question-reponses';


--
-- TOC entry 4147 (class 1259 OID 2598157)
-- Dependencies: 5
-- Name: question_reponse_elements_older; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE question_reponse_elements_older (
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    pere integer
);


ALTER TABLE contraintes.question_reponse_elements_older OWNER TO postgres;

--
-- TOC entry 9871 (class 0 OID 0)
-- Dependencies: 4147
-- Name: TABLE question_reponse_elements_older; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE question_reponse_elements_older IS 'Les associations question-reponses (sauvegarde du vieux question_reponse_elements)';


--
-- TOC entry 4149 (class 1259 OID 2598161)
-- Dependencies: 5
-- Name: question_reponse_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE question_reponse_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3)
);


ALTER TABLE contraintes.question_reponse_type OWNER TO postgres;

--
-- TOC entry 9873 (class 0 OID 0)
-- Dependencies: 4149
-- Name: TABLE question_reponse_type; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE question_reponse_type IS 'Les types des question-reponse';


--
-- TOC entry 4150 (class 1259 OID 2598164)
-- Dependencies: 5
-- Name: reponse; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE reponse (
    id integer NOT NULL
);


ALTER TABLE contraintes.reponse OWNER TO postgres;

--
-- TOC entry 9876 (class 0 OID 0)
-- Dependencies: 4150
-- Name: TABLE reponse; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE reponse IS 'Les numÃ©ros de rÃ©ponses de la plateforme';


--
-- TOC entry 4151 (class 1259 OID 2598166)
-- Dependencies: 5
-- Name: resultat_id_seq; Type: SEQUENCE; Schema: contraintes; Owner: pgsql
--

CREATE SEQUENCE resultat_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE contraintes.resultat_id_seq OWNER TO pgsql;

--
-- TOC entry 4152 (class 1259 OID 2598168)
-- Dependencies: 5046 5
-- Name: resultat; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat (
    id bigint DEFAULT nextval('resultat_id_seq'::regclass) NOT NULL,
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    parcours integer NOT NULL,
    etape integer NOT NULL,
    date_debut timestamp without time zone,
    duree interval
);


ALTER TABLE contraintes.resultat OWNER TO postgres;

--
-- TOC entry 4153 (class 1259 OID 2598171)
-- Dependencies: 5047 5
-- Name: resultat_exotlc; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_exotlc (
    id bigint NOT NULL,
    commentaire text,
    correction boolean DEFAULT false,
    fichier_rendu integer,
    date_correction timestamp without time zone
);


ALTER TABLE contraintes.resultat_exotlc OWNER TO postgres;

--
-- TOC entry 4154 (class 1259 OID 2598177)
-- Dependencies: 5048 5
-- Name: resultat_exotlc_critere; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_exotlc_critere (
    id bigint NOT NULL,
    critere integer NOT NULL,
    note integer,
    note_max integer,
    commentaire text,
    CONSTRAINT check_notes CHECK ((((note IS NULL) AND (note_max IS NULL)) OR ((note <= note_max) AND (note_max >= 0))))
);


ALTER TABLE contraintes.resultat_exotlc_critere OWNER TO postgres;

--
-- TOC entry 4155 (class 1259 OID 2598183)
-- Dependencies: 5049 5
-- Name: resultat_exotlc_sous_critere; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_exotlc_sous_critere (
    id bigint NOT NULL,
    sous_critere integer NOT NULL,
    note integer NOT NULL,
    note_max integer NOT NULL,
    CONSTRAINT check_notes CHECK (((note <= note_max) AND (note_max >= 0)))
);


ALTER TABLE contraintes.resultat_exotlc_sous_critere OWNER TO postgres;

--
-- TOC entry 4156 (class 1259 OID 2598186)
-- Dependencies: 5
-- Name: resultat_positionnement; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_positionnement (
    id bigint NOT NULL,
    test integer NOT NULL,
    positionnement integer NOT NULL
);


ALTER TABLE contraintes.resultat_positionnement OWNER TO postgres;

--
-- TOC entry 9883 (class 0 OID 0)
-- Dependencies: 4156
-- Name: TABLE resultat_positionnement; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE resultat_positionnement IS 'Contient les date de fin des positionnements pour un test,un stagiaire et une formation.';


--
-- TOC entry 4157 (class 1259 OID 2598188)
-- Dependencies: 5
-- Name: resultat_positionnement_question_reponse; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_positionnement_question_reponse (
    id bigint NOT NULL,
    test integer NOT NULL,
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    choix integer NOT NULL
);


ALTER TABLE contraintes.resultat_positionnement_question_reponse OWNER TO postgres;

--
-- TOC entry 9885 (class 0 OID 0)
-- Dependencies: 4157
-- Name: TABLE resultat_positionnement_question_reponse; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE resultat_positionnement_question_reponse IS 'Stockage des rÃ©sultats de questions de positionnement pour un test, un stagiaire et une formation.';


--
-- TOC entry 4158 (class 1259 OID 2598190)
-- Dependencies: 5050 5
-- Name: resultat_serie; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_serie (
    id bigint NOT NULL,
    evaluation integer NOT NULL,
    date_debut timestamp without time zone DEFAULT now() NOT NULL,
    date_fin timestamp without time zone
);


ALTER TABLE contraintes.resultat_serie OWNER TO postgres;

--
-- TOC entry 4159 (class 1259 OID 2598193)
-- Dependencies: 5
-- Name: resultat_serie_ftb; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_serie_ftb (
    id bigint NOT NULL,
    ftb bigint NOT NULL,
    reponse text
);


ALTER TABLE contraintes.resultat_serie_ftb OWNER TO postgres;

--
-- TOC entry 9888 (class 0 OID 0)
-- Dependencies: 4159
-- Name: TABLE resultat_serie_ftb; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE resultat_serie_ftb IS 'Contient les reponses aux Ã©valuations (remplir les blancs) d''une sÃ©rie pour un stagiaire et une formation.';


--
-- TOC entry 4160 (class 1259 OID 2598198)
-- Dependencies: 5051 5
-- Name: resultat_serie_question_reponse; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_serie_question_reponse (
    id bigint NOT NULL,
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    coche boolean DEFAULT false
);


ALTER TABLE contraintes.resultat_serie_question_reponse OWNER TO postgres;

--
-- TOC entry 9890 (class 0 OID 0)
-- Dependencies: 4160
-- Name: TABLE resultat_serie_question_reponse; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE resultat_serie_question_reponse IS 'Contient les reponses au Ã©valuations (qcm ou sondage)d''une sÃ©rie pour un stagiaire et une formation.';


--
-- TOC entry 4161 (class 1259 OID 2598201)
-- Dependencies: 5052 5
-- Name: resultat_serie_tentative; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_serie_tentative (
    id bigint NOT NULL,
    evaluation integer NOT NULL,
    date_debut timestamp without time zone DEFAULT now() NOT NULL,
    date_fin timestamp without time zone
);


ALTER TABLE contraintes.resultat_serie_tentative OWNER TO postgres;

--
-- TOC entry 4162 (class 1259 OID 2598204)
-- Dependencies: 5
-- Name: resultat_serie_tentative_ftb; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_serie_tentative_ftb (
    id bigint NOT NULL,
    ftb bigint NOT NULL,
    reponse character varying[]
);


ALTER TABLE contraintes.resultat_serie_tentative_ftb OWNER TO postgres;

--
-- TOC entry 9893 (class 0 OID 0)
-- Dependencies: 4162
-- Name: TABLE resultat_serie_tentative_ftb; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE resultat_serie_tentative_ftb IS 'Contient les resultats (ftb) d''une sÃ©rie en cas d''Ã©chec Ã  une sÃ©rie bloquante.';


--
-- TOC entry 4163 (class 1259 OID 2598209)
-- Dependencies: 5
-- Name: resultat_serie_tentative_question_reponse; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_serie_tentative_question_reponse (
    id bigint NOT NULL,
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    coche boolean
);


ALTER TABLE contraintes.resultat_serie_tentative_question_reponse OWNER TO postgres;

--
-- TOC entry 9895 (class 0 OID 0)
-- Dependencies: 4163
-- Name: TABLE resultat_serie_tentative_question_reponse; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE resultat_serie_tentative_question_reponse IS 'Contient les rÃ©sultats (qcm) d''une sÃ©rie en cas d''Ã©chec Ã  une sÃ©rie bloquante.';


--
-- TOC entry 4165 (class 1259 OID 2598213)
-- Dependencies: 5
-- Name: resultat_tentative; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_tentative (
    id bigserial NOT NULL,
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    parcours integer NOT NULL,
    etape integer NOT NULL,
    date_debut timestamp without time zone,
    duree interval,
    tentative integer NOT NULL
);


ALTER TABLE contraintes.resultat_tentative OWNER TO postgres;

--
-- TOC entry 4166 (class 1259 OID 2598216)
-- Dependencies: 5
-- Name: resultat_test; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE resultat_test (
    id bigint NOT NULL,
    positionnement integer,
    date_creation timestamp without time zone
);


ALTER TABLE contraintes.resultat_test OWNER TO postgres;

--
-- TOC entry 4167 (class 1259 OID 2598218)
-- Dependencies: 5
-- Name: salle_id_seq; Type: SEQUENCE; Schema: contraintes; Owner: pgsql
--

CREATE SEQUENCE salle_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE contraintes.salle_id_seq OWNER TO pgsql;

--
-- TOC entry 4168 (class 1259 OID 2598220)
-- Dependencies: 5054 5
-- Name: salle; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE salle (
    id integer DEFAULT nextval('salle_id_seq'::regclass) NOT NULL,
    libelle character varying(255)
);


ALTER TABLE contraintes.salle OWNER TO postgres;

--
-- TOC entry 9901 (class 0 OID 0)
-- Dependencies: 4168
-- Name: TABLE salle; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE salle IS 'Les sales pour les cours de formation';


--
-- TOC entry 4169 (class 1259 OID 2598223)
-- Dependencies: 5
-- Name: scenario; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE scenario (
    id integer NOT NULL,
    fichier integer NOT NULL
);


ALTER TABLE contraintes.scenario OWNER TO postgres;

--
-- TOC entry 4170 (class 1259 OID 2598225)
-- Dependencies: 5
-- Name: scenario_dynamique; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE scenario_dynamique (
    id integer NOT NULL,
    fichier integer NOT NULL
);


ALTER TABLE contraintes.scenario_dynamique OWNER TO postgres;

--
-- TOC entry 4172 (class 1259 OID 2598229)
-- Dependencies: 5056 5057 5058 5059 5060 5061 5062 5063 5064 5065 5066 5067 5
-- Name: scorm; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE scorm (
    id serial NOT NULL,
    course integer DEFAULT 0 NOT NULL,
    name character varying(255) DEFAULT ''::character varying NOT NULL,
    reference character varying(255) DEFAULT ''::character varying NOT NULL,
    maxgrade real DEFAULT (0)::real NOT NULL,
    grademethod integer DEFAULT 0 NOT NULL,
    datadir character varying(255) DEFAULT ''::character varying NOT NULL,
    launch integer DEFAULT 0 NOT NULL,
    summary text DEFAULT ''::text NOT NULL,
    auto integer DEFAULT 0 NOT NULL,
    popup character varying(255) DEFAULT ''::character varying NOT NULL,
    timemodified integer DEFAULT 0 NOT NULL,
    num_theme integer DEFAULT 0 NOT NULL
);


ALTER TABLE contraintes.scorm OWNER TO postgres;

--
-- TOC entry 4174 (class 1259 OID 2598249)
-- Dependencies: 5069 5070 5071 5072 5073 5074 5075 5076 5077 5078 5
-- Name: scorm_sco_users; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE scorm_sco_users (
    id serial NOT NULL,
    userid integer DEFAULT 0 NOT NULL,
    scormid integer DEFAULT 0 NOT NULL,
    scoid integer DEFAULT 0 NOT NULL,
    cmi_core_lesson_location character varying(255) DEFAULT ''::character varying NOT NULL,
    cmi_core_lesson_status character varying(30) DEFAULT ''::character varying NOT NULL,
    cmi_core_exit character varying(30) DEFAULT ''::character varying NOT NULL,
    cmi_core_total_time character varying(13) DEFAULT '00:00:00'::character varying NOT NULL,
    cmi_core_session_time character varying(13) DEFAULT '00:00:00'::character varying NOT NULL,
    cmi_core_score_raw real DEFAULT (0)::real NOT NULL,
    cmi_suspend_data text DEFAULT ''::text NOT NULL,
    num_cal integer
);


ALTER TABLE contraintes.scorm_sco_users OWNER TO postgres;

--
-- TOC entry 4176 (class 1259 OID 2598267)
-- Dependencies: 5080 5081 5082 5083 5084 5085 5086 5087 5088 5089 5090 5
-- Name: scorm_scoes; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE scorm_scoes (
    id serial NOT NULL,
    scorm integer DEFAULT 0 NOT NULL,
    manifest character varying(255) DEFAULT ''::character varying NOT NULL,
    organization character varying(255) DEFAULT ''::character varying NOT NULL,
    parent character varying(255) DEFAULT ''::character varying NOT NULL,
    identifier character varying(255) DEFAULT ''::character varying NOT NULL,
    launch character varying(255) DEFAULT ''::character varying NOT NULL,
    "type" character varying(5) DEFAULT ''::character varying NOT NULL,
    title character varying(255) DEFAULT ''::character varying NOT NULL,
    datafromlms text DEFAULT ''::text NOT NULL,
    "next" integer DEFAULT 0 NOT NULL,
    previous integer DEFAULT 0 NOT NULL
);


ALTER TABLE contraintes.scorm_scoes OWNER TO postgres;

--
-- TOC entry 4177 (class 1259 OID 2598284)
-- Dependencies: 5
-- Name: section_id_seq; Type: SEQUENCE; Schema: contraintes; Owner: pgsql
--

CREATE SEQUENCE section_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE contraintes.section_id_seq OWNER TO pgsql;

--
-- TOC entry 4178 (class 1259 OID 2598286)
-- Dependencies: 5091 5
-- Name: section; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE section (
    id integer DEFAULT nextval('section_id_seq'::regclass) NOT NULL,
    libelle character varying(255),
    icone integer
);


ALTER TABLE contraintes.section OWNER TO postgres;

--
-- TOC entry 9912 (class 0 OID 0)
-- Dependencies: 4178
-- Name: TABLE section; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE section IS 'Contient les sections pour les ressources.';


--
-- TOC entry 4179 (class 1259 OID 2598289)
-- Dependencies: 5
-- Name: serie; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE serie (
    id integer NOT NULL,
    bareme integer,
    chrono integer
);


ALTER TABLE contraintes.serie OWNER TO postgres;

--
-- TOC entry 9914 (class 0 OID 0)
-- Dependencies: 4179
-- Name: TABLE serie; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE serie IS 'Bareme et chrono pour une sÃ©rie';


--
-- TOC entry 4180 (class 1259 OID 2598291)
-- Dependencies: 5
-- Name: serie_aleatoire; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE serie_aleatoire (
    id integer NOT NULL,
    "type" integer
);


ALTER TABLE contraintes.serie_aleatoire OWNER TO postgres;

--
-- TOC entry 4181 (class 1259 OID 2598293)
-- Dependencies: 5
-- Name: serie_aleatoire_evaluations; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE serie_aleatoire_evaluations (
    serie integer NOT NULL,
    evaluation integer NOT NULL,
    formation integer NOT NULL,
    parcours integer NOT NULL,
    stagiaire integer NOT NULL,
    pere integer,
    source integer
);


ALTER TABLE contraintes.serie_aleatoire_evaluations OWNER TO postgres;

--
-- TOC entry 9917 (class 0 OID 0)
-- Dependencies: 4181
-- Name: TABLE serie_aleatoire_evaluations; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE serie_aleatoire_evaluations IS 'Contient les associations serie-evaluation d''une sÃ©rie alÃ©atoire pour un stagiaire et une formation.';


--
-- TOC entry 4182 (class 1259 OID 2598295)
-- Dependencies: 5
-- Name: serie_aleatoire_melangee; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE serie_aleatoire_melangee (
    serie integer NOT NULL,
    formation integer NOT NULL,
    parcours integer NOT NULL
);


ALTER TABLE contraintes.serie_aleatoire_melangee OWNER TO postgres;

--
-- TOC entry 4183 (class 1259 OID 2598297)
-- Dependencies: 5
-- Name: serie_aleatoire_multiserie; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE serie_aleatoire_multiserie (
    serie integer NOT NULL,
    serie_source integer NOT NULL,
    nb_evaluations integer,
    type_evaluations integer NOT NULL
);


ALTER TABLE contraintes.serie_aleatoire_multiserie OWNER TO postgres;

--
-- TOC entry 9920 (class 0 OID 0)
-- Dependencies: 4183
-- Name: TABLE serie_aleatoire_multiserie; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE serie_aleatoire_multiserie IS 'Contient les configurations des sÃ©rie alÃ©atoires multisÃ©rie (monothÃ¨me).';


--
-- TOC entry 4184 (class 1259 OID 2598299)
-- Dependencies: 5
-- Name: serie_aleatoire_multitheme; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE serie_aleatoire_multitheme (
    serie integer NOT NULL,
    theme_source integer NOT NULL,
    nb_evaluations integer,
    type_evaluations integer NOT NULL
);


ALTER TABLE contraintes.serie_aleatoire_multitheme OWNER TO postgres;

--
-- TOC entry 9922 (class 0 OID 0)
-- Dependencies: 4184
-- Name: TABLE serie_aleatoire_multitheme; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE serie_aleatoire_multitheme IS 'Contient les configurations des series alÃ©atoires multithÃ¨me.';


--
-- TOC entry 4186 (class 1259 OID 2598303)
-- Dependencies: 5
-- Name: serie_aleatoire_type; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE serie_aleatoire_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3)
);


ALTER TABLE contraintes.serie_aleatoire_type OWNER TO postgres;

--
-- TOC entry 9924 (class 0 OID 0)
-- Dependencies: 4186
-- Name: TABLE serie_aleatoire_type; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE serie_aleatoire_type IS 'Les types des serie aleatoires';


--
-- TOC entry 4187 (class 1259 OID 2598306)
-- Dependencies: 5093 5094 5
-- Name: serie_bloquante; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE serie_bloquante (
    serie integer NOT NULL,
    formation integer NOT NULL,
    parcours integer NOT NULL,
    seuil integer NOT NULL,
    etape_retour integer NOT NULL,
    tentatives integer NOT NULL,
    correction boolean DEFAULT false NOT NULL,
    blocage_parcours boolean DEFAULT false NOT NULL
);


ALTER TABLE contraintes.serie_bloquante OWNER TO postgres;

--
-- TOC entry 9927 (class 0 OID 0)
-- Dependencies: 4187
-- Name: TABLE serie_bloquante; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE serie_bloquante IS 'Pour configurer une sÃ©rie en mode bloquant.';


--
-- TOC entry 4188 (class 1259 OID 2598310)
-- Dependencies: 5
-- Name: serie_evaluations; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE serie_evaluations (
    serie integer NOT NULL,
    evaluation integer NOT NULL,
    commentaire character varying(255),
    bareme integer,
    chrono integer,
    points integer,
    pere integer
);


ALTER TABLE contraintes.serie_evaluations OWNER TO postgres;

--
-- TOC entry 9929 (class 0 OID 0)
-- Dependencies: 4188
-- Name: TABLE serie_evaluations; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE serie_evaluations IS 'Contient les associations serie- Ã©valuations';


SET default_with_oids = false;

--
-- TOC entry 4189 (class 1259 OID 2598312)
-- Dependencies: 5
-- Name: session; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE "session" (
    sid character varying(32) NOT NULL,
    name character varying(32) NOT NULL,
    debut timestamp without time zone NOT NULL,
    fin timestamp without time zone
);


ALTER TABLE contraintes."session" OWNER TO postgres;

SET default_with_oids = true;

--
-- TOC entry 4190 (class 1259 OID 2598314)
-- Dependencies: 5095 5
-- Name: session_active; Type: TABLE; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE TABLE session_active (
    sid character varying(32) NOT NULL,
    name character varying(32) NOT NULL,
    val text,
    changed timestamp without time zone DEFAULT now() NOT NULL,
    formation integer
);


ALTER TABLE contraintes.session_active OWNER TO pgsql;

--
-- TOC entry 4191 (class 1259 OID 2598320)
-- Dependencies: 5
-- Name: stagiaire_grille; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE stagiaire_grille (
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    grille integer NOT NULL,
    visible boolean
);


ALTER TABLE contraintes.stagiaire_grille OWNER TO postgres;

--
-- TOC entry 9933 (class 0 OID 0)
-- Dependencies: 4191
-- Name: TABLE stagiaire_grille; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE stagiaire_grille IS 'Contient les grilles prÃ©sentielles pour un stagiaire et une formation.';


--
-- TOC entry 4192 (class 1259 OID 2598322)
-- Dependencies: 5
-- Name: test; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE test (
    id integer NOT NULL,
    dynamique boolean,
    continu boolean
);


ALTER TABLE contraintes.test OWNER TO postgres;

--
-- TOC entry 9935 (class 0 OID 0)
-- Dependencies: 4192
-- Name: TABLE test; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE test IS 'Les caractÃ©ristiques d''un test (dynamique,continu)';


--
-- TOC entry 4193 (class 1259 OID 2598324)
-- Dependencies: 5
-- Name: test_positionnements; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE test_positionnements (
    test integer NOT NULL,
    positionnement integer NOT NULL,
    pere integer
);


ALTER TABLE contraintes.test_positionnements OWNER TO postgres;

--
-- TOC entry 9937 (class 0 OID 0)
-- Dependencies: 4193
-- Name: TABLE test_positionnements; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE test_positionnements IS 'Contient les associations test-positionnements.';


--
-- TOC entry 4195 (class 1259 OID 2598328)
-- Dependencies: 5
-- Name: theme; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE theme (
    id serial NOT NULL,
    libelle character varying(255),
    individu integer
);


ALTER TABLE contraintes.theme OWNER TO postgres;

--
-- TOC entry 9939 (class 0 OID 0)
-- Dependencies: 4195
-- Name: TABLE theme; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE theme IS 'Contient le libellÃ©s des thÃ¨mes.Les noms de rÃ©pertoires seront les numÃ©ros de themes.';


--
-- TOC entry 4196 (class 1259 OID 2598331)
-- Dependencies: 5
-- Name: theme_categories; Type: TABLE; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE TABLE theme_categories (
    theme integer NOT NULL,
    categorie integer NOT NULL,
    id integer NOT NULL
);


ALTER TABLE contraintes.theme_categories OWNER TO postgres;

--
-- TOC entry 9941 (class 0 OID 0)
-- Dependencies: 4196
-- Name: TABLE theme_categories; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TABLE theme_categories IS 'Pour le stockage de toutes les catÃ©gories';


SET search_path = public, pg_catalog;

--
-- TOC entry 4197 (class 1259 OID 2598333)
-- Dependencies: 6
-- Name: CORRECTION_MODELE_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE "CORRECTION_MODELE_id_seq"
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public."CORRECTION_MODELE_id_seq" OWNER TO pgsql;

--
-- TOC entry 4198 (class 1259 OID 2598335)
-- Dependencies: 5097 5098 5099 6
-- Name: active_sessions; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE active_sessions (
    sid character varying(32) DEFAULT ''::character varying NOT NULL,
    name character varying(32) DEFAULT ''::character varying NOT NULL,
    val text,
    changed character varying(14) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE public.active_sessions OWNER TO pgsql;

--
-- TOC entry 4199 (class 1259 OID 2598343)
-- Dependencies: 5100 6
-- Name: active_sessions_split; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE active_sessions_split (
    ct_sid character varying(32) NOT NULL,
    ct_name character varying(32) NOT NULL,
    ct_pos character varying(6) NOT NULL,
    ct_val text,
    ct_changed character varying(14) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE public.active_sessions_split OWNER TO pgsql;

--
-- TOC entry 4200 (class 1259 OID 2598349)
-- Dependencies: 6
-- Name: adrgroupe_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE adrgroupe_id_seq
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.adrgroupe_id_seq OWNER TO pgsql;

--
-- TOC entry 4201 (class 1259 OID 2598351)
-- Dependencies: 5101 6
-- Name: alert; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE alert (
    num_alert integer DEFAULT nextval(('"alert_num_alert_seq"'::text)::regclass) NOT NULL,
    num_cal integer,
    num_date integer,
    periode integer,
    intitule character varying(255),
    texte text
);


ALTER TABLE public.alert OWNER TO pgsql;

--
-- TOC entry 4202 (class 1259 OID 2598357)
-- Dependencies: 6
-- Name: alert_num_alert_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE alert_num_alert_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.alert_num_alert_seq OWNER TO pgsql;

--
-- TOC entry 4203 (class 1259 OID 2598359)
-- Dependencies: 6
-- Name: allias_fichier; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE allias_fichier (
    "type" character varying(1),
    theme integer,
    libelle character varying(255),
    allias character varying(400)
);


ALTER TABLE public.allias_fichier OWNER TO pgsql;

--
-- TOC entry 4204 (class 1259 OID 2598364)
-- Dependencies: 5102 5103 5104 6
-- Name: articles; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE articles (
    id integer DEFAULT nextval(('"articles_id_seq"'::text)::regclass) NOT NULL,
    "time" timestamp with time zone,
    author character varying(128),
    email character varying(50),
    subject character varying(50),
    body character varying,
    is_parent boolean DEFAULT false,
    subs character varying,
    parent integer,
    "level" integer,
    root integer,
    ip character varying(16),
    views integer,
    forum integer,
    moderation_state integer DEFAULT 0,
    attach character varying(30)
);


ALTER TABLE public.articles OWNER TO pgsql;

--
-- TOC entry 4205 (class 1259 OID 2598372)
-- Dependencies: 6
-- Name: articles_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE articles_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.articles_id_seq OWNER TO pgsql;

--
-- TOC entry 4206 (class 1259 OID 2598374)
-- Dependencies: 5105 5106 5107 6
-- Name: asso_exo_serie; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE asso_exo_serie (
    id_exo smallint NOT NULL,
    id_serie smallint NOT NULL,
    ordre smallint,
    commentaire character varying(255),
    bareme smallint DEFAULT 0,
    chrono smallint DEFAULT 0,
    point smallint DEFAULT 1,
    type_exo character(1)
);


ALTER TABLE public.asso_exo_serie OWNER TO pgsql;

--
-- TOC entry 4207 (class 1259 OID 2598379)
-- Dependencies: 6
-- Name: asso_exo_serie_aleatoire; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE asso_exo_serie_aleatoire (
    id_exo smallint NOT NULL,
    id_serie smallint NOT NULL,
    ordre smallint,
    commentaire character varying(255),
    bareme smallint,
    chrono smallint,
    point smallint,
    type_exo character(1),
    num_user integer,
    num_cal integer
);


ALTER TABLE public.asso_exo_serie_aleatoire OWNER TO pgsql;

--
-- TOC entry 4208 (class 1259 OID 2598381)
-- Dependencies: 6
-- Name: asso_liste_test; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE asso_liste_test (
    id_liste_test integer NOT NULL,
    id_test integer NOT NULL,
    ordre integer NOT NULL
);


ALTER TABLE public.asso_liste_test OWNER TO pgsql;

--
-- TOC entry 4209 (class 1259 OID 2598383)
-- Dependencies: 6
-- Name: asso_test_reponse; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE asso_test_reponse (
    id_test integer NOT NULL,
    id_reponse integer NOT NULL,
    niveau integer,
    num_bareme integer NOT NULL,
    ordre integer NOT NULL,
    longueur_media integer,
    largeur_media integer,
    media_reponse integer
);


ALTER TABLE public.asso_test_reponse OWNER TO pgsql;

SET default_with_oids = false;

--
-- TOC entry 4210 (class 1259 OID 2598385)
-- Dependencies: 6
-- Name: atest; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE atest (
    text text,
    num_text integer NOT NULL
);


ALTER TABLE public.atest OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4211 (class 1259 OID 2598390)
-- Dependencies: 5108 5109 6
-- Name: auth_user; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE auth_user (
    user_id character varying(32) NOT NULL,
    username character varying(32) DEFAULT ''::character varying NOT NULL,
    "password" character varying(32) DEFAULT ''::character varying NOT NULL,
    perms character varying(255)
);


ALTER TABLE public.auth_user OWNER TO pgsql;

--
-- TOC entry 4212 (class 1259 OID 2598394)
-- Dependencies: 5110 5111 6
-- Name: auth_user_md5; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE auth_user_md5 (
    user_id character varying(32) NOT NULL,
    username character varying(32) DEFAULT ''::character varying NOT NULL,
    "password" character varying(32) DEFAULT ''::character varying NOT NULL,
    perms character varying(255)
);


ALTER TABLE public.auth_user_md5 OWNER TO pgsql;

--
-- TOC entry 4213 (class 1259 OID 2598398)
-- Dependencies: 5112 6
-- Name: bareme; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE bareme (
    num_bareme integer DEFAULT nextval(('SEQ_BAREME'::text)::regclass) NOT NULL,
    libelle_bareme character varying(32),
    repok integer NOT NULL,
    repnotok integer NOT NULL,
    pascoche integer NOT NULL,
    toutcoche integer NOT NULL
);


ALTER TABLE public.bareme OWNER TO pgsql;

--
-- TOC entry 4214 (class 1259 OID 2598401)
-- Dependencies: 6
-- Name: block_ip; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE block_ip (
    ip character varying NOT NULL
);


ALTER TABLE public.block_ip OWNER TO pgsql;

--
-- TOC entry 4215 (class 1259 OID 2598406)
-- Dependencies: 5113 5114 6
-- Name: c_ban_users; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE c_ban_users (
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    ip character varying(16) NOT NULL,
    rooms character varying(100) NOT NULL,
    ban_until integer DEFAULT 0 NOT NULL
);


ALTER TABLE public.c_ban_users OWNER TO pgsql;

--
-- TOC entry 4216 (class 1259 OID 2598410)
-- Dependencies: 5115 5116 5117 6
-- Name: c_messages; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE c_messages (
    "type" smallint DEFAULT (0)::smallint NOT NULL,
    room character varying(256) NOT NULL,
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    m_time integer DEFAULT 0 NOT NULL,
    address character varying(30) NOT NULL,
    message text NOT NULL
);


ALTER TABLE public.c_messages OWNER TO pgsql;

--
-- TOC entry 4217 (class 1259 OID 2598418)
-- Dependencies: 5118 5119 5120 6
-- Name: c_reg_users; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE c_reg_users (
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    "password" character varying(32) NOT NULL,
    perms character varying(9) NOT NULL,
    rooms character varying(128) NOT NULL,
    reg_time integer DEFAULT 0 NOT NULL,
    ip character varying(16) NOT NULL,
    gender smallint DEFAULT (0)::smallint NOT NULL
);


ALTER TABLE public.c_reg_users OWNER TO pgsql;

--
-- TOC entry 4218 (class 1259 OID 2598423)
-- Dependencies: 5121 5122 6
-- Name: c_users; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE c_users (
    room character varying(256) NOT NULL,
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    u_time integer DEFAULT 0 NOT NULL,
    status character varying(1) NOT NULL,
    ip character varying(16) NOT NULL
);


ALTER TABLE public.c_users OWNER TO pgsql;

--
-- TOC entry 4219 (class 1259 OID 2598427)
-- Dependencies: 5123 6
-- Name: calendrier; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE calendrier (
    num_cal integer DEFAULT nextval(('SEQ_CALENDRIER'::text)::regclass) NOT NULL,
    nom_cal character varying(256),
    datedeb integer NOT NULL,
    datefin integer NOT NULL,
    langue character varying(100)
);


ALTER TABLE public.calendrier OWNER TO pgsql;

--
-- TOC entry 4220 (class 1259 OID 2598430)
-- Dependencies: 5124 5125 6
-- Name: capacite; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE capacite (
    num_capacite integer DEFAULT nextval(('seq_capacite'::text)::regclass) NOT NULL,
    libelle_capacite character varying(400) DEFAULT ''::character varying NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE public.capacite OWNER TO pgsql;

--
-- TOC entry 4221 (class 1259 OID 2598434)
-- Dependencies: 5126 5127 6
-- Name: categoriepage; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE categoriepage (
    id integer DEFAULT nextval(('categoriepage_id_seq'::text)::regclass),
    libelle_categorie character varying(100) DEFAULT ''::character varying NOT NULL,
    code character varying(1)
);


ALTER TABLE public.categoriepage OWNER TO pgsql;

--
-- TOC entry 4222 (class 1259 OID 2598438)
-- Dependencies: 6
-- Name: categoriepage_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE categoriepage_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.categoriepage_id_seq OWNER TO pgsql;

--
-- TOC entry 4223 (class 1259 OID 2598440)
-- Dependencies: 5128 6
-- Name: chrono; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE chrono (
    num_chrono integer DEFAULT nextval(('SEQ_CHRONO'::text)::regclass) NOT NULL,
    temps integer NOT NULL
);


ALTER TABLE public.chrono OWNER TO pgsql;

--
-- TOC entry 4224 (class 1259 OID 2598443)
-- Dependencies: 5129 6
-- Name: classe; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE classe (
    id integer DEFAULT nextval(('"classe_id_seq"'::text)::regclass) NOT NULL,
    nom character varying(100) NOT NULL,
    id_pere integer NOT NULL
);


ALTER TABLE public.classe OWNER TO pgsql;

--
-- TOC entry 4225 (class 1259 OID 2598446)
-- Dependencies: 6
-- Name: classe_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE classe_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.classe_id_seq OWNER TO pgsql;

--
-- TOC entry 4226 (class 1259 OID 2598448)
-- Dependencies: 6
-- Name: comment_presentiel; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE comment_presentiel (
    num_cal integer,
    num_user integer,
    num_grille integer,
    num_titrecapacite integer,
    num_capacite integer,
    num_date integer,
    "comment" character varying(200),
    note integer,
    notesur integer
);


ALTER TABLE public.comment_presentiel OWNER TO pgsql;

--
-- TOC entry 4227 (class 1259 OID 2598450)
-- Dependencies: 6
-- Name: commentaire; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE commentaire (
    num_qstaire integer,
    fourchette character varying(20),
    commentaire character varying(400),
    type_exo character(1)
);


ALTER TABLE public.commentaire OWNER TO pgsql;

--
-- TOC entry 4228 (class 1259 OID 2598452)
-- Dependencies: 6
-- Name: commentairepage; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE commentairepage (
    num_cal integer,
    num_page integer,
    commentaire character varying(1000),
    num_qcm integer,
    num_user integer
);


ALTER TABLE public.commentairepage OWNER TO pgsql;

--
-- TOC entry 4229 (class 1259 OID 2598457)
-- Dependencies: 5130 6
-- Name: commentuserrub; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE commentuserrub (
    num_comment integer DEFAULT nextval(('SEQ_COMMENTUSERRUB'::text)::regclass) NOT NULL,
    num_user integer NOT NULL,
    num_exo integer NOT NULL,
    num_rub integer NOT NULL,
    commentaire character varying(256),
    num_cal integer NOT NULL
);


ALTER TABLE public.commentuserrub OWNER TO pgsql;

--
-- TOC entry 4230 (class 1259 OID 2598460)
-- Dependencies: 6
-- Name: config_grille; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE config_grille (
    num_cal integer NOT NULL,
    num_user integer NOT NULL,
    num_grille integer NOT NULL,
    voir boolean
);


ALTER TABLE public.config_grille OWNER TO pgsql;

--
-- TOC entry 4231 (class 1259 OID 2598462)
-- Dependencies: 6
-- Name: config_orientation; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE config_orientation (
    num_parcours integer,
    seuil character varying(400),
    sousparcours character varying(600)
);


ALTER TABLE public.config_orientation OWNER TO pgsql;

--
-- TOC entry 4232 (class 1259 OID 2598467)
-- Dependencies: 6
-- Name: config_ressource; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE config_ressource (
    num_cal integer,
    num_espace integer,
    num_section integer,
    num_fic integer,
    "type" character(1),
    num_parcours integer,
    num_etape integer
);


ALTER TABLE public.config_ressource OWNER TO pgsql;

--
-- TOC entry 4233 (class 1259 OID 2598469)
-- Dependencies: 6
-- Name: configpage; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE configpage (
    num_cal integer,
    num_page integer,
    configuration character varying(100),
    num_qcm integer,
    type_user character varying(10)
);


ALTER TABLE public.configpage OWNER TO pgsql;

--
-- TOC entry 4234 (class 1259 OID 2598471)
-- Dependencies: 6
-- Name: connexion; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE connexion (
    num_user integer NOT NULL,
    date_connexion timestamp with time zone NOT NULL,
    date_deconnexion timestamp with time zone,
    ip character varying(16)
);


ALTER TABLE public.connexion OWNER TO pgsql;

--
-- TOC entry 4235 (class 1259 OID 2598473)
-- Dependencies: 5131 6
-- Name: content; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE content (
    num_content integer DEFAULT nextval(('SEQ_CONTENT'::text)::regclass) NOT NULL,
    co_num_thema integer NOT NULL,
    libelle_content character varying(255),
    nom_fic character varying(100),
    taille_fichier integer,
    mot_cle character varying(255)
);


ALTER TABLE public.content OWNER TO pgsql;

--
-- TOC entry 4236 (class 1259 OID 2598479)
-- Dependencies: 5132 6
-- Name: correction_modele; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE correction_modele (
    id integer DEFAULT nextval(('"CORRECTION_MODELE_id_seq"'::text)::regclass) NOT NULL,
    nom character varying(255) NOT NULL,
    num_theme integer NOT NULL
);


ALTER TABLE public.correction_modele OWNER TO pgsql;

--
-- TOC entry 4237 (class 1259 OID 2598482)
-- Dependencies: 6
-- Name: correction_modele_asso; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE correction_modele_asso (
    num_modele integer NOT NULL,
    num_rub integer NOT NULL,
    num_srub integer,
    note_sur integer,
    ordre integer
);


ALTER TABLE public.correction_modele_asso OWNER TO pgsql;

--
-- TOC entry 4238 (class 1259 OID 2598484)
-- Dependencies: 5133 6
-- Name: couleur; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE couleur (
    num_couleur integer DEFAULT nextval(('seq_couleur'::text)::regclass) NOT NULL,
    nom_couleur character varying(32) NOT NULL,
    code_hexa character varying(7) NOT NULL
);


ALTER TABLE public.couleur OWNER TO pgsql;

--
-- TOC entry 4239 (class 1259 OID 2598487)
-- Dependencies: 5134 6
-- Name: dates; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE dates (
    num_date integer DEFAULT nextval(('SEQ_DATES'::text)::regclass) NOT NULL,
    jour date NOT NULL
);


ALTER TABLE public.dates OWNER TO pgsql;

--
-- TOC entry 4240 (class 1259 OID 2598490)
-- Dependencies: 6
-- Name: detail_erreur_num_dt_erreur_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE detail_erreur_num_dt_erreur_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.detail_erreur_num_dt_erreur_seq OWNER TO pgsql;

--
-- TOC entry 4241 (class 1259 OID 2598492)
-- Dependencies: 5135 6
-- Name: droit; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE droit (
    num_droit integer DEFAULT nextval(('seq_droit'::text)::regclass) NOT NULL,
    libelle_droit character varying(127) NOT NULL,
    type_droit character varying(31) NOT NULL,
    acces_fichier character varying(127),
    defaut integer NOT NULL
);


ALTER TABLE public.droit OWNER TO pgsql;

--
-- TOC entry 4242 (class 1259 OID 2598495)
-- Dependencies: 6
-- Name: elaborqstn; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE elaborqstn (
    eq_num_qstaire integer NOT NULL,
    eq_num_question integer NOT NULL,
    eq_num_chrono integer NOT NULL,
    poids integer,
    num_ordre integer,
    commentaire character varying(255),
    num_bareme integer
);


ALTER TABLE public.elaborqstn OWNER TO pgsql;

--
-- TOC entry 4243 (class 1259 OID 2598497)
-- Dependencies: 6
-- Name: elaborqstn_aleatoire; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE elaborqstn_aleatoire (
    eq_num_qstaire integer,
    eq_num_question integer,
    eq_num_chrono integer,
    poids integer,
    num_ordre integer,
    commentaire character varying(255),
    num_bareme integer,
    num_user integer
);


ALTER TABLE public.elaborqstn_aleatoire OWNER TO pgsql;

--
-- TOC entry 4244 (class 1259 OID 2598499)
-- Dependencies: 6
-- Name: erreur_num_erreur_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE erreur_num_erreur_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.erreur_num_erreur_seq OWNER TO pgsql;

--
-- TOC entry 4245 (class 1259 OID 2598501)
-- Dependencies: 5136 6
-- Name: exotlc; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE exotlc (
    num_exo integer DEFAULT nextval(('SEQ_EXOTLC'::text)::regclass) NOT NULL,
    formateur integer NOT NULL,
    titre character varying(256) NOT NULL,
    commentaire character varying(1024),
    texte character varying(2048),
    enonce character varying(2048),
    remarque character varying(512),
    nomfic_rendu character varying,
    mode_rendu character varying
);


ALTER TABLE public.exotlc OWNER TO pgsql;

--
-- TOC entry 4246 (class 1259 OID 2598507)
-- Dependencies: 5137 6
-- Name: ficmediaqcm; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE ficmediaqcm (
    num_fic integer DEFAULT nextval(('seq_ficmediaqcm'::text)::regclass) NOT NULL,
    nom_fic character varying(32) NOT NULL,
    num_themedir integer NOT NULL
);


ALTER TABLE public.ficmediaqcm OWNER TO pgsql;

--
-- TOC entry 4247 (class 1259 OID 2598510)
-- Dependencies: 5138 6
-- Name: ficmediatlc; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE ficmediatlc (
    num_fic integer DEFAULT nextval(('seq_ficmediatlc'::text)::regclass) NOT NULL,
    nom_fic character varying(32) NOT NULL,
    num_themedir integer NOT NULL
);


ALTER TABLE public.ficmediatlc OWNER TO pgsql;

--
-- TOC entry 4248 (class 1259 OID 2598513)
-- Dependencies: 5139 6
-- Name: fictlc; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE fictlc (
    num_fic integer DEFAULT nextval(('SEQ_FICTLC'::text)::regclass) NOT NULL,
    nom_fic character varying(32) NOT NULL,
    num_themedir integer NOT NULL
);


ALTER TABLE public.fictlc OWNER TO pgsql;

--
-- TOC entry 4249 (class 1259 OID 2598516)
-- Dependencies: 5140 6
-- Name: filiere; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE filiere (
    id integer DEFAULT nextval(('"filiere_id_seq"'::text)::regclass) NOT NULL,
    nom character varying(100) NOT NULL,
    id_pere integer NOT NULL
);


ALTER TABLE public.filiere OWNER TO pgsql;

--
-- TOC entry 4250 (class 1259 OID 2598519)
-- Dependencies: 6
-- Name: filiere_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE filiere_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.filiere_id_seq OWNER TO pgsql;

--
-- TOC entry 4251 (class 1259 OID 2598521)
-- Dependencies: 6
-- Name: formatpage; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE formatpage (
    num_page integer,
    titre boolean,
    date boolean,
    nbquestion boolean,
    duree boolean,
    bareme boolean,
    tempsecoule boolean,
    score boolean,
    commentaire boolean,
    appreciation boolean,
    boutoncorrection boolean,
    chronometre boolean,
    email boolean,
    telephone_fixe boolean,
    adresse boolean,
    nom boolean,
    prenom boolean,
    photo_stagiaire boolean,
    diffusion_stagiaire boolean,
    diffusion_formateur boolean,
    photo_formateur boolean,
    telephone_portable boolean
);


ALTER TABLE public.formatpage OWNER TO pgsql;

--
-- TOC entry 4252 (class 1259 OID 2598523)
-- Dependencies: 6
-- Name: gest_cal; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gest_cal (
    gnum_cal integer NOT NULL,
    num_date integer NOT NULL,
    demi_jour character varying(1) NOT NULL,
    hdeb character varying(5) NOT NULL,
    hfin character varying(5) NOT NULL,
    libelle character varying(256) NOT NULL,
    "type" integer,
    numtype integer NOT NULL,
    num_intervenant integer,
    num_salle integer
);


ALTER TABLE public.gest_cal OWNER TO pgsql;

--
-- TOC entry 4253 (class 1259 OID 2598525)
-- Dependencies: 5141 6
-- Name: gest_ftb; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gest_ftb (
    id integer DEFAULT nextval(('"gest_ftb_id_seq"'::text)::regclass) NOT NULL,
    theme smallint NOT NULL,
    text text NOT NULL,
    show_word boolean NOT NULL,
    inter_html boolean
);


ALTER TABLE public.gest_ftb OWNER TO pgsql;

--
-- TOC entry 4254 (class 1259 OID 2598531)
-- Dependencies: 6
-- Name: gest_ftb_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE gest_ftb_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.gest_ftb_id_seq OWNER TO pgsql;

--
-- TOC entry 4255 (class 1259 OID 2598533)
-- Dependencies: 5142 6
-- Name: gestexotlc; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestexotlc (
    g_num_exotlc integer DEFAULT nextval(('SEQ_GESTEXOTLC'::text)::regclass) NOT NULL,
    gesttlc_exo integer NOT NULL,
    gesttlc_rub integer NOT NULL,
    gesttlc_srub integer NOT NULL,
    gesttlc_user integer NOT NULL,
    resultat integer NOT NULL,
    notesur integer NOT NULL,
    num_cal integer NOT NULL
);


ALTER TABLE public.gestexotlc OWNER TO pgsql;

--
-- TOC entry 4256 (class 1259 OID 2598536)
-- Dependencies: 6
-- Name: gestfic; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestfic (
    gestfic_num_exo integer NOT NULL,
    gestfic_num_fic integer NOT NULL,
    fic_correction character varying(255)
);


ALTER TABLE public.gestfic OWNER TO pgsql;

--
-- TOC entry 4257 (class 1259 OID 2598538)
-- Dependencies: 6
-- Name: gestforum; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestforum (
    numformation integer NOT NULL,
    numforum integer NOT NULL
);


ALTER TABLE public.gestforum OWNER TO pgsql;

--
-- TOC entry 4258 (class 1259 OID 2598540)
-- Dependencies: 6
-- Name: gestionnaire; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestionnaire (
    g_num_user integer NOT NULL,
    g_num_gest_c integer NOT NULL,
    g_num_gest_g integer NOT NULL,
    g_num_cal integer NOT NULL,
    g_num_droit integer NOT NULL,
    g_num_parcours integer
);


ALTER TABLE public.gestionnaire OWNER TO pgsql;

--
-- TOC entry 4259 (class 1259 OID 2598542)
-- Dependencies: 6
-- Name: gestionparcours; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestionparcours (
    gp_num_parcours integer NOT NULL,
    gp_num_groupe integer NOT NULL,
    gp_num_user integer NOT NULL,
    avancement integer NOT NULL,
    avancement_libre integer,
    etape_libre character varying(400),
    num_cal integer
);


ALTER TABLE public.gestionparcours OWNER TO pgsql;

--
-- TOC entry 4260 (class 1259 OID 2598544)
-- Dependencies: 6
-- Name: gestionqst; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestionqst (
    gqst_num_user integer,
    gqst_num_qstaire integer,
    gqst_num_question integer,
    result_qst integer,
    temps_mis integer,
    reponse character varying(20),
    num_cal integer
);


ALTER TABLE public.gestionqst OWNER TO pgsql;

--
-- TOC entry 4261 (class 1259 OID 2598546)
-- Dependencies: 6
-- Name: gestionqstn; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestionqstn (
    gqstn_num_user integer,
    gqstn_num_qstaire integer,
    temps_restant integer,
    result_qstn integer,
    commentaire_qstn character varying(255),
    num_cal integer,
    date_fin integer,
    total integer
);


ALTER TABLE public.gestionqstn OWNER TO pgsql;

--
-- TOC entry 4262 (class 1259 OID 2598548)
-- Dependencies: 6
-- Name: gestionutil; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestionutil (
    gu_num_user integer NOT NULL,
    gu_num_gest_gr integer NOT NULL,
    gu_num_droit integer NOT NULL
);


ALTER TABLE public.gestionutil OWNER TO pgsql;

--
-- TOC entry 4263 (class 1259 OID 2598550)
-- Dependencies: 6
-- Name: gestparcours; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestparcours (
    g_num_parcours integer NOT NULL,
    num_etape integer NOT NULL,
    type_etape character varying(1) NOT NULL,
    num_rang integer NOT NULL,
    num_c_q_e_d integer NOT NULL,
    num_thematik integer NOT NULL,
    attach_fic character varying(255),
    attach_parcours integer,
    num_etape_suivante integer,
    obligation character varying(1),
    nom_etape character varying(255),
    temps_etape integer
);


ALTER TABLE public.gestparcours OWNER TO pgsql;

--
-- TOC entry 4264 (class 1259 OID 2598555)
-- Dependencies: 6
-- Name: gestqcm; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestqcm (
    num_qstaire integer,
    num_cal integer,
    aleatoire boolean,
    datedeb integer,
    datefin integer
);


ALTER TABLE public.gestqcm OWNER TO pgsql;

--
-- TOC entry 4265 (class 1259 OID 2598557)
-- Dependencies: 6
-- Name: gestserie; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE gestserie (
    num_serie integer,
    num_cal integer,
    aleatoire boolean,
    datedeb integer,
    datefin integer
);


ALTER TABLE public.gestserie OWNER TO pgsql;

--
-- TOC entry 4266 (class 1259 OID 2598559)
-- Dependencies: 5143 5144 6
-- Name: grille; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE grille (
    num_grille integer DEFAULT nextval(('seq_grille'::text)::regclass) NOT NULL,
    libelle_grille character varying(400) DEFAULT ''::character varying NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE public.grille OWNER TO pgsql;

--
-- TOC entry 4267 (class 1259 OID 2598563)
-- Dependencies: 6
-- Name: grilletitrecapa; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE grilletitrecapa (
    gt_num_grille integer NOT NULL,
    gt_num_titrecapacite integer NOT NULL
);


ALTER TABLE public.grilletitrecapa OWNER TO pgsql;

--
-- TOC entry 4268 (class 1259 OID 2598565)
-- Dependencies: 6
-- Name: individu_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE individu_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.individu_id_seq OWNER TO pgsql;

--
-- TOC entry 4269 (class 1259 OID 2598567)
-- Dependencies: 5145 6
-- Name: intervention; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE intervention (
    id integer DEFAULT nextval(('"intervention_id_seq"'::text)::regclass) NOT NULL,
    nom character varying(100) NOT NULL,
    code_couleur character varying(10) NOT NULL
);


ALTER TABLE public.intervention OWNER TO pgsql;

--
-- TOC entry 4270 (class 1259 OID 2598570)
-- Dependencies: 6
-- Name: intervention_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE intervention_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.intervention_id_seq OWNER TO pgsql;

--
-- TOC entry 4271 (class 1259 OID 2598572)
-- Dependencies: 6
-- Name: intervention_type_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE intervention_type_id_seq
    START WITH 14
    INCREMENT BY 1
    NO MAXVALUE
    MINVALUE 14
    CACHE 1;


ALTER TABLE public.intervention_type_id_seq OWNER TO pgsql;

--
-- TOC entry 4272 (class 1259 OID 2598574)
-- Dependencies: 5146 6
-- Name: liste_test; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE liste_test (
    id_liste_test integer DEFAULT nextval(('"liste_test_id_liste_test_seq"'::text)::regclass) NOT NULL,
    nom_liste_test character varying NOT NULL,
    longueur_media integer,
    largeur_media integer,
    media_liste_test integer,
    dynamique boolean,
    continue boolean
);


ALTER TABLE public.liste_test OWNER TO pgsql;

--
-- TOC entry 4273 (class 1259 OID 2598580)
-- Dependencies: 6
-- Name: liste_test_id_liste_test_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE liste_test_id_liste_test_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.liste_test_id_liste_test_seq OWNER TO pgsql;

--
-- TOC entry 4274 (class 1259 OID 2598582)
-- Dependencies: 5147 5148 5149 5150 6
-- Name: log_display; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE log_display (
    module character varying(20) DEFAULT ''::character varying NOT NULL,
    "action" character varying(20) DEFAULT ''::character varying NOT NULL,
    mtable character varying(20) DEFAULT ''::character varying NOT NULL,
    field character varying(40) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE public.log_display OWNER TO pgsql;

--
-- TOC entry 4275 (class 1259 OID 2598588)
-- Dependencies: 6
-- Name: maxi; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE maxi (
    max integer
);


ALTER TABLE public.maxi OWNER TO pgsql;

--
-- TOC entry 4276 (class 1259 OID 2598590)
-- Dependencies: 6
-- Name: nb_etapes_reelle_faites; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE nb_etapes_reelle_faites (
    count bigint
);


ALTER TABLE public.nb_etapes_reelle_faites OWNER TO pgsql;

--
-- TOC entry 4277 (class 1259 OID 2598592)
-- Dependencies: 6
-- Name: nb_etapes_reelles_faites; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE nb_etapes_reelles_faites (
    count bigint
);


ALTER TABLE public.nb_etapes_reelles_faites OWNER TO pgsql;

--
-- TOC entry 4278 (class 1259 OID 2598594)
-- Dependencies: 6
-- Name: niveau_exo; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE niveau_exo (
    num_theme integer NOT NULL,
    num_exo integer NOT NULL,
    type_exo character(1) NOT NULL,
    niveau integer NOT NULL
);


ALTER TABLE public.niveau_exo OWNER TO pgsql;

--
-- TOC entry 4279 (class 1259 OID 2598596)
-- Dependencies: 6
-- Name: notation; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE notation (
    num_cal integer,
    num_user integer,
    num_grille integer,
    num_titrecapacite integer,
    num_capacite integer,
    notation character varying(400)
);


ALTER TABLE public.notation OWNER TO pgsql;

--
-- TOC entry 4280 (class 1259 OID 2598598)
-- Dependencies: 5151 6
-- Name: organisme; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE organisme (
    num_org integer DEFAULT nextval(('SEQ_ORGANISME'::text)::regclass) NOT NULL,
    libelle_org character varying(32) NOT NULL
);


ALTER TABLE public.organisme OWNER TO pgsql;

--
-- TOC entry 4281 (class 1259 OID 2598601)
-- Dependencies: 5152 5153 5154 6
-- Name: page; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE page (
    id integer DEFAULT nextval(('page_id_seq'::text)::regclass),
    titre_page character varying(200) DEFAULT ''::character varying NOT NULL,
    categorie integer NOT NULL,
    libelle_script character varying(200) DEFAULT ''::character varying NOT NULL
);


ALTER TABLE public.page OWNER TO pgsql;

--
-- TOC entry 4282 (class 1259 OID 2598606)
-- Dependencies: 6
-- Name: page_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE page_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.page_id_seq OWNER TO pgsql;

--
-- TOC entry 4283 (class 1259 OID 2598608)
-- Dependencies: 5155 6
-- Name: parcours; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE parcours (
    num_parcours integer DEFAULT nextval(('seq_parcours'::text)::regclass) NOT NULL,
    nom_parcours character varying(255) NOT NULL,
    affiche_fo boolean
);


ALTER TABLE public.parcours OWNER TO pgsql;

--
-- TOC entry 4284 (class 1259 OID 2598611)
-- Dependencies: 6
-- Name: pga_diagrams; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE pga_diagrams (
    diagramname character varying(64) NOT NULL,
    diagramtables text,
    diagramlinks text
);


ALTER TABLE public.pga_diagrams OWNER TO pgsql;

--
-- TOC entry 4285 (class 1259 OID 2598616)
-- Dependencies: 6
-- Name: pga_forms; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE pga_forms (
    formname character varying(64),
    formsource text
);


ALTER TABLE public.pga_forms OWNER TO pgsql;

--
-- TOC entry 4286 (class 1259 OID 2598621)
-- Dependencies: 6
-- Name: pga_graphs; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE pga_graphs (
    graphname character varying(64) NOT NULL,
    graphsource text,
    graphcode text
);


ALTER TABLE public.pga_graphs OWNER TO pgsql;

--
-- TOC entry 4287 (class 1259 OID 2598626)
-- Dependencies: 6
-- Name: pga_images; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE pga_images (
    imagename character varying(64) NOT NULL,
    imagesource text
);


ALTER TABLE public.pga_images OWNER TO pgsql;

--
-- TOC entry 4288 (class 1259 OID 2598631)
-- Dependencies: 6
-- Name: pga_layout; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE pga_layout (
    tablename character varying(64),
    nrcols smallint,
    colnames text,
    colwidth text
);


ALTER TABLE public.pga_layout OWNER TO pgsql;

--
-- TOC entry 4289 (class 1259 OID 2598636)
-- Dependencies: 6
-- Name: pga_queries; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE pga_queries (
    queryname character varying(64),
    querytype character(1),
    querycommand text,
    querytables text,
    querylinks text,
    queryresults text,
    querycomments text
);


ALTER TABLE public.pga_queries OWNER TO pgsql;

--
-- TOC entry 4290 (class 1259 OID 2598641)
-- Dependencies: 6
-- Name: pga_reports; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE pga_reports (
    reportname character varying(64),
    reportsource text,
    reportbody text,
    reportprocs text,
    reportoptions text
);


ALTER TABLE public.pga_reports OWNER TO pgsql;

--
-- TOC entry 4291 (class 1259 OID 2598646)
-- Dependencies: 6
-- Name: pga_schema; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE pga_schema (
    schemaname character varying(64),
    schematables text,
    schemalinks text
);


ALTER TABLE public.pga_schema OWNER TO pgsql;

--
-- TOC entry 4292 (class 1259 OID 2598651)
-- Dependencies: 6
-- Name: pga_scripts; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE pga_scripts (
    scriptname character varying(64),
    scriptsource text
);


ALTER TABLE public.pga_scripts OWNER TO pgsql;

--
-- TOC entry 4293 (class 1259 OID 2598656)
-- Dependencies: 6
-- Name: placegroupe; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE placegroupe (
    num_gest_groupe integer NOT NULL,
    maxplace integer NOT NULL,
    minplace integer NOT NULL
);


ALTER TABLE public.placegroupe OWNER TO pgsql;

--
-- TOC entry 4294 (class 1259 OID 2598658)
-- Dependencies: 5156 6
-- Name: proposition; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE proposition (
    num_prop integer DEFAULT nextval(('SEQ_PROPOSITION'::text)::regclass) NOT NULL,
    libelle_prop character varying(255),
    theme integer,
    inter_html boolean
);


ALTER TABLE public.proposition OWNER TO pgsql;

--
-- TOC entry 4295 (class 1259 OID 2598661)
-- Dependencies: 6
-- Name: proposition_sondage; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE proposition_sondage (
    num_sondage integer NOT NULL,
    num_proposition integer NOT NULL,
    pmedia integer,
    plargeur integer,
    phauteur integer,
    ordre integer
);


ALTER TABLE public.proposition_sondage OWNER TO pgsql;

--
-- TOC entry 4296 (class 1259 OID 2598663)
-- Dependencies: 6
-- Name: qcm_aleatoire; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE qcm_aleatoire (
    num_qstaire integer,
    theme integer,
    qstaire integer,
    nbquestion integer,
    "mode" integer
);


ALTER TABLE public.qcm_aleatoire OWNER TO pgsql;

--
-- TOC entry 4297 (class 1259 OID 2598665)
-- Dependencies: 6
-- Name: qcm_bloquant; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE qcm_bloquant (
    num_cal integer,
    num_qcm integer,
    seuil integer,
    etape_retour integer,
    tentative integer,
    correction boolean,
    blocage_parcours boolean
);


ALTER TABLE public.qcm_bloquant OWNER TO pgsql;

--
-- TOC entry 4298 (class 1259 OID 2598667)
-- Dependencies: 6
-- Name: quest_rep; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE quest_rep (
    qr_num_question integer NOT NULL,
    qr_num_rep integer NOT NULL,
    juste boolean,
    qmedia character varying(100),
    rmedia character varying(100),
    flash character varying(100),
    largeur_qmedia integer,
    hauteur_qmedia integer,
    largeur_rmedia integer,
    hauteur_rmedia integer,
    ordre integer
);


ALTER TABLE public.quest_rep OWNER TO pgsql;

--
-- TOC entry 4299 (class 1259 OID 2598669)
-- Dependencies: 5157 6
-- Name: question; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE question (
    num_question integer DEFAULT nextval(('SEQ_QUESTION'::text)::regclass) NOT NULL,
    libelle_question character varying(255),
    theme integer,
    inter_html boolean
);


ALTER TABLE public.question OWNER TO pgsql;

--
-- TOC entry 4300 (class 1259 OID 2598672)
-- Dependencies: 5158 6
-- Name: question_sondage; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE question_sondage (
    num_sondage integer DEFAULT nextval(('question_sondage_seq'::text)::regclass) NOT NULL,
    question character varying(255) NOT NULL,
    theme integer,
    qmedia integer,
    largeur integer,
    hauteur integer,
    type_sondage character varying,
    inter_html boolean
);


ALTER TABLE public.question_sondage OWNER TO pgsql;

--
-- TOC entry 4301 (class 1259 OID 2598678)
-- Dependencies: 6
-- Name: question_sondage_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE question_sondage_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.question_sondage_seq OWNER TO pgsql;

--
-- TOC entry 4302 (class 1259 OID 2598680)
-- Dependencies: 5159 6
-- Name: questionnaire; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE questionnaire (
    num_qstaire integer DEFAULT nextval(('SEQ_QUESTIONNAIRE'::text)::regclass) NOT NULL,
    libelle_qstaire character varying(255),
    num_bareme integer,
    poids_qstaire integer,
    theme integer,
    chrono_qstaire integer
);


ALTER TABLE public.questionnaire OWNER TO pgsql;

--
-- TOC entry 4303 (class 1259 OID 2598683)
-- Dependencies: 6
-- Name: rec; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE rec (
    id integer,
    libelle character varying(1024),
    interpretation_html boolean
);


ALTER TABLE public.rec OWNER TO postgres;

--
-- TOC entry 4304 (class 1259 OID 2598688)
-- Dependencies: 6
-- Name: reception_exostlc; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE reception_exostlc (
    num_exo integer NOT NULL,
    num_stag integer NOT NULL,
    num_cal integer NOT NULL,
    rcpt_date integer,
    nom_fic character varying(255),
    corrige character varying(10)
);


ALTER TABLE public.reception_exostlc OWNER TO pgsql;

--
-- TOC entry 4305 (class 1259 OID 2598690)
-- Dependencies: 5160 6
-- Name: reponse; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE reponse (
    num_rep integer DEFAULT nextval(('SEQ_REPONSE'::text)::regclass) NOT NULL,
    libelle_rep character varying(255),
    theme integer,
    inter_html boolean
);


ALTER TABLE public.reponse OWNER TO pgsql;

--
-- TOC entry 4306 (class 1259 OID 2598693)
-- Dependencies: 6
-- Name: res_liste; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE res_liste (
    id_stag smallint NOT NULL,
    id_formation smallint NOT NULL,
    id_liste smallint NOT NULL,
    score real,
    date_fin integer
);


ALTER TABLE public.res_liste OWNER TO pgsql;

--
-- TOC entry 4307 (class 1259 OID 2598695)
-- Dependencies: 6
-- Name: res_liste_test; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE res_liste_test (
    id_stag smallint NOT NULL,
    id_formation smallint NOT NULL,
    id_liste smallint NOT NULL,
    ordre_etape smallint NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    score real,
    type_exo character(1),
    temps_mis integer
);


ALTER TABLE public.res_liste_test OWNER TO pgsql;

--
-- TOC entry 4308 (class 1259 OID 2598697)
-- Dependencies: 6
-- Name: res_serie; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE res_serie (
    id_stag smallint NOT NULL,
    id_formation smallint NOT NULL,
    id_serie smallint NOT NULL,
    score real,
    date_fin integer
);


ALTER TABLE public.res_serie OWNER TO pgsql;

--
-- TOC entry 4309 (class 1259 OID 2598699)
-- Dependencies: 6
-- Name: res_serie_exo; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE res_serie_exo (
    id_stag smallint NOT NULL,
    id_formation smallint NOT NULL,
    id_serie smallint NOT NULL,
    ordre_etape smallint NOT NULL,
    reponse text,
    score real,
    type_exo character(1),
    temps_mis integer
);


ALTER TABLE public.res_serie_exo OWNER TO pgsql;

--
-- TOC entry 4310 (class 1259 OID 2598704)
-- Dependencies: 5161 5162 6
-- Name: resexouser; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE resexouser (
    num_resexouser integer DEFAULT nextval(('SEQ_RESEXOUSER'::text)::regclass) NOT NULL,
    num_user integer NOT NULL,
    num_exo integer NOT NULL,
    commentaire character varying(256),
    surtotal integer NOT NULL,
    score integer NOT NULL,
    date_correction integer,
    num_cal integer NOT NULL,
    corrige boolean DEFAULT false
);


ALTER TABLE public.resexouser OWNER TO pgsql;

--
-- TOC entry 4311 (class 1259 OID 2598708)
-- Dependencies: 5163 6
-- Name: ressource; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE ressource (
    num_res integer DEFAULT nextval(('SEQ_RESSOURCE'::text)::regclass) NOT NULL,
    libelle_res character varying(255)
);


ALTER TABLE public.ressource OWNER TO pgsql;

--
-- TOC entry 4312 (class 1259 OID 2598711)
-- Dependencies: 5164 6
-- Name: ressource_esp; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE ressource_esp (
    num_espace integer DEFAULT nextval(('seq_ressourceesp'::text)::regclass) NOT NULL,
    titre character varying(255) NOT NULL
);


ALTER TABLE public.ressource_esp OWNER TO pgsql;

--
-- TOC entry 4313 (class 1259 OID 2598714)
-- Dependencies: 5165 6
-- Name: ressource_fic; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE ressource_fic (
    num_fic integer DEFAULT nextval(('SEQ_RESSOURCEFIC'::text)::regclass) NOT NULL,
    nom_fic character varying(32) NOT NULL,
    num_themedir integer
);


ALTER TABLE public.ressource_fic OWNER TO pgsql;

--
-- TOC entry 4314 (class 1259 OID 2598717)
-- Dependencies: 5166 5167 6
-- Name: ressource_gest; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE ressource_gest (
    num_gest_res integer DEFAULT nextval(('SEQ_RESSOURCEGEST'::text)::regclass) NOT NULL,
    num_fic integer NOT NULL,
    num_section integer NOT NULL,
    num_espace integer NOT NULL,
    libelle character varying(255),
    num_cal integer NOT NULL,
    datedeb date,
    datefin date,
    nouveau integer,
    motcle character varying(255),
    "type" character(1) DEFAULT 'f'::bpchar
);


ALTER TABLE public.ressource_gest OWNER TO pgsql;

--
-- TOC entry 4315 (class 1259 OID 2598724)
-- Dependencies: 5168 6
-- Name: ressource_sec; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE ressource_sec (
    num_section integer DEFAULT nextval(('seq_ressourcesec'::text)::regclass) NOT NULL,
    titre character varying(255) NOT NULL,
    icone character varying(32)
);


ALTER TABLE public.ressource_sec OWNER TO pgsql;

--
-- TOC entry 4316 (class 1259 OID 2598727)
-- Dependencies: 5169 6
-- Name: ressource_txt; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE ressource_txt (
    num_text integer DEFAULT nextval(('"ressource_txt_num_text_seq"'::text)::regclass) NOT NULL,
    nom character varying(250) NOT NULL,
    num_themedir integer NOT NULL,
    text text NOT NULL
);


ALTER TABLE public.ressource_txt OWNER TO pgsql;

--
-- TOC entry 4317 (class 1259 OID 2598733)
-- Dependencies: 6
-- Name: ressource_txt_num_text_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE ressource_txt_num_text_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.ressource_txt_num_text_seq OWNER TO pgsql;

--
-- TOC entry 4318 (class 1259 OID 2598735)
-- Dependencies: 6
-- Name: ressource_txt_num_txt_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE ressource_txt_num_txt_seq
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.ressource_txt_num_txt_seq OWNER TO pgsql;

--
-- TOC entry 4319 (class 1259 OID 2598737)
-- Dependencies: 5170 6
-- Name: rubrique; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE rubrique (
    num_rub integer DEFAULT nextval(('SEQ_RUBRIQUE'::text)::regclass) NOT NULL,
    libelle_rub character varying(256) NOT NULL,
    rub_numtheme integer NOT NULL
);


ALTER TABLE public.rubrique OWNER TO pgsql;

--
-- TOC entry 4320 (class 1259 OID 2598740)
-- Dependencies: 5171 6
-- Name: salle; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE salle (
    num_salle integer DEFAULT nextval(('seq_salle'::text)::regclass) NOT NULL,
    nom_salle character varying(255) NOT NULL
);


ALTER TABLE public.salle OWNER TO pgsql;

--
-- TOC entry 4321 (class 1259 OID 2598743)
-- Dependencies: 6
-- Name: sauvegarde_calendrier; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE sauvegarde_calendrier (
    num_cal integer,
    nom_cal character varying(256),
    datedeb date,
    datefin date,
    date_presentiel character varying(600),
    date_synchrone character varying(600),
    date_asynchrone character varying(600),
    nom_filiere character varying(400),
    taille_groupe integer
);


ALTER TABLE public.sauvegarde_calendrier OWNER TO pgsql;

--
-- TOC entry 4322 (class 1259 OID 2598748)
-- Dependencies: 6
-- Name: sauvegarde_date; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE sauvegarde_date (
    num_date integer,
    jour date
);


ALTER TABLE public.sauvegarde_date OWNER TO pgsql;

--
-- TOC entry 4323 (class 1259 OID 2598750)
-- Dependencies: 6
-- Name: sauvegarde_evaluation; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE sauvegarde_evaluation (
    num_exo integer,
    nom_exo character varying(255),
    "type" character varying(3),
    theme integer
);


ALTER TABLE public.sauvegarde_evaluation OWNER TO pgsql;

--
-- TOC entry 4324 (class 1259 OID 2598752)
-- Dependencies: 6
-- Name: sauvegarde_exorubrique; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE sauvegarde_exorubrique (
    num_cal integer,
    num_user integer,
    num_exo integer,
    num_rubrique integer,
    num_sousrubrique integer,
    notesurvingt character varying(10)
);


ALTER TABLE public.sauvegarde_exorubrique OWNER TO pgsql;

--
-- TOC entry 4325 (class 1259 OID 2598754)
-- Dependencies: 6
-- Name: sauvegarde_presentiel; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE sauvegarde_presentiel (
    num_cal integer,
    num_user integer,
    num_grille integer,
    num_titrecapacite integer,
    num_capacite integer,
    notation character varying(400),
    notesurvingt character varying(600)
);


ALTER TABLE public.sauvegarde_presentiel OWNER TO pgsql;

--
-- TOC entry 4326 (class 1259 OID 2598759)
-- Dependencies: 6
-- Name: sauvegarde_resultat; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE sauvegarde_resultat (
    num_cal integer,
    num_user integer,
    num_exo integer,
    notesurvingt character varying(10),
    date integer,
    "type" character varying(3)
);


ALTER TABLE public.sauvegarde_resultat OWNER TO pgsql;

--
-- TOC entry 4327 (class 1259 OID 2598761)
-- Dependencies: 6
-- Name: sauvegarde_theme; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE sauvegarde_theme (
    num_theme integer,
    nom_theme character varying(128)
);


ALTER TABLE public.sauvegarde_theme OWNER TO pgsql;

--
-- TOC entry 4328 (class 1259 OID 2598763)
-- Dependencies: 5172 5173 5174 5175 5176 5177 5178 5179 5180 5181 5182 5183 5184 6
-- Name: scorm; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE scorm (
    id integer DEFAULT nextval(('"scorm_id_seq"'::text)::regclass) NOT NULL,
    course integer DEFAULT 0 NOT NULL,
    name character varying(255) DEFAULT ''::character varying NOT NULL,
    reference character varying(255) DEFAULT ''::character varying NOT NULL,
    maxgrade real DEFAULT (0)::real NOT NULL,
    grademethod integer DEFAULT 0 NOT NULL,
    datadir character varying(255) DEFAULT ''::character varying NOT NULL,
    launch integer DEFAULT 0 NOT NULL,
    summary text DEFAULT ''::text NOT NULL,
    auto integer DEFAULT 0 NOT NULL,
    popup character varying(255) DEFAULT ''::character varying NOT NULL,
    timemodified integer DEFAULT 0 NOT NULL,
    num_theme integer DEFAULT 0 NOT NULL
);


ALTER TABLE public.scorm OWNER TO pgsql;

--
-- TOC entry 4329 (class 1259 OID 2598781)
-- Dependencies: 6
-- Name: scorm_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE scorm_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.scorm_id_seq OWNER TO pgsql;

--
-- TOC entry 4330 (class 1259 OID 2598783)
-- Dependencies: 5185 5186 5187 5188 5189 5190 5191 5192 5193 5194 5195 6
-- Name: scorm_sco_users; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE scorm_sco_users (
    id integer DEFAULT nextval(('"scorm_sco_users_id_seq"'::text)::regclass) NOT NULL,
    userid integer DEFAULT 0 NOT NULL,
    scormid integer DEFAULT 0 NOT NULL,
    scoid integer DEFAULT 0 NOT NULL,
    cmi_core_lesson_location character varying(255) DEFAULT ''::character varying NOT NULL,
    cmi_core_lesson_status character varying(30) DEFAULT ''::character varying NOT NULL,
    cmi_core_exit character varying(30) DEFAULT ''::character varying NOT NULL,
    cmi_core_total_time character varying(13) DEFAULT '00:00:00'::character varying NOT NULL,
    cmi_core_session_time character varying(13) DEFAULT '00:00:00'::character varying NOT NULL,
    cmi_core_score_raw real DEFAULT (0)::real NOT NULL,
    cmi_suspend_data text DEFAULT ''::text NOT NULL,
    num_cal integer
);


ALTER TABLE public.scorm_sco_users OWNER TO pgsql;

--
-- TOC entry 4331 (class 1259 OID 2598799)
-- Dependencies: 6
-- Name: scorm_sco_users_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE scorm_sco_users_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.scorm_sco_users_id_seq OWNER TO pgsql;

--
-- TOC entry 4332 (class 1259 OID 2598801)
-- Dependencies: 5196 5197 5198 5199 5200 5201 5202 5203 5204 5205 5206 5207 6
-- Name: scorm_scoes; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE scorm_scoes (
    id integer DEFAULT nextval(('"scorm_scoes_id_seq"'::text)::regclass) NOT NULL,
    scorm integer DEFAULT 0 NOT NULL,
    manifest character varying(255) DEFAULT ''::character varying NOT NULL,
    organization character varying(255) DEFAULT ''::character varying NOT NULL,
    parent character varying(255) DEFAULT ''::character varying NOT NULL,
    identifier character varying(255) DEFAULT ''::character varying NOT NULL,
    launch character varying(255) DEFAULT ''::character varying NOT NULL,
    "type" character varying(5) DEFAULT ''::character varying NOT NULL,
    title character varying(255) DEFAULT ''::character varying NOT NULL,
    datafromlms text DEFAULT ''::text NOT NULL,
    "next" integer DEFAULT 0 NOT NULL,
    previous integer DEFAULT 0 NOT NULL
);


ALTER TABLE public.scorm_scoes OWNER TO pgsql;

--
-- TOC entry 4333 (class 1259 OID 2598818)
-- Dependencies: 6
-- Name: scorm_scoes_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE scorm_scoes_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.scorm_scoes_id_seq OWNER TO pgsql;

--
-- TOC entry 4334 (class 1259 OID 2598820)
-- Dependencies: 6
-- Name: seq_bareme; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_bareme
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_bareme OWNER TO pgsql;

--
-- TOC entry 4335 (class 1259 OID 2598822)
-- Dependencies: 6
-- Name: seq_calendrier; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_calendrier
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_calendrier OWNER TO pgsql;

--
-- TOC entry 4336 (class 1259 OID 2598824)
-- Dependencies: 6
-- Name: seq_capacite; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_capacite
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_capacite OWNER TO pgsql;

--
-- TOC entry 4337 (class 1259 OID 2598826)
-- Dependencies: 6
-- Name: seq_categorie; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_categorie
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_categorie OWNER TO pgsql;

--
-- TOC entry 4338 (class 1259 OID 2598828)
-- Dependencies: 6
-- Name: seq_chrono; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_chrono
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_chrono OWNER TO pgsql;

--
-- TOC entry 4339 (class 1259 OID 2598830)
-- Dependencies: 6
-- Name: seq_commentuserrub; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_commentuserrub
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_commentuserrub OWNER TO pgsql;

--
-- TOC entry 4340 (class 1259 OID 2598832)
-- Dependencies: 6
-- Name: seq_content; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_content
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_content OWNER TO pgsql;

--
-- TOC entry 4341 (class 1259 OID 2598834)
-- Dependencies: 6
-- Name: seq_couleur; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_couleur
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_couleur OWNER TO pgsql;

--
-- TOC entry 4342 (class 1259 OID 2598836)
-- Dependencies: 6
-- Name: seq_cours; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_cours
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_cours OWNER TO pgsql;

--
-- TOC entry 4343 (class 1259 OID 2598838)
-- Dependencies: 6
-- Name: seq_dates; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_dates
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_dates OWNER TO pgsql;

--
-- TOC entry 4344 (class 1259 OID 2598840)
-- Dependencies: 6
-- Name: seq_droit; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_droit
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_droit OWNER TO pgsql;

--
-- TOC entry 4345 (class 1259 OID 2598842)
-- Dependencies: 6
-- Name: seq_exotlc; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_exotlc
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_exotlc OWNER TO pgsql;

--
-- TOC entry 4346 (class 1259 OID 2598844)
-- Dependencies: 6
-- Name: seq_ficmediaqcm; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_ficmediaqcm
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ficmediaqcm OWNER TO pgsql;

--
-- TOC entry 4347 (class 1259 OID 2598846)
-- Dependencies: 6
-- Name: seq_ficmediatlc; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_ficmediatlc
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ficmediatlc OWNER TO pgsql;

--
-- TOC entry 4348 (class 1259 OID 2598848)
-- Dependencies: 6
-- Name: seq_fictlc; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_fictlc
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_fictlc OWNER TO pgsql;

--
-- TOC entry 4349 (class 1259 OID 2598850)
-- Dependencies: 6
-- Name: seq_gestexotlc; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_gestexotlc
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_gestexotlc OWNER TO pgsql;

--
-- TOC entry 4350 (class 1259 OID 2598852)
-- Dependencies: 6
-- Name: seq_gestioncours; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_gestioncours
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_gestioncours OWNER TO pgsql;

--
-- TOC entry 4351 (class 1259 OID 2598854)
-- Dependencies: 6
-- Name: seq_gestiongrille; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_gestiongrille
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_gestiongrille OWNER TO pgsql;

--
-- TOC entry 4352 (class 1259 OID 2598856)
-- Dependencies: 6
-- Name: seq_gestiongroupe; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_gestiongroupe
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_gestiongroupe OWNER TO pgsql;

--
-- TOC entry 4353 (class 1259 OID 2598858)
-- Dependencies: 6
-- Name: seq_grille; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_grille
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_grille OWNER TO pgsql;

--
-- TOC entry 4354 (class 1259 OID 2598860)
-- Dependencies: 6
-- Name: seq_grilletitrecapa; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_grilletitrecapa
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_grilletitrecapa OWNER TO pgsql;

--
-- TOC entry 4355 (class 1259 OID 2598862)
-- Dependencies: 6
-- Name: seq_groupe; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_groupe
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_groupe OWNER TO pgsql;

--
-- TOC entry 4356 (class 1259 OID 2598864)
-- Dependencies: 6
-- Name: seq_module; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_module
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_module OWNER TO pgsql;

--
-- TOC entry 4357 (class 1259 OID 2598866)
-- Dependencies: 6
-- Name: seq_notation; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_notation
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_notation OWNER TO pgsql;

--
-- TOC entry 4358 (class 1259 OID 2598868)
-- Dependencies: 6
-- Name: seq_organisme; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_organisme
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_organisme OWNER TO pgsql;

--
-- TOC entry 4359 (class 1259 OID 2598870)
-- Dependencies: 6
-- Name: seq_parcours; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_parcours
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_parcours OWNER TO pgsql;

--
-- TOC entry 4360 (class 1259 OID 2598872)
-- Dependencies: 6
-- Name: seq_proposition; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_proposition
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_proposition OWNER TO pgsql;

--
-- TOC entry 4361 (class 1259 OID 2598874)
-- Dependencies: 6
-- Name: seq_question; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_question
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_question OWNER TO pgsql;

--
-- TOC entry 4362 (class 1259 OID 2598876)
-- Dependencies: 6
-- Name: seq_questionnaire; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_questionnaire
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_questionnaire OWNER TO pgsql;

--
-- TOC entry 4363 (class 1259 OID 2598878)
-- Dependencies: 6
-- Name: seq_reponse; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_reponse
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_reponse OWNER TO pgsql;

--
-- TOC entry 4364 (class 1259 OID 2598880)
-- Dependencies: 6
-- Name: seq_resexouser; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_resexouser
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_resexouser OWNER TO pgsql;

--
-- TOC entry 4365 (class 1259 OID 2598882)
-- Dependencies: 6
-- Name: seq_ressource; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_ressource
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ressource OWNER TO pgsql;

--
-- TOC entry 4366 (class 1259 OID 2598884)
-- Dependencies: 6
-- Name: seq_ressourceesp; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_ressourceesp
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ressourceesp OWNER TO pgsql;

--
-- TOC entry 4367 (class 1259 OID 2598886)
-- Dependencies: 6
-- Name: seq_ressourcefic; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_ressourcefic
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ressourcefic OWNER TO pgsql;

--
-- TOC entry 4368 (class 1259 OID 2598888)
-- Dependencies: 6
-- Name: seq_ressourcegest; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_ressourcegest
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ressourcegest OWNER TO pgsql;

--
-- TOC entry 4369 (class 1259 OID 2598890)
-- Dependencies: 6
-- Name: seq_ressourcesec; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_ressourcesec
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_ressourcesec OWNER TO pgsql;

--
-- TOC entry 4370 (class 1259 OID 2598892)
-- Dependencies: 6
-- Name: seq_rubrique; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_rubrique
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_rubrique OWNER TO pgsql;

--
-- TOC entry 4371 (class 1259 OID 2598894)
-- Dependencies: 6
-- Name: seq_salle; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_salle
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_salle OWNER TO pgsql;

--
-- TOC entry 4372 (class 1259 OID 2598896)
-- Dependencies: 6
-- Name: seq_souscours; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_souscours
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_souscours OWNER TO pgsql;

--
-- TOC entry 4373 (class 1259 OID 2598898)
-- Dependencies: 6
-- Name: seq_sousgroupe; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_sousgroupe
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_sousgroupe OWNER TO pgsql;

--
-- TOC entry 4374 (class 1259 OID 2598900)
-- Dependencies: 6
-- Name: seq_sousouscours; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_sousouscours
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_sousouscours OWNER TO pgsql;

--
-- TOC entry 4375 (class 1259 OID 2598902)
-- Dependencies: 6
-- Name: seq_sousousgroupe; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_sousousgroupe
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_sousousgroupe OWNER TO pgsql;

--
-- TOC entry 4376 (class 1259 OID 2598904)
-- Dependencies: 6
-- Name: seq_sousousouscours; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_sousousouscours
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_sousousouscours OWNER TO pgsql;

--
-- TOC entry 4377 (class 1259 OID 2598906)
-- Dependencies: 6
-- Name: seq_sousousousgroupe; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_sousousousgroupe
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_sousousousgroupe OWNER TO pgsql;

--
-- TOC entry 4378 (class 1259 OID 2598908)
-- Dependencies: 6
-- Name: seq_sousousousouscours; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_sousousousouscours
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_sousousousouscours OWNER TO pgsql;

--
-- TOC entry 4379 (class 1259 OID 2598910)
-- Dependencies: 6
-- Name: seq_sousousousousgroupe; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_sousousousousgroupe
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_sousousousousgroupe OWNER TO pgsql;

--
-- TOC entry 4380 (class 1259 OID 2598912)
-- Dependencies: 6
-- Name: seq_sousrubrique; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_sousrubrique
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_sousrubrique OWNER TO pgsql;

--
-- TOC entry 4381 (class 1259 OID 2598914)
-- Dependencies: 6
-- Name: seq_thematique; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_thematique
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_thematique OWNER TO pgsql;

--
-- TOC entry 4382 (class 1259 OID 2598916)
-- Dependencies: 6
-- Name: seq_themedir; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_themedir
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_themedir OWNER TO pgsql;

--
-- TOC entry 4383 (class 1259 OID 2598918)
-- Dependencies: 6
-- Name: seq_titrecapa; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_titrecapa
    START WITH 1
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_titrecapa OWNER TO pgsql;

--
-- TOC entry 4384 (class 1259 OID 2598920)
-- Dependencies: 6
-- Name: seq_titrecapacite; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_titrecapacite
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_titrecapacite OWNER TO pgsql;

--
-- TOC entry 4385 (class 1259 OID 2598922)
-- Dependencies: 6
-- Name: seq_typeform; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_typeform
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_typeform OWNER TO pgsql;

--
-- TOC entry 4386 (class 1259 OID 2598924)
-- Dependencies: 6
-- Name: seq_utilisateurs; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE seq_utilisateurs
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.seq_utilisateurs OWNER TO pgsql;

--
-- TOC entry 4387 (class 1259 OID 2598926)
-- Dependencies: 6
-- Name: serie_aleatoire; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE serie_aleatoire (
    num_serie smallint,
    theme smallint,
    serie smallint,
    nbexo_par_type character varying(255),
    "mode" smallint
);


ALTER TABLE public.serie_aleatoire OWNER TO pgsql;

--
-- TOC entry 4388 (class 1259 OID 2598928)
-- Dependencies: 6
-- Name: serie_bloquante; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE serie_bloquante (
    num_cal integer,
    num_serie integer,
    seuil integer,
    etape_retour integer,
    tentative integer,
    correction boolean,
    blocage_parcours boolean
);


ALTER TABLE public.serie_bloquante OWNER TO pgsql;

--
-- TOC entry 4389 (class 1259 OID 2598930)
-- Dependencies: 5208 6
-- Name: serie_exo; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE serie_exo (
    id integer DEFAULT nextval(('"serie_ftb_id_seq"'::text)::regclass) NOT NULL,
    titre character varying(50) NOT NULL,
    theme smallint NOT NULL,
    options character varying(255),
    bareme smallint NOT NULL,
    chrono integer NOT NULL
);


ALTER TABLE public.serie_exo OWNER TO pgsql;

--
-- TOC entry 4390 (class 1259 OID 2598933)
-- Dependencies: 6
-- Name: serie_ftb_id_seq; Type: SEQUENCE; Schema: public; Owner: pgsql
--

CREATE SEQUENCE serie_ftb_id_seq
    INCREMENT BY 1
    MAXVALUE 2147483647
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.serie_ftb_id_seq OWNER TO pgsql;

--
-- TOC entry 4391 (class 1259 OID 2598935)
-- Dependencies: 6
-- Name: session; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE "session" (
    num_user integer NOT NULL,
    "session" character varying(32),
    num_cal integer
);


ALTER TABLE public."session" OWNER TO pgsql;

--
-- TOC entry 4392 (class 1259 OID 2598937)
-- Dependencies: 5209 6
-- Name: sousrubrique; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE sousrubrique (
    num_srub integer DEFAULT nextval(('SEQ_SOUSRUBRIQUE'::text)::regclass) NOT NULL,
    libelle_srub character varying(256) NOT NULL,
    srub_numtheme integer NOT NULL,
    num_rub integer NOT NULL
);


ALTER TABLE public.sousrubrique OWNER TO pgsql;

--
-- TOC entry 4393 (class 1259 OID 2598940)
-- Dependencies: 6
-- Name: stockresultqcm; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE stockresultqcm (
    num_user integer,
    num_qcm integer,
    temps_restant integer,
    resultat integer,
    commentaire character varying(255),
    num_cal integer,
    date_fin integer,
    total integer
);


ALTER TABLE public.stockresultqcm OWNER TO pgsql;

--
-- TOC entry 4394 (class 1259 OID 2598942)
-- Dependencies: 6
-- Name: stockresultserie; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE stockresultserie (
    num_user integer,
    num_serie integer,
    temps_restant integer,
    resultat real,
    commentaire character varying(255),
    num_cal integer,
    date_fin integer,
    total integer
);


ALTER TABLE public.stockresultserie OWNER TO pgsql;

--
-- TOC entry 4395 (class 1259 OID 2598944)
-- Dependencies: 6
-- Name: test; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE test (
    id_test integer NOT NULL,
    type_test character(1) NOT NULL,
    media_test integer,
    longueur_media integer,
    largeur_media integer,
    chrono integer,
    type_reponse character(1),
    question_commune text
);


ALTER TABLE public.test OWNER TO pgsql;

--
-- TOC entry 4396 (class 1259 OID 2598949)
-- Dependencies: 6
-- Name: test_quest_rep; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE test_quest_rep (
    id_test integer NOT NULL,
    id_question integer NOT NULL,
    id_reponse integer NOT NULL,
    type_exercice character(1) NOT NULL,
    id_exercice integer NOT NULL,
    ordre integer NOT NULL
);


ALTER TABLE public.test_quest_rep OWNER TO pgsql;

--
-- TOC entry 4397 (class 1259 OID 2598951)
-- Dependencies: 6
-- Name: test_rep_nbexogen; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE test_rep_nbexogen (
    id_test integer NOT NULL,
    id_reponse integer NOT NULL,
    type_exercice character(1) NOT NULL,
    nb_a_generer integer NOT NULL,
    taille_chapeau integer
);


ALTER TABLE public.test_rep_nbexogen OWNER TO pgsql;

--
-- TOC entry 4398 (class 1259 OID 2598953)
-- Dependencies: 5210 6
-- Name: themedir; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE themedir (
    num_themedir integer DEFAULT nextval(('SEQ_THEMEDIR'::text)::regclass) NOT NULL,
    nom_theme character varying(128) NOT NULL,
    nom_rep character varying(32) NOT NULL
);


ALTER TABLE public.themedir OWNER TO pgsql;

--
-- TOC entry 4399 (class 1259 OID 2598956)
-- Dependencies: 6
-- Name: titrecapa; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE titrecapa (
    tr_num_titrecapacite integer NOT NULL,
    tr_num_capacite integer NOT NULL
);


ALTER TABLE public.titrecapa OWNER TO pgsql;

--
-- TOC entry 4400 (class 1259 OID 2598958)
-- Dependencies: 5211 5212 6
-- Name: titrecapacite; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE titrecapacite (
    num_titrecapacite integer DEFAULT nextval(('seq_titrecapacite'::text)::regclass) NOT NULL,
    libelle_titrecapacite character varying(400) DEFAULT ''::character varying NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE public.titrecapacite OWNER TO pgsql;

--
-- TOC entry 4401 (class 1259 OID 2598962)
-- Dependencies: 6
-- Name: titrepage; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE titrepage (
    num_cal integer,
    num_page integer,
    titre character varying(400),
    num_qcm integer
);


ALTER TABLE public.titrepage OWNER TO pgsql;

--
-- TOC entry 4402 (class 1259 OID 2598964)
-- Dependencies: 5213 6
-- Name: typeform; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE typeform (
    num_typeform integer DEFAULT nextval(('SEQ_TYPEFORM'::text)::regclass) NOT NULL,
    libelle_form character varying(32) NOT NULL,
    colonne character varying(100)
);


ALTER TABLE public.typeform OWNER TO pgsql;

--
-- TOC entry 4403 (class 1259 OID 2598967)
-- Dependencies: 5214 6
-- Name: utilisateurs; Type: TABLE; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE TABLE utilisateurs (
    num_user integer DEFAULT nextval(('SEQ_UTILISATEURS'::text)::regclass) NOT NULL,
    id_user character varying(32) NOT NULL,
    "login" character varying(20) NOT NULL,
    "password" character varying(20) NOT NULL,
    nom character varying(40) NOT NULL,
    prenom character varying(30) NOT NULL,
    adresse character varying(255) NOT NULL,
    code character varying(10) NOT NULL,
    ville character varying(100) NOT NULL,
    email character varying(100),
    telfixe character varying(10),
    telport character varying(10),
    langue character varying(12),
    num_org integer NOT NULL,
    categorie character varying(2) NOT NULL,
    "session" character varying(32),
    total character varying(255),
    temps integer,
    fic_photo character varying(32)
);


ALTER TABLE public.utilisateurs OWNER TO pgsql;

SET search_path = v2, pg_catalog;

--
-- TOC entry 4404 (class 1259 OID 2598973)
-- Dependencies: 5215 5216 7
-- Name: c_ban_users; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE c_ban_users (
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    ip character varying(16) NOT NULL,
    rooms character varying(100) NOT NULL,
    ban_until integer DEFAULT 0 NOT NULL
);


ALTER TABLE v2.c_ban_users OWNER TO postgres;

--
-- TOC entry 4405 (class 1259 OID 2598977)
-- Dependencies: 7
-- Name: c_etape_chat; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE c_etape_chat (
    id integer NOT NULL
);


ALTER TABLE v2.c_etape_chat OWNER TO postgres;

--
-- TOC entry 4406 (class 1259 OID 2598979)
-- Dependencies: 5217 5218 5219 7
-- Name: c_messages; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE c_messages (
    "type" smallint DEFAULT (0)::smallint NOT NULL,
    room character varying(256) NOT NULL,
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    m_time integer DEFAULT 0 NOT NULL,
    address character varying(30) NOT NULL,
    message text NOT NULL
);


ALTER TABLE v2.c_messages OWNER TO postgres;

--
-- TOC entry 4407 (class 1259 OID 2598987)
-- Dependencies: 5220 5221 5222 7
-- Name: c_reg_users; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE c_reg_users (
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    "password" character varying(32) NOT NULL,
    perms character varying(9) NOT NULL,
    rooms character varying(128) NOT NULL,
    reg_time integer DEFAULT 0 NOT NULL,
    ip character varying(16) NOT NULL,
    gender smallint DEFAULT (0)::smallint NOT NULL
);


ALTER TABLE v2.c_reg_users OWNER TO postgres;

--
-- TOC entry 4408 (class 1259 OID 2598992)
-- Dependencies: 5223 5224 7
-- Name: c_users; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE c_users (
    room character varying(256) NOT NULL,
    username character varying(30) NOT NULL,
    latin1 smallint DEFAULT (0)::smallint NOT NULL,
    u_time integer DEFAULT 0 NOT NULL,
    status character varying(1) NOT NULL,
    ip character varying(16) NOT NULL
);


ALTER TABLE v2.c_users OWNER TO postgres;

--
-- TOC entry 4410 (class 1259 OID 2598998)
-- Dependencies: 7
-- Name: cls_classe; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE cls_classe (
    id serial NOT NULL,
    libelle character varying(255),
    pere integer,
    min integer,
    max integer
);


ALTER TABLE v2.cls_classe OWNER TO postgres;

--
-- TOC entry 10152 (class 0 OID 0)
-- Dependencies: 4410
-- Name: TABLE cls_classe; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE cls_classe IS 'Contient les classes virtuelles (les groupes).';


--
-- TOC entry 4411 (class 1259 OID 2599001)
-- Dependencies: 7
-- Name: cls_classe_individus; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE cls_classe_individus (
    classe integer NOT NULL,
    individu integer NOT NULL
);


ALTER TABLE v2.cls_classe_individus OWNER TO postgres;

--
-- TOC entry 10154 (class 0 OID 0)
-- Dependencies: 4411
-- Name: TABLE cls_classe_individus; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE cls_classe_individus IS 'Pour affilier des individus ÃÂ  une classe.';


--
-- TOC entry 4412 (class 1259 OID 2599003)
-- Dependencies: 7
-- Name: droit_id_seq; Type: SEQUENCE; Schema: v2; Owner: postgres
--

CREATE SEQUENCE droit_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    MINVALUE 0
    CACHE 1;


ALTER TABLE v2.droit_id_seq OWNER TO postgres;

--
-- TOC entry 4413 (class 1259 OID 2599005)
-- Dependencies: 7
-- Name: etape_type_id_seq; Type: SEQUENCE; Schema: v2; Owner: postgres
--

CREATE SEQUENCE etape_type_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE v2.etape_type_id_seq OWNER TO postgres;

--
-- TOC entry 4414 (class 1259 OID 2599007)
-- Dependencies: 7
-- Name: fb_categorie_ftb; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fb_categorie_ftb (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.fb_categorie_ftb OWNER TO postgres;

--
-- TOC entry 10158 (class 0 OID 0)
-- Dependencies: 4414
-- Name: TABLE fb_categorie_ftb; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE fb_categorie_ftb IS 'Les associatons ftb-theme';


--
-- TOC entry 4415 (class 1259 OID 2599009)
-- Dependencies: 7
-- Name: fb_ftb; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fb_ftb (
    id integer NOT NULL,
    text text NOT NULL,
    voir_mots boolean NOT NULL,
    interpretation_html boolean NOT NULL
);


ALTER TABLE v2.fb_ftb OWNER TO postgres;

--
-- TOC entry 4416 (class 1259 OID 2599014)
-- Dependencies: 7
-- Name: fb_resultat_serie_ftb; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fb_resultat_serie_ftb (
    id bigint NOT NULL,
    ftb bigint NOT NULL,
    reponse character varying[]
);


ALTER TABLE v2.fb_resultat_serie_ftb OWNER TO postgres;

--
-- TOC entry 10161 (class 0 OID 0)
-- Dependencies: 4416
-- Name: TABLE fb_resultat_serie_ftb; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE fb_resultat_serie_ftb IS 'Contient les reponses aux ÃÂ©valuations (remplir les blancs) d''une sÃÂ©rie pour un stagiaire et une formation.';


--
-- TOC entry 4418 (class 1259 OID 2599021)
-- Dependencies: 5227 7
-- Name: fchr_fichier; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fchr_fichier (
    id serial NOT NULL,
    libelle character varying(1024) NOT NULL,
    "type" integer,
    connecte boolean DEFAULT false
);


ALTER TABLE v2.fchr_fichier OWNER TO postgres;

--
-- TOC entry 4419 (class 1259 OID 2599028)
-- Dependencies: 7
-- Name: fchr_fichier_correction; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fchr_fichier_correction (
    id integer NOT NULL
);


ALTER TABLE v2.fchr_fichier_correction OWNER TO postgres;

--
-- TOC entry 4421 (class 1259 OID 2599032)
-- Dependencies: 7
-- Name: fchr_fichier_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fchr_fichier_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3),
    categorie integer
);


ALTER TABLE v2.fchr_fichier_type OWNER TO postgres;

--
-- TOC entry 4423 (class 1259 OID 2599037)
-- Dependencies: 7
-- Name: flr_filiere; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE flr_filiere (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    pere integer
);


ALTER TABLE v2.flr_filiere OWNER TO postgres;

--
-- TOC entry 4424 (class 1259 OID 2599040)
-- Dependencies: 5230 5231 5232 7
-- Name: frm_articles; Type: TABLE; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE TABLE frm_articles (
    id integer DEFAULT nextval(('"articles_id_seq"'::text)::regclass) NOT NULL,
    "time" timestamp with time zone,
    author character varying(128),
    email character varying(50),
    subject character varying(50),
    body character varying,
    is_parent boolean DEFAULT false,
    subs character varying,
    parent integer,
    "level" integer,
    root integer,
    ip character varying(16),
    views integer,
    forum integer,
    moderation_state integer DEFAULT 0,
    attach character varying(30)
);


ALTER TABLE v2.frm_articles OWNER TO pgsql;

--
-- TOC entry 4425 (class 1259 OID 2599048)
-- Dependencies: 7
-- Name: frm_block_ip; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frm_block_ip (
    ip character varying(39)
);


ALTER TABLE v2.frm_block_ip OWNER TO postgres;

--
-- TOC entry 4426 (class 1259 OID 2599050)
-- Dependencies: 7
-- Name: frm_etape_forum; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frm_etape_forum (
    id integer NOT NULL,
    forum integer
);


ALTER TABLE v2.frm_etape_forum OWNER TO postgres;

--
-- TOC entry 4427 (class 1259 OID 2599052)
-- Dependencies: 7
-- Name: frm_formation_forums; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frm_formation_forums (
    formation integer NOT NULL,
    forum integer NOT NULL
);


ALTER TABLE v2.frm_formation_forums OWNER TO postgres;

--
-- TOC entry 10170 (class 0 OID 0)
-- Dependencies: 4427
-- Name: TABLE frm_formation_forums; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE frm_formation_forums IS 'Contient les forums associÃÂ©s ÃÂ  une formation.';


--
-- TOC entry 4429 (class 1259 OID 2599056)
-- Dependencies: 5234 7
-- Name: frm_forum; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frm_forum (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    description character varying(1024) NOT NULL,
    moderation boolean NOT NULL,
    moderateur_pwd character varying(255),
    fils integer NOT NULL,
    messages integer NOT NULL,
    upload boolean NOT NULL,
    theme character varying(30) DEFAULT 'default'::character varying NOT NULL
);


ALTER TABLE v2.frm_forum OWNER TO postgres;

--
-- TOC entry 4431 (class 1259 OID 2599065)
-- Dependencies: 7
-- Name: frm_forum_environnement; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frm_forum_environnement (
    id serial NOT NULL,
    libelle character varying(255),
    chemin character varying(255),
    db_type character varying(255),
    db_serveur character varying(255),
    db_name character varying(255),
    db_user character varying(255),
    db_pwd character varying(255),
    "admin" character varying(255),
    admin_pwd character varying(255),
    email_valide boolean,
    email_verification boolean,
    interpretation_html boolean,
    citation boolean,
    noms_longs boolean,
    taille_pj integer,
    lignes integer,
    block_ip boolean,
    compte_vus boolean,
    fils_fermes boolean,
    affiche_fils boolean,
    encodage character varying
);


ALTER TABLE v2.frm_forum_environnement OWNER TO postgres;

--
-- TOC entry 4432 (class 1259 OID 2599071)
-- Dependencies: 7
-- Name: frm_forum_environnements; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frm_forum_environnements (
    forum integer NOT NULL,
    environnement integer
);


ALTER TABLE v2.frm_forum_environnements OWNER TO postgres;

--
-- TOC entry 4434 (class 1259 OID 2599075)
-- Dependencies: 7
-- Name: frm_message; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frm_message (
    id serial NOT NULL,
    libelle character varying(255),
    date integer,
    forum integer,
    auteur integer,
    contenu text,
    parent boolean,
    fils integer,
    pere integer,
    niveau integer,
    racine integer,
    ip character varying(39),
    lu integer,
    moderation boolean,
    "piece-jointe" character varying(255),
    anonyme boolean
);


ALTER TABLE v2.frm_message OWNER TO postgres;

--
-- TOC entry 4435 (class 1259 OID 2599081)
-- Dependencies: 7
-- Name: frmtn_formateur_droits; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frmtn_formateur_droits (
    formation integer NOT NULL,
    droit integer NOT NULL
);


ALTER TABLE v2.frmtn_formateur_droits OWNER TO postgres;

--
-- TOC entry 10176 (class 0 OID 0)
-- Dependencies: 4435
-- Name: TABLE frmtn_formateur_droits; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE frmtn_formateur_droits IS 'Les droits du formateur pour une formation.';


--
-- TOC entry 4437 (class 1259 OID 2599085)
-- Dependencies: 5238 7
-- Name: frmtn_formation; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frmtn_formation (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    parcours integer,
    date_debut date NOT NULL,
    date_fin date NOT NULL,
    langue integer NOT NULL,
    ressources_fusionnees boolean,
    CONSTRAINT check_dates CHECK ((date_debut <= date_fin))
);


ALTER TABLE v2.frmtn_formation OWNER TO postgres;

--
-- TOC entry 10178 (class 0 OID 0)
-- Dependencies: 4437
-- Name: TABLE frmtn_formation; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE frmtn_formation IS 'Les formations de la plateforme';


--
-- TOC entry 4438 (class 1259 OID 2599089)
-- Dependencies: 7
-- Name: frmtn_formation_langues; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frmtn_formation_langues (
    formation integer NOT NULL,
    langue integer NOT NULL
);


ALTER TABLE v2.frmtn_formation_langues OWNER TO postgres;

--
-- TOC entry 10180 (class 0 OID 0)
-- Dependencies: 4438
-- Name: TABLE frmtn_formation_langues; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE frmtn_formation_langues IS 'Contient les langues associÃÂ©es ÃÂ  une formation.';


--
-- TOC entry 4439 (class 1259 OID 2599091)
-- Dependencies: 7
-- Name: frmtn_formation_participants; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE frmtn_formation_participants (
    formation integer NOT NULL,
    formateur integer NOT NULL,
    classe integer NOT NULL
);


ALTER TABLE v2.frmtn_formation_participants OWNER TO postgres;

--
-- TOC entry 10182 (class 0 OID 0)
-- Dependencies: 4439
-- Name: TABLE frmtn_formation_participants; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE frmtn_formation_participants IS 'Contient le formateur et la classe associÃÂ©s ÃÂ  une formation.';


--
-- TOC entry 4440 (class 1259 OID 2599093)
-- Dependencies: 7
-- Name: fw_connexion; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_connexion (
    individu integer NOT NULL,
    connexion timestamp without time zone NOT NULL,
    deconnexion timestamp without time zone,
    ip character varying(39)
);


ALTER TABLE v2.fw_connexion OWNER TO postgres;

--
-- TOC entry 10184 (class 0 OID 0)
-- Dependencies: 4440
-- Name: TABLE fw_connexion; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE fw_connexion IS 'Pour le stockage des connexions d''un individu en front-office.';


--
-- TOC entry 4441 (class 1259 OID 2599095)
-- Dependencies: 5239 7
-- Name: fw_droit; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_droit (
    id integer DEFAULT nextval(('v2.droit_id_seq'::text)::regclass) NOT NULL,
    libelle character varying(255),
    pere integer,
    "type" integer,
    defaut boolean
);


ALTER TABLE v2.fw_droit OWNER TO postgres;

--
-- TOC entry 10186 (class 0 OID 0)
-- Dependencies: 4441
-- Name: TABLE fw_droit; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE fw_droit IS 'Contient les diffÃÂ©rents droits';


--
-- TOC entry 4443 (class 1259 OID 2599100)
-- Dependencies: 7
-- Name: fw_langue; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_langue (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(20),
    locale character varying
);


ALTER TABLE v2.fw_langue OWNER TO postgres;

--
-- TOC entry 4445 (class 1259 OID 2599108)
-- Dependencies: 7
-- Name: fw_langue_message; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_langue_message (
    id serial NOT NULL,
    langue integer NOT NULL,
    "type" integer NOT NULL,
    libelle text
);


ALTER TABLE v2.fw_langue_message OWNER TO postgres;

--
-- TOC entry 4447 (class 1259 OID 2599116)
-- Dependencies: 7
-- Name: fw_langue_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_langue_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(20)
);


ALTER TABLE v2.fw_langue_type OWNER TO postgres;

--
-- TOC entry 4448 (class 1259 OID 2599119)
-- Dependencies: 7
-- Name: fw_session; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE fw_session (
    individu integer NOT NULL,
    "session" character varying(32),
    formation integer
);


ALTER TABLE v2.fw_session OWNER TO postgres;

--
-- TOC entry 10191 (class 0 OID 0)
-- Dependencies: 4448
-- Name: TABLE fw_session; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE fw_session IS 'Contient la session d''un individu pour une formation.';


--
-- TOC entry 4450 (class 1259 OID 2599123)
-- Dependencies: 7
-- Name: grll_capacite; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_capacite (
    id serial NOT NULL,
    libelle character varying(255)
);


ALTER TABLE v2.grll_capacite OWNER TO postgres;

--
-- TOC entry 10193 (class 0 OID 0)
-- Dependencies: 4450
-- Name: TABLE grll_capacite; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE grll_capacite IS 'Contient les capacitÃÂ©s pour le prÃÂ©sentiel.';


--
-- TOC entry 4452 (class 1259 OID 2599128)
-- Dependencies: 7
-- Name: grll_capacite_titre; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_capacite_titre (
    id serial NOT NULL,
    libelle character varying(255)
);


ALTER TABLE v2.grll_capacite_titre OWNER TO postgres;

--
-- TOC entry 10195 (class 0 OID 0)
-- Dependencies: 4452
-- Name: TABLE grll_capacite_titre; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE grll_capacite_titre IS 'Contient les titres de capacitÃÂ© associÃÂ©s ÃÂ  une grille (pour le prÃÂ©sentiel).';


--
-- TOC entry 4453 (class 1259 OID 2599131)
-- Dependencies: 7
-- Name: grll_capacite_titre_capacites; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_capacite_titre_capacites (
    capacite_titre integer NOT NULL,
    capacite integer NOT NULL
);


ALTER TABLE v2.grll_capacite_titre_capacites OWNER TO postgres;

--
-- TOC entry 10197 (class 0 OID 0)
-- Dependencies: 4453
-- Name: TABLE grll_capacite_titre_capacites; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE grll_capacite_titre_capacites IS 'Contient les capacitÃÂ©s associÃÂ©es ÃÂ  un titre de capacitÃÂ© (pour le prÃÂ©sentiel).';


--
-- TOC entry 4455 (class 1259 OID 2599135)
-- Dependencies: 7
-- Name: grll_carton; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_carton (
    id serial NOT NULL,
    libelle character varying(255),
    couleur character varying(6),
    code character varying(3)
);


ALTER TABLE v2.grll_carton OWNER TO postgres;

--
-- TOC entry 10199 (class 0 OID 0)
-- Dependencies: 4455
-- Name: TABLE grll_carton; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE grll_carton IS 'Contient les caractÃÂ©ristiques des cartons pour le prÃÂ©sentiel.';


--
-- TOC entry 4456 (class 1259 OID 2599138)
-- Dependencies: 7
-- Name: grll_categorie_capacite; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_categorie_capacite (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.grll_categorie_capacite OWNER TO postgres;

--
-- TOC entry 10201 (class 0 OID 0)
-- Dependencies: 4456
-- Name: TABLE grll_categorie_capacite; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE grll_categorie_capacite IS 'Les associations capacitÃÂ©-theme';


--
-- TOC entry 4457 (class 1259 OID 2599140)
-- Dependencies: 7
-- Name: grll_categorie_capacite_titre; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_categorie_capacite_titre (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.grll_categorie_capacite_titre OWNER TO postgres;

--
-- TOC entry 10203 (class 0 OID 0)
-- Dependencies: 4457
-- Name: TABLE grll_categorie_capacite_titre; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE grll_categorie_capacite_titre IS 'Les association capacite_titre-theme';


--
-- TOC entry 4458 (class 1259 OID 2599142)
-- Dependencies: 7
-- Name: grll_categorie_grille; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_categorie_grille (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.grll_categorie_grille OWNER TO postgres;

--
-- TOC entry 10205 (class 0 OID 0)
-- Dependencies: 4458
-- Name: TABLE grll_categorie_grille; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE grll_categorie_grille IS 'Les association grille-theme';


--
-- TOC entry 4460 (class 1259 OID 2599146)
-- Dependencies: 7
-- Name: grll_grille; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_grille (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL
);


ALTER TABLE v2.grll_grille OWNER TO postgres;

--
-- TOC entry 4461 (class 1259 OID 2599149)
-- Dependencies: 7
-- Name: grll_grille_capacites_titres; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_grille_capacites_titres (
    grille integer NOT NULL,
    capacite_titre integer NOT NULL
);


ALTER TABLE v2.grll_grille_capacites_titres OWNER TO postgres;

--
-- TOC entry 4462 (class 1259 OID 2599151)
-- Dependencies: 5247 7
-- Name: grll_grille_resultats; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_grille_resultats (
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    grille integer NOT NULL,
    capacite_titre integer NOT NULL,
    capacite integer NOT NULL,
    commentaire text,
    note integer,
    note_max integer,
    carton integer,
    date timestamp without time zone NOT NULL,
    CONSTRAINT grille_resultats_check CHECK ((note <= note_max))
);


ALTER TABLE v2.grll_grille_resultats OWNER TO postgres;

--
-- TOC entry 4463 (class 1259 OID 2599157)
-- Dependencies: 7
-- Name: grll_stagiaire_grille; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE grll_stagiaire_grille (
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    grille integer NOT NULL,
    visible boolean
);


ALTER TABLE v2.grll_stagiaire_grille OWNER TO postgres;

--
-- TOC entry 10210 (class 0 OID 0)
-- Dependencies: 4463
-- Name: TABLE grll_stagiaire_grille; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE grll_stagiaire_grille IS 'Contient les grilles prÃÂ©sentielles pour un stagiaire et une formation.';


--
-- TOC entry 4465 (class 1259 OID 2599161)
-- Dependencies: 7
-- Name: lrt_alerte; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE lrt_alerte (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    formation integer,
    date date,
    jours integer,
    texte text
);


ALTER TABLE v2.lrt_alerte OWNER TO postgres;

--
-- TOC entry 10212 (class 0 OID 0)
-- Dependencies: 4465
-- Name: TABLE lrt_alerte; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE lrt_alerte IS 'Contient les alertes associÃÂ©es ÃÂ  une formation.';


--
-- TOC entry 4466 (class 1259 OID 2599167)
-- Dependencies: 7
-- Name: lst_liste; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE lst_liste (
    id integer NOT NULL,
    "type" integer NOT NULL
);


ALTER TABLE v2.lst_liste OWNER TO postgres;

--
-- TOC entry 4468 (class 1259 OID 2599171)
-- Dependencies: 7
-- Name: lst_liste_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE lst_liste_type (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    code character varying(3)
);


ALTER TABLE v2.lst_liste_type OWNER TO postgres;

--
-- TOC entry 4469 (class 1259 OID 2599174)
-- Dependencies: 7
-- Name: lst_page_liste; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE lst_page_liste (
    formation integer NOT NULL,
    parcours integer NOT NULL,
    liste integer NOT NULL,
    page integer NOT NULL,
    titre character varying(255),
    commentaire text
);


ALTER TABLE v2.lst_page_liste OWNER TO postgres;

--
-- TOC entry 4470 (class 1259 OID 2599179)
-- Dependencies: 7
-- Name: lst_page_liste_configuration; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE lst_page_liste_configuration (
    formation integer NOT NULL,
    parcours integer NOT NULL,
    liste integer NOT NULL,
    page integer NOT NULL,
    page_element integer NOT NULL
);


ALTER TABLE v2.lst_page_liste_configuration OWNER TO postgres;

--
-- TOC entry 4471 (class 1259 OID 2599181)
-- Dependencies: 7
-- Name: md_media; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE md_media (
    id integer NOT NULL
);


ALTER TABLE v2.md_media OWNER TO postgres;

--
-- TOC entry 4472 (class 1259 OID 2599183)
-- Dependencies: 7
-- Name: ndvd_fichier_photo; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE ndvd_fichier_photo (
    id integer NOT NULL
);


ALTER TABLE v2.ndvd_fichier_photo OWNER TO postgres;

--
-- TOC entry 4474 (class 1259 OID 2599187)
-- Dependencies: 7
-- Name: ndvd_individu; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE ndvd_individu (
    id serial NOT NULL,
    identifiant_md5 character varying(32),
    "login" character varying(255) NOT NULL,
    "password" character varying(255) NOT NULL,
    nom character varying(255) NOT NULL,
    prenom character varying(255) NOT NULL,
    adresse character varying(512),
    code character varying(255),
    ville character varying(512),
    email character varying(512),
    tel_fixe character varying(255),
    tel_port character varying(255),
    langue integer,
    organisme integer,
    photo integer
);


ALTER TABLE v2.ndvd_individu OWNER TO postgres;

--
-- TOC entry 4475 (class 1259 OID 2599193)
-- Dependencies: 7
-- Name: ndvd_individu_droits; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE ndvd_individu_droits (
    individu integer NOT NULL,
    classe integer NOT NULL,
    droit integer NOT NULL
);


ALTER TABLE v2.ndvd_individu_droits OWNER TO postgres;

--
-- TOC entry 4477 (class 1259 OID 2599197)
-- Dependencies: 7
-- Name: ndvd_individu_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE ndvd_individu_type (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    code character varying(3)
);


ALTER TABLE v2.ndvd_individu_type OWNER TO postgres;

--
-- TOC entry 4478 (class 1259 OID 2599200)
-- Dependencies: 7
-- Name: ndvd_individu_types; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE ndvd_individu_types (
    "type" integer NOT NULL,
    individu integer NOT NULL
);


ALTER TABLE v2.ndvd_individu_types OWNER TO postgres;

--
-- TOC entry 4480 (class 1259 OID 2599204)
-- Dependencies: 7
-- Name: ndvd_organisme; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE ndvd_organisme (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL
);


ALTER TABLE v2.ndvd_organisme OWNER TO postgres;

--
-- TOC entry 4482 (class 1259 OID 2599209)
-- Dependencies: 7
-- Name: pg_page; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pg_page (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    "type" integer,
    script character varying(2048)
);


ALTER TABLE v2.pg_page OWNER TO postgres;

--
-- TOC entry 4483 (class 1259 OID 2599215)
-- Dependencies: 7
-- Name: pg_page_annuaire_configuration; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pg_page_annuaire_configuration (
    formation integer NOT NULL,
    page integer NOT NULL,
    individu_type integer NOT NULL,
    page_element integer NOT NULL
);


ALTER TABLE v2.pg_page_annuaire_configuration OWNER TO postgres;

--
-- TOC entry 4484 (class 1259 OID 2599217)
-- Dependencies: 7
-- Name: pg_page_commentaire; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pg_page_commentaire (
    page integer NOT NULL,
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    commentaire text
);


ALTER TABLE v2.pg_page_commentaire OWNER TO postgres;

--
-- TOC entry 4486 (class 1259 OID 2599224)
-- Dependencies: 7
-- Name: pg_page_element; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pg_page_element (
    id serial NOT NULL,
    libelle character varying(255)
);


ALTER TABLE v2.pg_page_element OWNER TO postgres;

--
-- TOC entry 4487 (class 1259 OID 2599227)
-- Dependencies: 7
-- Name: pg_page_elements; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pg_page_elements (
    page integer NOT NULL,
    page_element integer NOT NULL
);


ALTER TABLE v2.pg_page_elements OWNER TO postgres;

--
-- TOC entry 4489 (class 1259 OID 2599231)
-- Dependencies: 7
-- Name: pg_page_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pg_page_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3)
);


ALTER TABLE v2.pg_page_type OWNER TO postgres;

--
-- TOC entry 4490 (class 1259 OID 2599234)
-- Dependencies: 7
-- Name: prcrs_parcours; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE prcrs_parcours (
    id integer NOT NULL,
    filiere integer NOT NULL,
    duree boolean
);


ALTER TABLE v2.prcrs_parcours OWNER TO postgres;

--
-- TOC entry 4491 (class 1259 OID 2599236)
-- Dependencies: 5256 7
-- Name: prcrs_parcours_oriente; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE prcrs_parcours_oriente (
    id integer NOT NULL,
    "type" integer,
    seuil integer,
    sous_parcours integer NOT NULL,
    ordre integer,
    CONSTRAINT check_parcours_cycle CHECK ((id <> sous_parcours))
);


ALTER TABLE v2.prcrs_parcours_oriente OWNER TO postgres;

--
-- TOC entry 10232 (class 0 OID 0)
-- Dependencies: 4491
-- Name: TABLE prcrs_parcours_oriente; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE prcrs_parcours_oriente IS 'Pour configurer un parcours en orientation.(A la fin du parcours principal, le stagiaire est orientÃÂ© vers un autre parcours en fonction des rÃÂ©sultats obtenus).';


--
-- TOC entry 4492 (class 1259 OID 2599239)
-- Dependencies: 7
-- Name: pstnnmnt_categorie_positionnement; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pstnnmnt_categorie_positionnement (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.pstnnmnt_categorie_positionnement OWNER TO postgres;

--
-- TOC entry 4493 (class 1259 OID 2599241)
-- Dependencies: 7
-- Name: pstnnmnt_choix; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pstnnmnt_choix (
    id integer NOT NULL,
    question_reponse integer,
    bareme integer,
    pere integer
);


ALTER TABLE v2.pstnnmnt_choix OWNER TO postgres;

--
-- TOC entry 10235 (class 0 OID 0)
-- Dependencies: 4493
-- Name: TABLE pstnnmnt_choix; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE pstnnmnt_choix IS 'pour un positionnement,  stockage des rÃ©ponses et du nombre d''evaluations qu''elles generent.';


--
-- TOC entry 4495 (class 1259 OID 2599245)
-- Dependencies: 7
-- Name: pstnnmnt_positionnement; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pstnnmnt_positionnement (
    id serial NOT NULL,
    libelle character varying NOT NULL,
    chrono integer,
    serie_generee integer NOT NULL,
    qsrc integer NOT NULL
);


ALTER TABLE v2.pstnnmnt_positionnement OWNER TO postgres;

--
-- TOC entry 10237 (class 0 OID 0)
-- Dependencies: 4495
-- Name: TABLE pstnnmnt_positionnement; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE pstnnmnt_positionnement IS 'Contient les positionnements';


--
-- TOC entry 4496 (class 1259 OID 2599251)
-- Dependencies: 5258 7
-- Name: pstnnmnt_positionnement_choix_evaluations; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pstnnmnt_positionnement_choix_evaluations (
    positionnement integer NOT NULL,
    reponse integer NOT NULL,
    "type" integer NOT NULL,
    nombre integer,
    nombre_max integer,
    bareme integer,
    CONSTRAINT chech_positif CHECK ((((nombre <= nombre_max) AND (nombre_max > 0)) AND (nombre >= 0)))
);


ALTER TABLE v2.pstnnmnt_positionnement_choix_evaluations OWNER TO postgres;

--
-- TOC entry 10239 (class 0 OID 0)
-- Dependencies: 4496
-- Name: TABLE pstnnmnt_positionnement_choix_evaluations; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE pstnnmnt_positionnement_choix_evaluations IS 'Les ÃÂ©valuations ÃÂ  gÃÂ©nÃÂ©rer en fonction des rÃÂ©ponses d''un positionnement (qcm)';


--
-- TOC entry 4497 (class 1259 OID 2599254)
-- Dependencies: 7
-- Name: pstnnmnt_positionnement_elements; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pstnnmnt_positionnement_elements (
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    choix integer NOT NULL
);


ALTER TABLE v2.pstnnmnt_positionnement_elements OWNER TO postgres;

--
-- TOC entry 10241 (class 0 OID 0)
-- Dependencies: 4497
-- Name: TABLE pstnnmnt_positionnement_elements; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE pstnnmnt_positionnement_elements IS 'Contient les associations positionnement-questions';


--
-- TOC entry 4498 (class 1259 OID 2599256)
-- Dependencies: 7
-- Name: pstnnmnt_positionnement_evaluations; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pstnnmnt_positionnement_evaluations (
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    choix integer NOT NULL,
    evaluation integer NOT NULL,
    pere integer
);


ALTER TABLE v2.pstnnmnt_positionnement_evaluations OWNER TO postgres;

--
-- TOC entry 4500 (class 1259 OID 2599260)
-- Dependencies: 7
-- Name: pstnnmnt_positionnement_old; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pstnnmnt_positionnement_old (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    type_question integer NOT NULL,
    chrono integer,
    serie_aleatoire integer NOT NULL,
    question_reponse integer
);


ALTER TABLE v2.pstnnmnt_positionnement_old OWNER TO postgres;

--
-- TOC entry 10244 (class 0 OID 0)
-- Dependencies: 4500
-- Name: TABLE pstnnmnt_positionnement_old; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE pstnnmnt_positionnement_old IS 'Contient les positionnements';


--
-- TOC entry 4501 (class 1259 OID 2599263)
-- Dependencies: 7
-- Name: pstnnmnt_resultat_positionnement; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pstnnmnt_resultat_positionnement (
    id bigint NOT NULL,
    test integer NOT NULL,
    positionnement integer NOT NULL
);


ALTER TABLE v2.pstnnmnt_resultat_positionnement OWNER TO postgres;

--
-- TOC entry 10246 (class 0 OID 0)
-- Dependencies: 4501
-- Name: TABLE pstnnmnt_resultat_positionnement; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE pstnnmnt_resultat_positionnement IS 'Contient les date de fin des positionnements pour un test,un stagiaire et une formation.';


--
-- TOC entry 4502 (class 1259 OID 2599265)
-- Dependencies: 7
-- Name: pstnnmnt_resultat_positionnement_question_reponse; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE pstnnmnt_resultat_positionnement_question_reponse (
    id bigint NOT NULL,
    test integer NOT NULL,
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    choix integer NOT NULL
);


ALTER TABLE v2.pstnnmnt_resultat_positionnement_question_reponse OWNER TO postgres;

--
-- TOC entry 10248 (class 0 OID 0)
-- Dependencies: 4502
-- Name: TABLE pstnnmnt_resultat_positionnement_question_reponse; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE pstnnmnt_resultat_positionnement_question_reponse IS 'Stockage des rÃÂ©sultats de questions de positionnement pour un test, un stagiaire et une formation.';


--
-- TOC entry 4503 (class 1259 OID 2599267)
-- Dependencies: 7
-- Name: qc_categorie_qsrc; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qc_categorie_qsrc (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.qc_categorie_qsrc OWNER TO postgres;

--
-- TOC entry 4504 (class 1259 OID 2599269)
-- Dependencies: 7
-- Name: qc_qsrc; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qc_qsrc (
    id integer NOT NULL,
    question character varying(1024) NOT NULL
);


ALTER TABLE v2.qc_qsrc OWNER TO postgres;

--
-- TOC entry 4505 (class 1259 OID 2599274)
-- Dependencies: 7
-- Name: qr_categorie_question_reponse; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_categorie_question_reponse (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.qr_categorie_question_reponse OWNER TO postgres;

--
-- TOC entry 4506 (class 1259 OID 2599276)
-- Dependencies: 7
-- Name: qr_categorie_question_reponse_element; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_categorie_question_reponse_element (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.qr_categorie_question_reponse_element OWNER TO postgres;

--
-- TOC entry 10253 (class 0 OID 0)
-- Dependencies: 4506
-- Name: TABLE qr_categorie_question_reponse_element; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE qr_categorie_question_reponse_element IS 'Les association grille-theme';


--
-- TOC entry 4507 (class 1259 OID 2599278)
-- Dependencies: 7
-- Name: qr_categorie_sondage_element; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_categorie_sondage_element (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.qr_categorie_sondage_element OWNER TO postgres;

--
-- TOC entry 10255 (class 0 OID 0)
-- Dependencies: 4507
-- Name: TABLE qr_categorie_sondage_element; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE qr_categorie_sondage_element IS 'Les association grille-theme';


--
-- TOC entry 4508 (class 1259 OID 2599280)
-- Dependencies: 7
-- Name: qr_media_question_reponse; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_media_question_reponse (
    question_reponse integer NOT NULL,
    media integer NOT NULL,
    hauteur integer,
    largeur integer
);


ALTER TABLE v2.qr_media_question_reponse OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4509 (class 1259 OID 2599282)
-- Dependencies: 7
-- Name: qr_media_question_reponse_element; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_media_question_reponse_element (
    question_reponse integer NOT NULL,
    question_reponse_element integer NOT NULL,
    media integer NOT NULL,
    hauteur integer,
    largeur integer
);


ALTER TABLE v2.qr_media_question_reponse_element OWNER TO postgres;

SET default_with_oids = true;

--
-- TOC entry 4510 (class 1259 OID 2599284)
-- Dependencies: 7
-- Name: qr_qcm_elements; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_qcm_elements (
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    juste boolean
);


ALTER TABLE v2.qr_qcm_elements OWNER TO postgres;

--
-- TOC entry 4511 (class 1259 OID 2599286)
-- Dependencies: 7
-- Name: qr_question; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_question (
    id integer NOT NULL
);


ALTER TABLE v2.qr_question OWNER TO postgres;

--
-- TOC entry 10260 (class 0 OID 0)
-- Dependencies: 4511
-- Name: TABLE qr_question; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE qr_question IS 'Les numÃÂ©ros de question de la plateforme';


--
-- TOC entry 4512 (class 1259 OID 2599288)
-- Dependencies: 7
-- Name: qr_question_reponse; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_question_reponse (
    id integer NOT NULL,
    "type" integer NOT NULL,
    radio boolean
);


ALTER TABLE v2.qr_question_reponse OWNER TO postgres;

--
-- TOC entry 4514 (class 1259 OID 2599292)
-- Dependencies: 7
-- Name: qr_question_reponse_element; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_question_reponse_element (
    id serial NOT NULL,
    libelle character varying(1024),
    interpretation_html boolean,
    "type" integer,
    reponse boolean
);


ALTER TABLE v2.qr_question_reponse_element OWNER TO postgres;

--
-- TOC entry 4515 (class 1259 OID 2599298)
-- Dependencies: 7
-- Name: qr_question_reponse_elements; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_question_reponse_elements (
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    pere integer
);


ALTER TABLE v2.qr_question_reponse_elements OWNER TO postgres;

--
-- TOC entry 10264 (class 0 OID 0)
-- Dependencies: 4515
-- Name: TABLE qr_question_reponse_elements; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE qr_question_reponse_elements IS 'Les associations question-reponses';


--
-- TOC entry 4517 (class 1259 OID 2599302)
-- Dependencies: 7
-- Name: qr_question_reponse_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_question_reponse_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3)
);


ALTER TABLE v2.qr_question_reponse_type OWNER TO postgres;

--
-- TOC entry 10266 (class 0 OID 0)
-- Dependencies: 4517
-- Name: TABLE qr_question_reponse_type; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE qr_question_reponse_type IS 'Les types des question-reponse';


--
-- TOC entry 4518 (class 1259 OID 2599305)
-- Dependencies: 7
-- Name: qr_reponse; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_reponse (
    id integer NOT NULL
);


ALTER TABLE v2.qr_reponse OWNER TO postgres;

--
-- TOC entry 10268 (class 0 OID 0)
-- Dependencies: 4518
-- Name: TABLE qr_reponse; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE qr_reponse IS 'Les numÃÂ©ros de rÃÂ©ponses de la plateforme';


--
-- TOC entry 4519 (class 1259 OID 2599307)
-- Dependencies: 5262 7
-- Name: qr_resultat_serie_question_reponse; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_resultat_serie_question_reponse (
    id bigint NOT NULL,
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    coche boolean DEFAULT false
);


ALTER TABLE v2.qr_resultat_serie_question_reponse OWNER TO postgres;

--
-- TOC entry 10270 (class 0 OID 0)
-- Dependencies: 4519
-- Name: TABLE qr_resultat_serie_question_reponse; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE qr_resultat_serie_question_reponse IS 'Contient les reponses au ÃÂ©valuations (qcm ou sondage)d''une sÃÂ©rie pour un stagiaire et une formation.';


--
-- TOC entry 4520 (class 1259 OID 2599310)
-- Dependencies: 7
-- Name: qr_resultat_serie_tentative_question_reponse; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE qr_resultat_serie_tentative_question_reponse (
    id bigint NOT NULL,
    question_reponse integer NOT NULL,
    question integer NOT NULL,
    reponse integer NOT NULL,
    coche boolean
);


ALTER TABLE v2.qr_resultat_serie_tentative_question_reponse OWNER TO postgres;

--
-- TOC entry 10272 (class 0 OID 0)
-- Dependencies: 4520
-- Name: TABLE qr_resultat_serie_tentative_question_reponse; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE qr_resultat_serie_tentative_question_reponse IS 'Contient les rÃÂ©sultats (qcm) d''une sÃÂ©rie en cas d''ÃÂ©chec ÃÂ  une sÃÂ©rie bloquante.';


--
-- TOC entry 4521 (class 1259 OID 2599312)
-- Dependencies: 7
-- Name: resultat_id_seq; Type: SEQUENCE; Schema: v2; Owner: pgsql
--

CREATE SEQUENCE resultat_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE v2.resultat_id_seq OWNER TO pgsql;

--
-- TOC entry 4522 (class 1259 OID 2599314)
-- Dependencies: 7
-- Name: rssrc_categorie_etape_ressource; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_categorie_etape_ressource (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.rssrc_categorie_etape_ressource OWNER TO postgres;

--
-- TOC entry 4523 (class 1259 OID 2599316)
-- Dependencies: 7
-- Name: rssrc_categorie_fichier_ressource; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_categorie_fichier_ressource (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.rssrc_categorie_fichier_ressource OWNER TO postgres;

--
-- TOC entry 4524 (class 1259 OID 2599318)
-- Dependencies: 7
-- Name: rssrc_categorie_fichier_ressource_fichier; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_categorie_fichier_ressource_fichier (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.rssrc_categorie_fichier_ressource_fichier OWNER TO postgres;

--
-- TOC entry 10277 (class 0 OID 0)
-- Dependencies: 4524
-- Name: TABLE rssrc_categorie_fichier_ressource_fichier; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE rssrc_categorie_fichier_ressource_fichier IS 'Les associations ressource-theme';


--
-- TOC entry 4525 (class 1259 OID 2599320)
-- Dependencies: 7
-- Name: rssrc_categorie_fichier_ressource_texte; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_categorie_fichier_ressource_texte (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.rssrc_categorie_fichier_ressource_texte OWNER TO postgres;

--
-- TOC entry 4527 (class 1259 OID 2599324)
-- Dependencies: 7
-- Name: rssrc_espace; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_espace (
    id serial NOT NULL,
    libelle character varying(255)
);


ALTER TABLE v2.rssrc_espace OWNER TO postgres;

--
-- TOC entry 10280 (class 0 OID 0)
-- Dependencies: 4527
-- Name: TABLE rssrc_espace; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE rssrc_espace IS 'Contient les espaces pour les ressources.';


--
-- TOC entry 4528 (class 1259 OID 2599327)
-- Dependencies: 7
-- Name: rssrc_etape_ressource; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_etape_ressource (
    id integer NOT NULL,
    ressource integer,
    espace integer,
    section integer
);


ALTER TABLE v2.rssrc_etape_ressource OWNER TO postgres;

--
-- TOC entry 4529 (class 1259 OID 2599329)
-- Dependencies: 7
-- Name: rssrc_fichier_icone; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_fichier_icone (
    id integer NOT NULL
);


ALTER TABLE v2.rssrc_fichier_icone OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4530 (class 1259 OID 2599331)
-- Dependencies: 7
-- Name: rssrc_fichier_ressource; Type: TABLE; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE TABLE rssrc_fichier_ressource (
    id integer NOT NULL
);


ALTER TABLE v2.rssrc_fichier_ressource OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4531 (class 1259 OID 2599333)
-- Dependencies: 7
-- Name: rssrc_fichier_ressource_fichier; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_fichier_ressource_fichier (
    id integer NOT NULL
);


ALTER TABLE v2.rssrc_fichier_ressource_fichier OWNER TO postgres;

--
-- TOC entry 4532 (class 1259 OID 2599335)
-- Dependencies: 5264 7
-- Name: rssrc_fichier_ressource_texte; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_fichier_ressource_texte (
    id integer NOT NULL,
    libelle character varying(255),
    adresse character varying(255),
    description character varying(255),
    mise_en_forme text,
    date_modification date DEFAULT ('now'::text)::date
);


ALTER TABLE v2.rssrc_fichier_ressource_texte OWNER TO postgres;

--
-- TOC entry 4533 (class 1259 OID 2599341)
-- Dependencies: 7
-- Name: rssrc_formation_ressources; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_formation_ressources (
    formation integer NOT NULL,
    ressource integer NOT NULL,
    debut_disponibilite timestamp without time zone,
    fin_disponibilite timestamp without time zone,
    duree_nouveaute integer,
    espace integer NOT NULL,
    section integer NOT NULL
);


ALTER TABLE v2.rssrc_formation_ressources OWNER TO postgres;

--
-- TOC entry 10287 (class 0 OID 0)
-- Dependencies: 4533
-- Name: TABLE rssrc_formation_ressources; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE rssrc_formation_ressources IS 'Contient les ressources associÃÂ©es ÃÂ  une formation.Une ressource est dÃÂ©finie par son numÃÂ©ro,ses dates de dÃÂ©but et fin et sa durÃÂ©e de nouveautÃÂ©.';


--
-- TOC entry 4534 (class 1259 OID 2599343)
-- Dependencies: 7
-- Name: rssrc_page_ressource_configuration; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_page_ressource_configuration (
    formation integer NOT NULL,
    page integer NOT NULL,
    parcours integer NOT NULL,
    etape_ressource integer NOT NULL,
    commentaire text
);


ALTER TABLE v2.rssrc_page_ressource_configuration OWNER TO postgres;

--
-- TOC entry 4536 (class 1259 OID 2599350)
-- Dependencies: 7
-- Name: rssrc_ressource; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_ressource (
    id serial NOT NULL,
    fichier integer,
    mots_cles text
);


ALTER TABLE v2.rssrc_ressource OWNER TO postgres;

--
-- TOC entry 10290 (class 0 OID 0)
-- Dependencies: 4536
-- Name: TABLE rssrc_ressource; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE rssrc_ressource IS 'Description des ressources';


--
-- TOC entry 4537 (class 1259 OID 2599356)
-- Dependencies: 7
-- Name: section_id_seq; Type: SEQUENCE; Schema: v2; Owner: pgsql
--

CREATE SEQUENCE section_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE v2.section_id_seq OWNER TO pgsql;

--
-- TOC entry 4538 (class 1259 OID 2599358)
-- Dependencies: 5266 7
-- Name: rssrc_section; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE rssrc_section (
    id integer DEFAULT nextval('section_id_seq'::regclass) NOT NULL,
    libelle character varying(255),
    icone integer
);


ALTER TABLE v2.rssrc_section OWNER TO postgres;

--
-- TOC entry 10293 (class 0 OID 0)
-- Dependencies: 4538
-- Name: TABLE rssrc_section; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE rssrc_section IS 'Contient les sections pour les ressources.';


--
-- TOC entry 4539 (class 1259 OID 2599361)
-- Dependencies: 7
-- Name: salle_id_seq; Type: SEQUENCE; Schema: v2; Owner: pgsql
--

CREATE SEQUENCE salle_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE v2.salle_id_seq OWNER TO pgsql;

--
-- TOC entry 4540 (class 1259 OID 2599363)
-- Dependencies: 7
-- Name: scnr_categorie_fichier_css; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scnr_categorie_fichier_css (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.scnr_categorie_fichier_css OWNER TO postgres;

--
-- TOC entry 10296 (class 0 OID 0)
-- Dependencies: 4540
-- Name: TABLE scnr_categorie_fichier_css; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE scnr_categorie_fichier_css IS 'Les associations css-theme';


--
-- TOC entry 4541 (class 1259 OID 2599365)
-- Dependencies: 7
-- Name: scnr_categorie_fichier_media_scenario; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scnr_categorie_fichier_media_scenario (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.scnr_categorie_fichier_media_scenario OWNER TO postgres;

--
-- TOC entry 10298 (class 0 OID 0)
-- Dependencies: 4541
-- Name: TABLE scnr_categorie_fichier_media_scenario; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE scnr_categorie_fichier_media_scenario IS 'Association theme/mÃÂ©dias de scenario';


--
-- TOC entry 4542 (class 1259 OID 2599367)
-- Dependencies: 7
-- Name: scnr_categorie_fichier_scenario; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scnr_categorie_fichier_scenario (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.scnr_categorie_fichier_scenario OWNER TO postgres;

--
-- TOC entry 10300 (class 0 OID 0)
-- Dependencies: 4542
-- Name: TABLE scnr_categorie_fichier_scenario; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE scnr_categorie_fichier_scenario IS 'Les associations scenario-theme';


--
-- TOC entry 4543 (class 1259 OID 2599369)
-- Dependencies: 7
-- Name: scnr_categorie_scenario; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scnr_categorie_scenario (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.scnr_categorie_scenario OWNER TO postgres;

--
-- TOC entry 4544 (class 1259 OID 2599371)
-- Dependencies: 7
-- Name: scnr_fichier_css; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scnr_fichier_css (
    id integer NOT NULL
);


ALTER TABLE v2.scnr_fichier_css OWNER TO postgres;

--
-- TOC entry 4545 (class 1259 OID 2599373)
-- Dependencies: 7
-- Name: scnr_fichier_media_scenario; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scnr_fichier_media_scenario (
    id integer NOT NULL
);


ALTER TABLE v2.scnr_fichier_media_scenario OWNER TO postgres;

--
-- TOC entry 4546 (class 1259 OID 2599375)
-- Dependencies: 7
-- Name: scnr_fichier_scenario; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scnr_fichier_scenario (
    id integer NOT NULL
);


ALTER TABLE v2.scnr_fichier_scenario OWNER TO postgres;

--
-- TOC entry 4547 (class 1259 OID 2599377)
-- Dependencies: 7
-- Name: scnr_scenario; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scnr_scenario (
    id integer NOT NULL,
    fichier integer NOT NULL
);


ALTER TABLE v2.scnr_scenario OWNER TO postgres;

--
-- TOC entry 4548 (class 1259 OID 2599379)
-- Dependencies: 7
-- Name: scrm_categorie_fichier_etape_scorm; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scrm_categorie_fichier_etape_scorm (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.scrm_categorie_fichier_etape_scorm OWNER TO postgres;

--
-- TOC entry 10307 (class 0 OID 0)
-- Dependencies: 4548
-- Name: TABLE scrm_categorie_fichier_etape_scorm; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE scrm_categorie_fichier_etape_scorm IS 'Les association scorm-theme';


--
-- TOC entry 4549 (class 1259 OID 2599381)
-- Dependencies: 7
-- Name: scrm_etape_scorm; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scrm_etape_scorm (
    id integer NOT NULL,
    fichier integer NOT NULL,
    scorm integer
);


ALTER TABLE v2.scrm_etape_scorm OWNER TO postgres;

--
-- TOC entry 4550 (class 1259 OID 2599383)
-- Dependencies: 7
-- Name: scrm_fichier_etape_scorm; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scrm_fichier_etape_scorm (
    id integer NOT NULL
);


ALTER TABLE v2.scrm_fichier_etape_scorm OWNER TO postgres;

--
-- TOC entry 4552 (class 1259 OID 2599387)
-- Dependencies: 5268 5269 5270 5271 5272 5273 5274 5275 5276 5277 5278 5279 7
-- Name: scrm_scorm; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scrm_scorm (
    id serial NOT NULL,
    course integer DEFAULT 0 NOT NULL,
    name character varying(255) DEFAULT ''::character varying NOT NULL,
    reference character varying(255) DEFAULT ''::character varying NOT NULL,
    maxgrade real DEFAULT (0)::real NOT NULL,
    grademethod integer DEFAULT 0 NOT NULL,
    datadir character varying(255) DEFAULT ''::character varying NOT NULL,
    launch integer DEFAULT 0 NOT NULL,
    summary text DEFAULT ''::text NOT NULL,
    auto integer DEFAULT 0 NOT NULL,
    popup character varying(255) DEFAULT ''::character varying NOT NULL,
    timemodified integer DEFAULT 0 NOT NULL,
    num_theme integer DEFAULT 0 NOT NULL
);


ALTER TABLE v2.scrm_scorm OWNER TO postgres;

--
-- TOC entry 4554 (class 1259 OID 2599407)
-- Dependencies: 5281 5282 5283 5284 5285 5286 5287 5288 5289 5290 7
-- Name: scrm_scorm_sco_users; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scrm_scorm_sco_users (
    id serial NOT NULL,
    userid integer DEFAULT 0 NOT NULL,
    scormid integer DEFAULT 0 NOT NULL,
    scoid integer DEFAULT 0 NOT NULL,
    cmi_core_lesson_location character varying(255) DEFAULT ''::character varying NOT NULL,
    cmi_core_lesson_status character varying(30) DEFAULT ''::character varying NOT NULL,
    cmi_core_exit character varying(30) DEFAULT ''::character varying NOT NULL,
    cmi_core_total_time character varying(13) DEFAULT '00:00:00'::character varying NOT NULL,
    cmi_core_session_time character varying(13) DEFAULT '00:00:00'::character varying NOT NULL,
    cmi_core_score_raw real DEFAULT (0)::real NOT NULL,
    cmi_suspend_data text DEFAULT ''::text NOT NULL,
    num_cal integer
);


ALTER TABLE v2.scrm_scorm_sco_users OWNER TO postgres;

--
-- TOC entry 4556 (class 1259 OID 2599425)
-- Dependencies: 5292 5293 5294 5295 5296 5297 5298 5299 5300 5301 5302 7
-- Name: scrm_scorm_scoes; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE scrm_scorm_scoes (
    id serial NOT NULL,
    scorm integer DEFAULT 0 NOT NULL,
    manifest character varying(255) DEFAULT ''::character varying NOT NULL,
    organization character varying(255) DEFAULT ''::character varying NOT NULL,
    parent character varying(255) DEFAULT ''::character varying NOT NULL,
    identifier character varying(255) DEFAULT ''::character varying NOT NULL,
    launch character varying(255) DEFAULT ''::character varying NOT NULL,
    "type" character varying(5) DEFAULT ''::character varying NOT NULL,
    title character varying(255) DEFAULT ''::character varying NOT NULL,
    datafromlms text DEFAULT ''::text NOT NULL,
    "next" integer DEFAULT 0 NOT NULL,
    previous integer DEFAULT 0 NOT NULL
);


ALTER TABLE v2.scrm_scorm_scoes OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4557 (class 1259 OID 2599442)
-- Dependencies: 7
-- Name: snrdnmq_bloc_scenario; Type: TABLE; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE TABLE snrdnmq_bloc_scenario (
    id integer NOT NULL,
    fichier integer
);


ALTER TABLE v2.snrdnmq_bloc_scenario OWNER TO pgsql;

--
-- TOC entry 4558 (class 1259 OID 2599444)
-- Dependencies: 7
-- Name: snrdnmq_scenario_dynamique; Type: TABLE; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE TABLE snrdnmq_scenario_dynamique (
    id integer NOT NULL,
    css integer
);


ALTER TABLE v2.snrdnmq_scenario_dynamique OWNER TO pgsql;

--
-- TOC entry 4559 (class 1259 OID 2599446)
-- Dependencies: 7
-- Name: snrdnmq_scenario_dynamique_blocs; Type: TABLE; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE TABLE snrdnmq_scenario_dynamique_blocs (
    scenario_dynamique integer NOT NULL,
    bloc_scenario integer NOT NULL,
    pere integer NOT NULL,
    contenu text
);


ALTER TABLE v2.snrdnmq_scenario_dynamique_blocs OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4560 (class 1259 OID 2599451)
-- Dependencies: 7
-- Name: sr_categorie_serie; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE sr_categorie_serie (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.sr_categorie_serie OWNER TO postgres;

--
-- TOC entry 10314 (class 0 OID 0)
-- Dependencies: 4560
-- Name: TABLE sr_categorie_serie; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE sr_categorie_serie IS 'Les associations serie-theme';


--
-- TOC entry 4561 (class 1259 OID 2599453)
-- Dependencies: 5303 7
-- Name: sr_resultat_serie; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE sr_resultat_serie (
    id bigint NOT NULL,
    evaluation integer NOT NULL,
    date_creation timestamp without time zone DEFAULT now() NOT NULL
);


ALTER TABLE v2.sr_resultat_serie OWNER TO postgres;

--
-- TOC entry 4562 (class 1259 OID 2599456)
-- Dependencies: 5304 7
-- Name: sr_resultat_serie_tentative; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE sr_resultat_serie_tentative (
    id bigint NOT NULL,
    evaluation integer NOT NULL,
    date_creation timestamp without time zone DEFAULT now() NOT NULL
);


ALTER TABLE v2.sr_resultat_serie_tentative OWNER TO postgres;

--
-- TOC entry 4563 (class 1259 OID 2599459)
-- Dependencies: 7
-- Name: sr_resultat_serie_tentative_ftb; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE sr_resultat_serie_tentative_ftb (
    id bigint NOT NULL,
    ftb bigint NOT NULL,
    reponse character varying[]
);


ALTER TABLE v2.sr_resultat_serie_tentative_ftb OWNER TO postgres;

--
-- TOC entry 10318 (class 0 OID 0)
-- Dependencies: 4563
-- Name: TABLE sr_resultat_serie_tentative_ftb; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE sr_resultat_serie_tentative_ftb IS 'Contient les resultats (ftb) d''une sÃÂ©rie en cas d''ÃÂ©chec ÃÂ  une sÃÂ©rie bloquante.';


--
-- TOC entry 4564 (class 1259 OID 2599464)
-- Dependencies: 7
-- Name: sr_serie; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE sr_serie (
    id integer NOT NULL,
    bareme integer,
    chrono integer
);


ALTER TABLE v2.sr_serie OWNER TO postgres;

--
-- TOC entry 10320 (class 0 OID 0)
-- Dependencies: 4564
-- Name: TABLE sr_serie; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE sr_serie IS 'Bareme et chrono pour une sÃÂ©rie';


--
-- TOC entry 4565 (class 1259 OID 2599466)
-- Dependencies: 5305 5306 7
-- Name: sr_serie_bloquante; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE sr_serie_bloquante (
    serie integer NOT NULL,
    formation integer NOT NULL,
    parcours integer NOT NULL,
    seuil integer NOT NULL,
    etape_retour integer NOT NULL,
    tentatives integer NOT NULL,
    correction boolean DEFAULT false NOT NULL,
    blocage_parcours boolean DEFAULT false NOT NULL
);


ALTER TABLE v2.sr_serie_bloquante OWNER TO postgres;

--
-- TOC entry 10322 (class 0 OID 0)
-- Dependencies: 4565
-- Name: TABLE sr_serie_bloquante; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE sr_serie_bloquante IS 'Pour configurer une sÃÂ©rie en mode bloquant.';


--
-- TOC entry 4566 (class 1259 OID 2599470)
-- Dependencies: 7
-- Name: sr_serie_evaluations; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE sr_serie_evaluations (
    serie integer NOT NULL,
    evaluation integer NOT NULL,
    commentaire character varying(255),
    bareme integer,
    chrono integer,
    points integer,
    pere integer
);


ALTER TABLE v2.sr_serie_evaluations OWNER TO postgres;

--
-- TOC entry 10324 (class 0 OID 0)
-- Dependencies: 4566
-- Name: TABLE sr_serie_evaluations; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE sr_serie_evaluations IS 'Contient les associations serie- ÃÂ©valuations';


--
-- TOC entry 4567 (class 1259 OID 2599472)
-- Dependencies: 7
-- Name: srltr_serie_aleatoire; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE srltr_serie_aleatoire (
    id integer NOT NULL,
    "type" integer
);


ALTER TABLE v2.srltr_serie_aleatoire OWNER TO postgres;

--
-- TOC entry 4568 (class 1259 OID 2599474)
-- Dependencies: 7
-- Name: srltr_serie_aleatoire_evaluations; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE srltr_serie_aleatoire_evaluations (
    serie integer NOT NULL,
    evaluation integer NOT NULL,
    formation integer NOT NULL,
    parcours integer NOT NULL,
    stagiaire integer NOT NULL,
    pere integer
);


ALTER TABLE v2.srltr_serie_aleatoire_evaluations OWNER TO postgres;

--
-- TOC entry 10327 (class 0 OID 0)
-- Dependencies: 4568
-- Name: TABLE srltr_serie_aleatoire_evaluations; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE srltr_serie_aleatoire_evaluations IS 'Contient les associations serie-evaluation d''une sÃÂ©rie alÃÂ©atoire pour un stagiaire et une formation.';


--
-- TOC entry 4570 (class 1259 OID 2599478)
-- Dependencies: 7
-- Name: srltr_serie_aleatoire_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE srltr_serie_aleatoire_type (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3)
);


ALTER TABLE v2.srltr_serie_aleatoire_type OWNER TO postgres;

--
-- TOC entry 10329 (class 0 OID 0)
-- Dependencies: 4570
-- Name: TABLE srltr_serie_aleatoire_type; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE srltr_serie_aleatoire_type IS 'Les types des serie aleatoires';


--
-- TOC entry 4571 (class 1259 OID 2599481)
-- Dependencies: 7
-- Name: srltrmlg_serie_aleatoire_melangee; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE srltrmlg_serie_aleatoire_melangee (
    serie integer NOT NULL,
    formation integer NOT NULL,
    parcours integer NOT NULL
);


ALTER TABLE v2.srltrmlg_serie_aleatoire_melangee OWNER TO postgres;

--
-- TOC entry 4572 (class 1259 OID 2599483)
-- Dependencies: 7
-- Name: srltrmltsr_serie_aleatoire_multiserie; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE srltrmltsr_serie_aleatoire_multiserie (
    serie integer NOT NULL,
    serie_source integer NOT NULL,
    nb_evaluations integer,
    type_evaluations integer NOT NULL
);


ALTER TABLE v2.srltrmltsr_serie_aleatoire_multiserie OWNER TO postgres;

--
-- TOC entry 10332 (class 0 OID 0)
-- Dependencies: 4572
-- Name: TABLE srltrmltsr_serie_aleatoire_multiserie; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE srltrmltsr_serie_aleatoire_multiserie IS 'Contient les configurations des sÃÂ©rie alÃÂ©atoires multisÃÂ©rie (monothÃÂ¨me).';


--
-- TOC entry 4573 (class 1259 OID 2599485)
-- Dependencies: 7
-- Name: srltrmltthm_serie_aleatoire_multitheme; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE srltrmltthm_serie_aleatoire_multitheme (
    serie integer NOT NULL,
    theme_source integer NOT NULL,
    nb_evaluations integer,
    type_evaluations integer NOT NULL
);


ALTER TABLE v2.srltrmltthm_serie_aleatoire_multitheme OWNER TO postgres;

--
-- TOC entry 10334 (class 0 OID 0)
-- Dependencies: 4573
-- Name: TABLE srltrmltthm_serie_aleatoire_multitheme; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE srltrmltthm_serie_aleatoire_multitheme IS 'Contient les configurations des series alÃÂ©atoires multithÃÂ¨me.';


--
-- TOC entry 4575 (class 1259 OID 2599489)
-- Dependencies: 5309 7
-- Name: thm_categorie; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE thm_categorie (
    id serial NOT NULL,
    libelle character varying(1024),
    table_cible character varying(1024) NOT NULL,
    gestionnaire_contenu boolean DEFAULT false,
    table_etape character varying
);


ALTER TABLE v2.thm_categorie OWNER TO postgres;

--
-- TOC entry 4577 (class 1259 OID 2599498)
-- Dependencies: 7
-- Name: thm_theme; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE thm_theme (
    id serial NOT NULL,
    libelle character varying(255)
);


ALTER TABLE v2.thm_theme OWNER TO postgres;

--
-- TOC entry 10337 (class 0 OID 0)
-- Dependencies: 4577
-- Name: TABLE thm_theme; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE thm_theme IS 'Contient le libellÃÂ©s des thÃÂ¨mes.Les noms de rÃÂ©pertoires seront les numÃÂ©ros de themes.';


--
-- TOC entry 4578 (class 1259 OID 2599501)
-- Dependencies: 7
-- Name: thm_theme_categories; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE thm_theme_categories (
    theme integer NOT NULL,
    categorie integer NOT NULL,
    id integer NOT NULL
);


ALTER TABLE v2.thm_theme_categories OWNER TO postgres;

--
-- TOC entry 10339 (class 0 OID 0)
-- Dependencies: 4578
-- Name: TABLE thm_theme_categories; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE thm_theme_categories IS 'Pour le stockage de toutes les catÃÂ©gories';


--
-- TOC entry 4579 (class 1259 OID 2599503)
-- Dependencies: 7
-- Name: tp_categorie_etape; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tp_categorie_etape (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.tp_categorie_etape OWNER TO postgres;

SET default_with_oids = false;

--
-- TOC entry 4580 (class 1259 OID 2599505)
-- Dependencies: 5311 7
-- Name: tp_commentaire_etape; Type: TABLE; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE TABLE tp_commentaire_etape (
    etape integer NOT NULL,
    min integer NOT NULL,
    max integer NOT NULL,
    commentaire text,
    CONSTRAINT check_min_max CHECK ((min <= max))
);


ALTER TABLE v2.tp_commentaire_etape OWNER TO pgsql;

SET default_with_oids = true;

--
-- TOC entry 4582 (class 1259 OID 2599513)
-- Dependencies: 5313 7
-- Name: tp_etape; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tp_etape (
    id serial NOT NULL,
    libelle character varying(255),
    "type" integer NOT NULL,
    date_creation timestamp without time zone DEFAULT now() NOT NULL
);


ALTER TABLE v2.tp_etape OWNER TO postgres;

--
-- TOC entry 10343 (class 0 OID 0)
-- Dependencies: 4582
-- Name: TABLE tp_etape; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE tp_etape IS 'Contient les ÃÂ©tapes de crÃÂ©ation d''un parcours';


--
-- TOC entry 4583 (class 1259 OID 2599517)
-- Dependencies: 5314 7
-- Name: tp_etape_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tp_etape_type (
    id integer DEFAULT nextval(('v2.etape_type_id_seq'::text)::regclass) NOT NULL,
    libelle character varying(255),
    code character varying(3),
    ordre integer NOT NULL
);


ALTER TABLE v2.tp_etape_type OWNER TO postgres;

--
-- TOC entry 4584 (class 1259 OID 2599520)
-- Dependencies: 5315 5316 5317 7
-- Name: tp_parcours_etapes; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tp_parcours_etapes (
    parcours integer NOT NULL,
    etape integer NOT NULL,
    pere integer,
    obligatoire boolean DEFAULT false NOT NULL,
    chrono integer,
    fin boolean DEFAULT false NOT NULL,
    libelle_type_etape character varying(255),
    CONSTRAINT check_parcours_etape CHECK ((etape <> parcours))
);


ALTER TABLE v2.tp_parcours_etapes OWNER TO postgres;

--
-- TOC entry 10346 (class 0 OID 0)
-- Dependencies: 4584
-- Name: TABLE tp_parcours_etapes; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE tp_parcours_etapes IS 'Contient les ÃÂ©tapes des parcours.';


--
-- TOC entry 4585 (class 1259 OID 2599525)
-- Dependencies: 5318 7
-- Name: tp_resultat; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tp_resultat (
    id bigint DEFAULT nextval('resultat_id_seq'::regclass) NOT NULL,
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    parcours integer NOT NULL,
    etape integer NOT NULL,
    date_debut timestamp without time zone,
    duree interval
);


ALTER TABLE v2.tp_resultat OWNER TO postgres;

--
-- TOC entry 4587 (class 1259 OID 2599530)
-- Dependencies: 7
-- Name: tp_resultat_tentative; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tp_resultat_tentative (
    id bigserial NOT NULL,
    formation integer NOT NULL,
    stagiaire integer NOT NULL,
    parcours integer NOT NULL,
    etape integer NOT NULL,
    date_debut timestamp without time zone,
    duree interval,
    tentative integer NOT NULL
);


ALTER TABLE v2.tp_resultat_tentative OWNER TO postgres;

--
-- TOC entry 4588 (class 1259 OID 2599533)
-- Dependencies: 7
-- Name: tst_categorie_test; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tst_categorie_test (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.tst_categorie_test OWNER TO postgres;

--
-- TOC entry 4589 (class 1259 OID 2599535)
-- Dependencies: 7
-- Name: tst_media_test; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tst_media_test (
    test integer NOT NULL,
    media integer NOT NULL,
    hauteur integer,
    largeur integer
);


ALTER TABLE v2.tst_media_test OWNER TO postgres;

--
-- TOC entry 4590 (class 1259 OID 2599537)
-- Dependencies: 7
-- Name: tst_resultat_test; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tst_resultat_test (
    id bigint NOT NULL,
    positionnement integer,
    date_creation timestamp without time zone
);


ALTER TABLE v2.tst_resultat_test OWNER TO postgres;

--
-- TOC entry 4591 (class 1259 OID 2599539)
-- Dependencies: 7
-- Name: tst_test; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tst_test (
    id integer NOT NULL,
    dynamique boolean,
    continu boolean
);


ALTER TABLE v2.tst_test OWNER TO postgres;

--
-- TOC entry 10353 (class 0 OID 0)
-- Dependencies: 4591
-- Name: TABLE tst_test; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE tst_test IS 'Les caractÃÂ©ristiques d''un test (dynamique,continu)';


--
-- TOC entry 4592 (class 1259 OID 2599541)
-- Dependencies: 7
-- Name: tst_test_positionnements; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE tst_test_positionnements (
    test integer NOT NULL,
    positionnement integer NOT NULL,
    pere integer
);


ALTER TABLE v2.tst_test_positionnements OWNER TO postgres;

--
-- TOC entry 10355 (class 0 OID 0)
-- Dependencies: 4592
-- Name: TABLE tst_test_positionnements; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE tst_test_positionnements IS 'Contient les associations test-positionnements.';


--
-- TOC entry 4594 (class 1259 OID 2599545)
-- Dependencies: 7
-- Name: vltn_bareme; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vltn_bareme (
    id serial NOT NULL,
    libelle character varying(255),
    juste integer,
    fausse integer,
    manquantes integer,
    toutes integer
);


ALTER TABLE v2.vltn_bareme OWNER TO postgres;

--
-- TOC entry 10357 (class 0 OID 0)
-- Dependencies: 4594
-- Name: TABLE vltn_bareme; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE vltn_bareme IS 'Contient les barÃÂ¨mes de la plateforme';


--
-- TOC entry 4595 (class 1259 OID 2599548)
-- Dependencies: 7
-- Name: vltn_categorie_evaluation; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vltn_categorie_evaluation (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.vltn_categorie_evaluation OWNER TO postgres;

--
-- TOC entry 4596 (class 1259 OID 2599550)
-- Dependencies: 7
-- Name: vltn_categorie_fichier_media_evaluation; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vltn_categorie_fichier_media_evaluation (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.vltn_categorie_fichier_media_evaluation OWNER TO postgres;

--
-- TOC entry 10360 (class 0 OID 0)
-- Dependencies: 4596
-- Name: TABLE vltn_categorie_fichier_media_evaluation; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE vltn_categorie_fichier_media_evaluation IS 'Association theme/mÃÂ©dias de scenario';


--
-- TOC entry 4598 (class 1259 OID 2599554)
-- Dependencies: 5322 7
-- Name: vltn_evaluation; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vltn_evaluation (
    id serial NOT NULL,
    libelle character varying(1024) NOT NULL,
    "type" integer NOT NULL,
    date_creation timestamp without time zone DEFAULT now() NOT NULL
);


ALTER TABLE v2.vltn_evaluation OWNER TO postgres;

--
-- TOC entry 4600 (class 1259 OID 2599563)
-- Dependencies: 5324 7
-- Name: vltn_evaluation_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vltn_evaluation_type (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    code character varying(3),
    couleur character(6) DEFAULT 'ffffff'::bpchar
);


ALTER TABLE v2.vltn_evaluation_type OWNER TO postgres;

--
-- TOC entry 4601 (class 1259 OID 2599567)
-- Dependencies: 7
-- Name: vltn_fichier_media_evaluation; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vltn_fichier_media_evaluation (
    id integer NOT NULL
);


ALTER TABLE v2.vltn_fichier_media_evaluation OWNER TO postgres;

--
-- TOC entry 4602 (class 1259 OID 2599569)
-- Dependencies: 7
-- Name: vnmnt_evenement; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vnmnt_evenement (
    formation integer NOT NULL,
    libelle character varying(255),
    date timestamp without time zone NOT NULL,
    duree interval NOT NULL,
    modalite integer,
    intervention integer,
    intervenant integer,
    salle integer
);


ALTER TABLE v2.vnmnt_evenement OWNER TO postgres;

--
-- TOC entry 10365 (class 0 OID 0)
-- Dependencies: 4602
-- Name: TABLE vnmnt_evenement; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE vnmnt_evenement IS 'Contient les cours associÃÂ©s aux dates d''une formation.';


--
-- TOC entry 4603 (class 1259 OID 2599571)
-- Dependencies: 7
-- Name: vnmnt_evenement_presentiel; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vnmnt_evenement_presentiel (
    formation integer NOT NULL,
    date timestamp without time zone NOT NULL
);


ALTER TABLE v2.vnmnt_evenement_presentiel OWNER TO postgres;

--
-- TOC entry 10367 (class 0 OID 0)
-- Dependencies: 4603
-- Name: TABLE vnmnt_evenement_presentiel; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE vnmnt_evenement_presentiel IS 'Contient les dates de cours presentiels associÃÂ©s ÃÂ  une formation.';


--
-- TOC entry 4605 (class 1259 OID 2599575)
-- Dependencies: 7
-- Name: vnmnt_intervention; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vnmnt_intervention (
    id serial NOT NULL,
    libelle character varying(255),
    couleur integer NOT NULL
);


ALTER TABLE v2.vnmnt_intervention OWNER TO postgres;

--
-- TOC entry 4607 (class 1259 OID 2599580)
-- Dependencies: 7
-- Name: vnmnt_modalite; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vnmnt_modalite (
    id serial NOT NULL,
    libelle character varying(255),
    code character varying(3)
);


ALTER TABLE v2.vnmnt_modalite OWNER TO postgres;

--
-- TOC entry 4608 (class 1259 OID 2599583)
-- Dependencies: 5327 7
-- Name: vnmnt_salle; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE vnmnt_salle (
    id integer DEFAULT nextval('salle_id_seq'::regclass) NOT NULL,
    libelle character varying(255)
);


ALTER TABLE v2.vnmnt_salle OWNER TO postgres;

--
-- TOC entry 10371 (class 0 OID 0)
-- Dependencies: 4608
-- Name: TABLE vnmnt_salle; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE vnmnt_salle IS 'Les sales pour les cours de formation';


--
-- TOC entry 4609 (class 1259 OID 2599586)
-- Dependencies: 7
-- Name: xtlc_categorie_critere; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_categorie_critere (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.xtlc_categorie_critere OWNER TO postgres;

--
-- TOC entry 10373 (class 0 OID 0)
-- Dependencies: 4609
-- Name: TABLE xtlc_categorie_critere; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE xtlc_categorie_critere IS 'Les associations critere-theme';


--
-- TOC entry 4610 (class 1259 OID 2599588)
-- Dependencies: 7
-- Name: xtlc_categorie_exotlc; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_categorie_exotlc (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.xtlc_categorie_exotlc OWNER TO postgres;

--
-- TOC entry 4611 (class 1259 OID 2599590)
-- Dependencies: 7
-- Name: xtlc_categorie_fichier_correction; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_categorie_fichier_correction (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.xtlc_categorie_fichier_correction OWNER TO postgres;

--
-- TOC entry 10376 (class 0 OID 0)
-- Dependencies: 4611
-- Name: TABLE xtlc_categorie_fichier_correction; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE xtlc_categorie_fichier_correction IS 'Les associations fichier_correction-theme';


--
-- TOC entry 4612 (class 1259 OID 2599592)
-- Dependencies: 7
-- Name: xtlc_categorie_fichier_exotlc; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_categorie_fichier_exotlc (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.xtlc_categorie_fichier_exotlc OWNER TO postgres;

--
-- TOC entry 10378 (class 0 OID 0)
-- Dependencies: 4612
-- Name: TABLE xtlc_categorie_fichier_exotlc; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE xtlc_categorie_fichier_exotlc IS 'Les associations fichier_exotlc-theme';


--
-- TOC entry 4613 (class 1259 OID 2599594)
-- Dependencies: 7
-- Name: xtlc_categorie_fichier_media_exotlc; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_categorie_fichier_media_exotlc (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.xtlc_categorie_fichier_media_exotlc OWNER TO postgres;

--
-- TOC entry 10380 (class 0 OID 0)
-- Dependencies: 4613
-- Name: TABLE xtlc_categorie_fichier_media_exotlc; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE xtlc_categorie_fichier_media_exotlc IS 'Association theme/mÃÂ©dias de scenario';


--
-- TOC entry 4614 (class 1259 OID 2599596)
-- Dependencies: 7
-- Name: xtlc_categorie_modele_correction; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_categorie_modele_correction (
    id integer NOT NULL,
    categorie integer NOT NULL,
    theme integer NOT NULL
);


ALTER TABLE v2.xtlc_categorie_modele_correction OWNER TO postgres;

--
-- TOC entry 10382 (class 0 OID 0)
-- Dependencies: 4614
-- Name: TABLE xtlc_categorie_modele_correction; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE xtlc_categorie_modele_correction IS 'Les associations modele_correction-theme';


--
-- TOC entry 4616 (class 1259 OID 2599600)
-- Dependencies: 7
-- Name: xtlc_critere; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_critere (
    id serial NOT NULL,
    libelle character varying,
    pere integer
);


ALTER TABLE v2.xtlc_critere OWNER TO postgres;

--
-- TOC entry 10384 (class 0 OID 0)
-- Dependencies: 4616
-- Name: TABLE xtlc_critere; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE xtlc_critere IS 'Contient les critÃÂ¨res de correction (pour les exotlc).';


--
-- TOC entry 4617 (class 1259 OID 2599606)
-- Dependencies: 7
-- Name: xtlc_exotlc; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_exotlc (
    id integer NOT NULL,
    commentaire character varying(255),
    texte character varying(255),
    enonce character varying(255),
    remarque character varying(255),
    "type" integer NOT NULL
);


ALTER TABLE v2.xtlc_exotlc OWNER TO postgres;

--
-- TOC entry 10386 (class 0 OID 0)
-- Dependencies: 4617
-- Name: TABLE xtlc_exotlc; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TABLE xtlc_exotlc IS 'Contient les exotlc';


--
-- TOC entry 4618 (class 1259 OID 2599611)
-- Dependencies: 7
-- Name: xtlc_exotlc_corrections; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_exotlc_corrections (
    exotlc integer NOT NULL,
    correction integer NOT NULL
);


ALTER TABLE v2.xtlc_exotlc_corrections OWNER TO postgres;

--
-- TOC entry 4619 (class 1259 OID 2599613)
-- Dependencies: 7
-- Name: xtlc_exotlc_fichiers; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_exotlc_fichiers (
    exotlc integer NOT NULL,
    fichier integer NOT NULL
);


ALTER TABLE v2.xtlc_exotlc_fichiers OWNER TO postgres;

--
-- TOC entry 4620 (class 1259 OID 2599615)
-- Dependencies: 7
-- Name: xtlc_exotlc_mail; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_exotlc_mail (
    id integer NOT NULL,
    formateur integer NOT NULL
);


ALTER TABLE v2.xtlc_exotlc_mail OWNER TO postgres;

--
-- TOC entry 4621 (class 1259 OID 2599617)
-- Dependencies: 7
-- Name: xtlc_exotlc_plate_forme; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_exotlc_plate_forme (
    id integer NOT NULL,
    fichier_rendu character varying(1024)
);


ALTER TABLE v2.xtlc_exotlc_plate_forme OWNER TO postgres;

--
-- TOC entry 4623 (class 1259 OID 2599624)
-- Dependencies: 7
-- Name: xtlc_exotlc_type; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_exotlc_type (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL,
    code character varying(3)
);


ALTER TABLE v2.xtlc_exotlc_type OWNER TO postgres;

--
-- TOC entry 4624 (class 1259 OID 2599627)
-- Dependencies: 7
-- Name: xtlc_fichier_exotlc; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_fichier_exotlc (
    id integer NOT NULL
);


ALTER TABLE v2.xtlc_fichier_exotlc OWNER TO postgres;

--
-- TOC entry 4625 (class 1259 OID 2599629)
-- Dependencies: 7
-- Name: xtlc_fichier_media_exotlc; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_fichier_media_exotlc (
    id integer NOT NULL
);


ALTER TABLE v2.xtlc_fichier_media_exotlc OWNER TO postgres;

--
-- TOC entry 4627 (class 1259 OID 2599633)
-- Dependencies: 7
-- Name: xtlc_modele_correction; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_modele_correction (
    id serial NOT NULL,
    libelle character varying(255) NOT NULL
);


ALTER TABLE v2.xtlc_modele_correction OWNER TO postgres;

--
-- TOC entry 4628 (class 1259 OID 2599636)
-- Dependencies: 7
-- Name: xtlc_resultat_exotlc; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_resultat_exotlc (
    id bigint NOT NULL,
    commentaire text,
    correction boolean,
    fichier_rendu integer,
    date_correction timestamp without time zone
);


ALTER TABLE v2.xtlc_resultat_exotlc OWNER TO postgres;

--
-- TOC entry 4629 (class 1259 OID 2599641)
-- Dependencies: 5331 7
-- Name: xtlc_resultat_exotlc_critere; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_resultat_exotlc_critere (
    id bigint NOT NULL,
    critere integer NOT NULL,
    note integer,
    note_max integer,
    commentaire text,
    CONSTRAINT check_notes CHECK ((((note IS NULL) AND (note_max IS NULL)) OR ((note <= note_max) AND (note_max >= 0))))
);


ALTER TABLE v2.xtlc_resultat_exotlc_critere OWNER TO postgres;

--
-- TOC entry 4630 (class 1259 OID 2599647)
-- Dependencies: 5332 7
-- Name: xtlc_resultat_exotlc_sous_critere; Type: TABLE; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE TABLE xtlc_resultat_exotlc_sous_critere (
    id bigint NOT NULL,
    sous_critere integer NOT NULL,
    note integer NOT NULL,
    note_max integer NOT NULL,
    CONSTRAINT check_notes CHECK (((note <= note_max) AND (note_max >= 0)))
);


ALTER TABLE v2.xtlc_resultat_exotlc_sous_critere OWNER TO postgres;

SET search_path = contraintes, pg_catalog;

--
-- TOC entry 5013 (class 2604 OID 2599650)
-- Dependencies: 4065 4066 4066
-- Name: code; Type: DEFAULT; Schema: contraintes; Owner: postgres
--

ALTER TABLE fw_individu_type ALTER COLUMN code SET DEFAULT ('custom_profile_'::text || (currval('fw_individu_type_id_seq'::regclass))::text);


--
-- TOC entry 5338 (class 2606 OID 2599652)
-- Dependencies: 3929 3929 3929
-- Name: active_sessions_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY active_sessions
    ADD CONSTRAINT active_sessions_pkey PRIMARY KEY (sid, name);


--
-- TOC entry 5839 (class 2606 OID 2599654)
-- Dependencies: 4190 4190 4190
-- Name: active_sessions_pkey1; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY session_active
    ADD CONSTRAINT active_sessions_pkey1 PRIMARY KEY (sid, name);


--
-- TOC entry 5453 (class 2606 OID 2599656)
-- Dependencies: 3994 3994
-- Name: droit_code_key; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY droit
    ADD CONSTRAINT droit_code_key UNIQUE (code);


--
-- TOC entry 5457 (class 2606 OID 2599658)
-- Dependencies: 3997 3997
-- Name: droit_type_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY droit_type
    ADD CONSTRAINT droit_type_pkey PRIMARY KEY (id);


--
-- TOC entry 5500 (class 2606 OID 2599660)
-- Dependencies: 4018 4018
-- Name: exotlc_modele_correction_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY exotlc_modele_correction
    ADD CONSTRAINT exotlc_modele_correction_pkey PRIMARY KEY (id);


--
-- TOC entry 5531 (class 2606 OID 2599662)
-- Dependencies: 4034 4034
-- Name: fichier_metadata_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY fichier_metadata
    ADD CONSTRAINT fichier_metadata_pkey PRIMARY KEY (id);


--
-- TOC entry 5630 (class 2606 OID 2599664)
-- Dependencies: 4085 4085 4085
-- Name: individu_type_droits_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY individu_type_droits
    ADD CONSTRAINT individu_type_droits_pkey PRIMARY KEY (individu_type, droit);


--
-- TOC entry 5604 (class 2606 OID 2599666)
-- Dependencies: 4072 4072 4072 4072
-- Name: module_individus_types_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY fw_module_individus_types
    ADD CONSTRAINT module_individus_types_pkey PRIMARY KEY (module, individu_type, droit);


--
-- TOC entry 5612 (class 2606 OID 2599668)
-- Dependencies: 4076 4076
-- Name: permissions_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY fw_permission
    ADD CONSTRAINT permissions_pkey PRIMARY KEY (id);


--
-- TOC entry 5342 (class 2606 OID 2599670)
-- Dependencies: 3931 3931
-- Name: pk_alerte; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alerte
    ADD CONSTRAINT pk_alerte PRIMARY KEY (id);


--
-- TOC entry 5347 (class 2606 OID 2599672)
-- Dependencies: 3934 3934
-- Name: pk_bareme; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY bareme
    ADD CONSTRAINT pk_bareme PRIMARY KEY (id);


--
-- TOC entry 5488 (class 2606 OID 2599674)
-- Dependencies: 4012 4012 4012
-- Name: pk_calendrier; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY evenement
    ADD CONSTRAINT pk_calendrier PRIMARY KEY (formation, date);


--
-- TOC entry 5350 (class 2606 OID 2599676)
-- Dependencies: 3941 3941
-- Name: pk_capacite; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY capacite
    ADD CONSTRAINT pk_capacite PRIMARY KEY (id);


--
-- TOC entry 5352 (class 2606 OID 2599678)
-- Dependencies: 3943 3943
-- Name: pk_capacite_titre; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY capacite_titre
    ADD CONSTRAINT pk_capacite_titre PRIMARY KEY (id);


--
-- TOC entry 5354 (class 2606 OID 2599680)
-- Dependencies: 3944 3944 3944
-- Name: pk_capacite_titre_capacites; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY capacite_titre_capacites
    ADD CONSTRAINT pk_capacite_titre_capacites PRIMARY KEY (capacite_titre, capacite);


--
-- TOC entry 5356 (class 2606 OID 2599682)
-- Dependencies: 3946 3946
-- Name: pk_carton; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY carton
    ADD CONSTRAINT pk_carton PRIMARY KEY (id);


--
-- TOC entry 5358 (class 2606 OID 2599684)
-- Dependencies: 3948 3948
-- Name: pk_categorie; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie
    ADD CONSTRAINT pk_categorie PRIMARY KEY (id);


--
-- TOC entry 5360 (class 2606 OID 2599686)
-- Dependencies: 3949 3949
-- Name: pk_categorie_capacite; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_capacite
    ADD CONSTRAINT pk_categorie_capacite PRIMARY KEY (id);


--
-- TOC entry 5362 (class 2606 OID 2599688)
-- Dependencies: 3950 3950
-- Name: pk_categorie_capacite_titre; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_capacite_titre
    ADD CONSTRAINT pk_categorie_capacite_titre PRIMARY KEY (id);


--
-- TOC entry 5364 (class 2606 OID 2599690)
-- Dependencies: 3951 3951
-- Name: pk_categorie_critere; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_critere
    ADD CONSTRAINT pk_categorie_critere PRIMARY KEY (id);


--
-- TOC entry 5381 (class 2606 OID 2599692)
-- Dependencies: 3959 3959
-- Name: pk_categorie_css; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_css
    ADD CONSTRAINT pk_categorie_css PRIMARY KEY (id);


--
-- TOC entry 5366 (class 2606 OID 2599694)
-- Dependencies: 3952 3952 3952 3952
-- Name: pk_categorie_etape; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_etape
    ADD CONSTRAINT pk_categorie_etape PRIMARY KEY (id, theme, categorie);


--
-- TOC entry 5368 (class 2606 OID 2599696)
-- Dependencies: 3953 3953
-- Name: pk_categorie_etape_forum; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_etape_forum
    ADD CONSTRAINT pk_categorie_etape_forum PRIMARY KEY (id);


--
-- TOC entry 5372 (class 2606 OID 2599698)
-- Dependencies: 3955 3955
-- Name: pk_categorie_evaluation; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_evaluation
    ADD CONSTRAINT pk_categorie_evaluation PRIMARY KEY (id);


--
-- TOC entry 5374 (class 2606 OID 2599700)
-- Dependencies: 3956 3956
-- Name: pk_categorie_exotlc; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_exotlc
    ADD CONSTRAINT pk_categorie_exotlc PRIMARY KEY (id);


--
-- TOC entry 5376 (class 2606 OID 2599702)
-- Dependencies: 3957 3957
-- Name: pk_categorie_fichier_bloc_scenario; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_bloc_scenario
    ADD CONSTRAINT pk_categorie_fichier_bloc_scenario PRIMARY KEY (id);


--
-- TOC entry 5378 (class 2606 OID 2599704)
-- Dependencies: 3958 3958
-- Name: pk_categorie_fichier_correction; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_correction
    ADD CONSTRAINT pk_categorie_fichier_correction PRIMARY KEY (id);


--
-- TOC entry 5385 (class 2606 OID 2599706)
-- Dependencies: 3961 3961
-- Name: pk_categorie_fichier_exotlc; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_exotlc
    ADD CONSTRAINT pk_categorie_fichier_exotlc PRIMARY KEY (id);


--
-- TOC entry 5387 (class 2606 OID 2599708)
-- Dependencies: 3962 3962
-- Name: pk_categorie_fichier_glossaire; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_glossaire
    ADD CONSTRAINT pk_categorie_fichier_glossaire PRIMARY KEY (id);


--
-- TOC entry 5395 (class 2606 OID 2599710)
-- Dependencies: 3966 3966
-- Name: pk_categorie_fichier_ressource; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_ressource
    ADD CONSTRAINT pk_categorie_fichier_ressource PRIMARY KEY (id);


--
-- TOC entry 5398 (class 2606 OID 2599712)
-- Dependencies: 3967 3967
-- Name: pk_categorie_fichier_ressource_fichier; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_ressource_fichier
    ADD CONSTRAINT pk_categorie_fichier_ressource_fichier PRIMARY KEY (id);


--
-- TOC entry 5403 (class 2606 OID 2599714)
-- Dependencies: 3969 3969
-- Name: pk_categorie_fichier_scenario; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_scenario
    ADD CONSTRAINT pk_categorie_fichier_scenario PRIMARY KEY (id);


--
-- TOC entry 5405 (class 2606 OID 2599716)
-- Dependencies: 3970 3970
-- Name: pk_categorie_fichier_scenario_dynamique; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_scenario_dynamique
    ADD CONSTRAINT pk_categorie_fichier_scenario_dynamique PRIMARY KEY (id);


--
-- TOC entry 5407 (class 2606 OID 2599718)
-- Dependencies: 3971 3971
-- Name: pk_categorie_fichier_slide_scenario; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_slide_scenario
    ADD CONSTRAINT pk_categorie_fichier_slide_scenario PRIMARY KEY (id);


--
-- TOC entry 5400 (class 2606 OID 2599720)
-- Dependencies: 3968 3968
-- Name: pk_categorie_fichier_texte; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_ressource_texte
    ADD CONSTRAINT pk_categorie_fichier_texte PRIMARY KEY (id);


--
-- TOC entry 5409 (class 2606 OID 2599722)
-- Dependencies: 3972 3972
-- Name: pk_categorie_ftb; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_ftb
    ADD CONSTRAINT pk_categorie_ftb PRIMARY KEY (id);


--
-- TOC entry 5411 (class 2606 OID 2599724)
-- Dependencies: 3973 3973
-- Name: pk_categorie_glossaire; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_glossaire
    ADD CONSTRAINT pk_categorie_glossaire PRIMARY KEY (id);


--
-- TOC entry 5413 (class 2606 OID 2599726)
-- Dependencies: 3974 3974
-- Name: pk_categorie_grille; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_grille
    ADD CONSTRAINT pk_categorie_grille PRIMARY KEY (id);


--
-- TOC entry 5393 (class 2606 OID 2599728)
-- Dependencies: 3965 3965 3965
-- Name: pk_categorie_media; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_media_scenario
    ADD CONSTRAINT pk_categorie_media PRIMARY KEY (id, theme);


--
-- TOC entry 5389 (class 2606 OID 2599730)
-- Dependencies: 3963 3963 3963
-- Name: pk_categorie_media_evaluation; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_media_evaluation
    ADD CONSTRAINT pk_categorie_media_evaluation PRIMARY KEY (id, theme);


--
-- TOC entry 5391 (class 2606 OID 2599732)
-- Dependencies: 3964 3964 3964
-- Name: pk_categorie_media_exotlc; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_media_exotlc
    ADD CONSTRAINT pk_categorie_media_exotlc PRIMARY KEY (id, theme);


--
-- TOC entry 5415 (class 2606 OID 2599734)
-- Dependencies: 3975 3975
-- Name: pk_categorie_modele_correction; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_modele_correction
    ADD CONSTRAINT pk_categorie_modele_correction PRIMARY KEY (id);


--
-- TOC entry 5417 (class 2606 OID 2599736)
-- Dependencies: 3976 3976
-- Name: pk_categorie_positionnement; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_positionnement
    ADD CONSTRAINT pk_categorie_positionnement PRIMARY KEY (id);


--
-- TOC entry 5423 (class 2606 OID 2599738)
-- Dependencies: 3979 3979
-- Name: pk_categorie_qcm_element; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_question_reponse_element
    ADD CONSTRAINT pk_categorie_qcm_element PRIMARY KEY (id);


--
-- TOC entry 5419 (class 2606 OID 2599740)
-- Dependencies: 3977 3977
-- Name: pk_categorie_qsrc; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_qsrc
    ADD CONSTRAINT pk_categorie_qsrc PRIMARY KEY (id);


--
-- TOC entry 5421 (class 2606 OID 2599742)
-- Dependencies: 3978 3978
-- Name: pk_categorie_question_reponse; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_question_reponse
    ADD CONSTRAINT pk_categorie_question_reponse PRIMARY KEY (id);


--
-- TOC entry 5370 (class 2606 OID 2599744)
-- Dependencies: 3954 3954
-- Name: pk_categorie_ressource; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_etape_ressource
    ADD CONSTRAINT pk_categorie_ressource PRIMARY KEY (id);


--
-- TOC entry 5425 (class 2606 OID 2599746)
-- Dependencies: 3980 3980
-- Name: pk_categorie_scenario; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_scenario
    ADD CONSTRAINT pk_categorie_scenario PRIMARY KEY (id);


--
-- TOC entry 5427 (class 2606 OID 2599748)
-- Dependencies: 3981 3981
-- Name: pk_categorie_scenario_dynamique; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_scenario_dynamique
    ADD CONSTRAINT pk_categorie_scenario_dynamique PRIMARY KEY (id);


--
-- TOC entry 5383 (class 2606 OID 2599750)
-- Dependencies: 3960 3960
-- Name: pk_categorie_scorm; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_fichier_etape_scorm
    ADD CONSTRAINT pk_categorie_scorm PRIMARY KEY (id);


--
-- TOC entry 5429 (class 2606 OID 2599752)
-- Dependencies: 3982 3982 3982
-- Name: pk_categorie_serie; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_serie
    ADD CONSTRAINT pk_categorie_serie PRIMARY KEY (id, theme);


--
-- TOC entry 5431 (class 2606 OID 2599754)
-- Dependencies: 3983 3983
-- Name: pk_categorie_sondage_element; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_sondage_element
    ADD CONSTRAINT pk_categorie_sondage_element PRIMARY KEY (id);


--
-- TOC entry 5433 (class 2606 OID 2599756)
-- Dependencies: 3984 3984
-- Name: pk_categorie_test; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY categorie_test
    ADD CONSTRAINT pk_categorie_test PRIMARY KEY (id);


--
-- TOC entry 5464 (class 2606 OID 2599758)
-- Dependencies: 4002 4002
-- Name: pk_chat; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY etape_chat
    ADD CONSTRAINT pk_chat PRIMARY KEY (id);


--
-- TOC entry 5438 (class 2606 OID 2599760)
-- Dependencies: 3985 3985
-- Name: pk_choix; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY choix
    ADD CONSTRAINT pk_choix PRIMARY KEY (id);


--
-- TOC entry 5442 (class 2606 OID 2599762)
-- Dependencies: 3987 3987
-- Name: pk_classe; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY classe
    ADD CONSTRAINT pk_classe PRIMARY KEY (id);


--
-- TOC entry 5444 (class 2606 OID 2599764)
-- Dependencies: 3988 3988 3988
-- Name: pk_classe_individus; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY classe_individus
    ADD CONSTRAINT pk_classe_individus PRIMARY KEY (classe, individu);


--
-- TOC entry 5447 (class 2606 OID 2599766)
-- Dependencies: 3989 3989 3989 3989
-- Name: pk_commentaire_etape; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY commentaire_etape
    ADD CONSTRAINT pk_commentaire_etape PRIMARY KEY (etape, min, max);


--
-- TOC entry 5449 (class 2606 OID 2599768)
-- Dependencies: 3991 3991 3991
-- Name: pk_connexion; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY connexion_old
    ADD CONSTRAINT pk_connexion PRIMARY KEY (individu, connexion);


--
-- TOC entry 5451 (class 2606 OID 2599770)
-- Dependencies: 3993 3993
-- Name: pk_critere; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY critere
    ADD CONSTRAINT pk_critere PRIMARY KEY (id);


--
-- TOC entry 5455 (class 2606 OID 2599772)
-- Dependencies: 3994 3994
-- Name: pk_droit; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY droit
    ADD CONSTRAINT pk_droit PRIMARY KEY (id);


--
-- TOC entry 5587 (class 2606 OID 2599774)
-- Dependencies: 4062 4062
-- Name: pk_droit_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_droit
    ADD CONSTRAINT pk_droit_1 PRIMARY KEY (id);


--
-- TOC entry 5557 (class 2606 OID 2599776)
-- Dependencies: 4047 4047 4047
-- Name: pk_droits_formateur; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY formateur_droits
    ADD CONSTRAINT pk_droits_formateur PRIMARY KEY (formation, droit);


--
-- TOC entry 5459 (class 2606 OID 2599778)
-- Dependencies: 3999 3999
-- Name: pk_espace; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY espace
    ADD CONSTRAINT pk_espace PRIMARY KEY (id);


--
-- TOC entry 5462 (class 2606 OID 2599780)
-- Dependencies: 4001 4001
-- Name: pk_etape; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY etape
    ADD CONSTRAINT pk_etape PRIMARY KEY (id);


--
-- TOC entry 5690 (class 2606 OID 2599782)
-- Dependencies: 4126 4126
-- Name: pk_etape_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pc_etape
    ADD CONSTRAINT pk_etape_1 PRIMARY KEY (id);


--
-- TOC entry 5466 (class 2606 OID 2599784)
-- Dependencies: 4003 4003
-- Name: pk_etape_forum; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY etape_forum
    ADD CONSTRAINT pk_etape_forum PRIMARY KEY (id);


--
-- TOC entry 5473 (class 2606 OID 2599786)
-- Dependencies: 4004 4004
-- Name: pk_etape_ressource; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY etape_ressource
    ADD CONSTRAINT pk_etape_ressource PRIMARY KEY (id);


--
-- TOC entry 5475 (class 2606 OID 2599788)
-- Dependencies: 4005 4005
-- Name: pk_etape_scorm; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY etape_scorm
    ADD CONSTRAINT pk_etape_scorm PRIMARY KEY (id);


--
-- TOC entry 5478 (class 2606 OID 2599790)
-- Dependencies: 4006 4006
-- Name: pk_etape_type; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY etape_type
    ADD CONSTRAINT pk_etape_type PRIMARY KEY (id);


--
-- TOC entry 5693 (class 2606 OID 2599792)
-- Dependencies: 4128 4128
-- Name: pk_etape_type_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pc_etape_type
    ADD CONSTRAINT pk_etape_type_1 PRIMARY KEY (id);


--
-- TOC entry 5482 (class 2606 OID 2599794)
-- Dependencies: 4009 4009
-- Name: pk_evaluation; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY evaluation
    ADD CONSTRAINT pk_evaluation PRIMARY KEY (id);


--
-- TOC entry 5486 (class 2606 OID 2599796)
-- Dependencies: 4011 4011
-- Name: pk_evaluation_type; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY evaluation_type
    ADD CONSTRAINT pk_evaluation_type PRIMARY KEY (id);


--
-- TOC entry 5490 (class 2606 OID 2599798)
-- Dependencies: 4013 4013 4013
-- Name: pk_evenement_presentiel; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY evenement_presentiel
    ADD CONSTRAINT pk_evenement_presentiel PRIMARY KEY (formation, date);


--
-- TOC entry 5492 (class 2606 OID 2599800)
-- Dependencies: 4014 4014
-- Name: pk_exotlc; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY exotlc
    ADD CONSTRAINT pk_exotlc PRIMARY KEY (id);


--
-- TOC entry 5494 (class 2606 OID 2599802)
-- Dependencies: 4015 4015 4015
-- Name: pk_exotlc_corrections; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY exotlc_corrections
    ADD CONSTRAINT pk_exotlc_corrections PRIMARY KEY (exotlc, correction);


--
-- TOC entry 5496 (class 2606 OID 2599804)
-- Dependencies: 4016 4016 4016
-- Name: pk_exotlc_fichiers; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY exotlc_fichiers
    ADD CONSTRAINT pk_exotlc_fichiers PRIMARY KEY (exotlc, fichier);


--
-- TOC entry 5498 (class 2606 OID 2599806)
-- Dependencies: 4017 4017
-- Name: pk_exotlc_mail; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY exotlc_mail
    ADD CONSTRAINT pk_exotlc_mail PRIMARY KEY (id);


--
-- TOC entry 5503 (class 2606 OID 2599808)
-- Dependencies: 4019 4019
-- Name: pk_exotlc_plate_forme; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY exotlc_plate_forme
    ADD CONSTRAINT pk_exotlc_plate_forme PRIMARY KEY (id);


--
-- TOC entry 5505 (class 2606 OID 2599810)
-- Dependencies: 4021 4021
-- Name: pk_exotlc_type; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY exotlc_type
    ADD CONSTRAINT pk_exotlc_type PRIMARY KEY (id);


--
-- TOC entry 5508 (class 2606 OID 2599812)
-- Dependencies: 4023 4023
-- Name: pk_fichier; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier
    ADD CONSTRAINT pk_fichier PRIMARY KEY (id);


--
-- TOC entry 5510 (class 2606 OID 2599814)
-- Dependencies: 4024 4024
-- Name: pk_fichier_bloc_scenario; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_bloc_scenario
    ADD CONSTRAINT pk_fichier_bloc_scenario PRIMARY KEY (id);


--
-- TOC entry 5512 (class 2606 OID 2599816)
-- Dependencies: 4025 4025
-- Name: pk_fichier_correction; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_correction
    ADD CONSTRAINT pk_fichier_correction PRIMARY KEY (id);


--
-- TOC entry 5514 (class 2606 OID 2599818)
-- Dependencies: 4026 4026
-- Name: pk_fichier_css; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_css
    ADD CONSTRAINT pk_fichier_css PRIMARY KEY (id);


--
-- TOC entry 5519 (class 2606 OID 2599820)
-- Dependencies: 4028 4028
-- Name: pk_fichier_exotlc; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_exotlc
    ADD CONSTRAINT pk_fichier_exotlc PRIMARY KEY (id);


--
-- TOC entry 5521 (class 2606 OID 2599822)
-- Dependencies: 4029 4029
-- Name: pk_fichier_glossaire; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_glossaire
    ADD CONSTRAINT pk_fichier_glossaire PRIMARY KEY (id);


--
-- TOC entry 5523 (class 2606 OID 2599824)
-- Dependencies: 4030 4030
-- Name: pk_fichier_icone; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_icone
    ADD CONSTRAINT pk_fichier_icone PRIMARY KEY (id);


--
-- TOC entry 5529 (class 2606 OID 2599826)
-- Dependencies: 4033 4033
-- Name: pk_fichier_media; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_media_scenario
    ADD CONSTRAINT pk_fichier_media PRIMARY KEY (id);


--
-- TOC entry 5525 (class 2606 OID 2599828)
-- Dependencies: 4031 4031
-- Name: pk_fichier_media_evaluation; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_media_evaluation
    ADD CONSTRAINT pk_fichier_media_evaluation PRIMARY KEY (id);


--
-- TOC entry 5527 (class 2606 OID 2599830)
-- Dependencies: 4032 4032
-- Name: pk_fichier_media_exotlc; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_media_exotlc
    ADD CONSTRAINT pk_fichier_media_exotlc PRIMARY KEY (id);


--
-- TOC entry 5534 (class 2606 OID 2599832)
-- Dependencies: 4035 4035
-- Name: pk_fichier_photo; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_photo
    ADD CONSTRAINT pk_fichier_photo PRIMARY KEY (id);


--
-- TOC entry 5536 (class 2606 OID 2599834)
-- Dependencies: 4036 4036
-- Name: pk_fichier_ressource; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY fichier_ressource
    ADD CONSTRAINT pk_fichier_ressource PRIMARY KEY (id);


--
-- TOC entry 5538 (class 2606 OID 2599836)
-- Dependencies: 4037 4037
-- Name: pk_fichier_ressource_fichier; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_ressource_fichier
    ADD CONSTRAINT pk_fichier_ressource_fichier PRIMARY KEY (id);


--
-- TOC entry 5540 (class 2606 OID 2599838)
-- Dependencies: 4038 4038
-- Name: pk_fichier_ressource_texte; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_ressource_texte
    ADD CONSTRAINT pk_fichier_ressource_texte PRIMARY KEY (id);


--
-- TOC entry 5543 (class 2606 OID 2599840)
-- Dependencies: 4039 4039
-- Name: pk_fichier_scenario; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_scenario
    ADD CONSTRAINT pk_fichier_scenario PRIMARY KEY (id);


--
-- TOC entry 5549 (class 2606 OID 2599842)
-- Dependencies: 4041 4041 4041
-- Name: pk_fichier_scenario_dynamique_blocs; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_scenario_dynamique_blocs
    ADD CONSTRAINT pk_fichier_scenario_dynamique_blocs PRIMARY KEY (id, ordre);


--
-- TOC entry 5517 (class 2606 OID 2599844)
-- Dependencies: 4027 4027
-- Name: pk_fichier_scorm; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_etape_scorm
    ADD CONSTRAINT pk_fichier_scorm PRIMARY KEY (id);


--
-- TOC entry 5551 (class 2606 OID 2599846)
-- Dependencies: 4042 4042
-- Name: pk_fichier_slide_scenario; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_slide_scenario
    ADD CONSTRAINT pk_fichier_slide_scenario PRIMARY KEY (id);


--
-- TOC entry 5553 (class 2606 OID 2599848)
-- Dependencies: 4044 4044
-- Name: pk_fichier_type; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_type
    ADD CONSTRAINT pk_fichier_type PRIMARY KEY (id);


--
-- TOC entry 5555 (class 2606 OID 2599850)
-- Dependencies: 4046 4046
-- Name: pk_filiere; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY filiere
    ADD CONSTRAINT pk_filiere PRIMARY KEY (id);


--
-- TOC entry 5697 (class 2606 OID 2599852)
-- Dependencies: 4130 4130
-- Name: pk_filiere_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pc_filiere
    ADD CONSTRAINT pk_filiere_1 PRIMARY KEY (id);


--
-- TOC entry 5559 (class 2606 OID 2599854)
-- Dependencies: 4049 4049
-- Name: pk_formation; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY formation
    ADD CONSTRAINT pk_formation PRIMARY KEY (id);


--
-- TOC entry 5561 (class 2606 OID 2599856)
-- Dependencies: 4050 4050 4050
-- Name: pk_formation_forums; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY formation_forums
    ADD CONSTRAINT pk_formation_forums PRIMARY KEY (formation, forum);


--
-- TOC entry 5563 (class 2606 OID 2599858)
-- Dependencies: 4051 4051 4051
-- Name: pk_formation_langues; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY formation_langues
    ADD CONSTRAINT pk_formation_langues PRIMARY KEY (formation, langue);


--
-- TOC entry 5566 (class 2606 OID 2599860)
-- Dependencies: 4052 4052 4052
-- Name: pk_formation_participants; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY formation_participants
    ADD CONSTRAINT pk_formation_participants PRIMARY KEY (formation, classe);


--
-- TOC entry 5572 (class 2606 OID 2599862)
-- Dependencies: 4053 4053 4053
-- Name: pk_formation_ressources; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY formation_ressources
    ADD CONSTRAINT pk_formation_ressources PRIMARY KEY (formation, fichier_ressource);


--
-- TOC entry 5577 (class 2606 OID 2599864)
-- Dependencies: 4054 4054
-- Name: pk_formation_session; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY formation_session
    ADD CONSTRAINT pk_formation_session PRIMARY KEY (formation);


--
-- TOC entry 5579 (class 2606 OID 2599866)
-- Dependencies: 4056 4056
-- Name: pk_forum; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY forum
    ADD CONSTRAINT pk_forum PRIMARY KEY (id);


--
-- TOC entry 5581 (class 2606 OID 2599868)
-- Dependencies: 4058 4058
-- Name: pk_forum_environnement; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY forum_environnement
    ADD CONSTRAINT pk_forum_environnement PRIMARY KEY (id);


--
-- TOC entry 5583 (class 2606 OID 2599870)
-- Dependencies: 4059 4059
-- Name: pk_forum_environnements; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY forum_environnements
    ADD CONSTRAINT pk_forum_environnements PRIMARY KEY (forum);


--
-- TOC entry 5585 (class 2606 OID 2599872)
-- Dependencies: 4060 4060
-- Name: pk_ftb; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ftb
    ADD CONSTRAINT pk_ftb PRIMARY KEY (id);


--
-- TOC entry 5606 (class 2606 OID 2599874)
-- Dependencies: 4074 4074
-- Name: pk_fw_module_pages; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY fw_module_pages
    ADD CONSTRAINT pk_fw_module_pages PRIMARY KEY (id);


--
-- TOC entry 5614 (class 2606 OID 2599876)
-- Dependencies: 4078 4078
-- Name: pk_glossaire; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY glossaire
    ADD CONSTRAINT pk_glossaire PRIMARY KEY (id);


--
-- TOC entry 5620 (class 2606 OID 2599878)
-- Dependencies: 4081 4081
-- Name: pk_grille; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grille
    ADD CONSTRAINT pk_grille PRIMARY KEY (id);


--
-- TOC entry 5622 (class 2606 OID 2599880)
-- Dependencies: 4082 4082 4082
-- Name: pk_grille_capacites_titres; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grille_capacites_titres
    ADD CONSTRAINT pk_grille_capacites_titres PRIMARY KEY (grille, capacite_titre);


--
-- TOC entry 5624 (class 2606 OID 2599882)
-- Dependencies: 4083 4083 4083 4083 4083 4083 4083
-- Name: pk_grille_resultats; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grille_resultats
    ADD CONSTRAINT pk_grille_resultats PRIMARY KEY (formation, stagiaire, grille, capacite_titre, capacite, date);


--
-- TOC entry 5591 (class 2606 OID 2599884)
-- Dependencies: 4064 4064
-- Name: pk_individu_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_individu
    ADD CONSTRAINT pk_individu_1 PRIMARY KEY (id);


--
-- TOC entry 5626 (class 2606 OID 2599886)
-- Dependencies: 4084 4084 4084 4084
-- Name: pk_individu_droits; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY individu_droits
    ADD CONSTRAINT pk_individu_droits PRIMARY KEY (individu, droit, classe);


--
-- TOC entry 5595 (class 2606 OID 2599888)
-- Dependencies: 4067 4067 4067
-- Name: pk_individu_types_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_individu_types
    ADD CONSTRAINT pk_individu_types_1 PRIMARY KEY ("type", individu);


--
-- TOC entry 5632 (class 2606 OID 2599890)
-- Dependencies: 4087 4087
-- Name: pk_inscription; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY inscription
    ADD CONSTRAINT pk_inscription PRIMARY KEY (id);


--
-- TOC entry 5636 (class 2606 OID 2599892)
-- Dependencies: 4089 4089
-- Name: pk_intervention; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY intervention
    ADD CONSTRAINT pk_intervention PRIMARY KEY (id);


--
-- TOC entry 5638 (class 2606 OID 2599894)
-- Dependencies: 4091 4091
-- Name: pk_langue; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY langue
    ADD CONSTRAINT pk_langue PRIMARY KEY (id);


--
-- TOC entry 5597 (class 2606 OID 2599896)
-- Dependencies: 4069 4069
-- Name: pk_langue_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_langue
    ADD CONSTRAINT pk_langue_1 PRIMARY KEY (id);


--
-- TOC entry 5640 (class 2606 OID 2599898)
-- Dependencies: 4092 4092 4092 4092
-- Name: pk_langue_messages; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY langue_message
    ADD CONSTRAINT pk_langue_messages PRIMARY KEY (id, "type", langue);


--
-- TOC entry 5642 (class 2606 OID 2599900)
-- Dependencies: 4094 4094
-- Name: pk_langue_type_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY langue_type
    ADD CONSTRAINT pk_langue_type_1 PRIMARY KEY (id);


--
-- TOC entry 5644 (class 2606 OID 2599902)
-- Dependencies: 4095 4095
-- Name: pk_liste; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY liste
    ADD CONSTRAINT pk_liste PRIMARY KEY (id);


--
-- TOC entry 5646 (class 2606 OID 2599904)
-- Dependencies: 4097 4097
-- Name: pk_liste_type; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY liste_type
    ADD CONSTRAINT pk_liste_type PRIMARY KEY (id);


--
-- TOC entry 5648 (class 2606 OID 2599906)
-- Dependencies: 4098 4098
-- Name: pk_media; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY media
    ADD CONSTRAINT pk_media PRIMARY KEY (id);


--
-- TOC entry 5650 (class 2606 OID 2599908)
-- Dependencies: 4099 4099
-- Name: pk_media_question_reponse; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY media_question_reponse
    ADD CONSTRAINT pk_media_question_reponse PRIMARY KEY (question_reponse);


--
-- TOC entry 5652 (class 2606 OID 2599910)
-- Dependencies: 4100 4100 4100
-- Name: pk_media_question_reponse_element; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY media_question_reponse_element
    ADD CONSTRAINT pk_media_question_reponse_element PRIMARY KEY (question_reponse, question_reponse_element);


--
-- TOC entry 5654 (class 2606 OID 2599912)
-- Dependencies: 4101 4101 4101
-- Name: pk_media_test; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY media_test
    ADD CONSTRAINT pk_media_test PRIMARY KEY (test, media);


--
-- TOC entry 5656 (class 2606 OID 2599914)
-- Dependencies: 4103 4103
-- Name: pk_message; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY message
    ADD CONSTRAINT pk_message PRIMARY KEY (id);


--
-- TOC entry 5658 (class 2606 OID 2599916)
-- Dependencies: 4105 4105
-- Name: pk_modalite; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY modalite
    ADD CONSTRAINT pk_modalite PRIMARY KEY (id);


--
-- TOC entry 5660 (class 2606 OID 2599918)
-- Dependencies: 4107 4107
-- Name: pk_modele_correction; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY modele_correction
    ADD CONSTRAINT pk_modele_correction PRIMARY KEY (id);


--
-- TOC entry 5334 (class 2606 OID 2599920)
-- Dependencies: 3927 3927 3927
-- Name: pk_modele_correction_criteres; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY modele_correction_criteres
    ADD CONSTRAINT pk_modele_correction_criteres PRIMARY KEY (modele_correction, critere);


--
-- TOC entry 5599 (class 2606 OID 2599922)
-- Dependencies: 4071 4071
-- Name: pk_module; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY fw_module
    ADD CONSTRAINT pk_module PRIMARY KEY (id);


--
-- TOC entry 5610 (class 2606 OID 2599924)
-- Dependencies: 4075 4075 4075
-- Name: pk_module_submodules; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY fw_module_submodules
    ADD CONSTRAINT pk_module_submodules PRIMARY KEY (module, submodule);


--
-- TOC entry 5662 (class 2606 OID 2599926)
-- Dependencies: 4109 4109
-- Name: pk_organisme; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY organisme
    ADD CONSTRAINT pk_organisme PRIMARY KEY (id);


--
-- TOC entry 5664 (class 2606 OID 2599928)
-- Dependencies: 4111 4111
-- Name: pk_page; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY page
    ADD CONSTRAINT pk_page PRIMARY KEY (id);


--
-- TOC entry 5666 (class 2606 OID 2599930)
-- Dependencies: 4112 4112 4112 4112 4112
-- Name: pk_page_annuaire_configuration; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY page_annuaire_configuration
    ADD CONSTRAINT pk_page_annuaire_configuration PRIMARY KEY (page, formation, individu_type, page_element);


--
-- TOC entry 5668 (class 2606 OID 2599932)
-- Dependencies: 4113 4113 4113 4113
-- Name: pk_page_commentaire; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY page_commentaire
    ADD CONSTRAINT pk_page_commentaire PRIMARY KEY (page, formation, stagiaire);


--
-- TOC entry 5670 (class 2606 OID 2599934)
-- Dependencies: 4115 4115
-- Name: pk_page_element; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY page_element
    ADD CONSTRAINT pk_page_element PRIMARY KEY (id);


--
-- TOC entry 5672 (class 2606 OID 2599936)
-- Dependencies: 4116 4116 4116
-- Name: pk_page_elements; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY page_elements
    ADD CONSTRAINT pk_page_elements PRIMARY KEY (page, page_element);


--
-- TOC entry 5674 (class 2606 OID 2599938)
-- Dependencies: 4117 4117 4117 4117 4117
-- Name: pk_page_liste; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY page_liste
    ADD CONSTRAINT pk_page_liste PRIMARY KEY (formation, parcours, liste, page);


--
-- TOC entry 5676 (class 2606 OID 2599940)
-- Dependencies: 4118 4118 4118 4118 4118 4118
-- Name: pk_page_liste_configuration; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY page_liste_configuration
    ADD CONSTRAINT pk_page_liste_configuration PRIMARY KEY (page, parcours, formation, liste, page_element);


--
-- TOC entry 5678 (class 2606 OID 2599942)
-- Dependencies: 4119 4119 4119 4119 4119
-- Name: pk_page_ressource_configuration; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY page_ressource_configuration
    ADD CONSTRAINT pk_page_ressource_configuration PRIMARY KEY (page, formation, parcours, etape_ressource);


--
-- TOC entry 5680 (class 2606 OID 2599944)
-- Dependencies: 4121 4121
-- Name: pk_page_type; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY page_type
    ADD CONSTRAINT pk_page_type PRIMARY KEY (id);


--
-- TOC entry 5682 (class 2606 OID 2599946)
-- Dependencies: 4122 4122
-- Name: pk_parcours; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY parcours
    ADD CONSTRAINT pk_parcours PRIMARY KEY (id);


--
-- TOC entry 5699 (class 2606 OID 2599948)
-- Dependencies: 4131 4131
-- Name: pk_parcours_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pc_parcours
    ADD CONSTRAINT pk_parcours_1 PRIMARY KEY (id);


--
-- TOC entry 5684 (class 2606 OID 2599950)
-- Dependencies: 4123 4123 4123
-- Name: pk_parcours_etapes; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY parcours_etapes
    ADD CONSTRAINT pk_parcours_etapes PRIMARY KEY (parcours, etape);


--
-- TOC entry 5717 (class 2606 OID 2599952)
-- Dependencies: 4138 4138
-- Name: pk_positionnement; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY positionnement_old
    ADD CONSTRAINT pk_positionnement PRIMARY KEY (id);


--
-- TOC entry 5701 (class 2606 OID 2599954)
-- Dependencies: 4133 4133
-- Name: pk_positionnement_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY positionnement
    ADD CONSTRAINT pk_positionnement_1 PRIMARY KEY (id);


--
-- TOC entry 5712 (class 2606 OID 2599956)
-- Dependencies: 4135 4135 4135 4135
-- Name: pk_positionnement_elements; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY positionnement_elements
    ADD CONSTRAINT pk_positionnement_elements PRIMARY KEY (question_reponse, question, choix);


--
-- TOC entry 5708 (class 2606 OID 2599958)
-- Dependencies: 4134 4134 4134 4134
-- Name: pk_positionnement_evaluations_generees; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY positionnement_choix_evaluations
    ADD CONSTRAINT pk_positionnement_evaluations_generees PRIMARY KEY (positionnement, "type", reponse);


--
-- TOC entry 5721 (class 2606 OID 2599960)
-- Dependencies: 4139 4139 4139 4139
-- Name: pk_qcm_elements; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qcm_elements
    ADD CONSTRAINT pk_qcm_elements PRIMARY KEY (question_reponse, question, reponse);


--
-- TOC entry 5723 (class 2606 OID 2599962)
-- Dependencies: 4140 4140
-- Name: pk_qsrc; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qsrc
    ADD CONSTRAINT pk_qsrc PRIMARY KEY (id);


--
-- TOC entry 5727 (class 2606 OID 2599964)
-- Dependencies: 4141 4141
-- Name: pk_question; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question
    ADD CONSTRAINT pk_question PRIMARY KEY (id);


--
-- TOC entry 5729 (class 2606 OID 2599966)
-- Dependencies: 4142 4142
-- Name: pk_question_reponse; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse
    ADD CONSTRAINT pk_question_reponse PRIMARY KEY (id);


--
-- TOC entry 5733 (class 2606 OID 2599968)
-- Dependencies: 4144 4144
-- Name: pk_question_reponse_element; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_element
    ADD CONSTRAINT pk_question_reponse_element PRIMARY KEY (id);


--
-- TOC entry 5744 (class 2606 OID 2599970)
-- Dependencies: 4146 4146 4146 4146
-- Name: pk_question_reponse_elements; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_elements_old
    ADD CONSTRAINT pk_question_reponse_elements PRIMARY KEY (question_reponse, question, reponse);


--
-- TOC entry 5735 (class 2606 OID 2599972)
-- Dependencies: 4145 4145 4145
-- Name: pk_question_reponse_elements_new; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_elements
    ADD CONSTRAINT pk_question_reponse_elements_new PRIMARY KEY (question_reponse, question_reponse_element);


--
-- TOC entry 5749 (class 2606 OID 2599974)
-- Dependencies: 4147 4147 4147 4147
-- Name: pk_question_reponse_elements_old; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_elements_older
    ADD CONSTRAINT pk_question_reponse_elements_old PRIMARY KEY (question_reponse, question, reponse);


--
-- TOC entry 5753 (class 2606 OID 2599976)
-- Dependencies: 4149 4149
-- Name: pk_question_reponse_type; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_type
    ADD CONSTRAINT pk_question_reponse_type PRIMARY KEY (id);


--
-- TOC entry 5755 (class 2606 OID 2599978)
-- Dependencies: 4150 4150
-- Name: pk_reponse; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY reponse
    ADD CONSTRAINT pk_reponse PRIMARY KEY (id);


--
-- TOC entry 5759 (class 2606 OID 2599980)
-- Dependencies: 4152 4152
-- Name: pk_resultat; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat
    ADD CONSTRAINT pk_resultat PRIMARY KEY (id);


--
-- TOC entry 5764 (class 2606 OID 2599982)
-- Dependencies: 4153 4153
-- Name: pk_resultat_exotlc; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_exotlc
    ADD CONSTRAINT pk_resultat_exotlc PRIMARY KEY (id);


--
-- TOC entry 5766 (class 2606 OID 2599984)
-- Dependencies: 4154 4154 4154
-- Name: pk_resultat_exotlc_critere; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_exotlc_critere
    ADD CONSTRAINT pk_resultat_exotlc_critere PRIMARY KEY (id, critere);


--
-- TOC entry 5768 (class 2606 OID 2599986)
-- Dependencies: 4155 4155 4155
-- Name: pk_resultat_exotlc_sous_critere; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_exotlc_sous_critere
    ADD CONSTRAINT pk_resultat_exotlc_sous_critere PRIMARY KEY (id, sous_critere);


--
-- TOC entry 5771 (class 2606 OID 2599988)
-- Dependencies: 4156 4156 4156 4156
-- Name: pk_resultat_positionnement; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_positionnement
    ADD CONSTRAINT pk_resultat_positionnement PRIMARY KEY (id, test, positionnement);


--
-- TOC entry 5774 (class 2606 OID 2599990)
-- Dependencies: 4157 4157 4157 4157 4157 4157
-- Name: pk_resultat_positionnement_question_reponse; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_positionnement_question_reponse
    ADD CONSTRAINT pk_resultat_positionnement_question_reponse PRIMARY KEY (id, test, question_reponse, question, choix);


--
-- TOC entry 5778 (class 2606 OID 2599992)
-- Dependencies: 4158 4158 4158
-- Name: pk_resultat_serie; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_serie
    ADD CONSTRAINT pk_resultat_serie PRIMARY KEY (id, evaluation);


--
-- TOC entry 5783 (class 2606 OID 2599994)
-- Dependencies: 4160 4160 4160 4160 4160
-- Name: pk_resultat_serie_question_reponse; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_serie_question_reponse
    ADD CONSTRAINT pk_resultat_serie_question_reponse PRIMARY KEY (id, question_reponse, question, reponse);


--
-- TOC entry 5786 (class 2606 OID 2599996)
-- Dependencies: 4161 4161 4161
-- Name: pk_resultat_serie_tentative; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_serie_tentative
    ADD CONSTRAINT pk_resultat_serie_tentative PRIMARY KEY (id, evaluation);


--
-- TOC entry 5788 (class 2606 OID 2599998)
-- Dependencies: 4163 4163 4163 4163 4163
-- Name: pk_resultat_serie_tentative_question_reponse; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_serie_tentative_question_reponse
    ADD CONSTRAINT pk_resultat_serie_tentative_question_reponse PRIMARY KEY (id, question_reponse, question, reponse);


--
-- TOC entry 5790 (class 2606 OID 2600000)
-- Dependencies: 4165 4165
-- Name: pk_resultat_tentative; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_tentative
    ADD CONSTRAINT pk_resultat_tentative PRIMARY KEY (id);


--
-- TOC entry 5794 (class 2606 OID 2600002)
-- Dependencies: 4168 4168
-- Name: pk_salle; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY salle
    ADD CONSTRAINT pk_salle PRIMARY KEY (id);


--
-- TOC entry 5796 (class 2606 OID 2600004)
-- Dependencies: 4169 4169
-- Name: pk_scenario; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scenario
    ADD CONSTRAINT pk_scenario PRIMARY KEY (id);


--
-- TOC entry 5800 (class 2606 OID 2600006)
-- Dependencies: 4170 4170
-- Name: pk_scenario_dynamique; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scenario_dynamique
    ADD CONSTRAINT pk_scenario_dynamique PRIMARY KEY (id);


--
-- TOC entry 5545 (class 2606 OID 2600008)
-- Dependencies: 4040 4040
-- Name: pk_scenario_editor; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fichier_scenario_dynamique
    ADD CONSTRAINT pk_scenario_editor PRIMARY KEY (id);


--
-- TOC entry 5813 (class 2606 OID 2600010)
-- Dependencies: 4178 4178
-- Name: pk_section; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY section
    ADD CONSTRAINT pk_section PRIMARY KEY (id);


--
-- TOC entry 5815 (class 2606 OID 2600012)
-- Dependencies: 4179 4179
-- Name: pk_serie; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie
    ADD CONSTRAINT pk_serie PRIMARY KEY (id);


--
-- TOC entry 5817 (class 2606 OID 2600014)
-- Dependencies: 4180 4180
-- Name: pk_serie_aleatoire; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie_aleatoire
    ADD CONSTRAINT pk_serie_aleatoire PRIMARY KEY (id);


--
-- TOC entry 5819 (class 2606 OID 2600016)
-- Dependencies: 4181 4181 4181 4181 4181 4181
-- Name: pk_serie_aleatoire_evaluations; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie_aleatoire_evaluations
    ADD CONSTRAINT pk_serie_aleatoire_evaluations PRIMARY KEY (stagiaire, serie, evaluation, formation, parcours);


--
-- TOC entry 5821 (class 2606 OID 2600018)
-- Dependencies: 4182 4182 4182 4182
-- Name: pk_serie_aleatoire_melangee; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie_aleatoire_melangee
    ADD CONSTRAINT pk_serie_aleatoire_melangee PRIMARY KEY (serie, formation, parcours);


--
-- TOC entry 5823 (class 2606 OID 2600020)
-- Dependencies: 4183 4183 4183 4183
-- Name: pk_serie_aleatoire_multiserie; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie_aleatoire_multiserie
    ADD CONSTRAINT pk_serie_aleatoire_multiserie PRIMARY KEY (serie, serie_source, type_evaluations);


--
-- TOC entry 5826 (class 2606 OID 2600022)
-- Dependencies: 4184 4184 4184 4184
-- Name: pk_serie_aleatoire_multitheme; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie_aleatoire_multitheme
    ADD CONSTRAINT pk_serie_aleatoire_multitheme PRIMARY KEY (serie, theme_source, type_evaluations);


--
-- TOC entry 5828 (class 2606 OID 2600024)
-- Dependencies: 4186 4186
-- Name: pk_serie_aleatoire_type; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie_aleatoire_type
    ADD CONSTRAINT pk_serie_aleatoire_type PRIMARY KEY (id);


--
-- TOC entry 5831 (class 2606 OID 2600026)
-- Dependencies: 4187 4187 4187 4187
-- Name: pk_serie_blocante; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie_bloquante
    ADD CONSTRAINT pk_serie_blocante PRIMARY KEY (serie, formation, parcours);


--
-- TOC entry 5835 (class 2606 OID 2600028)
-- Dependencies: 4188 4188 4188
-- Name: pk_serie_evaluations; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie_evaluations
    ADD CONSTRAINT pk_serie_evaluations PRIMARY KEY (serie, evaluation);


--
-- TOC entry 5842 (class 2606 OID 2600030)
-- Dependencies: 4191 4191 4191 4191
-- Name: pk_stagiaire_grille; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY stagiaire_grille
    ADD CONSTRAINT pk_stagiaire_grille PRIMARY KEY (formation, stagiaire, grille);


--
-- TOC entry 5844 (class 2606 OID 2600032)
-- Dependencies: 4192 4192
-- Name: pk_test; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY test
    ADD CONSTRAINT pk_test PRIMARY KEY (id);


--
-- TOC entry 5846 (class 2606 OID 2600034)
-- Dependencies: 4193 4193 4193
-- Name: pk_test_positionnements; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY test_positionnements
    ADD CONSTRAINT pk_test_positionnements PRIMARY KEY (test, positionnement);


--
-- TOC entry 5849 (class 2606 OID 2600036)
-- Dependencies: 4195 4195
-- Name: pk_theme; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY theme
    ADD CONSTRAINT pk_theme PRIMARY KEY (id);


--
-- TOC entry 5851 (class 2606 OID 2600038)
-- Dependencies: 4196 4196 4196 4196
-- Name: pk_theme_categories; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY theme_categories
    ADD CONSTRAINT pk_theme_categories PRIMARY KEY (categorie, id, theme);


--
-- TOC entry 5593 (class 2606 OID 2600040)
-- Dependencies: 4066 4066
-- Name: pk_type_individu_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_individu_type
    ADD CONSTRAINT pk_type_individu_1 PRIMARY KEY (id);


--
-- TOC entry 5804 (class 2606 OID 2600042)
-- Dependencies: 4172 4172
-- Name: scorm_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scorm
    ADD CONSTRAINT scorm_pkey PRIMARY KEY (id);


--
-- TOC entry 5807 (class 2606 OID 2600044)
-- Dependencies: 4174 4174
-- Name: scorm_sco_users_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scorm_sco_users
    ADD CONSTRAINT scorm_sco_users_pkey PRIMARY KEY (id);


--
-- TOC entry 5810 (class 2606 OID 2600046)
-- Dependencies: 4176 4176
-- Name: scorm_scoes_pkey; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scorm_scoes
    ADD CONSTRAINT scorm_scoes_pkey PRIMARY KEY (id);


--
-- TOC entry 5440 (class 2606 OID 2600048)
-- Dependencies: 3985 3985 3985 3985
-- Name: u_choix; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY choix
    ADD CONSTRAINT u_choix UNIQUE (id, question_reponse, pere);


--
-- TOC entry 5480 (class 2606 OID 2600050)
-- Dependencies: 4006 4006
-- Name: u_etape_type; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY etape_type
    ADD CONSTRAINT u_etape_type UNIQUE (ordre);


--
-- TOC entry 5695 (class 2606 OID 2600052)
-- Dependencies: 4128 4128
-- Name: u_etape_type_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pc_etape_type
    ADD CONSTRAINT u_etape_type_1 UNIQUE (ordre);


--
-- TOC entry 5616 (class 2606 OID 2600054)
-- Dependencies: 4078 4078
-- Name: u_fichier_glossaire; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY glossaire
    ADD CONSTRAINT u_fichier_glossaire UNIQUE (fichier);


--
-- TOC entry 5618 (class 2606 OID 2600056)
-- Dependencies: 4079 4079
-- Name: u_fichier_glossaire_fichiers; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY glossaire_fichiers
    ADD CONSTRAINT u_fichier_glossaire_fichiers UNIQUE (fichier);


--
-- TOC entry 5798 (class 2606 OID 2600058)
-- Dependencies: 4169 4169
-- Name: u_fichier_scenario; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scenario
    ADD CONSTRAINT u_fichier_scenario UNIQUE (fichier);


--
-- TOC entry 5802 (class 2606 OID 2600060)
-- Dependencies: 4170 4170
-- Name: u_fichier_scenario_dynamique; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scenario_dynamique
    ADD CONSTRAINT u_fichier_scenario_dynamique UNIQUE (fichier);


--
-- TOC entry 5574 (class 2606 OID 2600062)
-- Dependencies: 4053 4053 4053 4053 4053
-- Name: u_formation_ressources; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY formation_ressources
    ADD CONSTRAINT u_formation_ressources UNIQUE (formation, fichier_ressource, espace, section);


--
-- TOC entry 5634 (class 2606 OID 2600064)
-- Dependencies: 4087 4087
-- Name: u_inscription; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY inscription
    ADD CONSTRAINT u_inscription UNIQUE ("login");


--
-- TOC entry 5703 (class 2606 OID 2600066)
-- Dependencies: 4133 4133 4133
-- Name: u_positionnement; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY positionnement
    ADD CONSTRAINT u_positionnement UNIQUE (id, qsrc);


--
-- TOC entry 5719 (class 2606 OID 2600068)
-- Dependencies: 4138 4138 4138
-- Name: u_positionnement_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY positionnement_old
    ADD CONSTRAINT u_positionnement_1 UNIQUE (id, question_reponse);


--
-- TOC entry 5715 (class 2606 OID 2600070)
-- Dependencies: 4136 4136 4136 4136 4136 4136
-- Name: u_positionnement_evaluations; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY positionnement_evaluations
    ADD CONSTRAINT u_positionnement_evaluations UNIQUE (question_reponse, question, choix, evaluation, pere);


--
-- TOC entry 5761 (class 2606 OID 2600072)
-- Dependencies: 4152 4152 4152 4152 4152
-- Name: u_resultat; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat
    ADD CONSTRAINT u_resultat UNIQUE (formation, stagiaire, parcours, etape);


--
-- TOC entry 5792 (class 2606 OID 2600074)
-- Dependencies: 4165 4165 4165 4165 4165 4165
-- Name: u_resultat_tentative; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY resultat_tentative
    ADD CONSTRAINT u_resultat_tentative UNIQUE (formation, stagiaire, parcours, etape, tentative);


--
-- TOC entry 5344 (class 2606 OID 2600076)
-- Dependencies: 3931 3931 3931
-- Name: uk_alerte; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY alerte
    ADD CONSTRAINT uk_alerte UNIQUE (formation, date);


--
-- TOC entry 5568 (class 2606 OID 2600078)
-- Dependencies: 4052 4052 4052
-- Name: uk_formation_participants; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY formation_participants
    ADD CONSTRAINT uk_formation_participants UNIQUE (formation, classe);


--
-- TOC entry 5601 (class 2606 OID 2600080)
-- Dependencies: 4071 4071
-- Name: uk_module; Type: CONSTRAINT; Schema: contraintes; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY fw_module
    ADD CONSTRAINT uk_module UNIQUE (code);


--
-- TOC entry 5687 (class 2606 OID 2600082)
-- Dependencies: 4124 4124 4124 4124 4124 4124
-- Name: uk_parcours_orientation; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY parcours_oriente
    ADD CONSTRAINT uk_parcours_orientation UNIQUE (id, "type", seuil, sous_parcours, ordre);


--
-- TOC entry 5746 (class 2606 OID 2600084)
-- Dependencies: 4146 4146 4146 4146 4146
-- Name: uk_question_reponse_elements_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_elements_old
    ADD CONSTRAINT uk_question_reponse_elements_1 UNIQUE (question_reponse, question, reponse, pere);


--
-- TOC entry 5737 (class 2606 OID 2600086)
-- Dependencies: 4145 4145 4145 4145
-- Name: uk_question_reponse_elements_1_new; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_elements
    ADD CONSTRAINT uk_question_reponse_elements_1_new UNIQUE (question_reponse, question_reponse_element, pere);


--
-- TOC entry 5739 (class 2606 OID 2600088)
-- Dependencies: 4145 4145 4145 4145
-- Name: uk_question_reponse_elements_2_new; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_elements
    ADD CONSTRAINT uk_question_reponse_elements_2_new UNIQUE (question_reponse, question_reponse_element, pere);


--
-- TOC entry 5741 (class 2606 OID 2600090)
-- Dependencies: 4145 4145 4145
-- Name: uk_question_reponse_elements_3_new; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_elements
    ADD CONSTRAINT uk_question_reponse_elements_3_new UNIQUE (question_reponse, question_reponse_element);


--
-- TOC entry 5751 (class 2606 OID 2600092)
-- Dependencies: 4147 4147 4147 4147 4147
-- Name: uk_question_reponse_elements_old_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse_elements_older
    ADD CONSTRAINT uk_question_reponse_elements_old_1 UNIQUE (question_reponse, question, reponse, pere);


--
-- TOC entry 5837 (class 2606 OID 2600094)
-- Dependencies: 4188 4188 4188
-- Name: uk_serie_evaluations; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY serie_evaluations
    ADD CONSTRAINT uk_serie_evaluations UNIQUE (serie, pere);


--
-- TOC entry 5468 (class 2606 OID 2600096)
-- Dependencies: 4003 4003 4003
-- Name: uq_etape_forum_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY etape_forum
    ADD CONSTRAINT uq_etape_forum_1 UNIQUE (id, forum);


--
-- TOC entry 5484 (class 2606 OID 2600098)
-- Dependencies: 4009 4009 4009
-- Name: uq_evaluation_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY evaluation
    ADD CONSTRAINT uq_evaluation_1 UNIQUE (id, "type");


--
-- TOC entry 5725 (class 2606 OID 2600100)
-- Dependencies: 4140 4140
-- Name: uq_qsrc_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qsrc
    ADD CONSTRAINT uq_qsrc_1 UNIQUE (id);


--
-- TOC entry 5731 (class 2606 OID 2600102)
-- Dependencies: 4142 4142 4142
-- Name: uq_question_reponse_1; Type: CONSTRAINT; Schema: contraintes; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY question_reponse
    ADD CONSTRAINT uq_question_reponse_1 UNIQUE (id, "type");


SET search_path = public, pg_catalog;

--
-- TOC entry 5889 (class 2606 OID 2600104)
-- Dependencies: 4236 4236
-- Name: CORRECTION_MODELE_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY correction_modele
    ADD CONSTRAINT "CORRECTION_MODELE_pkey" PRIMARY KEY (id);


--
-- TOC entry 5853 (class 2606 OID 2600106)
-- Dependencies: 4198 4198 4198
-- Name: active_sessions_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY active_sessions
    ADD CONSTRAINT active_sessions_pkey PRIMARY KEY (sid, name);


--
-- TOC entry 5857 (class 2606 OID 2600108)
-- Dependencies: 4199 4199 4199 4199
-- Name: active_sessions_split_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY active_sessions_split
    ADD CONSTRAINT active_sessions_split_pkey PRIMARY KEY (ct_sid, ct_name, ct_pos);


--
-- TOC entry 5864 (class 2606 OID 2600110)
-- Dependencies: 4209 4209 4209
-- Name: asso_test_reponse_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY asso_test_reponse
    ADD CONSTRAINT asso_test_reponse_pkey PRIMARY KEY (id_reponse, id_test);


--
-- TOC entry 5872 (class 2606 OID 2600112)
-- Dependencies: 4212 4212
-- Name: auth_user_md5_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY auth_user_md5
    ADD CONSTRAINT auth_user_md5_pkey PRIMARY KEY (user_id);


--
-- TOC entry 5868 (class 2606 OID 2600114)
-- Dependencies: 4211 4211
-- Name: auth_user_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY auth_user
    ADD CONSTRAINT auth_user_pkey PRIMARY KEY (user_id);


--
-- TOC entry 5884 (class 2606 OID 2600116)
-- Dependencies: 4224 4224
-- Name: classe_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY classe
    ADD CONSTRAINT classe_pkey PRIMARY KEY (id);


--
-- TOC entry 5886 (class 2606 OID 2600118)
-- Dependencies: 4229 4229
-- Name: commentuserrub_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY commentuserrub
    ADD CONSTRAINT commentuserrub_pkey PRIMARY KEY (num_comment);


--
-- TOC entry 5893 (class 2606 OID 2600120)
-- Dependencies: 4241 4241
-- Name: droit_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY droit
    ADD CONSTRAINT droit_pkey PRIMARY KEY (num_droit);


--
-- TOC entry 5899 (class 2606 OID 2600122)
-- Dependencies: 4249 4249
-- Name: filiere_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY filiere
    ADD CONSTRAINT filiere_pkey PRIMARY KEY (id);


--
-- TOC entry 5901 (class 2606 OID 2600124)
-- Dependencies: 4253 4253
-- Name: gest_ftb_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY gest_ftb
    ADD CONSTRAINT gest_ftb_pkey PRIMARY KEY (id);


--
-- TOC entry 5906 (class 2606 OID 2600126)
-- Dependencies: 4269 4269
-- Name: intervention_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY intervention
    ADD CONSTRAINT intervention_pkey PRIMARY KEY (id);


--
-- TOC entry 5908 (class 2606 OID 2600128)
-- Dependencies: 4272 4272
-- Name: liste_test_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY liste_test
    ADD CONSTRAINT liste_test_pkey PRIMARY KEY (id_liste_test);


--
-- TOC entry 5910 (class 2606 OID 2600130)
-- Dependencies: 4278 4278 4278 4278
-- Name: niveau_exo_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY niveau_exo
    ADD CONSTRAINT niveau_exo_pkey PRIMARY KEY (num_theme, num_exo, type_exo);


--
-- TOC entry 5915 (class 2606 OID 2600132)
-- Dependencies: 4284 4284
-- Name: pga_diagrams_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY pga_diagrams
    ADD CONSTRAINT pga_diagrams_pkey PRIMARY KEY (diagramname);


--
-- TOC entry 5917 (class 2606 OID 2600134)
-- Dependencies: 4286 4286
-- Name: pga_graphs_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY pga_graphs
    ADD CONSTRAINT pga_graphs_pkey PRIMARY KEY (graphname);


--
-- TOC entry 5919 (class 2606 OID 2600136)
-- Dependencies: 4287 4287
-- Name: pga_images_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY pga_images
    ADD CONSTRAINT pga_images_pkey PRIMARY KEY (imagename);


--
-- TOC entry 5866 (class 2606 OID 2600138)
-- Dependencies: 4210 4210
-- Name: pkffdfd; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY atest
    ADD CONSTRAINT pkffdfd PRIMARY KEY (num_text);


--
-- TOC entry 5921 (class 2606 OID 2600140)
-- Dependencies: 4293 4293
-- Name: placegroupe_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY placegroupe
    ADD CONSTRAINT placegroupe_pkey PRIMARY KEY (num_gest_groupe);


--
-- TOC entry 5926 (class 2606 OID 2600142)
-- Dependencies: 4306 4306 4306 4306
-- Name: res_liste_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY res_liste
    ADD CONSTRAINT res_liste_pkey PRIMARY KEY (id_formation, id_liste, id_stag);


--
-- TOC entry 5928 (class 2606 OID 2600144)
-- Dependencies: 4307 4307 4307 4307 4307 4307 4307
-- Name: res_liste_test_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY res_liste_test
    ADD CONSTRAINT res_liste_test_pkey PRIMARY KEY (id_formation, id_liste, id_stag, ordre_etape, question, reponse);


--
-- TOC entry 5932 (class 2606 OID 2600146)
-- Dependencies: 4309 4309 4309 4309 4309
-- Name: res_serie_exo_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY res_serie_exo
    ADD CONSTRAINT res_serie_exo_pkey PRIMARY KEY (id_formation, id_serie, id_stag, ordre_etape);


--
-- TOC entry 5930 (class 2606 OID 2600148)
-- Dependencies: 4308 4308 4308 4308
-- Name: res_serie_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY res_serie
    ADD CONSTRAINT res_serie_pkey PRIMARY KEY (id_formation, id_serie, id_stag);


--
-- TOC entry 5934 (class 2606 OID 2600150)
-- Dependencies: 4310 4310
-- Name: resexouser_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY resexouser
    ADD CONSTRAINT resexouser_pkey PRIMARY KEY (num_resexouser);


--
-- TOC entry 5942 (class 2606 OID 2600152)
-- Dependencies: 4316 4316
-- Name: ressource_txt_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY ressource_txt
    ADD CONSTRAINT ressource_txt_pkey PRIMARY KEY (num_text);


--
-- TOC entry 5946 (class 2606 OID 2600154)
-- Dependencies: 4328 4328
-- Name: scorm_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY scorm
    ADD CONSTRAINT scorm_pkey PRIMARY KEY (id);


--
-- TOC entry 5948 (class 2606 OID 2600156)
-- Dependencies: 4330 4330
-- Name: scorm_sco_users_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY scorm_sco_users
    ADD CONSTRAINT scorm_sco_users_pkey PRIMARY KEY (id);


--
-- TOC entry 5950 (class 2606 OID 2600158)
-- Dependencies: 4332 4332
-- Name: scorm_scoes_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY scorm_scoes
    ADD CONSTRAINT scorm_scoes_pkey PRIMARY KEY (id);


--
-- TOC entry 5952 (class 2606 OID 2600160)
-- Dependencies: 4389 4389
-- Name: serie_ftb_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY serie_exo
    ADD CONSTRAINT serie_ftb_pkey PRIMARY KEY (id);


--
-- TOC entry 5955 (class 2606 OID 2600162)
-- Dependencies: 4395 4395
-- Name: test_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY test
    ADD CONSTRAINT test_pkey PRIMARY KEY (id_test);


--
-- TOC entry 5957 (class 2606 OID 2600164)
-- Dependencies: 4396 4396 4396 4396 4396 4396 4396
-- Name: test_quest_rep_pkey; Type: CONSTRAINT; Schema: public; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY test_quest_rep
    ADD CONSTRAINT test_quest_rep_pkey PRIMARY KEY (id_exercice, id_question, id_reponse, id_test, type_exercice, ordre);


SET search_path = v2, pg_catalog;

--
-- TOC entry 6044 (class 2606 OID 2600166)
-- Dependencies: 4465 4465
-- Name: pk_alerte; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY lrt_alerte
    ADD CONSTRAINT pk_alerte PRIMARY KEY (id);


--
-- TOC entry 6319 (class 2606 OID 2600168)
-- Dependencies: 4594 4594
-- Name: pk_bareme; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vltn_bareme
    ADD CONSTRAINT pk_bareme PRIMARY KEY (id);


--
-- TOC entry 6333 (class 2606 OID 2600170)
-- Dependencies: 4602 4602 4602
-- Name: pk_calendrier; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vnmnt_evenement
    ADD CONSTRAINT pk_calendrier PRIMARY KEY (formation, date);


--
-- TOC entry 6022 (class 2606 OID 2600172)
-- Dependencies: 4450 4450
-- Name: pk_capacite; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_capacite
    ADD CONSTRAINT pk_capacite PRIMARY KEY (id);


--
-- TOC entry 6024 (class 2606 OID 2600174)
-- Dependencies: 4452 4452
-- Name: pk_capacite_titre; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_capacite_titre
    ADD CONSTRAINT pk_capacite_titre PRIMARY KEY (id);


--
-- TOC entry 6026 (class 2606 OID 2600176)
-- Dependencies: 4453 4453 4453
-- Name: pk_capacite_titre_capacites; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_capacite_titre_capacites
    ADD CONSTRAINT pk_capacite_titre_capacites PRIMARY KEY (capacite_titre, capacite);


--
-- TOC entry 6028 (class 2606 OID 2600178)
-- Dependencies: 4455 4455
-- Name: pk_carton; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_carton
    ADD CONSTRAINT pk_carton PRIMARY KEY (id);


--
-- TOC entry 6281 (class 2606 OID 2600180)
-- Dependencies: 4575 4575
-- Name: pk_categorie; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY thm_categorie
    ADD CONSTRAINT pk_categorie PRIMARY KEY (id);


--
-- TOC entry 6030 (class 2606 OID 2600182)
-- Dependencies: 4456 4456
-- Name: pk_categorie_capacite; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_categorie_capacite
    ADD CONSTRAINT pk_categorie_capacite PRIMARY KEY (id);


--
-- TOC entry 6032 (class 2606 OID 2600184)
-- Dependencies: 4457 4457
-- Name: pk_categorie_capacite_titre; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_categorie_capacite_titre
    ADD CONSTRAINT pk_categorie_capacite_titre PRIMARY KEY (id);


--
-- TOC entry 6343 (class 2606 OID 2600186)
-- Dependencies: 4609 4609
-- Name: pk_categorie_critere; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_categorie_critere
    ADD CONSTRAINT pk_categorie_critere PRIMARY KEY (id);


--
-- TOC entry 6202 (class 2606 OID 2600188)
-- Dependencies: 4540 4540
-- Name: pk_categorie_css; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scnr_categorie_fichier_css
    ADD CONSTRAINT pk_categorie_css PRIMARY KEY (id);


--
-- TOC entry 6287 (class 2606 OID 2600190)
-- Dependencies: 4579 4579 4579 4579
-- Name: pk_categorie_etape; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tp_categorie_etape
    ADD CONSTRAINT pk_categorie_etape PRIMARY KEY (id, theme, categorie);


--
-- TOC entry 6321 (class 2606 OID 2600192)
-- Dependencies: 4595 4595
-- Name: pk_categorie_evaluation; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vltn_categorie_evaluation
    ADD CONSTRAINT pk_categorie_evaluation PRIMARY KEY (id);


--
-- TOC entry 6345 (class 2606 OID 2600194)
-- Dependencies: 4610 4610
-- Name: pk_categorie_exotlc; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_categorie_exotlc
    ADD CONSTRAINT pk_categorie_exotlc PRIMARY KEY (id);


--
-- TOC entry 6347 (class 2606 OID 2600196)
-- Dependencies: 4611 4611
-- Name: pk_categorie_fichier_correction; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_categorie_fichier_correction
    ADD CONSTRAINT pk_categorie_fichier_correction PRIMARY KEY (id);


--
-- TOC entry 6349 (class 2606 OID 2600198)
-- Dependencies: 4612 4612
-- Name: pk_categorie_fichier_exotlc; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_categorie_fichier_exotlc
    ADD CONSTRAINT pk_categorie_fichier_exotlc PRIMARY KEY (id);


--
-- TOC entry 6167 (class 2606 OID 2600200)
-- Dependencies: 4523 4523
-- Name: pk_categorie_fichier_ressource; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_categorie_fichier_ressource
    ADD CONSTRAINT pk_categorie_fichier_ressource PRIMARY KEY (id);


--
-- TOC entry 6170 (class 2606 OID 2600202)
-- Dependencies: 4524 4524
-- Name: pk_categorie_fichier_ressource_fichier; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_categorie_fichier_ressource_fichier
    ADD CONSTRAINT pk_categorie_fichier_ressource_fichier PRIMARY KEY (id);


--
-- TOC entry 6207 (class 2606 OID 2600204)
-- Dependencies: 4542 4542
-- Name: pk_categorie_fichier_scenario; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scnr_categorie_fichier_scenario
    ADD CONSTRAINT pk_categorie_fichier_scenario PRIMARY KEY (id);


--
-- TOC entry 6172 (class 2606 OID 2600206)
-- Dependencies: 4525 4525
-- Name: pk_categorie_fichier_texte; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_categorie_fichier_ressource_texte
    ADD CONSTRAINT pk_categorie_fichier_texte PRIMARY KEY (id);


--
-- TOC entry 5970 (class 2606 OID 2600208)
-- Dependencies: 4414 4414
-- Name: pk_categorie_ftb; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fb_categorie_ftb
    ADD CONSTRAINT pk_categorie_ftb PRIMARY KEY (id);


--
-- TOC entry 6034 (class 2606 OID 2600210)
-- Dependencies: 4458 4458
-- Name: pk_categorie_grille; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_categorie_grille
    ADD CONSTRAINT pk_categorie_grille PRIMARY KEY (id);


--
-- TOC entry 6204 (class 2606 OID 2600212)
-- Dependencies: 4541 4541 4541
-- Name: pk_categorie_media; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scnr_categorie_fichier_media_scenario
    ADD CONSTRAINT pk_categorie_media PRIMARY KEY (id, theme);


--
-- TOC entry 6323 (class 2606 OID 2600214)
-- Dependencies: 4596 4596 4596
-- Name: pk_categorie_media_evaluation; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vltn_categorie_fichier_media_evaluation
    ADD CONSTRAINT pk_categorie_media_evaluation PRIMARY KEY (id, theme);


--
-- TOC entry 6351 (class 2606 OID 2600216)
-- Dependencies: 4613 4613 4613
-- Name: pk_categorie_media_exotlc; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_categorie_fichier_media_exotlc
    ADD CONSTRAINT pk_categorie_media_exotlc PRIMARY KEY (id, theme);


--
-- TOC entry 6353 (class 2606 OID 2600218)
-- Dependencies: 4614 4614
-- Name: pk_categorie_modele_correction; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_categorie_modele_correction
    ADD CONSTRAINT pk_categorie_modele_correction PRIMARY KEY (id);


--
-- TOC entry 6089 (class 2606 OID 2600220)
-- Dependencies: 4492 4492
-- Name: pk_categorie_positionnement; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_categorie_positionnement
    ADD CONSTRAINT pk_categorie_positionnement PRIMARY KEY (id);


--
-- TOC entry 6132 (class 2606 OID 2600222)
-- Dependencies: 4506 4506
-- Name: pk_categorie_qcm_element; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_categorie_question_reponse_element
    ADD CONSTRAINT pk_categorie_qcm_element PRIMARY KEY (id);


--
-- TOC entry 6124 (class 2606 OID 2600224)
-- Dependencies: 4503 4503
-- Name: pk_categorie_qsrc; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qc_categorie_qsrc
    ADD CONSTRAINT pk_categorie_qsrc PRIMARY KEY (id);


--
-- TOC entry 6130 (class 2606 OID 2600226)
-- Dependencies: 4505 4505
-- Name: pk_categorie_question_reponse; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_categorie_question_reponse
    ADD CONSTRAINT pk_categorie_question_reponse PRIMARY KEY (id);


--
-- TOC entry 6165 (class 2606 OID 2600228)
-- Dependencies: 4522 4522
-- Name: pk_categorie_ressource; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_categorie_etape_ressource
    ADD CONSTRAINT pk_categorie_ressource PRIMARY KEY (id);


--
-- TOC entry 6209 (class 2606 OID 2600230)
-- Dependencies: 4543 4543
-- Name: pk_categorie_scenario; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scnr_categorie_scenario
    ADD CONSTRAINT pk_categorie_scenario PRIMARY KEY (id);


--
-- TOC entry 6222 (class 2606 OID 2600232)
-- Dependencies: 4548 4548
-- Name: pk_categorie_scorm; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scrm_categorie_fichier_etape_scorm
    ADD CONSTRAINT pk_categorie_scorm PRIMARY KEY (id);


--
-- TOC entry 6248 (class 2606 OID 2600234)
-- Dependencies: 4560 4560 4560
-- Name: pk_categorie_serie; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sr_categorie_serie
    ADD CONSTRAINT pk_categorie_serie PRIMARY KEY (id, theme);


--
-- TOC entry 6134 (class 2606 OID 2600236)
-- Dependencies: 4507 4507
-- Name: pk_categorie_sondage_element; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_categorie_sondage_element
    ADD CONSTRAINT pk_categorie_sondage_element PRIMARY KEY (id);


--
-- TOC entry 6311 (class 2606 OID 2600238)
-- Dependencies: 4588 4588
-- Name: pk_categorie_test; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tst_categorie_test
    ADD CONSTRAINT pk_categorie_test PRIMARY KEY (id);


--
-- TOC entry 5963 (class 2606 OID 2600240)
-- Dependencies: 4405 4405
-- Name: pk_chat; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY c_etape_chat
    ADD CONSTRAINT pk_chat PRIMARY KEY (id);


--
-- TOC entry 6094 (class 2606 OID 2600242)
-- Dependencies: 4493 4493
-- Name: pk_choix; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_choix
    ADD CONSTRAINT pk_choix PRIMARY KEY (id);


--
-- TOC entry 5966 (class 2606 OID 2600244)
-- Dependencies: 4410 4410
-- Name: pk_classe; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY cls_classe
    ADD CONSTRAINT pk_classe PRIMARY KEY (id);


--
-- TOC entry 5968 (class 2606 OID 2600246)
-- Dependencies: 4411 4411 4411
-- Name: pk_classe_individus; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY cls_classe_individus
    ADD CONSTRAINT pk_classe_individus PRIMARY KEY (classe, individu);


--
-- TOC entry 6290 (class 2606 OID 2600248)
-- Dependencies: 4580 4580 4580 4580
-- Name: pk_commentaire_etape; Type: CONSTRAINT; Schema: v2; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY tp_commentaire_etape
    ADD CONSTRAINT pk_commentaire_etape PRIMARY KEY (etape, min, max);


--
-- TOC entry 6010 (class 2606 OID 2600250)
-- Dependencies: 4440 4440 4440
-- Name: pk_connexion; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_connexion
    ADD CONSTRAINT pk_connexion PRIMARY KEY (individu, connexion);


--
-- TOC entry 6355 (class 2606 OID 2600252)
-- Dependencies: 4616 4616
-- Name: pk_critere; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_critere
    ADD CONSTRAINT pk_critere PRIMARY KEY (id);


--
-- TOC entry 6012 (class 2606 OID 2600254)
-- Dependencies: 4441 4441
-- Name: pk_droit; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_droit
    ADD CONSTRAINT pk_droit PRIMARY KEY (id);


--
-- TOC entry 5999 (class 2606 OID 2600256)
-- Dependencies: 4435 4435 4435
-- Name: pk_droits_formateur; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frmtn_formateur_droits
    ADD CONSTRAINT pk_droits_formateur PRIMARY KEY (formation, droit);


--
-- TOC entry 6174 (class 2606 OID 2600258)
-- Dependencies: 4527 4527
-- Name: pk_espace; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_espace
    ADD CONSTRAINT pk_espace PRIMARY KEY (id);


--
-- TOC entry 6293 (class 2606 OID 2600260)
-- Dependencies: 4582 4582
-- Name: pk_etape; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tp_etape
    ADD CONSTRAINT pk_etape PRIMARY KEY (id);


--
-- TOC entry 5985 (class 2606 OID 2600262)
-- Dependencies: 4426 4426
-- Name: pk_etape_forum; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frm_etape_forum
    ADD CONSTRAINT pk_etape_forum PRIMARY KEY (id);


--
-- TOC entry 6178 (class 2606 OID 2600264)
-- Dependencies: 4528 4528
-- Name: pk_etape_ressource; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_etape_ressource
    ADD CONSTRAINT pk_etape_ressource PRIMARY KEY (id);


--
-- TOC entry 6224 (class 2606 OID 2600266)
-- Dependencies: 4549 4549
-- Name: pk_etape_scorm; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scrm_etape_scorm
    ADD CONSTRAINT pk_etape_scorm PRIMARY KEY (id);


--
-- TOC entry 6296 (class 2606 OID 2600268)
-- Dependencies: 4583 4583
-- Name: pk_etape_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tp_etape_type
    ADD CONSTRAINT pk_etape_type PRIMARY KEY (id);


--
-- TOC entry 6325 (class 2606 OID 2600270)
-- Dependencies: 4598 4598
-- Name: pk_evaluation; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vltn_evaluation
    ADD CONSTRAINT pk_evaluation PRIMARY KEY (id);


--
-- TOC entry 6329 (class 2606 OID 2600272)
-- Dependencies: 4600 4600
-- Name: pk_evaluation_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vltn_evaluation_type
    ADD CONSTRAINT pk_evaluation_type PRIMARY KEY (id);


--
-- TOC entry 6335 (class 2606 OID 2600274)
-- Dependencies: 4603 4603 4603
-- Name: pk_evenement_presentiel; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vnmnt_evenement_presentiel
    ADD CONSTRAINT pk_evenement_presentiel PRIMARY KEY (formation, date);


--
-- TOC entry 6357 (class 2606 OID 2600276)
-- Dependencies: 4617 4617
-- Name: pk_exotlc; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_exotlc
    ADD CONSTRAINT pk_exotlc PRIMARY KEY (id);


--
-- TOC entry 6359 (class 2606 OID 2600278)
-- Dependencies: 4618 4618 4618
-- Name: pk_exotlc_corrections; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_exotlc_corrections
    ADD CONSTRAINT pk_exotlc_corrections PRIMARY KEY (exotlc, correction);


--
-- TOC entry 6361 (class 2606 OID 2600280)
-- Dependencies: 4619 4619 4619
-- Name: pk_exotlc_fichiers; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_exotlc_fichiers
    ADD CONSTRAINT pk_exotlc_fichiers PRIMARY KEY (exotlc, fichier);


--
-- TOC entry 6363 (class 2606 OID 2600282)
-- Dependencies: 4620 4620
-- Name: pk_exotlc_mail; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_exotlc_mail
    ADD CONSTRAINT pk_exotlc_mail PRIMARY KEY (id);


--
-- TOC entry 6365 (class 2606 OID 2600284)
-- Dependencies: 4621 4621
-- Name: pk_exotlc_plate_forme; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_exotlc_plate_forme
    ADD CONSTRAINT pk_exotlc_plate_forme PRIMARY KEY (id);


--
-- TOC entry 6367 (class 2606 OID 2600286)
-- Dependencies: 4623 4623
-- Name: pk_exotlc_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_exotlc_type
    ADD CONSTRAINT pk_exotlc_type PRIMARY KEY (id);


--
-- TOC entry 5976 (class 2606 OID 2600288)
-- Dependencies: 4418 4418
-- Name: pk_fichier; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fchr_fichier
    ADD CONSTRAINT pk_fichier PRIMARY KEY (id);


--
-- TOC entry 5978 (class 2606 OID 2600290)
-- Dependencies: 4419 4419
-- Name: pk_fichier_correction; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fchr_fichier_correction
    ADD CONSTRAINT pk_fichier_correction PRIMARY KEY (id);


--
-- TOC entry 6211 (class 2606 OID 2600292)
-- Dependencies: 4544 4544
-- Name: pk_fichier_css; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scnr_fichier_css
    ADD CONSTRAINT pk_fichier_css PRIMARY KEY (id);


--
-- TOC entry 6369 (class 2606 OID 2600294)
-- Dependencies: 4624 4624
-- Name: pk_fichier_exotlc; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_fichier_exotlc
    ADD CONSTRAINT pk_fichier_exotlc PRIMARY KEY (id);


--
-- TOC entry 6180 (class 2606 OID 2600296)
-- Dependencies: 4529 4529
-- Name: pk_fichier_icone; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_fichier_icone
    ADD CONSTRAINT pk_fichier_icone PRIMARY KEY (id);


--
-- TOC entry 6213 (class 2606 OID 2600298)
-- Dependencies: 4545 4545
-- Name: pk_fichier_media; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scnr_fichier_media_scenario
    ADD CONSTRAINT pk_fichier_media PRIMARY KEY (id);


--
-- TOC entry 6331 (class 2606 OID 2600300)
-- Dependencies: 4601 4601
-- Name: pk_fichier_media_evaluation; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vltn_fichier_media_evaluation
    ADD CONSTRAINT pk_fichier_media_evaluation PRIMARY KEY (id);


--
-- TOC entry 6371 (class 2606 OID 2600302)
-- Dependencies: 4625 4625
-- Name: pk_fichier_media_exotlc; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_fichier_media_exotlc
    ADD CONSTRAINT pk_fichier_media_exotlc PRIMARY KEY (id);


--
-- TOC entry 6058 (class 2606 OID 2600304)
-- Dependencies: 4472 4472
-- Name: pk_fichier_photo; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ndvd_fichier_photo
    ADD CONSTRAINT pk_fichier_photo PRIMARY KEY (id);


--
-- TOC entry 6182 (class 2606 OID 2600306)
-- Dependencies: 4530 4530
-- Name: pk_fichier_ressource; Type: CONSTRAINT; Schema: v2; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY rssrc_fichier_ressource
    ADD CONSTRAINT pk_fichier_ressource PRIMARY KEY (id);


--
-- TOC entry 6184 (class 2606 OID 2600308)
-- Dependencies: 4531 4531
-- Name: pk_fichier_ressource_fichier; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_fichier_ressource_fichier
    ADD CONSTRAINT pk_fichier_ressource_fichier PRIMARY KEY (id);


--
-- TOC entry 6186 (class 2606 OID 2600310)
-- Dependencies: 4532 4532
-- Name: pk_fichier_ressource_texte; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_fichier_ressource_texte
    ADD CONSTRAINT pk_fichier_ressource_texte PRIMARY KEY (id);


--
-- TOC entry 6216 (class 2606 OID 2600312)
-- Dependencies: 4546 4546
-- Name: pk_fichier_scenario; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scnr_fichier_scenario
    ADD CONSTRAINT pk_fichier_scenario PRIMARY KEY (id);


--
-- TOC entry 6227 (class 2606 OID 2600314)
-- Dependencies: 4550 4550
-- Name: pk_fichier_scorm; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scrm_fichier_etape_scorm
    ADD CONSTRAINT pk_fichier_scorm PRIMARY KEY (id);


--
-- TOC entry 5980 (class 2606 OID 2600316)
-- Dependencies: 4421 4421
-- Name: pk_fichier_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fchr_fichier_type
    ADD CONSTRAINT pk_fichier_type PRIMARY KEY (id);


--
-- TOC entry 5982 (class 2606 OID 2600318)
-- Dependencies: 4423 4423
-- Name: pk_filiere; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY flr_filiere
    ADD CONSTRAINT pk_filiere PRIMARY KEY (id);


--
-- TOC entry 6001 (class 2606 OID 2600320)
-- Dependencies: 4437 4437
-- Name: pk_formation; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frmtn_formation
    ADD CONSTRAINT pk_formation PRIMARY KEY (id);


--
-- TOC entry 5989 (class 2606 OID 2600322)
-- Dependencies: 4427 4427 4427
-- Name: pk_formation_forums; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frm_formation_forums
    ADD CONSTRAINT pk_formation_forums PRIMARY KEY (formation, forum);


--
-- TOC entry 6003 (class 2606 OID 2600324)
-- Dependencies: 4438 4438 4438
-- Name: pk_formation_langues; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frmtn_formation_langues
    ADD CONSTRAINT pk_formation_langues PRIMARY KEY (formation, langue);


--
-- TOC entry 6006 (class 2606 OID 2600326)
-- Dependencies: 4439 4439 4439
-- Name: pk_formation_participants; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frmtn_formation_participants
    ADD CONSTRAINT pk_formation_participants PRIMARY KEY (formation, classe);


--
-- TOC entry 6190 (class 2606 OID 2600328)
-- Dependencies: 4533 4533 4533
-- Name: pk_formation_ressources; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_formation_ressources
    ADD CONSTRAINT pk_formation_ressources PRIMARY KEY (formation, ressource);


--
-- TOC entry 5991 (class 2606 OID 2600330)
-- Dependencies: 4429 4429
-- Name: pk_forum; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frm_forum
    ADD CONSTRAINT pk_forum PRIMARY KEY (id);


--
-- TOC entry 5993 (class 2606 OID 2600332)
-- Dependencies: 4431 4431
-- Name: pk_forum_environnement; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frm_forum_environnement
    ADD CONSTRAINT pk_forum_environnement PRIMARY KEY (id);


--
-- TOC entry 5995 (class 2606 OID 2600334)
-- Dependencies: 4432 4432
-- Name: pk_forum_environnements; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frm_forum_environnements
    ADD CONSTRAINT pk_forum_environnements PRIMARY KEY (forum);


--
-- TOC entry 5972 (class 2606 OID 2600336)
-- Dependencies: 4415 4415
-- Name: pk_ftb; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fb_ftb
    ADD CONSTRAINT pk_ftb PRIMARY KEY (id);


--
-- TOC entry 6036 (class 2606 OID 2600338)
-- Dependencies: 4460 4460
-- Name: pk_grille; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_grille
    ADD CONSTRAINT pk_grille PRIMARY KEY (id);


--
-- TOC entry 6038 (class 2606 OID 2600340)
-- Dependencies: 4461 4461 4461
-- Name: pk_grille_capacites_titres; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_grille_capacites_titres
    ADD CONSTRAINT pk_grille_capacites_titres PRIMARY KEY (grille, capacite_titre);


--
-- TOC entry 6040 (class 2606 OID 2600342)
-- Dependencies: 4462 4462 4462 4462 4462 4462 4462
-- Name: pk_grille_resultats; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_grille_resultats
    ADD CONSTRAINT pk_grille_resultats PRIMARY KEY (formation, stagiaire, grille, capacite_titre, capacite, date);


--
-- TOC entry 6060 (class 2606 OID 2600344)
-- Dependencies: 4474 4474
-- Name: pk_individu; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ndvd_individu
    ADD CONSTRAINT pk_individu PRIMARY KEY (id);


--
-- TOC entry 6064 (class 2606 OID 2600346)
-- Dependencies: 4475 4475 4475 4475
-- Name: pk_individu_droits; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ndvd_individu_droits
    ADD CONSTRAINT pk_individu_droits PRIMARY KEY (individu, droit, classe);


--
-- TOC entry 6068 (class 2606 OID 2600348)
-- Dependencies: 4478 4478 4478
-- Name: pk_individu_types; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ndvd_individu_types
    ADD CONSTRAINT pk_individu_types PRIMARY KEY ("type", individu);


--
-- TOC entry 6337 (class 2606 OID 2600350)
-- Dependencies: 4605 4605
-- Name: pk_intervention; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vnmnt_intervention
    ADD CONSTRAINT pk_intervention PRIMARY KEY (id);


--
-- TOC entry 6014 (class 2606 OID 2600352)
-- Dependencies: 4443 4443
-- Name: pk_langue; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_langue
    ADD CONSTRAINT pk_langue PRIMARY KEY (id);


--
-- TOC entry 6016 (class 2606 OID 2600354)
-- Dependencies: 4445 4445 4445 4445
-- Name: pk_langue_messages; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_langue_message
    ADD CONSTRAINT pk_langue_messages PRIMARY KEY (id, "type", langue);


--
-- TOC entry 6018 (class 2606 OID 2600356)
-- Dependencies: 4447 4447
-- Name: pk_langue_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_langue_type
    ADD CONSTRAINT pk_langue_type PRIMARY KEY (id);


--
-- TOC entry 6048 (class 2606 OID 2600358)
-- Dependencies: 4466 4466
-- Name: pk_liste; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY lst_liste
    ADD CONSTRAINT pk_liste PRIMARY KEY (id);


--
-- TOC entry 6050 (class 2606 OID 2600360)
-- Dependencies: 4468 4468
-- Name: pk_liste_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY lst_liste_type
    ADD CONSTRAINT pk_liste_type PRIMARY KEY (id);


--
-- TOC entry 6056 (class 2606 OID 2600362)
-- Dependencies: 4471 4471
-- Name: pk_media; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY md_media
    ADD CONSTRAINT pk_media PRIMARY KEY (id);


--
-- TOC entry 6136 (class 2606 OID 2600364)
-- Dependencies: 4508 4508
-- Name: pk_media_question_reponse; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_media_question_reponse
    ADD CONSTRAINT pk_media_question_reponse PRIMARY KEY (question_reponse);


--
-- TOC entry 6138 (class 2606 OID 2600366)
-- Dependencies: 4509 4509 4509
-- Name: pk_media_question_reponse_element; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_media_question_reponse_element
    ADD CONSTRAINT pk_media_question_reponse_element PRIMARY KEY (question_reponse, question_reponse_element);


--
-- TOC entry 6313 (class 2606 OID 2600368)
-- Dependencies: 4589 4589 4589
-- Name: pk_media_test; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tst_media_test
    ADD CONSTRAINT pk_media_test PRIMARY KEY (test, media);


--
-- TOC entry 5997 (class 2606 OID 2600370)
-- Dependencies: 4434 4434
-- Name: pk_message; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frm_message
    ADD CONSTRAINT pk_message PRIMARY KEY (id);


--
-- TOC entry 6339 (class 2606 OID 2600372)
-- Dependencies: 4607 4607
-- Name: pk_modalite; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vnmnt_modalite
    ADD CONSTRAINT pk_modalite PRIMARY KEY (id);


--
-- TOC entry 6373 (class 2606 OID 2600374)
-- Dependencies: 4627 4627
-- Name: pk_modele_correction; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_modele_correction
    ADD CONSTRAINT pk_modele_correction PRIMARY KEY (id);


--
-- TOC entry 5336 (class 2606 OID 2600376)
-- Dependencies: 3928 3928 3928
-- Name: pk_modele_correction_criteres; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_modele_correction_criteres
    ADD CONSTRAINT pk_modele_correction_criteres PRIMARY KEY (modele_correction, critere);


--
-- TOC entry 6070 (class 2606 OID 2600378)
-- Dependencies: 4480 4480
-- Name: pk_organisme; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ndvd_organisme
    ADD CONSTRAINT pk_organisme PRIMARY KEY (id);


--
-- TOC entry 6072 (class 2606 OID 2600380)
-- Dependencies: 4482 4482
-- Name: pk_page; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pg_page
    ADD CONSTRAINT pk_page PRIMARY KEY (id);


--
-- TOC entry 6074 (class 2606 OID 2600382)
-- Dependencies: 4483 4483 4483 4483 4483
-- Name: pk_page_annuaire_configuration; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pg_page_annuaire_configuration
    ADD CONSTRAINT pk_page_annuaire_configuration PRIMARY KEY (page, formation, individu_type, page_element);


--
-- TOC entry 6076 (class 2606 OID 2600384)
-- Dependencies: 4484 4484 4484 4484
-- Name: pk_page_commentaire; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pg_page_commentaire
    ADD CONSTRAINT pk_page_commentaire PRIMARY KEY (page, formation, stagiaire);


--
-- TOC entry 6078 (class 2606 OID 2600386)
-- Dependencies: 4486 4486
-- Name: pk_page_element; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pg_page_element
    ADD CONSTRAINT pk_page_element PRIMARY KEY (id);


--
-- TOC entry 6080 (class 2606 OID 2600388)
-- Dependencies: 4487 4487 4487
-- Name: pk_page_elements; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pg_page_elements
    ADD CONSTRAINT pk_page_elements PRIMARY KEY (page, page_element);


--
-- TOC entry 6052 (class 2606 OID 2600390)
-- Dependencies: 4469 4469 4469 4469 4469
-- Name: pk_page_liste; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY lst_page_liste
    ADD CONSTRAINT pk_page_liste PRIMARY KEY (formation, parcours, liste, page);


--
-- TOC entry 6054 (class 2606 OID 2600392)
-- Dependencies: 4470 4470 4470 4470 4470 4470
-- Name: pk_page_liste_configuration; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY lst_page_liste_configuration
    ADD CONSTRAINT pk_page_liste_configuration PRIMARY KEY (page, parcours, formation, liste, page_element);


--
-- TOC entry 6194 (class 2606 OID 2600394)
-- Dependencies: 4534 4534 4534 4534 4534
-- Name: pk_page_ressource_configuration; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_page_ressource_configuration
    ADD CONSTRAINT pk_page_ressource_configuration PRIMARY KEY (page, formation, parcours, etape_ressource);


--
-- TOC entry 6082 (class 2606 OID 2600396)
-- Dependencies: 4489 4489
-- Name: pk_page_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pg_page_type
    ADD CONSTRAINT pk_page_type PRIMARY KEY (id);


--
-- TOC entry 6084 (class 2606 OID 2600398)
-- Dependencies: 4490 4490
-- Name: pk_parcours; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY prcrs_parcours
    ADD CONSTRAINT pk_parcours PRIMARY KEY (id);


--
-- TOC entry 6300 (class 2606 OID 2600400)
-- Dependencies: 4584 4584 4584
-- Name: pk_parcours_etapes; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tp_parcours_etapes
    ADD CONSTRAINT pk_parcours_etapes PRIMARY KEY (parcours, etape);


--
-- TOC entry 6114 (class 2606 OID 2600402)
-- Dependencies: 4500 4500
-- Name: pk_positionnement; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_positionnement_old
    ADD CONSTRAINT pk_positionnement PRIMARY KEY (id);


--
-- TOC entry 6098 (class 2606 OID 2600404)
-- Dependencies: 4495 4495
-- Name: pk_positionnement_1; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_positionnement
    ADD CONSTRAINT pk_positionnement_1 PRIMARY KEY (id);


--
-- TOC entry 6109 (class 2606 OID 2600406)
-- Dependencies: 4497 4497 4497 4497
-- Name: pk_positionnement_elements; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_positionnement_elements
    ADD CONSTRAINT pk_positionnement_elements PRIMARY KEY (question_reponse, question, choix);


--
-- TOC entry 6105 (class 2606 OID 2600408)
-- Dependencies: 4496 4496 4496 4496
-- Name: pk_positionnement_evaluations_generees; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_positionnement_choix_evaluations
    ADD CONSTRAINT pk_positionnement_evaluations_generees PRIMARY KEY (positionnement, "type", reponse);


--
-- TOC entry 6140 (class 2606 OID 2600410)
-- Dependencies: 4510 4510 4510 4510
-- Name: pk_qcm_elements; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_qcm_elements
    ADD CONSTRAINT pk_qcm_elements PRIMARY KEY (question_reponse, question, reponse);


--
-- TOC entry 6126 (class 2606 OID 2600412)
-- Dependencies: 4504 4504
-- Name: pk_qsrc; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qc_qsrc
    ADD CONSTRAINT pk_qsrc PRIMARY KEY (id);


--
-- TOC entry 6142 (class 2606 OID 2600414)
-- Dependencies: 4511 4511
-- Name: pk_question; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_question
    ADD CONSTRAINT pk_question PRIMARY KEY (id);


--
-- TOC entry 6144 (class 2606 OID 2600416)
-- Dependencies: 4512 4512
-- Name: pk_question_reponse; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_question_reponse
    ADD CONSTRAINT pk_question_reponse PRIMARY KEY (id);


--
-- TOC entry 6148 (class 2606 OID 2600418)
-- Dependencies: 4514 4514
-- Name: pk_question_reponse_element; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_question_reponse_element
    ADD CONSTRAINT pk_question_reponse_element PRIMARY KEY (id);


--
-- TOC entry 6151 (class 2606 OID 2600420)
-- Dependencies: 4515 4515 4515 4515
-- Name: pk_question_reponse_elements; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_question_reponse_elements
    ADD CONSTRAINT pk_question_reponse_elements PRIMARY KEY (question_reponse, question, reponse);


--
-- TOC entry 6155 (class 2606 OID 2600422)
-- Dependencies: 4517 4517
-- Name: pk_question_reponse_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_question_reponse_type
    ADD CONSTRAINT pk_question_reponse_type PRIMARY KEY (id);


--
-- TOC entry 6157 (class 2606 OID 2600424)
-- Dependencies: 4518 4518
-- Name: pk_reponse; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_reponse
    ADD CONSTRAINT pk_reponse PRIMARY KEY (id);


--
-- TOC entry 6197 (class 2606 OID 2600426)
-- Dependencies: 4536 4536
-- Name: pk_ressource; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_ressource
    ADD CONSTRAINT pk_ressource PRIMARY KEY (id);


--
-- TOC entry 6303 (class 2606 OID 2600428)
-- Dependencies: 4585 4585
-- Name: pk_resultat; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tp_resultat
    ADD CONSTRAINT pk_resultat PRIMARY KEY (id);


--
-- TOC entry 6376 (class 2606 OID 2600430)
-- Dependencies: 4628 4628
-- Name: pk_resultat_exotlc; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_resultat_exotlc
    ADD CONSTRAINT pk_resultat_exotlc PRIMARY KEY (id);


--
-- TOC entry 6378 (class 2606 OID 2600432)
-- Dependencies: 4629 4629 4629
-- Name: pk_resultat_exotlc_critere; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_resultat_exotlc_critere
    ADD CONSTRAINT pk_resultat_exotlc_critere PRIMARY KEY (id, critere);


--
-- TOC entry 6380 (class 2606 OID 2600434)
-- Dependencies: 4630 4630 4630
-- Name: pk_resultat_exotlc_sous_critere; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY xtlc_resultat_exotlc_sous_critere
    ADD CONSTRAINT pk_resultat_exotlc_sous_critere PRIMARY KEY (id, sous_critere);


--
-- TOC entry 6119 (class 2606 OID 2600436)
-- Dependencies: 4501 4501 4501 4501
-- Name: pk_resultat_positionnement; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_resultat_positionnement
    ADD CONSTRAINT pk_resultat_positionnement PRIMARY KEY (id, test, positionnement);


--
-- TOC entry 6122 (class 2606 OID 2600438)
-- Dependencies: 4502 4502 4502 4502 4502 4502
-- Name: pk_resultat_positionnement_question_reponse; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_resultat_positionnement_question_reponse
    ADD CONSTRAINT pk_resultat_positionnement_question_reponse PRIMARY KEY (id, test, question_reponse, question, choix);


--
-- TOC entry 6252 (class 2606 OID 2600440)
-- Dependencies: 4561 4561 4561
-- Name: pk_resultat_serie; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sr_resultat_serie
    ADD CONSTRAINT pk_resultat_serie PRIMARY KEY (id, evaluation);


--
-- TOC entry 6161 (class 2606 OID 2600442)
-- Dependencies: 4519 4519 4519 4519 4519
-- Name: pk_resultat_serie_question_reponse; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_resultat_serie_question_reponse
    ADD CONSTRAINT pk_resultat_serie_question_reponse PRIMARY KEY (id, question_reponse, question, reponse);


--
-- TOC entry 6255 (class 2606 OID 2600444)
-- Dependencies: 4562 4562 4562
-- Name: pk_resultat_serie_tentative; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sr_resultat_serie_tentative
    ADD CONSTRAINT pk_resultat_serie_tentative PRIMARY KEY (id, evaluation);


--
-- TOC entry 6163 (class 2606 OID 2600446)
-- Dependencies: 4520 4520 4520 4520 4520
-- Name: pk_resultat_serie_tentative_question_reponse; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_resultat_serie_tentative_question_reponse
    ADD CONSTRAINT pk_resultat_serie_tentative_question_reponse PRIMARY KEY (id, question_reponse, question, reponse);


--
-- TOC entry 6307 (class 2606 OID 2600448)
-- Dependencies: 4587 4587
-- Name: pk_resultat_tentative; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tp_resultat_tentative
    ADD CONSTRAINT pk_resultat_tentative PRIMARY KEY (id);


--
-- TOC entry 6341 (class 2606 OID 2600450)
-- Dependencies: 4608 4608
-- Name: pk_salle; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vnmnt_salle
    ADD CONSTRAINT pk_salle PRIMARY KEY (id);


--
-- TOC entry 6218 (class 2606 OID 2600452)
-- Dependencies: 4547 4547
-- Name: pk_scenario; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scnr_scenario
    ADD CONSTRAINT pk_scenario PRIMARY KEY (id);


--
-- TOC entry 6199 (class 2606 OID 2600454)
-- Dependencies: 4538 4538
-- Name: pk_section; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_section
    ADD CONSTRAINT pk_section PRIMARY KEY (id);


--
-- TOC entry 6257 (class 2606 OID 2600456)
-- Dependencies: 4564 4564
-- Name: pk_serie; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sr_serie
    ADD CONSTRAINT pk_serie PRIMARY KEY (id);


--
-- TOC entry 6268 (class 2606 OID 2600458)
-- Dependencies: 4567 4567
-- Name: pk_serie_aleatoire; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY srltr_serie_aleatoire
    ADD CONSTRAINT pk_serie_aleatoire PRIMARY KEY (id);


--
-- TOC entry 6270 (class 2606 OID 2600460)
-- Dependencies: 4568 4568 4568 4568 4568 4568
-- Name: pk_serie_aleatoire_evaluations; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY srltr_serie_aleatoire_evaluations
    ADD CONSTRAINT pk_serie_aleatoire_evaluations PRIMARY KEY (stagiaire, serie, evaluation, formation, parcours);


--
-- TOC entry 6274 (class 2606 OID 2600462)
-- Dependencies: 4571 4571 4571 4571
-- Name: pk_serie_aleatoire_melangee; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY srltrmlg_serie_aleatoire_melangee
    ADD CONSTRAINT pk_serie_aleatoire_melangee PRIMARY KEY (serie, formation, parcours);


--
-- TOC entry 6276 (class 2606 OID 2600464)
-- Dependencies: 4572 4572 4572 4572
-- Name: pk_serie_aleatoire_multiserie; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY srltrmltsr_serie_aleatoire_multiserie
    ADD CONSTRAINT pk_serie_aleatoire_multiserie PRIMARY KEY (serie, serie_source, type_evaluations);


--
-- TOC entry 6279 (class 2606 OID 2600466)
-- Dependencies: 4573 4573 4573 4573
-- Name: pk_serie_aleatoire_multitheme; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY srltrmltthm_serie_aleatoire_multitheme
    ADD CONSTRAINT pk_serie_aleatoire_multitheme PRIMARY KEY (serie, theme_source, type_evaluations);


--
-- TOC entry 6272 (class 2606 OID 2600468)
-- Dependencies: 4570 4570
-- Name: pk_serie_aleatoire_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY srltr_serie_aleatoire_type
    ADD CONSTRAINT pk_serie_aleatoire_type PRIMARY KEY (id);


--
-- TOC entry 6260 (class 2606 OID 2600470)
-- Dependencies: 4565 4565 4565 4565
-- Name: pk_serie_blocante; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sr_serie_bloquante
    ADD CONSTRAINT pk_serie_blocante PRIMARY KEY (serie, formation, parcours);


--
-- TOC entry 6264 (class 2606 OID 2600472)
-- Dependencies: 4566 4566 4566
-- Name: pk_serie_evaluations; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sr_serie_evaluations
    ADD CONSTRAINT pk_serie_evaluations PRIMARY KEY (serie, evaluation);


--
-- TOC entry 6020 (class 2606 OID 2600474)
-- Dependencies: 4448 4448
-- Name: pk_session; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY fw_session
    ADD CONSTRAINT pk_session PRIMARY KEY (individu);


--
-- TOC entry 6238 (class 2606 OID 2600476)
-- Dependencies: 4557 4557
-- Name: pk_snrdnmq_bloc_scenario; Type: CONSTRAINT; Schema: v2; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY snrdnmq_bloc_scenario
    ADD CONSTRAINT pk_snrdnmq_bloc_scenario PRIMARY KEY (id);


--
-- TOC entry 6042 (class 2606 OID 2600478)
-- Dependencies: 4463 4463 4463 4463
-- Name: pk_stagiaire_grille; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY grll_stagiaire_grille
    ADD CONSTRAINT pk_stagiaire_grille PRIMARY KEY (formation, stagiaire, grille);


--
-- TOC entry 6315 (class 2606 OID 2600480)
-- Dependencies: 4591 4591
-- Name: pk_test; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tst_test
    ADD CONSTRAINT pk_test PRIMARY KEY (id);


--
-- TOC entry 6317 (class 2606 OID 2600482)
-- Dependencies: 4592 4592 4592
-- Name: pk_test_positionnements; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tst_test_positionnements
    ADD CONSTRAINT pk_test_positionnements PRIMARY KEY (test, positionnement);


--
-- TOC entry 6283 (class 2606 OID 2600484)
-- Dependencies: 4577 4577
-- Name: pk_theme; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY thm_theme
    ADD CONSTRAINT pk_theme PRIMARY KEY (id);


--
-- TOC entry 6285 (class 2606 OID 2600486)
-- Dependencies: 4578 4578 4578 4578
-- Name: pk_theme_categories; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY thm_theme_categories
    ADD CONSTRAINT pk_theme_categories PRIMARY KEY (categorie, id, theme);


--
-- TOC entry 6066 (class 2606 OID 2600488)
-- Dependencies: 4477 4477
-- Name: pk_type_individu; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ndvd_individu_type
    ADD CONSTRAINT pk_type_individu PRIMARY KEY (id);


--
-- TOC entry 6229 (class 2606 OID 2600490)
-- Dependencies: 4552 4552
-- Name: scorm_pkey; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scrm_scorm
    ADD CONSTRAINT scorm_pkey PRIMARY KEY (id);


--
-- TOC entry 6232 (class 2606 OID 2600492)
-- Dependencies: 4554 4554
-- Name: scorm_sco_users_pkey; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scrm_scorm_sco_users
    ADD CONSTRAINT scorm_sco_users_pkey PRIMARY KEY (id);


--
-- TOC entry 6235 (class 2606 OID 2600494)
-- Dependencies: 4556 4556
-- Name: scorm_scoes_pkey; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scrm_scorm_scoes
    ADD CONSTRAINT scorm_scoes_pkey PRIMARY KEY (id);


--
-- TOC entry 6246 (class 2606 OID 2600496)
-- Dependencies: 4559 4559 4559 4559
-- Name: snrdnmq_scenario_dynamique_blocs_pkey; Type: CONSTRAINT; Schema: v2; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY snrdnmq_scenario_dynamique_blocs
    ADD CONSTRAINT snrdnmq_scenario_dynamique_blocs_pkey PRIMARY KEY (scenario_dynamique, bloc_scenario, pere);


--
-- TOC entry 6242 (class 2606 OID 2600498)
-- Dependencies: 4558 4558
-- Name: snrdnmq_scenario_dynamique_pkey; Type: CONSTRAINT; Schema: v2; Owner: pgsql; Tablespace: 
--

ALTER TABLE ONLY snrdnmq_scenario_dynamique
    ADD CONSTRAINT snrdnmq_scenario_dynamique_pkey PRIMARY KEY (id);


--
-- TOC entry 6096 (class 2606 OID 2600500)
-- Dependencies: 4493 4493 4493 4493
-- Name: u_choix; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_choix
    ADD CONSTRAINT u_choix UNIQUE (id, question_reponse, pere);


--
-- TOC entry 6298 (class 2606 OID 2600502)
-- Dependencies: 4583 4583
-- Name: u_etape_type; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tp_etape_type
    ADD CONSTRAINT u_etape_type UNIQUE (ordre);


--
-- TOC entry 6220 (class 2606 OID 2600504)
-- Dependencies: 4547 4547
-- Name: u_fichier_scenario; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY scnr_scenario
    ADD CONSTRAINT u_fichier_scenario UNIQUE (fichier);


--
-- TOC entry 6192 (class 2606 OID 2600506)
-- Dependencies: 4533 4533 4533 4533 4533
-- Name: u_formation_ressources; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY rssrc_formation_ressources
    ADD CONSTRAINT u_formation_ressources UNIQUE (formation, ressource, espace, section);


--
-- TOC entry 6062 (class 2606 OID 2600508)
-- Dependencies: 4474 4474
-- Name: u_individu; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY ndvd_individu
    ADD CONSTRAINT u_individu UNIQUE ("login");


--
-- TOC entry 10399 (class 0 OID 0)
-- Dependencies: 6062
-- Name: CONSTRAINT u_individu ON ndvd_individu; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON CONSTRAINT u_individu ON ndvd_individu IS 'Pour un login unique';


--
-- TOC entry 6100 (class 2606 OID 2600510)
-- Dependencies: 4495 4495 4495
-- Name: u_positionnement; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_positionnement
    ADD CONSTRAINT u_positionnement UNIQUE (id, qsrc);


--
-- TOC entry 6116 (class 2606 OID 2600512)
-- Dependencies: 4500 4500 4500
-- Name: u_positionnement_1; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_positionnement_old
    ADD CONSTRAINT u_positionnement_1 UNIQUE (id, question_reponse);


--
-- TOC entry 6112 (class 2606 OID 2600514)
-- Dependencies: 4498 4498 4498 4498 4498 4498
-- Name: u_positionnement_evaluations; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY pstnnmnt_positionnement_evaluations
    ADD CONSTRAINT u_positionnement_evaluations UNIQUE (question_reponse, question, choix, evaluation, pere);


--
-- TOC entry 6305 (class 2606 OID 2600516)
-- Dependencies: 4585 4585 4585 4585 4585
-- Name: u_resultat; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tp_resultat
    ADD CONSTRAINT u_resultat UNIQUE (formation, stagiaire, parcours, etape);


--
-- TOC entry 6309 (class 2606 OID 2600518)
-- Dependencies: 4587 4587 4587 4587 4587 4587
-- Name: u_resultat_tentative; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY tp_resultat_tentative
    ADD CONSTRAINT u_resultat_tentative UNIQUE (formation, stagiaire, parcours, etape, tentative);


--
-- TOC entry 6046 (class 2606 OID 2600520)
-- Dependencies: 4465 4465 4465
-- Name: uk_alerte; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY lrt_alerte
    ADD CONSTRAINT uk_alerte UNIQUE (formation, date);


--
-- TOC entry 6008 (class 2606 OID 2600522)
-- Dependencies: 4439 4439 4439
-- Name: uk_formation_participants; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frmtn_formation_participants
    ADD CONSTRAINT uk_formation_participants UNIQUE (formation, classe);


--
-- TOC entry 6087 (class 2606 OID 2600524)
-- Dependencies: 4491 4491 4491 4491 4491 4491
-- Name: uk_parcours_orientation; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY prcrs_parcours_oriente
    ADD CONSTRAINT uk_parcours_orientation UNIQUE (id, "type", seuil, sous_parcours, ordre);


--
-- TOC entry 6153 (class 2606 OID 2600526)
-- Dependencies: 4515 4515 4515 4515 4515
-- Name: uk_question_reponse_elements_1; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_question_reponse_elements
    ADD CONSTRAINT uk_question_reponse_elements_1 UNIQUE (question_reponse, question, reponse, pere);


--
-- TOC entry 6266 (class 2606 OID 2600528)
-- Dependencies: 4566 4566 4566
-- Name: uk_serie_evaluations; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY sr_serie_evaluations
    ADD CONSTRAINT uk_serie_evaluations UNIQUE (serie, pere);


--
-- TOC entry 5987 (class 2606 OID 2600530)
-- Dependencies: 4426 4426 4426
-- Name: uq_etape_forum_1; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY frm_etape_forum
    ADD CONSTRAINT uq_etape_forum_1 UNIQUE (id, forum);


--
-- TOC entry 6327 (class 2606 OID 2600532)
-- Dependencies: 4598 4598 4598
-- Name: uq_evaluation_1; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY vltn_evaluation
    ADD CONSTRAINT uq_evaluation_1 UNIQUE (id, "type");


--
-- TOC entry 6128 (class 2606 OID 2600534)
-- Dependencies: 4504 4504
-- Name: uq_qsrc_1; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qc_qsrc
    ADD CONSTRAINT uq_qsrc_1 UNIQUE (id);


--
-- TOC entry 6146 (class 2606 OID 2600536)
-- Dependencies: 4512 4512 4512
-- Name: uq_question_reponse_1; Type: CONSTRAINT; Schema: v2; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY qr_question_reponse
    ADD CONSTRAINT uq_question_reponse_1 UNIQUE (id, "type");


SET search_path = contraintes, pg_catalog;

--
-- TOC entry 5345 (class 1259 OID 2600537)
-- Dependencies: 3932
-- Name: articles_pkey; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX articles_pkey ON articles USING btree (id);


--
-- TOC entry 5348 (class 1259 OID 2600538)
-- Dependencies: 3938
-- Name: c_reg_users_username_key; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX c_reg_users_username_key ON c_reg_users USING btree (username);


--
-- TOC entry 5627 (class 1259 OID 2600539)
-- Dependencies: 4085
-- Name: fki_; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_ ON individu_type_droits USING btree (individu_type);


--
-- TOC entry 5602 (class 1259 OID 2600540)
-- Dependencies: 4072
-- Name: fki_1; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_1 ON fw_module_individus_types USING btree (droit);


--
-- TOC entry 5501 (class 1259 OID 2600541)
-- Dependencies: 4018
-- Name: fki_c; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_c ON exotlc_modele_correction USING btree (modele_correction);


--
-- TOC entry 5379 (class 1259 OID 2600542)
-- Dependencies: 3959
-- Name: fki_categorie_css; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_categorie_css ON categorie_fichier_css USING btree (id);


--
-- TOC entry 5396 (class 1259 OID 2600543)
-- Dependencies: 3967
-- Name: fki_categorie_ressource_2; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_categorie_ressource_2 ON categorie_fichier_ressource_fichier USING btree (id);


--
-- TOC entry 5401 (class 1259 OID 2600544)
-- Dependencies: 3969
-- Name: fki_categorie_scenario; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_categorie_scenario ON categorie_fichier_scenario USING btree (id);


--
-- TOC entry 5824 (class 1259 OID 2600545)
-- Dependencies: 4184 4184
-- Name: fki_categorie_serie; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_categorie_serie ON serie_aleatoire_multitheme USING btree (theme_source, serie);


--
-- TOC entry 5434 (class 1259 OID 2600546)
-- Dependencies: 3985
-- Name: fki_choix_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_choix_1 ON choix USING btree (id);


--
-- TOC entry 5435 (class 1259 OID 2600547)
-- Dependencies: 3985
-- Name: fki_choix_2; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_choix_2 ON choix USING btree (question_reponse);


--
-- TOC entry 5436 (class 1259 OID 2600548)
-- Dependencies: 3985 3985
-- Name: fki_choix_3; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_choix_3 ON choix USING btree (question_reponse, id);


--
-- TOC entry 5445 (class 1259 OID 2600549)
-- Dependencies: 3989
-- Name: fki_commentaire_etape; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_commentaire_etape ON commentaire_etape USING btree (etape);


--
-- TOC entry 5460 (class 1259 OID 2600550)
-- Dependencies: 4001
-- Name: fki_etape; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_etape ON etape USING btree (id);


--
-- TOC entry 5688 (class 1259 OID 2600551)
-- Dependencies: 4126
-- Name: fki_etape_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_etape_1 ON pc_etape USING btree (id);


--
-- TOC entry 5476 (class 1259 OID 2600552)
-- Dependencies: 4006
-- Name: fki_etape_type; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_etape_type ON etape_type USING btree (id);


--
-- TOC entry 5691 (class 1259 OID 2600553)
-- Dependencies: 4128
-- Name: fki_etape_type_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_etape_type_1 ON pc_etape_type USING btree (id);


--
-- TOC entry 5532 (class 1259 OID 2600554)
-- Dependencies: 4034
-- Name: fki_fichier_metadata; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_fichier_metadata ON fichier_metadata USING btree (id);


--
-- TOC entry 5541 (class 1259 OID 2600555)
-- Dependencies: 4039
-- Name: fki_fichier_scenario; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_fichier_scenario ON fichier_scenario USING btree (id);


--
-- TOC entry 5546 (class 1259 OID 2600556)
-- Dependencies: 4041
-- Name: fki_fichier_scenario_dynamique_blocs_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_fichier_scenario_dynamique_blocs_1 ON fichier_scenario_dynamique_blocs USING btree (fichier_bloc_scenario);


--
-- TOC entry 5547 (class 1259 OID 2600557)
-- Dependencies: 4041
-- Name: fki_fichier_scenario_dynamique_blocs_2; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_fichier_scenario_dynamique_blocs_2 ON fichier_scenario_dynamique_blocs USING btree (id);


--
-- TOC entry 5515 (class 1259 OID 2600558)
-- Dependencies: 4027
-- Name: fki_fichier_scorm; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_fichier_scorm ON fichier_etape_scorm USING btree (id);


--
-- TOC entry 5564 (class 1259 OID 2600559)
-- Dependencies: 4052
-- Name: fki_formation_participants_formateur; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_formation_participants_formateur ON formation_participants USING btree (formateur);


--
-- TOC entry 5569 (class 1259 OID 2600560)
-- Dependencies: 4053
-- Name: fki_formation_ressources_3; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_formation_ressources_3 ON formation_ressources USING btree (espace);


--
-- TOC entry 5570 (class 1259 OID 2600561)
-- Dependencies: 4053
-- Name: fki_formation_ressources_4; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_formation_ressources_4 ON formation_ressources USING btree (section);


--
-- TOC entry 5575 (class 1259 OID 2600562)
-- Dependencies: 4054
-- Name: fki_formation_session_1; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_formation_session_1 ON formation_session USING btree (formation);


--
-- TOC entry 5756 (class 1259 OID 2961469)
-- Dependencies: 4152
-- Name: fki_individu; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_individu ON resultat USING btree (stagiaire);


--
-- TOC entry 5588 (class 1259 OID 2600563)
-- Dependencies: 4064
-- Name: fki_individu_organisme; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_individu_organisme ON fw_individu USING btree (organisme);


--
-- TOC entry 5589 (class 1259 OID 2600564)
-- Dependencies: 4064
-- Name: fki_individu_photo; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_individu_photo ON fw_individu USING btree (photo);


--
-- TOC entry 5628 (class 1259 OID 2600565)
-- Dependencies: 4085
-- Name: fki_individu_type_droit; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_individu_type_droit ON individu_type_droits USING btree (droit);


--
-- TOC entry 5607 (class 1259 OID 2600566)
-- Dependencies: 4075
-- Name: fki_module_submodules; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_module_submodules ON fw_module_submodules USING btree (submodule);


--
-- TOC entry 5608 (class 1259 OID 2600567)
-- Dependencies: 4075
-- Name: fki_module_submodules_1; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_module_submodules_1 ON fw_module_submodules USING btree (module);


--
-- TOC entry 5709 (class 1259 OID 2600568)
-- Dependencies: 4135 4135 4135
-- Name: fki_positionnement_elements_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_elements_1 ON positionnement_elements USING btree (question_reponse, question, choix);


--
-- TOC entry 5710 (class 1259 OID 2600569)
-- Dependencies: 4135
-- Name: fki_positionnement_elements_2; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_elements_2 ON positionnement_elements USING btree (choix);


--
-- TOC entry 5713 (class 1259 OID 2600570)
-- Dependencies: 4136
-- Name: fki_positionnement_evaluations_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_evaluations_1 ON positionnement_evaluations USING btree (evaluation);


--
-- TOC entry 5704 (class 1259 OID 2600571)
-- Dependencies: 4134
-- Name: fki_positionnement_evaluations_generees_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_evaluations_generees_1 ON positionnement_choix_evaluations USING btree (positionnement);


--
-- TOC entry 5705 (class 1259 OID 2600572)
-- Dependencies: 4134 4134
-- Name: fki_positionnement_evaluations_generees_2; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_evaluations_generees_2 ON positionnement_choix_evaluations USING btree (reponse, positionnement);


--
-- TOC entry 5706 (class 1259 OID 2600573)
-- Dependencies: 4134
-- Name: fki_positionnement_evaluations_generees_3; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_evaluations_generees_3 ON positionnement_choix_evaluations USING btree (bareme);


--
-- TOC entry 5469 (class 1259 OID 2600574)
-- Dependencies: 4004
-- Name: fki_ressource_etape_2; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_ressource_etape_2 ON etape_ressource USING btree (fichier);


--
-- TOC entry 5470 (class 1259 OID 2600575)
-- Dependencies: 4004
-- Name: fki_ressource_etape_3; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_ressource_etape_3 ON etape_ressource USING btree (espace);


--
-- TOC entry 5471 (class 1259 OID 2600576)
-- Dependencies: 4004
-- Name: fki_ressource_etape_4; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_ressource_etape_4 ON etape_ressource USING btree (section);


--
-- TOC entry 5762 (class 1259 OID 2600577)
-- Dependencies: 4153
-- Name: fki_resultat_exotlc_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_exotlc_1 ON resultat_exotlc USING btree (id);


--
-- TOC entry 5769 (class 1259 OID 2600578)
-- Dependencies: 4156 4156 4156
-- Name: fki_resultat_positionnement; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_positionnement ON resultat_positionnement USING btree (id, test, positionnement);


--
-- TOC entry 5772 (class 1259 OID 2600579)
-- Dependencies: 4157 4157 4157 4157 4157
-- Name: fki_resultat_positionnement_question_reponse; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_positionnement_question_reponse ON resultat_positionnement_question_reponse USING btree (id, test, question_reponse, question, choix);


--
-- TOC entry 5775 (class 1259 OID 2600580)
-- Dependencies: 4158
-- Name: fki_resultat_serie; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie ON resultat_serie USING btree (evaluation);


--
-- TOC entry 5776 (class 1259 OID 2600581)
-- Dependencies: 4158
-- Name: fki_resultat_serie_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_1 ON resultat_serie USING btree (id);


--
-- TOC entry 5779 (class 1259 OID 2600582)
-- Dependencies: 4159 4159
-- Name: fki_resultat_serie_ftb; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_ftb ON resultat_serie_ftb USING btree (id, ftb);


--
-- TOC entry 5780 (class 1259 OID 2600583)
-- Dependencies: 4160 4160 4160
-- Name: fki_resultat_serie_question_reponse; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_question_reponse ON resultat_serie_question_reponse USING btree (question_reponse, question, reponse);


--
-- TOC entry 5781 (class 1259 OID 2600584)
-- Dependencies: 4160 4160
-- Name: fki_resultat_serie_question_reponse_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_question_reponse_1 ON resultat_serie_question_reponse USING btree (id, question_reponse);


--
-- TOC entry 5784 (class 1259 OID 2600585)
-- Dependencies: 4161
-- Name: fki_resultat_serie_tentative_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_tentative_1 ON resultat_serie_tentative USING btree (id);


--
-- TOC entry 5829 (class 1259 OID 2600586)
-- Dependencies: 4187 4187
-- Name: fki_serie_blocante_3; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_serie_blocante_3 ON serie_bloquante USING btree (parcours, serie);


--
-- TOC entry 5832 (class 1259 OID 2600587)
-- Dependencies: 4188 4188
-- Name: fki_serie_evaluations_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_serie_evaluations_1 ON serie_evaluations USING btree (serie, pere);


--
-- TOC entry 5833 (class 1259 OID 2600588)
-- Dependencies: 4188 4188
-- Name: fki_serie_evaluations_5; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_serie_evaluations_5 ON serie_evaluations USING btree (serie, pere);


--
-- TOC entry 5840 (class 1259 OID 2600589)
-- Dependencies: 4190
-- Name: fki_session_active_formation; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_session_active_formation ON session_active USING btree (formation);


--
-- TOC entry 5847 (class 1259 OID 2600590)
-- Dependencies: 4195
-- Name: fki_theme_individu; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_theme_individu ON theme USING btree (individu);


--
-- TOC entry 5685 (class 1259 OID 2600591)
-- Dependencies: 4124
-- Name: i_parcours_oriente; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX i_parcours_oriente ON parcours_oriente USING btree (id);


--
-- TOC entry 5742 (class 1259 OID 2600592)
-- Dependencies: 4146 4146
-- Name: i_question_reponse_elements_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX i_question_reponse_elements_1 ON question_reponse_elements_old USING btree (question, pere);


--
-- TOC entry 5747 (class 1259 OID 2600593)
-- Dependencies: 4147 4147
-- Name: i_question_reponse_elements_old_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX i_question_reponse_elements_old_1 ON question_reponse_elements_older USING btree (question, pere);


--
-- TOC entry 5757 (class 1259 OID 2600594)
-- Dependencies: 4152 4152
-- Name: i_resultat_1; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX i_resultat_1 ON resultat USING btree (id, etape);


--
-- TOC entry 5339 (class 1259 OID 2600595)
-- Dependencies: 3929
-- Name: k_changed; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX k_changed ON active_sessions USING btree (changed);


--
-- TOC entry 5340 (class 1259 OID 2600596)
-- Dependencies: 3929
-- Name: k_changed_1; Type: INDEX; Schema: contraintes; Owner: pgsql; Tablespace: 
--

CREATE INDEX k_changed_1 ON active_sessions USING btree (changed);


--
-- TOC entry 5506 (class 1259 OID 2600597)
-- Dependencies: 4023
-- Name: kfi_fichier; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE INDEX kfi_fichier ON fichier USING btree (id);


--
-- TOC entry 5805 (class 1259 OID 2600598)
-- Dependencies: 4172
-- Name: scorm_pkey_u; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX scorm_pkey_u ON scorm USING btree (id);


--
-- TOC entry 5808 (class 1259 OID 2600599)
-- Dependencies: 4174
-- Name: scorm_sco_users_pkey_u; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX scorm_sco_users_pkey_u ON scorm_sco_users USING btree (id);


--
-- TOC entry 5811 (class 1259 OID 2600600)
-- Dependencies: 4176
-- Name: scorm_scoes_pkey_u; Type: INDEX; Schema: contraintes; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX scorm_scoes_pkey_u ON scorm_scoes USING btree (id);


SET search_path = public, pg_catalog;

--
-- TOC entry 5860 (class 1259 OID 2600601)
-- Dependencies: 4201
-- Name: alert_num_alert_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX alert_num_alert_key ON alert USING btree (num_alert);


--
-- TOC entry 5861 (class 1259 OID 2600602)
-- Dependencies: 4204
-- Name: articles_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX articles_pkey ON articles USING btree (id);


--
-- TOC entry 5862 (class 1259 OID 2600603)
-- Dependencies: 4206 4206 4206
-- Name: asso_exo_serie_id_exo_id_serie_; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX asso_exo_serie_id_exo_id_serie_ ON asso_exo_serie USING btree (id_exo, id_serie, ordre);


--
-- TOC entry 5875 (class 1259 OID 2600604)
-- Dependencies: 4213
-- Name: bareme_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX bareme_pkey ON bareme USING btree (num_bareme);


--
-- TOC entry 5876 (class 1259 OID 2600605)
-- Dependencies: 4214
-- Name: block_ip_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX block_ip_pkey ON block_ip USING btree (ip);


--
-- TOC entry 5877 (class 1259 OID 2600606)
-- Dependencies: 4217
-- Name: c_reg_users_username_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX c_reg_users_username_key ON c_reg_users USING btree (username);


--
-- TOC entry 5878 (class 1259 OID 2600607)
-- Dependencies: 4219
-- Name: calendrier_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX calendrier_pkey ON calendrier USING btree (num_cal);


--
-- TOC entry 5879 (class 1259 OID 2600608)
-- Dependencies: 4220
-- Name: capacite_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX capacite_pkey ON capacite USING btree (num_capacite);


--
-- TOC entry 5880 (class 1259 OID 2600609)
-- Dependencies: 4221
-- Name: categoriepage_id_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX categoriepage_id_key ON categoriepage USING btree (id);


--
-- TOC entry 5881 (class 1259 OID 2600610)
-- Dependencies: 4223
-- Name: chrono_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX chrono_pkey ON chrono USING btree (num_chrono);


--
-- TOC entry 5882 (class 1259 OID 2600611)
-- Dependencies: 4224
-- Name: classe_id_pere_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE INDEX classe_id_pere_key ON classe USING btree (id_pere);


--
-- TOC entry 5887 (class 1259 OID 2600612)
-- Dependencies: 4235
-- Name: content_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX content_pkey ON content USING btree (num_content);


--
-- TOC entry 5890 (class 1259 OID 2600613)
-- Dependencies: 4238
-- Name: couleur_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX couleur_pkey ON couleur USING btree (num_couleur);


--
-- TOC entry 5891 (class 1259 OID 2600614)
-- Dependencies: 4239
-- Name: dates_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX dates_pkey ON dates USING btree (num_date);


--
-- TOC entry 5894 (class 1259 OID 2600615)
-- Dependencies: 4245
-- Name: exotlc_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX exotlc_pkey ON exotlc USING btree (num_exo);


--
-- TOC entry 5895 (class 1259 OID 2600616)
-- Dependencies: 4246
-- Name: ficmediaqcm_num_fic_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX ficmediaqcm_num_fic_key ON ficmediaqcm USING btree (num_fic);


--
-- TOC entry 5896 (class 1259 OID 2600617)
-- Dependencies: 4248
-- Name: fictlc_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX fictlc_pkey ON fictlc USING btree (num_fic);


--
-- TOC entry 5897 (class 1259 OID 2600618)
-- Dependencies: 4249
-- Name: filiere_id_pere_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE INDEX filiere_id_pere_key ON filiere USING btree (id_pere);


--
-- TOC entry 5902 (class 1259 OID 2600619)
-- Dependencies: 4261 4261 4261
-- Name: gestionqstn_gqstn_num_user_gqst; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX gestionqstn_gqstn_num_user_gqst ON gestionqstn USING btree (gqstn_num_user, gqstn_num_qstaire, num_cal);


--
-- TOC entry 5903 (class 1259 OID 2600620)
-- Dependencies: 4266
-- Name: grille_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX grille_pkey ON grille USING btree (num_grille);


--
-- TOC entry 5904 (class 1259 OID 2600621)
-- Dependencies: 4269
-- Name: intervention_id_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE INDEX intervention_id_key ON intervention USING btree (id);


--
-- TOC entry 5858 (class 1259 OID 2600622)
-- Dependencies: 4199
-- Name: k_asp_changed; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE INDEX k_asp_changed ON active_sessions_split USING btree (ct_changed);


--
-- TOC entry 5859 (class 1259 OID 2600623)
-- Dependencies: 4199
-- Name: k_asp_changed_1; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE INDEX k_asp_changed_1 ON active_sessions_split USING btree (ct_changed);


--
-- TOC entry 5854 (class 1259 OID 2600624)
-- Dependencies: 4198
-- Name: k_changed; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE INDEX k_changed ON active_sessions USING btree (changed);


--
-- TOC entry 5855 (class 1259 OID 2600625)
-- Dependencies: 4198
-- Name: k_changed_1; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE INDEX k_changed_1 ON active_sessions USING btree (changed);


--
-- TOC entry 5869 (class 1259 OID 2600626)
-- Dependencies: 4211
-- Name: k_username; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX k_username ON auth_user USING btree (username);


--
-- TOC entry 5870 (class 1259 OID 2600627)
-- Dependencies: 4211
-- Name: k_username_1; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX k_username_1 ON auth_user USING btree (username);


--
-- TOC entry 5873 (class 1259 OID 2600628)
-- Dependencies: 4212
-- Name: k_username_md5; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX k_username_md5 ON auth_user_md5 USING btree (username);


--
-- TOC entry 5874 (class 1259 OID 2600629)
-- Dependencies: 4212
-- Name: k_username_md5_1; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX k_username_md5_1 ON auth_user_md5 USING btree (username);


--
-- TOC entry 5911 (class 1259 OID 2600630)
-- Dependencies: 4280
-- Name: organisme_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX organisme_pkey ON organisme USING btree (num_org);


--
-- TOC entry 5912 (class 1259 OID 2600631)
-- Dependencies: 4281
-- Name: page_id_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX page_id_key ON page USING btree (id);


--
-- TOC entry 5913 (class 1259 OID 2600632)
-- Dependencies: 4283
-- Name: parcours_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX parcours_pkey ON parcours USING btree (num_parcours);


--
-- TOC entry 5922 (class 1259 OID 2600633)
-- Dependencies: 4299
-- Name: question_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX question_pkey ON question USING btree (num_question);


--
-- TOC entry 5923 (class 1259 OID 2600634)
-- Dependencies: 4302
-- Name: questionnaire_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX questionnaire_pkey ON questionnaire USING btree (num_qstaire);


--
-- TOC entry 5924 (class 1259 OID 2600635)
-- Dependencies: 4305
-- Name: reponse_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX reponse_pkey ON reponse USING btree (num_rep);


--
-- TOC entry 5936 (class 1259 OID 2600636)
-- Dependencies: 4312
-- Name: ressource_esp_num_espace_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX ressource_esp_num_espace_key ON ressource_esp USING btree (num_espace);


--
-- TOC entry 5937 (class 1259 OID 2600637)
-- Dependencies: 4312
-- Name: ressource_esp_titre_key; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX ressource_esp_titre_key ON ressource_esp USING btree (titre);


--
-- TOC entry 5938 (class 1259 OID 2600638)
-- Dependencies: 4313
-- Name: ressource_fic_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX ressource_fic_pkey ON ressource_fic USING btree (num_fic);


--
-- TOC entry 5939 (class 1259 OID 2600639)
-- Dependencies: 4314
-- Name: ressource_gest_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX ressource_gest_pkey ON ressource_gest USING btree (num_gest_res);


--
-- TOC entry 5935 (class 1259 OID 2600640)
-- Dependencies: 4311
-- Name: ressource_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX ressource_pkey ON ressource USING btree (num_res);


--
-- TOC entry 5940 (class 1259 OID 2600641)
-- Dependencies: 4315
-- Name: ressource_sec_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX ressource_sec_pkey ON ressource_sec USING btree (num_section);


--
-- TOC entry 5943 (class 1259 OID 2600642)
-- Dependencies: 4319
-- Name: rubrique_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX rubrique_pkey ON rubrique USING btree (num_rub);


--
-- TOC entry 5944 (class 1259 OID 2600643)
-- Dependencies: 4320
-- Name: salle_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX salle_pkey ON salle USING btree (num_salle);


--
-- TOC entry 5953 (class 1259 OID 2600644)
-- Dependencies: 4392
-- Name: sousrubrique_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX sousrubrique_pkey ON sousrubrique USING btree (num_srub);


--
-- TOC entry 5958 (class 1259 OID 2600645)
-- Dependencies: 4398
-- Name: themedir_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX themedir_pkey ON themedir USING btree (num_themedir);


--
-- TOC entry 5959 (class 1259 OID 2600646)
-- Dependencies: 4400
-- Name: titrecapacite_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX titrecapacite_pkey ON titrecapacite USING btree (num_titrecapacite);


--
-- TOC entry 5960 (class 1259 OID 2600647)
-- Dependencies: 4402
-- Name: typeform_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX typeform_pkey ON typeform USING btree (num_typeform);


--
-- TOC entry 5961 (class 1259 OID 2600648)
-- Dependencies: 4403
-- Name: utilisateurs_pkey; Type: INDEX; Schema: public; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX utilisateurs_pkey ON utilisateurs USING btree (num_user);


SET search_path = v2, pg_catalog;

--
-- TOC entry 5983 (class 1259 OID 2600649)
-- Dependencies: 4424
-- Name: articles_pkey; Type: INDEX; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE UNIQUE INDEX articles_pkey ON frm_articles USING btree (id);


--
-- TOC entry 5964 (class 1259 OID 2600650)
-- Dependencies: 4407
-- Name: c_reg_users_username_key; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX c_reg_users_username_key ON c_reg_users USING btree (username);


--
-- TOC entry 6200 (class 1259 OID 2600651)
-- Dependencies: 4540
-- Name: fki_categorie_css; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_categorie_css ON scnr_categorie_fichier_css USING btree (id);


--
-- TOC entry 6168 (class 1259 OID 2600652)
-- Dependencies: 4524
-- Name: fki_categorie_ressource_2; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_categorie_ressource_2 ON rssrc_categorie_fichier_ressource_fichier USING btree (id);


--
-- TOC entry 6205 (class 1259 OID 2600653)
-- Dependencies: 4542
-- Name: fki_categorie_scenario; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_categorie_scenario ON scnr_categorie_fichier_scenario USING btree (id);


--
-- TOC entry 6277 (class 1259 OID 2600654)
-- Dependencies: 4573 4573
-- Name: fki_categorie_serie; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_categorie_serie ON srltrmltthm_serie_aleatoire_multitheme USING btree (theme_source, serie);


--
-- TOC entry 6090 (class 1259 OID 2600655)
-- Dependencies: 4493
-- Name: fki_choix_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_choix_1 ON pstnnmnt_choix USING btree (id);


--
-- TOC entry 6091 (class 1259 OID 2600656)
-- Dependencies: 4493
-- Name: fki_choix_2; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_choix_2 ON pstnnmnt_choix USING btree (question_reponse);


--
-- TOC entry 6092 (class 1259 OID 2600657)
-- Dependencies: 4493 4493
-- Name: fki_choix_3; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_choix_3 ON pstnnmnt_choix USING btree (question_reponse, id);


--
-- TOC entry 6288 (class 1259 OID 2600658)
-- Dependencies: 4580
-- Name: fki_commentaire_etape; Type: INDEX; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_commentaire_etape ON tp_commentaire_etape USING btree (etape);


--
-- TOC entry 6291 (class 1259 OID 2600659)
-- Dependencies: 4582
-- Name: fki_etape; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_etape ON tp_etape USING btree (id);


--
-- TOC entry 6294 (class 1259 OID 2600660)
-- Dependencies: 4583
-- Name: fki_etape_type; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_etape_type ON tp_etape_type USING btree (id);


--
-- TOC entry 6214 (class 1259 OID 2600661)
-- Dependencies: 4546
-- Name: fki_fichier_scenario; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_fichier_scenario ON scnr_fichier_scenario USING btree (id);


--
-- TOC entry 6225 (class 1259 OID 2600662)
-- Dependencies: 4550
-- Name: fki_fichier_scorm; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_fichier_scorm ON scrm_fichier_etape_scorm USING btree (id);


--
-- TOC entry 6004 (class 1259 OID 2600663)
-- Dependencies: 4439
-- Name: fki_formation_participants_formateur; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_formation_participants_formateur ON frmtn_formation_participants USING btree (formateur);


--
-- TOC entry 6187 (class 1259 OID 2600664)
-- Dependencies: 4533
-- Name: fki_formation_ressources_3; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_formation_ressources_3 ON rssrc_formation_ressources USING btree (espace);


--
-- TOC entry 6188 (class 1259 OID 2600665)
-- Dependencies: 4533
-- Name: fki_formation_ressources_4; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_formation_ressources_4 ON rssrc_formation_ressources USING btree (section);


--
-- TOC entry 6106 (class 1259 OID 2600666)
-- Dependencies: 4497 4497 4497
-- Name: fki_positionnement_elements_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_elements_1 ON pstnnmnt_positionnement_elements USING btree (question_reponse, question, choix);


--
-- TOC entry 6107 (class 1259 OID 2600667)
-- Dependencies: 4497
-- Name: fki_positionnement_elements_2; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_elements_2 ON pstnnmnt_positionnement_elements USING btree (choix);


--
-- TOC entry 6110 (class 1259 OID 2600668)
-- Dependencies: 4498
-- Name: fki_positionnement_evaluations_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_evaluations_1 ON pstnnmnt_positionnement_evaluations USING btree (evaluation);


--
-- TOC entry 6101 (class 1259 OID 2600669)
-- Dependencies: 4496
-- Name: fki_positionnement_evaluations_generees_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_evaluations_generees_1 ON pstnnmnt_positionnement_choix_evaluations USING btree (positionnement);


--
-- TOC entry 6102 (class 1259 OID 2600670)
-- Dependencies: 4496 4496
-- Name: fki_positionnement_evaluations_generees_2; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_evaluations_generees_2 ON pstnnmnt_positionnement_choix_evaluations USING btree (reponse, positionnement);


--
-- TOC entry 6103 (class 1259 OID 2600671)
-- Dependencies: 4496
-- Name: fki_positionnement_evaluations_generees_3; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_positionnement_evaluations_generees_3 ON pstnnmnt_positionnement_choix_evaluations USING btree (bareme);


--
-- TOC entry 6175 (class 1259 OID 2600672)
-- Dependencies: 4528
-- Name: fki_ressource_etape_3; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_ressource_etape_3 ON rssrc_etape_ressource USING btree (espace);


--
-- TOC entry 6176 (class 1259 OID 2600673)
-- Dependencies: 4528
-- Name: fki_ressource_etape_4; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_ressource_etape_4 ON rssrc_etape_ressource USING btree (section);


--
-- TOC entry 6195 (class 1259 OID 2600674)
-- Dependencies: 4536
-- Name: fki_ressource_fichier_ressource; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_ressource_fichier_ressource ON rssrc_ressource USING btree (fichier);


--
-- TOC entry 6374 (class 1259 OID 2600675)
-- Dependencies: 4628
-- Name: fki_resultat_exotlc_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_exotlc_1 ON xtlc_resultat_exotlc USING btree (id);


--
-- TOC entry 6117 (class 1259 OID 2600676)
-- Dependencies: 4501 4501 4501
-- Name: fki_resultat_positionnement; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_positionnement ON pstnnmnt_resultat_positionnement USING btree (id, test, positionnement);


--
-- TOC entry 6120 (class 1259 OID 2600677)
-- Dependencies: 4502 4502 4502 4502 4502
-- Name: fki_resultat_positionnement_question_reponse; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_positionnement_question_reponse ON pstnnmnt_resultat_positionnement_question_reponse USING btree (id, test, question_reponse, question, choix);


--
-- TOC entry 6249 (class 1259 OID 2600678)
-- Dependencies: 4561
-- Name: fki_resultat_serie; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie ON sr_resultat_serie USING btree (evaluation);


--
-- TOC entry 6250 (class 1259 OID 2600679)
-- Dependencies: 4561
-- Name: fki_resultat_serie_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_1 ON sr_resultat_serie USING btree (id);


--
-- TOC entry 5973 (class 1259 OID 2600680)
-- Dependencies: 4416 4416
-- Name: fki_resultat_serie_ftb; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_ftb ON fb_resultat_serie_ftb USING btree (id, ftb);


--
-- TOC entry 6158 (class 1259 OID 2600681)
-- Dependencies: 4519 4519 4519
-- Name: fki_resultat_serie_question_reponse; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_question_reponse ON qr_resultat_serie_question_reponse USING btree (question_reponse, question, reponse);


--
-- TOC entry 6159 (class 1259 OID 2600682)
-- Dependencies: 4519 4519
-- Name: fki_resultat_serie_question_reponse_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_question_reponse_1 ON qr_resultat_serie_question_reponse USING btree (id, question_reponse);


--
-- TOC entry 6253 (class 1259 OID 2600683)
-- Dependencies: 4562
-- Name: fki_resultat_serie_tentative_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_resultat_serie_tentative_1 ON sr_resultat_serie_tentative USING btree (id);


--
-- TOC entry 6239 (class 1259 OID 2600684)
-- Dependencies: 4558
-- Name: fki_scrdnmq_scenario_dynamique_1; Type: INDEX; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_scrdnmq_scenario_dynamique_1 ON snrdnmq_scenario_dynamique USING btree (css);


--
-- TOC entry 6240 (class 1259 OID 2600685)
-- Dependencies: 4558
-- Name: fki_scrdnmq_scenario_dynamique_2; Type: INDEX; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_scrdnmq_scenario_dynamique_2 ON snrdnmq_scenario_dynamique USING btree (id);


--
-- TOC entry 6258 (class 1259 OID 2600686)
-- Dependencies: 4565 4565
-- Name: fki_serie_blocante_3; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_serie_blocante_3 ON sr_serie_bloquante USING btree (parcours, serie);


--
-- TOC entry 6261 (class 1259 OID 2600687)
-- Dependencies: 4566 4566
-- Name: fki_serie_evaluations_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_serie_evaluations_1 ON sr_serie_evaluations USING btree (serie, pere);


--
-- TOC entry 6262 (class 1259 OID 2600688)
-- Dependencies: 4566 4566
-- Name: fki_serie_evaluations_5; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX fki_serie_evaluations_5 ON sr_serie_evaluations USING btree (serie, pere);


--
-- TOC entry 6243 (class 1259 OID 2600689)
-- Dependencies: 4559
-- Name: fki_snrdnmq_scenario_dynamique_blocs_1; Type: INDEX; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_snrdnmq_scenario_dynamique_blocs_1 ON snrdnmq_scenario_dynamique_blocs USING btree (scenario_dynamique);


--
-- TOC entry 6244 (class 1259 OID 2600690)
-- Dependencies: 4559
-- Name: fki_snrdnmq_scenario_dynamique_blocs_2; Type: INDEX; Schema: v2; Owner: pgsql; Tablespace: 
--

CREATE INDEX fki_snrdnmq_scenario_dynamique_blocs_2 ON snrdnmq_scenario_dynamique_blocs USING btree (bloc_scenario);


--
-- TOC entry 6085 (class 1259 OID 2600691)
-- Dependencies: 4491
-- Name: i_parcours_oriente; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX i_parcours_oriente ON prcrs_parcours_oriente USING btree (id);


--
-- TOC entry 6149 (class 1259 OID 2600692)
-- Dependencies: 4515 4515
-- Name: i_question_reponse_elements_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX i_question_reponse_elements_1 ON qr_question_reponse_elements USING btree (question, pere);


--
-- TOC entry 6301 (class 1259 OID 2600693)
-- Dependencies: 4585 4585
-- Name: i_resultat_1; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX i_resultat_1 ON tp_resultat USING btree (id, etape);


--
-- TOC entry 5974 (class 1259 OID 2600694)
-- Dependencies: 4418
-- Name: kfi_fichier; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE INDEX kfi_fichier ON fchr_fichier USING btree (id);


--
-- TOC entry 6230 (class 1259 OID 2600695)
-- Dependencies: 4552
-- Name: scorm_pkey_u; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX scorm_pkey_u ON scrm_scorm USING btree (id);


--
-- TOC entry 6233 (class 1259 OID 2600696)
-- Dependencies: 4554
-- Name: scorm_sco_users_pkey_u; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX scorm_sco_users_pkey_u ON scrm_scorm_sco_users USING btree (id);


--
-- TOC entry 6236 (class 1259 OID 2600697)
-- Dependencies: 4556
-- Name: scorm_scoes_pkey_u; Type: INDEX; Schema: v2; Owner: postgres; Tablespace: 
--

CREATE UNIQUE INDEX scorm_scoes_pkey_u ON scrm_scorm_scoes USING btree (id);


SET search_path = contraintes, pg_catalog;

--
-- TOC entry 6957 (class 2620 OID 2600698)
-- Dependencies: 3931 1564
-- Name: check_alerte_dates; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_alerte_dates
    BEFORE INSERT OR UPDATE ON alerte
    FOR EACH ROW
    EXECUTE PROCEDURE check_alerte_dates();


--
-- TOC entry 7061 (class 2620 OID 2600699)
-- Dependencies: 4140 1567
-- Name: check_evaluation_qsrc_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_evaluation_qsrc_type
    BEFORE INSERT OR UPDATE ON qsrc
    FOR EACH ROW
    EXECUTE PROCEDURE check_evaluation_qsrc_type();


--
-- TOC entry 7046 (class 2620 OID 2600700)
-- Dependencies: 4060 1569
-- Name: check_evaluation_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_evaluation_type
    BEFORE INSERT OR UPDATE ON ftb
    FOR EACH ROW
    EXECUTE PROCEDURE check_evaluation_type('3');


--
-- TOC entry 7022 (class 2620 OID 2600701)
-- Dependencies: 4019 1572
-- Name: check_exotlc_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_exotlc_type
    BEFORE INSERT OR UPDATE ON exotlc_plate_forme
    FOR EACH ROW
    EXECUTE PROCEDURE check_exotlc_type('1');


--
-- TOC entry 7020 (class 2620 OID 2600702)
-- Dependencies: 4017 1572
-- Name: check_exotlc_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_exotlc_type
    BEFORE INSERT OR UPDATE ON exotlc_mail
    FOR EACH ROW
    EXECUTE PROCEDURE check_exotlc_type('2');


--
-- TOC entry 7023 (class 2620 OID 2600703)
-- Dependencies: 4025 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_correction
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('3');


--
-- TOC entry 7026 (class 2620 OID 2600704)
-- Dependencies: 4028 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('2');


--
-- TOC entry 7030 (class 2620 OID 2600705)
-- Dependencies: 4030 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_icone
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('6');


--
-- TOC entry 7031 (class 2620 OID 2600706)
-- Dependencies: 4035 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_photo
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('4');


--
-- TOC entry 7035 (class 2620 OID 2600707)
-- Dependencies: 4038 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_ressource_texte
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('1');


--
-- TOC entry 7033 (class 2620 OID 2600708)
-- Dependencies: 4037 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_ressource_fichier
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('7');


--
-- TOC entry 7054 (class 2620 OID 2600709)
-- Dependencies: 4098 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON media
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('8');


--
-- TOC entry 7024 (class 2620 OID 2600710)
-- Dependencies: 4027 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('12');


--
-- TOC entry 7040 (class 2620 OID 2600711)
-- Dependencies: 4040 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('15');


--
-- TOC entry 7037 (class 2620 OID 2600712)
-- Dependencies: 4039 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('5');


--
-- TOC entry 7027 (class 2620 OID 2600713)
-- Dependencies: 4029 1573
-- Name: check_fichier_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fichier_glossaire
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('17');


--
-- TOC entry 7043 (class 2620 OID 2600714)
-- Dependencies: 4052 1575
-- Name: check_formateur_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_formateur_type
    BEFORE INSERT OR UPDATE ON formation_participants
    FOR EACH ROW
    EXECUTE PROCEDURE check_formateur_type();


--
-- TOC entry 7021 (class 2620 OID 2600715)
-- Dependencies: 4017 1575
-- Name: check_formateur_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_formateur_type
    BEFORE INSERT OR UPDATE ON exotlc_mail
    FOR EACH ROW
    EXECUTE PROCEDURE check_formateur_type();


--
-- TOC entry 7015 (class 2620 OID 2600716)
-- Dependencies: 4012 1576
-- Name: check_intervenant; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_intervenant
    BEFORE INSERT OR UPDATE ON evenement
    FOR EACH ROW
    EXECUTE PROCEDURE check_intervenant();


--
-- TOC entry 7016 (class 2620 OID 2600717)
-- Dependencies: 4012 1565
-- Name: check_intervention_date; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_intervention_date
    BEFORE INSERT OR UPDATE ON evenement
    FOR EACH ROW
    EXECUTE PROCEDURE check_calendrier_date();


--
-- TOC entry 7087 (class 2620 OID 2600718)
-- Dependencies: 4192 1578
-- Name: check_liste_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_liste_type
    BEFORE INSERT OR UPDATE ON test
    FOR EACH ROW
    EXECUTE PROCEDURE check_liste_type('3');


--
-- TOC entry 7078 (class 2620 OID 2600719)
-- Dependencies: 4180 1578
-- Name: check_liste_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_liste_type
    BEFORE INSERT OR UPDATE ON serie_aleatoire
    FOR EACH ROW
    EXECUTE PROCEDURE check_liste_type('1');


--
-- TOC entry 7077 (class 2620 OID 2600720)
-- Dependencies: 4179 1579
-- Name: check_liste_type_serie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_liste_type_serie
    AFTER INSERT OR UPDATE ON serie
    FOR EACH ROW
    EXECUTE PROCEDURE check_liste_type_serie();


--
-- TOC entry 7055 (class 2620 OID 2600721)
-- Dependencies: 4100 1580
-- Name: check_media_question_reponse_element; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_media_question_reponse_element
    BEFORE INSERT OR UPDATE ON media_question_reponse_element
    FOR EACH ROW
    EXECUTE PROCEDURE check_media_question_reponse_element();


--
-- TOC entry 7018 (class 2620 OID 2600722)
-- Dependencies: 4013 1581
-- Name: check_modalite; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_modalite
    BEFORE INSERT OR UPDATE ON evenement_presentiel
    FOR EACH ROW
    EXECUTE PROCEDURE check_modalite();


--
-- TOC entry 7060 (class 2620 OID 2600723)
-- Dependencies: 4139 1585
-- Name: check_qcm_elements_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_qcm_elements_type
    BEFORE INSERT OR UPDATE ON qcm_elements
    FOR EACH ROW
    EXECUTE PROCEDURE check_qcm_elements_type();


--
-- TOC entry 7064 (class 2620 OID 2600724)
-- Dependencies: 4145 40
-- Name: check_question_reponse_element_pere_types; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_question_reponse_element_pere_types
    AFTER INSERT OR UPDATE ON question_reponse_elements
    FOR EACH ROW
    EXECUTE PROCEDURE check_question_reponse_element_pere_types();


--
-- TOC entry 10400 (class 0 OID 0)
-- Dependencies: 7064
-- Name: TRIGGER check_question_reponse_element_pere_types ON question_reponse_elements; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TRIGGER check_question_reponse_element_pere_types ON question_reponse_elements IS 'verifie lintégrité des données';


--
-- TOC entry 7065 (class 2620 OID 2600725)
-- Dependencies: 4146 1588
-- Name: check_question_reponse_elements_types; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_question_reponse_elements_types
    BEFORE INSERT OR UPDATE ON question_reponse_elements_old
    FOR EACH ROW
    EXECUTE PROCEDURE check_question_reponse_elements_types();


--
-- TOC entry 7045 (class 2620 OID 2600726)
-- Dependencies: 4053 1589
-- Name: check_ressource_dates; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_ressource_dates
    BEFORE INSERT OR UPDATE ON formation_ressources
    FOR EACH ROW
    EXECUTE PROCEDURE check_ressource_dates();


--
-- TOC entry 7032 (class 2620 OID 2600727)
-- Dependencies: 4036 1590
-- Name: check_ressource_type; Type: TRIGGER; Schema: contraintes; Owner: pgsql
--

CREATE TRIGGER check_ressource_type
    BEFORE INSERT OR UPDATE ON fichier_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE check_ressource_type();


--
-- TOC entry 7080 (class 2620 OID 2600728)
-- Dependencies: 4184 1591
-- Name: check_serie_aleatoire_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_serie_aleatoire_type
    BEFORE INSERT OR UPDATE ON serie_aleatoire_multitheme
    FOR EACH ROW
    EXECUTE PROCEDURE check_serie_aleatoire_type('3');


--
-- TOC entry 7079 (class 2620 OID 2600729)
-- Dependencies: 4183 1591
-- Name: check_serie_aleatoire_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_serie_aleatoire_type
    BEFORE INSERT OR UPDATE ON serie_aleatoire_multiserie
    FOR EACH ROW
    EXECUTE PROCEDURE check_serie_aleatoire_type('2');


--
-- TOC entry 7083 (class 2620 OID 2600730)
-- Dependencies: 4188 1592
-- Name: check_serie_evaluation; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_serie_evaluation
    BEFORE INSERT OR UPDATE ON serie_evaluations
    FOR EACH ROW
    EXECUTE PROCEDURE check_serie_evaluation();


--
-- TOC entry 7072 (class 2620 OID 2600731)
-- Dependencies: 4162 1570
-- Name: check_serie_tentative; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_serie_tentative
    BEFORE INSERT OR UPDATE ON resultat_serie_tentative_ftb
    FOR EACH ROW
    EXECUTE PROCEDURE check_evaluation_type2('3');


--
-- TOC entry 7068 (class 2620 OID 2600732)
-- Dependencies: 4152 1593
-- Name: check_stagiaire_formation; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_stagiaire_formation
    BEFORE INSERT OR UPDATE ON resultat
    FOR EACH ROW
    EXECUTE PROCEDURE check_stagiaire_formation();


--
-- TOC entry 7086 (class 2620 OID 2600733)
-- Dependencies: 4191 1594
-- Name: check_stagiaire_type; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_stagiaire_type
    BEFORE INSERT OR UPDATE ON stagiaire_grille
    FOR EACH ROW
    EXECUTE PROCEDURE check_stagiaire_type();


--
-- TOC entry 7056 (class 2620 OID 2600734)
-- Dependencies: 4122 1595
-- Name: check_type_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON parcours
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('1');


--
-- TOC entry 7011 (class 2620 OID 2600735)
-- Dependencies: 4003 1595
-- Name: check_type_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON etape_forum
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('2');


--
-- TOC entry 7053 (class 2620 OID 2600736)
-- Dependencies: 4095 1595
-- Name: check_type_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON liste
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('4');


--
-- TOC entry 7019 (class 2620 OID 2600737)
-- Dependencies: 4014 1595
-- Name: check_type_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('5');


--
-- TOC entry 7073 (class 2620 OID 2600738)
-- Dependencies: 4169 1595
-- Name: check_type_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON scenario
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('6');


--
-- TOC entry 7012 (class 2620 OID 2600739)
-- Dependencies: 4004 1595
-- Name: check_type_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON etape_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('7');


--
-- TOC entry 7010 (class 2620 OID 2600740)
-- Dependencies: 4002 1595
-- Name: check_type_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON etape_chat
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('8');


--
-- TOC entry 7013 (class 2620 OID 2600741)
-- Dependencies: 4005 1595
-- Name: check_type_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('3');


--
-- TOC entry 7075 (class 2620 OID 2600742)
-- Dependencies: 4170 1595
-- Name: check_type_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('11');


--
-- TOC entry 7062 (class 2620 OID 2600743)
-- Dependencies: 4141 1596
-- Name: check_type_question; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_question
    BEFORE INSERT OR UPDATE ON question
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_question();


--
-- TOC entry 7067 (class 2620 OID 2600744)
-- Dependencies: 4150 1597
-- Name: check_type_reponse; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER check_type_reponse
    BEFORE INSERT OR UPDATE ON reponse
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_reponse();


--
-- TOC entry 7047 (class 2620 OID 2600745)
-- Dependencies: 4064 1665
-- Name: contraintes.fw_root_nodel; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER "contraintes.fw_root_nodel"
    BEFORE DELETE ON fw_individu
    FOR EACH ROW
    EXECUTE PROCEDURE fw_root_nodel();


--
-- TOC entry 7048 (class 2620 OID 2600746)
-- Dependencies: 4064 1667
-- Name: contraintes.fw_root_noupdate; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER "contraintes.fw_root_noupdate"
    BEFORE UPDATE ON fw_individu
    FOR EACH ROW
    EXECUTE PROCEDURE fw_root_noupdate();


--
-- TOC entry 7074 (class 2620 OID 2600747)
-- Dependencies: 4169 1604
-- Name: del_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_etape
    AFTER DELETE ON scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_etape();


--
-- TOC entry 7014 (class 2620 OID 2600748)
-- Dependencies: 4005 1604
-- Name: del_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_etape
    AFTER DELETE ON etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE del_etape();


--
-- TOC entry 7076 (class 2620 OID 2600749)
-- Dependencies: 4170 1604
-- Name: del_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_etape
    AFTER DELETE ON scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE del_etape();


--
-- TOC entry 7017 (class 2620 OID 2600750)
-- Dependencies: 4012 1607
-- Name: del_evenement_presentiel; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_evenement_presentiel
    AFTER DELETE ON evenement
    FOR EACH ROW
    EXECUTE PROCEDURE del_evenement_presentiel();


--
-- TOC entry 10401 (class 0 OID 0)
-- Dependencies: 7017
-- Name: TRIGGER del_evenement_presentiel ON evenement; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TRIGGER del_evenement_presentiel ON evenement IS 'supprime l''evet presentiel associé';


--
-- TOC entry 7058 (class 2620 OID 2600751)
-- Dependencies: 4123 1614
-- Name: del_parcours_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_parcours_etape
    AFTER DELETE ON parcours_etapes
    FOR EACH ROW
    EXECUTE PROCEDURE del_parcours_etape();


--
-- TOC entry 10402 (class 0 OID 0)
-- Dependencies: 7058
-- Name: TRIGGER del_parcours_etape ON parcours_etapes; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TRIGGER del_parcours_etape ON parcours_etapes IS 'pour supprimer l''etape si type 10
(etape parcours oriente)';


--
-- TOC entry 7057 (class 2620 OID 2600752)
-- Dependencies: 4122 1613
-- Name: del_parcours_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_parcours_etape
    BEFORE DELETE ON parcours
    FOR EACH ROW
    EXECUTE PROCEDURE del_parcours();


--
-- TOC entry 7059 (class 2620 OID 2600753)
-- Dependencies: 4134 1616
-- Name: del_positionnement_evaluations_a_generer; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_positionnement_evaluations_a_generer
    BEFORE UPDATE ON positionnement_choix_evaluations
    FOR EACH ROW
    EXECUTE PROCEDURE del_positionnement_evaluations_a_generer();


--
-- TOC entry 7066 (class 2620 OID 2600754)
-- Dependencies: 4146 1620
-- Name: del_question_reponse_element_media; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_question_reponse_element_media
    AFTER DELETE ON question_reponse_elements_old
    FOR EACH ROW
    EXECUTE PROCEDURE del_question_reponse_element_media();


--
-- TOC entry 7069 (class 2620 OID 2600755)
-- Dependencies: 4152 41
-- Name: del_resultat_duree; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_resultat_duree
    AFTER DELETE ON resultat
    FOR EACH ROW
    EXECUTE PROCEDURE del_resultat_duree();


--
-- TOC entry 10403 (class 0 OID 0)
-- Dependencies: 7069
-- Name: TRIGGER del_resultat_duree ON resultat; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TRIGGER del_resultat_duree ON resultat IS 'maj duree ds resultat';


--
-- TOC entry 7071 (class 2620 OID 2600756)
-- Dependencies: 4158 1624
-- Name: del_serie_aleatoire_evaluations; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_serie_aleatoire_evaluations
    AFTER DELETE ON resultat_serie
    FOR EACH ROW
    EXECUTE PROCEDURE del_serie_aleatoire_configuree_evaluations();


--
-- TOC entry 7070 (class 2620 OID 2600757)
-- Dependencies: 4152 1625
-- Name: del_serie_aleatoire_evaluations; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_serie_aleatoire_evaluations
    AFTER DELETE ON resultat
    FOR EACH ROW
    EXECUTE PROCEDURE del_serie_aleatoire_evaluations();


--
-- TOC entry 10404 (class 0 OID 0)
-- Dependencies: 7070
-- Name: TRIGGER del_serie_aleatoire_evaluations ON resultat; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TRIGGER del_serie_aleatoire_evaluations ON resultat IS 'supprime ds serie_aleatoire_evaluation si
l''etape supprimée est une serie aleatoire';


--
-- TOC entry 7051 (class 2620 OID 2600758)
-- Dependencies: 4083 1627
-- Name: del_stagiaire_grille; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_stagiaire_grille
    AFTER DELETE ON grille_resultats
    FOR EACH ROW
    EXECUTE PROCEDURE del_stagiaire_grille();


--
-- TOC entry 6958 (class 2620 OID 2600759)
-- Dependencies: 3949 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_capacite
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6959 (class 2620 OID 2600760)
-- Dependencies: 3950 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_capacite_titre
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6970 (class 2620 OID 2600761)
-- Dependencies: 3958 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_correction
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6960 (class 2620 OID 2600762)
-- Dependencies: 3951 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_critere
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6971 (class 2620 OID 2600763)
-- Dependencies: 3959 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_css
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6973 (class 2620 OID 2600764)
-- Dependencies: 3961 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6991 (class 2620 OID 2600765)
-- Dependencies: 3972 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_ftb
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6994 (class 2620 OID 2600766)
-- Dependencies: 3974 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_grille
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6976 (class 2620 OID 2600767)
-- Dependencies: 3963 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_media_evaluation
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6977 (class 2620 OID 2600768)
-- Dependencies: 3964 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_media_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6978 (class 2620 OID 2600769)
-- Dependencies: 3965 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_media_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6995 (class 2620 OID 2600770)
-- Dependencies: 3975 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_modele_correction
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6996 (class 2620 OID 2600771)
-- Dependencies: 3976 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_positionnement
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6997 (class 2620 OID 2600772)
-- Dependencies: 3977 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_qsrc
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6980 (class 2620 OID 2600773)
-- Dependencies: 3967 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_ressource_fichier
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6984 (class 2620 OID 2600774)
-- Dependencies: 3969 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6972 (class 2620 OID 2600775)
-- Dependencies: 3960 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7004 (class 2620 OID 2600776)
-- Dependencies: 3982 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_serie
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7007 (class 2620 OID 2600777)
-- Dependencies: 3983 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_sondage_element
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6998 (class 2620 OID 2600778)
-- Dependencies: 3978 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_question_reponse
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6966 (class 2620 OID 2600779)
-- Dependencies: 3955 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_evaluation
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6961 (class 2620 OID 2600780)
-- Dependencies: 3952 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_etape
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6967 (class 2620 OID 2600781)
-- Dependencies: 3956 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7000 (class 2620 OID 2600782)
-- Dependencies: 3980 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6963 (class 2620 OID 2600783)
-- Dependencies: 3954 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_etape_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6982 (class 2620 OID 2600784)
-- Dependencies: 3968 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_ressource_texte
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6979 (class 2620 OID 2600785)
-- Dependencies: 3966 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7008 (class 2620 OID 2600786)
-- Dependencies: 3984 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_test
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6969 (class 2620 OID 2600787)
-- Dependencies: 3957 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_bloc_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6987 (class 2620 OID 2600788)
-- Dependencies: 3970 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7002 (class 2620 OID 2600789)
-- Dependencies: 3981 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6962 (class 2620 OID 2600790)
-- Dependencies: 3953 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_etape_forum
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6990 (class 2620 OID 2600791)
-- Dependencies: 3971 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_slide_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6974 (class 2620 OID 2600792)
-- Dependencies: 3962 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_fichier_glossaire
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 6993 (class 2620 OID 2600793)
-- Dependencies: 3973 1630
-- Name: del_theme_categorie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON categorie_glossaire
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7005 (class 2620 OID 2600794)
-- Dependencies: 3982 1631
-- Name: del_theme_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_etape
    AFTER DELETE ON categorie_serie
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_etape();


--
-- TOC entry 6964 (class 2620 OID 2600795)
-- Dependencies: 3954 1631
-- Name: del_theme_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER del_theme_etape
    AFTER DELETE ON categorie_etape_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_etape();


--
-- TOC entry 7049 (class 2620 OID 2600796)
-- Dependencies: 4072 42
-- Name: delete_module_submodules_individu_type; Type: TRIGGER; Schema: contraintes; Owner: pgsql
--

CREATE TRIGGER delete_module_submodules_individu_type
    AFTER DELETE ON fw_module_individus_types
    FOR EACH ROW
    EXECUTE PROCEDURE delete_module_submodules_individu_type();


--
-- TOC entry 7081 (class 2620 OID 2600797)
-- Dependencies: 4184 1632
-- Name: delete_serie_aleatoire_multitheme_categorie_serie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER delete_serie_aleatoire_multitheme_categorie_serie
    AFTER DELETE ON serie_aleatoire_multitheme
    FOR EACH ROW
    EXECUTE PROCEDURE delete_serie_aleatoire_multitheme_categorie_serie();


--
-- TOC entry 10405 (class 0 OID 0)
-- Dependencies: 7081
-- Name: TRIGGER delete_serie_aleatoire_multitheme_categorie_serie ON serie_aleatoire_multitheme; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TRIGGER delete_serie_aleatoire_multitheme_categorie_serie ON serie_aleatoire_multitheme IS 'declenche la fonction du même nom pour supprimer un enregistrement ds categorie_serie';


--
-- TOC entry 7006 (class 2620 OID 2600798)
-- Dependencies: 3982 1677
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON categorie_serie
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 7001 (class 2620 OID 2600799)
-- Dependencies: 3980 1677
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON categorie_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 7009 (class 2620 OID 2600800)
-- Dependencies: 3984 1677
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON categorie_test
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 6968 (class 2620 OID 2600801)
-- Dependencies: 3956 1677
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON categorie_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 6965 (class 2620 OID 2600802)
-- Dependencies: 3954 1677
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON categorie_etape_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 7003 (class 2620 OID 2600803)
-- Dependencies: 3981 1677
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON categorie_scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 6999 (class 2620 OID 2600804)
-- Dependencies: 3978 1678
-- Name: insert_categorie_evaluation; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_evaluation
    AFTER INSERT ON categorie_question_reponse
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_evaluation();


--
-- TOC entry 6992 (class 2620 OID 2600805)
-- Dependencies: 3972 1678
-- Name: insert_categorie_evaluation; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_evaluation
    AFTER INSERT ON categorie_ftb
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_evaluation();


--
-- TOC entry 6981 (class 2620 OID 2600806)
-- Dependencies: 3967 1679
-- Name: insert_categorie_fichier_ressource; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_fichier_ressource
    AFTER INSERT ON categorie_fichier_ressource_fichier
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_fichier_ressource();


--
-- TOC entry 6983 (class 2620 OID 2600807)
-- Dependencies: 3968 1679
-- Name: insert_categorie_fichier_ressource; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_fichier_ressource
    AFTER INSERT ON categorie_fichier_ressource_texte
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_fichier_ressource();


--
-- TOC entry 6985 (class 2620 OID 2600808)
-- Dependencies: 3969 1679
-- Name: insert_categorie_fichier_ressource; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_fichier_ressource
    BEFORE INSERT ON categorie_fichier_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_fichier_ressource();


--
-- TOC entry 6988 (class 2620 OID 2600809)
-- Dependencies: 3970 1679
-- Name: insert_categorie_fichier_ressource; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_fichier_ressource
    BEFORE INSERT ON categorie_fichier_scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_fichier_ressource();


--
-- TOC entry 6986 (class 2620 OID 2600810)
-- Dependencies: 3969 1681
-- Name: insert_categorie_fichier_scenario; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_fichier_scenario
    BEFORE INSERT ON categorie_fichier_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_scenario();


--
-- TOC entry 6975 (class 2620 OID 2600811)
-- Dependencies: 3962 1680
-- Name: insert_categorie_glossaire; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_glossaire
    BEFORE INSERT ON categorie_fichier_glossaire
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_glossaire();


--
-- TOC entry 6989 (class 2620 OID 2600812)
-- Dependencies: 3970 1682
-- Name: insert_categorie_scenario_dynamique; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_categorie_scenario_dynamique
    BEFORE INSERT ON categorie_fichier_scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_scenario_dynamique();


--
-- TOC entry 7025 (class 2620 OID 2600813)
-- Dependencies: 4027 1684
-- Name: insert_etape_scorm; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_etape_scorm
    AFTER INSERT OR UPDATE ON fichier_etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE insert_etape_scorm();


--
-- TOC entry 7034 (class 2620 OID 2600814)
-- Dependencies: 4037 1685
-- Name: insert_fichier_ressource; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_fichier_ressource
    BEFORE INSERT ON fichier_ressource_fichier
    FOR EACH ROW
    EXECUTE PROCEDURE insert_fichier_ressource();


--
-- TOC entry 7036 (class 2620 OID 2600815)
-- Dependencies: 4038 1685
-- Name: insert_fichier_ressource; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_fichier_ressource
    BEFORE INSERT ON fichier_ressource_texte
    FOR EACH ROW
    EXECUTE PROCEDURE insert_fichier_ressource();


--
-- TOC entry 7038 (class 2620 OID 2600816)
-- Dependencies: 4039 1685
-- Name: insert_fichier_ressource; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_fichier_ressource
    BEFORE INSERT ON fichier_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE insert_fichier_ressource();


--
-- TOC entry 7041 (class 2620 OID 2600817)
-- Dependencies: 4040 1685
-- Name: insert_fichier_ressource; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_fichier_ressource
    BEFORE INSERT ON fichier_scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE insert_fichier_ressource();


--
-- TOC entry 7028 (class 2620 OID 2600818)
-- Dependencies: 4029 1685
-- Name: insert_fichier_ressource; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_fichier_ressource
    BEFORE INSERT ON fichier_glossaire
    FOR EACH ROW
    EXECUTE PROCEDURE insert_fichier_ressource();


--
-- TOC entry 7044 (class 2620 OID 2600819)
-- Dependencies: 4052 1686
-- Name: insert_formateur_droits_defaut; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_formateur_droits_defaut
    AFTER INSERT ON formation_participants
    FOR EACH ROW
    EXECUTE PROCEDURE insert_formateur_droits_defaut();


--
-- TOC entry 7029 (class 2620 OID 2600820)
-- Dependencies: 4029 1687
-- Name: insert_glossaire; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_glossaire
    AFTER INSERT ON fichier_glossaire
    FOR EACH ROW
    EXECUTE PROCEDURE insert_glossaire();


--
-- TOC entry 7063 (class 2620 OID 2600821)
-- Dependencies: 4144 1689
-- Name: insert_question_reponse_element; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_question_reponse_element
    AFTER INSERT ON question_reponse_element
    FOR EACH ROW
    EXECUTE PROCEDURE insert_question_reponse_element();


--
-- TOC entry 7039 (class 2620 OID 2600822)
-- Dependencies: 4039 1691
-- Name: insert_scenario; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_scenario
    AFTER INSERT ON fichier_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE insert_scenario();


--
-- TOC entry 7042 (class 2620 OID 2600823)
-- Dependencies: 4040 1692
-- Name: insert_scenario_dynamique; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER insert_scenario_dynamique
    AFTER INSERT ON fichier_scenario_dynamique
    FOR EACH ROW
    EXECUTE PROCEDURE insert_scenario_dynamique();


--
-- TOC entry 7084 (class 2620 OID 2600824)
-- Dependencies: 4190 1694
-- Name: insert_session_debut; Type: TRIGGER; Schema: contraintes; Owner: pgsql
--

CREATE TRIGGER insert_session_debut
    AFTER INSERT ON session_active
    FOR EACH ROW
    EXECUTE PROCEDURE insert_session_debut();


--
-- TOC entry 7085 (class 2620 OID 2600825)
-- Dependencies: 4190 1695
-- Name: insert_session_fin; Type: TRIGGER; Schema: contraintes; Owner: pgsql
--

CREATE TRIGGER insert_session_fin
    AFTER DELETE ON session_active
    FOR EACH ROW
    EXECUTE PROCEDURE insert_session_fin();


--
-- TOC entry 7050 (class 2620 OID 2600826)
-- Dependencies: 4072 51
-- Name: insert_submodule_module_individu_type; Type: TRIGGER; Schema: contraintes; Owner: pgsql
--

CREATE TRIGGER insert_submodule_module_individu_type
    AFTER INSERT OR UPDATE ON fw_module_individus_types
    FOR EACH ROW
    EXECUTE PROCEDURE insert_submodule_module_individu_type();


--
-- TOC entry 7052 (class 2620 OID 2600827)
-- Dependencies: 4092 48
-- Name: set_langue_message_others; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER set_langue_message_others
    AFTER INSERT ON langue_message
    FOR EACH ROW
    EXECUTE PROCEDURE insert_langue_message_others();


--
-- TOC entry 10406 (class 0 OID 0)
-- Dependencies: 7052
-- Name: TRIGGER set_langue_message_others ON langue_message; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TRIGGER set_langue_message_others ON langue_message IS 'permet de maintenir la cohésion des identifiants entre les différentes langues';


--
-- TOC entry 7082 (class 2620 OID 2600828)
-- Dependencies: 4184 1701
-- Name: update_serie_aleatoire_multitheme_categorie_serie; Type: TRIGGER; Schema: contraintes; Owner: postgres
--

CREATE TRIGGER update_serie_aleatoire_multitheme_categorie_serie
    BEFORE UPDATE ON serie_aleatoire_multitheme
    FOR EACH ROW
    EXECUTE PROCEDURE update_serie_aleatoire_multitheme_categorie_serie();


--
-- TOC entry 10407 (class 0 OID 0)
-- Dependencies: 7082
-- Name: TRIGGER update_serie_aleatoire_multitheme_categorie_serie ON serie_aleatoire_multitheme; Type: COMMENT; Schema: contraintes; Owner: postgres
--

COMMENT ON TRIGGER update_serie_aleatoire_multitheme_categorie_serie ON serie_aleatoire_multitheme IS 'declenche la fonction du même nom pour mettre à jour la table categorie_serie';


SET search_path = v2, pg_catalog;

--
-- TOC entry 7103 (class 2620 OID 2600829)
-- Dependencies: 4465 1796
-- Name: check_alerte_dates; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_alerte_dates
    BEFORE INSERT OR UPDATE ON lrt_alerte
    FOR EACH ROW
    EXECUTE PROCEDURE check_alerte_dates();


--
-- TOC entry 7089 (class 2620 OID 2600830)
-- Dependencies: 4411 62
-- Name: check_classe_organisme; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_classe_organisme
    BEFORE INSERT OR UPDATE ON cls_classe_individus
    FOR EACH ROW
    EXECUTE PROCEDURE check_classe_organisme();


--
-- TOC entry 7112 (class 2620 OID 2600831)
-- Dependencies: 4504 1798
-- Name: check_evaluation_qsrc_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_evaluation_qsrc_type
    BEFORE INSERT OR UPDATE ON qc_qsrc
    FOR EACH ROW
    EXECUTE PROCEDURE check_evaluation_qsrc_type();


--
-- TOC entry 7092 (class 2620 OID 2600832)
-- Dependencies: 4415 1799
-- Name: check_evaluation_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_evaluation_type
    BEFORE INSERT OR UPDATE ON fb_ftb
    FOR EACH ROW
    EXECUTE PROCEDURE check_evaluation_type('3');


--
-- TOC entry 7190 (class 2620 OID 2600833)
-- Dependencies: 4621 1801
-- Name: check_exotlc_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_exotlc_type
    BEFORE INSERT OR UPDATE ON xtlc_exotlc_plate_forme
    FOR EACH ROW
    EXECUTE PROCEDURE check_exotlc_type('1');


--
-- TOC entry 7188 (class 2620 OID 2600834)
-- Dependencies: 4620 1801
-- Name: check_exotlc_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_exotlc_type
    BEFORE INSERT OR UPDATE ON xtlc_exotlc_mail
    FOR EACH ROW
    EXECUTE PROCEDURE check_exotlc_type('2');


--
-- TOC entry 7093 (class 2620 OID 2600835)
-- Dependencies: 4419 1802
-- Name: check_fichier_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON fchr_fichier_correction
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('3');


--
-- TOC entry 7191 (class 2620 OID 2600836)
-- Dependencies: 4624 1802
-- Name: check_fichier_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON xtlc_fichier_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('2');


--
-- TOC entry 7132 (class 2620 OID 2600837)
-- Dependencies: 4529 1802
-- Name: check_fichier_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON rssrc_fichier_icone
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('6');


--
-- TOC entry 7106 (class 2620 OID 2600838)
-- Dependencies: 4472 1802
-- Name: check_fichier_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON ndvd_fichier_photo
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('4');


--
-- TOC entry 7146 (class 2620 OID 2600839)
-- Dependencies: 4546 1802
-- Name: check_fichier_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON scnr_fichier_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('5');


--
-- TOC entry 7136 (class 2620 OID 2600840)
-- Dependencies: 4532 1802
-- Name: check_fichier_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON rssrc_fichier_ressource_texte
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('1');


--
-- TOC entry 7134 (class 2620 OID 2600841)
-- Dependencies: 4531 1802
-- Name: check_fichier_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON rssrc_fichier_ressource_fichier
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('7');


--
-- TOC entry 7105 (class 2620 OID 2600842)
-- Dependencies: 4471 1802
-- Name: check_fichier_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON md_media
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('8');


--
-- TOC entry 7153 (class 2620 OID 2600843)
-- Dependencies: 4550 1802
-- Name: check_fichier_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_fichier_type
    BEFORE INSERT OR UPDATE ON scrm_fichier_etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE check_fichier_type('12');


--
-- TOC entry 7096 (class 2620 OID 2600844)
-- Dependencies: 4439 1803
-- Name: check_formateur_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_formateur_type
    BEFORE INSERT OR UPDATE ON frmtn_formation_participants
    FOR EACH ROW
    EXECUTE PROCEDURE check_formateur_type();


--
-- TOC entry 7189 (class 2620 OID 2600845)
-- Dependencies: 4620 1803
-- Name: check_formateur_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_formateur_type
    BEFORE INSERT OR UPDATE ON xtlc_exotlc_mail
    FOR EACH ROW
    EXECUTE PROCEDURE check_formateur_type();


--
-- TOC entry 7176 (class 2620 OID 2600846)
-- Dependencies: 4602 1804
-- Name: check_intervenant_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_intervenant_type
    BEFORE INSERT OR UPDATE ON vnmnt_evenement
    FOR EACH ROW
    EXECUTE PROCEDURE check_intervenant_type();


--
-- TOC entry 7177 (class 2620 OID 2600847)
-- Dependencies: 4602 1797
-- Name: check_intervention_date; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_intervention_date
    BEFORE INSERT OR UPDATE ON vnmnt_evenement
    FOR EACH ROW
    EXECUTE PROCEDURE check_calendrier_date();


--
-- TOC entry 7173 (class 2620 OID 2600848)
-- Dependencies: 4591 1805
-- Name: check_liste_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_liste_type
    BEFORE INSERT OR UPDATE ON tst_test
    FOR EACH ROW
    EXECUTE PROCEDURE check_liste_type('3');


--
-- TOC entry 7162 (class 2620 OID 2600849)
-- Dependencies: 4567 1805
-- Name: check_liste_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_liste_type
    BEFORE INSERT OR UPDATE ON srltr_serie_aleatoire
    FOR EACH ROW
    EXECUTE PROCEDURE check_liste_type('1');


--
-- TOC entry 7160 (class 2620 OID 2600850)
-- Dependencies: 4564 1806
-- Name: check_liste_type_serie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_liste_type_serie
    AFTER INSERT OR UPDATE ON sr_serie
    FOR EACH ROW
    EXECUTE PROCEDURE check_liste_type_serie();


--
-- TOC entry 7116 (class 2620 OID 2600851)
-- Dependencies: 4509 66
-- Name: check_media_question_reponse_element; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_media_question_reponse_element
    BEFORE INSERT OR UPDATE ON qr_media_question_reponse_element
    FOR EACH ROW
    EXECUTE PROCEDURE check_media_question_reponse_element();


--
-- TOC entry 7179 (class 2620 OID 2600852)
-- Dependencies: 4603 1807
-- Name: check_modalite; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_modalite
    BEFORE INSERT OR UPDATE ON vnmnt_evenement_presentiel
    FOR EACH ROW
    EXECUTE PROCEDURE check_modalite();


--
-- TOC entry 7117 (class 2620 OID 2600853)
-- Dependencies: 4510 1808
-- Name: check_qcm_elements_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_qcm_elements_type
    BEFORE INSERT OR UPDATE ON qr_qcm_elements
    FOR EACH ROW
    EXECUTE PROCEDURE check_qcm_elements_type();


--
-- TOC entry 7120 (class 2620 OID 2600854)
-- Dependencies: 4515 1809
-- Name: check_question_reponse_elements_types; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_question_reponse_elements_types
    BEFORE INSERT OR UPDATE ON qr_question_reponse_elements
    FOR EACH ROW
    EXECUTE PROCEDURE check_question_reponse_elements_types();


--
-- TOC entry 7138 (class 2620 OID 2600855)
-- Dependencies: 4533 1810
-- Name: check_ressource_dates; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_ressource_dates
    BEFORE INSERT OR UPDATE ON rssrc_formation_ressources
    FOR EACH ROW
    EXECUTE PROCEDURE check_ressource_dates();


--
-- TOC entry 7139 (class 2620 OID 2600856)
-- Dependencies: 4536 1811
-- Name: check_ressource_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_ressource_type
    BEFORE INSERT OR UPDATE ON rssrc_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE check_ressource_type();


--
-- TOC entry 7133 (class 2620 OID 2600857)
-- Dependencies: 4530 1811
-- Name: check_ressource_type; Type: TRIGGER; Schema: v2; Owner: pgsql
--

CREATE TRIGGER check_ressource_type
    BEFORE INSERT OR UPDATE ON rssrc_fichier_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE check_ressource_type();


--
-- TOC entry 7164 (class 2620 OID 2600858)
-- Dependencies: 4573 1812
-- Name: check_serie_aleatoire_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_serie_aleatoire_type
    BEFORE INSERT OR UPDATE ON srltrmltthm_serie_aleatoire_multitheme
    FOR EACH ROW
    EXECUTE PROCEDURE check_serie_aleatoire_type('3');


--
-- TOC entry 7163 (class 2620 OID 2600859)
-- Dependencies: 4572 1812
-- Name: check_serie_aleatoire_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_serie_aleatoire_type
    BEFORE INSERT OR UPDATE ON srltrmltsr_serie_aleatoire_multiserie
    FOR EACH ROW
    EXECUTE PROCEDURE check_serie_aleatoire_type('2');


--
-- TOC entry 7161 (class 2620 OID 2600860)
-- Dependencies: 4566 72
-- Name: check_serie_evaluation; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_serie_evaluation
    BEFORE INSERT OR UPDATE ON sr_serie_evaluations
    FOR EACH ROW
    EXECUTE PROCEDURE check_serie_evaluation();


--
-- TOC entry 7159 (class 2620 OID 2600861)
-- Dependencies: 4563 1800
-- Name: check_serie_tentative; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_serie_tentative
    BEFORE INSERT OR UPDATE ON sr_resultat_serie_tentative_ftb
    FOR EACH ROW
    EXECUTE PROCEDURE check_evaluation_type2('3');


--
-- TOC entry 7169 (class 2620 OID 2600862)
-- Dependencies: 4585 1813
-- Name: check_stagiaire_formation; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_stagiaire_formation
    BEFORE INSERT OR UPDATE ON tp_resultat
    FOR EACH ROW
    EXECUTE PROCEDURE check_stagiaire_formation();


--
-- TOC entry 7102 (class 2620 OID 2600863)
-- Dependencies: 4463 1814
-- Name: check_stagiaire_type; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_stagiaire_type
    BEFORE INSERT OR UPDATE ON grll_stagiaire_grille
    FOR EACH ROW
    EXECUTE PROCEDURE check_stagiaire_type();


--
-- TOC entry 7107 (class 2620 OID 2600864)
-- Dependencies: 4490 1815
-- Name: check_type_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON prcrs_parcours
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('1');


--
-- TOC entry 7094 (class 2620 OID 2600865)
-- Dependencies: 4426 1815
-- Name: check_type_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON frm_etape_forum
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('2');


--
-- TOC entry 7104 (class 2620 OID 2600866)
-- Dependencies: 4466 1815
-- Name: check_type_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON lst_liste
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('4');


--
-- TOC entry 7187 (class 2620 OID 2600867)
-- Dependencies: 4617 1815
-- Name: check_type_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON xtlc_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('5');


--
-- TOC entry 7148 (class 2620 OID 2600868)
-- Dependencies: 4547 1815
-- Name: check_type_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON scnr_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('6');


--
-- TOC entry 7131 (class 2620 OID 2600869)
-- Dependencies: 4528 1815
-- Name: check_type_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON rssrc_etape_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('7');


--
-- TOC entry 7088 (class 2620 OID 2600870)
-- Dependencies: 4405 1815
-- Name: check_type_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON c_etape_chat
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('8');


--
-- TOC entry 7151 (class 2620 OID 2600871)
-- Dependencies: 4549 1815
-- Name: check_type_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_etape
    BEFORE INSERT OR UPDATE ON scrm_etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_etape('3');


--
-- TOC entry 7118 (class 2620 OID 2600872)
-- Dependencies: 4511 1816
-- Name: check_type_question; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_question
    BEFORE INSERT OR UPDATE ON qr_question
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_question();


--
-- TOC entry 7122 (class 2620 OID 2600873)
-- Dependencies: 4518 1817
-- Name: check_type_reponse; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER check_type_reponse
    BEFORE INSERT OR UPDATE ON qr_reponse
    FOR EACH ROW
    EXECUTE PROCEDURE check_type_reponse();


--
-- TOC entry 7149 (class 2620 OID 2600874)
-- Dependencies: 4547 1818
-- Name: del_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_etape
    AFTER DELETE ON scnr_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_etape();


--
-- TOC entry 7152 (class 2620 OID 2600875)
-- Dependencies: 4549 1818
-- Name: del_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_etape
    AFTER DELETE ON scrm_etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE del_etape();


--
-- TOC entry 7140 (class 2620 OID 2600876)
-- Dependencies: 4536 1818
-- Name: del_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_etape
    AFTER DELETE ON rssrc_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE del_etape();


--
-- TOC entry 7178 (class 2620 OID 2600877)
-- Dependencies: 4602 106
-- Name: del_evenement_presentiel; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_evenement_presentiel
    AFTER DELETE ON vnmnt_evenement
    FOR EACH ROW
    EXECUTE PROCEDURE del_evenement_presentiel();


--
-- TOC entry 10408 (class 0 OID 0)
-- Dependencies: 7178
-- Name: TRIGGER del_evenement_presentiel ON vnmnt_evenement; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TRIGGER del_evenement_presentiel ON vnmnt_evenement IS 'supprime l''evet presentiel associÃ©';


--
-- TOC entry 7095 (class 2620 OID 2600878)
-- Dependencies: 4437 1819
-- Name: del_formation; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_formation
    BEFORE DELETE ON frmtn_formation
    FOR EACH ROW
    EXECUTE PROCEDURE del_formation();


--
-- TOC entry 7108 (class 2620 OID 2600879)
-- Dependencies: 4490 1820
-- Name: del_parcours; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_parcours
    BEFORE DELETE ON prcrs_parcours
    FOR EACH ROW
    EXECUTE PROCEDURE del_parcours();


--
-- TOC entry 7168 (class 2620 OID 2600880)
-- Dependencies: 4584 111
-- Name: del_parcours_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_parcours_etape
    AFTER DELETE ON tp_parcours_etapes
    FOR EACH ROW
    EXECUTE PROCEDURE del_parcours_etape();


--
-- TOC entry 10409 (class 0 OID 0)
-- Dependencies: 7168
-- Name: TRIGGER del_parcours_etape ON tp_parcours_etapes; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TRIGGER del_parcours_etape ON tp_parcours_etapes IS 'pour supprimer l''etape si type 10
(etape parcours oriente)';


--
-- TOC entry 7110 (class 2620 OID 2600881)
-- Dependencies: 4496 112
-- Name: del_positionnement_evaluations_a_generer; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_positionnement_evaluations_a_generer
    BEFORE UPDATE ON pstnnmnt_positionnement_choix_evaluations
    FOR EACH ROW
    EXECUTE PROCEDURE del_positionnement_evaluations_a_generer();


--
-- TOC entry 7121 (class 2620 OID 2600882)
-- Dependencies: 4515 116
-- Name: del_question_reponse_element_media; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_question_reponse_element_media
    AFTER DELETE ON qr_question_reponse_elements
    FOR EACH ROW
    EXECUTE PROCEDURE del_question_reponse_element_media();


--
-- TOC entry 7158 (class 2620 OID 2600883)
-- Dependencies: 4561 120
-- Name: del_serie_aleatoire_evaluations; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_serie_aleatoire_evaluations
    AFTER DELETE ON sr_resultat_serie
    FOR EACH ROW
    EXECUTE PROCEDURE del_serie_aleatoire_configuree_evaluations();


--
-- TOC entry 7170 (class 2620 OID 2600884)
-- Dependencies: 4585 121
-- Name: del_serie_aleatoire_evaluations; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_serie_aleatoire_evaluations
    AFTER DELETE ON tp_resultat
    FOR EACH ROW
    EXECUTE PROCEDURE del_serie_aleatoire_evaluations();


--
-- TOC entry 10410 (class 0 OID 0)
-- Dependencies: 7170
-- Name: TRIGGER del_serie_aleatoire_evaluations ON tp_resultat; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TRIGGER del_serie_aleatoire_evaluations ON tp_resultat IS 'supprime ds serie_aleatoire_evaluation si
l''etape supprimÃ©e est une serie aleatoire';


--
-- TOC entry 7101 (class 2620 OID 2600885)
-- Dependencies: 4462 123
-- Name: del_stagiaire_grille; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_stagiaire_grille
    AFTER DELETE ON grll_grille_resultats
    FOR EACH ROW
    EXECUTE PROCEDURE del_stagiaire_grille();


--
-- TOC entry 7098 (class 2620 OID 2600886)
-- Dependencies: 4456 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON grll_categorie_capacite
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7099 (class 2620 OID 2600887)
-- Dependencies: 4457 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON grll_categorie_capacite_titre
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7183 (class 2620 OID 2600888)
-- Dependencies: 4611 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON xtlc_categorie_fichier_correction
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7180 (class 2620 OID 2600889)
-- Dependencies: 4609 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON xtlc_categorie_critere
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7141 (class 2620 OID 2600890)
-- Dependencies: 4540 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON scnr_categorie_fichier_css
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7184 (class 2620 OID 2600891)
-- Dependencies: 4612 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON xtlc_categorie_fichier_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7090 (class 2620 OID 2600892)
-- Dependencies: 4414 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON fb_categorie_ftb
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7100 (class 2620 OID 2600893)
-- Dependencies: 4458 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON grll_categorie_grille
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7175 (class 2620 OID 2600894)
-- Dependencies: 4596 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON vltn_categorie_fichier_media_evaluation
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7185 (class 2620 OID 2600895)
-- Dependencies: 4613 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON xtlc_categorie_fichier_media_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7142 (class 2620 OID 2600896)
-- Dependencies: 4541 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON scnr_categorie_fichier_media_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7186 (class 2620 OID 2600897)
-- Dependencies: 4614 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON xtlc_categorie_modele_correction
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7109 (class 2620 OID 2600898)
-- Dependencies: 4492 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON pstnnmnt_categorie_positionnement
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7111 (class 2620 OID 2600899)
-- Dependencies: 4503 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON qc_categorie_qsrc
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7127 (class 2620 OID 2600900)
-- Dependencies: 4524 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON rssrc_categorie_fichier_ressource_fichier
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7143 (class 2620 OID 2600901)
-- Dependencies: 4542 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON scnr_categorie_fichier_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7150 (class 2620 OID 2600902)
-- Dependencies: 4548 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON scrm_categorie_fichier_etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7155 (class 2620 OID 2600903)
-- Dependencies: 4560 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON sr_categorie_serie
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7115 (class 2620 OID 2600904)
-- Dependencies: 4507 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON qr_categorie_sondage_element
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7113 (class 2620 OID 2600905)
-- Dependencies: 4505 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON qr_categorie_question_reponse
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7174 (class 2620 OID 2600906)
-- Dependencies: 4595 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON vltn_categorie_evaluation
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7167 (class 2620 OID 2600907)
-- Dependencies: 4579 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON tp_categorie_etape
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7181 (class 2620 OID 2600908)
-- Dependencies: 4610 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON xtlc_categorie_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7144 (class 2620 OID 2600909)
-- Dependencies: 4543 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON scnr_categorie_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7123 (class 2620 OID 2600910)
-- Dependencies: 4522 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON rssrc_categorie_etape_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7129 (class 2620 OID 2600911)
-- Dependencies: 4525 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON rssrc_categorie_fichier_ressource_texte
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7126 (class 2620 OID 2600912)
-- Dependencies: 4523 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON rssrc_categorie_fichier_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7171 (class 2620 OID 2600913)
-- Dependencies: 4588 1821
-- Name: del_theme_categorie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_categorie
    AFTER DELETE ON tst_categorie_test
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_categorie();


--
-- TOC entry 7156 (class 2620 OID 2600914)
-- Dependencies: 4560 126
-- Name: del_theme_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_etape
    AFTER DELETE ON sr_categorie_serie
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_etape();


--
-- TOC entry 7124 (class 2620 OID 2600915)
-- Dependencies: 4522 126
-- Name: del_theme_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER del_theme_etape
    AFTER DELETE ON rssrc_categorie_etape_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE del_theme_etape();


--
-- TOC entry 7165 (class 2620 OID 2600916)
-- Dependencies: 4573 127
-- Name: delete_serie_aleatoire_multitheme_categorie_serie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER delete_serie_aleatoire_multitheme_categorie_serie
    AFTER DELETE ON srltrmltthm_serie_aleatoire_multitheme
    FOR EACH ROW
    EXECUTE PROCEDURE delete_serie_aleatoire_multitheme_categorie_serie();


--
-- TOC entry 10411 (class 0 OID 0)
-- Dependencies: 7165
-- Name: TRIGGER delete_serie_aleatoire_multitheme_categorie_serie ON srltrmltthm_serie_aleatoire_multitheme; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TRIGGER delete_serie_aleatoire_multitheme_categorie_serie ON srltrmltthm_serie_aleatoire_multitheme IS 'declenche la fonction du mÃªme nom pour supprimer un enregistrement ds categorie_serie';


--
-- TOC entry 7157 (class 2620 OID 2600917)
-- Dependencies: 4560 282
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON sr_categorie_serie
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 7145 (class 2620 OID 2600918)
-- Dependencies: 4543 282
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON scnr_categorie_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 7172 (class 2620 OID 2600919)
-- Dependencies: 4588 282
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON tst_categorie_test
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 7182 (class 2620 OID 2600920)
-- Dependencies: 4610 282
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON xtlc_categorie_exotlc
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 7125 (class 2620 OID 2600921)
-- Dependencies: 4522 282
-- Name: insert_categorie_etape; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_categorie_etape
    AFTER INSERT ON rssrc_categorie_etape_ressource
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_etape();


--
-- TOC entry 7114 (class 2620 OID 2600922)
-- Dependencies: 4505 283
-- Name: insert_categorie_evaluation; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_categorie_evaluation
    AFTER INSERT ON qr_categorie_question_reponse
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_evaluation();


--
-- TOC entry 7091 (class 2620 OID 2600923)
-- Dependencies: 4414 283
-- Name: insert_categorie_evaluation; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_categorie_evaluation
    AFTER INSERT ON fb_categorie_ftb
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_evaluation();


--
-- TOC entry 7128 (class 2620 OID 2600924)
-- Dependencies: 4524 284
-- Name: insert_categorie_fichier_ressource; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_categorie_fichier_ressource
    AFTER INSERT ON rssrc_categorie_fichier_ressource_fichier
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_fichier_ressource();


--
-- TOC entry 7130 (class 2620 OID 2600925)
-- Dependencies: 4525 284
-- Name: insert_categorie_fichier_ressource; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_categorie_fichier_ressource
    AFTER INSERT ON rssrc_categorie_fichier_ressource_texte
    FOR EACH ROW
    EXECUTE PROCEDURE insert_categorie_fichier_ressource();


--
-- TOC entry 7154 (class 2620 OID 2600926)
-- Dependencies: 4550 1822
-- Name: insert_etape_scorm; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_etape_scorm
    AFTER INSERT OR UPDATE ON scrm_fichier_etape_scorm
    FOR EACH ROW
    EXECUTE PROCEDURE insert_etape_scorm();


--
-- TOC entry 7135 (class 2620 OID 2600927)
-- Dependencies: 4531 286
-- Name: insert_fichier_ressource; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_fichier_ressource
    BEFORE INSERT ON rssrc_fichier_ressource_fichier
    FOR EACH ROW
    EXECUTE PROCEDURE insert_fichier_ressource();


--
-- TOC entry 7137 (class 2620 OID 2600928)
-- Dependencies: 4532 286
-- Name: insert_fichier_ressource; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_fichier_ressource
    BEFORE INSERT ON rssrc_fichier_ressource_texte
    FOR EACH ROW
    EXECUTE PROCEDURE insert_fichier_ressource();


--
-- TOC entry 7097 (class 2620 OID 2600929)
-- Dependencies: 4439 287
-- Name: insert_formateur_droits_defaut; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_formateur_droits_defaut
    AFTER INSERT ON frmtn_formation_participants
    FOR EACH ROW
    EXECUTE PROCEDURE insert_formateur_droits_defaut();


--
-- TOC entry 7119 (class 2620 OID 2600930)
-- Dependencies: 4514 1823
-- Name: insert_question_reponse_element; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_question_reponse_element
    AFTER INSERT ON qr_question_reponse_element
    FOR EACH ROW
    EXECUTE PROCEDURE insert_question_reponse_element();


--
-- TOC entry 7147 (class 2620 OID 2600931)
-- Dependencies: 4546 1824
-- Name: insert_scenario; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER insert_scenario
    AFTER INSERT ON scnr_fichier_scenario
    FOR EACH ROW
    EXECUTE PROCEDURE insert_scenario();


--
-- TOC entry 7166 (class 2620 OID 2600932)
-- Dependencies: 4573 700
-- Name: update_serie_aleatoire_multitheme_categorie_serie; Type: TRIGGER; Schema: v2; Owner: postgres
--

CREATE TRIGGER update_serie_aleatoire_multitheme_categorie_serie
    BEFORE UPDATE ON srltrmltthm_serie_aleatoire_multitheme
    FOR EACH ROW
    EXECUTE PROCEDURE update_serie_aleatoire_multitheme_categorie_serie();


--
-- TOC entry 10412 (class 0 OID 0)
-- Dependencies: 7166
-- Name: TRIGGER update_serie_aleatoire_multitheme_categorie_serie ON srltrmltthm_serie_aleatoire_multitheme; Type: COMMENT; Schema: v2; Owner: postgres
--

COMMENT ON TRIGGER update_serie_aleatoire_multitheme_categorie_serie ON srltrmltthm_serie_aleatoire_multitheme IS 'declenche la fonction du mÃªme nom pour mettre Ã  jour la table categorie_serie';


SET search_path = contraintes, pg_catalog;

--
-- TOC entry 6387 (class 2606 OID 2960228)
-- Dependencies: 5558 4049 3931
-- Name: alerte_formation_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY alerte
    ADD CONSTRAINT alerte_formation_fkey FOREIGN KEY (formation) REFERENCES formation(id) ON UPDATE RESTRICT ON DELETE SET NULL;


--
-- TOC entry 6451 (class 2606 OID 2600938)
-- Dependencies: 5424 3980 3980
-- Name: categorie_scenario_id_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_scenario
    ADD CONSTRAINT categorie_scenario_id_fkey FOREIGN KEY (id) REFERENCES categorie_scenario(id);


--
-- TOC entry 6491 (class 2606 OID 2600943)
-- Dependencies: 5491 4014 4018
-- Name: exotlc_modele_correction_id_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY exotlc_modele_correction
    ADD CONSTRAINT exotlc_modele_correction_id_fkey FOREIGN KEY (id) REFERENCES exotlc(id);


--
-- TOC entry 6494 (class 2606 OID 2600948)
-- Dependencies: 5507 4023 4024
-- Name: fichier_bloc_scenario_id_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_bloc_scenario
    ADD CONSTRAINT fichier_bloc_scenario_id_fkey FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6507 (class 2606 OID 2600953)
-- Dependencies: 5507 4023 4036
-- Name: fichier_ressource_id_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY fichier_ressource
    ADD CONSTRAINT fichier_ressource_id_fkey FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6389 (class 2606 OID 2600958)
-- Dependencies: 5351 3943 3944
-- Name: fk_capacite_titre_capacites_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY capacite_titre_capacites
    ADD CONSTRAINT fk_capacite_titre_capacites_1 FOREIGN KEY (capacite_titre) REFERENCES capacite_titre(id);


--
-- TOC entry 6388 (class 2606 OID 2600963)
-- Dependencies: 5349 3941 3944
-- Name: fk_capacite_titre_capacites_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY capacite_titre_capacites
    ADD CONSTRAINT fk_capacite_titre_capacites_2 FOREIGN KEY (capacite) REFERENCES capacite(id);


--
-- TOC entry 6391 (class 2606 OID 2600968)
-- Dependencies: 5850 4196 4196 4196 3949 3949 3949
-- Name: fk_categorie_capacite_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_capacite
    ADD CONSTRAINT fk_categorie_capacite_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6390 (class 2606 OID 2600973)
-- Dependencies: 5349 3941 3949
-- Name: fk_categorie_capacite_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_capacite
    ADD CONSTRAINT fk_categorie_capacite_2 FOREIGN KEY (id) REFERENCES capacite(id) ON DELETE CASCADE;


--
-- TOC entry 6393 (class 2606 OID 2600978)
-- Dependencies: 5850 4196 4196 4196 3950 3950 3950
-- Name: fk_categorie_capacite_titre_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_capacite_titre
    ADD CONSTRAINT fk_categorie_capacite_titre_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6392 (class 2606 OID 2600983)
-- Dependencies: 5351 3943 3950
-- Name: fk_categorie_capacite_titre_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_capacite_titre
    ADD CONSTRAINT fk_categorie_capacite_titre_2 FOREIGN KEY (id) REFERENCES capacite_titre(id) ON DELETE CASCADE;


--
-- TOC entry 6395 (class 2606 OID 2600988)
-- Dependencies: 5850 4196 4196 4196 3951 3951 3951
-- Name: fk_categorie_critere_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_critere
    ADD CONSTRAINT fk_categorie_critere_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6394 (class 2606 OID 2600993)
-- Dependencies: 5450 3993 3951
-- Name: fk_categorie_critere_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_critere
    ADD CONSTRAINT fk_categorie_critere_2 FOREIGN KEY (id) REFERENCES critere(id) ON DELETE CASCADE;


--
-- TOC entry 6411 (class 2606 OID 2600998)
-- Dependencies: 5850 4196 4196 4196 3959 3959 3959
-- Name: fk_categorie_css_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_css
    ADD CONSTRAINT fk_categorie_css_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6410 (class 2606 OID 2601003)
-- Dependencies: 5513 4026 3959
-- Name: fk_categorie_css_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_css
    ADD CONSTRAINT fk_categorie_css_2 FOREIGN KEY (id) REFERENCES fichier_css(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6397 (class 2606 OID 2601008)
-- Dependencies: 5850 4196 4196 4196 3952 3952 3952
-- Name: fk_categorie_etape_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_etape
    ADD CONSTRAINT fk_categorie_etape_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6396 (class 2606 OID 2601013)
-- Dependencies: 5461 4001 3952
-- Name: fk_categorie_etape_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_etape
    ADD CONSTRAINT fk_categorie_etape_2 FOREIGN KEY (id) REFERENCES etape(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6399 (class 2606 OID 2601018)
-- Dependencies: 5850 4196 4196 4196 3953 3953 3953
-- Name: fk_categorie_etape_forum_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_etape_forum
    ADD CONSTRAINT fk_categorie_etape_forum_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6398 (class 2606 OID 2601023)
-- Dependencies: 5465 4003 3953
-- Name: fk_categorie_etape_forum_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_etape_forum
    ADD CONSTRAINT fk_categorie_etape_forum_2 FOREIGN KEY (id) REFERENCES etape_forum(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6403 (class 2606 OID 2601028)
-- Dependencies: 5850 4196 4196 4196 3955 3955 3955
-- Name: fk_categorie_evaluation_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_evaluation
    ADD CONSTRAINT fk_categorie_evaluation_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6402 (class 2606 OID 2601033)
-- Dependencies: 5481 4009 3955
-- Name: fk_categorie_evaluation_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_evaluation
    ADD CONSTRAINT fk_categorie_evaluation_2 FOREIGN KEY (id) REFERENCES evaluation(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6405 (class 2606 OID 2601038)
-- Dependencies: 5850 4196 4196 4196 3956 3956 3956
-- Name: fk_categorie_exotlc_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_exotlc
    ADD CONSTRAINT fk_categorie_exotlc_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6404 (class 2606 OID 2601043)
-- Dependencies: 5491 4014 3956
-- Name: fk_categorie_exotlc_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_exotlc
    ADD CONSTRAINT fk_categorie_exotlc_2 FOREIGN KEY (id) REFERENCES exotlc(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6407 (class 2606 OID 2601048)
-- Dependencies: 5850 4196 4196 4196 3957 3957 3957
-- Name: fk_categorie_fichier_bloc_scenario_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_bloc_scenario
    ADD CONSTRAINT fk_categorie_fichier_bloc_scenario_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6406 (class 2606 OID 2601053)
-- Dependencies: 5509 4024 3957
-- Name: fk_categorie_fichier_bloc_scenario_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_bloc_scenario
    ADD CONSTRAINT fk_categorie_fichier_bloc_scenario_2 FOREIGN KEY (id) REFERENCES fichier_bloc_scenario(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6409 (class 2606 OID 2601058)
-- Dependencies: 5850 4196 4196 4196 3958 3958 3958
-- Name: fk_categorie_fichier_correction_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_correction
    ADD CONSTRAINT fk_categorie_fichier_correction_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6408 (class 2606 OID 2601063)
-- Dependencies: 5511 4025 3958
-- Name: fk_categorie_fichier_correction_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_correction
    ADD CONSTRAINT fk_categorie_fichier_correction_2 FOREIGN KEY (id) REFERENCES fichier_correction(id) ON DELETE CASCADE;


--
-- TOC entry 6415 (class 2606 OID 2601068)
-- Dependencies: 5850 4196 4196 4196 3961 3961 3961
-- Name: fk_categorie_fichier_exotlc_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_exotlc
    ADD CONSTRAINT fk_categorie_fichier_exotlc_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6414 (class 2606 OID 2601073)
-- Dependencies: 5518 4028 3961
-- Name: fk_categorie_fichier_exotlc_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_exotlc
    ADD CONSTRAINT fk_categorie_fichier_exotlc_2 FOREIGN KEY (id) REFERENCES fichier_exotlc(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6417 (class 2606 OID 2601078)
-- Dependencies: 5850 4196 4196 4196 3962 3962 3962
-- Name: fk_categorie_fichier_glossaire_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_glossaire
    ADD CONSTRAINT fk_categorie_fichier_glossaire_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6416 (class 2606 OID 2601083)
-- Dependencies: 5520 4029 3962
-- Name: fk_categorie_fichier_glossaire_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_glossaire
    ADD CONSTRAINT fk_categorie_fichier_glossaire_2 FOREIGN KEY (id) REFERENCES fichier_glossaire(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6425 (class 2606 OID 2601088)
-- Dependencies: 5850 4196 4196 4196 3966 3966 3966
-- Name: fk_categorie_fichier_ressource_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_ressource
    ADD CONSTRAINT fk_categorie_fichier_ressource_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6424 (class 2606 OID 2601093)
-- Dependencies: 5535 4036 3966
-- Name: fk_categorie_fichier_ressource_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_ressource
    ADD CONSTRAINT fk_categorie_fichier_ressource_2 FOREIGN KEY (id) REFERENCES fichier_ressource(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6426 (class 2606 OID 2601098)
-- Dependencies: 5850 4196 4196 4196 3967 3967 3967
-- Name: fk_categorie_fichier_ressource_fichier_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_ressource_fichier
    ADD CONSTRAINT fk_categorie_fichier_ressource_fichier_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6429 (class 2606 OID 2601103)
-- Dependencies: 5850 4196 4196 4196 3969 3969 3969
-- Name: fk_categorie_fichier_scenario_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_scenario
    ADD CONSTRAINT fk_categorie_fichier_scenario_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6428 (class 2606 OID 2601108)
-- Dependencies: 5542 4039 3969
-- Name: fk_categorie_fichier_scenario_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_scenario
    ADD CONSTRAINT fk_categorie_fichier_scenario_2 FOREIGN KEY (id) REFERENCES fichier_scenario(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6431 (class 2606 OID 2601113)
-- Dependencies: 5850 4196 4196 4196 3970 3970 3970
-- Name: fk_categorie_fichier_scenario_dynamique_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_scenario_dynamique
    ADD CONSTRAINT fk_categorie_fichier_scenario_dynamique_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6430 (class 2606 OID 2601118)
-- Dependencies: 5544 4040 3970
-- Name: fk_categorie_fichier_scenario_dynamique_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_scenario_dynamique
    ADD CONSTRAINT fk_categorie_fichier_scenario_dynamique_2 FOREIGN KEY (id) REFERENCES fichier_scenario_dynamique(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6433 (class 2606 OID 2601123)
-- Dependencies: 5850 4196 4196 4196 3971 3971 3971
-- Name: fk_categorie_fichier_slide_scenario_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_slide_scenario
    ADD CONSTRAINT fk_categorie_fichier_slide_scenario_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6432 (class 2606 OID 2601128)
-- Dependencies: 5550 4042 3971
-- Name: fk_categorie_fichier_slide_scenario_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_slide_scenario
    ADD CONSTRAINT fk_categorie_fichier_slide_scenario_2 FOREIGN KEY (id) REFERENCES fichier_slide_scenario(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6427 (class 2606 OID 2601133)
-- Dependencies: 5850 4196 4196 4196 3968 3968 3968
-- Name: fk_categorie_fichier_texte_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_ressource_texte
    ADD CONSTRAINT fk_categorie_fichier_texte_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6435 (class 2606 OID 2601138)
-- Dependencies: 5850 4196 4196 4196 3972 3972 3972
-- Name: fk_categorie_ftb_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_ftb
    ADD CONSTRAINT fk_categorie_ftb_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6434 (class 2606 OID 2601143)
-- Dependencies: 5584 4060 3972
-- Name: fk_categorie_ftb_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_ftb
    ADD CONSTRAINT fk_categorie_ftb_2 FOREIGN KEY (id) REFERENCES ftb(id) ON DELETE CASCADE;


--
-- TOC entry 6437 (class 2606 OID 2601148)
-- Dependencies: 5850 4196 4196 4196 3973 3973 3973
-- Name: fk_categorie_glossaire_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_glossaire
    ADD CONSTRAINT fk_categorie_glossaire_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6436 (class 2606 OID 2601153)
-- Dependencies: 5613 4078 3973
-- Name: fk_categorie_glossaire_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_glossaire
    ADD CONSTRAINT fk_categorie_glossaire_2 FOREIGN KEY (id) REFERENCES glossaire(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6439 (class 2606 OID 2601158)
-- Dependencies: 5850 4196 4196 4196 3974 3974 3974
-- Name: fk_categorie_grille_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_grille
    ADD CONSTRAINT fk_categorie_grille_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6438 (class 2606 OID 2601163)
-- Dependencies: 5619 4081 3974
-- Name: fk_categorie_grille_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_grille
    ADD CONSTRAINT fk_categorie_grille_2 FOREIGN KEY (id) REFERENCES grille(id) ON DELETE CASCADE;


--
-- TOC entry 6423 (class 2606 OID 2601168)
-- Dependencies: 5850 4196 4196 4196 3965 3965 3965
-- Name: fk_categorie_media_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_media_scenario
    ADD CONSTRAINT fk_categorie_media_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6422 (class 2606 OID 2601173)
-- Dependencies: 5528 4033 3965
-- Name: fk_categorie_media_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_media_scenario
    ADD CONSTRAINT fk_categorie_media_2 FOREIGN KEY (id) REFERENCES fichier_media_scenario(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6419 (class 2606 OID 2601178)
-- Dependencies: 5850 4196 4196 4196 3963 3963 3963
-- Name: fk_categorie_media_evaluation_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_media_evaluation
    ADD CONSTRAINT fk_categorie_media_evaluation_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6418 (class 2606 OID 2601183)
-- Dependencies: 5524 4031 3963
-- Name: fk_categorie_media_evaluation_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_media_evaluation
    ADD CONSTRAINT fk_categorie_media_evaluation_2 FOREIGN KEY (id) REFERENCES fichier_media_evaluation(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6421 (class 2606 OID 2601188)
-- Dependencies: 5850 4196 4196 4196 3964 3964 3964
-- Name: fk_categorie_media_exotlc_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_media_exotlc
    ADD CONSTRAINT fk_categorie_media_exotlc_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6420 (class 2606 OID 2601193)
-- Dependencies: 5526 4032 3964
-- Name: fk_categorie_media_exotlc_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_media_exotlc
    ADD CONSTRAINT fk_categorie_media_exotlc_2 FOREIGN KEY (id) REFERENCES fichier_media_exotlc(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6441 (class 2606 OID 2601198)
-- Dependencies: 5850 4196 4196 4196 3975 3975 3975
-- Name: fk_categorie_modele_correction_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_modele_correction
    ADD CONSTRAINT fk_categorie_modele_correction_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6440 (class 2606 OID 2601203)
-- Dependencies: 5659 4107 3975
-- Name: fk_categorie_modele_correction_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_modele_correction
    ADD CONSTRAINT fk_categorie_modele_correction_2 FOREIGN KEY (id) REFERENCES modele_correction(id) ON DELETE CASCADE;


--
-- TOC entry 6443 (class 2606 OID 2601208)
-- Dependencies: 5850 4196 4196 4196 3976 3976 3976
-- Name: fk_categorie_positionnement_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_positionnement
    ADD CONSTRAINT fk_categorie_positionnement_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6442 (class 2606 OID 2601213)
-- Dependencies: 5700 4133 3976
-- Name: fk_categorie_positionnement_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_positionnement
    ADD CONSTRAINT fk_categorie_positionnement_2 FOREIGN KEY (id) REFERENCES positionnement(id) ON DELETE CASCADE;


--
-- TOC entry 6449 (class 2606 OID 2601218)
-- Dependencies: 5850 4196 4196 4196 3979 3979 3979
-- Name: fk_categorie_qcm_element_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_question_reponse_element
    ADD CONSTRAINT fk_categorie_qcm_element_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6448 (class 2606 OID 2601223)
-- Dependencies: 5732 4144 3979
-- Name: fk_categorie_qcm_element_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_question_reponse_element
    ADD CONSTRAINT fk_categorie_qcm_element_2 FOREIGN KEY (id) REFERENCES question_reponse_element(id) ON DELETE CASCADE;


--
-- TOC entry 6445 (class 2606 OID 2601228)
-- Dependencies: 5850 4196 4196 4196 3977 3977 3977
-- Name: fk_categorie_qsrc_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_qsrc
    ADD CONSTRAINT fk_categorie_qsrc_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6444 (class 2606 OID 2601233)
-- Dependencies: 5722 4140 3977
-- Name: fk_categorie_qsrc_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_qsrc
    ADD CONSTRAINT fk_categorie_qsrc_2 FOREIGN KEY (id) REFERENCES qsrc(id) ON DELETE CASCADE;


--
-- TOC entry 6447 (class 2606 OID 2601238)
-- Dependencies: 5850 4196 4196 4196 3978 3978 3978
-- Name: fk_categorie_question_reponse_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_question_reponse
    ADD CONSTRAINT fk_categorie_question_reponse_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6446 (class 2606 OID 2601243)
-- Dependencies: 5728 4142 3978
-- Name: fk_categorie_question_reponse_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_question_reponse
    ADD CONSTRAINT fk_categorie_question_reponse_2 FOREIGN KEY (id) REFERENCES question_reponse(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6401 (class 2606 OID 2601248)
-- Dependencies: 5850 4196 4196 4196 3954 3954 3954
-- Name: fk_categorie_ressource_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_etape_ressource
    ADD CONSTRAINT fk_categorie_ressource_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6400 (class 2606 OID 2601253)
-- Dependencies: 5472 4004 3954
-- Name: fk_categorie_ressource_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_etape_ressource
    ADD CONSTRAINT fk_categorie_ressource_2 FOREIGN KEY (id) REFERENCES etape_ressource(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6450 (class 2606 OID 2601258)
-- Dependencies: 5850 4196 4196 4196 3980 3980 3980
-- Name: fk_categorie_scenario_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_scenario
    ADD CONSTRAINT fk_categorie_scenario_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6453 (class 2606 OID 2601263)
-- Dependencies: 5850 4196 4196 4196 3981 3981 3981
-- Name: fk_categorie_scenario_dynamique_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_scenario_dynamique
    ADD CONSTRAINT fk_categorie_scenario_dynamique_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6452 (class 2606 OID 2601268)
-- Dependencies: 5799 4170 3981
-- Name: fk_categorie_scenario_dynamique_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_scenario_dynamique
    ADD CONSTRAINT fk_categorie_scenario_dynamique_2 FOREIGN KEY (id) REFERENCES scenario_dynamique(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6413 (class 2606 OID 2601273)
-- Dependencies: 5850 4196 4196 4196 3960 3960 3960
-- Name: fk_categorie_scorm_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_etape_scorm
    ADD CONSTRAINT fk_categorie_scorm_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6412 (class 2606 OID 2601278)
-- Dependencies: 5516 4027 3960
-- Name: fk_categorie_scorm_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_fichier_etape_scorm
    ADD CONSTRAINT fk_categorie_scorm_2 FOREIGN KEY (id) REFERENCES fichier_etape_scorm(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6676 (class 2606 OID 2601283)
-- Dependencies: 5428 3982 3982 4184 4184
-- Name: fk_categorie_serie; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_multitheme
    ADD CONSTRAINT fk_categorie_serie FOREIGN KEY (theme_source, serie) REFERENCES categorie_serie(theme, id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6455 (class 2606 OID 2601288)
-- Dependencies: 5850 4196 4196 4196 3982 3982 3982
-- Name: fk_categorie_serie_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_serie
    ADD CONSTRAINT fk_categorie_serie_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6454 (class 2606 OID 2601293)
-- Dependencies: 5814 4179 3982
-- Name: fk_categorie_serie_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_serie
    ADD CONSTRAINT fk_categorie_serie_2 FOREIGN KEY (id) REFERENCES serie(id) ON DELETE CASCADE;


--
-- TOC entry 6457 (class 2606 OID 2601298)
-- Dependencies: 5850 4196 4196 4196 3983 3983 3983
-- Name: fk_categorie_sondage_element_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_sondage_element
    ADD CONSTRAINT fk_categorie_sondage_element_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6456 (class 2606 OID 2601303)
-- Dependencies: 5728 4142 3983
-- Name: fk_categorie_sondage_element_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_sondage_element
    ADD CONSTRAINT fk_categorie_sondage_element_2 FOREIGN KEY (id) REFERENCES question_reponse(id);


--
-- TOC entry 6459 (class 2606 OID 2601308)
-- Dependencies: 5850 4196 4196 4196 3984 3984 3984
-- Name: fk_categorie_test_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_test
    ADD CONSTRAINT fk_categorie_test_1 FOREIGN KEY (id, categorie, theme) REFERENCES theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6458 (class 2606 OID 2601313)
-- Dependencies: 5843 4192 3984
-- Name: fk_categorie_test_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY categorie_test
    ADD CONSTRAINT fk_categorie_test_2 FOREIGN KEY (id) REFERENCES test(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6469 (class 2606 OID 2601318)
-- Dependencies: 5461 4001 4002
-- Name: fk_chat_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY etape_chat
    ADD CONSTRAINT fk_chat_1 FOREIGN KEY (id) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6460 (class 2606 OID 2601323)
-- Dependencies: 5754 4150 3985
-- Name: fk_choix_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY choix
    ADD CONSTRAINT fk_choix_1 FOREIGN KEY (id) REFERENCES reponse(id) ON DELETE CASCADE;


--
-- TOC entry 6461 (class 2606 OID 2601328)
-- Dependencies: 5441 3987 3987
-- Name: fk_classe_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY classe
    ADD CONSTRAINT fk_classe_1 FOREIGN KEY (pere) REFERENCES classe(id) ON DELETE CASCADE;


--
-- TOC entry 6463 (class 2606 OID 2601333)
-- Dependencies: 5441 3987 3988
-- Name: fk_classe_individus_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY classe_individus
    ADD CONSTRAINT fk_classe_individus_1 FOREIGN KEY (classe) REFERENCES classe(id);


--
-- TOC entry 6462 (class 2606 OID 2601338)
-- Dependencies: 5590 4064 3988
-- Name: fk_classe_individus_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY classe_individus
    ADD CONSTRAINT fk_classe_individus_2 FOREIGN KEY (individu) REFERENCES fw_individu(id);


--
-- TOC entry 6464 (class 2606 OID 2601343)
-- Dependencies: 5461 4001 3989
-- Name: fk_commentaire_etape; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY commentaire_etape
    ADD CONSTRAINT fk_commentaire_etape FOREIGN KEY (etape) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6465 (class 2606 OID 2601348)
-- Dependencies: 5590 4064 3991
-- Name: fk_connexion_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY connexion_old
    ADD CONSTRAINT fk_connexion_1 FOREIGN KEY (individu) REFERENCES fw_individu(id);


--
-- TOC entry 6466 (class 2606 OID 2601353)
-- Dependencies: 5450 3993 3993
-- Name: fk_critere_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY critere
    ADD CONSTRAINT fk_critere_1 FOREIGN KEY (pere) REFERENCES critere(id) ON DELETE CASCADE;


--
-- TOC entry 6467 (class 2606 OID 2601358)
-- Dependencies: 5592 4066 3994
-- Name: fk_droit_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY droit
    ADD CONSTRAINT fk_droit_1 FOREIGN KEY ("type") REFERENCES fw_individu_type(id);


--
-- TOC entry 6517 (class 2606 OID 2601363)
-- Dependencies: 5558 4049 4047
-- Name: fk_droits_formateur_formation_participants; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formateur_droits
    ADD CONSTRAINT fk_droits_formateur_formation_participants FOREIGN KEY (formation) REFERENCES formation(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6555 (class 2606 OID 2601368)
-- Dependencies: 5443 3988 3988 4084 4084
-- Name: fk_droits_individu_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY individu_droits
    ADD CONSTRAINT fk_droits_individu_2 FOREIGN KEY (classe, individu) REFERENCES classe_individus(classe, individu) ON DELETE CASCADE;


--
-- TOC entry 6468 (class 2606 OID 2601373)
-- Dependencies: 5477 4006 4001
-- Name: fk_etape_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY etape
    ADD CONSTRAINT fk_etape_1 FOREIGN KEY ("type") REFERENCES etape_type(id);


--
-- TOC entry 6603 (class 2606 OID 2601378)
-- Dependencies: 5692 4128 4126
-- Name: fk_etape_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY pc_etape
    ADD CONSTRAINT fk_etape_1 FOREIGN KEY ("type") REFERENCES pc_etape_type(id);


--
-- TOC entry 6476 (class 2606 OID 2601383)
-- Dependencies: 5461 4001 4005
-- Name: fk_etape_scorm_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY etape_scorm
    ADD CONSTRAINT fk_etape_scorm_1 FOREIGN KEY (id) REFERENCES etape(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6475 (class 2606 OID 2601388)
-- Dependencies: 5516 4027 4005
-- Name: fk_etape_scorm_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY etape_scorm
    ADD CONSTRAINT fk_etape_scorm_2 FOREIGN KEY (fichier) REFERENCES fichier_etape_scorm(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6477 (class 2606 OID 2601393)
-- Dependencies: 5485 4011 4009
-- Name: fk_evaluation_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY evaluation
    ADD CONSTRAINT fk_evaluation_2 FOREIGN KEY ("type") REFERENCES evaluation_type(id);


--
-- TOC entry 6478 (class 2606 OID 2601398)
-- Dependencies: 5558 4049 4012
-- Name: fk_evenement_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY evenement
    ADD CONSTRAINT fk_evenement_1 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6479 (class 2606 OID 2601403)
-- Dependencies: 5590 4064 4012
-- Name: fk_evenement_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY evenement
    ADD CONSTRAINT fk_evenement_2 FOREIGN KEY (intervenant) REFERENCES fw_individu(id);


--
-- TOC entry 6480 (class 2606 OID 2601408)
-- Dependencies: 5657 4105 4012
-- Name: fk_evenement_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY evenement
    ADD CONSTRAINT fk_evenement_3 FOREIGN KEY (modalite) REFERENCES modalite(id);


--
-- TOC entry 6481 (class 2606 OID 2601413)
-- Dependencies: 5793 4168 4012
-- Name: fk_evenement_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY evenement
    ADD CONSTRAINT fk_evenement_4 FOREIGN KEY (salle) REFERENCES salle(id);


--
-- TOC entry 6482 (class 2606 OID 2601418)
-- Dependencies: 5635 4089 4012
-- Name: fk_evenement_5; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY evenement
    ADD CONSTRAINT fk_evenement_5 FOREIGN KEY (intervention) REFERENCES intervention(id);


--
-- TOC entry 6483 (class 2606 OID 2601423)
-- Dependencies: 5487 4012 4012 4013 4013
-- Name: fk_evenement_presentiel_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY evenement_presentiel
    ADD CONSTRAINT fk_evenement_presentiel_1 FOREIGN KEY (formation, date) REFERENCES evenement(formation, date) ON DELETE CASCADE;


--
-- TOC entry 6485 (class 2606 OID 2601428)
-- Dependencies: 5504 4021 4014
-- Name: fk_exotlc_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY exotlc
    ADD CONSTRAINT fk_exotlc_2 FOREIGN KEY ("type") REFERENCES exotlc_type(id);


--
-- TOC entry 6484 (class 2606 OID 2601433)
-- Dependencies: 5461 4001 4014
-- Name: fk_exotlc_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY exotlc
    ADD CONSTRAINT fk_exotlc_3 FOREIGN KEY (id) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6487 (class 2606 OID 2601438)
-- Dependencies: 5491 4014 4015
-- Name: fk_exotlc_corrections_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY exotlc_corrections
    ADD CONSTRAINT fk_exotlc_corrections_1 FOREIGN KEY (exotlc) REFERENCES exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6486 (class 2606 OID 2601443)
-- Dependencies: 5511 4025 4015
-- Name: fk_exotlc_corrections_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY exotlc_corrections
    ADD CONSTRAINT fk_exotlc_corrections_2 FOREIGN KEY (correction) REFERENCES fichier_correction(id);


--
-- TOC entry 6489 (class 2606 OID 2601448)
-- Dependencies: 5491 4014 4016
-- Name: fk_exotlc_fichiers_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY exotlc_fichiers
    ADD CONSTRAINT fk_exotlc_fichiers_1 FOREIGN KEY (exotlc) REFERENCES exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6488 (class 2606 OID 2601453)
-- Dependencies: 5518 4028 4016
-- Name: fk_exotlc_fichiers_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY exotlc_fichiers
    ADD CONSTRAINT fk_exotlc_fichiers_2 FOREIGN KEY (fichier) REFERENCES fichier_exotlc(id);


--
-- TOC entry 6490 (class 2606 OID 2601458)
-- Dependencies: 5491 4014 4017
-- Name: fk_exotlc_mail_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY exotlc_mail
    ADD CONSTRAINT fk_exotlc_mail_1 FOREIGN KEY (id) REFERENCES exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6492 (class 2606 OID 2601463)
-- Dependencies: 5491 4014 4019
-- Name: fk_exotlc_plate_forme_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY exotlc_plate_forme
    ADD CONSTRAINT fk_exotlc_plate_forme_1 FOREIGN KEY (id) REFERENCES exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6493 (class 2606 OID 2601468)
-- Dependencies: 5552 4044 4023
-- Name: fk_fichier_1_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier
    ADD CONSTRAINT fk_fichier_1_1 FOREIGN KEY ("type") REFERENCES fichier_type(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6495 (class 2606 OID 2601473)
-- Dependencies: 5507 4023 4025
-- Name: fk_fichier_correction_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_correction
    ADD CONSTRAINT fk_fichier_correction_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6496 (class 2606 OID 2601478)
-- Dependencies: 5507 4023 4026
-- Name: fk_fichier_css_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_css
    ADD CONSTRAINT fk_fichier_css_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6498 (class 2606 OID 2601483)
-- Dependencies: 5507 4023 4028
-- Name: fk_fichier_exotlc_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_exotlc
    ADD CONSTRAINT fk_fichier_exotlc_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6499 (class 2606 OID 2601488)
-- Dependencies: 5507 4023 4029
-- Name: fk_fichier_glossaire_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_glossaire
    ADD CONSTRAINT fk_fichier_glossaire_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6500 (class 2606 OID 2601493)
-- Dependencies: 5507 4023 4030
-- Name: fk_fichier_icone_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_icone
    ADD CONSTRAINT fk_fichier_icone_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6503 (class 2606 OID 2601498)
-- Dependencies: 5507 4023 4033
-- Name: fk_fichier_media_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_media_scenario
    ADD CONSTRAINT fk_fichier_media_2 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6501 (class 2606 OID 2601503)
-- Dependencies: 5507 4023 4031
-- Name: fk_fichier_media_evaluation_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_media_evaluation
    ADD CONSTRAINT fk_fichier_media_evaluation_2 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6502 (class 2606 OID 2601508)
-- Dependencies: 5507 4023 4032
-- Name: fk_fichier_media_exotlc_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_media_exotlc
    ADD CONSTRAINT fk_fichier_media_exotlc_2 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6505 (class 2606 OID 2601513)
-- Dependencies: 5507 4023 4034
-- Name: fk_fichier_metadata; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY fichier_metadata
    ADD CONSTRAINT fk_fichier_metadata FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6504 (class 2606 OID 2601518)
-- Dependencies: 5590 4064 4034
-- Name: fk_fichier_metadata_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY fichier_metadata
    ADD CONSTRAINT fk_fichier_metadata_1 FOREIGN KEY (individu) REFERENCES fw_individu(id) ON DELETE CASCADE;


--
-- TOC entry 6506 (class 2606 OID 2601523)
-- Dependencies: 5507 4023 4035
-- Name: fk_fichier_photo_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_photo
    ADD CONSTRAINT fk_fichier_photo_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6508 (class 2606 OID 2601528)
-- Dependencies: 5507 4023 4037
-- Name: fk_fichier_ressource_fichier_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_ressource_fichier
    ADD CONSTRAINT fk_fichier_ressource_fichier_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6509 (class 2606 OID 2601533)
-- Dependencies: 5507 4023 4038
-- Name: fk_fichier_ressource_texte_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_ressource_texte
    ADD CONSTRAINT fk_fichier_ressource_texte_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6510 (class 2606 OID 2601538)
-- Dependencies: 5507 4023 4039
-- Name: fk_fichier_scenario_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_scenario
    ADD CONSTRAINT fk_fichier_scenario_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6511 (class 2606 OID 2601543)
-- Dependencies: 5507 4023 4040
-- Name: fk_fichier_scenario_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_scenario_dynamique
    ADD CONSTRAINT fk_fichier_scenario_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6512 (class 2606 OID 2601548)
-- Dependencies: 5544 4040 4041
-- Name: fk_fichier_scenario_dynamique_blocs_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_scenario_dynamique_blocs
    ADD CONSTRAINT fk_fichier_scenario_dynamique_blocs_2 FOREIGN KEY (id) REFERENCES fichier_scenario_dynamique(id) ON DELETE CASCADE;


--
-- TOC entry 6497 (class 2606 OID 2601553)
-- Dependencies: 5507 4023 4027
-- Name: fk_fichier_scorm_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_etape_scorm
    ADD CONSTRAINT fk_fichier_scorm_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6513 (class 2606 OID 2601558)
-- Dependencies: 5507 4023 4042
-- Name: fk_fichier_slide_scenario_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_slide_scenario
    ADD CONSTRAINT fk_fichier_slide_scenario_1 FOREIGN KEY (id) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6514 (class 2606 OID 2601563)
-- Dependencies: 5357 3948 4044
-- Name: fk_fichier_type_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fichier_type
    ADD CONSTRAINT fk_fichier_type_1 FOREIGN KEY (categorie) REFERENCES categorie(id);


--
-- TOC entry 6515 (class 2606 OID 2601568)
-- Dependencies: 5554 4046 4046
-- Name: fk_filiere_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY filiere
    ADD CONSTRAINT fk_filiere_1 FOREIGN KEY (pere) REFERENCES filiere(id) ON DELETE CASCADE;


--
-- TOC entry 6604 (class 2606 OID 2601573)
-- Dependencies: 5696 4130 4130
-- Name: fk_filiere_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY pc_filiere
    ADD CONSTRAINT fk_filiere_1 FOREIGN KEY (pere) REFERENCES pc_filiere(id) ON DELETE CASCADE;


--
-- TOC entry 6516 (class 2606 OID 2601578)
-- Dependencies: 5454 3994 4047
-- Name: fk_formateur_droits_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formateur_droits
    ADD CONSTRAINT fk_formateur_droits_2 FOREIGN KEY (droit) REFERENCES droit(id);


--
-- TOC entry 6519 (class 2606 OID 2601583)
-- Dependencies: 5681 4122 4049
-- Name: fk_formation_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation
    ADD CONSTRAINT fk_formation_1 FOREIGN KEY (parcours) REFERENCES parcours(id);


--
-- TOC entry 6518 (class 2606 OID 2601588)
-- Dependencies: 5637 4091 4049
-- Name: fk_formation_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation
    ADD CONSTRAINT fk_formation_2 FOREIGN KEY (langue) REFERENCES langue(id);


--
-- TOC entry 6521 (class 2606 OID 2601593)
-- Dependencies: 5578 4056 4050
-- Name: fk_formation_forums_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_forums
    ADD CONSTRAINT fk_formation_forums_1 FOREIGN KEY (forum) REFERENCES forum(id);


--
-- TOC entry 6520 (class 2606 OID 2961071)
-- Dependencies: 5558 4049 4050
-- Name: fk_formation_forums_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_forums
    ADD CONSTRAINT fk_formation_forums_2 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6523 (class 2606 OID 2601603)
-- Dependencies: 5637 4091 4051
-- Name: fk_formation_langues_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_langues
    ADD CONSTRAINT fk_formation_langues_1 FOREIGN KEY (langue) REFERENCES langue(id);


--
-- TOC entry 6522 (class 2606 OID 2960233)
-- Dependencies: 5558 4049 4051
-- Name: fk_formation_langues_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_langues
    ADD CONSTRAINT fk_formation_langues_2 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6524 (class 2606 OID 2960243)
-- Dependencies: 5558 4049 4052
-- Name: fk_formation_participants_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_participants
    ADD CONSTRAINT fk_formation_participants_2 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6526 (class 2606 OID 2601618)
-- Dependencies: 5441 3987 4052
-- Name: fk_formation_participants_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_participants
    ADD CONSTRAINT fk_formation_participants_3 FOREIGN KEY (classe) REFERENCES classe(id);


--
-- TOC entry 6525 (class 2606 OID 2601623)
-- Dependencies: 5590 4064 4052
-- Name: fk_formation_participants_formateur; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_participants
    ADD CONSTRAINT fk_formation_participants_formateur FOREIGN KEY (formateur) REFERENCES fw_individu(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6530 (class 2606 OID 2960252)
-- Dependencies: 5558 4049 4053
-- Name: fk_formation_ressources_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_ressources
    ADD CONSTRAINT fk_formation_ressources_1 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6527 (class 2606 OID 2601633)
-- Dependencies: 5535 4036 4053
-- Name: fk_formation_ressources_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_ressources
    ADD CONSTRAINT fk_formation_ressources_2 FOREIGN KEY (fichier_ressource) REFERENCES fichier_ressource(id);


--
-- TOC entry 6528 (class 2606 OID 2601638)
-- Dependencies: 5458 3999 4053
-- Name: fk_formation_ressources_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_ressources
    ADD CONSTRAINT fk_formation_ressources_3 FOREIGN KEY (espace) REFERENCES espace(id);


--
-- TOC entry 6529 (class 2606 OID 2601643)
-- Dependencies: 5812 4178 4053
-- Name: fk_formation_ressources_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY formation_ressources
    ADD CONSTRAINT fk_formation_ressources_4 FOREIGN KEY (section) REFERENCES section(id);


--
-- TOC entry 6531 (class 2606 OID 2601648)
-- Dependencies: 5558 4049 4054
-- Name: fk_formation_session_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY formation_session
    ADD CONSTRAINT fk_formation_session_1 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6470 (class 2606 OID 2601653)
-- Dependencies: 5461 4001 4003
-- Name: fk_forum_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY etape_forum
    ADD CONSTRAINT fk_forum_1 FOREIGN KEY (id) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6533 (class 2606 OID 2601658)
-- Dependencies: 5578 4056 4059
-- Name: fk_forum_environnements_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY forum_environnements
    ADD CONSTRAINT fk_forum_environnements_1 FOREIGN KEY (forum) REFERENCES forum(id);


--
-- TOC entry 6532 (class 2606 OID 2601663)
-- Dependencies: 5580 4058 4059
-- Name: fk_forum_environnements_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY forum_environnements
    ADD CONSTRAINT fk_forum_environnements_2 FOREIGN KEY (environnement) REFERENCES forum_environnement(id);


--
-- TOC entry 6534 (class 2606 OID 2601668)
-- Dependencies: 5481 4009 4060
-- Name: fk_ftb_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY ftb
    ADD CONSTRAINT fk_ftb_1 FOREIGN KEY (id) REFERENCES evaluation(id) ON DELETE CASCADE;


--
-- TOC entry 6545 (class 2606 OID 2601673)
-- Dependencies: 5520 4029 4078
-- Name: fk_glossaire_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY glossaire
    ADD CONSTRAINT fk_glossaire_1 FOREIGN KEY (fichier) REFERENCES fichier_glossaire(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6547 (class 2606 OID 2601678)
-- Dependencies: 5613 4078 4079
-- Name: fk_glossaire_fichiers_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY glossaire_fichiers
    ADD CONSTRAINT fk_glossaire_fichiers_1 FOREIGN KEY (id) REFERENCES glossaire(id) ON DELETE CASCADE;


--
-- TOC entry 6546 (class 2606 OID 2601683)
-- Dependencies: 5539 4038 4079
-- Name: fk_glossaire_fichiers_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY glossaire_fichiers
    ADD CONSTRAINT fk_glossaire_fichiers_2 FOREIGN KEY (fichier) REFERENCES fichier_ressource_texte(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6549 (class 2606 OID 2601688)
-- Dependencies: 5355 3946 4083
-- Name: fk_grille_resultats_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY grille_resultats
    ADD CONSTRAINT fk_grille_resultats_1 FOREIGN KEY (carton) REFERENCES carton(id);


--
-- TOC entry 6550 (class 2606 OID 2601693)
-- Dependencies: 5621 4082 4082 4083 4083
-- Name: fk_grille_resultats_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY grille_resultats
    ADD CONSTRAINT fk_grille_resultats_2 FOREIGN KEY (grille, capacite_titre) REFERENCES grille_capacites_titres(grille, capacite_titre);


--
-- TOC entry 6551 (class 2606 OID 2601698)
-- Dependencies: 5353 3944 3944 4083 4083
-- Name: fk_grille_resultats_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY grille_resultats
    ADD CONSTRAINT fk_grille_resultats_3 FOREIGN KEY (capacite_titre, capacite) REFERENCES capacite_titre_capacites(capacite_titre, capacite);


--
-- TOC entry 6552 (class 2606 OID 2601703)
-- Dependencies: 5841 4191 4191 4191 4083 4083 4083
-- Name: fk_grille_resultats_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY grille_resultats
    ADD CONSTRAINT fk_grille_resultats_4 FOREIGN KEY (formation, stagiaire, grille) REFERENCES stagiaire_grille(formation, stagiaire, grille) ON DELETE CASCADE;


--
-- TOC entry 6553 (class 2606 OID 2601708)
-- Dependencies: 5489 4013 4013 4083 4083
-- Name: fk_grille_resultats_5; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY grille_resultats
    ADD CONSTRAINT fk_grille_resultats_5 FOREIGN KEY (formation, date) REFERENCES evenement_presentiel(formation, date);


--
-- TOC entry 6687 (class 2606 OID 2601713)
-- Dependencies: 5619 4081 4191
-- Name: fk_grille_stagiaires_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY stagiaire_grille
    ADD CONSTRAINT fk_grille_stagiaires_1 FOREIGN KEY (grille) REFERENCES grille(id);


--
-- TOC entry 6685 (class 2606 OID 2961100)
-- Dependencies: 5558 4049 4191
-- Name: fk_grille_stagiaires_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY stagiaire_grille
    ADD CONSTRAINT fk_grille_stagiaires_2 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6686 (class 2606 OID 2601723)
-- Dependencies: 5590 4064 4191
-- Name: fk_grille_stagiaires_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY stagiaire_grille
    ADD CONSTRAINT fk_grille_stagiaires_3 FOREIGN KEY (stagiaire) REFERENCES fw_individu(id);


--
-- TOC entry 6548 (class 2606 OID 2601728)
-- Dependencies: 5619 4081 4082
-- Name: fk_grille_titres_capacites_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY grille_capacites_titres
    ADD CONSTRAINT fk_grille_titres_capacites_1 FOREIGN KEY (grille) REFERENCES grille(id) ON DELETE CASCADE;


--
-- TOC entry 6634 (class 2606 OID 2961464)
-- Dependencies: 5590 4064 4152
-- Name: fk_individu; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat
    ADD CONSTRAINT fk_individu FOREIGN KEY (stagiaire) REFERENCES fw_individu(id);


--
-- TOC entry 6554 (class 2606 OID 2601733)
-- Dependencies: 5454 3994 4084
-- Name: fk_individu_droits_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY individu_droits
    ADD CONSTRAINT fk_individu_droits_2 FOREIGN KEY (droit) REFERENCES droit(id);


--
-- TOC entry 6536 (class 2606 OID 2601738)
-- Dependencies: 5661 4109 4064
-- Name: fk_individu_organisme; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fw_individu
    ADD CONSTRAINT fk_individu_organisme FOREIGN KEY (organisme) REFERENCES organisme(id);


--
-- TOC entry 6535 (class 2606 OID 2601743)
-- Dependencies: 5533 4035 4064
-- Name: fk_individu_photo; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fw_individu
    ADD CONSTRAINT fk_individu_photo FOREIGN KEY (photo) REFERENCES fichier_photo(id) ON UPDATE CASCADE ON DELETE RESTRICT;


--
-- TOC entry 6538 (class 2606 OID 2601748)
-- Dependencies: 5592 4066 4067
-- Name: fk_individu_types_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fw_individu_types
    ADD CONSTRAINT fk_individu_types_1 FOREIGN KEY ("type") REFERENCES fw_individu_type(id);


--
-- TOC entry 6537 (class 2606 OID 2601753)
-- Dependencies: 5590 4064 4067
-- Name: fk_individu_types_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY fw_individu_types
    ADD CONSTRAINT fk_individu_types_2 FOREIGN KEY (individu) REFERENCES fw_individu(id) ON DELETE CASCADE;


--
-- TOC entry 6560 (class 2606 OID 2601758)
-- Dependencies: 5661 4109 4087
-- Name: fk_inscription_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY inscription
    ADD CONSTRAINT fk_inscription_1 FOREIGN KEY (organisme) REFERENCES organisme(id);


--
-- TOC entry 6559 (class 2606 OID 2601763)
-- Dependencies: 5637 4091 4087
-- Name: fk_inscription_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY inscription
    ADD CONSTRAINT fk_inscription_3 FOREIGN KEY (langue) REFERENCES langue(id);


--
-- TOC entry 6558 (class 2606 OID 2601768)
-- Dependencies: 5533 4035 4087
-- Name: fk_inscription_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY inscription
    ADD CONSTRAINT fk_inscription_4 FOREIGN KEY (photo) REFERENCES fichier_photo(id);


--
-- TOC entry 6563 (class 2606 OID 2601773)
-- Dependencies: 5641 4094 4092
-- Name: fk_langue_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY langue_message
    ADD CONSTRAINT fk_langue_3 FOREIGN KEY ("type") REFERENCES langue_type(id);


--
-- TOC entry 6562 (class 2606 OID 2601778)
-- Dependencies: 5637 4091 4092
-- Name: fk_langue_french_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY langue_message
    ADD CONSTRAINT fk_langue_french_2 FOREIGN KEY (langue) REFERENCES langue(id);


--
-- TOC entry 6561 (class 2606 OID 2601783)
-- Dependencies: 5639 4092 4092 4092 4092 4092 4092
-- Name: fk_langue_messages_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY langue_message
    ADD CONSTRAINT fk_langue_messages_3 FOREIGN KEY ("type", langue, id) REFERENCES langue_message("type", langue, id);


--
-- TOC entry 6565 (class 2606 OID 2601788)
-- Dependencies: 5461 4001 4095
-- Name: fk_liste_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY liste
    ADD CONSTRAINT fk_liste_1 FOREIGN KEY (id) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6564 (class 2606 OID 2601793)
-- Dependencies: 5645 4097 4095
-- Name: fk_liste_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY liste
    ADD CONSTRAINT fk_liste_2 FOREIGN KEY ("type") REFERENCES liste_type(id);


--
-- TOC entry 6566 (class 2606 OID 2601798)
-- Dependencies: 5507 4023 4098
-- Name: fk_media_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY media
    ADD CONSTRAINT fk_media_1 FOREIGN KEY (id) REFERENCES fichier(id);


--
-- TOC entry 6568 (class 2606 OID 2601803)
-- Dependencies: 5524 4031 4099
-- Name: fk_media_element_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY media_question_reponse
    ADD CONSTRAINT fk_media_element_1 FOREIGN KEY (media) REFERENCES fichier_media_evaluation(id);


--
-- TOC entry 6569 (class 2606 OID 2601808)
-- Dependencies: 5524 4031 4100
-- Name: fk_media_element_element_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY media_question_reponse_element
    ADD CONSTRAINT fk_media_element_element_1 FOREIGN KEY (media) REFERENCES fichier_media_evaluation(id);


--
-- TOC entry 6567 (class 2606 OID 2601813)
-- Dependencies: 5728 4142 4099
-- Name: fk_media_question_reponse_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY media_question_reponse
    ADD CONSTRAINT fk_media_question_reponse_2 FOREIGN KEY (question_reponse) REFERENCES question_reponse(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6571 (class 2606 OID 2601818)
-- Dependencies: 5647 4098 4101
-- Name: fk_media_test_liste_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY media_test
    ADD CONSTRAINT fk_media_test_liste_1 FOREIGN KEY (media) REFERENCES media(id);


--
-- TOC entry 6570 (class 2606 OID 2601823)
-- Dependencies: 5843 4192 4101
-- Name: fk_media_test_liste_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY media_test
    ADD CONSTRAINT fk_media_test_liste_2 FOREIGN KEY (test) REFERENCES test(id);


--
-- TOC entry 6573 (class 2606 OID 2601828)
-- Dependencies: 5578 4056 4103
-- Name: fk_message_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY message
    ADD CONSTRAINT fk_message_1 FOREIGN KEY (forum) REFERENCES forum(id);


--
-- TOC entry 6572 (class 2606 OID 2601833)
-- Dependencies: 5590 4064 4103
-- Name: fk_message_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY message
    ADD CONSTRAINT fk_message_2 FOREIGN KEY (auteur) REFERENCES fw_individu(id);


--
-- TOC entry 6383 (class 2606 OID 2601838)
-- Dependencies: 5659 4107 3927
-- Name: fk_modele_correction_criteres_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY modele_correction_criteres
    ADD CONSTRAINT fk_modele_correction_criteres_1 FOREIGN KEY (modele_correction) REFERENCES modele_correction(id) ON DELETE CASCADE;


--
-- TOC entry 6382 (class 2606 OID 2601843)
-- Dependencies: 5450 3993 3927
-- Name: fk_modele_correction_criteres_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY modele_correction_criteres
    ADD CONSTRAINT fk_modele_correction_criteres_2 FOREIGN KEY (critere) REFERENCES critere(id);


--
-- TOC entry 6381 (class 2606 OID 2601848)
-- Dependencies: 5333 3927 3927 3927 3927
-- Name: fk_modele_correction_criteres_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY modele_correction_criteres
    ADD CONSTRAINT fk_modele_correction_criteres_3 FOREIGN KEY (modele_correction, pere) REFERENCES modele_correction_criteres(modele_correction, critere);


--
-- TOC entry 6544 (class 2606 OID 2601853)
-- Dependencies: 5598 4071 4075
-- Name: fk_module_submodules_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY fw_module_submodules
    ADD CONSTRAINT fk_module_submodules_1 FOREIGN KEY (module) REFERENCES fw_module(id) ON DELETE CASCADE;


--
-- TOC entry 6543 (class 2606 OID 2601858)
-- Dependencies: 5598 4071 4075
-- Name: fk_module_submodules_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY fw_module_submodules
    ADD CONSTRAINT fk_module_submodules_2 FOREIGN KEY (submodule) REFERENCES fw_module(id) ON DELETE CASCADE;


--
-- TOC entry 6574 (class 2606 OID 2601863)
-- Dependencies: 5679 4121 4111
-- Name: fk_page_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page
    ADD CONSTRAINT fk_page_1 FOREIGN KEY ("type") REFERENCES page_type(id);


--
-- TOC entry 6577 (class 2606 OID 2601868)
-- Dependencies: 5671 4116 4116 4112 4112
-- Name: fk_page_annuaire_configuration_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_annuaire_configuration
    ADD CONSTRAINT fk_page_annuaire_configuration_1 FOREIGN KEY (page, page_element) REFERENCES page_elements(page, page_element);


--
-- TOC entry 6576 (class 2606 OID 2601873)
-- Dependencies: 5558 4049 4112
-- Name: fk_page_annuaire_configuration_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_annuaire_configuration
    ADD CONSTRAINT fk_page_annuaire_configuration_3 FOREIGN KEY (formation) REFERENCES formation(id);


--
-- TOC entry 6575 (class 2606 OID 2601878)
-- Dependencies: 5592 4066 4112
-- Name: fk_page_annuaire_configuration_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_annuaire_configuration
    ADD CONSTRAINT fk_page_annuaire_configuration_4 FOREIGN KEY (individu_type) REFERENCES fw_individu_type(id);


--
-- TOC entry 6580 (class 2606 OID 2601883)
-- Dependencies: 5663 4111 4113
-- Name: fk_page_commentaire_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_commentaire
    ADD CONSTRAINT fk_page_commentaire_1 FOREIGN KEY (page) REFERENCES page(id);


--
-- TOC entry 6578 (class 2606 OID 2965631)
-- Dependencies: 5558 4049 4113
-- Name: fk_page_commentaire_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_commentaire
    ADD CONSTRAINT fk_page_commentaire_2 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6579 (class 2606 OID 2601893)
-- Dependencies: 5590 4064 4113
-- Name: fk_page_commentaire_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_commentaire
    ADD CONSTRAINT fk_page_commentaire_3 FOREIGN KEY (stagiaire) REFERENCES fw_individu(id);


--
-- TOC entry 6590 (class 2606 OID 2601898)
-- Dependencies: 5671 4116 4116 4118 4118
-- Name: fk_page_configuration_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_liste_configuration
    ADD CONSTRAINT fk_page_configuration_1 FOREIGN KEY (page, page_element) REFERENCES page_elements(page, page_element);


--
-- TOC entry 6587 (class 2606 OID 2965571)
-- Dependencies: 5558 4049 4118
-- Name: fk_page_configuration_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_liste_configuration
    ADD CONSTRAINT fk_page_configuration_2 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6582 (class 2606 OID 2601908)
-- Dependencies: 5663 4111 4116
-- Name: fk_page_elements_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_elements
    ADD CONSTRAINT fk_page_elements_1 FOREIGN KEY (page) REFERENCES page(id);


--
-- TOC entry 6581 (class 2606 OID 2601913)
-- Dependencies: 5669 4115 4116
-- Name: fk_page_elements_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_elements
    ADD CONSTRAINT fk_page_elements_2 FOREIGN KEY (page_element) REFERENCES page_element(id);


--
-- TOC entry 6586 (class 2606 OID 2601918)
-- Dependencies: 5663 4111 4117
-- Name: fk_page_liste_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_liste
    ADD CONSTRAINT fk_page_liste_1 FOREIGN KEY (page) REFERENCES page(id);


--
-- TOC entry 6583 (class 2606 OID 2965580)
-- Dependencies: 5558 4049 4117
-- Name: fk_page_liste_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_liste
    ADD CONSTRAINT fk_page_liste_2 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6584 (class 2606 OID 2964205)
-- Dependencies: 5681 4122 4117
-- Name: fk_page_liste_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_liste
    ADD CONSTRAINT fk_page_liste_3 FOREIGN KEY (parcours) REFERENCES parcours(id) ON DELETE CASCADE;


--
-- TOC entry 6585 (class 2606 OID 2601933)
-- Dependencies: 5643 4095 4117
-- Name: fk_page_liste_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_liste
    ADD CONSTRAINT fk_page_liste_4 FOREIGN KEY (liste) REFERENCES liste(id) ON DELETE CASCADE;


--
-- TOC entry 6589 (class 2606 OID 2601938)
-- Dependencies: 5643 4095 4118
-- Name: fk_page_liste_configuration_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_liste_configuration
    ADD CONSTRAINT fk_page_liste_configuration_3 FOREIGN KEY (liste) REFERENCES liste(id);


--
-- TOC entry 6588 (class 2606 OID 2601943)
-- Dependencies: 5681 4122 4118
-- Name: fk_page_liste_configuration_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_liste_configuration
    ADD CONSTRAINT fk_page_liste_configuration_4 FOREIGN KEY (parcours) REFERENCES parcours(id);


--
-- TOC entry 6594 (class 2606 OID 2601948)
-- Dependencies: 5663 4111 4119
-- Name: fk_page_ressource_configuration_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_ressource_configuration
    ADD CONSTRAINT fk_page_ressource_configuration_1 FOREIGN KEY (page) REFERENCES page(id);


--
-- TOC entry 6593 (class 2606 OID 2601953)
-- Dependencies: 5681 4122 4119
-- Name: fk_page_ressource_configuration_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_ressource_configuration
    ADD CONSTRAINT fk_page_ressource_configuration_2 FOREIGN KEY (parcours) REFERENCES parcours(id);


--
-- TOC entry 6592 (class 2606 OID 2601958)
-- Dependencies: 5558 4049 4119
-- Name: fk_page_ressource_configuration_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_ressource_configuration
    ADD CONSTRAINT fk_page_ressource_configuration_3 FOREIGN KEY (formation) REFERENCES formation(id);


--
-- TOC entry 6591 (class 2606 OID 2601963)
-- Dependencies: 5472 4004 4119
-- Name: fk_page_ressource_configuration_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY page_ressource_configuration
    ADD CONSTRAINT fk_page_ressource_configuration_4 FOREIGN KEY (etape_ressource) REFERENCES etape_ressource(id);


--
-- TOC entry 6596 (class 2606 OID 2601968)
-- Dependencies: 5461 4001 4122
-- Name: fk_parcours_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY parcours
    ADD CONSTRAINT fk_parcours_3 FOREIGN KEY (id) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6606 (class 2606 OID 2601973)
-- Dependencies: 5689 4126 4131
-- Name: fk_parcours_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY pc_parcours
    ADD CONSTRAINT fk_parcours_3 FOREIGN KEY (id) REFERENCES pc_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6595 (class 2606 OID 2601978)
-- Dependencies: 5554 4046 4122
-- Name: fk_parcours_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY parcours
    ADD CONSTRAINT fk_parcours_4 FOREIGN KEY (filiere) REFERENCES filiere(id);


--
-- TOC entry 6605 (class 2606 OID 2601983)
-- Dependencies: 5696 4130 4131
-- Name: fk_parcours_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY pc_parcours
    ADD CONSTRAINT fk_parcours_4 FOREIGN KEY (filiere) REFERENCES pc_filiere(id);


--
-- TOC entry 6599 (class 2606 OID 2601988)
-- Dependencies: 5461 4001 4123
-- Name: fk_parcours_etapes_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY parcours_etapes
    ADD CONSTRAINT fk_parcours_etapes_2 FOREIGN KEY (etape) REFERENCES etape(id);


--
-- TOC entry 6598 (class 2606 OID 2601993)
-- Dependencies: 5681 4122 4123
-- Name: fk_parcours_etapes_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY parcours_etapes
    ADD CONSTRAINT fk_parcours_etapes_3 FOREIGN KEY (parcours) REFERENCES parcours(id);


--
-- TOC entry 6597 (class 2606 OID 2601998)
-- Dependencies: 5683 4123 4123 4123 4123
-- Name: fk_parcours_etapes_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY parcours_etapes
    ADD CONSTRAINT fk_parcours_etapes_4 FOREIGN KEY (parcours, pere) REFERENCES parcours_etapes(parcours, etape) ON UPDATE CASCADE;


--
-- TOC entry 6602 (class 2606 OID 2602003)
-- Dependencies: 5461 4001 4124
-- Name: fk_parcours_orientation_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY parcours_oriente
    ADD CONSTRAINT fk_parcours_orientation_1 FOREIGN KEY (id) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6600 (class 2606 OID 2964162)
-- Dependencies: 5681 4122 4124
-- Name: fk_parcours_orientation_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY parcours_oriente
    ADD CONSTRAINT fk_parcours_orientation_2 FOREIGN KEY (sous_parcours) REFERENCES parcours(id) ON DELETE CASCADE;


--
-- TOC entry 6601 (class 2606 OID 2602013)
-- Dependencies: 5477 4006 4124
-- Name: fk_parcours_orientation_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY parcours_oriente
    ADD CONSTRAINT fk_parcours_orientation_3 FOREIGN KEY ("type") REFERENCES etape_type(id);


--
-- TOC entry 6617 (class 2606 OID 2602018)
-- Dependencies: 5728 4142 4138
-- Name: fk_positionnement_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement_old
    ADD CONSTRAINT fk_positionnement_1 FOREIGN KEY (question_reponse) REFERENCES question_reponse(id) ON DELETE CASCADE;


--
-- TOC entry 6608 (class 2606 OID 2602023)
-- Dependencies: 5722 4140 4133
-- Name: fk_positionnement_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement
    ADD CONSTRAINT fk_positionnement_1 FOREIGN KEY (qsrc) REFERENCES qsrc(id) ON DELETE CASCADE;


--
-- TOC entry 6616 (class 2606 OID 2602028)
-- Dependencies: 5816 4180 4138
-- Name: fk_positionnement_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement_old
    ADD CONSTRAINT fk_positionnement_2 FOREIGN KEY (serie_aleatoire) REFERENCES serie_aleatoire(id) ON DELETE CASCADE;


--
-- TOC entry 6607 (class 2606 OID 2602033)
-- Dependencies: 5816 4180 4133
-- Name: fk_positionnement_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement
    ADD CONSTRAINT fk_positionnement_2 FOREIGN KEY (serie_generee) REFERENCES serie_aleatoire(id) ON DELETE CASCADE;


--
-- TOC entry 6615 (class 2606 OID 2602038)
-- Dependencies: 5752 4149 4138
-- Name: fk_positionnement_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement_old
    ADD CONSTRAINT fk_positionnement_3 FOREIGN KEY (type_question) REFERENCES question_reponse_type(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6613 (class 2606 OID 2602043)
-- Dependencies: 5743 4146 4146 4146 4135 4135 4135
-- Name: fk_positionnement_elements_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement_elements
    ADD CONSTRAINT fk_positionnement_elements_1 FOREIGN KEY (question_reponse, question, choix) REFERENCES question_reponse_elements_old(question_reponse, question, reponse) ON DELETE CASCADE;


--
-- TOC entry 6612 (class 2606 OID 2602048)
-- Dependencies: 5437 3985 4135
-- Name: fk_positionnement_elements_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement_elements
    ADD CONSTRAINT fk_positionnement_elements_2 FOREIGN KEY (choix) REFERENCES choix(id) ON DELETE CASCADE;


--
-- TOC entry 6614 (class 2606 OID 2602053)
-- Dependencies: 5481 4009 4136
-- Name: fk_positionnement_evaluations_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement_evaluations
    ADD CONSTRAINT fk_positionnement_evaluations_1 FOREIGN KEY (evaluation) REFERENCES evaluation(id);


--
-- TOC entry 6611 (class 2606 OID 2602058)
-- Dependencies: 5485 4011 4134
-- Name: fk_positionnement_evaluations_generees; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement_choix_evaluations
    ADD CONSTRAINT fk_positionnement_evaluations_generees FOREIGN KEY ("type") REFERENCES evaluation_type(id);


--
-- TOC entry 6610 (class 2606 OID 2602063)
-- Dependencies: 5716 4138 4134
-- Name: fk_positionnement_evaluations_generees_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement_choix_evaluations
    ADD CONSTRAINT fk_positionnement_evaluations_generees_1 FOREIGN KEY (positionnement) REFERENCES positionnement_old(id) ON DELETE CASCADE;


--
-- TOC entry 6609 (class 2606 OID 2602068)
-- Dependencies: 5346 3934 4134
-- Name: fk_positionnement_evaluations_generees_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY positionnement_choix_evaluations
    ADD CONSTRAINT fk_positionnement_evaluations_generees_3 FOREIGN KEY (bareme) REFERENCES bareme(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6619 (class 2606 OID 2602073)
-- Dependencies: 5734 4145 4145 4139 4139
-- Name: fk_qcm_4_q; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY qcm_elements
    ADD CONSTRAINT fk_qcm_4_q FOREIGN KEY (question_reponse, question) REFERENCES question_reponse_elements(question_reponse, question_reponse_element) ON DELETE CASCADE;


--
-- TOC entry 6618 (class 2606 OID 2602078)
-- Dependencies: 5734 4145 4145 4139 4139
-- Name: fk_qcm_4_r; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY qcm_elements
    ADD CONSTRAINT fk_qcm_4_r FOREIGN KEY (question_reponse, reponse) REFERENCES question_reponse_elements(question_reponse, question_reponse_element) ON DELETE CASCADE;


--
-- TOC entry 6620 (class 2606 OID 2602083)
-- Dependencies: 5481 4009 4140
-- Name: fk_qrc_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY qsrc
    ADD CONSTRAINT fk_qrc_1 FOREIGN KEY (id) REFERENCES evaluation(id) ON DELETE CASCADE;


--
-- TOC entry 6621 (class 2606 OID 2602088)
-- Dependencies: 5732 4144 4141
-- Name: fk_question_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question
    ADD CONSTRAINT fk_question_1 FOREIGN KEY (id) REFERENCES question_reponse_element(id) ON DELETE CASCADE;


--
-- TOC entry 6623 (class 2606 OID 2602093)
-- Dependencies: 5752 4149 4142
-- Name: fk_question_reponse_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse
    ADD CONSTRAINT fk_question_reponse_1 FOREIGN KEY ("type") REFERENCES question_reponse_type(id);


--
-- TOC entry 6629 (class 2606 OID 2602098)
-- Dependencies: 5754 4150 4146
-- Name: fk_question_reponse_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse_elements_old
    ADD CONSTRAINT fk_question_reponse_3 FOREIGN KEY (reponse) REFERENCES reponse(id);


--
-- TOC entry 6622 (class 2606 OID 2602103)
-- Dependencies: 5483 4009 4009 4142 4142
-- Name: fk_question_reponse_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse
    ADD CONSTRAINT fk_question_reponse_3 FOREIGN KEY (id, "type") REFERENCES evaluation(id, "type") ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6632 (class 2606 OID 2602108)
-- Dependencies: 5754 4150 4147
-- Name: fk_question_reponse_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse_elements_older
    ADD CONSTRAINT fk_question_reponse_3 FOREIGN KEY (reponse) REFERENCES reponse(id);


--
-- TOC entry 6625 (class 2606 OID 2602113)
-- Dependencies: 5728 4142 4145
-- Name: fk_question_reponse_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse_elements
    ADD CONSTRAINT fk_question_reponse_3 FOREIGN KEY (question_reponse) REFERENCES question_reponse(id) ON DELETE CASCADE;


--
-- TOC entry 6628 (class 2606 OID 2602118)
-- Dependencies: 5726 4141 4146
-- Name: fk_question_reponse_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse_elements_old
    ADD CONSTRAINT fk_question_reponse_4 FOREIGN KEY (question) REFERENCES question(id);


--
-- TOC entry 6631 (class 2606 OID 2602123)
-- Dependencies: 5726 4141 4147
-- Name: fk_question_reponse_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse_elements_older
    ADD CONSTRAINT fk_question_reponse_4 FOREIGN KEY (question) REFERENCES question(id);


--
-- TOC entry 6624 (class 2606 OID 2602128)
-- Dependencies: 5752 4149 4144
-- Name: fk_question_reponse_element_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse_element
    ADD CONSTRAINT fk_question_reponse_element_1 FOREIGN KEY ("type") REFERENCES question_reponse_type(id);


--
-- TOC entry 6626 (class 2606 OID 2602133)
-- Dependencies: 5732 4144 4145
-- Name: fk_question_reponse_element_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse_elements
    ADD CONSTRAINT fk_question_reponse_element_4 FOREIGN KEY (question_reponse_element) REFERENCES question_reponse_element(id);


--
-- TOC entry 6627 (class 2606 OID 2602138)
-- Dependencies: 5728 4142 4146
-- Name: fk_question_reponse_elements_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse_elements_old
    ADD CONSTRAINT fk_question_reponse_elements_4 FOREIGN KEY (question_reponse) REFERENCES question_reponse(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6630 (class 2606 OID 2602143)
-- Dependencies: 5728 4142 4147
-- Name: fk_question_reponse_elements_old_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY question_reponse_elements_older
    ADD CONSTRAINT fk_question_reponse_elements_old_4 FOREIGN KEY (question_reponse) REFERENCES question_reponse(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6633 (class 2606 OID 2602148)
-- Dependencies: 5732 4144 4150
-- Name: fk_reponse_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY reponse
    ADD CONSTRAINT fk_reponse_1 FOREIGN KEY (id) REFERENCES question_reponse_element(id) ON DELETE CASCADE;


--
-- TOC entry 6471 (class 2606 OID 2602153)
-- Dependencies: 5461 4001 4004
-- Name: fk_ressource_etape_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY etape_ressource
    ADD CONSTRAINT fk_ressource_etape_1 FOREIGN KEY (id) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6472 (class 2606 OID 2602158)
-- Dependencies: 5535 4036 4004
-- Name: fk_ressource_etape_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY etape_ressource
    ADD CONSTRAINT fk_ressource_etape_2 FOREIGN KEY (fichier) REFERENCES fichier_ressource(id);


--
-- TOC entry 6473 (class 2606 OID 2602163)
-- Dependencies: 5458 3999 4004
-- Name: fk_ressource_etape_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY etape_ressource
    ADD CONSTRAINT fk_ressource_etape_3 FOREIGN KEY (espace) REFERENCES espace(id);


--
-- TOC entry 6474 (class 2606 OID 2602168)
-- Dependencies: 5812 4178 4004
-- Name: fk_ressource_etape_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY etape_ressource
    ADD CONSTRAINT fk_ressource_etape_4 FOREIGN KEY (section) REFERENCES section(id);


--
-- TOC entry 6636 (class 2606 OID 2602173)
-- Dependencies: 5683 4123 4123 4152 4152
-- Name: fk_resultat_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat
    ADD CONSTRAINT fk_resultat_2 FOREIGN KEY (parcours, etape) REFERENCES parcours_etapes(parcours, etape);


--
-- TOC entry 6638 (class 2606 OID 2602178)
-- Dependencies: 5507 4023 4153
-- Name: fk_resultat_exotlc; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_exotlc
    ADD CONSTRAINT fk_resultat_exotlc FOREIGN KEY (fichier_rendu) REFERENCES fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6637 (class 2606 OID 2602183)
-- Dependencies: 5758 4152 4153
-- Name: fk_resultat_exotlc_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_exotlc
    ADD CONSTRAINT fk_resultat_exotlc_1 FOREIGN KEY (id) REFERENCES resultat(id) ON DELETE CASCADE;


--
-- TOC entry 6640 (class 2606 OID 2602188)
-- Dependencies: 5450 3993 4154
-- Name: fk_resultat_exotlc_critere_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_exotlc_critere
    ADD CONSTRAINT fk_resultat_exotlc_critere_2 FOREIGN KEY (critere) REFERENCES critere(id) ON DELETE RESTRICT;


--
-- TOC entry 6639 (class 2606 OID 2602193)
-- Dependencies: 5763 4153 4154
-- Name: fk_resultat_exotlc_critere_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_exotlc_critere
    ADD CONSTRAINT fk_resultat_exotlc_critere_3 FOREIGN KEY (id) REFERENCES resultat_exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6642 (class 2606 OID 2602198)
-- Dependencies: 5450 3993 4155
-- Name: fk_resultat_exotlc_sous_critere_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_exotlc_sous_critere
    ADD CONSTRAINT fk_resultat_exotlc_sous_critere_2 FOREIGN KEY (sous_critere) REFERENCES critere(id) ON DELETE RESTRICT;


--
-- TOC entry 6641 (class 2606 OID 2602203)
-- Dependencies: 5763 4153 4155
-- Name: fk_resultat_exotlc_sous_critere_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_exotlc_sous_critere
    ADD CONSTRAINT fk_resultat_exotlc_sous_critere_3 FOREIGN KEY (id) REFERENCES resultat_exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6643 (class 2606 OID 2602208)
-- Dependencies: 5845 4193 4193 4156 4156
-- Name: fk_resultat_positionnement_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_positionnement
    ADD CONSTRAINT fk_resultat_positionnement_1 FOREIGN KEY (id, positionnement) REFERENCES test_positionnements(test, positionnement);


--
-- TOC entry 6645 (class 2606 OID 2602213)
-- Dependencies: 5770 4156 4156 4156 4157 4157 4157
-- Name: fk_resultat_positionnement_question_reponse; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_positionnement_question_reponse
    ADD CONSTRAINT fk_resultat_positionnement_question_reponse FOREIGN KEY (id, test, question_reponse) REFERENCES resultat_positionnement(id, test, positionnement) ON DELETE CASCADE;


--
-- TOC entry 6644 (class 2606 OID 2602218)
-- Dependencies: 5711 4135 4135 4135 4157 4157 4157
-- Name: fk_resultat_positionnement_question_reponse_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_positionnement_question_reponse
    ADD CONSTRAINT fk_resultat_positionnement_question_reponse_1 FOREIGN KEY (question_reponse, question, choix) REFERENCES positionnement_elements(question_reponse, question, choix);


--
-- TOC entry 6647 (class 2606 OID 2602223)
-- Dependencies: 5481 4009 4158
-- Name: fk_resultat_serie; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_serie
    ADD CONSTRAINT fk_resultat_serie FOREIGN KEY (evaluation) REFERENCES evaluation(id);


--
-- TOC entry 6646 (class 2606 OID 2602228)
-- Dependencies: 5758 4152 4158
-- Name: fk_resultat_serie_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_serie
    ADD CONSTRAINT fk_resultat_serie_1 FOREIGN KEY (id) REFERENCES resultat(id) ON DELETE CASCADE;


--
-- TOC entry 6648 (class 2606 OID 2602233)
-- Dependencies: 5777 4158 4158 4159 4159
-- Name: fk_resultat_serie_ftb; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_serie_ftb
    ADD CONSTRAINT fk_resultat_serie_ftb FOREIGN KEY (id, ftb) REFERENCES resultat_serie(id, evaluation) ON DELETE CASCADE;


--
-- TOC entry 6651 (class 2606 OID 2602238)
-- Dependencies: 5777 4158 4158 4160 4160
-- Name: fk_resultat_serie_question_reponse_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_serie_question_reponse
    ADD CONSTRAINT fk_resultat_serie_question_reponse_1 FOREIGN KEY (id, question_reponse) REFERENCES resultat_serie(id, evaluation) ON DELETE CASCADE;


--
-- TOC entry 6650 (class 2606 OID 2602243)
-- Dependencies: 5734 4145 4145 4160 4160
-- Name: fk_resultat_serie_question_reponse_question; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_serie_question_reponse
    ADD CONSTRAINT fk_resultat_serie_question_reponse_question FOREIGN KEY (question_reponse, question) REFERENCES question_reponse_elements(question_reponse, question_reponse_element);


--
-- TOC entry 6649 (class 2606 OID 2602248)
-- Dependencies: 5734 4145 4145 4160 4160
-- Name: fk_resultat_serie_question_reponse_reponse; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_serie_question_reponse
    ADD CONSTRAINT fk_resultat_serie_question_reponse_reponse FOREIGN KEY (question_reponse, reponse) REFERENCES question_reponse_elements(question_reponse, question_reponse_element);


--
-- TOC entry 6652 (class 2606 OID 2602253)
-- Dependencies: 5789 4165 4161
-- Name: fk_resultat_serie_tentative_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_serie_tentative
    ADD CONSTRAINT fk_resultat_serie_tentative_1 FOREIGN KEY (id) REFERENCES resultat_tentative(id) ON DELETE CASCADE;


--
-- TOC entry 6653 (class 2606 OID 2602258)
-- Dependencies: 5785 4161 4161 4162 4162
-- Name: fk_resultat_serie_tentative_ftb; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_serie_tentative_ftb
    ADD CONSTRAINT fk_resultat_serie_tentative_ftb FOREIGN KEY (id, ftb) REFERENCES resultat_serie_tentative(id, evaluation) ON DELETE CASCADE;


--
-- TOC entry 6654 (class 2606 OID 2602263)
-- Dependencies: 5785 4161 4161 4163 4163
-- Name: fk_resultat_serie_tentative_question_reponse_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat_serie_tentative_question_reponse
    ADD CONSTRAINT fk_resultat_serie_tentative_question_reponse_1 FOREIGN KEY (id, question_reponse) REFERENCES resultat_serie_tentative(id, evaluation) ON DELETE CASCADE;


--
-- TOC entry 6656 (class 2606 OID 2602268)
-- Dependencies: 5461 4001 4169
-- Name: fk_scenario_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY scenario
    ADD CONSTRAINT fk_scenario_1 FOREIGN KEY (id) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6655 (class 2606 OID 2602273)
-- Dependencies: 5542 4039 4169
-- Name: fk_scenario_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY scenario
    ADD CONSTRAINT fk_scenario_2 FOREIGN KEY (fichier) REFERENCES fichier_scenario(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6658 (class 2606 OID 2602278)
-- Dependencies: 5461 4001 4170
-- Name: fk_scenario_dynamique_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY scenario_dynamique
    ADD CONSTRAINT fk_scenario_dynamique_1 FOREIGN KEY (id) REFERENCES etape(id) ON DELETE CASCADE;


--
-- TOC entry 6657 (class 2606 OID 2602283)
-- Dependencies: 5544 4040 4170
-- Name: fk_scenario_dynamique_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY scenario_dynamique
    ADD CONSTRAINT fk_scenario_dynamique_2 FOREIGN KEY (fichier) REFERENCES fichier_scenario_dynamique(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6659 (class 2606 OID 2602288)
-- Dependencies: 5522 4030 4178
-- Name: fk_section_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY section
    ADD CONSTRAINT fk_section_1 FOREIGN KEY (icone) REFERENCES fichier_icone(id);


--
-- TOC entry 6661 (class 2606 OID 2602293)
-- Dependencies: 5643 4095 4179
-- Name: fk_serie_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie
    ADD CONSTRAINT fk_serie_1 FOREIGN KEY (id) REFERENCES liste(id) ON DELETE CASCADE;


--
-- TOC entry 6660 (class 2606 OID 2602298)
-- Dependencies: 5346 3934 4179
-- Name: fk_serie_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie
    ADD CONSTRAINT fk_serie_2 FOREIGN KEY (bareme) REFERENCES bareme(id);


--
-- TOC entry 6663 (class 2606 OID 2602303)
-- Dependencies: 5814 4179 4180
-- Name: fk_serie_aleatoire_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire
    ADD CONSTRAINT fk_serie_aleatoire_2 FOREIGN KEY (id) REFERENCES serie(id) ON DELETE CASCADE;


--
-- TOC entry 6662 (class 2606 OID 2602308)
-- Dependencies: 5827 4186 4180
-- Name: fk_serie_aleatoire_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire
    ADD CONSTRAINT fk_serie_aleatoire_3 FOREIGN KEY ("type") REFERENCES serie_aleatoire_type(id);


--
-- TOC entry 6664 (class 2606 OID 2602313)
-- Dependencies: 5590 4064 4181
-- Name: fk_serie_aleatoire_evaluations_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_2 FOREIGN KEY (stagiaire) REFERENCES fw_individu(id);


--
-- TOC entry 6665 (class 2606 OID 2602318)
-- Dependencies: 5481 4009 4181
-- Name: fk_serie_aleatoire_evaluations_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_3 FOREIGN KEY (evaluation) REFERENCES evaluation(id);


--
-- TOC entry 6666 (class 2606 OID 2602323)
-- Dependencies: 5816 4180 4181
-- Name: fk_serie_aleatoire_evaluations_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_4 FOREIGN KEY (serie) REFERENCES serie_aleatoire(id) ON DELETE CASCADE;


--
-- TOC entry 6668 (class 2606 OID 2965606)
-- Dependencies: 5558 4049 4181
-- Name: fk_serie_aleatoire_evaluations_6; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_6 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6667 (class 2606 OID 2602333)
-- Dependencies: 5818 4181 4181 4181 4181 4181 4181 4181 4181 4181 4181
-- Name: fk_serie_aleatoire_evaluations_7; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_7 FOREIGN KEY (stagiaire, serie, pere, formation, parcours) REFERENCES serie_aleatoire_evaluations(stagiaire, serie, evaluation, formation, parcours);


--
-- TOC entry 6669 (class 2606 OID 2965856)
-- Dependencies: 5558 4049 4182
-- Name: fk_serie_aleatoire_melangee_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_melangee
    ADD CONSTRAINT fk_serie_aleatoire_melangee_1 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6671 (class 2606 OID 2602343)
-- Dependencies: 5814 4179 4182
-- Name: fk_serie_aleatoire_melangee_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_melangee
    ADD CONSTRAINT fk_serie_aleatoire_melangee_2 FOREIGN KEY (serie) REFERENCES serie(id) ON DELETE CASCADE;


--
-- TOC entry 6670 (class 2606 OID 2602348)
-- Dependencies: 5683 4123 4123 4182 4182
-- Name: fk_serie_aleatoire_melangee_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_melangee
    ADD CONSTRAINT fk_serie_aleatoire_melangee_3 FOREIGN KEY (parcours, serie) REFERENCES parcours_etapes(parcours, etape) ON DELETE CASCADE;


--
-- TOC entry 6673 (class 2606 OID 2602353)
-- Dependencies: 5485 4011 4183
-- Name: fk_serie_aleatoire_multiserie_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_multiserie
    ADD CONSTRAINT fk_serie_aleatoire_multiserie_2 FOREIGN KEY (type_evaluations) REFERENCES evaluation_type(id);


--
-- TOC entry 6675 (class 2606 OID 2602358)
-- Dependencies: 5485 4011 4184
-- Name: fk_serie_aleatoire_multitheme_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_multitheme
    ADD CONSTRAINT fk_serie_aleatoire_multitheme_3 FOREIGN KEY (type_evaluations) REFERENCES evaluation_type(id);


--
-- TOC entry 6672 (class 2606 OID 2602363)
-- Dependencies: 5816 4180 4183
-- Name: fk_serie_aleatoire_serie_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_multiserie
    ADD CONSTRAINT fk_serie_aleatoire_serie_1 FOREIGN KEY (serie) REFERENCES serie_aleatoire(id) ON DELETE CASCADE;


--
-- TOC entry 6674 (class 2606 OID 2602368)
-- Dependencies: 5816 4180 4184
-- Name: fk_serie_aleatoire_theme_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_aleatoire_multitheme
    ADD CONSTRAINT fk_serie_aleatoire_theme_1 FOREIGN KEY (serie) REFERENCES serie_aleatoire(id) ON DELETE CASCADE;


--
-- TOC entry 6679 (class 2606 OID 2602373)
-- Dependencies: 5814 4179 4187
-- Name: fk_serie_blocante_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_bloquante
    ADD CONSTRAINT fk_serie_blocante_1 FOREIGN KEY (serie) REFERENCES serie(id) ON DELETE CASCADE;


--
-- TOC entry 6677 (class 2606 OID 2965589)
-- Dependencies: 5558 4049 4187
-- Name: fk_serie_blocante_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_bloquante
    ADD CONSTRAINT fk_serie_blocante_2 FOREIGN KEY (formation) REFERENCES formation(id) ON DELETE CASCADE;


--
-- TOC entry 6678 (class 2606 OID 2602383)
-- Dependencies: 5683 4123 4123 4187 4187
-- Name: fk_serie_blocante_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_bloquante
    ADD CONSTRAINT fk_serie_blocante_3 FOREIGN KEY (parcours, serie) REFERENCES parcours_etapes(parcours, etape) ON DELETE CASCADE;


--
-- TOC entry 6680 (class 2606 OID 2602388)
-- Dependencies: 5481 4009 4188
-- Name: fk_serie_evaluations_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_evaluations
    ADD CONSTRAINT fk_serie_evaluations_2 FOREIGN KEY (evaluation) REFERENCES evaluation(id);


--
-- TOC entry 6681 (class 2606 OID 2602393)
-- Dependencies: 5346 3934 4188
-- Name: fk_serie_evaluations_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_evaluations
    ADD CONSTRAINT fk_serie_evaluations_3 FOREIGN KEY (bareme) REFERENCES bareme(id);


--
-- TOC entry 6682 (class 2606 OID 2602398)
-- Dependencies: 5814 4179 4188
-- Name: fk_serie_evaluations_4; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_evaluations
    ADD CONSTRAINT fk_serie_evaluations_4 FOREIGN KEY (serie) REFERENCES serie(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6683 (class 2606 OID 2602403)
-- Dependencies: 5834 4188 4188 4188 4188
-- Name: fk_serie_evaluations_5; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY serie_evaluations
    ADD CONSTRAINT fk_serie_evaluations_5 FOREIGN KEY (serie, pere) REFERENCES serie_evaluations(serie, evaluation);


--
-- TOC entry 6684 (class 2606 OID 2602408)
-- Dependencies: 5558 4049 4190
-- Name: fk_session_active_formation; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY session_active
    ADD CONSTRAINT fk_session_active_formation FOREIGN KEY (formation) REFERENCES formation(id);


--
-- TOC entry 6688 (class 2606 OID 2602413)
-- Dependencies: 5643 4095 4192
-- Name: fk_test_liste_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY test
    ADD CONSTRAINT fk_test_liste_1 FOREIGN KEY (id) REFERENCES liste(id) ON DELETE CASCADE;


--
-- TOC entry 6691 (class 2606 OID 2602418)
-- Dependencies: 5843 4192 4193
-- Name: fk_test_liste_tests_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY test_positionnements
    ADD CONSTRAINT fk_test_liste_tests_1 FOREIGN KEY (test) REFERENCES test(id) ON DELETE CASCADE;


--
-- TOC entry 6690 (class 2606 OID 2602423)
-- Dependencies: 5716 4138 4193
-- Name: fk_test_liste_tests_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY test_positionnements
    ADD CONSTRAINT fk_test_liste_tests_2 FOREIGN KEY (positionnement) REFERENCES positionnement_old(id);


--
-- TOC entry 6689 (class 2606 OID 2602428)
-- Dependencies: 5845 4193 4193 4193 4193
-- Name: fk_test_liste_tests_3; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY test_positionnements
    ADD CONSTRAINT fk_test_liste_tests_3 FOREIGN KEY (test, pere) REFERENCES test_positionnements(test, positionnement);


--
-- TOC entry 6694 (class 2606 OID 2602433)
-- Dependencies: 5848 4195 4196
-- Name: fk_theme_categories_1; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY theme_categories
    ADD CONSTRAINT fk_theme_categories_1 FOREIGN KEY (theme) REFERENCES theme(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6693 (class 2606 OID 2602438)
-- Dependencies: 5357 3948 4196
-- Name: fk_theme_categories_2; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY theme_categories
    ADD CONSTRAINT fk_theme_categories_2 FOREIGN KEY (categorie) REFERENCES categorie(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6541 (class 2606 OID 2602443)
-- Dependencies: 5586 4062 4072
-- Name: fw_module_individus_types_droit_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY fw_module_individus_types
    ADD CONSTRAINT fw_module_individus_types_droit_fkey FOREIGN KEY (droit) REFERENCES fw_droit(id);


--
-- TOC entry 6542 (class 2606 OID 2602448)
-- Dependencies: 5598 4071 4074
-- Name: fw_module_pages_module_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY fw_module_pages
    ADD CONSTRAINT fw_module_pages_module_fkey FOREIGN KEY (module) REFERENCES fw_module(id) ON DELETE CASCADE;


--
-- TOC entry 6557 (class 2606 OID 2602453)
-- Dependencies: 5454 3994 4085
-- Name: individu_type_droits_droit_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY individu_type_droits
    ADD CONSTRAINT individu_type_droits_droit_fkey FOREIGN KEY (droit) REFERENCES droit(id);


--
-- TOC entry 6556 (class 2606 OID 2602458)
-- Dependencies: 5592 4066 4085
-- Name: individu_type_droits_individu_type_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY individu_type_droits
    ADD CONSTRAINT individu_type_droits_individu_type_fkey FOREIGN KEY (individu_type) REFERENCES fw_individu_type(id);


--
-- TOC entry 6540 (class 2606 OID 2602463)
-- Dependencies: 5592 4066 4072
-- Name: module_individus_types_individu_type_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY fw_module_individus_types
    ADD CONSTRAINT module_individus_types_individu_type_fkey FOREIGN KEY (individu_type) REFERENCES fw_individu_type(id);


--
-- TOC entry 6539 (class 2606 OID 2602468)
-- Dependencies: 5598 4071 4072
-- Name: module_individus_types_module_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: pgsql
--

ALTER TABLE ONLY fw_module_individus_types
    ADD CONSTRAINT module_individus_types_module_fkey FOREIGN KEY (module) REFERENCES fw_module(id) ON DELETE CASCADE;


--
-- TOC entry 6635 (class 2606 OID 2961017)
-- Dependencies: 5558 4049 4152
-- Name: resultat_formation_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY resultat
    ADD CONSTRAINT resultat_formation_fkey FOREIGN KEY (formation) REFERENCES formation(id);


--
-- TOC entry 6692 (class 2606 OID 2602473)
-- Dependencies: 5590 4064 4195
-- Name: theme_individu_fkey; Type: FK CONSTRAINT; Schema: contraintes; Owner: postgres
--

ALTER TABLE ONLY theme
    ADD CONSTRAINT theme_individu_fkey FOREIGN KEY (individu) REFERENCES fw_individu(id);


SET search_path = v2, pg_catalog;

--
-- TOC entry 6748 (class 2606 OID 2602478)
-- Dependencies: 6000 4437 4465
-- Name: alerte_formation_fkey; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lrt_alerte
    ADD CONSTRAINT alerte_formation_fkey FOREIGN KEY (formation) REFERENCES frmtn_formation(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6732 (class 2606 OID 2602483)
-- Dependencies: 6023 4452 4453
-- Name: fk_capacite_titre_capacites_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_capacite_titre_capacites
    ADD CONSTRAINT fk_capacite_titre_capacites_1 FOREIGN KEY (capacite_titre) REFERENCES grll_capacite_titre(id);


--
-- TOC entry 6731 (class 2606 OID 2602488)
-- Dependencies: 6021 4450 4453
-- Name: fk_capacite_titre_capacites_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_capacite_titre_capacites
    ADD CONSTRAINT fk_capacite_titre_capacites_2 FOREIGN KEY (capacite) REFERENCES grll_capacite(id);


--
-- TOC entry 6734 (class 2606 OID 2602493)
-- Dependencies: 6284 4578 4578 4578 4456 4456 4456
-- Name: fk_categorie_capacite_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_categorie_capacite
    ADD CONSTRAINT fk_categorie_capacite_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6733 (class 2606 OID 2602498)
-- Dependencies: 6021 4450 4456
-- Name: fk_categorie_capacite_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_categorie_capacite
    ADD CONSTRAINT fk_categorie_capacite_2 FOREIGN KEY (id) REFERENCES grll_capacite(id) ON DELETE CASCADE;


--
-- TOC entry 6736 (class 2606 OID 2602503)
-- Dependencies: 6284 4578 4578 4578 4457 4457 4457
-- Name: fk_categorie_capacite_titre_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_categorie_capacite_titre
    ADD CONSTRAINT fk_categorie_capacite_titre_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6735 (class 2606 OID 2602508)
-- Dependencies: 6023 4452 4457
-- Name: fk_categorie_capacite_titre_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_categorie_capacite_titre
    ADD CONSTRAINT fk_categorie_capacite_titre_2 FOREIGN KEY (id) REFERENCES grll_capacite_titre(id) ON DELETE CASCADE;


--
-- TOC entry 6929 (class 2606 OID 2602513)
-- Dependencies: 6284 4578 4578 4578 4609 4609 4609
-- Name: fk_categorie_critere_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_critere
    ADD CONSTRAINT fk_categorie_critere_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6928 (class 2606 OID 2602518)
-- Dependencies: 6354 4616 4609
-- Name: fk_categorie_critere_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_critere
    ADD CONSTRAINT fk_categorie_critere_2 FOREIGN KEY (id) REFERENCES xtlc_critere(id) ON DELETE CASCADE;


--
-- TOC entry 6847 (class 2606 OID 2602523)
-- Dependencies: 6284 4578 4578 4578 4540 4540 4540
-- Name: fk_categorie_css_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_categorie_fichier_css
    ADD CONSTRAINT fk_categorie_css_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6846 (class 2606 OID 2602528)
-- Dependencies: 6210 4544 4540
-- Name: fk_categorie_css_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_categorie_fichier_css
    ADD CONSTRAINT fk_categorie_css_2 FOREIGN KEY (id) REFERENCES scnr_fichier_css(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6901 (class 2606 OID 2602533)
-- Dependencies: 6284 4578 4578 4578 4579 4579 4579
-- Name: fk_categorie_etape_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tp_categorie_etape
    ADD CONSTRAINT fk_categorie_etape_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6900 (class 2606 OID 2602538)
-- Dependencies: 6292 4582 4579
-- Name: fk_categorie_etape_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tp_categorie_etape
    ADD CONSTRAINT fk_categorie_etape_2 FOREIGN KEY (id) REFERENCES tp_etape(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6917 (class 2606 OID 2602543)
-- Dependencies: 6284 4578 4578 4578 4595 4595 4595
-- Name: fk_categorie_evaluation_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vltn_categorie_evaluation
    ADD CONSTRAINT fk_categorie_evaluation_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6916 (class 2606 OID 2602548)
-- Dependencies: 6324 4598 4595
-- Name: fk_categorie_evaluation_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vltn_categorie_evaluation
    ADD CONSTRAINT fk_categorie_evaluation_2 FOREIGN KEY (id) REFERENCES vltn_evaluation(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6931 (class 2606 OID 2602553)
-- Dependencies: 6284 4578 4578 4578 4610 4610 4610
-- Name: fk_categorie_exotlc_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_exotlc
    ADD CONSTRAINT fk_categorie_exotlc_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6930 (class 2606 OID 2602558)
-- Dependencies: 6356 4617 4610
-- Name: fk_categorie_exotlc_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_exotlc
    ADD CONSTRAINT fk_categorie_exotlc_2 FOREIGN KEY (id) REFERENCES xtlc_exotlc(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6933 (class 2606 OID 2602563)
-- Dependencies: 6284 4578 4578 4578 4611 4611 4611
-- Name: fk_categorie_fichier_correction_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_fichier_correction
    ADD CONSTRAINT fk_categorie_fichier_correction_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6932 (class 2606 OID 2602568)
-- Dependencies: 5977 4419 4611
-- Name: fk_categorie_fichier_correction_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_fichier_correction
    ADD CONSTRAINT fk_categorie_fichier_correction_2 FOREIGN KEY (id) REFERENCES fchr_fichier_correction(id) ON DELETE CASCADE;


--
-- TOC entry 6935 (class 2606 OID 2602573)
-- Dependencies: 6284 4578 4578 4578 4612 4612 4612
-- Name: fk_categorie_fichier_exotlc_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_fichier_exotlc
    ADD CONSTRAINT fk_categorie_fichier_exotlc_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6934 (class 2606 OID 2602578)
-- Dependencies: 6368 4624 4612
-- Name: fk_categorie_fichier_exotlc_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_fichier_exotlc
    ADD CONSTRAINT fk_categorie_fichier_exotlc_2 FOREIGN KEY (id) REFERENCES xtlc_fichier_exotlc(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6826 (class 2606 OID 2602583)
-- Dependencies: 6284 4578 4578 4578 4523 4523 4523
-- Name: fk_categorie_fichier_ressource_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_categorie_fichier_ressource
    ADD CONSTRAINT fk_categorie_fichier_ressource_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6825 (class 2606 OID 2602588)
-- Dependencies: 6181 4530 4523
-- Name: fk_categorie_fichier_ressource_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_categorie_fichier_ressource
    ADD CONSTRAINT fk_categorie_fichier_ressource_2 FOREIGN KEY (id) REFERENCES rssrc_fichier_ressource(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6827 (class 2606 OID 2602593)
-- Dependencies: 6284 4578 4578 4578 4524 4524 4524
-- Name: fk_categorie_fichier_ressource_fichier_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_categorie_fichier_ressource_fichier
    ADD CONSTRAINT fk_categorie_fichier_ressource_fichier_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6851 (class 2606 OID 2602598)
-- Dependencies: 6284 4578 4578 4578 4542 4542 4542
-- Name: fk_categorie_fichier_scenario_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_categorie_fichier_scenario
    ADD CONSTRAINT fk_categorie_fichier_scenario_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6850 (class 2606 OID 2602603)
-- Dependencies: 6215 4546 4542
-- Name: fk_categorie_fichier_scenario_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_categorie_fichier_scenario
    ADD CONSTRAINT fk_categorie_fichier_scenario_2 FOREIGN KEY (id) REFERENCES scnr_fichier_scenario(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6828 (class 2606 OID 2602608)
-- Dependencies: 6284 4578 4578 4578 4525 4525 4525
-- Name: fk_categorie_fichier_texte_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_categorie_fichier_ressource_texte
    ADD CONSTRAINT fk_categorie_fichier_texte_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6700 (class 2606 OID 2602613)
-- Dependencies: 6284 4578 4578 4578 4414 4414 4414
-- Name: fk_categorie_ftb_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fb_categorie_ftb
    ADD CONSTRAINT fk_categorie_ftb_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6699 (class 2606 OID 2602618)
-- Dependencies: 5971 4415 4414
-- Name: fk_categorie_ftb_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fb_categorie_ftb
    ADD CONSTRAINT fk_categorie_ftb_2 FOREIGN KEY (id) REFERENCES fb_ftb(id) ON DELETE CASCADE;


--
-- TOC entry 6738 (class 2606 OID 2602623)
-- Dependencies: 6284 4578 4578 4578 4458 4458 4458
-- Name: fk_categorie_grille_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_categorie_grille
    ADD CONSTRAINT fk_categorie_grille_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6737 (class 2606 OID 2602628)
-- Dependencies: 6035 4460 4458
-- Name: fk_categorie_grille_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_categorie_grille
    ADD CONSTRAINT fk_categorie_grille_2 FOREIGN KEY (id) REFERENCES grll_grille(id) ON DELETE CASCADE;


--
-- TOC entry 6849 (class 2606 OID 2602633)
-- Dependencies: 6284 4578 4578 4578 4541 4541 4541
-- Name: fk_categorie_media_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_categorie_fichier_media_scenario
    ADD CONSTRAINT fk_categorie_media_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6848 (class 2606 OID 2602638)
-- Dependencies: 6212 4545 4541
-- Name: fk_categorie_media_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_categorie_fichier_media_scenario
    ADD CONSTRAINT fk_categorie_media_2 FOREIGN KEY (id) REFERENCES scnr_fichier_media_scenario(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6919 (class 2606 OID 2602643)
-- Dependencies: 6284 4578 4578 4578 4596 4596 4596
-- Name: fk_categorie_media_evaluation_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vltn_categorie_fichier_media_evaluation
    ADD CONSTRAINT fk_categorie_media_evaluation_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6918 (class 2606 OID 2602648)
-- Dependencies: 6330 4601 4596
-- Name: fk_categorie_media_evaluation_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vltn_categorie_fichier_media_evaluation
    ADD CONSTRAINT fk_categorie_media_evaluation_2 FOREIGN KEY (id) REFERENCES vltn_fichier_media_evaluation(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6937 (class 2606 OID 2602653)
-- Dependencies: 6284 4578 4578 4578 4613 4613 4613
-- Name: fk_categorie_media_exotlc_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_fichier_media_exotlc
    ADD CONSTRAINT fk_categorie_media_exotlc_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6936 (class 2606 OID 2602658)
-- Dependencies: 6370 4625 4613
-- Name: fk_categorie_media_exotlc_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_fichier_media_exotlc
    ADD CONSTRAINT fk_categorie_media_exotlc_2 FOREIGN KEY (id) REFERENCES xtlc_fichier_media_exotlc(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6939 (class 2606 OID 2602663)
-- Dependencies: 6284 4578 4578 4578 4614 4614 4614
-- Name: fk_categorie_modele_correction_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_modele_correction
    ADD CONSTRAINT fk_categorie_modele_correction_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6938 (class 2606 OID 2602668)
-- Dependencies: 6372 4627 4614
-- Name: fk_categorie_modele_correction_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_categorie_modele_correction
    ADD CONSTRAINT fk_categorie_modele_correction_2 FOREIGN KEY (id) REFERENCES xtlc_modele_correction(id) ON DELETE CASCADE;


--
-- TOC entry 6783 (class 2606 OID 2602673)
-- Dependencies: 6284 4578 4578 4578 4492 4492 4492
-- Name: fk_categorie_positionnement_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_categorie_positionnement
    ADD CONSTRAINT fk_categorie_positionnement_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6782 (class 2606 OID 2602678)
-- Dependencies: 6097 4495 4492
-- Name: fk_categorie_positionnement_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_categorie_positionnement
    ADD CONSTRAINT fk_categorie_positionnement_2 FOREIGN KEY (id) REFERENCES pstnnmnt_positionnement(id) ON DELETE CASCADE;


--
-- TOC entry 6805 (class 2606 OID 2602683)
-- Dependencies: 6284 4578 4578 4578 4506 4506 4506
-- Name: fk_categorie_qcm_element_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_categorie_question_reponse_element
    ADD CONSTRAINT fk_categorie_qcm_element_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6804 (class 2606 OID 2602688)
-- Dependencies: 6147 4514 4506
-- Name: fk_categorie_qcm_element_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_categorie_question_reponse_element
    ADD CONSTRAINT fk_categorie_qcm_element_2 FOREIGN KEY (id) REFERENCES qr_question_reponse_element(id) ON DELETE CASCADE;


--
-- TOC entry 6800 (class 2606 OID 2602693)
-- Dependencies: 6284 4578 4578 4578 4503 4503 4503
-- Name: fk_categorie_qsrc_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qc_categorie_qsrc
    ADD CONSTRAINT fk_categorie_qsrc_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6799 (class 2606 OID 2602698)
-- Dependencies: 6125 4504 4503
-- Name: fk_categorie_qsrc_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qc_categorie_qsrc
    ADD CONSTRAINT fk_categorie_qsrc_2 FOREIGN KEY (id) REFERENCES qc_qsrc(id) ON DELETE CASCADE;


--
-- TOC entry 6803 (class 2606 OID 2602703)
-- Dependencies: 6284 4578 4578 4578 4505 4505 4505
-- Name: fk_categorie_question_reponse_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_categorie_question_reponse
    ADD CONSTRAINT fk_categorie_question_reponse_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6802 (class 2606 OID 2602708)
-- Dependencies: 6143 4512 4505
-- Name: fk_categorie_question_reponse_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_categorie_question_reponse
    ADD CONSTRAINT fk_categorie_question_reponse_2 FOREIGN KEY (id) REFERENCES qr_question_reponse(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6824 (class 2606 OID 2602713)
-- Dependencies: 6284 4578 4578 4578 4522 4522 4522
-- Name: fk_categorie_ressource_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_categorie_etape_ressource
    ADD CONSTRAINT fk_categorie_ressource_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6823 (class 2606 OID 2602718)
-- Dependencies: 6177 4528 4522
-- Name: fk_categorie_ressource_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_categorie_etape_ressource
    ADD CONSTRAINT fk_categorie_ressource_2 FOREIGN KEY (id) REFERENCES rssrc_etape_ressource(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6853 (class 2606 OID 2602723)
-- Dependencies: 6284 4578 4578 4578 4543 4543 4543
-- Name: fk_categorie_scenario_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_categorie_scenario
    ADD CONSTRAINT fk_categorie_scenario_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6852 (class 2606 OID 2602728)
-- Dependencies: 6217 4547 4543
-- Name: fk_categorie_scenario_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_categorie_scenario
    ADD CONSTRAINT fk_categorie_scenario_2 FOREIGN KEY (id) REFERENCES scnr_scenario(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6860 (class 2606 OID 2602733)
-- Dependencies: 6284 4578 4578 4578 4548 4548 4548
-- Name: fk_categorie_scorm_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scrm_categorie_fichier_etape_scorm
    ADD CONSTRAINT fk_categorie_scorm_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6859 (class 2606 OID 2602738)
-- Dependencies: 6226 4550 4548
-- Name: fk_categorie_scorm_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scrm_categorie_fichier_etape_scorm
    ADD CONSTRAINT fk_categorie_scorm_2 FOREIGN KEY (id) REFERENCES scrm_fichier_etape_scorm(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6897 (class 2606 OID 2602743)
-- Dependencies: 6247 4560 4560 4573 4573
-- Name: fk_categorie_serie; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltrmltthm_serie_aleatoire_multitheme
    ADD CONSTRAINT fk_categorie_serie FOREIGN KEY (theme_source, serie) REFERENCES sr_categorie_serie(theme, id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6869 (class 2606 OID 2602748)
-- Dependencies: 6284 4578 4578 4578 4560 4560 4560
-- Name: fk_categorie_serie_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_categorie_serie
    ADD CONSTRAINT fk_categorie_serie_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6868 (class 2606 OID 2602753)
-- Dependencies: 6256 4564 4560
-- Name: fk_categorie_serie_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_categorie_serie
    ADD CONSTRAINT fk_categorie_serie_2 FOREIGN KEY (id) REFERENCES sr_serie(id) ON DELETE CASCADE;


--
-- TOC entry 6807 (class 2606 OID 2602758)
-- Dependencies: 6284 4578 4578 4578 4507 4507 4507
-- Name: fk_categorie_sondage_element_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_categorie_sondage_element
    ADD CONSTRAINT fk_categorie_sondage_element_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6806 (class 2606 OID 2602763)
-- Dependencies: 6143 4512 4507
-- Name: fk_categorie_sondage_element_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_categorie_sondage_element
    ADD CONSTRAINT fk_categorie_sondage_element_2 FOREIGN KEY (id) REFERENCES qr_question_reponse(id);


--
-- TOC entry 6909 (class 2606 OID 2602768)
-- Dependencies: 6284 4578 4578 4578 4588 4588 4588
-- Name: fk_categorie_test_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tst_categorie_test
    ADD CONSTRAINT fk_categorie_test_1 FOREIGN KEY (id, categorie, theme) REFERENCES thm_theme_categories(id, categorie, theme) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6908 (class 2606 OID 2602773)
-- Dependencies: 6314 4591 4588
-- Name: fk_categorie_test_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tst_categorie_test
    ADD CONSTRAINT fk_categorie_test_2 FOREIGN KEY (id) REFERENCES tst_test(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6695 (class 2606 OID 2602778)
-- Dependencies: 6292 4582 4405
-- Name: fk_chat_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY c_etape_chat
    ADD CONSTRAINT fk_chat_1 FOREIGN KEY (id) REFERENCES tp_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6784 (class 2606 OID 2602783)
-- Dependencies: 6156 4518 4493
-- Name: fk_choix_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_choix
    ADD CONSTRAINT fk_choix_1 FOREIGN KEY (id) REFERENCES qr_reponse(id) ON DELETE CASCADE;


--
-- TOC entry 6696 (class 2606 OID 2602788)
-- Dependencies: 5965 4410 4410
-- Name: fk_classe_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY cls_classe
    ADD CONSTRAINT fk_classe_1 FOREIGN KEY (pere) REFERENCES cls_classe(id) ON DELETE CASCADE;


--
-- TOC entry 6698 (class 2606 OID 2602793)
-- Dependencies: 5965 4410 4411
-- Name: fk_classe_individus_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY cls_classe_individus
    ADD CONSTRAINT fk_classe_individus_1 FOREIGN KEY (classe) REFERENCES cls_classe(id);


--
-- TOC entry 6697 (class 2606 OID 2602798)
-- Dependencies: 6059 4474 4411
-- Name: fk_classe_individus_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY cls_classe_individus
    ADD CONSTRAINT fk_classe_individus_2 FOREIGN KEY (individu) REFERENCES ndvd_individu(id);


--
-- TOC entry 6902 (class 2606 OID 2602803)
-- Dependencies: 6292 4582 4580
-- Name: fk_commentaire_etape; Type: FK CONSTRAINT; Schema: v2; Owner: pgsql
--

ALTER TABLE ONLY tp_commentaire_etape
    ADD CONSTRAINT fk_commentaire_etape FOREIGN KEY (etape) REFERENCES tp_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6723 (class 2606 OID 2602808)
-- Dependencies: 6059 4474 4440
-- Name: fk_connexion_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fw_connexion
    ADD CONSTRAINT fk_connexion_1 FOREIGN KEY (individu) REFERENCES ndvd_individu(id);


--
-- TOC entry 6940 (class 2606 OID 2602813)
-- Dependencies: 6354 4616 4616
-- Name: fk_critere_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_critere
    ADD CONSTRAINT fk_critere_1 FOREIGN KEY (pere) REFERENCES xtlc_critere(id) ON DELETE CASCADE;


--
-- TOC entry 6725 (class 2606 OID 2602818)
-- Dependencies: 6065 4477 4441
-- Name: fk_droit_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fw_droit
    ADD CONSTRAINT fk_droit_1 FOREIGN KEY ("type") REFERENCES ndvd_individu_type(id);


--
-- TOC entry 6724 (class 2606 OID 2602823)
-- Dependencies: 6011 4441 4441
-- Name: fk_droit_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fw_droit
    ADD CONSTRAINT fk_droit_2 FOREIGN KEY (pere) REFERENCES fw_droit(id);


--
-- TOC entry 6715 (class 2606 OID 2602828)
-- Dependencies: 6000 4437 4435
-- Name: fk_droits_formateur_formation_participants; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frmtn_formateur_droits
    ADD CONSTRAINT fk_droits_formateur_formation_participants FOREIGN KEY (formation) REFERENCES frmtn_formation(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6765 (class 2606 OID 2602833)
-- Dependencies: 5967 4411 4411 4475 4475
-- Name: fk_droits_individu_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY ndvd_individu_droits
    ADD CONSTRAINT fk_droits_individu_2 FOREIGN KEY (classe, individu) REFERENCES cls_classe_individus(classe, individu) ON DELETE CASCADE;


--
-- TOC entry 6903 (class 2606 OID 2602838)
-- Dependencies: 6295 4583 4582
-- Name: fk_etape_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tp_etape
    ADD CONSTRAINT fk_etape_1 FOREIGN KEY ("type") REFERENCES tp_etape_type(id);


--
-- TOC entry 6862 (class 2606 OID 2602843)
-- Dependencies: 6292 4582 4549
-- Name: fk_etape_scorm_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scrm_etape_scorm
    ADD CONSTRAINT fk_etape_scorm_1 FOREIGN KEY (id) REFERENCES tp_etape(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6861 (class 2606 OID 2602848)
-- Dependencies: 6226 4550 4549
-- Name: fk_etape_scorm_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scrm_etape_scorm
    ADD CONSTRAINT fk_etape_scorm_2 FOREIGN KEY (fichier) REFERENCES scrm_fichier_etape_scorm(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6920 (class 2606 OID 2602853)
-- Dependencies: 6328 4600 4598
-- Name: fk_evaluation_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vltn_evaluation
    ADD CONSTRAINT fk_evaluation_2 FOREIGN KEY ("type") REFERENCES vltn_evaluation_type(id);


--
-- TOC entry 6926 (class 2606 OID 2602858)
-- Dependencies: 6000 4437 4602
-- Name: fk_evenement_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vnmnt_evenement
    ADD CONSTRAINT fk_evenement_1 FOREIGN KEY (formation) REFERENCES frmtn_formation(id) ON DELETE CASCADE;


--
-- TOC entry 6925 (class 2606 OID 2602863)
-- Dependencies: 6059 4474 4602
-- Name: fk_evenement_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vnmnt_evenement
    ADD CONSTRAINT fk_evenement_2 FOREIGN KEY (intervenant) REFERENCES ndvd_individu(id);


--
-- TOC entry 6924 (class 2606 OID 2602868)
-- Dependencies: 6338 4607 4602
-- Name: fk_evenement_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vnmnt_evenement
    ADD CONSTRAINT fk_evenement_3 FOREIGN KEY (modalite) REFERENCES vnmnt_modalite(id);


--
-- TOC entry 6923 (class 2606 OID 2602873)
-- Dependencies: 6340 4608 4602
-- Name: fk_evenement_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vnmnt_evenement
    ADD CONSTRAINT fk_evenement_4 FOREIGN KEY (salle) REFERENCES vnmnt_salle(id);


--
-- TOC entry 6922 (class 2606 OID 2602878)
-- Dependencies: 6336 4605 4602
-- Name: fk_evenement_5; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vnmnt_evenement
    ADD CONSTRAINT fk_evenement_5 FOREIGN KEY (intervention) REFERENCES vnmnt_intervention(id);


--
-- TOC entry 6927 (class 2606 OID 2602883)
-- Dependencies: 6332 4602 4602 4603 4603
-- Name: fk_evenement_presentiel_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vnmnt_evenement_presentiel
    ADD CONSTRAINT fk_evenement_presentiel_1 FOREIGN KEY (formation, date) REFERENCES vnmnt_evenement(formation, date) ON DELETE CASCADE;


--
-- TOC entry 6942 (class 2606 OID 2602888)
-- Dependencies: 6366 4623 4617
-- Name: fk_exotlc_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_exotlc
    ADD CONSTRAINT fk_exotlc_2 FOREIGN KEY ("type") REFERENCES xtlc_exotlc_type(id);


--
-- TOC entry 6941 (class 2606 OID 2602893)
-- Dependencies: 6292 4582 4617
-- Name: fk_exotlc_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_exotlc
    ADD CONSTRAINT fk_exotlc_3 FOREIGN KEY (id) REFERENCES tp_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6944 (class 2606 OID 2602898)
-- Dependencies: 6356 4617 4618
-- Name: fk_exotlc_corrections_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_exotlc_corrections
    ADD CONSTRAINT fk_exotlc_corrections_1 FOREIGN KEY (exotlc) REFERENCES xtlc_exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6943 (class 2606 OID 2602903)
-- Dependencies: 5977 4419 4618
-- Name: fk_exotlc_corrections_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_exotlc_corrections
    ADD CONSTRAINT fk_exotlc_corrections_2 FOREIGN KEY (correction) REFERENCES fchr_fichier_correction(id);


--
-- TOC entry 6946 (class 2606 OID 2602908)
-- Dependencies: 6356 4617 4619
-- Name: fk_exotlc_fichiers_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_exotlc_fichiers
    ADD CONSTRAINT fk_exotlc_fichiers_1 FOREIGN KEY (exotlc) REFERENCES xtlc_exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6945 (class 2606 OID 2602913)
-- Dependencies: 6368 4624 4619
-- Name: fk_exotlc_fichiers_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_exotlc_fichiers
    ADD CONSTRAINT fk_exotlc_fichiers_2 FOREIGN KEY (fichier) REFERENCES xtlc_fichier_exotlc(id);


--
-- TOC entry 6947 (class 2606 OID 2602918)
-- Dependencies: 6356 4617 4620
-- Name: fk_exotlc_mail_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_exotlc_mail
    ADD CONSTRAINT fk_exotlc_mail_1 FOREIGN KEY (id) REFERENCES xtlc_exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6948 (class 2606 OID 2602923)
-- Dependencies: 6356 4617 4621
-- Name: fk_exotlc_plate_forme_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_exotlc_plate_forme
    ADD CONSTRAINT fk_exotlc_plate_forme_1 FOREIGN KEY (id) REFERENCES xtlc_exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6703 (class 2606 OID 2602928)
-- Dependencies: 5979 4421 4418
-- Name: fk_fichier_1_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fchr_fichier
    ADD CONSTRAINT fk_fichier_1_1 FOREIGN KEY ("type") REFERENCES fchr_fichier_type(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6704 (class 2606 OID 2602933)
-- Dependencies: 5975 4418 4419
-- Name: fk_fichier_correction_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fchr_fichier_correction
    ADD CONSTRAINT fk_fichier_correction_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6854 (class 2606 OID 2602938)
-- Dependencies: 5975 4418 4544
-- Name: fk_fichier_css_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_fichier_css
    ADD CONSTRAINT fk_fichier_css_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6949 (class 2606 OID 2602943)
-- Dependencies: 5975 4418 4624
-- Name: fk_fichier_exotlc_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_fichier_exotlc
    ADD CONSTRAINT fk_fichier_exotlc_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6833 (class 2606 OID 2602948)
-- Dependencies: 5975 4418 4529
-- Name: fk_fichier_icone_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_fichier_icone
    ADD CONSTRAINT fk_fichier_icone_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6855 (class 2606 OID 2602953)
-- Dependencies: 5975 4418 4545
-- Name: fk_fichier_media_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_fichier_media_scenario
    ADD CONSTRAINT fk_fichier_media_2 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6921 (class 2606 OID 2602958)
-- Dependencies: 5975 4418 4601
-- Name: fk_fichier_media_evaluation_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY vltn_fichier_media_evaluation
    ADD CONSTRAINT fk_fichier_media_evaluation_2 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6950 (class 2606 OID 2602963)
-- Dependencies: 5975 4418 4625
-- Name: fk_fichier_media_exotlc_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_fichier_media_exotlc
    ADD CONSTRAINT fk_fichier_media_exotlc_2 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6760 (class 2606 OID 2602968)
-- Dependencies: 5975 4418 4472
-- Name: fk_fichier_photo_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY ndvd_fichier_photo
    ADD CONSTRAINT fk_fichier_photo_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6834 (class 2606 OID 2602973)
-- Dependencies: 5975 4418 4531
-- Name: fk_fichier_ressource_fichier_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_fichier_ressource_fichier
    ADD CONSTRAINT fk_fichier_ressource_fichier_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6835 (class 2606 OID 2602978)
-- Dependencies: 5975 4418 4532
-- Name: fk_fichier_ressource_texte_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_fichier_ressource_texte
    ADD CONSTRAINT fk_fichier_ressource_texte_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6856 (class 2606 OID 2602983)
-- Dependencies: 5975 4418 4546
-- Name: fk_fichier_scenario_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_fichier_scenario
    ADD CONSTRAINT fk_fichier_scenario_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6863 (class 2606 OID 2602988)
-- Dependencies: 5975 4418 4550
-- Name: fk_fichier_scorm_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scrm_fichier_etape_scorm
    ADD CONSTRAINT fk_fichier_scorm_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6705 (class 2606 OID 2602993)
-- Dependencies: 6280 4575 4421
-- Name: fk_fichier_type_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fchr_fichier_type
    ADD CONSTRAINT fk_fichier_type_1 FOREIGN KEY (categorie) REFERENCES thm_categorie(id);


--
-- TOC entry 6706 (class 2606 OID 2602998)
-- Dependencies: 5981 4423 4423
-- Name: fk_filiere_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY flr_filiere
    ADD CONSTRAINT fk_filiere_1 FOREIGN KEY (pere) REFERENCES flr_filiere(id) ON DELETE CASCADE;


--
-- TOC entry 6714 (class 2606 OID 2603003)
-- Dependencies: 6011 4441 4435
-- Name: fk_formateur_droits_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frmtn_formateur_droits
    ADD CONSTRAINT fk_formateur_droits_2 FOREIGN KEY (droit) REFERENCES fw_droit(id);


--
-- TOC entry 6717 (class 2606 OID 2603008)
-- Dependencies: 6083 4490 4437
-- Name: fk_formation_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frmtn_formation
    ADD CONSTRAINT fk_formation_1 FOREIGN KEY (parcours) REFERENCES prcrs_parcours(id);


--
-- TOC entry 6716 (class 2606 OID 2603013)
-- Dependencies: 6013 4443 4437
-- Name: fk_formation_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frmtn_formation
    ADD CONSTRAINT fk_formation_2 FOREIGN KEY (langue) REFERENCES fw_langue(id);


--
-- TOC entry 6709 (class 2606 OID 2603018)
-- Dependencies: 5990 4429 4427
-- Name: fk_formation_forums_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frm_formation_forums
    ADD CONSTRAINT fk_formation_forums_1 FOREIGN KEY (forum) REFERENCES frm_forum(id);


--
-- TOC entry 6708 (class 2606 OID 2603023)
-- Dependencies: 6000 4437 4427
-- Name: fk_formation_forums_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frm_formation_forums
    ADD CONSTRAINT fk_formation_forums_2 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6719 (class 2606 OID 2603028)
-- Dependencies: 6013 4443 4438
-- Name: fk_formation_langues_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frmtn_formation_langues
    ADD CONSTRAINT fk_formation_langues_1 FOREIGN KEY (langue) REFERENCES fw_langue(id);


--
-- TOC entry 6718 (class 2606 OID 2603033)
-- Dependencies: 6000 4437 4438
-- Name: fk_formation_langues_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frmtn_formation_langues
    ADD CONSTRAINT fk_formation_langues_2 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6722 (class 2606 OID 2603038)
-- Dependencies: 6000 4437 4439
-- Name: fk_formation_participants_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frmtn_formation_participants
    ADD CONSTRAINT fk_formation_participants_2 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6721 (class 2606 OID 2603043)
-- Dependencies: 5965 4410 4439
-- Name: fk_formation_participants_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frmtn_formation_participants
    ADD CONSTRAINT fk_formation_participants_3 FOREIGN KEY (classe) REFERENCES cls_classe(id);


--
-- TOC entry 6720 (class 2606 OID 2603048)
-- Dependencies: 6059 4474 4439
-- Name: fk_formation_participants_formateur; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frmtn_formation_participants
    ADD CONSTRAINT fk_formation_participants_formateur FOREIGN KEY (formateur) REFERENCES ndvd_individu(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6836 (class 2606 OID 2603053)
-- Dependencies: 6000 4437 4533
-- Name: fk_formation_ressources_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_formation_ressources
    ADD CONSTRAINT fk_formation_ressources_1 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6837 (class 2606 OID 2603058)
-- Dependencies: 6196 4536 4533
-- Name: fk_formation_ressources_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_formation_ressources
    ADD CONSTRAINT fk_formation_ressources_2 FOREIGN KEY (ressource) REFERENCES rssrc_ressource(id);


--
-- TOC entry 6838 (class 2606 OID 2603063)
-- Dependencies: 6173 4527 4533
-- Name: fk_formation_ressources_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_formation_ressources
    ADD CONSTRAINT fk_formation_ressources_3 FOREIGN KEY (espace) REFERENCES rssrc_espace(id);


--
-- TOC entry 6839 (class 2606 OID 2603068)
-- Dependencies: 6198 4538 4533
-- Name: fk_formation_ressources_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_formation_ressources
    ADD CONSTRAINT fk_formation_ressources_4 FOREIGN KEY (section) REFERENCES rssrc_section(id);


--
-- TOC entry 6707 (class 2606 OID 2603073)
-- Dependencies: 6292 4582 4426
-- Name: fk_forum_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frm_etape_forum
    ADD CONSTRAINT fk_forum_1 FOREIGN KEY (id) REFERENCES tp_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6711 (class 2606 OID 2603078)
-- Dependencies: 5990 4429 4432
-- Name: fk_forum_environnements_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frm_forum_environnements
    ADD CONSTRAINT fk_forum_environnements_1 FOREIGN KEY (forum) REFERENCES frm_forum(id);


--
-- TOC entry 6710 (class 2606 OID 2603083)
-- Dependencies: 5992 4431 4432
-- Name: fk_forum_environnements_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frm_forum_environnements
    ADD CONSTRAINT fk_forum_environnements_2 FOREIGN KEY (environnement) REFERENCES frm_forum_environnement(id);


--
-- TOC entry 6701 (class 2606 OID 2603088)
-- Dependencies: 6324 4598 4415
-- Name: fk_ftb_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fb_ftb
    ADD CONSTRAINT fk_ftb_1 FOREIGN KEY (id) REFERENCES vltn_evaluation(id) ON DELETE CASCADE;


--
-- TOC entry 6740 (class 2606 OID 2603093)
-- Dependencies: 6027 4455 4462
-- Name: fk_grille_resultats_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_grille_resultats
    ADD CONSTRAINT fk_grille_resultats_1 FOREIGN KEY (carton) REFERENCES grll_carton(id);


--
-- TOC entry 6741 (class 2606 OID 2603098)
-- Dependencies: 6037 4461 4461 4462 4462
-- Name: fk_grille_resultats_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_grille_resultats
    ADD CONSTRAINT fk_grille_resultats_2 FOREIGN KEY (grille, capacite_titre) REFERENCES grll_grille_capacites_titres(grille, capacite_titre);


--
-- TOC entry 6742 (class 2606 OID 2603103)
-- Dependencies: 6025 4453 4453 4462 4462
-- Name: fk_grille_resultats_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_grille_resultats
    ADD CONSTRAINT fk_grille_resultats_3 FOREIGN KEY (capacite_titre, capacite) REFERENCES grll_capacite_titre_capacites(capacite_titre, capacite);


--
-- TOC entry 6743 (class 2606 OID 2603108)
-- Dependencies: 6041 4463 4463 4463 4462 4462 4462
-- Name: fk_grille_resultats_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_grille_resultats
    ADD CONSTRAINT fk_grille_resultats_4 FOREIGN KEY (formation, stagiaire, grille) REFERENCES grll_stagiaire_grille(formation, stagiaire, grille) ON DELETE CASCADE;


--
-- TOC entry 6744 (class 2606 OID 2603113)
-- Dependencies: 6334 4603 4603 4462 4462
-- Name: fk_grille_resultats_5; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_grille_resultats
    ADD CONSTRAINT fk_grille_resultats_5 FOREIGN KEY (formation, date) REFERENCES vnmnt_evenement_presentiel(formation, date);


--
-- TOC entry 6747 (class 2606 OID 2603118)
-- Dependencies: 6035 4460 4463
-- Name: fk_grille_stagiaires_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_stagiaire_grille
    ADD CONSTRAINT fk_grille_stagiaires_1 FOREIGN KEY (grille) REFERENCES grll_grille(id);


--
-- TOC entry 6746 (class 2606 OID 2603123)
-- Dependencies: 6000 4437 4463
-- Name: fk_grille_stagiaires_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_stagiaire_grille
    ADD CONSTRAINT fk_grille_stagiaires_2 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6745 (class 2606 OID 2603128)
-- Dependencies: 6059 4474 4463
-- Name: fk_grille_stagiaires_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_stagiaire_grille
    ADD CONSTRAINT fk_grille_stagiaires_3 FOREIGN KEY (stagiaire) REFERENCES ndvd_individu(id);


--
-- TOC entry 6739 (class 2606 OID 2603133)
-- Dependencies: 6035 4460 4461
-- Name: fk_grille_titres_capacites_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY grll_grille_capacites_titres
    ADD CONSTRAINT fk_grille_titres_capacites_1 FOREIGN KEY (grille) REFERENCES grll_grille(id) ON DELETE CASCADE;


--
-- TOC entry 6763 (class 2606 OID 2603138)
-- Dependencies: 6069 4480 4474
-- Name: fk_individu_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY ndvd_individu
    ADD CONSTRAINT fk_individu_1 FOREIGN KEY (organisme) REFERENCES ndvd_organisme(id);


--
-- TOC entry 6762 (class 2606 OID 2603143)
-- Dependencies: 6013 4443 4474
-- Name: fk_individu_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY ndvd_individu
    ADD CONSTRAINT fk_individu_3 FOREIGN KEY (langue) REFERENCES fw_langue(id);


--
-- TOC entry 6761 (class 2606 OID 2603148)
-- Dependencies: 6057 4472 4474
-- Name: fk_individu_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY ndvd_individu
    ADD CONSTRAINT fk_individu_4 FOREIGN KEY (photo) REFERENCES ndvd_fichier_photo(id);


--
-- TOC entry 6764 (class 2606 OID 2603153)
-- Dependencies: 6011 4441 4475
-- Name: fk_individu_droits_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY ndvd_individu_droits
    ADD CONSTRAINT fk_individu_droits_2 FOREIGN KEY (droit) REFERENCES fw_droit(id);


--
-- TOC entry 6767 (class 2606 OID 2603158)
-- Dependencies: 6065 4477 4478
-- Name: fk_individu_types_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY ndvd_individu_types
    ADD CONSTRAINT fk_individu_types_1 FOREIGN KEY ("type") REFERENCES ndvd_individu_type(id);


--
-- TOC entry 6766 (class 2606 OID 2603163)
-- Dependencies: 6059 4474 4478
-- Name: fk_individu_types_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY ndvd_individu_types
    ADD CONSTRAINT fk_individu_types_2 FOREIGN KEY (individu) REFERENCES ndvd_individu(id) ON DELETE CASCADE;


--
-- TOC entry 6728 (class 2606 OID 2603168)
-- Dependencies: 6013 4443 4445
-- Name: fk_langue_french_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fw_langue_message
    ADD CONSTRAINT fk_langue_french_2 FOREIGN KEY (langue) REFERENCES fw_langue(id);


--
-- TOC entry 6727 (class 2606 OID 2603173)
-- Dependencies: 6017 4447 4445
-- Name: fk_langue_french_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fw_langue_message
    ADD CONSTRAINT fk_langue_french_3 FOREIGN KEY (id) REFERENCES fw_langue_type(id);


--
-- TOC entry 6726 (class 2606 OID 2603178)
-- Dependencies: 6015 4445 4445 4445 4445 4445 4445
-- Name: fk_langue_messages_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fw_langue_message
    ADD CONSTRAINT fk_langue_messages_3 FOREIGN KEY ("type", langue, id) REFERENCES fw_langue_message("type", langue, id);


--
-- TOC entry 6750 (class 2606 OID 2603183)
-- Dependencies: 6292 4582 4466
-- Name: fk_liste_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_liste
    ADD CONSTRAINT fk_liste_1 FOREIGN KEY (id) REFERENCES tp_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6749 (class 2606 OID 2603188)
-- Dependencies: 6049 4468 4466
-- Name: fk_liste_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_liste
    ADD CONSTRAINT fk_liste_2 FOREIGN KEY ("type") REFERENCES lst_liste_type(id);


--
-- TOC entry 6759 (class 2606 OID 2603193)
-- Dependencies: 5975 4418 4471
-- Name: fk_media_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY md_media
    ADD CONSTRAINT fk_media_1 FOREIGN KEY (id) REFERENCES fchr_fichier(id);


--
-- TOC entry 6809 (class 2606 OID 2603198)
-- Dependencies: 6330 4601 4508
-- Name: fk_media_element_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_media_question_reponse
    ADD CONSTRAINT fk_media_element_1 FOREIGN KEY (media) REFERENCES vltn_fichier_media_evaluation(id);


--
-- TOC entry 6810 (class 2606 OID 2603203)
-- Dependencies: 6330 4601 4509
-- Name: fk_media_element_element_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_media_question_reponse_element
    ADD CONSTRAINT fk_media_element_element_1 FOREIGN KEY (media) REFERENCES vltn_fichier_media_evaluation(id);


--
-- TOC entry 6808 (class 2606 OID 2603208)
-- Dependencies: 6143 4512 4508
-- Name: fk_media_question_reponse_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_media_question_reponse
    ADD CONSTRAINT fk_media_question_reponse_2 FOREIGN KEY (question_reponse) REFERENCES qr_question_reponse(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6911 (class 2606 OID 2603213)
-- Dependencies: 6055 4471 4589
-- Name: fk_media_test_liste_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tst_media_test
    ADD CONSTRAINT fk_media_test_liste_1 FOREIGN KEY (media) REFERENCES md_media(id);


--
-- TOC entry 6910 (class 2606 OID 2603218)
-- Dependencies: 6314 4591 4589
-- Name: fk_media_test_liste_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tst_media_test
    ADD CONSTRAINT fk_media_test_liste_2 FOREIGN KEY (test) REFERENCES tst_test(id);


--
-- TOC entry 6713 (class 2606 OID 2603223)
-- Dependencies: 5990 4429 4434
-- Name: fk_message_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frm_message
    ADD CONSTRAINT fk_message_1 FOREIGN KEY (forum) REFERENCES frm_forum(id);


--
-- TOC entry 6712 (class 2606 OID 2603228)
-- Dependencies: 6059 4474 4434
-- Name: fk_message_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY frm_message
    ADD CONSTRAINT fk_message_2 FOREIGN KEY (auteur) REFERENCES ndvd_individu(id);


--
-- TOC entry 6386 (class 2606 OID 2603233)
-- Dependencies: 6372 4627 3928
-- Name: fk_modele_correction_criteres_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_modele_correction_criteres
    ADD CONSTRAINT fk_modele_correction_criteres_1 FOREIGN KEY (modele_correction) REFERENCES xtlc_modele_correction(id) ON DELETE CASCADE;


--
-- TOC entry 6385 (class 2606 OID 2603238)
-- Dependencies: 6354 4616 3928
-- Name: fk_modele_correction_criteres_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_modele_correction_criteres
    ADD CONSTRAINT fk_modele_correction_criteres_2 FOREIGN KEY (critere) REFERENCES xtlc_critere(id);


--
-- TOC entry 6384 (class 2606 OID 2603243)
-- Dependencies: 5335 3928 3928 3928 3928
-- Name: fk_modele_correction_criteres_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_modele_correction_criteres
    ADD CONSTRAINT fk_modele_correction_criteres_3 FOREIGN KEY (modele_correction, pere) REFERENCES xtlc_modele_correction_criteres(modele_correction, critere);


--
-- TOC entry 6768 (class 2606 OID 2603248)
-- Dependencies: 6081 4489 4482
-- Name: fk_page_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pg_page
    ADD CONSTRAINT fk_page_1 FOREIGN KEY ("type") REFERENCES pg_page_type(id);


--
-- TOC entry 6771 (class 2606 OID 2603253)
-- Dependencies: 6079 4487 4487 4483 4483
-- Name: fk_page_annuaire_configuration_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pg_page_annuaire_configuration
    ADD CONSTRAINT fk_page_annuaire_configuration_1 FOREIGN KEY (page, page_element) REFERENCES pg_page_elements(page, page_element);


--
-- TOC entry 6770 (class 2606 OID 2603258)
-- Dependencies: 6000 4437 4483
-- Name: fk_page_annuaire_configuration_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pg_page_annuaire_configuration
    ADD CONSTRAINT fk_page_annuaire_configuration_3 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6769 (class 2606 OID 2603263)
-- Dependencies: 6065 4477 4483
-- Name: fk_page_annuaire_configuration_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pg_page_annuaire_configuration
    ADD CONSTRAINT fk_page_annuaire_configuration_4 FOREIGN KEY (individu_type) REFERENCES ndvd_individu_type(id);


--
-- TOC entry 6774 (class 2606 OID 2603268)
-- Dependencies: 6071 4482 4484
-- Name: fk_page_commentaire_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pg_page_commentaire
    ADD CONSTRAINT fk_page_commentaire_1 FOREIGN KEY (page) REFERENCES pg_page(id);


--
-- TOC entry 6773 (class 2606 OID 2603273)
-- Dependencies: 6000 4437 4484
-- Name: fk_page_commentaire_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pg_page_commentaire
    ADD CONSTRAINT fk_page_commentaire_2 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6772 (class 2606 OID 2603278)
-- Dependencies: 6059 4474 4484
-- Name: fk_page_commentaire_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pg_page_commentaire
    ADD CONSTRAINT fk_page_commentaire_3 FOREIGN KEY (stagiaire) REFERENCES ndvd_individu(id);


--
-- TOC entry 6758 (class 2606 OID 2603283)
-- Dependencies: 6079 4487 4487 4470 4470
-- Name: fk_page_configuration_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_page_liste_configuration
    ADD CONSTRAINT fk_page_configuration_1 FOREIGN KEY (page, page_element) REFERENCES pg_page_elements(page, page_element);


--
-- TOC entry 6757 (class 2606 OID 2603288)
-- Dependencies: 6000 4437 4470
-- Name: fk_page_configuration_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_page_liste_configuration
    ADD CONSTRAINT fk_page_configuration_2 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6776 (class 2606 OID 2603293)
-- Dependencies: 6071 4482 4487
-- Name: fk_page_elements_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pg_page_elements
    ADD CONSTRAINT fk_page_elements_1 FOREIGN KEY (page) REFERENCES pg_page(id);


--
-- TOC entry 6775 (class 2606 OID 2603298)
-- Dependencies: 6077 4486 4487
-- Name: fk_page_elements_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pg_page_elements
    ADD CONSTRAINT fk_page_elements_2 FOREIGN KEY (page_element) REFERENCES pg_page_element(id);


--
-- TOC entry 6754 (class 2606 OID 2603303)
-- Dependencies: 6071 4482 4469
-- Name: fk_page_liste_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_page_liste
    ADD CONSTRAINT fk_page_liste_1 FOREIGN KEY (page) REFERENCES pg_page(id);


--
-- TOC entry 6753 (class 2606 OID 2603308)
-- Dependencies: 6000 4437 4469
-- Name: fk_page_liste_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_page_liste
    ADD CONSTRAINT fk_page_liste_2 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6752 (class 2606 OID 2603313)
-- Dependencies: 6083 4490 4469
-- Name: fk_page_liste_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_page_liste
    ADD CONSTRAINT fk_page_liste_3 FOREIGN KEY (parcours) REFERENCES prcrs_parcours(id);


--
-- TOC entry 6751 (class 2606 OID 2603318)
-- Dependencies: 6047 4466 4469
-- Name: fk_page_liste_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_page_liste
    ADD CONSTRAINT fk_page_liste_4 FOREIGN KEY (liste) REFERENCES lst_liste(id) ON DELETE CASCADE;


--
-- TOC entry 6756 (class 2606 OID 2603323)
-- Dependencies: 6047 4466 4470
-- Name: fk_page_liste_configuration_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_page_liste_configuration
    ADD CONSTRAINT fk_page_liste_configuration_3 FOREIGN KEY (liste) REFERENCES lst_liste(id);


--
-- TOC entry 6755 (class 2606 OID 2603328)
-- Dependencies: 6083 4490 4470
-- Name: fk_page_liste_configuration_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY lst_page_liste_configuration
    ADD CONSTRAINT fk_page_liste_configuration_4 FOREIGN KEY (parcours) REFERENCES prcrs_parcours(id);


--
-- TOC entry 6843 (class 2606 OID 2603333)
-- Dependencies: 6071 4482 4534
-- Name: fk_page_ressource_configuration_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_page_ressource_configuration
    ADD CONSTRAINT fk_page_ressource_configuration_1 FOREIGN KEY (page) REFERENCES pg_page(id);


--
-- TOC entry 6842 (class 2606 OID 2603338)
-- Dependencies: 6083 4490 4534
-- Name: fk_page_ressource_configuration_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_page_ressource_configuration
    ADD CONSTRAINT fk_page_ressource_configuration_2 FOREIGN KEY (parcours) REFERENCES prcrs_parcours(id);


--
-- TOC entry 6841 (class 2606 OID 2603343)
-- Dependencies: 6000 4437 4534
-- Name: fk_page_ressource_configuration_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_page_ressource_configuration
    ADD CONSTRAINT fk_page_ressource_configuration_3 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6840 (class 2606 OID 2603348)
-- Dependencies: 6177 4528 4534
-- Name: fk_page_ressource_configuration_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_page_ressource_configuration
    ADD CONSTRAINT fk_page_ressource_configuration_4 FOREIGN KEY (etape_ressource) REFERENCES rssrc_etape_ressource(id);


--
-- TOC entry 6778 (class 2606 OID 2603353)
-- Dependencies: 6292 4582 4490
-- Name: fk_parcours_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY prcrs_parcours
    ADD CONSTRAINT fk_parcours_3 FOREIGN KEY (id) REFERENCES tp_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6777 (class 2606 OID 2603358)
-- Dependencies: 5981 4423 4490
-- Name: fk_parcours_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY prcrs_parcours
    ADD CONSTRAINT fk_parcours_4 FOREIGN KEY (filiere) REFERENCES flr_filiere(id);


--
-- TOC entry 6906 (class 2606 OID 2603363)
-- Dependencies: 6292 4582 4584
-- Name: fk_parcours_etapes_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tp_parcours_etapes
    ADD CONSTRAINT fk_parcours_etapes_2 FOREIGN KEY (etape) REFERENCES tp_etape(id);


--
-- TOC entry 6905 (class 2606 OID 2603368)
-- Dependencies: 6083 4490 4584
-- Name: fk_parcours_etapes_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tp_parcours_etapes
    ADD CONSTRAINT fk_parcours_etapes_3 FOREIGN KEY (parcours) REFERENCES prcrs_parcours(id);


--
-- TOC entry 6904 (class 2606 OID 2603373)
-- Dependencies: 6299 4584 4584 4584 4584
-- Name: fk_parcours_etapes_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tp_parcours_etapes
    ADD CONSTRAINT fk_parcours_etapes_4 FOREIGN KEY (parcours, pere) REFERENCES tp_parcours_etapes(parcours, etape) ON UPDATE CASCADE;


--
-- TOC entry 6781 (class 2606 OID 2603378)
-- Dependencies: 6292 4582 4491
-- Name: fk_parcours_orientation_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY prcrs_parcours_oriente
    ADD CONSTRAINT fk_parcours_orientation_1 FOREIGN KEY (id) REFERENCES tp_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6780 (class 2606 OID 2603383)
-- Dependencies: 6083 4490 4491
-- Name: fk_parcours_orientation_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY prcrs_parcours_oriente
    ADD CONSTRAINT fk_parcours_orientation_2 FOREIGN KEY (sous_parcours) REFERENCES prcrs_parcours(id);


--
-- TOC entry 6779 (class 2606 OID 2603388)
-- Dependencies: 6295 4583 4491
-- Name: fk_parcours_orientation_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY prcrs_parcours_oriente
    ADD CONSTRAINT fk_parcours_orientation_3 FOREIGN KEY ("type") REFERENCES tp_etape_type(id);


--
-- TOC entry 6795 (class 2606 OID 2603393)
-- Dependencies: 6143 4512 4500
-- Name: fk_positionnement_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement_old
    ADD CONSTRAINT fk_positionnement_1 FOREIGN KEY (question_reponse) REFERENCES qr_question_reponse(id) ON DELETE CASCADE;


--
-- TOC entry 6786 (class 2606 OID 2603398)
-- Dependencies: 6125 4504 4495
-- Name: fk_positionnement_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement
    ADD CONSTRAINT fk_positionnement_1 FOREIGN KEY (qsrc) REFERENCES qc_qsrc(id) ON DELETE CASCADE;


--
-- TOC entry 6794 (class 2606 OID 2603403)
-- Dependencies: 6267 4567 4500
-- Name: fk_positionnement_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement_old
    ADD CONSTRAINT fk_positionnement_2 FOREIGN KEY (serie_aleatoire) REFERENCES srltr_serie_aleatoire(id) ON DELETE CASCADE;


--
-- TOC entry 6785 (class 2606 OID 2603408)
-- Dependencies: 6267 4567 4495
-- Name: fk_positionnement_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement
    ADD CONSTRAINT fk_positionnement_2 FOREIGN KEY (serie_generee) REFERENCES srltr_serie_aleatoire(id) ON DELETE CASCADE;


--
-- TOC entry 6793 (class 2606 OID 2603413)
-- Dependencies: 6154 4517 4500
-- Name: fk_positionnement_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement_old
    ADD CONSTRAINT fk_positionnement_3 FOREIGN KEY (type_question) REFERENCES qr_question_reponse_type(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6791 (class 2606 OID 2603418)
-- Dependencies: 6150 4515 4515 4515 4497 4497 4497
-- Name: fk_positionnement_elements_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement_elements
    ADD CONSTRAINT fk_positionnement_elements_1 FOREIGN KEY (question_reponse, question, choix) REFERENCES qr_question_reponse_elements(question_reponse, question, reponse) ON DELETE CASCADE;


--
-- TOC entry 6790 (class 2606 OID 2603423)
-- Dependencies: 6093 4493 4497
-- Name: fk_positionnement_elements_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement_elements
    ADD CONSTRAINT fk_positionnement_elements_2 FOREIGN KEY (choix) REFERENCES pstnnmnt_choix(id) ON DELETE CASCADE;


--
-- TOC entry 6792 (class 2606 OID 2603428)
-- Dependencies: 6324 4598 4498
-- Name: fk_positionnement_evaluations_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement_evaluations
    ADD CONSTRAINT fk_positionnement_evaluations_1 FOREIGN KEY (evaluation) REFERENCES vltn_evaluation(id);


--
-- TOC entry 6789 (class 2606 OID 2603433)
-- Dependencies: 6328 4600 4496
-- Name: fk_positionnement_evaluations_generees; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement_choix_evaluations
    ADD CONSTRAINT fk_positionnement_evaluations_generees FOREIGN KEY ("type") REFERENCES vltn_evaluation_type(id);


--
-- TOC entry 6788 (class 2606 OID 2603438)
-- Dependencies: 6113 4500 4496
-- Name: fk_positionnement_evaluations_generees_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement_choix_evaluations
    ADD CONSTRAINT fk_positionnement_evaluations_generees_1 FOREIGN KEY (positionnement) REFERENCES pstnnmnt_positionnement_old(id) ON DELETE CASCADE;


--
-- TOC entry 6787 (class 2606 OID 2603443)
-- Dependencies: 6318 4594 4496
-- Name: fk_positionnement_evaluations_generees_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_positionnement_choix_evaluations
    ADD CONSTRAINT fk_positionnement_evaluations_generees_3 FOREIGN KEY (bareme) REFERENCES vltn_bareme(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6811 (class 2606 OID 2603448)
-- Dependencies: 6150 4515 4515 4515 4510 4510 4510
-- Name: fk_qcm_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_qcm_elements
    ADD CONSTRAINT fk_qcm_4 FOREIGN KEY (question_reponse, question, reponse) REFERENCES qr_question_reponse_elements(question_reponse, question, reponse) ON DELETE CASCADE;


--
-- TOC entry 6801 (class 2606 OID 2603453)
-- Dependencies: 6324 4598 4504
-- Name: fk_qrc_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qc_qsrc
    ADD CONSTRAINT fk_qrc_1 FOREIGN KEY (id) REFERENCES vltn_evaluation(id) ON DELETE CASCADE;


--
-- TOC entry 6812 (class 2606 OID 2603458)
-- Dependencies: 6147 4514 4511
-- Name: fk_question_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_question
    ADD CONSTRAINT fk_question_1 FOREIGN KEY (id) REFERENCES qr_question_reponse_element(id) ON DELETE CASCADE;


--
-- TOC entry 6814 (class 2606 OID 2603463)
-- Dependencies: 6154 4517 4512
-- Name: fk_question_reponse_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_question_reponse
    ADD CONSTRAINT fk_question_reponse_1 FOREIGN KEY ("type") REFERENCES qr_question_reponse_type(id);


--
-- TOC entry 6818 (class 2606 OID 2603468)
-- Dependencies: 6156 4518 4515
-- Name: fk_question_reponse_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_question_reponse_elements
    ADD CONSTRAINT fk_question_reponse_3 FOREIGN KEY (reponse) REFERENCES qr_reponse(id);


--
-- TOC entry 6813 (class 2606 OID 2603473)
-- Dependencies: 6326 4598 4598 4512 4512
-- Name: fk_question_reponse_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_question_reponse
    ADD CONSTRAINT fk_question_reponse_3 FOREIGN KEY (id, "type") REFERENCES vltn_evaluation(id, "type") ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6817 (class 2606 OID 2603478)
-- Dependencies: 6141 4511 4515
-- Name: fk_question_reponse_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_question_reponse_elements
    ADD CONSTRAINT fk_question_reponse_4 FOREIGN KEY (question) REFERENCES qr_question(id);


--
-- TOC entry 6815 (class 2606 OID 2603483)
-- Dependencies: 6154 4517 4514
-- Name: fk_question_reponse_element_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_question_reponse_element
    ADD CONSTRAINT fk_question_reponse_element_1 FOREIGN KEY ("type") REFERENCES qr_question_reponse_type(id);


--
-- TOC entry 6816 (class 2606 OID 2603488)
-- Dependencies: 6143 4512 4515
-- Name: fk_question_reponse_elements_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_question_reponse_elements
    ADD CONSTRAINT fk_question_reponse_elements_4 FOREIGN KEY (question_reponse) REFERENCES qr_question_reponse(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6819 (class 2606 OID 2603493)
-- Dependencies: 6147 4514 4518
-- Name: fk_reponse_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_reponse
    ADD CONSTRAINT fk_reponse_1 FOREIGN KEY (id) REFERENCES qr_question_reponse_element(id) ON DELETE CASCADE;


--
-- TOC entry 6832 (class 2606 OID 2603498)
-- Dependencies: 6292 4582 4528
-- Name: fk_ressource_etape_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_etape_ressource
    ADD CONSTRAINT fk_ressource_etape_1 FOREIGN KEY (id) REFERENCES tp_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6831 (class 2606 OID 2603503)
-- Dependencies: 6196 4536 4528
-- Name: fk_ressource_etape_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_etape_ressource
    ADD CONSTRAINT fk_ressource_etape_2 FOREIGN KEY (ressource) REFERENCES rssrc_ressource(id);


--
-- TOC entry 6830 (class 2606 OID 2603508)
-- Dependencies: 6173 4527 4528
-- Name: fk_ressource_etape_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_etape_ressource
    ADD CONSTRAINT fk_ressource_etape_3 FOREIGN KEY (espace) REFERENCES rssrc_espace(id);


--
-- TOC entry 6829 (class 2606 OID 2603513)
-- Dependencies: 6198 4538 4528
-- Name: fk_ressource_etape_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_etape_ressource
    ADD CONSTRAINT fk_ressource_etape_4 FOREIGN KEY (section) REFERENCES rssrc_section(id);


--
-- TOC entry 6844 (class 2606 OID 2603518)
-- Dependencies: 6181 4530 4536
-- Name: fk_ressource_fichier_ressource; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_ressource
    ADD CONSTRAINT fk_ressource_fichier_ressource FOREIGN KEY (fichier) REFERENCES rssrc_fichier_ressource(id);


--
-- TOC entry 6907 (class 2606 OID 2603523)
-- Dependencies: 6299 4584 4584 4585 4585
-- Name: fk_resultat_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tp_resultat
    ADD CONSTRAINT fk_resultat_2 FOREIGN KEY (parcours, etape) REFERENCES tp_parcours_etapes(parcours, etape);


--
-- TOC entry 6952 (class 2606 OID 2603528)
-- Dependencies: 5975 4418 4628
-- Name: fk_resultat_exotlc; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_resultat_exotlc
    ADD CONSTRAINT fk_resultat_exotlc FOREIGN KEY (fichier_rendu) REFERENCES fchr_fichier(id) ON DELETE CASCADE;


--
-- TOC entry 6951 (class 2606 OID 2603533)
-- Dependencies: 6302 4585 4628
-- Name: fk_resultat_exotlc_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_resultat_exotlc
    ADD CONSTRAINT fk_resultat_exotlc_1 FOREIGN KEY (id) REFERENCES tp_resultat(id) ON DELETE CASCADE;


--
-- TOC entry 6954 (class 2606 OID 2603538)
-- Dependencies: 6354 4616 4629
-- Name: fk_resultat_exotlc_critere_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_resultat_exotlc_critere
    ADD CONSTRAINT fk_resultat_exotlc_critere_2 FOREIGN KEY (critere) REFERENCES xtlc_critere(id) ON DELETE RESTRICT;


--
-- TOC entry 6953 (class 2606 OID 2603543)
-- Dependencies: 6375 4628 4629
-- Name: fk_resultat_exotlc_critere_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_resultat_exotlc_critere
    ADD CONSTRAINT fk_resultat_exotlc_critere_3 FOREIGN KEY (id) REFERENCES xtlc_resultat_exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6956 (class 2606 OID 2603548)
-- Dependencies: 6354 4616 4630
-- Name: fk_resultat_exotlc_sous_critere_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_resultat_exotlc_sous_critere
    ADD CONSTRAINT fk_resultat_exotlc_sous_critere_2 FOREIGN KEY (sous_critere) REFERENCES xtlc_critere(id) ON DELETE RESTRICT;


--
-- TOC entry 6955 (class 2606 OID 2603553)
-- Dependencies: 6375 4628 4630
-- Name: fk_resultat_exotlc_sous_critere_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY xtlc_resultat_exotlc_sous_critere
    ADD CONSTRAINT fk_resultat_exotlc_sous_critere_3 FOREIGN KEY (id) REFERENCES xtlc_resultat_exotlc(id) ON DELETE CASCADE;


--
-- TOC entry 6796 (class 2606 OID 2603558)
-- Dependencies: 6316 4592 4592 4501 4501
-- Name: fk_resultat_positionnement_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_resultat_positionnement
    ADD CONSTRAINT fk_resultat_positionnement_1 FOREIGN KEY (id, positionnement) REFERENCES tst_test_positionnements(test, positionnement);


--
-- TOC entry 6798 (class 2606 OID 2603563)
-- Dependencies: 6118 4501 4501 4501 4502 4502 4502
-- Name: fk_resultat_positionnement_question_reponse; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_resultat_positionnement_question_reponse
    ADD CONSTRAINT fk_resultat_positionnement_question_reponse FOREIGN KEY (id, test, question_reponse) REFERENCES pstnnmnt_resultat_positionnement(id, test, positionnement) ON DELETE CASCADE;


--
-- TOC entry 6797 (class 2606 OID 2603568)
-- Dependencies: 6108 4497 4497 4497 4502 4502 4502
-- Name: fk_resultat_positionnement_question_reponse_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY pstnnmnt_resultat_positionnement_question_reponse
    ADD CONSTRAINT fk_resultat_positionnement_question_reponse_1 FOREIGN KEY (question_reponse, question, choix) REFERENCES pstnnmnt_positionnement_elements(question_reponse, question, choix);


--
-- TOC entry 6871 (class 2606 OID 2603573)
-- Dependencies: 6324 4598 4561
-- Name: fk_resultat_serie; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_resultat_serie
    ADD CONSTRAINT fk_resultat_serie FOREIGN KEY (evaluation) REFERENCES vltn_evaluation(id);


--
-- TOC entry 6870 (class 2606 OID 2603578)
-- Dependencies: 6302 4585 4561
-- Name: fk_resultat_serie_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_resultat_serie
    ADD CONSTRAINT fk_resultat_serie_1 FOREIGN KEY (id) REFERENCES tp_resultat(id) ON DELETE CASCADE;


--
-- TOC entry 6702 (class 2606 OID 2603583)
-- Dependencies: 6251 4561 4561 4416 4416
-- Name: fk_resultat_serie_ftb; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fb_resultat_serie_ftb
    ADD CONSTRAINT fk_resultat_serie_ftb FOREIGN KEY (id, ftb) REFERENCES sr_resultat_serie(id, evaluation) ON DELETE CASCADE;


--
-- TOC entry 6821 (class 2606 OID 2603588)
-- Dependencies: 6150 4515 4515 4515 4519 4519 4519
-- Name: fk_resultat_serie_question_reponse; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_resultat_serie_question_reponse
    ADD CONSTRAINT fk_resultat_serie_question_reponse FOREIGN KEY (question_reponse, question, reponse) REFERENCES qr_question_reponse_elements(question_reponse, question, reponse);


--
-- TOC entry 6820 (class 2606 OID 2603593)
-- Dependencies: 6251 4561 4561 4519 4519
-- Name: fk_resultat_serie_question_reponse_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_resultat_serie_question_reponse
    ADD CONSTRAINT fk_resultat_serie_question_reponse_1 FOREIGN KEY (id, question_reponse) REFERENCES sr_resultat_serie(id, evaluation) ON DELETE CASCADE;


--
-- TOC entry 6872 (class 2606 OID 2603598)
-- Dependencies: 6306 4587 4562
-- Name: fk_resultat_serie_tentative_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_resultat_serie_tentative
    ADD CONSTRAINT fk_resultat_serie_tentative_1 FOREIGN KEY (id) REFERENCES tp_resultat_tentative(id) ON DELETE CASCADE;


--
-- TOC entry 6873 (class 2606 OID 2603603)
-- Dependencies: 6254 4562 4562 4563 4563
-- Name: fk_resultat_serie_tentative_ftb; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_resultat_serie_tentative_ftb
    ADD CONSTRAINT fk_resultat_serie_tentative_ftb FOREIGN KEY (id, ftb) REFERENCES sr_resultat_serie_tentative(id, evaluation) ON DELETE CASCADE;


--
-- TOC entry 6822 (class 2606 OID 2603608)
-- Dependencies: 6254 4562 4562 4520 4520
-- Name: fk_resultat_serie_tentative_question_reponse_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY qr_resultat_serie_tentative_question_reponse
    ADD CONSTRAINT fk_resultat_serie_tentative_question_reponse_1 FOREIGN KEY (id, question_reponse) REFERENCES sr_resultat_serie_tentative(id, evaluation) ON DELETE CASCADE;


--
-- TOC entry 6858 (class 2606 OID 2603613)
-- Dependencies: 6292 4582 4547
-- Name: fk_scenario_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_scenario
    ADD CONSTRAINT fk_scenario_1 FOREIGN KEY (id) REFERENCES tp_etape(id) ON DELETE CASCADE;


--
-- TOC entry 6857 (class 2606 OID 2603618)
-- Dependencies: 6215 4546 4547
-- Name: fk_scenario_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY scnr_scenario
    ADD CONSTRAINT fk_scenario_2 FOREIGN KEY (fichier) REFERENCES scnr_fichier_scenario(id) ON UPDATE RESTRICT ON DELETE CASCADE;


--
-- TOC entry 6865 (class 2606 OID 2603623)
-- Dependencies: 6210 4544 4558
-- Name: fk_scrdnmq_scenario_dynamique_1; Type: FK CONSTRAINT; Schema: v2; Owner: pgsql
--

ALTER TABLE ONLY snrdnmq_scenario_dynamique
    ADD CONSTRAINT fk_scrdnmq_scenario_dynamique_1 FOREIGN KEY (css) REFERENCES scnr_fichier_css(id);


--
-- TOC entry 6864 (class 2606 OID 2603628)
-- Dependencies: 6292 4582 4558
-- Name: fk_scrdnmq_scenario_dynamique_2; Type: FK CONSTRAINT; Schema: v2; Owner: pgsql
--

ALTER TABLE ONLY snrdnmq_scenario_dynamique
    ADD CONSTRAINT fk_scrdnmq_scenario_dynamique_2 FOREIGN KEY (id) REFERENCES tp_etape(id);


--
-- TOC entry 6845 (class 2606 OID 2603633)
-- Dependencies: 6179 4529 4538
-- Name: fk_section_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY rssrc_section
    ADD CONSTRAINT fk_section_1 FOREIGN KEY (icone) REFERENCES rssrc_fichier_icone(id);


--
-- TOC entry 6875 (class 2606 OID 2603638)
-- Dependencies: 6047 4466 4564
-- Name: fk_serie_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_serie
    ADD CONSTRAINT fk_serie_1 FOREIGN KEY (id) REFERENCES lst_liste(id) ON DELETE CASCADE;


--
-- TOC entry 6874 (class 2606 OID 2603643)
-- Dependencies: 6318 4594 4564
-- Name: fk_serie_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_serie
    ADD CONSTRAINT fk_serie_2 FOREIGN KEY (bareme) REFERENCES vltn_bareme(id);


--
-- TOC entry 6884 (class 2606 OID 2603648)
-- Dependencies: 6256 4564 4567
-- Name: fk_serie_aleatoire_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltr_serie_aleatoire
    ADD CONSTRAINT fk_serie_aleatoire_2 FOREIGN KEY (id) REFERENCES sr_serie(id) ON DELETE CASCADE;


--
-- TOC entry 6883 (class 2606 OID 2603653)
-- Dependencies: 6271 4570 4567
-- Name: fk_serie_aleatoire_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltr_serie_aleatoire
    ADD CONSTRAINT fk_serie_aleatoire_3 FOREIGN KEY ("type") REFERENCES srltr_serie_aleatoire_type(id);


--
-- TOC entry 6889 (class 2606 OID 2603658)
-- Dependencies: 6059 4474 4568
-- Name: fk_serie_aleatoire_evaluations_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltr_serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_2 FOREIGN KEY (stagiaire) REFERENCES ndvd_individu(id);


--
-- TOC entry 6888 (class 2606 OID 2603663)
-- Dependencies: 6324 4598 4568
-- Name: fk_serie_aleatoire_evaluations_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltr_serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_3 FOREIGN KEY (evaluation) REFERENCES vltn_evaluation(id);


--
-- TOC entry 6887 (class 2606 OID 2603668)
-- Dependencies: 6267 4567 4568
-- Name: fk_serie_aleatoire_evaluations_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltr_serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_4 FOREIGN KEY (serie) REFERENCES srltr_serie_aleatoire(id);


--
-- TOC entry 6886 (class 2606 OID 2603673)
-- Dependencies: 6000 4437 4568
-- Name: fk_serie_aleatoire_evaluations_6; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltr_serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_6 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6885 (class 2606 OID 2603678)
-- Dependencies: 6269 4568 4568 4568 4568 4568 4568 4568 4568 4568 4568
-- Name: fk_serie_aleatoire_evaluations_7; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltr_serie_aleatoire_evaluations
    ADD CONSTRAINT fk_serie_aleatoire_evaluations_7 FOREIGN KEY (stagiaire, serie, pere, formation, parcours) REFERENCES srltr_serie_aleatoire_evaluations(stagiaire, serie, evaluation, formation, parcours);


--
-- TOC entry 6892 (class 2606 OID 2603683)
-- Dependencies: 6000 4437 4571
-- Name: fk_serie_aleatoire_melangee_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltrmlg_serie_aleatoire_melangee
    ADD CONSTRAINT fk_serie_aleatoire_melangee_1 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6891 (class 2606 OID 2603688)
-- Dependencies: 6256 4564 4571
-- Name: fk_serie_aleatoire_melangee_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltrmlg_serie_aleatoire_melangee
    ADD CONSTRAINT fk_serie_aleatoire_melangee_2 FOREIGN KEY (serie) REFERENCES sr_serie(id) ON DELETE CASCADE;


--
-- TOC entry 6890 (class 2606 OID 2603693)
-- Dependencies: 6299 4584 4584 4571 4571
-- Name: fk_serie_aleatoire_melangee_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltrmlg_serie_aleatoire_melangee
    ADD CONSTRAINT fk_serie_aleatoire_melangee_3 FOREIGN KEY (parcours, serie) REFERENCES tp_parcours_etapes(parcours, etape) ON DELETE CASCADE;


--
-- TOC entry 6894 (class 2606 OID 2603698)
-- Dependencies: 6328 4600 4572
-- Name: fk_serie_aleatoire_multiserie_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltrmltsr_serie_aleatoire_multiserie
    ADD CONSTRAINT fk_serie_aleatoire_multiserie_2 FOREIGN KEY (type_evaluations) REFERENCES vltn_evaluation_type(id);


--
-- TOC entry 6896 (class 2606 OID 2603703)
-- Dependencies: 6328 4600 4573
-- Name: fk_serie_aleatoire_multitheme_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltrmltthm_serie_aleatoire_multitheme
    ADD CONSTRAINT fk_serie_aleatoire_multitheme_3 FOREIGN KEY (type_evaluations) REFERENCES vltn_evaluation_type(id);


--
-- TOC entry 6893 (class 2606 OID 2603708)
-- Dependencies: 6267 4567 4572
-- Name: fk_serie_aleatoire_serie_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltrmltsr_serie_aleatoire_multiserie
    ADD CONSTRAINT fk_serie_aleatoire_serie_1 FOREIGN KEY (serie) REFERENCES srltr_serie_aleatoire(id) ON DELETE CASCADE;


--
-- TOC entry 6895 (class 2606 OID 2603713)
-- Dependencies: 6267 4567 4573
-- Name: fk_serie_aleatoire_theme_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY srltrmltthm_serie_aleatoire_multitheme
    ADD CONSTRAINT fk_serie_aleatoire_theme_1 FOREIGN KEY (serie) REFERENCES srltr_serie_aleatoire(id) ON DELETE CASCADE;


--
-- TOC entry 6878 (class 2606 OID 2603718)
-- Dependencies: 6256 4564 4565
-- Name: fk_serie_blocante_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_serie_bloquante
    ADD CONSTRAINT fk_serie_blocante_1 FOREIGN KEY (serie) REFERENCES sr_serie(id) ON DELETE CASCADE;


--
-- TOC entry 6877 (class 2606 OID 2603723)
-- Dependencies: 6000 4437 4565
-- Name: fk_serie_blocante_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_serie_bloquante
    ADD CONSTRAINT fk_serie_blocante_2 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6876 (class 2606 OID 2603728)
-- Dependencies: 6299 4584 4584 4565 4565
-- Name: fk_serie_blocante_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_serie_bloquante
    ADD CONSTRAINT fk_serie_blocante_3 FOREIGN KEY (parcours, serie) REFERENCES tp_parcours_etapes(parcours, etape) ON DELETE CASCADE;


--
-- TOC entry 6879 (class 2606 OID 2603733)
-- Dependencies: 6324 4598 4566
-- Name: fk_serie_evaluations_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_serie_evaluations
    ADD CONSTRAINT fk_serie_evaluations_2 FOREIGN KEY (evaluation) REFERENCES vltn_evaluation(id);


--
-- TOC entry 6880 (class 2606 OID 2603738)
-- Dependencies: 6318 4594 4566
-- Name: fk_serie_evaluations_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_serie_evaluations
    ADD CONSTRAINT fk_serie_evaluations_3 FOREIGN KEY (bareme) REFERENCES vltn_bareme(id);


--
-- TOC entry 6881 (class 2606 OID 2603743)
-- Dependencies: 6256 4564 4566
-- Name: fk_serie_evaluations_4; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_serie_evaluations
    ADD CONSTRAINT fk_serie_evaluations_4 FOREIGN KEY (serie) REFERENCES sr_serie(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 6882 (class 2606 OID 2603748)
-- Dependencies: 6263 4566 4566 4566 4566
-- Name: fk_serie_evaluations_5; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY sr_serie_evaluations
    ADD CONSTRAINT fk_serie_evaluations_5 FOREIGN KEY (serie, pere) REFERENCES sr_serie_evaluations(serie, evaluation);


--
-- TOC entry 6730 (class 2606 OID 2603753)
-- Dependencies: 6059 4474 4448
-- Name: fk_session_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fw_session
    ADD CONSTRAINT fk_session_1 FOREIGN KEY (individu) REFERENCES ndvd_individu(id);


--
-- TOC entry 6729 (class 2606 OID 2603758)
-- Dependencies: 6000 4437 4448
-- Name: fk_session_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY fw_session
    ADD CONSTRAINT fk_session_2 FOREIGN KEY (formation) REFERENCES frmtn_formation(id);


--
-- TOC entry 6867 (class 2606 OID 2603763)
-- Dependencies: 6241 4558 4559
-- Name: fk_snrdnmq_scenario_dynamique_blocs_1; Type: FK CONSTRAINT; Schema: v2; Owner: pgsql
--

ALTER TABLE ONLY snrdnmq_scenario_dynamique_blocs
    ADD CONSTRAINT fk_snrdnmq_scenario_dynamique_blocs_1 FOREIGN KEY (scenario_dynamique) REFERENCES snrdnmq_scenario_dynamique(id);


--
-- TOC entry 6866 (class 2606 OID 2603768)
-- Dependencies: 6237 4557 4559
-- Name: fk_snrdnmq_scenario_dynamique_blocs_2; Type: FK CONSTRAINT; Schema: v2; Owner: pgsql
--

ALTER TABLE ONLY snrdnmq_scenario_dynamique_blocs
    ADD CONSTRAINT fk_snrdnmq_scenario_dynamique_blocs_2 FOREIGN KEY (bloc_scenario) REFERENCES snrdnmq_bloc_scenario(id);


--
-- TOC entry 6912 (class 2606 OID 2603773)
-- Dependencies: 6047 4466 4591
-- Name: fk_test_liste_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tst_test
    ADD CONSTRAINT fk_test_liste_1 FOREIGN KEY (id) REFERENCES lst_liste(id) ON DELETE CASCADE;


--
-- TOC entry 6915 (class 2606 OID 2603778)
-- Dependencies: 6314 4591 4592
-- Name: fk_test_liste_tests_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tst_test_positionnements
    ADD CONSTRAINT fk_test_liste_tests_1 FOREIGN KEY (test) REFERENCES tst_test(id) ON DELETE CASCADE;


--
-- TOC entry 6914 (class 2606 OID 2603783)
-- Dependencies: 6113 4500 4592
-- Name: fk_test_liste_tests_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tst_test_positionnements
    ADD CONSTRAINT fk_test_liste_tests_2 FOREIGN KEY (positionnement) REFERENCES pstnnmnt_positionnement_old(id);


--
-- TOC entry 6913 (class 2606 OID 2603788)
-- Dependencies: 6316 4592 4592 4592 4592
-- Name: fk_test_liste_tests_3; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY tst_test_positionnements
    ADD CONSTRAINT fk_test_liste_tests_3 FOREIGN KEY (test, pere) REFERENCES tst_test_positionnements(test, positionnement);


--
-- TOC entry 6899 (class 2606 OID 2603793)
-- Dependencies: 6282 4577 4578
-- Name: fk_theme_categories_1; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY thm_theme_categories
    ADD CONSTRAINT fk_theme_categories_1 FOREIGN KEY (theme) REFERENCES thm_theme(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 6898 (class 2606 OID 2603798)
-- Dependencies: 6280 4575 4578
-- Name: fk_theme_categories_2; Type: FK CONSTRAINT; Schema: v2; Owner: postgres
--

ALTER TABLE ONLY thm_theme_categories
    ADD CONSTRAINT fk_theme_categories_2 FOREIGN KEY (categorie) REFERENCES thm_categorie(id) ON UPDATE RESTRICT ON DELETE RESTRICT;


--
-- TOC entry 7194 (class 0 OID 0)
-- Dependencies: 5
-- Name: contraintes; Type: ACL; Schema: -; Owner: pgsql
--

REVOKE ALL ON SCHEMA contraintes FROM PUBLIC;
REVOKE ALL ON SCHEMA contraintes FROM pgsql;
GRANT ALL ON SCHEMA contraintes TO pgsql;
GRANT USAGE ON SCHEMA contraintes TO www;
GRANT ALL ON SCHEMA contraintes TO PUBLIC;
GRANT ALL ON SCHEMA contraintes TO "grp-www";


--
-- TOC entry 7196 (class 0 OID 0)
-- Dependencies: 6
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO pgsql;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- TOC entry 7197 (class 0 OID 0)
-- Dependencies: 7
-- Name: v2; Type: ACL; Schema: -; Owner: pgsql
--

REVOKE ALL ON SCHEMA v2 FROM PUBLIC;
REVOKE ALL ON SCHEMA v2 FROM pgsql;
GRANT ALL ON SCHEMA v2 TO pgsql;
GRANT ALL ON SCHEMA v2 TO PUBLIC;
GRANT USAGE ON SCHEMA v2 TO www;


SET search_path = contraintes, pg_catalog;

--
-- TOC entry 7199 (class 0 OID 0)
-- Dependencies: 828
-- Name: af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_check_formation_evenement(integer, date, time without time zone, time without time zone, time without time zone, character varying, integer) TO "grp-www";


--
-- TOC entry 7201 (class 0 OID 0)
-- Dependencies: 829
-- Name: af_del_alerte(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_alerte(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_alerte(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_alerte(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_alerte(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_alerte(integer) TO "grp-www";


--
-- TOC entry 7203 (class 0 OID 0)
-- Dependencies: 830
-- Name: af_del_bareme(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_bareme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_bareme(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_bareme(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_bareme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_bareme(integer) TO "grp-www";


--
-- TOC entry 7205 (class 0 OID 0)
-- Dependencies: 831
-- Name: af_del_capacite(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_capacite(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_capacite(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_capacite(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_capacite(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_capacite(integer) TO "grp-www";


--
-- TOC entry 7207 (class 0 OID 0)
-- Dependencies: 832
-- Name: af_del_capacite_titre(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_capacite_titre(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_capacite_titre(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_capacite_titre(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_capacite_titre(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_capacite_titre(integer) TO "grp-www";


--
-- TOC entry 7209 (class 0 OID 0)
-- Dependencies: 833
-- Name: af_del_capacite_titre_capacite(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_capacite_titre_capacite(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_capacite_titre_capacite(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_capacite_titre_capacite(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_capacite_titre_capacite(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_capacite_titre_capacite(integer, integer) TO "grp-www";


--
-- TOC entry 7211 (class 0 OID 0)
-- Dependencies: 834
-- Name: af_del_categorie(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_del_categorie(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_categorie(integer) FROM postgres;
GRANT ALL ON FUNCTION af_del_categorie(integer) TO postgres;
GRANT ALL ON FUNCTION af_del_categorie(integer) TO www;
GRANT ALL ON FUNCTION af_del_categorie(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_categorie(integer) TO "grp-www";


--
-- TOC entry 7213 (class 0 OID 0)
-- Dependencies: 835
-- Name: af_del_categorie_element(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_categorie_element(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_categorie_element(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_categorie_element(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_categorie_element(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_categorie_element(integer, integer) TO "grp-www";


--
-- TOC entry 7215 (class 0 OID 0)
-- Dependencies: 836
-- Name: af_del_classe(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_classe(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_classe(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_classe(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_classe(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_classe(integer) TO "grp-www";


--
-- TOC entry 7217 (class 0 OID 0)
-- Dependencies: 837
-- Name: af_del_classe_droit(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_classe_droit(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_classe_droit(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_classe_droit(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_classe_droit(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_classe_droit(integer, integer) TO "grp-www";


--
-- TOC entry 7219 (class 0 OID 0)
-- Dependencies: 838
-- Name: af_del_classe_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_classe_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_classe_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_classe_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_classe_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_classe_individu(integer, integer) TO "grp-www";


--
-- TOC entry 7221 (class 0 OID 0)
-- Dependencies: 839
-- Name: af_del_commentaire(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_commentaire(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_commentaire(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_commentaire(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_commentaire(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_commentaire(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7223 (class 0 OID 0)
-- Dependencies: 840
-- Name: af_del_critere(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_critere(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_critere(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_critere(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_critere(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_critere(integer) TO "grp-www";


--
-- TOC entry 7225 (class 0 OID 0)
-- Dependencies: 841
-- Name: af_del_espace(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_espace(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_espace(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_espace(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_espace(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_espace(integer) TO "grp-www";


--
-- TOC entry 7227 (class 0 OID 0)
-- Dependencies: 842
-- Name: af_del_etape(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_etape(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_etape(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_etape(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_etape(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_etape(integer) TO "grp-www";


--
-- TOC entry 7229 (class 0 OID 0)
-- Dependencies: 843
-- Name: af_del_etape_resultat_individu(integer, integer, integer[], integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_etape_resultat_individu(integer, integer, integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_etape_resultat_individu(integer, integer, integer[], integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_del_etape_resultat_individu(integer, integer, integer[], integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_del_etape_resultat_individu(integer, integer, integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_etape_resultat_individu(integer, integer, integer[], integer[]) TO "grp-www";


--
-- TOC entry 7231 (class 0 OID 0)
-- Dependencies: 844
-- Name: af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_etape_resultat_tentative_individu(integer, integer, integer[], integer) TO "grp-www";


--
-- TOC entry 7233 (class 0 OID 0)
-- Dependencies: 845
-- Name: af_del_evaluation(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_evaluation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_evaluation(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_evaluation(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_evaluation(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_evaluation(integer) TO "grp-www";


--
-- TOC entry 7235 (class 0 OID 0)
-- Dependencies: 1825
-- Name: af_del_evaluation_resultat_individu(bigint, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_evaluation_resultat_individu(bigint, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_evaluation_resultat_individu(bigint, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_del_evaluation_resultat_individu(bigint, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_del_evaluation_resultat_individu(bigint, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_evaluation_resultat_individu(bigint, integer[]) TO "grp-www";


--
-- TOC entry 7237 (class 0 OID 0)
-- Dependencies: 846
-- Name: af_del_evaluation_resultat_tentative_individu(bigint, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_evaluation_resultat_tentative_individu(bigint, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_evaluation_resultat_tentative_individu(bigint, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_del_evaluation_resultat_tentative_individu(bigint, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_del_evaluation_resultat_tentative_individu(bigint, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_evaluation_resultat_tentative_individu(bigint, integer[]) TO "grp-www";


--
-- TOC entry 7239 (class 0 OID 0)
-- Dependencies: 847
-- Name: af_del_evaluations(integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_evaluations(integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_evaluations(integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_del_evaluations(integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_del_evaluations(integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_evaluations(integer[]) TO "grp-www";


--
-- TOC entry 7241 (class 0 OID 0)
-- Dependencies: 848
-- Name: af_del_exotlc_fichiers(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_exotlc_fichiers(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_exotlc_fichiers(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_exotlc_fichiers(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_exotlc_fichiers(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_exotlc_fichiers(integer) TO "grp-www";


--
-- TOC entry 7243 (class 0 OID 0)
-- Dependencies: 849
-- Name: af_del_fichier(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_fichier(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_fichier(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_fichier(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_fichier(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_fichier(integer) TO "grp-www";


--
-- TOC entry 7244 (class 0 OID 0)
-- Dependencies: 850
-- Name: af_del_fichier_scenario_dynamique_bloc(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_fichier_scenario_dynamique_bloc(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_fichier_scenario_dynamique_bloc(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_fichier_scenario_dynamique_bloc(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_fichier_scenario_dynamique_bloc(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_fichier_scenario_dynamique_bloc(integer, integer) TO "grp-www";


--
-- TOC entry 7246 (class 0 OID 0)
-- Dependencies: 851
-- Name: af_del_fichier_texte(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_fichier_texte(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_fichier_texte(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_fichier_texte(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_fichier_texte(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_fichier_texte(integer) TO "grp-www";


--
-- TOC entry 7247 (class 0 OID 0)
-- Dependencies: 852
-- Name: af_del_fichiers_scenarios_dynamiques(integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_fichiers_scenarios_dynamiques(integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_fichiers_scenarios_dynamiques(integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_del_fichiers_scenarios_dynamiques(integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_del_fichiers_scenarios_dynamiques(integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_fichiers_scenarios_dynamiques(integer[]) TO "grp-www";


--
-- TOC entry 7248 (class 0 OID 0)
-- Dependencies: 853
-- Name: af_del_filiere(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_filiere(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_filiere(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_filiere(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_filiere(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_filiere(integer) TO "grp-www";


--
-- TOC entry 7249 (class 0 OID 0)
-- Dependencies: 1826
-- Name: af_del_formation(integer); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION af_del_formation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation(integer) FROM www;
GRANT ALL ON FUNCTION af_del_formation(integer) TO www;
GRANT ALL ON FUNCTION af_del_formation(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation(integer) TO "grp-www";


--
-- TOC entry 7251 (class 0 OID 0)
-- Dependencies: 854
-- Name: af_del_formation_droit(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_droit(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_droit(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_droit(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_droit(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_droit(integer, integer) TO "grp-www";


--
-- TOC entry 7253 (class 0 OID 0)
-- Dependencies: 855
-- Name: af_del_formation_espace(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_espace(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_espace(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_espace(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_espace(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_espace(integer, integer) TO "grp-www";


--
-- TOC entry 7255 (class 0 OID 0)
-- Dependencies: 856
-- Name: af_del_formation_espace_section(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_espace_section(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_espace_section(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_espace_section(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_espace_section(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_espace_section(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7257 (class 0 OID 0)
-- Dependencies: 857
-- Name: af_del_formation_evenement(integer, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_evenement(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_evenement(integer, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_evenement(integer, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_evenement(integer, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_evenement(integer, timestamp without time zone) TO "grp-www";


--
-- TOC entry 7259 (class 0 OID 0)
-- Dependencies: 858
-- Name: af_del_formation_evenements(integer, date); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_evenements(integer, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_evenements(integer, date) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_evenements(integer, date) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_evenements(integer, date) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_evenements(integer, date) TO "grp-www";


--
-- TOC entry 7261 (class 0 OID 0)
-- Dependencies: 859
-- Name: af_del_formation_forum(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_forum(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_forum(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_forum(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_forum(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_forum(integer, integer) TO "grp-www";


--
-- TOC entry 7263 (class 0 OID 0)
-- Dependencies: 860
-- Name: af_del_formation_langue(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_langue(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_langue(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_langue(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_langue(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_langue(integer, integer) TO "grp-www";


--
-- TOC entry 7265 (class 0 OID 0)
-- Dependencies: 861
-- Name: af_del_formation_ressource(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_ressource(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_ressource(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_ressource(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_ressource(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_ressource(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7267 (class 0 OID 0)
-- Dependencies: 862
-- Name: af_del_formation_resultat_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_resultat_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_resultat_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_resultat_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_resultat_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_resultat_individu(integer, integer) TO "grp-www";


--
-- TOC entry 7269 (class 0 OID 0)
-- Dependencies: 863
-- Name: af_del_formation_session(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_formation_session(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_formation_session(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_formation_session(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_formation_session(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_formation_session(integer) TO "grp-www";


--
-- TOC entry 7271 (class 0 OID 0)
-- Dependencies: 864
-- Name: af_del_forum(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_forum(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_forum(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_forum(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_forum(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_forum(integer) TO "grp-www";


--
-- TOC entry 7273 (class 0 OID 0)
-- Dependencies: 865
-- Name: af_del_grille(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_grille(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_grille(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_grille(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_grille(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_grille(integer) TO "grp-www";


--
-- TOC entry 7275 (class 0 OID 0)
-- Dependencies: 866
-- Name: af_del_grille_capacite_titre(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_grille_capacite_titre(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_grille_capacite_titre(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_grille_capacite_titre(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_grille_capacite_titre(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_grille_capacite_titre(integer, integer) TO "grp-www";


--
-- TOC entry 7277 (class 0 OID 0)
-- Dependencies: 867
-- Name: af_del_individu(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_individu(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_individu(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_individu(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_individu(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_individu(integer) TO "grp-www";


--
-- TOC entry 7279 (class 0 OID 0)
-- Dependencies: 868
-- Name: af_del_individu_droit_classe(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_individu_droit_classe(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_individu_droit_classe(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_individu_droit_classe(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_individu_droit_classe(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_individu_droit_classe(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7281 (class 0 OID 0)
-- Dependencies: 869
-- Name: af_del_individu_session(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_individu_session(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_individu_session(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_individu_session(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_individu_session(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_individu_session(integer) TO "grp-www";


--
-- TOC entry 7283 (class 0 OID 0)
-- Dependencies: 870
-- Name: af_del_individu_type(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_individu_type(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_individu_type(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_individu_type(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_individu_type(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_individu_type(integer, integer) TO "grp-www";


--
-- TOC entry 7285 (class 0 OID 0)
-- Dependencies: 871
-- Name: af_del_inscription(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_inscription(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_inscription(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_inscription(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_inscription(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_inscription(integer) TO "grp-www";


--
-- TOC entry 7287 (class 0 OID 0)
-- Dependencies: 872
-- Name: af_del_intervention(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_intervention(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_intervention(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_intervention(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_intervention(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_intervention(integer) TO "grp-www";


--
-- TOC entry 7289 (class 0 OID 0)
-- Dependencies: 873
-- Name: af_del_langue_message(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_langue_message(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_langue_message(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_langue_message(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_langue_message(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_langue_message(integer, integer) TO "grp-www";


--
-- TOC entry 7291 (class 0 OID 0)
-- Dependencies: 874
-- Name: af_del_langue_messages(integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_langue_messages(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_langue_messages(integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_del_langue_messages(integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_del_langue_messages(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_langue_messages(integer, integer[]) TO "grp-www";


--
-- TOC entry 7293 (class 0 OID 0)
-- Dependencies: 875
-- Name: af_del_organisme(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_organisme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_organisme(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_organisme(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_organisme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_organisme(integer) TO "grp-www";


--
-- TOC entry 7295 (class 0 OID 0)
-- Dependencies: 876
-- Name: af_del_page_annuaire_configuration(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_page_annuaire_configuration(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_page_annuaire_configuration(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_page_annuaire_configuration(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_page_annuaire_configuration(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_page_annuaire_configuration(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7297 (class 0 OID 0)
-- Dependencies: 877
-- Name: af_del_page_liste_configuration(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_page_liste_configuration(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_page_liste_configuration(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_page_liste_configuration(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_page_liste_configuration(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_page_liste_configuration(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7298 (class 0 OID 0)
-- Dependencies: 878
-- Name: af_del_parcours_etape(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_parcours_etape(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_parcours_etape(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_parcours_etape(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_parcours_etape(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_parcours_etape(integer, integer) TO "grp-www";


--
-- TOC entry 7299 (class 0 OID 0)
-- Dependencies: 879
-- Name: af_del_positionnement(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_positionnement(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_positionnement(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_positionnement(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_positionnement(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_positionnement(integer) TO "grp-www";


--
-- TOC entry 7300 (class 0 OID 0)
-- Dependencies: 880
-- Name: af_del_positionnement_choix(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_positionnement_choix(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_positionnement_choix(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_positionnement_choix(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_positionnement_choix(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_positionnement_choix(integer, integer) TO "grp-www";


--
-- TOC entry 7301 (class 0 OID 0)
-- Dependencies: 881
-- Name: af_del_positionnement_evaluations_a_generer(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_positionnement_evaluations_a_generer(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_positionnement_evaluations_a_generer(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_positionnement_evaluations_a_generer(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_positionnement_evaluations_a_generer(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_positionnement_evaluations_a_generer(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7302 (class 0 OID 0)
-- Dependencies: 882
-- Name: af_del_positionnement_question(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_positionnement_question(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_positionnement_question(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_positionnement_question(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_positionnement_question(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_positionnement_question(integer, integer) TO "grp-www";


--
-- TOC entry 7304 (class 0 OID 0)
-- Dependencies: 883
-- Name: af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) TO "grp-www";


--
-- TOC entry 7305 (class 0 OID 0)
-- Dependencies: 884
-- Name: af_del_qsrc_question(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_qsrc_question(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_qsrc_question(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_qsrc_question(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_qsrc_question(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_qsrc_question(integer, integer) TO "grp-www";


--
-- TOC entry 7307 (class 0 OID 0)
-- Dependencies: 885
-- Name: af_del_question_reponse_association_element(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_question_reponse_association_element(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_question_reponse_association_element(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_association_element(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_association_element(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_question_reponse_association_element(integer, integer) TO "grp-www";


--
-- TOC entry 7308 (class 0 OID 0)
-- Dependencies: 886
-- Name: af_del_question_reponse_choix(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_question_reponse_choix(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_question_reponse_choix(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_choix(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_choix(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_question_reponse_choix(integer, integer) TO "grp-www";


--
-- TOC entry 7310 (class 0 OID 0)
-- Dependencies: 887
-- Name: af_del_question_reponse_element(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_question_reponse_element(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_question_reponse_element(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_element(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_element(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_question_reponse_element(integer) TO "grp-www";


--
-- TOC entry 7312 (class 0 OID 0)
-- Dependencies: 888
-- Name: af_del_question_reponse_element_media(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_question_reponse_element_media(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_question_reponse_element_media(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_element_media(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_element_media(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_question_reponse_element_media(integer, integer) TO "grp-www";


--
-- TOC entry 7314 (class 0 OID 0)
-- Dependencies: 889
-- Name: af_del_question_reponse_media(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_question_reponse_media(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_question_reponse_media(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_media(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_question_reponse_media(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_question_reponse_media(integer) TO "grp-www";


--
-- TOC entry 7316 (class 0 OID 0)
-- Dependencies: 890
-- Name: af_del_resultat_exotlc(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_resultat_exotlc(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_resultat_exotlc(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_resultat_exotlc(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_resultat_exotlc(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_resultat_exotlc(integer) TO "grp-www";


--
-- TOC entry 7317 (class 0 OID 0)
-- Dependencies: 891
-- Name: af_del_resultat_exotlc_fichier_rendu(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_resultat_exotlc_fichier_rendu(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_resultat_exotlc_fichier_rendu(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_resultat_exotlc_fichier_rendu(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_resultat_exotlc_fichier_rendu(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_resultat_exotlc_fichier_rendu(integer) TO "grp-www";


--
-- TOC entry 7318 (class 0 OID 0)
-- Dependencies: 892
-- Name: af_del_resultat_fin(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_resultat_fin(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_resultat_fin(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_resultat_fin(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_resultat_fin(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_resultat_fin(integer) TO "grp-www";


--
-- TOC entry 7320 (class 0 OID 0)
-- Dependencies: 893
-- Name: af_del_salle(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_salle(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_salle(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_salle(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_salle(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_salle(integer) TO "grp-www";


--
-- TOC entry 7322 (class 0 OID 0)
-- Dependencies: 894
-- Name: af_del_section(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_section(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_section(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_section(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_section(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_section(integer) TO "grp-www";


--
-- TOC entry 7324 (class 0 OID 0)
-- Dependencies: 895
-- Name: af_del_serie_aleatoire_configuration(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_serie_aleatoire_configuration(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_serie_aleatoire_configuration(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_serie_aleatoire_configuration(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_serie_aleatoire_configuration(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_serie_aleatoire_configuration(integer, integer) TO "grp-www";


--
-- TOC entry 7326 (class 0 OID 0)
-- Dependencies: 896
-- Name: af_del_serie_aleatoire_melangee(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_serie_aleatoire_melangee(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_serie_aleatoire_melangee(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_serie_aleatoire_melangee(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_serie_aleatoire_melangee(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_serie_aleatoire_melangee(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7328 (class 0 OID 0)
-- Dependencies: 897
-- Name: af_del_serie_bloquante_configuration(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_serie_bloquante_configuration(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_serie_bloquante_configuration(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_serie_bloquante_configuration(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_serie_bloquante_configuration(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_serie_bloquante_configuration(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7329 (class 0 OID 0)
-- Dependencies: 898
-- Name: af_del_serie_evaluation(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_serie_evaluation(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_serie_evaluation(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_serie_evaluation(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_serie_evaluation(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_serie_evaluation(integer, integer) TO "grp-www";


--
-- TOC entry 7331 (class 0 OID 0)
-- Dependencies: 899
-- Name: af_del_serie_evaluation_ordre(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_serie_evaluation_ordre(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_serie_evaluation_ordre(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_serie_evaluation_ordre(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_serie_evaluation_ordre(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_serie_evaluation_ordre(integer, integer) TO "grp-www";


--
-- TOC entry 7333 (class 0 OID 0)
-- Dependencies: 900
-- Name: af_del_template(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_template(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_template(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_template(integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_template(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_template(integer) TO "grp-www";


--
-- TOC entry 7334 (class 0 OID 0)
-- Dependencies: 901
-- Name: af_del_test_positionnement(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_test_positionnement(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_test_positionnement(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_del_test_positionnement(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_del_test_positionnement(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_test_positionnement(integer, integer) TO "grp-www";


--
-- TOC entry 7335 (class 0 OID 0)
-- Dependencies: 902
-- Name: af_del_tests(integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_del_tests(tests integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_tests(tests integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_del_tests(tests integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_del_tests(tests integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_tests(tests integer[]) TO "grp-www";


--
-- TOC entry 7337 (class 0 OID 0)
-- Dependencies: 903
-- Name: af_del_theme(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_del_theme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_del_theme(integer) FROM postgres;
GRANT ALL ON FUNCTION af_del_theme(integer) TO postgres;
GRANT ALL ON FUNCTION af_del_theme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_del_theme(integer) TO "grp-www";


--
-- TOC entry 7339 (class 0 OID 0)
-- Dependencies: 1827
-- Name: af_fk_finder(character varying, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_fk_finder(character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_fk_finder(character varying, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_fk_finder(character varying, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_fk_finder(character varying, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_fk_finder(character varying, character varying, integer) TO "grp-www";


--
-- TOC entry 7341 (class 0 OID 0)
-- Dependencies: 1828
-- Name: af_fk_finder_oid(character varying, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_fk_finder_oid(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_fk_finder_oid(character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_fk_finder_oid(character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_fk_finder_oid(character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_fk_finder_oid(character varying, character varying) TO "grp-www";


--
-- TOC entry 7343 (class 0 OID 0)
-- Dependencies: 904
-- Name: af_fk_finder_tree(oid, oid, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_fk_finder_tree(oid, oid, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_fk_finder_tree(oid, oid, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_fk_finder_tree(oid, oid, integer) TO pgsql;
GRANT ALL ON FUNCTION af_fk_finder_tree(oid, oid, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_fk_finder_tree(oid, oid, integer) TO "grp-www";


--
-- TOC entry 7345 (class 0 OID 0)
-- Dependencies: 905
-- Name: af_gen_del_element(character varying, character varying, integer, text); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_gen_del_element(character varying, character varying, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_del_element(character varying, character varying, integer, text) FROM postgres;
GRANT ALL ON FUNCTION af_gen_del_element(character varying, character varying, integer, text) TO postgres;
GRANT ALL ON FUNCTION af_gen_del_element(character varying, character varying, integer, text) TO www;
GRANT ALL ON FUNCTION af_gen_del_element(character varying, character varying, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_del_element(character varying, character varying, integer, text) TO "grp-www";


--
-- TOC entry 7347 (class 0 OID 0)
-- Dependencies: 906
-- Name: af_gen_get_element_niveau(character varying, character varying, integer, text, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_gen_get_element_niveau(character varying, character varying, integer, text, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_get_element_niveau(character varying, character varying, integer, text, integer) FROM postgres;
GRANT ALL ON FUNCTION af_gen_get_element_niveau(character varying, character varying, integer, text, integer) TO postgres;
GRANT ALL ON FUNCTION af_gen_get_element_niveau(character varying, character varying, integer, text, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_get_element_niveau(character varying, character varying, integer, text, integer) TO "grp-www";


--
-- TOC entry 7349 (class 0 OID 0)
-- Dependencies: 907
-- Name: af_gen_get_elements(character varying, character varying, integer, text, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer) FROM postgres;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer) TO postgres;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer) TO www;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer) TO "grp-www";


--
-- TOC entry 7351 (class 0 OID 0)
-- Dependencies: 908
-- Name: af_gen_get_elements(character varying, character varying, integer, text); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text) FROM postgres;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text) TO postgres;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text) TO www;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text) TO "grp-www";


--
-- TOC entry 7353 (class 0 OID 0)
-- Dependencies: 909
-- Name: af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) TO www;
GRANT ALL ON FUNCTION af_gen_get_elements(character varying, character varying, integer, text, integer, integer[]) TO "grp-www";


--
-- TOC entry 7355 (class 0 OID 0)
-- Dependencies: 1829
-- Name: af_gen_get_int_values(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_gen_get_int_values(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_get_int_values(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_gen_get_int_values(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_gen_get_int_values(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_get_int_values(integer, integer) TO "grp-www";


--
-- TOC entry 7357 (class 0 OID 0)
-- Dependencies: 910
-- Name: af_gen_get_last_element(character varying, character varying, text); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, text) FROM postgres;
GRANT ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, text) TO postgres;
GRANT ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, text) TO www;
GRANT ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, text) TO "grp-www";


--
-- TOC entry 7359 (class 0 OID 0)
-- Dependencies: 911
-- Name: af_gen_get_last_element(character varying, character varying, integer[], text); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, integer[], text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, integer[], text) FROM postgres;
GRANT ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, integer[], text) TO postgres;
GRANT ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, integer[], text) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, integer[], text) TO www;
GRANT ALL ON FUNCTION af_gen_get_last_element(character varying, character varying, integer[], text) TO "grp-www";


--
-- TOC entry 7361 (class 0 OID 0)
-- Dependencies: 912
-- Name: af_gen_invert_elements(character varying, character varying, integer, integer, text); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_gen_invert_elements(character varying, character varying, integer, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_invert_elements(character varying, character varying, integer, integer, text) FROM postgres;
GRANT ALL ON FUNCTION af_gen_invert_elements(character varying, character varying, integer, integer, text) TO postgres;
GRANT ALL ON FUNCTION af_gen_invert_elements(character varying, character varying, integer, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_invert_elements(character varying, character varying, integer, integer, text) TO "grp-www";


--
-- TOC entry 7363 (class 0 OID 0)
-- Dependencies: 1831
-- Name: af_gen_set_element(character varying, character varying, integer, integer, text, text, text); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_gen_set_element(character varying, character varying, integer, integer, text, text, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_gen_set_element(character varying, character varying, integer, integer, text, text, text) FROM postgres;
GRANT ALL ON FUNCTION af_gen_set_element(character varying, character varying, integer, integer, text, text, text) TO postgres;
GRANT ALL ON FUNCTION af_gen_set_element(character varying, character varying, integer, integer, text, text, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_gen_set_element(character varying, character varying, integer, integer, text, text, text) TO "grp-www";


--
-- TOC entry 7365 (class 0 OID 0)
-- Dependencies: 1832
-- Name: af_get_alerte(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_alerte(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_alerte(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_alerte(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_alerte(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_alerte(integer) TO "grp-www";


--
-- TOC entry 7367 (class 0 OID 0)
-- Dependencies: 1833
-- Name: af_get_alerte_periode_max(integer, date); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_alerte_periode_max(integer, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_alerte_periode_max(integer, date) FROM pgsql;
GRANT ALL ON FUNCTION af_get_alerte_periode_max(integer, date) TO pgsql;
GRANT ALL ON FUNCTION af_get_alerte_periode_max(integer, date) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_alerte_periode_max(integer, date) TO "grp-www";


--
-- TOC entry 7369 (class 0 OID 0)
-- Dependencies: 913
-- Name: af_get_alertes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_alertes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_alertes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_alertes() TO pgsql;
GRANT ALL ON FUNCTION af_get_alertes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_alertes() TO "grp-www";


--
-- TOC entry 7371 (class 0 OID 0)
-- Dependencies: 914
-- Name: af_get_alertes_liees(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_alertes_liees(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_alertes_liees(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_alertes_liees(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_alertes_liees(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_alertes_liees(integer) TO "grp-www";


--
-- TOC entry 7373 (class 0 OID 0)
-- Dependencies: 915
-- Name: af_get_alertes_non_liees(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_alertes_non_liees() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_alertes_non_liees() FROM pgsql;
GRANT ALL ON FUNCTION af_get_alertes_non_liees() TO pgsql;
GRANT ALL ON FUNCTION af_get_alertes_non_liees() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_alertes_non_liees() TO "grp-www";


--
-- TOC entry 7374 (class 0 OID 0)
-- Dependencies: 916
-- Name: af_get_all_themes(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_all_themes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_all_themes() FROM postgres;
GRANT ALL ON FUNCTION af_get_all_themes() TO postgres;
GRANT ALL ON FUNCTION af_get_all_themes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_all_themes() TO "grp-www";


--
-- TOC entry 7376 (class 0 OID 0)
-- Dependencies: 917
-- Name: af_get_bareme(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_bareme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_bareme(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_bareme(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_bareme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_bareme(integer) TO "grp-www";


--
-- TOC entry 7377 (class 0 OID 0)
-- Dependencies: 918
-- Name: af_get_baremes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_baremes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_baremes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_baremes() TO pgsql;
GRANT ALL ON FUNCTION af_get_baremes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_baremes() TO "grp-www";


--
-- TOC entry 7379 (class 0 OID 0)
-- Dependencies: 919
-- Name: af_get_capacite(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_capacite(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_capacite(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_capacite(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_capacite(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_capacite(integer) TO "grp-www";


--
-- TOC entry 7381 (class 0 OID 0)
-- Dependencies: 920
-- Name: af_get_capacite_titre(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_capacite_titre(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_capacite_titre(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_capacite_titre(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_capacite_titre(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_capacite_titre(integer) TO "grp-www";


--
-- TOC entry 7383 (class 0 OID 0)
-- Dependencies: 921
-- Name: af_get_capacite_titre_capacite_themes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_capacite_titre_capacite_themes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_capacite_titre_capacite_themes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_capacite_titre_capacite_themes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_capacite_titre_capacite_themes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_capacite_titre_capacite_themes(integer) TO "grp-www";


--
-- TOC entry 7385 (class 0 OID 0)
-- Dependencies: 922
-- Name: af_get_capacite_titre_capacites(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_capacite_titre_capacites(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_capacite_titre_capacites(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_capacite_titre_capacites(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_capacite_titre_capacites(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_capacite_titre_capacites(integer) TO "grp-www";


--
-- TOC entry 7387 (class 0 OID 0)
-- Dependencies: 923
-- Name: af_get_capacite_titre_capacites_disponibles(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_capacite_titre_capacites_disponibles(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_capacite_titre_capacites_disponibles(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_capacite_titre_capacites_disponibles(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_capacite_titre_capacites_disponibles(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_capacite_titre_capacites_disponibles(integer, integer) TO "grp-www";


--
-- TOC entry 7389 (class 0 OID 0)
-- Dependencies: 924
-- Name: af_get_categorie(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_categorie(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_categorie(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_categorie(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie(integer) TO "grp-www";


--
-- TOC entry 7391 (class 0 OID 0)
-- Dependencies: 925
-- Name: af_get_categorie_elements(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_categorie_elements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_elements(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_categorie_elements(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_categorie_elements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_elements(integer) TO "grp-www";


--
-- TOC entry 7393 (class 0 OID 0)
-- Dependencies: 926
-- Name: af_get_categorie_elements_all_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_categorie_elements_all_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_elements_all_theme(integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_categorie_elements_all_theme(integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_categorie_elements_all_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_elements_all_theme(integer, integer) TO "grp-www";


--
-- TOC entry 7395 (class 0 OID 0)
-- Dependencies: 927
-- Name: af_get_categorie_elements_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_categorie_elements_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_elements_theme(integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_categorie_elements_theme(integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_categorie_elements_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_elements_theme(integer, integer) TO "grp-www";


--
-- TOC entry 7397 (class 0 OID 0)
-- Dependencies: 928
-- Name: af_get_categorie_fichiers_all_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_categorie_fichiers_all_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_fichiers_all_theme(integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_all_theme(integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_all_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_all_theme(integer, integer) TO "grp-www";


--
-- TOC entry 7399 (class 0 OID 0)
-- Dependencies: 1834
-- Name: af_get_categorie_fichiers_scenario_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_categorie_fichiers_scenario_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_fichiers_scenario_theme(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_scenario_theme(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_scenario_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_scenario_theme(integer, integer) TO "grp-www";


--
-- TOC entry 7401 (class 0 OID 0)
-- Dependencies: 929
-- Name: af_get_categorie_fichiers_textes_all_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_categorie_fichiers_textes_all_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_fichiers_textes_all_theme(integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_textes_all_theme(integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_textes_all_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_textes_all_theme(integer, integer) TO "grp-www";


--
-- TOC entry 7403 (class 0 OID 0)
-- Dependencies: 930
-- Name: af_get_categorie_fichiers_textes_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_categorie_fichiers_textes_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_fichiers_textes_theme(integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_textes_theme(integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_textes_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_textes_theme(integer, integer) TO "grp-www";


--
-- TOC entry 7405 (class 0 OID 0)
-- Dependencies: 931
-- Name: af_get_categorie_fichiers_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_categorie_fichiers_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_fichiers_theme(integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_theme(integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_theme(integer, integer) TO "grp-www";


--
-- TOC entry 7407 (class 0 OID 0)
-- Dependencies: 932
-- Name: af_get_categorie_fichiers_themes(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_categorie_fichiers_themes(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_fichiers_themes(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_themes(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_themes(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_fichiers_themes(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7409 (class 0 OID 0)
-- Dependencies: 933
-- Name: af_get_categorie_themes(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_categorie_themes(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_themes(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_categorie_themes(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_categorie_themes(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_themes(integer, integer) TO "grp-www";


--
-- TOC entry 7411 (class 0 OID 0)
-- Dependencies: 934
-- Name: af_get_categorie_themes_element_infos(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_categorie_themes_element_infos(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_themes_element_infos(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_categorie_themes_element_infos(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_categorie_themes_element_infos(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_themes_element_infos(integer, integer) TO "grp-www";


--
-- TOC entry 7413 (class 0 OID 0)
-- Dependencies: 935
-- Name: af_get_categorie_themes_type_evaluation(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_categorie_themes_type_evaluation(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categorie_themes_type_evaluation(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_categorie_themes_type_evaluation(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_categorie_themes_type_evaluation(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categorie_themes_type_evaluation(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7415 (class 0 OID 0)
-- Dependencies: 936
-- Name: af_get_categories(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_categories() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categories() FROM postgres;
GRANT ALL ON FUNCTION af_get_categories() TO postgres;
GRANT ALL ON FUNCTION af_get_categories() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categories() TO "grp-www";


--
-- TOC entry 7417 (class 0 OID 0)
-- Dependencies: 937
-- Name: af_get_categories(boolean); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_categories(boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_categories(boolean) FROM postgres;
GRANT ALL ON FUNCTION af_get_categories(boolean) TO postgres;
GRANT ALL ON FUNCTION af_get_categories(boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_categories(boolean) TO "grp-www";


--
-- TOC entry 7419 (class 0 OID 0)
-- Dependencies: 938
-- Name: af_get_classe(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe(integer) TO "grp-www";


--
-- TOC entry 7421 (class 0 OID 0)
-- Dependencies: 939
-- Name: af_get_classe_droits_communs(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_droits_communs(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_droits_communs(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_droits_communs(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_droits_communs(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_droits_communs(integer, integer) TO "grp-www";


--
-- TOC entry 7423 (class 0 OID 0)
-- Dependencies: 940
-- Name: af_get_classe_droits_non_affilies(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_droits_non_affilies(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_droits_non_affilies(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_droits_non_affilies(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_droits_non_affilies(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_droits_non_affilies(integer) TO "grp-www";


--
-- TOC entry 7425 (class 0 OID 0)
-- Dependencies: 941
-- Name: af_get_classe_evenements(integer, date); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_evenements(integer, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_evenements(integer, date) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_evenements(integer, date) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_evenements(integer, date) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_evenements(integer, date) TO "grp-www";


--
-- TOC entry 7427 (class 0 OID 0)
-- Dependencies: 942
-- Name: af_get_classe_fils(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_fils(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_fils(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_fils(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_fils(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_fils(integer) TO "grp-www";


--
-- TOC entry 7429 (class 0 OID 0)
-- Dependencies: 943
-- Name: af_get_classe_formations(integer, character varying, character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_formations(integer, character varying, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_formations(integer, character varying, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_formations(integer, character varying, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_formations(integer, character varying, character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_formations(integer, character varying, character varying, integer, integer) TO "grp-www";


--
-- TOC entry 7431 (class 0 OID 0)
-- Dependencies: 1835
-- Name: af_get_classe_individus(integer, integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_individus(integer, integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_individus(integer, integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_individus(integer, integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_individus(integer, integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_individus(integer, integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 7433 (class 0 OID 0)
-- Dependencies: 944
-- Name: af_get_classe_individus_affiliables(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_individus_affiliables(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_individus_affiliables(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_individus_affiliables(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_individus_affiliables(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_individus_affiliables(integer) TO "grp-www";


--
-- TOC entry 7435 (class 0 OID 0)
-- Dependencies: 945
-- Name: af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_individus_except_individus_types(integer, integer[], character varying, boolean) TO "grp-www";


--
-- TOC entry 7437 (class 0 OID 0)
-- Dependencies: 1836
-- Name: af_get_classe_individus_infos(integer, integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_individus_infos(integer, integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_individus_infos(integer, integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_individus_infos(integer, integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_individus_infos(integer, integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_individus_infos(integer, integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 7439 (class 0 OID 0)
-- Dependencies: 946
-- Name: af_get_classe_nom_entier(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_nom_entier(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_nom_entier(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_nom_entier(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_nom_entier(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_nom_entier(integer) TO "grp-www";


--
-- TOC entry 7441 (class 0 OID 0)
-- Dependencies: 947
-- Name: af_get_classe_organisme(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_organisme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_organisme(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_organisme(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_organisme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_organisme(integer) TO "grp-www";


--
-- TOC entry 7443 (class 0 OID 0)
-- Dependencies: 948
-- Name: af_get_classe_pere(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_classe_pere(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_pere(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_classe_pere(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_classe_pere(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_pere(integer) TO "grp-www";


--
-- TOC entry 7445 (class 0 OID 0)
-- Dependencies: 949
-- Name: af_get_classe_peres_fils(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classe_peres_fils() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classe_peres_fils() FROM pgsql;
GRANT ALL ON FUNCTION af_get_classe_peres_fils() TO pgsql;
GRANT ALL ON FUNCTION af_get_classe_peres_fils() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classe_peres_fils() TO "grp-www";


--
-- TOC entry 7447 (class 0 OID 0)
-- Dependencies: 950
-- Name: af_get_classes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_classes() TO pgsql;
GRANT ALL ON FUNCTION af_get_classes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classes() TO "grp-www";


--
-- TOC entry 7449 (class 0 OID 0)
-- Dependencies: 951
-- Name: af_get_classes_exotlcs_corriges(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classes_exotlcs_corriges() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classes_exotlcs_corriges() FROM pgsql;
GRANT ALL ON FUNCTION af_get_classes_exotlcs_corriges() TO pgsql;
GRANT ALL ON FUNCTION af_get_classes_exotlcs_corriges() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classes_exotlcs_corriges() TO "grp-www";


--
-- TOC entry 7451 (class 0 OID 0)
-- Dependencies: 952
-- Name: af_get_classes_formation(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classes_formation() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classes_formation() FROM pgsql;
GRANT ALL ON FUNCTION af_get_classes_formation() TO pgsql;
GRANT ALL ON FUNCTION af_get_classes_formation() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classes_formation() TO "grp-www";


--
-- TOC entry 7453 (class 0 OID 0)
-- Dependencies: 953
-- Name: af_get_classes_individu(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_classes_individu() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_classes_individu() FROM pgsql;
GRANT ALL ON FUNCTION af_get_classes_individu() TO pgsql;
GRANT ALL ON FUNCTION af_get_classes_individu() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_classes_individu() TO "grp-www";


--
-- TOC entry 7455 (class 0 OID 0)
-- Dependencies: 954
-- Name: af_get_commentaire(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_commentaire(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_commentaire(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_commentaire(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_commentaire(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_commentaire(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7457 (class 0 OID 0)
-- Dependencies: 955
-- Name: af_get_connexion_dates_max(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_connexion_dates_max(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_connexion_dates_max(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_connexion_dates_max(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_connexion_dates_max(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_connexion_dates_max(integer) TO "grp-www";


--
-- TOC entry 7459 (class 0 OID 0)
-- Dependencies: 956
-- Name: af_get_connexion_individus(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_connexion_individus() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_connexion_individus() FROM pgsql;
GRANT ALL ON FUNCTION af_get_connexion_individus() TO pgsql;
GRANT ALL ON FUNCTION af_get_connexion_individus() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_connexion_individus() TO "grp-www";


--
-- TOC entry 7461 (class 0 OID 0)
-- Dependencies: 957
-- Name: af_get_critere(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_critere(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_critere(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_critere(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_critere(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_critere(integer) TO "grp-www";


--
-- TOC entry 7463 (class 0 OID 0)
-- Dependencies: 958
-- Name: af_get_critere_sous_criteres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_critere_sous_criteres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_critere_sous_criteres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_critere_sous_criteres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_critere_sous_criteres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_critere_sous_criteres(integer) TO "grp-www";


--
-- TOC entry 7465 (class 0 OID 0)
-- Dependencies: 959
-- Name: af_get_criteres(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_criteres() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_criteres() FROM pgsql;
GRANT ALL ON FUNCTION af_get_criteres() TO pgsql;
GRANT ALL ON FUNCTION af_get_criteres() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_criteres() TO "grp-www";


--
-- TOC entry 7467 (class 0 OID 0)
-- Dependencies: 960
-- Name: af_get_droit(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_droit(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_droit(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_droit(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_droit(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_droit(integer) TO "grp-www";


--
-- TOC entry 7469 (class 0 OID 0)
-- Dependencies: 961
-- Name: af_get_droits(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_droits(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_droits(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_droits(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_droits(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_droits(integer) TO "grp-www";


--
-- TOC entry 7471 (class 0 OID 0)
-- Dependencies: 962
-- Name: af_get_droits_defaut(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_droits_defaut(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_droits_defaut(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_droits_defaut(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_droits_defaut(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_droits_defaut(integer) TO "grp-www";


--
-- TOC entry 7473 (class 0 OID 0)
-- Dependencies: 963
-- Name: af_get_element_themes_categorie(integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_element_themes_categorie(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_element_themes_categorie(integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_element_themes_categorie(integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_element_themes_categorie(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_element_themes_categorie(integer, integer) TO www;
GRANT ALL ON FUNCTION af_get_element_themes_categorie(integer, integer) TO "grp-www";


--
-- TOC entry 7475 (class 0 OID 0)
-- Dependencies: 964
-- Name: af_get_espace(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_espace(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_espace(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_espace(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_espace(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_espace(integer) TO "grp-www";


--
-- TOC entry 7477 (class 0 OID 0)
-- Dependencies: 965
-- Name: af_get_espaces(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_espaces() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_espaces() FROM pgsql;
GRANT ALL ON FUNCTION af_get_espaces() TO pgsql;
GRANT ALL ON FUNCTION af_get_espaces() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_espaces() TO "grp-www";


--
-- TOC entry 7479 (class 0 OID 0)
-- Dependencies: 966
-- Name: af_get_etape(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape(integer) TO "grp-www";


--
-- TOC entry 7480 (class 0 OID 0)
-- Dependencies: 967
-- Name: af_get_etape_classes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_classes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_classes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_classes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_classes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_classes(integer) TO "grp-www";


--
-- TOC entry 7481 (class 0 OID 0)
-- Dependencies: 968
-- Name: af_get_etape_filieres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_filieres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_filieres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_filieres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_filieres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_filieres(integer) TO "grp-www";


--
-- TOC entry 7482 (class 0 OID 0)
-- Dependencies: 969
-- Name: af_get_etape_formations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_formations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_formations(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_formations(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_formations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_formations(integer) TO "grp-www";


--
-- TOC entry 7483 (class 0 OID 0)
-- Dependencies: 970
-- Name: af_get_etape_formations_classe(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_formations_classe(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_formations_classe(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_formations_classe(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_formations_classe(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_formations_classe(integer, integer) TO "grp-www";


--
-- TOC entry 7485 (class 0 OID 0)
-- Dependencies: 971
-- Name: af_get_etape_forum(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_forum(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_forum(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_forum(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_forum(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_forum(integer) TO "grp-www";


--
-- TOC entry 7486 (class 0 OID 0)
-- Dependencies: 972
-- Name: af_get_etape_parcours_oriente_configuration(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_parcours_oriente_configuration(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_parcours_oriente_configuration(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_parcours_oriente_configuration(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_parcours_oriente_configuration(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_parcours_oriente_configuration(integer) TO "grp-www";


--
-- TOC entry 7488 (class 0 OID 0)
-- Dependencies: 973
-- Name: af_get_etape_parcourss(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_parcourss(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_parcourss(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_parcourss(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_parcourss(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_parcourss(integer) TO "grp-www";


--
-- TOC entry 7489 (class 0 OID 0)
-- Dependencies: 974
-- Name: af_get_etape_ressource(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_ressource(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_ressource(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_ressource(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_ressource(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_ressource(integer) TO "grp-www";


--
-- TOC entry 7491 (class 0 OID 0)
-- Dependencies: 975
-- Name: af_get_etape_ressource_infos(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_etape_ressource_infos(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_ressource_infos(integer, integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_etape_ressource_infos(integer, integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_etape_ressource_infos(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_ressource_infos(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7492 (class 0 OID 0)
-- Dependencies: 976
-- Name: af_get_etape_resultats(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_resultats(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_resultats(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_resultats(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_resultats(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_resultats(integer) TO "grp-www";


--
-- TOC entry 7494 (class 0 OID 0)
-- Dependencies: 977
-- Name: af_get_etape_scorm_fichier(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_scorm_fichier(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_scorm_fichier(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_scorm_fichier(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_scorm_fichier(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_scorm_fichier(integer) TO "grp-www";


--
-- TOC entry 7495 (class 0 OID 0)
-- Dependencies: 1837
-- Name: af_get_etape_type_sous_type(integer, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etape_type_sous_type(integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etape_type_sous_type(integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etape_type_sous_type(integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_etape_type_sous_type(integer, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etape_type_sous_type(integer, integer, character varying) TO "grp-www";


--
-- TOC entry 7496 (class 0 OID 0)
-- Dependencies: 978
-- Name: af_get_etapes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etapes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etapes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_etapes() TO pgsql;
GRANT ALL ON FUNCTION af_get_etapes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etapes() TO "grp-www";


--
-- TOC entry 7498 (class 0 OID 0)
-- Dependencies: 1838
-- Name: af_get_etapes_chats(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etapes_chats() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etapes_chats() FROM pgsql;
GRANT ALL ON FUNCTION af_get_etapes_chats() TO pgsql;
GRANT ALL ON FUNCTION af_get_etapes_chats() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etapes_chats() TO "grp-www";


--
-- TOC entry 7500 (class 0 OID 0)
-- Dependencies: 979
-- Name: af_get_etapes_fichiers(integer[], character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etapes_fichiers(integer[], character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etapes_fichiers(integer[], character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_etapes_fichiers(integer[], character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_etapes_fichiers(integer[], character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etapes_fichiers(integer[], character varying) TO "grp-www";


--
-- TOC entry 7502 (class 0 OID 0)
-- Dependencies: 980
-- Name: af_get_etapes_forum(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_etapes_forum() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_etapes_forum() FROM pgsql;
GRANT ALL ON FUNCTION af_get_etapes_forum() TO pgsql;
GRANT ALL ON FUNCTION af_get_etapes_forum() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_etapes_forum() TO "grp-www";


--
-- TOC entry 7503 (class 0 OID 0)
-- Dependencies: 981
-- Name: af_get_evaluation(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_evaluation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evaluation(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_evaluation(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_evaluation(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evaluation(integer) TO "grp-www";


--
-- TOC entry 7505 (class 0 OID 0)
-- Dependencies: 1839
-- Name: af_get_evaluation_bareme(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_evaluation_bareme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evaluation_bareme(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_bareme(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_bareme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evaluation_bareme(integer, integer) TO "grp-www";


--
-- TOC entry 7507 (class 0 OID 0)
-- Dependencies: 1840
-- Name: af_get_evaluation_point(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_evaluation_point(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evaluation_point(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_point(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_point(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evaluation_point(integer, integer) TO "grp-www";


--
-- TOC entry 7509 (class 0 OID 0)
-- Dependencies: 982
-- Name: af_get_evaluation_resultats(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_evaluation_resultats(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evaluation_resultats(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_resultats(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_resultats(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evaluation_resultats(integer) TO "grp-www";


--
-- TOC entry 7511 (class 0 OID 0)
-- Dependencies: 983
-- Name: af_get_evaluation_series(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_evaluation_series(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evaluation_series(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_evaluation_series(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_evaluation_series(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evaluation_series(integer) TO "grp-www";


--
-- TOC entry 7512 (class 0 OID 0)
-- Dependencies: 984
-- Name: af_get_evaluation_type(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_evaluation_type(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evaluation_type(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_type(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_type(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evaluation_type(integer) TO "grp-www";


--
-- TOC entry 7513 (class 0 OID 0)
-- Dependencies: 985
-- Name: af_get_evaluation_types(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_evaluation_types() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evaluation_types() FROM pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_types() TO pgsql;
GRANT ALL ON FUNCTION af_get_evaluation_types() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evaluation_types() TO "grp-www";


--
-- TOC entry 7515 (class 0 OID 0)
-- Dependencies: 986
-- Name: af_get_evenement_intervenants(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_evenement_intervenants(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evenement_intervenants(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_evenement_intervenants(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_evenement_intervenants(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evenement_intervenants(integer) TO "grp-www";


--
-- TOC entry 7517 (class 0 OID 0)
-- Dependencies: 987
-- Name: af_get_evenements(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_evenements() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evenements() FROM pgsql;
GRANT ALL ON FUNCTION af_get_evenements() TO pgsql;
GRANT ALL ON FUNCTION af_get_evenements() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evenements() TO "grp-www";


--
-- TOC entry 7519 (class 0 OID 0)
-- Dependencies: 988
-- Name: af_get_evenements_dates(date, time without time zone, time without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_evenements_dates(date, time without time zone, time without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_evenements_dates(date, time without time zone, time without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_get_evenements_dates(date, time without time zone, time without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_get_evenements_dates(date, time without time zone, time without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_evenements_dates(date, time without time zone, time without time zone) TO "grp-www";


--
-- TOC entry 7521 (class 0 OID 0)
-- Dependencies: 989
-- Name: af_get_exotlc(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc(integer, integer) TO "grp-www";


--
-- TOC entry 7523 (class 0 OID 0)
-- Dependencies: 990
-- Name: af_get_exotlc_fichier(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc_fichier(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc_fichier(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_fichier(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_fichier(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc_fichier(integer) TO "grp-www";


--
-- TOC entry 7525 (class 0 OID 0)
-- Dependencies: 991
-- Name: af_get_exotlc_fichiers(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc_fichiers(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc_fichiers(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_fichiers(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_fichiers(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc_fichiers(integer) TO "grp-www";


--
-- TOC entry 7527 (class 0 OID 0)
-- Dependencies: 992
-- Name: af_get_exotlc_fichiers_correction(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc_fichiers_correction(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc_fichiers_correction(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_fichiers_correction(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_fichiers_correction(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc_fichiers_correction(integer) TO "grp-www";


--
-- TOC entry 7529 (class 0 OID 0)
-- Dependencies: 993
-- Name: af_get_exotlc_mail(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc_mail(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc_mail(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_mail(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_mail(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc_mail(integer) TO "grp-www";


--
-- TOC entry 7530 (class 0 OID 0)
-- Dependencies: 994
-- Name: af_get_exotlc_modele_correction(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc_modele_correction(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc_modele_correction(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_modele_correction(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_modele_correction(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc_modele_correction(integer) TO "grp-www";


--
-- TOC entry 7532 (class 0 OID 0)
-- Dependencies: 995
-- Name: af_get_exotlc_plate_forme(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc_plate_forme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc_plate_forme(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_plate_forme(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_plate_forme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc_plate_forme(integer) TO "grp-www";


--
-- TOC entry 7534 (class 0 OID 0)
-- Dependencies: 996
-- Name: af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc_stagiaires_corriges_formation(integer, integer, integer, boolean) TO "grp-www";


--
-- TOC entry 7536 (class 0 OID 0)
-- Dependencies: 997
-- Name: af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc_stagiaires_fichier_rendu(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7538 (class 0 OID 0)
-- Dependencies: 998
-- Name: af_get_exotlc_type(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlc_type(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlc_type(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_type(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlc_type(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlc_type(integer) TO "grp-www";


--
-- TOC entry 7540 (class 0 OID 0)
-- Dependencies: 999
-- Name: af_get_exotlcs(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_exotlcs() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_exotlcs() FROM pgsql;
GRANT ALL ON FUNCTION af_get_exotlcs() TO pgsql;
GRANT ALL ON FUNCTION af_get_exotlcs() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_exotlcs() TO "grp-www";


--
-- TOC entry 7542 (class 0 OID 0)
-- Dependencies: 1000
-- Name: af_get_fichier(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_fichier(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_fichier(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_fichier(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier(integer) TO "grp-www";


--
-- TOC entry 7544 (class 0 OID 0)
-- Dependencies: 1001
-- Name: af_get_fichier_glossaire(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_fichier_glossaire(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_glossaire(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_fichier_glossaire(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_fichier_glossaire(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_glossaire(integer) TO "grp-www";


--
-- TOC entry 7545 (class 0 OID 0)
-- Dependencies: 1830
-- Name: af_get_fichier_metadata(integer); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION af_get_fichier_metadata(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_metadata(integer) FROM www;
GRANT ALL ON FUNCTION af_get_fichier_metadata(integer) TO www;
GRANT ALL ON FUNCTION af_get_fichier_metadata(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_metadata(integer) TO "grp-www";


--
-- TOC entry 7547 (class 0 OID 0)
-- Dependencies: 1002
-- Name: af_get_fichier_scenario_dynamique(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique(integer) TO "grp-www";


--
-- TOC entry 7548 (class 0 OID 0)
-- Dependencies: 1003
-- Name: af_get_fichier_scenario_dynamique_bloc(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_bloc(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_bloc(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_bloc(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_bloc(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_bloc(integer, integer) TO "grp-www";


--
-- TOC entry 7549 (class 0 OID 0)
-- Dependencies: 1004
-- Name: af_get_fichier_scenario_dynamique_blocs(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs(integer) TO "grp-www";


--
-- TOC entry 7550 (class 0 OID 0)
-- Dependencies: 1005
-- Name: af_get_fichier_scenario_dynamique_blocs_type(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs_type(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs_type(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs_type(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs_type(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_blocs_type(integer) TO "grp-www";


--
-- TOC entry 7551 (class 0 OID 0)
-- Dependencies: 1006
-- Name: af_get_fichier_scenario_dynamique_slide(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_slide(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_slide(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_slide(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_slide(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_slide(integer, integer) TO "grp-www";


--
-- TOC entry 7552 (class 0 OID 0)
-- Dependencies: 1007
-- Name: af_get_fichier_scenario_dynamique_slides(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_slides(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_scenario_dynamique_slides(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_slides(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_slides(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_scenario_dynamique_slides(integer) TO "grp-www";


--
-- TOC entry 7554 (class 0 OID 0)
-- Dependencies: 1008
-- Name: af_get_fichier_texte(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_fichier_texte(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_texte(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_fichier_texte(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_fichier_texte(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_texte(integer) TO "grp-www";


--
-- TOC entry 7556 (class 0 OID 0)
-- Dependencies: 19
-- Name: af_get_fichier_type(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_fichier_type(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichier_type(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_fichier_type(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_fichier_type(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichier_type(integer) TO "grp-www";


--
-- TOC entry 7558 (class 0 OID 0)
-- Dependencies: 1009
-- Name: af_get_fichiers(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_fichiers() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichiers() FROM postgres;
GRANT ALL ON FUNCTION af_get_fichiers() TO postgres;
GRANT ALL ON FUNCTION af_get_fichiers() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichiers() TO "grp-www";


--
-- TOC entry 7560 (class 0 OID 0)
-- Dependencies: 1010
-- Name: af_get_fichiers_type(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_fichiers_type(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_fichiers_type(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_fichiers_type(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_fichiers_type(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_fichiers_type(integer) TO "grp-www";


--
-- TOC entry 7561 (class 0 OID 0)
-- Dependencies: 1011
-- Name: af_get_filiere(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filiere(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filiere(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_filiere(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_filiere(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filiere(integer) TO "grp-www";


--
-- TOC entry 7562 (class 0 OID 0)
-- Dependencies: 1012
-- Name: af_get_filiere_etapes_disponibles_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filiere_etapes_disponibles_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filiere_etapes_disponibles_theme(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_filiere_etapes_disponibles_theme(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_filiere_etapes_disponibles_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filiere_etapes_disponibles_theme(integer, integer) TO "grp-www";


--
-- TOC entry 7564 (class 0 OID 0)
-- Dependencies: 1013
-- Name: af_get_filiere_formations(integer, character varying, boolean, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filiere_formations(integer, character varying, boolean, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filiere_formations(integer, character varying, boolean, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_filiere_formations(integer, character varying, boolean, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_filiere_formations(integer, character varying, boolean, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filiere_formations(integer, character varying, boolean, integer) TO "grp-www";


--
-- TOC entry 7565 (class 0 OID 0)
-- Dependencies: 1841
-- Name: af_get_filiere_libelle_complet(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filiere_libelle_complet(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filiere_libelle_complet(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_filiere_libelle_complet(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_filiere_libelle_complet(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filiere_libelle_complet(integer) TO "grp-www";


--
-- TOC entry 7566 (class 0 OID 0)
-- Dependencies: 1014
-- Name: af_get_filiere_parcourss(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filiere_parcourss(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filiere_parcourss(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_filiere_parcourss(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_filiere_parcourss(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filiere_parcourss(integer) TO "grp-www";


--
-- TOC entry 7568 (class 0 OID 0)
-- Dependencies: 1015
-- Name: af_get_filiere_pere(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_filiere_pere(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filiere_pere(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_filiere_pere(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_filiere_pere(integer) TO www;
GRANT ALL ON FUNCTION af_get_filiere_pere(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filiere_pere(integer) TO "grp-www";


--
-- TOC entry 7569 (class 0 OID 0)
-- Dependencies: 1016
-- Name: af_get_filiere_sous_filieres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filiere_sous_filieres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filiere_sous_filieres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_filiere_sous_filieres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_filiere_sous_filieres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filiere_sous_filieres(integer) TO "grp-www";


--
-- TOC entry 7570 (class 0 OID 0)
-- Dependencies: 1017
-- Name: af_get_filiere_sous_parcourss_disponibles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filiere_sous_parcourss_disponibles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filiere_sous_parcourss_disponibles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_filiere_sous_parcourss_disponibles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_filiere_sous_parcourss_disponibles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filiere_sous_parcourss_disponibles(integer) TO "grp-www";


--
-- TOC entry 7571 (class 0 OID 0)
-- Dependencies: 1018
-- Name: af_get_filieres(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filieres() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filieres() FROM pgsql;
GRANT ALL ON FUNCTION af_get_filieres() TO pgsql;
GRANT ALL ON FUNCTION af_get_filieres() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filieres() TO "grp-www";


--
-- TOC entry 7573 (class 0 OID 0)
-- Dependencies: 1019
-- Name: af_get_filieres_formation(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filieres_formation() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filieres_formation() FROM pgsql;
GRANT ALL ON FUNCTION af_get_filieres_formation() TO pgsql;
GRANT ALL ON FUNCTION af_get_filieres_formation() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filieres_formation() TO "grp-www";


--
-- TOC entry 7575 (class 0 OID 0)
-- Dependencies: 1020
-- Name: af_get_filieres_parcours(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filieres_parcours() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filieres_parcours() FROM pgsql;
GRANT ALL ON FUNCTION af_get_filieres_parcours() TO pgsql;
GRANT ALL ON FUNCTION af_get_filieres_parcours() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filieres_parcours() TO "grp-www";


--
-- TOC entry 7577 (class 0 OID 0)
-- Dependencies: 1021
-- Name: af_get_filieres_parcours(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_filieres_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_filieres_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_filieres_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_filieres_parcours(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_filieres_parcours(integer) TO "grp-www";


--
-- TOC entry 7579 (class 0 OID 0)
-- Dependencies: 1022
-- Name: af_get_formateur_classes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formateur_classes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formateur_classes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formateur_classes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formateur_classes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formateur_classes(integer) TO "grp-www";


--
-- TOC entry 7581 (class 0 OID 0)
-- Dependencies: 1023
-- Name: af_get_formateur_droits(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formateur_droits(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formateur_droits(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formateur_droits(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formateur_droits(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formateur_droits(integer, integer) TO "grp-www";


--
-- TOC entry 7583 (class 0 OID 0)
-- Dependencies: 1024
-- Name: af_get_formateur_formations(integer, character varying, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formateur_formations(integer, character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formateur_formations(integer, character varying, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formateur_formations(integer, character varying, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formateur_formations(integer, character varying, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formateur_formations(integer, character varying, character varying, integer) TO "grp-www";


--
-- TOC entry 7585 (class 0 OID 0)
-- Dependencies: 1025
-- Name: af_get_formateur_individu_formations(integer, character varying, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formateur_individu_formations(integer, character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formateur_individu_formations(integer, character varying, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formateur_individu_formations(integer, character varying, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formateur_individu_formations(integer, character varying, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formateur_individu_formations(integer, character varying, character varying, integer) TO "grp-www";


--
-- TOC entry 7587 (class 0 OID 0)
-- Dependencies: 1026
-- Name: af_get_formateurs(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formateurs(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formateurs(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formateurs(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formateurs(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formateurs(integer) TO "grp-www";


--
-- TOC entry 7588 (class 0 OID 0)
-- Dependencies: 1027
-- Name: af_get_formation(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation(integer) TO "grp-www";


--
-- TOC entry 7590 (class 0 OID 0)
-- Dependencies: 1028
-- Name: af_get_formation_alerte(integer, date); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_alerte(integer, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_alerte(integer, date) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_alerte(integer, date) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_alerte(integer, date) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_alerte(integer, date) TO "grp-www";


--
-- TOC entry 7592 (class 0 OID 0)
-- Dependencies: 1842
-- Name: af_get_formation_alertes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_alertes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_alertes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_alertes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_alertes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_alertes(integer) TO "grp-www";


--
-- TOC entry 7594 (class 0 OID 0)
-- Dependencies: 1029
-- Name: af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_alertes_periode(integer, timestamp without time zone, timestamp without time zone) TO "grp-www";


--
-- TOC entry 7596 (class 0 OID 0)
-- Dependencies: 1030
-- Name: af_get_formation_all_ressources_individu(integer, boolean, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_all_ressources_individu(integer, boolean, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_all_ressources_individu(integer, boolean, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_all_ressources_individu(integer, boolean, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_all_ressources_individu(integer, boolean, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_all_ressources_individu(integer, boolean, integer) TO "grp-www";


--
-- TOC entry 7597 (class 0 OID 0)
-- Dependencies: 1031
-- Name: af_get_formation_avancement(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_avancement(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_avancement(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_avancement(integer) TO "grp-www";


--
-- TOC entry 7599 (class 0 OID 0)
-- Dependencies: 1032
-- Name: af_get_formation_avancement_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_avancement_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_avancement_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_avancement_individu(integer, integer) TO "grp-www";


--
-- TOC entry 7600 (class 0 OID 0)
-- Dependencies: 1033
-- Name: af_get_formation_avancement_max(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_avancement_max(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_avancement_max(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_max(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_max(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_avancement_max(integer, integer) TO "grp-www";


--
-- TOC entry 7601 (class 0 OID 0)
-- Dependencies: 1034
-- Name: af_get_formation_avancement_max_parcours(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_avancement_max_parcours(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_avancement_max_parcours(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_max_parcours(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_max_parcours(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_avancement_max_parcours(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7602 (class 0 OID 0)
-- Dependencies: 1035
-- Name: af_get_formation_avancement_parcours(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_avancement_parcours(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_avancement_parcours(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_parcours(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_parcours(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_avancement_parcours(integer, integer) TO "grp-www";


--
-- TOC entry 7604 (class 0 OID 0)
-- Dependencies: 1036
-- Name: af_get_formation_avancement_parcours_individu(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_avancement_parcours_individu(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_avancement_parcours_individu(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_parcours_individu(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_parcours_individu(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_avancement_parcours_individu(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7606 (class 0 OID 0)
-- Dependencies: 1037
-- Name: af_get_formation_avancement_reel_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_avancement_reel_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_avancement_reel_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_reel_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_avancement_reel_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_avancement_reel_individu(integer, integer) TO "grp-www";


--
-- TOC entry 7608 (class 0 OID 0)
-- Dependencies: 1038
-- Name: af_get_formation_classes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_classes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_classes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_classes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_classes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_classes(integer) TO "grp-www";


--
-- TOC entry 7610 (class 0 OID 0)
-- Dependencies: 1039
-- Name: af_get_formation_droits(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_droits(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_droits(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_droits(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_droits(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_droits(integer) TO "grp-www";


--
-- TOC entry 7612 (class 0 OID 0)
-- Dependencies: 1040
-- Name: af_get_formation_espace_ressources(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_espace_ressources(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_espace_ressources(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_ressources(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_ressources(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_espace_ressources(integer, integer) TO "grp-www";


--
-- TOC entry 7614 (class 0 OID 0)
-- Dependencies: 1041
-- Name: af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_espace_section_all_ressources_individu(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7616 (class 0 OID 0)
-- Dependencies: 1042
-- Name: af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_espace_section_etapes_ressources_avancement_in(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7618 (class 0 OID 0)
-- Dependencies: 1843
-- Name: af_get_formation_espace_section_ressources(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_espace_section_ressources(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_espace_section_ressources(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_section_ressources(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_section_ressources(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_espace_section_ressources(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7620 (class 0 OID 0)
-- Dependencies: 1043
-- Name: af_get_formation_espace_section_ressources_no_date(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_espace_section_ressources_no_date(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_espace_section_ressources_no_date(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_section_ressources_no_date(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_espace_section_ressources_no_date(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_espace_section_ressources_no_date(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7622 (class 0 OID 0)
-- Dependencies: 1044
-- Name: af_get_formation_espace_sections(integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_formation_espace_sections(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_espace_sections(integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_formation_espace_sections(integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_formation_espace_sections(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_espace_sections(integer, integer) TO "grp-www";


--
-- TOC entry 7623 (class 0 OID 0)
-- Dependencies: 1045
-- Name: af_get_formation_etape_individu_encadrants(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_etape_individu_encadrants(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_etape_individu_encadrants(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_etape_individu_encadrants(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_etape_individu_encadrants(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_etape_individu_encadrants(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7624 (class 0 OID 0)
-- Dependencies: 1046
-- Name: af_get_formation_etapes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_etapes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_etapes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_etapes(integer) TO "grp-www";


--
-- TOC entry 7626 (class 0 OID 0)
-- Dependencies: 1047
-- Name: af_get_formation_etapes_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_etapes_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_etapes_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_etapes_individu(integer, integer) TO "grp-www";


--
-- TOC entry 7628 (class 0 OID 0)
-- Dependencies: 1048
-- Name: af_get_formation_etapes_reelles_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_etapes_reelles_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_etapes_reelles_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_reelles_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_reelles_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_etapes_reelles_individu(integer, integer) TO "grp-www";


--
-- TOC entry 7630 (class 0 OID 0)
-- Dependencies: 1049
-- Name: af_get_formation_etapes_ressources_avancement_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_etapes_ressources_avancement_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_etapes_ressources_avancement_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_ressources_avancement_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_ressources_avancement_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_etapes_ressources_avancement_individu(integer, integer) TO "grp-www";


--
-- TOC entry 7632 (class 0 OID 0)
-- Dependencies: 1050
-- Name: af_get_formation_etapes_series(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_etapes_series(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_etapes_series(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_series(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_series(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_etapes_series(integer) TO "grp-www";


--
-- TOC entry 7634 (class 0 OID 0)
-- Dependencies: 1051
-- Name: af_get_formation_etapes_type(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_etapes_type(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_etapes_type(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_type(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_etapes_type(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_etapes_type(integer, character varying) TO "grp-www";


--
-- TOC entry 7636 (class 0 OID 0)
-- Dependencies: 1052
-- Name: af_get_formation_evenement(integer, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_evenement(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_evenement(integer, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_evenement(integer, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_evenement(integer, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_evenement(integer, timestamp without time zone) TO "grp-www";


--
-- TOC entry 7638 (class 0 OID 0)
-- Dependencies: 1053
-- Name: af_get_formation_evenements(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_evenements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_evenements(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_evenements(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_evenements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_evenements(integer) TO "grp-www";


--
-- TOC entry 7640 (class 0 OID 0)
-- Dependencies: 1054
-- Name: af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_evenements_periode(integer, timestamp without time zone, timestamp without time zone) TO "grp-www";


--
-- TOC entry 7642 (class 0 OID 0)
-- Dependencies: 1055
-- Name: af_get_formation_evenements_presentiels(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_evenements_presentiels(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_evenements_presentiels(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_evenements_presentiels(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_evenements_presentiels(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_evenements_presentiels(integer) TO "grp-www";


--
-- TOC entry 7644 (class 0 OID 0)
-- Dependencies: 20
-- Name: af_get_formation_evolution_reelle_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_evolution_reelle_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_evolution_reelle_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_evolution_reelle_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_evolution_reelle_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_evolution_reelle_individu(integer, integer) TO "grp-www";


--
-- TOC entry 7646 (class 0 OID 0)
-- Dependencies: 1844
-- Name: af_get_formation_exostlc_fichier_rendu(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_exostlc_fichier_rendu(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_exostlc_fichier_rendu(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_exostlc_fichier_rendu(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_exostlc_fichier_rendu(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_exostlc_fichier_rendu(integer) TO "grp-www";


--
-- TOC entry 7647 (class 0 OID 0)
-- Dependencies: 1056
-- Name: af_get_formation_formateur(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_formateur(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_formateur(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_formateur(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_formateur(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_formateur(integer) TO "grp-www";


--
-- TOC entry 7649 (class 0 OID 0)
-- Dependencies: 1057
-- Name: af_get_formation_forums(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_forums(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_forums(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_forums(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_forums(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_forums(integer) TO "grp-www";


--
-- TOC entry 7651 (class 0 OID 0)
-- Dependencies: 1058
-- Name: af_get_formation_forums_disponibles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_forums_disponibles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_forums_disponibles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_forums_disponibles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_forums_disponibles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_forums_disponibles(integer) TO "grp-www";


--
-- TOC entry 7653 (class 0 OID 0)
-- Dependencies: 1059
-- Name: af_get_formation_grilles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_grilles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_grilles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_grilles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_grilles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_grilles(integer) TO "grp-www";


--
-- TOC entry 7655 (class 0 OID 0)
-- Dependencies: 1060
-- Name: af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_individu_parcours_exotlcs_score(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7657 (class 0 OID 0)
-- Dependencies: 1061
-- Name: af_get_formation_individu_parcours_score(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_individu_parcours_score(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_individu_parcours_score(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_individu_parcours_score(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_individu_parcours_score(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_individu_parcours_score(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7659 (class 0 OID 0)
-- Dependencies: 1062
-- Name: af_get_formation_individu_parcours_series_score(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_individu_parcours_series_score(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_individu_parcours_series_score(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_individu_parcours_series_score(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_individu_parcours_series_score(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_individu_parcours_series_score(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7661 (class 0 OID 0)
-- Dependencies: 1063
-- Name: af_get_formation_individus(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_individus(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_individus(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_individus(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_individus(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_individus(integer) TO "grp-www";


--
-- TOC entry 7662 (class 0 OID 0)
-- Dependencies: 1064
-- Name: af_get_formation_individus(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_individus(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_individus(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_individus(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_individus(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_individus(integer, integer) TO "grp-www";


--
-- TOC entry 7664 (class 0 OID 0)
-- Dependencies: 1065
-- Name: af_get_formation_individus_except_individus_types(integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_individus_except_individus_types(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_individus_except_individus_types(integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_individus_except_individus_types(integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_individus_except_individus_types(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_individus_except_individus_types(integer, integer[]) TO "grp-www";


--
-- TOC entry 7666 (class 0 OID 0)
-- Dependencies: 1066
-- Name: af_get_formation_intervenants(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_intervenants(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_intervenants(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_intervenants(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_intervenants(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_intervenants(integer) TO "grp-www";


--
-- TOC entry 7667 (class 0 OID 0)
-- Dependencies: 1067
-- Name: af_get_formation_langues(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_langues(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_langues(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_langues(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_langues(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_langues(integer) TO "grp-www";


--
-- TOC entry 7669 (class 0 OID 0)
-- Dependencies: 1068
-- Name: af_get_formation_parcourss_ressources(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_parcourss_ressources(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_parcourss_ressources(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_parcourss_ressources(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_parcourss_ressources(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_parcourss_ressources(integer) TO "grp-www";


--
-- TOC entry 7670 (class 0 OID 0)
-- Dependencies: 1845
-- Name: af_get_formation_participants(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_participants(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_participants(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_participants(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_participants(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_participants(integer) TO "grp-www";


--
-- TOC entry 7672 (class 0 OID 0)
-- Dependencies: 1069
-- Name: af_get_formation_ressource(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_ressource(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_ressource(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressource(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressource(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_ressource(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7674 (class 0 OID 0)
-- Dependencies: 1070
-- Name: af_get_formation_ressource_nouveaute(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_ressource_nouveaute(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_ressource_nouveaute(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressource_nouveaute(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressource_nouveaute(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_ressource_nouveaute(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7675 (class 0 OID 0)
-- Dependencies: 1071
-- Name: af_get_formation_ressources(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_ressources(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_ressources(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressources(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressources(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_ressources(integer) TO "grp-www";


--
-- TOC entry 7676 (class 0 OID 0)
-- Dependencies: 1846
-- Name: af_get_formation_ressources(integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_ressources(integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_ressources(integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressources(integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressources(integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_ressources(integer, boolean) TO "grp-www";


--
-- TOC entry 7678 (class 0 OID 0)
-- Dependencies: 1072
-- Name: af_get_formation_ressources_nouveaute(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_ressources_nouveaute(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_ressources_nouveaute(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressources_nouveaute(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_ressources_nouveaute(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_ressources_nouveaute(integer) TO "grp-www";


--
-- TOC entry 7680 (class 0 OID 0)
-- Dependencies: 1073
-- Name: af_get_formation_salles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_salles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_salles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_salles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_salles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_salles(integer) TO "grp-www";


--
-- TOC entry 7681 (class 0 OID 0)
-- Dependencies: 1074
-- Name: af_get_formation_sections(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_sections(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_sections(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_sections(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_sections(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_sections(integer) TO "grp-www";


--
-- TOC entry 7683 (class 0 OID 0)
-- Dependencies: 1075
-- Name: af_get_formation_session(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_session(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_session(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_session(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_session(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_session(integer) TO "grp-www";


--
-- TOC entry 7685 (class 0 OID 0)
-- Dependencies: 1076
-- Name: af_get_formation_stagiaires_correction(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formation_stagiaires_correction(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formation_stagiaires_correction(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formation_stagiaires_correction(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formation_stagiaires_correction(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formation_stagiaires_correction(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7687 (class 0 OID 0)
-- Dependencies: 1077
-- Name: af_get_formations(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formations() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formations() FROM pgsql;
GRANT ALL ON FUNCTION af_get_formations() TO pgsql;
GRANT ALL ON FUNCTION af_get_formations() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formations() TO "grp-www";


--
-- TOC entry 7689 (class 0 OID 0)
-- Dependencies: 1078
-- Name: af_get_formations(character varying, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formations(character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formations(character varying, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formations(character varying, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formations(character varying, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formations(character varying, character varying, integer) TO "grp-www";


--
-- TOC entry 7691 (class 0 OID 0)
-- Dependencies: 1079
-- Name: af_get_formations_classes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formations_classes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formations_classes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_formations_classes() TO pgsql;
GRANT ALL ON FUNCTION af_get_formations_classes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formations_classes() TO "grp-www";


--
-- TOC entry 7693 (class 0 OID 0)
-- Dependencies: 1080
-- Name: af_get_formations_dates(date, date, boolean, boolean, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formations_dates(date, date, boolean, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formations_dates(date, date, boolean, boolean, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formations_dates(date, date, boolean, boolean, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_formations_dates(date, date, boolean, boolean, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formations_dates(date, date, boolean, boolean, boolean) TO "grp-www";


--
-- TOC entry 7694 (class 0 OID 0)
-- Dependencies: 1847
-- Name: af_get_formations_dates_bornes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formations_dates_bornes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formations_dates_bornes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_formations_dates_bornes() TO pgsql;
GRANT ALL ON FUNCTION af_get_formations_dates_bornes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formations_dates_bornes() TO "grp-www";


--
-- TOC entry 7696 (class 0 OID 0)
-- Dependencies: 1848
-- Name: af_get_formations_exotlcs_corriges(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formations_exotlcs_corriges() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formations_exotlcs_corriges() FROM pgsql;
GRANT ALL ON FUNCTION af_get_formations_exotlcs_corriges() TO pgsql;
GRANT ALL ON FUNCTION af_get_formations_exotlcs_corriges() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formations_exotlcs_corriges() TO "grp-www";


--
-- TOC entry 7698 (class 0 OID 0)
-- Dependencies: 1081
-- Name: af_get_formations_fichier_rendu(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formations_fichier_rendu() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formations_fichier_rendu() FROM pgsql;
GRANT ALL ON FUNCTION af_get_formations_fichier_rendu() TO pgsql;
GRANT ALL ON FUNCTION af_get_formations_fichier_rendu() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formations_fichier_rendu() TO "grp-www";


--
-- TOC entry 7700 (class 0 OID 0)
-- Dependencies: 1082
-- Name: af_get_formations_forums(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formations_forums(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formations_forums(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_formations_forums(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_formations_forums(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formations_forums(integer) TO "grp-www";


--
-- TOC entry 7702 (class 0 OID 0)
-- Dependencies: 1083
-- Name: af_get_formations_presentielles(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_formations_presentielles() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_formations_presentielles() FROM pgsql;
GRANT ALL ON FUNCTION af_get_formations_presentielles() TO pgsql;
GRANT ALL ON FUNCTION af_get_formations_presentielles() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_formations_presentielles() TO "grp-www";


--
-- TOC entry 7704 (class 0 OID 0)
-- Dependencies: 1084
-- Name: af_get_forum(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_forum(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_forum(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_forum(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_forum(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_forum(integer) TO "grp-www";


--
-- TOC entry 7705 (class 0 OID 0)
-- Dependencies: 21
-- Name: af_get_forum_environnement(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_forum_environnement(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_forum_environnement(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_forum_environnement(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_forum_environnement(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_forum_environnement(integer) TO "grp-www";


--
-- TOC entry 7707 (class 0 OID 0)
-- Dependencies: 1085
-- Name: af_get_forum_environnements(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_forum_environnements() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_forum_environnements() FROM pgsql;
GRANT ALL ON FUNCTION af_get_forum_environnements() TO pgsql;
GRANT ALL ON FUNCTION af_get_forum_environnements() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_forum_environnements() TO "grp-www";


--
-- TOC entry 7709 (class 0 OID 0)
-- Dependencies: 1086
-- Name: af_get_forum_forum_environnement(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_forum_forum_environnement(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_forum_forum_environnement(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_forum_forum_environnement(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_forum_forum_environnement(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_forum_forum_environnement(integer) TO "grp-www";


--
-- TOC entry 7711 (class 0 OID 0)
-- Dependencies: 1087
-- Name: af_get_forums(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_forums() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_forums() FROM pgsql;
GRANT ALL ON FUNCTION af_get_forums() TO pgsql;
GRANT ALL ON FUNCTION af_get_forums() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_forums() TO "grp-www";


--
-- TOC entry 7713 (class 0 OID 0)
-- Dependencies: 1088
-- Name: af_get_ftb(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_ftb(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_ftb(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_ftb(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_ftb(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_ftb(integer) TO "grp-www";


--
-- TOC entry 7715 (class 0 OID 0)
-- Dependencies: 1849
-- Name: af_get_ftb_liste_mot(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_ftb_liste_mot(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_ftb_liste_mot(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_ftb_liste_mot(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_ftb_liste_mot(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_ftb_liste_mot(integer, integer) TO "grp-www";


--
-- TOC entry 7717 (class 0 OID 0)
-- Dependencies: 22
-- Name: af_get_glossaire(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_glossaire(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_glossaire(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_glossaire(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_glossaire(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_glossaire(integer) TO "grp-www";


--
-- TOC entry 7719 (class 0 OID 0)
-- Dependencies: 1089
-- Name: af_get_glossaire_fichier(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_glossaire_fichier(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_glossaire_fichier(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_glossaire_fichier(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_glossaire_fichier(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_glossaire_fichier(integer) TO "grp-www";


--
-- TOC entry 7721 (class 0 OID 0)
-- Dependencies: 23
-- Name: af_get_glossaire_fichiers(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_glossaire_fichiers(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_glossaire_fichiers(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_glossaire_fichiers(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_glossaire_fichiers(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_glossaire_fichiers(integer) TO "grp-www";


--
-- TOC entry 7723 (class 0 OID 0)
-- Dependencies: 1850
-- Name: af_get_grille(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_grille(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_grille(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_grille(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_grille(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_grille(integer) TO "grp-www";


--
-- TOC entry 7725 (class 0 OID 0)
-- Dependencies: 1090
-- Name: af_get_grille_capacite_titre_themes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_grille_capacite_titre_themes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_grille_capacite_titre_themes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_grille_capacite_titre_themes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_grille_capacite_titre_themes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_grille_capacite_titre_themes(integer) TO "grp-www";


--
-- TOC entry 7727 (class 0 OID 0)
-- Dependencies: 1091
-- Name: af_get_grille_capacites_titres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_grille_capacites_titres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_grille_capacites_titres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_grille_capacites_titres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_grille_capacites_titres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_grille_capacites_titres(integer) TO "grp-www";


--
-- TOC entry 7729 (class 0 OID 0)
-- Dependencies: 1092
-- Name: af_get_grille_capacites_titres_disponibles(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_grille_capacites_titres_disponibles(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_grille_capacites_titres_disponibles(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_grille_capacites_titres_disponibles(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_grille_capacites_titres_disponibles(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_grille_capacites_titres_disponibles(integer, integer) TO "grp-www";


--
-- TOC entry 7731 (class 0 OID 0)
-- Dependencies: 1093
-- Name: af_get_grille_stagiaires_formation(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_grille_stagiaires_formation(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_grille_stagiaires_formation(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_grille_stagiaires_formation(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_grille_stagiaires_formation(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_grille_stagiaires_formation(integer, integer) TO "grp-www";


--
-- TOC entry 7733 (class 0 OID 0)
-- Dependencies: 1094
-- Name: af_get_icones(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_icones() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_icones() FROM pgsql;
GRANT ALL ON FUNCTION af_get_icones() TO pgsql;
GRANT ALL ON FUNCTION af_get_icones() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_icones() TO "grp-www";


--
-- TOC entry 7735 (class 0 OID 0)
-- Dependencies: 1095
-- Name: af_get_individu(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu(integer) TO "grp-www";


--
-- TOC entry 7736 (class 0 OID 0)
-- Dependencies: 1096
-- Name: af_get_individu(character varying, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu(character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu(character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu(character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu(character varying, character varying) TO "grp-www";


--
-- TOC entry 7738 (class 0 OID 0)
-- Dependencies: 1097
-- Name: af_get_individu_classes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_classes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_classes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_classes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_classes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_classes(integer) TO "grp-www";


--
-- TOC entry 7740 (class 0 OID 0)
-- Dependencies: 1098
-- Name: af_get_individu_date_connexion_max(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_date_connexion_max(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_date_connexion_max(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_date_connexion_max(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_date_connexion_max(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_date_connexion_max(integer) TO "grp-www";


--
-- TOC entry 7742 (class 0 OID 0)
-- Dependencies: 1099
-- Name: af_get_individu_date_deconnexion_max(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_date_deconnexion_max(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_date_deconnexion_max(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_date_deconnexion_max(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_date_deconnexion_max(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_date_deconnexion_max(integer) TO "grp-www";


--
-- TOC entry 7744 (class 0 OID 0)
-- Dependencies: 1100
-- Name: af_get_individu_droits_classe(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_droits_classe(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_droits_classe(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_droits_classe(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_droits_classe(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_droits_classe(integer, integer) TO "grp-www";


--
-- TOC entry 7746 (class 0 OID 0)
-- Dependencies: 1101
-- Name: af_get_individu_filieres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_filieres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_filieres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_filieres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_filieres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_filieres(integer) TO "grp-www";


--
-- TOC entry 7748 (class 0 OID 0)
-- Dependencies: 1102
-- Name: af_get_individu_formations(integer, integer, character varying, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_formations(integer, integer, character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_formations(integer, integer, character varying, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_formations(integer, integer, character varying, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_formations(integer, integer, character varying, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_formations(integer, integer, character varying, character varying, integer) TO "grp-www";


--
-- TOC entry 7750 (class 0 OID 0)
-- Dependencies: 1103
-- Name: af_get_individu_formations(integer, character varying, character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_formations(integer, character varying, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_formations(integer, character varying, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_formations(integer, character varying, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_formations(integer, character varying, character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_formations(integer, character varying, character varying, integer, integer) TO "grp-www";


--
-- TOC entry 7752 (class 0 OID 0)
-- Dependencies: 1104
-- Name: af_get_individu_grille(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_grille(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_grille(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_grille(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_grille(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_grille(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7754 (class 0 OID 0)
-- Dependencies: 1105
-- Name: af_get_individu_last_deconnexion(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_last_deconnexion(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_last_deconnexion(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_last_deconnexion(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_last_deconnexion(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_last_deconnexion(integer) TO "grp-www";


--
-- TOC entry 7756 (class 0 OID 0)
-- Dependencies: 1106
-- Name: af_get_individu_nom_prenom(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_nom_prenom(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_nom_prenom(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_nom_prenom(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_nom_prenom(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_nom_prenom(integer) TO "grp-www";


--
-- TOC entry 7758 (class 0 OID 0)
-- Dependencies: 1107
-- Name: af_get_individu_themes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_themes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_themes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_themes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_themes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_themes(integer) TO "grp-www";


--
-- TOC entry 7760 (class 0 OID 0)
-- Dependencies: 1108
-- Name: af_get_individu_types(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_types(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_types(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_types(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_types(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_types(integer) TO "grp-www";


--
-- TOC entry 7762 (class 0 OID 0)
-- Dependencies: 1109
-- Name: af_get_individu_types(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individu_types() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individu_types() FROM pgsql;
GRANT ALL ON FUNCTION af_get_individu_types() TO pgsql;
GRANT ALL ON FUNCTION af_get_individu_types() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individu_types() TO "grp-www";


--
-- TOC entry 7764 (class 0 OID 0)
-- Dependencies: 1110
-- Name: af_get_individus(integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individus(integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individus(integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individus(integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_individus(integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individus(integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 7766 (class 0 OID 0)
-- Dependencies: 1111
-- Name: af_get_individus_exotlcs_corriges(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individus_exotlcs_corriges() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individus_exotlcs_corriges() FROM pgsql;
GRANT ALL ON FUNCTION af_get_individus_exotlcs_corriges() TO pgsql;
GRANT ALL ON FUNCTION af_get_individus_exotlcs_corriges() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individus_exotlcs_corriges() TO "grp-www";


--
-- TOC entry 7768 (class 0 OID 0)
-- Dependencies: 1112
-- Name: af_get_individus_infos(integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individus_infos(integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individus_infos(integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individus_infos(integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_individus_infos(integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individus_infos(integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 7770 (class 0 OID 0)
-- Dependencies: 1851
-- Name: af_get_individus_initiale(character varying, integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individus_initiale(character varying, integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individus_initiale(character varying, integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_individus_initiale(character varying, integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_individus_initiale(character varying, integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individus_initiale(character varying, integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 7772 (class 0 OID 0)
-- Dependencies: 1852
-- Name: af_get_individus_types(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_individus_types() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_individus_types() FROM pgsql;
GRANT ALL ON FUNCTION af_get_individus_types() TO pgsql;
GRANT ALL ON FUNCTION af_get_individus_types() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_individus_types() TO "grp-www";


--
-- TOC entry 7774 (class 0 OID 0)
-- Dependencies: 1113
-- Name: af_get_inscription(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_inscription(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_inscription(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_inscription(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_inscription(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_inscription(integer) TO "grp-www";


--
-- TOC entry 7776 (class 0 OID 0)
-- Dependencies: 1114
-- Name: af_get_inscriptions(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_inscriptions() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_inscriptions() FROM pgsql;
GRANT ALL ON FUNCTION af_get_inscriptions() TO pgsql;
GRANT ALL ON FUNCTION af_get_inscriptions() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_inscriptions() TO "grp-www";


--
-- TOC entry 7778 (class 0 OID 0)
-- Dependencies: 1115
-- Name: af_get_intervenant_evenements(integer, date); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_intervenant_evenements(integer, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_intervenant_evenements(integer, date) FROM pgsql;
GRANT ALL ON FUNCTION af_get_intervenant_evenements(integer, date) TO pgsql;
GRANT ALL ON FUNCTION af_get_intervenant_evenements(integer, date) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_intervenant_evenements(integer, date) TO "grp-www";


--
-- TOC entry 7780 (class 0 OID 0)
-- Dependencies: 1116
-- Name: af_get_intervenant_evenements_presentiels(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_intervenant_evenements_presentiels(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_intervenant_evenements_presentiels(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_intervenant_evenements_presentiels(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_intervenant_evenements_presentiels(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_intervenant_evenements_presentiels(integer, integer) TO "grp-www";


--
-- TOC entry 7782 (class 0 OID 0)
-- Dependencies: 1117
-- Name: af_get_intervenant_formations_grille(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_intervenant_formations_grille(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_intervenant_formations_grille(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_intervenant_formations_grille(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_intervenant_formations_grille(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_intervenant_formations_grille(integer) TO "grp-www";


--
-- TOC entry 7784 (class 0 OID 0)
-- Dependencies: 1118
-- Name: af_get_intervenant_formations_presentielles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_intervenant_formations_presentielles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_intervenant_formations_presentielles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_intervenant_formations_presentielles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_intervenant_formations_presentielles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_intervenant_formations_presentielles(integer) TO "grp-www";


--
-- TOC entry 7786 (class 0 OID 0)
-- Dependencies: 1119
-- Name: af_get_intervenants(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_intervenants(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_intervenants(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_intervenants(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_intervenants(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_intervenants(integer) TO "grp-www";


--
-- TOC entry 7788 (class 0 OID 0)
-- Dependencies: 1120
-- Name: af_get_intervenants_presentiel_grille(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_intervenants_presentiel_grille(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_intervenants_presentiel_grille(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_intervenants_presentiel_grille(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_intervenants_presentiel_grille(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_intervenants_presentiel_grille(integer) TO "grp-www";


--
-- TOC entry 7790 (class 0 OID 0)
-- Dependencies: 1121
-- Name: af_get_intervention(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_intervention(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_intervention(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_intervention(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_intervention(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_intervention(integer) TO "grp-www";


--
-- TOC entry 7792 (class 0 OID 0)
-- Dependencies: 1122
-- Name: af_get_interventions(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_interventions() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_interventions() FROM pgsql;
GRANT ALL ON FUNCTION af_get_interventions() TO pgsql;
GRANT ALL ON FUNCTION af_get_interventions() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_interventions() TO "grp-www";


--
-- TOC entry 7794 (class 0 OID 0)
-- Dependencies: 1123
-- Name: af_get_langue(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langue(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langue(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_langue(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_langue(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langue(integer) TO "grp-www";


--
-- TOC entry 7796 (class 0 OID 0)
-- Dependencies: 1124
-- Name: af_get_langue(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langue(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langue(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_langue(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_langue(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langue(character varying) TO "grp-www";


--
-- TOC entry 7798 (class 0 OID 0)
-- Dependencies: 1125
-- Name: af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langue_libelles(integer[], integer, integer, character varying, integer, integer, character varying) TO "grp-www";


--
-- TOC entry 7800 (class 0 OID 0)
-- Dependencies: 1853
-- Name: af_get_langue_message_libelle(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langue_message_libelle(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langue_message_libelle(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_langue_message_libelle(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_langue_message_libelle(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langue_message_libelle(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7802 (class 0 OID 0)
-- Dependencies: 1126
-- Name: af_get_langue_messages(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langue_messages(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langue_messages(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_langue_messages(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_langue_messages(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langue_messages(integer) TO "grp-www";


--
-- TOC entry 7804 (class 0 OID 0)
-- Dependencies: 1127
-- Name: af_get_langue_messages_type(integer, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langue_messages_type(integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langue_messages_type(integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_langue_messages_type(integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_langue_messages_type(integer, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langue_messages_type(integer, integer, character varying) TO "grp-www";


--
-- TOC entry 7806 (class 0 OID 0)
-- Dependencies: 24
-- Name: af_get_langue_type(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langue_type(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langue_type(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_langue_type(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_langue_type(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langue_type(integer) TO "grp-www";


--
-- TOC entry 7808 (class 0 OID 0)
-- Dependencies: 1128
-- Name: af_get_langue_types(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langue_types() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langue_types() FROM pgsql;
GRANT ALL ON FUNCTION af_get_langue_types() TO pgsql;
GRANT ALL ON FUNCTION af_get_langue_types() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langue_types() TO "grp-www";


--
-- TOC entry 7810 (class 0 OID 0)
-- Dependencies: 1129
-- Name: af_get_langues(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langues() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langues() FROM pgsql;
GRANT ALL ON FUNCTION af_get_langues() TO pgsql;
GRANT ALL ON FUNCTION af_get_langues() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langues() TO "grp-www";


--
-- TOC entry 7812 (class 0 OID 0)
-- Dependencies: 1130
-- Name: af_get_langues_messages_type(integer[], integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_langues_messages_type(integer[], integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_langues_messages_type(integer[], integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_langues_messages_type(integer[], integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_langues_messages_type(integer[], integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_langues_messages_type(integer[], integer) TO "grp-www";


--
-- TOC entry 7813 (class 0 OID 0)
-- Dependencies: 1131
-- Name: af_get_liste(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_liste(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_liste(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_liste(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_liste(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_liste(integer) TO "grp-www";


--
-- TOC entry 7815 (class 0 OID 0)
-- Dependencies: 1132
-- Name: af_get_liste_themes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_liste_themes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_liste_themes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_liste_themes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_liste_themes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_liste_themes(integer) TO "grp-www";


--
-- TOC entry 7817 (class 0 OID 0)
-- Dependencies: 1133
-- Name: af_get_medias(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_medias() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_medias() FROM postgres;
GRANT ALL ON FUNCTION af_get_medias() TO postgres;
GRANT ALL ON FUNCTION af_get_medias() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_medias() TO "grp-www";


--
-- TOC entry 7819 (class 0 OID 0)
-- Dependencies: 1134
-- Name: af_get_medias_scenarios_theme(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_medias_scenarios_theme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_medias_scenarios_theme(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_medias_scenarios_theme(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_medias_scenarios_theme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_medias_scenarios_theme(integer) TO "grp-www";


--
-- TOC entry 7821 (class 0 OID 0)
-- Dependencies: 1135
-- Name: af_get_medias_scenarios_themes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_medias_scenarios_themes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_medias_scenarios_themes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_medias_scenarios_themes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_medias_scenarios_themes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_medias_scenarios_themes(integer) TO "grp-www";


--
-- TOC entry 7823 (class 0 OID 0)
-- Dependencies: 1136
-- Name: af_get_medias_scenarios_themes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_medias_scenarios_themes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_medias_scenarios_themes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_medias_scenarios_themes() TO pgsql;
GRANT ALL ON FUNCTION af_get_medias_scenarios_themes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_medias_scenarios_themes() TO "grp-www";


--
-- TOC entry 7825 (class 0 OID 0)
-- Dependencies: 1137
-- Name: af_get_modalite(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_modalite(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_modalite(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_modalite(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_modalite(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_modalite(integer) TO "grp-www";


--
-- TOC entry 7827 (class 0 OID 0)
-- Dependencies: 1138
-- Name: af_get_modalites(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_modalites() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_modalites() FROM pgsql;
GRANT ALL ON FUNCTION af_get_modalites() TO pgsql;
GRANT ALL ON FUNCTION af_get_modalites() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_modalites() TO "grp-www";


--
-- TOC entry 7829 (class 0 OID 0)
-- Dependencies: 1854
-- Name: af_get_modele_correction_criteres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_modele_correction_criteres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_modele_correction_criteres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_modele_correction_criteres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_modele_correction_criteres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_modele_correction_criteres(integer) TO "grp-www";


--
-- TOC entry 7831 (class 0 OID 0)
-- Dependencies: 1139
-- Name: af_get_modeles_correction(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_modeles_correction() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_modeles_correction() FROM pgsql;
GRANT ALL ON FUNCTION af_get_modeles_correction() TO pgsql;
GRANT ALL ON FUNCTION af_get_modeles_correction() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_modeles_correction() TO "grp-www";


--
-- TOC entry 7833 (class 0 OID 0)
-- Dependencies: 1140
-- Name: af_get_organisme(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_organisme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_organisme(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_organisme(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_organisme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_organisme(integer) TO "grp-www";


--
-- TOC entry 7835 (class 0 OID 0)
-- Dependencies: 1141
-- Name: af_get_organisme_individus(integer, character varying, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_organisme_individus(integer, character varying, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_organisme_individus(integer, character varying, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_organisme_individus(integer, character varying, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_organisme_individus(integer, character varying, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_organisme_individus(integer, character varying, integer, boolean) TO "grp-www";


--
-- TOC entry 7837 (class 0 OID 0)
-- Dependencies: 1855
-- Name: af_get_organismes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_organismes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_organismes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_organismes() TO pgsql;
GRANT ALL ON FUNCTION af_get_organismes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_organismes() TO "grp-www";


--
-- TOC entry 7839 (class 0 OID 0)
-- Dependencies: 1142
-- Name: af_get_organismes_non_vide(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_organismes_non_vide() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_organismes_non_vide() FROM pgsql;
GRANT ALL ON FUNCTION af_get_organismes_non_vide() TO pgsql;
GRANT ALL ON FUNCTION af_get_organismes_non_vide() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_organismes_non_vide() TO "grp-www";


--
-- TOC entry 7841 (class 0 OID 0)
-- Dependencies: 1143
-- Name: af_get_page_annuaire_configuration(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_page_annuaire_configuration(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_page_annuaire_configuration(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_page_annuaire_configuration(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_page_annuaire_configuration(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_page_annuaire_configuration(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7843 (class 0 OID 0)
-- Dependencies: 1144
-- Name: af_get_page_commentaire(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_page_commentaire(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_page_commentaire(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_page_commentaire(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_page_commentaire(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_page_commentaire(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7845 (class 0 OID 0)
-- Dependencies: 1145
-- Name: af_get_page_elements(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_page_elements() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_page_elements() FROM pgsql;
GRANT ALL ON FUNCTION af_get_page_elements() TO pgsql;
GRANT ALL ON FUNCTION af_get_page_elements() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_page_elements() TO "grp-www";


--
-- TOC entry 7847 (class 0 OID 0)
-- Dependencies: 1146
-- Name: af_get_page_elements(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_page_elements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_page_elements(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_page_elements(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_page_elements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_page_elements(integer) TO "grp-www";


--
-- TOC entry 7849 (class 0 OID 0)
-- Dependencies: 1147
-- Name: af_get_page_liste(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_page_liste(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_page_liste(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_page_liste(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_page_liste(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_page_liste(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7851 (class 0 OID 0)
-- Dependencies: 1148
-- Name: af_get_page_liste_configuration(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_page_liste_configuration(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_page_liste_configuration(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_page_liste_configuration(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_page_liste_configuration(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_page_liste_configuration(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7853 (class 0 OID 0)
-- Dependencies: 1149
-- Name: af_get_page_ressource_configuration(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_page_ressource_configuration(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_page_ressource_configuration(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_page_ressource_configuration(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_page_ressource_configuration(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_page_ressource_configuration(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7855 (class 0 OID 0)
-- Dependencies: 1150
-- Name: af_get_page_type_pages(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_page_type_pages(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_page_type_pages(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_page_type_pages(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_page_type_pages(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_page_type_pages(integer) TO "grp-www";


--
-- TOC entry 7857 (class 0 OID 0)
-- Dependencies: 1151
-- Name: af_get_pages_types(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_pages_types() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_pages_types() FROM pgsql;
GRANT ALL ON FUNCTION af_get_pages_types() TO pgsql;
GRANT ALL ON FUNCTION af_get_pages_types() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_pages_types() TO "grp-www";


--
-- TOC entry 7858 (class 0 OID 0)
-- Dependencies: 1152
-- Name: af_get_parcours(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours() FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours() TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours() TO "grp-www";


--
-- TOC entry 7859 (class 0 OID 0)
-- Dependencies: 1153
-- Name: af_get_parcours(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours(integer) TO "grp-www";


--
-- TOC entry 7861 (class 0 OID 0)
-- Dependencies: 1856
-- Name: af_get_parcours_all_formations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_all_formations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_all_formations(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_all_formations(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_all_formations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_all_formations(integer) TO "grp-www";


--
-- TOC entry 7862 (class 0 OID 0)
-- Dependencies: 1154
-- Name: af_get_parcours_avancement(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_avancement(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_avancement(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_avancement(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_avancement(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_avancement(integer) TO "grp-www";


--
-- TOC entry 7863 (class 0 OID 0)
-- Dependencies: 1155
-- Name: af_get_parcours_avancement_max(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_avancement_max(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_avancement_max(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_avancement_max(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_avancement_max(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_avancement_max(integer) TO "grp-www";


--
-- TOC entry 7865 (class 0 OID 0)
-- Dependencies: 1156
-- Name: af_get_parcours_chats_disponibles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_chats_disponibles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_chats_disponibles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_chats_disponibles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_chats_disponibles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_chats_disponibles(integer) TO "grp-www";


--
-- TOC entry 7866 (class 0 OID 0)
-- Dependencies: 1157
-- Name: af_get_parcours_etape(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etape(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etape(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etape(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etape(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etape(integer, integer) TO "grp-www";


--
-- TOC entry 7867 (class 0 OID 0)
-- Dependencies: 1158
-- Name: af_get_parcours_etape_fille(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etape_fille(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etape_fille(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etape_fille(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etape_fille(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etape_fille(integer, integer) TO "grp-www";


--
-- TOC entry 7868 (class 0 OID 0)
-- Dependencies: 1159
-- Name: af_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etape_parcours_oriente_parcourss_disponibles(integer) TO "grp-www";


--
-- TOC entry 7869 (class 0 OID 0)
-- Dependencies: 1160
-- Name: af_get_parcours_etape_resultats(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etape_resultats(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etape_resultats(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etape_resultats(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etape_resultats(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etape_resultats(integer, integer) TO "grp-www";


--
-- TOC entry 7870 (class 0 OID 0)
-- Dependencies: 1161
-- Name: af_get_parcours_etapes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etapes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etapes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etapes(integer) TO "grp-www";


--
-- TOC entry 7871 (class 0 OID 0)
-- Dependencies: 1162
-- Name: af_get_parcours_etapes_deroulees(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etapes_deroulees(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etapes_deroulees(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_deroulees(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_deroulees(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etapes_deroulees(integer) TO "grp-www";


--
-- TOC entry 7873 (class 0 OID 0)
-- Dependencies: 1857
-- Name: af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etapes_deroulees_formation_individu(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7874 (class 0 OID 0)
-- Dependencies: 1163
-- Name: af_get_parcours_etapes_disponibles_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etapes_disponibles_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etapes_disponibles_theme(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_disponibles_theme(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_disponibles_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etapes_disponibles_theme(integer, integer) TO "grp-www";


--
-- TOC entry 7875 (class 0 OID 0)
-- Dependencies: 1858
-- Name: af_get_parcours_etapes_duree_type(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etapes_duree_type(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etapes_duree_type(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_duree_type(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_duree_type(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etapes_duree_type(integer, character varying) TO "grp-www";


--
-- TOC entry 7876 (class 0 OID 0)
-- Dependencies: 1164
-- Name: af_get_parcours_etapes_durees_type(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etapes_durees_type(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etapes_durees_type(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_durees_type(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_durees_type(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etapes_durees_type(integer, character varying) TO "grp-www";


--
-- TOC entry 7877 (class 0 OID 0)
-- Dependencies: 1165
-- Name: af_get_parcours_etapes_durees_type_distincts(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etapes_durees_type_distincts(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etapes_durees_type_distincts(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_durees_type_distincts(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_durees_type_distincts(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etapes_durees_type_distincts(integer, character varying) TO "grp-www";


--
-- TOC entry 7878 (class 0 OID 0)
-- Dependencies: 1166
-- Name: af_get_parcours_etapes_durees_valuees(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etapes_durees_valuees(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etapes_durees_valuees(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_durees_valuees(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_durees_valuees(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etapes_durees_valuees(integer) TO "grp-www";


--
-- TOC entry 7879 (class 0 OID 0)
-- Dependencies: 1167
-- Name: af_get_parcours_etapes_type(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_etapes_type(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_etapes_type(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_type(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_etapes_type(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_etapes_type(integer, character varying) TO "grp-www";


--
-- TOC entry 7881 (class 0 OID 0)
-- Dependencies: 1168
-- Name: af_get_parcours_formations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_formations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_formations(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_formations(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_formations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_formations(integer) TO "grp-www";


--
-- TOC entry 7883 (class 0 OID 0)
-- Dependencies: 1169
-- Name: af_get_parcours_forums_disponibles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_forums_disponibles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_forums_disponibles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_forums_disponibles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_forums_disponibles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_forums_disponibles(integer) TO "grp-www";


--
-- TOC entry 7884 (class 0 OID 0)
-- Dependencies: 1170
-- Name: af_get_parcours_mode_affichage(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_mode_affichage(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_mode_affichage(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_mode_affichage(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_mode_affichage(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_mode_affichage(integer) TO "grp-www";


--
-- TOC entry 7885 (class 0 OID 0)
-- Dependencies: 1171
-- Name: af_get_parcours_oriente_configuration(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_oriente_configuration(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_oriente_configuration(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_oriente_configuration(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_oriente_configuration(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_oriente_configuration(integer) TO "grp-www";


--
-- TOC entry 7886 (class 0 OID 0)
-- Dependencies: 1172
-- Name: af_get_parcours_oriente_sous_parcours(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_oriente_sous_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_oriente_sous_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_oriente_sous_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_oriente_sous_parcours(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_oriente_sous_parcours(integer) TO "grp-www";


--
-- TOC entry 7887 (class 0 OID 0)
-- Dependencies: 1173
-- Name: af_get_parcours_orientes_sous_parcours(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_orientes_sous_parcours() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_orientes_sous_parcours() FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_orientes_sous_parcours() TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_orientes_sous_parcours() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_orientes_sous_parcours() TO "grp-www";


--
-- TOC entry 7888 (class 0 OID 0)
-- Dependencies: 1174
-- Name: af_get_parcours_parcours_pere(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_parcours_pere(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_parcours_pere(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_parcours_pere(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_parcours_pere(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_parcours_pere(integer) TO "grp-www";


--
-- TOC entry 7889 (class 0 OID 0)
-- Dependencies: 1175
-- Name: af_get_parcours_ressources(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_ressources(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_ressources(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_ressources(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_ressources(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_ressources(integer) TO "grp-www";


--
-- TOC entry 7890 (class 0 OID 0)
-- Dependencies: 1176
-- Name: af_get_parcours_sous_parcourss_disponibles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_sous_parcourss_disponibles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_sous_parcourss_disponibles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_sous_parcourss_disponibles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_sous_parcourss_disponibles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_sous_parcourss_disponibles(integer) TO "grp-www";


--
-- TOC entry 7891 (class 0 OID 0)
-- Dependencies: 1177
-- Name: af_get_parcours_type_etape_personnalise(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_type_etape_personnalise(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_type_etape_personnalise(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_type_etape_personnalise(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_type_etape_personnalise(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_type_etape_personnalise(integer, character varying) TO "grp-www";


--
-- TOC entry 7892 (class 0 OID 0)
-- Dependencies: 1178
-- Name: af_get_parcours_types_etapes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_types_etapes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_types_etapes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_types_etapes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_types_etapes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_types_etapes(integer) TO "grp-www";


--
-- TOC entry 7893 (class 0 OID 0)
-- Dependencies: 1179
-- Name: af_get_parcours_types_etapes_personnalises(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcours_types_etapes_personnalises(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcours_types_etapes_personnalises(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcours_types_etapes_personnalises(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_parcours_types_etapes_personnalises(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcours_types_etapes_personnalises(integer) TO "grp-www";


--
-- TOC entry 7895 (class 0 OID 0)
-- Dependencies: 1180
-- Name: af_get_parcourss_orientes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_parcourss_orientes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_parcourss_orientes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_parcourss_orientes() TO pgsql;
GRANT ALL ON FUNCTION af_get_parcourss_orientes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_parcourss_orientes() TO "grp-www";


--
-- TOC entry 7896 (class 0 OID 0)
-- Dependencies: 1181
-- Name: af_get_positionnement(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement(integer) TO "grp-www";


--
-- TOC entry 7897 (class 0 OID 0)
-- Dependencies: 1182
-- Name: af_get_positionnement_choix(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_choix(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_choix(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_choix(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_choix(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_choix(integer) TO "grp-www";


--
-- TOC entry 7898 (class 0 OID 0)
-- Dependencies: 1183
-- Name: af_get_positionnement_choix_infos(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_choix_infos(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_choix_infos(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_choix_infos(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_choix_infos(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_choix_infos(integer) TO "grp-www";


--
-- TOC entry 7899 (class 0 OID 0)
-- Dependencies: 1184
-- Name: af_get_positionnement_choix_infos(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_choix_infos(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_choix_infos(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_choix_infos(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_choix_infos(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_choix_infos(integer, integer) TO "grp-www";


--
-- TOC entry 7900 (class 0 OID 0)
-- Dependencies: 1859
-- Name: af_get_positionnement_count_evaluations_a_associer(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_count_evaluations_a_associer(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_count_evaluations_a_associer(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_count_evaluations_a_associer(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_count_evaluations_a_associer(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_count_evaluations_a_associer(integer) TO "grp-www";


--
-- TOC entry 7901 (class 0 OID 0)
-- Dependencies: 1185
-- Name: af_get_positionnement_elements(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_elements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_elements(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_elements(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_elements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_elements(integer) TO "grp-www";


--
-- TOC entry 7902 (class 0 OID 0)
-- Dependencies: 1186
-- Name: af_get_positionnement_evaluation_a_generer(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_evaluation_a_generer(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_evaluation_a_generer(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluation_a_generer(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluation_a_generer(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_evaluation_a_generer(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7903 (class 0 OID 0)
-- Dependencies: 1187
-- Name: af_get_positionnement_evaluations_a_generer(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7904 (class 0 OID 0)
-- Dependencies: 1188
-- Name: af_get_positionnement_evaluations_a_generer(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7905 (class 0 OID 0)
-- Dependencies: 1189
-- Name: af_get_positionnement_evaluations_a_generer(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_a_generer(integer) TO "grp-www";


--
-- TOC entry 7906 (class 0 OID 0)
-- Dependencies: 1190
-- Name: af_get_positionnement_evaluations_affiliables_type(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_evaluations_affiliables_type(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_evaluations_affiliables_type(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_affiliables_type(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_affiliables_type(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_evaluations_affiliables_type(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7907 (class 0 OID 0)
-- Dependencies: 1191
-- Name: af_get_positionnement_last_question(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_last_question(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_last_question(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_last_question(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_last_question(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_last_question(integer) TO "grp-www";


--
-- TOC entry 7908 (class 0 OID 0)
-- Dependencies: 1192
-- Name: af_get_positionnement_media(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_media(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_media(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_media(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_media(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_media(integer) TO "grp-www";


--
-- TOC entry 7909 (class 0 OID 0)
-- Dependencies: 1193
-- Name: af_get_positionnement_nb_evaluations_a_generer(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_nb_evaluations_a_generer(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_nb_evaluations_a_generer(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_nb_evaluations_a_generer(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_nb_evaluations_a_generer(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_nb_evaluations_a_generer(integer) TO "grp-www";


--
-- TOC entry 7910 (class 0 OID 0)
-- Dependencies: 1194
-- Name: af_get_positionnement_question_positionnement_solution(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_question_positionnement_solution(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_question_positionnement_solution(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_question_positionnement_solution(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_question_positionnement_solution(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_question_positionnement_solution(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7911 (class 0 OID 0)
-- Dependencies: 1195
-- Name: af_get_positionnement_questions(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_questions(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_questions(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_questions(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_questions(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_questions(integer) TO "grp-www";


--
-- TOC entry 7912 (class 0 OID 0)
-- Dependencies: 1196
-- Name: af_get_positionnement_tests(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnement_tests(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnement_tests(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_tests(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnement_tests(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnement_tests(integer) TO "grp-www";


--
-- TOC entry 7913 (class 0 OID 0)
-- Dependencies: 1197
-- Name: af_get_positionnements(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_positionnements() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_positionnements() FROM pgsql;
GRANT ALL ON FUNCTION af_get_positionnements() TO pgsql;
GRANT ALL ON FUNCTION af_get_positionnements() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_positionnements() TO "grp-www";


--
-- TOC entry 7915 (class 0 OID 0)
-- Dependencies: 1198
-- Name: af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone) TO "grp-www";


--
-- TOC entry 7917 (class 0 OID 0)
-- Dependencies: 1199
-- Name: af_get_presentiel_carton_individu(integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_presentiel_carton_individu(integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_presentiel_carton_individu(integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_carton_individu(integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_carton_individu(integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_presentiel_carton_individu(integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7919 (class 0 OID 0)
-- Dependencies: 1200
-- Name: af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) TO "grp-www";


--
-- TOC entry 7921 (class 0 OID 0)
-- Dependencies: 1201
-- Name: af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_presentiel_resultat_individu_date(integer, integer, integer, integer, integer, timestamp without time zone) TO "grp-www";


--
-- TOC entry 7923 (class 0 OID 0)
-- Dependencies: 1202
-- Name: af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_presentiel_resultats_individu_capacite(integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7925 (class 0 OID 0)
-- Dependencies: 1203
-- Name: af_get_presentiel_resultats_individu_grille(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_presentiel_resultats_individu_grille(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_presentiel_resultats_individu_grille(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_resultats_individu_grille(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_resultats_individu_grille(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_presentiel_resultats_individu_grille(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7927 (class 0 OID 0)
-- Dependencies: 1204
-- Name: af_get_presentiel_stagiaire_grille(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_presentiel_stagiaire_grille(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_presentiel_stagiaire_grille(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_stagiaire_grille(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_presentiel_stagiaire_grille(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_presentiel_stagiaire_grille(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7928 (class 0 OID 0)
-- Dependencies: 1205
-- Name: af_get_qrc_question_solution(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_qrc_question_solution(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_qrc_question_solution(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_qrc_question_solution(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_qrc_question_solution(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_qrc_question_solution(integer, integer, integer) TO "grp-www";


--
-- TOC entry 7929 (class 0 OID 0)
-- Dependencies: 1206
-- Name: af_get_qsrc(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_qsrc(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_qsrc(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_qsrc(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_qsrc(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_qsrc(integer) TO "grp-www";


--
-- TOC entry 7930 (class 0 OID 0)
-- Dependencies: 1207
-- Name: af_get_qsrc_question_reponse(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_qsrc_question_reponse(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_qsrc_question_reponse(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_qsrc_question_reponse(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_qsrc_question_reponse(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_qsrc_question_reponse(integer) TO "grp-www";


--
-- TOC entry 7931 (class 0 OID 0)
-- Dependencies: 1208
-- Name: af_get_qsrc_questions(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_qsrc_questions(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_qsrc_questions(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_qsrc_questions(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_qsrc_questions(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_qsrc_questions(integer) TO "grp-www";


--
-- TOC entry 7933 (class 0 OID 0)
-- Dependencies: 1209
-- Name: af_get_question(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_question(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_question(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_question(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question(integer) TO "grp-www";


--
-- TOC entry 7935 (class 0 OID 0)
-- Dependencies: 1860
-- Name: af_get_question_positionnement_media(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_positionnement_media(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_positionnement_media(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_positionnement_media(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_positionnement_media(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_positionnement_media(integer, integer) TO "grp-www";


--
-- TOC entry 7937 (class 0 OID 0)
-- Dependencies: 1210
-- Name: af_get_question_reponse(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse(integer) TO "grp-www";


--
-- TOC entry 7939 (class 0 OID 0)
-- Dependencies: 1211
-- Name: af_get_question_reponse_association_elements(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_association_elements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_association_elements(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_association_elements(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_association_elements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_association_elements(integer) TO "grp-www";


--
-- TOC entry 7940 (class 0 OID 0)
-- Dependencies: 1212
-- Name: af_get_question_reponse_choix(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_choix(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_choix(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_choix(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_choix(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_choix(integer) TO "grp-www";


--
-- TOC entry 7942 (class 0 OID 0)
-- Dependencies: 1213
-- Name: af_get_question_reponse_element(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_question_reponse_element(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_element(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_question_reponse_element(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_question_reponse_element(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_element(integer) TO "grp-www";


--
-- TOC entry 7944 (class 0 OID 0)
-- Dependencies: 1214
-- Name: af_get_question_reponse_element_evaluations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_element_evaluations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_element_evaluations(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_element_evaluations(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_element_evaluations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_element_evaluations(integer) TO "grp-www";


--
-- TOC entry 7946 (class 0 OID 0)
-- Dependencies: 1215
-- Name: af_get_question_reponse_element_media(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_element_media(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_element_media(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_element_media(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_element_media(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_element_media(integer, integer) TO "grp-www";


--
-- TOC entry 7948 (class 0 OID 0)
-- Dependencies: 1216
-- Name: af_get_question_reponse_element_media(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_element_media(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_element_media(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_element_media(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_element_media(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_element_media(integer) TO "grp-www";


--
-- TOC entry 7950 (class 0 OID 0)
-- Dependencies: 1217
-- Name: af_get_question_reponse_elements(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_question_reponse_elements() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_elements() FROM postgres;
GRANT ALL ON FUNCTION af_get_question_reponse_elements() TO postgres;
GRANT ALL ON FUNCTION af_get_question_reponse_elements() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_elements() TO "grp-www";


--
-- TOC entry 7952 (class 0 OID 0)
-- Dependencies: 1218
-- Name: af_get_question_reponse_elements(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_question_reponse_elements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_elements(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_question_reponse_elements(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_question_reponse_elements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_elements(integer) TO "grp-www";


--
-- TOC entry 7954 (class 0 OID 0)
-- Dependencies: 1219
-- Name: af_get_question_reponse_elements(integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_elements(integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_elements(integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_elements(integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_elements(integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_elements(integer, boolean) TO "grp-www";


--
-- TOC entry 7956 (class 0 OID 0)
-- Dependencies: 1220
-- Name: af_get_question_reponse_elements_infos(integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_elements_infos(integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_elements_infos(integer, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_elements_infos(integer, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_elements_infos(integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_elements_infos(integer, integer, boolean) TO "grp-www";


--
-- TOC entry 7958 (class 0 OID 0)
-- Dependencies: 1221
-- Name: af_get_question_reponse_elements_media(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_elements_media(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_elements_media(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_elements_media(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_elements_media(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_elements_media(integer) TO "grp-www";


--
-- TOC entry 7960 (class 0 OID 0)
-- Dependencies: 25
-- Name: af_get_question_reponse_last_reponse(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_last_reponse(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_last_reponse(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_last_reponse(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_last_reponse(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_last_reponse(integer) TO "grp-www";


--
-- TOC entry 7962 (class 0 OID 0)
-- Dependencies: 1222
-- Name: af_get_question_reponse_media(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_media(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_media(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_media(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_media(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_media(integer) TO "grp-www";


--
-- TOC entry 7964 (class 0 OID 0)
-- Dependencies: 1223
-- Name: af_get_question_reponse_questions(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_questions(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_questions(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_questions(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_questions(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_questions(integer) TO "grp-www";


--
-- TOC entry 7966 (class 0 OID 0)
-- Dependencies: 1224
-- Name: af_get_question_reponse_solution(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_question_reponse_solution(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_solution(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_solution(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_question_reponse_solution(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_solution(integer, integer) TO "grp-www";


--
-- TOC entry 7968 (class 0 OID 0)
-- Dependencies: 1225
-- Name: af_get_question_reponse_solutions(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_question_reponse_solutions(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_question_reponse_solutions(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_question_reponse_solutions(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_question_reponse_solutions(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_question_reponse_solutions(integer) TO "grp-www";


--
-- TOC entry 7970 (class 0 OID 0)
-- Dependencies: 1226
-- Name: af_get_questions(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_questions() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_questions() FROM postgres;
GRANT ALL ON FUNCTION af_get_questions() TO postgres;
GRANT ALL ON FUNCTION af_get_questions() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_questions() TO "grp-www";


--
-- TOC entry 7972 (class 0 OID 0)
-- Dependencies: 1227
-- Name: af_get_reponse(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_reponse(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_reponse(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_reponse(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_reponse(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_reponse(integer) TO "grp-www";


--
-- TOC entry 7974 (class 0 OID 0)
-- Dependencies: 1228
-- Name: af_get_reponse_question_reponse_resultats(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_reponse_question_reponse_resultats(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_reponse_question_reponse_resultats(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_reponse_question_reponse_resultats(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_reponse_question_reponse_resultats(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_reponse_question_reponse_resultats(integer) TO "grp-www";


--
-- TOC entry 7976 (class 0 OID 0)
-- Dependencies: 1229
-- Name: af_get_reponses(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_reponses() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_reponses() FROM postgres;
GRANT ALL ON FUNCTION af_get_reponses() TO postgres;
GRANT ALL ON FUNCTION af_get_reponses() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_reponses() TO "grp-www";


--
-- TOC entry 7978 (class 0 OID 0)
-- Dependencies: 1230
-- Name: af_get_reponses(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_reponses(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_reponses(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_reponses(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_reponses(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_reponses(integer) TO "grp-www";


--
-- TOC entry 7980 (class 0 OID 0)
-- Dependencies: 1231
-- Name: af_get_ressource(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_ressource(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_ressource(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_ressource(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_ressource(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_ressource(integer) TO "grp-www";


--
-- TOC entry 7981 (class 0 OID 0)
-- Dependencies: 1232
-- Name: af_get_resultat(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 7982 (class 0 OID 0)
-- Dependencies: 1233
-- Name: af_get_resultat(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat(bigint) TO "grp-www";


--
-- TOC entry 7984 (class 0 OID 0)
-- Dependencies: 1234
-- Name: af_get_resultat_etape_tentative(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_etape_tentative(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_etape_tentative(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_etape_tentative(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_etape_tentative(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_etape_tentative(bigint) TO "grp-www";


--
-- TOC entry 7985 (class 0 OID 0)
-- Dependencies: 1861
-- Name: af_get_resultat_exotlc(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_exotlc(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_exotlc(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_exotlc(bigint) TO "grp-www";


--
-- TOC entry 7987 (class 0 OID 0)
-- Dependencies: 1862
-- Name: af_get_resultat_exotlc_critere(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_exotlc_critere(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_exotlc_critere(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_critere(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_critere(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_critere(bigint, integer) TO "grp-www";


--
-- TOC entry 7989 (class 0 OID 0)
-- Dependencies: 1235
-- Name: af_get_resultat_exotlc_critere_sous_criteres(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_exotlc_critere_sous_criteres(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_exotlc_critere_sous_criteres(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_critere_sous_criteres(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_critere_sous_criteres(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_critere_sous_criteres(bigint, integer) TO "grp-www";


--
-- TOC entry 7991 (class 0 OID 0)
-- Dependencies: 1236
-- Name: af_get_resultat_exotlc_criteres(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_exotlc_criteres(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_exotlc_criteres(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_criteres(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_criteres(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_criteres(bigint) TO "grp-www";


--
-- TOC entry 7993 (class 0 OID 0)
-- Dependencies: 1237
-- Name: af_get_resultat_exotlc_moyenne(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_exotlc_moyenne(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_exotlc_moyenne(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_moyenne(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_moyenne(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_moyenne(bigint) TO "grp-www";


--
-- TOC entry 7995 (class 0 OID 0)
-- Dependencies: 1238
-- Name: af_get_resultat_exotlc_sous_critere(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_exotlc_sous_critere(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_exotlc_sous_critere(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_sous_critere(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_sous_critere(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_sous_critere(bigint, integer) TO "grp-www";


--
-- TOC entry 7997 (class 0 OID 0)
-- Dependencies: 1863
-- Name: af_get_resultat_exotlc_sous_criteres(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_exotlc_sous_criteres(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_exotlc_sous_criteres(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_sous_criteres(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_sous_criteres(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_exotlc_sous_criteres(bigint) TO "grp-www";


--
-- TOC entry 7998 (class 0 OID 0)
-- Dependencies: 1864
-- Name: af_get_resultat_formation(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_formation(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_formation(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_formation(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_formation(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_formation(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8000 (class 0 OID 0)
-- Dependencies: 1239
-- Name: af_get_resultat_ftb_langue_ams_reponse(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_ftb_langue_ams_reponse(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_ftb_langue_ams_reponse(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_ftb_langue_ams_reponse(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_ftb_langue_ams_reponse(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_ftb_langue_ams_reponse(bigint, integer) TO "grp-www";


--
-- TOC entry 8002 (class 0 OID 0)
-- Dependencies: 1240
-- Name: af_get_resultat_parcours_exotlcs_score_partiel(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_parcours_exotlcs_score_partiel(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_parcours_exotlcs_score_partiel(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_parcours_exotlcs_score_partiel(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_parcours_exotlcs_score_partiel(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_parcours_exotlcs_score_partiel(bigint) TO "grp-www";


--
-- TOC entry 8004 (class 0 OID 0)
-- Dependencies: 1241
-- Name: af_get_resultat_parcours_parcours_oriente(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_parcours_parcours_oriente(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_parcours_parcours_oriente(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_parcours_parcours_oriente(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_parcours_parcours_oriente(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_parcours_parcours_oriente(bigint) TO "grp-www";


--
-- TOC entry 8006 (class 0 OID 0)
-- Dependencies: 1865
-- Name: af_get_resultat_parcours_score_partiel(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_parcours_score_partiel(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_parcours_score_partiel(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_parcours_score_partiel(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_parcours_score_partiel(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_parcours_score_partiel(bigint) TO "grp-www";


--
-- TOC entry 8008 (class 0 OID 0)
-- Dependencies: 1242
-- Name: af_get_resultat_parcours_series_score_partiel(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_parcours_series_score_partiel(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_parcours_series_score_partiel(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_parcours_series_score_partiel(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_parcours_series_score_partiel(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_parcours_series_score_partiel(bigint) TO "grp-www";


--
-- TOC entry 8010 (class 0 OID 0)
-- Dependencies: 1866
-- Name: af_get_resultat_serie_aleatoire_avancement_max(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_avancement_max(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_avancement_max(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_avancement_max(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_avancement_max(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_avancement_max(bigint) TO "grp-www";


--
-- TOC entry 8012 (class 0 OID 0)
-- Dependencies: 1867
-- Name: af_get_resultat_serie_aleatoire_evaluation(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluation(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluation(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluation(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluation(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluation(bigint, integer) TO "grp-www";


--
-- TOC entry 8013 (class 0 OID 0)
-- Dependencies: 26
-- Name: af_get_resultat_serie_aleatoire_evaluations_duree_totale(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_duree_totale(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_duree_totale(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_duree_totale(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_duree_totale(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_duree_totale(bigint) TO "grp-www";


--
-- TOC entry 8015 (class 0 OID 0)
-- Dependencies: 1243
-- Name: af_get_resultat_serie_aleatoire_evaluations_scores(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_scores(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_scores(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_scores(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_scores(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_evaluations_scores(bigint) TO "grp-www";


--
-- TOC entry 8017 (class 0 OID 0)
-- Dependencies: 1244
-- Name: af_get_resultat_serie_aleatoire_question_reponse(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_question_reponse(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_question_reponse(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_question_reponse(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_question_reponse(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_question_reponse(bigint, integer) TO "grp-www";


--
-- TOC entry 8019 (class 0 OID 0)
-- Dependencies: 1245
-- Name: af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_questionreponses_scores(bigint, integer) TO "grp-www";


--
-- TOC entry 8021 (class 0 OID 0)
-- Dependencies: 1246
-- Name: af_get_resultat_serie_aleatoire_score(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_score(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_aleatoire_score(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_score(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_score(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_aleatoire_score(bigint) TO "grp-www";


--
-- TOC entry 8022 (class 0 OID 0)
-- Dependencies: 1247
-- Name: af_get_resultat_serie_avancement_max(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_avancement_max(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_avancement_max(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_avancement_max(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_avancement_max(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_avancement_max(bigint) TO "grp-www";


--
-- TOC entry 8023 (class 0 OID 0)
-- Dependencies: 1248
-- Name: af_get_resultat_serie_evaluation(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluation(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluation(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluation(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluation(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluation(bigint, integer) TO "grp-www";


--
-- TOC entry 8024 (class 0 OID 0)
-- Dependencies: 1249
-- Name: af_get_resultat_serie_evaluation_old(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluation_old(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluation_old(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluation_old(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluation_old(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluation_old(bigint, integer) TO "grp-www";


--
-- TOC entry 8025 (class 0 OID 0)
-- Dependencies: 1250
-- Name: af_get_resultat_serie_evaluation_tentative(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluation_tentative(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluation_tentative(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluation_tentative(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluation_tentative(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluation_tentative(bigint, integer) TO "grp-www";


--
-- TOC entry 8027 (class 0 OID 0)
-- Dependencies: 1251
-- Name: af_get_resultat_serie_evaluations(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations(bigint) TO "grp-www";


--
-- TOC entry 8028 (class 0 OID 0)
-- Dependencies: 27
-- Name: af_get_resultat_serie_evaluations_duree_totale(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations_duree_totale(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations_duree_totale(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_duree_totale(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_duree_totale(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_duree_totale(bigint) TO "grp-www";


--
-- TOC entry 8030 (class 0 OID 0)
-- Dependencies: 1252
-- Name: af_get_resultat_serie_evaluations_scores_tentative(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_tentative(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_tentative(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_tentative(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_tentative(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_tentative(bigint) TO "grp-www";


--
-- TOC entry 8032 (class 0 OID 0)
-- Dependencies: 1253
-- Name: af_get_resultat_serie_evaluations_scores_toto(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_toto(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_toto(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_toto(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_toto(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_scores_toto(bigint) TO "grp-www";


--
-- TOC entry 8034 (class 0 OID 0)
-- Dependencies: 1254
-- Name: af_get_resultat_serie_evaluations_tentative(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations_tentative(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_evaluations_tentative(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_tentative(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_tentative(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_evaluations_tentative(bigint) TO "grp-www";


--
-- TOC entry 8035 (class 0 OID 0)
-- Dependencies: 1255
-- Name: af_get_resultat_serie_ftb(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_ftb(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_ftb(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb(bigint, integer) TO "grp-www";


--
-- TOC entry 8037 (class 0 OID 0)
-- Dependencies: 1256
-- Name: af_get_resultat_serie_ftb_scores(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_ftb_scores(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_ftb_scores(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb_scores(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb_scores(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb_scores(bigint, integer) TO "grp-www";


--
-- TOC entry 8039 (class 0 OID 0)
-- Dependencies: 1868
-- Name: af_get_resultat_serie_ftb_scores_tentative(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_ftb_scores_tentative(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_ftb_scores_tentative(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb_scores_tentative(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb_scores_tentative(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb_scores_tentative(bigint, integer) TO "grp-www";


--
-- TOC entry 8040 (class 0 OID 0)
-- Dependencies: 1257
-- Name: af_get_resultat_serie_ftb_tentative(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_ftb_tentative(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_ftb_tentative(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb_tentative(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb_tentative(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_ftb_tentative(bigint, integer) TO "grp-www";


--
-- TOC entry 8042 (class 0 OID 0)
-- Dependencies: 1258
-- Name: af_get_resultat_serie_melangee_avancement_max(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_melangee_avancement_max(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_melangee_avancement_max(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_melangee_avancement_max(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_melangee_avancement_max(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_melangee_avancement_max(bigint) TO "grp-www";


--
-- TOC entry 8043 (class 0 OID 0)
-- Dependencies: 1259
-- Name: af_get_resultat_serie_question_reponse(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_question_reponse(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_question_reponse(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_question_reponse(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_question_reponse(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_question_reponse(bigint, integer) TO "grp-www";


--
-- TOC entry 8044 (class 0 OID 0)
-- Dependencies: 1260
-- Name: af_get_resultat_serie_question_reponse_tentative(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_question_reponse_tentative(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_question_reponse_tentative(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_question_reponse_tentative(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_question_reponse_tentative(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_question_reponse_tentative(bigint, integer) TO "grp-www";


--
-- TOC entry 8046 (class 0 OID 0)
-- Dependencies: 1261
-- Name: af_get_resultat_serie_questionreponses_scores(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores(bigint, integer) TO "grp-www";


--
-- TOC entry 8048 (class 0 OID 0)
-- Dependencies: 1262
-- Name: af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_questionreponses_scores_tentative(bigint, integer) TO "grp-www";


--
-- TOC entry 8050 (class 0 OID 0)
-- Dependencies: 1263
-- Name: af_get_resultat_serie_questionreponses_stagiaires(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_questionreponses_stagiaires(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_questionreponses_stagiaires(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_questionreponses_stagiaires(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_questionreponses_stagiaires(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_questionreponses_stagiaires(bigint, integer) TO "grp-www";


--
-- TOC entry 8052 (class 0 OID 0)
-- Dependencies: 1264
-- Name: af_get_resultat_serie_score(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_score(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_score(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_score(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_score(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_score(bigint) TO "grp-www";


--
-- TOC entry 8054 (class 0 OID 0)
-- Dependencies: 1265
-- Name: af_get_resultat_serie_score_tentative(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_serie_score_tentative(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_serie_score_tentative(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_score_tentative(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_serie_score_tentative(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_serie_score_tentative(bigint) TO "grp-www";


--
-- TOC entry 8056 (class 0 OID 0)
-- Dependencies: 1266
-- Name: af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_sondage_question_reponse_score(bigint, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8058 (class 0 OID 0)
-- Dependencies: 1869
-- Name: af_get_resultat_tentative(integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_tentative(integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_tentative(integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_tentative(integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_tentative(integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_tentative(integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8060 (class 0 OID 0)
-- Dependencies: 1267
-- Name: af_get_resultat_tentative(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_resultat_tentative(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_resultat_tentative(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_get_resultat_tentative(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_get_resultat_tentative(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_resultat_tentative(bigint) TO "grp-www";


--
-- TOC entry 8062 (class 0 OID 0)
-- Dependencies: 1268
-- Name: af_get_salle(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_salle(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_salle(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_salle(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_salle(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_salle(integer) TO "grp-www";


--
-- TOC entry 8064 (class 0 OID 0)
-- Dependencies: 1269
-- Name: af_get_salle_evenements(integer, date); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_salle_evenements(integer, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_salle_evenements(integer, date) FROM pgsql;
GRANT ALL ON FUNCTION af_get_salle_evenements(integer, date) TO pgsql;
GRANT ALL ON FUNCTION af_get_salle_evenements(integer, date) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_salle_evenements(integer, date) TO "grp-www";


--
-- TOC entry 8066 (class 0 OID 0)
-- Dependencies: 1270
-- Name: af_get_salles(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_salles() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_salles() FROM postgres;
GRANT ALL ON FUNCTION af_get_salles() TO postgres;
GRANT ALL ON FUNCTION af_get_salles() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_salles() TO "grp-www";


--
-- TOC entry 8067 (class 0 OID 0)
-- Dependencies: 1271
-- Name: af_get_scenario(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_scenario(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_scenario(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_scenario(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_scenario(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_scenario(integer) TO "grp-www";


--
-- TOC entry 8068 (class 0 OID 0)
-- Dependencies: 1272
-- Name: af_get_scenario_dynamique(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_scenario_dynamique(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_scenario_dynamique(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_scenario_dynamique(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_scenario_dynamique(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_scenario_dynamique(integer) TO "grp-www";


--
-- TOC entry 8070 (class 0 OID 0)
-- Dependencies: 1273
-- Name: af_get_scenario_dynamique_fichier(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_scenario_dynamique_fichier(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_scenario_dynamique_fichier(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_scenario_dynamique_fichier(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_scenario_dynamique_fichier(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_scenario_dynamique_fichier(integer) TO "grp-www";


--
-- TOC entry 8072 (class 0 OID 0)
-- Dependencies: 1274
-- Name: af_get_scenario_fichier(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_scenario_fichier(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_scenario_fichier(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_scenario_fichier(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_scenario_fichier(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_scenario_fichier(integer) TO "grp-www";


--
-- TOC entry 8074 (class 0 OID 0)
-- Dependencies: 1275
-- Name: af_get_section(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_section(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_section(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_section(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_section(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_section(integer) TO "grp-www";


--
-- TOC entry 8076 (class 0 OID 0)
-- Dependencies: 1276
-- Name: af_get_sections(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_sections() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_sections() FROM pgsql;
GRANT ALL ON FUNCTION af_get_sections() TO pgsql;
GRANT ALL ON FUNCTION af_get_sections() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_sections() TO "grp-www";


--
-- TOC entry 8078 (class 0 OID 0)
-- Dependencies: 1277
-- Name: af_get_serie(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie(integer) TO "grp-www";


--
-- TOC entry 8080 (class 0 OID 0)
-- Dependencies: 1278
-- Name: af_get_serie_aleatoire(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire(integer) TO "grp-www";


--
-- TOC entry 8082 (class 0 OID 0)
-- Dependencies: 1279
-- Name: af_get_serie_aleatoire_evaluations(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_evaluations(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_evaluations(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_evaluations(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_evaluations(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_evaluations(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8084 (class 0 OID 0)
-- Dependencies: 1280
-- Name: af_get_serie_aleatoire_melangee_themes(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_melangee_themes() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_melangee_themes() FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_melangee_themes() TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_melangee_themes() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_melangee_themes() TO "grp-www";


--
-- TOC entry 8085 (class 0 OID 0)
-- Dependencies: 28
-- Name: af_get_serie_aleatoire_multiserie_evaluation(integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluation(integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluation(integer, integer, integer, integer, integer) FROM www;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluation(integer, integer, integer, integer, integer) TO www;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluation(integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluation(integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8087 (class 0 OID 0)
-- Dependencies: 1281
-- Name: af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8088 (class 0 OID 0)
-- Dependencies: 1870
-- Name: af_get_serie_aleatoire_multiserie_somme_chronos(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_chronos(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_chronos(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_chronos(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_chronos(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_chronos(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8090 (class 0 OID 0)
-- Dependencies: 1871
-- Name: af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_somme_points(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8092 (class 0 OID 0)
-- Dependencies: 1872
-- Name: af_get_serie_aleatoire_multiserie_themes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_themes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_multiserie_themes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_themes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_themes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_multiserie_themes(integer) TO "grp-www";


--
-- TOC entry 8094 (class 0 OID 0)
-- Dependencies: 1282
-- Name: af_get_serie_aleatoire_series_associations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_series_associations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_series_associations(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_series_associations(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_series_associations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_series_associations(integer) TO "grp-www";


--
-- TOC entry 8096 (class 0 OID 0)
-- Dependencies: 1283
-- Name: af_get_serie_aleatoire_series_sources(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_series_sources(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_series_sources(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_series_sources(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_series_sources(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_series_sources(integer) TO "grp-www";


--
-- TOC entry 8098 (class 0 OID 0)
-- Dependencies: 1284
-- Name: af_get_serie_aleatoire_themes(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_themes(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_themes(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_themes(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_themes(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_themes(integer, integer) TO "grp-www";


--
-- TOC entry 8100 (class 0 OID 0)
-- Dependencies: 1285
-- Name: af_get_serie_aleatoire_themes_associations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_themes_associations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_themes_associations(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_themes_associations(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_themes_associations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_themes_associations(integer) TO "grp-www";


--
-- TOC entry 8101 (class 0 OID 0)
-- Dependencies: 1286
-- Name: af_get_serie_aleatoire_type(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_type(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_type(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_type(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_type(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_type(integer) TO "grp-www";


--
-- TOC entry 8102 (class 0 OID 0)
-- Dependencies: 1873
-- Name: af_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_aleatoire_types_evaluations_type(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8103 (class 0 OID 0)
-- Dependencies: 1287
-- Name: af_get_serie_avancement(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_avancement(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_avancement(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_avancement(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_avancement(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_avancement(integer) TO "grp-www";


--
-- TOC entry 8104 (class 0 OID 0)
-- Dependencies: 1288
-- Name: af_get_serie_avancement_max(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_avancement_max(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_avancement_max(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_avancement_max(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_avancement_max(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_avancement_max(integer) TO "grp-www";


--
-- TOC entry 8106 (class 0 OID 0)
-- Dependencies: 1289
-- Name: af_get_serie_bloquante_configuration(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_bloquante_configuration(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_bloquante_configuration(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_bloquante_configuration(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_bloquante_configuration(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_bloquante_configuration(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8107 (class 0 OID 0)
-- Dependencies: 29
-- Name: af_get_serie_bloquante_tentative(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_bloquante_tentative(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_bloquante_tentative(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_bloquante_tentative(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_bloquante_tentative(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_bloquante_tentative(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8109 (class 0 OID 0)
-- Dependencies: 1290
-- Name: af_get_serie_commentaires(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_commentaires(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_commentaires(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_commentaires(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_commentaires(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_commentaires(integer) TO "grp-www";


--
-- TOC entry 8111 (class 0 OID 0)
-- Dependencies: 1291
-- Name: af_get_serie_distincts_types(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_distincts_types(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_distincts_types(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_distincts_types(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_distincts_types(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_distincts_types(integer) TO "grp-www";


--
-- TOC entry 8113 (class 0 OID 0)
-- Dependencies: 1292
-- Name: af_get_serie_evaluation(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_evaluation(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_evaluation(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluation(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluation(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_evaluation(integer, integer) TO "grp-www";


--
-- TOC entry 8115 (class 0 OID 0)
-- Dependencies: 1293
-- Name: af_get_serie_evaluation_indice(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_evaluation_indice(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_evaluation_indice(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluation_indice(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluation_indice(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_evaluation_indice(integer, integer) TO "grp-www";


--
-- TOC entry 8116 (class 0 OID 0)
-- Dependencies: 30
-- Name: af_get_serie_evaluation_resultats(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_evaluation_resultats(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_evaluation_resultats(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluation_resultats(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluation_resultats(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_evaluation_resultats(integer, integer) TO "grp-www";


--
-- TOC entry 8118 (class 0 OID 0)
-- Dependencies: 1294
-- Name: af_get_serie_evaluations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_evaluations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_evaluations(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluations(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_evaluations(integer) TO "grp-www";


--
-- TOC entry 8120 (class 0 OID 0)
-- Dependencies: 1295
-- Name: af_get_serie_evaluations_disponibles_theme(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme(integer, integer) TO "grp-www";


--
-- TOC entry 8122 (class 0 OID 0)
-- Dependencies: 1296
-- Name: af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_categorie(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8124 (class 0 OID 0)
-- Dependencies: 1297
-- Name: af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_evaluations_disponibles_theme_type(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8125 (class 0 OID 0)
-- Dependencies: 1874
-- Name: af_get_serie_ftb_resultats(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_ftb_resultats(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_ftb_resultats(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_ftb_resultats(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_ftb_resultats(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_ftb_resultats(integer) TO "grp-www";


--
-- TOC entry 8127 (class 0 OID 0)
-- Dependencies: 1298
-- Name: af_get_serie_individus(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_individus(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_individus(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_individus(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_individus(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_individus(integer) TO "grp-www";


--
-- TOC entry 8128 (class 0 OID 0)
-- Dependencies: 1299
-- Name: af_get_serie_question_reponse_resultats(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_question_reponse_resultats(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_question_reponse_resultats(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_question_reponse_resultats(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_question_reponse_resultats(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_question_reponse_resultats(integer) TO "grp-www";


--
-- TOC entry 8129 (class 0 OID 0)
-- Dependencies: 1300
-- Name: af_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_questions_evaluations_disponibles_theme_type(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8130 (class 0 OID 0)
-- Dependencies: 1301
-- Name: af_get_serie_series_aleatoires(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_series_aleatoires(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_series_aleatoires(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_series_aleatoires(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_series_aleatoires(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_series_aleatoires(integer) TO "grp-www";


--
-- TOC entry 8132 (class 0 OID 0)
-- Dependencies: 1875
-- Name: af_get_serie_simple(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_simple(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_simple(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_simple(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_simple(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_simple(integer) TO "grp-www";


--
-- TOC entry 8133 (class 0 OID 0)
-- Dependencies: 1302
-- Name: af_get_serie_simple_type(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_simple_type(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_simple_type(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_simple_type(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_simple_type(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_simple_type(integer) TO "grp-www";


--
-- TOC entry 8134 (class 0 OID 0)
-- Dependencies: 1303
-- Name: af_get_serie_somme_chronos(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_somme_chronos(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_somme_chronos(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_somme_chronos(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_somme_chronos(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_somme_chronos(integer) TO "grp-www";


--
-- TOC entry 8136 (class 0 OID 0)
-- Dependencies: 1304
-- Name: af_get_serie_somme_points(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_somme_points(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_somme_points(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_somme_points(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_somme_points(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_somme_points(integer) TO "grp-www";


--
-- TOC entry 8137 (class 0 OID 0)
-- Dependencies: 1305
-- Name: af_get_serie_types_evaluations_type(integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_serie_types_evaluations_type(integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_serie_types_evaluations_type(integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_serie_types_evaluations_type(integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_serie_types_evaluations_type(integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_serie_types_evaluations_type(integer, boolean) TO "grp-www";


--
-- TOC entry 8139 (class 0 OID 0)
-- Dependencies: 1306
-- Name: af_get_series_aleatoires_type(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_series_aleatoires_type(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_series_aleatoires_type(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_series_aleatoires_type(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_series_aleatoires_type(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_series_aleatoires_type(integer) TO "grp-www";


--
-- TOC entry 8141 (class 0 OID 0)
-- Dependencies: 1307
-- Name: af_get_session_individus(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_session_individus() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_session_individus() FROM pgsql;
GRANT ALL ON FUNCTION af_get_session_individus() TO pgsql;
GRANT ALL ON FUNCTION af_get_session_individus() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_session_individus() TO "grp-www";


--
-- TOC entry 8143 (class 0 OID 0)
-- Dependencies: 1308
-- Name: af_get_sondage_elements(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_sondage_elements() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_sondage_elements() FROM postgres;
GRANT ALL ON FUNCTION af_get_sondage_elements() TO postgres;
GRANT ALL ON FUNCTION af_get_sondage_elements() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_sondage_elements() TO "grp-www";


--
-- TOC entry 8145 (class 0 OID 0)
-- Dependencies: 31
-- Name: af_get_sondage_propositions(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_sondage_propositions(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_sondage_propositions(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_sondage_propositions(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_sondage_propositions(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_sondage_propositions(integer) TO "grp-www";


--
-- TOC entry 8147 (class 0 OID 0)
-- Dependencies: 1309
-- Name: af_get_stagiaire_exotlcs_corriges_formation(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_stagiaire_exotlcs_corriges_formation(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_stagiaire_exotlcs_corriges_formation(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_stagiaire_exotlcs_corriges_formation(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_stagiaire_exotlcs_corriges_formation(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_stagiaire_exotlcs_corriges_formation(integer, integer) TO "grp-www";


--
-- TOC entry 8149 (class 0 OID 0)
-- Dependencies: 1310
-- Name: af_get_stagiaires_formation(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_stagiaires_formation() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_stagiaires_formation() FROM pgsql;
GRANT ALL ON FUNCTION af_get_stagiaires_formation() TO pgsql;
GRANT ALL ON FUNCTION af_get_stagiaires_formation() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_stagiaires_formation() TO "grp-www";


--
-- TOC entry 8151 (class 0 OID 0)
-- Dependencies: 1311
-- Name: af_get_template(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_template(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_template(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_template(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_template(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_template(integer) TO "grp-www";


--
-- TOC entry 8152 (class 0 OID 0)
-- Dependencies: 3927
-- Name: modele_correction_criteres; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE modele_correction_criteres FROM PUBLIC;
REVOKE ALL ON TABLE modele_correction_criteres FROM postgres;
GRANT ALL ON TABLE modele_correction_criteres TO postgres;
GRANT ALL ON TABLE modele_correction_criteres TO www;
GRANT ALL ON TABLE modele_correction_criteres TO "grp-www";
GRANT ALL ON TABLE modele_correction_criteres TO PUBLIC;


--
-- TOC entry 8154 (class 0 OID 0)
-- Dependencies: 1312
-- Name: af_get_template_associations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_template_associations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_template_associations(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_template_associations(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_template_associations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_template_associations(integer) TO "grp-www";


--
-- TOC entry 8156 (class 0 OID 0)
-- Dependencies: 1313
-- Name: af_get_template_criteres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_template_criteres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_template_criteres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_template_criteres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_template_criteres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_template_criteres(integer) TO "grp-www";


--
-- TOC entry 8158 (class 0 OID 0)
-- Dependencies: 1314
-- Name: af_get_template_criteres_non_ordonnes(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_template_criteres_non_ordonnes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_template_criteres_non_ordonnes(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_template_criteres_non_ordonnes(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_template_criteres_non_ordonnes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_template_criteres_non_ordonnes(integer) TO "grp-www";


--
-- TOC entry 8160 (class 0 OID 0)
-- Dependencies: 1876
-- Name: af_get_template_sous_critere(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_template_sous_critere(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_template_sous_critere(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_template_sous_critere(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_template_sous_critere(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_template_sous_critere(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8162 (class 0 OID 0)
-- Dependencies: 1315
-- Name: af_get_template_sous_criteres(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_template_sous_criteres(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_template_sous_criteres(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_template_sous_criteres(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_template_sous_criteres(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_template_sous_criteres(integer, integer) TO "grp-www";


--
-- TOC entry 8164 (class 0 OID 0)
-- Dependencies: 1316
-- Name: af_get_template_sous_criteres_non_ordonnes(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_template_sous_criteres_non_ordonnes(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_template_sous_criteres_non_ordonnes(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_template_sous_criteres_non_ordonnes(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_template_sous_criteres_non_ordonnes(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_template_sous_criteres_non_ordonnes(integer, integer) TO "grp-www";


--
-- TOC entry 8165 (class 0 OID 0)
-- Dependencies: 1317
-- Name: af_get_test(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_test(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_test(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_test(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_test(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_test(integer) TO "grp-www";


--
-- TOC entry 8166 (class 0 OID 0)
-- Dependencies: 1318
-- Name: af_get_test_last_positionnement(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_test_last_positionnement(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_test_last_positionnement(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_test_last_positionnement(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_test_last_positionnement(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_test_last_positionnement(integer) TO "grp-www";


--
-- TOC entry 8167 (class 0 OID 0)
-- Dependencies: 1319
-- Name: af_get_test_parcours(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_test_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_test_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_test_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_test_parcours(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_test_parcours(integer) TO "grp-www";


--
-- TOC entry 8168 (class 0 OID 0)
-- Dependencies: 1320
-- Name: af_get_test_positionnements(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_test_positionnements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_test_positionnements(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_test_positionnements(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_test_positionnements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_test_positionnements(integer) TO "grp-www";


--
-- TOC entry 8169 (class 0 OID 0)
-- Dependencies: 1321
-- Name: af_get_test_positionnements_disponibles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_test_positionnements_disponibles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_test_positionnements_disponibles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_test_positionnements_disponibles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_test_positionnements_disponibles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_test_positionnements_disponibles(integer) TO "grp-www";


--
-- TOC entry 8170 (class 0 OID 0)
-- Dependencies: 1322
-- Name: af_get_test_positionnements_infos(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_test_positionnements_infos(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_test_positionnements_infos(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_test_positionnements_infos(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_test_positionnements_infos(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_test_positionnements_infos(integer) TO "grp-www";


--
-- TOC entry 8171 (class 0 OID 0)
-- Dependencies: 1323
-- Name: af_get_test_somme_chronos(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_test_somme_chronos(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_test_somme_chronos(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_test_somme_chronos(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_test_somme_chronos(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_test_somme_chronos(integer) TO "grp-www";


--
-- TOC entry 8172 (class 0 OID 0)
-- Dependencies: 1324
-- Name: af_get_tests(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_tests() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_tests() FROM pgsql;
GRANT ALL ON FUNCTION af_get_tests() TO pgsql;
GRANT ALL ON FUNCTION af_get_tests() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_tests() TO "grp-www";


--
-- TOC entry 8174 (class 0 OID 0)
-- Dependencies: 1325
-- Name: af_get_theme(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_theme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_theme(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_theme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme(integer) TO "grp-www";


--
-- TOC entry 8176 (class 0 OID 0)
-- Dependencies: 1326
-- Name: af_get_theme(character varying); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_theme(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme(character varying) FROM postgres;
GRANT ALL ON FUNCTION af_get_theme(character varying) TO postgres;
GRANT ALL ON FUNCTION af_get_theme(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme(character varying) TO "grp-www";


--
-- TOC entry 8178 (class 0 OID 0)
-- Dependencies: 1327
-- Name: af_get_theme_capacites(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_capacites(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_capacites(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_capacites(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_capacites(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_capacites(integer) TO "grp-www";


--
-- TOC entry 8180 (class 0 OID 0)
-- Dependencies: 1328
-- Name: af_get_theme_capacites_titres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_capacites_titres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_capacites_titres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_capacites_titres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_capacites_titres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_capacites_titres(integer) TO "grp-www";


--
-- TOC entry 8182 (class 0 OID 0)
-- Dependencies: 1329
-- Name: af_get_theme_categories(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_theme_categories(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_categories(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_theme_categories(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_theme_categories(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_categories(integer) TO "grp-www";


--
-- TOC entry 8184 (class 0 OID 0)
-- Dependencies: 1330
-- Name: af_get_theme_criteres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_criteres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_criteres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_criteres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_criteres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_criteres(integer) TO "grp-www";


--
-- TOC entry 8186 (class 0 OID 0)
-- Dependencies: 1331
-- Name: af_get_theme_elements(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_elements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_elements(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_elements(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_elements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_elements(integer) TO "grp-www";


--
-- TOC entry 8188 (class 0 OID 0)
-- Dependencies: 1332
-- Name: af_get_theme_elements_all(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_elements_all(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_elements_all(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_elements_all(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_elements_all(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_elements_all(integer) TO "grp-www";


--
-- TOC entry 8190 (class 0 OID 0)
-- Dependencies: 1333
-- Name: af_get_theme_etapes_forum(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_etapes_forum(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_etapes_forum(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_etapes_forum(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_etapes_forum(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_etapes_forum(integer) TO "grp-www";


--
-- TOC entry 8192 (class 0 OID 0)
-- Dependencies: 1334
-- Name: af_get_theme_etapes_ressource(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_etapes_ressource(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_etapes_ressource(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_etapes_ressource(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_etapes_ressource(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_etapes_ressource(integer) TO "grp-www";


--
-- TOC entry 8194 (class 0 OID 0)
-- Dependencies: 1335
-- Name: af_get_theme_evaluations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_evaluations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_evaluations(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_evaluations(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_evaluations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_evaluations(integer) TO "grp-www";


--
-- TOC entry 8196 (class 0 OID 0)
-- Dependencies: 1336
-- Name: af_get_theme_exostlc_titre(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_exostlc_titre(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_exostlc_titre(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_exostlc_titre(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_exostlc_titre(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_exostlc_titre(integer, character varying) TO "grp-www";


--
-- TOC entry 8198 (class 0 OID 0)
-- Dependencies: 1337
-- Name: af_get_theme_exostlc_type(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_exostlc_type(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_exostlc_type(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_exostlc_type(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_exostlc_type(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_exostlc_type(integer, character varying) TO "grp-www";


--
-- TOC entry 8199 (class 0 OID 0)
-- Dependencies: 1877
-- Name: af_get_theme_fichiers_blocs_scenarios(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_theme_fichiers_blocs_scenarios(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_fichiers_blocs_scenarios(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_theme_fichiers_blocs_scenarios(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_theme_fichiers_blocs_scenarios(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_fichiers_blocs_scenarios(integer) TO "grp-www";


--
-- TOC entry 8200 (class 0 OID 0)
-- Dependencies: 1338
-- Name: af_get_theme_fichiers_scenarios_dynamiques(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_fichiers_scenarios_dynamiques(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_fichiers_scenarios_dynamiques(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_fichiers_scenarios_dynamiques(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_fichiers_scenarios_dynamiques(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_fichiers_scenarios_dynamiques(integer, character varying) TO "grp-www";


--
-- TOC entry 8201 (class 0 OID 0)
-- Dependencies: 1339
-- Name: af_get_theme_fichiers_slides_scenarios(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_theme_fichiers_slides_scenarios(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_fichiers_slides_scenarios(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_theme_fichiers_slides_scenarios(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_theme_fichiers_slides_scenarios(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_fichiers_slides_scenarios(integer) TO "grp-www";


--
-- TOC entry 8203 (class 0 OID 0)
-- Dependencies: 1340
-- Name: af_get_theme_ftbs(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_ftbs(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_ftbs(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_ftbs(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_ftbs(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_ftbs(integer, integer) TO "grp-www";


--
-- TOC entry 8205 (class 0 OID 0)
-- Dependencies: 32
-- Name: af_get_theme_glossaires(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_theme_glossaires(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_glossaires(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_theme_glossaires(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_theme_glossaires(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_glossaires(integer) TO "grp-www";


--
-- TOC entry 8207 (class 0 OID 0)
-- Dependencies: 1341
-- Name: af_get_theme_grilles(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_grilles(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_grilles(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_grilles(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_grilles(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_grilles(integer) TO "grp-www";


--
-- TOC entry 8209 (class 0 OID 0)
-- Dependencies: 1342
-- Name: af_get_theme_grilles_capacite(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_grilles_capacite(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_grilles_capacite(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_grilles_capacite(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_grilles_capacite(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_grilles_capacite(integer) TO "grp-www";


--
-- TOC entry 8211 (class 0 OID 0)
-- Dependencies: 1343
-- Name: af_get_theme_modeles_correction(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_modeles_correction(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_modeles_correction(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_modeles_correction(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_modeles_correction(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_modeles_correction(integer) TO "grp-www";


--
-- TOC entry 8212 (class 0 OID 0)
-- Dependencies: 1344
-- Name: af_get_theme_positionnements(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_positionnements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_positionnements(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_positionnements(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_positionnements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_positionnements(integer) TO "grp-www";


--
-- TOC entry 8214 (class 0 OID 0)
-- Dependencies: 1345
-- Name: af_get_theme_qsrcs(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_qsrcs(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_qsrcs(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_qsrcs(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_qsrcs(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_qsrcs(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8216 (class 0 OID 0)
-- Dependencies: 1346
-- Name: af_get_theme_question_reponse_elements(integer, integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_question_reponse_elements(integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_question_reponse_elements(integer, integer, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_question_reponse_elements(integer, integer, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_question_reponse_elements(integer, integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_question_reponse_elements(integer, integer, integer, boolean) TO "grp-www";


--
-- TOC entry 8218 (class 0 OID 0)
-- Dependencies: 1878
-- Name: af_get_theme_question_reponse_reponses(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_theme_question_reponse_reponses(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_question_reponse_reponses(integer, integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_theme_question_reponse_reponses(integer, integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_get_theme_question_reponse_reponses(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_question_reponse_reponses(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8220 (class 0 OID 0)
-- Dependencies: 1347
-- Name: af_get_theme_question_reponses(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_question_reponses(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_question_reponses(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_question_reponses(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_question_reponses(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_question_reponses(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8222 (class 0 OID 0)
-- Dependencies: 1348
-- Name: af_get_theme_ressources(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_ressources(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_ressources(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_ressources(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_ressources(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_ressources(integer) TO "grp-www";


--
-- TOC entry 8223 (class 0 OID 0)
-- Dependencies: 1349
-- Name: af_get_theme_scenarios_dynamiques_colonnes_libelles(integer, character varying, integer, character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_scenarios_dynamiques_colonnes_libelles(integer, character varying, integer, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_scenarios_dynamiques_colonnes_libelles(integer, character varying, integer, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_scenarios_dynamiques_colonnes_libelles(integer, character varying, integer, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_scenarios_dynamiques_colonnes_libelles(integer, character varying, integer, character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_scenarios_dynamiques_colonnes_libelles(integer, character varying, integer, character varying, integer, integer) TO "grp-www";


--
-- TOC entry 8225 (class 0 OID 0)
-- Dependencies: 1350
-- Name: af_get_theme_series(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_series(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_series(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_series(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_series(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_series(integer) TO "grp-www";


--
-- TOC entry 8227 (class 0 OID 0)
-- Dependencies: 1351
-- Name: af_get_theme_series_aleatoire_melangees(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_series_aleatoire_melangees(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_series_aleatoire_melangees(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_series_aleatoire_melangees(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_series_aleatoire_melangees(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_series_aleatoire_melangees(integer) TO "grp-www";


--
-- TOC entry 8229 (class 0 OID 0)
-- Dependencies: 1879
-- Name: af_get_theme_series_aleatoires(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_series_aleatoires(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_series_aleatoires(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_series_aleatoires(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_series_aleatoires(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_series_aleatoires(integer, integer) TO "grp-www";


--
-- TOC entry 8231 (class 0 OID 0)
-- Dependencies: 1352
-- Name: af_get_theme_series_non_vide(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_series_non_vide(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_series_non_vide(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_series_non_vide(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_series_non_vide(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_series_non_vide(integer, integer) TO "grp-www";


--
-- TOC entry 8233 (class 0 OID 0)
-- Dependencies: 1353
-- Name: af_get_theme_sous_criteres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_theme_sous_criteres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_theme_sous_criteres(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_theme_sous_criteres(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_theme_sous_criteres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_theme_sous_criteres(integer) TO "grp-www";


--
-- TOC entry 8235 (class 0 OID 0)
-- Dependencies: 1354
-- Name: af_get_themes(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_get_themes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_themes(integer) FROM postgres;
GRANT ALL ON FUNCTION af_get_themes(integer) TO postgres;
GRANT ALL ON FUNCTION af_get_themes(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_themes(integer) TO "grp-www";


--
-- TOC entry 8237 (class 0 OID 0)
-- Dependencies: 1355
-- Name: af_get_themes_ressource(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_themes_ressource() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_themes_ressource() FROM pgsql;
GRANT ALL ON FUNCTION af_get_themes_ressource() TO pgsql;
GRANT ALL ON FUNCTION af_get_themes_ressource() TO PUBLIC;
GRANT ALL ON FUNCTION af_get_themes_ressource() TO "grp-www";


--
-- TOC entry 8239 (class 0 OID 0)
-- Dependencies: 1356
-- Name: af_get_themes_ressource_fichier_texte(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_get_themes_ressource_fichier_texte(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_get_themes_ressource_fichier_texte(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_get_themes_ressource_fichier_texte(integer) TO pgsql;
GRANT ALL ON FUNCTION af_get_themes_ressource_fichier_texte(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_get_themes_ressource_fichier_texte(integer) TO "grp-www";


--
-- TOC entry 8241 (class 0 OID 0)
-- Dependencies: 1357
-- Name: af_is_capacite_titre_capacite_supprimable(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_capacite_titre_capacite_supprimable(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_capacite_titre_capacite_supprimable(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_capacite_titre_capacite_supprimable(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_capacite_titre_capacite_supprimable(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_capacite_titre_capacite_supprimable(integer, integer) TO "grp-www";


--
-- TOC entry 8242 (class 0 OID 0)
-- Dependencies: 1880
-- Name: af_is_fichier_scenario_dynamique_supprimable(integer); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION af_is_fichier_scenario_dynamique_supprimable(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_fichier_scenario_dynamique_supprimable(integer) FROM www;
GRANT ALL ON FUNCTION af_is_fichier_scenario_dynamique_supprimable(integer) TO www;
GRANT ALL ON FUNCTION af_is_fichier_scenario_dynamique_supprimable(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_fichier_scenario_dynamique_supprimable(integer) TO "grp-www";


--
-- TOC entry 8243 (class 0 OID 0)
-- Dependencies: 1358
-- Name: af_is_fichier_scenario_dynamique_used(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_fichier_scenario_dynamique_used(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_fichier_scenario_dynamique_used(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_fichier_scenario_dynamique_used(integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_fichier_scenario_dynamique_used(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_fichier_scenario_dynamique_used(integer) TO "grp-www";


--
-- TOC entry 8244 (class 0 OID 0)
-- Dependencies: 1359
-- Name: af_is_filiere_libelle_ok(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_filiere_libelle_ok(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_filiere_libelle_ok(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_is_filiere_libelle_ok(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_is_filiere_libelle_ok(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_filiere_libelle_ok(integer, character varying) TO "grp-www";


--
-- TOC entry 8246 (class 0 OID 0)
-- Dependencies: 1360
-- Name: af_is_formation_evenement_supprimable(integer, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_formation_evenement_supprimable(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_formation_evenement_supprimable(integer, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_is_formation_evenement_supprimable(integer, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_is_formation_evenement_supprimable(integer, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_formation_evenement_supprimable(integer, timestamp without time zone) TO "grp-www";


--
-- TOC entry 8248 (class 0 OID 0)
-- Dependencies: 1361
-- Name: af_is_formation_evenements_hors_periode(integer, date, date); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_formation_evenements_hors_periode(integer, date, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_formation_evenements_hors_periode(integer, date, date) FROM pgsql;
GRANT ALL ON FUNCTION af_is_formation_evenements_hors_periode(integer, date, date) TO pgsql;
GRANT ALL ON FUNCTION af_is_formation_evenements_hors_periode(integer, date, date) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_formation_evenements_hors_periode(integer, date, date) TO "grp-www";


--
-- TOC entry 8250 (class 0 OID 0)
-- Dependencies: 1362
-- Name: af_is_formation_evenements_supprimable(integer, date); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_formation_evenements_supprimable(integer, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_formation_evenements_supprimable(integer, date) FROM pgsql;
GRANT ALL ON FUNCTION af_is_formation_evenements_supprimable(integer, date) TO pgsql;
GRANT ALL ON FUNCTION af_is_formation_evenements_supprimable(integer, date) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_formation_evenements_supprimable(integer, date) TO "grp-www";


--
-- TOC entry 8252 (class 0 OID 0)
-- Dependencies: 1363
-- Name: af_is_grille_capacite_titre_supprimable(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_grille_capacite_titre_supprimable(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_grille_capacite_titre_supprimable(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_grille_capacite_titre_supprimable(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_grille_capacite_titre_supprimable(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_grille_capacite_titre_supprimable(integer, integer) TO "grp-www";


--
-- TOC entry 8254 (class 0 OID 0)
-- Dependencies: 1364
-- Name: af_is_individu_droit_classe(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_individu_droit_classe(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_individu_droit_classe(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_individu_droit_classe(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_individu_droit_classe(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_individu_droit_classe(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8256 (class 0 OID 0)
-- Dependencies: 1365
-- Name: af_is_individu_supprimable(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_individu_supprimable(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_individu_supprimable(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_individu_supprimable(integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_individu_supprimable(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_individu_supprimable(integer) TO "grp-www";


--
-- TOC entry 8257 (class 0 OID 0)
-- Dependencies: 1366
-- Name: af_is_locked_by_constraint(character varying, character varying, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_locked_by_constraint(character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_locked_by_constraint(character varying, character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_is_locked_by_constraint(character varying, character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_is_locked_by_constraint(character varying, character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_locked_by_constraint(character varying, character varying, character varying) TO "grp-www";


--
-- TOC entry 8259 (class 0 OID 0)
-- Dependencies: 1881
-- Name: af_is_login_inscription_ok(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_login_inscription_ok(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_login_inscription_ok(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_is_login_inscription_ok(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_is_login_inscription_ok(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_login_inscription_ok(character varying) TO "grp-www";


--
-- TOC entry 8261 (class 0 OID 0)
-- Dependencies: 1367
-- Name: af_is_login_ok(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_login_ok(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_login_ok(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_is_login_ok(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_is_login_ok(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_login_ok(character varying) TO "grp-www";


--
-- TOC entry 8262 (class 0 OID 0)
-- Dependencies: 1882
-- Name: af_is_parcours_etape_modifiable(integer, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_parcours_etape_modifiable(integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_parcours_etape_modifiable(integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_is_parcours_etape_modifiable(integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_is_parcours_etape_modifiable(integer, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_parcours_etape_modifiable(integer, integer, character varying) TO "grp-www";


--
-- TOC entry 8264 (class 0 OID 0)
-- Dependencies: 1883
-- Name: af_is_parcours_oriente(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_parcours_oriente(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_parcours_oriente(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_parcours_oriente(integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_parcours_oriente(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_parcours_oriente(integer) TO "grp-www";


--
-- TOC entry 8266 (class 0 OID 0)
-- Dependencies: 1884
-- Name: af_is_resultat_exotlc_critere(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_resultat_exotlc_critere(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_resultat_exotlc_critere(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_resultat_exotlc_critere(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_resultat_exotlc_critere(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_resultat_exotlc_critere(integer, integer) TO "grp-www";


--
-- TOC entry 8268 (class 0 OID 0)
-- Dependencies: 1885
-- Name: af_is_resultat_exotlc_sous_critere(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_resultat_exotlc_sous_critere(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_resultat_exotlc_sous_critere(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_resultat_exotlc_sous_critere(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_resultat_exotlc_sous_critere(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_resultat_exotlc_sous_critere(integer, integer) TO "grp-www";


--
-- TOC entry 8270 (class 0 OID 0)
-- Dependencies: 1368
-- Name: af_is_resultat_formation_parcours_etape(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_resultat_formation_parcours_etape(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_resultat_formation_parcours_etape(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_resultat_formation_parcours_etape(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_resultat_formation_parcours_etape(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_resultat_formation_parcours_etape(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8272 (class 0 OID 0)
-- Dependencies: 1369
-- Name: af_is_serie_aleatoire(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_serie_aleatoire(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_serie_aleatoire(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_serie_aleatoire(integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_serie_aleatoire(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_serie_aleatoire(integer) TO "grp-www";


--
-- TOC entry 8274 (class 0 OID 0)
-- Dependencies: 1370
-- Name: af_is_serie_aleatoire_melangee(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_serie_aleatoire_melangee(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_serie_aleatoire_melangee(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_serie_aleatoire_melangee(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_serie_aleatoire_melangee(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_serie_aleatoire_melangee(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8276 (class 0 OID 0)
-- Dependencies: 1371
-- Name: af_is_serie_bloquante_configuree(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_is_serie_bloquante_configuree(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_is_serie_bloquante_configuree(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_is_serie_bloquante_configuree(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_is_serie_bloquante_configuree(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_is_serie_bloquante_configuree(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8278 (class 0 OID 0)
-- Dependencies: 1372
-- Name: af_maj_alerte(integer, character varying, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_alerte(integer, character varying, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_alerte(integer, character varying, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_alerte(integer, character varying, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_alerte(integer, character varying, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_alerte(integer, character varying, integer, character varying) TO "grp-www";


--
-- TOC entry 8280 (class 0 OID 0)
-- Dependencies: 1373
-- Name: af_maj_bareme(integer, character varying, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_bareme(integer, character varying, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_bareme(integer, character varying, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_bareme(integer, character varying, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_bareme(integer, character varying, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_bareme(integer, character varying, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8282 (class 0 OID 0)
-- Dependencies: 1374
-- Name: af_maj_capacite(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_capacite(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_capacite(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_capacite(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_capacite(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_capacite(integer, character varying) TO "grp-www";


--
-- TOC entry 8284 (class 0 OID 0)
-- Dependencies: 1375
-- Name: af_maj_capacite_titre(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_capacite_titre(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_capacite_titre(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_capacite_titre(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_capacite_titre(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_capacite_titre(integer, character varying) TO "grp-www";


--
-- TOC entry 8286 (class 0 OID 0)
-- Dependencies: 1376
-- Name: af_maj_categorie(integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_maj_categorie(integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_categorie(integer, character varying, boolean) FROM postgres;
GRANT ALL ON FUNCTION af_maj_categorie(integer, character varying, boolean) TO postgres;
GRANT ALL ON FUNCTION af_maj_categorie(integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_categorie(integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 8288 (class 0 OID 0)
-- Dependencies: 1377
-- Name: af_maj_classe(integer, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_classe(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_classe(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_classe(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_classe(integer, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_classe(integer, character varying, integer) TO "grp-www";


--
-- TOC entry 8290 (class 0 OID 0)
-- Dependencies: 1378
-- Name: af_maj_classe_places(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_classe_places(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_classe_places(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_classe_places(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_classe_places(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_classe_places(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8292 (class 0 OID 0)
-- Dependencies: 1379
-- Name: af_maj_commentaire(integer, integer, integer, character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_commentaire(integer, integer, integer, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_commentaire(integer, integer, integer, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_commentaire(integer, integer, integer, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_commentaire(integer, integer, integer, character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_commentaire(integer, integer, integer, character varying, integer, integer) TO "grp-www";


--
-- TOC entry 8294 (class 0 OID 0)
-- Dependencies: 1380
-- Name: af_maj_critere(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_critere(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_critere(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_critere(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_critere(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_critere(integer, character varying) TO "grp-www";


--
-- TOC entry 8296 (class 0 OID 0)
-- Dependencies: 1381
-- Name: af_maj_droit(integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_droit(integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_droit(integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_droit(integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_droit(integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_droit(integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 8298 (class 0 OID 0)
-- Dependencies: 1382
-- Name: af_maj_espace(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_espace(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_espace(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_espace(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_espace(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_espace(integer, character varying) TO "grp-www";


--
-- TOC entry 8300 (class 0 OID 0)
-- Dependencies: 1383
-- Name: af_maj_etape_chat(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_etape_chat(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_etape_chat(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_etape_chat(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_etape_chat(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_etape_chat(integer, character varying) TO "grp-www";


--
-- TOC entry 8302 (class 0 OID 0)
-- Dependencies: 1384
-- Name: af_maj_etape_forum(integer, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_etape_forum(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_etape_forum(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_etape_forum(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_etape_forum(integer, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_etape_forum(integer, character varying, integer) TO "grp-www";


--
-- TOC entry 8304 (class 0 OID 0)
-- Dependencies: 1385
-- Name: af_maj_etape_libelle(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_etape_libelle(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_etape_libelle(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_etape_libelle(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_etape_libelle(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_etape_libelle(integer, character varying) TO "grp-www";


--
-- TOC entry 8305 (class 0 OID 0)
-- Dependencies: 1386
-- Name: af_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_etape_parcours(integer, integer, character varying, boolean, integer, boolean) TO "grp-www";


--
-- TOC entry 8307 (class 0 OID 0)
-- Dependencies: 1387
-- Name: af_maj_etape_ressource(integer, character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_etape_ressource(integer, character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_etape_ressource(integer, character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_etape_ressource(integer, character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_etape_ressource(integer, character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_etape_ressource(integer, character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8309 (class 0 OID 0)
-- Dependencies: 1388
-- Name: af_maj_etapes_libelles(integer[], character varying[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_etapes_libelles(integer[], character varying[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_etapes_libelles(integer[], character varying[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_etapes_libelles(integer[], character varying[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_etapes_libelles(integer[], character varying[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_etapes_libelles(integer[], character varying[]) TO "grp-www";


--
-- TOC entry 8311 (class 0 OID 0)
-- Dependencies: 1389
-- Name: af_maj_evaluation(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_evaluation(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_evaluation(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_evaluation(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_evaluation(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_evaluation(integer, character varying) TO "grp-www";


--
-- TOC entry 8313 (class 0 OID 0)
-- Dependencies: 1390
-- Name: af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_exotlc_mail(integer, character varying, character varying, character varying, character varying, character varying, integer) TO "grp-www";


--
-- TOC entry 8315 (class 0 OID 0)
-- Dependencies: 33
-- Name: af_maj_exotlc_modele_correction(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_exotlc_modele_correction(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_exotlc_modele_correction(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_exotlc_modele_correction(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_exotlc_modele_correction(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_exotlc_modele_correction(integer, integer) TO "grp-www";


--
-- TOC entry 8317 (class 0 OID 0)
-- Dependencies: 1391
-- Name: af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_exotlc_plate_forme(integer, character varying, character varying, character varying, character varying, character varying, character varying, boolean) TO "grp-www";


--
-- TOC entry 8319 (class 0 OID 0)
-- Dependencies: 1392
-- Name: af_maj_fichier(integer, character varying, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_fichier(integer, character varying, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_fichier(integer, character varying, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_fichier(integer, character varying, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_fichier(integer, character varying, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_fichier(integer, character varying, integer, boolean) TO "grp-www";


--
-- TOC entry 8320 (class 0 OID 0)
-- Dependencies: 1886
-- Name: af_maj_fichier_libelle(integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_fichier_libelle(integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_fichier_libelle(integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_fichier_libelle(integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_maj_fichier_libelle(integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_fichier_libelle(integer, text) TO "grp-www";


--
-- TOC entry 8321 (class 0 OID 0)
-- Dependencies: 1393
-- Name: af_maj_fichier_scenario_dynamique(integer, character varying, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_maj_fichier_scenario_dynamique(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_fichier_scenario_dynamique(integer, character varying, integer) FROM postgres;
GRANT ALL ON FUNCTION af_maj_fichier_scenario_dynamique(integer, character varying, integer) TO postgres;
GRANT ALL ON FUNCTION af_maj_fichier_scenario_dynamique(integer, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_fichier_scenario_dynamique(integer, character varying, integer) TO "grp-www";


--
-- TOC entry 8322 (class 0 OID 0)
-- Dependencies: 1394
-- Name: af_maj_fichier_scenario_dynamique_bloc(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_fichier_scenario_dynamique_bloc(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_fichier_scenario_dynamique_bloc(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_fichier_scenario_dynamique_bloc(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_fichier_scenario_dynamique_bloc(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_fichier_scenario_dynamique_bloc(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8324 (class 0 OID 0)
-- Dependencies: 1395
-- Name: af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_fichier_texte(integer, character varying, character varying, character varying, character varying, text, boolean) TO "grp-www";


--
-- TOC entry 8326 (class 0 OID 0)
-- Dependencies: 1396
-- Name: af_maj_fichiers_connection(integer[], boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_fichiers_connection(integer[], boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_fichiers_connection(integer[], boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_fichiers_connection(integer[], boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_fichiers_connection(integer[], boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_fichiers_connection(integer[], boolean) TO "grp-www";


--
-- TOC entry 8328 (class 0 OID 0)
-- Dependencies: 1397
-- Name: af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_fichiers_scenarios_dynamiques_libelles(integer[], text[]) TO "grp-www";


--
-- TOC entry 8329 (class 0 OID 0)
-- Dependencies: 1398
-- Name: af_maj_filiere(integer, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_filiere(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_filiere(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_filiere(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_filiere(integer, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_filiere(integer, character varying, integer) TO "grp-www";


--
-- TOC entry 8331 (class 0 OID 0)
-- Dependencies: 1399
-- Name: af_maj_formation(integer, character varying, date, date, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_formation(integer, character varying, date, date, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_formation(integer, character varying, date, date, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_formation(integer, character varying, date, date, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_formation(integer, character varying, date, date, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_formation(integer, character varying, date, date, integer) TO "grp-www";


--
-- TOC entry 8333 (class 0 OID 0)
-- Dependencies: 1400
-- Name: af_maj_formation_dates(integer, date, date); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_formation_dates(integer, date, date) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_formation_dates(integer, date, date) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_formation_dates(integer, date, date) TO pgsql;
GRANT ALL ON FUNCTION af_maj_formation_dates(integer, date, date) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_formation_dates(integer, date, date) TO "grp-www";


--
-- TOC entry 8335 (class 0 OID 0)
-- Dependencies: 1401
-- Name: af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer, timestamp without time zone) TO "grp-www";


--
-- TOC entry 8337 (class 0 OID 0)
-- Dependencies: 1402
-- Name: af_maj_formation_langues(integer, integer[], integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_formation_langues(integer, integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_formation_langues(integer, integer[], integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_formation_langues(integer, integer[], integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_formation_langues(integer, integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_formation_langues(integer, integer[], integer[]) TO "grp-www";


--
-- TOC entry 8339 (class 0 OID 0)
-- Dependencies: 1403
-- Name: af_maj_formation_libelle(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_formation_libelle(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_formation_libelle(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_formation_libelle(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_formation_libelle(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_formation_libelle(integer, character varying) TO "grp-www";


--
-- TOC entry 8341 (class 0 OID 0)
-- Dependencies: 1404
-- Name: af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_formation_ressource(integer, integer, integer, integer, character varying, timestamp without time zone, timestamp without time zone, interval, text, integer, integer) TO "grp-www";


--
-- TOC entry 8343 (class 0 OID 0)
-- Dependencies: 1405
-- Name: af_maj_formation_ressources_fusionnees(integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_formation_ressources_fusionnees(integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_formation_ressources_fusionnees(integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_formation_ressources_fusionnees(integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_formation_ressources_fusionnees(integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_formation_ressources_fusionnees(integer, boolean) TO "grp-www";


--
-- TOC entry 8345 (class 0 OID 0)
-- Dependencies: 1407
-- Name: af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer) TO "grp-www";


--
-- TOC entry 8347 (class 0 OID 0)
-- Dependencies: 1406
-- Name: af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_forum(integer, character varying, character varying, boolean, character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8348 (class 0 OID 0)
-- Dependencies: 34
-- Name: af_maj_forum_environnement(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, integer, integer, boolean, boolean, boolean, boolean, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_forum_environnement(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, integer, integer, boolean, boolean, boolean, boolean, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_forum_environnement(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, integer, integer, boolean, boolean, boolean, boolean, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_forum_environnement(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, integer, integer, boolean, boolean, boolean, boolean, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_forum_environnement(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, integer, integer, boolean, boolean, boolean, boolean, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_forum_environnement(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, boolean, boolean, boolean, boolean, boolean, integer, integer, boolean, boolean, boolean, boolean, character varying) TO "grp-www";


--
-- TOC entry 8350 (class 0 OID 0)
-- Dependencies: 1408
-- Name: af_maj_ftb(integer, text, boolean, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_ftb(integer, text, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_ftb(integer, text, boolean, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_ftb(integer, text, boolean, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_ftb(integer, text, boolean, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_ftb(integer, text, boolean, boolean) TO "grp-www";


--
-- TOC entry 8352 (class 0 OID 0)
-- Dependencies: 1409
-- Name: af_maj_grille(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_grille(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_grille(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_grille(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_grille(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_grille(integer, character varying) TO "grp-www";


--
-- TOC entry 8354 (class 0 OID 0)
-- Dependencies: 1410
-- Name: af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8355 (class 0 OID 0)
-- Dependencies: 1411
-- Name: af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer) TO "grp-www";


--
-- TOC entry 8357 (class 0 OID 0)
-- Dependencies: 1412
-- Name: af_maj_individu_date_deconnexion(integer, timestamp without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_individu_date_deconnexion(integer, timestamp without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_individu_date_deconnexion(integer, timestamp without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_individu_date_deconnexion(integer, timestamp without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_maj_individu_date_deconnexion(integer, timestamp without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_individu_date_deconnexion(integer, timestamp without time zone) TO "grp-www";


--
-- TOC entry 8359 (class 0 OID 0)
-- Dependencies: 1413
-- Name: af_maj_individu_session(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_individu_session(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_individu_session(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_individu_session(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_individu_session(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_individu_session(integer, integer) TO "grp-www";


--
-- TOC entry 8361 (class 0 OID 0)
-- Dependencies: 1414
-- Name: af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_inscription(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8363 (class 0 OID 0)
-- Dependencies: 1415
-- Name: af_maj_intervention(integer, character varying, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_intervention(integer, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_intervention(integer, character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_intervention(integer, character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_intervention(integer, character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_intervention(integer, character varying, character varying) TO "grp-www";


--
-- TOC entry 8365 (class 0 OID 0)
-- Dependencies: 1416
-- Name: af_maj_langue_libelle(integer, integer, integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_langue_libelle(integer, integer, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_langue_libelle(integer, integer, integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_langue_libelle(integer, integer, integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_maj_langue_libelle(integer, integer, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_langue_libelle(integer, integer, integer, text) TO "grp-www";


--
-- TOC entry 8367 (class 0 OID 0)
-- Dependencies: 1417
-- Name: af_maj_langue_libelles(integer, integer, integer[], text[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_langue_libelles(integer, integer, integer[], text[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_langue_libelles(integer, integer, integer[], text[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_langue_libelles(integer, integer, integer[], text[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_langue_libelles(integer, integer, integer[], text[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_langue_libelles(integer, integer, integer[], text[]) TO "grp-www";


--
-- TOC entry 8369 (class 0 OID 0)
-- Dependencies: 1418
-- Name: af_maj_modele_correction_criteres_note(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_modele_correction_criteres_note(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_modele_correction_criteres_note(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_modele_correction_criteres_note(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_modele_correction_criteres_note(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_modele_correction_criteres_note(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8371 (class 0 OID 0)
-- Dependencies: 1419
-- Name: af_maj_organisme(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_organisme(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_organisme(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_organisme(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_organisme(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_organisme(integer, character varying) TO "grp-www";


--
-- TOC entry 8372 (class 0 OID 0)
-- Dependencies: 1420
-- Name: af_maj_parcours_duree(integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_parcours_duree(integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_parcours_duree(integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_duree(integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_duree(integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_parcours_duree(integer, boolean) TO "grp-www";


--
-- TOC entry 8373 (class 0 OID 0)
-- Dependencies: 1421
-- Name: af_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_parcours_etape(integer, integer, integer, boolean, integer, boolean) TO "grp-www";


--
-- TOC entry 8374 (class 0 OID 0)
-- Dependencies: 1422
-- Name: af_maj_parcours_etape_duree(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_parcours_etape_duree(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_parcours_etape_duree(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etape_duree(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etape_duree(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_parcours_etape_duree(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8375 (class 0 OID 0)
-- Dependencies: 1887
-- Name: af_maj_parcours_etape_ordre(integer, integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_parcours_etape_ordre(integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_parcours_etape_ordre(integer, integer, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etape_ordre(integer, integer, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etape_ordre(integer, integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_parcours_etape_ordre(integer, integer, integer, boolean) TO "grp-www";


--
-- TOC entry 8376 (class 0 OID 0)
-- Dependencies: 1423
-- Name: af_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_parcours_etape_type_etape_personnalise(integer, integer, character varying) TO "grp-www";


--
-- TOC entry 8377 (class 0 OID 0)
-- Dependencies: 1424
-- Name: af_maj_parcours_etapes_duree_type(integer, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_parcours_etapes_duree_type(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_parcours_etapes_duree_type(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etapes_duree_type(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_etapes_duree_type(integer, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_parcours_etapes_duree_type(integer, character varying, integer) TO "grp-www";


--
-- TOC entry 8378 (class 0 OID 0)
-- Dependencies: 1425
-- Name: af_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_parcours_oriente(integer, character varying, integer[], integer[], integer, integer[]) TO "grp-www";


--
-- TOC entry 8379 (class 0 OID 0)
-- Dependencies: 1426
-- Name: af_maj_parcours_type_etape_personnalise(integer, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_parcours_type_etape_personnalise(integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_parcours_type_etape_personnalise(integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_type_etape_personnalise(integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_parcours_type_etape_personnalise(integer, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_parcours_type_etape_personnalise(integer, integer, character varying) TO "grp-www";


--
-- TOC entry 8380 (class 0 OID 0)
-- Dependencies: 1427
-- Name: af_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_positionnement(integer, character varying, integer, integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8381 (class 0 OID 0)
-- Dependencies: 1888
-- Name: af_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8382 (class 0 OID 0)
-- Dependencies: 1428
-- Name: af_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_positionnement_nb_evaluations_a_generer(integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8383 (class 0 OID 0)
-- Dependencies: 1429
-- Name: af_maj_positionnement_question_positionnement_solution(integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_positionnement_question_positionnement_solution(integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_positionnement_question_positionnement_solution(integer, integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_positionnement_question_positionnement_solution(integer, integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_positionnement_question_positionnement_solution(integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_positionnement_question_positionnement_solution(integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8385 (class 0 OID 0)
-- Dependencies: 1430
-- Name: af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) TO "grp-www";


--
-- TOC entry 8387 (class 0 OID 0)
-- Dependencies: 1431
-- Name: af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_presentiel_note_individu_date(integer, integer, integer, integer, integer, timestamp without time zone, text, integer, integer) TO "grp-www";


--
-- TOC entry 8389 (class 0 OID 0)
-- Dependencies: 1432
-- Name: af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_presentiel_stagiaire_grille(integer, integer, integer, boolean) TO "grp-www";


--
-- TOC entry 8391 (class 0 OID 0)
-- Dependencies: 1433
-- Name: af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_qrc(integer, character varying, character varying, boolean, integer[], integer[], integer[]) TO "grp-www";


--
-- TOC entry 8392 (class 0 OID 0)
-- Dependencies: 1889
-- Name: af_maj_qrc_question_solution(integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_qrc_question_solution(integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_qrc_question_solution(integer, integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_qrc_question_solution(integer, integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_qrc_question_solution(integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_qrc_question_solution(integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8393 (class 0 OID 0)
-- Dependencies: 1434
-- Name: af_maj_qsrc(integer, character varying, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_qsrc(integer, character varying, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_qsrc(integer, character varying, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_qsrc(integer, character varying, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_qsrc(integer, character varying, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_qsrc(integer, character varying, character varying, boolean) TO "grp-www";


--
-- TOC entry 8394 (class 0 OID 0)
-- Dependencies: 1435
-- Name: af_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_qsrc_question(integer, integer, character varying, integer, integer, integer, boolean) TO "grp-www";


--
-- TOC entry 8395 (class 0 OID 0)
-- Dependencies: 1436
-- Name: af_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_question_positionnement(integer, integer, character varying, integer, integer, integer, boolean) TO "grp-www";


--
-- TOC entry 8396 (class 0 OID 0)
-- Dependencies: 1437
-- Name: af_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8398 (class 0 OID 0)
-- Dependencies: 1438
-- Name: af_maj_question_reponse_element(integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_question_reponse_element(integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_question_reponse_element(integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_element(integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_element(integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_question_reponse_element(integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 8400 (class 0 OID 0)
-- Dependencies: 1439
-- Name: af_maj_question_reponse_element_media(integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_question_reponse_element_media(integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_question_reponse_element_media(integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_element_media(integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_element_media(integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_question_reponse_element_media(integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8402 (class 0 OID 0)
-- Dependencies: 1440
-- Name: af_maj_question_reponse_media(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_question_reponse_media(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_question_reponse_media(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_media(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_media(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_question_reponse_media(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8404 (class 0 OID 0)
-- Dependencies: 1890
-- Name: af_maj_question_reponse_solution(integer, integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_question_reponse_solution(integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_question_reponse_solution(integer, integer, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_solution(integer, integer, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_question_reponse_solution(integer, integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_question_reponse_solution(integer, integer, integer, boolean) TO "grp-www";


--
-- TOC entry 8406 (class 0 OID 0)
-- Dependencies: 1891
-- Name: af_maj_ressource(integer, integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_ressource(integer, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_ressource(integer, integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_ressource(integer, integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_maj_ressource(integer, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_ressource(integer, integer, text) TO "grp-www";


--
-- TOC entry 8407 (class 0 OID 0)
-- Dependencies: 1441
-- Name: af_maj_resultat_debut(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_resultat_debut(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_resultat_debut(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_debut(integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_debut(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_resultat_debut(integer) TO "grp-www";


--
-- TOC entry 8409 (class 0 OID 0)
-- Dependencies: 1442
-- Name: af_maj_resultat_exotlc(integer, text, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_resultat_exotlc(integer, text, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_resultat_exotlc(integer, text, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc(integer, text, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc(integer, text, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc(integer, text, boolean) TO "grp-www";


--
-- TOC entry 8411 (class 0 OID 0)
-- Dependencies: 1443
-- Name: af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc_critere(bigint, integer, integer, integer, text) TO "grp-www";


--
-- TOC entry 8412 (class 0 OID 0)
-- Dependencies: 1444
-- Name: af_maj_resultat_exotlc_plateforme(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_resultat_exotlc_plateforme(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_resultat_exotlc_plateforme(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc_plateforme(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc_plateforme(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc_plateforme(bigint, integer) TO "grp-www";


--
-- TOC entry 8414 (class 0 OID 0)
-- Dependencies: 1445
-- Name: af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_resultat_exotlc_sous_critere(bigint, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8415 (class 0 OID 0)
-- Dependencies: 1892
-- Name: af_maj_resultat_fin(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_resultat_fin(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_resultat_fin(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_fin(integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_resultat_fin(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_resultat_fin(integer) TO "grp-www";


--
-- TOC entry 8417 (class 0 OID 0)
-- Dependencies: 1446
-- Name: af_maj_salle(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_salle(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_salle(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_salle(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_maj_salle(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_salle(integer, character varying) TO "grp-www";


--
-- TOC entry 8419 (class 0 OID 0)
-- Dependencies: 1447
-- Name: af_maj_section(integer, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_section(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_section(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_section(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_section(integer, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_section(integer, character varying, integer) TO "grp-www";


--
-- TOC entry 8421 (class 0 OID 0)
-- Dependencies: 1448
-- Name: af_maj_serie(integer, character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_serie(integer, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_serie(integer, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_serie(integer, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_serie(integer, character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_serie(integer, character varying, integer, integer) TO "grp-www";


--
-- TOC entry 8423 (class 0 OID 0)
-- Dependencies: 1449
-- Name: af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) TO "grp-www";


--
-- TOC entry 8425 (class 0 OID 0)
-- Dependencies: 1450
-- Name: af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8427 (class 0 OID 0)
-- Dependencies: 1452
-- Name: af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8428 (class 0 OID 0)
-- Dependencies: 1451
-- Name: af_maj_serie_evaluation_ordre(integer, integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_serie_evaluation_ordre(integer, integer, integer, boolean) TO "grp-www";


--
-- TOC entry 8429 (class 0 OID 0)
-- Dependencies: 1893
-- Name: af_maj_src(integer, character varying, character varying, boolean, integer[], integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_src(integer, character varying, character varying, boolean, integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_src(integer, character varying, character varying, boolean, integer[], integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_src(integer, character varying, character varying, boolean, integer[], integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_maj_src(integer, character varying, character varying, boolean, integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_src(integer, character varying, character varying, boolean, integer[], integer[]) TO "grp-www";


--
-- TOC entry 8430 (class 0 OID 0)
-- Dependencies: 1894
-- Name: af_maj_test(integer, character varying, boolean, boolean, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_test(integer, character varying, boolean, boolean, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_test(integer, character varying, boolean, boolean, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_test(integer, character varying, boolean, boolean, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_test(integer, character varying, boolean, boolean, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_test(integer, character varying, boolean, boolean, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8432 (class 0 OID 0)
-- Dependencies: 1453
-- Name: af_maj_theme(integer, character varying); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_maj_theme(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_theme(integer, character varying) FROM postgres;
GRANT ALL ON FUNCTION af_maj_theme(integer, character varying) TO postgres;
GRANT ALL ON FUNCTION af_maj_theme(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_theme(integer, character varying) TO "grp-www";


--
-- TOC entry 8433 (class 0 OID 0)
-- Dependencies: 35
-- Name: af_maj_theme_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_maj_theme_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_maj_theme_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_maj_theme_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_maj_theme_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_maj_theme_individu(integer, integer) TO "grp-www";


--
-- TOC entry 8435 (class 0 OID 0)
-- Dependencies: 1454
-- Name: af_set_alerte(character varying, integer, date, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_alerte(character varying, integer, date, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_alerte(character varying, integer, date, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_alerte(character varying, integer, date, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_alerte(character varying, integer, date, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_alerte(character varying, integer, date, integer, character varying) TO "grp-www";


--
-- TOC entry 8437 (class 0 OID 0)
-- Dependencies: 1455
-- Name: af_set_bareme(character varying, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_bareme(character varying, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_bareme(character varying, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_bareme(character varying, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_bareme(character varying, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_bareme(character varying, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8439 (class 0 OID 0)
-- Dependencies: 1456
-- Name: af_set_capacite(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_capacite(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_capacite(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_capacite(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_capacite(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_capacite(character varying) TO "grp-www";


--
-- TOC entry 8441 (class 0 OID 0)
-- Dependencies: 1457
-- Name: af_set_capacite_titre(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_capacite_titre(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_capacite_titre(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_capacite_titre(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_capacite_titre(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_capacite_titre(character varying) TO "grp-www";


--
-- TOC entry 8443 (class 0 OID 0)
-- Dependencies: 1458
-- Name: af_set_capacite_titre_capacite(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_capacite_titre_capacite(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_capacite_titre_capacite(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_capacite_titre_capacite(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_capacite_titre_capacite(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_capacite_titre_capacite(integer, integer) TO "grp-www";


--
-- TOC entry 8445 (class 0 OID 0)
-- Dependencies: 1895
-- Name: af_set_categorie(character varying, character varying, boolean); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_categorie(character varying, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_categorie(character varying, character varying, boolean) FROM postgres;
GRANT ALL ON FUNCTION af_set_categorie(character varying, character varying, boolean) TO postgres;
GRANT ALL ON FUNCTION af_set_categorie(character varying, character varying, boolean) TO www;
GRANT ALL ON FUNCTION af_set_categorie(character varying, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_categorie(character varying, character varying, boolean) TO "grp-www";


--
-- TOC entry 8447 (class 0 OID 0)
-- Dependencies: 1896
-- Name: af_set_categorie_element_theme(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_categorie_element_theme(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_categorie_element_theme(integer, integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_categorie_element_theme(integer, integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_categorie_element_theme(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_categorie_element_theme(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8449 (class 0 OID 0)
-- Dependencies: 1459
-- Name: af_set_categorie_fichier_glossaire_theme(character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_categorie_fichier_glossaire_theme(character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_categorie_fichier_glossaire_theme(character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_categorie_fichier_glossaire_theme(character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_categorie_fichier_glossaire_theme(character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_categorie_fichier_glossaire_theme(character varying, integer, integer) TO "grp-www";


--
-- TOC entry 8451 (class 0 OID 0)
-- Dependencies: 1460
-- Name: af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_categorie_fichier_texte_theme(character varying, character varying, character varying, character varying, text, boolean, integer, integer) TO "grp-www";


--
-- TOC entry 8453 (class 0 OID 0)
-- Dependencies: 1461
-- Name: af_set_categorie_fichier_theme(character varying, boolean, integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_categorie_fichier_theme(character varying, boolean, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_categorie_fichier_theme(character varying, boolean, integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_categorie_fichier_theme(character varying, boolean, integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_categorie_fichier_theme(character varying, boolean, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_categorie_fichier_theme(character varying, boolean, integer, integer) TO "grp-www";


--
-- TOC entry 8455 (class 0 OID 0)
-- Dependencies: 1462
-- Name: af_set_categorie_sondage_element(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_categorie_sondage_element(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_categorie_sondage_element(integer, integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_categorie_sondage_element(integer, integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_categorie_sondage_element(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_categorie_sondage_element(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8456 (class 0 OID 0)
-- Dependencies: 1463
-- Name: af_set_categories_elements_theme(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_categories_elements_theme(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_categories_elements_theme(integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_categories_elements_theme(integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_categories_elements_theme(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_categories_elements_theme(integer) TO "grp-www";


--
-- TOC entry 8458 (class 0 OID 0)
-- Dependencies: 1464
-- Name: af_set_classe(character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_classe(character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_classe(character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_classe(character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_classe(character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_classe(character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8460 (class 0 OID 0)
-- Dependencies: 1465
-- Name: af_set_classe_droit(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_classe_droit(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_classe_droit(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_classe_droit(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_classe_droit(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_classe_droit(integer, integer) TO "grp-www";


--
-- TOC entry 8462 (class 0 OID 0)
-- Dependencies: 1897
-- Name: af_set_classe_individu(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_classe_individu(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_classe_individu(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_classe_individu(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_classe_individu(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_classe_individu(integer, integer) TO "grp-www";


--
-- TOC entry 8463 (class 0 OID 0)
-- Dependencies: 1466
-- Name: af_set_classe_individu(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_classe_individu() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_classe_individu() FROM pgsql;
GRANT ALL ON FUNCTION af_set_classe_individu() TO pgsql;
GRANT ALL ON FUNCTION af_set_classe_individu() TO PUBLIC;
GRANT ALL ON FUNCTION af_set_classe_individu() TO "grp-www";


--
-- TOC entry 8465 (class 0 OID 0)
-- Dependencies: 1467
-- Name: af_set_commentaire(integer, integer, integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_commentaire(integer, integer, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_commentaire(integer, integer, integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_set_commentaire(integer, integer, integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_set_commentaire(integer, integer, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_commentaire(integer, integer, integer, text) TO "grp-www";


--
-- TOC entry 8467 (class 0 OID 0)
-- Dependencies: 1468
-- Name: af_set_critere(character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_critere(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_critere(character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_critere(character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_critere(character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_critere(character varying, integer) TO "grp-www";


--
-- TOC entry 8469 (class 0 OID 0)
-- Dependencies: 1469
-- Name: af_set_espace(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_espace(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_espace(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_espace(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_espace(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_espace(character varying) TO "grp-www";


--
-- TOC entry 8471 (class 0 OID 0)
-- Dependencies: 1470
-- Name: af_set_etape(character varying, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_etape(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_etape(character varying, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_etape(character varying, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_etape(character varying, integer) TO www;
GRANT ALL ON FUNCTION af_set_etape(character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_etape(character varying, integer) TO "grp-www";


--
-- TOC entry 8473 (class 0 OID 0)
-- Dependencies: 1471
-- Name: af_set_etape_chat(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_etape_chat(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_etape_chat(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_etape_chat(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_etape_chat(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_etape_chat(character varying) TO "grp-www";


--
-- TOC entry 8475 (class 0 OID 0)
-- Dependencies: 1472
-- Name: af_set_etape_forum(character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_etape_forum(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_etape_forum(character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_etape_forum(character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_etape_forum(character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_etape_forum(character varying, integer) TO "grp-www";


--
-- TOC entry 8476 (class 0 OID 0)
-- Dependencies: 1473
-- Name: af_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_etape_parcours_oriente_configuration(integer, integer[], integer[], integer[]) TO "grp-www";


--
-- TOC entry 8477 (class 0 OID 0)
-- Dependencies: 1474
-- Name: af_set_etape_ressource(character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_etape_ressource(character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_etape_ressource(character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_etape_ressource(character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_etape_ressource(character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_etape_ressource(character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8479 (class 0 OID 0)
-- Dependencies: 1898
-- Name: af_set_evaluation(character varying, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_evaluation(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_evaluation(character varying, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_evaluation(character varying, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_evaluation(character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_evaluation(character varying, integer) TO "grp-www";


--
-- TOC entry 8481 (class 0 OID 0)
-- Dependencies: 1475
-- Name: af_set_exotlc_corrections(integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_exotlc_corrections(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_exotlc_corrections(integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_corrections(integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_corrections(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_exotlc_corrections(integer, integer[]) TO "grp-www";


--
-- TOC entry 8483 (class 0 OID 0)
-- Dependencies: 1476
-- Name: af_set_exotlc_fichiers(integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_exotlc_fichiers(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_exotlc_fichiers(integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_fichiers(integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_fichiers(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_exotlc_fichiers(integer, integer[]) TO "grp-www";


--
-- TOC entry 8485 (class 0 OID 0)
-- Dependencies: 1477
-- Name: af_set_exotlc_fichiers_all(integer, integer[], integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_exotlc_fichiers_all(integer, integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_exotlc_fichiers_all(integer, integer[], integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_fichiers_all(integer, integer[], integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_fichiers_all(integer, integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_exotlc_fichiers_all(integer, integer[], integer[]) TO "grp-www";


--
-- TOC entry 8487 (class 0 OID 0)
-- Dependencies: 1478
-- Name: af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_exotlc_mail(character varying, character varying, character varying, character varying, character varying, integer) TO "grp-www";


--
-- TOC entry 8489 (class 0 OID 0)
-- Dependencies: 1479
-- Name: af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_exotlc_plateforme(character varying, character varying, character varying, character varying, character varying, character varying, boolean) TO "grp-www";


--
-- TOC entry 8490 (class 0 OID 0)
-- Dependencies: 1480
-- Name: af_set_fichier(character varying, integer, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_fichier(character varying, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_fichier(character varying, integer, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_set_fichier(character varying, integer, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_set_fichier(character varying, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_fichier(character varying, integer, boolean) TO "grp-www";


--
-- TOC entry 8492 (class 0 OID 0)
-- Dependencies: 1481
-- Name: af_set_fichier_icone(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_fichier_icone(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_fichier_icone(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_fichier_icone(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_fichier_icone(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_fichier_icone(character varying) TO "grp-www";


--
-- TOC entry 8493 (class 0 OID 0)
-- Dependencies: 1482
-- Name: af_set_fichier_metadata(integer, text, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_fichier_metadata(integer, text, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_fichier_metadata(integer, text, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_fichier_metadata(integer, text, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_fichier_metadata(integer, text, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_fichier_metadata(integer, text, integer) TO "grp-www";


--
-- TOC entry 8494 (class 0 OID 0)
-- Dependencies: 36
-- Name: af_set_fichier_photo(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_fichier_photo(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_fichier_photo(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_fichier_photo(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_fichier_photo(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_fichier_photo(character varying) TO "grp-www";


--
-- TOC entry 8495 (class 0 OID 0)
-- Dependencies: 1483
-- Name: af_set_fichier_scenario_dynamique(character varying, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_fichier_scenario_dynamique(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_fichier_scenario_dynamique(character varying, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_fichier_scenario_dynamique(character varying, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_fichier_scenario_dynamique(character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_fichier_scenario_dynamique(character varying, integer) TO "grp-www";


--
-- TOC entry 8496 (class 0 OID 0)
-- Dependencies: 1484
-- Name: af_set_fichier_scenario_dynamique_bloc(integer, integer, integer, text[], text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_fichier_scenario_dynamique_bloc(integer, integer, integer, text[], text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_fichier_scenario_dynamique_bloc(integer, integer, integer, text[], text) FROM pgsql;
GRANT ALL ON FUNCTION af_set_fichier_scenario_dynamique_bloc(integer, integer, integer, text[], text) TO pgsql;
GRANT ALL ON FUNCTION af_set_fichier_scenario_dynamique_bloc(integer, integer, integer, text[], text) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_fichier_scenario_dynamique_bloc(integer, integer, integer, text[], text) TO "grp-www";


--
-- TOC entry 8497 (class 0 OID 0)
-- Dependencies: 1485
-- Name: af_set_filiere(character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_filiere(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_filiere(character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_filiere(character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_filiere(character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_filiere(character varying, integer) TO "grp-www";


--
-- TOC entry 8498 (class 0 OID 0)
-- Dependencies: 1486
-- Name: af_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_formation(character varying, date, date, integer, integer, integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8500 (class 0 OID 0)
-- Dependencies: 1899
-- Name: af_set_formation_droit(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_formation_droit(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_formation_droit(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_formation_droit(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_formation_droit(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_formation_droit(integer, integer) TO "grp-www";


--
-- TOC entry 8502 (class 0 OID 0)
-- Dependencies: 1900
-- Name: af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_formation_evenement(integer, character varying, timestamp without time zone, time without time zone, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8504 (class 0 OID 0)
-- Dependencies: 1487
-- Name: af_set_formation_forum(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_formation_forum(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_formation_forum(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_formation_forum(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_formation_forum(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_formation_forum(integer, integer) TO "grp-www";


--
-- TOC entry 8505 (class 0 OID 0)
-- Dependencies: 1488
-- Name: af_set_formation_langue(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_formation_langue(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_formation_langue(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_formation_langue(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_formation_langue(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_formation_langue(integer, integer) TO "grp-www";


--
-- TOC entry 8506 (class 0 OID 0)
-- Dependencies: 1489
-- Name: af_set_formation_participants(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_formation_participants(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_formation_participants(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_formation_participants(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_formation_participants(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_formation_participants(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8508 (class 0 OID 0)
-- Dependencies: 1490
-- Name: af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_formation_ressource(integer, integer, timestamp without time zone, timestamp without time zone, interval, integer, integer) TO "grp-www";


--
-- TOC entry 8510 (class 0 OID 0)
-- Dependencies: 1491
-- Name: af_set_formation_session(integer, time without time zone, time without time zone); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_formation_session(integer, time without time zone, time without time zone) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_formation_session(integer, time without time zone, time without time zone) FROM pgsql;
GRANT ALL ON FUNCTION af_set_formation_session(integer, time without time zone, time without time zone) TO pgsql;
GRANT ALL ON FUNCTION af_set_formation_session(integer, time without time zone, time without time zone) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_formation_session(integer, time without time zone, time without time zone) TO "grp-www";


--
-- TOC entry 8512 (class 0 OID 0)
-- Dependencies: 1492
-- Name: af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_forum(character varying, character varying, boolean, character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8514 (class 0 OID 0)
-- Dependencies: 1493
-- Name: af_set_ftb(text, boolean, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_ftb(text, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_ftb(text, boolean, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_set_ftb(text, boolean, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_set_ftb(text, boolean, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_ftb(text, boolean, boolean) TO "grp-www";


--
-- TOC entry 8516 (class 0 OID 0)
-- Dependencies: 37
-- Name: af_set_glossaire(character varying); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_glossaire(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_glossaire(character varying) FROM postgres;
GRANT ALL ON FUNCTION af_set_glossaire(character varying) TO postgres;
GRANT ALL ON FUNCTION af_set_glossaire(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_glossaire(character varying) TO "grp-www";


--
-- TOC entry 8518 (class 0 OID 0)
-- Dependencies: 38
-- Name: af_set_glossaire_fichier(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_glossaire_fichier(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_glossaire_fichier(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_glossaire_fichier(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_glossaire_fichier(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_glossaire_fichier(integer, integer) TO "grp-www";


--
-- TOC entry 8520 (class 0 OID 0)
-- Dependencies: 1494
-- Name: af_set_grille(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_grille(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_grille(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_grille(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_grille(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_grille(character varying) TO "grp-www";


--
-- TOC entry 8522 (class 0 OID 0)
-- Dependencies: 1495
-- Name: af_set_grille_capacite_titre(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_grille_capacite_titre(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_grille_capacite_titre(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_grille_capacite_titre(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_grille_capacite_titre(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_grille_capacite_titre(integer, integer) TO "grp-www";


--
-- TOC entry 8524 (class 0 OID 0)
-- Dependencies: 1496
-- Name: af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_individu(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8526 (class 0 OID 0)
-- Dependencies: 1497
-- Name: af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_individu_connexion(integer, timestamp without time zone, timestamp without time zone, character varying) TO "grp-www";


--
-- TOC entry 8528 (class 0 OID 0)
-- Dependencies: 1498
-- Name: af_set_individu_droit_classe(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_individu_droit_classe(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_individu_droit_classe(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_individu_droit_classe(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_individu_droit_classe(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_individu_droit_classe(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8530 (class 0 OID 0)
-- Dependencies: 1499
-- Name: af_set_individu_droits_classe(integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_individu_droits_classe(integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_individu_droits_classe(integer, integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_individu_droits_classe(integer, integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_individu_droits_classe(integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_individu_droits_classe(integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8532 (class 0 OID 0)
-- Dependencies: 1500
-- Name: af_set_individu_session(integer, character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_individu_session(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_individu_session(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_individu_session(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_individu_session(integer, character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_individu_session(integer, character varying, integer) TO "grp-www";


--
-- TOC entry 8534 (class 0 OID 0)
-- Dependencies: 1501
-- Name: af_set_individu_type(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_individu_type(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_individu_type(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_individu_type(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_individu_type(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_individu_type(integer, integer) TO "grp-www";


--
-- TOC entry 8536 (class 0 OID 0)
-- Dependencies: 1502
-- Name: af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_inscription(character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8537 (class 0 OID 0)
-- Dependencies: 39
-- Name: af_set_inscriptions(integer, character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_inscriptions(integer, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_inscriptions(integer, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_inscriptions(integer, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_inscriptions(integer, character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_inscriptions(integer, character varying, integer, integer) TO "grp-www";


--
-- TOC entry 8539 (class 0 OID 0)
-- Dependencies: 1503
-- Name: af_set_intervention(character varying, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_intervention(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_intervention(character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_intervention(character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_intervention(character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_intervention(character varying, character varying) TO "grp-www";


--
-- TOC entry 8541 (class 0 OID 0)
-- Dependencies: 1505
-- Name: af_set_langue_message(integer, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_langue_message(integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_langue_message(integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_langue_message(integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_langue_message(integer, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_langue_message(integer, integer, character varying) TO "grp-www";


--
-- TOC entry 8543 (class 0 OID 0)
-- Dependencies: 1504
-- Name: af_set_langue_message(integer, integer, integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_langue_message(integer, integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_langue_message(integer, integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_langue_message(integer, integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_langue_message(integer, integer, integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_langue_message(integer, integer, integer, character varying) TO "grp-www";


--
-- TOC entry 8545 (class 0 OID 0)
-- Dependencies: 1506
-- Name: af_set_langues_messages_incomplets(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_langues_messages_incomplets() FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_langues_messages_incomplets() FROM pgsql;
GRANT ALL ON FUNCTION af_set_langues_messages_incomplets() TO pgsql;
GRANT ALL ON FUNCTION af_set_langues_messages_incomplets() TO PUBLIC;
GRANT ALL ON FUNCTION af_set_langues_messages_incomplets() TO "grp-www";


--
-- TOC entry 8547 (class 0 OID 0)
-- Dependencies: 1507
-- Name: af_set_media(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_media(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_media(integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_media(integer) TO postgres;
GRANT ALL ON FUNCTION af_set_media(integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_media(integer) TO "grp-www";


--
-- TOC entry 8549 (class 0 OID 0)
-- Dependencies: 1901
-- Name: af_set_media_question_reponse_element(integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_media_question_reponse_element(integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_media_question_reponse_element(integer, integer, integer, integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_media_question_reponse_element(integer, integer, integer, integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_media_question_reponse_element(integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_media_question_reponse_element(integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8551 (class 0 OID 0)
-- Dependencies: 1508
-- Name: af_set_modele_correction(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_modele_correction(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_modele_correction(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_modele_correction(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_modele_correction(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_modele_correction(character varying) TO "grp-www";


--
-- TOC entry 8553 (class 0 OID 0)
-- Dependencies: 1509
-- Name: af_set_modele_correction_criteres(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_modele_correction_criteres(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_modele_correction_criteres(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_modele_correction_criteres(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_modele_correction_criteres(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_modele_correction_criteres(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8555 (class 0 OID 0)
-- Dependencies: 1510
-- Name: af_set_organisme(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_organisme(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_organisme(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_organisme(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_organisme(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_organisme(character varying) TO "grp-www";


--
-- TOC entry 8557 (class 0 OID 0)
-- Dependencies: 1511
-- Name: af_set_page_annuaire_configuration(integer, integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_page_annuaire_configuration(integer, integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_page_annuaire_configuration(integer, integer, integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_page_annuaire_configuration(integer, integer, integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_page_annuaire_configuration(integer, integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_page_annuaire_configuration(integer, integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8559 (class 0 OID 0)
-- Dependencies: 1512
-- Name: af_set_page_commentaire(integer, integer, integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_page_commentaire(integer, integer, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_page_commentaire(integer, integer, integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_set_page_commentaire(integer, integer, integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_set_page_commentaire(integer, integer, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_page_commentaire(integer, integer, integer, text) TO "grp-www";


--
-- TOC entry 8561 (class 0 OID 0)
-- Dependencies: 1513
-- Name: af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) FROM pgsql;
GRANT ALL ON FUNCTION af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) TO pgsql;
GRANT ALL ON FUNCTION af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_page_liste_configuration(integer, integer, integer, integer, integer[], character varying, text) TO "grp-www";


--
-- TOC entry 8563 (class 0 OID 0)
-- Dependencies: 1514
-- Name: af_set_page_ressource_configuration(integer, integer, integer, integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_page_ressource_configuration(integer, integer, integer, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_page_ressource_configuration(integer, integer, integer, integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_set_page_ressource_configuration(integer, integer, integer, integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_set_page_ressource_configuration(integer, integer, integer, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_page_ressource_configuration(integer, integer, integer, integer, text) TO "grp-www";


--
-- TOC entry 8565 (class 0 OID 0)
-- Dependencies: 1515
-- Name: af_set_parcours(character varying, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_parcours(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_parcours(character varying, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_parcours(character varying, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_parcours(character varying, integer) TO www;
GRANT ALL ON FUNCTION af_set_parcours(character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_parcours(character varying, integer) TO "grp-www";


--
-- TOC entry 8567 (class 0 OID 0)
-- Dependencies: 1516
-- Name: af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) FROM postgres;
GRANT ALL ON FUNCTION af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) TO postgres;
GRANT ALL ON FUNCTION af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) TO www;
GRANT ALL ON FUNCTION af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_parcours_etape(integer, integer, integer, boolean, integer, boolean) TO "grp-www";


--
-- TOC entry 8568 (class 0 OID 0)
-- Dependencies: 1517
-- Name: af_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_parcours_oriente(character varying, integer[], integer[], integer, integer[]) TO "grp-www";


--
-- TOC entry 8569 (class 0 OID 0)
-- Dependencies: 1518
-- Name: af_set_positionnement(character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_positionnement(character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_positionnement(character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_positionnement(character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_positionnement(character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_positionnement(character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8570 (class 0 OID 0)
-- Dependencies: 1902
-- Name: af_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_positionnement_choix(integer, integer, integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8571 (class 0 OID 0)
-- Dependencies: 1903
-- Name: af_set_positionnement_evaluation_a_generer(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_positionnement_evaluation_a_generer(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_positionnement_evaluation_a_generer(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_positionnement_evaluation_a_generer(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_positionnement_evaluation_a_generer(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_positionnement_evaluation_a_generer(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8572 (class 0 OID 0)
-- Dependencies: 1519
-- Name: af_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_positionnement_nb_evaluations_a_generer(integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8573 (class 0 OID 0)
-- Dependencies: 1520
-- Name: af_set_positionnement_question_positionnement_solution(integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_positionnement_question_positionnement_solution(integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_positionnement_question_positionnement_solution(integer, integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_positionnement_question_positionnement_solution(integer, integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_positionnement_question_positionnement_solution(integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_positionnement_question_positionnement_solution(integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8575 (class 0 OID 0)
-- Dependencies: 1521
-- Name: af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_presentiel_carton_capacite_date(integer, integer, integer, integer, integer, timestamp without time zone, integer) TO "grp-www";


--
-- TOC entry 8577 (class 0 OID 0)
-- Dependencies: 1522
-- Name: af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) FROM postgres;
GRANT ALL ON FUNCTION af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) TO postgres;
GRANT ALL ON FUNCTION af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_qcm(character varying, integer, boolean, integer[], integer[], integer[]) TO "grp-www";


--
-- TOC entry 8579 (class 0 OID 0)
-- Dependencies: 1523
-- Name: af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_qrc(character varying, integer, character varying, integer[], integer[], boolean, integer[]) TO "grp-www";


--
-- TOC entry 8580 (class 0 OID 0)
-- Dependencies: 1524
-- Name: af_set_qrc_question_solution(integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_qrc_question_solution(integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_qrc_question_solution(integer, integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_qrc_question_solution(integer, integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_qrc_question_solution(integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_qrc_question_solution(integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8581 (class 0 OID 0)
-- Dependencies: 1525
-- Name: af_set_qsrc(character varying, integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_qsrc(character varying, integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_qsrc(character varying, integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_set_qsrc(character varying, integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_set_qsrc(character varying, integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_qsrc(character varying, integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 8582 (class 0 OID 0)
-- Dependencies: 1526
-- Name: af_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_qsrc_question(integer, character varying, boolean, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8584 (class 0 OID 0)
-- Dependencies: 1904
-- Name: af_set_question(character varying, boolean, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_question(character varying, boolean, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_question(character varying, boolean, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_question(character varying, boolean, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_question(character varying, boolean, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_question(character varying, boolean, integer) TO "grp-www";


--
-- TOC entry 8585 (class 0 OID 0)
-- Dependencies: 1527
-- Name: af_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_question_positionnement(integer, character varying, boolean, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8587 (class 0 OID 0)
-- Dependencies: 1528
-- Name: af_set_question_reponse(integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_question_reponse(integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_question_reponse(integer, integer, boolean) FROM postgres;
GRANT ALL ON FUNCTION af_set_question_reponse(integer, integer, boolean) TO postgres;
GRANT ALL ON FUNCTION af_set_question_reponse(integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_question_reponse(integer, integer, boolean) TO "grp-www";


--
-- TOC entry 8589 (class 0 OID 0)
-- Dependencies: 1529
-- Name: af_set_question_reponse(character varying, integer, boolean, integer[], integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_question_reponse(character varying, integer, boolean, integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_question_reponse(character varying, integer, boolean, integer[], integer[]) FROM postgres;
GRANT ALL ON FUNCTION af_set_question_reponse(character varying, integer, boolean, integer[], integer[]) TO postgres;
GRANT ALL ON FUNCTION af_set_question_reponse(character varying, integer, boolean, integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_question_reponse(character varying, integer, boolean, integer[], integer[]) TO "grp-www";


--
-- TOC entry 8591 (class 0 OID 0)
-- Dependencies: 1905
-- Name: af_set_question_reponse_association_element(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_question_reponse_association_element(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_question_reponse_association_element(integer, integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_question_reponse_association_element(integer, integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_question_reponse_association_element(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_question_reponse_association_element(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8592 (class 0 OID 0)
-- Dependencies: 1530
-- Name: af_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_question_reponse_choix(integer, integer, integer, integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8594 (class 0 OID 0)
-- Dependencies: 1531
-- Name: af_set_question_reponse_element(character varying, boolean, integer, boolean); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_question_reponse_element(character varying, boolean, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_question_reponse_element(character varying, boolean, integer, boolean) FROM postgres;
GRANT ALL ON FUNCTION af_set_question_reponse_element(character varying, boolean, integer, boolean) TO postgres;
GRANT ALL ON FUNCTION af_set_question_reponse_element(character varying, boolean, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_question_reponse_element(character varying, boolean, integer, boolean) TO "grp-www";


--
-- TOC entry 8596 (class 0 OID 0)
-- Dependencies: 1532
-- Name: af_set_question_reponse_media(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_question_reponse_media(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_question_reponse_media(integer, integer, integer, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_question_reponse_media(integer, integer, integer, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_question_reponse_media(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_question_reponse_media(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8598 (class 0 OID 0)
-- Dependencies: 1533
-- Name: af_set_question_reponse_solution(integer, integer, integer, boolean); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_question_reponse_solution(integer, integer, integer, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_question_reponse_solution(integer, integer, integer, boolean) FROM postgres;
GRANT ALL ON FUNCTION af_set_question_reponse_solution(integer, integer, integer, boolean) TO postgres;
GRANT ALL ON FUNCTION af_set_question_reponse_solution(integer, integer, integer, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_question_reponse_solution(integer, integer, integer, boolean) TO "grp-www";


--
-- TOC entry 8600 (class 0 OID 0)
-- Dependencies: 1534
-- Name: af_set_reponse(character varying, boolean, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_reponse(character varying, boolean, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_reponse(character varying, boolean, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_reponse(character varying, boolean, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_reponse(character varying, boolean, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_reponse(character varying, boolean, integer) TO "grp-www";


--
-- TOC entry 8602 (class 0 OID 0)
-- Dependencies: 1535
-- Name: af_set_ressource(integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_ressource(integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_ressource(integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_set_ressource(integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_set_ressource(integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_ressource(integer, text) TO "grp-www";


--
-- TOC entry 8603 (class 0 OID 0)
-- Dependencies: 1536
-- Name: af_set_resultat_debut(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_debut(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_debut(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_debut(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_debut(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_debut(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8605 (class 0 OID 0)
-- Dependencies: 1537
-- Name: af_set_resultat_exotlc(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_exotlc(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_exotlc(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_exotlc(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_exotlc(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_exotlc(bigint) TO "grp-www";


--
-- TOC entry 8607 (class 0 OID 0)
-- Dependencies: 1538
-- Name: af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_exotlc_critere(bigint, integer, integer, integer, text) TO "grp-www";


--
-- TOC entry 8608 (class 0 OID 0)
-- Dependencies: 1539
-- Name: af_set_resultat_exotlc_plateforme(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_exotlc_plateforme(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_exotlc_plateforme(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_exotlc_plateforme(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_exotlc_plateforme(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_exotlc_plateforme(bigint, integer) TO "grp-www";


--
-- TOC entry 8610 (class 0 OID 0)
-- Dependencies: 1540
-- Name: af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_exotlc_sous_critere(bigint, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8611 (class 0 OID 0)
-- Dependencies: 1541
-- Name: af_set_resultat_fin(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_fin(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_fin(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_fin(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_fin(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_fin(bigint) TO "grp-www";


--
-- TOC entry 8613 (class 0 OID 0)
-- Dependencies: 1542
-- Name: af_set_resultat_meilleure_tentative(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_meilleure_tentative(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_meilleure_tentative(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_meilleure_tentative(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_meilleure_tentative(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_meilleure_tentative(bigint) TO "grp-www";


--
-- TOC entry 8614 (class 0 OID 0)
-- Dependencies: 1543
-- Name: af_set_resultat_serie_debut(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_serie_debut(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_serie_debut(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_debut(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_debut(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_serie_debut(bigint, integer) TO "grp-www";


--
-- TOC entry 8615 (class 0 OID 0)
-- Dependencies: 1544
-- Name: af_set_resultat_serie_fin(bigint, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_serie_fin(bigint, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_serie_fin(bigint, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_fin(bigint, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_fin(bigint, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_serie_fin(bigint, integer) TO "grp-www";


--
-- TOC entry 8616 (class 0 OID 0)
-- Dependencies: 1545
-- Name: af_set_resultat_serie_ftb(bigint, integer, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_serie_ftb(bigint, integer, text) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_serie_ftb(bigint, integer, text) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_ftb(bigint, integer, text) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_ftb(bigint, integer, text) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_serie_ftb(bigint, integer, text) TO "grp-www";


--
-- TOC entry 8617 (class 0 OID 0)
-- Dependencies: 1546
-- Name: af_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_serie_qsrc(bigint, integer, integer[], integer[], integer[]) TO "grp-www";


--
-- TOC entry 8618 (class 0 OID 0)
-- Dependencies: 1547
-- Name: af_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_serie_question_reponse(bigint, integer, integer[], integer[], integer[]) TO "grp-www";


--
-- TOC entry 8620 (class 0 OID 0)
-- Dependencies: 1548
-- Name: af_set_resultat_tentative(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_resultat_tentative(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_resultat_tentative(bigint) FROM pgsql;
GRANT ALL ON FUNCTION af_set_resultat_tentative(bigint) TO pgsql;
GRANT ALL ON FUNCTION af_set_resultat_tentative(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_resultat_tentative(bigint) TO "grp-www";


--
-- TOC entry 8622 (class 0 OID 0)
-- Dependencies: 1549
-- Name: af_set_salle(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_salle(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_salle(character varying) FROM pgsql;
GRANT ALL ON FUNCTION af_set_salle(character varying) TO pgsql;
GRANT ALL ON FUNCTION af_set_salle(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_salle(character varying) TO "grp-www";


--
-- TOC entry 8624 (class 0 OID 0)
-- Dependencies: 1906
-- Name: af_set_section(character varying, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_section(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_section(character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_section(character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_section(character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_section(character varying, integer) TO "grp-www";


--
-- TOC entry 8626 (class 0 OID 0)
-- Dependencies: 1550
-- Name: af_set_serie(character varying, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie(character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie(character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie(character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie(character varying, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie(character varying, integer, integer) TO "grp-www";


--
-- TOC entry 8628 (class 0 OID 0)
-- Dependencies: 1551
-- Name: af_set_serie(character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie(character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie(character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie(character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie(character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie(character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8630 (class 0 OID 0)
-- Dependencies: 1552
-- Name: af_set_serie_aleatoire(character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie_aleatoire(character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie_aleatoire(character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire(character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire(character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie_aleatoire(character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8632 (class 0 OID 0)
-- Dependencies: 1553
-- Name: af_set_serie_aleatoire_melangee(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie_aleatoire_melangee(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie_aleatoire_melangee(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_melangee(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_melangee(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_melangee(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8634 (class 0 OID 0)
-- Dependencies: 1554
-- Name: af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_melangee_evaluations(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8636 (class 0 OID 0)
-- Dependencies: 1907
-- Name: af_set_serie_aleatoire_multiserie_configuration(integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie_aleatoire_multiserie_configuration(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie_aleatoire_multiserie_configuration(integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multiserie_configuration(integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multiserie_configuration(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multiserie_configuration(integer, integer[]) TO "grp-www";


--
-- TOC entry 8638 (class 0 OID 0)
-- Dependencies: 1555
-- Name: af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multiserie_evaluations(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8640 (class 0 OID 0)
-- Dependencies: 1556
-- Name: af_set_serie_aleatoire_multitheme_configuration(integer, integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie_aleatoire_multitheme_configuration(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie_aleatoire_multitheme_configuration(integer, integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multitheme_configuration(integer, integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multitheme_configuration(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multitheme_configuration(integer, integer[]) TO "grp-www";


--
-- TOC entry 8642 (class 0 OID 0)
-- Dependencies: 1557
-- Name: af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie_aleatoire_multitheme_evaluations(integer, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8644 (class 0 OID 0)
-- Dependencies: 1908
-- Name: af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie_bloquante_configuration(integer, integer, integer, integer, integer, integer, boolean, boolean) TO "grp-www";


--
-- TOC entry 8646 (class 0 OID 0)
-- Dependencies: 1909
-- Name: af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_serie_evaluation(integer, integer, integer, character varying, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8648 (class 0 OID 0)
-- Dependencies: 1558
-- Name: af_set_sondage(character varying, integer, boolean, integer[], integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_sondage(character varying, integer, boolean, integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_sondage(character varying, integer, boolean, integer[], integer[]) FROM postgres;
GRANT ALL ON FUNCTION af_set_sondage(character varying, integer, boolean, integer[], integer[]) TO postgres;
GRANT ALL ON FUNCTION af_set_sondage(character varying, integer, boolean, integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_sondage(character varying, integer, boolean, integer[], integer[]) TO "grp-www";


--
-- TOC entry 8649 (class 0 OID 0)
-- Dependencies: 1559
-- Name: af_set_src(character varying, integer, character varying, boolean, integer[], integer[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_src(character varying, integer, character varying, boolean, integer[], integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_src(character varying, integer, character varying, boolean, integer[], integer[]) FROM pgsql;
GRANT ALL ON FUNCTION af_set_src(character varying, integer, character varying, boolean, integer[], integer[]) TO pgsql;
GRANT ALL ON FUNCTION af_set_src(character varying, integer, character varying, boolean, integer[], integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_src(character varying, integer, character varying, boolean, integer[], integer[]) TO "grp-www";


--
-- TOC entry 8650 (class 0 OID 0)
-- Dependencies: 1560
-- Name: af_set_test(character varying, boolean, boolean, integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_test(character varying, boolean, boolean, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_test(character varying, boolean, boolean, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_test(character varying, boolean, boolean, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_test(character varying, boolean, boolean, integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_test(character varying, boolean, boolean, integer, integer, integer) TO "grp-www";


--
-- TOC entry 8651 (class 0 OID 0)
-- Dependencies: 1561
-- Name: af_set_test_positionnement(integer, integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION af_set_test_positionnement(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_test_positionnement(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION af_set_test_positionnement(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION af_set_test_positionnement(integer, integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_test_positionnement(integer, integer, integer) TO "grp-www";


--
-- TOC entry 8653 (class 0 OID 0)
-- Dependencies: 1562
-- Name: af_set_theme(character varying, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION af_set_theme(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION af_set_theme(character varying, integer) FROM postgres;
GRANT ALL ON FUNCTION af_set_theme(character varying, integer) TO postgres;
GRANT ALL ON FUNCTION af_set_theme(character varying, integer) TO PUBLIC;
GRANT ALL ON FUNCTION af_set_theme(character varying, integer) TO "grp-www";


--
-- TOC entry 8655 (class 0 OID 0)
-- Dependencies: 1563
-- Name: ag_get_stagiaires_formation(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION ag_get_stagiaires_formation() FROM PUBLIC;
REVOKE ALL ON FUNCTION ag_get_stagiaires_formation() FROM pgsql;
GRANT ALL ON FUNCTION ag_get_stagiaires_formation() TO pgsql;
GRANT ALL ON FUNCTION ag_get_stagiaires_formation() TO PUBLIC;
GRANT ALL ON FUNCTION ag_get_stagiaires_formation() TO "grp-www";


--
-- TOC entry 8657 (class 0 OID 0)
-- Dependencies: 1564
-- Name: check_alerte_dates(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_alerte_dates() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_alerte_dates() FROM postgres;
GRANT ALL ON FUNCTION check_alerte_dates() TO postgres;
GRANT ALL ON FUNCTION check_alerte_dates() TO PUBLIC;
GRANT ALL ON FUNCTION check_alerte_dates() TO "grp-www";


--
-- TOC entry 8659 (class 0 OID 0)
-- Dependencies: 1565
-- Name: check_calendrier_date(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_calendrier_date() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_calendrier_date() FROM postgres;
GRANT ALL ON FUNCTION check_calendrier_date() TO postgres;
GRANT ALL ON FUNCTION check_calendrier_date() TO PUBLIC;
GRANT ALL ON FUNCTION check_calendrier_date() TO "grp-www";


--
-- TOC entry 8661 (class 0 OID 0)
-- Dependencies: 1566
-- Name: check_classe_organisme(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION check_classe_organisme() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_classe_organisme() FROM pgsql;
GRANT ALL ON FUNCTION check_classe_organisme() TO pgsql;
GRANT ALL ON FUNCTION check_classe_organisme() TO PUBLIC;
GRANT ALL ON FUNCTION check_classe_organisme() TO "grp-www";


--
-- TOC entry 8663 (class 0 OID 0)
-- Dependencies: 1567
-- Name: check_evaluation_qsrc_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_evaluation_qsrc_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_evaluation_qsrc_type() FROM postgres;
GRANT ALL ON FUNCTION check_evaluation_qsrc_type() TO postgres;
GRANT ALL ON FUNCTION check_evaluation_qsrc_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_evaluation_qsrc_type() TO "grp-www";


--
-- TOC entry 8665 (class 0 OID 0)
-- Dependencies: 1568
-- Name: check_evaluation_question_reponse_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_evaluation_question_reponse_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_evaluation_question_reponse_type() FROM postgres;
GRANT ALL ON FUNCTION check_evaluation_question_reponse_type() TO postgres;
GRANT ALL ON FUNCTION check_evaluation_question_reponse_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_evaluation_question_reponse_type() TO "grp-www";


--
-- TOC entry 8667 (class 0 OID 0)
-- Dependencies: 1569
-- Name: check_evaluation_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_evaluation_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_evaluation_type() FROM postgres;
GRANT ALL ON FUNCTION check_evaluation_type() TO postgres;
GRANT ALL ON FUNCTION check_evaluation_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_evaluation_type() TO "grp-www";


--
-- TOC entry 8669 (class 0 OID 0)
-- Dependencies: 1570
-- Name: check_evaluation_type2(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_evaluation_type2() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_evaluation_type2() FROM postgres;
GRANT ALL ON FUNCTION check_evaluation_type2() TO postgres;
GRANT ALL ON FUNCTION check_evaluation_type2() TO PUBLIC;
GRANT ALL ON FUNCTION check_evaluation_type2() TO "grp-www";


--
-- TOC entry 8671 (class 0 OID 0)
-- Dependencies: 1571
-- Name: check_evaluation_type2_question_reponse(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_evaluation_type2_question_reponse() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_evaluation_type2_question_reponse() FROM postgres;
GRANT ALL ON FUNCTION check_evaluation_type2_question_reponse() TO postgres;
GRANT ALL ON FUNCTION check_evaluation_type2_question_reponse() TO PUBLIC;
GRANT ALL ON FUNCTION check_evaluation_type2_question_reponse() TO "grp-www";


--
-- TOC entry 8673 (class 0 OID 0)
-- Dependencies: 1572
-- Name: check_exotlc_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_exotlc_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_exotlc_type() FROM postgres;
GRANT ALL ON FUNCTION check_exotlc_type() TO postgres;
GRANT ALL ON FUNCTION check_exotlc_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_exotlc_type() TO "grp-www";


--
-- TOC entry 8675 (class 0 OID 0)
-- Dependencies: 1573
-- Name: check_fichier_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_fichier_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_fichier_type() FROM postgres;
GRANT ALL ON FUNCTION check_fichier_type() TO postgres;
GRANT ALL ON FUNCTION check_fichier_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_fichier_type() TO "grp-www";


--
-- TOC entry 8676 (class 0 OID 0)
-- Dependencies: 1574
-- Name: check_fichier_types(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_fichier_types() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_fichier_types() FROM postgres;
GRANT ALL ON FUNCTION check_fichier_types() TO postgres;
GRANT ALL ON FUNCTION check_fichier_types() TO PUBLIC;
GRANT ALL ON FUNCTION check_fichier_types() TO "grp-www";


--
-- TOC entry 8678 (class 0 OID 0)
-- Dependencies: 1575
-- Name: check_formateur_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_formateur_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_formateur_type() FROM postgres;
GRANT ALL ON FUNCTION check_formateur_type() TO postgres;
GRANT ALL ON FUNCTION check_formateur_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_formateur_type() TO "grp-www";


--
-- TOC entry 8680 (class 0 OID 0)
-- Dependencies: 1576
-- Name: check_intervenant(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_intervenant() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_intervenant() FROM postgres;
GRANT ALL ON FUNCTION check_intervenant() TO postgres;
GRANT ALL ON FUNCTION check_intervenant() TO PUBLIC;
GRANT ALL ON FUNCTION check_intervenant() TO "grp-www";


--
-- TOC entry 8682 (class 0 OID 0)
-- Dependencies: 1577
-- Name: check_liste_resultats_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_liste_resultats_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_liste_resultats_type() FROM postgres;
GRANT ALL ON FUNCTION check_liste_resultats_type() TO postgres;
GRANT ALL ON FUNCTION check_liste_resultats_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_liste_resultats_type() TO "grp-www";


--
-- TOC entry 8684 (class 0 OID 0)
-- Dependencies: 1578
-- Name: check_liste_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_liste_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_liste_type() FROM postgres;
GRANT ALL ON FUNCTION check_liste_type() TO postgres;
GRANT ALL ON FUNCTION check_liste_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_liste_type() TO "grp-www";


--
-- TOC entry 8686 (class 0 OID 0)
-- Dependencies: 1579
-- Name: check_liste_type_serie(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_liste_type_serie() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_liste_type_serie() FROM postgres;
GRANT ALL ON FUNCTION check_liste_type_serie() TO postgres;
GRANT ALL ON FUNCTION check_liste_type_serie() TO PUBLIC;
GRANT ALL ON FUNCTION check_liste_type_serie() TO "grp-www";


--
-- TOC entry 8687 (class 0 OID 0)
-- Dependencies: 1580
-- Name: check_media_question_reponse_element(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION check_media_question_reponse_element() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_media_question_reponse_element() FROM pgsql;
GRANT ALL ON FUNCTION check_media_question_reponse_element() TO pgsql;
GRANT ALL ON FUNCTION check_media_question_reponse_element() TO PUBLIC;
GRANT ALL ON FUNCTION check_media_question_reponse_element() TO "grp-www";


--
-- TOC entry 8689 (class 0 OID 0)
-- Dependencies: 1581
-- Name: check_modalite(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_modalite() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_modalite() FROM postgres;
GRANT ALL ON FUNCTION check_modalite() TO postgres;
GRANT ALL ON FUNCTION check_modalite() TO PUBLIC;
GRANT ALL ON FUNCTION check_modalite() TO "grp-www";


--
-- TOC entry 8691 (class 0 OID 0)
-- Dependencies: 1582
-- Name: check_positionnement_evaluations_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_positionnement_evaluations_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_positionnement_evaluations_type() FROM postgres;
GRANT ALL ON FUNCTION check_positionnement_evaluations_type() TO postgres;
GRANT ALL ON FUNCTION check_positionnement_evaluations_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_positionnement_evaluations_type() TO "grp-www";


--
-- TOC entry 8693 (class 0 OID 0)
-- Dependencies: 1583
-- Name: check_positionnement_questions_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_positionnement_questions_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_positionnement_questions_type() FROM postgres;
GRANT ALL ON FUNCTION check_positionnement_questions_type() TO postgres;
GRANT ALL ON FUNCTION check_positionnement_questions_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_positionnement_questions_type() TO "grp-www";


--
-- TOC entry 8695 (class 0 OID 0)
-- Dependencies: 1584
-- Name: check_positionnement_reponses_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_positionnement_reponses_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_positionnement_reponses_type() FROM postgres;
GRANT ALL ON FUNCTION check_positionnement_reponses_type() TO postgres;
GRANT ALL ON FUNCTION check_positionnement_reponses_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_positionnement_reponses_type() TO "grp-www";


--
-- TOC entry 8697 (class 0 OID 0)
-- Dependencies: 1585
-- Name: check_qcm_elements_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_qcm_elements_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_qcm_elements_type() FROM postgres;
GRANT ALL ON FUNCTION check_qcm_elements_type() TO postgres;
GRANT ALL ON FUNCTION check_qcm_elements_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_qcm_elements_type() TO "grp-www";


--
-- TOC entry 8699 (class 0 OID 0)
-- Dependencies: 1586
-- Name: check_qrc_correction_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_qrc_correction_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_qrc_correction_type() FROM postgres;
GRANT ALL ON FUNCTION check_qrc_correction_type() TO postgres;
GRANT ALL ON FUNCTION check_qrc_correction_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_qrc_correction_type() TO "grp-www";


--
-- TOC entry 8701 (class 0 OID 0)
-- Dependencies: 1587
-- Name: check_qsrc_positionnement_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_qsrc_positionnement_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_qsrc_positionnement_type() FROM postgres;
GRANT ALL ON FUNCTION check_qsrc_positionnement_type() TO postgres;
GRANT ALL ON FUNCTION check_qsrc_positionnement_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_qsrc_positionnement_type() TO "grp-www";


--
-- TOC entry 8704 (class 0 OID 0)
-- Dependencies: 1588
-- Name: check_question_reponse_elements_types(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_question_reponse_elements_types() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_question_reponse_elements_types() FROM postgres;
GRANT ALL ON FUNCTION check_question_reponse_elements_types() TO postgres;
GRANT ALL ON FUNCTION check_question_reponse_elements_types() TO PUBLIC;
GRANT ALL ON FUNCTION check_question_reponse_elements_types() TO "grp-www";


--
-- TOC entry 8706 (class 0 OID 0)
-- Dependencies: 1589
-- Name: check_ressource_dates(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_ressource_dates() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_ressource_dates() FROM postgres;
GRANT ALL ON FUNCTION check_ressource_dates() TO postgres;
GRANT ALL ON FUNCTION check_ressource_dates() TO PUBLIC;
GRANT ALL ON FUNCTION check_ressource_dates() TO "grp-www";


--
-- TOC entry 8708 (class 0 OID 0)
-- Dependencies: 1590
-- Name: check_ressource_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_ressource_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_ressource_type() FROM postgres;
GRANT ALL ON FUNCTION check_ressource_type() TO postgres;
GRANT ALL ON FUNCTION check_ressource_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_ressource_type() TO "grp-www";


--
-- TOC entry 8710 (class 0 OID 0)
-- Dependencies: 1591
-- Name: check_serie_aleatoire_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_serie_aleatoire_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_serie_aleatoire_type() FROM postgres;
GRANT ALL ON FUNCTION check_serie_aleatoire_type() TO postgres;
GRANT ALL ON FUNCTION check_serie_aleatoire_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_serie_aleatoire_type() TO "grp-www";


--
-- TOC entry 8711 (class 0 OID 0)
-- Dependencies: 1592
-- Name: check_serie_evaluation(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION check_serie_evaluation() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_serie_evaluation() FROM pgsql;
GRANT ALL ON FUNCTION check_serie_evaluation() TO pgsql;
GRANT ALL ON FUNCTION check_serie_evaluation() TO PUBLIC;
GRANT ALL ON FUNCTION check_serie_evaluation() TO "grp-www";


--
-- TOC entry 8713 (class 0 OID 0)
-- Dependencies: 1593
-- Name: check_stagiaire_formation(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_stagiaire_formation() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_stagiaire_formation() FROM postgres;
GRANT ALL ON FUNCTION check_stagiaire_formation() TO postgres;
GRANT ALL ON FUNCTION check_stagiaire_formation() TO PUBLIC;
GRANT ALL ON FUNCTION check_stagiaire_formation() TO "grp-www";


--
-- TOC entry 8715 (class 0 OID 0)
-- Dependencies: 1594
-- Name: check_stagiaire_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_stagiaire_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_stagiaire_type() FROM postgres;
GRANT ALL ON FUNCTION check_stagiaire_type() TO postgres;
GRANT ALL ON FUNCTION check_stagiaire_type() TO PUBLIC;
GRANT ALL ON FUNCTION check_stagiaire_type() TO "grp-www";


--
-- TOC entry 8717 (class 0 OID 0)
-- Dependencies: 1595
-- Name: check_type_etape(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_type_etape() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_type_etape() FROM postgres;
GRANT ALL ON FUNCTION check_type_etape() TO postgres;
GRANT ALL ON FUNCTION check_type_etape() TO PUBLIC;
GRANT ALL ON FUNCTION check_type_etape() TO "grp-www";


--
-- TOC entry 8719 (class 0 OID 0)
-- Dependencies: 1596
-- Name: check_type_question(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_type_question() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_type_question() FROM postgres;
GRANT ALL ON FUNCTION check_type_question() TO postgres;
GRANT ALL ON FUNCTION check_type_question() TO PUBLIC;
GRANT ALL ON FUNCTION check_type_question() TO "grp-www";


--
-- TOC entry 8721 (class 0 OID 0)
-- Dependencies: 1597
-- Name: check_type_reponse(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION check_type_reponse() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_type_reponse() FROM postgres;
GRANT ALL ON FUNCTION check_type_reponse() TO postgres;
GRANT ALL ON FUNCTION check_type_reponse() TO PUBLIC;
GRANT ALL ON FUNCTION check_type_reponse() TO "grp-www";


--
-- TOC entry 8723 (class 0 OID 0)
-- Dependencies: 1598
-- Name: cls_check_classe_organisme(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION cls_check_classe_organisme() FROM PUBLIC;
REVOKE ALL ON FUNCTION cls_check_classe_organisme() FROM pgsql;
GRANT ALL ON FUNCTION cls_check_classe_organisme() TO pgsql;
GRANT ALL ON FUNCTION cls_check_classe_organisme() TO PUBLIC;
GRANT ALL ON FUNCTION cls_check_classe_organisme() TO "grp-www";


--
-- TOC entry 8725 (class 0 OID 0)
-- Dependencies: 1599
-- Name: cls_get_classe_individus(integer, integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION cls_get_classe_individus(integer, integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 8727 (class 0 OID 0)
-- Dependencies: 1600
-- Name: copy_langue(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION copy_langue() FROM PUBLIC;
REVOKE ALL ON FUNCTION copy_langue() FROM pgsql;
GRANT ALL ON FUNCTION copy_langue() TO pgsql;
GRANT ALL ON FUNCTION copy_langue() TO PUBLIC;
GRANT ALL ON FUNCTION copy_langue() TO "grp-www";


--
-- TOC entry 8729 (class 0 OID 0)
-- Dependencies: 1601
-- Name: create_error(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION create_error() FROM PUBLIC;
REVOKE ALL ON FUNCTION create_error() FROM pgsql;
GRANT ALL ON FUNCTION create_error() TO pgsql;
GRANT ALL ON FUNCTION create_error() TO PUBLIC;
GRANT ALL ON FUNCTION create_error() TO "grp-www";


--
-- TOC entry 8731 (class 0 OID 0)
-- Dependencies: 1602
-- Name: del_classe(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_classe() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_classe() FROM www;
GRANT ALL ON FUNCTION del_classe() TO www;
GRANT ALL ON FUNCTION del_classe() TO PUBLIC;
GRANT ALL ON FUNCTION del_classe() TO "grp-www";


--
-- TOC entry 8733 (class 0 OID 0)
-- Dependencies: 1603
-- Name: del_classe_individu(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_classe_individu() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_classe_individu() FROM www;
GRANT ALL ON FUNCTION del_classe_individu() TO www;
GRANT ALL ON FUNCTION del_classe_individu() TO PUBLIC;
GRANT ALL ON FUNCTION del_classe_individu() TO "grp-www";


--
-- TOC entry 8735 (class 0 OID 0)
-- Dependencies: 1604
-- Name: del_etape(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_etape() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_etape() FROM www;
GRANT ALL ON FUNCTION del_etape() TO www;
GRANT ALL ON FUNCTION del_etape() TO PUBLIC;
GRANT ALL ON FUNCTION del_etape() TO "grp-www";


--
-- TOC entry 8737 (class 0 OID 0)
-- Dependencies: 1605
-- Name: del_etape_resultats(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_etape_resultats() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_etape_resultats() FROM www;
GRANT ALL ON FUNCTION del_etape_resultats() TO www;
GRANT ALL ON FUNCTION del_etape_resultats() TO PUBLIC;
GRANT ALL ON FUNCTION del_etape_resultats() TO "grp-www";


--
-- TOC entry 8739 (class 0 OID 0)
-- Dependencies: 1606
-- Name: del_evaluation(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_evaluation() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_evaluation() FROM www;
GRANT ALL ON FUNCTION del_evaluation() TO www;
GRANT ALL ON FUNCTION del_evaluation() TO PUBLIC;
GRANT ALL ON FUNCTION del_evaluation() TO "grp-www";


--
-- TOC entry 8741 (class 0 OID 0)
-- Dependencies: 1607
-- Name: del_evenement_presentiel(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_evenement_presentiel() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_evenement_presentiel() FROM pgsql;
GRANT ALL ON FUNCTION del_evenement_presentiel() TO pgsql;
GRANT ALL ON FUNCTION del_evenement_presentiel() TO PUBLIC;
GRANT ALL ON FUNCTION del_evenement_presentiel() TO "grp-www";


--
-- TOC entry 8742 (class 0 OID 0)
-- Dependencies: 1608
-- Name: del_exotlc(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION del_exotlc() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_exotlc() FROM postgres;
GRANT ALL ON FUNCTION del_exotlc() TO postgres;
GRANT ALL ON FUNCTION del_exotlc() TO PUBLIC;
GRANT ALL ON FUNCTION del_exotlc() TO "grp-www";


--
-- TOC entry 8744 (class 0 OID 0)
-- Dependencies: 1609
-- Name: del_fichier_correction(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_fichier_correction() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_fichier_correction() FROM www;
GRANT ALL ON FUNCTION del_fichier_correction() TO www;
GRANT ALL ON FUNCTION del_fichier_correction() TO PUBLIC;
GRANT ALL ON FUNCTION del_fichier_correction() TO "grp-www";


--
-- TOC entry 8746 (class 0 OID 0)
-- Dependencies: 1610
-- Name: del_fichier_exotlc(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_fichier_exotlc() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_fichier_exotlc() FROM www;
GRANT ALL ON FUNCTION del_fichier_exotlc() TO www;
GRANT ALL ON FUNCTION del_fichier_exotlc() TO PUBLIC;
GRANT ALL ON FUNCTION del_fichier_exotlc() TO "grp-www";


--
-- TOC entry 8748 (class 0 OID 0)
-- Dependencies: 1611
-- Name: del_formation(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_formation() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_formation() FROM www;
GRANT ALL ON FUNCTION del_formation() TO www;
GRANT ALL ON FUNCTION del_formation() TO PUBLIC;
GRANT ALL ON FUNCTION del_formation() TO "grp-www";


--
-- TOC entry 8750 (class 0 OID 0)
-- Dependencies: 1612
-- Name: del_individu(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_individu() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_individu() FROM www;
GRANT ALL ON FUNCTION del_individu() TO www;
GRANT ALL ON FUNCTION del_individu() TO PUBLIC;
GRANT ALL ON FUNCTION del_individu() TO "grp-www";


--
-- TOC entry 8752 (class 0 OID 0)
-- Dependencies: 1613
-- Name: del_parcours(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_parcours() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_parcours() FROM www;
GRANT ALL ON FUNCTION del_parcours() TO www;
GRANT ALL ON FUNCTION del_parcours() TO PUBLIC;
GRANT ALL ON FUNCTION del_parcours() TO "grp-www";


--
-- TOC entry 8754 (class 0 OID 0)
-- Dependencies: 1614
-- Name: del_parcours_etape(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_parcours_etape() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_parcours_etape() FROM pgsql;
GRANT ALL ON FUNCTION del_parcours_etape() TO pgsql;
GRANT ALL ON FUNCTION del_parcours_etape() TO PUBLIC;
GRANT ALL ON FUNCTION del_parcours_etape() TO "grp-www";


--
-- TOC entry 8755 (class 0 OID 0)
-- Dependencies: 1615
-- Name: del_positionnement(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION del_positionnement() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_positionnement() FROM postgres;
GRANT ALL ON FUNCTION del_positionnement() TO postgres;
GRANT ALL ON FUNCTION del_positionnement() TO PUBLIC;
GRANT ALL ON FUNCTION del_positionnement() TO "grp-www";


--
-- TOC entry 8756 (class 0 OID 0)
-- Dependencies: 1616
-- Name: del_positionnement_evaluations_a_generer(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_positionnement_evaluations_a_generer() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_positionnement_evaluations_a_generer() FROM pgsql;
GRANT ALL ON FUNCTION del_positionnement_evaluations_a_generer() TO pgsql;
GRANT ALL ON FUNCTION del_positionnement_evaluations_a_generer() TO PUBLIC;
GRANT ALL ON FUNCTION del_positionnement_evaluations_a_generer() TO "grp-www";


--
-- TOC entry 8757 (class 0 OID 0)
-- Dependencies: 1617
-- Name: del_qsrc(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION del_qsrc() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_qsrc() FROM postgres;
GRANT ALL ON FUNCTION del_qsrc() TO postgres;
GRANT ALL ON FUNCTION del_qsrc() TO PUBLIC;
GRANT ALL ON FUNCTION del_qsrc() TO "grp-www";


--
-- TOC entry 8758 (class 0 OID 0)
-- Dependencies: 1618
-- Name: del_question_reponse(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_question_reponse() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_question_reponse() FROM www;
GRANT ALL ON FUNCTION del_question_reponse() TO www;
GRANT ALL ON FUNCTION del_question_reponse() TO PUBLIC;
GRANT ALL ON FUNCTION del_question_reponse() TO "grp-www";


--
-- TOC entry 8759 (class 0 OID 0)
-- Dependencies: 1619
-- Name: del_question_reponse_element(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION del_question_reponse_element() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_question_reponse_element() FROM postgres;
GRANT ALL ON FUNCTION del_question_reponse_element() TO postgres;
GRANT ALL ON FUNCTION del_question_reponse_element() TO PUBLIC;
GRANT ALL ON FUNCTION del_question_reponse_element() TO "grp-www";


--
-- TOC entry 8760 (class 0 OID 0)
-- Dependencies: 1620
-- Name: del_question_reponse_element_media(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_question_reponse_element_media() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_question_reponse_element_media() FROM pgsql;
GRANT ALL ON FUNCTION del_question_reponse_element_media() TO pgsql;
GRANT ALL ON FUNCTION del_question_reponse_element_media() TO PUBLIC;
GRANT ALL ON FUNCTION del_question_reponse_element_media() TO "grp-www";


--
-- TOC entry 8762 (class 0 OID 0)
-- Dependencies: 1621
-- Name: del_ressource(); Type: ACL; Schema: contraintes; Owner: www
--

REVOKE ALL ON FUNCTION del_ressource() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_ressource() FROM www;
GRANT ALL ON FUNCTION del_ressource() TO www;
GRANT ALL ON FUNCTION del_ressource() TO PUBLIC;
GRANT ALL ON FUNCTION del_ressource() TO "grp-www";


--
-- TOC entry 8764 (class 0 OID 0)
-- Dependencies: 1622
-- Name: del_serie(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION del_serie() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_serie() FROM postgres;
GRANT ALL ON FUNCTION del_serie() TO postgres;
GRANT ALL ON FUNCTION del_serie() TO PUBLIC;
GRANT ALL ON FUNCTION del_serie() TO "grp-www";


--
-- TOC entry 8765 (class 0 OID 0)
-- Dependencies: 1623
-- Name: del_serie_aleatoire(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION del_serie_aleatoire() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_serie_aleatoire() FROM postgres;
GRANT ALL ON FUNCTION del_serie_aleatoire() TO postgres;
GRANT ALL ON FUNCTION del_serie_aleatoire() TO PUBLIC;
GRANT ALL ON FUNCTION del_serie_aleatoire() TO "grp-www";


--
-- TOC entry 8766 (class 0 OID 0)
-- Dependencies: 1624
-- Name: del_serie_aleatoire_configuree_evaluations(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_serie_aleatoire_configuree_evaluations() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_serie_aleatoire_configuree_evaluations() FROM pgsql;
GRANT ALL ON FUNCTION del_serie_aleatoire_configuree_evaluations() TO pgsql;
GRANT ALL ON FUNCTION del_serie_aleatoire_configuree_evaluations() TO PUBLIC;
GRANT ALL ON FUNCTION del_serie_aleatoire_configuree_evaluations() TO "grp-www";


--
-- TOC entry 8768 (class 0 OID 0)
-- Dependencies: 1625
-- Name: del_serie_aleatoire_evaluations(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_serie_aleatoire_evaluations() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_serie_aleatoire_evaluations() FROM pgsql;
GRANT ALL ON FUNCTION del_serie_aleatoire_evaluations() TO pgsql;
GRANT ALL ON FUNCTION del_serie_aleatoire_evaluations() TO PUBLIC;
GRANT ALL ON FUNCTION del_serie_aleatoire_evaluations() TO "grp-www";


--
-- TOC entry 8769 (class 0 OID 0)
-- Dependencies: 1626
-- Name: del_serie_evaluations(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION del_serie_evaluations() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_serie_evaluations() FROM postgres;
GRANT ALL ON FUNCTION del_serie_evaluations() TO postgres;
GRANT ALL ON FUNCTION del_serie_evaluations() TO PUBLIC;
GRANT ALL ON FUNCTION del_serie_evaluations() TO "grp-www";


--
-- TOC entry 8771 (class 0 OID 0)
-- Dependencies: 1627
-- Name: del_stagiaire_grille(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_stagiaire_grille() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_stagiaire_grille() FROM pgsql;
GRANT ALL ON FUNCTION del_stagiaire_grille() TO pgsql;
GRANT ALL ON FUNCTION del_stagiaire_grille() TO PUBLIC;
GRANT ALL ON FUNCTION del_stagiaire_grille() TO "grp-www";


--
-- TOC entry 8772 (class 0 OID 0)
-- Dependencies: 1628
-- Name: del_test(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION del_test() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_test() FROM postgres;
GRANT ALL ON FUNCTION del_test() TO postgres;
GRANT ALL ON FUNCTION del_test() TO PUBLIC;
GRANT ALL ON FUNCTION del_test() TO "grp-www";


--
-- TOC entry 8773 (class 0 OID 0)
-- Dependencies: 1629
-- Name: del_test_positonnements(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION del_test_positonnements() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_test_positonnements() FROM postgres;
GRANT ALL ON FUNCTION del_test_positonnements() TO postgres;
GRANT ALL ON FUNCTION del_test_positonnements() TO PUBLIC;
GRANT ALL ON FUNCTION del_test_positonnements() TO "grp-www";


--
-- TOC entry 8774 (class 0 OID 0)
-- Dependencies: 1630
-- Name: del_theme_categorie(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_theme_categorie() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_theme_categorie() FROM pgsql;
GRANT ALL ON FUNCTION del_theme_categorie() TO pgsql;
GRANT ALL ON FUNCTION del_theme_categorie() TO PUBLIC;
GRANT ALL ON FUNCTION del_theme_categorie() TO "grp-www";


--
-- TOC entry 8776 (class 0 OID 0)
-- Dependencies: 1631
-- Name: del_theme_etape(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_theme_etape() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_theme_etape() FROM pgsql;
GRANT ALL ON FUNCTION del_theme_etape() TO pgsql;
GRANT ALL ON FUNCTION del_theme_etape() TO PUBLIC;
GRANT ALL ON FUNCTION del_theme_etape() TO "grp-www";


--
-- TOC entry 8778 (class 0 OID 0)
-- Dependencies: 1632
-- Name: delete_serie_aleatoire_multitheme_categorie_serie(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION delete_serie_aleatoire_multitheme_categorie_serie() FROM PUBLIC;
REVOKE ALL ON FUNCTION delete_serie_aleatoire_multitheme_categorie_serie() FROM pgsql;
GRANT ALL ON FUNCTION delete_serie_aleatoire_multitheme_categorie_serie() TO pgsql;
GRANT ALL ON FUNCTION delete_serie_aleatoire_multitheme_categorie_serie() TO PUBLIC;
GRANT ALL ON FUNCTION delete_serie_aleatoire_multitheme_categorie_serie() TO "grp-www";


--
-- TOC entry 8780 (class 0 OID 0)
-- Dependencies: 1634
-- Name: fmt_check_formateur_type(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fmt_check_formateur_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION fmt_check_formateur_type() FROM postgres;
GRANT ALL ON FUNCTION fmt_check_formateur_type() TO postgres;
GRANT ALL ON FUNCTION fmt_check_formateur_type() TO PUBLIC;
GRANT ALL ON FUNCTION fmt_check_formateur_type() TO "grp-www";


--
-- TOC entry 8781 (class 0 OID 0)
-- Dependencies: 1633
-- Name: fmt_get_filiere_formations(integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fmt_get_filiere_formations(integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION fmt_get_filiere_formations(integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION fmt_get_filiere_formations(integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION fmt_get_filiere_formations(integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION fmt_get_filiere_formations(integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 8782 (class 0 OID 0)
-- Dependencies: 1635
-- Name: fmt_get_formation(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fmt_get_formation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fmt_get_formation(integer) FROM pgsql;
GRANT ALL ON FUNCTION fmt_get_formation(integer) TO pgsql;
GRANT ALL ON FUNCTION fmt_get_formation(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fmt_get_formation(integer) TO "grp-www";


--
-- TOC entry 8783 (class 0 OID 0)
-- Dependencies: 1636
-- Name: fmt_get_formation_langues(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fmt_get_formation_langues(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fmt_get_formation_langues(integer) FROM pgsql;
GRANT ALL ON FUNCTION fmt_get_formation_langues(integer) TO pgsql;
GRANT ALL ON FUNCTION fmt_get_formation_langues(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fmt_get_formation_langues(integer) TO "grp-www";


--
-- TOC entry 8785 (class 0 OID 0)
-- Dependencies: 1638
-- Name: fmt_get_individu_filieres(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fmt_get_individu_filieres(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fmt_get_individu_filieres(integer) FROM pgsql;
GRANT ALL ON FUNCTION fmt_get_individu_filieres(integer) TO pgsql;
GRANT ALL ON FUNCTION fmt_get_individu_filieres(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fmt_get_individu_filieres(integer) TO "grp-www";


--
-- TOC entry 8786 (class 0 OID 0)
-- Dependencies: 1637
-- Name: fmt_insert_formateur_droits_defaut(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fmt_insert_formateur_droits_defaut() FROM PUBLIC;
REVOKE ALL ON FUNCTION fmt_insert_formateur_droits_defaut() FROM pgsql;
GRANT ALL ON FUNCTION fmt_insert_formateur_droits_defaut() TO pgsql;
GRANT ALL ON FUNCTION fmt_insert_formateur_droits_defaut() TO PUBLIC;
GRANT ALL ON FUNCTION fmt_insert_formateur_droits_defaut() TO "grp-www";


--
-- TOC entry 8787 (class 0 OID 0)
-- Dependencies: 43
-- Name: fw_check_individu_modules_access_by_type(integer, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_check_individu_modules_access_by_type(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_check_individu_modules_access_by_type(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION fw_check_individu_modules_access_by_type(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION fw_check_individu_modules_access_by_type(integer, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_check_individu_modules_access_by_type(integer, character varying) TO "grp-www";


--
-- TOC entry 8788 (class 0 OID 0)
-- Dependencies: 1639
-- Name: fw_del_individu_individus_types(integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_del_individu_individus_types(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_del_individu_individus_types(integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION fw_del_individu_individus_types(integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION fw_del_individu_individus_types(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_del_individu_individus_types(integer, integer[]) TO "grp-www";


--
-- TOC entry 8789 (class 0 OID 0)
-- Dependencies: 1640
-- Name: fw_del_individu_type_modules(integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_del_individu_type_modules(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_del_individu_type_modules(integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION fw_del_individu_type_modules(integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION fw_del_individu_type_modules(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_del_individu_type_modules(integer, integer[]) TO "grp-www";


--
-- TOC entry 8790 (class 0 OID 0)
-- Dependencies: 1641
-- Name: fw_del_module(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_del_module(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_del_module(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_del_module(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_del_module(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_del_module(integer) TO "grp-www";


--
-- TOC entry 8791 (class 0 OID 0)
-- Dependencies: 1642
-- Name: fw_del_module_individus_types(integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_del_module_individus_types(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_del_module_individus_types(integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION fw_del_module_individus_types(integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION fw_del_module_individus_types(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_del_module_individus_types(integer, integer[]) TO "grp-www";


--
-- TOC entry 8792 (class 0 OID 0)
-- Dependencies: 1643
-- Name: fw_get_ams_libelle(character varying, character varying, character varying, character varying); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_get_ams_libelle(character varying, character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_ams_libelle(character varying, character varying, character varying, character varying) FROM postgres;
GRANT ALL ON FUNCTION fw_get_ams_libelle(character varying, character varying, character varying, character varying) TO postgres;
GRANT ALL ON FUNCTION fw_get_ams_libelle(character varying, character varying, character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_ams_libelle(character varying, character varying, character varying, character varying) TO "grp-www";


--
-- TOC entry 8793 (class 0 OID 0)
-- Dependencies: 1910
-- Name: fw_get_connexions(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_connexions() FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_connexions() FROM pgsql;
GRANT ALL ON FUNCTION fw_get_connexions() TO pgsql;
GRANT ALL ON FUNCTION fw_get_connexions() TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_connexions() TO "grp-www";


--
-- TOC entry 8794 (class 0 OID 0)
-- Dependencies: 1911
-- Name: fw_get_droits(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_get_droits() FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_droits() FROM postgres;
GRANT ALL ON FUNCTION fw_get_droits() TO postgres;
GRANT ALL ON FUNCTION fw_get_droits() TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_droits() TO "grp-www";


--
-- TOC entry 8796 (class 0 OID 0)
-- Dependencies: 1644
-- Name: fw_get_droits_defaut(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_droits_defaut(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_droits_defaut(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_droits_defaut(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_get_droits_defaut(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_droits_defaut(integer) TO "grp-www";


--
-- TOC entry 8798 (class 0 OID 0)
-- Dependencies: 1645
-- Name: fw_get_individu(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_individu(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individu(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_individu(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_get_individu(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individu(integer) TO "grp-www";


--
-- TOC entry 8799 (class 0 OID 0)
-- Dependencies: 1646
-- Name: fw_get_individu_droits(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_get_individu_droits(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individu_droits(integer) FROM postgres;
GRANT ALL ON FUNCTION fw_get_individu_droits(integer) TO postgres;
GRANT ALL ON FUNCTION fw_get_individu_droits(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individu_droits(integer) TO "grp-www";


--
-- TOC entry 8800 (class 0 OID 0)
-- Dependencies: 1647
-- Name: fw_get_individu_modules(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_get_individu_modules(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individu_modules(integer) FROM postgres;
GRANT ALL ON FUNCTION fw_get_individu_modules(integer) TO postgres;
GRANT ALL ON FUNCTION fw_get_individu_modules(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individu_modules(integer) TO "grp-www";


--
-- TOC entry 8802 (class 0 OID 0)
-- Dependencies: 1648
-- Name: fw_get_individu_nom_prenom(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_individu_nom_prenom(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individu_nom_prenom(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_individu_nom_prenom(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_get_individu_nom_prenom(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individu_nom_prenom(integer) TO "grp-www";


--
-- TOC entry 8803 (class 0 OID 0)
-- Dependencies: 1649
-- Name: fw_get_individu_type_modules(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_get_individu_type_modules(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individu_type_modules(integer) FROM postgres;
GRANT ALL ON FUNCTION fw_get_individu_type_modules(integer) TO postgres;
GRANT ALL ON FUNCTION fw_get_individu_type_modules(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individu_type_modules(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_get_individu_type_modules(integer) TO "grp-www";


--
-- TOC entry 8805 (class 0 OID 0)
-- Dependencies: 1651
-- Name: fw_get_individu_types(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_individu_types(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individu_types(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_individu_types(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_get_individu_types(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individu_types(integer) TO "grp-www";


--
-- TOC entry 8807 (class 0 OID 0)
-- Dependencies: 1650
-- Name: fw_get_individu_types(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_individu_types() FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individu_types() FROM pgsql;
GRANT ALL ON FUNCTION fw_get_individu_types() TO pgsql;
GRANT ALL ON FUNCTION fw_get_individu_types() TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individu_types() TO "grp-www";


--
-- TOC entry 8809 (class 0 OID 0)
-- Dependencies: 1652
-- Name: fw_get_individus(integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_individus(integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individus(integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_individus(integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION fw_get_individus(integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individus(integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 8811 (class 0 OID 0)
-- Dependencies: 1653
-- Name: fw_get_individus_except_individus_types(integer[], character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_individus_except_individus_types(integer[], character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individus_except_individus_types(integer[], character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_individus_except_individus_types(integer[], character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION fw_get_individus_except_individus_types(integer[], character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individus_except_individus_types(integer[], character varying, boolean) TO "grp-www";


--
-- TOC entry 8813 (class 0 OID 0)
-- Dependencies: 1912
-- Name: fw_get_individus_infos(integer, character varying, boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_individus_infos(integer, character varying, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individus_infos(integer, character varying, boolean) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_individus_infos(integer, character varying, boolean) TO pgsql;
GRANT ALL ON FUNCTION fw_get_individus_infos(integer, character varying, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individus_infos(integer, character varying, boolean) TO "grp-www";


--
-- TOC entry 8815 (class 0 OID 0)
-- Dependencies: 1913
-- Name: fw_get_individus_types(boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_individus_types(boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individus_types(boolean) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_individus_types(boolean) TO pgsql;
GRANT ALL ON FUNCTION fw_get_individus_types(boolean) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individus_types(boolean) TO "grp-www";


--
-- TOC entry 8816 (class 0 OID 0)
-- Dependencies: 44
-- Name: fw_get_individus_types_libelles_by_codes(character varying[]); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_individus_types_libelles_by_codes(character varying[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individus_types_libelles_by_codes(character varying[]) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_individus_types_libelles_by_codes(character varying[]) TO pgsql;
GRANT ALL ON FUNCTION fw_get_individus_types_libelles_by_codes(character varying[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individus_types_libelles_by_codes(character varying[]) TO "grp-www";


--
-- TOC entry 8817 (class 0 OID 0)
-- Dependencies: 1914
-- Name: fw_get_individus_types_modules_droits(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_get_individus_types_modules_droits() FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_individus_types_modules_droits() FROM postgres;
GRANT ALL ON FUNCTION fw_get_individus_types_modules_droits() TO postgres;
GRANT ALL ON FUNCTION fw_get_individus_types_modules_droits() TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_individus_types_modules_droits() TO "grp-www";


--
-- TOC entry 8819 (class 0 OID 0)
-- Dependencies: 1915
-- Name: fw_get_langue(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_langue(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_langue(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_langue(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_get_langue(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_langue(integer) TO "grp-www";


--
-- TOC entry 8821 (class 0 OID 0)
-- Dependencies: 1654
-- Name: fw_get_langues(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_langues() FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_langues() FROM pgsql;
GRANT ALL ON FUNCTION fw_get_langues() TO pgsql;
GRANT ALL ON FUNCTION fw_get_langues() TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_langues() TO "grp-www";


--
-- TOC entry 8822 (class 0 OID 0)
-- Dependencies: 1655
-- Name: fw_get_module(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_module(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_module(character varying) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_module(character varying) TO pgsql;
GRANT ALL ON FUNCTION fw_get_module(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_module(character varying) TO "grp-www";


--
-- TOC entry 8823 (class 0 OID 0)
-- Dependencies: 1656
-- Name: fw_get_module_individus_types(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_module_individus_types(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_module_individus_types(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_module_individus_types(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_get_module_individus_types(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_module_individus_types(integer) TO "grp-www";


--
-- TOC entry 8824 (class 0 OID 0)
-- Dependencies: 1657
-- Name: fw_get_module_individus_types_droits(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_get_module_individus_types_droits(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_module_individus_types_droits(integer) FROM postgres;
GRANT ALL ON FUNCTION fw_get_module_individus_types_droits(integer) TO postgres;
GRANT ALL ON FUNCTION fw_get_module_individus_types_droits(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_module_individus_types_droits(integer) TO "grp-www";


--
-- TOC entry 8825 (class 0 OID 0)
-- Dependencies: 1658
-- Name: fw_get_module_pages(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_module_pages(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_module_pages(character varying) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_module_pages(character varying) TO pgsql;
GRANT ALL ON FUNCTION fw_get_module_pages(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_module_pages(character varying) TO "grp-www";


--
-- TOC entry 8826 (class 0 OID 0)
-- Dependencies: 1659
-- Name: fw_get_module_submodules(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_module_submodules(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_module_submodules(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_module_submodules(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_get_module_submodules(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_module_submodules(integer) TO "grp-www";


--
-- TOC entry 8827 (class 0 OID 0)
-- Dependencies: 1661
-- Name: fw_get_modules(boolean); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_modules(boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_modules(boolean) FROM pgsql;
GRANT ALL ON FUNCTION fw_get_modules(boolean) TO pgsql;
GRANT ALL ON FUNCTION fw_get_modules(boolean) TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_modules(boolean) TO "grp-www";


--
-- TOC entry 8828 (class 0 OID 0)
-- Dependencies: 1660
-- Name: fw_get_modules(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_get_modules() FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_modules() FROM pgsql;
GRANT ALL ON FUNCTION fw_get_modules() TO pgsql;
GRANT ALL ON FUNCTION fw_get_modules() TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_modules() TO "grp-www";


--
-- TOC entry 8829 (class 0 OID 0)
-- Dependencies: 1662
-- Name: fw_get_modules_individus_types_droits(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_get_modules_individus_types_droits() FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_get_modules_individus_types_droits() FROM postgres;
GRANT ALL ON FUNCTION fw_get_modules_individus_types_droits() TO postgres;
GRANT ALL ON FUNCTION fw_get_modules_individus_types_droits() TO PUBLIC;
GRANT ALL ON FUNCTION fw_get_modules_individus_types_droits() TO "grp-www";


--
-- TOC entry 8831 (class 0 OID 0)
-- Dependencies: 1916
-- Name: fw_is_formateur(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_is_formateur(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_is_formateur(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_is_formateur(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_is_formateur(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_is_formateur(integer) TO "grp-www";


--
-- TOC entry 8833 (class 0 OID 0)
-- Dependencies: 1917
-- Name: fw_is_root(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_is_root(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_is_root(integer) FROM pgsql;
GRANT ALL ON FUNCTION fw_is_root(integer) TO pgsql;
GRANT ALL ON FUNCTION fw_is_root(integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_is_root(integer) TO "grp-www";


--
-- TOC entry 8834 (class 0 OID 0)
-- Dependencies: 1663
-- Name: fw_maj_individu_langue(integer, integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_maj_individu_langue(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_maj_individu_langue(integer, integer) FROM postgres;
GRANT ALL ON FUNCTION fw_maj_individu_langue(integer, integer) TO postgres;
GRANT ALL ON FUNCTION fw_maj_individu_langue(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION fw_maj_individu_langue(integer, integer) TO "grp-www";


--
-- TOC entry 8835 (class 0 OID 0)
-- Dependencies: 1664
-- Name: fw_maj_module_activation(integer, boolean, boolean); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_maj_module_activation(integer, boolean, boolean) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_maj_module_activation(integer, boolean, boolean) FROM postgres;
GRANT ALL ON FUNCTION fw_maj_module_activation(integer, boolean, boolean) TO postgres;
GRANT ALL ON FUNCTION fw_maj_module_activation(integer, boolean, boolean) TO PUBLIC;
GRANT ALL ON FUNCTION fw_maj_module_activation(integer, boolean, boolean) TO "grp-www";


--
-- TOC entry 8836 (class 0 OID 0)
-- Dependencies: 1665
-- Name: fw_root_nodel(); Type: ACL; Schema: contraintes; Owner: skel
--

REVOKE ALL ON FUNCTION fw_root_nodel() FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_root_nodel() FROM skel;
GRANT ALL ON FUNCTION fw_root_nodel() TO skel;
GRANT ALL ON FUNCTION fw_root_nodel() TO PUBLIC;
GRANT ALL ON FUNCTION fw_root_nodel() TO "grp-www";


--
-- TOC entry 8837 (class 0 OID 0)
-- Dependencies: 1667
-- Name: fw_root_noupdate(); Type: ACL; Schema: contraintes; Owner: skel
--

REVOKE ALL ON FUNCTION fw_root_noupdate() FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_root_noupdate() FROM skel;
GRANT ALL ON FUNCTION fw_root_noupdate() TO skel;
GRANT ALL ON FUNCTION fw_root_noupdate() TO PUBLIC;
GRANT ALL ON FUNCTION fw_root_noupdate() TO "grp-www";


--
-- TOC entry 8838 (class 0 OID 0)
-- Dependencies: 1666
-- Name: fw_set_individu_individus_types(integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_set_individu_individus_types(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_individu_individus_types(integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION fw_set_individu_individus_types(integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION fw_set_individu_individus_types(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_individu_individus_types(integer, integer[]) TO "grp-www";


--
-- TOC entry 8839 (class 0 OID 0)
-- Dependencies: 45
-- Name: fw_set_individu_type(character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_set_individu_type(character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_individu_type(character varying) FROM pgsql;
GRANT ALL ON FUNCTION fw_set_individu_type(character varying) TO pgsql;
GRANT ALL ON FUNCTION fw_set_individu_type(character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_individu_type(character varying) TO "grp-www";


--
-- TOC entry 8840 (class 0 OID 0)
-- Dependencies: 1668
-- Name: fw_set_individu_type_module_droits(integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_set_individu_type_module_droits(integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_individu_type_module_droits(integer, integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION fw_set_individu_type_module_droits(integer, integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION fw_set_individu_type_module_droits(integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_individu_type_module_droits(integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8841 (class 0 OID 0)
-- Dependencies: 1918
-- Name: fw_set_individu_type_modules(integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_set_individu_type_modules(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_individu_type_modules(integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION fw_set_individu_type_modules(integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION fw_set_individu_type_modules(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_individu_type_modules(integer, integer[]) TO "grp-www";


--
-- TOC entry 8842 (class 0 OID 0)
-- Dependencies: 1669
-- Name: fw_set_individu_type_modules_old(integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_set_individu_type_modules_old(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_individu_type_modules_old(integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION fw_set_individu_type_modules_old(integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION fw_set_individu_type_modules_old(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_individu_type_modules_old(integer, integer[]) TO "grp-www";


--
-- TOC entry 8843 (class 0 OID 0)
-- Dependencies: 1670
-- Name: fw_set_langue(character varying, character varying, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_set_langue(character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_langue(character varying, character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION fw_set_langue(character varying, character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION fw_set_langue(character varying, character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_langue(character varying, character varying, character varying) TO "grp-www";


--
-- TOC entry 8845 (class 0 OID 0)
-- Dependencies: 1671
-- Name: fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying) FROM pgsql;
GRANT ALL ON FUNCTION fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying) TO pgsql;
GRANT ALL ON FUNCTION fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_module(character varying, character varying, character varying, character varying, text, boolean, character varying) TO "grp-www";


--
-- TOC entry 8846 (class 0 OID 0)
-- Dependencies: 1672
-- Name: fw_set_module_individu_type_droits(integer, integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_set_module_individu_type_droits(integer, integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_module_individu_type_droits(integer, integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION fw_set_module_individu_type_droits(integer, integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION fw_set_module_individu_type_droits(integer, integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_module_individu_type_droits(integer, integer, integer[]) TO "grp-www";


--
-- TOC entry 8847 (class 0 OID 0)
-- Dependencies: 1673
-- Name: fw_set_module_individus_types(integer, integer[]); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION fw_set_module_individus_types(integer, integer[]) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_module_individus_types(integer, integer[]) FROM postgres;
GRANT ALL ON FUNCTION fw_set_module_individus_types(integer, integer[]) TO postgres;
GRANT ALL ON FUNCTION fw_set_module_individus_types(integer, integer[]) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_module_individus_types(integer, integer[]) TO "grp-www";


--
-- TOC entry 8848 (class 0 OID 0)
-- Dependencies: 1674
-- Name: fw_set_module_page(integer, character varying, character varying, character varying, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_set_module_page(integer, character varying, character varying, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_module_page(integer, character varying, character varying, character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION fw_set_module_page(integer, character varying, character varying, character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION fw_set_module_page(integer, character varying, character varying, character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_module_page(integer, character varying, character varying, character varying, character varying) TO "grp-www";


--
-- TOC entry 8849 (class 0 OID 0)
-- Dependencies: 1676
-- Name: fw_set_module_submodule(integer, character varying, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_set_module_submodule(integer, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_module_submodule(integer, character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION fw_set_module_submodule(integer, character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION fw_set_module_submodule(integer, character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_module_submodule(integer, character varying, character varying) TO "grp-www";


--
-- TOC entry 8850 (class 0 OID 0)
-- Dependencies: 1675
-- Name: fw_set_module_submodule(integer, integer, character varying, character varying); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION fw_set_module_submodule(integer, integer, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION fw_set_module_submodule(integer, integer, character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION fw_set_module_submodule(integer, integer, character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION fw_set_module_submodule(integer, integer, character varying, character varying) TO PUBLIC;
GRANT ALL ON FUNCTION fw_set_module_submodule(integer, integer, character varying, character varying) TO "grp-www";


--
-- TOC entry 8851 (class 0 OID 0)
-- Dependencies: 46
-- Name: get_random_string(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION get_random_string(string_length integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION get_random_string(string_length integer) FROM pgsql;
GRANT ALL ON FUNCTION get_random_string(string_length integer) TO pgsql;
GRANT ALL ON FUNCTION get_random_string(string_length integer) TO PUBLIC;
GRANT ALL ON FUNCTION get_random_string(string_length integer) TO "grp-www";


--
-- TOC entry 8852 (class 0 OID 0)
-- Dependencies: 47
-- Name: get_random_string_2(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION get_random_string_2(string_length integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION get_random_string_2(string_length integer) FROM pgsql;
GRANT ALL ON FUNCTION get_random_string_2(string_length integer) TO pgsql;
GRANT ALL ON FUNCTION get_random_string_2(string_length integer) TO PUBLIC;
GRANT ALL ON FUNCTION get_random_string_2(string_length integer) TO "grp-www";


--
-- TOC entry 8853 (class 0 OID 0)
-- Dependencies: 1677
-- Name: insert_categorie_etape(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_categorie_etape() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_categorie_etape() FROM pgsql;
GRANT ALL ON FUNCTION insert_categorie_etape() TO pgsql;
GRANT ALL ON FUNCTION insert_categorie_etape() TO PUBLIC;
GRANT ALL ON FUNCTION insert_categorie_etape() TO "grp-www";


--
-- TOC entry 8854 (class 0 OID 0)
-- Dependencies: 1678
-- Name: insert_categorie_evaluation(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_categorie_evaluation() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_categorie_evaluation() FROM pgsql;
GRANT ALL ON FUNCTION insert_categorie_evaluation() TO pgsql;
GRANT ALL ON FUNCTION insert_categorie_evaluation() TO PUBLIC;
GRANT ALL ON FUNCTION insert_categorie_evaluation() TO "grp-www";


--
-- TOC entry 8855 (class 0 OID 0)
-- Dependencies: 1679
-- Name: insert_categorie_fichier_ressource(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_categorie_fichier_ressource() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_categorie_fichier_ressource() FROM pgsql;
GRANT ALL ON FUNCTION insert_categorie_fichier_ressource() TO pgsql;
GRANT ALL ON FUNCTION insert_categorie_fichier_ressource() TO PUBLIC;
GRANT ALL ON FUNCTION insert_categorie_fichier_ressource() TO "grp-www";


--
-- TOC entry 8856 (class 0 OID 0)
-- Dependencies: 1680
-- Name: insert_categorie_glossaire(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_categorie_glossaire() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_categorie_glossaire() FROM pgsql;
GRANT ALL ON FUNCTION insert_categorie_glossaire() TO pgsql;
GRANT ALL ON FUNCTION insert_categorie_glossaire() TO PUBLIC;
GRANT ALL ON FUNCTION insert_categorie_glossaire() TO "grp-www";


--
-- TOC entry 8857 (class 0 OID 0)
-- Dependencies: 1681
-- Name: insert_categorie_scenario(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_categorie_scenario() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_categorie_scenario() FROM pgsql;
GRANT ALL ON FUNCTION insert_categorie_scenario() TO pgsql;
GRANT ALL ON FUNCTION insert_categorie_scenario() TO PUBLIC;
GRANT ALL ON FUNCTION insert_categorie_scenario() TO "grp-www";


--
-- TOC entry 8858 (class 0 OID 0)
-- Dependencies: 1682
-- Name: insert_categorie_scenario_dynamique(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_categorie_scenario_dynamique() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_categorie_scenario_dynamique() FROM pgsql;
GRANT ALL ON FUNCTION insert_categorie_scenario_dynamique() TO pgsql;
GRANT ALL ON FUNCTION insert_categorie_scenario_dynamique() TO PUBLIC;
GRANT ALL ON FUNCTION insert_categorie_scenario_dynamique() TO "grp-www";


--
-- TOC entry 8859 (class 0 OID 0)
-- Dependencies: 1683
-- Name: insert_categorie_scenarios(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_categorie_scenarios() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_categorie_scenarios() FROM pgsql;
GRANT ALL ON FUNCTION insert_categorie_scenarios() TO pgsql;
GRANT ALL ON FUNCTION insert_categorie_scenarios() TO PUBLIC;
GRANT ALL ON FUNCTION insert_categorie_scenarios() TO "grp-www";


--
-- TOC entry 8860 (class 0 OID 0)
-- Dependencies: 1684
-- Name: insert_etape_scorm(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_etape_scorm() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_etape_scorm() FROM pgsql;
GRANT ALL ON FUNCTION insert_etape_scorm() TO pgsql;
GRANT ALL ON FUNCTION insert_etape_scorm() TO PUBLIC;
GRANT ALL ON FUNCTION insert_etape_scorm() TO "grp-www";


--
-- TOC entry 8861 (class 0 OID 0)
-- Dependencies: 1685
-- Name: insert_fichier_ressource(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_fichier_ressource() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_fichier_ressource() FROM pgsql;
GRANT ALL ON FUNCTION insert_fichier_ressource() TO pgsql;
GRANT ALL ON FUNCTION insert_fichier_ressource() TO PUBLIC;
GRANT ALL ON FUNCTION insert_fichier_ressource() TO "grp-www";


--
-- TOC entry 8862 (class 0 OID 0)
-- Dependencies: 1686
-- Name: insert_formateur_droits_defaut(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_formateur_droits_defaut() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_formateur_droits_defaut() FROM pgsql;
GRANT ALL ON FUNCTION insert_formateur_droits_defaut() TO pgsql;
GRANT ALL ON FUNCTION insert_formateur_droits_defaut() TO PUBLIC;
GRANT ALL ON FUNCTION insert_formateur_droits_defaut() TO "grp-www";


--
-- TOC entry 8863 (class 0 OID 0)
-- Dependencies: 1687
-- Name: insert_glossaire(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_glossaire() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_glossaire() FROM pgsql;
GRANT ALL ON FUNCTION insert_glossaire() TO pgsql;
GRANT ALL ON FUNCTION insert_glossaire() TO PUBLIC;
GRANT ALL ON FUNCTION insert_glossaire() TO "grp-www";


--
-- TOC entry 8864 (class 0 OID 0)
-- Dependencies: 1688
-- Name: insert_liste(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_liste() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_liste() FROM pgsql;
GRANT ALL ON FUNCTION insert_liste() TO pgsql;
GRANT ALL ON FUNCTION insert_liste() TO PUBLIC;
GRANT ALL ON FUNCTION insert_liste() TO "grp-www";


--
-- TOC entry 8866 (class 0 OID 0)
-- Dependencies: 49
-- Name: insert_qcm_sondage(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_qcm_sondage() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_qcm_sondage() FROM pgsql;
GRANT ALL ON FUNCTION insert_qcm_sondage() TO pgsql;
GRANT ALL ON FUNCTION insert_qcm_sondage() TO PUBLIC;
GRANT ALL ON FUNCTION insert_qcm_sondage() TO "grp-www";


--
-- TOC entry 8868 (class 0 OID 0)
-- Dependencies: 1919
-- Name: insert_qsrc(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_qsrc() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_qsrc() FROM pgsql;
GRANT ALL ON FUNCTION insert_qsrc() TO pgsql;
GRANT ALL ON FUNCTION insert_qsrc() TO PUBLIC;
GRANT ALL ON FUNCTION insert_qsrc() TO "grp-www";


--
-- TOC entry 8869 (class 0 OID 0)
-- Dependencies: 1689
-- Name: insert_question_reponse_element(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_question_reponse_element() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_question_reponse_element() FROM pgsql;
GRANT ALL ON FUNCTION insert_question_reponse_element() TO pgsql;
GRANT ALL ON FUNCTION insert_question_reponse_element() TO PUBLIC;
GRANT ALL ON FUNCTION insert_question_reponse_element() TO "grp-www";


--
-- TOC entry 8870 (class 0 OID 0)
-- Dependencies: 1690
-- Name: insert_ressource(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_ressource() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_ressource() FROM pgsql;
GRANT ALL ON FUNCTION insert_ressource() TO pgsql;
GRANT ALL ON FUNCTION insert_ressource() TO PUBLIC;
GRANT ALL ON FUNCTION insert_ressource() TO "grp-www";


--
-- TOC entry 8871 (class 0 OID 0)
-- Dependencies: 1691
-- Name: insert_scenario(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_scenario() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_scenario() FROM pgsql;
GRANT ALL ON FUNCTION insert_scenario() TO pgsql;
GRANT ALL ON FUNCTION insert_scenario() TO PUBLIC;
GRANT ALL ON FUNCTION insert_scenario() TO "grp-www";


--
-- TOC entry 8872 (class 0 OID 0)
-- Dependencies: 1692
-- Name: insert_scenario_dynamique(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_scenario_dynamique() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_scenario_dynamique() FROM pgsql;
GRANT ALL ON FUNCTION insert_scenario_dynamique() TO pgsql;
GRANT ALL ON FUNCTION insert_scenario_dynamique() TO PUBLIC;
GRANT ALL ON FUNCTION insert_scenario_dynamique() TO "grp-www";


--
-- TOC entry 8874 (class 0 OID 0)
-- Dependencies: 1693
-- Name: insert_serie_aleatoire_multitheme_theme_categorie(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_serie_aleatoire_multitheme_theme_categorie() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_serie_aleatoire_multitheme_theme_categorie() FROM pgsql;
GRANT ALL ON FUNCTION insert_serie_aleatoire_multitheme_theme_categorie() TO pgsql;
GRANT ALL ON FUNCTION insert_serie_aleatoire_multitheme_theme_categorie() TO PUBLIC;
GRANT ALL ON FUNCTION insert_serie_aleatoire_multitheme_theme_categorie() TO "grp-www";


--
-- TOC entry 8875 (class 0 OID 0)
-- Dependencies: 1694
-- Name: insert_session_debut(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION insert_session_debut() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_session_debut() FROM postgres;
GRANT ALL ON FUNCTION insert_session_debut() TO postgres;
GRANT ALL ON FUNCTION insert_session_debut() TO PUBLIC;
GRANT ALL ON FUNCTION insert_session_debut() TO "grp-www";


--
-- TOC entry 8876 (class 0 OID 0)
-- Dependencies: 1695
-- Name: insert_session_fin(); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION insert_session_fin() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_session_fin() FROM postgres;
GRANT ALL ON FUNCTION insert_session_fin() TO postgres;
GRANT ALL ON FUNCTION insert_session_fin() TO PUBLIC;
GRANT ALL ON FUNCTION insert_session_fin() TO "grp-www";


--
-- TOC entry 8877 (class 0 OID 0)
-- Dependencies: 50
-- Name: is_individu_individu_type(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION is_individu_individu_type(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION is_individu_individu_type(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION is_individu_individu_type(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION is_individu_individu_type(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION is_individu_individu_type(integer, integer) TO "grp-www";


--
-- TOC entry 8879 (class 0 OID 0)
-- Dependencies: 1696
-- Name: old_af_get_formations(integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION old_af_get_formations(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION old_af_get_formations(integer) FROM pgsql;
GRANT ALL ON FUNCTION old_af_get_formations(integer) TO pgsql;
GRANT ALL ON FUNCTION old_af_get_formations(integer) TO PUBLIC;
GRANT ALL ON FUNCTION old_af_get_formations(integer) TO "grp-www";


--
-- TOC entry 8881 (class 0 OID 0)
-- Dependencies: 1697
-- Name: old_af_get_question_reponse_elements(integer); Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON FUNCTION old_af_get_question_reponse_elements(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION old_af_get_question_reponse_elements(integer) FROM postgres;
GRANT ALL ON FUNCTION old_af_get_question_reponse_elements(integer) TO postgres;
GRANT ALL ON FUNCTION old_af_get_question_reponse_elements(integer) TO PUBLIC;
GRANT ALL ON FUNCTION old_af_get_question_reponse_elements(integer) TO "grp-www";


--
-- TOC entry 8883 (class 0 OID 0)
-- Dependencies: 1698
-- Name: old_af_get_resultat_serie_evaluations_scores(bigint); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION old_af_get_resultat_serie_evaluations_scores(bigint) FROM PUBLIC;
REVOKE ALL ON FUNCTION old_af_get_resultat_serie_evaluations_scores(bigint) FROM pgsql;
GRANT ALL ON FUNCTION old_af_get_resultat_serie_evaluations_scores(bigint) TO pgsql;
GRANT ALL ON FUNCTION old_af_get_resultat_serie_evaluations_scores(bigint) TO PUBLIC;
GRANT ALL ON FUNCTION old_af_get_resultat_serie_evaluations_scores(bigint) TO "grp-www";


--
-- TOC entry 8885 (class 0 OID 0)
-- Dependencies: 1699
-- Name: old_af_get_theme_series(integer, integer); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION old_af_get_theme_series(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION old_af_get_theme_series(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION old_af_get_theme_series(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION old_af_get_theme_series(integer, integer) TO PUBLIC;
GRANT ALL ON FUNCTION old_af_get_theme_series(integer, integer) TO "grp-www";


--
-- TOC entry 8886 (class 0 OID 0)
-- Dependencies: 1700
-- Name: substr_count(text, text); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION substr_count(chaine text, souschaine text) FROM PUBLIC;
REVOKE ALL ON FUNCTION substr_count(chaine text, souschaine text) FROM pgsql;
GRANT ALL ON FUNCTION substr_count(chaine text, souschaine text) TO pgsql;
GRANT ALL ON FUNCTION substr_count(chaine text, souschaine text) TO PUBLIC;
GRANT ALL ON FUNCTION substr_count(chaine text, souschaine text) TO "grp-www";


--
-- TOC entry 8888 (class 0 OID 0)
-- Dependencies: 1701
-- Name: update_serie_aleatoire_multitheme_categorie_serie(); Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON FUNCTION update_serie_aleatoire_multitheme_categorie_serie() FROM PUBLIC;
REVOKE ALL ON FUNCTION update_serie_aleatoire_multitheme_categorie_serie() FROM pgsql;
GRANT ALL ON FUNCTION update_serie_aleatoire_multitheme_categorie_serie() TO pgsql;
GRANT ALL ON FUNCTION update_serie_aleatoire_multitheme_categorie_serie() TO PUBLIC;
GRANT ALL ON FUNCTION update_serie_aleatoire_multitheme_categorie_serie() TO "grp-www";


SET search_path = public, pg_catalog;

--
-- TOC entry 8889 (class 0 OID 0)
-- Dependencies: 1702
-- Name: _af_check_access(character varying, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_check_access(character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_check_access(character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_check_access(character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_check_access(character varying, integer, integer) TO PUBLIC;


--
-- TOC entry 8890 (class 0 OID 0)
-- Dependencies: 1703
-- Name: _af_check_aleatoire_serie(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_check_aleatoire_serie(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_check_aleatoire_serie(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_check_aleatoire_serie(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_check_aleatoire_serie(integer) TO PUBLIC;


--
-- TOC entry 8891 (class 0 OID 0)
-- Dependencies: 1704
-- Name: _af_check_dynamique_parcours(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_check_dynamique_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_check_dynamique_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_check_dynamique_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_check_dynamique_parcours(integer) TO PUBLIC;


--
-- TOC entry 8892 (class 0 OID 0)
-- Dependencies: 1705
-- Name: _af_check_groupe(integer, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_check_groupe(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_check_groupe(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_check_groupe(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_check_groupe(integer, character varying) TO PUBLIC;


--
-- TOC entry 8893 (class 0 OID 0)
-- Dependencies: 1706
-- Name: _af_del_avancement_stagiaire(integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_del_avancement_stagiaire(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_del_avancement_stagiaire(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_del_avancement_stagiaire(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_del_avancement_stagiaire(integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8894 (class 0 OID 0)
-- Dependencies: 1707
-- Name: _af_del_exotlc_stagiaire(integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_del_exotlc_stagiaire(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_del_exotlc_stagiaire(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_del_exotlc_stagiaire(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_del_exotlc_stagiaire(integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8895 (class 0 OID 0)
-- Dependencies: 1708
-- Name: _af_del_groupe(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_del_groupe(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_del_groupe(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_del_groupe(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_del_groupe(integer) TO PUBLIC;


--
-- TOC entry 8896 (class 0 OID 0)
-- Dependencies: 1709
-- Name: _af_del_individu_groupe(integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_del_individu_groupe(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_del_individu_groupe(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_del_individu_groupe(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_del_individu_groupe(integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8897 (class 0 OID 0)
-- Dependencies: 1710
-- Name: _af_del_series_bloquantes_stagi(integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_del_series_bloquantes_stagi(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_del_series_bloquantes_stagi(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_del_series_bloquantes_stagi(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_del_series_bloquantes_stagi(integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8898 (class 0 OID 0)
-- Dependencies: 1711
-- Name: _af_get_avancement_stagiaire(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_avancement_stagiaire(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_avancement_stagiaire(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_avancement_stagiaire(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_avancement_stagiaire(integer, integer) TO PUBLIC;


--
-- TOC entry 8899 (class 0 OID 0)
-- Dependencies: 1712
-- Name: _af_get_avancement_stagiaires_f(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_avancement_stagiaires_f(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_avancement_stagiaires_f(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_avancement_stagiaires_f(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_avancement_stagiaires_f(integer) TO PUBLIC;


--
-- TOC entry 8900 (class 0 OID 0)
-- Dependencies: 1713
-- Name: _af_get_classes_formateur(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_classes_formateur(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_classes_formateur(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_classes_formateur(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_classes_formateur(integer) TO PUBLIC;


--
-- TOC entry 8901 (class 0 OID 0)
-- Dependencies: 1714
-- Name: _af_get_connexions(integer, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_connexions(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_connexions(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_connexions(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_get_connexions(integer, character varying) TO PUBLIC;


--
-- TOC entry 8902 (class 0 OID 0)
-- Dependencies: 1715
-- Name: _af_get_droits_defaut(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_droits_defaut(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_droits_defaut(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_droits_defaut(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_droits_defaut(integer) TO PUBLIC;


--
-- TOC entry 8903 (class 0 OID 0)
-- Dependencies: 1716
-- Name: _af_get_droits_groupe_individu(integer, integer, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_droits_groupe_individu(integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_droits_groupe_individu(integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_droits_groupe_individu(integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_get_droits_groupe_individu(integer, integer, character varying) TO PUBLIC;


--
-- TOC entry 8904 (class 0 OID 0)
-- Dependencies: 1717
-- Name: _af_get_dynamique_parcours(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_dynamique_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_dynamique_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_dynamique_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_dynamique_parcours(integer) TO PUBLIC;


--
-- TOC entry 8905 (class 0 OID 0)
-- Dependencies: 1718
-- Name: _af_get_etapes_libres_parcours(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_etapes_libres_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_etapes_libres_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_etapes_libres_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_etapes_libres_parcours(integer) TO PUBLIC;


--
-- TOC entry 8906 (class 0 OID 0)
-- Dependencies: 1719
-- Name: _af_get_form_de_groupe(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_form_de_groupe(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_form_de_groupe(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_form_de_groupe(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_form_de_groupe(integer) TO PUBLIC;


--
-- TOC entry 8907 (class 0 OID 0)
-- Dependencies: 1720
-- Name: _af_get_form_user_groupe_eval(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_form_user_groupe_eval(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_form_user_groupe_eval(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_form_user_groupe_eval(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_form_user_groupe_eval(integer, integer) TO PUBLIC;


--
-- TOC entry 8908 (class 0 OID 0)
-- Dependencies: 1721
-- Name: _af_get_formations(character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations(character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations(character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations(character varying, integer) TO PUBLIC;


--
-- TOC entry 8909 (class 0 OID 0)
-- Dependencies: 1722
-- Name: _af_get_formations_filiere(integer, character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_filiere(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_filiere(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_filiere(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_filiere(integer, character varying, integer) TO PUBLIC;


--
-- TOC entry 8910 (class 0 OID 0)
-- Dependencies: 1723
-- Name: _af_get_formations_formateur(integer, integer, character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_formateur(integer, integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_formateur(integer, integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_formateur(integer, integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_formateur(integer, integer, character varying, integer) TO PUBLIC;


--
-- TOC entry 8911 (class 0 OID 0)
-- Dependencies: 1724
-- Name: _af_get_formations_formateur(integer, character varying, character varying, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_formateur(integer, character varying, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_formateur(integer, character varying, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_formateur(integer, character varying, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_formateur(integer, character varying, character varying, integer, integer) TO PUBLIC;


--
-- TOC entry 8912 (class 0 OID 0)
-- Dependencies: 1725
-- Name: _af_get_formations_formateur_pe(integer, integer, character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_formateur_pe(integer, integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_formateur_pe(integer, integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_formateur_pe(integer, integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_formateur_pe(integer, integer, character varying, integer) TO PUBLIC;


--
-- TOC entry 8913 (class 0 OID 0)
-- Dependencies: 1726
-- Name: _af_get_formations_groupe(integer, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_groupe(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_groupe(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_groupe(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_groupe(integer, character varying) TO PUBLIC;


--
-- TOC entry 8914 (class 0 OID 0)
-- Dependencies: 1727
-- Name: _af_get_formations_groupe(integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_groupe(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_groupe(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_groupe(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_groupe(integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8915 (class 0 OID 0)
-- Dependencies: 1728
-- Name: _af_get_formations_groupe(integer, character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_groupe(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_groupe(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_groupe(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_groupe(integer, character varying, integer) TO PUBLIC;


--
-- TOC entry 8916 (class 0 OID 0)
-- Dependencies: 1729
-- Name: _af_get_formations_individu(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_individu(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_individu(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_individu(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_individu(integer) TO PUBLIC;


--
-- TOC entry 8917 (class 0 OID 0)
-- Dependencies: 1730
-- Name: _af_get_formations_individu(integer, character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_individu(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_individu(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_individu(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_individu(integer, character varying, integer) TO PUBLIC;


--
-- TOC entry 8918 (class 0 OID 0)
-- Dependencies: 1731
-- Name: _af_get_formations_sondage_fini(character varying, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_sondage_fini(character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_sondage_fini(character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_sondage_fini(character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_sondage_fini(character varying, character varying) TO PUBLIC;


--
-- TOC entry 8919 (class 0 OID 0)
-- Dependencies: 1732
-- Name: _af_get_formations_stagiaire_ev(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_formations_stagiaire_ev(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_formations_stagiaire_ev(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_formations_stagiaire_ev(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_formations_stagiaire_ev(integer, integer) TO PUBLIC;


--
-- TOC entry 8920 (class 0 OID 0)
-- Dependencies: 1733
-- Name: _af_get_groupes_evaluation_fini(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_groupes_evaluation_fini(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_groupes_evaluation_fini(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_groupes_evaluation_fini(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_groupes_evaluation_fini(integer) TO PUBLIC;


--
-- TOC entry 8921 (class 0 OID 0)
-- Dependencies: 1734
-- Name: _af_get_groupes_individu(integer, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_groupes_individu(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_groupes_individu(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_groupes_individu(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_get_groupes_individu(integer, character varying) TO PUBLIC;


--
-- TOC entry 8922 (class 0 OID 0)
-- Dependencies: 1735
-- Name: _af_get_individus(); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_individus() FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_individus() FROM pgsql;
GRANT ALL ON FUNCTION _af_get_individus() TO pgsql;
GRANT ALL ON FUNCTION _af_get_individus() TO PUBLIC;


--
-- TOC entry 8923 (class 0 OID 0)
-- Dependencies: 1736
-- Name: _af_get_individus_affiliables(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_individus_affiliables(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_individus_affiliables(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_individus_affiliables(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_individus_affiliables(integer) TO PUBLIC;


--
-- TOC entry 8924 (class 0 OID 0)
-- Dependencies: 1737
-- Name: _af_get_individus_formation(integer, integer, integer, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_individus_formation(integer, integer, integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_individus_formation(integer, integer, integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_individus_formation(integer, integer, integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_get_individus_formation(integer, integer, integer, character varying) TO PUBLIC;


--
-- TOC entry 8925 (class 0 OID 0)
-- Dependencies: 1738
-- Name: _af_get_individus_groupe(integer, integer, character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_individus_groupe(integer, integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_individus_groupe(integer, integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_individus_groupe(integer, integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_individus_groupe(integer, integer, character varying, integer) TO PUBLIC;


--
-- TOC entry 8926 (class 0 OID 0)
-- Dependencies: 1739
-- Name: _af_get_individus_organisme(integer, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_individus_organisme(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_individus_organisme(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_individus_organisme(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_get_individus_organisme(integer, character varying) TO PUBLIC;


--
-- TOC entry 8927 (class 0 OID 0)
-- Dependencies: 1740
-- Name: _af_get_individus_organisme(integer, character varying, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_individus_organisme(integer, character varying, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_individus_organisme(integer, character varying, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_individus_organisme(integer, character varying, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_individus_organisme(integer, character varying, integer, integer) TO PUBLIC;


--
-- TOC entry 8928 (class 0 OID 0)
-- Dependencies: 1741
-- Name: _af_get_infos_exos_formation(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_infos_exos_formation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_infos_exos_formation(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_infos_exos_formation(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_infos_exos_formation(integer) TO PUBLIC;


--
-- TOC entry 8929 (class 0 OID 0)
-- Dependencies: 1742
-- Name: _af_get_infos_formation(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_infos_formation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_infos_formation(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_infos_formation(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_infos_formation(integer) TO PUBLIC;


--
-- TOC entry 8930 (class 0 OID 0)
-- Dependencies: 1743
-- Name: _af_get_infos_groupe(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_infos_groupe(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_infos_groupe(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_infos_groupe(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_infos_groupe(integer) TO PUBLIC;


--
-- TOC entry 8931 (class 0 OID 0)
-- Dependencies: 1744
-- Name: _af_get_infos_individu(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_infos_individu(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_infos_individu(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_infos_individu(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_infos_individu(integer) TO PUBLIC;


--
-- TOC entry 8932 (class 0 OID 0)
-- Dependencies: 1745
-- Name: _af_get_infos_presentiel_stagia(integer, integer, integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_infos_presentiel_stagia(integer, integer, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_infos_presentiel_stagia(integer, integer, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_infos_presentiel_stagia(integer, integer, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_infos_presentiel_stagia(integer, integer, integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8933 (class 0 OID 0)
-- Dependencies: 1746
-- Name: _af_get_infos_series_formation(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_infos_series_formation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_infos_series_formation(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_infos_series_formation(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_infos_series_formation(integer) TO PUBLIC;


--
-- TOC entry 8934 (class 0 OID 0)
-- Dependencies: 1747
-- Name: _af_get_liste_groupe_eval(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_liste_groupe_eval(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_liste_groupe_eval(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_liste_groupe_eval(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_liste_groupe_eval(integer) TO PUBLIC;


--
-- TOC entry 8935 (class 0 OID 0)
-- Dependencies: 1748
-- Name: _af_get_liste_stag_avec_eval(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_liste_stag_avec_eval(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_liste_stag_avec_eval(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_liste_stag_avec_eval(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_liste_stag_avec_eval(integer) TO PUBLIC;


--
-- TOC entry 8936 (class 0 OID 0)
-- Dependencies: 1749
-- Name: _af_get_liste_stag_groupe_eval(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_liste_stag_groupe_eval(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_liste_stag_groupe_eval(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_liste_stag_groupe_eval(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_liste_stag_groupe_eval(integer) TO PUBLIC;


--
-- TOC entry 8937 (class 0 OID 0)
-- Dependencies: 1750
-- Name: _af_get_mode_affichage_parcours(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_mode_affichage_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_mode_affichage_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_mode_affichage_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_mode_affichage_parcours(integer) TO PUBLIC;


--
-- TOC entry 8938 (class 0 OID 0)
-- Dependencies: 1751
-- Name: _af_get_nb_classes(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_classes(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_classes(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_classes(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_classes(integer) TO PUBLIC;


--
-- TOC entry 8939 (class 0 OID 0)
-- Dependencies: 1752
-- Name: _af_get_nb_exos(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_exos(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_exos(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_exos(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_exos(integer) TO PUBLIC;


--
-- TOC entry 8940 (class 0 OID 0)
-- Dependencies: 1753
-- Name: _af_get_nb_exos_faits(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_exos_faits(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_exos_faits(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_exos_faits(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_exos_faits(integer, integer) TO PUBLIC;


--
-- TOC entry 8941 (class 0 OID 0)
-- Dependencies: 1754
-- Name: _af_get_nb_exos_finis(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_exos_finis(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_exos_finis(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_exos_finis(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_exos_finis(integer, integer) TO PUBLIC;


--
-- TOC entry 8942 (class 0 OID 0)
-- Dependencies: 1755
-- Name: _af_get_nb_exos_form(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_exos_form(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_exos_form(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_exos_form(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_exos_form(integer) TO PUBLIC;


--
-- TOC entry 8943 (class 0 OID 0)
-- Dependencies: 1756
-- Name: _af_get_nb_formations(integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_formations(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_formations(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_formations(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_formations(integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8944 (class 0 OID 0)
-- Dependencies: 1757
-- Name: _af_get_nb_series(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_series(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_series(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_series(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_series(integer) TO PUBLIC;


--
-- TOC entry 8945 (class 0 OID 0)
-- Dependencies: 1758
-- Name: _af_get_nb_series_faites(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_series_faites(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_series_faites(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_series_faites(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_series_faites(integer, integer) TO PUBLIC;


--
-- TOC entry 8946 (class 0 OID 0)
-- Dependencies: 1759
-- Name: _af_get_nb_series_finies(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_series_finies(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_series_finies(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_series_finies(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_series_finies(integer, integer) TO PUBLIC;


--
-- TOC entry 8947 (class 0 OID 0)
-- Dependencies: 1760
-- Name: _af_get_nb_series_form(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nb_series_form(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nb_series_form(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nb_series_form(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nb_series_form(integer) TO PUBLIC;


--
-- TOC entry 8948 (class 0 OID 0)
-- Dependencies: 1761
-- Name: _af_get_niveau_groupe(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_niveau_groupe(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_niveau_groupe(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_niveau_groupe(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_niveau_groupe(integer) TO PUBLIC;


--
-- TOC entry 8949 (class 0 OID 0)
-- Dependencies: 1762
-- Name: _af_get_nom_calendrier(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nom_calendrier(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nom_calendrier(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nom_calendrier(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nom_calendrier(integer) TO PUBLIC;


--
-- TOC entry 8950 (class 0 OID 0)
-- Dependencies: 1763
-- Name: _af_get_nom_groupe(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nom_groupe(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nom_groupe(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nom_groupe(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nom_groupe(integer) TO PUBLIC;


--
-- TOC entry 8951 (class 0 OID 0)
-- Dependencies: 1764
-- Name: _af_get_nom_prenom_individu(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nom_prenom_individu(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nom_prenom_individu(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nom_prenom_individu(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nom_prenom_individu(integer) TO PUBLIC;


--
-- TOC entry 8952 (class 0 OID 0)
-- Dependencies: 1765
-- Name: _af_get_nom_prenom_utilisateur(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_nom_prenom_utilisateur(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_nom_prenom_utilisateur(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_nom_prenom_utilisateur(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_nom_prenom_utilisateur(integer) TO PUBLIC;


--
-- TOC entry 8953 (class 0 OID 0)
-- Dependencies: 1766
-- Name: _af_get_numero_groupe(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_numero_groupe(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_numero_groupe(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_numero_groupe(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_numero_groupe(integer) TO PUBLIC;


--
-- TOC entry 8954 (class 0 OID 0)
-- Dependencies: 1767
-- Name: _af_get_numero_parcours(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_numero_parcours(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_numero_parcours(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_numero_parcours(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_numero_parcours(integer, integer) TO PUBLIC;


--
-- TOC entry 8955 (class 0 OID 0)
-- Dependencies: 1768
-- Name: _af_get_parcours_formation(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_parcours_formation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_parcours_formation(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_parcours_formation(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_parcours_formation(integer) TO PUBLIC;


--
-- TOC entry 8956 (class 0 OID 0)
-- Dependencies: 1769
-- Name: _af_get_places_groupe(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_places_groupe(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_places_groupe(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_places_groupe(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_places_groupe(integer) TO PUBLIC;


--
-- TOC entry 8957 (class 0 OID 0)
-- Dependencies: 1770
-- Name: _af_get_resultats_exos_formatio(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_resultats_exos_formatio(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_resultats_exos_formatio(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_resultats_exos_formatio(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_resultats_exos_formatio(integer) TO PUBLIC;


--
-- TOC entry 8958 (class 0 OID 0)
-- Dependencies: 1771
-- Name: _af_get_resultats_series_format(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_resultats_series_format(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_resultats_series_format(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_resultats_series_format(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_resultats_series_format(integer) TO PUBLIC;


--
-- TOC entry 8959 (class 0 OID 0)
-- Dependencies: 1772
-- Name: _af_get_sous_parcours(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_sous_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_sous_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_sous_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_sous_parcours(integer) TO PUBLIC;


--
-- TOC entry 8960 (class 0 OID 0)
-- Dependencies: 1773
-- Name: _af_get_stag_avec_eval(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_stag_avec_eval(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_stag_avec_eval(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_stag_avec_eval(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_stag_avec_eval(integer) TO PUBLIC;


--
-- TOC entry 8961 (class 0 OID 0)
-- Dependencies: 1774
-- Name: _af_get_stag_form(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_stag_form(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_stag_form(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_stag_form(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_stag_form(integer) TO PUBLIC;


--
-- TOC entry 8962 (class 0 OID 0)
-- Dependencies: 1775
-- Name: _af_get_stagiaires_evaluation_f(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_stagiaires_evaluation_f(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_stagiaires_evaluation_f(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_stagiaires_evaluation_f(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_stagiaires_evaluation_f(integer) TO PUBLIC;


--
-- TOC entry 8963 (class 0 OID 0)
-- Dependencies: 1776
-- Name: _af_get_types_etapes_serie(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_get_types_etapes_serie(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_get_types_etapes_serie(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_get_types_etapes_serie(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_get_types_etapes_serie(integer, integer) TO PUBLIC;


--
-- TOC entry 8964 (class 0 OID 0)
-- Dependencies: 1777
-- Name: _af_liste_exos_form(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_liste_exos_form(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_liste_exos_form(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_liste_exos_form(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_liste_exos_form(integer) TO PUBLIC;


--
-- TOC entry 8965 (class 0 OID 0)
-- Dependencies: 1778
-- Name: _af_liste_series_form(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_liste_series_form(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_liste_series_form(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_liste_series_form(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_liste_series_form(integer) TO PUBLIC;


--
-- TOC entry 8966 (class 0 OID 0)
-- Dependencies: 1779
-- Name: _af_maj_infos_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_maj_infos_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_maj_infos_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_maj_infos_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_maj_infos_individu(integer, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, character varying, integer, character varying, character varying) TO PUBLIC;


--
-- TOC entry 8967 (class 0 OID 0)
-- Dependencies: 1780
-- Name: _af_maj_nom_groupe(integer, character varying); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_maj_nom_groupe(integer, character varying) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_maj_nom_groupe(integer, character varying) FROM pgsql;
GRANT ALL ON FUNCTION _af_maj_nom_groupe(integer, character varying) TO pgsql;
GRANT ALL ON FUNCTION _af_maj_nom_groupe(integer, character varying) TO PUBLIC;


--
-- TOC entry 8968 (class 0 OID 0)
-- Dependencies: 1781
-- Name: _af_maj_nom_groupe(integer, character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_maj_nom_groupe(integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_maj_nom_groupe(integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_maj_nom_groupe(integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_maj_nom_groupe(integer, character varying, integer) TO PUBLIC;


--
-- TOC entry 8969 (class 0 OID 0)
-- Dependencies: 1782
-- Name: _af_maj_places_groupe(integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_maj_places_groupe(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_maj_places_groupe(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_maj_places_groupe(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_maj_places_groupe(integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8970 (class 0 OID 0)
-- Dependencies: 1783
-- Name: _af_recup_ss_parcours(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_recup_ss_parcours(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_recup_ss_parcours(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_recup_ss_parcours(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_recup_ss_parcours(integer) TO PUBLIC;


--
-- TOC entry 8971 (class 0 OID 0)
-- Dependencies: 1784
-- Name: _af_set_avancement_stagiaire(integer, integer, integer, integer, integer, character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_set_avancement_stagiaire(integer, integer, integer, integer, integer, character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_set_avancement_stagiaire(integer, integer, integer, integer, integer, character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_set_avancement_stagiaire(integer, integer, integer, integer, integer, character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_set_avancement_stagiaire(integer, integer, integer, integer, integer, character varying, integer) TO PUBLIC;


--
-- TOC entry 8972 (class 0 OID 0)
-- Dependencies: 1785
-- Name: _af_set_droit_individu(integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_set_droit_individu(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_set_droit_individu(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_set_droit_individu(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_set_droit_individu(integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8973 (class 0 OID 0)
-- Dependencies: 1786
-- Name: _af_set_groupe(character varying, integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_set_groupe(character varying, integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_set_groupe(character varying, integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_set_groupe(character varying, integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_set_groupe(character varying, integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8974 (class 0 OID 0)
-- Dependencies: 1787
-- Name: _af_set_places_groupe(integer, integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_set_places_groupe(integer, integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_set_places_groupe(integer, integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_set_places_groupe(integer, integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_set_places_groupe(integer, integer, integer) TO PUBLIC;


--
-- TOC entry 8975 (class 0 OID 0)
-- Dependencies: 1788
-- Name: _af_stats_exo_formation(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_stats_exo_formation(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_stats_exo_formation(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_stats_exo_formation(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_stats_exo_formation(integer, integer) TO PUBLIC;


--
-- TOC entry 8976 (class 0 OID 0)
-- Dependencies: 1789
-- Name: _af_stats_exos_formation(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_stats_exos_formation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_stats_exos_formation(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_stats_exos_formation(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_stats_exos_formation(integer) TO PUBLIC;


--
-- TOC entry 8977 (class 0 OID 0)
-- Dependencies: 1790
-- Name: _af_stats_liste_formations(character varying, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_stats_liste_formations(character varying, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_stats_liste_formations(character varying, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_stats_liste_formations(character varying, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_stats_liste_formations(character varying, integer) TO PUBLIC;


--
-- TOC entry 8978 (class 0 OID 0)
-- Dependencies: 1791
-- Name: _af_stats_serie_formation(integer, integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_stats_serie_formation(integer, integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_stats_serie_formation(integer, integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_stats_serie_formation(integer, integer) TO pgsql;
GRANT ALL ON FUNCTION _af_stats_serie_formation(integer, integer) TO PUBLIC;


--
-- TOC entry 8979 (class 0 OID 0)
-- Dependencies: 1792
-- Name: _af_stats_series_formation(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_stats_series_formation(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_stats_series_formation(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_stats_series_formation(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_stats_series_formation(integer) TO PUBLIC;


--
-- TOC entry 8980 (class 0 OID 0)
-- Dependencies: 1793
-- Name: _af_test(); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_test() FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_test() FROM pgsql;
GRANT ALL ON FUNCTION _af_test() TO pgsql;
GRANT ALL ON FUNCTION _af_test() TO PUBLIC;


--
-- TOC entry 8981 (class 0 OID 0)
-- Dependencies: 1794
-- Name: _af_test_parcours_dyn(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_test_parcours_dyn(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_test_parcours_dyn(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_test_parcours_dyn(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_test_parcours_dyn(integer) TO PUBLIC;


--
-- TOC entry 8982 (class 0 OID 0)
-- Dependencies: 1795
-- Name: _af_test_serie_aleatoire(integer); Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON FUNCTION _af_test_serie_aleatoire(integer) FROM PUBLIC;
REVOKE ALL ON FUNCTION _af_test_serie_aleatoire(integer) FROM pgsql;
GRANT ALL ON FUNCTION _af_test_serie_aleatoire(integer) TO pgsql;
GRANT ALL ON FUNCTION _af_test_serie_aleatoire(integer) TO PUBLIC;


SET search_path = v2, pg_catalog;

--
-- TOC entry 8988 (class 0 OID 0)
-- Dependencies: 1796
-- Name: check_alerte_dates(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_alerte_dates() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_alerte_dates() FROM postgres;
GRANT ALL ON FUNCTION check_alerte_dates() TO postgres;
GRANT ALL ON FUNCTION check_alerte_dates() TO PUBLIC;


--
-- TOC entry 8990 (class 0 OID 0)
-- Dependencies: 1797
-- Name: check_calendrier_date(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_calendrier_date() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_calendrier_date() FROM postgres;
GRANT ALL ON FUNCTION check_calendrier_date() TO postgres;
GRANT ALL ON FUNCTION check_calendrier_date() TO PUBLIC;


--
-- TOC entry 8993 (class 0 OID 0)
-- Dependencies: 1798
-- Name: check_evaluation_qsrc_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_evaluation_qsrc_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_evaluation_qsrc_type() FROM postgres;
GRANT ALL ON FUNCTION check_evaluation_qsrc_type() TO postgres;
GRANT ALL ON FUNCTION check_evaluation_qsrc_type() TO PUBLIC;


--
-- TOC entry 8996 (class 0 OID 0)
-- Dependencies: 1799
-- Name: check_evaluation_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_evaluation_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_evaluation_type() FROM postgres;
GRANT ALL ON FUNCTION check_evaluation_type() TO postgres;
GRANT ALL ON FUNCTION check_evaluation_type() TO PUBLIC;


--
-- TOC entry 8998 (class 0 OID 0)
-- Dependencies: 1800
-- Name: check_evaluation_type2(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_evaluation_type2() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_evaluation_type2() FROM postgres;
GRANT ALL ON FUNCTION check_evaluation_type2() TO postgres;
GRANT ALL ON FUNCTION check_evaluation_type2() TO PUBLIC;


--
-- TOC entry 9001 (class 0 OID 0)
-- Dependencies: 1801
-- Name: check_exotlc_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_exotlc_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_exotlc_type() FROM postgres;
GRANT ALL ON FUNCTION check_exotlc_type() TO postgres;
GRANT ALL ON FUNCTION check_exotlc_type() TO PUBLIC;


--
-- TOC entry 9003 (class 0 OID 0)
-- Dependencies: 1802
-- Name: check_fichier_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_fichier_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_fichier_type() FROM postgres;
GRANT ALL ON FUNCTION check_fichier_type() TO postgres;
GRANT ALL ON FUNCTION check_fichier_type() TO PUBLIC;


--
-- TOC entry 9005 (class 0 OID 0)
-- Dependencies: 1803
-- Name: check_formateur_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_formateur_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_formateur_type() FROM postgres;
GRANT ALL ON FUNCTION check_formateur_type() TO postgres;
GRANT ALL ON FUNCTION check_formateur_type() TO PUBLIC;


--
-- TOC entry 9007 (class 0 OID 0)
-- Dependencies: 1804
-- Name: check_intervenant_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_intervenant_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_intervenant_type() FROM postgres;
GRANT ALL ON FUNCTION check_intervenant_type() TO postgres;
GRANT ALL ON FUNCTION check_intervenant_type() TO PUBLIC;


--
-- TOC entry 9010 (class 0 OID 0)
-- Dependencies: 1805
-- Name: check_liste_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_liste_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_liste_type() FROM postgres;
GRANT ALL ON FUNCTION check_liste_type() TO postgres;
GRANT ALL ON FUNCTION check_liste_type() TO PUBLIC;


--
-- TOC entry 9012 (class 0 OID 0)
-- Dependencies: 1806
-- Name: check_liste_type_serie(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_liste_type_serie() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_liste_type_serie() FROM postgres;
GRANT ALL ON FUNCTION check_liste_type_serie() TO postgres;
GRANT ALL ON FUNCTION check_liste_type_serie() TO PUBLIC;


--
-- TOC entry 9014 (class 0 OID 0)
-- Dependencies: 1807
-- Name: check_modalite(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_modalite() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_modalite() FROM postgres;
GRANT ALL ON FUNCTION check_modalite() TO postgres;
GRANT ALL ON FUNCTION check_modalite() TO PUBLIC;


--
-- TOC entry 9019 (class 0 OID 0)
-- Dependencies: 1808
-- Name: check_qcm_elements_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_qcm_elements_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_qcm_elements_type() FROM postgres;
GRANT ALL ON FUNCTION check_qcm_elements_type() TO postgres;
GRANT ALL ON FUNCTION check_qcm_elements_type() TO PUBLIC;


--
-- TOC entry 9023 (class 0 OID 0)
-- Dependencies: 1809
-- Name: check_question_reponse_elements_types(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_question_reponse_elements_types() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_question_reponse_elements_types() FROM postgres;
GRANT ALL ON FUNCTION check_question_reponse_elements_types() TO postgres;
GRANT ALL ON FUNCTION check_question_reponse_elements_types() TO PUBLIC;


--
-- TOC entry 9025 (class 0 OID 0)
-- Dependencies: 1810
-- Name: check_ressource_dates(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_ressource_dates() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_ressource_dates() FROM postgres;
GRANT ALL ON FUNCTION check_ressource_dates() TO postgres;
GRANT ALL ON FUNCTION check_ressource_dates() TO PUBLIC;


--
-- TOC entry 9027 (class 0 OID 0)
-- Dependencies: 1811
-- Name: check_ressource_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_ressource_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_ressource_type() FROM postgres;
GRANT ALL ON FUNCTION check_ressource_type() TO postgres;
GRANT ALL ON FUNCTION check_ressource_type() TO PUBLIC;


--
-- TOC entry 9029 (class 0 OID 0)
-- Dependencies: 1812
-- Name: check_serie_aleatoire_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_serie_aleatoire_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_serie_aleatoire_type() FROM postgres;
GRANT ALL ON FUNCTION check_serie_aleatoire_type() TO postgres;
GRANT ALL ON FUNCTION check_serie_aleatoire_type() TO PUBLIC;


--
-- TOC entry 9031 (class 0 OID 0)
-- Dependencies: 1813
-- Name: check_stagiaire_formation(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_stagiaire_formation() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_stagiaire_formation() FROM postgres;
GRANT ALL ON FUNCTION check_stagiaire_formation() TO postgres;
GRANT ALL ON FUNCTION check_stagiaire_formation() TO PUBLIC;


--
-- TOC entry 9033 (class 0 OID 0)
-- Dependencies: 1814
-- Name: check_stagiaire_type(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_stagiaire_type() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_stagiaire_type() FROM postgres;
GRANT ALL ON FUNCTION check_stagiaire_type() TO postgres;
GRANT ALL ON FUNCTION check_stagiaire_type() TO PUBLIC;


--
-- TOC entry 9035 (class 0 OID 0)
-- Dependencies: 1815
-- Name: check_type_etape(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_type_etape() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_type_etape() FROM postgres;
GRANT ALL ON FUNCTION check_type_etape() TO postgres;
GRANT ALL ON FUNCTION check_type_etape() TO PUBLIC;


--
-- TOC entry 9037 (class 0 OID 0)
-- Dependencies: 1816
-- Name: check_type_question(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_type_question() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_type_question() FROM postgres;
GRANT ALL ON FUNCTION check_type_question() TO postgres;
GRANT ALL ON FUNCTION check_type_question() TO PUBLIC;


--
-- TOC entry 9039 (class 0 OID 0)
-- Dependencies: 1817
-- Name: check_type_reponse(); Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON FUNCTION check_type_reponse() FROM PUBLIC;
REVOKE ALL ON FUNCTION check_type_reponse() FROM postgres;
GRANT ALL ON FUNCTION check_type_reponse() TO postgres;
GRANT ALL ON FUNCTION check_type_reponse() TO PUBLIC;


--
-- TOC entry 9071 (class 0 OID 0)
-- Dependencies: 1818
-- Name: del_etape(); Type: ACL; Schema: v2; Owner: www
--

REVOKE ALL ON FUNCTION del_etape() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_etape() FROM www;
GRANT ALL ON FUNCTION del_etape() TO www;
GRANT ALL ON FUNCTION del_etape() TO PUBLIC;


--
-- TOC entry 9078 (class 0 OID 0)
-- Dependencies: 1819
-- Name: del_formation(); Type: ACL; Schema: v2; Owner: www
--

REVOKE ALL ON FUNCTION del_formation() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_formation() FROM www;
GRANT ALL ON FUNCTION del_formation() TO www;
GRANT ALL ON FUNCTION del_formation() TO PUBLIC;


--
-- TOC entry 9081 (class 0 OID 0)
-- Dependencies: 1820
-- Name: del_parcours(); Type: ACL; Schema: v2; Owner: www
--

REVOKE ALL ON FUNCTION del_parcours() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_parcours() FROM www;
GRANT ALL ON FUNCTION del_parcours() TO www;
GRANT ALL ON FUNCTION del_parcours() TO PUBLIC;


--
-- TOC entry 9086 (class 0 OID 0)
-- Dependencies: 1821
-- Name: del_theme_categorie(); Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON FUNCTION del_theme_categorie() FROM PUBLIC;
REVOKE ALL ON FUNCTION del_theme_categorie() FROM pgsql;
GRANT ALL ON FUNCTION del_theme_categorie() TO pgsql;
GRANT ALL ON FUNCTION del_theme_categorie() TO PUBLIC;


--
-- TOC entry 9219 (class 0 OID 0)
-- Dependencies: 1822
-- Name: insert_etape_scorm(); Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_etape_scorm() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_etape_scorm() FROM pgsql;
GRANT ALL ON FUNCTION insert_etape_scorm() TO pgsql;
GRANT ALL ON FUNCTION insert_etape_scorm() TO PUBLIC;


--
-- TOC entry 9220 (class 0 OID 0)
-- Dependencies: 1823
-- Name: insert_question_reponse_element(); Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_question_reponse_element() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_question_reponse_element() FROM pgsql;
GRANT ALL ON FUNCTION insert_question_reponse_element() TO pgsql;
GRANT ALL ON FUNCTION insert_question_reponse_element() TO PUBLIC;


--
-- TOC entry 9221 (class 0 OID 0)
-- Dependencies: 1824
-- Name: insert_scenario(); Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON FUNCTION insert_scenario() FROM PUBLIC;
REVOKE ALL ON FUNCTION insert_scenario() FROM pgsql;
GRANT ALL ON FUNCTION insert_scenario() TO pgsql;
GRANT ALL ON FUNCTION insert_scenario() TO PUBLIC;


--
-- TOC entry 9570 (class 0 OID 0)
-- Dependencies: 3928
-- Name: xtlc_modele_correction_criteres; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_modele_correction_criteres FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_modele_correction_criteres FROM postgres;
GRANT ALL ON TABLE xtlc_modele_correction_criteres TO postgres;
GRANT ALL ON TABLE xtlc_modele_correction_criteres TO www;
GRANT ALL ON TABLE xtlc_modele_correction_criteres TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_modele_correction_criteres TO "grp-www";


SET search_path = contraintes, pg_catalog;

--
-- TOC entry 9601 (class 0 OID 0)
-- Dependencies: 3929
-- Name: active_sessions; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE active_sessions FROM PUBLIC;
REVOKE ALL ON TABLE active_sessions FROM pgsql;
GRANT ALL ON TABLE active_sessions TO pgsql;
GRANT ALL ON TABLE active_sessions TO "grp-www";
GRANT ALL ON TABLE active_sessions TO PUBLIC;


--
-- TOC entry 9603 (class 0 OID 0)
-- Dependencies: 3931
-- Name: alerte; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE alerte FROM PUBLIC;
REVOKE ALL ON TABLE alerte FROM postgres;
GRANT ALL ON TABLE alerte TO postgres;
GRANT ALL ON TABLE alerte TO www;
GRANT ALL ON TABLE alerte TO "grp-www";
GRANT ALL ON TABLE alerte TO PUBLIC;


--
-- TOC entry 9604 (class 0 OID 0)
-- Dependencies: 3930
-- Name: alerte_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE alerte_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE alerte_id_seq FROM postgres;
GRANT ALL ON TABLE alerte_id_seq TO postgres;
GRANT ALL ON TABLE alerte_id_seq TO PUBLIC;
GRANT ALL ON TABLE alerte_id_seq TO "grp-www";


--
-- TOC entry 9605 (class 0 OID 0)
-- Dependencies: 3932
-- Name: articles; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE articles FROM PUBLIC;
REVOKE ALL ON TABLE articles FROM pgsql;
GRANT ALL ON TABLE articles TO pgsql;
GRANT ALL ON TABLE articles TO postgres;
GRANT ALL ON TABLE articles TO www;
GRANT ALL ON TABLE articles TO "grp-www";
GRANT ALL ON TABLE articles TO PUBLIC;


--
-- TOC entry 9607 (class 0 OID 0)
-- Dependencies: 3934
-- Name: bareme; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE bareme FROM PUBLIC;
REVOKE ALL ON TABLE bareme FROM postgres;
GRANT ALL ON TABLE bareme TO postgres;
GRANT ALL ON TABLE bareme TO www;
GRANT ALL ON TABLE bareme TO "grp-www";
GRANT ALL ON TABLE bareme TO PUBLIC;


--
-- TOC entry 9608 (class 0 OID 0)
-- Dependencies: 3933
-- Name: bareme_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE bareme_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE bareme_id_seq FROM postgres;
GRANT ALL ON TABLE bareme_id_seq TO postgres;
GRANT ALL ON TABLE bareme_id_seq TO PUBLIC;
GRANT ALL ON TABLE bareme_id_seq TO "grp-www";


--
-- TOC entry 9609 (class 0 OID 0)
-- Dependencies: 3935
-- Name: block_ip; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE block_ip FROM PUBLIC;
REVOKE ALL ON TABLE block_ip FROM postgres;
GRANT ALL ON TABLE block_ip TO postgres;
GRANT ALL ON TABLE block_ip TO www;
GRANT ALL ON TABLE block_ip TO "grp-www";
GRANT ALL ON TABLE block_ip TO PUBLIC;


--
-- TOC entry 9610 (class 0 OID 0)
-- Dependencies: 3936
-- Name: c_ban_users; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE c_ban_users FROM PUBLIC;
REVOKE ALL ON TABLE c_ban_users FROM postgres;
GRANT ALL ON TABLE c_ban_users TO postgres;
GRANT ALL ON TABLE c_ban_users TO www;
GRANT ALL ON TABLE c_ban_users TO "grp-www";
GRANT ALL ON TABLE c_ban_users TO PUBLIC;


--
-- TOC entry 9611 (class 0 OID 0)
-- Dependencies: 3937
-- Name: c_messages; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE c_messages FROM PUBLIC;
REVOKE ALL ON TABLE c_messages FROM postgres;
GRANT ALL ON TABLE c_messages TO postgres;
GRANT ALL ON TABLE c_messages TO www;
GRANT ALL ON TABLE c_messages TO "grp-www";
GRANT ALL ON TABLE c_messages TO PUBLIC;


--
-- TOC entry 9612 (class 0 OID 0)
-- Dependencies: 3938
-- Name: c_reg_users; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE c_reg_users FROM PUBLIC;
REVOKE ALL ON TABLE c_reg_users FROM postgres;
GRANT ALL ON TABLE c_reg_users TO postgres;
GRANT ALL ON TABLE c_reg_users TO www;
GRANT ALL ON TABLE c_reg_users TO "grp-www";
GRANT ALL ON TABLE c_reg_users TO PUBLIC;


--
-- TOC entry 9613 (class 0 OID 0)
-- Dependencies: 3939
-- Name: c_users; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE c_users FROM PUBLIC;
REVOKE ALL ON TABLE c_users FROM postgres;
GRANT ALL ON TABLE c_users TO postgres;
GRANT ALL ON TABLE c_users TO www;
GRANT ALL ON TABLE c_users TO "grp-www";
GRANT ALL ON TABLE c_users TO PUBLIC;


--
-- TOC entry 9615 (class 0 OID 0)
-- Dependencies: 3941
-- Name: capacite; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE capacite FROM PUBLIC;
REVOKE ALL ON TABLE capacite FROM postgres;
GRANT ALL ON TABLE capacite TO postgres;
GRANT ALL ON TABLE capacite TO www;
GRANT ALL ON TABLE capacite TO "grp-www";
GRANT ALL ON TABLE capacite TO PUBLIC;


--
-- TOC entry 9616 (class 0 OID 0)
-- Dependencies: 3940
-- Name: capacite_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE capacite_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE capacite_id_seq FROM postgres;
GRANT ALL ON TABLE capacite_id_seq TO postgres;
GRANT ALL ON TABLE capacite_id_seq TO PUBLIC;
GRANT ALL ON TABLE capacite_id_seq TO "grp-www";


--
-- TOC entry 9618 (class 0 OID 0)
-- Dependencies: 3943
-- Name: capacite_titre; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE capacite_titre FROM PUBLIC;
REVOKE ALL ON TABLE capacite_titre FROM postgres;
GRANT ALL ON TABLE capacite_titre TO postgres;
GRANT ALL ON TABLE capacite_titre TO www;
GRANT ALL ON TABLE capacite_titre TO "grp-www";
GRANT ALL ON TABLE capacite_titre TO PUBLIC;


--
-- TOC entry 9620 (class 0 OID 0)
-- Dependencies: 3944
-- Name: capacite_titre_capacites; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE capacite_titre_capacites FROM PUBLIC;
REVOKE ALL ON TABLE capacite_titre_capacites FROM postgres;
GRANT ALL ON TABLE capacite_titre_capacites TO postgres;
GRANT ALL ON TABLE capacite_titre_capacites TO www;
GRANT ALL ON TABLE capacite_titre_capacites TO "grp-www";
GRANT ALL ON TABLE capacite_titre_capacites TO PUBLIC;


--
-- TOC entry 9621 (class 0 OID 0)
-- Dependencies: 3942
-- Name: capacite_titre_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE capacite_titre_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE capacite_titre_id_seq FROM postgres;
GRANT ALL ON TABLE capacite_titre_id_seq TO postgres;
GRANT ALL ON TABLE capacite_titre_id_seq TO PUBLIC;
GRANT ALL ON TABLE capacite_titre_id_seq TO "grp-www";


--
-- TOC entry 9623 (class 0 OID 0)
-- Dependencies: 3946
-- Name: carton; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE carton FROM PUBLIC;
REVOKE ALL ON TABLE carton FROM postgres;
GRANT ALL ON TABLE carton TO postgres;
GRANT ALL ON TABLE carton TO www;
GRANT ALL ON TABLE carton TO "grp-www";
GRANT ALL ON TABLE carton TO PUBLIC;


--
-- TOC entry 9624 (class 0 OID 0)
-- Dependencies: 3945
-- Name: carton_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE carton_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE carton_id_seq FROM postgres;
GRANT ALL ON TABLE carton_id_seq TO postgres;
GRANT ALL ON TABLE carton_id_seq TO PUBLIC;
GRANT ALL ON TABLE carton_id_seq TO "grp-www";


--
-- TOC entry 9625 (class 0 OID 0)
-- Dependencies: 3948
-- Name: categorie; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie FROM PUBLIC;
REVOKE ALL ON TABLE categorie FROM postgres;
GRANT ALL ON TABLE categorie TO postgres;
GRANT ALL ON TABLE categorie TO www;
GRANT ALL ON TABLE categorie TO "grp-www";
GRANT ALL ON TABLE categorie TO PUBLIC;


--
-- TOC entry 9627 (class 0 OID 0)
-- Dependencies: 3949
-- Name: categorie_capacite; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_capacite FROM PUBLIC;
REVOKE ALL ON TABLE categorie_capacite FROM postgres;
GRANT ALL ON TABLE categorie_capacite TO postgres;
GRANT ALL ON TABLE categorie_capacite TO www;
GRANT ALL ON TABLE categorie_capacite TO "grp-www";
GRANT ALL ON TABLE categorie_capacite TO PUBLIC;


--
-- TOC entry 9629 (class 0 OID 0)
-- Dependencies: 3950
-- Name: categorie_capacite_titre; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_capacite_titre FROM PUBLIC;
REVOKE ALL ON TABLE categorie_capacite_titre FROM postgres;
GRANT ALL ON TABLE categorie_capacite_titre TO postgres;
GRANT ALL ON TABLE categorie_capacite_titre TO www;
GRANT ALL ON TABLE categorie_capacite_titre TO "grp-www";
GRANT ALL ON TABLE categorie_capacite_titre TO PUBLIC;


--
-- TOC entry 9631 (class 0 OID 0)
-- Dependencies: 3951
-- Name: categorie_critere; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_critere FROM PUBLIC;
REVOKE ALL ON TABLE categorie_critere FROM postgres;
GRANT ALL ON TABLE categorie_critere TO postgres;
GRANT ALL ON TABLE categorie_critere TO www;
GRANT ALL ON TABLE categorie_critere TO "grp-www";
GRANT ALL ON TABLE categorie_critere TO PUBLIC;


--
-- TOC entry 9632 (class 0 OID 0)
-- Dependencies: 3952
-- Name: categorie_etape; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_etape FROM PUBLIC;
REVOKE ALL ON TABLE categorie_etape FROM postgres;
GRANT ALL ON TABLE categorie_etape TO postgres;
GRANT ALL ON TABLE categorie_etape TO "grp-www";
GRANT ALL ON TABLE categorie_etape TO PUBLIC;


--
-- TOC entry 9633 (class 0 OID 0)
-- Dependencies: 3953
-- Name: categorie_etape_forum; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_etape_forum FROM PUBLIC;
REVOKE ALL ON TABLE categorie_etape_forum FROM postgres;
GRANT ALL ON TABLE categorie_etape_forum TO postgres;
GRANT ALL ON TABLE categorie_etape_forum TO www;
GRANT ALL ON TABLE categorie_etape_forum TO "grp-www";
GRANT ALL ON TABLE categorie_etape_forum TO PUBLIC;


--
-- TOC entry 9634 (class 0 OID 0)
-- Dependencies: 3954
-- Name: categorie_etape_ressource; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_etape_ressource FROM PUBLIC;
REVOKE ALL ON TABLE categorie_etape_ressource FROM postgres;
GRANT ALL ON TABLE categorie_etape_ressource TO postgres;
GRANT ALL ON TABLE categorie_etape_ressource TO "grp-www";
GRANT ALL ON TABLE categorie_etape_ressource TO PUBLIC;


--
-- TOC entry 9635 (class 0 OID 0)
-- Dependencies: 3955
-- Name: categorie_evaluation; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_evaluation FROM PUBLIC;
REVOKE ALL ON TABLE categorie_evaluation FROM postgres;
GRANT ALL ON TABLE categorie_evaluation TO postgres;
GRANT ALL ON TABLE categorie_evaluation TO "grp-www";
GRANT ALL ON TABLE categorie_evaluation TO PUBLIC;


--
-- TOC entry 9636 (class 0 OID 0)
-- Dependencies: 3956
-- Name: categorie_exotlc; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE categorie_exotlc FROM postgres;
GRANT ALL ON TABLE categorie_exotlc TO postgres;
GRANT ALL ON TABLE categorie_exotlc TO "grp-www";
GRANT ALL ON TABLE categorie_exotlc TO PUBLIC;


--
-- TOC entry 9637 (class 0 OID 0)
-- Dependencies: 3957
-- Name: categorie_fichier_bloc_scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_bloc_scenario FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_bloc_scenario FROM postgres;
GRANT ALL ON TABLE categorie_fichier_bloc_scenario TO postgres;
GRANT ALL ON TABLE categorie_fichier_bloc_scenario TO www;
GRANT ALL ON TABLE categorie_fichier_bloc_scenario TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_bloc_scenario TO PUBLIC;


--
-- TOC entry 9639 (class 0 OID 0)
-- Dependencies: 3958
-- Name: categorie_fichier_correction; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_correction FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_correction FROM postgres;
GRANT ALL ON TABLE categorie_fichier_correction TO postgres;
GRANT ALL ON TABLE categorie_fichier_correction TO www;
GRANT ALL ON TABLE categorie_fichier_correction TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_correction TO PUBLIC;


--
-- TOC entry 9641 (class 0 OID 0)
-- Dependencies: 3959
-- Name: categorie_fichier_css; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_css FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_css FROM postgres;
GRANT ALL ON TABLE categorie_fichier_css TO postgres;
GRANT ALL ON TABLE categorie_fichier_css TO www;
GRANT ALL ON TABLE categorie_fichier_css TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_css TO PUBLIC;


--
-- TOC entry 9643 (class 0 OID 0)
-- Dependencies: 3960
-- Name: categorie_fichier_etape_scorm; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_etape_scorm FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_etape_scorm FROM postgres;
GRANT ALL ON TABLE categorie_fichier_etape_scorm TO postgres;
GRANT ALL ON TABLE categorie_fichier_etape_scorm TO www;
GRANT ALL ON TABLE categorie_fichier_etape_scorm TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_etape_scorm TO PUBLIC;


--
-- TOC entry 9645 (class 0 OID 0)
-- Dependencies: 3961
-- Name: categorie_fichier_exotlc; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_exotlc FROM postgres;
GRANT ALL ON TABLE categorie_fichier_exotlc TO postgres;
GRANT ALL ON TABLE categorie_fichier_exotlc TO www;
GRANT ALL ON TABLE categorie_fichier_exotlc TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_exotlc TO PUBLIC;


--
-- TOC entry 9646 (class 0 OID 0)
-- Dependencies: 3962
-- Name: categorie_fichier_glossaire; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_glossaire FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_glossaire FROM postgres;
GRANT ALL ON TABLE categorie_fichier_glossaire TO postgres;
GRANT ALL ON TABLE categorie_fichier_glossaire TO www;
GRANT ALL ON TABLE categorie_fichier_glossaire TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_glossaire TO PUBLIC;


--
-- TOC entry 9648 (class 0 OID 0)
-- Dependencies: 3963
-- Name: categorie_fichier_media_evaluation; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_media_evaluation FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_media_evaluation FROM postgres;
GRANT ALL ON TABLE categorie_fichier_media_evaluation TO postgres;
GRANT ALL ON TABLE categorie_fichier_media_evaluation TO www;
GRANT ALL ON TABLE categorie_fichier_media_evaluation TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_media_evaluation TO PUBLIC;


--
-- TOC entry 9650 (class 0 OID 0)
-- Dependencies: 3964
-- Name: categorie_fichier_media_exotlc; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_media_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_media_exotlc FROM postgres;
GRANT ALL ON TABLE categorie_fichier_media_exotlc TO postgres;
GRANT ALL ON TABLE categorie_fichier_media_exotlc TO www;
GRANT ALL ON TABLE categorie_fichier_media_exotlc TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_media_exotlc TO PUBLIC;


--
-- TOC entry 9652 (class 0 OID 0)
-- Dependencies: 3965
-- Name: categorie_fichier_media_scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_media_scenario FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_media_scenario FROM postgres;
GRANT ALL ON TABLE categorie_fichier_media_scenario TO postgres;
GRANT ALL ON TABLE categorie_fichier_media_scenario TO www;
GRANT ALL ON TABLE categorie_fichier_media_scenario TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_media_scenario TO PUBLIC;


--
-- TOC entry 9653 (class 0 OID 0)
-- Dependencies: 3966
-- Name: categorie_fichier_ressource; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_ressource FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_ressource FROM postgres;
GRANT ALL ON TABLE categorie_fichier_ressource TO postgres;
GRANT ALL ON TABLE categorie_fichier_ressource TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_ressource TO PUBLIC;


--
-- TOC entry 9655 (class 0 OID 0)
-- Dependencies: 3967
-- Name: categorie_fichier_ressource_fichier; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_ressource_fichier FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_ressource_fichier FROM postgres;
GRANT ALL ON TABLE categorie_fichier_ressource_fichier TO postgres;
GRANT ALL ON TABLE categorie_fichier_ressource_fichier TO www;
GRANT ALL ON TABLE categorie_fichier_ressource_fichier TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_ressource_fichier TO PUBLIC;


--
-- TOC entry 9656 (class 0 OID 0)
-- Dependencies: 3968
-- Name: categorie_fichier_ressource_texte; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_ressource_texte FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_ressource_texte FROM postgres;
GRANT ALL ON TABLE categorie_fichier_ressource_texte TO postgres;
GRANT ALL ON TABLE categorie_fichier_ressource_texte TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_ressource_texte TO PUBLIC;


--
-- TOC entry 9658 (class 0 OID 0)
-- Dependencies: 3969
-- Name: categorie_fichier_scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_scenario FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_scenario FROM postgres;
GRANT ALL ON TABLE categorie_fichier_scenario TO postgres;
GRANT ALL ON TABLE categorie_fichier_scenario TO www;
GRANT ALL ON TABLE categorie_fichier_scenario TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_scenario TO PUBLIC;


--
-- TOC entry 9659 (class 0 OID 0)
-- Dependencies: 3970
-- Name: categorie_fichier_scenario_dynamique; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_scenario_dynamique FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_scenario_dynamique FROM postgres;
GRANT ALL ON TABLE categorie_fichier_scenario_dynamique TO postgres;
GRANT ALL ON TABLE categorie_fichier_scenario_dynamique TO www;
GRANT ALL ON TABLE categorie_fichier_scenario_dynamique TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_scenario_dynamique TO PUBLIC;


--
-- TOC entry 9660 (class 0 OID 0)
-- Dependencies: 3971
-- Name: categorie_fichier_slide_scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_fichier_slide_scenario FROM PUBLIC;
REVOKE ALL ON TABLE categorie_fichier_slide_scenario FROM postgres;
GRANT ALL ON TABLE categorie_fichier_slide_scenario TO postgres;
GRANT ALL ON TABLE categorie_fichier_slide_scenario TO www;
GRANT ALL ON TABLE categorie_fichier_slide_scenario TO "grp-www";
GRANT ALL ON TABLE categorie_fichier_slide_scenario TO PUBLIC;


--
-- TOC entry 9662 (class 0 OID 0)
-- Dependencies: 3972
-- Name: categorie_ftb; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_ftb FROM PUBLIC;
REVOKE ALL ON TABLE categorie_ftb FROM postgres;
GRANT ALL ON TABLE categorie_ftb TO postgres;
GRANT ALL ON TABLE categorie_ftb TO www;
GRANT ALL ON TABLE categorie_ftb TO "grp-www";
GRANT ALL ON TABLE categorie_ftb TO PUBLIC;


--
-- TOC entry 9663 (class 0 OID 0)
-- Dependencies: 3973
-- Name: categorie_glossaire; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_glossaire FROM PUBLIC;
REVOKE ALL ON TABLE categorie_glossaire FROM postgres;
GRANT ALL ON TABLE categorie_glossaire TO postgres;
GRANT ALL ON TABLE categorie_glossaire TO www;
GRANT ALL ON TABLE categorie_glossaire TO "grp-www";
GRANT ALL ON TABLE categorie_glossaire TO PUBLIC;


--
-- TOC entry 9665 (class 0 OID 0)
-- Dependencies: 3974
-- Name: categorie_grille; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_grille FROM PUBLIC;
REVOKE ALL ON TABLE categorie_grille FROM postgres;
GRANT ALL ON TABLE categorie_grille TO postgres;
GRANT ALL ON TABLE categorie_grille TO www;
GRANT ALL ON TABLE categorie_grille TO "grp-www";
GRANT ALL ON TABLE categorie_grille TO PUBLIC;


--
-- TOC entry 9666 (class 0 OID 0)
-- Dependencies: 3947
-- Name: categorie_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE categorie_id_seq FROM postgres;
GRANT ALL ON TABLE categorie_id_seq TO postgres;
GRANT ALL ON TABLE categorie_id_seq TO PUBLIC;
GRANT ALL ON TABLE categorie_id_seq TO "grp-www";


--
-- TOC entry 9668 (class 0 OID 0)
-- Dependencies: 3975
-- Name: categorie_modele_correction; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_modele_correction FROM PUBLIC;
REVOKE ALL ON TABLE categorie_modele_correction FROM postgres;
GRANT ALL ON TABLE categorie_modele_correction TO postgres;
GRANT ALL ON TABLE categorie_modele_correction TO www;
GRANT ALL ON TABLE categorie_modele_correction TO "grp-www";
GRANT ALL ON TABLE categorie_modele_correction TO PUBLIC;


--
-- TOC entry 9669 (class 0 OID 0)
-- Dependencies: 3976
-- Name: categorie_positionnement; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_positionnement FROM PUBLIC;
REVOKE ALL ON TABLE categorie_positionnement FROM postgres;
GRANT ALL ON TABLE categorie_positionnement TO postgres;
GRANT ALL ON TABLE categorie_positionnement TO www;
GRANT ALL ON TABLE categorie_positionnement TO "grp-www";
GRANT ALL ON TABLE categorie_positionnement TO PUBLIC;


--
-- TOC entry 9670 (class 0 OID 0)
-- Dependencies: 3977
-- Name: categorie_qsrc; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_qsrc FROM PUBLIC;
REVOKE ALL ON TABLE categorie_qsrc FROM postgres;
GRANT ALL ON TABLE categorie_qsrc TO postgres;
GRANT ALL ON TABLE categorie_qsrc TO www;
GRANT ALL ON TABLE categorie_qsrc TO "grp-www";
GRANT ALL ON TABLE categorie_qsrc TO PUBLIC;


--
-- TOC entry 9671 (class 0 OID 0)
-- Dependencies: 3978
-- Name: categorie_question_reponse; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE categorie_question_reponse FROM postgres;
GRANT ALL ON TABLE categorie_question_reponse TO postgres;
GRANT ALL ON TABLE categorie_question_reponse TO "grp-www";
GRANT ALL ON TABLE categorie_question_reponse TO PUBLIC;


--
-- TOC entry 9673 (class 0 OID 0)
-- Dependencies: 3979
-- Name: categorie_question_reponse_element; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_question_reponse_element FROM PUBLIC;
REVOKE ALL ON TABLE categorie_question_reponse_element FROM postgres;
GRANT ALL ON TABLE categorie_question_reponse_element TO postgres;
GRANT ALL ON TABLE categorie_question_reponse_element TO www;
GRANT ALL ON TABLE categorie_question_reponse_element TO "grp-www";
GRANT ALL ON TABLE categorie_question_reponse_element TO PUBLIC;


--
-- TOC entry 9674 (class 0 OID 0)
-- Dependencies: 3980
-- Name: categorie_scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_scenario FROM PUBLIC;
REVOKE ALL ON TABLE categorie_scenario FROM postgres;
GRANT ALL ON TABLE categorie_scenario TO postgres;
GRANT ALL ON TABLE categorie_scenario TO "grp-www";
GRANT ALL ON TABLE categorie_scenario TO PUBLIC;


--
-- TOC entry 9675 (class 0 OID 0)
-- Dependencies: 3981
-- Name: categorie_scenario_dynamique; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_scenario_dynamique FROM PUBLIC;
REVOKE ALL ON TABLE categorie_scenario_dynamique FROM postgres;
GRANT ALL ON TABLE categorie_scenario_dynamique TO postgres;
GRANT ALL ON TABLE categorie_scenario_dynamique TO www;
GRANT ALL ON TABLE categorie_scenario_dynamique TO "grp-www";
GRANT ALL ON TABLE categorie_scenario_dynamique TO PUBLIC;


--
-- TOC entry 9677 (class 0 OID 0)
-- Dependencies: 3982
-- Name: categorie_serie; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_serie FROM PUBLIC;
REVOKE ALL ON TABLE categorie_serie FROM postgres;
GRANT ALL ON TABLE categorie_serie TO postgres;
GRANT ALL ON TABLE categorie_serie TO www;
GRANT ALL ON TABLE categorie_serie TO "grp-www";
GRANT ALL ON TABLE categorie_serie TO PUBLIC;


--
-- TOC entry 9679 (class 0 OID 0)
-- Dependencies: 3983
-- Name: categorie_sondage_element; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_sondage_element FROM PUBLIC;
REVOKE ALL ON TABLE categorie_sondage_element FROM postgres;
GRANT ALL ON TABLE categorie_sondage_element TO postgres;
GRANT ALL ON TABLE categorie_sondage_element TO www;
GRANT ALL ON TABLE categorie_sondage_element TO "grp-www";
GRANT ALL ON TABLE categorie_sondage_element TO PUBLIC;


--
-- TOC entry 9680 (class 0 OID 0)
-- Dependencies: 3984
-- Name: categorie_test; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE categorie_test FROM PUBLIC;
REVOKE ALL ON TABLE categorie_test FROM postgres;
GRANT ALL ON TABLE categorie_test TO postgres;
GRANT ALL ON TABLE categorie_test TO "grp-www";
GRANT ALL ON TABLE categorie_test TO PUBLIC;


--
-- TOC entry 9682 (class 0 OID 0)
-- Dependencies: 3985
-- Name: choix; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE choix FROM PUBLIC;
REVOKE ALL ON TABLE choix FROM postgres;
GRANT ALL ON TABLE choix TO postgres;
GRANT ALL ON TABLE choix TO www;
GRANT ALL ON TABLE choix TO "grp-www";
GRANT ALL ON TABLE choix TO PUBLIC;


--
-- TOC entry 9684 (class 0 OID 0)
-- Dependencies: 3987
-- Name: classe; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE classe FROM PUBLIC;
REVOKE ALL ON TABLE classe FROM postgres;
GRANT ALL ON TABLE classe TO postgres;
GRANT ALL ON TABLE classe TO www;
GRANT ALL ON TABLE classe TO "grp-www";
GRANT ALL ON TABLE classe TO PUBLIC;


--
-- TOC entry 9685 (class 0 OID 0)
-- Dependencies: 3986
-- Name: classe_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE classe_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE classe_id_seq FROM postgres;
GRANT ALL ON TABLE classe_id_seq TO postgres;
GRANT ALL ON TABLE classe_id_seq TO PUBLIC;
GRANT ALL ON TABLE classe_id_seq TO "grp-www";


--
-- TOC entry 9687 (class 0 OID 0)
-- Dependencies: 3988
-- Name: classe_individus; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE classe_individus FROM PUBLIC;
REVOKE ALL ON TABLE classe_individus FROM postgres;
GRANT ALL ON TABLE classe_individus TO postgres;
GRANT ALL ON TABLE classe_individus TO www;
GRANT ALL ON TABLE classe_individus TO "grp-www";
GRANT ALL ON TABLE classe_individus TO PUBLIC;


--
-- TOC entry 9688 (class 0 OID 0)
-- Dependencies: 3989
-- Name: commentaire_etape; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE commentaire_etape FROM PUBLIC;
REVOKE ALL ON TABLE commentaire_etape FROM pgsql;
GRANT ALL ON TABLE commentaire_etape TO pgsql;
GRANT ALL ON TABLE commentaire_etape TO "grp-www";
GRANT ALL ON TABLE commentaire_etape TO PUBLIC;


--
-- TOC entry 9689 (class 0 OID 0)
-- Dependencies: 3990
-- Name: connexion; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE connexion FROM PUBLIC;
REVOKE ALL ON TABLE connexion FROM pgsql;
GRANT ALL ON TABLE connexion TO pgsql;
GRANT ALL ON TABLE connexion TO "grp-www";
GRANT ALL ON TABLE connexion TO PUBLIC;


--
-- TOC entry 9691 (class 0 OID 0)
-- Dependencies: 3991
-- Name: connexion_old; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE connexion_old FROM PUBLIC;
REVOKE ALL ON TABLE connexion_old FROM postgres;
GRANT ALL ON TABLE connexion_old TO postgres;
GRANT ALL ON TABLE connexion_old TO "grp-www";
GRANT ALL ON TABLE connexion_old TO PUBLIC;


--
-- TOC entry 9693 (class 0 OID 0)
-- Dependencies: 3993
-- Name: critere; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE critere FROM PUBLIC;
REVOKE ALL ON TABLE critere FROM postgres;
GRANT ALL ON TABLE critere TO postgres;
GRANT ALL ON TABLE critere TO www;
GRANT ALL ON TABLE critere TO "grp-www";
GRANT ALL ON TABLE critere TO PUBLIC;


--
-- TOC entry 9694 (class 0 OID 0)
-- Dependencies: 3992
-- Name: critere_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE critere_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE critere_id_seq FROM postgres;
GRANT ALL ON TABLE critere_id_seq TO postgres;
GRANT ALL ON TABLE critere_id_seq TO PUBLIC;
GRANT ALL ON TABLE critere_id_seq TO "grp-www";


--
-- TOC entry 9696 (class 0 OID 0)
-- Dependencies: 3994
-- Name: droit; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE droit FROM PUBLIC;
REVOKE ALL ON TABLE droit FROM postgres;
GRANT ALL ON TABLE droit TO postgres;
GRANT ALL ON TABLE droit TO www;
GRANT ALL ON TABLE droit TO "grp-www";
GRANT ALL ON TABLE droit TO PUBLIC;


--
-- TOC entry 9697 (class 0 OID 0)
-- Dependencies: 3995
-- Name: droit_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE droit_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE droit_id_seq FROM postgres;
GRANT ALL ON TABLE droit_id_seq TO postgres;
GRANT ALL ON TABLE droit_id_seq TO PUBLIC;
GRANT ALL ON TABLE droit_id_seq TO "grp-www";


--
-- TOC entry 9698 (class 0 OID 0)
-- Dependencies: 3997
-- Name: droit_type; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE droit_type FROM PUBLIC;
REVOKE ALL ON TABLE droit_type FROM pgsql;
GRANT ALL ON TABLE droit_type TO pgsql;
GRANT ALL ON TABLE droit_type TO "grp-www";
GRANT ALL ON TABLE droit_type TO PUBLIC;


--
-- TOC entry 9699 (class 0 OID 0)
-- Dependencies: 3996
-- Name: droit_type_id_seq; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE droit_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE droit_type_id_seq FROM pgsql;
GRANT ALL ON TABLE droit_type_id_seq TO pgsql;
GRANT ALL ON TABLE droit_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE droit_type_id_seq TO "grp-www";


--
-- TOC entry 9701 (class 0 OID 0)
-- Dependencies: 3999
-- Name: espace; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE espace FROM PUBLIC;
REVOKE ALL ON TABLE espace FROM postgres;
GRANT ALL ON TABLE espace TO postgres;
GRANT ALL ON TABLE espace TO www;
GRANT ALL ON TABLE espace TO "grp-www";
GRANT ALL ON TABLE espace TO PUBLIC;


--
-- TOC entry 9702 (class 0 OID 0)
-- Dependencies: 3998
-- Name: espace_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE espace_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE espace_id_seq FROM postgres;
GRANT ALL ON TABLE espace_id_seq TO postgres;
GRANT ALL ON TABLE espace_id_seq TO PUBLIC;
GRANT ALL ON TABLE espace_id_seq TO "grp-www";


--
-- TOC entry 9704 (class 0 OID 0)
-- Dependencies: 4001
-- Name: etape; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE etape FROM PUBLIC;
REVOKE ALL ON TABLE etape FROM postgres;
GRANT ALL ON TABLE etape TO postgres;
GRANT ALL ON TABLE etape TO www;
GRANT ALL ON TABLE etape TO "grp-www";
GRANT ALL ON TABLE etape TO PUBLIC;


--
-- TOC entry 9705 (class 0 OID 0)
-- Dependencies: 4002
-- Name: etape_chat; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE etape_chat FROM PUBLIC;
REVOKE ALL ON TABLE etape_chat FROM postgres;
GRANT ALL ON TABLE etape_chat TO postgres;
GRANT ALL ON TABLE etape_chat TO www;
GRANT ALL ON TABLE etape_chat TO "grp-www";
GRANT ALL ON TABLE etape_chat TO PUBLIC;


--
-- TOC entry 9706 (class 0 OID 0)
-- Dependencies: 4003
-- Name: etape_forum; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE etape_forum FROM PUBLIC;
REVOKE ALL ON TABLE etape_forum FROM postgres;
GRANT ALL ON TABLE etape_forum TO postgres;
GRANT ALL ON TABLE etape_forum TO www;
GRANT ALL ON TABLE etape_forum TO "grp-www";
GRANT ALL ON TABLE etape_forum TO PUBLIC;


--
-- TOC entry 9707 (class 0 OID 0)
-- Dependencies: 4000
-- Name: etape_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE etape_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE etape_id_seq FROM postgres;
GRANT ALL ON TABLE etape_id_seq TO postgres;
GRANT ALL ON TABLE etape_id_seq TO PUBLIC;
GRANT ALL ON TABLE etape_id_seq TO "grp-www";


--
-- TOC entry 9708 (class 0 OID 0)
-- Dependencies: 4004
-- Name: etape_ressource; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE etape_ressource FROM PUBLIC;
REVOKE ALL ON TABLE etape_ressource FROM postgres;
GRANT ALL ON TABLE etape_ressource TO postgres;
GRANT ALL ON TABLE etape_ressource TO www;
GRANT ALL ON TABLE etape_ressource TO "grp-www";
GRANT ALL ON TABLE etape_ressource TO PUBLIC;


--
-- TOC entry 9709 (class 0 OID 0)
-- Dependencies: 4005
-- Name: etape_scorm; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE etape_scorm FROM PUBLIC;
REVOKE ALL ON TABLE etape_scorm FROM postgres;
GRANT ALL ON TABLE etape_scorm TO postgres;
GRANT ALL ON TABLE etape_scorm TO www;
GRANT ALL ON TABLE etape_scorm TO "grp-www";
GRANT ALL ON TABLE etape_scorm TO PUBLIC;


--
-- TOC entry 9710 (class 0 OID 0)
-- Dependencies: 4006
-- Name: etape_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE etape_type FROM PUBLIC;
REVOKE ALL ON TABLE etape_type FROM postgres;
GRANT ALL ON TABLE etape_type TO postgres;
GRANT ALL ON TABLE etape_type TO www;
GRANT ALL ON TABLE etape_type TO "grp-www";
GRANT ALL ON TABLE etape_type TO PUBLIC;


--
-- TOC entry 9711 (class 0 OID 0)
-- Dependencies: 4007
-- Name: etape_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE etape_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE etape_type_id_seq FROM postgres;
GRANT ALL ON TABLE etape_type_id_seq TO postgres;
GRANT ALL ON TABLE etape_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE etape_type_id_seq TO "grp-www";


--
-- TOC entry 9712 (class 0 OID 0)
-- Dependencies: 4009
-- Name: evaluation; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE evaluation FROM PUBLIC;
REVOKE ALL ON TABLE evaluation FROM postgres;
GRANT ALL ON TABLE evaluation TO postgres;
GRANT ALL ON TABLE evaluation TO www;
GRANT ALL ON TABLE evaluation TO "grp-www";
GRANT ALL ON TABLE evaluation TO PUBLIC;


--
-- TOC entry 9713 (class 0 OID 0)
-- Dependencies: 4008
-- Name: evaluation_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE evaluation_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE evaluation_id_seq FROM postgres;
GRANT ALL ON TABLE evaluation_id_seq TO postgres;
GRANT ALL ON TABLE evaluation_id_seq TO www;
GRANT ALL ON TABLE evaluation_id_seq TO PUBLIC;
GRANT ALL ON TABLE evaluation_id_seq TO "grp-www";


--
-- TOC entry 9714 (class 0 OID 0)
-- Dependencies: 4011
-- Name: evaluation_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE evaluation_type FROM PUBLIC;
REVOKE ALL ON TABLE evaluation_type FROM postgres;
GRANT ALL ON TABLE evaluation_type TO postgres;
GRANT ALL ON TABLE evaluation_type TO www;
GRANT ALL ON TABLE evaluation_type TO "grp-www";
GRANT ALL ON TABLE evaluation_type TO PUBLIC;


--
-- TOC entry 9715 (class 0 OID 0)
-- Dependencies: 4010
-- Name: evaluation_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE evaluation_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE evaluation_type_id_seq FROM postgres;
GRANT ALL ON TABLE evaluation_type_id_seq TO postgres;
GRANT ALL ON TABLE evaluation_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE evaluation_type_id_seq TO "grp-www";


--
-- TOC entry 9717 (class 0 OID 0)
-- Dependencies: 4012
-- Name: evenement; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE evenement FROM PUBLIC;
REVOKE ALL ON TABLE evenement FROM postgres;
GRANT ALL ON TABLE evenement TO postgres;
GRANT ALL ON TABLE evenement TO www;
GRANT ALL ON TABLE evenement TO "grp-www";
GRANT ALL ON TABLE evenement TO PUBLIC;


--
-- TOC entry 9719 (class 0 OID 0)
-- Dependencies: 4013
-- Name: evenement_presentiel; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE evenement_presentiel FROM PUBLIC;
REVOKE ALL ON TABLE evenement_presentiel FROM postgres;
GRANT ALL ON TABLE evenement_presentiel TO postgres;
GRANT ALL ON TABLE evenement_presentiel TO www;
GRANT ALL ON TABLE evenement_presentiel TO "grp-www";
GRANT ALL ON TABLE evenement_presentiel TO PUBLIC;


--
-- TOC entry 9721 (class 0 OID 0)
-- Dependencies: 4014
-- Name: exotlc; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE exotlc FROM PUBLIC;
REVOKE ALL ON TABLE exotlc FROM postgres;
GRANT ALL ON TABLE exotlc TO postgres;
GRANT ALL ON TABLE exotlc TO www;
GRANT ALL ON TABLE exotlc TO "grp-www";
GRANT ALL ON TABLE exotlc TO PUBLIC;


--
-- TOC entry 9722 (class 0 OID 0)
-- Dependencies: 4015
-- Name: exotlc_corrections; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE exotlc_corrections FROM PUBLIC;
REVOKE ALL ON TABLE exotlc_corrections FROM postgres;
GRANT ALL ON TABLE exotlc_corrections TO postgres;
GRANT ALL ON TABLE exotlc_corrections TO www;
GRANT ALL ON TABLE exotlc_corrections TO "grp-www";
GRANT ALL ON TABLE exotlc_corrections TO PUBLIC;


--
-- TOC entry 9723 (class 0 OID 0)
-- Dependencies: 4016
-- Name: exotlc_fichiers; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE exotlc_fichiers FROM PUBLIC;
REVOKE ALL ON TABLE exotlc_fichiers FROM postgres;
GRANT ALL ON TABLE exotlc_fichiers TO postgres;
GRANT ALL ON TABLE exotlc_fichiers TO www;
GRANT ALL ON TABLE exotlc_fichiers TO "grp-www";
GRANT ALL ON TABLE exotlc_fichiers TO PUBLIC;


--
-- TOC entry 9724 (class 0 OID 0)
-- Dependencies: 4017
-- Name: exotlc_mail; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE exotlc_mail FROM PUBLIC;
REVOKE ALL ON TABLE exotlc_mail FROM postgres;
GRANT ALL ON TABLE exotlc_mail TO postgres;
GRANT ALL ON TABLE exotlc_mail TO www;
GRANT ALL ON TABLE exotlc_mail TO "grp-www";
GRANT ALL ON TABLE exotlc_mail TO PUBLIC;


--
-- TOC entry 9725 (class 0 OID 0)
-- Dependencies: 4018
-- Name: exotlc_modele_correction; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE exotlc_modele_correction FROM PUBLIC;
REVOKE ALL ON TABLE exotlc_modele_correction FROM pgsql;
GRANT ALL ON TABLE exotlc_modele_correction TO pgsql;
GRANT ALL ON TABLE exotlc_modele_correction TO "grp-www";
GRANT ALL ON TABLE exotlc_modele_correction TO PUBLIC;


--
-- TOC entry 9726 (class 0 OID 0)
-- Dependencies: 4019
-- Name: exotlc_plate_forme; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE exotlc_plate_forme FROM PUBLIC;
REVOKE ALL ON TABLE exotlc_plate_forme FROM postgres;
GRANT ALL ON TABLE exotlc_plate_forme TO postgres;
GRANT ALL ON TABLE exotlc_plate_forme TO www;
GRANT ALL ON TABLE exotlc_plate_forme TO "grp-www";
GRANT ALL ON TABLE exotlc_plate_forme TO PUBLIC;


--
-- TOC entry 9727 (class 0 OID 0)
-- Dependencies: 4021
-- Name: exotlc_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE exotlc_type FROM PUBLIC;
REVOKE ALL ON TABLE exotlc_type FROM postgres;
GRANT ALL ON TABLE exotlc_type TO postgres;
GRANT ALL ON TABLE exotlc_type TO www;
GRANT ALL ON TABLE exotlc_type TO "grp-www";
GRANT ALL ON TABLE exotlc_type TO PUBLIC;


--
-- TOC entry 9728 (class 0 OID 0)
-- Dependencies: 4020
-- Name: exotlc_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE exotlc_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE exotlc_type_id_seq FROM postgres;
GRANT ALL ON TABLE exotlc_type_id_seq TO postgres;
GRANT ALL ON TABLE exotlc_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE exotlc_type_id_seq TO "grp-www";


--
-- TOC entry 9729 (class 0 OID 0)
-- Dependencies: 4023
-- Name: fichier; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier FROM PUBLIC;
REVOKE ALL ON TABLE fichier FROM postgres;
GRANT ALL ON TABLE fichier TO postgres;
GRANT ALL ON TABLE fichier TO www;
GRANT ALL ON TABLE fichier TO "grp-www";
GRANT ALL ON TABLE fichier TO PUBLIC;


--
-- TOC entry 9730 (class 0 OID 0)
-- Dependencies: 4024
-- Name: fichier_bloc_scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_bloc_scenario FROM PUBLIC;
REVOKE ALL ON TABLE fichier_bloc_scenario FROM postgres;
GRANT ALL ON TABLE fichier_bloc_scenario TO postgres;
GRANT ALL ON TABLE fichier_bloc_scenario TO "grp-www";
GRANT ALL ON TABLE fichier_bloc_scenario TO PUBLIC;


--
-- TOC entry 9731 (class 0 OID 0)
-- Dependencies: 4025
-- Name: fichier_correction; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_correction FROM PUBLIC;
REVOKE ALL ON TABLE fichier_correction FROM postgres;
GRANT ALL ON TABLE fichier_correction TO postgres;
GRANT ALL ON TABLE fichier_correction TO www;
GRANT ALL ON TABLE fichier_correction TO "grp-www";
GRANT ALL ON TABLE fichier_correction TO PUBLIC;


--
-- TOC entry 9732 (class 0 OID 0)
-- Dependencies: 4026
-- Name: fichier_css; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_css FROM PUBLIC;
REVOKE ALL ON TABLE fichier_css FROM postgres;
GRANT ALL ON TABLE fichier_css TO postgres;
GRANT ALL ON TABLE fichier_css TO www;
GRANT ALL ON TABLE fichier_css TO "grp-www";
GRANT ALL ON TABLE fichier_css TO PUBLIC;


--
-- TOC entry 9733 (class 0 OID 0)
-- Dependencies: 4027
-- Name: fichier_etape_scorm; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_etape_scorm FROM PUBLIC;
REVOKE ALL ON TABLE fichier_etape_scorm FROM postgres;
GRANT ALL ON TABLE fichier_etape_scorm TO postgres;
GRANT ALL ON TABLE fichier_etape_scorm TO www;
GRANT ALL ON TABLE fichier_etape_scorm TO "grp-www";
GRANT ALL ON TABLE fichier_etape_scorm TO PUBLIC;


--
-- TOC entry 9734 (class 0 OID 0)
-- Dependencies: 4028
-- Name: fichier_exotlc; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE fichier_exotlc FROM postgres;
GRANT ALL ON TABLE fichier_exotlc TO postgres;
GRANT ALL ON TABLE fichier_exotlc TO www;
GRANT ALL ON TABLE fichier_exotlc TO "grp-www";
GRANT ALL ON TABLE fichier_exotlc TO PUBLIC;


--
-- TOC entry 9735 (class 0 OID 0)
-- Dependencies: 4029
-- Name: fichier_glossaire; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_glossaire FROM PUBLIC;
REVOKE ALL ON TABLE fichier_glossaire FROM postgres;
GRANT ALL ON TABLE fichier_glossaire TO postgres;
GRANT ALL ON TABLE fichier_glossaire TO "grp-www";
GRANT ALL ON TABLE fichier_glossaire TO PUBLIC;


--
-- TOC entry 9736 (class 0 OID 0)
-- Dependencies: 4030
-- Name: fichier_icone; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_icone FROM PUBLIC;
REVOKE ALL ON TABLE fichier_icone FROM postgres;
GRANT ALL ON TABLE fichier_icone TO postgres;
GRANT ALL ON TABLE fichier_icone TO www;
GRANT ALL ON TABLE fichier_icone TO "grp-www";
GRANT ALL ON TABLE fichier_icone TO PUBLIC;


--
-- TOC entry 9737 (class 0 OID 0)
-- Dependencies: 4022
-- Name: fichier_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE fichier_id_seq FROM postgres;
GRANT ALL ON TABLE fichier_id_seq TO postgres;
GRANT ALL ON TABLE fichier_id_seq TO PUBLIC;
GRANT ALL ON TABLE fichier_id_seq TO "grp-www";


--
-- TOC entry 9738 (class 0 OID 0)
-- Dependencies: 4031
-- Name: fichier_media_evaluation; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_media_evaluation FROM PUBLIC;
REVOKE ALL ON TABLE fichier_media_evaluation FROM postgres;
GRANT ALL ON TABLE fichier_media_evaluation TO postgres;
GRANT ALL ON TABLE fichier_media_evaluation TO www;
GRANT ALL ON TABLE fichier_media_evaluation TO "grp-www";
GRANT ALL ON TABLE fichier_media_evaluation TO PUBLIC;


--
-- TOC entry 9739 (class 0 OID 0)
-- Dependencies: 4032
-- Name: fichier_media_exotlc; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_media_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE fichier_media_exotlc FROM postgres;
GRANT ALL ON TABLE fichier_media_exotlc TO postgres;
GRANT ALL ON TABLE fichier_media_exotlc TO www;
GRANT ALL ON TABLE fichier_media_exotlc TO "grp-www";
GRANT ALL ON TABLE fichier_media_exotlc TO PUBLIC;


--
-- TOC entry 9740 (class 0 OID 0)
-- Dependencies: 4033
-- Name: fichier_media_scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_media_scenario FROM PUBLIC;
REVOKE ALL ON TABLE fichier_media_scenario FROM postgres;
GRANT ALL ON TABLE fichier_media_scenario TO postgres;
GRANT ALL ON TABLE fichier_media_scenario TO www;
GRANT ALL ON TABLE fichier_media_scenario TO "grp-www";
GRANT ALL ON TABLE fichier_media_scenario TO PUBLIC;


--
-- TOC entry 9741 (class 0 OID 0)
-- Dependencies: 4034
-- Name: fichier_metadata; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE fichier_metadata FROM PUBLIC;
REVOKE ALL ON TABLE fichier_metadata FROM pgsql;
GRANT ALL ON TABLE fichier_metadata TO pgsql;
GRANT ALL ON TABLE fichier_metadata TO "grp-www";
GRANT ALL ON TABLE fichier_metadata TO PUBLIC;


--
-- TOC entry 9742 (class 0 OID 0)
-- Dependencies: 4035
-- Name: fichier_photo; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_photo FROM PUBLIC;
REVOKE ALL ON TABLE fichier_photo FROM postgres;
GRANT ALL ON TABLE fichier_photo TO postgres;
GRANT ALL ON TABLE fichier_photo TO www;
GRANT ALL ON TABLE fichier_photo TO "grp-www";
GRANT ALL ON TABLE fichier_photo TO PUBLIC;


--
-- TOC entry 9743 (class 0 OID 0)
-- Dependencies: 4036
-- Name: fichier_ressource; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE fichier_ressource FROM PUBLIC;
REVOKE ALL ON TABLE fichier_ressource FROM pgsql;
GRANT ALL ON TABLE fichier_ressource TO pgsql;
GRANT ALL ON TABLE fichier_ressource TO postgres;
GRANT ALL ON TABLE fichier_ressource TO www;
GRANT ALL ON TABLE fichier_ressource TO "grp-www";
GRANT ALL ON TABLE fichier_ressource TO PUBLIC;


--
-- TOC entry 9744 (class 0 OID 0)
-- Dependencies: 4037
-- Name: fichier_ressource_fichier; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_ressource_fichier FROM PUBLIC;
REVOKE ALL ON TABLE fichier_ressource_fichier FROM postgres;
GRANT ALL ON TABLE fichier_ressource_fichier TO postgres;
GRANT ALL ON TABLE fichier_ressource_fichier TO www;
GRANT ALL ON TABLE fichier_ressource_fichier TO "grp-www";
GRANT ALL ON TABLE fichier_ressource_fichier TO PUBLIC;


--
-- TOC entry 9745 (class 0 OID 0)
-- Dependencies: 4038
-- Name: fichier_ressource_texte; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_ressource_texte FROM PUBLIC;
REVOKE ALL ON TABLE fichier_ressource_texte FROM postgres;
GRANT ALL ON TABLE fichier_ressource_texte TO postgres;
GRANT ALL ON TABLE fichier_ressource_texte TO www;
GRANT ALL ON TABLE fichier_ressource_texte TO "grp-www";
GRANT ALL ON TABLE fichier_ressource_texte TO PUBLIC;


--
-- TOC entry 9746 (class 0 OID 0)
-- Dependencies: 4039
-- Name: fichier_scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_scenario FROM PUBLIC;
REVOKE ALL ON TABLE fichier_scenario FROM postgres;
GRANT ALL ON TABLE fichier_scenario TO postgres;
GRANT ALL ON TABLE fichier_scenario TO www;
GRANT ALL ON TABLE fichier_scenario TO "grp-www";
GRANT ALL ON TABLE fichier_scenario TO PUBLIC;


--
-- TOC entry 9747 (class 0 OID 0)
-- Dependencies: 4040
-- Name: fichier_scenario_dynamique; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_scenario_dynamique FROM PUBLIC;
REVOKE ALL ON TABLE fichier_scenario_dynamique FROM postgres;
GRANT ALL ON TABLE fichier_scenario_dynamique TO postgres;
GRANT ALL ON TABLE fichier_scenario_dynamique TO "grp-www";
GRANT ALL ON TABLE fichier_scenario_dynamique TO PUBLIC;


--
-- TOC entry 9748 (class 0 OID 0)
-- Dependencies: 4041
-- Name: fichier_scenario_dynamique_blocs; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_scenario_dynamique_blocs FROM PUBLIC;
REVOKE ALL ON TABLE fichier_scenario_dynamique_blocs FROM postgres;
GRANT ALL ON TABLE fichier_scenario_dynamique_blocs TO postgres;
GRANT ALL ON TABLE fichier_scenario_dynamique_blocs TO "grp-www";
GRANT ALL ON TABLE fichier_scenario_dynamique_blocs TO PUBLIC;


--
-- TOC entry 9749 (class 0 OID 0)
-- Dependencies: 4042
-- Name: fichier_slide_scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_slide_scenario FROM PUBLIC;
REVOKE ALL ON TABLE fichier_slide_scenario FROM postgres;
GRANT ALL ON TABLE fichier_slide_scenario TO postgres;
GRANT ALL ON TABLE fichier_slide_scenario TO "grp-www";
GRANT ALL ON TABLE fichier_slide_scenario TO PUBLIC;


--
-- TOC entry 9750 (class 0 OID 0)
-- Dependencies: 4044
-- Name: fichier_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_type FROM PUBLIC;
REVOKE ALL ON TABLE fichier_type FROM postgres;
GRANT ALL ON TABLE fichier_type TO postgres;
GRANT ALL ON TABLE fichier_type TO www;
GRANT ALL ON TABLE fichier_type TO "grp-www";
GRANT ALL ON TABLE fichier_type TO PUBLIC;


--
-- TOC entry 9751 (class 0 OID 0)
-- Dependencies: 4043
-- Name: fichier_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fichier_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE fichier_type_id_seq FROM postgres;
GRANT ALL ON TABLE fichier_type_id_seq TO postgres;
GRANT ALL ON TABLE fichier_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE fichier_type_id_seq TO "grp-www";


--
-- TOC entry 9752 (class 0 OID 0)
-- Dependencies: 4046
-- Name: filiere; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE filiere FROM PUBLIC;
REVOKE ALL ON TABLE filiere FROM postgres;
GRANT ALL ON TABLE filiere TO postgres;
GRANT ALL ON TABLE filiere TO www;
GRANT ALL ON TABLE filiere TO "grp-www";
GRANT ALL ON TABLE filiere TO PUBLIC;


--
-- TOC entry 9753 (class 0 OID 0)
-- Dependencies: 4045
-- Name: filiere_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE filiere_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE filiere_id_seq FROM postgres;
GRANT ALL ON TABLE filiere_id_seq TO postgres;
GRANT ALL ON TABLE filiere_id_seq TO PUBLIC;
GRANT ALL ON TABLE filiere_id_seq TO "grp-www";


--
-- TOC entry 9755 (class 0 OID 0)
-- Dependencies: 4047
-- Name: formateur_droits; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE formateur_droits FROM PUBLIC;
REVOKE ALL ON TABLE formateur_droits FROM postgres;
GRANT ALL ON TABLE formateur_droits TO postgres;
GRANT ALL ON TABLE formateur_droits TO www;
GRANT ALL ON TABLE formateur_droits TO "grp-www";
GRANT ALL ON TABLE formateur_droits TO PUBLIC;


--
-- TOC entry 9757 (class 0 OID 0)
-- Dependencies: 4049
-- Name: formation; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE formation FROM PUBLIC;
REVOKE ALL ON TABLE formation FROM postgres;
GRANT ALL ON TABLE formation TO postgres;
GRANT ALL ON TABLE formation TO www;
GRANT ALL ON TABLE formation TO "grp-www";
GRANT ALL ON TABLE formation TO PUBLIC;


--
-- TOC entry 9759 (class 0 OID 0)
-- Dependencies: 4050
-- Name: formation_forums; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE formation_forums FROM PUBLIC;
REVOKE ALL ON TABLE formation_forums FROM postgres;
GRANT ALL ON TABLE formation_forums TO postgres;
GRANT ALL ON TABLE formation_forums TO www;
GRANT ALL ON TABLE formation_forums TO "grp-www";
GRANT ALL ON TABLE formation_forums TO PUBLIC;


--
-- TOC entry 9760 (class 0 OID 0)
-- Dependencies: 4048
-- Name: formation_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE formation_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE formation_id_seq FROM postgres;
GRANT ALL ON TABLE formation_id_seq TO postgres;
GRANT ALL ON TABLE formation_id_seq TO PUBLIC;
GRANT ALL ON TABLE formation_id_seq TO "grp-www";


--
-- TOC entry 9762 (class 0 OID 0)
-- Dependencies: 4051
-- Name: formation_langues; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE formation_langues FROM PUBLIC;
REVOKE ALL ON TABLE formation_langues FROM postgres;
GRANT ALL ON TABLE formation_langues TO postgres;
GRANT ALL ON TABLE formation_langues TO www;
GRANT ALL ON TABLE formation_langues TO "grp-www";
GRANT ALL ON TABLE formation_langues TO PUBLIC;


--
-- TOC entry 9764 (class 0 OID 0)
-- Dependencies: 4052
-- Name: formation_participants; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE formation_participants FROM PUBLIC;
REVOKE ALL ON TABLE formation_participants FROM postgres;
GRANT ALL ON TABLE formation_participants TO postgres;
GRANT ALL ON TABLE formation_participants TO www;
GRANT ALL ON TABLE formation_participants TO "grp-www";
GRANT ALL ON TABLE formation_participants TO PUBLIC;


--
-- TOC entry 9766 (class 0 OID 0)
-- Dependencies: 4053
-- Name: formation_ressources; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE formation_ressources FROM PUBLIC;
REVOKE ALL ON TABLE formation_ressources FROM postgres;
GRANT ALL ON TABLE formation_ressources TO postgres;
GRANT ALL ON TABLE formation_ressources TO www;
GRANT ALL ON TABLE formation_ressources TO "grp-www";
GRANT ALL ON TABLE formation_ressources TO PUBLIC;


--
-- TOC entry 9767 (class 0 OID 0)
-- Dependencies: 4054
-- Name: formation_session; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE formation_session FROM PUBLIC;
REVOKE ALL ON TABLE formation_session FROM pgsql;
GRANT ALL ON TABLE formation_session TO pgsql;
GRANT ALL ON TABLE formation_session TO "grp-www";
GRANT ALL ON TABLE formation_session TO PUBLIC;


--
-- TOC entry 9768 (class 0 OID 0)
-- Dependencies: 4056
-- Name: forum; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE forum FROM PUBLIC;
REVOKE ALL ON TABLE forum FROM postgres;
GRANT ALL ON TABLE forum TO postgres;
GRANT ALL ON TABLE forum TO www;
GRANT ALL ON TABLE forum TO "grp-www";
GRANT ALL ON TABLE forum TO PUBLIC;


--
-- TOC entry 9769 (class 0 OID 0)
-- Dependencies: 4058
-- Name: forum_environnement; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE forum_environnement FROM PUBLIC;
REVOKE ALL ON TABLE forum_environnement FROM postgres;
GRANT ALL ON TABLE forum_environnement TO postgres;
GRANT ALL ON TABLE forum_environnement TO www;
GRANT ALL ON TABLE forum_environnement TO "grp-www";
GRANT ALL ON TABLE forum_environnement TO PUBLIC;


--
-- TOC entry 9770 (class 0 OID 0)
-- Dependencies: 4057
-- Name: forum_environnement_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE forum_environnement_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE forum_environnement_id_seq FROM postgres;
GRANT ALL ON TABLE forum_environnement_id_seq TO postgres;
GRANT ALL ON TABLE forum_environnement_id_seq TO PUBLIC;
GRANT ALL ON TABLE forum_environnement_id_seq TO "grp-www";


--
-- TOC entry 9771 (class 0 OID 0)
-- Dependencies: 4059
-- Name: forum_environnements; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE forum_environnements FROM PUBLIC;
REVOKE ALL ON TABLE forum_environnements FROM postgres;
GRANT ALL ON TABLE forum_environnements TO postgres;
GRANT ALL ON TABLE forum_environnements TO www;
GRANT ALL ON TABLE forum_environnements TO "grp-www";
GRANT ALL ON TABLE forum_environnements TO PUBLIC;


--
-- TOC entry 9772 (class 0 OID 0)
-- Dependencies: 4055
-- Name: forum_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE forum_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE forum_id_seq FROM postgres;
GRANT ALL ON TABLE forum_id_seq TO postgres;
GRANT ALL ON TABLE forum_id_seq TO PUBLIC;
GRANT ALL ON TABLE forum_id_seq TO "grp-www";


--
-- TOC entry 9773 (class 0 OID 0)
-- Dependencies: 4060
-- Name: ftb; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE ftb FROM PUBLIC;
REVOKE ALL ON TABLE ftb FROM postgres;
GRANT ALL ON TABLE ftb TO postgres;
GRANT ALL ON TABLE ftb TO www;
GRANT ALL ON TABLE ftb TO "grp-www";
GRANT ALL ON TABLE ftb TO PUBLIC;


--
-- TOC entry 9775 (class 0 OID 0)
-- Dependencies: 4062
-- Name: fw_droit; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fw_droit FROM PUBLIC;
REVOKE ALL ON TABLE fw_droit FROM postgres;
GRANT ALL ON TABLE fw_droit TO postgres;
GRANT ALL ON TABLE fw_droit TO www;
GRANT ALL ON TABLE fw_droit TO "grp-www";
GRANT ALL ON TABLE fw_droit TO PUBLIC;


--
-- TOC entry 9776 (class 0 OID 0)
-- Dependencies: 4061
-- Name: fw_droit_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fw_droit_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE fw_droit_id_seq FROM postgres;
GRANT ALL ON TABLE fw_droit_id_seq TO postgres;
GRANT ALL ON TABLE fw_droit_id_seq TO PUBLIC;
GRANT ALL ON TABLE fw_droit_id_seq TO "grp-www";


--
-- TOC entry 9777 (class 0 OID 0)
-- Dependencies: 4064
-- Name: fw_individu; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fw_individu FROM PUBLIC;
REVOKE ALL ON TABLE fw_individu FROM postgres;
GRANT ALL ON TABLE fw_individu TO postgres;
GRANT ALL ON TABLE fw_individu TO www;
GRANT ALL ON TABLE fw_individu TO "grp-www";
GRANT ALL ON TABLE fw_individu TO PUBLIC;


--
-- TOC entry 9778 (class 0 OID 0)
-- Dependencies: 4063
-- Name: fw_individu_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fw_individu_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE fw_individu_id_seq FROM postgres;
GRANT ALL ON TABLE fw_individu_id_seq TO postgres;
GRANT ALL ON TABLE fw_individu_id_seq TO PUBLIC;
GRANT ALL ON TABLE fw_individu_id_seq TO "grp-www";


--
-- TOC entry 9779 (class 0 OID 0)
-- Dependencies: 4066
-- Name: fw_individu_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fw_individu_type FROM PUBLIC;
REVOKE ALL ON TABLE fw_individu_type FROM postgres;
GRANT ALL ON TABLE fw_individu_type TO postgres;
GRANT ALL ON TABLE fw_individu_type TO www;
GRANT ALL ON TABLE fw_individu_type TO "grp-www";
GRANT ALL ON TABLE fw_individu_type TO PUBLIC;


--
-- TOC entry 9780 (class 0 OID 0)
-- Dependencies: 4065
-- Name: fw_individu_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fw_individu_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE fw_individu_type_id_seq FROM postgres;
GRANT ALL ON TABLE fw_individu_type_id_seq TO postgres;
GRANT ALL ON TABLE fw_individu_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE fw_individu_type_id_seq TO "grp-www";


--
-- TOC entry 9781 (class 0 OID 0)
-- Dependencies: 4067
-- Name: fw_individu_types; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fw_individu_types FROM PUBLIC;
REVOKE ALL ON TABLE fw_individu_types FROM postgres;
GRANT ALL ON TABLE fw_individu_types TO postgres;
GRANT ALL ON TABLE fw_individu_types TO www;
GRANT ALL ON TABLE fw_individu_types TO "grp-www";
GRANT ALL ON TABLE fw_individu_types TO PUBLIC;


--
-- TOC entry 9782 (class 0 OID 0)
-- Dependencies: 4069
-- Name: fw_langue; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fw_langue FROM PUBLIC;
REVOKE ALL ON TABLE fw_langue FROM postgres;
GRANT ALL ON TABLE fw_langue TO postgres;
GRANT ALL ON TABLE fw_langue TO www;
GRANT ALL ON TABLE fw_langue TO "grp-www";
GRANT ALL ON TABLE fw_langue TO PUBLIC;


--
-- TOC entry 9783 (class 0 OID 0)
-- Dependencies: 4068
-- Name: fw_langue_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE fw_langue_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE fw_langue_id_seq FROM postgres;
GRANT ALL ON TABLE fw_langue_id_seq TO postgres;
GRANT ALL ON TABLE fw_langue_id_seq TO PUBLIC;
GRANT ALL ON TABLE fw_langue_id_seq TO "grp-www";


--
-- TOC entry 9784 (class 0 OID 0)
-- Dependencies: 4071
-- Name: fw_module; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE fw_module FROM PUBLIC;
REVOKE ALL ON TABLE fw_module FROM pgsql;
GRANT ALL ON TABLE fw_module TO pgsql;
GRANT ALL ON TABLE fw_module TO "grp-www";
GRANT ALL ON TABLE fw_module TO PUBLIC;


--
-- TOC entry 9785 (class 0 OID 0)
-- Dependencies: 4070
-- Name: fw_module_id_seq; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE fw_module_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE fw_module_id_seq FROM pgsql;
GRANT ALL ON TABLE fw_module_id_seq TO pgsql;
GRANT ALL ON TABLE fw_module_id_seq TO PUBLIC;
GRANT ALL ON TABLE fw_module_id_seq TO "grp-www";


--
-- TOC entry 9786 (class 0 OID 0)
-- Dependencies: 4072
-- Name: fw_module_individus_types; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE fw_module_individus_types FROM PUBLIC;
REVOKE ALL ON TABLE fw_module_individus_types FROM pgsql;
GRANT ALL ON TABLE fw_module_individus_types TO pgsql;
GRANT ALL ON TABLE fw_module_individus_types TO "grp-www";
GRANT ALL ON TABLE fw_module_individus_types TO PUBLIC;


--
-- TOC entry 9787 (class 0 OID 0)
-- Dependencies: 4074
-- Name: fw_module_pages; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE fw_module_pages FROM PUBLIC;
REVOKE ALL ON TABLE fw_module_pages FROM pgsql;
GRANT ALL ON TABLE fw_module_pages TO pgsql;
GRANT ALL ON TABLE fw_module_pages TO "grp-www";
GRANT ALL ON TABLE fw_module_pages TO PUBLIC;


--
-- TOC entry 9788 (class 0 OID 0)
-- Dependencies: 4073
-- Name: fw_module_pages_id_seq; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE fw_module_pages_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE fw_module_pages_id_seq FROM pgsql;
GRANT ALL ON TABLE fw_module_pages_id_seq TO pgsql;
GRANT ALL ON TABLE fw_module_pages_id_seq TO PUBLIC;
GRANT ALL ON TABLE fw_module_pages_id_seq TO "grp-www";


--
-- TOC entry 9789 (class 0 OID 0)
-- Dependencies: 4075
-- Name: fw_module_submodules; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE fw_module_submodules FROM PUBLIC;
REVOKE ALL ON TABLE fw_module_submodules FROM pgsql;
GRANT ALL ON TABLE fw_module_submodules TO pgsql;
GRANT ALL ON TABLE fw_module_submodules TO "grp-www";
GRANT ALL ON TABLE fw_module_submodules TO PUBLIC;


--
-- TOC entry 9790 (class 0 OID 0)
-- Dependencies: 4076
-- Name: fw_permission; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE fw_permission FROM PUBLIC;
REVOKE ALL ON TABLE fw_permission FROM pgsql;
GRANT ALL ON TABLE fw_permission TO pgsql;
GRANT ALL ON TABLE fw_permission TO "grp-www";
GRANT ALL ON TABLE fw_permission TO PUBLIC;


--
-- TOC entry 9791 (class 0 OID 0)
-- Dependencies: 4077
-- Name: glossaire_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE glossaire_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE glossaire_id_seq FROM postgres;
GRANT ALL ON TABLE glossaire_id_seq TO postgres;
GRANT ALL ON TABLE glossaire_id_seq TO "grp-www";
GRANT ALL ON TABLE glossaire_id_seq TO PUBLIC;


--
-- TOC entry 9792 (class 0 OID 0)
-- Dependencies: 4078
-- Name: glossaire; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE glossaire FROM PUBLIC;
REVOKE ALL ON TABLE glossaire FROM postgres;
GRANT ALL ON TABLE glossaire TO postgres;
GRANT ALL ON TABLE glossaire TO "grp-www";
GRANT ALL ON TABLE glossaire TO PUBLIC;


--
-- TOC entry 9793 (class 0 OID 0)
-- Dependencies: 4079
-- Name: glossaire_fichiers; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE glossaire_fichiers FROM PUBLIC;
REVOKE ALL ON TABLE glossaire_fichiers FROM postgres;
GRANT ALL ON TABLE glossaire_fichiers TO postgres;
GRANT ALL ON TABLE glossaire_fichiers TO "grp-www";
GRANT ALL ON TABLE glossaire_fichiers TO PUBLIC;


--
-- TOC entry 9794 (class 0 OID 0)
-- Dependencies: 4081
-- Name: grille; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE grille FROM PUBLIC;
REVOKE ALL ON TABLE grille FROM postgres;
GRANT ALL ON TABLE grille TO postgres;
GRANT ALL ON TABLE grille TO www;
GRANT ALL ON TABLE grille TO "grp-www";
GRANT ALL ON TABLE grille TO PUBLIC;


--
-- TOC entry 9795 (class 0 OID 0)
-- Dependencies: 4082
-- Name: grille_capacites_titres; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE grille_capacites_titres FROM PUBLIC;
REVOKE ALL ON TABLE grille_capacites_titres FROM postgres;
GRANT ALL ON TABLE grille_capacites_titres TO postgres;
GRANT ALL ON TABLE grille_capacites_titres TO www;
GRANT ALL ON TABLE grille_capacites_titres TO "grp-www";
GRANT ALL ON TABLE grille_capacites_titres TO PUBLIC;


--
-- TOC entry 9796 (class 0 OID 0)
-- Dependencies: 4080
-- Name: grille_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE grille_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE grille_id_seq FROM postgres;
GRANT ALL ON TABLE grille_id_seq TO postgres;
GRANT ALL ON TABLE grille_id_seq TO PUBLIC;
GRANT ALL ON TABLE grille_id_seq TO "grp-www";


--
-- TOC entry 9797 (class 0 OID 0)
-- Dependencies: 4083
-- Name: grille_resultats; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE grille_resultats FROM PUBLIC;
REVOKE ALL ON TABLE grille_resultats FROM postgres;
GRANT ALL ON TABLE grille_resultats TO postgres;
GRANT ALL ON TABLE grille_resultats TO www;
GRANT ALL ON TABLE grille_resultats TO "grp-www";
GRANT ALL ON TABLE grille_resultats TO PUBLIC;


--
-- TOC entry 9798 (class 0 OID 0)
-- Dependencies: 4084
-- Name: individu_droits; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE individu_droits FROM PUBLIC;
REVOKE ALL ON TABLE individu_droits FROM postgres;
GRANT ALL ON TABLE individu_droits TO postgres;
GRANT ALL ON TABLE individu_droits TO www;
GRANT ALL ON TABLE individu_droits TO "grp-www";
GRANT ALL ON TABLE individu_droits TO PUBLIC;


--
-- TOC entry 9799 (class 0 OID 0)
-- Dependencies: 4085
-- Name: individu_type_droits; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE individu_type_droits FROM PUBLIC;
REVOKE ALL ON TABLE individu_type_droits FROM pgsql;
GRANT ALL ON TABLE individu_type_droits TO pgsql;
GRANT ALL ON TABLE individu_type_droits TO "grp-www";
GRANT ALL ON TABLE individu_type_droits TO PUBLIC;


--
-- TOC entry 9800 (class 0 OID 0)
-- Dependencies: 4087
-- Name: inscription; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE inscription FROM PUBLIC;
REVOKE ALL ON TABLE inscription FROM postgres;
GRANT ALL ON TABLE inscription TO postgres;
GRANT ALL ON TABLE inscription TO www;
GRANT ALL ON TABLE inscription TO "grp-www";
GRANT ALL ON TABLE inscription TO PUBLIC;


--
-- TOC entry 9801 (class 0 OID 0)
-- Dependencies: 4086
-- Name: inscription_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE inscription_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE inscription_id_seq FROM postgres;
GRANT ALL ON TABLE inscription_id_seq TO postgres;
GRANT ALL ON TABLE inscription_id_seq TO PUBLIC;
GRANT ALL ON TABLE inscription_id_seq TO "grp-www";


--
-- TOC entry 9802 (class 0 OID 0)
-- Dependencies: 4089
-- Name: intervention; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE intervention FROM PUBLIC;
REVOKE ALL ON TABLE intervention FROM postgres;
GRANT ALL ON TABLE intervention TO postgres;
GRANT ALL ON TABLE intervention TO www;
GRANT ALL ON TABLE intervention TO "grp-www";
GRANT ALL ON TABLE intervention TO PUBLIC;


--
-- TOC entry 9803 (class 0 OID 0)
-- Dependencies: 4088
-- Name: intervention_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE intervention_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE intervention_id_seq FROM postgres;
GRANT ALL ON TABLE intervention_id_seq TO postgres;
GRANT ALL ON TABLE intervention_id_seq TO PUBLIC;
GRANT ALL ON TABLE intervention_id_seq TO "grp-www";


--
-- TOC entry 9804 (class 0 OID 0)
-- Dependencies: 4091
-- Name: langue; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE langue FROM PUBLIC;
REVOKE ALL ON TABLE langue FROM postgres;
GRANT ALL ON TABLE langue TO postgres;
GRANT ALL ON TABLE langue TO www;
GRANT ALL ON TABLE langue TO "grp-www";
GRANT ALL ON TABLE langue TO PUBLIC;


--
-- TOC entry 9805 (class 0 OID 0)
-- Dependencies: 4090
-- Name: langue_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE langue_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE langue_id_seq FROM postgres;
GRANT ALL ON TABLE langue_id_seq TO postgres;
GRANT ALL ON TABLE langue_id_seq TO PUBLIC;
GRANT ALL ON TABLE langue_id_seq TO "grp-www";


--
-- TOC entry 9806 (class 0 OID 0)
-- Dependencies: 4092
-- Name: langue_message; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE langue_message FROM PUBLIC;
REVOKE ALL ON TABLE langue_message FROM postgres;
GRANT ALL ON TABLE langue_message TO postgres;
GRANT ALL ON TABLE langue_message TO www;
GRANT ALL ON TABLE langue_message TO "grp-www";
GRANT ALL ON TABLE langue_message TO PUBLIC;


--
-- TOC entry 9807 (class 0 OID 0)
-- Dependencies: 4094
-- Name: langue_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE langue_type FROM PUBLIC;
REVOKE ALL ON TABLE langue_type FROM postgres;
GRANT ALL ON TABLE langue_type TO postgres;
GRANT ALL ON TABLE langue_type TO www;
GRANT ALL ON TABLE langue_type TO "grp-www";
GRANT ALL ON TABLE langue_type TO PUBLIC;


--
-- TOC entry 9808 (class 0 OID 0)
-- Dependencies: 4093
-- Name: langue_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE langue_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE langue_type_id_seq FROM postgres;
GRANT ALL ON TABLE langue_type_id_seq TO postgres;
GRANT ALL ON TABLE langue_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE langue_type_id_seq TO "grp-www";


--
-- TOC entry 9809 (class 0 OID 0)
-- Dependencies: 4095
-- Name: liste; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE liste FROM PUBLIC;
REVOKE ALL ON TABLE liste FROM postgres;
GRANT ALL ON TABLE liste TO postgres;
GRANT ALL ON TABLE liste TO www;
GRANT ALL ON TABLE liste TO "grp-www";
GRANT ALL ON TABLE liste TO PUBLIC;


--
-- TOC entry 9810 (class 0 OID 0)
-- Dependencies: 4097
-- Name: liste_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE liste_type FROM PUBLIC;
REVOKE ALL ON TABLE liste_type FROM postgres;
GRANT ALL ON TABLE liste_type TO postgres;
GRANT ALL ON TABLE liste_type TO www;
GRANT ALL ON TABLE liste_type TO "grp-www";
GRANT ALL ON TABLE liste_type TO PUBLIC;


--
-- TOC entry 9811 (class 0 OID 0)
-- Dependencies: 4096
-- Name: liste_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE liste_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE liste_type_id_seq FROM postgres;
GRANT ALL ON TABLE liste_type_id_seq TO postgres;
GRANT ALL ON TABLE liste_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE liste_type_id_seq TO "grp-www";


--
-- TOC entry 9812 (class 0 OID 0)
-- Dependencies: 4098
-- Name: media; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE media FROM PUBLIC;
REVOKE ALL ON TABLE media FROM postgres;
GRANT ALL ON TABLE media TO postgres;
GRANT ALL ON TABLE media TO www;
GRANT ALL ON TABLE media TO "grp-www";
GRANT ALL ON TABLE media TO PUBLIC;


--
-- TOC entry 9813 (class 0 OID 0)
-- Dependencies: 4099
-- Name: media_question_reponse; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE media_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE media_question_reponse FROM postgres;
GRANT ALL ON TABLE media_question_reponse TO postgres;
GRANT ALL ON TABLE media_question_reponse TO www;
GRANT ALL ON TABLE media_question_reponse TO "grp-www";
GRANT ALL ON TABLE media_question_reponse TO PUBLIC;


--
-- TOC entry 9814 (class 0 OID 0)
-- Dependencies: 4100
-- Name: media_question_reponse_element; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE media_question_reponse_element FROM PUBLIC;
REVOKE ALL ON TABLE media_question_reponse_element FROM postgres;
GRANT ALL ON TABLE media_question_reponse_element TO postgres;
GRANT ALL ON TABLE media_question_reponse_element TO "grp-www";
GRANT ALL ON TABLE media_question_reponse_element TO PUBLIC;


--
-- TOC entry 9815 (class 0 OID 0)
-- Dependencies: 4101
-- Name: media_test; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE media_test FROM PUBLIC;
REVOKE ALL ON TABLE media_test FROM postgres;
GRANT ALL ON TABLE media_test TO postgres;
GRANT ALL ON TABLE media_test TO www;
GRANT ALL ON TABLE media_test TO "grp-www";
GRANT ALL ON TABLE media_test TO PUBLIC;


--
-- TOC entry 9816 (class 0 OID 0)
-- Dependencies: 4103
-- Name: message; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE message FROM PUBLIC;
REVOKE ALL ON TABLE message FROM postgres;
GRANT ALL ON TABLE message TO postgres;
GRANT ALL ON TABLE message TO www;
GRANT ALL ON TABLE message TO "grp-www";
GRANT ALL ON TABLE message TO PUBLIC;


--
-- TOC entry 9817 (class 0 OID 0)
-- Dependencies: 4102
-- Name: message_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE message_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE message_id_seq FROM postgres;
GRANT ALL ON TABLE message_id_seq TO postgres;
GRANT ALL ON TABLE message_id_seq TO PUBLIC;
GRANT ALL ON TABLE message_id_seq TO "grp-www";


--
-- TOC entry 9818 (class 0 OID 0)
-- Dependencies: 4105
-- Name: modalite; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE modalite FROM PUBLIC;
REVOKE ALL ON TABLE modalite FROM postgres;
GRANT ALL ON TABLE modalite TO postgres;
GRANT ALL ON TABLE modalite TO www;
GRANT ALL ON TABLE modalite TO "grp-www";
GRANT ALL ON TABLE modalite TO PUBLIC;


--
-- TOC entry 9819 (class 0 OID 0)
-- Dependencies: 4104
-- Name: modalite_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE modalite_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE modalite_id_seq FROM postgres;
GRANT ALL ON TABLE modalite_id_seq TO postgres;
GRANT ALL ON TABLE modalite_id_seq TO "grp-www";
GRANT ALL ON TABLE modalite_id_seq TO PUBLIC;


--
-- TOC entry 9820 (class 0 OID 0)
-- Dependencies: 4107
-- Name: modele_correction; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE modele_correction FROM PUBLIC;
REVOKE ALL ON TABLE modele_correction FROM postgres;
GRANT ALL ON TABLE modele_correction TO postgres;
GRANT ALL ON TABLE modele_correction TO www;
GRANT ALL ON TABLE modele_correction TO "grp-www";
GRANT ALL ON TABLE modele_correction TO PUBLIC;


--
-- TOC entry 9821 (class 0 OID 0)
-- Dependencies: 4106
-- Name: modele_correction_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE modele_correction_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE modele_correction_id_seq FROM postgres;
GRANT ALL ON TABLE modele_correction_id_seq TO postgres;
GRANT ALL ON TABLE modele_correction_id_seq TO PUBLIC;
GRANT ALL ON TABLE modele_correction_id_seq TO "grp-www";


--
-- TOC entry 9822 (class 0 OID 0)
-- Dependencies: 4109
-- Name: organisme; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE organisme FROM PUBLIC;
REVOKE ALL ON TABLE organisme FROM postgres;
GRANT ALL ON TABLE organisme TO postgres;
GRANT ALL ON TABLE organisme TO www;
GRANT ALL ON TABLE organisme TO "grp-www";
GRANT ALL ON TABLE organisme TO PUBLIC;


--
-- TOC entry 9823 (class 0 OID 0)
-- Dependencies: 4108
-- Name: organisme_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE organisme_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE organisme_id_seq FROM postgres;
GRANT ALL ON TABLE organisme_id_seq TO postgres;
GRANT ALL ON TABLE organisme_id_seq TO PUBLIC;
GRANT ALL ON TABLE organisme_id_seq TO "grp-www";


--
-- TOC entry 9824 (class 0 OID 0)
-- Dependencies: 4111
-- Name: page; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page FROM PUBLIC;
REVOKE ALL ON TABLE page FROM postgres;
GRANT ALL ON TABLE page TO postgres;
GRANT ALL ON TABLE page TO www;
GRANT ALL ON TABLE page TO "grp-www";
GRANT ALL ON TABLE page TO PUBLIC;


--
-- TOC entry 9825 (class 0 OID 0)
-- Dependencies: 4112
-- Name: page_annuaire_configuration; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_annuaire_configuration FROM PUBLIC;
REVOKE ALL ON TABLE page_annuaire_configuration FROM postgres;
GRANT ALL ON TABLE page_annuaire_configuration TO postgres;
GRANT ALL ON TABLE page_annuaire_configuration TO www;
GRANT ALL ON TABLE page_annuaire_configuration TO "grp-www";
GRANT ALL ON TABLE page_annuaire_configuration TO PUBLIC;


--
-- TOC entry 9826 (class 0 OID 0)
-- Dependencies: 4113
-- Name: page_commentaire; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_commentaire FROM PUBLIC;
REVOKE ALL ON TABLE page_commentaire FROM postgres;
GRANT ALL ON TABLE page_commentaire TO postgres;
GRANT ALL ON TABLE page_commentaire TO www;
GRANT ALL ON TABLE page_commentaire TO "grp-www";
GRANT ALL ON TABLE page_commentaire TO PUBLIC;


--
-- TOC entry 9827 (class 0 OID 0)
-- Dependencies: 4115
-- Name: page_element; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_element FROM PUBLIC;
REVOKE ALL ON TABLE page_element FROM postgres;
GRANT ALL ON TABLE page_element TO postgres;
GRANT ALL ON TABLE page_element TO www;
GRANT ALL ON TABLE page_element TO "grp-www";
GRANT ALL ON TABLE page_element TO PUBLIC;


--
-- TOC entry 9828 (class 0 OID 0)
-- Dependencies: 4114
-- Name: page_element_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_element_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE page_element_id_seq FROM postgres;
GRANT ALL ON TABLE page_element_id_seq TO postgres;
GRANT ALL ON TABLE page_element_id_seq TO PUBLIC;
GRANT ALL ON TABLE page_element_id_seq TO "grp-www";


--
-- TOC entry 9829 (class 0 OID 0)
-- Dependencies: 4116
-- Name: page_elements; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_elements FROM PUBLIC;
REVOKE ALL ON TABLE page_elements FROM postgres;
GRANT ALL ON TABLE page_elements TO postgres;
GRANT ALL ON TABLE page_elements TO www;
GRANT ALL ON TABLE page_elements TO "grp-www";
GRANT ALL ON TABLE page_elements TO PUBLIC;


--
-- TOC entry 9830 (class 0 OID 0)
-- Dependencies: 4110
-- Name: page_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE page_id_seq FROM postgres;
GRANT ALL ON TABLE page_id_seq TO postgres;
GRANT ALL ON TABLE page_id_seq TO PUBLIC;
GRANT ALL ON TABLE page_id_seq TO "grp-www";


--
-- TOC entry 9831 (class 0 OID 0)
-- Dependencies: 4117
-- Name: page_liste; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_liste FROM PUBLIC;
REVOKE ALL ON TABLE page_liste FROM postgres;
GRANT ALL ON TABLE page_liste TO postgres;
GRANT ALL ON TABLE page_liste TO "grp-www";
GRANT ALL ON TABLE page_liste TO PUBLIC;


--
-- TOC entry 9832 (class 0 OID 0)
-- Dependencies: 4118
-- Name: page_liste_configuration; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_liste_configuration FROM PUBLIC;
REVOKE ALL ON TABLE page_liste_configuration FROM postgres;
GRANT ALL ON TABLE page_liste_configuration TO postgres;
GRANT ALL ON TABLE page_liste_configuration TO "grp-www";
GRANT ALL ON TABLE page_liste_configuration TO PUBLIC;


--
-- TOC entry 9833 (class 0 OID 0)
-- Dependencies: 4119
-- Name: page_ressource_configuration; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_ressource_configuration FROM PUBLIC;
REVOKE ALL ON TABLE page_ressource_configuration FROM postgres;
GRANT ALL ON TABLE page_ressource_configuration TO postgres;
GRANT ALL ON TABLE page_ressource_configuration TO "grp-www";
GRANT ALL ON TABLE page_ressource_configuration TO PUBLIC;


--
-- TOC entry 9834 (class 0 OID 0)
-- Dependencies: 4121
-- Name: page_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_type FROM PUBLIC;
REVOKE ALL ON TABLE page_type FROM postgres;
GRANT ALL ON TABLE page_type TO postgres;
GRANT ALL ON TABLE page_type TO www;
GRANT ALL ON TABLE page_type TO "grp-www";
GRANT ALL ON TABLE page_type TO PUBLIC;


--
-- TOC entry 9835 (class 0 OID 0)
-- Dependencies: 4120
-- Name: page_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE page_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE page_type_id_seq FROM postgres;
GRANT ALL ON TABLE page_type_id_seq TO postgres;
GRANT ALL ON TABLE page_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE page_type_id_seq TO "grp-www";


--
-- TOC entry 9836 (class 0 OID 0)
-- Dependencies: 4122
-- Name: parcours; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE parcours FROM PUBLIC;
REVOKE ALL ON TABLE parcours FROM postgres;
GRANT ALL ON TABLE parcours TO postgres;
GRANT ALL ON TABLE parcours TO www;
GRANT ALL ON TABLE parcours TO "grp-www";
GRANT ALL ON TABLE parcours TO PUBLIC;


--
-- TOC entry 9838 (class 0 OID 0)
-- Dependencies: 4123
-- Name: parcours_etapes; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE parcours_etapes FROM PUBLIC;
REVOKE ALL ON TABLE parcours_etapes FROM postgres;
GRANT ALL ON TABLE parcours_etapes TO postgres;
GRANT ALL ON TABLE parcours_etapes TO www;
GRANT ALL ON TABLE parcours_etapes TO "grp-www";
GRANT ALL ON TABLE parcours_etapes TO PUBLIC;


--
-- TOC entry 9840 (class 0 OID 0)
-- Dependencies: 4124
-- Name: parcours_oriente; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE parcours_oriente FROM PUBLIC;
REVOKE ALL ON TABLE parcours_oriente FROM postgres;
GRANT ALL ON TABLE parcours_oriente TO postgres;
GRANT ALL ON TABLE parcours_oriente TO www;
GRANT ALL ON TABLE parcours_oriente TO "grp-www";
GRANT ALL ON TABLE parcours_oriente TO PUBLIC;


--
-- TOC entry 9842 (class 0 OID 0)
-- Dependencies: 4126
-- Name: pc_etape; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE pc_etape FROM PUBLIC;
REVOKE ALL ON TABLE pc_etape FROM postgres;
GRANT ALL ON TABLE pc_etape TO postgres;
GRANT ALL ON TABLE pc_etape TO www;
GRANT ALL ON TABLE pc_etape TO "grp-www";
GRANT ALL ON TABLE pc_etape TO PUBLIC;


--
-- TOC entry 9843 (class 0 OID 0)
-- Dependencies: 4125
-- Name: pc_etape_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE pc_etape_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE pc_etape_id_seq FROM postgres;
GRANT ALL ON TABLE pc_etape_id_seq TO postgres;
GRANT ALL ON TABLE pc_etape_id_seq TO PUBLIC;
GRANT ALL ON TABLE pc_etape_id_seq TO "grp-www";


--
-- TOC entry 9844 (class 0 OID 0)
-- Dependencies: 4128
-- Name: pc_etape_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE pc_etape_type FROM PUBLIC;
REVOKE ALL ON TABLE pc_etape_type FROM postgres;
GRANT ALL ON TABLE pc_etape_type TO postgres;
GRANT ALL ON TABLE pc_etape_type TO www;
GRANT ALL ON TABLE pc_etape_type TO "grp-www";
GRANT ALL ON TABLE pc_etape_type TO PUBLIC;


--
-- TOC entry 9845 (class 0 OID 0)
-- Dependencies: 4127
-- Name: pc_etape_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE pc_etape_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE pc_etape_type_id_seq FROM postgres;
GRANT ALL ON TABLE pc_etape_type_id_seq TO postgres;
GRANT ALL ON TABLE pc_etape_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE pc_etape_type_id_seq TO "grp-www";


--
-- TOC entry 9846 (class 0 OID 0)
-- Dependencies: 4130
-- Name: pc_filiere; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE pc_filiere FROM PUBLIC;
REVOKE ALL ON TABLE pc_filiere FROM postgres;
GRANT ALL ON TABLE pc_filiere TO postgres;
GRANT ALL ON TABLE pc_filiere TO www;
GRANT ALL ON TABLE pc_filiere TO "grp-www";
GRANT ALL ON TABLE pc_filiere TO PUBLIC;


--
-- TOC entry 9847 (class 0 OID 0)
-- Dependencies: 4129
-- Name: pc_filiere_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE pc_filiere_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE pc_filiere_id_seq FROM postgres;
GRANT ALL ON TABLE pc_filiere_id_seq TO postgres;
GRANT ALL ON TABLE pc_filiere_id_seq TO PUBLIC;
GRANT ALL ON TABLE pc_filiere_id_seq TO "grp-www";


--
-- TOC entry 9848 (class 0 OID 0)
-- Dependencies: 4131
-- Name: pc_parcours; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE pc_parcours FROM PUBLIC;
REVOKE ALL ON TABLE pc_parcours FROM postgres;
GRANT ALL ON TABLE pc_parcours TO postgres;
GRANT ALL ON TABLE pc_parcours TO www;
GRANT ALL ON TABLE pc_parcours TO "grp-www";
GRANT ALL ON TABLE pc_parcours TO PUBLIC;


--
-- TOC entry 9850 (class 0 OID 0)
-- Dependencies: 4133
-- Name: positionnement; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE positionnement FROM PUBLIC;
REVOKE ALL ON TABLE positionnement FROM postgres;
GRANT ALL ON TABLE positionnement TO postgres;
GRANT ALL ON TABLE positionnement TO www;
GRANT ALL ON TABLE positionnement TO "grp-www";
GRANT ALL ON TABLE positionnement TO PUBLIC;


--
-- TOC entry 9852 (class 0 OID 0)
-- Dependencies: 4134
-- Name: positionnement_choix_evaluations; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE positionnement_choix_evaluations FROM PUBLIC;
REVOKE ALL ON TABLE positionnement_choix_evaluations FROM postgres;
GRANT ALL ON TABLE positionnement_choix_evaluations TO postgres;
GRANT ALL ON TABLE positionnement_choix_evaluations TO www;
GRANT ALL ON TABLE positionnement_choix_evaluations TO "grp-www";
GRANT ALL ON TABLE positionnement_choix_evaluations TO PUBLIC;


--
-- TOC entry 9854 (class 0 OID 0)
-- Dependencies: 4135
-- Name: positionnement_elements; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE positionnement_elements FROM PUBLIC;
REVOKE ALL ON TABLE positionnement_elements FROM postgres;
GRANT ALL ON TABLE positionnement_elements TO postgres;
GRANT ALL ON TABLE positionnement_elements TO www;
GRANT ALL ON TABLE positionnement_elements TO "grp-www";
GRANT ALL ON TABLE positionnement_elements TO PUBLIC;


--
-- TOC entry 9855 (class 0 OID 0)
-- Dependencies: 4136
-- Name: positionnement_evaluations; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE positionnement_evaluations FROM PUBLIC;
REVOKE ALL ON TABLE positionnement_evaluations FROM postgres;
GRANT ALL ON TABLE positionnement_evaluations TO postgres;
GRANT ALL ON TABLE positionnement_evaluations TO www;
GRANT ALL ON TABLE positionnement_evaluations TO "grp-www";
GRANT ALL ON TABLE positionnement_evaluations TO PUBLIC;


--
-- TOC entry 9856 (class 0 OID 0)
-- Dependencies: 4132
-- Name: positionnement_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE positionnement_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE positionnement_id_seq FROM postgres;
GRANT ALL ON TABLE positionnement_id_seq TO postgres;
GRANT ALL ON TABLE positionnement_id_seq TO PUBLIC;
GRANT ALL ON TABLE positionnement_id_seq TO "grp-www";


--
-- TOC entry 9858 (class 0 OID 0)
-- Dependencies: 4138
-- Name: positionnement_old; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE positionnement_old FROM PUBLIC;
REVOKE ALL ON TABLE positionnement_old FROM postgres;
GRANT ALL ON TABLE positionnement_old TO postgres;
GRANT ALL ON TABLE positionnement_old TO www;
GRANT ALL ON TABLE positionnement_old TO "grp-www";
GRANT ALL ON TABLE positionnement_old TO PUBLIC;


--
-- TOC entry 9859 (class 0 OID 0)
-- Dependencies: 4137
-- Name: positionnement_old_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE positionnement_old_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE positionnement_old_id_seq FROM postgres;
GRANT ALL ON TABLE positionnement_old_id_seq TO postgres;
GRANT ALL ON TABLE positionnement_old_id_seq TO PUBLIC;
GRANT ALL ON TABLE positionnement_old_id_seq TO "grp-www";


--
-- TOC entry 9860 (class 0 OID 0)
-- Dependencies: 4139
-- Name: qcm_elements; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE qcm_elements FROM PUBLIC;
REVOKE ALL ON TABLE qcm_elements FROM postgres;
GRANT ALL ON TABLE qcm_elements TO postgres;
GRANT ALL ON TABLE qcm_elements TO www;
GRANT ALL ON TABLE qcm_elements TO "grp-www";
GRANT ALL ON TABLE qcm_elements TO PUBLIC;


--
-- TOC entry 9861 (class 0 OID 0)
-- Dependencies: 4140
-- Name: qsrc; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE qsrc FROM PUBLIC;
REVOKE ALL ON TABLE qsrc FROM postgres;
GRANT ALL ON TABLE qsrc TO postgres;
GRANT ALL ON TABLE qsrc TO www;
GRANT ALL ON TABLE qsrc TO "grp-www";
GRANT ALL ON TABLE qsrc TO PUBLIC;


--
-- TOC entry 9863 (class 0 OID 0)
-- Dependencies: 4141
-- Name: question; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE question FROM PUBLIC;
REVOKE ALL ON TABLE question FROM postgres;
GRANT ALL ON TABLE question TO postgres;
GRANT ALL ON TABLE question TO www;
GRANT ALL ON TABLE question TO "grp-www";
GRANT ALL ON TABLE question TO PUBLIC;


--
-- TOC entry 9864 (class 0 OID 0)
-- Dependencies: 4142
-- Name: question_reponse; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE question_reponse FROM postgres;
GRANT ALL ON TABLE question_reponse TO postgres;
GRANT ALL ON TABLE question_reponse TO www;
GRANT ALL ON TABLE question_reponse TO "grp-www";
GRANT ALL ON TABLE question_reponse TO PUBLIC;


--
-- TOC entry 9865 (class 0 OID 0)
-- Dependencies: 4144
-- Name: question_reponse_element; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE question_reponse_element FROM PUBLIC;
REVOKE ALL ON TABLE question_reponse_element FROM postgres;
GRANT ALL ON TABLE question_reponse_element TO postgres;
GRANT ALL ON TABLE question_reponse_element TO www;
GRANT ALL ON TABLE question_reponse_element TO "grp-www";
GRANT ALL ON TABLE question_reponse_element TO PUBLIC;


--
-- TOC entry 9866 (class 0 OID 0)
-- Dependencies: 4143
-- Name: question_reponse_element_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE question_reponse_element_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE question_reponse_element_id_seq FROM postgres;
GRANT ALL ON TABLE question_reponse_element_id_seq TO postgres;
GRANT ALL ON TABLE question_reponse_element_id_seq TO www;
GRANT ALL ON TABLE question_reponse_element_id_seq TO PUBLIC;
GRANT ALL ON TABLE question_reponse_element_id_seq TO "grp-www";


--
-- TOC entry 9868 (class 0 OID 0)
-- Dependencies: 4145
-- Name: question_reponse_elements; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE question_reponse_elements FROM PUBLIC;
REVOKE ALL ON TABLE question_reponse_elements FROM postgres;
GRANT ALL ON TABLE question_reponse_elements TO postgres;
GRANT ALL ON TABLE question_reponse_elements TO www;
GRANT ALL ON TABLE question_reponse_elements TO "grp-www";
GRANT ALL ON TABLE question_reponse_elements TO PUBLIC;


--
-- TOC entry 9870 (class 0 OID 0)
-- Dependencies: 4146
-- Name: question_reponse_elements_old; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE question_reponse_elements_old FROM PUBLIC;
REVOKE ALL ON TABLE question_reponse_elements_old FROM postgres;
GRANT ALL ON TABLE question_reponse_elements_old TO postgres;
GRANT ALL ON TABLE question_reponse_elements_old TO www;
GRANT ALL ON TABLE question_reponse_elements_old TO "grp-www";
GRANT ALL ON TABLE question_reponse_elements_old TO PUBLIC;


--
-- TOC entry 9872 (class 0 OID 0)
-- Dependencies: 4147
-- Name: question_reponse_elements_older; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE question_reponse_elements_older FROM PUBLIC;
REVOKE ALL ON TABLE question_reponse_elements_older FROM postgres;
GRANT ALL ON TABLE question_reponse_elements_older TO postgres;
GRANT ALL ON TABLE question_reponse_elements_older TO www;
GRANT ALL ON TABLE question_reponse_elements_older TO "grp-www";
GRANT ALL ON TABLE question_reponse_elements_older TO PUBLIC;


--
-- TOC entry 9874 (class 0 OID 0)
-- Dependencies: 4149
-- Name: question_reponse_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE question_reponse_type FROM PUBLIC;
REVOKE ALL ON TABLE question_reponse_type FROM postgres;
GRANT ALL ON TABLE question_reponse_type TO postgres;
GRANT ALL ON TABLE question_reponse_type TO www;
GRANT ALL ON TABLE question_reponse_type TO "grp-www";
GRANT ALL ON TABLE question_reponse_type TO PUBLIC;


--
-- TOC entry 9875 (class 0 OID 0)
-- Dependencies: 4148
-- Name: question_reponse_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE question_reponse_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE question_reponse_type_id_seq FROM postgres;
GRANT ALL ON TABLE question_reponse_type_id_seq TO postgres;
GRANT ALL ON TABLE question_reponse_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE question_reponse_type_id_seq TO "grp-www";


--
-- TOC entry 9877 (class 0 OID 0)
-- Dependencies: 4150
-- Name: reponse; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE reponse FROM PUBLIC;
REVOKE ALL ON TABLE reponse FROM postgres;
GRANT ALL ON TABLE reponse TO postgres;
GRANT ALL ON TABLE reponse TO www;
GRANT ALL ON TABLE reponse TO "grp-www";
GRANT ALL ON TABLE reponse TO PUBLIC;


--
-- TOC entry 9878 (class 0 OID 0)
-- Dependencies: 4151
-- Name: resultat_id_seq; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE resultat_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE resultat_id_seq FROM pgsql;
GRANT ALL ON TABLE resultat_id_seq TO pgsql;
GRANT ALL ON TABLE resultat_id_seq TO PUBLIC;
GRANT ALL ON TABLE resultat_id_seq TO "grp-www";


--
-- TOC entry 9879 (class 0 OID 0)
-- Dependencies: 4152
-- Name: resultat; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat FROM PUBLIC;
REVOKE ALL ON TABLE resultat FROM postgres;
GRANT ALL ON TABLE resultat TO postgres;
GRANT ALL ON TABLE resultat TO www;
GRANT ALL ON TABLE resultat TO "grp-www";
GRANT ALL ON TABLE resultat TO PUBLIC;


--
-- TOC entry 9880 (class 0 OID 0)
-- Dependencies: 4153
-- Name: resultat_exotlc; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE resultat_exotlc FROM postgres;
GRANT ALL ON TABLE resultat_exotlc TO postgres;
GRANT ALL ON TABLE resultat_exotlc TO www;
GRANT ALL ON TABLE resultat_exotlc TO "grp-www";
GRANT ALL ON TABLE resultat_exotlc TO PUBLIC;


--
-- TOC entry 9881 (class 0 OID 0)
-- Dependencies: 4154
-- Name: resultat_exotlc_critere; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_exotlc_critere FROM PUBLIC;
REVOKE ALL ON TABLE resultat_exotlc_critere FROM postgres;
GRANT ALL ON TABLE resultat_exotlc_critere TO postgres;
GRANT ALL ON TABLE resultat_exotlc_critere TO www;
GRANT ALL ON TABLE resultat_exotlc_critere TO "grp-www";
GRANT ALL ON TABLE resultat_exotlc_critere TO PUBLIC;


--
-- TOC entry 9882 (class 0 OID 0)
-- Dependencies: 4155
-- Name: resultat_exotlc_sous_critere; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_exotlc_sous_critere FROM PUBLIC;
REVOKE ALL ON TABLE resultat_exotlc_sous_critere FROM postgres;
GRANT ALL ON TABLE resultat_exotlc_sous_critere TO postgres;
GRANT ALL ON TABLE resultat_exotlc_sous_critere TO www;
GRANT ALL ON TABLE resultat_exotlc_sous_critere TO "grp-www";
GRANT ALL ON TABLE resultat_exotlc_sous_critere TO PUBLIC;


--
-- TOC entry 9884 (class 0 OID 0)
-- Dependencies: 4156
-- Name: resultat_positionnement; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_positionnement FROM PUBLIC;
REVOKE ALL ON TABLE resultat_positionnement FROM postgres;
GRANT ALL ON TABLE resultat_positionnement TO postgres;
GRANT ALL ON TABLE resultat_positionnement TO www;
GRANT ALL ON TABLE resultat_positionnement TO "grp-www";
GRANT ALL ON TABLE resultat_positionnement TO PUBLIC;


--
-- TOC entry 9886 (class 0 OID 0)
-- Dependencies: 4157
-- Name: resultat_positionnement_question_reponse; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_positionnement_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE resultat_positionnement_question_reponse FROM postgres;
GRANT ALL ON TABLE resultat_positionnement_question_reponse TO postgres;
GRANT ALL ON TABLE resultat_positionnement_question_reponse TO www;
GRANT ALL ON TABLE resultat_positionnement_question_reponse TO "grp-www";
GRANT ALL ON TABLE resultat_positionnement_question_reponse TO PUBLIC;


--
-- TOC entry 9887 (class 0 OID 0)
-- Dependencies: 4158
-- Name: resultat_serie; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_serie FROM PUBLIC;
REVOKE ALL ON TABLE resultat_serie FROM postgres;
GRANT ALL ON TABLE resultat_serie TO postgres;
GRANT ALL ON TABLE resultat_serie TO www;
GRANT ALL ON TABLE resultat_serie TO "grp-www";
GRANT ALL ON TABLE resultat_serie TO PUBLIC;


--
-- TOC entry 9889 (class 0 OID 0)
-- Dependencies: 4159
-- Name: resultat_serie_ftb; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_serie_ftb FROM PUBLIC;
REVOKE ALL ON TABLE resultat_serie_ftb FROM postgres;
GRANT ALL ON TABLE resultat_serie_ftb TO postgres;
GRANT ALL ON TABLE resultat_serie_ftb TO www;
GRANT ALL ON TABLE resultat_serie_ftb TO "grp-www";
GRANT ALL ON TABLE resultat_serie_ftb TO PUBLIC;


--
-- TOC entry 9891 (class 0 OID 0)
-- Dependencies: 4160
-- Name: resultat_serie_question_reponse; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_serie_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE resultat_serie_question_reponse FROM postgres;
GRANT ALL ON TABLE resultat_serie_question_reponse TO postgres;
GRANT ALL ON TABLE resultat_serie_question_reponse TO www;
GRANT ALL ON TABLE resultat_serie_question_reponse TO "grp-www";
GRANT ALL ON TABLE resultat_serie_question_reponse TO PUBLIC;


--
-- TOC entry 9892 (class 0 OID 0)
-- Dependencies: 4161
-- Name: resultat_serie_tentative; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_serie_tentative FROM PUBLIC;
REVOKE ALL ON TABLE resultat_serie_tentative FROM postgres;
GRANT ALL ON TABLE resultat_serie_tentative TO postgres;
GRANT ALL ON TABLE resultat_serie_tentative TO www;
GRANT ALL ON TABLE resultat_serie_tentative TO "grp-www";
GRANT ALL ON TABLE resultat_serie_tentative TO PUBLIC;


--
-- TOC entry 9894 (class 0 OID 0)
-- Dependencies: 4162
-- Name: resultat_serie_tentative_ftb; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_serie_tentative_ftb FROM PUBLIC;
REVOKE ALL ON TABLE resultat_serie_tentative_ftb FROM postgres;
GRANT ALL ON TABLE resultat_serie_tentative_ftb TO postgres;
GRANT ALL ON TABLE resultat_serie_tentative_ftb TO www;
GRANT ALL ON TABLE resultat_serie_tentative_ftb TO "grp-www";
GRANT ALL ON TABLE resultat_serie_tentative_ftb TO PUBLIC;


--
-- TOC entry 9896 (class 0 OID 0)
-- Dependencies: 4163
-- Name: resultat_serie_tentative_question_reponse; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_serie_tentative_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE resultat_serie_tentative_question_reponse FROM postgres;
GRANT ALL ON TABLE resultat_serie_tentative_question_reponse TO postgres;
GRANT ALL ON TABLE resultat_serie_tentative_question_reponse TO www;
GRANT ALL ON TABLE resultat_serie_tentative_question_reponse TO "grp-www";
GRANT ALL ON TABLE resultat_serie_tentative_question_reponse TO PUBLIC;


--
-- TOC entry 9897 (class 0 OID 0)
-- Dependencies: 4165
-- Name: resultat_tentative; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_tentative FROM PUBLIC;
REVOKE ALL ON TABLE resultat_tentative FROM postgres;
GRANT ALL ON TABLE resultat_tentative TO postgres;
GRANT ALL ON TABLE resultat_tentative TO www;
GRANT ALL ON TABLE resultat_tentative TO "grp-www";
GRANT ALL ON TABLE resultat_tentative TO PUBLIC;


--
-- TOC entry 9898 (class 0 OID 0)
-- Dependencies: 4164
-- Name: resultat_tentative_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_tentative_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE resultat_tentative_id_seq FROM postgres;
GRANT ALL ON TABLE resultat_tentative_id_seq TO postgres;
GRANT ALL ON TABLE resultat_tentative_id_seq TO PUBLIC;
GRANT ALL ON TABLE resultat_tentative_id_seq TO "grp-www";


--
-- TOC entry 9899 (class 0 OID 0)
-- Dependencies: 4166
-- Name: resultat_test; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE resultat_test FROM PUBLIC;
REVOKE ALL ON TABLE resultat_test FROM postgres;
GRANT ALL ON TABLE resultat_test TO postgres;
GRANT ALL ON TABLE resultat_test TO www;
GRANT ALL ON TABLE resultat_test TO "grp-www";
GRANT ALL ON TABLE resultat_test TO PUBLIC;


--
-- TOC entry 9900 (class 0 OID 0)
-- Dependencies: 4167
-- Name: salle_id_seq; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE salle_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE salle_id_seq FROM pgsql;
GRANT ALL ON TABLE salle_id_seq TO pgsql;
GRANT ALL ON TABLE salle_id_seq TO PUBLIC;
GRANT ALL ON TABLE salle_id_seq TO "grp-www";


--
-- TOC entry 9902 (class 0 OID 0)
-- Dependencies: 4168
-- Name: salle; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE salle FROM PUBLIC;
REVOKE ALL ON TABLE salle FROM postgres;
GRANT ALL ON TABLE salle TO postgres;
GRANT ALL ON TABLE salle TO www;
GRANT ALL ON TABLE salle TO "grp-www";
GRANT ALL ON TABLE salle TO PUBLIC;


--
-- TOC entry 9903 (class 0 OID 0)
-- Dependencies: 4169
-- Name: scenario; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE scenario FROM PUBLIC;
REVOKE ALL ON TABLE scenario FROM postgres;
GRANT ALL ON TABLE scenario TO postgres;
GRANT ALL ON TABLE scenario TO www;
GRANT ALL ON TABLE scenario TO "grp-www";
GRANT ALL ON TABLE scenario TO PUBLIC;


--
-- TOC entry 9904 (class 0 OID 0)
-- Dependencies: 4170
-- Name: scenario_dynamique; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE scenario_dynamique FROM PUBLIC;
REVOKE ALL ON TABLE scenario_dynamique FROM postgres;
GRANT ALL ON TABLE scenario_dynamique TO postgres;
GRANT ALL ON TABLE scenario_dynamique TO "grp-www";
GRANT ALL ON TABLE scenario_dynamique TO PUBLIC;


--
-- TOC entry 9905 (class 0 OID 0)
-- Dependencies: 4172
-- Name: scorm; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE scorm FROM PUBLIC;
REVOKE ALL ON TABLE scorm FROM postgres;
GRANT ALL ON TABLE scorm TO postgres;
GRANT ALL ON TABLE scorm TO www;
GRANT ALL ON TABLE scorm TO "grp-www";
GRANT ALL ON TABLE scorm TO PUBLIC;


--
-- TOC entry 9906 (class 0 OID 0)
-- Dependencies: 4171
-- Name: scorm_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE scorm_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE scorm_id_seq FROM postgres;
GRANT ALL ON TABLE scorm_id_seq TO postgres;
GRANT ALL ON TABLE scorm_id_seq TO PUBLIC;
GRANT ALL ON TABLE scorm_id_seq TO "grp-www";


--
-- TOC entry 9907 (class 0 OID 0)
-- Dependencies: 4174
-- Name: scorm_sco_users; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE scorm_sco_users FROM PUBLIC;
REVOKE ALL ON TABLE scorm_sco_users FROM postgres;
GRANT ALL ON TABLE scorm_sco_users TO postgres;
GRANT ALL ON TABLE scorm_sco_users TO www;
GRANT ALL ON TABLE scorm_sco_users TO "grp-www";
GRANT ALL ON TABLE scorm_sco_users TO PUBLIC;


--
-- TOC entry 9908 (class 0 OID 0)
-- Dependencies: 4173
-- Name: scorm_sco_users_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE scorm_sco_users_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE scorm_sco_users_id_seq FROM postgres;
GRANT ALL ON TABLE scorm_sco_users_id_seq TO postgres;
GRANT ALL ON TABLE scorm_sco_users_id_seq TO PUBLIC;
GRANT ALL ON TABLE scorm_sco_users_id_seq TO "grp-www";


--
-- TOC entry 9909 (class 0 OID 0)
-- Dependencies: 4176
-- Name: scorm_scoes; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE scorm_scoes FROM PUBLIC;
REVOKE ALL ON TABLE scorm_scoes FROM postgres;
GRANT ALL ON TABLE scorm_scoes TO postgres;
GRANT ALL ON TABLE scorm_scoes TO www;
GRANT ALL ON TABLE scorm_scoes TO "grp-www";
GRANT ALL ON TABLE scorm_scoes TO PUBLIC;


--
-- TOC entry 9910 (class 0 OID 0)
-- Dependencies: 4175
-- Name: scorm_scoes_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE scorm_scoes_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE scorm_scoes_id_seq FROM postgres;
GRANT ALL ON TABLE scorm_scoes_id_seq TO postgres;
GRANT ALL ON TABLE scorm_scoes_id_seq TO PUBLIC;
GRANT ALL ON TABLE scorm_scoes_id_seq TO "grp-www";


--
-- TOC entry 9911 (class 0 OID 0)
-- Dependencies: 4177
-- Name: section_id_seq; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE section_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE section_id_seq FROM pgsql;
GRANT ALL ON TABLE section_id_seq TO pgsql;
GRANT ALL ON TABLE section_id_seq TO PUBLIC;
GRANT ALL ON TABLE section_id_seq TO "grp-www";


--
-- TOC entry 9913 (class 0 OID 0)
-- Dependencies: 4178
-- Name: section; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE section FROM PUBLIC;
REVOKE ALL ON TABLE section FROM postgres;
GRANT ALL ON TABLE section TO postgres;
GRANT ALL ON TABLE section TO www;
GRANT ALL ON TABLE section TO "grp-www";
GRANT ALL ON TABLE section TO PUBLIC;


--
-- TOC entry 9915 (class 0 OID 0)
-- Dependencies: 4179
-- Name: serie; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie FROM PUBLIC;
REVOKE ALL ON TABLE serie FROM postgres;
GRANT ALL ON TABLE serie TO postgres;
GRANT ALL ON TABLE serie TO www;
GRANT ALL ON TABLE serie TO "grp-www";
GRANT ALL ON TABLE serie TO PUBLIC;


--
-- TOC entry 9916 (class 0 OID 0)
-- Dependencies: 4180
-- Name: serie_aleatoire; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie_aleatoire FROM PUBLIC;
REVOKE ALL ON TABLE serie_aleatoire FROM postgres;
GRANT ALL ON TABLE serie_aleatoire TO postgres;
GRANT ALL ON TABLE serie_aleatoire TO www;
GRANT ALL ON TABLE serie_aleatoire TO "grp-www";
GRANT ALL ON TABLE serie_aleatoire TO PUBLIC;


--
-- TOC entry 9918 (class 0 OID 0)
-- Dependencies: 4181
-- Name: serie_aleatoire_evaluations; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie_aleatoire_evaluations FROM PUBLIC;
REVOKE ALL ON TABLE serie_aleatoire_evaluations FROM postgres;
GRANT ALL ON TABLE serie_aleatoire_evaluations TO postgres;
GRANT ALL ON TABLE serie_aleatoire_evaluations TO www;
GRANT ALL ON TABLE serie_aleatoire_evaluations TO "grp-www";
GRANT ALL ON TABLE serie_aleatoire_evaluations TO PUBLIC;


--
-- TOC entry 9919 (class 0 OID 0)
-- Dependencies: 4182
-- Name: serie_aleatoire_melangee; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie_aleatoire_melangee FROM PUBLIC;
REVOKE ALL ON TABLE serie_aleatoire_melangee FROM postgres;
GRANT ALL ON TABLE serie_aleatoire_melangee TO postgres;
GRANT ALL ON TABLE serie_aleatoire_melangee TO "grp-www";
GRANT ALL ON TABLE serie_aleatoire_melangee TO PUBLIC;


--
-- TOC entry 9921 (class 0 OID 0)
-- Dependencies: 4183
-- Name: serie_aleatoire_multiserie; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie_aleatoire_multiserie FROM PUBLIC;
REVOKE ALL ON TABLE serie_aleatoire_multiserie FROM postgres;
GRANT ALL ON TABLE serie_aleatoire_multiserie TO postgres;
GRANT ALL ON TABLE serie_aleatoire_multiserie TO www;
GRANT ALL ON TABLE serie_aleatoire_multiserie TO "grp-www";
GRANT ALL ON TABLE serie_aleatoire_multiserie TO PUBLIC;


--
-- TOC entry 9923 (class 0 OID 0)
-- Dependencies: 4184
-- Name: serie_aleatoire_multitheme; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie_aleatoire_multitheme FROM PUBLIC;
REVOKE ALL ON TABLE serie_aleatoire_multitheme FROM postgres;
GRANT ALL ON TABLE serie_aleatoire_multitheme TO postgres;
GRANT ALL ON TABLE serie_aleatoire_multitheme TO www;
GRANT ALL ON TABLE serie_aleatoire_multitheme TO "grp-www";
GRANT ALL ON TABLE serie_aleatoire_multitheme TO PUBLIC;


--
-- TOC entry 9925 (class 0 OID 0)
-- Dependencies: 4186
-- Name: serie_aleatoire_type; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie_aleatoire_type FROM PUBLIC;
REVOKE ALL ON TABLE serie_aleatoire_type FROM postgres;
GRANT ALL ON TABLE serie_aleatoire_type TO postgres;
GRANT ALL ON TABLE serie_aleatoire_type TO www;
GRANT ALL ON TABLE serie_aleatoire_type TO "grp-www";
GRANT ALL ON TABLE serie_aleatoire_type TO PUBLIC;


--
-- TOC entry 9926 (class 0 OID 0)
-- Dependencies: 4185
-- Name: serie_aleatoire_type_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie_aleatoire_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE serie_aleatoire_type_id_seq FROM postgres;
GRANT ALL ON TABLE serie_aleatoire_type_id_seq TO postgres;
GRANT ALL ON TABLE serie_aleatoire_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE serie_aleatoire_type_id_seq TO "grp-www";


--
-- TOC entry 9928 (class 0 OID 0)
-- Dependencies: 4187
-- Name: serie_bloquante; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie_bloquante FROM PUBLIC;
REVOKE ALL ON TABLE serie_bloquante FROM postgres;
GRANT ALL ON TABLE serie_bloquante TO postgres;
GRANT ALL ON TABLE serie_bloquante TO "grp-www";
GRANT ALL ON TABLE serie_bloquante TO PUBLIC;


--
-- TOC entry 9930 (class 0 OID 0)
-- Dependencies: 4188
-- Name: serie_evaluations; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE serie_evaluations FROM PUBLIC;
REVOKE ALL ON TABLE serie_evaluations FROM postgres;
GRANT ALL ON TABLE serie_evaluations TO postgres;
GRANT ALL ON TABLE serie_evaluations TO www;
GRANT ALL ON TABLE serie_evaluations TO "grp-www";
GRANT ALL ON TABLE serie_evaluations TO PUBLIC;


--
-- TOC entry 9931 (class 0 OID 0)
-- Dependencies: 4189
-- Name: session; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE "session" FROM PUBLIC;
REVOKE ALL ON TABLE "session" FROM postgres;
GRANT ALL ON TABLE "session" TO postgres;
GRANT ALL ON TABLE "session" TO "grp-www";
GRANT ALL ON TABLE "session" TO PUBLIC;


--
-- TOC entry 9932 (class 0 OID 0)
-- Dependencies: 4190
-- Name: session_active; Type: ACL; Schema: contraintes; Owner: pgsql
--

REVOKE ALL ON TABLE session_active FROM PUBLIC;
REVOKE ALL ON TABLE session_active FROM pgsql;
GRANT ALL ON TABLE session_active TO pgsql;
GRANT ALL ON TABLE session_active TO "grp-www";
GRANT ALL ON TABLE session_active TO PUBLIC;


--
-- TOC entry 9934 (class 0 OID 0)
-- Dependencies: 4191
-- Name: stagiaire_grille; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE stagiaire_grille FROM PUBLIC;
REVOKE ALL ON TABLE stagiaire_grille FROM postgres;
GRANT ALL ON TABLE stagiaire_grille TO postgres;
GRANT ALL ON TABLE stagiaire_grille TO www;
GRANT ALL ON TABLE stagiaire_grille TO "grp-www";
GRANT ALL ON TABLE stagiaire_grille TO PUBLIC;


--
-- TOC entry 9936 (class 0 OID 0)
-- Dependencies: 4192
-- Name: test; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE test FROM PUBLIC;
REVOKE ALL ON TABLE test FROM postgres;
GRANT ALL ON TABLE test TO postgres;
GRANT ALL ON TABLE test TO www;
GRANT ALL ON TABLE test TO "grp-www";
GRANT ALL ON TABLE test TO PUBLIC;


--
-- TOC entry 9938 (class 0 OID 0)
-- Dependencies: 4193
-- Name: test_positionnements; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE test_positionnements FROM PUBLIC;
REVOKE ALL ON TABLE test_positionnements FROM postgres;
GRANT ALL ON TABLE test_positionnements TO postgres;
GRANT ALL ON TABLE test_positionnements TO www;
GRANT ALL ON TABLE test_positionnements TO "grp-www";
GRANT ALL ON TABLE test_positionnements TO PUBLIC;


--
-- TOC entry 9940 (class 0 OID 0)
-- Dependencies: 4195
-- Name: theme; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE theme FROM PUBLIC;
REVOKE ALL ON TABLE theme FROM postgres;
GRANT ALL ON TABLE theme TO postgres;
GRANT ALL ON TABLE theme TO www;
GRANT ALL ON TABLE theme TO "grp-www";
GRANT ALL ON TABLE theme TO PUBLIC;


--
-- TOC entry 9942 (class 0 OID 0)
-- Dependencies: 4196
-- Name: theme_categories; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE theme_categories FROM PUBLIC;
REVOKE ALL ON TABLE theme_categories FROM postgres;
GRANT ALL ON TABLE theme_categories TO postgres;
GRANT ALL ON TABLE theme_categories TO www;
GRANT ALL ON TABLE theme_categories TO "grp-www";
GRANT ALL ON TABLE theme_categories TO PUBLIC;


--
-- TOC entry 9943 (class 0 OID 0)
-- Dependencies: 4194
-- Name: theme_id_seq; Type: ACL; Schema: contraintes; Owner: postgres
--

REVOKE ALL ON TABLE theme_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE theme_id_seq FROM postgres;
GRANT ALL ON TABLE theme_id_seq TO postgres;
GRANT ALL ON TABLE theme_id_seq TO PUBLIC;
GRANT ALL ON TABLE theme_id_seq TO "grp-www";


SET search_path = public, pg_catalog;

--
-- TOC entry 9944 (class 0 OID 0)
-- Dependencies: 4197
-- Name: CORRECTION_MODELE_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE "CORRECTION_MODELE_id_seq" FROM PUBLIC;
REVOKE ALL ON TABLE "CORRECTION_MODELE_id_seq" FROM pgsql;
GRANT ALL ON TABLE "CORRECTION_MODELE_id_seq" TO pgsql;
GRANT ALL ON TABLE "CORRECTION_MODELE_id_seq" TO postgres;
GRANT ALL ON TABLE "CORRECTION_MODELE_id_seq" TO www;
GRANT ALL ON TABLE "CORRECTION_MODELE_id_seq" TO PUBLIC;


--
-- TOC entry 9945 (class 0 OID 0)
-- Dependencies: 4198
-- Name: active_sessions; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE active_sessions FROM PUBLIC;
REVOKE ALL ON TABLE active_sessions FROM pgsql;
GRANT ALL ON TABLE active_sessions TO pgsql;
GRANT ALL ON TABLE active_sessions TO "grp-www";
GRANT ALL ON TABLE active_sessions TO PUBLIC;


--
-- TOC entry 9946 (class 0 OID 0)
-- Dependencies: 4199
-- Name: active_sessions_split; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE active_sessions_split FROM PUBLIC;
REVOKE ALL ON TABLE active_sessions_split FROM pgsql;
GRANT ALL ON TABLE active_sessions_split TO pgsql;
GRANT ALL ON TABLE active_sessions_split TO "grp-www";
GRANT ALL ON TABLE active_sessions_split TO PUBLIC;


--
-- TOC entry 9947 (class 0 OID 0)
-- Dependencies: 4200
-- Name: adrgroupe_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE adrgroupe_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE adrgroupe_id_seq FROM pgsql;
GRANT ALL ON TABLE adrgroupe_id_seq TO pgsql;
GRANT ALL ON TABLE adrgroupe_id_seq TO postgres;
GRANT ALL ON TABLE adrgroupe_id_seq TO www;
GRANT ALL ON TABLE adrgroupe_id_seq TO PUBLIC;


--
-- TOC entry 9948 (class 0 OID 0)
-- Dependencies: 4201
-- Name: alert; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE alert FROM PUBLIC;
REVOKE ALL ON TABLE alert FROM pgsql;
GRANT ALL ON TABLE alert TO pgsql;
GRANT ALL ON TABLE alert TO postgres;
GRANT ALL ON TABLE alert TO www;
GRANT ALL ON TABLE alert TO PUBLIC;


--
-- TOC entry 9949 (class 0 OID 0)
-- Dependencies: 4202
-- Name: alert_num_alert_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE alert_num_alert_seq FROM PUBLIC;
REVOKE ALL ON TABLE alert_num_alert_seq FROM pgsql;
GRANT ALL ON TABLE alert_num_alert_seq TO pgsql;
GRANT ALL ON TABLE alert_num_alert_seq TO postgres;
GRANT ALL ON TABLE alert_num_alert_seq TO www;
GRANT ALL ON TABLE alert_num_alert_seq TO PUBLIC;


--
-- TOC entry 9950 (class 0 OID 0)
-- Dependencies: 4203
-- Name: allias_fichier; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE allias_fichier FROM PUBLIC;
REVOKE ALL ON TABLE allias_fichier FROM pgsql;
GRANT ALL ON TABLE allias_fichier TO pgsql;
GRANT ALL ON TABLE allias_fichier TO postgres;
GRANT ALL ON TABLE allias_fichier TO www;
GRANT ALL ON TABLE allias_fichier TO PUBLIC;


--
-- TOC entry 9951 (class 0 OID 0)
-- Dependencies: 4204
-- Name: articles; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE articles FROM PUBLIC;
REVOKE ALL ON TABLE articles FROM pgsql;
GRANT ALL ON TABLE articles TO pgsql;
GRANT ALL ON TABLE articles TO postgres;
GRANT ALL ON TABLE articles TO www;
GRANT ALL ON TABLE articles TO PUBLIC;


--
-- TOC entry 9952 (class 0 OID 0)
-- Dependencies: 4205
-- Name: articles_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE articles_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE articles_id_seq FROM pgsql;
GRANT ALL ON TABLE articles_id_seq TO pgsql;
GRANT ALL ON TABLE articles_id_seq TO postgres;
GRANT ALL ON TABLE articles_id_seq TO www;
GRANT ALL ON TABLE articles_id_seq TO PUBLIC;


--
-- TOC entry 9953 (class 0 OID 0)
-- Dependencies: 4206
-- Name: asso_exo_serie; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE asso_exo_serie FROM PUBLIC;
REVOKE ALL ON TABLE asso_exo_serie FROM pgsql;
GRANT ALL ON TABLE asso_exo_serie TO pgsql;
GRANT ALL ON TABLE asso_exo_serie TO postgres;
GRANT ALL ON TABLE asso_exo_serie TO www;
GRANT ALL ON TABLE asso_exo_serie TO PUBLIC;


--
-- TOC entry 9954 (class 0 OID 0)
-- Dependencies: 4207
-- Name: asso_exo_serie_aleatoire; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE asso_exo_serie_aleatoire FROM PUBLIC;
REVOKE ALL ON TABLE asso_exo_serie_aleatoire FROM pgsql;
GRANT ALL ON TABLE asso_exo_serie_aleatoire TO pgsql;
GRANT ALL ON TABLE asso_exo_serie_aleatoire TO postgres;
GRANT ALL ON TABLE asso_exo_serie_aleatoire TO www;
GRANT ALL ON TABLE asso_exo_serie_aleatoire TO PUBLIC;


--
-- TOC entry 9955 (class 0 OID 0)
-- Dependencies: 4208
-- Name: asso_liste_test; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE asso_liste_test FROM PUBLIC;
REVOKE ALL ON TABLE asso_liste_test FROM pgsql;
GRANT ALL ON TABLE asso_liste_test TO pgsql;
GRANT ALL ON TABLE asso_liste_test TO postgres;
GRANT ALL ON TABLE asso_liste_test TO www;
GRANT ALL ON TABLE asso_liste_test TO PUBLIC;


--
-- TOC entry 9956 (class 0 OID 0)
-- Dependencies: 4209
-- Name: asso_test_reponse; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE asso_test_reponse FROM PUBLIC;
REVOKE ALL ON TABLE asso_test_reponse FROM pgsql;
GRANT ALL ON TABLE asso_test_reponse TO pgsql;
GRANT ALL ON TABLE asso_test_reponse TO postgres;
GRANT ALL ON TABLE asso_test_reponse TO www;
GRANT ALL ON TABLE asso_test_reponse TO PUBLIC;


--
-- TOC entry 9957 (class 0 OID 0)
-- Dependencies: 4211
-- Name: auth_user; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE auth_user FROM PUBLIC;
REVOKE ALL ON TABLE auth_user FROM pgsql;
GRANT ALL ON TABLE auth_user TO pgsql;
GRANT ALL ON TABLE auth_user TO "grp-www";
GRANT ALL ON TABLE auth_user TO PUBLIC;


--
-- TOC entry 9958 (class 0 OID 0)
-- Dependencies: 4212
-- Name: auth_user_md5; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE auth_user_md5 FROM PUBLIC;
REVOKE ALL ON TABLE auth_user_md5 FROM pgsql;
GRANT ALL ON TABLE auth_user_md5 TO pgsql;
GRANT ALL ON TABLE auth_user_md5 TO "grp-www";
GRANT ALL ON TABLE auth_user_md5 TO PUBLIC;


--
-- TOC entry 9959 (class 0 OID 0)
-- Dependencies: 4213
-- Name: bareme; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE bareme FROM PUBLIC;
REVOKE ALL ON TABLE bareme FROM pgsql;
GRANT ALL ON TABLE bareme TO pgsql;
GRANT ALL ON TABLE bareme TO postgres;
GRANT ALL ON TABLE bareme TO www;
GRANT ALL ON TABLE bareme TO PUBLIC;


--
-- TOC entry 9960 (class 0 OID 0)
-- Dependencies: 4214
-- Name: block_ip; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE block_ip FROM PUBLIC;
REVOKE ALL ON TABLE block_ip FROM pgsql;
GRANT ALL ON TABLE block_ip TO pgsql;
GRANT ALL ON TABLE block_ip TO postgres;
GRANT ALL ON TABLE block_ip TO www;
GRANT ALL ON TABLE block_ip TO PUBLIC;


--
-- TOC entry 9961 (class 0 OID 0)
-- Dependencies: 4215
-- Name: c_ban_users; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE c_ban_users FROM PUBLIC;
REVOKE ALL ON TABLE c_ban_users FROM pgsql;
GRANT ALL ON TABLE c_ban_users TO pgsql;
GRANT ALL ON TABLE c_ban_users TO postgres;
GRANT ALL ON TABLE c_ban_users TO www;
GRANT ALL ON TABLE c_ban_users TO PUBLIC;


--
-- TOC entry 9962 (class 0 OID 0)
-- Dependencies: 4216
-- Name: c_messages; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE c_messages FROM PUBLIC;
REVOKE ALL ON TABLE c_messages FROM pgsql;
GRANT ALL ON TABLE c_messages TO pgsql;
GRANT ALL ON TABLE c_messages TO postgres;
GRANT ALL ON TABLE c_messages TO www;
GRANT ALL ON TABLE c_messages TO PUBLIC;


--
-- TOC entry 9963 (class 0 OID 0)
-- Dependencies: 4217
-- Name: c_reg_users; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE c_reg_users FROM PUBLIC;
REVOKE ALL ON TABLE c_reg_users FROM pgsql;
GRANT ALL ON TABLE c_reg_users TO pgsql;
GRANT ALL ON TABLE c_reg_users TO postgres;
GRANT ALL ON TABLE c_reg_users TO www;
GRANT ALL ON TABLE c_reg_users TO PUBLIC;


--
-- TOC entry 9964 (class 0 OID 0)
-- Dependencies: 4218
-- Name: c_users; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE c_users FROM PUBLIC;
REVOKE ALL ON TABLE c_users FROM pgsql;
GRANT ALL ON TABLE c_users TO pgsql;
GRANT ALL ON TABLE c_users TO postgres;
GRANT ALL ON TABLE c_users TO www;
GRANT ALL ON TABLE c_users TO PUBLIC;


--
-- TOC entry 9965 (class 0 OID 0)
-- Dependencies: 4219
-- Name: calendrier; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE calendrier FROM PUBLIC;
REVOKE ALL ON TABLE calendrier FROM pgsql;
GRANT ALL ON TABLE calendrier TO pgsql;
GRANT ALL ON TABLE calendrier TO postgres;
GRANT ALL ON TABLE calendrier TO www;
GRANT ALL ON TABLE calendrier TO PUBLIC;


--
-- TOC entry 9966 (class 0 OID 0)
-- Dependencies: 4220
-- Name: capacite; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE capacite FROM PUBLIC;
REVOKE ALL ON TABLE capacite FROM pgsql;
GRANT ALL ON TABLE capacite TO pgsql;
GRANT ALL ON TABLE capacite TO postgres;
GRANT ALL ON TABLE capacite TO www;
GRANT ALL ON TABLE capacite TO PUBLIC;


--
-- TOC entry 9967 (class 0 OID 0)
-- Dependencies: 4221
-- Name: categoriepage; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE categoriepage FROM PUBLIC;
REVOKE ALL ON TABLE categoriepage FROM pgsql;
GRANT ALL ON TABLE categoriepage TO pgsql;
GRANT ALL ON TABLE categoriepage TO postgres;
GRANT ALL ON TABLE categoriepage TO www;
GRANT ALL ON TABLE categoriepage TO PUBLIC;


--
-- TOC entry 9968 (class 0 OID 0)
-- Dependencies: 4222
-- Name: categoriepage_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE categoriepage_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE categoriepage_id_seq FROM pgsql;
GRANT ALL ON TABLE categoriepage_id_seq TO pgsql;
GRANT ALL ON TABLE categoriepage_id_seq TO www;
GRANT ALL ON TABLE categoriepage_id_seq TO PUBLIC;


--
-- TOC entry 9969 (class 0 OID 0)
-- Dependencies: 4223
-- Name: chrono; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE chrono FROM PUBLIC;
REVOKE ALL ON TABLE chrono FROM pgsql;
GRANT ALL ON TABLE chrono TO pgsql;
GRANT ALL ON TABLE chrono TO postgres;
GRANT ALL ON TABLE chrono TO www;
GRANT ALL ON TABLE chrono TO PUBLIC;


--
-- TOC entry 9970 (class 0 OID 0)
-- Dependencies: 4224
-- Name: classe; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE classe FROM PUBLIC;
REVOKE ALL ON TABLE classe FROM pgsql;
GRANT ALL ON TABLE classe TO pgsql;
GRANT ALL ON TABLE classe TO postgres;
GRANT ALL ON TABLE classe TO www;
GRANT ALL ON TABLE classe TO PUBLIC;


--
-- TOC entry 9971 (class 0 OID 0)
-- Dependencies: 4225
-- Name: classe_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE classe_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE classe_id_seq FROM pgsql;
GRANT ALL ON TABLE classe_id_seq TO pgsql;
GRANT ALL ON TABLE classe_id_seq TO postgres;
GRANT ALL ON TABLE classe_id_seq TO www;
GRANT ALL ON TABLE classe_id_seq TO PUBLIC;


--
-- TOC entry 9972 (class 0 OID 0)
-- Dependencies: 4226
-- Name: comment_presentiel; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE comment_presentiel FROM PUBLIC;
REVOKE ALL ON TABLE comment_presentiel FROM pgsql;
GRANT ALL ON TABLE comment_presentiel TO pgsql;
GRANT ALL ON TABLE comment_presentiel TO postgres;
GRANT ALL ON TABLE comment_presentiel TO www;
GRANT ALL ON TABLE comment_presentiel TO PUBLIC;


--
-- TOC entry 9973 (class 0 OID 0)
-- Dependencies: 4227
-- Name: commentaire; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE commentaire FROM PUBLIC;
REVOKE ALL ON TABLE commentaire FROM pgsql;
GRANT ALL ON TABLE commentaire TO pgsql;
GRANT ALL ON TABLE commentaire TO postgres;
GRANT ALL ON TABLE commentaire TO www;
GRANT ALL ON TABLE commentaire TO PUBLIC;


--
-- TOC entry 9974 (class 0 OID 0)
-- Dependencies: 4228
-- Name: commentairepage; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE commentairepage FROM PUBLIC;
REVOKE ALL ON TABLE commentairepage FROM pgsql;
GRANT ALL ON TABLE commentairepage TO pgsql;
GRANT ALL ON TABLE commentairepage TO postgres;
GRANT ALL ON TABLE commentairepage TO www;
GRANT ALL ON TABLE commentairepage TO PUBLIC;


--
-- TOC entry 9975 (class 0 OID 0)
-- Dependencies: 4229
-- Name: commentuserrub; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE commentuserrub FROM PUBLIC;
REVOKE ALL ON TABLE commentuserrub FROM pgsql;
GRANT ALL ON TABLE commentuserrub TO pgsql;
GRANT ALL ON TABLE commentuserrub TO postgres;
GRANT ALL ON TABLE commentuserrub TO www;
GRANT ALL ON TABLE commentuserrub TO PUBLIC;


--
-- TOC entry 9976 (class 0 OID 0)
-- Dependencies: 4230
-- Name: config_grille; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE config_grille FROM PUBLIC;
REVOKE ALL ON TABLE config_grille FROM pgsql;
GRANT ALL ON TABLE config_grille TO pgsql;
GRANT ALL ON TABLE config_grille TO postgres;
GRANT ALL ON TABLE config_grille TO www;
GRANT ALL ON TABLE config_grille TO PUBLIC;


--
-- TOC entry 9977 (class 0 OID 0)
-- Dependencies: 4231
-- Name: config_orientation; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE config_orientation FROM PUBLIC;
REVOKE ALL ON TABLE config_orientation FROM pgsql;
GRANT ALL ON TABLE config_orientation TO pgsql;
GRANT ALL ON TABLE config_orientation TO postgres;
GRANT ALL ON TABLE config_orientation TO www;
GRANT ALL ON TABLE config_orientation TO PUBLIC;


--
-- TOC entry 9978 (class 0 OID 0)
-- Dependencies: 4232
-- Name: config_ressource; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE config_ressource FROM PUBLIC;
REVOKE ALL ON TABLE config_ressource FROM pgsql;
GRANT ALL ON TABLE config_ressource TO pgsql;
GRANT ALL ON TABLE config_ressource TO postgres;
GRANT ALL ON TABLE config_ressource TO www;
GRANT ALL ON TABLE config_ressource TO PUBLIC;


--
-- TOC entry 9979 (class 0 OID 0)
-- Dependencies: 4233
-- Name: configpage; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE configpage FROM PUBLIC;
REVOKE ALL ON TABLE configpage FROM pgsql;
GRANT ALL ON TABLE configpage TO pgsql;
GRANT ALL ON TABLE configpage TO postgres;
GRANT ALL ON TABLE configpage TO www;
GRANT ALL ON TABLE configpage TO PUBLIC;


--
-- TOC entry 9980 (class 0 OID 0)
-- Dependencies: 4234
-- Name: connexion; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE connexion FROM PUBLIC;
REVOKE ALL ON TABLE connexion FROM pgsql;
GRANT ALL ON TABLE connexion TO pgsql;
GRANT ALL ON TABLE connexion TO postgres;
GRANT ALL ON TABLE connexion TO www;
GRANT ALL ON TABLE connexion TO PUBLIC;


--
-- TOC entry 9981 (class 0 OID 0)
-- Dependencies: 4235
-- Name: content; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE content FROM PUBLIC;
REVOKE ALL ON TABLE content FROM pgsql;
GRANT ALL ON TABLE content TO pgsql;
GRANT ALL ON TABLE content TO postgres;
GRANT ALL ON TABLE content TO www;
GRANT ALL ON TABLE content TO PUBLIC;


--
-- TOC entry 9982 (class 0 OID 0)
-- Dependencies: 4236
-- Name: correction_modele; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE correction_modele FROM PUBLIC;
REVOKE ALL ON TABLE correction_modele FROM pgsql;
GRANT ALL ON TABLE correction_modele TO pgsql;
GRANT ALL ON TABLE correction_modele TO postgres;
GRANT ALL ON TABLE correction_modele TO www;
GRANT ALL ON TABLE correction_modele TO PUBLIC;


--
-- TOC entry 9983 (class 0 OID 0)
-- Dependencies: 4237
-- Name: correction_modele_asso; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE correction_modele_asso FROM PUBLIC;
REVOKE ALL ON TABLE correction_modele_asso FROM pgsql;
GRANT ALL ON TABLE correction_modele_asso TO pgsql;
GRANT ALL ON TABLE correction_modele_asso TO postgres;
GRANT ALL ON TABLE correction_modele_asso TO www;
GRANT ALL ON TABLE correction_modele_asso TO PUBLIC;


--
-- TOC entry 9984 (class 0 OID 0)
-- Dependencies: 4238
-- Name: couleur; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE couleur FROM PUBLIC;
REVOKE ALL ON TABLE couleur FROM pgsql;
GRANT ALL ON TABLE couleur TO pgsql;
GRANT ALL ON TABLE couleur TO postgres;
GRANT ALL ON TABLE couleur TO www;
GRANT ALL ON TABLE couleur TO PUBLIC;


--
-- TOC entry 9985 (class 0 OID 0)
-- Dependencies: 4239
-- Name: dates; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE dates FROM PUBLIC;
REVOKE ALL ON TABLE dates FROM pgsql;
GRANT ALL ON TABLE dates TO pgsql;
GRANT ALL ON TABLE dates TO postgres;
GRANT ALL ON TABLE dates TO www;
GRANT ALL ON TABLE dates TO PUBLIC;


--
-- TOC entry 9986 (class 0 OID 0)
-- Dependencies: 4240
-- Name: detail_erreur_num_dt_erreur_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE detail_erreur_num_dt_erreur_seq FROM PUBLIC;
REVOKE ALL ON TABLE detail_erreur_num_dt_erreur_seq FROM pgsql;
GRANT ALL ON TABLE detail_erreur_num_dt_erreur_seq TO pgsql;
GRANT ALL ON TABLE detail_erreur_num_dt_erreur_seq TO postgres;
GRANT ALL ON TABLE detail_erreur_num_dt_erreur_seq TO www;
GRANT ALL ON TABLE detail_erreur_num_dt_erreur_seq TO PUBLIC;


--
-- TOC entry 9987 (class 0 OID 0)
-- Dependencies: 4241
-- Name: droit; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE droit FROM PUBLIC;
REVOKE ALL ON TABLE droit FROM pgsql;
GRANT ALL ON TABLE droit TO pgsql;
GRANT ALL ON TABLE droit TO postgres;
GRANT ALL ON TABLE droit TO www;
GRANT ALL ON TABLE droit TO PUBLIC;


--
-- TOC entry 9988 (class 0 OID 0)
-- Dependencies: 4242
-- Name: elaborqstn; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE elaborqstn FROM PUBLIC;
REVOKE ALL ON TABLE elaborqstn FROM pgsql;
GRANT ALL ON TABLE elaborqstn TO pgsql;
GRANT ALL ON TABLE elaborqstn TO postgres;
GRANT ALL ON TABLE elaborqstn TO www;
GRANT ALL ON TABLE elaborqstn TO PUBLIC;


--
-- TOC entry 9989 (class 0 OID 0)
-- Dependencies: 4243
-- Name: elaborqstn_aleatoire; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE elaborqstn_aleatoire FROM PUBLIC;
REVOKE ALL ON TABLE elaborqstn_aleatoire FROM pgsql;
GRANT ALL ON TABLE elaborqstn_aleatoire TO pgsql;
GRANT ALL ON TABLE elaborqstn_aleatoire TO postgres;
GRANT ALL ON TABLE elaborqstn_aleatoire TO www;
GRANT ALL ON TABLE elaborqstn_aleatoire TO PUBLIC;


--
-- TOC entry 9990 (class 0 OID 0)
-- Dependencies: 4244
-- Name: erreur_num_erreur_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE erreur_num_erreur_seq FROM PUBLIC;
REVOKE ALL ON TABLE erreur_num_erreur_seq FROM pgsql;
GRANT ALL ON TABLE erreur_num_erreur_seq TO pgsql;
GRANT ALL ON TABLE erreur_num_erreur_seq TO postgres;
GRANT ALL ON TABLE erreur_num_erreur_seq TO www;
GRANT ALL ON TABLE erreur_num_erreur_seq TO PUBLIC;


--
-- TOC entry 9991 (class 0 OID 0)
-- Dependencies: 4245
-- Name: exotlc; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE exotlc FROM PUBLIC;
REVOKE ALL ON TABLE exotlc FROM pgsql;
GRANT ALL ON TABLE exotlc TO pgsql;
GRANT ALL ON TABLE exotlc TO postgres;
GRANT ALL ON TABLE exotlc TO www;
GRANT ALL ON TABLE exotlc TO PUBLIC;


--
-- TOC entry 9992 (class 0 OID 0)
-- Dependencies: 4246
-- Name: ficmediaqcm; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ficmediaqcm FROM PUBLIC;
REVOKE ALL ON TABLE ficmediaqcm FROM pgsql;
GRANT ALL ON TABLE ficmediaqcm TO pgsql;
GRANT ALL ON TABLE ficmediaqcm TO postgres;
GRANT ALL ON TABLE ficmediaqcm TO www;
GRANT ALL ON TABLE ficmediaqcm TO PUBLIC;


--
-- TOC entry 9993 (class 0 OID 0)
-- Dependencies: 4247
-- Name: ficmediatlc; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ficmediatlc FROM PUBLIC;
REVOKE ALL ON TABLE ficmediatlc FROM pgsql;
GRANT ALL ON TABLE ficmediatlc TO pgsql;
GRANT ALL ON TABLE ficmediatlc TO postgres;
GRANT ALL ON TABLE ficmediatlc TO www;
GRANT ALL ON TABLE ficmediatlc TO PUBLIC;


--
-- TOC entry 9994 (class 0 OID 0)
-- Dependencies: 4248
-- Name: fictlc; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE fictlc FROM PUBLIC;
REVOKE ALL ON TABLE fictlc FROM pgsql;
GRANT ALL ON TABLE fictlc TO pgsql;
GRANT ALL ON TABLE fictlc TO postgres;
GRANT ALL ON TABLE fictlc TO www;
GRANT ALL ON TABLE fictlc TO PUBLIC;


--
-- TOC entry 9995 (class 0 OID 0)
-- Dependencies: 4249
-- Name: filiere; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE filiere FROM PUBLIC;
REVOKE ALL ON TABLE filiere FROM pgsql;
GRANT ALL ON TABLE filiere TO pgsql;
GRANT ALL ON TABLE filiere TO postgres;
GRANT ALL ON TABLE filiere TO www;
GRANT ALL ON TABLE filiere TO PUBLIC;


--
-- TOC entry 9996 (class 0 OID 0)
-- Dependencies: 4250
-- Name: filiere_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE filiere_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE filiere_id_seq FROM pgsql;
GRANT ALL ON TABLE filiere_id_seq TO pgsql;
GRANT ALL ON TABLE filiere_id_seq TO postgres;
GRANT ALL ON TABLE filiere_id_seq TO www;
GRANT ALL ON TABLE filiere_id_seq TO PUBLIC;


--
-- TOC entry 9997 (class 0 OID 0)
-- Dependencies: 4251
-- Name: formatpage; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE formatpage FROM PUBLIC;
REVOKE ALL ON TABLE formatpage FROM pgsql;
GRANT ALL ON TABLE formatpage TO pgsql;
GRANT ALL ON TABLE formatpage TO postgres;
GRANT ALL ON TABLE formatpage TO www;
GRANT ALL ON TABLE formatpage TO PUBLIC;


--
-- TOC entry 9998 (class 0 OID 0)
-- Dependencies: 4252
-- Name: gest_cal; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gest_cal FROM PUBLIC;
REVOKE ALL ON TABLE gest_cal FROM pgsql;
GRANT ALL ON TABLE gest_cal TO pgsql;
GRANT ALL ON TABLE gest_cal TO postgres;
GRANT ALL ON TABLE gest_cal TO www;
GRANT ALL ON TABLE gest_cal TO PUBLIC;


--
-- TOC entry 9999 (class 0 OID 0)
-- Dependencies: 4253
-- Name: gest_ftb; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gest_ftb FROM PUBLIC;
REVOKE ALL ON TABLE gest_ftb FROM pgsql;
GRANT ALL ON TABLE gest_ftb TO pgsql;
GRANT ALL ON TABLE gest_ftb TO postgres;
GRANT ALL ON TABLE gest_ftb TO www;
GRANT ALL ON TABLE gest_ftb TO PUBLIC;


--
-- TOC entry 10000 (class 0 OID 0)
-- Dependencies: 4254
-- Name: gest_ftb_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gest_ftb_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE gest_ftb_id_seq FROM pgsql;
GRANT ALL ON TABLE gest_ftb_id_seq TO pgsql;
GRANT ALL ON TABLE gest_ftb_id_seq TO postgres;
GRANT ALL ON TABLE gest_ftb_id_seq TO www;
GRANT ALL ON TABLE gest_ftb_id_seq TO PUBLIC;


--
-- TOC entry 10001 (class 0 OID 0)
-- Dependencies: 4255
-- Name: gestexotlc; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestexotlc FROM PUBLIC;
REVOKE ALL ON TABLE gestexotlc FROM pgsql;
GRANT ALL ON TABLE gestexotlc TO pgsql;
GRANT ALL ON TABLE gestexotlc TO postgres;
GRANT ALL ON TABLE gestexotlc TO www;
GRANT ALL ON TABLE gestexotlc TO PUBLIC;


--
-- TOC entry 10002 (class 0 OID 0)
-- Dependencies: 4256
-- Name: gestfic; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestfic FROM PUBLIC;
REVOKE ALL ON TABLE gestfic FROM pgsql;
GRANT ALL ON TABLE gestfic TO pgsql;
GRANT ALL ON TABLE gestfic TO postgres;
GRANT ALL ON TABLE gestfic TO www;
GRANT ALL ON TABLE gestfic TO PUBLIC;


--
-- TOC entry 10003 (class 0 OID 0)
-- Dependencies: 4257
-- Name: gestforum; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestforum FROM PUBLIC;
REVOKE ALL ON TABLE gestforum FROM pgsql;
GRANT ALL ON TABLE gestforum TO pgsql;
GRANT ALL ON TABLE gestforum TO postgres;
GRANT ALL ON TABLE gestforum TO www;
GRANT ALL ON TABLE gestforum TO PUBLIC;


--
-- TOC entry 10004 (class 0 OID 0)
-- Dependencies: 4258
-- Name: gestionnaire; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestionnaire FROM PUBLIC;
REVOKE ALL ON TABLE gestionnaire FROM pgsql;
GRANT ALL ON TABLE gestionnaire TO pgsql;
GRANT ALL ON TABLE gestionnaire TO postgres;
GRANT ALL ON TABLE gestionnaire TO www;
GRANT ALL ON TABLE gestionnaire TO PUBLIC;


--
-- TOC entry 10005 (class 0 OID 0)
-- Dependencies: 4259
-- Name: gestionparcours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestionparcours FROM PUBLIC;
REVOKE ALL ON TABLE gestionparcours FROM pgsql;
GRANT ALL ON TABLE gestionparcours TO pgsql;
GRANT ALL ON TABLE gestionparcours TO postgres;
GRANT ALL ON TABLE gestionparcours TO www;
GRANT ALL ON TABLE gestionparcours TO PUBLIC;


--
-- TOC entry 10006 (class 0 OID 0)
-- Dependencies: 4260
-- Name: gestionqst; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestionqst FROM PUBLIC;
REVOKE ALL ON TABLE gestionqst FROM pgsql;
GRANT ALL ON TABLE gestionqst TO pgsql;
GRANT ALL ON TABLE gestionqst TO postgres;
GRANT ALL ON TABLE gestionqst TO www;
GRANT ALL ON TABLE gestionqst TO PUBLIC;


--
-- TOC entry 10007 (class 0 OID 0)
-- Dependencies: 4261
-- Name: gestionqstn; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestionqstn FROM PUBLIC;
REVOKE ALL ON TABLE gestionqstn FROM pgsql;
GRANT ALL ON TABLE gestionqstn TO pgsql;
GRANT ALL ON TABLE gestionqstn TO postgres;
GRANT ALL ON TABLE gestionqstn TO www;
GRANT ALL ON TABLE gestionqstn TO PUBLIC;


--
-- TOC entry 10008 (class 0 OID 0)
-- Dependencies: 4262
-- Name: gestionutil; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestionutil FROM PUBLIC;
REVOKE ALL ON TABLE gestionutil FROM pgsql;
GRANT ALL ON TABLE gestionutil TO pgsql;
GRANT ALL ON TABLE gestionutil TO postgres;
GRANT ALL ON TABLE gestionutil TO www;
GRANT ALL ON TABLE gestionutil TO PUBLIC;


--
-- TOC entry 10009 (class 0 OID 0)
-- Dependencies: 4263
-- Name: gestparcours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestparcours FROM PUBLIC;
REVOKE ALL ON TABLE gestparcours FROM pgsql;
GRANT ALL ON TABLE gestparcours TO pgsql;
GRANT ALL ON TABLE gestparcours TO postgres;
GRANT ALL ON TABLE gestparcours TO www;
GRANT ALL ON TABLE gestparcours TO PUBLIC;


--
-- TOC entry 10010 (class 0 OID 0)
-- Dependencies: 4264
-- Name: gestqcm; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestqcm FROM PUBLIC;
REVOKE ALL ON TABLE gestqcm FROM pgsql;
GRANT ALL ON TABLE gestqcm TO pgsql;
GRANT ALL ON TABLE gestqcm TO postgres;
GRANT ALL ON TABLE gestqcm TO www;
GRANT ALL ON TABLE gestqcm TO PUBLIC;


--
-- TOC entry 10011 (class 0 OID 0)
-- Dependencies: 4265
-- Name: gestserie; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE gestserie FROM PUBLIC;
REVOKE ALL ON TABLE gestserie FROM pgsql;
GRANT ALL ON TABLE gestserie TO pgsql;
GRANT ALL ON TABLE gestserie TO postgres;
GRANT ALL ON TABLE gestserie TO www;
GRANT ALL ON TABLE gestserie TO PUBLIC;


--
-- TOC entry 10012 (class 0 OID 0)
-- Dependencies: 4266
-- Name: grille; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE grille FROM PUBLIC;
REVOKE ALL ON TABLE grille FROM pgsql;
GRANT ALL ON TABLE grille TO pgsql;
GRANT ALL ON TABLE grille TO postgres;
GRANT ALL ON TABLE grille TO www;
GRANT ALL ON TABLE grille TO PUBLIC;


--
-- TOC entry 10013 (class 0 OID 0)
-- Dependencies: 4267
-- Name: grilletitrecapa; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE grilletitrecapa FROM PUBLIC;
REVOKE ALL ON TABLE grilletitrecapa FROM pgsql;
GRANT ALL ON TABLE grilletitrecapa TO pgsql;
GRANT ALL ON TABLE grilletitrecapa TO postgres;
GRANT ALL ON TABLE grilletitrecapa TO www;
GRANT ALL ON TABLE grilletitrecapa TO PUBLIC;


--
-- TOC entry 10014 (class 0 OID 0)
-- Dependencies: 4268
-- Name: individu_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE individu_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE individu_id_seq FROM pgsql;
GRANT ALL ON TABLE individu_id_seq TO pgsql;
GRANT ALL ON TABLE individu_id_seq TO "grp-www";
GRANT ALL ON TABLE individu_id_seq TO PUBLIC;


--
-- TOC entry 10015 (class 0 OID 0)
-- Dependencies: 4269
-- Name: intervention; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE intervention FROM PUBLIC;
REVOKE ALL ON TABLE intervention FROM pgsql;
GRANT ALL ON TABLE intervention TO pgsql;
GRANT ALL ON TABLE intervention TO postgres;
GRANT ALL ON TABLE intervention TO www;
GRANT ALL ON TABLE intervention TO PUBLIC;


--
-- TOC entry 10016 (class 0 OID 0)
-- Dependencies: 4270
-- Name: intervention_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE intervention_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE intervention_id_seq FROM pgsql;
GRANT ALL ON TABLE intervention_id_seq TO pgsql;
GRANT ALL ON TABLE intervention_id_seq TO postgres;
GRANT ALL ON TABLE intervention_id_seq TO www;
GRANT ALL ON TABLE intervention_id_seq TO PUBLIC;


--
-- TOC entry 10017 (class 0 OID 0)
-- Dependencies: 4272
-- Name: liste_test; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE liste_test FROM PUBLIC;
REVOKE ALL ON TABLE liste_test FROM pgsql;
GRANT ALL ON TABLE liste_test TO pgsql;
GRANT ALL ON TABLE liste_test TO postgres;
GRANT ALL ON TABLE liste_test TO www;
GRANT ALL ON TABLE liste_test TO PUBLIC;


--
-- TOC entry 10018 (class 0 OID 0)
-- Dependencies: 4273
-- Name: liste_test_id_liste_test_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE liste_test_id_liste_test_seq FROM PUBLIC;
REVOKE ALL ON TABLE liste_test_id_liste_test_seq FROM pgsql;
GRANT ALL ON TABLE liste_test_id_liste_test_seq TO pgsql;
GRANT ALL ON TABLE liste_test_id_liste_test_seq TO postgres;
GRANT ALL ON TABLE liste_test_id_liste_test_seq TO www;
GRANT ALL ON TABLE liste_test_id_liste_test_seq TO PUBLIC;


--
-- TOC entry 10019 (class 0 OID 0)
-- Dependencies: 4274
-- Name: log_display; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE log_display FROM PUBLIC;
REVOKE ALL ON TABLE log_display FROM pgsql;
GRANT ALL ON TABLE log_display TO pgsql;
GRANT ALL ON TABLE log_display TO postgres;
GRANT ALL ON TABLE log_display TO www;
GRANT ALL ON TABLE log_display TO PUBLIC;


--
-- TOC entry 10020 (class 0 OID 0)
-- Dependencies: 4275
-- Name: maxi; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE maxi FROM PUBLIC;
REVOKE ALL ON TABLE maxi FROM pgsql;
GRANT ALL ON TABLE maxi TO pgsql;
GRANT ALL ON TABLE maxi TO PUBLIC;


--
-- TOC entry 10021 (class 0 OID 0)
-- Dependencies: 4278
-- Name: niveau_exo; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE niveau_exo FROM PUBLIC;
REVOKE ALL ON TABLE niveau_exo FROM pgsql;
GRANT ALL ON TABLE niveau_exo TO pgsql;
GRANT ALL ON TABLE niveau_exo TO postgres;
GRANT ALL ON TABLE niveau_exo TO www;
GRANT ALL ON TABLE niveau_exo TO PUBLIC;


--
-- TOC entry 10022 (class 0 OID 0)
-- Dependencies: 4279
-- Name: notation; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE notation FROM PUBLIC;
REVOKE ALL ON TABLE notation FROM pgsql;
GRANT ALL ON TABLE notation TO pgsql;
GRANT ALL ON TABLE notation TO postgres;
GRANT ALL ON TABLE notation TO www;
GRANT ALL ON TABLE notation TO PUBLIC;


--
-- TOC entry 10023 (class 0 OID 0)
-- Dependencies: 4280
-- Name: organisme; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE organisme FROM PUBLIC;
REVOKE ALL ON TABLE organisme FROM pgsql;
GRANT ALL ON TABLE organisme TO pgsql;
GRANT ALL ON TABLE organisme TO postgres;
GRANT ALL ON TABLE organisme TO www;
GRANT ALL ON TABLE organisme TO PUBLIC;


--
-- TOC entry 10024 (class 0 OID 0)
-- Dependencies: 4281
-- Name: page; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE page FROM PUBLIC;
REVOKE ALL ON TABLE page FROM pgsql;
GRANT ALL ON TABLE page TO pgsql;
GRANT ALL ON TABLE page TO postgres;
GRANT ALL ON TABLE page TO www;
GRANT ALL ON TABLE page TO PUBLIC;


--
-- TOC entry 10025 (class 0 OID 0)
-- Dependencies: 4282
-- Name: page_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE page_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE page_id_seq FROM pgsql;
GRANT ALL ON TABLE page_id_seq TO pgsql;
GRANT ALL ON TABLE page_id_seq TO www;
GRANT ALL ON TABLE page_id_seq TO PUBLIC;


--
-- TOC entry 10026 (class 0 OID 0)
-- Dependencies: 4283
-- Name: parcours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE parcours FROM PUBLIC;
REVOKE ALL ON TABLE parcours FROM pgsql;
GRANT ALL ON TABLE parcours TO pgsql;
GRANT ALL ON TABLE parcours TO postgres;
GRANT ALL ON TABLE parcours TO www;
GRANT ALL ON TABLE parcours TO PUBLIC;


--
-- TOC entry 10027 (class 0 OID 0)
-- Dependencies: 4284
-- Name: pga_diagrams; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE pga_diagrams FROM PUBLIC;
REVOKE ALL ON TABLE pga_diagrams FROM pgsql;
GRANT ALL ON TABLE pga_diagrams TO pgsql;
GRANT ALL ON TABLE pga_diagrams TO PUBLIC;


--
-- TOC entry 10028 (class 0 OID 0)
-- Dependencies: 4285
-- Name: pga_forms; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE pga_forms FROM PUBLIC;
REVOKE ALL ON TABLE pga_forms FROM pgsql;
GRANT ALL ON TABLE pga_forms TO pgsql;
GRANT ALL ON TABLE pga_forms TO postgres;
GRANT ALL ON TABLE pga_forms TO www;
GRANT ALL ON TABLE pga_forms TO PUBLIC;


--
-- TOC entry 10029 (class 0 OID 0)
-- Dependencies: 4286
-- Name: pga_graphs; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE pga_graphs FROM PUBLIC;
REVOKE ALL ON TABLE pga_graphs FROM pgsql;
GRANT ALL ON TABLE pga_graphs TO pgsql;
GRANT ALL ON TABLE pga_graphs TO PUBLIC;


--
-- TOC entry 10030 (class 0 OID 0)
-- Dependencies: 4287
-- Name: pga_images; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE pga_images FROM PUBLIC;
REVOKE ALL ON TABLE pga_images FROM pgsql;
GRANT ALL ON TABLE pga_images TO pgsql;
GRANT ALL ON TABLE pga_images TO PUBLIC;


--
-- TOC entry 10031 (class 0 OID 0)
-- Dependencies: 4288
-- Name: pga_layout; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE pga_layout FROM PUBLIC;
REVOKE ALL ON TABLE pga_layout FROM pgsql;
GRANT ALL ON TABLE pga_layout TO pgsql;
GRANT ALL ON TABLE pga_layout TO postgres;
GRANT ALL ON TABLE pga_layout TO www;
GRANT ALL ON TABLE pga_layout TO PUBLIC;


--
-- TOC entry 10032 (class 0 OID 0)
-- Dependencies: 4289
-- Name: pga_queries; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE pga_queries FROM PUBLIC;
REVOKE ALL ON TABLE pga_queries FROM pgsql;
GRANT ALL ON TABLE pga_queries TO pgsql;
GRANT ALL ON TABLE pga_queries TO postgres;
GRANT ALL ON TABLE pga_queries TO www;
GRANT ALL ON TABLE pga_queries TO PUBLIC;


--
-- TOC entry 10033 (class 0 OID 0)
-- Dependencies: 4290
-- Name: pga_reports; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE pga_reports FROM PUBLIC;
REVOKE ALL ON TABLE pga_reports FROM pgsql;
GRANT ALL ON TABLE pga_reports TO pgsql;
GRANT ALL ON TABLE pga_reports TO postgres;
GRANT ALL ON TABLE pga_reports TO www;
GRANT ALL ON TABLE pga_reports TO PUBLIC;


--
-- TOC entry 10034 (class 0 OID 0)
-- Dependencies: 4291
-- Name: pga_schema; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE pga_schema FROM PUBLIC;
REVOKE ALL ON TABLE pga_schema FROM pgsql;
GRANT ALL ON TABLE pga_schema TO pgsql;
GRANT ALL ON TABLE pga_schema TO postgres;
GRANT ALL ON TABLE pga_schema TO PUBLIC;


--
-- TOC entry 10035 (class 0 OID 0)
-- Dependencies: 4292
-- Name: pga_scripts; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE pga_scripts FROM PUBLIC;
REVOKE ALL ON TABLE pga_scripts FROM pgsql;
GRANT ALL ON TABLE pga_scripts TO pgsql;
GRANT ALL ON TABLE pga_scripts TO postgres;
GRANT ALL ON TABLE pga_scripts TO www;
GRANT ALL ON TABLE pga_scripts TO PUBLIC;


--
-- TOC entry 10036 (class 0 OID 0)
-- Dependencies: 4293
-- Name: placegroupe; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE placegroupe FROM PUBLIC;
REVOKE ALL ON TABLE placegroupe FROM pgsql;
GRANT ALL ON TABLE placegroupe TO pgsql;
GRANT ALL ON TABLE placegroupe TO postgres;
GRANT ALL ON TABLE placegroupe TO www;
GRANT ALL ON TABLE placegroupe TO PUBLIC;


--
-- TOC entry 10037 (class 0 OID 0)
-- Dependencies: 4294
-- Name: proposition; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE proposition FROM PUBLIC;
REVOKE ALL ON TABLE proposition FROM pgsql;
GRANT ALL ON TABLE proposition TO pgsql;
GRANT ALL ON TABLE proposition TO www;
GRANT ALL ON TABLE proposition TO PUBLIC;


--
-- TOC entry 10038 (class 0 OID 0)
-- Dependencies: 4295
-- Name: proposition_sondage; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE proposition_sondage FROM PUBLIC;
REVOKE ALL ON TABLE proposition_sondage FROM pgsql;
GRANT ALL ON TABLE proposition_sondage TO pgsql;
GRANT ALL ON TABLE proposition_sondage TO postgres;
GRANT ALL ON TABLE proposition_sondage TO www;
GRANT ALL ON TABLE proposition_sondage TO PUBLIC;


--
-- TOC entry 10039 (class 0 OID 0)
-- Dependencies: 4296
-- Name: qcm_aleatoire; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE qcm_aleatoire FROM PUBLIC;
REVOKE ALL ON TABLE qcm_aleatoire FROM pgsql;
GRANT ALL ON TABLE qcm_aleatoire TO pgsql;
GRANT ALL ON TABLE qcm_aleatoire TO postgres;
GRANT ALL ON TABLE qcm_aleatoire TO www;
GRANT ALL ON TABLE qcm_aleatoire TO PUBLIC;


--
-- TOC entry 10040 (class 0 OID 0)
-- Dependencies: 4297
-- Name: qcm_bloquant; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE qcm_bloquant FROM PUBLIC;
REVOKE ALL ON TABLE qcm_bloquant FROM pgsql;
GRANT ALL ON TABLE qcm_bloquant TO pgsql;
GRANT ALL ON TABLE qcm_bloquant TO postgres;
GRANT ALL ON TABLE qcm_bloquant TO www;
GRANT ALL ON TABLE qcm_bloquant TO PUBLIC;


--
-- TOC entry 10041 (class 0 OID 0)
-- Dependencies: 4298
-- Name: quest_rep; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE quest_rep FROM PUBLIC;
REVOKE ALL ON TABLE quest_rep FROM pgsql;
GRANT ALL ON TABLE quest_rep TO pgsql;
GRANT ALL ON TABLE quest_rep TO postgres;
GRANT ALL ON TABLE quest_rep TO www;
GRANT ALL ON TABLE quest_rep TO PUBLIC;


--
-- TOC entry 10042 (class 0 OID 0)
-- Dependencies: 4299
-- Name: question; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE question FROM PUBLIC;
REVOKE ALL ON TABLE question FROM pgsql;
GRANT ALL ON TABLE question TO pgsql;
GRANT ALL ON TABLE question TO postgres;
GRANT ALL ON TABLE question TO www;
GRANT ALL ON TABLE question TO PUBLIC;


--
-- TOC entry 10043 (class 0 OID 0)
-- Dependencies: 4300
-- Name: question_sondage; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE question_sondage FROM PUBLIC;
REVOKE ALL ON TABLE question_sondage FROM pgsql;
GRANT ALL ON TABLE question_sondage TO pgsql;
GRANT ALL ON TABLE question_sondage TO postgres;
GRANT ALL ON TABLE question_sondage TO www;
GRANT ALL ON TABLE question_sondage TO PUBLIC;


--
-- TOC entry 10044 (class 0 OID 0)
-- Dependencies: 4301
-- Name: question_sondage_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE question_sondage_seq FROM PUBLIC;
REVOKE ALL ON TABLE question_sondage_seq FROM pgsql;
GRANT ALL ON TABLE question_sondage_seq TO pgsql;
GRANT ALL ON TABLE question_sondage_seq TO postgres;
GRANT ALL ON TABLE question_sondage_seq TO www;
GRANT ALL ON TABLE question_sondage_seq TO PUBLIC;


--
-- TOC entry 10045 (class 0 OID 0)
-- Dependencies: 4302
-- Name: questionnaire; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE questionnaire FROM PUBLIC;
REVOKE ALL ON TABLE questionnaire FROM pgsql;
GRANT ALL ON TABLE questionnaire TO pgsql;
GRANT ALL ON TABLE questionnaire TO postgres;
GRANT ALL ON TABLE questionnaire TO www;
GRANT ALL ON TABLE questionnaire TO PUBLIC;


--
-- TOC entry 10046 (class 0 OID 0)
-- Dependencies: 4303
-- Name: rec; Type: ACL; Schema: public; Owner: postgres
--

REVOKE ALL ON TABLE rec FROM PUBLIC;
REVOKE ALL ON TABLE rec FROM postgres;
GRANT ALL ON TABLE rec TO postgres;
GRANT ALL ON TABLE rec TO PUBLIC;


--
-- TOC entry 10047 (class 0 OID 0)
-- Dependencies: 4304
-- Name: reception_exostlc; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE reception_exostlc FROM PUBLIC;
REVOKE ALL ON TABLE reception_exostlc FROM pgsql;
GRANT ALL ON TABLE reception_exostlc TO pgsql;
GRANT ALL ON TABLE reception_exostlc TO postgres;
GRANT ALL ON TABLE reception_exostlc TO www;
GRANT ALL ON TABLE reception_exostlc TO PUBLIC;


--
-- TOC entry 10048 (class 0 OID 0)
-- Dependencies: 4305
-- Name: reponse; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE reponse FROM PUBLIC;
REVOKE ALL ON TABLE reponse FROM pgsql;
GRANT ALL ON TABLE reponse TO pgsql;
GRANT ALL ON TABLE reponse TO postgres;
GRANT ALL ON TABLE reponse TO www;
GRANT ALL ON TABLE reponse TO PUBLIC;


--
-- TOC entry 10049 (class 0 OID 0)
-- Dependencies: 4306
-- Name: res_liste; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE res_liste FROM PUBLIC;
REVOKE ALL ON TABLE res_liste FROM pgsql;
GRANT ALL ON TABLE res_liste TO pgsql;
GRANT ALL ON TABLE res_liste TO postgres;
GRANT ALL ON TABLE res_liste TO www;
GRANT ALL ON TABLE res_liste TO PUBLIC;


--
-- TOC entry 10050 (class 0 OID 0)
-- Dependencies: 4307
-- Name: res_liste_test; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE res_liste_test FROM PUBLIC;
REVOKE ALL ON TABLE res_liste_test FROM pgsql;
GRANT ALL ON TABLE res_liste_test TO pgsql;
GRANT ALL ON TABLE res_liste_test TO postgres;
GRANT ALL ON TABLE res_liste_test TO www;
GRANT ALL ON TABLE res_liste_test TO PUBLIC;


--
-- TOC entry 10051 (class 0 OID 0)
-- Dependencies: 4308
-- Name: res_serie; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE res_serie FROM PUBLIC;
REVOKE ALL ON TABLE res_serie FROM pgsql;
GRANT ALL ON TABLE res_serie TO pgsql;
GRANT ALL ON TABLE res_serie TO postgres;
GRANT ALL ON TABLE res_serie TO www;
GRANT ALL ON TABLE res_serie TO PUBLIC;


--
-- TOC entry 10052 (class 0 OID 0)
-- Dependencies: 4309
-- Name: res_serie_exo; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE res_serie_exo FROM PUBLIC;
REVOKE ALL ON TABLE res_serie_exo FROM pgsql;
GRANT ALL ON TABLE res_serie_exo TO pgsql;
GRANT ALL ON TABLE res_serie_exo TO postgres;
GRANT ALL ON TABLE res_serie_exo TO www;
GRANT ALL ON TABLE res_serie_exo TO PUBLIC;


--
-- TOC entry 10053 (class 0 OID 0)
-- Dependencies: 4310
-- Name: resexouser; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE resexouser FROM PUBLIC;
REVOKE ALL ON TABLE resexouser FROM pgsql;
GRANT ALL ON TABLE resexouser TO pgsql;
GRANT ALL ON TABLE resexouser TO postgres;
GRANT ALL ON TABLE resexouser TO www;
GRANT ALL ON TABLE resexouser TO PUBLIC;


--
-- TOC entry 10054 (class 0 OID 0)
-- Dependencies: 4311
-- Name: ressource; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ressource FROM PUBLIC;
REVOKE ALL ON TABLE ressource FROM pgsql;
GRANT ALL ON TABLE ressource TO pgsql;
GRANT ALL ON TABLE ressource TO postgres;
GRANT ALL ON TABLE ressource TO www;
GRANT ALL ON TABLE ressource TO PUBLIC;


--
-- TOC entry 10055 (class 0 OID 0)
-- Dependencies: 4312
-- Name: ressource_esp; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ressource_esp FROM PUBLIC;
REVOKE ALL ON TABLE ressource_esp FROM pgsql;
GRANT ALL ON TABLE ressource_esp TO pgsql;
GRANT ALL ON TABLE ressource_esp TO postgres;
GRANT ALL ON TABLE ressource_esp TO www;
GRANT ALL ON TABLE ressource_esp TO PUBLIC;


--
-- TOC entry 10056 (class 0 OID 0)
-- Dependencies: 4313
-- Name: ressource_fic; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ressource_fic FROM PUBLIC;
REVOKE ALL ON TABLE ressource_fic FROM pgsql;
GRANT ALL ON TABLE ressource_fic TO pgsql;
GRANT ALL ON TABLE ressource_fic TO postgres;
GRANT ALL ON TABLE ressource_fic TO www;
GRANT ALL ON TABLE ressource_fic TO PUBLIC;


--
-- TOC entry 10057 (class 0 OID 0)
-- Dependencies: 4314
-- Name: ressource_gest; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ressource_gest FROM PUBLIC;
REVOKE ALL ON TABLE ressource_gest FROM pgsql;
GRANT ALL ON TABLE ressource_gest TO pgsql;
GRANT ALL ON TABLE ressource_gest TO postgres;
GRANT ALL ON TABLE ressource_gest TO www;
GRANT ALL ON TABLE ressource_gest TO PUBLIC;


--
-- TOC entry 10058 (class 0 OID 0)
-- Dependencies: 4315
-- Name: ressource_sec; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ressource_sec FROM PUBLIC;
REVOKE ALL ON TABLE ressource_sec FROM pgsql;
GRANT ALL ON TABLE ressource_sec TO pgsql;
GRANT ALL ON TABLE ressource_sec TO postgres;
GRANT ALL ON TABLE ressource_sec TO www;
GRANT ALL ON TABLE ressource_sec TO PUBLIC;


--
-- TOC entry 10059 (class 0 OID 0)
-- Dependencies: 4316
-- Name: ressource_txt; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ressource_txt FROM PUBLIC;
REVOKE ALL ON TABLE ressource_txt FROM pgsql;
GRANT ALL ON TABLE ressource_txt TO pgsql;
GRANT ALL ON TABLE ressource_txt TO postgres;
GRANT ALL ON TABLE ressource_txt TO www;
GRANT ALL ON TABLE ressource_txt TO PUBLIC;


--
-- TOC entry 10060 (class 0 OID 0)
-- Dependencies: 4317
-- Name: ressource_txt_num_text_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ressource_txt_num_text_seq FROM PUBLIC;
REVOKE ALL ON TABLE ressource_txt_num_text_seq FROM pgsql;
GRANT ALL ON TABLE ressource_txt_num_text_seq TO pgsql;
GRANT ALL ON TABLE ressource_txt_num_text_seq TO postgres;
GRANT ALL ON TABLE ressource_txt_num_text_seq TO www;
GRANT ALL ON TABLE ressource_txt_num_text_seq TO PUBLIC;


--
-- TOC entry 10061 (class 0 OID 0)
-- Dependencies: 4318
-- Name: ressource_txt_num_txt_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE ressource_txt_num_txt_seq FROM PUBLIC;
REVOKE ALL ON TABLE ressource_txt_num_txt_seq FROM pgsql;
GRANT ALL ON TABLE ressource_txt_num_txt_seq TO pgsql;
GRANT ALL ON TABLE ressource_txt_num_txt_seq TO postgres;
GRANT ALL ON TABLE ressource_txt_num_txt_seq TO www;
GRANT ALL ON TABLE ressource_txt_num_txt_seq TO PUBLIC;


--
-- TOC entry 10062 (class 0 OID 0)
-- Dependencies: 4319
-- Name: rubrique; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE rubrique FROM PUBLIC;
REVOKE ALL ON TABLE rubrique FROM pgsql;
GRANT ALL ON TABLE rubrique TO pgsql;
GRANT ALL ON TABLE rubrique TO postgres;
GRANT ALL ON TABLE rubrique TO www;
GRANT ALL ON TABLE rubrique TO PUBLIC;


--
-- TOC entry 10063 (class 0 OID 0)
-- Dependencies: 4320
-- Name: salle; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE salle FROM PUBLIC;
REVOKE ALL ON TABLE salle FROM pgsql;
GRANT ALL ON TABLE salle TO pgsql;
GRANT ALL ON TABLE salle TO postgres;
GRANT ALL ON TABLE salle TO www;
GRANT ALL ON TABLE salle TO PUBLIC;


--
-- TOC entry 10064 (class 0 OID 0)
-- Dependencies: 4321
-- Name: sauvegarde_calendrier; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE sauvegarde_calendrier FROM PUBLIC;
REVOKE ALL ON TABLE sauvegarde_calendrier FROM pgsql;
GRANT ALL ON TABLE sauvegarde_calendrier TO pgsql;
GRANT ALL ON TABLE sauvegarde_calendrier TO postgres;
GRANT ALL ON TABLE sauvegarde_calendrier TO www;
GRANT ALL ON TABLE sauvegarde_calendrier TO PUBLIC;


--
-- TOC entry 10065 (class 0 OID 0)
-- Dependencies: 4322
-- Name: sauvegarde_date; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE sauvegarde_date FROM PUBLIC;
REVOKE ALL ON TABLE sauvegarde_date FROM pgsql;
GRANT ALL ON TABLE sauvegarde_date TO pgsql;
GRANT ALL ON TABLE sauvegarde_date TO postgres;
GRANT ALL ON TABLE sauvegarde_date TO www;
GRANT ALL ON TABLE sauvegarde_date TO PUBLIC;


--
-- TOC entry 10066 (class 0 OID 0)
-- Dependencies: 4323
-- Name: sauvegarde_evaluation; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE sauvegarde_evaluation FROM PUBLIC;
REVOKE ALL ON TABLE sauvegarde_evaluation FROM pgsql;
GRANT ALL ON TABLE sauvegarde_evaluation TO pgsql;
GRANT ALL ON TABLE sauvegarde_evaluation TO postgres;
GRANT ALL ON TABLE sauvegarde_evaluation TO www;
GRANT ALL ON TABLE sauvegarde_evaluation TO PUBLIC;


--
-- TOC entry 10067 (class 0 OID 0)
-- Dependencies: 4324
-- Name: sauvegarde_exorubrique; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE sauvegarde_exorubrique FROM PUBLIC;
REVOKE ALL ON TABLE sauvegarde_exorubrique FROM pgsql;
GRANT ALL ON TABLE sauvegarde_exorubrique TO pgsql;
GRANT ALL ON TABLE sauvegarde_exorubrique TO postgres;
GRANT ALL ON TABLE sauvegarde_exorubrique TO www;
GRANT ALL ON TABLE sauvegarde_exorubrique TO PUBLIC;


--
-- TOC entry 10068 (class 0 OID 0)
-- Dependencies: 4325
-- Name: sauvegarde_presentiel; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE sauvegarde_presentiel FROM PUBLIC;
REVOKE ALL ON TABLE sauvegarde_presentiel FROM pgsql;
GRANT ALL ON TABLE sauvegarde_presentiel TO pgsql;
GRANT ALL ON TABLE sauvegarde_presentiel TO postgres;
GRANT ALL ON TABLE sauvegarde_presentiel TO www;
GRANT ALL ON TABLE sauvegarde_presentiel TO PUBLIC;


--
-- TOC entry 10069 (class 0 OID 0)
-- Dependencies: 4326
-- Name: sauvegarde_resultat; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE sauvegarde_resultat FROM PUBLIC;
REVOKE ALL ON TABLE sauvegarde_resultat FROM pgsql;
GRANT ALL ON TABLE sauvegarde_resultat TO pgsql;
GRANT ALL ON TABLE sauvegarde_resultat TO postgres;
GRANT ALL ON TABLE sauvegarde_resultat TO www;
GRANT ALL ON TABLE sauvegarde_resultat TO PUBLIC;


--
-- TOC entry 10070 (class 0 OID 0)
-- Dependencies: 4327
-- Name: sauvegarde_theme; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE sauvegarde_theme FROM PUBLIC;
REVOKE ALL ON TABLE sauvegarde_theme FROM pgsql;
GRANT ALL ON TABLE sauvegarde_theme TO pgsql;
GRANT ALL ON TABLE sauvegarde_theme TO postgres;
GRANT ALL ON TABLE sauvegarde_theme TO www;
GRANT ALL ON TABLE sauvegarde_theme TO PUBLIC;


--
-- TOC entry 10071 (class 0 OID 0)
-- Dependencies: 4328
-- Name: scorm; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE scorm FROM PUBLIC;
REVOKE ALL ON TABLE scorm FROM pgsql;
GRANT ALL ON TABLE scorm TO pgsql;
GRANT ALL ON TABLE scorm TO postgres;
GRANT ALL ON TABLE scorm TO www;
GRANT ALL ON TABLE scorm TO PUBLIC;


--
-- TOC entry 10072 (class 0 OID 0)
-- Dependencies: 4329
-- Name: scorm_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE scorm_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE scorm_id_seq FROM pgsql;
GRANT ALL ON TABLE scorm_id_seq TO pgsql;
GRANT ALL ON TABLE scorm_id_seq TO postgres;
GRANT ALL ON TABLE scorm_id_seq TO www;
GRANT ALL ON TABLE scorm_id_seq TO PUBLIC;


--
-- TOC entry 10073 (class 0 OID 0)
-- Dependencies: 4330
-- Name: scorm_sco_users; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE scorm_sco_users FROM PUBLIC;
REVOKE ALL ON TABLE scorm_sco_users FROM pgsql;
GRANT ALL ON TABLE scorm_sco_users TO pgsql;
GRANT ALL ON TABLE scorm_sco_users TO postgres;
GRANT ALL ON TABLE scorm_sco_users TO www;
GRANT ALL ON TABLE scorm_sco_users TO PUBLIC;


--
-- TOC entry 10074 (class 0 OID 0)
-- Dependencies: 4331
-- Name: scorm_sco_users_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE scorm_sco_users_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE scorm_sco_users_id_seq FROM pgsql;
GRANT ALL ON TABLE scorm_sco_users_id_seq TO pgsql;
GRANT ALL ON TABLE scorm_sco_users_id_seq TO postgres;
GRANT ALL ON TABLE scorm_sco_users_id_seq TO www;
GRANT ALL ON TABLE scorm_sco_users_id_seq TO PUBLIC;


--
-- TOC entry 10075 (class 0 OID 0)
-- Dependencies: 4332
-- Name: scorm_scoes; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE scorm_scoes FROM PUBLIC;
REVOKE ALL ON TABLE scorm_scoes FROM pgsql;
GRANT ALL ON TABLE scorm_scoes TO pgsql;
GRANT ALL ON TABLE scorm_scoes TO postgres;
GRANT ALL ON TABLE scorm_scoes TO www;
GRANT ALL ON TABLE scorm_scoes TO PUBLIC;


--
-- TOC entry 10076 (class 0 OID 0)
-- Dependencies: 4333
-- Name: scorm_scoes_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE scorm_scoes_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE scorm_scoes_id_seq FROM pgsql;
GRANT ALL ON TABLE scorm_scoes_id_seq TO pgsql;
GRANT ALL ON TABLE scorm_scoes_id_seq TO postgres;
GRANT ALL ON TABLE scorm_scoes_id_seq TO www;
GRANT ALL ON TABLE scorm_scoes_id_seq TO PUBLIC;


--
-- TOC entry 10077 (class 0 OID 0)
-- Dependencies: 4334
-- Name: seq_bareme; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_bareme FROM PUBLIC;
REVOKE ALL ON TABLE seq_bareme FROM pgsql;
GRANT ALL ON TABLE seq_bareme TO pgsql;
GRANT ALL ON TABLE seq_bareme TO postgres;
GRANT ALL ON TABLE seq_bareme TO www;
GRANT ALL ON TABLE seq_bareme TO PUBLIC;


--
-- TOC entry 10078 (class 0 OID 0)
-- Dependencies: 4335
-- Name: seq_calendrier; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_calendrier FROM PUBLIC;
REVOKE ALL ON TABLE seq_calendrier FROM pgsql;
GRANT ALL ON TABLE seq_calendrier TO pgsql;
GRANT ALL ON TABLE seq_calendrier TO postgres;
GRANT ALL ON TABLE seq_calendrier TO www;
GRANT ALL ON TABLE seq_calendrier TO PUBLIC;


--
-- TOC entry 10079 (class 0 OID 0)
-- Dependencies: 4336
-- Name: seq_capacite; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_capacite FROM PUBLIC;
REVOKE ALL ON TABLE seq_capacite FROM pgsql;
GRANT ALL ON TABLE seq_capacite TO pgsql;
GRANT ALL ON TABLE seq_capacite TO postgres;
GRANT ALL ON TABLE seq_capacite TO www;
GRANT ALL ON TABLE seq_capacite TO PUBLIC;


--
-- TOC entry 10080 (class 0 OID 0)
-- Dependencies: 4337
-- Name: seq_categorie; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_categorie FROM PUBLIC;
REVOKE ALL ON TABLE seq_categorie FROM pgsql;
GRANT ALL ON TABLE seq_categorie TO pgsql;
GRANT ALL ON TABLE seq_categorie TO postgres;
GRANT ALL ON TABLE seq_categorie TO www;
GRANT ALL ON TABLE seq_categorie TO PUBLIC;


--
-- TOC entry 10081 (class 0 OID 0)
-- Dependencies: 4338
-- Name: seq_chrono; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_chrono FROM PUBLIC;
REVOKE ALL ON TABLE seq_chrono FROM pgsql;
GRANT ALL ON TABLE seq_chrono TO pgsql;
GRANT ALL ON TABLE seq_chrono TO postgres;
GRANT ALL ON TABLE seq_chrono TO www;
GRANT ALL ON TABLE seq_chrono TO PUBLIC;


--
-- TOC entry 10082 (class 0 OID 0)
-- Dependencies: 4339
-- Name: seq_commentuserrub; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_commentuserrub FROM PUBLIC;
REVOKE ALL ON TABLE seq_commentuserrub FROM pgsql;
GRANT ALL ON TABLE seq_commentuserrub TO pgsql;
GRANT ALL ON TABLE seq_commentuserrub TO postgres;
GRANT ALL ON TABLE seq_commentuserrub TO www;
GRANT ALL ON TABLE seq_commentuserrub TO PUBLIC;


--
-- TOC entry 10083 (class 0 OID 0)
-- Dependencies: 4340
-- Name: seq_content; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_content FROM PUBLIC;
REVOKE ALL ON TABLE seq_content FROM pgsql;
GRANT ALL ON TABLE seq_content TO pgsql;
GRANT ALL ON TABLE seq_content TO postgres;
GRANT ALL ON TABLE seq_content TO www;
GRANT ALL ON TABLE seq_content TO PUBLIC;


--
-- TOC entry 10084 (class 0 OID 0)
-- Dependencies: 4341
-- Name: seq_couleur; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_couleur FROM PUBLIC;
REVOKE ALL ON TABLE seq_couleur FROM pgsql;
GRANT ALL ON TABLE seq_couleur TO pgsql;
GRANT ALL ON TABLE seq_couleur TO postgres;
GRANT ALL ON TABLE seq_couleur TO www;
GRANT ALL ON TABLE seq_couleur TO PUBLIC;


--
-- TOC entry 10085 (class 0 OID 0)
-- Dependencies: 4342
-- Name: seq_cours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_cours FROM PUBLIC;
REVOKE ALL ON TABLE seq_cours FROM pgsql;
GRANT ALL ON TABLE seq_cours TO pgsql;
GRANT ALL ON TABLE seq_cours TO postgres;
GRANT ALL ON TABLE seq_cours TO www;
GRANT ALL ON TABLE seq_cours TO PUBLIC;


--
-- TOC entry 10086 (class 0 OID 0)
-- Dependencies: 4343
-- Name: seq_dates; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_dates FROM PUBLIC;
REVOKE ALL ON TABLE seq_dates FROM pgsql;
GRANT ALL ON TABLE seq_dates TO pgsql;
GRANT ALL ON TABLE seq_dates TO postgres;
GRANT ALL ON TABLE seq_dates TO www;
GRANT ALL ON TABLE seq_dates TO PUBLIC;


--
-- TOC entry 10087 (class 0 OID 0)
-- Dependencies: 4344
-- Name: seq_droit; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_droit FROM PUBLIC;
REVOKE ALL ON TABLE seq_droit FROM pgsql;
GRANT ALL ON TABLE seq_droit TO pgsql;
GRANT ALL ON TABLE seq_droit TO postgres;
GRANT ALL ON TABLE seq_droit TO www;
GRANT ALL ON TABLE seq_droit TO PUBLIC;


--
-- TOC entry 10088 (class 0 OID 0)
-- Dependencies: 4345
-- Name: seq_exotlc; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE seq_exotlc FROM pgsql;
GRANT ALL ON TABLE seq_exotlc TO pgsql;
GRANT ALL ON TABLE seq_exotlc TO postgres;
GRANT ALL ON TABLE seq_exotlc TO www;
GRANT ALL ON TABLE seq_exotlc TO PUBLIC;


--
-- TOC entry 10089 (class 0 OID 0)
-- Dependencies: 4346
-- Name: seq_ficmediaqcm; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_ficmediaqcm FROM PUBLIC;
REVOKE ALL ON TABLE seq_ficmediaqcm FROM pgsql;
GRANT ALL ON TABLE seq_ficmediaqcm TO pgsql;
GRANT ALL ON TABLE seq_ficmediaqcm TO postgres;
GRANT ALL ON TABLE seq_ficmediaqcm TO www;
GRANT ALL ON TABLE seq_ficmediaqcm TO PUBLIC;


--
-- TOC entry 10090 (class 0 OID 0)
-- Dependencies: 4347
-- Name: seq_ficmediatlc; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_ficmediatlc FROM PUBLIC;
REVOKE ALL ON TABLE seq_ficmediatlc FROM pgsql;
GRANT ALL ON TABLE seq_ficmediatlc TO pgsql;
GRANT ALL ON TABLE seq_ficmediatlc TO postgres;
GRANT ALL ON TABLE seq_ficmediatlc TO www;
GRANT ALL ON TABLE seq_ficmediatlc TO PUBLIC;


--
-- TOC entry 10091 (class 0 OID 0)
-- Dependencies: 4348
-- Name: seq_fictlc; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_fictlc FROM PUBLIC;
REVOKE ALL ON TABLE seq_fictlc FROM pgsql;
GRANT ALL ON TABLE seq_fictlc TO pgsql;
GRANT ALL ON TABLE seq_fictlc TO postgres;
GRANT ALL ON TABLE seq_fictlc TO www;
GRANT ALL ON TABLE seq_fictlc TO PUBLIC;


--
-- TOC entry 10092 (class 0 OID 0)
-- Dependencies: 4349
-- Name: seq_gestexotlc; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_gestexotlc FROM PUBLIC;
REVOKE ALL ON TABLE seq_gestexotlc FROM pgsql;
GRANT ALL ON TABLE seq_gestexotlc TO pgsql;
GRANT ALL ON TABLE seq_gestexotlc TO postgres;
GRANT ALL ON TABLE seq_gestexotlc TO www;
GRANT ALL ON TABLE seq_gestexotlc TO PUBLIC;


--
-- TOC entry 10093 (class 0 OID 0)
-- Dependencies: 4350
-- Name: seq_gestioncours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_gestioncours FROM PUBLIC;
REVOKE ALL ON TABLE seq_gestioncours FROM pgsql;
GRANT ALL ON TABLE seq_gestioncours TO pgsql;
GRANT ALL ON TABLE seq_gestioncours TO postgres;
GRANT ALL ON TABLE seq_gestioncours TO www;
GRANT ALL ON TABLE seq_gestioncours TO PUBLIC;


--
-- TOC entry 10094 (class 0 OID 0)
-- Dependencies: 4351
-- Name: seq_gestiongrille; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_gestiongrille FROM PUBLIC;
REVOKE ALL ON TABLE seq_gestiongrille FROM pgsql;
GRANT ALL ON TABLE seq_gestiongrille TO pgsql;
GRANT ALL ON TABLE seq_gestiongrille TO postgres;
GRANT ALL ON TABLE seq_gestiongrille TO www;
GRANT ALL ON TABLE seq_gestiongrille TO PUBLIC;


--
-- TOC entry 10095 (class 0 OID 0)
-- Dependencies: 4352
-- Name: seq_gestiongroupe; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_gestiongroupe FROM PUBLIC;
REVOKE ALL ON TABLE seq_gestiongroupe FROM pgsql;
GRANT ALL ON TABLE seq_gestiongroupe TO pgsql;
GRANT ALL ON TABLE seq_gestiongroupe TO postgres;
GRANT ALL ON TABLE seq_gestiongroupe TO www;
GRANT ALL ON TABLE seq_gestiongroupe TO PUBLIC;


--
-- TOC entry 10096 (class 0 OID 0)
-- Dependencies: 4353
-- Name: seq_grille; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_grille FROM PUBLIC;
REVOKE ALL ON TABLE seq_grille FROM pgsql;
GRANT ALL ON TABLE seq_grille TO pgsql;
GRANT ALL ON TABLE seq_grille TO postgres;
GRANT ALL ON TABLE seq_grille TO www;
GRANT ALL ON TABLE seq_grille TO PUBLIC;


--
-- TOC entry 10097 (class 0 OID 0)
-- Dependencies: 4354
-- Name: seq_grilletitrecapa; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_grilletitrecapa FROM PUBLIC;
REVOKE ALL ON TABLE seq_grilletitrecapa FROM pgsql;
GRANT ALL ON TABLE seq_grilletitrecapa TO pgsql;
GRANT ALL ON TABLE seq_grilletitrecapa TO postgres;
GRANT ALL ON TABLE seq_grilletitrecapa TO www;
GRANT ALL ON TABLE seq_grilletitrecapa TO PUBLIC;


--
-- TOC entry 10098 (class 0 OID 0)
-- Dependencies: 4355
-- Name: seq_groupe; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_groupe FROM PUBLIC;
REVOKE ALL ON TABLE seq_groupe FROM pgsql;
GRANT ALL ON TABLE seq_groupe TO pgsql;
GRANT ALL ON TABLE seq_groupe TO postgres;
GRANT ALL ON TABLE seq_groupe TO www;
GRANT ALL ON TABLE seq_groupe TO PUBLIC;


--
-- TOC entry 10099 (class 0 OID 0)
-- Dependencies: 4356
-- Name: seq_module; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_module FROM PUBLIC;
REVOKE ALL ON TABLE seq_module FROM pgsql;
GRANT ALL ON TABLE seq_module TO pgsql;
GRANT ALL ON TABLE seq_module TO postgres;
GRANT ALL ON TABLE seq_module TO www;
GRANT ALL ON TABLE seq_module TO PUBLIC;


--
-- TOC entry 10100 (class 0 OID 0)
-- Dependencies: 4357
-- Name: seq_notation; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_notation FROM PUBLIC;
REVOKE ALL ON TABLE seq_notation FROM pgsql;
GRANT ALL ON TABLE seq_notation TO pgsql;
GRANT ALL ON TABLE seq_notation TO postgres;
GRANT ALL ON TABLE seq_notation TO www;
GRANT ALL ON TABLE seq_notation TO PUBLIC;


--
-- TOC entry 10101 (class 0 OID 0)
-- Dependencies: 4358
-- Name: seq_organisme; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_organisme FROM PUBLIC;
REVOKE ALL ON TABLE seq_organisme FROM pgsql;
GRANT ALL ON TABLE seq_organisme TO pgsql;
GRANT ALL ON TABLE seq_organisme TO postgres;
GRANT ALL ON TABLE seq_organisme TO www;
GRANT ALL ON TABLE seq_organisme TO PUBLIC;


--
-- TOC entry 10102 (class 0 OID 0)
-- Dependencies: 4359
-- Name: seq_parcours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_parcours FROM PUBLIC;
REVOKE ALL ON TABLE seq_parcours FROM pgsql;
GRANT ALL ON TABLE seq_parcours TO pgsql;
GRANT ALL ON TABLE seq_parcours TO postgres;
GRANT ALL ON TABLE seq_parcours TO www;
GRANT ALL ON TABLE seq_parcours TO PUBLIC;


--
-- TOC entry 10103 (class 0 OID 0)
-- Dependencies: 4360
-- Name: seq_proposition; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_proposition FROM PUBLIC;
REVOKE ALL ON TABLE seq_proposition FROM pgsql;
GRANT ALL ON TABLE seq_proposition TO pgsql;
GRANT ALL ON TABLE seq_proposition TO www;
GRANT ALL ON TABLE seq_proposition TO PUBLIC;


--
-- TOC entry 10104 (class 0 OID 0)
-- Dependencies: 4361
-- Name: seq_question; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_question FROM PUBLIC;
REVOKE ALL ON TABLE seq_question FROM pgsql;
GRANT ALL ON TABLE seq_question TO pgsql;
GRANT ALL ON TABLE seq_question TO postgres;
GRANT ALL ON TABLE seq_question TO www;
GRANT ALL ON TABLE seq_question TO PUBLIC;


--
-- TOC entry 10105 (class 0 OID 0)
-- Dependencies: 4362
-- Name: seq_questionnaire; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_questionnaire FROM PUBLIC;
REVOKE ALL ON TABLE seq_questionnaire FROM pgsql;
GRANT ALL ON TABLE seq_questionnaire TO pgsql;
GRANT ALL ON TABLE seq_questionnaire TO postgres;
GRANT ALL ON TABLE seq_questionnaire TO www;
GRANT ALL ON TABLE seq_questionnaire TO PUBLIC;


--
-- TOC entry 10106 (class 0 OID 0)
-- Dependencies: 4363
-- Name: seq_reponse; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_reponse FROM PUBLIC;
REVOKE ALL ON TABLE seq_reponse FROM pgsql;
GRANT ALL ON TABLE seq_reponse TO pgsql;
GRANT ALL ON TABLE seq_reponse TO postgres;
GRANT ALL ON TABLE seq_reponse TO www;
GRANT ALL ON TABLE seq_reponse TO PUBLIC;


--
-- TOC entry 10107 (class 0 OID 0)
-- Dependencies: 4364
-- Name: seq_resexouser; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_resexouser FROM PUBLIC;
REVOKE ALL ON TABLE seq_resexouser FROM pgsql;
GRANT ALL ON TABLE seq_resexouser TO pgsql;
GRANT ALL ON TABLE seq_resexouser TO postgres;
GRANT ALL ON TABLE seq_resexouser TO www;
GRANT ALL ON TABLE seq_resexouser TO PUBLIC;


--
-- TOC entry 10108 (class 0 OID 0)
-- Dependencies: 4365
-- Name: seq_ressource; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_ressource FROM PUBLIC;
REVOKE ALL ON TABLE seq_ressource FROM pgsql;
GRANT ALL ON TABLE seq_ressource TO pgsql;
GRANT ALL ON TABLE seq_ressource TO postgres;
GRANT ALL ON TABLE seq_ressource TO www;
GRANT ALL ON TABLE seq_ressource TO PUBLIC;


--
-- TOC entry 10109 (class 0 OID 0)
-- Dependencies: 4366
-- Name: seq_ressourceesp; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_ressourceesp FROM PUBLIC;
REVOKE ALL ON TABLE seq_ressourceesp FROM pgsql;
GRANT ALL ON TABLE seq_ressourceesp TO pgsql;
GRANT ALL ON TABLE seq_ressourceesp TO postgres;
GRANT ALL ON TABLE seq_ressourceesp TO www;
GRANT ALL ON TABLE seq_ressourceesp TO PUBLIC;


--
-- TOC entry 10110 (class 0 OID 0)
-- Dependencies: 4367
-- Name: seq_ressourcefic; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_ressourcefic FROM PUBLIC;
REVOKE ALL ON TABLE seq_ressourcefic FROM pgsql;
GRANT ALL ON TABLE seq_ressourcefic TO pgsql;
GRANT ALL ON TABLE seq_ressourcefic TO postgres;
GRANT ALL ON TABLE seq_ressourcefic TO www;
GRANT ALL ON TABLE seq_ressourcefic TO PUBLIC;


--
-- TOC entry 10111 (class 0 OID 0)
-- Dependencies: 4368
-- Name: seq_ressourcegest; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_ressourcegest FROM PUBLIC;
REVOKE ALL ON TABLE seq_ressourcegest FROM pgsql;
GRANT ALL ON TABLE seq_ressourcegest TO pgsql;
GRANT ALL ON TABLE seq_ressourcegest TO postgres;
GRANT ALL ON TABLE seq_ressourcegest TO www;
GRANT ALL ON TABLE seq_ressourcegest TO PUBLIC;


--
-- TOC entry 10112 (class 0 OID 0)
-- Dependencies: 4369
-- Name: seq_ressourcesec; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_ressourcesec FROM PUBLIC;
REVOKE ALL ON TABLE seq_ressourcesec FROM pgsql;
GRANT ALL ON TABLE seq_ressourcesec TO pgsql;
GRANT ALL ON TABLE seq_ressourcesec TO postgres;
GRANT ALL ON TABLE seq_ressourcesec TO www;
GRANT ALL ON TABLE seq_ressourcesec TO PUBLIC;


--
-- TOC entry 10113 (class 0 OID 0)
-- Dependencies: 4370
-- Name: seq_rubrique; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_rubrique FROM PUBLIC;
REVOKE ALL ON TABLE seq_rubrique FROM pgsql;
GRANT ALL ON TABLE seq_rubrique TO pgsql;
GRANT ALL ON TABLE seq_rubrique TO postgres;
GRANT ALL ON TABLE seq_rubrique TO www;
GRANT ALL ON TABLE seq_rubrique TO PUBLIC;


--
-- TOC entry 10114 (class 0 OID 0)
-- Dependencies: 4371
-- Name: seq_salle; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_salle FROM PUBLIC;
REVOKE ALL ON TABLE seq_salle FROM pgsql;
GRANT ALL ON TABLE seq_salle TO pgsql;
GRANT ALL ON TABLE seq_salle TO postgres;
GRANT ALL ON TABLE seq_salle TO www;
GRANT ALL ON TABLE seq_salle TO PUBLIC;


--
-- TOC entry 10115 (class 0 OID 0)
-- Dependencies: 4372
-- Name: seq_souscours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_souscours FROM PUBLIC;
REVOKE ALL ON TABLE seq_souscours FROM pgsql;
GRANT ALL ON TABLE seq_souscours TO pgsql;
GRANT ALL ON TABLE seq_souscours TO postgres;
GRANT ALL ON TABLE seq_souscours TO www;
GRANT ALL ON TABLE seq_souscours TO PUBLIC;


--
-- TOC entry 10116 (class 0 OID 0)
-- Dependencies: 4373
-- Name: seq_sousgroupe; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_sousgroupe FROM PUBLIC;
REVOKE ALL ON TABLE seq_sousgroupe FROM pgsql;
GRANT ALL ON TABLE seq_sousgroupe TO pgsql;
GRANT ALL ON TABLE seq_sousgroupe TO postgres;
GRANT ALL ON TABLE seq_sousgroupe TO www;
GRANT ALL ON TABLE seq_sousgroupe TO PUBLIC;


--
-- TOC entry 10117 (class 0 OID 0)
-- Dependencies: 4374
-- Name: seq_sousouscours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_sousouscours FROM PUBLIC;
REVOKE ALL ON TABLE seq_sousouscours FROM pgsql;
GRANT ALL ON TABLE seq_sousouscours TO pgsql;
GRANT ALL ON TABLE seq_sousouscours TO postgres;
GRANT ALL ON TABLE seq_sousouscours TO www;
GRANT ALL ON TABLE seq_sousouscours TO PUBLIC;


--
-- TOC entry 10118 (class 0 OID 0)
-- Dependencies: 4375
-- Name: seq_sousousgroupe; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_sousousgroupe FROM PUBLIC;
REVOKE ALL ON TABLE seq_sousousgroupe FROM pgsql;
GRANT ALL ON TABLE seq_sousousgroupe TO pgsql;
GRANT ALL ON TABLE seq_sousousgroupe TO postgres;
GRANT ALL ON TABLE seq_sousousgroupe TO www;
GRANT ALL ON TABLE seq_sousousgroupe TO PUBLIC;


--
-- TOC entry 10119 (class 0 OID 0)
-- Dependencies: 4376
-- Name: seq_sousousouscours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_sousousouscours FROM PUBLIC;
REVOKE ALL ON TABLE seq_sousousouscours FROM pgsql;
GRANT ALL ON TABLE seq_sousousouscours TO pgsql;
GRANT ALL ON TABLE seq_sousousouscours TO postgres;
GRANT ALL ON TABLE seq_sousousouscours TO www;
GRANT ALL ON TABLE seq_sousousouscours TO PUBLIC;


--
-- TOC entry 10120 (class 0 OID 0)
-- Dependencies: 4377
-- Name: seq_sousousousgroupe; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_sousousousgroupe FROM PUBLIC;
REVOKE ALL ON TABLE seq_sousousousgroupe FROM pgsql;
GRANT ALL ON TABLE seq_sousousousgroupe TO pgsql;
GRANT ALL ON TABLE seq_sousousousgroupe TO postgres;
GRANT ALL ON TABLE seq_sousousousgroupe TO www;
GRANT ALL ON TABLE seq_sousousousgroupe TO PUBLIC;


--
-- TOC entry 10121 (class 0 OID 0)
-- Dependencies: 4378
-- Name: seq_sousousousouscours; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_sousousousouscours FROM PUBLIC;
REVOKE ALL ON TABLE seq_sousousousouscours FROM pgsql;
GRANT ALL ON TABLE seq_sousousousouscours TO pgsql;
GRANT ALL ON TABLE seq_sousousousouscours TO postgres;
GRANT ALL ON TABLE seq_sousousousouscours TO www;
GRANT ALL ON TABLE seq_sousousousouscours TO PUBLIC;


--
-- TOC entry 10122 (class 0 OID 0)
-- Dependencies: 4379
-- Name: seq_sousousousousgroupe; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_sousousousousgroupe FROM PUBLIC;
REVOKE ALL ON TABLE seq_sousousousousgroupe FROM pgsql;
GRANT ALL ON TABLE seq_sousousousousgroupe TO pgsql;
GRANT ALL ON TABLE seq_sousousousousgroupe TO postgres;
GRANT ALL ON TABLE seq_sousousousousgroupe TO www;
GRANT ALL ON TABLE seq_sousousousousgroupe TO PUBLIC;


--
-- TOC entry 10123 (class 0 OID 0)
-- Dependencies: 4380
-- Name: seq_sousrubrique; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_sousrubrique FROM PUBLIC;
REVOKE ALL ON TABLE seq_sousrubrique FROM pgsql;
GRANT ALL ON TABLE seq_sousrubrique TO pgsql;
GRANT ALL ON TABLE seq_sousrubrique TO postgres;
GRANT ALL ON TABLE seq_sousrubrique TO www;
GRANT ALL ON TABLE seq_sousrubrique TO PUBLIC;


--
-- TOC entry 10124 (class 0 OID 0)
-- Dependencies: 4381
-- Name: seq_thematique; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_thematique FROM PUBLIC;
REVOKE ALL ON TABLE seq_thematique FROM pgsql;
GRANT ALL ON TABLE seq_thematique TO pgsql;
GRANT ALL ON TABLE seq_thematique TO postgres;
GRANT ALL ON TABLE seq_thematique TO www;
GRANT ALL ON TABLE seq_thematique TO PUBLIC;


--
-- TOC entry 10125 (class 0 OID 0)
-- Dependencies: 4382
-- Name: seq_themedir; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_themedir FROM PUBLIC;
REVOKE ALL ON TABLE seq_themedir FROM pgsql;
GRANT ALL ON TABLE seq_themedir TO pgsql;
GRANT ALL ON TABLE seq_themedir TO postgres;
GRANT ALL ON TABLE seq_themedir TO www;
GRANT ALL ON TABLE seq_themedir TO PUBLIC;


--
-- TOC entry 10126 (class 0 OID 0)
-- Dependencies: 4383
-- Name: seq_titrecapa; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_titrecapa FROM PUBLIC;
REVOKE ALL ON TABLE seq_titrecapa FROM pgsql;
GRANT ALL ON TABLE seq_titrecapa TO pgsql;
GRANT ALL ON TABLE seq_titrecapa TO postgres;
GRANT ALL ON TABLE seq_titrecapa TO www;
GRANT ALL ON TABLE seq_titrecapa TO PUBLIC;


--
-- TOC entry 10127 (class 0 OID 0)
-- Dependencies: 4384
-- Name: seq_titrecapacite; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_titrecapacite FROM PUBLIC;
REVOKE ALL ON TABLE seq_titrecapacite FROM pgsql;
GRANT ALL ON TABLE seq_titrecapacite TO pgsql;
GRANT ALL ON TABLE seq_titrecapacite TO postgres;
GRANT ALL ON TABLE seq_titrecapacite TO www;
GRANT ALL ON TABLE seq_titrecapacite TO PUBLIC;


--
-- TOC entry 10128 (class 0 OID 0)
-- Dependencies: 4385
-- Name: seq_typeform; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_typeform FROM PUBLIC;
REVOKE ALL ON TABLE seq_typeform FROM pgsql;
GRANT ALL ON TABLE seq_typeform TO pgsql;
GRANT ALL ON TABLE seq_typeform TO postgres;
GRANT ALL ON TABLE seq_typeform TO www;
GRANT ALL ON TABLE seq_typeform TO PUBLIC;


--
-- TOC entry 10129 (class 0 OID 0)
-- Dependencies: 4386
-- Name: seq_utilisateurs; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE seq_utilisateurs FROM PUBLIC;
REVOKE ALL ON TABLE seq_utilisateurs FROM pgsql;
GRANT ALL ON TABLE seq_utilisateurs TO pgsql;
GRANT ALL ON TABLE seq_utilisateurs TO postgres;
GRANT ALL ON TABLE seq_utilisateurs TO www;
GRANT ALL ON TABLE seq_utilisateurs TO PUBLIC;


--
-- TOC entry 10130 (class 0 OID 0)
-- Dependencies: 4387
-- Name: serie_aleatoire; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE serie_aleatoire FROM PUBLIC;
REVOKE ALL ON TABLE serie_aleatoire FROM pgsql;
GRANT ALL ON TABLE serie_aleatoire TO pgsql;
GRANT ALL ON TABLE serie_aleatoire TO postgres;
GRANT ALL ON TABLE serie_aleatoire TO www;
GRANT ALL ON TABLE serie_aleatoire TO PUBLIC;


--
-- TOC entry 10131 (class 0 OID 0)
-- Dependencies: 4388
-- Name: serie_bloquante; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE serie_bloquante FROM PUBLIC;
REVOKE ALL ON TABLE serie_bloquante FROM pgsql;
GRANT ALL ON TABLE serie_bloquante TO pgsql;
GRANT ALL ON TABLE serie_bloquante TO postgres;
GRANT ALL ON TABLE serie_bloquante TO www;
GRANT ALL ON TABLE serie_bloquante TO PUBLIC;


--
-- TOC entry 10132 (class 0 OID 0)
-- Dependencies: 4389
-- Name: serie_exo; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE serie_exo FROM PUBLIC;
REVOKE ALL ON TABLE serie_exo FROM pgsql;
GRANT ALL ON TABLE serie_exo TO pgsql;
GRANT ALL ON TABLE serie_exo TO postgres;
GRANT ALL ON TABLE serie_exo TO www;
GRANT ALL ON TABLE serie_exo TO PUBLIC;


--
-- TOC entry 10133 (class 0 OID 0)
-- Dependencies: 4390
-- Name: serie_ftb_id_seq; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE serie_ftb_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE serie_ftb_id_seq FROM pgsql;
GRANT ALL ON TABLE serie_ftb_id_seq TO pgsql;
GRANT ALL ON TABLE serie_ftb_id_seq TO postgres;
GRANT ALL ON TABLE serie_ftb_id_seq TO www;
GRANT ALL ON TABLE serie_ftb_id_seq TO PUBLIC;


--
-- TOC entry 10134 (class 0 OID 0)
-- Dependencies: 4391
-- Name: session; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE "session" FROM PUBLIC;
REVOKE ALL ON TABLE "session" FROM pgsql;
GRANT ALL ON TABLE "session" TO pgsql;
GRANT ALL ON TABLE "session" TO postgres;
GRANT ALL ON TABLE "session" TO www;
GRANT ALL ON TABLE "session" TO PUBLIC;


--
-- TOC entry 10135 (class 0 OID 0)
-- Dependencies: 4392
-- Name: sousrubrique; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE sousrubrique FROM PUBLIC;
REVOKE ALL ON TABLE sousrubrique FROM pgsql;
GRANT ALL ON TABLE sousrubrique TO pgsql;
GRANT ALL ON TABLE sousrubrique TO postgres;
GRANT ALL ON TABLE sousrubrique TO www;
GRANT ALL ON TABLE sousrubrique TO PUBLIC;


--
-- TOC entry 10136 (class 0 OID 0)
-- Dependencies: 4393
-- Name: stockresultqcm; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE stockresultqcm FROM PUBLIC;
REVOKE ALL ON TABLE stockresultqcm FROM pgsql;
GRANT ALL ON TABLE stockresultqcm TO pgsql;
GRANT ALL ON TABLE stockresultqcm TO postgres;
GRANT ALL ON TABLE stockresultqcm TO www;
GRANT ALL ON TABLE stockresultqcm TO PUBLIC;


--
-- TOC entry 10137 (class 0 OID 0)
-- Dependencies: 4394
-- Name: stockresultserie; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE stockresultserie FROM PUBLIC;
REVOKE ALL ON TABLE stockresultserie FROM pgsql;
GRANT ALL ON TABLE stockresultserie TO pgsql;
GRANT ALL ON TABLE stockresultserie TO postgres;
GRANT ALL ON TABLE stockresultserie TO www;
GRANT ALL ON TABLE stockresultserie TO PUBLIC;


--
-- TOC entry 10138 (class 0 OID 0)
-- Dependencies: 4395
-- Name: test; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE test FROM PUBLIC;
REVOKE ALL ON TABLE test FROM pgsql;
GRANT ALL ON TABLE test TO pgsql;
GRANT ALL ON TABLE test TO postgres;
GRANT ALL ON TABLE test TO www;
GRANT ALL ON TABLE test TO PUBLIC;


--
-- TOC entry 10139 (class 0 OID 0)
-- Dependencies: 4396
-- Name: test_quest_rep; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE test_quest_rep FROM PUBLIC;
REVOKE ALL ON TABLE test_quest_rep FROM pgsql;
GRANT ALL ON TABLE test_quest_rep TO pgsql;
GRANT ALL ON TABLE test_quest_rep TO postgres;
GRANT ALL ON TABLE test_quest_rep TO www;
GRANT ALL ON TABLE test_quest_rep TO PUBLIC;


--
-- TOC entry 10140 (class 0 OID 0)
-- Dependencies: 4397
-- Name: test_rep_nbexogen; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE test_rep_nbexogen FROM PUBLIC;
REVOKE ALL ON TABLE test_rep_nbexogen FROM pgsql;
GRANT ALL ON TABLE test_rep_nbexogen TO pgsql;
GRANT ALL ON TABLE test_rep_nbexogen TO postgres;
GRANT ALL ON TABLE test_rep_nbexogen TO www;
GRANT ALL ON TABLE test_rep_nbexogen TO PUBLIC;


--
-- TOC entry 10141 (class 0 OID 0)
-- Dependencies: 4398
-- Name: themedir; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE themedir FROM PUBLIC;
REVOKE ALL ON TABLE themedir FROM pgsql;
GRANT ALL ON TABLE themedir TO pgsql;
GRANT ALL ON TABLE themedir TO postgres;
GRANT ALL ON TABLE themedir TO www;
GRANT ALL ON TABLE themedir TO PUBLIC;


--
-- TOC entry 10142 (class 0 OID 0)
-- Dependencies: 4399
-- Name: titrecapa; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE titrecapa FROM PUBLIC;
REVOKE ALL ON TABLE titrecapa FROM pgsql;
GRANT ALL ON TABLE titrecapa TO pgsql;
GRANT ALL ON TABLE titrecapa TO postgres;
GRANT ALL ON TABLE titrecapa TO www;
GRANT ALL ON TABLE titrecapa TO PUBLIC;


--
-- TOC entry 10143 (class 0 OID 0)
-- Dependencies: 4400
-- Name: titrecapacite; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE titrecapacite FROM PUBLIC;
REVOKE ALL ON TABLE titrecapacite FROM pgsql;
GRANT ALL ON TABLE titrecapacite TO pgsql;
GRANT ALL ON TABLE titrecapacite TO postgres;
GRANT ALL ON TABLE titrecapacite TO www;
GRANT ALL ON TABLE titrecapacite TO PUBLIC;


--
-- TOC entry 10144 (class 0 OID 0)
-- Dependencies: 4401
-- Name: titrepage; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE titrepage FROM PUBLIC;
REVOKE ALL ON TABLE titrepage FROM pgsql;
GRANT ALL ON TABLE titrepage TO pgsql;
GRANT ALL ON TABLE titrepage TO postgres;
GRANT ALL ON TABLE titrepage TO www;
GRANT ALL ON TABLE titrepage TO PUBLIC;


--
-- TOC entry 10145 (class 0 OID 0)
-- Dependencies: 4402
-- Name: typeform; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE typeform FROM PUBLIC;
REVOKE ALL ON TABLE typeform FROM pgsql;
GRANT ALL ON TABLE typeform TO pgsql;
GRANT ALL ON TABLE typeform TO postgres;
GRANT ALL ON TABLE typeform TO www;
GRANT ALL ON TABLE typeform TO PUBLIC;


--
-- TOC entry 10146 (class 0 OID 0)
-- Dependencies: 4403
-- Name: utilisateurs; Type: ACL; Schema: public; Owner: pgsql
--

REVOKE ALL ON TABLE utilisateurs FROM PUBLIC;
REVOKE ALL ON TABLE utilisateurs FROM pgsql;
GRANT ALL ON TABLE utilisateurs TO pgsql;
GRANT ALL ON TABLE utilisateurs TO postgres;
GRANT ALL ON TABLE utilisateurs TO www;
GRANT ALL ON TABLE utilisateurs TO PUBLIC;


SET search_path = v2, pg_catalog;

--
-- TOC entry 10147 (class 0 OID 0)
-- Dependencies: 4404
-- Name: c_ban_users; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE c_ban_users FROM PUBLIC;
REVOKE ALL ON TABLE c_ban_users FROM postgres;
GRANT ALL ON TABLE c_ban_users TO postgres;
GRANT ALL ON TABLE c_ban_users TO www;
GRANT ALL ON TABLE c_ban_users TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE c_ban_users TO "grp-www";


--
-- TOC entry 10148 (class 0 OID 0)
-- Dependencies: 4405
-- Name: c_etape_chat; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE c_etape_chat FROM PUBLIC;
REVOKE ALL ON TABLE c_etape_chat FROM postgres;
GRANT ALL ON TABLE c_etape_chat TO postgres;
GRANT ALL ON TABLE c_etape_chat TO www;
GRANT ALL ON TABLE c_etape_chat TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE c_etape_chat TO "grp-www";


--
-- TOC entry 10149 (class 0 OID 0)
-- Dependencies: 4406
-- Name: c_messages; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE c_messages FROM PUBLIC;
REVOKE ALL ON TABLE c_messages FROM postgres;
GRANT ALL ON TABLE c_messages TO postgres;
GRANT ALL ON TABLE c_messages TO www;
GRANT ALL ON TABLE c_messages TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE c_messages TO "grp-www";


--
-- TOC entry 10150 (class 0 OID 0)
-- Dependencies: 4407
-- Name: c_reg_users; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE c_reg_users FROM PUBLIC;
REVOKE ALL ON TABLE c_reg_users FROM postgres;
GRANT ALL ON TABLE c_reg_users TO postgres;
GRANT ALL ON TABLE c_reg_users TO www;
GRANT ALL ON TABLE c_reg_users TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE c_reg_users TO "grp-www";


--
-- TOC entry 10151 (class 0 OID 0)
-- Dependencies: 4408
-- Name: c_users; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE c_users FROM PUBLIC;
REVOKE ALL ON TABLE c_users FROM postgres;
GRANT ALL ON TABLE c_users TO postgres;
GRANT ALL ON TABLE c_users TO www;
GRANT ALL ON TABLE c_users TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE c_users TO "grp-www";


--
-- TOC entry 10153 (class 0 OID 0)
-- Dependencies: 4410
-- Name: cls_classe; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE cls_classe FROM PUBLIC;
REVOKE ALL ON TABLE cls_classe FROM postgres;
GRANT ALL ON TABLE cls_classe TO postgres;
GRANT ALL ON TABLE cls_classe TO www;
GRANT ALL ON TABLE cls_classe TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE cls_classe TO "grp-www";


--
-- TOC entry 10155 (class 0 OID 0)
-- Dependencies: 4411
-- Name: cls_classe_individus; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE cls_classe_individus FROM PUBLIC;
REVOKE ALL ON TABLE cls_classe_individus FROM postgres;
GRANT ALL ON TABLE cls_classe_individus TO postgres;
GRANT ALL ON TABLE cls_classe_individus TO www;
GRANT ALL ON TABLE cls_classe_individus TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE cls_classe_individus TO "grp-www";


--
-- TOC entry 10156 (class 0 OID 0)
-- Dependencies: 4412
-- Name: droit_id_seq; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE droit_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE droit_id_seq FROM postgres;
GRANT ALL ON TABLE droit_id_seq TO postgres;
GRANT ALL ON TABLE droit_id_seq TO PUBLIC;
GRANT ALL ON TABLE droit_id_seq TO "grp-www";


--
-- TOC entry 10157 (class 0 OID 0)
-- Dependencies: 4413
-- Name: etape_type_id_seq; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE etape_type_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE etape_type_id_seq FROM postgres;
GRANT ALL ON TABLE etape_type_id_seq TO postgres;
GRANT ALL ON TABLE etape_type_id_seq TO PUBLIC;
GRANT ALL ON TABLE etape_type_id_seq TO "grp-www";


--
-- TOC entry 10159 (class 0 OID 0)
-- Dependencies: 4414
-- Name: fb_categorie_ftb; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fb_categorie_ftb FROM PUBLIC;
REVOKE ALL ON TABLE fb_categorie_ftb FROM postgres;
GRANT ALL ON TABLE fb_categorie_ftb TO postgres;
GRANT ALL ON TABLE fb_categorie_ftb TO www;
GRANT ALL ON TABLE fb_categorie_ftb TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fb_categorie_ftb TO "grp-www";


--
-- TOC entry 10160 (class 0 OID 0)
-- Dependencies: 4415
-- Name: fb_ftb; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fb_ftb FROM PUBLIC;
REVOKE ALL ON TABLE fb_ftb FROM postgres;
GRANT ALL ON TABLE fb_ftb TO postgres;
GRANT ALL ON TABLE fb_ftb TO www;
GRANT ALL ON TABLE fb_ftb TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fb_ftb TO "grp-www";


--
-- TOC entry 10162 (class 0 OID 0)
-- Dependencies: 4416
-- Name: fb_resultat_serie_ftb; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fb_resultat_serie_ftb FROM PUBLIC;
REVOKE ALL ON TABLE fb_resultat_serie_ftb FROM postgres;
GRANT ALL ON TABLE fb_resultat_serie_ftb TO postgres;
GRANT ALL ON TABLE fb_resultat_serie_ftb TO www;
GRANT ALL ON TABLE fb_resultat_serie_ftb TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fb_resultat_serie_ftb TO "grp-www";


--
-- TOC entry 10163 (class 0 OID 0)
-- Dependencies: 4418
-- Name: fchr_fichier; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fchr_fichier FROM PUBLIC;
REVOKE ALL ON TABLE fchr_fichier FROM postgres;
GRANT ALL ON TABLE fchr_fichier TO postgres;
GRANT ALL ON TABLE fchr_fichier TO www;
GRANT ALL ON TABLE fchr_fichier TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fchr_fichier TO "grp-www";


--
-- TOC entry 10164 (class 0 OID 0)
-- Dependencies: 4419
-- Name: fchr_fichier_correction; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fchr_fichier_correction FROM PUBLIC;
REVOKE ALL ON TABLE fchr_fichier_correction FROM postgres;
GRANT ALL ON TABLE fchr_fichier_correction TO postgres;
GRANT ALL ON TABLE fchr_fichier_correction TO www;
GRANT ALL ON TABLE fchr_fichier_correction TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fchr_fichier_correction TO "grp-www";


--
-- TOC entry 10165 (class 0 OID 0)
-- Dependencies: 4421
-- Name: fchr_fichier_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fchr_fichier_type FROM PUBLIC;
REVOKE ALL ON TABLE fchr_fichier_type FROM postgres;
GRANT ALL ON TABLE fchr_fichier_type TO postgres;
GRANT ALL ON TABLE fchr_fichier_type TO www;
GRANT ALL ON TABLE fchr_fichier_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fchr_fichier_type TO "grp-www";


--
-- TOC entry 10166 (class 0 OID 0)
-- Dependencies: 4423
-- Name: flr_filiere; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE flr_filiere FROM PUBLIC;
REVOKE ALL ON TABLE flr_filiere FROM postgres;
GRANT ALL ON TABLE flr_filiere TO postgres;
GRANT ALL ON TABLE flr_filiere TO www;
GRANT ALL ON TABLE flr_filiere TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE flr_filiere TO "grp-www";


--
-- TOC entry 10167 (class 0 OID 0)
-- Dependencies: 4424
-- Name: frm_articles; Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON TABLE frm_articles FROM PUBLIC;
REVOKE ALL ON TABLE frm_articles FROM pgsql;
GRANT ALL ON TABLE frm_articles TO pgsql;
GRANT ALL ON TABLE frm_articles TO postgres;
GRANT ALL ON TABLE frm_articles TO www;
GRANT ALL ON TABLE frm_articles TO PUBLIC;


--
-- TOC entry 10168 (class 0 OID 0)
-- Dependencies: 4425
-- Name: frm_block_ip; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frm_block_ip FROM PUBLIC;
REVOKE ALL ON TABLE frm_block_ip FROM postgres;
GRANT ALL ON TABLE frm_block_ip TO postgres;
GRANT ALL ON TABLE frm_block_ip TO www;
GRANT ALL ON TABLE frm_block_ip TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frm_block_ip TO "grp-www";


--
-- TOC entry 10169 (class 0 OID 0)
-- Dependencies: 4426
-- Name: frm_etape_forum; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frm_etape_forum FROM PUBLIC;
REVOKE ALL ON TABLE frm_etape_forum FROM postgres;
GRANT ALL ON TABLE frm_etape_forum TO postgres;
GRANT ALL ON TABLE frm_etape_forum TO www;
GRANT ALL ON TABLE frm_etape_forum TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frm_etape_forum TO "grp-www";


--
-- TOC entry 10171 (class 0 OID 0)
-- Dependencies: 4427
-- Name: frm_formation_forums; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frm_formation_forums FROM PUBLIC;
REVOKE ALL ON TABLE frm_formation_forums FROM postgres;
GRANT ALL ON TABLE frm_formation_forums TO postgres;
GRANT ALL ON TABLE frm_formation_forums TO www;
GRANT ALL ON TABLE frm_formation_forums TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frm_formation_forums TO "grp-www";


--
-- TOC entry 10172 (class 0 OID 0)
-- Dependencies: 4429
-- Name: frm_forum; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frm_forum FROM PUBLIC;
REVOKE ALL ON TABLE frm_forum FROM postgres;
GRANT ALL ON TABLE frm_forum TO postgres;
GRANT ALL ON TABLE frm_forum TO www;
GRANT ALL ON TABLE frm_forum TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frm_forum TO "grp-www";


--
-- TOC entry 10173 (class 0 OID 0)
-- Dependencies: 4431
-- Name: frm_forum_environnement; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frm_forum_environnement FROM PUBLIC;
REVOKE ALL ON TABLE frm_forum_environnement FROM postgres;
GRANT ALL ON TABLE frm_forum_environnement TO postgres;
GRANT ALL ON TABLE frm_forum_environnement TO www;
GRANT ALL ON TABLE frm_forum_environnement TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frm_forum_environnement TO "grp-www";


--
-- TOC entry 10174 (class 0 OID 0)
-- Dependencies: 4432
-- Name: frm_forum_environnements; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frm_forum_environnements FROM PUBLIC;
REVOKE ALL ON TABLE frm_forum_environnements FROM postgres;
GRANT ALL ON TABLE frm_forum_environnements TO postgres;
GRANT ALL ON TABLE frm_forum_environnements TO www;
GRANT ALL ON TABLE frm_forum_environnements TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frm_forum_environnements TO "grp-www";


--
-- TOC entry 10175 (class 0 OID 0)
-- Dependencies: 4434
-- Name: frm_message; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frm_message FROM PUBLIC;
REVOKE ALL ON TABLE frm_message FROM postgres;
GRANT ALL ON TABLE frm_message TO postgres;
GRANT ALL ON TABLE frm_message TO www;
GRANT ALL ON TABLE frm_message TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frm_message TO "grp-www";


--
-- TOC entry 10177 (class 0 OID 0)
-- Dependencies: 4435
-- Name: frmtn_formateur_droits; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frmtn_formateur_droits FROM PUBLIC;
REVOKE ALL ON TABLE frmtn_formateur_droits FROM postgres;
GRANT ALL ON TABLE frmtn_formateur_droits TO postgres;
GRANT ALL ON TABLE frmtn_formateur_droits TO www;
GRANT ALL ON TABLE frmtn_formateur_droits TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frmtn_formateur_droits TO "grp-www";


--
-- TOC entry 10179 (class 0 OID 0)
-- Dependencies: 4437
-- Name: frmtn_formation; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frmtn_formation FROM PUBLIC;
REVOKE ALL ON TABLE frmtn_formation FROM postgres;
GRANT ALL ON TABLE frmtn_formation TO postgres;
GRANT ALL ON TABLE frmtn_formation TO www;
GRANT ALL ON TABLE frmtn_formation TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frmtn_formation TO "grp-www";


--
-- TOC entry 10181 (class 0 OID 0)
-- Dependencies: 4438
-- Name: frmtn_formation_langues; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frmtn_formation_langues FROM PUBLIC;
REVOKE ALL ON TABLE frmtn_formation_langues FROM postgres;
GRANT ALL ON TABLE frmtn_formation_langues TO postgres;
GRANT ALL ON TABLE frmtn_formation_langues TO www;
GRANT ALL ON TABLE frmtn_formation_langues TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frmtn_formation_langues TO "grp-www";


--
-- TOC entry 10183 (class 0 OID 0)
-- Dependencies: 4439
-- Name: frmtn_formation_participants; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE frmtn_formation_participants FROM PUBLIC;
REVOKE ALL ON TABLE frmtn_formation_participants FROM postgres;
GRANT ALL ON TABLE frmtn_formation_participants TO postgres;
GRANT ALL ON TABLE frmtn_formation_participants TO www;
GRANT ALL ON TABLE frmtn_formation_participants TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE frmtn_formation_participants TO "grp-www";


--
-- TOC entry 10185 (class 0 OID 0)
-- Dependencies: 4440
-- Name: fw_connexion; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fw_connexion FROM PUBLIC;
REVOKE ALL ON TABLE fw_connexion FROM postgres;
GRANT ALL ON TABLE fw_connexion TO postgres;
GRANT ALL ON TABLE fw_connexion TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fw_connexion TO "grp-www";


--
-- TOC entry 10187 (class 0 OID 0)
-- Dependencies: 4441
-- Name: fw_droit; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fw_droit FROM PUBLIC;
REVOKE ALL ON TABLE fw_droit FROM postgres;
GRANT ALL ON TABLE fw_droit TO postgres;
GRANT ALL ON TABLE fw_droit TO www;
GRANT ALL ON TABLE fw_droit TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fw_droit TO "grp-www";


--
-- TOC entry 10188 (class 0 OID 0)
-- Dependencies: 4443
-- Name: fw_langue; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fw_langue FROM PUBLIC;
REVOKE ALL ON TABLE fw_langue FROM postgres;
GRANT ALL ON TABLE fw_langue TO postgres;
GRANT ALL ON TABLE fw_langue TO www;
GRANT ALL ON TABLE fw_langue TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fw_langue TO "grp-www";


--
-- TOC entry 10189 (class 0 OID 0)
-- Dependencies: 4445
-- Name: fw_langue_message; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fw_langue_message FROM PUBLIC;
REVOKE ALL ON TABLE fw_langue_message FROM postgres;
GRANT ALL ON TABLE fw_langue_message TO postgres;
GRANT ALL ON TABLE fw_langue_message TO www;
GRANT ALL ON TABLE fw_langue_message TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fw_langue_message TO "grp-www";


--
-- TOC entry 10190 (class 0 OID 0)
-- Dependencies: 4447
-- Name: fw_langue_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fw_langue_type FROM PUBLIC;
REVOKE ALL ON TABLE fw_langue_type FROM postgres;
GRANT ALL ON TABLE fw_langue_type TO postgres;
GRANT ALL ON TABLE fw_langue_type TO www;
GRANT ALL ON TABLE fw_langue_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fw_langue_type TO "grp-www";


--
-- TOC entry 10192 (class 0 OID 0)
-- Dependencies: 4448
-- Name: fw_session; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE fw_session FROM PUBLIC;
REVOKE ALL ON TABLE fw_session FROM postgres;
GRANT ALL ON TABLE fw_session TO postgres;
GRANT ALL ON TABLE fw_session TO www;
GRANT ALL ON TABLE fw_session TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE fw_session TO "grp-www";


--
-- TOC entry 10194 (class 0 OID 0)
-- Dependencies: 4450
-- Name: grll_capacite; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_capacite FROM PUBLIC;
REVOKE ALL ON TABLE grll_capacite FROM postgres;
GRANT ALL ON TABLE grll_capacite TO postgres;
GRANT ALL ON TABLE grll_capacite TO www;
GRANT ALL ON TABLE grll_capacite TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_capacite TO "grp-www";


--
-- TOC entry 10196 (class 0 OID 0)
-- Dependencies: 4452
-- Name: grll_capacite_titre; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_capacite_titre FROM PUBLIC;
REVOKE ALL ON TABLE grll_capacite_titre FROM postgres;
GRANT ALL ON TABLE grll_capacite_titre TO postgres;
GRANT ALL ON TABLE grll_capacite_titre TO www;
GRANT ALL ON TABLE grll_capacite_titre TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_capacite_titre TO "grp-www";


--
-- TOC entry 10198 (class 0 OID 0)
-- Dependencies: 4453
-- Name: grll_capacite_titre_capacites; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_capacite_titre_capacites FROM PUBLIC;
REVOKE ALL ON TABLE grll_capacite_titre_capacites FROM postgres;
GRANT ALL ON TABLE grll_capacite_titre_capacites TO postgres;
GRANT ALL ON TABLE grll_capacite_titre_capacites TO www;
GRANT ALL ON TABLE grll_capacite_titre_capacites TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_capacite_titre_capacites TO "grp-www";


--
-- TOC entry 10200 (class 0 OID 0)
-- Dependencies: 4455
-- Name: grll_carton; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_carton FROM PUBLIC;
REVOKE ALL ON TABLE grll_carton FROM postgres;
GRANT ALL ON TABLE grll_carton TO postgres;
GRANT ALL ON TABLE grll_carton TO www;
GRANT ALL ON TABLE grll_carton TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_carton TO "grp-www";


--
-- TOC entry 10202 (class 0 OID 0)
-- Dependencies: 4456
-- Name: grll_categorie_capacite; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_categorie_capacite FROM PUBLIC;
REVOKE ALL ON TABLE grll_categorie_capacite FROM postgres;
GRANT ALL ON TABLE grll_categorie_capacite TO postgres;
GRANT ALL ON TABLE grll_categorie_capacite TO www;
GRANT ALL ON TABLE grll_categorie_capacite TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_categorie_capacite TO "grp-www";


--
-- TOC entry 10204 (class 0 OID 0)
-- Dependencies: 4457
-- Name: grll_categorie_capacite_titre; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_categorie_capacite_titre FROM PUBLIC;
REVOKE ALL ON TABLE grll_categorie_capacite_titre FROM postgres;
GRANT ALL ON TABLE grll_categorie_capacite_titre TO postgres;
GRANT ALL ON TABLE grll_categorie_capacite_titre TO www;
GRANT ALL ON TABLE grll_categorie_capacite_titre TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_categorie_capacite_titre TO "grp-www";


--
-- TOC entry 10206 (class 0 OID 0)
-- Dependencies: 4458
-- Name: grll_categorie_grille; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_categorie_grille FROM PUBLIC;
REVOKE ALL ON TABLE grll_categorie_grille FROM postgres;
GRANT ALL ON TABLE grll_categorie_grille TO postgres;
GRANT ALL ON TABLE grll_categorie_grille TO www;
GRANT ALL ON TABLE grll_categorie_grille TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_categorie_grille TO "grp-www";


--
-- TOC entry 10207 (class 0 OID 0)
-- Dependencies: 4460
-- Name: grll_grille; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_grille FROM PUBLIC;
REVOKE ALL ON TABLE grll_grille FROM postgres;
GRANT ALL ON TABLE grll_grille TO postgres;
GRANT ALL ON TABLE grll_grille TO www;
GRANT ALL ON TABLE grll_grille TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_grille TO "grp-www";


--
-- TOC entry 10208 (class 0 OID 0)
-- Dependencies: 4461
-- Name: grll_grille_capacites_titres; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_grille_capacites_titres FROM PUBLIC;
REVOKE ALL ON TABLE grll_grille_capacites_titres FROM postgres;
GRANT ALL ON TABLE grll_grille_capacites_titres TO postgres;
GRANT ALL ON TABLE grll_grille_capacites_titres TO www;
GRANT ALL ON TABLE grll_grille_capacites_titres TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_grille_capacites_titres TO "grp-www";


--
-- TOC entry 10209 (class 0 OID 0)
-- Dependencies: 4462
-- Name: grll_grille_resultats; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_grille_resultats FROM PUBLIC;
REVOKE ALL ON TABLE grll_grille_resultats FROM postgres;
GRANT ALL ON TABLE grll_grille_resultats TO postgres;
GRANT ALL ON TABLE grll_grille_resultats TO www;
GRANT ALL ON TABLE grll_grille_resultats TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_grille_resultats TO "grp-www";


--
-- TOC entry 10211 (class 0 OID 0)
-- Dependencies: 4463
-- Name: grll_stagiaire_grille; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE grll_stagiaire_grille FROM PUBLIC;
REVOKE ALL ON TABLE grll_stagiaire_grille FROM postgres;
GRANT ALL ON TABLE grll_stagiaire_grille TO postgres;
GRANT ALL ON TABLE grll_stagiaire_grille TO www;
GRANT ALL ON TABLE grll_stagiaire_grille TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE grll_stagiaire_grille TO "grp-www";


--
-- TOC entry 10213 (class 0 OID 0)
-- Dependencies: 4465
-- Name: lrt_alerte; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE lrt_alerte FROM PUBLIC;
REVOKE ALL ON TABLE lrt_alerte FROM postgres;
GRANT ALL ON TABLE lrt_alerte TO postgres;
GRANT ALL ON TABLE lrt_alerte TO www;
GRANT ALL ON TABLE lrt_alerte TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE lrt_alerte TO "grp-www";


--
-- TOC entry 10214 (class 0 OID 0)
-- Dependencies: 4466
-- Name: lst_liste; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE lst_liste FROM PUBLIC;
REVOKE ALL ON TABLE lst_liste FROM postgres;
GRANT ALL ON TABLE lst_liste TO postgres;
GRANT ALL ON TABLE lst_liste TO www;
GRANT ALL ON TABLE lst_liste TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE lst_liste TO "grp-www";


--
-- TOC entry 10215 (class 0 OID 0)
-- Dependencies: 4468
-- Name: lst_liste_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE lst_liste_type FROM PUBLIC;
REVOKE ALL ON TABLE lst_liste_type FROM postgres;
GRANT ALL ON TABLE lst_liste_type TO postgres;
GRANT ALL ON TABLE lst_liste_type TO www;
GRANT ALL ON TABLE lst_liste_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE lst_liste_type TO "grp-www";


--
-- TOC entry 10216 (class 0 OID 0)
-- Dependencies: 4469
-- Name: lst_page_liste; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE lst_page_liste FROM PUBLIC;
REVOKE ALL ON TABLE lst_page_liste FROM postgres;
GRANT ALL ON TABLE lst_page_liste TO postgres;
GRANT ALL ON TABLE lst_page_liste TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE lst_page_liste TO "grp-www";


--
-- TOC entry 10217 (class 0 OID 0)
-- Dependencies: 4470
-- Name: lst_page_liste_configuration; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE lst_page_liste_configuration FROM PUBLIC;
REVOKE ALL ON TABLE lst_page_liste_configuration FROM postgres;
GRANT ALL ON TABLE lst_page_liste_configuration TO postgres;
GRANT ALL ON TABLE lst_page_liste_configuration TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE lst_page_liste_configuration TO "grp-www";


--
-- TOC entry 10218 (class 0 OID 0)
-- Dependencies: 4471
-- Name: md_media; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE md_media FROM PUBLIC;
REVOKE ALL ON TABLE md_media FROM postgres;
GRANT ALL ON TABLE md_media TO postgres;
GRANT ALL ON TABLE md_media TO www;
GRANT ALL ON TABLE md_media TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE md_media TO "grp-www";


--
-- TOC entry 10219 (class 0 OID 0)
-- Dependencies: 4472
-- Name: ndvd_fichier_photo; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE ndvd_fichier_photo FROM PUBLIC;
REVOKE ALL ON TABLE ndvd_fichier_photo FROM postgres;
GRANT ALL ON TABLE ndvd_fichier_photo TO postgres;
GRANT ALL ON TABLE ndvd_fichier_photo TO www;
GRANT ALL ON TABLE ndvd_fichier_photo TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE ndvd_fichier_photo TO "grp-www";


--
-- TOC entry 10220 (class 0 OID 0)
-- Dependencies: 4474
-- Name: ndvd_individu; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE ndvd_individu FROM PUBLIC;
REVOKE ALL ON TABLE ndvd_individu FROM postgres;
GRANT ALL ON TABLE ndvd_individu TO postgres;
GRANT ALL ON TABLE ndvd_individu TO www;
GRANT ALL ON TABLE ndvd_individu TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE ndvd_individu TO "grp-www";


--
-- TOC entry 10221 (class 0 OID 0)
-- Dependencies: 4475
-- Name: ndvd_individu_droits; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE ndvd_individu_droits FROM PUBLIC;
REVOKE ALL ON TABLE ndvd_individu_droits FROM postgres;
GRANT ALL ON TABLE ndvd_individu_droits TO postgres;
GRANT ALL ON TABLE ndvd_individu_droits TO www;
GRANT ALL ON TABLE ndvd_individu_droits TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE ndvd_individu_droits TO "grp-www";


--
-- TOC entry 10222 (class 0 OID 0)
-- Dependencies: 4477
-- Name: ndvd_individu_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE ndvd_individu_type FROM PUBLIC;
REVOKE ALL ON TABLE ndvd_individu_type FROM postgres;
GRANT ALL ON TABLE ndvd_individu_type TO postgres;
GRANT ALL ON TABLE ndvd_individu_type TO www;
GRANT ALL ON TABLE ndvd_individu_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE ndvd_individu_type TO "grp-www";


--
-- TOC entry 10223 (class 0 OID 0)
-- Dependencies: 4478
-- Name: ndvd_individu_types; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE ndvd_individu_types FROM PUBLIC;
REVOKE ALL ON TABLE ndvd_individu_types FROM postgres;
GRANT ALL ON TABLE ndvd_individu_types TO postgres;
GRANT ALL ON TABLE ndvd_individu_types TO www;
GRANT ALL ON TABLE ndvd_individu_types TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE ndvd_individu_types TO "grp-www";


--
-- TOC entry 10224 (class 0 OID 0)
-- Dependencies: 4480
-- Name: ndvd_organisme; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE ndvd_organisme FROM PUBLIC;
REVOKE ALL ON TABLE ndvd_organisme FROM postgres;
GRANT ALL ON TABLE ndvd_organisme TO postgres;
GRANT ALL ON TABLE ndvd_organisme TO www;
GRANT ALL ON TABLE ndvd_organisme TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE ndvd_organisme TO "grp-www";


--
-- TOC entry 10225 (class 0 OID 0)
-- Dependencies: 4482
-- Name: pg_page; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pg_page FROM PUBLIC;
REVOKE ALL ON TABLE pg_page FROM postgres;
GRANT ALL ON TABLE pg_page TO postgres;
GRANT ALL ON TABLE pg_page TO www;
GRANT ALL ON TABLE pg_page TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pg_page TO "grp-www";


--
-- TOC entry 10226 (class 0 OID 0)
-- Dependencies: 4483
-- Name: pg_page_annuaire_configuration; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pg_page_annuaire_configuration FROM PUBLIC;
REVOKE ALL ON TABLE pg_page_annuaire_configuration FROM postgres;
GRANT ALL ON TABLE pg_page_annuaire_configuration TO postgres;
GRANT ALL ON TABLE pg_page_annuaire_configuration TO www;
GRANT ALL ON TABLE pg_page_annuaire_configuration TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pg_page_annuaire_configuration TO "grp-www";


--
-- TOC entry 10227 (class 0 OID 0)
-- Dependencies: 4484
-- Name: pg_page_commentaire; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pg_page_commentaire FROM PUBLIC;
REVOKE ALL ON TABLE pg_page_commentaire FROM postgres;
GRANT ALL ON TABLE pg_page_commentaire TO postgres;
GRANT ALL ON TABLE pg_page_commentaire TO www;
GRANT ALL ON TABLE pg_page_commentaire TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pg_page_commentaire TO "grp-www";


--
-- TOC entry 10228 (class 0 OID 0)
-- Dependencies: 4486
-- Name: pg_page_element; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pg_page_element FROM PUBLIC;
REVOKE ALL ON TABLE pg_page_element FROM postgres;
GRANT ALL ON TABLE pg_page_element TO postgres;
GRANT ALL ON TABLE pg_page_element TO www;
GRANT ALL ON TABLE pg_page_element TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pg_page_element TO "grp-www";


--
-- TOC entry 10229 (class 0 OID 0)
-- Dependencies: 4487
-- Name: pg_page_elements; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pg_page_elements FROM PUBLIC;
REVOKE ALL ON TABLE pg_page_elements FROM postgres;
GRANT ALL ON TABLE pg_page_elements TO postgres;
GRANT ALL ON TABLE pg_page_elements TO www;
GRANT ALL ON TABLE pg_page_elements TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pg_page_elements TO "grp-www";


--
-- TOC entry 10230 (class 0 OID 0)
-- Dependencies: 4489
-- Name: pg_page_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pg_page_type FROM PUBLIC;
REVOKE ALL ON TABLE pg_page_type FROM postgres;
GRANT ALL ON TABLE pg_page_type TO postgres;
GRANT ALL ON TABLE pg_page_type TO www;
GRANT ALL ON TABLE pg_page_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pg_page_type TO "grp-www";


--
-- TOC entry 10231 (class 0 OID 0)
-- Dependencies: 4490
-- Name: prcrs_parcours; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE prcrs_parcours FROM PUBLIC;
REVOKE ALL ON TABLE prcrs_parcours FROM postgres;
GRANT ALL ON TABLE prcrs_parcours TO postgres;
GRANT ALL ON TABLE prcrs_parcours TO www;
GRANT ALL ON TABLE prcrs_parcours TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE prcrs_parcours TO "grp-www";


--
-- TOC entry 10233 (class 0 OID 0)
-- Dependencies: 4491
-- Name: prcrs_parcours_oriente; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE prcrs_parcours_oriente FROM PUBLIC;
REVOKE ALL ON TABLE prcrs_parcours_oriente FROM postgres;
GRANT ALL ON TABLE prcrs_parcours_oriente TO postgres;
GRANT ALL ON TABLE prcrs_parcours_oriente TO www;
GRANT ALL ON TABLE prcrs_parcours_oriente TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE prcrs_parcours_oriente TO "grp-www";


--
-- TOC entry 10234 (class 0 OID 0)
-- Dependencies: 4492
-- Name: pstnnmnt_categorie_positionnement; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pstnnmnt_categorie_positionnement FROM PUBLIC;
REVOKE ALL ON TABLE pstnnmnt_categorie_positionnement FROM postgres;
GRANT ALL ON TABLE pstnnmnt_categorie_positionnement TO postgres;
GRANT ALL ON TABLE pstnnmnt_categorie_positionnement TO www;
GRANT ALL ON TABLE pstnnmnt_categorie_positionnement TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pstnnmnt_categorie_positionnement TO "grp-www";


--
-- TOC entry 10236 (class 0 OID 0)
-- Dependencies: 4493
-- Name: pstnnmnt_choix; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pstnnmnt_choix FROM PUBLIC;
REVOKE ALL ON TABLE pstnnmnt_choix FROM postgres;
GRANT ALL ON TABLE pstnnmnt_choix TO postgres;
GRANT ALL ON TABLE pstnnmnt_choix TO www;
GRANT ALL ON TABLE pstnnmnt_choix TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pstnnmnt_choix TO "grp-www";


--
-- TOC entry 10238 (class 0 OID 0)
-- Dependencies: 4495
-- Name: pstnnmnt_positionnement; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pstnnmnt_positionnement FROM PUBLIC;
REVOKE ALL ON TABLE pstnnmnt_positionnement FROM postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement TO postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement TO www;
GRANT ALL ON TABLE pstnnmnt_positionnement TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pstnnmnt_positionnement TO "grp-www";


--
-- TOC entry 10240 (class 0 OID 0)
-- Dependencies: 4496
-- Name: pstnnmnt_positionnement_choix_evaluations; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pstnnmnt_positionnement_choix_evaluations FROM PUBLIC;
REVOKE ALL ON TABLE pstnnmnt_positionnement_choix_evaluations FROM postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement_choix_evaluations TO postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement_choix_evaluations TO www;
GRANT ALL ON TABLE pstnnmnt_positionnement_choix_evaluations TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pstnnmnt_positionnement_choix_evaluations TO "grp-www";


--
-- TOC entry 10242 (class 0 OID 0)
-- Dependencies: 4497
-- Name: pstnnmnt_positionnement_elements; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pstnnmnt_positionnement_elements FROM PUBLIC;
REVOKE ALL ON TABLE pstnnmnt_positionnement_elements FROM postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement_elements TO postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement_elements TO www;
GRANT ALL ON TABLE pstnnmnt_positionnement_elements TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pstnnmnt_positionnement_elements TO "grp-www";


--
-- TOC entry 10243 (class 0 OID 0)
-- Dependencies: 4498
-- Name: pstnnmnt_positionnement_evaluations; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pstnnmnt_positionnement_evaluations FROM PUBLIC;
REVOKE ALL ON TABLE pstnnmnt_positionnement_evaluations FROM postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement_evaluations TO postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement_evaluations TO www;
GRANT ALL ON TABLE pstnnmnt_positionnement_evaluations TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pstnnmnt_positionnement_evaluations TO "grp-www";


--
-- TOC entry 10245 (class 0 OID 0)
-- Dependencies: 4500
-- Name: pstnnmnt_positionnement_old; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pstnnmnt_positionnement_old FROM PUBLIC;
REVOKE ALL ON TABLE pstnnmnt_positionnement_old FROM postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement_old TO postgres;
GRANT ALL ON TABLE pstnnmnt_positionnement_old TO www;
GRANT ALL ON TABLE pstnnmnt_positionnement_old TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pstnnmnt_positionnement_old TO "grp-www";


--
-- TOC entry 10247 (class 0 OID 0)
-- Dependencies: 4501
-- Name: pstnnmnt_resultat_positionnement; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pstnnmnt_resultat_positionnement FROM PUBLIC;
REVOKE ALL ON TABLE pstnnmnt_resultat_positionnement FROM postgres;
GRANT ALL ON TABLE pstnnmnt_resultat_positionnement TO postgres;
GRANT ALL ON TABLE pstnnmnt_resultat_positionnement TO www;
GRANT ALL ON TABLE pstnnmnt_resultat_positionnement TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pstnnmnt_resultat_positionnement TO "grp-www";


--
-- TOC entry 10249 (class 0 OID 0)
-- Dependencies: 4502
-- Name: pstnnmnt_resultat_positionnement_question_reponse; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE pstnnmnt_resultat_positionnement_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE pstnnmnt_resultat_positionnement_question_reponse FROM postgres;
GRANT ALL ON TABLE pstnnmnt_resultat_positionnement_question_reponse TO postgres;
GRANT ALL ON TABLE pstnnmnt_resultat_positionnement_question_reponse TO www;
GRANT ALL ON TABLE pstnnmnt_resultat_positionnement_question_reponse TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE pstnnmnt_resultat_positionnement_question_reponse TO "grp-www";


--
-- TOC entry 10250 (class 0 OID 0)
-- Dependencies: 4503
-- Name: qc_categorie_qsrc; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qc_categorie_qsrc FROM PUBLIC;
REVOKE ALL ON TABLE qc_categorie_qsrc FROM postgres;
GRANT ALL ON TABLE qc_categorie_qsrc TO postgres;
GRANT ALL ON TABLE qc_categorie_qsrc TO www;
GRANT ALL ON TABLE qc_categorie_qsrc TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qc_categorie_qsrc TO "grp-www";


--
-- TOC entry 10251 (class 0 OID 0)
-- Dependencies: 4504
-- Name: qc_qsrc; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qc_qsrc FROM PUBLIC;
REVOKE ALL ON TABLE qc_qsrc FROM postgres;
GRANT ALL ON TABLE qc_qsrc TO postgres;
GRANT ALL ON TABLE qc_qsrc TO www;
GRANT ALL ON TABLE qc_qsrc TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qc_qsrc TO "grp-www";


--
-- TOC entry 10252 (class 0 OID 0)
-- Dependencies: 4505
-- Name: qr_categorie_question_reponse; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_categorie_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE qr_categorie_question_reponse FROM postgres;
GRANT ALL ON TABLE qr_categorie_question_reponse TO postgres;
GRANT ALL ON TABLE qr_categorie_question_reponse TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_categorie_question_reponse TO "grp-www";


--
-- TOC entry 10254 (class 0 OID 0)
-- Dependencies: 4506
-- Name: qr_categorie_question_reponse_element; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_categorie_question_reponse_element FROM PUBLIC;
REVOKE ALL ON TABLE qr_categorie_question_reponse_element FROM postgres;
GRANT ALL ON TABLE qr_categorie_question_reponse_element TO postgres;
GRANT ALL ON TABLE qr_categorie_question_reponse_element TO www;
GRANT ALL ON TABLE qr_categorie_question_reponse_element TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_categorie_question_reponse_element TO "grp-www";


--
-- TOC entry 10256 (class 0 OID 0)
-- Dependencies: 4507
-- Name: qr_categorie_sondage_element; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_categorie_sondage_element FROM PUBLIC;
REVOKE ALL ON TABLE qr_categorie_sondage_element FROM postgres;
GRANT ALL ON TABLE qr_categorie_sondage_element TO postgres;
GRANT ALL ON TABLE qr_categorie_sondage_element TO www;
GRANT ALL ON TABLE qr_categorie_sondage_element TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_categorie_sondage_element TO "grp-www";


--
-- TOC entry 10257 (class 0 OID 0)
-- Dependencies: 4508
-- Name: qr_media_question_reponse; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_media_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE qr_media_question_reponse FROM postgres;
GRANT ALL ON TABLE qr_media_question_reponse TO postgres;
GRANT ALL ON TABLE qr_media_question_reponse TO www;
GRANT ALL ON TABLE qr_media_question_reponse TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_media_question_reponse TO "grp-www";


--
-- TOC entry 10258 (class 0 OID 0)
-- Dependencies: 4509
-- Name: qr_media_question_reponse_element; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_media_question_reponse_element FROM PUBLIC;
REVOKE ALL ON TABLE qr_media_question_reponse_element FROM postgres;
GRANT ALL ON TABLE qr_media_question_reponse_element TO postgres;
GRANT ALL ON TABLE qr_media_question_reponse_element TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_media_question_reponse_element TO "grp-www";


--
-- TOC entry 10259 (class 0 OID 0)
-- Dependencies: 4510
-- Name: qr_qcm_elements; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_qcm_elements FROM PUBLIC;
REVOKE ALL ON TABLE qr_qcm_elements FROM postgres;
GRANT ALL ON TABLE qr_qcm_elements TO postgres;
GRANT ALL ON TABLE qr_qcm_elements TO www;
GRANT ALL ON TABLE qr_qcm_elements TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_qcm_elements TO "grp-www";


--
-- TOC entry 10261 (class 0 OID 0)
-- Dependencies: 4511
-- Name: qr_question; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_question FROM PUBLIC;
REVOKE ALL ON TABLE qr_question FROM postgres;
GRANT ALL ON TABLE qr_question TO postgres;
GRANT ALL ON TABLE qr_question TO www;
GRANT ALL ON TABLE qr_question TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_question TO "grp-www";


--
-- TOC entry 10262 (class 0 OID 0)
-- Dependencies: 4512
-- Name: qr_question_reponse; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE qr_question_reponse FROM postgres;
GRANT ALL ON TABLE qr_question_reponse TO postgres;
GRANT ALL ON TABLE qr_question_reponse TO www;
GRANT ALL ON TABLE qr_question_reponse TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_question_reponse TO "grp-www";


--
-- TOC entry 10263 (class 0 OID 0)
-- Dependencies: 4514
-- Name: qr_question_reponse_element; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_question_reponse_element FROM PUBLIC;
REVOKE ALL ON TABLE qr_question_reponse_element FROM postgres;
GRANT ALL ON TABLE qr_question_reponse_element TO postgres;
GRANT ALL ON TABLE qr_question_reponse_element TO www;
GRANT ALL ON TABLE qr_question_reponse_element TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_question_reponse_element TO "grp-www";


--
-- TOC entry 10265 (class 0 OID 0)
-- Dependencies: 4515
-- Name: qr_question_reponse_elements; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_question_reponse_elements FROM PUBLIC;
REVOKE ALL ON TABLE qr_question_reponse_elements FROM postgres;
GRANT ALL ON TABLE qr_question_reponse_elements TO postgres;
GRANT ALL ON TABLE qr_question_reponse_elements TO www;
GRANT ALL ON TABLE qr_question_reponse_elements TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_question_reponse_elements TO "grp-www";


--
-- TOC entry 10267 (class 0 OID 0)
-- Dependencies: 4517
-- Name: qr_question_reponse_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_question_reponse_type FROM PUBLIC;
REVOKE ALL ON TABLE qr_question_reponse_type FROM postgres;
GRANT ALL ON TABLE qr_question_reponse_type TO postgres;
GRANT ALL ON TABLE qr_question_reponse_type TO www;
GRANT ALL ON TABLE qr_question_reponse_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_question_reponse_type TO "grp-www";


--
-- TOC entry 10269 (class 0 OID 0)
-- Dependencies: 4518
-- Name: qr_reponse; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_reponse FROM PUBLIC;
REVOKE ALL ON TABLE qr_reponse FROM postgres;
GRANT ALL ON TABLE qr_reponse TO postgres;
GRANT ALL ON TABLE qr_reponse TO www;
GRANT ALL ON TABLE qr_reponse TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_reponse TO "grp-www";


--
-- TOC entry 10271 (class 0 OID 0)
-- Dependencies: 4519
-- Name: qr_resultat_serie_question_reponse; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_resultat_serie_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE qr_resultat_serie_question_reponse FROM postgres;
GRANT ALL ON TABLE qr_resultat_serie_question_reponse TO postgres;
GRANT ALL ON TABLE qr_resultat_serie_question_reponse TO www;
GRANT ALL ON TABLE qr_resultat_serie_question_reponse TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_resultat_serie_question_reponse TO "grp-www";


--
-- TOC entry 10273 (class 0 OID 0)
-- Dependencies: 4520
-- Name: qr_resultat_serie_tentative_question_reponse; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE qr_resultat_serie_tentative_question_reponse FROM PUBLIC;
REVOKE ALL ON TABLE qr_resultat_serie_tentative_question_reponse FROM postgres;
GRANT ALL ON TABLE qr_resultat_serie_tentative_question_reponse TO postgres;
GRANT ALL ON TABLE qr_resultat_serie_tentative_question_reponse TO www;
GRANT ALL ON TABLE qr_resultat_serie_tentative_question_reponse TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE qr_resultat_serie_tentative_question_reponse TO "grp-www";


--
-- TOC entry 10274 (class 0 OID 0)
-- Dependencies: 4521
-- Name: resultat_id_seq; Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON TABLE resultat_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE resultat_id_seq FROM pgsql;
GRANT ALL ON TABLE resultat_id_seq TO pgsql;
GRANT ALL ON TABLE resultat_id_seq TO PUBLIC;
GRANT ALL ON TABLE resultat_id_seq TO "grp-www";


--
-- TOC entry 10275 (class 0 OID 0)
-- Dependencies: 4522
-- Name: rssrc_categorie_etape_ressource; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_categorie_etape_ressource FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_categorie_etape_ressource FROM postgres;
GRANT ALL ON TABLE rssrc_categorie_etape_ressource TO postgres;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_categorie_etape_ressource TO "grp-www";


--
-- TOC entry 10276 (class 0 OID 0)
-- Dependencies: 4523
-- Name: rssrc_categorie_fichier_ressource; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_categorie_fichier_ressource FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_categorie_fichier_ressource FROM postgres;
GRANT ALL ON TABLE rssrc_categorie_fichier_ressource TO postgres;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_categorie_fichier_ressource TO "grp-www";


--
-- TOC entry 10278 (class 0 OID 0)
-- Dependencies: 4524
-- Name: rssrc_categorie_fichier_ressource_fichier; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_categorie_fichier_ressource_fichier FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_categorie_fichier_ressource_fichier FROM postgres;
GRANT ALL ON TABLE rssrc_categorie_fichier_ressource_fichier TO postgres;
GRANT ALL ON TABLE rssrc_categorie_fichier_ressource_fichier TO www;
GRANT ALL ON TABLE rssrc_categorie_fichier_ressource_fichier TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_categorie_fichier_ressource_fichier TO "grp-www";


--
-- TOC entry 10279 (class 0 OID 0)
-- Dependencies: 4525
-- Name: rssrc_categorie_fichier_ressource_texte; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_categorie_fichier_ressource_texte FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_categorie_fichier_ressource_texte FROM postgres;
GRANT ALL ON TABLE rssrc_categorie_fichier_ressource_texte TO postgres;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_categorie_fichier_ressource_texte TO "grp-www";


--
-- TOC entry 10281 (class 0 OID 0)
-- Dependencies: 4527
-- Name: rssrc_espace; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_espace FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_espace FROM postgres;
GRANT ALL ON TABLE rssrc_espace TO postgres;
GRANT ALL ON TABLE rssrc_espace TO www;
GRANT ALL ON TABLE rssrc_espace TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_espace TO "grp-www";


--
-- TOC entry 10282 (class 0 OID 0)
-- Dependencies: 4528
-- Name: rssrc_etape_ressource; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_etape_ressource FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_etape_ressource FROM postgres;
GRANT ALL ON TABLE rssrc_etape_ressource TO postgres;
GRANT ALL ON TABLE rssrc_etape_ressource TO www;
GRANT ALL ON TABLE rssrc_etape_ressource TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_etape_ressource TO "grp-www";


--
-- TOC entry 10283 (class 0 OID 0)
-- Dependencies: 4529
-- Name: rssrc_fichier_icone; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_fichier_icone FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_fichier_icone FROM postgres;
GRANT ALL ON TABLE rssrc_fichier_icone TO postgres;
GRANT ALL ON TABLE rssrc_fichier_icone TO www;
GRANT ALL ON TABLE rssrc_fichier_icone TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_fichier_icone TO "grp-www";


--
-- TOC entry 10284 (class 0 OID 0)
-- Dependencies: 4530
-- Name: rssrc_fichier_ressource; Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON TABLE rssrc_fichier_ressource FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_fichier_ressource FROM pgsql;
GRANT ALL ON TABLE rssrc_fichier_ressource TO pgsql;
GRANT ALL ON TABLE rssrc_fichier_ressource TO postgres;
GRANT ALL ON TABLE rssrc_fichier_ressource TO www;
GRANT ALL ON TABLE rssrc_fichier_ressource TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_fichier_ressource TO "grp-www";


--
-- TOC entry 10285 (class 0 OID 0)
-- Dependencies: 4531
-- Name: rssrc_fichier_ressource_fichier; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_fichier_ressource_fichier FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_fichier_ressource_fichier FROM postgres;
GRANT ALL ON TABLE rssrc_fichier_ressource_fichier TO postgres;
GRANT ALL ON TABLE rssrc_fichier_ressource_fichier TO www;
GRANT ALL ON TABLE rssrc_fichier_ressource_fichier TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_fichier_ressource_fichier TO "grp-www";


--
-- TOC entry 10286 (class 0 OID 0)
-- Dependencies: 4532
-- Name: rssrc_fichier_ressource_texte; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_fichier_ressource_texte FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_fichier_ressource_texte FROM postgres;
GRANT ALL ON TABLE rssrc_fichier_ressource_texte TO postgres;
GRANT ALL ON TABLE rssrc_fichier_ressource_texte TO www;
GRANT ALL ON TABLE rssrc_fichier_ressource_texte TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_fichier_ressource_texte TO "grp-www";


--
-- TOC entry 10288 (class 0 OID 0)
-- Dependencies: 4533
-- Name: rssrc_formation_ressources; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_formation_ressources FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_formation_ressources FROM postgres;
GRANT ALL ON TABLE rssrc_formation_ressources TO postgres;
GRANT ALL ON TABLE rssrc_formation_ressources TO www;
GRANT ALL ON TABLE rssrc_formation_ressources TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_formation_ressources TO "grp-www";


--
-- TOC entry 10289 (class 0 OID 0)
-- Dependencies: 4534
-- Name: rssrc_page_ressource_configuration; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_page_ressource_configuration FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_page_ressource_configuration FROM postgres;
GRANT ALL ON TABLE rssrc_page_ressource_configuration TO postgres;
GRANT ALL ON TABLE rssrc_page_ressource_configuration TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_page_ressource_configuration TO "grp-www";


--
-- TOC entry 10291 (class 0 OID 0)
-- Dependencies: 4536
-- Name: rssrc_ressource; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_ressource FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_ressource FROM postgres;
GRANT ALL ON TABLE rssrc_ressource TO postgres;
GRANT ALL ON TABLE rssrc_ressource TO www;
GRANT ALL ON TABLE rssrc_ressource TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_ressource TO "grp-www";


--
-- TOC entry 10292 (class 0 OID 0)
-- Dependencies: 4537
-- Name: section_id_seq; Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON TABLE section_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE section_id_seq FROM pgsql;
GRANT ALL ON TABLE section_id_seq TO pgsql;
GRANT ALL ON TABLE section_id_seq TO PUBLIC;
GRANT ALL ON TABLE section_id_seq TO "grp-www";


--
-- TOC entry 10294 (class 0 OID 0)
-- Dependencies: 4538
-- Name: rssrc_section; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE rssrc_section FROM PUBLIC;
REVOKE ALL ON TABLE rssrc_section FROM postgres;
GRANT ALL ON TABLE rssrc_section TO postgres;
GRANT ALL ON TABLE rssrc_section TO www;
GRANT ALL ON TABLE rssrc_section TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE rssrc_section TO "grp-www";


--
-- TOC entry 10295 (class 0 OID 0)
-- Dependencies: 4539
-- Name: salle_id_seq; Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON TABLE salle_id_seq FROM PUBLIC;
REVOKE ALL ON TABLE salle_id_seq FROM pgsql;
GRANT ALL ON TABLE salle_id_seq TO pgsql;
GRANT ALL ON TABLE salle_id_seq TO PUBLIC;
GRANT ALL ON TABLE salle_id_seq TO "grp-www";


--
-- TOC entry 10297 (class 0 OID 0)
-- Dependencies: 4540
-- Name: scnr_categorie_fichier_css; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scnr_categorie_fichier_css FROM PUBLIC;
REVOKE ALL ON TABLE scnr_categorie_fichier_css FROM postgres;
GRANT ALL ON TABLE scnr_categorie_fichier_css TO postgres;
GRANT ALL ON TABLE scnr_categorie_fichier_css TO www;
GRANT ALL ON TABLE scnr_categorie_fichier_css TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scnr_categorie_fichier_css TO "grp-www";


--
-- TOC entry 10299 (class 0 OID 0)
-- Dependencies: 4541
-- Name: scnr_categorie_fichier_media_scenario; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scnr_categorie_fichier_media_scenario FROM PUBLIC;
REVOKE ALL ON TABLE scnr_categorie_fichier_media_scenario FROM postgres;
GRANT ALL ON TABLE scnr_categorie_fichier_media_scenario TO postgres;
GRANT ALL ON TABLE scnr_categorie_fichier_media_scenario TO www;
GRANT ALL ON TABLE scnr_categorie_fichier_media_scenario TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scnr_categorie_fichier_media_scenario TO "grp-www";


--
-- TOC entry 10301 (class 0 OID 0)
-- Dependencies: 4542
-- Name: scnr_categorie_fichier_scenario; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scnr_categorie_fichier_scenario FROM PUBLIC;
REVOKE ALL ON TABLE scnr_categorie_fichier_scenario FROM postgres;
GRANT ALL ON TABLE scnr_categorie_fichier_scenario TO postgres;
GRANT ALL ON TABLE scnr_categorie_fichier_scenario TO www;
GRANT ALL ON TABLE scnr_categorie_fichier_scenario TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scnr_categorie_fichier_scenario TO "grp-www";


--
-- TOC entry 10302 (class 0 OID 0)
-- Dependencies: 4543
-- Name: scnr_categorie_scenario; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scnr_categorie_scenario FROM PUBLIC;
REVOKE ALL ON TABLE scnr_categorie_scenario FROM postgres;
GRANT ALL ON TABLE scnr_categorie_scenario TO postgres;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scnr_categorie_scenario TO "grp-www";


--
-- TOC entry 10303 (class 0 OID 0)
-- Dependencies: 4544
-- Name: scnr_fichier_css; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scnr_fichier_css FROM PUBLIC;
REVOKE ALL ON TABLE scnr_fichier_css FROM postgres;
GRANT ALL ON TABLE scnr_fichier_css TO postgres;
GRANT ALL ON TABLE scnr_fichier_css TO www;
GRANT ALL ON TABLE scnr_fichier_css TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scnr_fichier_css TO "grp-www";


--
-- TOC entry 10304 (class 0 OID 0)
-- Dependencies: 4545
-- Name: scnr_fichier_media_scenario; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scnr_fichier_media_scenario FROM PUBLIC;
REVOKE ALL ON TABLE scnr_fichier_media_scenario FROM postgres;
GRANT ALL ON TABLE scnr_fichier_media_scenario TO postgres;
GRANT ALL ON TABLE scnr_fichier_media_scenario TO www;
GRANT ALL ON TABLE scnr_fichier_media_scenario TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scnr_fichier_media_scenario TO "grp-www";


--
-- TOC entry 10305 (class 0 OID 0)
-- Dependencies: 4546
-- Name: scnr_fichier_scenario; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scnr_fichier_scenario FROM PUBLIC;
REVOKE ALL ON TABLE scnr_fichier_scenario FROM postgres;
GRANT ALL ON TABLE scnr_fichier_scenario TO postgres;
GRANT ALL ON TABLE scnr_fichier_scenario TO www;
GRANT ALL ON TABLE scnr_fichier_scenario TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scnr_fichier_scenario TO "grp-www";


--
-- TOC entry 10306 (class 0 OID 0)
-- Dependencies: 4547
-- Name: scnr_scenario; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scnr_scenario FROM PUBLIC;
REVOKE ALL ON TABLE scnr_scenario FROM postgres;
GRANT ALL ON TABLE scnr_scenario TO postgres;
GRANT ALL ON TABLE scnr_scenario TO www;
GRANT ALL ON TABLE scnr_scenario TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scnr_scenario TO "grp-www";


--
-- TOC entry 10308 (class 0 OID 0)
-- Dependencies: 4548
-- Name: scrm_categorie_fichier_etape_scorm; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scrm_categorie_fichier_etape_scorm FROM PUBLIC;
REVOKE ALL ON TABLE scrm_categorie_fichier_etape_scorm FROM postgres;
GRANT ALL ON TABLE scrm_categorie_fichier_etape_scorm TO postgres;
GRANT ALL ON TABLE scrm_categorie_fichier_etape_scorm TO www;
GRANT ALL ON TABLE scrm_categorie_fichier_etape_scorm TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scrm_categorie_fichier_etape_scorm TO "grp-www";


--
-- TOC entry 10309 (class 0 OID 0)
-- Dependencies: 4549
-- Name: scrm_etape_scorm; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scrm_etape_scorm FROM PUBLIC;
REVOKE ALL ON TABLE scrm_etape_scorm FROM postgres;
GRANT ALL ON TABLE scrm_etape_scorm TO postgres;
GRANT ALL ON TABLE scrm_etape_scorm TO www;
GRANT ALL ON TABLE scrm_etape_scorm TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scrm_etape_scorm TO "grp-www";


--
-- TOC entry 10310 (class 0 OID 0)
-- Dependencies: 4550
-- Name: scrm_fichier_etape_scorm; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scrm_fichier_etape_scorm FROM PUBLIC;
REVOKE ALL ON TABLE scrm_fichier_etape_scorm FROM postgres;
GRANT ALL ON TABLE scrm_fichier_etape_scorm TO postgres;
GRANT ALL ON TABLE scrm_fichier_etape_scorm TO www;
GRANT ALL ON TABLE scrm_fichier_etape_scorm TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scrm_fichier_etape_scorm TO "grp-www";


--
-- TOC entry 10311 (class 0 OID 0)
-- Dependencies: 4552
-- Name: scrm_scorm; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scrm_scorm FROM PUBLIC;
REVOKE ALL ON TABLE scrm_scorm FROM postgres;
GRANT ALL ON TABLE scrm_scorm TO postgres;
GRANT ALL ON TABLE scrm_scorm TO www;
GRANT ALL ON TABLE scrm_scorm TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scrm_scorm TO "grp-www";


--
-- TOC entry 10312 (class 0 OID 0)
-- Dependencies: 4554
-- Name: scrm_scorm_sco_users; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scrm_scorm_sco_users FROM PUBLIC;
REVOKE ALL ON TABLE scrm_scorm_sco_users FROM postgres;
GRANT ALL ON TABLE scrm_scorm_sco_users TO postgres;
GRANT ALL ON TABLE scrm_scorm_sco_users TO www;
GRANT ALL ON TABLE scrm_scorm_sco_users TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scrm_scorm_sco_users TO "grp-www";


--
-- TOC entry 10313 (class 0 OID 0)
-- Dependencies: 4556
-- Name: scrm_scorm_scoes; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE scrm_scorm_scoes FROM PUBLIC;
REVOKE ALL ON TABLE scrm_scorm_scoes FROM postgres;
GRANT ALL ON TABLE scrm_scorm_scoes TO postgres;
GRANT ALL ON TABLE scrm_scorm_scoes TO www;
GRANT ALL ON TABLE scrm_scorm_scoes TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE scrm_scorm_scoes TO "grp-www";


--
-- TOC entry 10315 (class 0 OID 0)
-- Dependencies: 4560
-- Name: sr_categorie_serie; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE sr_categorie_serie FROM PUBLIC;
REVOKE ALL ON TABLE sr_categorie_serie FROM postgres;
GRANT ALL ON TABLE sr_categorie_serie TO postgres;
GRANT ALL ON TABLE sr_categorie_serie TO www;
GRANT ALL ON TABLE sr_categorie_serie TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE sr_categorie_serie TO "grp-www";


--
-- TOC entry 10316 (class 0 OID 0)
-- Dependencies: 4561
-- Name: sr_resultat_serie; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE sr_resultat_serie FROM PUBLIC;
REVOKE ALL ON TABLE sr_resultat_serie FROM postgres;
GRANT ALL ON TABLE sr_resultat_serie TO postgres;
GRANT ALL ON TABLE sr_resultat_serie TO www;
GRANT ALL ON TABLE sr_resultat_serie TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE sr_resultat_serie TO "grp-www";


--
-- TOC entry 10317 (class 0 OID 0)
-- Dependencies: 4562
-- Name: sr_resultat_serie_tentative; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE sr_resultat_serie_tentative FROM PUBLIC;
REVOKE ALL ON TABLE sr_resultat_serie_tentative FROM postgres;
GRANT ALL ON TABLE sr_resultat_serie_tentative TO postgres;
GRANT ALL ON TABLE sr_resultat_serie_tentative TO www;
GRANT ALL ON TABLE sr_resultat_serie_tentative TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE sr_resultat_serie_tentative TO "grp-www";


--
-- TOC entry 10319 (class 0 OID 0)
-- Dependencies: 4563
-- Name: sr_resultat_serie_tentative_ftb; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE sr_resultat_serie_tentative_ftb FROM PUBLIC;
REVOKE ALL ON TABLE sr_resultat_serie_tentative_ftb FROM postgres;
GRANT ALL ON TABLE sr_resultat_serie_tentative_ftb TO postgres;
GRANT ALL ON TABLE sr_resultat_serie_tentative_ftb TO www;
GRANT ALL ON TABLE sr_resultat_serie_tentative_ftb TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE sr_resultat_serie_tentative_ftb TO "grp-www";


--
-- TOC entry 10321 (class 0 OID 0)
-- Dependencies: 4564
-- Name: sr_serie; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE sr_serie FROM PUBLIC;
REVOKE ALL ON TABLE sr_serie FROM postgres;
GRANT ALL ON TABLE sr_serie TO postgres;
GRANT ALL ON TABLE sr_serie TO www;
GRANT ALL ON TABLE sr_serie TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE sr_serie TO "grp-www";


--
-- TOC entry 10323 (class 0 OID 0)
-- Dependencies: 4565
-- Name: sr_serie_bloquante; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE sr_serie_bloquante FROM PUBLIC;
REVOKE ALL ON TABLE sr_serie_bloquante FROM postgres;
GRANT ALL ON TABLE sr_serie_bloquante TO postgres;
GRANT ALL ON TABLE sr_serie_bloquante TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE sr_serie_bloquante TO "grp-www";


--
-- TOC entry 10325 (class 0 OID 0)
-- Dependencies: 4566
-- Name: sr_serie_evaluations; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE sr_serie_evaluations FROM PUBLIC;
REVOKE ALL ON TABLE sr_serie_evaluations FROM postgres;
GRANT ALL ON TABLE sr_serie_evaluations TO postgres;
GRANT ALL ON TABLE sr_serie_evaluations TO www;
GRANT ALL ON TABLE sr_serie_evaluations TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE sr_serie_evaluations TO "grp-www";


--
-- TOC entry 10326 (class 0 OID 0)
-- Dependencies: 4567
-- Name: srltr_serie_aleatoire; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE srltr_serie_aleatoire FROM PUBLIC;
REVOKE ALL ON TABLE srltr_serie_aleatoire FROM postgres;
GRANT ALL ON TABLE srltr_serie_aleatoire TO postgres;
GRANT ALL ON TABLE srltr_serie_aleatoire TO www;
GRANT ALL ON TABLE srltr_serie_aleatoire TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE srltr_serie_aleatoire TO "grp-www";


--
-- TOC entry 10328 (class 0 OID 0)
-- Dependencies: 4568
-- Name: srltr_serie_aleatoire_evaluations; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE srltr_serie_aleatoire_evaluations FROM PUBLIC;
REVOKE ALL ON TABLE srltr_serie_aleatoire_evaluations FROM postgres;
GRANT ALL ON TABLE srltr_serie_aleatoire_evaluations TO postgres;
GRANT ALL ON TABLE srltr_serie_aleatoire_evaluations TO www;
GRANT ALL ON TABLE srltr_serie_aleatoire_evaluations TO PUBLIC;


--
-- TOC entry 10330 (class 0 OID 0)
-- Dependencies: 4570
-- Name: srltr_serie_aleatoire_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE srltr_serie_aleatoire_type FROM PUBLIC;
REVOKE ALL ON TABLE srltr_serie_aleatoire_type FROM postgres;
GRANT ALL ON TABLE srltr_serie_aleatoire_type TO postgres;
GRANT ALL ON TABLE srltr_serie_aleatoire_type TO www;
GRANT ALL ON TABLE srltr_serie_aleatoire_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE srltr_serie_aleatoire_type TO "grp-www";


--
-- TOC entry 10331 (class 0 OID 0)
-- Dependencies: 4571
-- Name: srltrmlg_serie_aleatoire_melangee; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE srltrmlg_serie_aleatoire_melangee FROM PUBLIC;
REVOKE ALL ON TABLE srltrmlg_serie_aleatoire_melangee FROM postgres;
GRANT ALL ON TABLE srltrmlg_serie_aleatoire_melangee TO postgres;
GRANT ALL ON TABLE srltrmlg_serie_aleatoire_melangee TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE srltrmlg_serie_aleatoire_melangee TO "grp-www";


--
-- TOC entry 10333 (class 0 OID 0)
-- Dependencies: 4572
-- Name: srltrmltsr_serie_aleatoire_multiserie; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE srltrmltsr_serie_aleatoire_multiserie FROM PUBLIC;
REVOKE ALL ON TABLE srltrmltsr_serie_aleatoire_multiserie FROM postgres;
GRANT ALL ON TABLE srltrmltsr_serie_aleatoire_multiserie TO postgres;
GRANT ALL ON TABLE srltrmltsr_serie_aleatoire_multiserie TO www;
GRANT ALL ON TABLE srltrmltsr_serie_aleatoire_multiserie TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE srltrmltsr_serie_aleatoire_multiserie TO "grp-www";


--
-- TOC entry 10335 (class 0 OID 0)
-- Dependencies: 4573
-- Name: srltrmltthm_serie_aleatoire_multitheme; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE srltrmltthm_serie_aleatoire_multitheme FROM PUBLIC;
REVOKE ALL ON TABLE srltrmltthm_serie_aleatoire_multitheme FROM postgres;
GRANT ALL ON TABLE srltrmltthm_serie_aleatoire_multitheme TO postgres;
GRANT ALL ON TABLE srltrmltthm_serie_aleatoire_multitheme TO www;
GRANT ALL ON TABLE srltrmltthm_serie_aleatoire_multitheme TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE srltrmltthm_serie_aleatoire_multitheme TO "grp-www";


--
-- TOC entry 10336 (class 0 OID 0)
-- Dependencies: 4575
-- Name: thm_categorie; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE thm_categorie FROM PUBLIC;
REVOKE ALL ON TABLE thm_categorie FROM postgres;
GRANT ALL ON TABLE thm_categorie TO postgres;
GRANT ALL ON TABLE thm_categorie TO www;
GRANT ALL ON TABLE thm_categorie TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE thm_categorie TO "grp-www";


--
-- TOC entry 10338 (class 0 OID 0)
-- Dependencies: 4577
-- Name: thm_theme; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE thm_theme FROM PUBLIC;
REVOKE ALL ON TABLE thm_theme FROM postgres;
GRANT ALL ON TABLE thm_theme TO postgres;
GRANT ALL ON TABLE thm_theme TO www;
GRANT ALL ON TABLE thm_theme TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE thm_theme TO "grp-www";


--
-- TOC entry 10340 (class 0 OID 0)
-- Dependencies: 4578
-- Name: thm_theme_categories; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE thm_theme_categories FROM PUBLIC;
REVOKE ALL ON TABLE thm_theme_categories FROM postgres;
GRANT ALL ON TABLE thm_theme_categories TO postgres;
GRANT ALL ON TABLE thm_theme_categories TO www;
GRANT ALL ON TABLE thm_theme_categories TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE thm_theme_categories TO "grp-www";


--
-- TOC entry 10341 (class 0 OID 0)
-- Dependencies: 4579
-- Name: tp_categorie_etape; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tp_categorie_etape FROM PUBLIC;
REVOKE ALL ON TABLE tp_categorie_etape FROM postgres;
GRANT ALL ON TABLE tp_categorie_etape TO postgres;
GRANT ALL ON TABLE tp_categorie_etape TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tp_categorie_etape TO "grp-www";


--
-- TOC entry 10342 (class 0 OID 0)
-- Dependencies: 4580
-- Name: tp_commentaire_etape; Type: ACL; Schema: v2; Owner: pgsql
--

REVOKE ALL ON TABLE tp_commentaire_etape FROM PUBLIC;
REVOKE ALL ON TABLE tp_commentaire_etape FROM pgsql;
GRANT ALL ON TABLE tp_commentaire_etape TO pgsql;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tp_commentaire_etape TO "grp-www";


--
-- TOC entry 10344 (class 0 OID 0)
-- Dependencies: 4582
-- Name: tp_etape; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tp_etape FROM PUBLIC;
REVOKE ALL ON TABLE tp_etape FROM postgres;
GRANT ALL ON TABLE tp_etape TO postgres;
GRANT ALL ON TABLE tp_etape TO www;
GRANT ALL ON TABLE tp_etape TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tp_etape TO "grp-www";


--
-- TOC entry 10345 (class 0 OID 0)
-- Dependencies: 4583
-- Name: tp_etape_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tp_etape_type FROM PUBLIC;
REVOKE ALL ON TABLE tp_etape_type FROM postgres;
GRANT ALL ON TABLE tp_etape_type TO postgres;
GRANT ALL ON TABLE tp_etape_type TO www;
GRANT ALL ON TABLE tp_etape_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tp_etape_type TO "grp-www";


--
-- TOC entry 10347 (class 0 OID 0)
-- Dependencies: 4584
-- Name: tp_parcours_etapes; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tp_parcours_etapes FROM PUBLIC;
REVOKE ALL ON TABLE tp_parcours_etapes FROM postgres;
GRANT ALL ON TABLE tp_parcours_etapes TO postgres;
GRANT ALL ON TABLE tp_parcours_etapes TO www;
GRANT ALL ON TABLE tp_parcours_etapes TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tp_parcours_etapes TO "grp-www";


--
-- TOC entry 10348 (class 0 OID 0)
-- Dependencies: 4585
-- Name: tp_resultat; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tp_resultat FROM PUBLIC;
REVOKE ALL ON TABLE tp_resultat FROM postgres;
GRANT ALL ON TABLE tp_resultat TO postgres;
GRANT ALL ON TABLE tp_resultat TO www;
GRANT ALL ON TABLE tp_resultat TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tp_resultat TO "grp-www";


--
-- TOC entry 10349 (class 0 OID 0)
-- Dependencies: 4587
-- Name: tp_resultat_tentative; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tp_resultat_tentative FROM PUBLIC;
REVOKE ALL ON TABLE tp_resultat_tentative FROM postgres;
GRANT ALL ON TABLE tp_resultat_tentative TO postgres;
GRANT ALL ON TABLE tp_resultat_tentative TO www;
GRANT ALL ON TABLE tp_resultat_tentative TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tp_resultat_tentative TO "grp-www";


--
-- TOC entry 10350 (class 0 OID 0)
-- Dependencies: 4588
-- Name: tst_categorie_test; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tst_categorie_test FROM PUBLIC;
REVOKE ALL ON TABLE tst_categorie_test FROM postgres;
GRANT ALL ON TABLE tst_categorie_test TO postgres;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tst_categorie_test TO "grp-www";


--
-- TOC entry 10351 (class 0 OID 0)
-- Dependencies: 4589
-- Name: tst_media_test; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tst_media_test FROM PUBLIC;
REVOKE ALL ON TABLE tst_media_test FROM postgres;
GRANT ALL ON TABLE tst_media_test TO postgres;
GRANT ALL ON TABLE tst_media_test TO www;
GRANT ALL ON TABLE tst_media_test TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tst_media_test TO "grp-www";


--
-- TOC entry 10352 (class 0 OID 0)
-- Dependencies: 4590
-- Name: tst_resultat_test; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tst_resultat_test FROM PUBLIC;
REVOKE ALL ON TABLE tst_resultat_test FROM postgres;
GRANT ALL ON TABLE tst_resultat_test TO postgres;
GRANT ALL ON TABLE tst_resultat_test TO www;
GRANT ALL ON TABLE tst_resultat_test TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tst_resultat_test TO "grp-www";


--
-- TOC entry 10354 (class 0 OID 0)
-- Dependencies: 4591
-- Name: tst_test; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tst_test FROM PUBLIC;
REVOKE ALL ON TABLE tst_test FROM postgres;
GRANT ALL ON TABLE tst_test TO postgres;
GRANT ALL ON TABLE tst_test TO www;
GRANT ALL ON TABLE tst_test TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tst_test TO "grp-www";


--
-- TOC entry 10356 (class 0 OID 0)
-- Dependencies: 4592
-- Name: tst_test_positionnements; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE tst_test_positionnements FROM PUBLIC;
REVOKE ALL ON TABLE tst_test_positionnements FROM postgres;
GRANT ALL ON TABLE tst_test_positionnements TO postgres;
GRANT ALL ON TABLE tst_test_positionnements TO www;
GRANT ALL ON TABLE tst_test_positionnements TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE tst_test_positionnements TO "grp-www";


--
-- TOC entry 10358 (class 0 OID 0)
-- Dependencies: 4594
-- Name: vltn_bareme; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vltn_bareme FROM PUBLIC;
REVOKE ALL ON TABLE vltn_bareme FROM postgres;
GRANT ALL ON TABLE vltn_bareme TO postgres;
GRANT ALL ON TABLE vltn_bareme TO www;
GRANT ALL ON TABLE vltn_bareme TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vltn_bareme TO "grp-www";


--
-- TOC entry 10359 (class 0 OID 0)
-- Dependencies: 4595
-- Name: vltn_categorie_evaluation; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vltn_categorie_evaluation FROM PUBLIC;
REVOKE ALL ON TABLE vltn_categorie_evaluation FROM postgres;
GRANT ALL ON TABLE vltn_categorie_evaluation TO postgres;
GRANT ALL ON TABLE vltn_categorie_evaluation TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vltn_categorie_evaluation TO "grp-www";


--
-- TOC entry 10361 (class 0 OID 0)
-- Dependencies: 4596
-- Name: vltn_categorie_fichier_media_evaluation; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vltn_categorie_fichier_media_evaluation FROM PUBLIC;
REVOKE ALL ON TABLE vltn_categorie_fichier_media_evaluation FROM postgres;
GRANT ALL ON TABLE vltn_categorie_fichier_media_evaluation TO postgres;
GRANT ALL ON TABLE vltn_categorie_fichier_media_evaluation TO www;
GRANT ALL ON TABLE vltn_categorie_fichier_media_evaluation TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vltn_categorie_fichier_media_evaluation TO "grp-www";


--
-- TOC entry 10362 (class 0 OID 0)
-- Dependencies: 4598
-- Name: vltn_evaluation; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vltn_evaluation FROM PUBLIC;
REVOKE ALL ON TABLE vltn_evaluation FROM postgres;
GRANT ALL ON TABLE vltn_evaluation TO postgres;
GRANT ALL ON TABLE vltn_evaluation TO www;
GRANT ALL ON TABLE vltn_evaluation TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vltn_evaluation TO "grp-www";


--
-- TOC entry 10363 (class 0 OID 0)
-- Dependencies: 4600
-- Name: vltn_evaluation_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vltn_evaluation_type FROM PUBLIC;
REVOKE ALL ON TABLE vltn_evaluation_type FROM postgres;
GRANT ALL ON TABLE vltn_evaluation_type TO postgres;
GRANT ALL ON TABLE vltn_evaluation_type TO www;
GRANT ALL ON TABLE vltn_evaluation_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vltn_evaluation_type TO "grp-www";


--
-- TOC entry 10364 (class 0 OID 0)
-- Dependencies: 4601
-- Name: vltn_fichier_media_evaluation; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vltn_fichier_media_evaluation FROM PUBLIC;
REVOKE ALL ON TABLE vltn_fichier_media_evaluation FROM postgres;
GRANT ALL ON TABLE vltn_fichier_media_evaluation TO postgres;
GRANT ALL ON TABLE vltn_fichier_media_evaluation TO www;
GRANT ALL ON TABLE vltn_fichier_media_evaluation TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vltn_fichier_media_evaluation TO "grp-www";


--
-- TOC entry 10366 (class 0 OID 0)
-- Dependencies: 4602
-- Name: vnmnt_evenement; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vnmnt_evenement FROM PUBLIC;
REVOKE ALL ON TABLE vnmnt_evenement FROM postgres;
GRANT ALL ON TABLE vnmnt_evenement TO postgres;
GRANT ALL ON TABLE vnmnt_evenement TO www;
GRANT ALL ON TABLE vnmnt_evenement TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vnmnt_evenement TO "grp-www";


--
-- TOC entry 10368 (class 0 OID 0)
-- Dependencies: 4603
-- Name: vnmnt_evenement_presentiel; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vnmnt_evenement_presentiel FROM PUBLIC;
REVOKE ALL ON TABLE vnmnt_evenement_presentiel FROM postgres;
GRANT ALL ON TABLE vnmnt_evenement_presentiel TO postgres;
GRANT ALL ON TABLE vnmnt_evenement_presentiel TO www;
GRANT ALL ON TABLE vnmnt_evenement_presentiel TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vnmnt_evenement_presentiel TO "grp-www";


--
-- TOC entry 10369 (class 0 OID 0)
-- Dependencies: 4605
-- Name: vnmnt_intervention; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vnmnt_intervention FROM PUBLIC;
REVOKE ALL ON TABLE vnmnt_intervention FROM postgres;
GRANT ALL ON TABLE vnmnt_intervention TO postgres;
GRANT ALL ON TABLE vnmnt_intervention TO www;
GRANT ALL ON TABLE vnmnt_intervention TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vnmnt_intervention TO "grp-www";


--
-- TOC entry 10370 (class 0 OID 0)
-- Dependencies: 4607
-- Name: vnmnt_modalite; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vnmnt_modalite FROM PUBLIC;
REVOKE ALL ON TABLE vnmnt_modalite FROM postgres;
GRANT ALL ON TABLE vnmnt_modalite TO postgres;
GRANT ALL ON TABLE vnmnt_modalite TO www;
GRANT ALL ON TABLE vnmnt_modalite TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vnmnt_modalite TO "grp-www";


--
-- TOC entry 10372 (class 0 OID 0)
-- Dependencies: 4608
-- Name: vnmnt_salle; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE vnmnt_salle FROM PUBLIC;
REVOKE ALL ON TABLE vnmnt_salle FROM postgres;
GRANT ALL ON TABLE vnmnt_salle TO postgres;
GRANT ALL ON TABLE vnmnt_salle TO www;
GRANT ALL ON TABLE vnmnt_salle TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE vnmnt_salle TO "grp-www";


--
-- TOC entry 10374 (class 0 OID 0)
-- Dependencies: 4609
-- Name: xtlc_categorie_critere; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_categorie_critere FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_categorie_critere FROM postgres;
GRANT ALL ON TABLE xtlc_categorie_critere TO postgres;
GRANT ALL ON TABLE xtlc_categorie_critere TO www;
GRANT ALL ON TABLE xtlc_categorie_critere TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_categorie_critere TO "grp-www";


--
-- TOC entry 10375 (class 0 OID 0)
-- Dependencies: 4610
-- Name: xtlc_categorie_exotlc; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_categorie_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_categorie_exotlc FROM postgres;
GRANT ALL ON TABLE xtlc_categorie_exotlc TO postgres;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_categorie_exotlc TO "grp-www";


--
-- TOC entry 10377 (class 0 OID 0)
-- Dependencies: 4611
-- Name: xtlc_categorie_fichier_correction; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_categorie_fichier_correction FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_categorie_fichier_correction FROM postgres;
GRANT ALL ON TABLE xtlc_categorie_fichier_correction TO postgres;
GRANT ALL ON TABLE xtlc_categorie_fichier_correction TO www;
GRANT ALL ON TABLE xtlc_categorie_fichier_correction TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_categorie_fichier_correction TO "grp-www";


--
-- TOC entry 10379 (class 0 OID 0)
-- Dependencies: 4612
-- Name: xtlc_categorie_fichier_exotlc; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_categorie_fichier_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_categorie_fichier_exotlc FROM postgres;
GRANT ALL ON TABLE xtlc_categorie_fichier_exotlc TO postgres;
GRANT ALL ON TABLE xtlc_categorie_fichier_exotlc TO www;
GRANT ALL ON TABLE xtlc_categorie_fichier_exotlc TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_categorie_fichier_exotlc TO "grp-www";


--
-- TOC entry 10381 (class 0 OID 0)
-- Dependencies: 4613
-- Name: xtlc_categorie_fichier_media_exotlc; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_categorie_fichier_media_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_categorie_fichier_media_exotlc FROM postgres;
GRANT ALL ON TABLE xtlc_categorie_fichier_media_exotlc TO postgres;
GRANT ALL ON TABLE xtlc_categorie_fichier_media_exotlc TO www;
GRANT ALL ON TABLE xtlc_categorie_fichier_media_exotlc TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_categorie_fichier_media_exotlc TO "grp-www";


--
-- TOC entry 10383 (class 0 OID 0)
-- Dependencies: 4614
-- Name: xtlc_categorie_modele_correction; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_categorie_modele_correction FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_categorie_modele_correction FROM postgres;
GRANT ALL ON TABLE xtlc_categorie_modele_correction TO postgres;
GRANT ALL ON TABLE xtlc_categorie_modele_correction TO www;
GRANT ALL ON TABLE xtlc_categorie_modele_correction TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_categorie_modele_correction TO "grp-www";


--
-- TOC entry 10385 (class 0 OID 0)
-- Dependencies: 4616
-- Name: xtlc_critere; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_critere FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_critere FROM postgres;
GRANT ALL ON TABLE xtlc_critere TO postgres;
GRANT ALL ON TABLE xtlc_critere TO www;
GRANT ALL ON TABLE xtlc_critere TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_critere TO "grp-www";


--
-- TOC entry 10387 (class 0 OID 0)
-- Dependencies: 4617
-- Name: xtlc_exotlc; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_exotlc FROM postgres;
GRANT ALL ON TABLE xtlc_exotlc TO postgres;
GRANT ALL ON TABLE xtlc_exotlc TO www;
GRANT ALL ON TABLE xtlc_exotlc TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_exotlc TO "grp-www";


--
-- TOC entry 10388 (class 0 OID 0)
-- Dependencies: 4618
-- Name: xtlc_exotlc_corrections; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_exotlc_corrections FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_exotlc_corrections FROM postgres;
GRANT ALL ON TABLE xtlc_exotlc_corrections TO postgres;
GRANT ALL ON TABLE xtlc_exotlc_corrections TO www;
GRANT ALL ON TABLE xtlc_exotlc_corrections TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_exotlc_corrections TO "grp-www";


--
-- TOC entry 10389 (class 0 OID 0)
-- Dependencies: 4619
-- Name: xtlc_exotlc_fichiers; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_exotlc_fichiers FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_exotlc_fichiers FROM postgres;
GRANT ALL ON TABLE xtlc_exotlc_fichiers TO postgres;
GRANT ALL ON TABLE xtlc_exotlc_fichiers TO www;
GRANT ALL ON TABLE xtlc_exotlc_fichiers TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_exotlc_fichiers TO "grp-www";


--
-- TOC entry 10390 (class 0 OID 0)
-- Dependencies: 4620
-- Name: xtlc_exotlc_mail; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_exotlc_mail FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_exotlc_mail FROM postgres;
GRANT ALL ON TABLE xtlc_exotlc_mail TO postgres;
GRANT ALL ON TABLE xtlc_exotlc_mail TO www;
GRANT ALL ON TABLE xtlc_exotlc_mail TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_exotlc_mail TO "grp-www";


--
-- TOC entry 10391 (class 0 OID 0)
-- Dependencies: 4621
-- Name: xtlc_exotlc_plate_forme; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_exotlc_plate_forme FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_exotlc_plate_forme FROM postgres;
GRANT ALL ON TABLE xtlc_exotlc_plate_forme TO postgres;
GRANT ALL ON TABLE xtlc_exotlc_plate_forme TO www;
GRANT ALL ON TABLE xtlc_exotlc_plate_forme TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_exotlc_plate_forme TO "grp-www";


--
-- TOC entry 10392 (class 0 OID 0)
-- Dependencies: 4623
-- Name: xtlc_exotlc_type; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_exotlc_type FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_exotlc_type FROM postgres;
GRANT ALL ON TABLE xtlc_exotlc_type TO postgres;
GRANT ALL ON TABLE xtlc_exotlc_type TO www;
GRANT ALL ON TABLE xtlc_exotlc_type TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_exotlc_type TO "grp-www";


--
-- TOC entry 10393 (class 0 OID 0)
-- Dependencies: 4624
-- Name: xtlc_fichier_exotlc; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_fichier_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_fichier_exotlc FROM postgres;
GRANT ALL ON TABLE xtlc_fichier_exotlc TO postgres;
GRANT ALL ON TABLE xtlc_fichier_exotlc TO www;
GRANT ALL ON TABLE xtlc_fichier_exotlc TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_fichier_exotlc TO "grp-www";


--
-- TOC entry 10394 (class 0 OID 0)
-- Dependencies: 4625
-- Name: xtlc_fichier_media_exotlc; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_fichier_media_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_fichier_media_exotlc FROM postgres;
GRANT ALL ON TABLE xtlc_fichier_media_exotlc TO postgres;
GRANT ALL ON TABLE xtlc_fichier_media_exotlc TO www;
GRANT ALL ON TABLE xtlc_fichier_media_exotlc TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_fichier_media_exotlc TO "grp-www";


--
-- TOC entry 10395 (class 0 OID 0)
-- Dependencies: 4627
-- Name: xtlc_modele_correction; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_modele_correction FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_modele_correction FROM postgres;
GRANT ALL ON TABLE xtlc_modele_correction TO postgres;
GRANT ALL ON TABLE xtlc_modele_correction TO www;
GRANT ALL ON TABLE xtlc_modele_correction TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_modele_correction TO "grp-www";


--
-- TOC entry 10396 (class 0 OID 0)
-- Dependencies: 4628
-- Name: xtlc_resultat_exotlc; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_resultat_exotlc FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_resultat_exotlc FROM postgres;
GRANT ALL ON TABLE xtlc_resultat_exotlc TO postgres;
GRANT ALL ON TABLE xtlc_resultat_exotlc TO www;
GRANT ALL ON TABLE xtlc_resultat_exotlc TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_resultat_exotlc TO "grp-www";


--
-- TOC entry 10397 (class 0 OID 0)
-- Dependencies: 4629
-- Name: xtlc_resultat_exotlc_critere; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_resultat_exotlc_critere FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_resultat_exotlc_critere FROM postgres;
GRANT ALL ON TABLE xtlc_resultat_exotlc_critere TO postgres;
GRANT ALL ON TABLE xtlc_resultat_exotlc_critere TO www;
GRANT ALL ON TABLE xtlc_resultat_exotlc_critere TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_resultat_exotlc_critere TO "grp-www";


--
-- TOC entry 10398 (class 0 OID 0)
-- Dependencies: 4630
-- Name: xtlc_resultat_exotlc_sous_critere; Type: ACL; Schema: v2; Owner: postgres
--

REVOKE ALL ON TABLE xtlc_resultat_exotlc_sous_critere FROM PUBLIC;
REVOKE ALL ON TABLE xtlc_resultat_exotlc_sous_critere FROM postgres;
GRANT ALL ON TABLE xtlc_resultat_exotlc_sous_critere TO postgres;
GRANT ALL ON TABLE xtlc_resultat_exotlc_sous_critere TO www;
GRANT ALL ON TABLE xtlc_resultat_exotlc_sous_critere TO PUBLIC;
GRANT INSERT,SELECT,UPDATE,DELETE ON TABLE xtlc_resultat_exotlc_sous_critere TO "grp-www";


-- Completed on 2009-02-08 16:29:00 CET

--
-- PostgreSQL database dump complete
--

